<?php

/**
 * o------------------------------------------------------------------------------o
 * | This package is licensed under the Phpguru license. A quick summary is       |
 * | that for commercial use, there is a small one-time licensing fee to pay. For |
 * | registered charities and educational institutes there is a reduced license   |
 * | fee available. You can read more  at:								|
 * |															   |
 * |			   http://www.phpguru.org/static/license.html			   |
 * o------------------------------------------------------------------------------o
 *
 */

/**
 * Converts a given number to a textual representation of it
 */
class TextualNumber {

    public static $is_currency = true;
    public static $is_negative = false;
    public static $decimal_places = CLX_NUM_TWO;
    public static $units_male = array(
        'en' => array(CLX_NUM_ZERO => 'zero', CLX_NUM_ONE => 'one', CLX_NUM_TWO => 'two', CLX_NUM_THREE => 'three', CLX_NUM_FOUR => 'four', CLX_NUM_FIVE => 'five', CLX_NUM_SIX => 'six', CLX_NUM_7 => 'seven', CLX_NUM_8 => 'eight', CLX_NUM_NINE => 'nine'),
        'es' => array(CLX_NUM_ZERO => 'cero', CLX_NUM_ONE => 'uno', CLX_NUM_TWO => 'dos', CLX_NUM_THREE => 'tres', CLX_NUM_FOUR => 'cuatro', CLX_NUM_FIVE => 'cinco', CLX_NUM_SIX => 'seis', CLX_NUM_7 => 'siete', CLX_NUM_8 => 'ocho', CLX_NUM_NINE => 'nueve')
    );
    public static $units_female = array(
        'en' => array(CLX_NUM_ZERO => 'zero', CLX_NUM_ONE => 'one', CLX_NUM_TWO => 'two', CLX_NUM_THREE => 'three', CLX_NUM_FOUR => 'four', CLX_NUM_FIVE => 'five', CLX_NUM_SIX => 'six', CLX_NUM_7 => 'seven', CLX_NUM_8 => 'eight', CLX_NUM_NINE => 'nine'),
        'es' => array(CLX_NUM_ZERO => 'cero', CLX_NUM_ONE => 'una', CLX_NUM_TWO => 'dos', CLX_NUM_THREE => 'tres', CLX_NUM_FOUR => 'cuatro', CLX_NUM_FIVE => 'cinco', CLX_NUM_SIX => 'seis', CLX_NUM_7 => 'siete', CLX_NUM_8 => 'ocho', CLX_NUM_NINE => 'nueve')
    );
    public static $units_other = array(
        'en' => array(CLX_NUM_ZERO => 'zero', CLX_NUM_ONE => 'one', CLX_NUM_TWO => 'two', CLX_NUM_THREE => 'three', CLX_NUM_FOUR => 'four', CLX_NUM_FIVE => 'five', CLX_NUM_SIX => 'six', CLX_NUM_7 => 'seven', CLX_NUM_8 => 'eight', CLX_NUM_NINE => 'nine'),
        'es' => array(CLX_NUM_ZERO => 'cero', CLX_NUM_ONE => 'un', CLX_NUM_TWO => 'dos', CLX_NUM_THREE => 'tres', CLX_NUM_FOUR => 'cuatro', CLX_NUM_FIVE => 'cinco', CLX_NUM_SIX => 'seis', CLX_NUM_7 => 'siete', CLX_NUM_8 => 'ocho', CLX_NUM_NINE => 'nueve')
    );
    public static $teens = array(
        'en' => array(CLX_NUM_ZERO => 'ten', CLX_NUM_ONE => 'eleven', CLX_NUM_TWO => 'twelve', CLX_NUM_THREE => 'thirteen', CLX_NUM_FOUR => 'fourteen', CLX_NUM_FIVE => 'fifteen', CLX_NUM_SIX => 'sixteen', CLX_NUM_7 => 'seventeen', CLX_NUM_8 => 'eighteen', CLX_NUM_NINE => 'nineteen'),
        'es' => array(CLX_NUM_ZERO => 'diez', CLX_NUM_ONE => 'once', CLX_NUM_TWO => 'doce', CLX_NUM_THREE => 'trece', CLX_NUM_FOUR => 'catorce', CLX_NUM_FIVE => 'quince', CLX_NUM_SIX => 'dieciséis', CLX_NUM_7 => 'diecisiete', CLX_NUM_8 => 'dieciocho', CLX_NUM_NINE => 'diecinueve')
    );
    public static $tens = array(
        'en' => array(CLX_NUM_ZERO => 'zero', CLX_NUM_TWO => 'twenty', CLX_NUM_THREE => 'thirty', CLX_NUM_FOUR => 'fourty', CLX_NUM_FIVE => 'fifty', CLX_NUM_SIX => 'sixty', CLX_NUM_7 => 'seventy', CLX_NUM_8 => 'eighty', CLX_NUM_NINE => 'ninety'),
        'es' => array(CLX_NUM_ZERO => 'cero', CLX_NUM_TWO => 'veinte', CLX_NUM_THREE => 'treinta', CLX_NUM_FOUR => 'cuarenta', CLX_NUM_FIVE => 'cincuenta', CLX_NUM_SIX => 'sesenta', CLX_NUM_7 => 'setenta', CLX_NUM_8 => 'ochenta', CLX_NUM_NINE => 'noventa'));
    public static $hundreds_male = array(
        'en' => array(CLX_NUM_ZERO => '', CLX_NUM_ONE => 'one', CLX_NUM_TWO => 'two', CLX_NUM_THREE => 'three', CLX_NUM_FOUR => 'four', CLX_NUM_FIVE => 'five', CLX_NUM_SIX => 'six', CLX_NUM_7 => 'seven', CLX_NUM_8 => 'eight', CLX_NUM_NINE => 'nine', CLX_NUM_HUNDRED => 'one'),
	
        'es' => array(CLX_NUM_ZERO => '', CLX_NUM_ONE => 'ciento', CLX_NUM_TWO => 'doscientos', CLX_NUM_THREE => 'trescientos', CLX_NUM_FOUR => 'cuatrocientos', CLX_NUM_FIVE => 'quinientos', CLX_NUM_SIX => 'seiscientos', CLX_NUM_7 => 'setecientos', CLX_NUM_8 => 'ochocientos', CLX_NUM_NINE => 'novecientos', CLX_NUM_HUNDRED => 'cien'));
    public static $hundreds_female = array(
        'en' => array(CLX_NUM_ZERO => '', CLX_NUM_ONE => 'one', CLX_NUM_TWO => 'two', CLX_NUM_THREE => 'three', CLX_NUM_FOUR => 'four', CLX_NUM_FIVE => 'five', CLX_NUM_SIX => 'six', CLX_NUM_7 => 'seven', CLX_NUM_8 => 'eight', CLX_NUM_NINE => 'nine', CLX_NUM_HUNDRED => 'one'),
	
        'es' => array(CLX_NUM_ZERO => '', CLX_NUM_ONE => 'ciento', CLX_NUM_TWO => 'doscientas', CLX_NUM_THREE => 'trescientas', CLX_NUM_FOUR => 'cuatrocientas', CLX_NUM_FIVE => 'quinientas', CLX_NUM_SIX => 'seiscientas', CLX_NUM_7 => 'setecientas', CLX_NUM_8 => 'ochocientas', CLX_NUM_NINE => 'novecientas', CLX_NUM_HUNDRED => 'cien'));
    public static $hundreds_other = array(
        'en' => array(CLX_NUM_ZERO => '', CLX_NUM_ONE => 'one', CLX_NUM_TWO => 'two', CLX_NUM_THREE => 'three', CLX_NUM_FOUR => 'four', CLX_NUM_FIVE => 'five', CLX_NUM_SIX => 'six', CLX_NUM_7 => 'seven', CLX_NUM_8 => 'eight', CLX_NUM_NINE => 'nine', CLX_NUM_HUNDRED => 'one'),
	'es' => array(CLX_NUM_ZERO => '', CLX_NUM_ONE => 'ciento', CLX_NUM_TWO => 'doscientos', CLX_NUM_THREE => 'trescientos', CLX_NUM_FOUR => 'cuatrocientos', CLX_NUM_FIVE => 'quinientos', CLX_NUM_SIX => 'seiscientos', CLX_NUM_7 => 'setecientos', CLX_NUM_8 => 'ochocientos', CLX_NUM_NINE => 'novecientos', CLX_NUM_HUNDRED => 'cien'));
 
    public static $suffix = array(
        'en' => array(CLX_NUM_ZERO => 'thousand', CLX_NUM_ONE => 'million', CLX_NUM_TWO => 'billion', CLX_NUM_THREE => 'trillion', CLX_NUM_FOUR => 'quadrillion'),
        'es' => array(CLX_NUM_ZERO => 'mil', CLX_NUM_ONE => 'millones', CLX_NUM_TWO => 'billones', CLX_NUM_THREE => 'trillones', CLX_NUM_FOUR => 'cuatrillones')
    );
    public static $negatives = array('en' => 'Minus', 'es' => 'Menos');
    public static $other = array(
        'en' => array(CLX_NUM_ZERO => 'Invalid characters in input', CLX_NUM_ONE => 'Out of range', CLX_NUM_TWO => 'hundred', CLX_NUM_THREE => 'hundred and', CLX_NUM_FOUR => 'and', CLX_NUM_FIVE => 'minus', CLX_NUM_SIX => 'with', CLX_NUM_7 => 'cents', CLX_NUM_8 => 's', CLX_NUM_NINE => ' ', CLX_NUM_TEN => 's', CLX_NUM_11 => '', CLX_NUM_12 => 'point'),
        'es' => array(CLX_NUM_ZERO => 'Caracteres invalidos', CLX_NUM_ONE => 'Fuera de rango', CLX_NUM_TWO => '', CLX_NUM_THREE => '', CLX_NUM_FOUR => ' ', CLX_NUM_FIVE => 'menos', CLX_NUM_SIX => 'con', CLX_NUM_7 => 'centavos', CLX_NUM_8 => '', CLX_NUM_NINE => 'y', CLX_NUM_TEN => 's', CLX_NUM_11 => 'o', CLX_NUM_12 => 'punto')
    );

    /**
     * Returns appropriate text for given number. Despite
     * appearances the number should (though isn') . 't required) be
     * passed in as a string. This allows large numbers to be
     * converted. Integers are handled just fine though.
     * Negative numbers are handled fine.
     *
     * The billion/trillion etc suffixes are done using the American
     * style (eg 9 zeros for billion, 12 for trillion), which albeit
     * being mathmetically incorrect, is (I believe) the commonly
     * accepted norm. Since this code was written for the purpose
     * of validating human vs spider form submissions, this is the
     * more appropriate way to go.
     *
     * @param  string $int The number to convert. Optional.
     * @return text        Resulting text
     */
    private static function ToString($int, $lang = 'en', $is_integer = false, $is_decimal = false,$gender='m') {
		$lang=clx_language_lower_upper($lang);
        // Check for purely numeric chars
        if (!preg_match('#^[\d.]+$#', $int)) {
		  throw new Exception(self::$other[$lang][CLX_NUM_ZERO]);
        }
        // Handle decimals
        if (strpos($int, '.') !== false) {
		  $decimal = substr($int, strpos($int, '.') + CLX_NUM_ONE);
		  $int = substr($int, CLX_NUM_ZERO, strpos($int, '.'));
        }
        // Lose insignificant zeros
        if ($is_decimal) {
        //    $int = rtrim($int, '0');
	}
        else
		  $int = ltrim($int, '0');
        // Check for valid number
        if ($int === '') {
		  $int = '0';
        }
        // Lose the negative, don't use abs() so as to allow large numbers
        if (($negative = ($int < CLX_NUM_ZERO)) === true) {
		  $int = substr($int, CLX_NUM_ONE);
        }
        // Number too big?
        if (strlen($int) > CLX_NUM_18) {
		  throw new Exception(self::$other[$lang][CLX_NUM_ONE]);
        }
        // Keep original number
        /**
         * Main number deciphering bit thing
         */
        switch (strlen($int)) {
		  // Single digit number
		  case '1':
		if (lowercase($gender)=='m')
		    $text = self::$units_male[$lang][$int];
		else if (lowercase($gender)=='f')
		    $text = self::$units_female[$lang][$int];
		else 
		    $text = self::$units_other[$lang][$int];
			 break;
		  // Two digit number
		  case '2':

			 if ($int[CLX_NUM_ZERO] === '1') {
			     $text = self::$teens[$lang][$int[CLX_NUM_ONE]];
			 } else if ($int[CLX_NUM_ONE] === '0') {
			     $text = self::$tens[$lang][$int[CLX_NUM_ZERO]] . ' ' . self::$other[$lang][CLX_NUM_THREE] . ' ';
			 } else {
			     if (lowercase($gender)=='m')
			$text = self::$tens[$lang][$int[CLX_NUM_ZERO]] . ' ' . self::$other[$lang][CLX_NUM_NINE] . ' ' . self::$units_male[$lang][$int[CLX_NUM_ONE]];
		    else if (lowercase($gender)=='f')
			$text = self::$tens[$lang][$int[CLX_NUM_ZERO]] . ' ' . self::$other[$lang][CLX_NUM_NINE] . ' ' . self::$units_female[$lang][$int[CLX_NUM_ONE]];
		    else 
			$text = self::$tens[$lang][$int[CLX_NUM_ZERO]] . ' ' . self::$other[$lang][CLX_NUM_NINE] . ' ' . self::$units_other[$lang][$int[CLX_NUM_ONE]];
			 }
			 break;
		  // Three digit number
		  case '3':
			 if ($int % CLX_NUM_HUNDRED == CLX_NUM_ZERO) {
			     if ($int == CLX_NUM_HUNDRED) {
			         if (lowercase($gender)=='m' )
			    $text = self::$hundreds_male[$lang][$int] . ' ' . self::$other[$lang][CLX_NUM_TWO];
			else if (lowercase($gender)=='f')
			    $text = self::$hundreds_female[$lang][$int] . ' ' . self::$other[$lang][CLX_NUM_TWO];
			else 
			    $text = self::$hundreds_other[$lang][$int] . ' ' . self::$other[$lang][CLX_NUM_TWO];
			     } else {
			         if (lowercase($gender)=='m' )
			    $text = self::$hundreds_male[$lang][$int[CLX_NUM_ZERO]] . ' ' . self::$other[$lang][CLX_NUM_TWO];
			else if (lowercase($gender)=='f')
			    $text = self::$hundreds_female[$lang][$int[CLX_NUM_ZERO]] . ' ' . self::$other[$lang][CLX_NUM_TWO];
			else 
			    $text = self::$hundreds_other[$lang][$int[CLX_NUM_ZERO]] . ' ' . self::$other[$lang][CLX_NUM_TWO];

			     }
			 } else {
			     //$text = self::$units[$lang][$int{0}] . ' '.self::$other[$lang][3].' ' . self::GetText(substr($int, 1), $lang);
			         if (lowercase($gender)=='m' )
			    $text = self::$hundreds_male[$lang][$int[CLX_NUM_ZERO]] . ' ' . self::$other[$lang][CLX_NUM_THREE] . ' ' . self::GetText(substr($int, CLX_NUM_ONE), $lang,false,false,$gender);
			else if (lowercase($gender)=='f')
			    $text = self::$hundreds_female[$lang][$int[CLX_NUM_ZERO]] . ' ' . self::$other[$lang][CLX_NUM_THREE] . ' ' . self::GetText(substr($int, CLX_NUM_ONE), $lang,false,false,$gender);
			else 
			    $text = self::$hundreds_other[$lang][$int[CLX_NUM_ZERO]] . ' ' . self::$other[$lang][CLX_NUM_THREE] . ' ' . self::GetText(substr($int, CLX_NUM_ONE), $lang,false,false,$gender);

			 }
			 break;
		  // Anything else
		  default:
			 $pieces = array();
			 $suffixIndex = CLX_INIT_ZERO;
			 $done_digits = -CLX_NUM_ONE * strlen(abs($int));
			 $done_digits = -CLX_NUM_THREE;
			 // Handle the last three digits
			 $num = substr($int, $done_digits);
			 if ($num > CLX_NUM_ZERO) {
			     $pieces[] = self::GetText($num, $lang,false,false,$gender);
			 }
			 $int = substr($int, CLX_NUM_ZERO, $done_digits);
			 // Now handle the thousands/millions etc
			 while (strlen($int) > abs($done_digits)) {
			     $num = substr($int, $done_digits);
			     if ($num > CLX_NUM_ZERO) {
			         $pieces[] = self::GetText($num, $lang,false,false,$gender) . '  ' . self::$suffix[$lang][$suffixIndex];
			     }
			     $int = substr($int, CLX_NUM_ZERO, $done_digits);
			     $suffixIndex++;
			 }
			 if (strlen($int) == CLX_NUM_ONE && substr($int, $done_digits) === CLX_NUM_ONE) {
			     if ($lang === 'en') {
			         $pieces[] = self::GetText(substr($int, $done_digits), $lang,false,false,$gender) . ' ' . self::$suffix[$lang][$suffixIndex];
			     } else {
			         $pieces[] = substr(self::GetText(substr($int, $done_digits), $lang,false,false,$gender), CLX_NUM_ZERO, CLX_NUM_TWO) . ' ' . self::$suffix[$lang][$suffixIndex];
			     }
			 } else {
			     $pieces[] = self::GetText(substr($int, $done_digits), $lang,false,false,$gender) . '  ' . self::$suffix[$lang][$suffixIndex];
			 }
			 /**
			  * Figure out whether we need to add 'and' in there somewhere
			  */
			 $pieces = array_reverse($pieces);
			 if (count($pieces) > CLX_NUM_ONE && strpos($pieces[count($pieces) - CLX_NUM_ONE], ' ' . self::$other[$lang][CLX_NUM_FOUR] . ' ') === false) {
			     $pieces[] = $pieces[count($pieces) - CLX_NUM_ONE];
			     $pieces[count($pieces) - CLX_NUM_TWO] = self::$other[$lang][CLX_NUM_FOUR];
			 }
			 // Create the text
			 $text = implode(' ', $pieces);
			 // Negative number?
			 if (!empty($negative)) {
			     $text = self::$other[$lang][CLX_NUM_FIVE] . ' ' . $text;
			 }
			 break;
        }
        /**
         * Handle any decimal part
         */
        if (!empty($decimal)) {
		  $pieces = array();
		  $decimal = preg_replace('#[^0-9]#', '', $decimal);
		  for ($i = CLX_NUM_ZERO, $len = strlen($decimal); $i < $len; ++$i) {
		if (lowercase($gender)=='m')
		    $pieces[] = self::$units_male[$lang][$decimal[$i]];
		else if (lowercase($gender)=='f')
		    $pieces[] = self::$units_female[$lang][$decimal[$i]];
		else 
		    $pieces[] = self::$units_other[$lang][$decimal[$i]];

	    }
		  $text_con = ( self::$is_currency ? self::$other[$lang][CLX_NUM_SIX] : self::$other[$lang][CLX_NUM_12] );
		  $text .= ' ' . $text_con . ' ' . implode(' ', $pieces) . ' ' . self::$other[$lang][CLX_NUM_7];
        }



        return $text;
    }

    /**
     * Returns text for given number. Parameter should ideally
     * be a string (to handle large numbers) though integers are
     * OK.
     *
     * @param  string $int Number to convert
     * @return string      Resulting textual representation
     */
    public static function GetText($int, $lang = 'en', $is_integer = false, $is_decimal = false, $gender='m') {
		$lang=clx_language_lower_upper($lang);
        if ($int < 0) {
		  self::$is_negative = true;
		  $int = -1 * $int;
        }
        $text = self::ToString($int, $lang, $is_integer, $is_decimal,$gender);

        return $text;
    }

    /**
     * Returns currency version of a given number.
     *
     * @param  string $int   Number to convert
     * @param  string $major Word to use for left hand side of decimal point
     * @param  string $minor Word to use for right hand side of decimal point
     * @param bool $is_integer
     * @return string        Resulting string
     */
    public function GetCurrency($int, $lang = 'en', $major = 'pound', $minor = 'pence', $is_integer = false, $is_currency = true, $decimal_places = null,$currency='',$gender='m') {
		$lang=clx_language_lower_upper($lang);
	if (isset($_GET["VER"])) {
				    ECHO"x". $gender;
				    DIE;
				}
        if ($int < 0) {
		  self::$is_negative = true;
		  $int = -1 * $int;
        }
        if (trim($int) === '') {
		  $text = ''; //  : blank if zero condition
        } else {
		  if (is_null($decimal_places)) {
			 $decimal_places = ($is_integer ? CLX_NUM_ZERO : CLX_NUM_TWO);
		  } else {
			 $decimal_places = CLX_NUM_ZERO + $decimal_places;
		  }
		  self::$decimal_places = $decimal_places;
		  self::$is_currency = $is_currency;
		  if (substr($lang,0,2) === 'es') {
			 $lang = 'es';
		  }
		  if (strpos($int, '.') === false)
			 $int.= '.00';
		  if (strpos($int, '.') !== false) {
			 $left = substr($int, CLX_NUM_ZERO, strpos($int, '.'));
			 $right = substr($int, strpos($int, '.') + CLX_NUM_ONE);
			 // Plural $major ?
			 if ((int) abs($left) > CLX_NUM_ONE && $major <> '') {
			     $major .= self::$other[$lang][CLX_NUM_8];
			 }
			 if ((int) abs($right) !== CLX_NUM_ONE && $minor <> '') {
			     $minor .= self::$other[$lang][CLX_NUM_TEN];
			 }
			 if ($major === '') {
			     if ($minor === '') {
			         if (!empty($is_integer)) {

					   $text = self::GetText($left, $lang, $is_integer,false,$gender);
			         } else {
					   if (self::$is_currency) {
						  $text = self::GetText($left, $lang, $is_integer,false,$gender) .
								' ' . self::$other[$lang][CLX_NUM_SIX] . ' ' .
								substr($right, CLX_NUM_ZERO, self::$decimal_places) . '/100';
					   } else {
						  $text = self::GetText($left, $lang, $is_integer,false,$gender) .
								' ' . self::$other[$lang][CLX_NUM_12] . ' ' .
								self::GetText(substr($right, CLX_NUM_ZERO, self::$decimal_places), $lang, $is_integer, true,$gender);
					   }
			         }
			     } else {
			         $text = self::GetText($left, $lang, $is_integer,false,$gender) . ' ' . self::GetText($right, $lang, $is_integer, true,false,$gender) . ' ' . $minor;
			     }
			 } else {
			     $text = self::GetText($left, $lang, $is_integer) .
					   ' ' . $major . ' ' . self::$other[$lang][CLX_NUM_FOUR] . '  ' . self::GetText($right, $lang, $is_integer, true,$gender) . '  ' . $minor;
			 }
		  } else {
			 $text = self::GetText($int, $lang, $is_integer,false,$gender) . ' ' . $major;
		  }
		  $text = str_replace('  ', ' ', (string) $text);
		  $text = str_replace('veinte y uno', 'ventiuno', $text);
		  $text = str_replace('veinte y dos', 'veintidós', $text);
		  $text = str_replace('veinte y tres', 'veintitrés', $text);
		  $text = str_replace('veinte y cuatro', 'veinticuatro', $text);
		  $text = str_replace('veinte y cinco', 'veinticinco', $text);
		  $text = str_replace('veinte y seis', 'veintiséis', $text);
		  $text = str_replace('veinte y siete', 'veintisiete', $text);
		  $text = str_replace('veinte y ocho', 'veintiocho', $text);
		  $text = str_replace('veinte y nueve', 'veintinueve', $text);

		  $text = str_replace('y uno mil', 'y un mil', $text);

		  // Caso 1002121 - CJRD - 2016-03-04 - Verifica casos especiales adicionales a los previstos inicialmente
		  // Los que comienzan por... por ejemplo: 1,305,000 = uno millones trescientos cinco mil > un millon trescientos cinco mil
		  /*
		    $text = str_replace('un millones', 'un millón', $text);
		    $text = str_replace('un billones', 'un billón', $text);
		    $text = str_replace('un trillones', 'un trillón', $text);
		    $text = str_replace('un cuatrillones', 'un cuatrillón', $text);
		   */
		  $text = $this->tn_special_cases('uno millones', 'un millón', $text);
		  $text = $this->tn_special_cases('uno billones', 'un billón', $text);
		  $text = $this->tn_special_cases('uno trillones', 'un trillón', $text);
		  $text = $this->tn_special_cases('uno cuatrillones', 'un cuatrillón', $text);

		  // Los que contienen... por ejemplo: 31,305,000 = treinta y uno millones trescientos cinco mil > treinta y un millon trescientos cinco mil
		  $text = str_replace('uno millones', 'un millones', $text);
		  $text = str_replace('uno billones', 'un billones', $text);
		  $text = str_replace('uno trillones', 'un trillones', $text);
		  $text = str_replace('uno cuatrillones', 'un cuatrillones', $text);

		  // Por ejemplo: 1,000 > uno mil >  mil
		  // Por ejemplo: 1,500 > uno mil >  mil quinientos
		  $text = $this->tn_special_cases('uno mil', 'mil', $text);
		  // Por ejemplo: 301,000 > trecientos uno mil > trecientos un mil
		  $text = str_replace('uno mil', 'un mil', $text);
        }


        if (self::$is_negative) {
		  $text = self::$negatives[$lang] . ' ' . $text;
        }
	$currenttext='';
	if (!empty($currency)) {
	    $DBLT = &getTool('DBLT'); 
	    $currenttext= $DBLT->getListItem('CURR', $currency,2);
	}
        return ucfirst($text) .$currenttext;
    }

    function tn_special_cases($str_srch, $str_replace, $text) {
        if (substr($text, CLX_NUM_ZERO, strlen($str_srch)) === $str_srch) {
		  // Solo si comienza con el string que se está evaluando
		  $text = str_replace($str_srch, $str_replace, $text);
        }
        return $text;
    }

    function GetStringNumberMix($variantPar0, $lang = 'en', $major = 'pound', $minor = 'pence', $is_integer = false, $is_currency = true, $decimal_places = null) {
        define('INDIVIDUAL_NUMBERS', '(IN)');
		$lang=clx_language_lower_upper($lang);
        $variantPar = $variantPar0;
        $sw_individual_numbers = ( substr($variantPar, CLX_NUM_ZERO, strlen(INDIVIDUAL_NUMBERS)) == INDIVIDUAL_NUMBERS );
        if (!empty($sw_individual_numbers)) {
		  $variantPar = substr($variantPar, strlen(INDIVIDUAL_NUMBERS), strlen($variantPar) - strlen(INDIVIDUAL_NUMBERS));
        }
        $s_response = '';
        $i = CLX_INIT_ZERO;
        $last_string = '';
        $last_number = '';
        while ($i < strlen($variantPar)) {
		  $curr_char = substr($variantPar, $i, CLX_NUM_ONE);
		  if (is_numeric($curr_char)) {
			 if ($last_string !== '') {
			     $s_response .= ( ' ' . $last_string );
			     $last_string = '';
			 }
			 $last_number .= $curr_char;
			 if (!empty($sw_individual_numbers)) {
			     $last_number = (CLX_NUM_ZERO + $last_number);
			     $s_response .= ( ' ' . self::GetCurrency($last_number, $lang, $major, $minor, $is_integer, $is_currency, $decimal_places) );
			     $last_number = '';
			 }
		  } else {
			 if ($last_number !== '') {
			     $last_number = (CLX_NUM_ZERO + $last_number);
			     $s_response .= ( ' ' . self::GetCurrency($last_number, $lang, $major, $minor, $is_integer, $is_currency, $decimal_places) );
			     $last_number = '';
			 }
			 $last_string .= $curr_char;
		  }
		  $i += CLX_NUM_ONE;
        }
        if ($last_string !== '') {
		  $s_response .= ( ' ' . $last_string );
        } elseif ($last_number !== '') {
		  $last_number = (CLX_NUM_ZERO + $last_number);
		  $s_response .= ( ' ' . self::GetCurrency($last_number, $lang, $major, $minor, $is_integer, $is_currency, $decimal_places) );
        }
        return $s_response;
    }

}
