<?php

/**
 * General Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-10-09 11:22:02 -0400 (Tue, 09 Oct 2018) $
 * @version        $Rev: 10222 $
 * @package		Clientix.Classes.File
 * @abstract		General Class
 * CHANGE LOG
 *  Included label
 */
class clx_filesystem {

    /**
     * Constructor
     */
    function __construct() {

    }

// End constructor
    function writableDirectory($directory) {

    }

// End method
    function createDirectory($directory) {
        return mkdir($directory);
    }

// End method
    function isDirectory($directory) {
        return is_dir($directory);
    }

// End method
    function isFile($directory) {
        return is_file($directory);
    }

// End method
    function rDir($directory) {
        $return = array();
        if ($this->isDirectory($directory)) {
		  $dir = dir($directory);
		  while (false !== $entry = $dir->read()) {
			 $return[] = $entry;
		  }
        } else {
		  $return = false;
        }
        return $return;
    }

    /**
     * Reads and entire file and return its content
     */
    function rFile($filename, $binaryread = false) {
        $handle = fopen($filename, (!$binaryread) ? 'r' : 'rb');
        $contents = fread($handle, filesize($filename));
        fclose($handle);
        return $contents;
    }

// End method
    /**
     * Create a file and writes content to it,
     * return the number of lines writen or false.
     */
    function wFile($filename, $content) {
        $handle = fopen($filename, 'w');
        $write = fwrite($handle, $content);
        fclose($handle);
        return $write;
    }

    /**
     * Prepares path to be used on window or linux
     */
    function pPath($filename) {
        if (stristr(PHP_OS, 'WIN') !== false) {
		  $from = '/';
		  $to = '\\';
        } else {
		  $to = '/';
		  $from = '\\';
        }
        return str_replace($from, $to, $filename);
    }

// End method
    /**
     * Copy a file, or recursively copy a folder and its contents
     *
     * @author      Aidan Lister <aidan@php.net>
     * @version     1.0.1
     * @param       string   $source    Source path
     * @param       string   $dest      Destination path
     * @return      bool     Returns true on success, false on failure
     */
    function copyr($source, $dest) {
        // Simple copy for a file
        if ($this->isFile($source) === true) {
		  return copy($source, $dest);
        }
        // Make destination directory
        if (!$this->isDirectory($dest)) {
		  mkdir($dest);
        }
        // Loop through the folder
        $dir = dir($source);
        while (false !== $entry = $dir->read()) {
		  // Skip pointers
		  if ($entry === '.' || $entry === '..') {
			 continue;
		  }
		  // Deep copy directories
		  if ($dest !== $source . '/' . $entry) {
			 ClxFreeReturn($this->copyr($source . '/' . $entry, $dest . '/' . $entry));
		  }
        }
        // Clean up
        $dir->close();
        return true;
    }

}
