<?php

/**
 * General Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 16:24:19 +0000 (Thu, 03 Sep 2015) $
 * @version      $Rev: 6814 $
 * @package		Clientix.Classes.File
 * @abstract	General Class
 * CHANGE LOG
 */
class clx_msexcel extends clx_file {

    var $filename;
    var $filemode;

    function clx_file_excell($file_name, $mode = 'r') {
        $this->filename = $file_name;
        $this->filemode = $mode;
    }

//end constructor
    // Builds xml
    function buildXml($data) {
        $ln = CLX_CHAR_NL;
        $date = date('c');
        $cols = count(array_keys($data));
        $company = '';
        $author = '';
        $version = '1.0';
        $contents = '<?xml version=' . singleQuote('1.0') . '?>';
        $contents .= '<?mso-application progid=' . singleQuote('Excel.Sheet') . '?>';
        $contents .= '<Workbook xmlns="urn:schemas-microsoft-com:office:spreadsheet"	xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:x="urn:schemas-microsoft-com:office:excel" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40">' . $ln;
        $contents .= ' <DocumentProperties
						xmlns="urn:schemas-microsoft-com:office:office">
						<Author>' . $author . '</Author>
						<LastAuthor>' . $author . '</LastAuthor>
						<Created>' . $date . '</Created>
						<LastSaved>' . $date . '</LastSaved>
						<Company>' . $company . '</Company>
						<Version>' . $version . '</Version>
				    </DocumentProperties>' . $ln;
        $contents .= ' <ExcelWorkbook
						xmlns="urn:schemas-microsoft-com:office:excel">
					  <WindowHeight>8535</WindowHeight>
					  <WindowWidth>12345</WindowWidth>
					  <WindowTopX>480</WindowTopX>
					  <WindowTopY>90</WindowTopY>
					  <ProtectStructure>false</ProtectStructure>
					  <ProtectWindows>false</ProtectWindows>
					</ExcelWorkbook>' . $ln;
        $contents .= ' <Styles>
						<Style ss:ID="Default" ss:Name="Normal">
							  <Alignment ss:Vertical="Bottom"/>
							  <Borders/>
							  <Font/>
							  <Interior/>
							  <NumberFormat/>
							  <Protection/>
						</Style>
						<Style ss:ID="s21" ss:Name="Hyperlink">
							<Font x:Family="Arial" ss:Color="#0000FF" ss:Underline="Single"/>
						</Style>
						<Style ss:ID="s23">
							<Font x:Family="Arial" ss:Bold="1"/>
						</Style>
						<Style ss:ID="s24">
							<Font x:Family="Arial"/>
						</Style>
					</Styles>' . $ln;
        //Table definition
        $contents .= ' <Worksheet ss:Name="Names">
					<Table ss:ExpandedColumnCount="' . $cols . '"
						ss:ExpandedRowCount="' . ($cols + CLX_NUM_ONE) . '"
					x:FullColumns="1" x:FullRows="1">' . $ln;
        //Headers
        $contents .= '<Column ss:Index="' . $cols . '"
						ss:AutoFitWidth="0" ss:Width="100"/>' . $ln;
        //Lines
        $i = CLX_NUM_ZERO;
        foreach ($data as $key => $val) {
		  if ($i == CLX_NUM_ZERO) {
			 //headers
			 $contents .= '<Row ss:StyleID="s23">
								<Cell><Data ss:Type="String">
							';
			 $contents .= implode('</Data>
									</Cell>
									<Cell>
										<Data ss:Type="String">', $val);
			 $contents .= '</Data></Cell></Row>' . $ln;
			 $i++;
			 continue;
		  }
		  $contents .= ' <Row  ss:StyleID="s24">
						<Cell>
							<Data ss:Type="String">';
		  $contents .= implode('</Data>
									</Cell>
									<Cell>
										<Data ss:Type="String">', $val);
		  $contents .='</Data>
						</Cell>
					</Row>' . $ln;
        }//end while
        $contents .= '</Table>
					<WorksheetOptions
						xmlns="urn:schemas-microsoft-com:office:excel">
						<Print>
							<ValidPrinterInfo/>
							<HorizontalResolution>300</HorizontalResolution>
							<VerticalResolution>300</VerticalResolution>
						</Print>
						<Selected/>
						<Panes>
							<Pane>
								<Number>3</Number>
								<ActiveRow>1</ActiveRow>
							</Pane>
						</Panes>
						<ProtectObjects>false</ProtectObjects>
						<ProtectScenarios>false</ProtectScenarios>
					</WorksheetOptions>
				</Worksheet>
			</Workbook>' . $ln;
        return $contents;
    }

}
