<?php
if (!function_exists('initAccoRecord')) {
    /*
     * Code Library: ACCO-REC
     */
    if (!class_exists('ibs_crm_account_socket_import')) {
        includeCodeLib('EIBS_ACCO');
    }
    ClxCommon::$cached['acco_utilities_debug'] = false;

    function initAccoRecord(&$record) {
	ClxFreeReturn($record);
        $contenidoHTML = 'initAccoRecord<br>';
        echo $contenidoHTML;
    }

    function loadAccoRecord(&$record) {
	ClxFreeReturn($record);
        $contenidoHTML = 'loadAccoRecord<br>';
        echo $contenidoHTML;
    }

// ACCO Record Validation: Mandatory Fields for e-IBS Client export
    define('MAX_PHONE_NUMBER_LEN', CLX_NUM_32);
    //define('MAX_PHONE_NUMBER_LEN', CLX_NUM_12);//para ibs son 12 pero en cualquier otro caso no molestar con esto
    function validateAccoRecord(&$msg1, $record) {
        ClxCommon::$cached['b_sw_accorecval_deactivation'] = false;
        //IBS Client search is not required to validate
        if (!empty($record['fm']) && $record['fm'] === 'ACCO_IBS_SRCH') {
            return;
        }
        $fm = (UserRequest::$request['ac'] <> 'DELETE') ? 'ACCO_' : '';
        if (!isset($record[$fm . 'LEGAL_TYPE']) )
			$record[$fm . 'ISINDIVIDUAL'] =-1;
		else
			$record[$fm . 'ISINDIVIDUAL'] = set_isindividual($record[$fm . 'LEGAL_TYPE']);
   
        $msg = array();
        if (!is_array($msg1)) {
            $msg1 = array();
        }
        if (!isset(ClxCommon::$cached['b_sw_accorecval_deactivation']) || empty(ClxCommon::$cached['b_sw_accorecval_deactivation'])) {
            ClxCommon::$cached['b_sw_accorecval_deactivation'] = false;
        }
        $s_eibs_interface_active = companyParameter('EIBS_INTERFACE_ACTIVE');
        $max_ph_len = trim(companyParameter('MAX_PHONE_NUMBER_LEN'));
        if(is_null($max_ph_len) || $max_ph_len === '' || $max_ph_len === 'null' || $max_ph_len === 'NULL') {
            $max_ph_len = MAX_PHONE_NUMBER_LEN;
        } else {
            $max_ph_len = CLX_NUM_ZERO+$max_ph_len;
        }
        if (UserRequest::$request['ac'] === 'DELETE') {
        } else {
            if ($s_eibs_interface_active === '1' && ClxCommon::$cached['b_sw_accorecval_deactivation'] == false) {
                // IBS Interface is active, so, validates mandatory fields
                // WARNING: ONLY WORKS WITH VERSION 55 AND FURTHER
                if ($record[$fm . 'ISINDIVIDUAL'] === CLX_NUM_ONE) {
                    // Individual
                    if (trim($record[$fm . 'FIRSTNAME']) === '') {
                        $msg[$fm . 'FIRSTNAME'] = dict('GEN_ERR_IBS_IMPCLI_MISSING_VALUE');
                    }
                    if (trim($record[$fm . 'LASTNAME']) === '') {
                        $msg[$fm . 'LASTNAME'] = dict('GEN_ERR_IBS_IMPCLI_MISSING_VALUE');
                    }
                    if (trim($record[$fm . 'INCOME_SOURCE']) === '') {
                        $msg[$fm . 'INCOME_SOURCE'] = dict('GEN_ERR_IBS_IMPCLI_MISSING_VALUE');
                    }
                    if (trim($record[$fm . 'CITIZENSHIP']) === '') {
                        $msg[$fm . 'CITIZENSHIP'] = dict('GEN_ERR_IBS_IMPCLI_MISSING_VALUE');
                    }
                    if (trim($record[$fm . 'BIRTHDATE']) === '') {
                        $msg[$fm . 'BIRTHDATE'] = dict('GEN_ERR_IBS_IMPCLI_MISSING_VALUE');
                    }
                    if (trim($record[$fm . 'SEX']) === '') {
                        $msg[$fm . 'SEX'] = dict('GEN_ERR_IBS_IMPCLI_MISSING_VALUE');
                    }
                    if (trim($record[$fm . 'MOBILE_PHONE']) !== '' && strlen(trim($record[$fm . 'MOBILE_PHONE'])) > $max_ph_len) {
                        $msg[$fm . 'MOBILE_PHONE'] = dict('GEN_ERR_FORMATOR_OR_SIZE');
                    }
                } else {
                    // Corporation
                    if (trim($record[$fm . 'IDNAME']) === '') {
                        $msg[$fm . 'IDNAME'] = dict('GEN_ERR_IBS_IMPCLI_MISSING_VALUE');
                    }
                    if (array_key_exists($fm . 'INDUSTRYCLASS', $record) && trim($record[$fm . 'INDUSTRYCLASS']) === '') {
                        $msg[$fm . 'INDUSTRYCLASS'] = dict('GEN_ERR_IBS_IMPCLI_MISSING_VALUE');
                    }
                }
                // Mandatory Fields
                if (trim($record[$fm . 'ID_TYPE']) === '') {
                    $msg[$fm . 'ID_TYPE'] = dict('GEN_ERR_IBS_IMPCLI_MISSING_VALUE');
                }
                if (trim($record[$fm . 'IDENTIFICATION']) === '') {
                    $msg[$fm . 'IDENTIFICATION'] = dict('GEN_ERR_IBS_IMPCLI_MISSING_VALUE');
                }
                if (trim($record[$fm . 'ADDRESS1']) === '') {
                    $msg[$fm . 'ADDRESS1'] = dict('GEN_ERR_IBS_IMPCLI_MISSING_VALUE');
                }
                if (trim($record[$fm . 'CITY']) === '') {
                    $msg[$fm . 'CITY'] = dict('GEN_ERR_IBS_IMPCLI_MISSING_VALUE');
                }
                if (trim($record[$fm . 'STATE']) === '') {
                    $msg[$fm . 'STATE'] = dict('GEN_ERR_IBS_IMPCLI_MISSING_VALUE');
                }
                if (trim($record[$fm . 'COUNTRY']) === '') {
                    $msg[$fm . 'COUNTRY'] = dict('GEN_ERR_IBS_IMPCLI_MISSING_VALUE');
                }
                // Size limit on phone numbers
                if (trim($record[$fm . 'PHONE']) !== '' && strlen(trim($record[$fm . 'PHONE'])) > $max_ph_len) {
                    $msg[$fm . 'PHONE'] = dict('GEN_ERR_FORMATOR_OR_SIZE');
                }
                if (trim($record[$fm . 'FAX']) !== '' && strlen(trim($record[$fm . 'FAX'])) > $max_ph_len) {
                    $msg[$fm . 'FAX'] = dict('GEN_ERR_FORMATOR_OR_SIZE');
                }
            }
            // If the field isn't in the form, throws the error message anyway
            foreach ($msg as $name => $value) {
                if (!isset($record[$name])) {
                    addMessage($name . ' - ' . $value);
                }
            }
            $msg1 = array_merge($msg1, $msg);
        }
    }

    function createpostAccoRecord(&$record) {
	//ClxFreeReturn($record);
    }

    function createpreAccoRecord(&$record) {
        set_isindividual_record($record);
        if (ClxCommon::$db->fieldExists('CRM_ACCOUNTS', 'REQ_SYNCH')) {
            $record['REQ_SYNCH'] = CLX_NUM_ONE;
        }
        accoIdname($record, '');
        //Setting access tree to assignee
        if (empty($record['ACCDEP']) && !empty($record['ASSIGNEDTO_USER'])) {
            $record['ACCDEP'] = getAccessTreeDefNode('ACCDEP', $record['ASSIGNEDTO_USER']);
        }
    }

    function updatepreAccoRecord(&$record) {
        set_isindividual_record($record);
        if (ClxCommon::$db->fieldExists('CRM_ACCOUNTS', 'REQ_SYNCH')) {
            $record['REQ_SYNCH'] = CLX_NUM_ONE;
        }
        accoIdname($record, '');
        //Setting access tree to assignee
        if (empty($record['ACCDEP']) && !empty($record['ASSIGNEDTO_USER'])) {
            $record['ACCDEP'] = getAccessTreeDefNode('ACCDEP', $record['ASSIGNEDTO_USER']);
        }
    }

    function updateAccoRecord(&$record) {
        //method used on post database commit
        //Validando la existencia de compliance y ejecutando recalculo
        if (existsCodeLib('CMP') && ClxCommon::$db->fieldExists('CRM_ACCOUNTS', 'ERROR_MSGS') && ClxCommon::$db->fieldExists('CMP_ACCOUNT_PROCESSES', 'IDCODE') && array_key_exists('IDCODE', $record)) {
            if (!class_exists('cmp_utilities')) {
                includeCodeLib('CMP');
            }
            $cmp = new cmp_utilities();
            $cmp->reValidateCmap($record['IDCODE']);
            unset($cmp);
        }
    }

    function deleteAccoRecord(&$record) {
        //e cho 'deleteAccoRecord<br>';
    }

    function LoadAccountcode($session_values, $record) {
        $reckeys = key($record);
        $cur_tablecode = substr($reckeys, CLX_NUM_ZERO, strpos($reckeys, '_', CLX_NUM_ZERO));
        unset($reckeys);
        $history = $session_values['history'];
        foreach ($history as $key => $value) {
            if (!empty($value['parentrecord']['CONT_accountcode'])) {
                $record[$cur_tablecode . '_accountcode'] = $value['parentrecord']['CONT_accountcode'];
                $record[$cur_tablecode . '_accountcode_prim'] = $value['parentrecord']['CONT_accountcode_prim'];
                $record[$cur_tablecode . '_accountcode_secd'] = $value['parentrecord']['CONT_accountcode_secd'];
                break;
            }
        }//end for each
        return $record;
    }

    function verfy_city_stat_code($record, &$msg, $fm = '') {
        // Two first City code characters must be equal to first two of the State code
        // (if both fields were specified)
        if (trim($record[$fm . 'STATE']) !== '' && trim($record[$fm . 'CITY']) !== '' &&
                $record[$fm . 'STATE'] != substr($record[$fm . 'CITY'], CLX_NUM_ZERO, CLX_NUM_TWO)) {
            /*
             * GEN_ERR_IBS_CITYSTATEINCOMPAT
             * Error, State & City incompatibility
             * Error, El estado y la ciudad no corresponden.
             */
            $msg[$fm . 'STATE'] = dict('GEN_ERR_IBS_CITYSTATEINCOMPAT') . ' (' . singleQuote($record[$fm . 'STATE']) . ', ' . singleQuote($record[$fm . 'CITY']) . ')';
            $msg[$fm . 'CITY'] = $msg[$fm . 'STATE'];
        }
    }

    /**
     * Split name according to separator
     * @param $record
     */
    function accoSplitIdname(&$record, $separator) {
        if ($record['ISINDIVIDUAL'] == CLX_NUM_ONE) {
            $names = explode($separator, $record['IDNAME']);
            if (!empty($names[CLX_NUM_ONE])) {
                $record['FIRSTNAME'] = trim($names[CLX_NUM_ONE]);
            }
            if (!empty($names[CLX_NUM_ZERO])) {
                $record['LASTNAME'] = trim($names[CLX_NUM_ZERO]);
            }
        } else {
            $record['LEGAL_NAME'] = $record['IDNAME'];
        }
    }

    /**
     * Construct leads name
     * @param unknown_type $record
     */
    function accoIdname(&$record, $prefix = '') {
        $name_mode = companyParameter('CRM_ACCO_IDNAME');
        //En servicios web como el de LA se regresa el cuscun y se actualiza lo que arroja un warning.
        //si no existe idname el cual no viene en la trama del servicio
        //entonces no hay que hacer nada con el campo de idname
        if (!array_key_exists($prefix . 'IDNAME', $record)) {
            return;
        }
        $idname = (!empty($record[$prefix . 'IDNAME'])) ? $record[$prefix . 'IDNAME'] : 'AUTO';
        $fname = (!empty($record[$prefix . 'FIRSTNAME'])) ? $record[$prefix . 'FIRSTNAME'] : '';
        $lname = (!empty($record[$prefix . 'LASTNAME'])) ? $record[$prefix . 'LASTNAME'] : '';
        $cname = 'null';
        if (array_key_exists($prefix . 'LEGAL_NAME', $record)) {
            $cname = $record[$prefix . 'LEGAL_NAME'];
        }
        if (array_key_exists($prefix . 'COMPANY', $record)) {
            $cname = $record[$prefix . 'COMPANY'];
        }
        $idname = uppercase($idname);
        if ($fname === 'null') {
            $fname = '';
        }
        if ($lname === 'null') {
            $lname = '';
        }
        if ($cname === 'null') {
            $cname = '';
        }
        if ($idname === 'AUTO') {
            if (intval($name_mode) === CLX_NUM_ONE && array_key_exists($prefix . 'ISINDIVIDUAL', $record)) {
                if (intval($record[$prefix . 'ISINDIVIDUAL']) === 1) {
                    $idname = $lname . ',' . $fname;
                } else {
                    $idname = $cname;
                }
            } else {
                if (!empty($lname) && !empty($fname) && !empty($cname)) {
                    $idname = $lname . ',' . $fname . '-' . $cname;
                } elseif (!empty($lname) && !empty($fname) && empty($cname)) {
                    $idname = $lname . ',' . $fname;
                } elseif (!empty($lname) && empty($fname) && !empty($cname)) {
                    $idname = $lname . '-' . $cname;
                } elseif (empty($lname) && !empty($fname) && !empty($cname)) {
                    $idname = $fname . '-' . $cname;
                } elseif (empty($lname) && empty($fname) && !empty($cname)) {
                    $idname = $cname;
                } else {
                    $idname = 'N/A';
                }
            }
            $record[$prefix . 'IDNAME'] = uppercase($idname);
        }
        if (!isset($record[$prefix . 'FULLNAME']) || is_null($record[$prefix . 'FULLNAME']) || trim($record[$prefix . 'FULLNAME']) === '') {
            $record[$prefix . 'FULLNAME'] = acco_full_name($record, $prefix);
        }
        accoApcId($record, $prefix);
    }

    /**
     * ACCO: Construct Identification for APC Export
     * @param array $record
     * @param char $prefix
     */
    function accoApcId(&$record, $prefix = '') {
        if (ClxCommon::$cached['acco_utilities_debug'] === true) {
            echoLog('<br>prefix = ' . $prefix .
                    '<br>fm = ' . UserRequest::$request['fm'] .
                    '<br>' .
                    print_r(UserRequest::$request, true) .
                    '<br>');
        }
        $acconame = tableName('ACCO');
        /*
         *  Field IDENTIFICATION_APC for Asociacion Panamena de Credito export file,
         *  because identification for that institution mus be in a specific format, difficut to calculate by SQL command
         */
        if ($prefix === 'ACCO' || (!empty(UserRequest::$request['fm']) && substr(UserRequest::$request['fm'], CLX_NUM_ZERO, CLX_NUM_FOUR) === 'ACCO')) {
            if (ClxCommon::$cached['acco_utilities_debug'] === true) {
                echoLog('Entro en condicional de solo ACCO<br><br>');
            }
            if (ClxCommon::$db->fieldExists($acconame, 'IDENTIFICATION_APC')) {
                $record = build_apc_identification($record, $prefix, 'IDENTIFICATION_APC', ClxCommon::$cached['acco_utilities_debug']);
            }
        }
    }

    /*
     * Builds identification for APC report
     * Feature include ACCO.IDENTIFICATION_APC column settling with IDENTIFICATION according to APC rules about text exchange file.
     * ACCO.IDENTIFICATION must have dashes '-' so this method can separate Cedula/RUC parts and fill it with zeroes before/after according to ID_TYPE.
     */
    function build_apc_identification($record, $prefix, $fieldname, $debug) {
        // Verify General Parameter APC_ID_ENABLED.
        // To activate (1) or deactivate (0) ACCO IDENTIFICATION_APC  setting for APC Export /
        // Para activar (1) o desactiva (0) la asignaci�n de la columna IDENTIFICATION_APC de la tabla ACCO para la Exportaci�n a la APC
        $SYPR = getTool('SYPR');
        $SYPR->initParameters('EBSK', 'IBS_ENABLED');
        $apc_id_enabled = (trim(companyParameter('APC_ID_ENABLED')) !== '0');
        if (!empty($debug)) {
            echoLog('<br>APC_ID_ENABLED = ' . companyParameter('APC_ID_ENABLED'));
        }
        if (!empty($debug)) {
            echoLog('<br>apc_id_enabled = ' . ($apc_id_enabled ? 'true' : 'false'));
        }
        // THIS FEATURE IS ENABLED BY DEFAULT (PARAMETER DOESN'T EXIST) or parameter is '1',
        // and can be turned off assigning '0' to this parameter
        if ($apc_id_enabled == false) {
            return $record;
        }
        if (!empty($debug)) {
            echoLog('<br>EBSK_IBS_ENABLED = ' . EBSK_IBS_ENABLED);
        }
        $s_fm = UserRequest::$request['fm']; // Get form name
        if (!empty($debug)) {
            echoLog('<br>s_fm = ' . $s_fm);
        }
        $apc_id = $record[$prefix . 'IDENTIFICATION'];
        if (strpos($apc_id, '-') === false) {
            // if no dashes, IDENTIFICATION must be updated from IBS
            if (EBSK_IBS_ENABLED === '1' && $s_fm !== 'ACCO_IBS_SRCH' && isset($record[$prefix . 'IBS_CUSCUN'])) {
                /*
                 * GEN_ERR_APC_EXP_INVALID_ID
                 * It's necessary to update ID from IBS for account (CUSCUN '^1'). Please go to 'IBS Accounts > IBS Client Search' option
                 * Es necesario actualizar la identificaci�n desde IBS a la cuenta (CUSCUN '^1'). Favor usar la opci�n 'IBS Cuentas > Busqueda de cliente IBS'
                 */
                $s_msg = dict('GEN_ERR_APC_EXP_INVALID_ID', $record[$prefix . 'IBS_CUSCUN']);
            } else {
                /*
                 * GEN_ERR_APC_EXP_INVALID_ID2
                 * It's necessary to update ID with hyphens in order to effectively split C�dula/RUC parts for APC Export
                 * Es necesario ponerle guiones a la identificaci�n de tal forma de poder separar las partes de la C�dula/RUC para la Exportaci�n a la APC
                 */
                $s_msg = dict('GEN_ERR_APC_EXP_INVALID_ID2');
            }
            addMessage($s_msg);
        } else {
            $apc_id = get_apc_identification($record, $prefix, $apc_id);
            if (EBSK_IBS_ENABLED === '1') {
                /*
                 * GEN_ERR_APC_EXP_UPDTD_ID
                 * ID updated for APC Export (CUSCUN '^1', new APC ID '^2')
                 * La identificaci�n ha sido actualizada para la Exportaci�n a la APC. (CUSCUN '^1', nueva identificaci�n para APC '^2')
                 */
                $s_msg = dict('GEN_ERR_APC_EXP_UPDTD_ID', $record[$prefix . 'IBS_CUSCUN'], str_replace(' ', 'b', $apc_id));
            } else {
                /*
                 * GEN_ERR_APC_EXP_UPDTD_ID2
                 * ID updated for APC Export (new APC ID '^2')
                 * La identificaci�n ha sido actualizada para la Exportaci�n a la APC (nueva identificaci�n APC '^2')
                 */
                $s_msg = dict('GEN_ERR_APC_EXP_UPDTD_ID2', '', str_replace(' ', 'b', $apc_id));
            }
            addMessage($s_msg);
        }
        $record[$prefix . $fieldname] = $apc_id;
        return $record;
    }

    function get_apc_identification($record, $prefix, $apc_id) {
        $ar_apc_id = explode('-', $apc_id);
        // convert to APC format
        switch ($record[$prefix . 'LEGAL_TYPE']) {
            // Persons
            case 'I':
                /*
                 * PERSONA NATURAL
                 *
                 * Provincia: 2 posiciones
                 * Inicial: 2 posiciones
                 * Tomo: 5 posiciones
                 * Asiento: 6 posiciones
                 * Libres: 6 posiciones
                 *
                 * Cuando es persona natural se justifica cada parte que forma la identificaci�n hacia la derecha. La excepci�n aplica a las identificaciones con letras, estas se justifican a la izquierda.
                 * La identificaci�n no debe contener guiones.
                 * La b son espacios en blanco.
                 */
                switch ($record[$prefix . 'ID_TYPE']) {
                    /*
                     * Panamian Citizen (Cedula Paname�a)
                     *
                     * 8-550-780 debe aparecer: b8bbbb550bbb780
                     * 8PI-485-87 debe aparecer: b8PIbb485bbbb87
                     * 9AV-18-2148 debe aparecer: b9AVbbb18bb2148
                     */
                    case 'CE01':
                    /*
                     * Foreigner Citizen (Cedula Extranjero)
                     *
                     * E-8-4512   de aparecer: bbEbbbbb8bb4512
                     * N-8-4512   de aparecer: bbNbbbbb8bb4512
                     * PE-87-480  debe aparecer: bbPEbbb87bbb480
                     */
                    case 'CE04':
                        $apc_id = str_pad(ltrim($ar_apc_id[CLX_NUM_ZERO], '0'), CLX_NUM_TWO, ' ', STR_PAD_LEFT) . str_pad($ar_apc_id[CLX_NUM_ONE], CLX_NUM_TWO, ' ', STR_PAD_RIGHT) . str_pad(ltrim($ar_apc_id[CLX_NUM_TWO], '0'), CLX_NUM_FIVE, ' ', STR_PAD_LEFT) . str_pad(ltrim($ar_apc_id[CLX_NUM_THREE], '0'), CLX_NUM_SIX, ' ', STR_PAD_LEFT);
                        break;
                    /*
                     * Foreigner Passport (Pasaporte)
                     * Pasaporte = 21 posiciones
                     * AD1456233 debe aparecer: bbbbbbbbbbbbAD1456233
                     * 012344321 debe aparecer:  bbbbbbbbbbbbb12344321
                     */
                    case 'PA02':
                        $apc_id = $apc_id = str_replace('-', '', $apc_id);
                        str_pad(ltrim($apc_id, '0'), CLX_NUM_21, ' ', STR_PAD_LEFT);
                        break;
                    default:
                        break;
                }
                break;
            // Corporations
            case 'C':
            case 'O':
                switch ($record[$prefix . 'ID_TYPE']) {
                    /*
                     * R.U.C.
                     *
                     * Rollo/Tomo: 7 posiciones
                     * Folio/Imagen: 7 posiciones
                     * Asiento/Ficha: 7 posiciones
                     *
                     * Cuando es persona Jur�dica (RUC) se justifica cada parte que forma el ruc hacia la izquierda.
                     * La identificaci�n no debe contener guiones.
                     * No se debe reportar el Digito Verificador (DV).
                     * La b son espacios en blanco.
                     * Ejemplos:
                     * 	1802-23-15987 de aparecer: 1802bbb23bbbbb15987bb
                     * 	8-550-780 debe aparecer:      8bbbbbb550bbbb780bbbb
                     * 	8NT-50-78 dene aparecer:     8NTbbbb50bbbbb78bbbbb
                     */
                    case 'RU07':
                        if (isset($ar_apc_id[CLX_NUM_THREE])) {
                            $apc_id = str_pad(ltrim($ar_apc_id[CLX_NUM_ZERO] . $ar_apc_id[CLX_NUM_ONE], '0'), CLX_NUM_7, ' ', STR_PAD_RIGHT) . str_pad(ltrim($ar_apc_id[CLX_NUM_TWO], '0'), CLX_NUM_7, ' ', STR_PAD_RIGHT) . str_pad(ltrim($ar_apc_id[CLX_NUM_THREE], '0'), CLX_NUM_7, ' ', STR_PAD_RIGHT);
                        } else {
                            $apc_id = str_pad(ltrim($ar_apc_id[CLX_NUM_ZERO], '0'), CLX_NUM_7, ' ', STR_PAD_RIGHT) . str_pad(ltrim($ar_apc_id[CLX_NUM_ONE], '0'), CLX_NUM_7, ' ', STR_PAD_RIGHT) . str_pad(ltrim($ar_apc_id[CLX_NUM_TWO], '0'), CLX_NUM_7, ' ', STR_PAD_RIGHT);
                        }
                        break;
                    default:
                        break;
                }
                break;
            default:
                break;
        }
        return $apc_id;
    }

    function acco_update_all_full_name() {
        $acconame = tableName('ACCO');
        $sql = 'SELECT * FROM ' . $acconame;
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($record = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))) {
            if (is_null($record['FULLNAME']) || trim($record['FULLNAME']) === '') {
                $record['FULLNAME'] = acco_full_name($record);
                ClxCommon::$db->updateRecord($acconame, array('FULLNAME' => $record['FULLNAME']), 'UPPER(IDCODE)=' . singleQuote(uppercase($record['IDCODE'])));
            }
        }
		ClxCommon::$db->freeResult($rs);
    }

    /*
     * Devuelve array indicando si existe mas de un registro de ACCO con el mismo IBS_CUSCUN
     *
     */
    function acco_get_repeated_cuscun($ibs_cuscun) {
        $acconame = tableName('ACCO');
        $err_msg = '';
        $record = ClxCommon::$db->getOneRecord('SELECT GROUP_CONCAT(IDCODE SEPARATOR ', ') AS IDCODES, COUNT(IBS_CUSCUN) CONTADOR FROM ' . $acconame . ' WHERE IBS_CUSCUN = ' . singleQuote($ibs_cuscun) . ' GROUP BY IBS_CUSCUN');
        if ($record['CONTADOR'] > CLX_NUM_ONE) {
            /*
             * GEN_ERR_CUSCUN_REPEATED_01
             * IBS Client Code (CUSCUN '^1') is repeated in ^2 Clientix accounts (Codes: ^3).
             * El codigo de cliente de IBS (CUSCUN '^1') esta repetido en ^2 cuentas de Clientix (Codigos: ^3).
             */
            $err_msg = dict('GEN_ERR_CUSCUN_REPEATED_01', $ibs_cuscun, $record['CONTADOR'], $record['IDCODES']);
        }
        $response = array('error' => ($err_msg !== ''),
            'errmsg' => $err_msg
        );
        return $response;
    }

    /*
     * Acomoda todos los IDENTIFICATION_APC con el formato solicitado por la
     * APC (Asociacionn Panamea de Credito) respecto al formato de las identificaciones.
     * En caso de errores, reporta en el Log de Excepciones del cronograma en ejecuci�n
     */
    function acco_update_all_apc_identification($parameters = array()) {
        $contenidoHTML = '';
        $acconame = tableName('ACCO');
        $prefix = '';
        $debug = false;
        $fieldname = 'IDENTIFICATION_APC';
        if (isset($parameters['SCHEDULECODE'])) {
            $PRPR = &getTool('PRPR');
        }
        $fix_by_interface = CLX_INIT_ZERO;
        if (isset($parameters['BK_INTRFSE_MODE'])) {
            if ($parameters['BK_INTRFSE_MODE'] === '1') {
                if (EBSK_IBS_ENABLED === '1') {
                    $fix_by_interface = CLX_NUM_ONE;
                    $o_ibs_acco_socket_import = new ibs_crm_account_socket_import();
                    $o_ibs_acco_socket_import->searchClientOnIbsByCuscum_force_ibs_search = true;
                }
            }
        }
        $sql = 'SELECT * FROM ' . $acconame;
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($record = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))) {
            $apc_id = $record['IDENTIFICATION'];
            $err_msg = '';
            if (strpos($apc_id, '-') === false && $fix_by_interface == CLX_NUM_ONE && $record['IBS_CUSCUN'] !== '') {
                // if no dashes, IDENTIFICATION must be updated from IBS
                // unless cuscun is set in more than one record
                $ar_apc_id = acco_get_repeated_cuscun($record['IBS_CUSCUN']);
                if ($ar_apc_id['error'] === true) {
                    $err_msg = $ar_apc_id['errormsg'];
                } else {
                    $a_response = $o_ibs_acco_socket_import->searchClientOnIbsByCuscum($record['IBS_CUSCUN'], $debug);
                    if ($a_response['error'] == false) {
                        // OK, client was created from IBS
                        $ar_apc_id = ClxCommon::$db->getOneRecord(
                                'SELECT IDENTIFICATION ' . ' FROM ' . $acconame . ' WHERE IDCODE = ' . singleQuote($a_response['clx_idcode']));
                        $apc_id = $ar_apc_id['IDENTIFICATION'];
                    } else {
                        // There was an error
                        $err_msg = $a_response['errormsg'];
                    }
                }
            }
            if (strpos($apc_id, '-') === false && $err_msg === '') {
                /*
                 * GEN_ERR_APC_EXP_INVALID_ID_01
                 * Identification '^1' doesn't have dashes '-'.
                 * La Identificacion '^1' no tiene guiones '-'.
                 */
                $err_msg = dict('GEN_ERR_APC_EXP_INVALID_ID_01', $record['IDENTIFICATION']);
                if ($record['IBS_CUSCUN'] !== '') {
                    /*
                     * GEN_ERR_APC_EXP_INVALID_ID
                     * It's necessary to update ID from IBS for account (CUSCUN '^1'). Please go to 'IBS Accounts > IBS Client Search' option.
                     * Es necesario actualizar la identificaci�n desde IBS a la cuenta (CUSCUN '^1'). Favor usar la opci�n 'IBS Cuentas > Busqueda de cliente IBS'.
                     */
                    $err_msg .= ' ' . dict('GEN_ERR_APC_EXP_INVALID_ID', $record['IBS_CUSCUN']);
                } else {
                    /*
                     * GEN_ERR_APC_EXP_INVALID_ID_02
                     * It's necessary to update it for Account '^1'.
                     * Es necesario actualizarla para la cuenta '^1'.
                     */
                    $err_msg .= ' ' . dict('GEN_ERR_APC_EXP_INVALID_ID_02', $record['IDCODE']);
                }
            } else {
                $apc_id = get_apc_identification($record, $prefix, $apc_id);
                ClxCommon::$db->updateRecord($acconame, array($fieldname => $apc_id), 'UPPER(IDCODE)=' . singleQuote(uppercase($record['IDCODE'])));
                /*
                 * GEN_ERR_APC_EXP_UPDTD_ID
                 * ID updated for APC Export (CUSCUN '^1', new APC ID '^2')
                 * La identificaci�n ha sido actualizada para la Exportaci�n a la APC. (CUSCUN '^1', nueva identificaci�pn para APC '^2')
                 */
            }
            if ($err_msg !== '') {
                if (isset($parameters['SCHEDULECODE'])) {
                    $PRPR->report_exception($parameters['SCHEDULECODE'], $parameters['START_TIME'], $parameters['RUNID'], $err_msg, '', 'ERRO');
                } else {
                    $contenidoHTML.= '<br>' . $err_msg;
                }
            }
        }
		ClxCommon::$db->freeResult($rs);
        echo $contenidoHTML;
    }

    function acco_name_fix_null($str) {
        $str = trim($str);
        if (is_null($str) || $str === 'null' || $str === 'null') {
            $str = '';
        }
        return $str;
    }

    function acco_full_name($record, $prefix = '') {
        $s_long_name = '';
        if ($record[$prefix . 'ISINDIVIDUAL'] == '1') {
            $first_name = acco_name_fix_null($record[$prefix . 'FIRSTNAME']);
            if (array_key_exists($prefix . 'SECOND_NAME', $record)) {
                $second_name = acco_name_fix_null($record[$prefix . 'SECOND_NAME']);
            } else {
                $second_name = '';
            }
            $lastname = acco_name_fix_null($record[$prefix . 'LASTNAME']);
            if (isset($record[$prefix . 'SECOND_LASTNAME'])) {
                $second_lastname = acco_name_fix_null($record[$prefix . 'SECOND_LASTNAME']);
            } else {
                $second_lastname = '';
            }
            $s_long_name = trim(trim($first_name . ' ' . $second_name) . ' ' . trim($lastname . ' ' . $second_lastname));
        } else {
            if (array_key_exists($prefix . 'LEGAL_NAME', $record) && trim($record[$prefix . 'LEGAL_NAME']) !== '') {
                $s_long_name = $record[$prefix . 'LEGAL_NAME'];
            }
        }
        /*
        // Caso 1003768 - GB-Ajustes Revision Auditoria (FULLNAME) | Deja en blanco en vez de poner el Token '((** ERROR: NO NAME **))'
        if ($s_long_name === '') {
            $s_long_name = '((** ERROR: NO NAME **))';
        }
        */
        if (ClxCommon::$cached['acco_utilities_debug'] === true) {
            echoLog('s_long_name = ' . $s_long_name . '<br><br>');
        }
        return $s_long_name;
    }

    function set_isindividual_record(&$record) {
		if (!isset($record['LEGAL_TYPE']))
			$record['LEGAL_TYPE']=1;
        $record['ISINDIVIDUAL'] = set_isindividual($record['LEGAL_TYPE']);
    }

    function set_isindividual($s_legal_type) {
        $s_response = ($s_legal_type === 'I' || $s_legal_type === 'V' || $s_legal_type === 'E' ) ? CLX_NUM_ONE : CLX_NUM_ZERO;
        return $s_response;
    }

    /**
     * This code generates an entry in the account tree for each account created
     * @param $record
     */
    function generateAccotreeEntry(&$record) {
        $ParameterTreeName = companyParameter('ACTE_DEF_NAME');
        $ParameterTreeValue = companyParameter('ACTE_DEF_VALUE');
        if (!empty($ParameterTreeName)) {
            $treecont_id = $ParameterTreeValue . '.' . $record['IDCODE'];
            $treecont_name = $record['IDNAME'];
            $treecont_rec = ClxCommon::$db->getRecord('CLX_AC_TREE_CONTENTS', 'IDCODE=' . singleQuote($treecont_id));
            if (empty($treecont_rec['IDCODE'])) {
                $rec = array();
                $rec['IDCODE'] = $treecont_id;
                $rec['IDNAME'] = $treecont_name;
                $rec['TREECODE'] = $ParameterTreeName;
                $rec['LEVELS'] = CLX_NUM_TWO;
                $rec['PARENT'] = $ParameterTreeValue;
                ClxCommon::$db->createRecord('CLX_AC_TREE_CONTENTS', $rec, false);
                ClxCommon::$db->updateRecord('CRM_ACCOUNTS', array('ACCDEP' => $treecont_id), 'UPPER(IDCODE)=' . singleQuote(uppercase($record['IDCODE'])));
            }
        }
    }

    /**
     * Verify Account in Black List and set Black List Flag in case of fund
     * @param unknown_type $accountcode
     */
    function accoCheckBlakList($accountcode) {
        $blakname = tableName('BLAK');
        $acconame = tableName('ACCO');
        if ($blakname === '') {
            return;
        }
        $sql = 'SELECT IDNAME, IDENTIFICATION, ISINDIVIDUAL, FIRSTNAME, LASTNAME, BIRTH_COUNTRY, CITIZENSHIP, INCORPORATION_COUNTRY, LEGAL_NAME FROM ' . $acconame . ' WHERE IDCODE = ' . singleQuote($accountcode) . ' AND BLACKLIST = 0';
        $accorec = ClxCommon::$db->getOneRecord($sql);
        if (empty($accorec)) {
            return;
        }
        if ($accorec['ISINDIVIDUAL'] == CLX_NUM_ONE) {
            $accorec['COUNTRY'] = $accorec['CITIZENSHIP'];
        } else {
            $accorec['COUNTRY'] = $accorec['INCORPORATION_COUNTRY'];
        }
        $accorec['FIRSTNAME'] = ClxCommon::$db->addslashes($accorec['FIRSTNAME']);
        $accorec['LASTNAME'] = ClxCommon::$db->addslashes($accorec['LASTNAME']);
        $accorec['LEGAL_NAME'] = ClxCommon::$db->addslashes($accorec['LEGAL_NAME']);
        $sql = 'SELECT COUNT(BLAK.ID) QTY FROM ' . $blakname . ' BLAK WHERE ((1=' . $accorec['ISINDIVIDUAL'] . ' AND BLAK.NAME LIKE ' . singleQuote('%' . $accorec['FIRSTNAME'] . '%') . ' AND BLAK.NAME LIKE ' . singleQuote('%' . $accorec['LASTNAME'] . '%') . ') OR (0=' . $accorec['ISINDIVIDUAL'] . ' AND BLAK.NAME LIKE ' . singleQuote('%' . $accorec['LEGAL_NAME'] . '%') . ') OR (BLAK.COUNTRY = ' . singleQuote($accorec['COUNTRY']) . ' AND BLAK.OTHER_TITLE LIKE ' . singleQuote('%' . $accorec['IDENTIFICATION'] . '%') . '))';
        $qty = ClxCommon::$db->getOne($sql);
        if ($qty > CLX_NUM_ZERO) {
            $sql = 'UPDATE ' . $acconame . ' SET BLACKLIST = 1 WHERE IDCODE = ' . singleQuote($accountcode);
            ClxCommon::$db->executeQuery($sql);
        }
    }

    /**
     * Create CLX Client from IBS Client
     * @param Integer $ibs_cuscun
     */
    function searchClientOnIbsByCuscum($ibs_cuscun, $debug = false) {
        $a = new ibs_crm_account_socket_import();
        $a_response = $a->searchClientOnIbsByCuscum($ibs_cuscun, $debug);
        unset($a);
        return $a_response;
    }

    /**
     * To bew called from a Formula in FILO masive import process to verify the need of client creation from IBS
     * @param Integer $ibs_cuscun
     */
    function cuscun_registry_for_dbimport($ibs_cuscun, $clx_idcode, $import_code, $line_counter, $debug = false, $ibs_cuscun_key = 'IBS_CUSCUN', $clx_idcode_key = 'DEBTOR_CODE') {
        $clx_idcode = trim($clx_idcode);
        if ($clx_idcode !== '') {
            // Nothing to do if clientix CRM account code is not specified
            if (!empty($debug)) {
                echoLog('Codigo CLX fue especificado<br>');
            }
            return $clx_idcode;
        }
        define('INVALID_CLX_IDCODE_TOKEN', '**INVALID**');
        $err_record = array('ERRORMSG' => '',
            'IMPORTCODE' => $import_code,
            'LINENUM' => $line_counter,
            'fieldname' => $clx_idcode_key,
            'ERRORNUM' => '0'
        );
        if (EBSK_IBS_ENABLED === '0') {
            // IBS Interfaces are disabled and clientix CRM account code is not specified
            if (!empty($debug)) {
                echoLog('IBS desactivado<br>');
            }
            if ($clx_idcode === '') {
                /*
                 * GEN_ERR_FILO_IMPPRT_NO_CLNT
                 * Column(s) value(s) missing (^1). At least one must specified
                 * La(s) columna(s) no fue(ron) especificada(s) (^1). Al menos una debe estar presente
                 */
                $err_record['ERRORMSG'] = dict('GEN_ERR_FILO_IMPPRT_NO_CLNT', $clx_idcode_key);
                if (!empty($debug))
                    echoLog('No se especifico codigo CLX<br>');
            }
        } else {
            // IBS Interfaces are enabled and clientix CRM account code is not specified
            if (!empty($debug))
                echoLog('IBS activado<br>');
            $ibs_cuscun = trim($ibs_cuscun);
            if ($ibs_cuscun === '') {
                /*
                 * GEN_ERR_FILO_IMPPRT_NO_CLNT
                 * Column(s) value(s) missing (^1). At least one must specified
                 * La(s) columna(s) no fue(ron) especificada(s) (^1). Al menos una debe estar presente
                 */
                $err_record['ERRORMSG'] = dict('GEN_ERR_FILO_IMPPRT_NO_CLNT', $ibs_cuscun_key . ', ' . $clx_idcode_key);
                if (!empty($debug)) {
                    echoLog('No se especifico CUSCUN<br>');
                }
            } else {
                if (!empty($debug)) {
                    echoLog('Va a llamar a searchClientOnIbsByCuscum<br>');
                }
                $a_response = searchClientOnIbsByCuscum($ibs_cuscun, $debug);
                if (!empty($debug)) {
                    echoLog('llamo al programa searchClientOnIbsByCuscum<br>');
                }
                if ($a_response['error'] == false) {
                    // OK, client was created from IBS
                    if (!empty($debug)) {
                        echoLog('TODO OK<br>');
                    }
                    $clx_idcode = $a_response['clx_idcode'];
                } else {
                    // There was an error
                    $err_record['ERRORMSG'] = $a_response['errormsg'];
                    $err_record['fieldname'] = $ibs_cuscun_key;
                }
            }
        }
        if ($err_record['ERRORMSG'] !== '') {
            // Error reporting... 1) screen, 2) log and put something wrong on return value to include error on import process general error reporting
            $clx_idcode = INVALID_CLX_IDCODE_TOKEN; // To take error in account in current process general error reporting
            /*
             * GEN_LBL_LINE_NUM
             * Line Number
             * N�mero de Linea
             */
            if (!empty($debug))
                echoLog('ERROR:  ' . $err_record['ERRORMSG'] . (' - ' . dict('GEN_LBL_LINE_NUM') . ': ' . $line_counter) . '<br>');
            // Insert error in import process event log
            $err_record['ERRORMSG'] = addslashes($err_record['ERRORMSG']);
            ClxCommon::$db->createRecord('CLX_DB_IMPORT_ERRORS', $err_record, false);
        }
        return $clx_idcode;
    }

    function user_is_in_acctree($username = '', $acctreecode = 'ACCO') {
        $ACTU = &getTool('ACTU');
        $ACTE = &getTool('ACTE');
        if ($username === '') {
            $username = $_SESSION['user_record']['username'];
        }
        $sql = 'SELECT COUNT(*) FROM ' . $ACTU->tablename . ' ACTU, ' . $ACTE->tablename . ' ACTE WHERE ACTU.TREECODE = ACTE.TREECODE AND ACTU.TREENODE = ACTE.IDCODE AND ACTU.TREECODE = ' . singleQuote($acctreecode) . '  AND ACTU.STATUS = 1 AND ACTU.DEFAULT_ENTRY = 1 AND UPPER(ACTU.USERNAME) = ' . singleQuote(uppercase($username));
        $qty = ClxCommon::$db->getOne($sql);
        return $qty > CLX_NUM_ZERO;
    }
    
    /**
     * Execute product interface. See process IBS_CLI_IMP | Caso 1002664
     */
    function clx0080_mass_read_interfase($parameters) {
	$connectors = explode(',',$parameters['CONNECTORCODE']);
	$EBSK = getTool("EBSK");
	$EBSK->debug = (isset($parameters['FLG_DEBUG']) && trim($parameters['FLG_DEBUG'])==='1')?true:false;
	$EBSK->rename_file = (isset($parameters['RENAME_FILE']) && trim($parameters['RENAME_FILE'])==='1')?true:false;
	$flg_production = (isset($parameters['FLG_PRODUCTION']) && trim($parameters['FLG_PRODUCTION'])==='1')?true:false;
	if($flg_production) {
            $EBSK->record_commit_counter = 10;
        }
	$EBSK->verbouse = (!isset($parameters['FLG_VERBOSE']) || (isset($parameters['FLG_VERBOSE']) && trim($parameters['FLG_VERBOSE']) != '0')); // "0" = No Verbose / [Any other value] = Report statistics
	$EBSK->create_log = (!isset($parameters['LOG_METHOD']) || (isset($parameters['LOG_METHOD']) && trim($parameters['LOG_METHOD']) != '0')); // "0" = No log / Any other value = Create a .log file
	$EBSK->use_record_delimiter_reading_fixlen_files = (!isset($parameters['FLG_REC_DELIM']) || (isset($parameters['FLG_REC_DELIM']) && trim($parameters['FLG_REC_DELIM']) != '0')); // "0" = FALSE / Any other value = TRUE
	$EBSK->invalid_field_values_report = (!isset($parameters['INV_FLD_VAL_RPT']) || (isset($parameters['INV_FLD_VAL_RPT']) && trim($parameters['INV_FLD_VAL_RPT']) != '0')); // "0" = FALSE / Any other value = TRUE
	foreach($connectors as $val) {
            $EBSK->readMultiMessageFile($val, $flg_production);
	}
    }
    
    //CASO 1004412 BNP - CAMPO NOMBRE DEL CLIENTE
    //Función para actualizar Nombre del Cliente  y Numero Externo (IBS CUSCUN) en la tabla de Casos (SRRQ)
    function update_srrqClientName(&$record) {

        //Verificar que existe la tabla SRRQ en el sistema ;
        $srrqName = tableName('SRRQ');
        $countSRRQ = ClxCommon::$db->tableExists($srrqName);

        $rec ['ACCOUNTCODE'] = $record['IDCODE'];

        $acco_individual = $record['ISINDIVIDUAL'];
        $acco_lastname = singlequote(str_IReplace('NULL', '', $record['LASTNAME']));
        $acco_secondlastname = singlequote(str_IReplace('NULL', '', $record['SECOND_LASTNAME']));
        $acco_firstname = singlequote(str_IReplace('NULL', '', $record['FIRSTNAME']));
        $acco_secondname = singlequote(str_IReplace('NULL', '', $record['SECOND_NAME']));
        $acco_legalname = singlequote(str_IReplace('NULL', '', $record['LEGAL_NAME']));

        $acco_IBSCUSCUN = singlequote(str_IReplace('NULL', '', $record['IBS_CUSCUN']));

        if ($countSRRQ > 0) {

            $rec ['ACCOUNTCODE'] = $record ['IDCODE'];
            $sql = "UPDATE SERV_REQUESTS SRRQ 
					SET CLIENT_NAME= (SELECT  ACCO.LEGAL_NAME FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE=".singlequote($rec ['ACCOUNTCODE']).")

					,IBS_CUSCUN= $acco_IBSCUSCUN 

					WHERE SRRQ.ACCOUNTCODE =" . singlequote($rec ['ACCOUNTCODE']) ; 

            $results = ClxCommon::$db->executeQuery ( $sql );

        }

    }

    function update_legalName(&$record) {
        //		$recid_string = toString($acco_id);
        $rec ['IDCODE'] = $record ['IDCODE'];
        if ($record ['ISINDIVIDUAL'] == 1){
            $sql = "UPDATE CRM_ACCOUNTS
						SET LEGAL_NAME = LTRIM(IF(ISINDIVIDUAL='1', CONCAT(IF(FIRSTNAME <> '', CONCAT('', FIRSTNAME), ''),
									   IF(SECOND_NAME <> '', CONCAT(' ', SECOND_NAME), ''),
										IF(LASTNAME <> '', CONCAT(' ', LASTNAME), '' ),
										IF(MARRIED_LASTNAME <> '',  CONCAT(' DE ', MARRIED_LASTNAME), ''),
										IF(SECOND_LASTNAME <> '' AND  (MARRIED_LASTNAME  = '' OR MARRIED_LASTNAME IS NULL), CONCAT(' ',SECOND_LASTNAME), '')
										)
						,LEGAL_NAME))
				WHERE IDCODE=" . singlequote($rec ['IDCODE']);

            $results = ClxCommon::$db->executeQuery ( $sql );
        }
    }


}