<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: imrsnik $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-11-20 09:20:36 -0500 (Fri, 20 Nov 2015) $
 * @version        $Rev: 7525 $
 *
 * CHANGE LOG
 *  Included svn prop
 */

/**
 * Alert Utilities
 */
class alrt_alerts {

    function __construct() {
        $this->code = 'ALRT';
        $this->name = 'User Alerts';
        $this->system = 'Alert and Notices';
        $this->version = '0.1.0.0';
        //Tables
        multiTableName($this, array('ALRT', 'ALSC'));
    }

    /**
     * Broadcast to a list of users
     * Blank for all users
     */
    function broadcast($memo, $delivery_date = 'now', $groupcode = '', $username = '') {
        $delivery_date = xFormat::date($delivery_date, 'Y-m-d H:i:s');
        //alrm
        $rec = array('MEMO' => $memo,
		  'CREATEDBY' => $_SESSION['user_record']['username'],
		  'MODIFIEDBY' => $_SESSION['user_record']['username'],
		  'TOUSER' => $username,
		  'CDATE' => xFormat::getNow('Y-m-d H:i:s'),
		  'MDATE' => xFormat::getNow('Y-m-d H:i:s'));
        $rec['ALERT_CODE'] = ClxCommon::$db->createRecord($this->alrtname, $rec, false);
        if (!empty($username)) {
		  $screc = array('ALERT_CODE' => $rec['ALERT_CODE'],
			 'DELIVERY_DATE' => $delivery_date,
			 'RECIEVED_DATE' => '',
			 'STATUS' => 'A',
			 'TOUSER' => $username);
		  ClxCommon::$db->createRecord($this->alscname, $screc, false);
        }
        $crit = '';
        if (!empty($groupcode)) {
		  if (!empty($groupcode)) {
			 $crit .=' ACGM.GROUPCODE = ' . singleQuote($groupcode) . ' AND ';
		  }
		  if (!empty($username)) {
			 $crit .=' UPPER(ACGM.USERNAME) = ' . singleQuote(uppercase($username)) . ' AND ';
		  }
		  $sql = 'INSERT INTO ' . $this->alscname . '(ALERT_CODE, DELIVERY_DATE, STATUS, TOUSER) SELECT ' . singleQuote($rec['ALERT_CODE']) . '  ALERT_CODE, ' . singleQuote($delivery_date) . '  DELIVERY_DATE, ' . singleQuote('A') . ' STATUS, ACGM.USERNAME USERNAME FROM CLX_AC_USERS ACUS, CLX_AC_GROUP_MEMBERS ACGM WHERE ACUS.USERNAME = ACGM.USERNAME AND NOT EXISTS(SELECT X.ID FROM ' . $this->alscname . ' X WHERE X.ALERT_CODE = ' . singleQuote($rec['ALERT_CODE']) . ' AND X.TOUSER = ACGM.USERNAME) AND ' . $crit . ' ACUS.STATUS = 1';
		  ClxCommon::$db->executeQueryVoid($sql);
        }
    }

    function alert_search($username, $date = 'now') {
        $return = array();
        $date = xFormat::date($date, 'Y-m-d H:i:s');
        $rs = ClxCommon::$db->executeQuery('SELECT ALSC.DELIVERY_DATE,  ALRT.MEMO,  ALRT.ID ID FROM ' . $this->alrtname . ' ALRT, ' . $this->alscname . ' ALSC ' . ' WHERE ALRT.ID = ALSC.ALERT_CODE AND ALSC.STATUS = ' . singleQuote('A') . ' AND ALSC.TOUSER = ' . singleQuote(uppercase($username)) . ' AND ALSC.DELIVERY_DATE <=' . singleQuote($date) . ' AND (ALSC.RECIEVED_DATE IS NULL OR RECIEVED_DATE=' . singleQuote('0000-00-00 00:00:00') . ')');
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $return[] = $r;
        }
        ClxCommon::$db->freeResult($rs);
        return $return;
    }

function user_exists() {
        return !empty($_SESSION['user_record']['username']);
    }

    function alert_count() {
        if (ClxCommon::$db->tableExists($this->alrtname)) {
		  $qty = ClxCommon::$db->getOne('SELECT count(ALRT.ID) count FROM ' . $this->alrtname . ' ALRT,' . $this->alscname . ' ALSC  WHERE ALRT.ID = ALSC.ALERT_CODE AND ALSC.STATUS = ' . singleQuote('A') . ' AND ALSC.TOUSER = ' . singleQuote($_SESSION['user_record']['username']) . ' AND ALSC.DELIVERY_DATE <=' . singleQuote(xFormat::getNow('Y-m-d H:i:s')) . ' AND (ALSC.RECIEVED_DATE IS NULL OR RECIEVED_DATE=' . singleQuote('0000-00-00 00:00:00') . ')');
        } else {
		  $qty = CLX_INIT_ZERO;
        }
        return $qty;
    }

    function alert_display() {

    }

    function ajax() {

    }

    /**
     * Initialize Eschedule Message
     */
    function initSchedule(&$record) {
        if (!empty($record['TOUSER']) && !empty($record['DELIVERY_DATE'])) {
		  $alert_code = ClxCommon::$db->getField($this->alrtname, 'max(ID)', 'CREATEDBY=' . singleQuote($record['CREATEDBY']));
		  $screc = array('ALERT_CODE' => $alert_code,
			 'DELIVERY_DATE' => $record['DELIVERY_DATE'],
			 'RECIEVED_DATE' => '',
			 'STATUS' => 'A',
			 'TOUSER' => $record['TOUSER']);
		  ClxCommon::$db->createRecord($this->alscname, $screc, false);
        }
    }

}
