<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: imrsnik $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-11-20 09:20:36 -0500 (Fri, 20 Nov 2015) $
 * @version        $Rev: 7525 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
/**
 * E-Mail Utilities
 * Set of function to operate the e-mail applications on Clientix
 * @package CODE_BASE_email
 * @copyright	Alenet, Inc.
 * @version		1.0.0
 * @since
 * @author		Alenet, Inc <support@alenet.com>
 */

/**
 * Initialize Mail Form Record. Sets email_Account, Username, Amount other
 */
function initMail(&$record) {
    $record['MAIL_EMAIL_ACCOUNT'] = $_SESSION['user_record']['username'];
    $record['MAIL_EMAIL_ACCOUNT_PRIM'] = $_SESSION['user_record']['username'];
    $record['MAIL_EMAIL_ACCOUNT_SECD'] = $_SESSION['user_record']['firstname'] . ' ' . $_SESSION['user_record']['lastname'];
    $record['MAIL_IS_SIGNATURE'] = CLX_NUM_ONE;
    $record['MAIL_EMAIL_CONTENTS'] = stripslashes($record['EMAIL_CONTENTS']);
    return $record;
}

/**
 * Prepares MAIL Form record to be saved into database
 */
function saveMail($record) {
    $record['EMAIL_CONTENTS'] = addslashes(str_replace(CLX_CHAR_NL, '<br>', $record['EMAIL_CONTENTS']));
    return $record;
}

/**
 * Creates a new email for Reply, Replyall and Forward and store it into mail draft table
 */
function mailAction($idlist, $action) {//Replay && Forward
    $mailrec = ClxCommon::$db->getRecord('BASE_EMAIL', 'ID=' . $idlist[CLX_NUM_ZERO]);
    //Cleaning From
    $from = trim($mailrec['FROM_EMAIL']);
    if (($pos = strpos($from, '<')) > CLX_NUM_ZERO) {
        $from = substr($from, $pos + CLX_NUM_ONE, strpos($from, '>', $pos) - $pos - CLX_NUM_ONE);
    }
    //Find to account
    $to = trim($mailrec['TO_EMAIL']);
    if (($pos = strpos($to, '<')) > CLX_NUM_ZERO) {
        $to = substr($to, $pos + CLX_NUM_ONE, strpos($to, '>', $pos) - $pos - CLX_NUM_ONE);
    }
    //Carbon copy
    $cc = trim($mailrec['CC_EMAIL']);
    //Reply to
    //Retrieve Account Id and Access tree for email
    $treerecs = ClxCommon::$db->executeQuery('SELECT ACTU.TREENODE FROM CLX_DB_FIELDS DBF, CLX_AC_TREE_USERS ACTU WHERE DBF.FIELDNAME = ' . singleQuote('EMAIL_TREE') . ' AND ACTU.USERNAME=' . singleQuote($_SESSION['user_record']['username']) . ' AND ACTU.TREECODE = DBF.FIELD_EXTRA1');
    $treerec = ClxCommon::$db->getNextRecord($treerecs);
	ClxCommon::$db->freeResult($treerecs);
    if (!empty($treerec['TREENODE'])) {
        $mailrec['EMAIL_TREE'] = $treerec['TREENODE'];
    } else {
        $mailrec['EMAIL_TREE'] = '';
    }
    //Find email Account code
    $accountmail = explode(',', str_replace(';', ',', $to));
    reset($accountmail);
    foreach ($accountmail as $key => $val) {
        $accountrec = array();
        $accountrec = ClxCommon::$db->getRecord('BASE_EMAIL_ACCOUNTS', 'OWNERCODE=' . singleQuote($_SESSION['user_record']['username']), 'EMAIL LIKE ' . singleQuote('%' . $val . '%'));
        if (!empty($accountrec))
		  break;
    }
    //Clear not req values and Set new record
    unset($mailrec['ID'], $mailrec['SEND_DATE'], $mailrec['EMAIL_STATUS'], $mailrec['SEND_DATE'], $mailrec['RECEIVED_DATE'], $mailrec['CC_EMAIL'], $mailrec['EMAIL_HEADERS'], $mailrec['REPLY_EMAIL']);
    //User General Information and Dates
    $mailrec['EMAIL_ACCOUNT'] = (isset($accountrec['ID'])) ? $accountrec['ID'] : '';
    $mailrec['OWNERCODE'] = $_SESSION['user_record']['username'];
    $mailrec['EMAIL_DIRECTION'] = 'DRFT';
    $mailrec['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
    $mailrec['MDATE'] = xFormat::getNow('Y-m-d H:i:s');
    $mailrec['EMAIL_PRIORITY'] = CLX_INIT_ZERO;
    $mailrec['IS_SIGNATURE'] = CLX_NUM_ONE;
    //Clean prev Content
    $content = trim($mailrec['EMAIL_CONTENTS']);
    switch ($action) {
        case 'FORWARD':
		  $mailrec['SUBJECT'] = '[Fwd: ' . $mailrec['SUBJECT'] . ']';
		  $mailrec['FROM_EMAIL'] = '';
		  $mailrec['TO_EMAIL'] = '';
		  $mailrec['EMAIL_CONTENTS'] = $content;
		  $mailid = ClxCommon::$db->createRecord('BASE_EMAIL', $mailrec, false);
		  //Adding Attachments
		  $files = ClxCommon::$db->getRecords('BASE_EMAIL_ATTACHMENTS', 'MAILID=' . $idlist[CLX_NUM_ZERO]);
		  while ($file = ClxCommon::$db->getNextRecord($files)) {
			 unset($file['ID']);
			 $file['MAILID'] = $mailid;
			 ClxCommon::$db->createRecord('BASE_EMAIL_ATTACHMENTS', $file, false);
		  }
		  ClxCommon::$db->freeResult($files);
		  break;
        case 'REPLY':
		  $mailrec['SUBJECT'] = 'Re: ' . $mailrec['SUBJECT'];
		  $mailrec['FROM_EMAIL'] = '';
		  if (!empty($reply_email))
			 $mailrec['TO_EMAIL'] = $reply_email;
		  else
			 $mailrec['TO_EMAIL'] = $from;
		  $mailrec['EMAIL_CONTENTS'] = $from . ' wrote: ' . '<br>' . $content . CLX_CHAR_NL;
		  $mailid = ClxCommon::$db->createRecord('BASE_EMAIL', $mailrec, false);
		  break;
        case 'REPLYALL':
		  $mailrec['SUBJECT'] = 'Re: ' . $mailrec['SUBJECT'];
		  $mailrec['FROM_EMAIL'] = '';
		  $mailrec['TO_EMAIL'] = $from;
		  if (!empty($cc))
			 $mailrec['TO_EMAIL'] = $mailrec['TO_EMAIL'] . ', ' . $cc;
		  $mailrec['EMAIL_CONTENTS'] = $content;
		  $mailid = ClxCommon::$db->createRecord('BASE_EMAIL', $mailrec, false);
		  break;
        default:
		  return;
    }
}

/**
 * Set folder where mail will be displayed DRFT,IN,OUT.
 */
function setMailDirection($record, $direction) {
    $record['EMAIL_DIRECTION'] = $direction;
    $record['OWNERCODE'] = $_SESSION['user_record']['username'];
    return $record;
}

/**
 * Modify mail status to old when users displays de email on inbox.
 */
function loadMAILRecord(&$record) {
    if ($record['MAIL_EMAIL_STATUS'] === 'NEW') {
        $r = array();
        $r['EMAIL_STATUS'] = 'OLD';
        ClxCommon::$db->updateRecord('BASE_EMAIL', $r, 'ID=' . $record['MAIL_ID']);
    }
    $record['MAIL_EMAIL_CONTENTS'] = stripslashes($record['MAIL_EMAIL_CONTENTS']);
    return $record;
}

/**
 * Get Email Action
 */
function getMail() {
    $contents = '';
    $username = $_SESSION['user_record']['username'];
    $qty = ClxCommon::$db->oneExistsRecords('BASE_EMAIL_ACCOUNTS', 'UPPER(OWNERCODE)=' . singleQuote(uppercase($username)));
    if ($qty > CLX_NUM_ZERO) {
        $mail_accounts = ClxCommon::$db->getRecords('BASE_EMAIL_ACCOUNTS', 'UPPER(OWNERCODE)=' . singleQuote(uppercase($username)));
        while ($mail_account = ClxCommon::$db->getNextRecord($mail_accounts)) {
		  $contents .= getMailAccount($mail_account) . '<br>';
        }
		ClxCommon::$db->freeResult($mail_accounts);
    } else {
        $contents = note(dict('BASE_MAIL_NO_ACCOUNTS'));
    }
    return $contents;
}

/**
 * Get Mail from Email account on POP3 server
 */
function getMailAccount($mail_account) {
    ini_set('include_path', kPathToWebSite . kPathToPear);
    require_once'Net/POP3.php';
    require_once'Mail/mimeDecode.php';
    if (!class_exists('Net_POP3')) {
        return alert(dict('GEN_MSG_MAILDISABLED'));
        salir();
    }
    UserResponse::setIgnoreUserAbort(CLX_NUM_ONE);
    UserResponse::setRunTimeLimit(CLX_NUM_24 * CLX_NUM_60 * CLX_NUM_60);
    $decode_options = array();
    $decode_options['include_bodies'] = true;
    $decode_options['decode_bodies'] = true;
    $decode_options['decode_headers'] = true;
    $pop3 = new Net_POP3();
    $ok = $pop3->connect($mail_account['POP3_HOSTNAME'], CLX_NUM_110);
    if (empty($ok))
        return alert(dict('BASE_MAIL_ERROR_CANT_CONNECT', $mail_account['POP3_HOSTNAME']));
    $ok = $pop3->login($mail_account['POP3_USERNAME'], $mail_account['POP3_PASSWORD']);
    if (empty($ok))
        return alert(dict('BASE_MAIL_ERROR_CANT_LOGIN', $mail_account['IDNAME']));
    $qty = $pop3->numMsg();
    if (empty($qty))
        return alert(dict('BASE_MAIL_ERROR_CANT_GETQTY', $mail_account['IDNAME']));
    if ($qty > CLX_NUM_ZERO) {
        for ($i = $qty; $i >= CLX_NUM_ONE; $i--) {
		  $raw_msg = $pop3->getMsg($i);
		  $mime = new Mail_mimeDecode($raw_msg);
		  $msg = $mime->decode($decode_options);
		  $record = array();
		  $record['FROM_EMAIL'] = $msg->headers['from'];
		  $record['TO_EMAIL'] = $msg->headers[CLX_PROP_TO];
		  $record['CC_EMAIL'] = (isset($msg->headers['cc'])) ? $msg->headers['cc'] : '';
		  $record['REPLY_EMAIL'] = (isset($msg->headers['reply-to'])) ? $msg->headers['reply-to'] : '';
		  $record['SUBJECT'] = $msg->headers['subject'];
		  $record['MIME_TYPE_PRIMARY'] = $msg->ctype_primary;
		  $record['MIME_TYPE_SECONDARY'] = $msg->ctype_secondary;
		  if ($msg->ctype_primary === 'multipart') {
			 $record['MIME_ENCODING'] = $msg->headers['content-type'];
		  } else {
			 $record['MIME_ENCODING'] = $msg->headers['content-transfer-encoding'];
		  }
		  $record['SEND_DATE'] = xFormat::date($msg->headers['date'], 'Y-m-d H:i:s');
		  $record['RECEIVED_DATE'] = xFormat::getNow('Y-m-d H:i:s');
		  $record['EMAIL_STATUS'] = 'NEW';
		  //Setting Priority
		  if (!isset($msg->headers['x-priority']))
			 $record['EMAIL_PRIORITY'] = CLX_NUM_ZERO;
		  elseif (stristr($msg->headers['x-priority'], 'HIGH'))
			 $record['EMAIL_PRIORITY'] = CLX_NUM_ONE;
		  elseif (stristr($msg->headers['x-priority'], 'HIGHEST'))
			 $record['EMAIL_PRIORITY'] = CLX_NUM_TWO;
		  elseif (stristr($msg->headers['x-priority'], 'NORMAL'))
			 $record['EMAIL_PRIORITY'] = CLX_NUM_THREE;
		  elseif (stristr($msg->headers['x-priority'], 'LOW'))
			 $record['EMAIL_PRIORITY'] = CLX_NUM_FOUR;
		  elseif (stristr($msg->headers['x-priority'], 'LOWEST'))
			 $record['EMAIL_PRIORITY'] = CLX_NUM_FIVE;
		  $record['EMAIL_HEADERS'] = '';
		  $record['EMAIL_CONTENTS'] = '';
		  if (!empty($msg->body)) {
			 $record['EMAIL_CONTENTS'] = trim($msg->body);
		  }
		  $record['EMAIL_DIRECTION'] = 'IN';
		  $record['OWNERCODE'] = $_SESSION['user_record']['username'];
		  $record['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
		  $record['MDATE'] = xFormat::getNow('Y-m-d H:i:s');
		  foreach ($record as $key => $val) {
			 $record[$key] = addslashes($val);
		  }
		  $mailid = ClxCommon::$db->createRecord('BASE_EMAIL', $record, false);
		  if (isset($msg->parts)) {
			 ClxFreeReturn(saveMailAttachments($record, $mailid, $msg->parts));
		  }
		  if (isset($mail_account['POP3_DELETEMSG']) && $mail_account['POP3_DELETEMSG'] === true)
			 $pop3->deleteMsg($i);
        }
    }
    $pop3->disconnect();
    return note(dict('BASE_MAIL_NOTE_GET_MAIL', $qty, $mail_account['IDNAME']));
}

function niceHeaders($raw_headers) {
    $headers = '';
    foreach ($raw_headers as $key => $value) {
        $headers .= '<b>' . $key . '</b>: ' . $value . CLX_CHAR_NL;
    }
    return $headers;
}

/**
 * Save Email Attachements
 */
function saveMailAttachments($mailrec, $mailid, $parts) {
    $SDFL = &getTool('SDFL');
    if (!isset($hasContents))
        $hasContents = false;
    $record = array();
    foreach ($parts as $part) {
        if (isset($part->parts)) {
		  $mailrec = saveMailAttachments($mailrec, $mailid, $part->parts);
        } else {
		  if ($part->ctype_primary === 'text' && ($part->ctype_secondary === 'plain' || $part->ctype_secondary === 'html') && empty($hasContents)) {
			 $hasContents = true;
			 if (!empty($part->body)) {
		    $record = array();
		    $contents = $part->body;
		    $mailrec['EMAIL_CONTENTS'] .= $contents;
		    ClxCommon::$db->updateRecord('BASE_EMAIL', $mailrec, 'ID=' . $mailid);
		}    
		  }else {
			 $contents = (isset($part->body)) ? $part->body : '';
			 $name = $part->d_parameters['filename'];
			 if (! empty($name)) {
		    $type = $part->ctype_primary . '/' . $part->ctype_secondary;
		    $contents = (isset($part->body)) ? $part->body : '';
		    $saveindatabase = true;
		    $path = '';
		    $encoding = $part->headers['content-transfer-encoding'];
		    $fileid = $SDFL->saveFile($name, $type, $contents, $saveindatabase, $path, $encoding, '');
		    if (strstr($part->disposition, 'inline')) {
			$content_id = $part->headers['content-id'];
			$mailrec['EMAIL_CONTENTS'] = str_replace($content_id, 'window.php?to=SDFL&ac=SHOW_FILE&ff=' . $fileid, $mailrec['EMAIL_CONTENTS']);
			ClxCommon::$db->updateRecord('BASE_EMAIL', $mailrec, 'ID=' . $mailid);
		    }
		    $record = array();
		    $record['MAILID'] = $mailid;
		    $record['ANYFILE'] = $fileid;
		    ClxCommon::$db->createRecord('BASE_EMAIL_ATTACHMENTS', $record, false);
		}    
		  }
        }
    }
    return $mailrec;
}

// Table: MAAC (Mail Accounts)
function createpreMAACRecord(&$record) {
    $record['OWNERCODE'] = $_SESSION['user_record']['username'];
}

function sendMails($idlist) {
    ini_set('include_path', '.:/php/includes:' . kPathToWebSite . kPathToPear);
    require_once'Net/POP3.php';
    require_once'Mail/mimeDecode.php';
    if (!class_exists('Net_POP3')) {
        return alert(dict('GEN_MSG_MAILDISABLED'));
        salir();
    }
    foreach ($idlist as $id) {
        ClxFreeReturn(sendMail($id));
    }
}

function sendMail($mailid) {
    ini_set('include_path', '.:/php/includes:' . kPathToWebSite . kPathToPear);
    require_once'Mail.php';
    require_once'Mail/mime.php';
    if (!class_exists('Mail_mime')) {
        return alert(dict('GEN_MSG_MAILDISABLED'));
        salir();
    }
    $mailrec = ClxCommon::$db->getRecord('BASE_EMAIL', 'ID=' . $mailid);
    $accountrec = ClxCommon::$db->getRecord('BASE_EMAIL_ACCOUNTS', 'ID=' . $mailrec['EMAIL_ACCOUNT']);
    //signature
    if ($mailrec['IS_SIGNATURE'] == CLX_NUM_ONE) {
        $mailrec['EMAIL_CONTENTS'] .='<hr noshade size="1"><font face="arial" size=1><i>' . $accountrec['SIGNATURE'] . '</i></font>';
    }
    $mailrec['EMAIL_CONTENTS'] = stripslashes($mailrec['EMAIL_CONTENTS']);
    $mailrec['EMAIL_CONTENTS'] = str_replace(CLX_CHAR_NL . CLX_CHAR_NL, CLX_CHAR_NL, stripslashes($mailrec['EMAIL_CONTENTS']));
    $mailrec['EMAIL_CONTENTS'] = str_replace(CLX_CHAR_NL, '<br>', $mailrec['EMAIL_CONTENTS']);
    //Setting mail
    $text = stripslashes($mailrec['EMAIL_CONTENTS']);
    $html = '<html><body><p>' . stripslashes($mailrec['EMAIL_CONTENTS']) . '</p></body></html>';
    $crlf = CLX_CHAR_CR . CLX_CHAR_NL;
    $hdrs = array('From' => $accountrec['EMAIL'],
        'Subject' => $mailrec['SUBJECT'],
    );
    //setting cc and bcc
    if (!empty($mailrec['CC_EMAIL']))
        $hdrs['Cc'] = $mailrec['CC_EMAIL'];
    if (!empty($mailrec['BCC_EMAIL']))
        $hdrs['Bcc'] = $mailrec['BCC_EMAIL'];
    $mime = new Mail_mime($crlf);
    $mime->setTXTBody($text);
    $mime->setHTMLBody($html);
    $files = ClxCommon::$db->getRecords('BASE_EMAIL_ATTACHMENTS', 'MAILID=' . $mailid);
    while ($file = ClxCommon::$db->getNextRecord($files)) {
        $fileid = $file['ANYFILE'];
        $filerec = ClxCommon::$db->getRecord('CLX_SD_FILES', 'ID=' . singleQuote($fileid));
        if (strlen($filerec['FILENAME']) == CLX_NUM_ZERO) {
		  $filecontents = $filerec['CONTENTS'];
        } else {
		  $filecontents = file_get_contents(kPathToWebSite . $filerec['FILENAME']);
        }
        $mime->addAttachment($filecontents, $filerec['type'], $filerec['name'], false);
    }
    $body = $mime->get();
    $hdrs = $mime->headers($hdrs);
    $mail = & Mail::factory('mail');
    $mail->send($mailrec['TO_EMAIL'], $hdrs, $body);
    $r = array();
    $r['SEND_DATE'] = xFormat::getNow('Y-m-d H:i:s');
    $r['EMAIL_DIRECTION'] = 'OUT';
    $r['FROM_EMAIL'] = $accountrec['EMAIL'];
    ClxCommon::$db->updateRecord('BASE_EMAIL', $r, 'ID=' . $mailid);
}

function composeForm() {
    
}
