<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */

/**
 * Base Stock Utilities, get the stock 20 min delay
 * version: 1.0.0
 * author: Alenet, Inc.
 * date: 6/10/2005
 */
function BASE_stock($symbol) {
    if (strlen($symbol) == CLX_NUM_ZERO)
        return false;
    if (!class_exists('soapclient')) {
        require_once kPathToWebSite . 'classes/nusoap.php';
    }
    $result = (float) CLX_INIT_ZERO;
    // Array of parameters
    $service = 'http://services.xmethods.net/soap/urn:xmethods-delayed-quotes.wsdl';
    $parameters = array('symbol' => $symbol);
    if (file($service) !== false) {
        // Define new object and specify location of wsdl file.
        $soapclient = new soapclient($service, true);
        // call the method and get the result.
        $result = $soapclient->call('getQuote', $parameters);
    }
    return $result;
}

function BASE_get_quotes() {
    $tablename = tableName('STOC');
    $sql = 'SELECT IDCODE, MAX(EFFTDATE) EFFTDATE FROM ' . $tablename . ' GROUP BY IDCODE';
    $result = ClxCommon::$db->executeQuery($sql);
    $d = date('Y-m-d');
    while ($row = ClxCommon::$db->getNextRecord($result)) {
        if ($d <> $row['EFFTDATE']) {
		  $price = BASE_stock($row['IDCODE']);
		  $record = array();
		  $record['IDCODE'] = $row['IDCODE'];
		  $record['EFFTDATE'] = $d;
		  $record['PRICE'] = $price;
		  ClxCommon::$db->createRecord($tablename, $record, false);
        }
    }
	ClxCommon::$db->freeResult($result);
}
