
<?php

/**
 * Trust Constracts Interface
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
/*
  Record of changes 			Desarrollo inicial
 */
if (!class_exists('ibs'))
    includeCodeLib('EIBS');
/*
  General Parameters:
  Librer�as de C�digo:
  Motor de Proceso:
  Cronograma:
  Depende de:
  tools/eb_sockets.php
  data/code/EIBS_utilities.php
  data/code/PROC_class_aid.php
  data/code/EIBS_util_ibiq.php
 */
/*
 * ******************************************************************************************************************
 * e-IBS Trust Constracts Interface common properties and methods
 * *****************************************************************************************************************
 */

class ibs_fico_interface_commons extends ibs {
    /*
     * Constructor
     * @param text, array
     * @return void
     */

    function __construct($s_comp_code = null, $parameters = array()) {
        parent::ibs($this->s_comp_code, $parameters);
        if (!empty($this->debug)) {

        }
    }

// Method End
}

// Class End
/*
 * ******************************************************************************************************************
 * e-IBS Batch Trust Constracts Interface
 * *****************************************************************************************************************
 */
class ibs_fico__batch_interface_commons extends ibs_fico_interface_commons {
    /*
     * Constructor
     * @param text, array
     * @return void
     */

    function __construct($s_comp_code = null, $parameters = array()) {
        parent::ibs_fico_interface_commons($s_comp_code, $parameters);
        if (!empty($this->debug)) {

        }
    }

// Method End
    /**
     * Creates a FIDU Contract (FICO) into IBS
     * @param void
     * @return text
     */
    function createFiduContracts() {
        $contents = '';
        $idlist = getIdlist();
        //Retrive Account
        $sql = 'SELECT FICO.* FROM ' . $this->ficoname . ' FICO WHERE ID IN (' . singleQuote($implode(CLX_CHAR_SINGLE_QUOTE . ',' . CLX_CHAR_SINGLE_QUOTE, $idlist)) . ')';

        echoLog(debug_dump('createFiduContracts - idlist', $idlist));
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($ficorec = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $s_id_nombre = '(' . $ficorec['IDCODE'] . ') ' . $ficorec['IDNAME'] . ': ';
            if ($ficorec['IBS_CONCUN'] <> '') {
                /**
                 * GEN_ERR_IBSFICOEXISTS
                 * Contract Already exists on IBS
                 * El Contrato ya se encuentra registrado en IBS.
                 */
                $contents .= $s_id_nombre . dict('GEN_ERR_IBSFICOEXISTS');
                continue;
            }
            if ($this->validateFico($ficorec)) {

            } else {
                /**
                 * GEN_ERR_IBSMISSINGFICOINFO
                 * Error, Missing Contract Information
                 * Error, Falta informaci�n del contrato.
                 */
                $contents .= dict('GEN_ERR_IBSMISSINGFICOINFO');
            }
        }
		ClxCommon::$db->freeResult($rs);
        return $this->display($contents);
    }

// Method End
    /**
     * Validate Constract
     * Validate if contract is complete to be sent to ibs
     * @param array
     * @return boolean
     */
    function validateFico($clientrec) {
        return true;
    }

// Method End
    /**
     * Sends a validated Constract to IBS
     * @param array
     * @return text
     */
    function createFico($ficorec) {
        $ficorec['H01OPECODE'] = '0001'; //Create
        $ficorec['USERNAME'] = $this->username;
        $result = $this->send('CLX005001', $ficorec);
        return $this->print_error_out($result, $this->ar_last_sent_skt);
    }

// Method End
}

// Class End
class fipa_import {

    var $contents = '';
    var $o_proc_eng_params;
    var $s_log_filename;
    var $o_logfile_mngr;
    var $s_title;
    var $s_process_code = 'FIPA_IMPORT';
    var $s_logfile_folder = 'export/';
    var $s_import_folder = 'temp/';
    var $s_import_def_code = 'MIG_FIPA';
    var $s_filename_init_string = 'fipa_import';
    var $s_fipa_idcode;
    var $cietclass;

    /*
     * Constructor
     */

    function __construct($parameters = array()) {
        // Instance extended import methods & loads required classes
        if (!class_exists('clx_import_extended_tool'))
            includeCodeLib('CIET');
        $this->cietclass = new clx_import_extended_tool($parameters, $this->s_import_def_code);
        // Inicializa los parametros del process engine
        $this->o_proc_eng_params = new proc_eng_params($parameters);
        // Extensi�n del archivo log
        define('IMPORT_ERRFILE_EXT', '.html');
        // Titulo para el reporte de resultado
        /*
         * MKCP_IMP_TITLE
         * Marketing Targets Import
         * Importaci�n de Targets de Mercadeo
         */
        //$this->s_title = dict('MKCP_IMP_TITLE');
        $this->s_title = $this->cietclass->s_title;
        multiTableName($this, array('FIPA', 'ACCO', 'FICO'));
    }

// Method End
    /**
     * Function will extract the flat file and load it into FIPA
     * Entry point for batch process engine
     */
    function run($filename = '') {
        // Verifies process engine parameters
        if (!$this->o_proc_eng_params->verify_parameters()) {
            echoLog('<h1>' . $this->o_proc_eng_params->errormsg . '</h1>');
            return false;
        }
        $this->o_proc_eng_params->set_tablename($this->cietclass->a_import_header['TABLECODE']);
        // Reads the file name (if not specified as method's parameter, look for it at process parameter)
        if ($filename === '') {
            $filename = $this->o_proc_eng_params->process_parameters['ANYFILE'];
        }
        // Verifies the input file existance
        $a_report_file_existance_and_openit_response = $this->cietclass->report_file_existance_and_openit($filename);
        if ($a_report_file_existance_and_openit_response['error'] === true) {
            echoLog($a_report_file_existance_and_openit_response['errormsg']);
            return false;
        }
        // Opens log file
        if (!$this->open_log_file($filename)) {
            return false;
        }
        // Begin reporting
        $this->o_logfile_mngr->write($this->cietclass->report_init());
        $this->o_logfile_mngr->write(CLX_CHAR_NL . '<tr>' . $this->cietclass->s_record_data_to_show . '</tr>' . CLX_CHAR_NL);
        // Deletes previous FIPA contents... ?????
        while ($line = $this->cietclass->read_next_line()) {
            // Read next line
            $record = $this->cietclass->read_line_into_record_array($line);
            // Deletes FIPA records for this contract
            $this->fipa_row_deletion($record);
        }
        // Starts reading flat file (closes it and reopen)
        $this->cietclass->terminates_process();
        $this->cietclass = new clx_import_extended_tool($this->o_proc_eng_params->process_parameters, $this->s_import_def_code);
        $this->cietclass->report_file_existance_and_openit($filename);
        $i_imported_rec_counter = CLX_INIT_ZERO;
        while ($line = $this->cietclass->read_next_line()) {
            // Read next line
            $record = $this->cietclass->read_line_into_record_array($line);
            // Prepares reporting detail line
            $i_imported_rec_counter++;
            $this->cietclass->s_record_data_to_show = str_replace('%i_imported_rec_counter%', $i_imported_rec_counter, $this->cietclass->s_record_data_to_show);
            $this->cietclass->s_record_data_to_show = str_replace('%extra_info%', '', $this->cietclass->s_record_data_to_show);
            // Record creation
            ClxFreeReturn($this->fipa_row_creation($record));

            // Reporting...
            $this->o_logfile_mngr->write($this->cietclass->s_record_data_to_show);
        }

        // Assigns NEVER to the process scheduling and closes log/debug files
        $this->terminates_process();
        return true;
    }

// Method End
    /*
     * Opens the error log flat text file
     */
    function open_log_file($filename) {
        $this->s_log_filename = $this->import_log_filename($this->s_filename_init_string, 'log');
        /*
         * GEN_LBL_ORIG_FILE
         * Source File
         * Archivo Fuente
         */
        /*
         * GEN_LBL_LOGFILE
         * Log file
         * Archivo de Errores
         */
        $title = $this->s_title . '<br><br>' .
                dict('GEN_LBL_ORIG_FILE') . ': $filename<br>' .
                dict('GEN_LBL_LOGFILE') . ': ' . $this->s_log_filename . '<br>';
        $title .= '<br>';
        $this->o_logfile_mngr = new clx_logfile_mngr($this->s_logfile_folder . $this->s_log_filename);
        if ($this->o_logfile_mngr->error === true) {
            $this->cietclass->proc_log_write($this->o_logfile_mngr->errorMsg);
            return false;
        }
        $this->o_logfile_mngr->write($title);
        return true;
    }

// Method End
    /**
     * Returns the log flat text file name
     */
    function import_log_filename($filename, $filetype) {
        $s_response = $filename . '_' . $filetype . '_' . adodb_date('Ymd') . '_' . adodb_date('hms') . IMPORT_ERRFILE_EXT;
        return $s_response;
    }

// Method End
    /*
     * FIPA row creation
     */
    function fipa_row_deletion($record) {
        $sql = 'DELETE FROM ' . $this->fipaname . ' WHERE CONTRACT_CODE = ' . singleQuote($record['CONTRACT_CODE']);
        ClxCommon::$db->executeQueryVoid($sql);
    }

    /*
     * FIPA row creation
     */

    function fipa_row_creation($a_record_read) {
        $record = array();
        $record['IDCODE'] = 'AUTO';
        $record['CREATEDBY'] = '';
        $record['MODIFIEDBY'] = '';
        $record['CDATE'] = '';
        $record['MDATE'] = '';
        $record = setCreationData($record);
        $record = setCreationIdCode($record, 'FIPA');
        $this->s_fipa_idcode = $record['IDCODE'];
        $s_acco_idname = $this->cietclass->line[$this->cietclass->a_flatfile_headers['NOMBRE CLIENTE']];
        $a_contract_record = ClxCommon::$db->getRecord($this->ficoname, 'IDCODE = ' . singleQuote($a_record_read['CONTRACT_CODE']));
        $record['ACCOUNTCODE'] = ClxCommon::$db->getField($this->acconame, 'IDCODE', 'IDNAME = ' . singleQuote($s_acco_idname));
        $record['CONTRACT_CODE'] = $a_record_read['CONTRACT_CODE'];
        $record['START_DATE'] = $a_contract_record['START_DATE'];
        $record['END_DATE'] = 'null';
        $record['STATUS'] = $a_record_read['STATUS'];
        $record['CLX_AUTH_STATUS'] = 'AP';

        $record['FIPATERM_REASON'] = $a_record_read['FIPATERM_REASON'];
        $record['PARTICIPANT_TYPE'] = $a_record_read['PARTICIPANT_TYPE'];
        $record['ISPRIMARY'] = $a_record_read['ISPRIMARY'];
        $record['CAP_PERIOD'] = $a_record_read['CAP_PERIOD'];
        $record['CAPITALIZATION_PCT'] = $a_record_read['CAPITALIZATION_PCT'];
        $record['CAPPAYMENT_PCT'] = $a_record_read['CAPPAYMENT_PCT'];
        $record['COMITTED_TRUST_AMT'] = $a_record_read['COMITTED_TRUST_AMT'];
        $i_fipa_id = CLX_INIT_ZERO;
        if ($record['ACCOUNTCODE'] !== '') {
            $i_fipa_id = ClxCommon::$db->createRecord($this->fipaname, $record, true);
        } else {
            // Couldn't find the client crm account... ERROR
        }
        return $i_fipa_id;
    }

// Method End
    /*
     * Put a link to the file
     */
    function put_link_to_logfile() {
        $filespec = $this->s_logfile_folder . $this->s_log_filename;
        echo $this->o_proc_eng_params->get_file_link(array(array('FILENAME' => $filespec,
            )
                )
        );
    }

    /*
     * Terminates de process to prepares it for new execution, optimize table and close log/debug files
     */

    function terminates_process() {
        // Terminates reporting
        $this->o_logfile_mngr->write($this->cietclass->report_ending());
        // Closes input file
        $this->cietclass->terminates_process();
        // Close log file
        $this->o_logfile_mngr->close();
        // Put a link to the file
        $this->put_link_to_logfile();
        // Assigns NEVER to the process scheduling
        $a_pars_tobe_erased = array();
        $this->o_proc_eng_params->stop_proc_sched($a_pars_tobe_erased);
        // Optimize table (recommended on large import processes
        $this->o_proc_eng_params->optimize_table();
    }

}
