<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-02-03 08:38:47 -0500 (Wed, 03 Feb 2016) $
 * @version        $Rev: 7778 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
/*
  Record of changes 			Desarrollo de import de productos y de relacion productos clientes
  Se agreg� el parametro b_empty_proc_params para evitar eliminar el contenido del parametro 			Se agreg� la columna EFFTDATE al archivo de entrada en el m�todo acco_prod_import_read_line_into_record_array() 			Se agreg� parametro para definir el modo de trabajo del import de productos. Antes era solo estilo matching record, ahora tiene la opcion adicional de solo agregar los nuevos, que es la opcion por defecto 				acco_prod_get_prod_acco(): se le quitan los ceros delante al IBS_CUSCUN ya que el import de clientes de IBS los almacena sin ceros delante
  prod_import(): se elimino el uso de la columna PRODUCTNAME
  Se cambio CAMPO NUEVO como columna en el archivo de texto. Ahora se llama APCNME */
if (!class_exists('ibs'))
    includeCodeLib('EIBS');

class ibs_product_interfase extends ibs {

    var $contents;
    var $o_clx_file;
    var $import_folder;   // Parameter: PROD_INTRF_IMP_DIR
    var $prod_business_unit; // Parameter: PROD_INTRF_BUSS_UNIT
    var $prod_product_class; // Parameter: PROD_INTRF_PRDCT_CLASS
    // OJO OJO OJO var $batch_id;
    var $record_id;
    var $record_headers;
    var $local_debug = false;
    var $local_debug_2 = false;
    var $o_debugfile_mngr;
    var $debug_filename;
    var $filename_init_string;
    var $prodname;
    var $acconame;
    var $acpsname;
    var $s_title;
    var $s_process_code;
    var $proc_eng_params;
    var $o_logfile_mngr;
    var $log_filename;
    var $logfile_folder_real;
    var $logfile_folder_relative = 'export';
    var $a_field_size;
    var $b_remove_source_plain_file = false;
    var $b_process_style = 'A'; // 'A' = Add new records only, 'M' = matching record
    var $b_empty_proc_params = false;
    var $a_rec_estatus_desc;

    // OJO OJO OJO var $username;
    // OJO OJO OJO var $lang;
    function ibs_product_interfase($s_comp_code = null, $parameters = array()) {
        define('prod_import_ERRFILE_EXT', '.html');
        parent::__construct($s_comp_code, $parameters);
        // Server's import folder default value
        $this->import_folder = companyParameter('PROD_INTRF_IMP_DIR');
        if (empty($this->import_folder)) {
            $this->import_folder = kPathToWebSite . 'temp/';
        }
        // Bussines Unit default value, to be assigned in creation of new PROD rows
        $this->prod_business_unit = companyParameter('PROD_INTRF_BUSS_UNIT');
        // Product Class default value, to be assigned in creation of new PROD rows
        $this->prod_product_class = companyParameter('PROD_INTRF_PRDCT_CLASS');
        // Constants
        define('ACPS_ACCOUNT_NO', 'ACPS_ACCOUNT_NO');
        // Log file folder
        $this->logfile_folder_real = kPathToWebSite . $this->logfile_folder_relative . DIRECTORY_SEPARATOR;
        multiTableName($this, array('ACCO', 'PROD', 'ACPS'));
        //if(!class_exists('inve_utilities')) includeCodeLib('INUT');
        if (!function_exists('setCreationData'))
            includeCodeLib('GEN_REC_UTIL');
        if (!class_exists('clx_file_delimited'))
            require_once kPathToWebSite . 'classes/clx_file_delimited.php';
        // Inicializa los parametros del process engine
        $this->proc_eng_params = new proc_eng_params($parameters);
        //$this->proc_eng_params->debug = $this->local_debug;
        // Init status description array
        $this->fill_arrays();
        if (!empty($this->local_debug_2))
            echo 'ini_get(', singleQuote('memory_limit'), ')=', ini_get('memory_limit'), CLX_CHAR_NL;
        if (!empty($this->local_debug_2))
            echo 'ini_get(', singleQuote('magic_quotes_gpc'), ')=', ini_get('magic_quotes_gpc'), CLX_CHAR_NL;
    }

// Method End
    /*
     *  Fill description arrays
     */
    function fill_arrays() {
        $this->a_rec_estatus_desc = array();
        /*
         * GEN_LBL_CREATED
         * Created
         * Creado
         */
        $this->a_rec_estatus_desc['C'] = dict('GEN_LBL_CREATED');
        /*
         * GEN_LBL_MODIFIED
         * Modified
         * Modificado
         */
        $this->a_rec_estatus_desc['U'] = dict('GEN_LBL_MODIFIED');
        /*
         * GEN_LBL_INACTIVATED
         * Inactivated
         * Inactivado
         */
		 $this->a_rec_estatus_desc['I'] = dict('GEN_LBL_INACTIVATED');
        /*
         * GEN_LBL_IGNORED
         * Ignored
         * Ignorado
         */
        $this->a_rec_estatus_desc['M'] = dict('GEN_LBL_IGNORED');
    }

    /**
     * Product import - entry point method
     */
    function prod_import($filename = null) {
        /*
         * CODE_MSG_PRODIMPRT_TITLE
         * Products import
         * Importaci�n de Productos
         */
        $this->s_title = dict('CODE_MSG_PRODIMPRT_TITLE');
        $this->s_process_code = 'IBS_PROD_IMP';
        $this->filename_init_string = 'ibs_prod_import';
        // Depuraci�n (OJO estas instrucciones deben estar justo aqui)
        $this->echoLogDebug_openVoid();
        // To truncate field lenght avoiding db errors
        $this->a_field_size = array();
        $this->a_field_size['IDNAME'] = ClxCommon::$db->getField('CLX_DB_FIELDS', 'FIELD_SIZE', 'FIELDNAME = ' . singleQuote('IDNAME') . '');
        $this->proc_eng_params->set_tablename('PROD');
        if ($filename != null) {
            // If the parameter has passed, executes the import process directly, assuming that it's an automatic process between systems
            ClxFreeReturn($this->prod_import_doitnow($filename));
        } else {
            // Ask the user for the import file location
            $ac = UserRequest::$request['ac'];
            $this->prod_import_action($ac);
        }
    }

// Method End
    /**
     * Client <-> Product import - entry point method
     */
    function acco_prod_import($filename = null) {
        /*
         * CODE_MSG_ACCOPRODIMPRT_TITLE
         * CRM Accounts and Products link import
         * Importaci�n de relaci�n de Productos y Cuentas CRM
         */
        $this->s_title = dict('CODE_MSG_ACCOPRODIMPRT_TITLE');
        $this->s_process_code = 'IBS_ACPS_IMP';
        $this->filename_init_string = 'ibs_acps_import';
        // Depuraci�n (OJO estas instrucciones deben estar justo aqui)
        $this->echoLogDebug_openVoid();
        $this->proc_eng_params->set_tablename('ACPS');
        if ($filename != null) {
            // If the parameter has passed, executes the import process directly, assuming that it's an automatic process between systems
            ClxFreeReturn($this->acco_prod_import_doitnow($filename));
        } else {
            // Ask the user for the import file location
            $ac = UserRequest::$request['ac'];
            $this->prod_import_action($ac);
        }
    }

// Method End
    /*
     * Verifies the input file existance
     */
    function report_file_existance_and_openit($filename) {
        // Verifies the input file existance
        if (file_exists($filename)) {
            /*
             * GEN_ERR_FILE_FOUND
             * File found: ^1
             * Archivo encontrado: ^1
             */
            $this->echoLog(CLX_CHAR_NL . dict('GEN_ERR_FILE_FOUND', $filename));
            // Opens input file
            $this->o_clx_file = new clx_file_delimited($filename, CLX_CHAR_NL, CLX_CHAR_TAB);
            if ($this->o_clx_file->error === true) {
                $msg = dict('GEN_ERR_FILE_OPENERROR', "($filename)") . ' (' . $this->o_clx_file->errorMsg . ')';
                $this->proc_log_write($msg);
                return false;
            }
            return true;
        } else {
            /*
             * GEN_ERR_FILE_NOTFOUND
             * File not found: ^1
             * Archivo no fue encontrado: ^1
             */
            $msg = dict('GEN_ERR_FILE_NOTFOUND', $filename);
            $this->proc_log_write($msg);
            return false;
        }
    }

// Method End
    function open_log_file($filename) {
        $this->log_filename = $this->prod_import_log_filename($this->filename_init_string, 'log');
        /*
         * GEN_LBL_ORIG_FILE
         * Source File
         * Archivo Fuente
         */
        /*
         * GEN_LBL_LOGFILE
         * Log file
         * Archivo de Errores
         */
        $title = $this->s_title . '<br><br>' .
                dict('GEN_LBL_ORIG_FILE') . ': ' . $filename . '<br>' .
                dict('GEN_LBL_LOGFILE') . ': ' . $this->log_filename . '<br>';
        if (!empty($this->local_debug)) {
            /*
             * GEN_LBL_DEBUGFILE
             * Debug File
             * Archivo de Depuraci�n
             */
            $title .= dict('GEN_LBL_DEBUGFILE') . ': ' . $this->debug_filename . '<br>';
        }
        $title .= '<br>';
        $this->o_logfile_mngr = new clx_logfile_mngr($this->logfile_folder_real . $this->log_filename);
        if (!empty($this->o_logfile_mngr->error)) {
            $this->proc_log_write($this->o_logfile_mngr->errorMsg);
            return false;
        }
        $this->o_logfile_mngr->write($title);
        if (!empty($this->local_debug)) {
            $this->o_debugfile_mngr->write($title);
        }
        return true;
    }

// Method End
    /*
     * Debug file open
     */

    function echoLogDebug_openVoid() {
        ClxFreeReturn($this->echoLogDebug_open());
    }

    function echoLogDebug_open() {
        $this->debug_filename = $this->prod_import_log_filename($this->filename_init_string, 'debug');
        if (!empty($this->local_debug)) {
            $this->o_debugfile_mngr = new clx_logfile_mngr($this->logfile_folder_real . $this->debug_filename);
            if (!empty($this->o_logfile_mngr->error)) {
                $this->proc_log_write($this->o_logfile_mngr->errorMsg);
                return false;
            }
        }
        return true;
    }

// Method End
    /**
     * Function will extract the flat file and load it into PROD
     */
    function prod_import_doitnow($filename) {
        // Verifies process engine parameters
        if (!$this->proc_eng_params->verify_parameters()) {
            $this->echoLog('<h1>' . $this->proc_eng_params->errormsg . '</h1>');
            return false;
        }
        // Verifies the input file existance
        if (!$this->report_file_existance_and_openit($filename)) {
            return false;
        }
        // Opens log file
        if (!$this->open_log_file($filename)) {
            return false;
        }
        if (!empty($this->local_debug_2))
            $this->o_logfile_mngr->write('Initialices prod table (matching record algotithm');
        // Initialices prod table (matching record algotithm
        if ($this->b_process_style === 'M')
            $this->prod_import_table_estatus_init();
        $i_line_counter = CLX_INIT_ZERO;
        $b_header_line_read = false;
        $this->record_headers = null;
        if (!empty($this->local_debug_2))
            $this->o_logfile_mngr->write('Comienza Ciclo');
        while (($line = $this->o_clx_file->getNextRecord()) === true) {
            if (!empty($this->local_debug_2))
                $this->o_logfile_mngr->write('<b>' . $i_line_counter . ' --&gt;' . $line . '&lt;--</b><br>');
            $this->echoLogDebug('<b>' . $i_line_counter . ' --&gt;' . $line . '&lt;--</b><br>');
            // skips blank lines
            $line = $this->o_clx_file->delete_ending_crlf($line);
            if (trim($line) !== '') {
                if (empty($b_header_line_read)) {
                    // Set the first line read flag
                    $b_header_line_read = true;
                    // Read the first line
                    if (!empty($this->local_debug_2))
                        $this->o_logfile_mngr->write('Read the first line - 0<br>');
                    $this->record_headers = $this->prod_import_read_line_into_record_array_header($line);
                    // Special missing field cases
                    // BT Case: if 'CAMPO NUEVO' column is set, change it for the right columnname APCNME
                    if (isset($this->record_headers['CAMPO NUEVO']) && !isset($this->record_headers['APCNME'])) {
                        $this->record_headers['APCNME'] = $this->record_headers['CAMPO NUEVO'];
                    }
                    // If column APCNME is not set (short product description), assume large description in that column
                    if (!isset($this->record_headers['APCNME'])) {
                        $this->record_headers['APCNME'] = $this->record_headers['APCDSC'];
                    }
                    // Initialices ending validations accumulators
                    $this->record_headers['line_counter_noblanks'] = CLX_INIT_ZERO;
                    if (!empty($this->local_debug_2))
                        $this->o_logfile_mngr->write('Read the first line - 3<br>');
                } else {
                    $i_line_counter++;
                    // Read further lines
                    if (!empty($this->local_debug_2))
                        $this->o_logfile_mngr->write('Read further lines - 0<br>');
                    $record = $this->prod_import_read_line_into_record_array($line);
                    if (!empty($this->local_debug_2))
                        $this->o_logfile_mngr->write('Read further lines - 1<br>');
                    $this->record_headers['line_counter_noblanks'] ++;
                    if (!empty($this->local_debug_2))
                        $this->o_logfile_mngr->write('Read further lines - 2<br>');
                    $s_record_data_to_show = $i_line_counter . ') ' . $record['IDCODE'] . ' | ' . $record['IDNAME'];
                    // Other field fixes
                    // PROD record creation
                    if (!empty($this->local_debug_2))
                        $this->o_logfile_mngr->write('Read further lines - 3<br>');
                    $s_status = $this->prod_import_rec_creation($record);
                    if (!empty($this->local_debug_2))
                        $this->o_logfile_mngr->write('Read further lines - 4<br>');
                    $s_status = $s_status . ' - ' . $this->a_rec_estatus_desc[$s_status];
                    if (!empty($this->local_debug_2))
                        $this->o_logfile_mngr->write('Read further lines - 5<br>');
                    $s_record_data_to_show .= ' (' . $s_status . ')';
                    $this->o_logfile_mngr->write($s_record_data_to_show . '<br>' . CLX_CHAR_NL);
                    if (!empty($this->local_debug_2))
                        $this->o_logfile_mngr->write('Read further lines - 6<br>');
                }
            }
        }
        // Closes input file
        $this->o_clx_file->close();
        // Report inactive products
        if ($this->b_process_style === 'M')
            $this->prod_import_inactive_report();
        // Removes the original file
        if ($this->b_remove_source_plain_file === true)
            unlink($filename);
        // Put a link to the file
        $this->put_link_to_logfile();
        // Assigns NEVER to the process scheduling and closes log/debug files
        $this->terminates_process();
        $this->echoLogDebug('PROD endded');
    }

// Method End
    /*
     * Report inactive products
     */
    function prod_import_inactive_report() {
        // Total lines processed
        /*
         * GEN_LBL_LINESPROCESSED
         * ^1 processed lines
         * ^1 lineas procesadas
         */
        $this->o_logfile_mngr->write('<br>' .
                dict('GEN_LBL_LINESPROCESSED', $this->record_headers['line_counter_noblanks']) . '<br><br>' . CLX_CHAR_NL .
                dict('GEN_LBL_INACTIVATED') . ':<br>' . CLX_CHAR_NL
        );
        $sql = 'SELECT IDCODE, IDNAME FROM ' . $this->prodname . ' WHERE STATUS = ' . singleQuote('I') . '';
        $rs = ClxCommon::$db->executeQuery($sql);
        $i_line_counter = CLX_INIT_ZERO;
        while (($record = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))) {
            $s_record_data_to_show = ++$i_line_counter . ') ' . $record['IDCODE'] . ' | ' . $record['IDNAME'];
            $this->o_logfile_mngr->write($s_record_data_to_show . '<br>' . CLX_CHAR_NL);
        }
		ClxCommon::$db->freeResult($rs);
    }

// Method end
    /*
     * Initialize PROD table for import. Deactivates all records prior to import
     */
    function prod_import_table_estatus_init() {
        $sql = '	UPDATE ' . $this->prodname . '  SET STATUS = ' . singleQuote('I') . ' ';
        if (!empty($this->local_debug_2))
            ClxCommon::$db->debug = true;
        ClxCommon::$db->executeQuery($sql);
        if (!empty($this->local_debug_2))
            ClxCommon::$db->debug = false;
    }

    /*
     * Creates PROD record
     */

    function prod_import_rec_creation($record) {
        if (!empty($this->local_debug_2))
            $this->o_logfile_mngr->write('prod_import_rec_creation - 0<br>');
        if (!empty($this->local_debug_2))
            ClxCommon::$db->debug = true;
        $n_record_qty = ClxCommon::$db->oneExistsRecords($this->prodname, 'IDCODE = ' . singleQuote($record['IDCODE']));
        if (!empty($this->local_debug_2))
            ClxCommon::$db->debug = false;
        if (!empty($this->local_debug_2))
            echo CLX_CHAR_NL;
        if (!empty($this->local_debug_2))
            $this->o_logfile_mngr->write('prod_import_rec_creation - 1<br>');
        if ($n_record_qty > CLX_NUM_ZERO) {
            // Update record
            $store_idcode = $record['IDCODE']; //por si lo necesitas despues
            unset($record['IDCODE']);
            if (!empty($this->local_debug_2))
                $this->o_logfile_mngr->write('prod_import_rec_creation - 2<br>');
            if (!empty($this->local_debug_2))
                ClxCommon::$db->debug = true;
            ClxCommon::$db->updateRecord($this->prodname, $record, 'IDCODE = ' . singleQuote($store_idcode));
            if (!empty($this->local_debug_2))
                ClxCommon::$db->debug = false;
            if (!empty($this->local_debug_2))
                echo CLX_CHAR_NL;
            $record['IDCODE'] = $store_idcode;
            if (!empty($this->local_debug_2))
                $this->o_logfile_mngr->write('prod_import_rec_creation - 3<br>');
            $s_response = 'U';
        } else {
            // Creates record
            if (!empty($this->local_debug_2))
                ClxFreeReturn ( ClxCommon::$db->debug);
            if (!empty($this->local_debug_2))
                $this->o_logfile_mngr->write('prod_import_rec_creation - 4<br>');
            if (!empty($this->local_debug_2))
                ClxCommon::$db->debug = true;
            $this->record_id = ClxCommon::$db->createRecord($this->prodname, $record, true);
            if (!empty($this->local_debug_2))
                ClxCommon::$db->debug = false;
            if (!empty($this->local_debug_2))
                echo CLX_CHAR_NL;
            if (!empty($this->local_debug_2))
                $this->o_logfile_mngr->write('prod_import_rec_creation - 5<br>');
            $s_response = 'C';
        }
        return $s_response;
    }

    /*
     * Returns unique code id for the PROD row
     */

    function prod_import_code_generation($line) {
        // Sub-product code + minus sign + bank code
        $s_response = $line[$this->record_headers['APCCDE']] . '-' . $line[$this->record_headers['APCBNK']];
        return $s_response;
    }

    /**
     * Returns record array from the FIRST line (HEADER)
     */
    function prod_import_read_line_into_record_array_header($line) {
        //e cho 'Line:' . $line.'<br>';
        $line = $this->o_clx_file->toArray($line);
        $record = array();
        $total = count($line);
        for ($i = CLX_INIT_ZERO; $i < $total; $i++) {
            // To know the relationship between column names and it's indexes #
            $record[uppercase(trim($line[$i]))] = $i;
        }
        $this->echoLogDebug(debug_dump('Encabezado Registro', $record));
        return $record;
    }

// Method End
    /**
     * Returns record array from the line of PROD table
     */
    function prod_import_read_line_into_record_array($line) {
        //e cho 'Line:' . $line.'<br>';
        $line = $this->o_clx_file->toArray($line);
        $record = array();
        // 	IDCODE 	C�digo 	Nunca 	No 	No 	Default Campo 	0
        $record['IDCODE'] = $this->prod_import_code_generation($line);
        // 	IDNAME 	Nombre Corto 	Nunca 	No 	No 	Default Campo 	0
        $record['IDNAME'] = fija($line[$this->record_headers['APCNME']], $this->a_field_size['IDNAME']);
        // 	EFFTDATE 	Fecha Efectiva 	Nunca 	No 	No 	Default Campo 	0
        $record['EFFTDATE'] = adodb_date('Y-m-d');
        // 	DESCRIPTION 	Descripci�n 	Nunca 	No 	No 	Default Campo 	0
        $record['DESCRIPTION'] = $line[$this->record_headers['APCDSC']]; // $line[5];
        // 	STATUS 	Estado 	Nunca 	No 	No 	Default Campo 	0
        $record['STATUS'] = 'A';
        // 	CURRENCY_CODE 	Moneda 	Nunca 	No 	No 	Default Campo 	20
        $record['CURRENCY_CODE'] = $line[$this->record_headers['APCCCY']]; // $line[8];
        // 	BUSINESS_UNIT 	Unidad De Negocio 	Nunca 	No 	No 	Default Campo 	0
        $record['BUSINESS_UNIT'] = $this->prod_business_unit;
        // 	PRODUCT_CLASS 	Clasificaci�n 	Nunca 	No 	No 	Default Campo 	20
        $record['PRODUCT_CLASS'] = $this->prod_product_class;
        //	C�digo del Producto del banco. Usado para generar el archivo de solicitud masiva de cuentas de banco (originalmente se llamaba VZ_BK_PROD_CODE)
        $record['IBS_PROD_CODE'] = $line[$this->record_headers['APCCDE']];
        //	Tipo de producto del banco. Utilizado para la generaci�n del archivo para la solicitud masiva de cuentas de banco (VZ_BK_PROD_TYPE)
        $record['IBS_PROD_TYPE'] = $line[$this->record_headers['APCTYP']];
        //	Codigo del banco
        $record['IBS_BANK_CODE'] = $line[$this->record_headers['APCBNK']];
        $this->echoLogDebug(debug_dump('Registro', $record));
        return $record;
    }

// Method End
    /**
     * Returns the form's especified filename
     */
    function prod_import_filename() {
        $this->echoLogDebug(debug_dump('_POST', UserRequest::$post));
        if (empty(UserRequest::$post['prod_import_localfile'])) {
            $filename_tmp = UserRequest::$files['prod_import_uploadfile']['tmp_name'];
            $filename = $this->import_folder . UserRequest::$files['prod_import_uploadfile']['name'];
            /*
             * GEN_ERR_UPLOADFAIL
             * Upload failed, trying to move the file to target directory. Possible access rights conflict
             * Fall� el Upload, al tratar de mover el archivo a su directorio de destino final. Posible conflicto con derechos en la seguridad de directorios
             */
            if (!move_uploaded_file($filename_tmp, $filename))
                addMessage(dict('GEN_ERR_UPLOADFAIL'));
        } else {
            $filename = UserRequest::$post['prod_import_localfile'];
        }
        return $filename;
    }

// Method End
    /**
     * Returns the log filename
     */
    function prod_import_log_filename($filename, $filetype) {
        $s_response = $filename . '_' . $filetype . '_' . adodb_date('Ymd') . '_' . adodb_date('hms') . prod_import_ERRFILE_EXT;
        return $s_response;
    }

// Method End
    /**
     * If the number comes with coma as decimal delimiter, converts it to '.'
     */
    function prod_import_cnv_number($s_chr) {
        $s_chr = str_replace(',', '.', $s_chr);
        $s_chr = str_replace('"', '', $s_chr);
        if ($s_chr === '') {
            $s_chr = '0.00';
        }
        return $s_chr;
    }

// Method End
    /**
     * Other field eventual fixes, just to correct missing data with default values
     */
    function prod_import_oth_fld_fix(&$record) {

    }

// Method End
    /*
     * Write the error log file or records
     */
    function proc_log_write($msg, $error = true, $a_fields = array()) {
        if (!empty($error))
            $this->proc_eng_params->report_exceptions($msg, $a_fields);
    }

    /**
     * Form to get the import filespec, for those cases where it isn') . 't specified as entry point method parameter
     */
    function prod_import_upload_form($record, $msg, $title) {
        // Setup de la forma y campos Hidden
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF'], CLX_PROP_ID, 'theForm', 'name', 'theForm');
        $form->addArgument(CLX_PROP_TO, UserRequest::$request[CLX_PROP_TO]);
        $form->addArgument('ac', UserRequest::$request['ac']);
        $form->addArgument('idlist', (array_key_exists('idlist', UserRequest::$request) ? UserRequest::$request['idlist'] : ''));
        $form->addArgument('it', (array_key_exists('it', UserRequest::$request)) ? UserRequest::$request['it'] : '');
        $form->addArgument('wind', '1');
        $form->addArgument('confirm', '1');
        $form->setProp('enctype', 'multipart/form-data');
        // Datos que se solicitan

        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));

        $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_NUM_TWO));
        $table->addCell(dict('TOOL_PACK_PROMPT_IMPORTEXPLAIN'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_NUM_TWO));
        if (!array_key_exists('prod_import_localfile', $record))
            $record['prod_import_localfile'] = '';
        if (!array_key_exists('prod_import_uploadfile', $record))
            $record['prod_import_uploadfile'] = '';
        $table->addField($msg, dict('TOOL_PACK_PROMPT_FILEONSERVER') . ':', 'prod_import_localfile', $record['prod_import_localfile'], CLX_NUM_48, CLX_NUM_255);
        $table->addFile($msg, dict('TOOL_PACK_PROMPT_UPLOADFILE') . ':', 'prod_import_uploadfile', $record['prod_import_uploadfile']);
        // Botones y parte final
        $c = new htmlSubmit(dict('GEN_LBL_IMPORT'), 'PRINT_DIALOG');
        $buttons = $c->source();
        if (strpos(UserRequest::$server['PHP_SELF'], 'pop.php') !== false) {
            $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
            $buttons .= $c->source();
        }
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_NUM_TWO));
        $form->setContents($table->source());
        $this->contents .= $form->source();
    }

// Method End
    /**
     * Form values validation
     */
    function prod_import_check_upload_form(&$msg) {
        $msg = array();
        if (empty(UserRequest::$post['prod_import_localfile'])) {
            if (UserRequest::$files['prod_import_uploadfile']['error']) {
                $msg['prod_import_uploadfile'] = dict('ERR_PACK_FILETOOBIG');
            }
        } elseif (!file_exists(UserRequest::$post['prod_import_localfile'])) {
            $msg['prod_import_localfile'] = dict('GEN_ERR_FILE_NOTFOUND', UserRequest::$post['prod_import_localfile']);
        }
        return count($msg) == CLX_NUM_ZERO;
    }

// Method End
    /**
     * takes action depending of form's values
     */
    function prod_import_action($ac, $filename = null) {
        if (!empty(UserRequest::$post['confirm'])) {
            $msg = array();
            if ($this->prod_import_check_upload_form($msg)) {
                // If the filename not found, takes it from the form
                $filename = $this->prod_import_filename();
                $this->scheduleImport($filename);
            } else {
                $this->prod_import_upload_form(UserRequest::$post, $msg, $this->s_title);
            }
        } else {
            if (empty($msg))
                $msg = array();
            $this->prod_import_upload_form(UserRequest::$post, $msg, $this->s_title);
        }
    }

// Method End
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /**
     * Function will extract the flat file and load it into ACPS
     */
    function acco_prod_import_doitnow($filename) {
//return false;
        // Verifies process engine parameters
        if (!$this->proc_eng_params->verify_parameters()) {
            $this->echoLog('<h1>' . $this->proc_eng_params->errormsg . '</h1>');
            return false;
        }
        if (!empty($this->local_debug_2))
            echo 'acco_prod_import_doitnow - 0', CLX_CHAR_NL;
        // Verifies the input file existance
        if (!$this->report_file_existance_and_openit($filename)) {
            return false;
        }
        if (!empty($this->local_debug_2))
            echo 'acco_prod_import_doitnow - 1', CLX_CHAR_NL;
        // Opens log file
        if (!$this->open_log_file($filename)) {
            return false;
        }
        if (!empty($this->local_debug_2))
            $this->o_logfile_mngr->write('acco_prod_import_doitnow - 2<br>');
        // Add temporary indexes for speed-up the process
        $this->create_drop_indexes(CLX_NUM_ZERO);
        if (!empty($this->local_debug_2))
            $this->o_logfile_mngr->write('acco_prod_import_doitnow - 3<br>');
        $i_line_counter = CLX_INIT_ZERO;
        $b_header_line_read = false;
        $this->record_headers = null;
        while (($line = $this->o_clx_file->getNextRecord()) === true) {
            $this->echoLogDebug('<b>' . $i_line_counter . ' --&gt;' . $line . '&lt;--</b><br>');
            if (!empty($this->local_debug_2))
                $this->o_logfile_mngr->write('<b>' . $i_line_counter . ' --&gt;' . $line . '&lt;--</b><br>');
            // skips blank lines
            $line = $this->o_clx_file->delete_ending_crlf($line);
            if (trim($line) !== '') {
                if (empty($b_header_line_read)) {
                    // Set the first line read flag
                    $b_header_line_read = true;
                    // Read the first line
                    if (!empty($this->local_debug_2))
                        $this->o_logfile_mngr->write('acco_prod_import_doitnow - 4<br>');
                    $this->record_headers = $this->prod_import_read_line_into_record_array_header($line);
                    if (!empty($this->local_debug_2))
                        $this->o_logfile_mngr->write('acco_prod_import_doitnow - 5<br>');
                    // Initialices ending validations accumulators
                    $this->record_headers['line_counter_noblanks'] = CLX_INIT_ZERO;
                } else {
                    $i_line_counter++;
                    // Read further lines
                    if (!empty($this->local_debug_2))
                        $this->o_logfile_mngr->write('acco_prod_import_doitnow - 6<br>');
                    $record = $this->acco_prod_import_read_line_into_record_array($line);
                    if (!empty($this->local_debug_2))
                        $this->o_logfile_mngr->write('acco_prod_import_doitnow - 7<br>');
                    $this->record_headers['line_counter_noblanks'] ++;
                    $s_record_data_to_show = $i_line_counter . ') ' . $record['IBS_BANK_CODE'] . ' | ' . $record['IBS_PROD_TYPE'] . ' | ' . $record[ACPS_ACCOUNT_NO] . ' | ' . $record['IBS_CUSCUN'];
                    if (!empty($this->local_debug_2))
                        $this->o_logfile_mngr->write('acco_prod_import_doitnow - 8<br>');
                    $a_fun_resp = $this->acco_prod_get_prod_acco($record);
                    if (!empty($this->local_debug_2))
                        $this->o_logfile_mngr->write('acco_prod_import_doitnow - 9<br>');
                    if (!empty($a_fun_resp['error'])) {
                        // Error looking for a PROD that matcthes with the line's data
                        $s_status = $a_fun_resp['errormsg'];
                        $this->proc_log_write($s_record_data_to_show . ' (' . $s_status . ')');
                    } else {
                        $record['ACCOUNTCODE'] = $a_fun_resp['ACCOUNTCODE'];
                        $record['PRODUCTCODE'] = $a_fun_resp['PRODUCTCODE'];
                        $record['PROD.IDNAME'] = $a_fun_resp['PROD.IDNAME'];
                        $record['PROD.CURRENCY_CODE'] = $a_fun_resp['PROD.CURRENCY_CODE'];
                        $s_record_data_to_show .= ' - CRM ID: ' .
                                $record['ACCOUNTCODE'] . ' &gt; ' .
                                $record['PRODUCTCODE'] . ' : ' .
                                $record['PROD.IDNAME'];
                        // ACPS record creation
                        if (!empty($this->local_debug_2))
                            $this->o_logfile_mngr->write('acco_prod_import_doitnow - 10<br>');
                        $s_status = $this->acco_prod_import_rec_creation($record);
                        if (!empty($this->local_debug_2))
                            $this->o_logfile_mngr->write('acco_prod_import_doitnow - 11<br>');
                        $s_status = $s_status . ' - ' . $this->a_rec_estatus_desc[$s_status];
                    }
                    $s_record_data_to_show .= ' (' . $s_status . ')';
                    $this->o_logfile_mngr->write($s_record_data_to_show . '<br>' . CLX_CHAR_NL);
                }
            }
        }
        // Closes input file
        $this->o_clx_file->close();
        // Removes the original file
        if (!empty($this->b_remove_source_plain_file))
            unlink($filename);
        // Put a link to the file
        $this->put_link_to_logfile();
        // Add temporary indexes for speed-up the process
        if (!empty($this->local_debug_2))
            $this->o_logfile_mngr->write('acco_prod_import_doitnow - 12<br>');
        $this->create_drop_indexes(CLX_NUM_ONE);
        // Assigns NEVER to the process scheduling and optimices database
        if (!empty($this->local_debug_2))
            $this->o_logfile_mngr->write('acco_prod_import_doitnow - 13<br>');
        $this->terminates_process();
        if (!empty($this->local_debug_2))
            $this->o_logfile_mngr->write('acco_prod_import_doitnow - 14<br>');
        $this->echoLogDebug('ACPS endded');
    }

// Method End
    /**
     * Returns record array from the line of ACPS table
     */
    function acco_prod_import_read_line_into_record_array($line) {
        //e cho 'Line:' . $line.'<br>';
        $line = $this->o_clx_file->toArray($line);
        $record = array();
        // APCBNK = BANCO
        $record['IBS_BANK_CODE'] = $line[$this->record_headers['APCBNK']];
        // APCTYP = COD. MADRE
        $record['IBS_PROD_TYPE'] = $line[$this->record_headers['APCTYP']];
        // APCCDE = COD. PROD.
        $record['IBS_PROD_CODE'] = $line[$this->record_headers['APCCDE']];
        // ACMACC = NUMERO DE CUENTA DE BANCO
        $record[ACPS_ACCOUNT_NO] = $line[$this->record_headers['ACMACC']];
        // CUSCUN = COD. CLIENTE
        $record['IBS_CUSCUN'] = $line[$this->record_headers['CUSCUN']];
        // EFFTDATE = FECHA DE APERTURA DEL PRODUCTO PARA ESTE CLIENTE
        if (isset($this->record_headers['EFFTDATE'])) {
            $record['EFFTDATE'] = $line[$this->record_headers['EFFTDATE']];
        } else {
            $record['EFFTDATE'] = adodb_date('Y-m-d');
        }
        $this->echoLogDebug(debug_dump('Registro', $record));
        return $record;
    }

// Method End
    /*
     * Searches for the corresponding product and account according to line's data
     */
    function acco_prod_get_prod_acco($record) {
        $a_response = array();
        $a_error_msg = array();
        $a_response['error'] = false;
        $s_ibs_cuscun = '' . (integer) $record['IBS_CUSCUN'];
        $a_response['ACCOUNTCODE'] = ClxCommon::$db->getField($this->acconame, 'IDCODE', 'IBS_CUSCUN = ' . singleQuote($s_ibs_cuscun));
        $a_prod_record = ClxCommon::$db->getRecord($this->prodname, 'IBS_BANK_CODE = ' . singleQuote($record['IBS_BANK_CODE']) . ' AND IBS_PROD_TYPE = ' . singleQuote($record['IBS_PROD_TYPE']) . ' AND IBS_PROD_CODE = ' . singleQuote($record['IBS_PROD_CODE']));
        $a_response['PRODUCTCODE'] = $a_prod_record['IDCODE'];
        $a_response['PROD.IDNAME'] = $a_prod_record['IDNAME'];
        $a_response['PROD.CURRENCY_CODE'] = $a_prod_record['CURRENCY_CODE'];
        if (empty($a_response['ACCOUNTCODE']) || is_null($a_response['ACCOUNTCODE'])) {
            $a_response['error'] = true;
            /*
             * CODE_ERR_IBS_ACCOCODNOTFND
             * IBS client code not found: ^1
             * No se encontr� el cliente con c�digo IBS: ^1
             */
            $a_error_msg[] = dict('CODE_ERR_IBS_ACCOCODNOTFND', $record['IBS_CUSCUN']);
        }
        if (empty($a_response['PRODUCTCODE']) || is_null($a_response['PRODUCTCODE'])) {
            $a_response['error'] = true;
            /*
             * CODE_ERR_IBS_PRODCODNOTFND
             * IBS product code not found. Prod. Code: ^1, Prod. Type: ^2, Bank: ^3
             * No se encontr� el c�digo del producto IBS. Cod. Prod.: ^1, Tipo Prd.: ^2, Banco: ^3
             */
            $a_error_msg[] = dict('CODE_ERR_IBS_PRODCODNOTFND', $record['IBS_PROD_CODE'], $record['IBS_PROD_TYPE'], $record['IBS_BANK_CODE']);
        }
        if (!empty($a_response['error'])) {
            $a_response['errormsg'] = implode(', ', $a_error_msg);
        }
        return $a_response;
    }

// Method End
    /*
     * Creates  ACPS record
     */
    function acco_prod_import_rec_creation($record_par) {
        $record = array();
        $record['IDCODE'] = 'AUTO';
        $record = setCreationIdCode($record, 'ACPS');
        $n_record_qty = ClxCommon::$db->oneExistsRecords($this->acpsname, 'ACCOUNTCODE = ' . singleQuote($record_par['ACCOUNTCODE']) . 'AND  PRODUCTCODE = ' . singleQuote($record_par['PRODUCTCODE']) . 'AND  ' . ACPS_ACCOUNT_NO . ' = ' . singleQuote($record_par[ACPS_ACCOUNT_NO]));
        $record['ACCOUNTCODE'] = $record_par['ACCOUNTCODE'];
        $record['EFFTDATE'] = $record_par['EFFTDATE'];
        $record['ACPS_STAT'] = 'A';
        $record['IDNAME'] = $record_par['PROD.IDNAME'];
        $record['PRODUCTCODE'] = $record_par['PRODUCTCODE'];
        $record['ACCOUNT_NO'] = $record_par['ACCOUNT_NO'];
        $record['BRANCH'] = '';
        $record['CURRENCY_CODE'] = $record_par['PROD.CURRENCY_CODE'];
        $record['BALANCE_AMT'] = CLX_INIT_ZERO;
        if ($n_record_qty > CLX_NUM_ZERO) {
            // Update record
            $s_response = 'M'; // Ignored
        } else {
            // Creates record
            ClxFreeReturn (ClxCommon::$db->debug);
            $this->record_id = ClxCommon::$db->createRecord($this->acpsname, $record, true);
            $s_response = 'C';
        }
        return $s_response;
    }

    /*
     * Add or delete indexes to accelerate the process
     */

    function create_drop_indexes($s_mode) {
        if ($s_mode == CLX_NUM_ZERO) {
            // At the beginning: Creates temporary indexes
            $this->create_drop_one_index('ACPS', 'ADD');
            $this->create_drop_one_index('PROD', 'ADD');
            $this->create_drop_one_index('ACCO', 'ADD');
        } else {
            // At the end of the process: Deletes temporary indexes
            $this->create_drop_one_index('ACPS', 'DROP');
            $this->create_drop_one_index('PROD', 'DROP');
            $this->create_drop_one_index('ACCO', 'DROP');
        }
    }

// Method End
    /*
     * Creates/drops indexes on one table
     */
    function create_drop_one_index($s_table_original, $s_action) {
        if (!empty($this->local_debug_2))
            echo 'create_drop_one_index(', $s_table_original, ', ', $s_action, ')', CLX_CHAR_NL;
        $b_ok = true;
        switch ($s_table_original) {
            case 'ACPS':
                $s_table = $this->acpsname;
                $s_index_name = 'TMP_ACPS_IMPORT';
                $s_index_cols = 'ACCOUNTCODE, PRODUCTCODE, ' . ACPS_ACCOUNT_NO;
                break;
            case 'PROD':
                $s_table = $this->prodname;
                $s_index_name = 'TMP_PROD_IMPORT';
                $s_index_cols = 'IBS_BANK_CODE, IBS_PROD_TYPE, IBS_PROD_CODE';
                break;
            case 'ACCO':
                $s_table = $this->acconame;
                $s_index_name = 'TMP_ACCO_IMPORT';
                $s_index_cols = 'IBS_CUSCUN';
                break;
            default;
                $b_ok = false;
        }
        if (!empty($b_ok)) {
            $sql = null;
            if ($s_action === 'ADD') {
                if ($this->table_index_exists($s_table, $s_index_name)) {
                    $this->create_drop_one_index($s_table_original, 'DROP');
                    $this->create_drop_one_index($s_table_original, 'ADD');
                } else {
                    $sql = ' ALTER TABLE ' . $s_table . ' ADD INDEX ' . $s_index_name . '	(' . $s_index_cols . ') ';
                }
            } else {
                $sql = ' ALTER TABLE ' . $s_table . ' DROP INDEX ' . $s_index_name;
            }
            if ($sql != null) {
                ClxCommon::$db->executeQuery($sql);
            }
        }
    }

// Method End
    /**
     * Verifies index existance on a table definition
     */
    function table_index_exists($s_table, $s_index_name) {
        $rs = ClxCommon::$db->executeQuery('SHOW INDEX FROM ' . $s_table . ' WHERE Key_name = ' . singleQuote($s_index_name));
        ClxFreeReturn(ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE));
		ClxCommon::$db->freeResult($rs);
        return true;
    }

// Method End
    /**
     * Schedule import process to  inmediate excecution
     */
    function scheduleImport($filename) {
        $ar_pars_2_send = array();
        $ar_pars_2_send['ANYFILE'] = $filename;
        $this->contents .= $this->proc_eng_params->create_proc_sched($this->s_title, $ar_pars_2_send, null, $this->s_process_code);
    }

    /*
     * Put a link to the file
     */

    function put_link_to_logfile() {
        $filespec = $this->logfile_folder_relative . DIRECTORY_SEPARATOR . $this->log_filename;
        $this->echoLog($this->proc_eng_params->get_file_link(array(array('FILENAME' => kWebSite . $filespec,
                        'FILENAME_PLAIN' => kWebSite . $filespec,
                    )
                        )
                )
        );
    }

    /*
     * Terminates de process to prepares it for new execution, optimize table and close log/debug files
     */

    function terminates_process() {
        $this->echoLogDebug('terminates_process');
        $this->echoLogDebug(debug_dump('Process Parameters', $this->proc_eng_params->process_parameters));
        // Assigns NEVER to the process scheduling
        $a_pars_tobe_erased = array();
        if (!empty($this->b_empty_proc_params))
            $a_pars_tobe_erased = array('ANYFILE' => '');
        $this->proc_eng_params->stop_proc_sched($a_pars_tobe_erased);
        // Close log file
        $this->o_logfile_mngr->close();
        // Close debug file
        if (!empty($this->local_debug)) {
            $this->o_debugfile_mngr->close();
        }
        // Optimize table (recommended on large import processes
        $this->proc_eng_params->optimize_table();
    }

    /*
     * Put string into debug output file
     */

    function echoLogDebug($msg) {
        if (!empty($this->local_debug)) {
            $this->o_debugfile_mngr->write($msg . '<br>' . CLX_CHAR_NL);
        }
    }

    /*
     * Local echoLog method, witch sustitutes echoLog() global method because it does an echo while this one assigns the 'contents' property
     */

    function echoLog($s_out_msg) {
        $this->contents .= $s_out_msg . '<BR>';
    }

// Method End
    /*
     * Returns the output response contents
     */
    function contents() {
        return $this->contents;
    }

    function source() {
        return $this->contents;
    }

}

/// Class End
/*
 * ************************************************************************************
 * ESPECIFICACION DE LA ESTRUCTURA DE LOS ARCHIVOS DE ENTRADA DE TEXTO PLANO *
 * ************************************************************************************
  Nombre del archivo: IBSPROD.TXT
  Descripci�n: Productos en IBS
  Tipo de Archivo: texto plano separado por tabuladores
  Columnas:
  APCBNK = BANCO APCTYP = COD. MADRE APCCDE = COD. PROD. APCDSC = DESCRIPCI�N DEL PRODUCTO NOMBRE COMPLETO APCNME = ABREV. DE NOMBRE DE PRODUCTO (BT = CAMPO NUEVO) APCCCY = MONEDA  Notas:
 * Las columnas vendr�n separadas con el caracter TAB (c�digo ASCCI # 9) y las lineas separadas con CR+LF
 * El primer registro llevar� los nombres de las columnas separadas por TAB, o sea:
  APCBNK	APCTYP	APCCDE	APCDSC	APCNME	APCCCY * El resto de los registros vendr�n con los datos que corresponden con cada columna
  Nombre del archivo: IBSACPS.TXT
  Descripci�n: Productos asociadas a los Clientes
  Tipo de Archivo: texto plano separado por tabuladores
  Columnas:
  APCBNK = BANCO APCTYP = COD. MADRE APCCDE = COD. PROD. ACMACC = NUMERO DE CUENTA DE BANCO CUSCUN = COD. CLIENTE EFFTDATE = FECHA DE APERTURA DEL PRODUCTO EN FORMATO AAAA-MM-DD  Notas:
 * Las columnas vendr�n separadas con el caracter TAB (c�digo ASCCI # 9) y las lineas separadas con los caracteres de fin de l�nea (CR+LF)
 * El primer registro llevar� los nombres de las columnas separadas por TAB, o sea:
  APCBNK	APCTYP	APCCDE	ACMACC	CUSCUN	EFFTDATE * El resto de los registros vendr�n con los datos que corresponden con cada columna
 * Podr�n haber mas de un registro para cada cliente, lo que significa que un cliente podr� tener mas de un producto asociado
 */
