<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-07 11:58:37 -0400 (Wed, 07 Oct 2015) $
 * @version        $Rev: 7154 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class fidu_fees {

    var $code = 'FIFE';
    var $datestamp;
    var $debug = false;
    var $disable = false; //false

    /**
     * Constructor
     */

    function __construct() {
        UserResponse::setIgnoreUserAbort(CLX_NUM_ONE);
        UserResponse::setRunTimeLimit(CLX_NUM_24 * CLX_NUM_60 * CLX_NUM_60);
        $this->datestamp = date('Y-m-d H:i:s');
        $this->asset_type_allow = '"AR"';
        multiTableName($this, array('FICO', 'COMP', 'FIAT', 'FITB', 'FITG', 'FIPA', 'FIAS', 'FIRT', 'FIRS', 'FIAC', 'FIBT', 'FETR', 'GLAC', 'FIAF', 'FITL', 'IETB', 'JELN', 'JEHD'));
        $this->intlib = true;
    }

// End contructor
    /**
     * Start process fees and commition process
     * @param: BOOL $type_pay Set true to generate payment transaction, false to accumulate comission.
     */
    function run($type_pay) {
        if (!empty($this->debug))
            echoLog('Commitions & Fees Process Started<hr>');
        //Comission effective date are associate to accounting date and not to effective date.
        $efftdate = '';
        if (!empty($type_pay))
            $type = ' adddate(COMP.ACCOUNTING_DATE,interval 1 day) = FIAC.NEXT_RUN_DATE AND FIAC.PAYMENT_FREQ<>' . singleQuote('NONE') . ' AND FIAC.NEXT_RUN_DATE IS NOT null ';
        else
            $type = '  adddate(COMP.ACCOUNTING_DATE,interval 1 day) = FIAC.NEXT_CHARGE_DATE AND FIAC.CHARGE_FREQUENCY<>' . singleQuote('NONE') . ' AND  FIAC.NEXT_CHARGE_DATE IS NOT null ';
        $sql = 'SELECT FIAC.*, FICO.CURRENCY_CODE FICO_CURRENCY_CODE, FICO.COMP_CODE, FICO.IDNAME CONTRACT_NAME, COMP.ACCOUNTING_DATE, FIPA.ACCOUNTCODE PARTICIPANT_ID FROM ' . $this->fiacname . ' FIAC, ' . $this->fipaname . ' FIPA, ' . $this->ficoname . ' FICO LEFT JOIN ' . $this->compname . ' COMP ON COMP.IDCODE = FICO.COMP_CODE WHERE FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ' AND FIAC.STATUS = ' . singleQuote('A') . ' AND FIAC.CONTRACT_CODE = FICO.IDCODE AND FIPA.CONTRACT_CODE = FICO.IDCODE AND ' . $type . ' ' . $efftdate . ' ORDER BY ID ASC';
        //pre($sql);
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            if (!empty($this->debug))
                echoLog('---->Processing Fee: ' . $result['IDCODE'] . ' ' . $result['IDNAME'] . ', on contract: ' . $result['CONTRACT_NAME']);
            if (!$this->validate($result, $type_pay))
                continue;
            if (empty($this->disable))
                $this->calculate($result, $type_pay);
            if (!empty($this->debug))
                echoLog('<hr>');
        }
        ClxCommon::$db->freeResult($results);
        if (!empty($this->debug))
            echoLog('<hr>Commitions & Fees Process Ended');
    }

    /**
     * void run_selected(void)
     * Runs all selected commisions for contract. Method used for over
     * @param: BOOL $type_pay Set true to generate payment transaction, false to accumulate comission.
     */
    function run_selected($type_pay) {
        if (!empty($this->debug))
            echoLog('Commitions & Fees Process Started<hr>');
        if (!empty(self::$request['idlist'])) {
            foreach (self::$request['idlist'] as $key => $val) {
                $efftdate = '';
                $sql = 'SELECT FIAC.*, FICO.CURRENCY_CODE FICO_CURRENCY_CODE, FICO.IDNAME CONTRACT_NAME, FICO.COMP_CODE, FIPA.ACCOUNTCODE PARTICIPANT_ID FROM ' . $this->fiacname . ' FIAC, ' . $this->fipaname . ' FIPA, ' . $this->ficoname . ' FICO, ' . $this->compname . ' COMP WHERE ' . ((!$type_pay) ? 'COMP.ACCOUNTING_DATE <= FIAC.NEXT_CHARGE_DATE AND ' : ' COMP.ACCOUNTING_DATE <= FIAC.NEXT_RUN_DATE AND ') . ' FIAC.STATUS = ' . singleQuote('A') . ' AND FIAC.CONTRACT_CODE = FICO.IDCODE  AND FIPA.CONTRACT_CODE = FICO.IDCODE AND FIAC.ID = ' . singleQuote($val) . ' ' . singleQuote($efftdate);
                $results = ClxCommon::$db->executeQuery($sql);
                while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                    if (!empty($this->debug))
                        echoLog('---->Processing Fee: ' . $result['IDCODE'] . ' ' . $result['IDNAME'] . ', on contract: ' . $result['CONTRACT_NAME']);
                    if (!$this->validate($result, $type_pay))
                        continue;
                    $this->calculate($result, $type_pay);
                }
				ClxCommon::$db->freeResult($results);
            }
        }
        if (!empty($this->debug))
            echoLog('<hr>Commitions & Fees Process Ended');
    }

    /**
     * void validateTransaction(array transaction)
     * @date:
     * @param: array Transaction Record
     * Required Validations: 1. Status, 2. Participants, 3. Balances
     */
    function validate($record, $type_pay) {
        $status = true;
        if (!empty($type_pay) && ($record['EXP_ITEM_CODE'] === true && '' || $record['AP_ITEM_CODE'] === true && '')) {
            /**
             * CODE_ERR_MISINGPAYACCOUNTING
             * Commision Payment Parameters missing, please complete payment parameters.
             * Comision invalida, favor completar los parametros faltantes para pago en comision ^1.
             */
            addMessage(dict('CODE_ERR_MISINGPAYACCOUNTING', $record['IDCODE'] . ', ' . $record['IDNAME']));
            $status = false;
        }
        if (empty($record['COMTRANS_CODE'])) {
            /**
             * CODE_ERR_MISSINGCOMTRANS_CODE
             * Contract transaction code required on fee ^1, please add transaction and set active.
             * Transacci�n de contrato requerida para esta comisi�n, favor seleccione transacci�n y coloque como estado activo para continuar en comisi�n ^1.
             */
            addMessage(dict('CODE_ERR_MISSINGCOMTRANS_CODE', $record['IDCODE'] . ', ' . $record['IDNAME']));
            $status = false;
        }
        return $status;
    }

    /**
     * Init Record
     */
    function fiacInit(&$record) {
        if (empty($record['COMTRANS_CODE'])) {
            $record['STATUS'] = 'I';
        }
    }

    /**
     * Calculate
     * @param: array $record FIAC Record
     * @param: BOOL $type_pay Set true to generate payment transaction, false to accumulate comission.
     */
    function calculate($record, $type_pay) {
        if (!empty($this->debug))
            echoLog('Commitions and fee: ' . $record['IDCODE'] . ' for ' . $record['CONTRACT_CODE'] . ', Participant:' . $record['PARTICIPANT_ID']);
        if (!empty($this->debug))
            echoLog('Divider: ' . $record['DIVIDER_FACTOR']);
        if (!empty($type_pay)) {
            ClxCommon::$db->updateRecord($this->fiacname, array('LAST_RUN_DATE' => $record['NEXT_RUN_DATE'], 'NEXT_RUN_DATE' => adodb_next_date($record['NEXT_RUN_DATE'], $record['PAYMENT_FREQ'])), 'IDCODE = ' . singleQuote($record['IDCODE']));
            //updating Record
        } else {
            ClxCommon::$db->updateRecord($this->fiacname, array('LAST_CHARGE_DATE' => $record['NEXT_CHARGE_DATE'], 'NEXT_CHARGE_DATE' => adodb_next_date($record['NEXT_CHARGE_DATE'], $record['CHARGE_FREQUENCY'])), 'IDCODE = ' . singleQuote($record['IDCODE']));
            //Last charge date
        }
        $amt = (string) '0.00';
        $charges = array();
        if (!empty($this->debug) && !empty($type_pay))
            echoLog('Pay Type Started');
        //Determinate if pay accoumulated or not
        //Restore Accumulated Charges
        $charge_acc = false;
        if (!empty($type_pay)) {
            if (!empty($this->debug))
                echoLog('Pay Accumulated Charges');
            $amt = $this->accumulatedCharges($record, $charges);
            if ($amt > CLX_NUM_ZERO || $record['CHARGE_FREQUENCY'] <> 'NONE')
                $charge_acc = true;
        }
        if (!empty($this->debug))
            echoLog('Generate Commision');
        if (empty($charge_acc)) {
            $amt = bcadd($amt, $this->maxmin($record, $this->flatFees($record, $charges)));
            //Transaction fees are already included on transaction creation. uncomment to enable post procesing
            $amt = bcadd($amt, $this->maxmin($record, $this->fiatFees($record, $charges)));
            $amt = bcadd($amt, $this->maxmin($record, $this->fiasFees($record, $charges)), CLX_NUM_TWO);
        }
        if (!empty($this->debug))
            echoLog('Commision Amount: ' . xFormat::number($amt));
        if ($amt == CLX_NUM_ZERO)
            return;
        if (empty($type_pay)) {
            if (!empty($this->debug))
                echoLog('Generate Commission');
            ClxFreeReturn($this->accumulateCommission($amt, $record, $charges));
        }else {
            if (!empty($this->debug))
                echoLog('-Pay Comission');
            if (empty($record['APPROVE_PAYMENT'])) {
                $record['EFFTDATE'] = $record['NEXT_RUN_DATE'];
                $record['EFFTDATE'] = date('Y-m-d', strtotime($record['EFFTDATE'] . ' + 1 day'));
                $pending = true;
            } else {
                $record['EFFTDATE'] = $record['NEXT_RUN_DATE'];
                $pending = false;
            }
            $this->generateTransaction($amt, $record, $charges, $pending, $record['PARTICIPANT_ID']);
        }
    }

// End method
    /**
     * Return Amount of Accumulated Charges for this commision
     * @param: array charges
     * @return: string amount
     */
    function accumulatedCharges($record, &$charges) {
        $amt = '0.00';
        //Get Total accumulators up to effective date and not paid.
        //USING (CREDIT - DEBIT) * -1 or inverse DEBIT-CREDIT since grows by credits
        $amt = ClxCommon::$db->getOne('SELECT SUM(ROUND((JELN.CREDIT_AMT-JELN.DEBIT_AMT), 2)) BALANCE FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JELN.COMMISSION_CODE = ' . singleQuote($record['IDCODE']) . ' AND JEHD.EFFTDATE <= ' . singleQuote($record['NEXT_RUN_DATE']) . ' AND JEHD.CONTRACT_CODE = ' . singleQuote($record['CONTRACT_CODE']) . ' AND JELN.PARTICIPANT_ID = ' . singleQuote($record['PARTICIPANT_ID']) . ' GROUP BY JEHD.CONTRACT_CODE, JELN.PARTICIPANT_ID');
        if (empty($amt))
            $amt = '0.00';
        if (!empty($this->debug))
            echoLog('Total Accumulated: ' . xFormat::number($amt));
        if ($amt <> CLX_NUM_ZERO)
            $charges[] = array('COMMISION_CHARGE_CODE' => $record['IDCODE'], 'TRANS_CHARGED_CODE' => '', 'AMT' => $amt);
        return $amt;
    }

    /**
     * Adjust the commision amount according to max and min boundaries
     * and return the right amount to be charged.
     * @param: array commision Records
     * @param: float Commition amount
     */
    function maxmin($record, $amount) {
        $return = $amount;
        if ($amount <> CLX_NUM_ZERO) {
            if ($amount < $record['MINIMUM_FEE'] && $record['MINIMUM_FEE'] <> CLX_NUM_ZERO) {
                $return = $record['MINIMUM_FEE'];
                if (!empty($this->debug))
                    echoLog('-Minimun Condition required, Amount: ' . xFormat::number($return));
            }
            if ($amount > $record['MAXIMUM_FEE'] && $record['MAXIMUM_FEE'] <> CLX_NUM_ZERO) {
                $return = $record['MAXIMUM_FEE'];
                if (!empty($this->debug))
                    echoLog('-Maximun Condition Meet, Amount: ' . xFormat::number($return));
            }
        }
        return $return;
    }

// End method
    /**
     * Returns the flat fees amount
     * @param: array Commision Record
     */
    function flatFees($record, &$charges) {
        $return = (float) CLX_NUM_0_PT_00;
        if (!function_exists('getExchange'))
            includeCodeLib('TRANSPRO');
        $base_currency = ClxCommon::$db->getOne('SELECT COMP.CURRENCY_CODE FROM ' . $this->compname . ' COMP, ' . $this->ficoname . ' FICO . WHERE FICO.COMP_CODE = COMP.IDCODE AND FICO.IDCODE = ' . singleQuote($record['CONTRACT_CODE']));
        if (!empty($record['FLAT_FEES'])) {
            if ($record['FLAT_FEES'] <> CLX_NUM_ZERO)
                $charges[] = array('COMMISION_CHARGE_CODE' => $record['IDCODE'], 'TRANS_CHARGED_CODE' => '', 'AMT' => getExchange($record['FLAT_FEES'], $record['CURRENCY_CODE'], $base_currency, $record['EFFTDATE']));
            $return = $record['FLAT_FEES'];
        }
        if (!empty($record['DIVIDER_FACTOR']) && $record['DIVIDER_FACTOR'] <> CLX_NUM_ZERO) {
            if (!empty($this->debug))
                echoLog('Divider factor on flat: ' . $record['DIVIDER_FACTOR']);
            $return = bcdiv($return, $record['DIVIDER_FACTOR']);
        }
        if (!empty($this->debug))
            echoLog('-Flat fees: ' . xFormat::number($return));
        return $return;
    }

// End method
    /**
     * Trasaction Formula Fees
     * Returns the transaction fees amount
     * @param: array Commision Record
     */
    function fiatFees($record, &$charges) {
        $return = (float) CLX_NUM_0_PT_00;
        $done = ($record['TRANSACTION_FEES'] == CLX_NUM_ZERO && $record['TRANSACTION_PERCENTAGE'] == CLX_NUM_ZERO);
        $amt = '0.00'; //Save the amount for the transactions
        $counter = CLX_INIT_ZERO; //Count number of transaction under criteria
        $fee = $record['TRANSACTION_FEES'];
        if ($fee > CLX_NUM_ZERO) {
            //Perfom Conversion
            if (!function_exists('getExchange'))
                includeCodeLib('TRANSPRO');
            $base_currency = ClxCommon::$db->getOne('SELECT COMP.CURRENCY_CODE FROM ' . $this->compname . ' COMP, ' . $this->ficoname . ' FICO WHERE FICO.COMP_CODE = COMP.IDCODE AND FICO.IDCODE = ' . singleQuote($record['CONTRACT_CODE']));
            $fee = getExchange($fee, $record['CURRENCY_CODE'], $base_currency, $record['EFFTDATE']);
        }
        $rate = $record['TRANSACTION_PERCENTAGE'];
        if (!empty($this->debug))
            echoLog('-Transaction fee: ' . xFormat::number($fee) . ', rate:' . $rate);
        //Determining Transaction Amounts
        if (empty($done) && $record['FIDU_ALL_TRANS'] == CLX_NUM_ONE && ($record['DEBIT_CREDIT'] === 'N/A' || $record['DEBIT_CREDIT'] === '')) { // For all transactions
            //Setting for all cases
            if (!empty($this->debug))
                echoLog('-- Any Trasactions');
            $sql = 'SELECT FIAT.IDCODE, FITL.INCEXP_CODE, ' . 'ROUND((JELN.CREDIT_AMT-JELN.DEBIT_AMT), 2) TRANS_AMT FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->fiatname . ' FIAT, ' . $this->fitlname . ' FITL LEFT JOIN ' . $this->ietbname . ' IETB  ON FITL.INCEXP_CODE = IETB.IDCODE LEFT JOIN ' . $this->glacname . ' GLAC ON GLAC.IDCODE = IETB.GLACCOUNTCODE WHERE JEHD.JE_STATUS NOT IN(' . singleQuote('PEND') . ', ' . singleQuote('REJ') . ') AND JEHD.TRANS_CODE = FIAT.IDCODE AND JEHD.CONTRACT_CODE = FIAT.CONTRACT_CODE AND JELN.JEHDR_CODE = JEHD.IDCODE AND FIAT.REVTRANS_CODE IS NULL AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GL_TYPE IN (' . singleQuote('EQ') . ') AND FIAT.IDCODE = FITL.TRANS_CODE AND FITL.INCEXP_CODE <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND FIAT.CONTRACT_CODE = ' . singleQuote($record['CONTRACT_CODE']) . ' AND JELN.PARTICIPANT_ID = ' . singleQuote($record['PARTICIPANT_ID']) . ' AND FIAT.TRANS_STATUS IN (' . singleQuoteArray(array('CLOS', 'AP')) . ') AND (FIAT.COMMISION_CHARGED <> 1 OR FIAT.COMMISION_CHARGED IS NULL) AND (SELECT IDCODE FROM ' . $this->fiatname . ' B WHERE B.REVTRANS_CODE = FIAT.IDCODE) IS NULL';
            $results = ClxCommon::$db->executeQuery($sql);
            while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                $counter = bcadd($counter, CLX_NUM_ONE, CLX_NUM_ZERO);
                $amt = bcadd($amt, $result['TRANS_AMT']);
                if (!empty($record['DIVIDER_FACTOR']) && $record['DIVIDER_FACTOR'] <> CLX_NUM_ZERO)
                    $amt = bcdiv($amt, $record['DIVIDER_FACTOR']);
                if ($rate > CLX_NUM_ZERO) {
                    $charges[] = array('COMMISION_CHARGE_CODE' => $record['IDCODE'], 'TRANS_CHARGED_CODE' => $result['IDCODE'], 'AMT' => bcmul($result['TRANS_AMT'], bcdiv($rate, CLX_NUM_HUNDRED)));
                } elseif ($fee > CLX_NUM_ZERO) {
                    $charges[] = array('COMMISION_CHARGE_CODE' => $record['IDCODE'], 'TRANS_CHARGED_CODE' => $result['IDCODE'], 'AMT' => $fee);
                }
            }
			ClxCommon::$db->freeResult($results);
        } elseif (empty($done) && $record['DEBIT_CREDIT'] <> 'N/A' && $record['DEBIT_CREDIT'] <> '') {
            //Selecting only CREDIT or DEBITS
            if (!empty($this->debug))
                echoLog('- Per Credit or Debits (' . $record['DEBIT_CREDIT']);
            $sql = 'SELECT FIAT.IDCODE, FITL.INCEXP_CODE, ' . 'ROUND((JELN.CREDIT_AMT-JELN.DEBIT_AMT), 2) TRANS_AMT FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->fiatname . ' FIAT, ' . $this->fitlname . ' FITL LEFT JOIN ' . $this->fitbname . ' FITB ON FIAT.TRANSTBL_CODE = FITB.IDCODE LEFT JOIN ' . $this->ietbname . ' IETB  ON FITL.INCEXP_CODE = IETB.IDCODE LEFT JOIN ' . $this->glacname . ' GLAC ON GLAC.IDCODE = IETB.GLACCOUNTCODE WHERE JEHD.JE_STATUS NOT IN(' . singleQuote('PEND') . ', ' . singleQuote('REJ') . ') AND JEHD.TRANS_CODE = FIAT.IDCODE AND JEHD.CONTRACT_CODE = FIAT.CONTRACT_CODE AND JELN.JEHDR_CODE = JEHD.IDCODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND JELN.PARTICIPANT_ID = ' . singleQuote($record['PARTICIPANT_ID']) . ' AND FIAT.REVTRANS_CODE IS NULL AND FITL.DEBIT_CREDIT = ' . singleQuote($record['DEBIT_CREDIT']) . ' AND GLAC.GL_TYPE IN (' . singleQuote('EQ') . ') AND FIAT.IDCODE = FITL.TRANS_CODE AND FITL.INCEXP_CODE <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND FIAT.CONTRACT_CODE = ' . singleQuote($record['CONTRACT_CODE']) . ' AND FIAT.TRANS_STATUS IN (' . singleQuoteArray(array('CLOS', 'AP')) . ') AND (FIAT.COMMISION_CHARGED <> 1 OR FIAT.COMMISION_CHARGED IS NULL) AND (SELECT IDCODE FROM ' . $this->fiatname . ' B WHERE B.REVTRANS_CODE = FIAT.IDCODE) IS NULL';
            $results = ClxCommon::$db->executeQuery($sql);
            while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                $counter = bcadd($counter, CLX_NUM_ONE, CLX_NUM_ZERO);
                $amt = bcadd($amt, $result['TRANS_AMT']);
                if (!empty($record['DIVIDER_FACTOR']) && $record['DIVIDER_FACTOR'] <> CLX_NUM_ZERO)
                    $amt = bcdiv($amt, $record['DIVIDER_FACTOR']);
                if ($rate > CLX_NUM_ZERO) {
                    $charges[] = array('COMMISION_CHARGE_CODE' => $record['IDCODE'], 'TRANS_CHARGED_CODE' => $result['IDCODE'], 'AMT' => bcmul($result['TRANS_AMT'], bcdiv($rate, CLX_NUM_HUNDRED)));
                } elseif ($fee > CLX_NUM_ZERO) {
                    $charges[] = array('COMMISION_CHARGE_CODE' => $record['IDCODE'], 'TRANS_CHARGED_CODE' => $result['IDCODE'], 'AMT' => $fee);
                }
            }
			ClxCommon::$db->freeResult($results);
        } elseif (empty($done) && (!empty($record['TRANSCODE']) || ClxCommon::$db->oneExistsRecords($this->fetrname, 'CONTFEE_CODE = ' . singleQuote($record['IDCODE'])) > CLX_NUM_ZERO)) {
            //Selecting Transansaction
            if (!empty($record['TRANSCODE'])) {
                if (!empty($this->debug))
                    echoLog('-- Per Transaction (' . $record['TRANSCODE'] . ')');
                $sql = 'SELECT FIAT.IDCODE, FITL.INCEXP_CODE, ROUND((JELN.CREDIT_AMT-JELN.DEBIT_AMT), 2) TRANS_AMT FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->fiatname . ' FIAT, ' . $this->fitlname . ' FITL LEFT JOIN ' . $this->ietbname . ' IETB  ON FITL.INCEXP_CODE = IETB.IDCODE LEFT JOIN ' . $this->glacname . ' GLAC ON GLAC.IDCODE = IETB.GLACCOUNTCODE WHERE JEHD.JE_STATUS NOT IN(' . singleQuote('PEND') . ', ' . singleQuote('REJ') . ') AND JEHD.TRANS_CODE = FIAT.IDCODE AND JEHD.CONTRACT_CODE = FIAT.CONTRACT_CODE AND JELN.JEHDR_CODE = JEHD.IDCODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND JELN.PARTICIPANT_ID = ' . singleQuote($record['PARTICIPANT_ID']) . ' AND FIAT.REVTRANS_CODE IS NULL AND GLAC.GL_TYPE IN (' . singleQuote('EQ') . ') AND FIAT.IDCODE = FITL.TRANS_CODE AND FITL.INCEXP_CODE <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND FIAT.CONTRACT_CODE = ' . singleQuote($record['CONTRACT_CODE']) . ' AND FIAT.TRANSTBL_CODE = ' . singleQuote($record['TRANSCODE']) . ' AND FIAT.TRANS_STATUS IN (' . singleQuoteArray(array('CLOS', 'AP')) . ') AND (FIAT.COMMISION_CHARGED <> 1 OR FIAT.COMMISION_CHARGED IS NULL) AND (SELECT IDCODE FROM ' . $this->fiatname . ' B WHERE B.REVTRANS_CODE = FIAT.IDCODE) IS NULL';
                //e cho '<hr><pre>' . $sql.'</pre><hr>';
                $results = ClxCommon::$db->executeQuery($sql);
                while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                    $counter = bcadd($counter, '1', CLX_NUM_ZERO);
                    $amt = bcadd($amt, $result['TRANS_AMT']);
                    if (!empty($record['DIVIDER_FACTOR']) && $record['DIVIDER_FACTOR'] <> CLX_NUM_ZERO)
                        $amt = bcdiv($amt, $record['DIVIDER_FACTOR']);
                    if ($rate > CLX_NUM_ZERO) {
                        $charges[] = array('COMMISION_CHARGE_CODE' => $record['IDCODE'], 'TRANS_CHARGED_CODE' => $result['IDCODE'], 'AMT' => bcmul($result['TRANS_AMT'], bcdiv($rate, CLX_NUM_HUNDRED)));
                    } elseif ($fee > CLX_NUM_ZERO) {
                        $charges[] = array('COMMISION_CHARGE_CODE' => $record['IDCODE'], 'TRANS_CHARGED_CODE' => $result['IDCODE'], 'AMT' => $fee);
                    }
                }
				ClxCommon::$db->freeResult($results);
            }
            if (ClxCommon::$db->oneExistsRecords($this->fetrname, 'CONTFEE_CODE = ' . singleQuote($record['IDCODE'])) > CLX_NUM_ZERO) {
                if (!empty($this->debug))
                    echoLog('-- Per Multiple Transaction');
                //All Transaction Comission should be changed from the capital(Equity) account and not from all trans amt
                $sql = 'SELECT FIAT.IDCODE, FITL.INCEXP_CODE, ROUND((JELN.CREDIT_AMT-JELN.DEBIT_AMT), 2) TRANS_AMT FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->fiatname . ' FIAT, ' . $this->fetrname . ' FETR, ' . $this->fitlname . ' FITL LEFT JOIN ' . $this->ietbname . ' IETB  ON FITL.INCEXP_CODE = IETB.IDCODE LEFT JOIN ' . $this->glacname . ' GLAC ON GLAC.IDCODE = IETB.GLACCOUNTCODE WHERE JEHD.JE_STATUS NOT IN(' . singleQuote('PEND') . ', ' . singleQuote('REJ') . ') AND JEHD.TRANS_CODE = FIAT.IDCODE AND JEHD.CONTRACT_CODE = FIAT.CONTRACT_CODE AND JELN.JEHDR_CODE = JEHD.IDCODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND JELN.PARTICIPANT_ID = ' . singleQuote($record['PARTICIPANT_ID']) . ' AND FIAT.REVTRANS_CODE IS NULL AND FIAT.TRANSTBL_CODE NOT IN (' . singleQuote($record['TRANSCODE']) . ') AND FIAT.TRANSTBL_CODE = FETR.TRANSTBL_CODE AND GLAC.GL_TYPE IN (' . singleQuote('EQ') . ') AND FIAT.IDCODE = FITL.TRANS_CODE AND FITL.INCEXP_CODE <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND FIAT.CONTRACT_CODE = ' . singleQuote($record['CONTRACT_CODE']) . ' AND FETR.CONTFEE_CODE = ' . singleQuote($record['IDCODE']) . ' AND FIAT.TRANS_STATUS IN (' . singleQuoteArray(array('CLOS', 'AP')) . ') AND (FIAT.COMMISION_CHARGED <> 1 OR FIAT.COMMISION_CHARGED IS NULL) AND (SELECT IDCODE FROM ' . $this->fiatname . ' B WHERE B.REVTRANS_CODE = FIAT.IDCODE) IS NULL';
                $results = ClxCommon::$db->executeQuery($sql);
                while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                    $counter = bcadd($counter, CLX_NUM_ONE, CLX_NUM_ZERO);
                    $amt = bcadd($amt, $result['TRANS_AMT'], CLX_NUM_TWO);
                    if (!empty($record['DIVIDER_FACTOR']) && $record['DIVIDER_FACTOR'] <> CLX_NUM_ZERO)
                        $amt = bcdiv($amt, $record['DIVIDER_FACTOR']);
                    if ($rate > CLX_NUM_ZERO) {
                        $charges[] = array('COMMISION_CHARGE_CODE' => $record['IDCODE'], 'TRANS_CHARGED_CODE' => $result['IDCODE'], 'AMT' => bcmul($result['TRANS_AMT'], bcdiv($rate, CLX_NUM_HUNDRED), CLX_NUM_TWO));
                    } elseif ($fee > CLX_NUM_ZERO) {
                        $charges[] = array('COMMISION_CHARGE_CODE' => $record['IDCODE'], 'TRANS_CHARGED_CODE' => $result['IDCODE'], 'AMT' => $fee);
                    }
                }
				ClxCommon::$db->freeResult($results);
            }
        } elseif (empty($done)) {
            $amt = '0.00';
        }
        if ($rate > CLX_NUM_ZERO) {
            $return = bcmul($amt, bcdiv($rate, CLX_NUM_HUNDRED));
        } elseif ($fee > CLX_NUM_ZERO) {
            $return = bcmul($counter, $fee);
        } else {
            $return = CLX_NUM_0_PT_00;
        }
        if (!empty($this->debug))
            echoLog('-Trasaction Fees: ' . $counter . ', Amt: ' . xFormat::number($return));
        return $return;
    }

// End method
    /**
     * Asset Formula Fees
     * Returns the transaction fees amount
     */
    function fiasFees($record, &$charges) {
        $rate = (!empty($record['FIDU_RATETBLCODE'])) ? true : false;
        $return = '0.00';
        $done = (empty($record['ASSET_PERCENTAGE']) && !$rate);
        // Determining Amounts first all asset or latter asset code
        // Determine All assets value.
        if (empty($done) && strlen($record['ASSET_COM_BASE']) > CLX_NUM_ZERO) {
            if (!empty($this->debug))
                echoLog('--Capital/Asset Formula, Total Formula: ' . xFormat::number($return));
            $return = $this->fiasCapitalFormula($record);
        }
        //Testing Rates to apply to amount
        if (empty($done) && !empty($rate)) {
            // Get Rate Scale
            $rates = ClxCommon::$db->getRecord($this->firtname, 'IDCODE = ' . singleQuote($record['FIDU_RATETBLCODE']));
            if ($rates['HAS_RATESCALE'] == CLX_NUM_ONE) {
                $sql = 'SELECT * FROM ' .
                        $this->firsname . ' WHERE FIDU_RATETBLCODE = ' . singleQuote($rates['IDCODE']) . ' AND ((RANGE_FROM_AMT < ' . $return . ' AND RANGE_TO_AMT >= ' . $return . ') OR (RANGE_FROM_AMT < ' . $return . ' AND RANGE_TO_AMT = 0.00))';
                $ratelines = ClxCommon::$db->executeQuery($sql);
                if ($ratelines === true)
                    $rateline = ClxCommon::$db->getNextRecord($ratelines);
					ClxCommon::$db->freeResult($ratelines);
                if (!empty($rateline['FEES_RATE_PCT'])) {
                    if (!empty($this->debug)) {
                        echoLog('--Asset Fee Rate (' . $rateline['FIDU_RATETBLCODE'] . '): ' . $rateline['RANGE_FROM_AMT'] . '-> ' . xFormat::number($rateline['RANGE_TO_AMT']) . ' ' . xFormat::number($rateline['FEES_RATE_PCT']) . '%');
                    }
                    $return = bcmul($return, bcdiv($rateline['FEES_RATE_PCT'], CLX_NUM_HUNDRED), CLX_NUM_TWO);
                } elseif (!empty($rateline['FEES_RATE_AMT'])) {
                    if (!empty($this->debug)) {
                        echoLog('--Asset Fee Rate (' . $rateline['FIDU_RATETBLCODE'] . '): ' . $rateline['RANGE_FROM_AMT'] . '-> ' . xFormat::number($rateline['RANGE_TO_AMT']) . ' ' . xFormat::number($rateline['FEES_RATE_AMT']));
                    }
                    $return = $rateline['FEES_RATE_AMT'];
                } else {
                    $return = CLX_NUM_0_PT_00;
                }
            } else {// If not rate scale then use just rate
                if (!empty($rates['FEES_RATE_AMT'])) {
                    $return = $rates['FEES_RATE_AMT'];
                } elseif (!empty($rates['FEES_RATE_PCT'])) {
                    $return = bcmul($return, bcdiv($rates['FEES_RATE_PCT'], CLX_NUM_HUNDRED));
                } else {
                    $return = '0.00';
                }
            }
        } elseif (empty($done) && empty($rate)) { //End if $rate false and !done
            if (!empty($this->debug))
                echoLog('--Asset Fee Porcentage: ' . xFormat::number($return) . ' Porcentaje: ' . xFormat::number($record['ASSET_PERCENTAGE']));
            $return = bcmul($return, bcdiv($record['ASSET_PERCENTAGE'], '100.00'));
            if (!empty($this->debug))
                echoLog('--Asset Fee Porcentage result: ' . xFormat::number($return));
        }
        if (!empty($record['DIVIDER_FACTOR']) && $record['DIVIDER_FACTOR'] <> CLX_NUM_ZERO)
            $return = bcdiv($return, $record['DIVIDER_FACTOR']);
        if ($return <> CLX_NUM_ZERO)
            $charges[] = array('COMMISION_CHARGE_CODE' => $record['IDCODE'], 'TRANS_CHARGED_CODE' => '', 'AMT' => $return);
        if (!empty($this->debug))
            echoLog('-Asset Fees: ' . xFormat::number($return));
        return $return;
    }

// End method
    /**
     * Calculate base on capital formula. from FIAC.ASSET_COM_BASE. Options are:
     * 	1. Capital Solamente(CAP) = (CAPITAL DEL DIA)(731 EQ)
     * 	2. Capital + Rendimiento Cobrado(CAIN) =(CAPITAL DEL DIA)(731 EQ) +  (INTERESES DEL DIA(750 IN) - 714(Intereses devengados) -740(GASTOS EX))
     * 	3. Capital + Rendimientos Cobrados y No Cobrados(CARE) = ((CAPITAL DEL DIA)(731 EQ) +  (INTERESES DEL DIA(750 IN) -740(GASTOS EX)))
     * 	4. Patrimonio + Ingresos - Gastos del Dia anterior(CTID)  730 + 750 - 740 (D�a Anterior)
     */
    function fiasCapitalFormula($record) {
        //Buscar Cuentas Principales para formula
        //Por contracto con comision por administracion, compania Roll up de cuentas por compania
        //Por contrato generar transaccion de comision.
        if (!class_exists('gl'))
            includeCodeLib('TRANSPRO');
        if (!class_exists('gl_accounting_reports'))
            includeCodeLib('GLREP');
        //setting first date
        $edate = $record['NEXT_CHARGE_DATE']; //date('Y-m-d');
        $sdate = substr($record['NEXT_CHARGE_DATE'], CLX_NUM_ZERO, CLX_NUM_8) . '01'; //date('Y-m-01');
        $comp_code = ClxCommon::$db->getField($this->ficoname, 'COMP_CODE', 'IDCODE = ' . singleQuote($record['CONTRACT_CODE']));
        $comp_rec = ClxCommon::$db->getRecord($this->compname, 'IDCODE = ' . singleQuote($comp_code));
        $capital_code = $comp_rec['CAPITAL_ACCODE'];
        $earnedint_code = $comp_rec['EARNEDINT_CODE'];
        $equity_code = ClxCommon::$db->getField($this->glacname, 'IDCODE', 'COMP_CODE = ' . singleQuote($comp_code), 'EFFTSTAT=' . singleQuote('A') . '', 'GL_TYPE = ' . singleQuote('EQ') . '', '(ACPARENT = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' OR ACPARENT IS NULL)');
        $income_code = ClxCommon::$db->getField($this->glacname, 'IDCODE', 'COMP_CODE = ' . singleQuote($comp_code), 'EFFTSTAT=' . singleQuote('A') . '', 'GL_TYPE = ' . singleQuote('IN') . '', '(ACPARENT = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' OR ACPARENT IS NULL)');
        $expense_code = ClxCommon::$db->getField($this->glacname, 'IDCODE', 'COMP_CODE = ' . singleQuote($comp_code), 'EFFTSTAT=' . singleQuote('A') . '', 'GL_TYPE = ' . singleQuote('EX') . '', '(ACPARENT = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' OR ACPARENT IS NULL)');
        if (empty($capital_code))
            $capital_code = 'capital_code';
        if (empty($earnedint_code))
            $earnedint_code = 'earnedint_code';
        if (empty($equity_code))
            $equity_code = 'equity_code';
        if (empty($income_code))
            $income_code = 'income_code';
        if (empty($expense_code))
            $expense_code = 'expense_code';
        $a = new gl_accounting_reports();
        /* Se incluye este cambio por rollup_by_currency ya que se requiere poder seleccionar los montos a travez de una determinada moneda.
          este metodo incluye la sumatoria de creditos y debitos sin apoyarse en la tabla de saldos acumulados al mes e incluye el parametro de moneda */
        $rollup = $a->rollup_by_currency($comp_code, $sdate, $edate, $record['CONTRACT_CODE'], $record['PARTICIPANT_ID'], false, array('IN', 'EX', 'EQ'), $record['CURRENCY_CODE']);
        if (!empty($this->debug))
            echolog('Today: ' . $sdate . ' -> ' . $edate);
        //Verificar signos, conciderar todas absolutas?
        $rollup2 = array();
        $rollup2[$equity_code]['BALANCE'] = (array_key_exists($equity_code, $rollup)) ? $rollup[$equity_code]['BALANCE'] : '0'; //Patrimonio.
        $rollup2[$capital_code]['BALANCE'] = (array_key_exists($capital_code, $rollup)) ? $rollup[$capital_code]['BALANCE'] : '0';
        $rollup2[$income_code]['BALANCE'] = (array_key_exists($income_code, $rollup)) ? $rollup[$income_code]['BALANCE'] : '0'; //Ingreso
        $rollup2[$earnedint_code]['BALANCE'] = (array_key_exists($earnedint_code, $rollup)) ? $rollup[$earnedint_code]['BALANCE'] : '0';
        $rollup2[$expense_code]['BALANCE'] = (array_key_exists($expense_code, $rollup)) ? $rollup[$expense_code]['BALANCE'] : '0'; //Gasto
        //ABS just to fail so lets do it the old fassion way
        if ($rollup2[$equity_code]['BALANCE'] < CLX_NUM_ZERO)
            $rollup2[$equity_code]['BALANCE'] = bcmul('-1', $rollup2[$equity_code]['BALANCE']);
        if ($rollup2[$capital_code]['BALANCE'] < CLX_NUM_ZERO)
            $rollup2[$capital_code]['BALANCE'] = bcmul('-1', $rollup2[$capital_code]['BALANCE']);
        if ($rollup2[$income_code]['BALANCE'] < CLX_NUM_ZERO)
            $rollup2[$income_code]['BALANCE'] = bcmul('-1', $rollup2[$income_code]['BALANCE']);
        if ($rollup2[$earnedint_code]['BALANCE'] < CLX_NUM_ZERO)
            $rollup2[$earnedint_code]['BALANCE'] = bcmul('-1', $rollup2[$earnedint_code]['BALANCE']);
        if ($rollup2[$expense_code]['BALANCE'] < CLX_NUM_ZERO)
            $rollup2[$expense_code]['BALANCE'] = bcmul('-1', $rollup2[$expense_code]['BALANCE']);
        //e cho '<!-- ';
        //print_r($rollup2);
        //e cho '-->';
        switch ($record['ASSET_COM_BASE']) {
            case 'CAP':
                $amt = $rollup2[$capital_code]['BALANCE'];
                if (!empty($this->debug))
                    echoLog('-Valor de Capital: ' . $amt);
                break;
            case 'CAIN':
                $amt = bcadd($rollup2[$capital_code]['BALANCE'], bcsub(bcsub($rollup2[$income_code]['BALANCE'], $rollup2[$earnedint_code]['BALANCE']), $rollup2[$expense_code]['BALANCE']), CLX_NUM_TWO);
                break;
            case 'CARE':
                $amt = bcadd($rollup2[$capital_code]['BALANCE'], bcsub($rollup2[$income_code]['BALANCE'], $rollup2[$expense_code]['BALANCE']), CLX_NUM_TWO);
                break;
            case 'EIEP':
                //Patrimonio + Ingresos - Gastos del Dia anterior(CTID)  730 + 750 - 740 (D�a Anterior)
                $split_date = adodb_getdate(adodb_strtotime($edate));
                $yesterday_edate = adodb_date('Y-m-d', adodb_mktime(CLX_NUM_ZERO, CLX_NUM_ZERO, CLX_NUM_ZERO, $split_date['mon'], $split_date['mday'] - CLX_NUM_ONE, $split_date['year']));
                $yesterday_sdate = substr($yesterday_edate, CLX_NUM_ZERO, CLX_NUM_8) . '01';
                $rollup = $a->rollup_by_currency($comp_code, $yesterday_sdate, $yesterday_edate, $record['CONTRACT_CODE'], $record['PARTICIPANT_ID'], false, array('IN', 'EX', 'EQ'), $record['CURRENCY_CODE']);
                if (!empty($this->debug))
                    echolog('Yesterday: ' . $yesterday_sdate . ' -> ' . $yesterday_edate);
                $rollup3 = array();
                $rollup3[$expense_code]['BALANCE'] = (array_key_exists($expense_code, $rollup)) ? $rollup[$expense_code]['BALANCE'] : CLX_NUM_ZERO;
                if ($rollup2[$income_code]['BALANCE'] < CLX_NUM_ZERO)
                    $rollup2[$income_code]['BALANCE'] = bcmul('-1', $rollup2[$income_code]['BALANCE']);
                $amt = bcsub(bcadd($rollup2[$equity_code]['BALANCE'], $rollup2[$income_code]['BALANCE']), $rollup3[$expense_code]['BALANCE']);
                if (!empty($this->debug))
                    echoLog('-Patrimonio + Ingresos - Gastos del Dia anterior, Patrimonio: ' . xFormat::number($rollup2[$equity_code]['BALANCE']) . ' Ingreso: ' . xFormat::number($rollup2[$income_code]['BALANCE']) . ' Gasto:' . xFormat::number($rollup3[$expense_code]['BALANCE']) . ', Monto:' . xFormat::number($amt));
                break;
            default:
                $amt = '0';
                break;
        }
        unset($rollup2, $rollup3, $rollup);
        return $amt;
    }

    /**
     * Charge Contract
     * @param: float $amt Fee Amount
     * @param: array fiac record
     */
    function generateTransaction($amount, $feeRec, $charges, $pending = true, $participant_id = '', $efftdate = '') {
        if ($amount <> CLX_NUM_ZERO || count($charges) <> CLX_NUM_ZERO) {
            if (empty($feeRec['FIDU_BANKACT_CODE'])) {
                $fibkno = ClxCommon::$db->getOne('SELECT COMP.DEF_BANKACC_CODE FROM ' . $this->compname . ' COMP, ' . $this->ficoname . ' FICO WHERE COMP.IDCODE = FICO.COMP_CODE AND FICO.IDCODE = ' . singleQuote($feeRec['CONTRACT_CODE']));
            } else {
                $fibkno = $feeRec['FIDU_BANKACT_CODE'];
            }
            if (!class_exists('gl'))
                includeCodeLib('TRANSPRO');
            if (!empty($this->debug))
                echoLog('--Generating Transaction: ' . $feeRec['COMTRANS_CODE'] . ', Cash Account:' . $feeRec['ASSET_CODE']);
            $rec = array('EFFTDATE' => (($efftdate <> '') ? $efftdate : $feeRec['EFFTDATE']),
                'CONTRACT_CODE' => $feeRec['CONTRACT_CODE'],
                'IDNAME' => '',
                'TRANSTBL_CODE' => $feeRec['COMTRANS_CODE'],
                'PARTICIPANT_ID' => $participant_id,
                'FIDU_BANKACT_CODE' => $fibkno,
                'TRANS_AMT' => $amount,
                'CURRENCY_CODE' => $feeRec['CURRENCY_CODE']);
            //Creating Contract Transaction
            $a = new fidu_transaction();
            $trans = $a->fiacTransaction($rec, $charges, $pending);
            if (!empty($this->debug))
                echoLog('--Generated Transaction : ' . $trans);
        }
    }

    /**
     * Charge Contract by accumulating amount, for latter payment process.
     * @param: float $amt Fee Amount
     * @param: array fiac record
     */
    function accumulateCommission($amount, $feeRec, $charges) {
        if (!class_exists('gl'))
            includeCodeLib('TRANSPRO');
        if (!empty($this->debug))
            echoLog('--Generating Transaction: ' . $feeRec['COMTRANS_CODE']);
        $comprec = ClxCommon::$db->getRecord($this->ficoname, 'IDCODE = ' . singleQuote($feeRec['CONTRACT_CODE']));
        if (empty($comprec['IDCODE']))
            return false;
        $d = (empty($feeRec['NEXT_CHARGE_DATE'])) ? xFormat::getNow('Y-m-d') : $feeRec['NEXT_CHARGE_DATE'];
        if ($amount <> CLX_NUM_ZERO) {
            //Generate Accounting
            $rec = array('COMP_CODE' => ClxCommon::$db->getField($this->ficoname, 'COMP_CODE', 'IDCODE = ' . singleQuote($feeRec['CONTRACT_CODE'])),
                'CONTRACT_CODE' => $feeRec['CONTRACT_CODE'],
                'PARTICIPANT_ID' => $feeRec['PARTICIPANT_ID'],
                'CURRENCY_CODE' => $feeRec['CURRENCY_CODE'],
                'TRANS_AMT' => $amount,
                'EFFTDATE' => $d,
                'CREATEDBY' => 'system',
                'CDATE' => $d,
                'MODIFIEDBY' => 'system',
                'MDATE' => $d,
                'IDNAME' => $feeRec['IDNAME'],
                'TRANSTBL_CODE' => '');
            //Creating Accounting
            $gl = new gl();
            $jehd_code = $gl->create_jehd($rec);
            //Creating Lines
            $dr_acc = ClxCommon::$db->getField($this->ietbname, 'GLACCOUNTCODE', 'IDCODE =' . singleQuote($feeRec['EXP_ITEM_CODE']));
            $gl->create_jeln_by_glcode($feeRec['CONTRACT_CODE'], $feeRec['PARTICIPANT_ID'], $jehd_code, $dr_acc, 'DR', $feeRec['CURRENCY_CODE'], $amount, CLX_NUM_ONE, '', $d, $feeRec['IDNAME']);
            $cr_acc = ClxCommon::$db->getField($this->ietbname, 'GLACCOUNTCODE', 'IDCODE =' . singleQuote($feeRec['AP_ITEM_CODE']));
            $gl->create_jeln_by_glcode($feeRec['CONTRACT_CODE'], $feeRec['PARTICIPANT_ID'], $jehd_code, $cr_acc, 'CR', $feeRec['CURRENCY_CODE'], $amount, CLX_NUM_TWO, '', $d, $feeRec['IDNAME'], '', $feeRec['IDCODE']);
            $gl->balance_jehd($jehd_code);
            unset($rec);
        }
    }

    function disbursement_formula(&$record) {
        $update_trans_amt = false;
        //2. Select right firt
        $sql = 'SELECT FIRT.IDCODE, FIRT.MINIMUM_FEE, FIRT.MAXIMUM_FEE, FIRT.DISBURSEMENT_TYPE, FIRT.DISBURSEMENT_PCT, FIRT.DISBURSEMENT_FEE, FIRT.DISBRSMNT_BASE, FIRT.DISBURSEMENT_ITEM, FIRT.DEBIT_CREDIT, FIAT.TRANS_AMT FROM ' . $this->firtname . ' FIRT, ' . $this->fiatname . ' FIAT, ' . $this->ficoname . ' FICO, ' . $this->fibtname . ' FIBT WHERE FICO.HAS_CHECK_FEE = 1 AND FIAT.CONTRACT_CODE = FICO.IDCODE AND FIAT.CURRENCY_CODE = FIRT.CURRENCY_CODE AND FIRT.DISBURSEMENT_TYPE = FIBT.DISBURSEMENT_TYPE AND FIBT.TRANS_CODE = FIAT.IDCODE AND FIAT.IDCODE = ' . singleQuote($record['TRANS_CODE']) . ' AND FIRT.DISBURSEMENT_TYPE = ' . singleQuote('CH') . ' AND (FIRT.DISBURSEMENT_PCT<>0 OR FIRT.DISBURSEMENT_FEE<>0) AND FIRT.DEBIT_CREDIT IN (' . singleQuote('DR') . ',' . singleQuote('CR') . ') AND FICO.COMP_CODE = FIRT.COMP_CODE AND FIRT.STATUS = ' . singleQuote('A') . ' AND FIRT.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->firtname . ' X WHERE X.IDCODE = FIRT.IDCODE AND X.CLX_EFFTDATE <= FIAT.EFFTDATE)';
        //If result then make the lines
        $results = ClxCommon::$db->executeQuery($sql);
        if (ClxCommon::$db->numRows($results) === CLX_NUM_ZERO) {
            ClxCommon::$db->deleteRecords($this->fitlname, 'TRANS_CODE = ' . singleQuote($record['TRANS_CODE']) . ' AND FIDU_RATETBLCODE <>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND FIDU_RATETBLCODE IS NOT null');
        }
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $update_trans_amt = true;
            $line = array('TRANS_CODE' => $record['TRANS_CODE'],
                'SEQNUM' => ClxCommon::$db->getField($this->fitlname, 'MAX(SEQNUM)+1', 'TRANS_CODE = ' . singleQuote($record['TRANS_CODE'])),
                'LINE_AMT' => '0',
                'INCEXP_CODE' => $result['DISBURSEMENT_ITEM'],
                'MEMO' => '',
                'DEBIT_CREDIT' => $result['DEBIT_CREDIT'],
                'SKIPFROMTRANS_AMT' => '0',
                'CASH_EFFECT' => CLX_NUM_ONE,
                'FIDU_RATETBLCODE' => $result['IDCODE'],
                'RECONCILIED' => CLX_NUM_ZERO);
            switch ($result['DEBIT_CREDIT']) {
                case 'DR':
                    $line['CASH_EFFECT'] = CLX_NUM_ONE;
                    break;
                case 'CR':
                    $line['CASH_EFFECT'] = -CLX_NUM_ONE;
                    break;
                default:
                    $line['CASH_EFFECT'] = CLX_INIT_ZERO;
                    break;
            }
            //Determine amount
            if ($result['DISBURSEMENT_PCT'] <> CLX_NUM_ZERO) {
                $qty = ClxCommon::$db->getOne('SELECT SUM(TRANS_AMT) FROM ' . $this->fibtname . ' WHERE TRANS_CODE = ' . singleQuote($record['TRANS_CODE']) . ' AND DISBURSEMENT_TYPE = ' . singleQuote($result['DISBURSEMENT_TYPE']) . ' GROUP BY TRANS_CODE');
                $amount = bcmul($qty, bcdiv($result['DISBURSEMENT_PCT'], CLX_NUM_HUNDRED));
            } else {
                if ($result['DISBRSMNT_BASE'] == CLX_NUM_ZERO) {
                    $qty = ClxCommon::$db->countRecords($this->fibtname, 'TRANS_CODE = ' . singleQuote($record['TRANS_CODE']) . ' AND DISBURSEMENT_TYPE = ' . singleQuote($result['DISBURSEMENT_TYPE']));
                } else {
                    $qty = '1';
                }
                $amount = bcmul($qty, $result['DISBURSEMENT_FEE']);
            }
            //Minimum amount
            if ($amount <= $result['MINIMUM_FEE'] && ($result['MINIMUM_FEE'] <> CLX_NUM_ZERO || $result['MAXIMUM_FEE'] <> CLX_NUM_ZERO)) {
                $amount = $result['MINIMUM_FEE'];
            }
            //Maximum amount
            if ($amount >= $result['MAXIMUM_FEE'] && ($result['MINIMUM_FEE'] <> CLX_NUM_ZERO || $result['MAXIMUM_FEE'] <> CLX_NUM_ZERO)) {
                $amount = $result['MAXIMUM_FEE'];
            }
            //Exchange Rate
            $line['LINE_AMT'] = $amount;
            unset($amount);
            $count = ClxCommon::$db->oneExistsRecords($this->fitlname, 'FIDU_RATETBLCODE=' . singleQuote($result['IDCODE']) . ' AND TRANS_CODE = ' . singleQuote($record['TRANS_CODE']));
            if ($count == CLX_NUM_ZERO) {
                ClxCommon::$db->createRecord($this->fitlname, $line, false);
            } else {
                ClxCommon::$db->updateRecord($this->fitlname, $line, 'FIDU_RATETBLCODE=' . singleQuote($result['IDCODE']) . ' AND TRANS_CODE = ' . singleQuote($record['TRANS_CODE']));
            }
        }
		ClxCommon::$db->freeResult($results);
        //updating transaction amount
        if ($update_trans_amt === true) {
            $sql = 'UPDATE ' . $this->fiatname . ' FIAT SET FIAT.LINE_AMT = IFNULL((SELECT SUM(X.LINE_AMT*X.CASH_EFFECT)LINE_AMT FROM ' . $this->fitlname . ' X WHERE X.TRANS_CODE = FIAT.IDCODE AND X.CASH_EFFECT <> 0),0), FIAT.MDATE = ' . singleQuote(xFormat::getnow()) . ', FIAT.MODIFIEDBY=' . singleQuote($_SESSION['user_record']['username']) . ' WHERE FIAT.IDCODE =' . singleQuote($record['TRANS_CODE']);
            ClxCommon::$db->executeQuery($sql);
        }
        unset($line, $results, $result, $amount, $count, $update_trans_amt);
    }

    function initFiacForm(&$record) {
        if ((UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE') && empty(UserRequest::$request['confirm'])) {
            $record['FIAC_EFFTDATE'] = adodb_next_day(ClxCommon::$db->getOne('SELECT COMP.ACCOUNTING_DATE FROM ' . $this->compname . ' COMP'));
        }
        if (UserRequest::$request['ac'] === 'DUPLICATE' && empty(UserRequest::$request['confirm'])) {
            $record['FIAC_IDCODE'] = 'AUTO';
        }
    }

    function initFirtForm(&$record) {
        if ((UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE') && empty(UserRequest::$request['confirm'])) {
            $record['FIRT_CLX_EFFTDATE'] = adodb_next_day(ClxCommon::$db->getOne('SELECT COMP.ACCOUNTING_DATE FROM ' . $this->compname . ' COMP'));
        }
        if (UserRequest::$request['ac'] === 'DUPLICATE' && empty(UserRequest::$request['confirm'])) {
            $record['FIRT_IDCODE'] = 'AUTO';
        }
    }

}
