<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
if (!class_exists('fidu_investments')) {

    /**
     * Fidu Investment
     * Fidu Investments Module Class.
     * @package 		INVE_utilities
     * @copyright	Alenet, Inc.
     * @version		1.0.0
     * @since
     * @author		Alenet, Inc <support@alenet.com>
     */
    class fidu_investments {

        /**
         * Constructor
         */
        function __construct() {

        }

        /**
         * Retrive Market Price for Product
         */
        function marketPrice($inpr_code) {
		  $efftdate = efftDate('STOC', 'IDCODE =' . singleQuote($inpr_code));
		  $efftdate = (strlen($efftdate) > CLX_NUM_ZERO) ? ' AND ' . $efftdate : '';
		  $return = ClxCommon::$db->getField($this->stocname, 'PRICE', 'IDCODE =' . singleQuote($inpr_code) . ' ' . $efftdate);
		  if ($return === '')
			 $return = CLX_INIT_ZERO;
		  return $return;
        }

        /**
         * Updates Market Price for security product
         */
        function getMarketPrice($id = '') {
		  $idlist = getIdlist();
		  if ($id === '') {
			 $ids = (is_array($idlist)) ? implode(',', $idlist) : $idlist;
		  } else {
			 $ids = $id;
		  }
		  $results = ClxCommon::$db->getRecords($this->infaname, 'ID IN (' . $ids . ')');
		  while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
			 $price = $this->marketPrice($result['IDCODE']);
			 if (!empty($price)) {
			     ClxCommon::$db->executeQuery('UPDATE ' . $this->infaname . ' SET MARKET_PRICE = ' . singleQuote($price) . ', MARKET_VALUE = SHARES*' . $price . ' WHERE ID = ' . $result['ID']);
			 }
		  }
		  ClxCommon::$db->freeResult($results);
        }

        /**
         * Set Cancelation Amount Automaticaly = to total invested.
         * Used on inat form to complete amount of investments
         * @return void
         * @param array Investment activity record
         */
        function cancelationAmount($record) {
		  //On Cancelation set Cancelation Amount = to invested amount for fix price
		  if ($record['INVEST_ACTIVITY'] === 'CA' && strlen($record['INVESTMENT_CODE']) > CLX_NUM_ZERO && $record['INVEST_AMT'] == CLX_NUM_ZERO) {
			 $inffrec = ClxCommon::$db->getRecord($this->infaname, 'IDCODE = ' . singleQuote($record['INVESTMENT_CODE']) . ' AND PORTFOLIO_CODE = ' . singleQuote($record['PORTFOLIO_CODE']));
			 ClxCommon::$db->executeQuery('UPDATE ' . $this->inatname . ' SET FACE_VALUE = ' . singleQuote($inffrec['FACE_VALUE']) . ', INVEST_AMT = ' . singleQuote($inffrec['INVEST_AMT']) . ', SELL_PRICE = ' . singleQuote($bcmul(bcdiv($inffrec['INVEST_AMT'], $inffrec['FACE_VALUE']), CLX_NUM_HUNDRED)) . ', UNIT_PRICE = 0, SHARES = 0 WHERE IDCODE = ' . singleQuote($record['IDCODE']));
		  }
        }

    }

}