<?php

/**
 * LA Sistemas Module Reports
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-08 15:32:52 -0400 (Thu, 08 Oct 2015) $
 * @version    	$Rev: 7191 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class lain_reports {

    var $err_msg = array();
    var $contents = '';
    var $run_id = CLX_INIT_ZERO; //Run id
    var $rif = '';
    var $testrif = ''; //V0000008620962';
    var $fromdate;
    var $todate;
    var $id_type = 'CIV';
    var $date_format = 'd/m/y';
    var $serv_date_format = 'd/m/y';
    var $n_executeClient_time_limit;

    /**
     * Constructor
     * @param void
     * @return void
     */
    function __construct() {
        multiTableName($this, array('INPO', 'INCO', 'ACCO', 'INTX', 'INOF'));
        $this->rif = $this->getRif();
        //Setting dates
        $this->fromdate = ''; //date('Y-m-d', strtotime(''));
        $this->todate = ''; //date('Y-m-d');
        $this->n_executeClient_time_limit = CLX_NUM_24 * CLX_NUM_60 * CLX_NUM_60;
    }

    /**
     * Run Report according to code provided
     *
     * @param string $report_code
     * @return string $contents
     */
    function run($report_code) {
        $formcode = 'ACCO_LAIN_SCHR';
        $formcode = 'LAIN_RIF_SCHR';
        if (CLX_NUM_ONE == CLX_NUM_TWO && !empty(UserRequest::$request['confirm']) && !empty(UserRequest::$request['ACCO_IDENTIFICATION'])) {
		  $this->rif = UserRequest::$request['ACCO_IDENTIFICATION'];
		  $this->setRif($this->rif);
		  //Getting Information
		  $request = 'to=' . UserRequest::$request[CLX_PROP_TO] . '&ac=' . UserRequest::$request['ac'] . '&it=' . UserRequest::$request['it'] . '&r=' . UserRequest::$request['ACCO_IDENTIFICATION'] . '&f=' . UserRequest::$request['ACCO_START_ACTIVITY_DATE'] . '&t=' . UserRequest::$request['ACCO_LAST_ACTIVITY_DATE'];
		  $this->contents .= ajaxRequest($request, 'divajax', 'sqsWait', dict('CODE_LAIN_WAITINGFORLA'));
        } else {
		  if (isset(UserRequest::$request['ACCO_IDENTIFICATION'])) {
			 $this->rif = UserRequest::$request['ACCO_IDENTIFICATION'];
			 $this->setRif($this->rif);
		  }
		  //comentado por no tener servicio con la
		  if (CLX_NUM_ONE == CLX_NUM_TWO && !empty(UserRequest::$request['r'])) {
			 $this->connectToLa(UserRequest::$get['r'], UserRequest::$get['f'], UserRequest::$get['t']);
		  }
		  switch ($report_code) {
			 case 'LAIN01':
			     ClxFreeReturn($this->prompt($formcode));
			     ClxFreeReturn($this->consolidated());
			     break;
			 case 'LAIN02':
			     ClxFreeReturn($this->prompt($formcode));
			     ClxFreeReturn($this->composition());
			     break;
			 case 'LAIN03':
			     ClxFreeReturn($this->prompt($formcode));
			     ClxFreeReturn($this->transactions());
			     break;
			 default:
			     $this->frame(dict('GEN_MSG_RECORD_NOTFOUND', $report_code), $this->contents, false);
			     break;
		  }//end swt
        }

        return $this->source();
    }

    function setRif($rif) {
        $_SESSION['others']['lain_rif'] = $rif;
    }

    function getRif() {
        if (empty($_SESSION['others']['lain_rif']))
		  $this->setRif($this->testrif);
        return $_SESSION['others']['lain_rif'];
    }

    /**
     * Returns contents to be set as part of html
     *
     * @return string $contents
     */
    function source() {
        return $this->contents;
    }

    /**
     * Adds contents to a holder table to present report
     *
     * @param string $title
     * @param bool $print_btn
     * @return void
     */
    private function frame($title, $contents, $print_btn = true) {
        $table = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_ALIGN => 'center'));
        if (empty(UserRequest::$get['np']) && $print_btn) {
		  $url = 'pop.php?to=EDIT&ac=CODE&it=' . UserRequest::$request['it'] . '&np=1';
		  $b = new htmlButton(dict('GEN_LBL_PRINT'));
		  $b->setProp('onclick', 'javascript:openWindow(' . singleQuote('print') . ',' . singleQuote($url) . ', 700, 600);');
            $table->addCell('<!--'. __FILE__ .'_'. __LINE__ .'-->'.$b->source(), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
        }
        //Spacer
        $table->addCell(CLX_CHAR_HTML_NBSP);
        //Conteniner
        $table2 = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_WIDTH => '98%', CLX_PROP_ALIGN => 'center'));
        $user = $_SESSION['user_record']['firstname'] .
			 ' ' . $_SESSION['user_record']['lastname'];
        //Setting Date
        $wday = dict('GEN_LBL_' . uppercase(date('l')));
        $mname = dict('GEN_LBL_' . uppercase(date('F')));
        $date = capitalize($wday . ', ' . date('d') . ' ' . $mname . ' ' . date('Y'));
        //$client = ucwords(lowercase(dict('CODE_LAIN_CLIENTNAME') . ': '.ClxCommon::$db->getField($this->acconame, 'IDNAME', 'IDENTIFICATION = '. singleQuote($this->rif) )));
        $client = dict('CODE_LAIN_CLIENTNAME') . ': ' . ClxCommon::$db->getField($this->acconame, 'IDNAME', 'IDENTIFICATION = ' . singleQuote($this->rif));
        if (empty(UserRequest::$get['np'])) {//excluyendo forma para impresion
		  $table2->addCell('<b><font size=2>' . dict('GEN_LBL_WELCOME') . ': ' . $user . '</font></b>', array(CLX_PROP_WIDTH => '50%'));
        }
        $table2->addCell('<b><font size=2>' . $title . '<bR>' . $date . '<br>' . $client . '</font></b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
        $table2->addCell(CLX_CHAR_HTML_NBSP, CLX_PROP_COLSPAN, CLX_NUM_TWO);
        $table2->addCell($contents, array(CLX_PROP_COLSPAN => CLX_NUM_TWO));
        $div = new htmlObject('div');
        $div->setProp(CLX_PROP_ID, 'div_to_print');
        $div->addContents($table2->source());
        $table->addCell($div->source());
        //Spacer
        $table->addCell(CLX_CHAR_HTML_NBSP);
        $this->contents .= $table->source();
    }

    private function prompt($formcode) {//Pres Import Form
        $ac = UserRequest::$request['ac'];
        $to = UserRequest::$request[CLX_PROP_TO];
        $it = UserRequest::$request['it'];
        $this->file_fields = array();
        //RTBL_REPCINV
        $EDIT = &getTool('EDIT');
        $record = array();
        $msg = array();
        $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote($formcode));
        if (empty(UserRequest::$post)) {
		  $record['ACCO_IDENTIFICATION'] = $this->rif;
		  $record['ACCO_ID_TYPE'] = $this->id_type;
		  $record['ACCO_START_ACTIVITY_DATE'] = $this->fromdate;
		  $record['ACCO_LAST_ACTIVITY_DATE'] = $this->todate;
        } else {
		  $record = UserRequest::$post;
        }
        UserRequest::$post['RTBL_ID'] = ''; //Entrada en blanco para evitar warning en object file.
        //Prepare Valiues
        if (!empty($record['confirm']) && empty($record['ACCO_IDENTIFICATION'])) {
		  $msg['ACCO_IDENTIFICATION'] = dict('GEN_LBL_REQUIRED');
        }
        if (empty(UserRequest::$get['np'])) {//excluyendo forma para impresion
		  //print_r($record);
		  $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', CLX_CLASS_FORM, '', dict('GEN_LBL_SEARCH'));
		  $this->contents .= '<br>' . $form->source() . '<br>';
        }
        return (empty($record['confirm']) || !empty($msg)) ? false : true;
    }

    /**
     * Used to format numbers
     *
     * @param decimal $val
     * @param int $decimals
     * @param string $dec_point
     * @param string $thousands_sep
     * @return string $val
     */
    function numberFormat($val, $decimals = CLX_NUM_TWO, $dec_point = '.', $thousands_sep = ',') {
        if ($val < CLX_NUM_ZERO) {
		  $val = '<font color=red>(' . str_replace('-', '', clx_format_currency($val, $decimals, $dec_point, $thousands_sep)) . ')</font>';
        } else {
		  $val = clx_format_currency($val, $decimals, $dec_point, $thousands_sep);
        }
        return $val;
    }

    //ACTUALIZACION DE SERVICIOS
    function prompt_rif($formcode = 'LAIN_RIF_SCHR', $showmenu = true) {
        if (!empty(UserRequest::$post['confirm']) && !empty(UserRequest::$request['ACCO_IDENTIFICATION'])) {
		  $request = 'to=' . UserRequest::$request[CLX_PROP_TO] . '&ac=' . UserRequest::$request['ac'] . '&it=' . UserRequest::$request['it'] . '&r=' . UserRequest::$request['ACCO_IDENTIFICATION'] . '&f=' . UserRequest::$request['ACCO_START_ACTIVITY_DATE'] . '&t=' . UserRequest::$request['ACCO_LAST_ACTIVITY_DATE'];
		  $this->contents .= ajaxRequest($request, 'divajax', 'sqsWait', dict('CODE_LAIN_WAITINGFORLA'));
		  /*
		    [ACCO_IDENTIFICATION] => J0000312072555
		    [ACCO_START_ACTIVITY_DATE] =>
		    [ACCO_LAST_ACTIVITY_DATE] =>
		   */
        } elseif (!empty(UserRequest::$get['r'])) {
		  $this->setRif(UserRequest::$get['r']);
		  //comentado por no tener servicio con la
		  if (CLX_NUM_ONE == CLX_NUM_TWO)
			 $this->connectToLa(UserRequest::$get['r'], UserRequest::$get['f'], UserRequest::$get['t']);
		  $table = new htmlTable(CLX_WIDTH_ONE);
		  $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_ALIGN => 'center'));
		  $note = dict('CODE_LAIN_UPDATECOMPLETED');
		  if ($showmenu === true) {
			 $username = $_SESSION['user_record']['username'];
			 $ACTO = &getTool('ACTO');
			 $groups = $ACTO->userGroups($username);
			 if (count($groups) > CLX_NUM_ZERO) {
			     $groups = toString($groups);
			     $sq = '((AC.OWNERCODE=' . singleQuote('USER') . ' AND UPPER(AC.OWNERREF)=' . singleQuote(uppercase($username)) . ') OR (AC.OWNERCODE=' . singleQuote('GRUP') . ' AND AC.OWNERREF IN (' . $groups . ')))';
			 } else {
			     $sq = '(AC.OWNERCODE=' . singleQuote('USER') . ' AND UPPER(AC.OWNERREF)=' . singleQuote(uppercase($username)) . ')';
			 }
			 if (!empty($_SESSION['user_record']['isadmin'])) {
			     $sql = 'SELECT * FROM CLX_UI_MENUITEMS WHERE ACTIVE = 1 AND TYPE <> ' . singleQuote('MENU') . ' AND PARENT = ' . singleQuote('INBK_MNU') . ' ORDER BY SEQNUM';
			 } else {
			     $sql = 'SELECT DISTINCT UI.* FROM CLX_AC_MENUITEMS AC, CLX_UI_MENUITEMS UI WHERE UI.ACTIVE = 1 AND AC.MENUID = UI.IDCODE AND AC.CANREAD=1 AND UI.TYPE <> ' . singleQuote('MENU') . ' AND UI.PARENT = ' . singleQuote('INBK_MNU') . ' AND ' . $sq . ' ORDER BY UI.SEQNUM';
			 }
			 $menus = ClxCommon::$db->executeQuery($sql);
			 $note .= '<ul>';
			 while ($menu = ClxCommon::$db->getNextRecord($menus)) {
			     $menuobj = getToolObject('UIMI', $menu['type']);
			     $url = $menuobj->makeURL($menu);
			     $note .='<li><a href="' . $url . '">' . dict($menu['NAME']) . '</a></li>';
			 }
			 ClxCommon::$db->freeResult($menus);
			 $note .= '</ul>';
		  }//end if menus
		  $this->contents .=string_encode(dialog(dict('GEN_LBL_NOTE'), CLX_CLASS_FORM, $note, ''));
        } else {
		  if (empty(UserRequest::$post['ACCO_START_ACTIVITY_DATE'])) {
			 UserRequest::$post['ACCO_IDENTIFICATION'] = $this->rif;
			 UserRequest::$post['ACCO_START_ACTIVITY_DATE'] = $this->fromdate;
			 UserRequest::$post['ACCO_LAST_ACTIVITY_DATE'] = $this->todate;
		  }
		  ClxFreeReturn($this->prompt($formcode));
        }
        return $this->source();
    }

    function connectToLa($rif, $fromdate, $todate) {
        //Cliente LA_CLIENTE
        $parameters = array('status' => CLX_NUM_ZERO,
		  'mensaje' => '',
		  'rif' => $rif,
		  'cadxml' => '');
       ClxFreeReturn( getService('LA_CLIENTE', $parameters));
        //Consolidado LA_CONS
        $parameters = array('status' => CLX_NUM_ZERO,
		  'mensaje' => '',
		  'rifi' => $rif,
		  'cadxml' => '');
        ClxFreeReturn( getService('LA_CONS', $parameters));
        //Posicion LA_CON_POS
        $parameters = array('status' => CLX_NUM_ZERO,
		  'mensaje' => '',
		  'rif' => $rif,
		  'cadxml' => '');
        ClxFreeReturn(getService('LA_CON_POS', $parameters));
        //Transacciones LA_TRANS_LIST
        $parameters = array('status' => CLX_NUM_ZERO,
		  'mensaje' => '',
		  'desde' => $fromdate,
		  'hasta' => $todate,
		  'rif' => $rif,
		  'cadxml' => '');
        ClxFreeReturn(getService('LA_TRANS_LIST', $parameters));
        
    }

    static function getPizarra() {
        //e cho 'Getting pizarra<br>';
        $parameters = array('status' => CLX_NUM_ZERO,
		  'mensaje' => '',
		  'asesor' => 'V999',
		  'cadxml' => '');
        $sql = 'TRUNCATE TABLE ' . tableName('INOF');
        ClxCommon::$db->executeQuery($sql);
        getService('LA_PANTALLA', $parameters);
    }

    //CONSOLIDADO DE CUENTAS - LAIN01
    /**
     * Builds the current report
     * @param void
     * @return void
     */
    private function consolidated() {
        $contents = '';
        if (empty($this->rif)) {
		  $this->contents .=note(dict('GEN_LBL_PLEASESEARCH'));
		  return CLX_CHAR_EMPTY_STRING;
        }
        $DBLT = &getTool('DBLT');
        $sql = 'SELECT DISTINCT CURRENCY_CODE, EXCHANGE_RT FROM INBK_INVEST_CONSOLIDATED WHERE IDENTIFICATION = ' . singleQuote($this->rif) . ' ORDER BY CURRENCY_CODE DESC';
        $results = ClxCommon::$db->executeQuery($sql);
        $currencies = array();
        $sql_extra = '';
        while ($result = ClxCommon::$db->getNextRecord($results, NUMERIC)) {
		  $result[CLX_NUM_TWO] = $DBLT->getListItem('curr', $result[CLX_NUM_ZERO]);
		  $currencies[$result[CLX_NUM_ZERO] . '_BALANCE_AMT'] = $result;
		  $sql_extra .= '(SELECT SUM(Y.BALANCE_AMT) FROM ' . $this->inconame . ' Y WHERE Y.IDENTIFICATION = X.IDENTIFICATION AND Y.GL_TYPE = X.GL_TYPE AND Y.CURRENCY_CODE = ' . singleQuote($result[CLX_NUM_ZERO]) . ') ' . $result[CLX_NUM_ZERO] . '_BALANCE_AMT,';
        }
		ClxCommon::$db->freeResult($results);
        //Seccion de consolidado
        $sql = 'SELECT
		  	case X.GL_TYPE WHEN ' . singleQuote('LI') . ' THEN ' . singleQuote('CODE_LAIN_GLTYPE_LI') . '
		  	    WHEN ' . singleQuote('AS') . ' THEN ' . singleQuote('CODE_LAIN_GLTYPE_AS') . '
		  	    ELSE ' . singleQuote('CODE_LAIN_GLTYPE_KNOWN') . '
		  	END GL_TYPE,
		  	' . $sql_extra . '
		  	SUM(X.BASE_BAL_AMT) BASE_BAL_AMT
		  FROM ' . $this->inconame . ' X WHERE X.IDENTIFICATION = ' . singleQuote($this->rif) . ' GROUP BY X.GL_TYPE UNION ALL SELECT ' . singleQuote('GEN_LBL_CONSOLIDATED') . ' GLTYPE, ' . str_replace('AND Y.GL_TYPE = X.GL_TYPE', '', $sql_extra) . ' SUM(X.BASE_BAL_AMT) BASE_BAL_AMT FROM ' . $this->inconame . ' X WHERE X.IDENTIFICATION = ' . singleQuote($this->rif) . ' GROUP BY X.IDENTIFICATION';
        /* 1.Resumen de cuenta
         * 2.total por moneda
         * 3. consolidado
         */
        $i = CLX_INIT_ZERO;
        $tableWitdh = count($currencies) + CLX_NUM_TWO;
        $table = new htmlTable($tableWitdh);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_ALIGN => 'center'));
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
		  $class = ($i % CLX_NUM_TWO == CLX_NUM_ONE) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT;
		  $style = 'text-align: right;';
		  if ($i == CLX_NUM_ZERO) {
			ClxFreeReturn(  ClxCommon::$db->numRows($results));
			 //Headers
			 foreach ($result as $key => $val) {
			     if (array_key_exists($key, $currencies))
			         $table->addCell($currencies[$key][CLX_NUM_TWO], array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
			     else
			         $table->addCell(dict('CODE_LAIN' . $key), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
			 }
		  }
		  foreach ($result as $key => $val) {
			 if ($key === 'GL_TYPE') {
			     $table->addCell(dict($val), array(CLX_PROP_CLASS => $class));
			 } else {
			     $val = $this->numberFormat($val);
			     $table->addCell($val, array(CLX_PROP_CLASS => $class, 'style' => $style));
			 }
		  }
		  $i++;
        }
		ClxCommon::$db->freeResult($results);
        $contents .=$table->source();
        $contents .='<br>';
        //Adding exchange Information
        foreach ($currencies as $key => $val) {
		  if ($val[CLX_NUM_ONE] == CLX_NUM_ONE)
			 continue;
		  $tableWitdh = CLX_NUM_THREE;
		  $class = CLX_CLASS_DATA;
		  $table = new htmlTable($tableWitdh);
		  $table->addCell(dict('GEN_LBL_EXCHANGE_RATE')
			     . ': ' . $val[CLX_NUM_TWO], array(CLX_PROP_CLASS => $class));
		  $table->addCell(CLX_CHAR_HTML_NBSP, CLX_PROP_CLASS, $class, CLX_PROP_WIDTH, CLX_NUM_HUNDRED, 'style', $style);
		  $table->addCell(clx_format_currency($val[CLX_NUM_ONE]), array(CLX_PROP_CLASS => $class, CLX_PROP_WIDTH => CLX_NUM_HUNDRED, 'style' => $style));
		  $table->addCell(dict('CODE_LAIN_INDREQMINMAN')/* Indice de requerimiento minimo de mantenimiento?' */, array(CLX_PROP_CLASS => $class));
		  $table->addCell('0.00%', array(CLX_PROP_CLASS => $class, CLX_PROP_WIDTH => CLX_NUM_HUNDRED, 'style' => $style));
		  $table->addCell('0.00', array(CLX_PROP_CLASS => $class, CLX_PROP_WIDTH => CLX_NUM_HUNDRED, 'style' => $style));
		  $table->addCell(dict('CODE_LAIN_INDREQMINMANACT')
			     , array(CLX_PROP_CLASS => $class));
		  $table->addCell('0.00%', array(CLX_PROP_CLASS => $class, CLX_PROP_WIDTH => CLX_NUM_HUNDRED, 'style' => $style));
		  $table->addCell('0.00', array(CLX_PROP_CLASS => $class, CLX_PROP_WIDTH => CLX_NUM_HUNDRED, 'style' => $style));
		  $contents .=$table->source();
		  $contents .='<br>';
        }
        //DETALLE POR MONEDA
        $tableWitdh = CLX_NUM_TWO;
        $table = new htmlTable($tableWitdh);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        foreach ($currencies as $key => $val) {
		  $class = CLX_CLASS_DATA;
		  $table2 = new htmlTable(CLX_NUM_THREE);
		  $table2->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => '98%', 'border' => CLX_NUM_ZERO));
		  $table2->addCell('<PLOT>', array(CLX_PROP_COLSPAN => CLX_NUM_THREE, CLX_PROP_ALIGN => 'center'));
		  $table2->addCell('<font size=2>' . dict('CODE_LAIN_PORTIN') . ' ' . $val[CLX_NUM_TWO] . '</font>', array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_NUM_THREE, 'style' => 'text-align: center);'));
		  $table2->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
		  $table2->addCell('%', array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
		  $table2->addCell(dict('GEN_LBL_AMOUNT'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
		  $data = array();
		  //Margin total
		  $sql = 'SELECT  ' . singleQuote('GEN_LBL_TOTAL') . ' LA_PRODUCTO, 10000 PARTICIPATION_PCT, -1*SUM(X.FINAL_CASH_AMT) BALANCE_AMT FROM ' . $this->inponame . ' X WHERE X.IDENTIFICATION = ' . singleQuote($this->rif) . ' AND X.CURRENCY_CODE = ' . singleQuote($val[CLX_NUM_ZERO]) . ' AND X.GL_TYPE = ' . singleQuote('LI') . '';
		  $margin = ClxCommon::$db->getOneRecord($sql);
		  $sql = 'SELECT  ' . singleQuote('GEN_LBL_TOTAL') . ' LA_PRODUCTO, 10000 PARTICIPATION_PCT, SUM(X.FINAL_CASH_AMT) BALANCE_AMT FROM ' . $this->inponame . ' X WHERE X.IDENTIFICATION = ' . singleQuote($this->rif) . ' AND X.CURRENCY_CODE = ' . singleQuote($val[CLX_NUM_ZERO]) . ' AND X.GL_TYPE = ' . singleQuote('AS') . ' UNION ALL SELECT  X.LA_PRODUCTO LA_PRODUCTO, IFNULL(ROUND((SUM(X.PARTICIPATION_PCT/100)*100), 4),0) PARTICIPATION_PCT, SUM(X.FINAL_CASH_AMT) BALANCE_AMT FROM ' . $this->inponame . ' X WHERE X.IDENTIFICATION = ' . singleQuote($this->rif) . ' AND X.CURRENCY_CODE = ' . singleQuote($val[CLX_NUM_ZERO]) . ' AND X.GL_TYPE = ' . singleQuote('AS') . ' GROUP BY X.LA_PRODUCTO UNION ALL SELECT  ' . singleQuote('GEN_LBL_TOTAL') . ' LA_PRODUCTO, 10000 PARTICIPATION_PCT, SUM(X.FINAL_CASH_AMT) BALANCE_AMT FROM ' . $this->inponame . ' X WHERE X.IDENTIFICATION = ' . singleQuote($this->rif) . ' AND X.CURRENCY_CODE = ' . singleQuote($val[CLX_NUM_ZERO]) . ' AND X.GL_TYPE = ' . singleQuote('AS') . '';
		  $i = CLX_INIT_ZERO;
		  $save_total = CLX_INIT_ZERO;
		  $results = ClxCommon::$db->executeQuery($sql);
		  $total = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE);
		  while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
			 //data
			 $class = ($i % CLX_NUM_TWO == CLX_NUM_ONE) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT;
			 if ($result['LA_PRODUCTO'] === 'GEN_LBL_TOTAL') {
			     // $class = CLX_CLASS_HEADERS;
			     $result['LA_PRODUCTO'] = dict($result['LA_PRODUCTO']);
			 } else {
			     $data[$result['LA_PRODUCTO']] = $result['BALANCE_AMT'];
			 }
			 $table2->addCell($result['LA_PRODUCTO'], array(CLX_PROP_CLASS => $class));
			 $result['PARTICIPATION_PCT'] = round(($result['BALANCE_AMT'] / $total['BALANCE_AMT']) * CLX_NUM_HUNDRED, CLX_NUM_FOUR);
			 $table2->addCell(clx_format_currency($result['PARTICIPATION_PCT']) . '%', array(CLX_PROP_CLASS => $class, 'style' => $style));
			 $save_total = $result['BALANCE_AMT'];
			 if ($result['BALANCE_AMT'] < CLX_NUM_ZERO) {
			     $val2 = '<font color=red>(' . str_replace('-', '', clx_format_currency($result['BALANCE_AMT'])) . ')</font>';
			 } else {
			     $val2 = clx_format_currency($result['BALANCE_AMT']);
			 }
			 $table2->addCell($val2, array(CLX_PROP_CLASS => $class, 'style' => $style));
			 $i++;
		  }
		  ClxCommon::$db->freeResult($results);
		  if (empty($margin)) {
			 $margin['BALANCE_AMT'] = CLX_INIT_ZERO;
		  }
		  $class = CLX_CLASS_DATAALT;
		  $table2->addCell(dict('GEN_LBL_MARGIN'), array(CLX_PROP_CLASS => $class));
		  $table2->addCell(CLX_CHAR_HTML_NBSP, CLX_PROP_CLASS, $class, 'style', $style);
		  $val3 = $this->numberFormat($margin['BALANCE_AMT']);
		  $table2->addCell($val3, array(CLX_PROP_CLASS => $class, 'style' => $style));
		  $class = CLX_CLASS_DATA;
		  $table2->addCell(dict('GEN_LBL_TOTAL_PORT'), array(CLX_PROP_CLASS => $class));
		  $table2->addCell(CLX_CHAR_HTML_NBSP, CLX_PROP_CLASS, $class, 'style', $style);
		  $table2->addCell($this->numberFormat(bcadd($save_total, $margin['BALANCE_AMT'])), array(CLX_PROP_CLASS => $class, 'style' => $style));
		  $src = $table2->source();
		  $src = str_replace('<PLOT>', $this->buildSummaryPlot($data, dict('CODE_LAIN_PORTIN') . ' ' . $val[CLX_NUM_TWO]), $src);
		  //Adding to report
		  $table->addCell($src, array(CLX_PROP_WIDTH => '50%'));
		  unset($data, $src);
        }
        $contents .=$table->source();
        $this->frame(dict('CODE_LAIN_ACCOCONSOLIDATE'), $contents);
    }

    /**
     * Builds Pie Chart for report
     *
     * @param array $data
     * @param string $title
     * @return string $chart_html
     */
    function buildSummaryPlot($data, $title = '') {
        $strColor = array('AFD8F8', 'F6BD0F', '8BBA00', 'A66EDD', 'F984A1', 'CCCC00' /* Chrome Yellow+Green */, '999999' /* Grey */, '0099CC' /* Blue Shade */, 'FF0000' /* #Bright Red */, '006F00' /* #Dark Green */, '0099FF' /* #Blue (Light) */, 'FF66CC' /* #Dark Pink */, '669966' /* #Dirty green */, '7C7CB4' /* #Violet shade of blue */, 'FF9933' /* #Orange */, '9900FF' /* #Violet */, '99FFCC' /* #Blue+Green Light */, 'CCCCFF' /* #Light violet */, '669900' /* #Shade of green */, '1941A5' /* #Dark Blue */);
        $title = trim(str_replace(CLX_CHAR_NL, '', $title), CLX_CHAR_NL . "\r");
        $xml = '<graph caption="' . $title . '" baseFont="arial" baseFontSize="' . singleQuote('10') . '" decimalPrecision="2"  showPercentageValues="1" showNames="1" showValues="1" showPercentageInLabel="1" pieBorderAlpha="100" pieRadius="50" animation="0" shadowYShift="4" shadowAlpha="40" align="center">';
        $i = CLX_INIT_ZERO;
        foreach ($data as $key => $val) {
		  if ($val == CLX_NUM_ZERO) {
			 $val = '1';
		  }
		  $xml .= '<set name="' . trim($key, "'\'?'.CLX_CHAR_NL.'\r") . '" value="' . trim($val, CLX_CHAR_NL.CLX_CHAR_CR) . '" color="' . '#' . $strColor[$i] . '" />';
		  if ($i == CLX_NUM_19) {
			 $i = CLX_INIT_ZERO;
		  } else {
			 $i++;
		  }
        }
        $w = CLX_NUM_300;
        $h = CLX_NUM_200;
        $xml .='</graph>';
        $contents = '<OBJECT classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"
			     WIDTH="' . $w . '" HEIGHT="' . $h . '" VIEWASTEXT codebase="http://download.macromedia.com/
			     pub/shockwave/cabs/flash/swflash.cab#version=6, 0, 0,0"
			     id="FC2Column" ALIGN="center" border=0>
			     <PARAM NAME=movie VALUE="plot/FC_2_3_Pie2D.swf">
			     <PARAM NAME="FlashVars" value="&dataXML=' . $xml . '&chartWidth=' . $w . '&chartHeight=' . $h . '">
			     <PARAM NAME=quality VALUE=high>
			     <PARAM NAME=bgcolor VALUE=#000000>
			     <EMBED src="plot/FC_2_3_Pie2D.swf" FlashVars="&dataXML=' . $xml . '&chartWidth=' . $w . '&chartHeight=' . $h . '" quality=high bgcolor=#FFFFFF
			    WIDTH="' . $w . '" HEIGHT="' . $h . '" NAME="FC_2_3_Pie2D"
			     ALIGN="
			     TYPE="application/x-shockwave-flash" PLUGINSPAGE="http://www.macromedia.com/go/getflashplayer"></EMBED>
			     </OBJECT>';
        //e cho $xml;
        return $contents;
    }

    //COMPOSICION DE PORTAFOLIO - LAIN02
    /**
     * Builds the current report
     * @param void
     * @return void
     */
    private function composition() {
        $style = 'text-align: right;';
        $contents = '';
        if (empty($this->rif)) {
		  $this->contents .=note(dict('GEN_LBL_PLEASESEARCH'));
		  return CLX_CHAR_EMPTY_STRING;
        }
        $DBLT = &getTool('DBLT');
        /* FROM LUIS ARANDA
		-LOS CAMPOS PARA SUMARIZAR SON PRODUCTO (DOS PRIMEROS
		DIGITOS UNICAMENTE), MONEDA Y ACTPAS */
        $sql = 'SELECT DISTINCT P.LA_PRODUCTO, P.CURRENCY_CODE, P.GL_TYPE FROM ' . $this->inponame . ' P WHERE P.IDENTIFICATION = ' . singleQuote($this->rif) . ' AND P.LA_PRODUCTO NOT LIKE ' . singleQuote('MG%') . ' ORDER BY  P.LA_PRODUCTO DESC, P.CURRENCY_CODE,P.GL_TYPE';
        $instruments = ClxCommon::$db->executeQuery($sql);
        while (($instrument = ClxCommon::$db->getNextRecord($instruments))) {
		  $instrument['INSTRUMENT_NAME'] = $DBLT->getListItem('INST', $instrument['LA_PRODUCTO']);
		  $i = CLX_INIT_ZERO;
		  /*
		    �Me pueden proporcionar una lista de tipos de instrumento
		    posibles y que columnas mostrar?
		    MT, MS  mutuos
		    RF, RV,  titulos valores
		    RP, MG, MM, monetarios */
		  $type = CLX_INIT_ZERO;
		  switch ($instrument['LA_PRODUCTO']) {
			 case 'MT':
			 case 'MS':
			     $type = CLX_NUM_ONE;
			     break;
			 case 'RF':
			 case 'RV':
			     $type = CLX_NUM_TWO;
			     break;
			 case 'RP':
			 case 'MG':
			 case 'MM':
			     $type = CLX_NUM_THREE;
			     break;
			 default:
			     break;
		  }//end switch
		  if ($type == CLX_NUM_ONE) {
			 $tableWitdh = CLX_NUM_7;
		  } elseif ($type == CLX_NUM_TWO) {
			 $tableWitdh = CLX_NUM_SIX;
		  } elseif ($type == CLX_NUM_THREE) {
			 $tableWitdh = CLX_NUM_SIX;
		  } else {
			 $tableWitdh = CLX_NUM_FIVE;
		  }
		  $table = new htmlTable($tableWitdh);
		  $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_ALIGN => 'center'));
		  $table = new htmlTable($tableWitdh);
		  $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_ALIGN => 'center'));

		  $table->addCell($instrument['INSTRUMENT_NAME'] . ' (' . $instrument['CURRENCY_CODE'] . ')', array(CLX_PROP_WIDTH => '200', CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
		  if ($type == CLX_NUM_THREE) {
			 $table->addCell(dict('CODE_LAIN_PLAZO'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
		  }
		  if ($type == CLX_NUM_ONE) {
			 $table->addCell(dict('CODE_LAIN_FECHAVALOR'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
			 $table->addCell(dict('CODE_LAIN_VENCIMIENTO'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
			 $table->addCell(dict('CODE_LAIN_PLAZO'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
		  }
		  $table->addCell(dict('CODE_LAIN_QTYORVALUE'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
		  $table->addCell(dict('CODE_LAIN_COSTADQ'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
		  if ($type <> CLX_NUM_ONE) {
			 $table->addCell(dict('CODE_LAIN_GAINMARK'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
			 $table->addCell(dict('CODE_LAIN_MARKVAL'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
		  }
		  if ($type == CLX_NUM_TWO) {
			 $table->addCell(dict('CODE_LAIN_ACCUINT'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
		  }
		  if ($type == CLX_NUM_ONE)
			 $table->addCell(dict('CODE_LAIN_REDEQ'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
		  $sql = 'SELECT
			        EXT_PRODUCT_CODE,
			         DESCRIPTION,
			         BEGIN_DATE,
			         END_DATE,
			         INV_TERM,
			         YIELD_RT,
			         FINAL_BAL_AMT,
			         FINAL_COST_AMT,
			         MARKET_PRICE,
			         REALIZED_EARNINGS,
			         EARNED_INT_AMT
			     FROM ' . $this->inponame . ' WHERE IDENTIFICATION = ' . singleQuote($this->rif) . ' AND LA_PRODUCTO = ' . singleQuote($instrument['LA_PRODUCTO']) . ' AND CURRENCY_CODE  = ' . singleQuote($instrument['CURRENCY_CODE']) . ' AND LA_PRODUCTO NOT LIKE ' . singleQuote('MG%') . ' UNION ALL SELECT ' . singleQuote(dict('GEN_LBL_TOTAL')) . ' EXT_PRODUCT_CODE, ' . singleQuote(CLX_CHAR_HTML_NBSP) . ' DESCRIPTION, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' BEGIN_DATE, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' END_DATE, ' . singleQuote(CLX_CHAR_HTML_NBSP) . ' INV_TERM, AVG(YIELD_RT) YIELD_RT, SUM(FINAL_BAL_AMT) FINAL_BAL_AMT, SUM(FINAL_COST_AMT) FINAL_COST_AMT, round(AVG(MARKET_PRICE), 4) MARKET_PRICE, SUM(REALIZED_EARNINGS) REALIZED_EARNINGS, SUM(EARNED_INT_AMT) EARNED_INT_AMT FROM ' . $this->inponame . ' WHERE IDENTIFICATION = ' . singleQuote($this->rif) . ' AND LA_PRODUCTO = ' . singleQuote($instrument['LA_PRODUCTO']) . ' AND CURRENCY_CODE  = ' . singleQuote($instrument['CURRENCY_CODE']) . ' AND LA_PRODUCTO NOT IN (' . singleQuoteArray(array('RP', 'MG', 'MM')) . ') GROUP BY LA_PRODUCTO, CURRENCY_CODE ';
		  $results = ClxCommon::$db->executeQuery($sql);
		  while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
			 $class = ($i % CLX_NUM_TWO == CLX_NUM_ONE) ? CLX_CLASS_DATAALT : CLX_CLASS_DATA;
			 $i++;
			 $table->addCell($result['EXT_PRODUCT_CODE'] . '<BR>' . $result['DESCRIPTION'], array(CLX_PROP_CLASS => $class));
			 if ($type == CLX_NUM_THREE) {
			     $table->addCell($result['INV_TERM'], array(CLX_PROP_CLASS => $class, 'style' => 'text-align: center);'));
			 }
			 if ($type == CLX_NUM_ONE) {
			     if ($result['BEGIN_DATE'] <> '')
			         $result['BEGIN_DATE'] = xFormat::date($result['BEGIN_DATE'], $this->date_format);
			     if ($result['END_DATE'] <> '')
			         $result['END_DATE'] = xFormat::date($result['END_DATE'], $this->date_format);
			     $table->addCell($result['BEGIN_DATE'], array(CLX_PROP_CLASS => $class, 'style' => 'text-align: center);'));
			     $table->addCell($result['END_DATE'], array(CLX_PROP_CLASS => $class, 'style' => 'text-align: center);'));
			     $table->addCell($result['INV_TERM'], array(CLX_PROP_CLASS => $class, 'style' => 'text-align: center);'));
			 }
			 $table->addCell($this->numberFormat($result['FINAL_BAL_AMT']), array(CLX_PROP_CLASS => $class, 'style' => $style));
			 $table->addCell($this->numberFormat($result['FINAL_COST_AMT']), array(CLX_PROP_CLASS => $class, 'style' => $style));
			 if ($type <> CLX_NUM_ONE) {
			     $table->addCell($this->numberFormat(bcsub($result['FINAL_COST_AMT'], $result['FINAL_BAL_AMT'])), array(CLX_PROP_CLASS => $class, 'style' => $style));
			     $table->addCell($this->numberFormat($result['MARKET_PRICE'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class, 'style' => $style));
			 }
			 if ($type == CLX_NUM_ONE) {
			     // On line total shows nothing, otherwise (detail line) shows the YIELD RATE
			     if ($result['EXT_PRODUCT_CODE'] == dict('GEN_LBL_TOTAL')) {
			         // Totals line
			         $s_colval = '';
			     } else {
			         // Detail line
			         $s_colval = $this->numberFormat($result['YIELD_RT']) . '%';
			     }
			     $table->addCell($s_colval, array(CLX_PROP_CLASS => $class, 'style' => $style));
			 }
			 if ($type == CLX_NUM_TWO) {
			     $table->addCell($this->numberFormat($result['EARNED_INT_AMT'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class, 'style' => $style));
			 }
		  }
		  ClxCommon::$db->freeResult($results);
		  $contents .=$table->source();
		  $contents .='<br>';
        }
		ClxCommon::$db->freeResult($instruments);
        //Totalizados
        $sql = 'SELECT CURRENCY_CODE, SUM(INIT_BAL_AMT) MARGIN, SUM(INV_BUY_QTY-INV_SELL_QTY) FINANCE, SUM(EARNED_INT_AMT) INTEREST, SUM(FINAL_BAL_AMT) BALANCE FROM ' . $this->inponame . ' WHERE IDENTIFICATION = ' . singleQuote($this->rif) . ' AND LA_PRODUCTO IN (' . singleQuoteArray(array('RP', 'MG', 'MM')) . ') GROUP BY  CURRENCY_CODE ';
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
		  $class = CLX_CLASS_DATAALT;
		  $tableWitdh = CLX_NUM_FOUR;
		  $table = new htmlTable($tableWitdh);
		  $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_ALIGN => 'center'));
		  $table->addCell(dict('CODE_LAIN_MARGEN') . ' (' . $result['CURRENCY_CODE'] . ')'
			     , array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
		  $table->addCell(dict('CODE_LAIN_DELTAFIN')
			     , array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
		  $table->addCell(dict('CODE_LAIN_INTCAUSADOS')
			     , array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
		  $table->addCell(dict('CODE_LAIN_FINALBALANCE')
			     , array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
		  //data
		  $class = CLX_CLASS_DATA;
		  $table->addCell($this->numberFormat($result['MARGIN'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class, 'style' => $style));
		  $table->addCell($this->numberFormat($result['FINANCE'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class, 'style' => $style));
		  $table->addCell($this->numberFormat($result['INTEREST'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class, 'style' => $style));
		  $table->addCell($this->numberFormat($result['BALANCE'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class, 'style' => $style));
		  $contents .=$table->source() . '<br>';
        }
		ClxCommon::$db->freeResult($results);
        $contents .='<br>';
        $this->frame(dict('CODE_LAIN_PORTFCONSOL'), $contents);
    }

    //MOVIMIENTOS DE CUENTA - LAIN03
    /**
     * Builds the current report
     * @param void
     * @return void
     */
    private function transactions() {
        $style = 'text-align: right;';
        $contents = '';
        if (empty($this->rif)) {
		  $this->contents .=note(dict('GEN_LBL_PLEASESEARCH'));
		  return CLX_CHAR_EMPTY_STRING;
        }
        $DBLT = &getTool('DBLT');
        $sql = 'SELECT DISTINCT REFERENCE, LA_PRODUCTO, CURRENCY_CODE FROM ' . $this->intxname . ' WHERE IDENTIFICATION = ' . singleQuote($this->rif) . ' ORDER BY REFERENCE DESC, CURRENCY_CODE';
        $instruments = ClxCommon::$db->executeQuery($sql);
        while ($instrument = ClxCommon::$db->getNextRecord($instruments)) {
		  $saldo_final = CLX_INIT_ZERO;
		  $sql = 'SELECT * FROM ' . $this->intxname . ' WHERE IDENTIFICATION = ' . singleQuote($this->rif) . ' AND REFERENCE = ' . singleQuote($instrument['REFERENCE']) . ' AND LA_PRODUCTO = ' . singleQuote($instrument['LA_PRODUCTO']) . ' AND CURRENCY_CODE  = ' . singleQuote($instrument['CURRENCY_CODE']) . ' ORDER BY IDCODE ASC';
		  $results = ClxCommon::$db->executeQuery($sql);
		  if (ClxCommon::$db->numRows($results) == CLX_NUM_ZERO) {
			 continue;
		  }
		  $instrument['INSTRUMENT_NAME'] = $DBLT->getListItem('INST', $instrument['LA_PRODUCTO']);
		  $instrument['REFERENCE'] . '<br>';
		  $tableWitdh1 = CLX_NUM_TWO;
		  $table1 = new htmlTable($tableWitdh1);
		  $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT, CLX_PROP_ALIGN => 'center'));
		  $table1->addCell(dict('CODE_LAIN_MOVEMENTSOF') . ' ' . $instrument['INSTRUMENT_NAME'] . ' (' . $instrument['CURRENCY_CODE'] . ')');
		  $table1->addCell(dict('GEN_LBL_REFERENCE') . ' ' . $instrument['REFERENCE'], array(CLX_PROP_WIDTH => '50%'));
		  $i = CLX_INIT_ZERO;
		  $tableWitdh = CLX_NUM_FIVE;
		  $instrument['REFERENCE'] . '<br>';
		  $table = new htmlTable($tableWitdh);
		  $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT, CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_ALIGN => 'center'));
		  $table->addCell(dict('GEN_LBL_DATE'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);', CLX_PROP_WIDTH, '30'));
		  $table->addCell(dict('GEN_LBL_DESCRIPTION'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);', CLX_PROP_WIDTH, '300'));
		  //$table->addCell(dict('GEN_LBL_INITIALBAL'),array( CLX_PROP_CLASS=> CLX_CLASS_HEADERS,'style'=>'text-align: center);'));
		  $table->addCell(dict('GEN_LBL_CREDITS'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
		  $table->addCell(dict('GEN_LBL_DEBITS'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
		  $table->addCell(dict('GEN_LBL_BALANCE'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align: center);'));
		  $i = CLX_INIT_ZERO;
		  while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
			 $class = ($i % CLX_NUM_TWO == CLX_NUM_ONE) ? CLX_CLASS_DATAALT : CLX_CLASS_DATA;
			 //Linea de saldo inicial
			 if ($i == CLX_NUM_ZERO) {
			     $saldo_final = $result['START_AMT'];
			     $table->addCell('', array(CLX_PROP_CLASS => $class, 'style' => 'text-align: center);'));
			     $table->addCell(dict('GEN_LBL_INITIALBAL'), array(CLX_PROP_CLASS => $class));
			     $table->addCell('', array(CLX_PROP_CLASS => $class, 'style' => $style));
			     $table->addCell('', array(CLX_PROP_CLASS => $class, 'style' => $style));
			     $table->addCell($this->numberFormat($saldo_final), array(CLX_PROP_CLASS => $class, 'style' => $style));
			     $i++;
			     $class = ($i % CLX_NUM_TWO == CLX_NUM_ONE) ? CLX_CLASS_DATAALT : CLX_CLASS_DATA;
			 }
			 if ($result['EFFTDATE'] <> '')
			     $result['EFFTDATE'] = xFormat::date($result['EFFTDATE'], $this->date_format);
			 $table->addCell($result['EFFTDATE'], array(CLX_PROP_CLASS => $class, 'style' => 'text-align: center);'));
			 $table->addCell(ucfirst($result['LA_CONCEPTO'] . ' ' . $result['IDNAME']), array(CLX_PROP_CLASS => $class));
			 /*
			   (Incremento no contable)
			   Abono
			   Compra
			   Incremento
			   Apertura
			   Renovacion
			   Venta
			   Cancelacion
			   Disminucion
			   Retiro
			   no clasificadas
			   Cancelaci�n de  Intereses: ?
			   Cambio de Tasa:?
			   Canc. de Inter�s:?
			   Cambio de Tasa:?
			   Amort/Cap: ?
			   Mutuos Activos Simples:?
			   Mutuos Pasivo Simple:?
			  */
			 $debits = CLX_INIT_ZERO;
			 $credits = CLX_INIT_ZERO;
			 if ($result['LA_CONCEPTO'] === 'Compra' || $result['LA_CONCEPTO'] === 'Abono' || $result['LA_CONCEPTO'] === 'Incremento' || $result['LA_CONCEPTO'] === 'Renovacion' || $result['LA_CONCEPTO'] === 'Apertura') {
			     $debits = CLX_INIT_ZERO;
			     $credits = $result['BALANCE_AMT'];
			 } elseif ($result['LA_CONCEPTO'] === 'Venta' || $result['LA_CONCEPTO'] === 'Retiro' || $result['LA_CONCEPTO'] === 'Cancelacion' || $result['LA_CONCEPTO'] === 'Disminucion') {
			     $debits = $result['BALANCE_AMT'];
			     $credits = CLX_INIT_ZERO;
			 } else {
			     $debits = CLX_INIT_ZERO;
			     $credits = CLX_INIT_ZERO;
			 }
			 $saldo_final = bcadd($saldo_final, bcsub($credits, $debits));
			 $table->addCell($this->numberFormat($credits), array(CLX_PROP_CLASS => $class, 'style' => $style));
			 $table->addCell($this->numberFormat($debits), array(CLX_PROP_CLASS => $class, 'style' => $style));
			 $table->addCell($this->numberFormat($saldo_final), array(CLX_PROP_CLASS => $class, 'style' => $style));
			 $i++;
		  }
		  $class = ($i % CLX_NUM_TWO == CLX_NUM_ONE) ? CLX_CLASS_DATAALT : CLX_CLASS_DATA;
		  $table->addCell('', array(CLX_PROP_CLASS => $class, 'style' => 'text-align: center);'));
		  $table->addCell(dict('CODE_LAIN_FINALBALANCE'), array(CLX_PROP_CLASS => $class));
		  $table->addCell('', array(CLX_PROP_CLASS => $class, 'style' => $style));
		  $table->addCell('', array(CLX_PROP_CLASS => $class, 'style' => $style));
		  $table->addCell($this->numberFormat($saldo_final), array(CLX_PROP_CLASS => $class, 'style' => $style));
		  $table1->addCell($table->source() . '<br>', array(CLX_PROP_COLSPAN => $tableWitdh1));
		  $contents .= $table1->source();
		  ClxCommon::$db->freeResult($results);
        }
		ClxCommon::$db->freeResult($instruments);
        $contents .='<br>';
        $this->frame(dict('CODE_LAIN_MOVIMIENTOSINV')
			 , $contents);
    }

    // CREACION DE CLIENTES
    /*
     * Reads the ID List and passes it to the Creates Customers functionallity
     *
     * @param void
     * @return void
     */
    function la_create_customer() {
        UserResponse::setRunTimeLimit($this->n_executeClient_time_limit);
        $idlist = getIdlist();
        $s_reponse = $this->la_create_customer_from_list($idlist);
        return $s_reponse;
    }

// Method End
    /*
     * Creates Customers into ULTRA LA from the given ID List
     *
     * @param array $idlist
     * @return string
     */
    function la_create_customer_from_list($idlist) {
        /*
         * LACRE1CUST_TITLE_01
         * TRANSMISION OF CRM ACCOUNT TO LA'S ULTRA SYSTEM
         * TRANSMISI�N DE CUENTAS CRM AL SISTEMA LA ULTRA
         */
        $contents = '<br><b>' . dict('LACRE1CUST_TITLE_01') . '</b><br>';
        //Retrive Account
        $sql = 'SELECT ACCO.ID, ACCO.IDCODE, ACCO.IDNAME, ACCO.ISINDIVIDUAL, ACCO.IBS_CUSCUN FROM ' . $this->acconame . ' ACCO WHERE ID IN (' . singleQuote(implode("','", $idlist)) . ')';
        $results = ClxCommon::$db->executeQuery($sql);
        while ($clientrec = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
		  $a_response = $this->la_create_one_customer($clientrec['IDCODE']);
		  $contents .= '<br>' . $a_response['response'] . '<br>';
        }
		ClxCommon::$db->freeResult($results);
        return $contents;
    }

    /**
     * Create customer on LA System
     * @param string $s_customer_idcode
     * @return string
     */
    function la_create_one_customer($s_customer_idcode) {
        if (defined('DONECLIENT' . $s_customer_idcode)) {
		  return true;
        }
        $parameters = ClxCommon::$db->getRecord($this->acconame, 'IDCODE = ' . singleQuote($s_customer_idcode));
        $b_error = false;
        if (!array_key_exists('IDCODE', $parameters)) {
		  /*
		   * LACRE1CUST_ACCO_NTFND
		   * CRM Account not found. Code: ^1
		   * Cuenta CRM no fue encontrada. C�digo: ^1
		   */
		  $s_return = dict('LACRE1CUST_ACCO_NTFND', $s_customer_idcode);
		  $b_error = true;
        } else {
		  if ($parameters['ISINDIVIDUAL'] == CLX_NUM_ZERO) {
			 $parameters['LASTNAME'] = $parameters['LEGAL_NAME'];
			 $parameters['FIRSTNAME'] = '';
			 $parameters['BIRTHDATE'] = $parameters['INCORPORATION_DATE'];
			 $parameters['MARITAL_STATUS'] = 'OT';
		  }
		  //Asignado para poder definir cual es la ciudad y estado a usar
		  if ($parameters['CORRESPONDENCE'] === 'E') {
			 $parameters['CITY'] = $parameters['CITY_02'];
			 $parameters['STATE'] = $parameters['STATE_02'];
		  }
		  $b_sw_creacion = ($parameters['IBS_CUSCUN'] === '');
		  $s_activity_descr = ($b_sw_creacion ? dict('GEN_LBL_CREATION') : dict('GEN_LBL_MODIFY'));
		  // Prepares data to be send
		  // Sends the customer info to LA
		  $a_response = getService('LA_ACT_CLNT', $parameters);
//e cho debug_dump('la_create_customer - LA_CLIENTE', $a_response);
		  /*
		   * LACRE1CUST_ACCO_ERR02
		   * No response from Web Service
		   * Sin respuesta del Web Service
		   */
		  $s_status = dict('LACRE1CUST_ACCO_ERR02');
		  $s_message = '';
		  if (array_key_exists('status', $a_response['a_response'])) {
			 $s_status = $a_response['a_response']['status'];
			 $s_message = $a_response['a_response']['mensaje'];
		  }
		  if ('' . $s_status === '0') {
			 /*
			  * LACRE1CUST_ACCO_DONE
			  * ^1 : CRM Account sent to ULTRA. Actividad: ^3, Status: ^2
			  * ^1 : Cuenta CRM enviada a ULTRA. Actividad: ^3, Status: ^2
			  */
			 $s_return = dict('LACRE1CUST_ACCO_DONE', $s_customer_idcode, $s_status, $s_activity_descr
			         ) . '<br>[' . $s_message . ']';
			 if ($b_sw_creacion === true) {
			     // Look and assign the external system customer code
			     $parameters_2 = array('status' => CLX_NUM_ZERO,
			         'mensaje' => '',
			         'rif' => $parameters['IDENTIFICATION'],
			         'cadxml' => '');
			     $a_response = getService('LA_CLIENTE', $parameters_2);
			 }
//$qq = ClxCommon::$db->getRecord($this->acconame, 'IDCODE = '. singleQuote($s_customer_idcode) );
//e cho '<br>IBS_CUSCUN='. $qq['IBS_CUSCUN'];
		  } else {
			 /*
			  * LACRE1CUST_ACCO_ERR01
			  * ^1 : Error sending CRM Account to ULTRA. Actividad: ^3, Status: ^2
			  * ^1 : Error enviando Cuenta CRM a ULTRA. Actividad: ^3, Estatus: ^2
			  */
			 $s_return = dict('LACRE1CUST_ACCO_ERR01', $s_customer_idcode, $s_status, $s_activity_descr
			         ) . '<br>[' . $s_message . ']';
			 $b_error = true;
		  }
        }
        $a_response = array
		  (
		  'error' => $b_error,
		  'response' => $s_return
        );
//print_r($a_response);
        //Clave para prevenir multiples actualizaciones
        define('DONECLIENT' . $s_customer_idcode, CLX_NUM_ONE);
        return $a_response;
    }

    //MET. CONFIRMACIONES
    function Dame_Transacd($record) {
        //Interpretando valores y consultando servicio
        $prmts = array('status' => CLX_NUM_ZERO,
		  'mensaje' => '',
		  'fechin' => $record['INCF_EFFTDATE'],
		  'valorcierre' => $record['INCF_LA_VALORCIERRE'],
		  'actpas' => $record['INCF_LA_ACTPAS'],
		  'mesin' => $record['INCF_LA_MESIN'],
		  'veh' => $record['INCF_LA_VEH'],
		  'rifi' => $record['INCF_IDENTIFICATION'],
		  'mrkt' => $record['INCF_MARKET_TYPE'],
		  'cadxml' => '');
        if ($record['INCF_MARKET_TYPE'] == CLX_NUM_NINE) {
		  UserRequest::$post['INCF_MARKET_TYPE'] = '';
		  UserRequest::$request['INCF_MARKET_TYPE'] = '';
		  $record['INCF_MARKET_TYPE'] = '';
        }
        $a_response = getService('LA_CONFIR', $prmts);
        if (!empty($a_response['mensaje']))
		  addMessage($a_response['mensaje']);
    }

}
