<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-10-26 15:41:17 -0400 (Wed, 26 Oct 2016) $
 * @version        $Rev: 8849 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class LeadUtils {

    var $leadId = CLX_INIT_ZERO; // Lead Identifiyer
    var $contents = '';
    var $current_form = '';
    var $convertToAcco_validation_formname = 'ACCO_GEN';
    var $username = '';
    var $now = '';

    /**
     * Constructor
     *
     * @param unknown_type $convertToAccount
     */
    function __construct($convertToAccount = true) {
        $idlist = getIdlist();
        if (empty($convertToAccount))
            return;
        $this->username = (!empty($_SESSION ['user_record'] ['username']))?$_SESSION ['user_record'] ['username']:'';
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        multiTableName($this, array('LEAP', 'COOB', 'DYEA', 'ACEA', 'FICO', 'CONT', 'OPPO', 'ACPH', 'ACCO', 'FIPA', 'DYCO', 'DYAC', 'FICO', 'COLO', 'COMP'));
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, 'EDIT');
        $form->addArgument('ac', 'LIST');
        $form->addArgument('li', 'LEADS');
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('GEN_LBL_CONVERTTOACCOUNT_RESULTS'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(' ', array(CLX_PROP_CLASS => '', CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $leadTable = tableName('LEAP');
        foreach ($idlist as $key => $value) {
            $leadRec = ClxCommon::$db->getRecord($leadTable, 'ID=' . $value);
            $table->addCell(dict('GEN_LBL_CONVERTING') . ': ' . $leadRec ['IDCODE'], array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $table->addCell($this->convertToAcco($leadRec), array(CLX_PROP_CLASS => '', CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        }
        $c = new htmlButtonCancel(dict('GEN_LBL_CONTINUE'));
        $table->addCell($c->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->addContents($table->source());
        $this->contents = $form->source();
    }

    /**
     * Validate Lead form
     *
     * @param array $record
     * @param array $msg
     */
    function validateLeadForm(&$record, &$msg) {
        if (empty($record ['LEAP_CONTACT_CODE']) || $record ['LEAP_CONTACT_CODE'] === 'null') {
            if (empty($record ['LEAP_FIRSTNAME']))
                $msg ['LEAP_FIRSTNAME'] = dict('GEN_LBL_REQUIRED');
            if (empty($record ['LEAP_LASTNAME']))
                $msg ['LEAP_LASTNAME'] = dict('GEN_LBL_REQUIRED');
        }
    }

    /**
     * Events performed after opportunity creation
     *
     * @param array $record
     */
    function saveLeadContact(&$record) {
        return; //Comentado ya que no se generara mas contacto de cuenta cambiado a cuenta relacionada
        multiTableName($this, array('LEAP', 'CONT'));
        $contrec = array();
        // prospect a create
        $sql = 'SELECT X.FIELDNAME FROM CLX_DB_TABLEFIELDS X WHERE X.TABLECODE = ' . singleQuote('CONT') . ' AND X.FIELDNAME <> ' . singleQuote('ID') . ' AND X.FIELDNAME <> ' . singleQuote('IDCODE') . ' AND X.FIELDNAME <> ' . singleQuote('IDNAME') . ' AND X.FIELDNAME <> ' . singleQuote('CDATE') . ' AND X.FIELDNAME <> ' . singleQuote('MDATE') . ' AND X.FIELDNAME <> ' . singleQuote('MODIFIEDBY') . ' AND X.FIELDNAME <> ' . singleQuote('CREATEDBY') . ' AND X.FIELDNAME <> ' . singleQuote('SOURCE_LEAD') . ' AND EXISTS(SELECT Y.FIELDNAME FROM CLX_DB_TABLEFIELDS Y WHERE X.FIELDNAME = Y.FIELDNAME AND Y.TABLECODE = ' . singleQuote('LEAP') . ')';
        $contFields = ClxCommon::$db->executeQuery($sql);
        while (($contField = ClxCommon::$db->getNextRecord($contFields, NUMERIC))) {
            if (!array_key_exists($contField [CLX_NUM_ZERO], $record))
                $contrec [$contField [CLX_NUM_ZERO]] = '';
            else
                $contrec [$contField [CLX_NUM_ZERO]] = $record [$contField [CLX_NUM_ZERO]];
        }
        $contrec ['SOURCE_LEAD'] = $record ['IDCODE'];
        if (!function_exists('setCreationData'))
            includeCodeLib('GEN_REC_UTIL');
        $this->leadIdname($contrec);
        if (empty($record ['CONTACT_CODE']) || $record ['CONTACT_CODE'] === 'null') {
            $this->leadIdname($contrec);
            // Determining contact code if exists
            $sql = 'SELECT IDCODE FROM ' . $this->contname . '  WHERE (IDENTIFICATION = ' . singleQuote($record ['IDENTIFICATION']) . ' AND IDENTIFICATION<>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') ';
            $contact_code = ClxCommon::$db->getOne($sql);
            if (!empty($contact_code)) { // if contact found
                ClxCommon::$db->updateRecord($this->leapname, array('CONTACT_CODE' => $contact_code), 'IDCODE = ' . singleQuote($record ['IDCODE']));
                $record ['CONTACT_CODE'] = $contact_code;
            } else { // create contact
                $contrec ['IDCODE'] = 'AUTO';
                $contrec ['CDATE'] = $this->now;
                $contrec ['MDATE'] = $this->now;
                $contrec ['CREATEDBY'] = $this->username;
                $contrec ['MODIFIEDBY'] = $this->username;
                $contrec ['STATUS'] = 'A';

                $contrec ['CATEGORY'] = 'Prospect';
                $contrec ['CONT_ACCESS'] = $record ['ACCDEP'];
                setCreationData($contrec);
                setCreationIdCode($contrec, 'CONT');
                ClxCommon::$db->updateRecord($this->leapname, array('CONTACT_CODE' => $contrec ['IDCODE']), 'IDCODE = ' . singleQuote($record ['IDCODE']));
                // setting name
                ClxCommon::$db->createRecord($this->contname, $contrec, false);
            }
        }
    }

    /**
     * Source
     *
     * @return string
     */
    function source() {
        return $this->contents;
    }

    /**
     * Init forms
     * @param unknown_type $record
     */
    function init_form(&$record) {
        if (UserRequest::$request['ac'] === 'DUPLICATE' && empty(UserRequest::$post['confirm'])) {
            $record['LEAP_IDCODE'] = 'AUTO';
            $record['LEAP_CONVERTACCOUNT'] = CLX_INIT_ZERO;
            $record['LEAP_ACCOUNTCODE'] = '';
            $record['LEAP_ACCOUNTCODE_prim'] = '';
            $record['LEAP_ACCOUNTCODE_secd'] = '';
            $record['LEAP_ACCOUNTCODE_terc'] = '';
        }
    }

    /**
     *
     * @param array $record
     */
    function initContLead(&$record) {
        if (!empty(UserRequest::$get ['cc'])) {
            $contact_rec = ClxCommon::$db->getRecord('CRM_CONTACTS', 'IDCODE = ' . singleQuote(UserRequest::$get ['cc']));
            $record ['LEAP_CONTACT_CODE'] = $contact_rec ['IDCODE'];
            $record ['LEAP_CONTACT_CODE_prim'] = $contact_rec ['IDCODE'];
            $record ['LEAP_CONTACT_CODE_secd'] = $contact_rec ['IDNAME'];
            $record ['LEAP_CONTACT_CODE_terc'] = $contact_rec ['COMPANY'];

            if (empty($record ['LEAP_ACCDEP']))
                $record ['LEAP_ACCDEP'] = $contact_rec ['CONT_ACCESS'];
            $record ['LEAP_IDNAME'] = $contact_rec ['IDNAME'];
            foreach ($record as $key => $val) {
                $contact_key = str_replace('LEAP_', '', $key);
                if ($contact_key === 'IDCODE' || $contact_key === 'ACCDEP')
                    continue;
                if (array_key_exists($contact_key, $contact_rec)) {
                    $record [$key] = $contact_rec [$contact_key];
                }
            }
            if (empty($record ['LEAP_CURRENCY_CODE']) || $record ['LEAP_CURRENCY_CODE'] === 'null') {
                $record ['LEAP_CURRENCY_CODE'] = ClxCommon::$db->getField('BASE_COMPANIES', 'CURRENCY_CODE');
            }
        }
        // Some defaults
        $record ['LEAP_OWNERCODE'] = $_SESSION ['user_record'] ['username'];
        $record ['LEAP_ASSIGNEDTO_USER'] = $_SESSION ['user_record'] ['username'];
    }

    /**
     * Paints html label
     *
     * @param unknown_type $status
     * @return string
     */
    function status_html_label($status = true) {
        $lbl = ' ' . dict('GEN_LBL_STATUS') . ': ';
        if (!empty($status)) {
            $lbl .= '<font color = "green">' . dict('GEN_LBL_OK') . '</font>';
        } else {
            $lbl .= '<font color = "red">' . dict('GEN_LBL_FAIL') . '</font>';
        }
        return $lbl;
    }

    /**
     * Convert lead to account
     *
     * @param array $leadRec
     * @return Ambigous <unknown, string>|string
     */
    function convertToAcco($leadRec) {
        ClxCommon::$cached['b_sw_accorecval_deactivation'] = true;
        if (empty($leadRec)) {
            return dict('GEN_LBL_NOLEADFOUND');
        }
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => '', CLX_PROP_WIDTH => CLX_PROP_100PCT));
        // keys to undo in case of error, format['tablecode']=id
        $undokeys = array();
        //ACCO CREATION
        if (!$this->convert_build_acco($leadRec, $table, $undokeys)) {
            return $table->source();
        }
        //CONT CREATION
        UserRequest::$request ['li'] = 'LEADS';
        if (!$this->convert_build_acco_cont($leadRec, $table, $undokeys)) {
            return $table->source();
        }

        if (!$this->convert_build_oppo($leadRec, $table, $undokeys)) {
            return $table->source();
        }
        // Wraping up
        if (empty($msg)) {
            // Convertion completed. New code: ^1
            ClxCommon::$db->updateRecord($this->leapname, array('CONVERTACCOUNT' => CLX_NUM_ONE, 'ACCOUNTCODE' => $leadRec ['ACCOUNTCODE']), 'ID=' . $leadRec ['ID']);
            $table->addCell(dict('GEN_LBL_PROCESS_COMPLETED'), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $table->width));
        } else {
            // Error on acco
            $this->displayMsg($msg, $table);
        }
        return $table->source();
    }

    /**
     * Creates account from lead record
     *
     * @param array $leadRec
     * @param obj $table
     * @param array $undokeys
     * @return boolean
     */
    private function convert_build_acco(&$leadRec, &$table, &$undokeys) {
        $EDIT = &getTool('EDIT');
        $UIFM = &getTool('UIFM');
        $msg = array();
        $formcode = '';
        $formrec = array();
        $tablecode = '';
        $tablerec = array();
        if (!empty($leadRec ['ISINDIVIDUAL'])) {
            $this->convertToAcco_validation_formname = 'ACCO_PERS';
        } else {
            $this->convertToAcco_validation_formname = 'ACCO_CORP';
        }
        $EDIT->getMenuInformation($this->convertToAcco_validation_formname, 'CREATE_FORM', $formcode, $formrec, $tablecode, $tablerec);
        // Search accounts by identification and update leads based on type Only
        // create account if account is not found
        $accoRec = ClxCommon::$db->getRecord($this->acconame, 'IDCODE=' . singleQuote($leadRec ['ACCOUNTCODE']));
        $acco_exists = (!empty($accoRec)) ? true : false;
        if (empty($acco_exists)) {
            $accoRec = $EDIT->defaultRecord($tablerec);
            $EDIT->executeInitEvents($formrec, $tablerec, $accoRec, $msg);
            foreach ($leadRec as $key => $val) {
                if (array_key_exists('ACCO_' . $key, $accoRec)) {
                    $accoRec['ACCO_' . $key] = $val;
                }
            }
            // Setting Account record from lead
            $accoRec ['ACCO_ID'] = CLX_INIT_ZERO;
            $accoRec ['ACCO_IDCODE'] = 'AUTO';
            $accoRec ['ACCO_COTYPE'] = (!empty($leadRec ['COTYPE'])) ? $leadRec ['COTYPE'] : '1';
            $accoRec ['ACCO_COMPLOC_CODE'] = $leadRec['BRANCH'];

            if (!empty($leadRec ['ISINDIVIDUAL'])) {
                $accoRec ['ACCO_ISINDIVIDUAL'] = CLX_NUM_ONE;
                $accoRec ['ACCO_COTYPE'] = '1';
                $accoRec ['ACCO_ID_TYPE'] = $leadRec ['ID_TYPE'];
                $accoRec ['ACCO_SECOND_NAME'] = $leadRec ['SECONDNAME'];
            } else {
                $accoRec ['ACCO_ISINDIVIDUAL'] = CLX_INIT_ZERO;
                $accoRec ['ACCO_ID_TYPE'] = 'RIF';
                //$accoRec ['ACCO_IDENTIFICATION'] = $leadRec['TAXID'];
                $accoRec ['ACCO_LEGAL_NAME'] = $leadRec ['COMPANY'];
            } // end-else
            $accoRec ['ACCO_PHOTO'] = CLX_INIT_ZERO;
            $accoRec ['ACCO_SIGNATURE_IMAGE'] = CLX_INIT_ZERO;
            // salegrett (03/01/05)-----END------
            $accoRec ['ACCO_IDNAME'] = $leadRec ['IDNAME'];
            $accoRec ['ACCO_ACCTYPE'] = 'CUST';
            $accoRec ['ACCO_CLIENT_SINCE_DATE'] = $this->now;
            $accoRec ['ACCO_COMPANY_NAME'] = (!empty($leadRec ['COMPANY'])) ? $leadRec ['COMPANY'] : '';
            $accoRec ['ACCO_CATEGORYCODE'] = (!empty($leadRec ['CATEGORYCODE'])) ? $leadRec ['CATEGORYCODE'] : '';
            $accoRec ['ACCO_PARENTACCOUNT'] = (!empty($leadRec ['RELATED_ACCOUNT'])) ? $leadRec ['RELATED_ACCOUNT'] : '';
            $accoRec ['ACCO_RECEIVECAMPAIGNS'] = '1';
            $accoRec ['ACCO_MAILING_ADDRESS'] = '1';
            $accoRec ['ACCO_CDATE'] = $this->now;
            $accoRec ['ACCO_MDATE'] = $this->now;
            $accoRec ['ACCO_CREATEDBY'] = $this->username;
            $accoRec ['ACCO_MODIFIEDBY'] = $this->username;
            $accoRec ['ACCO_ACCSTAT'] = 'A';
            $accoRec ['ACCO_INITIAL_DATE'] = $this->now;
            $accoRec ['ACCO_LAST_ACTIVITY_DATE'] = $this->now;
            $accoRec ['ACCO_START_ACTIVITY_DATE'] = $this->now;
            $accoRec ['ACCO_INDUSTRYCLASS'] = (!empty($leadRec ['INDUSTRYCLASS'])) ? $leadRec ['INDUSTRYCLASS'] : '';
            $accoRec ['ACCO_SYMBOL'] = (!empty($leadRec ['SYMBOL'])) ? $leadRec ['SYMBOL'] : '';
            $accoRec ['ACCO_ISCUSTOMER'] = CLX_INIT_ZERO;
            $accoRec ['ACCO_SOURCE_LEAD'] = $leadRec ['IDCODE'];
            if (empty($leadRec ['SPOUSE'])) {
                $accoRec['ACCO_SPOUSE'] = '';
            }
            if (!empty($leadRec ['ACCDEP'])) {
                $accoRec ['ACCO_ACCDEP'] = $leadRec ['ACCDEP'];
            }
            UserRequest::$post = $accoRec;
			
			$UIFM->userCheckForm($formrec, $accoRec, $msg);
            if (empty($msg)) {
                UserRequest::$request ['li'] = 'ACCO';
                $id = $EDIT->createRecord($formrec, $tablerec, false);
                if (empty($id)) {

                    $msg ['CLX_MSG'] = dict('GEN_ERR_NO_ACCESS') . ' [LEAD_UTILITIES-CAN_CREATE][ACCO]';
                    $this->displayMsg($msg, $table);
                    $table->addCell(dict('GEN_LBL_ACCO_CREATE') . $this->status_html_label(false), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $table->width));
                    return $table->source();
                }
                // Updating lead source
                $accoRec = ClxCommon::$db->getRecord($this->acconame, 'ID = ' . singleQuote($id));
                $leadRec ['ACCOUNTCODE'] = $accoRec['IDCODE'];
                // Setting account information for lead
                ClxCommon::$db->updateRecord('MARK_LEAPS', array('ACCOUNTCODE' => $accoRec ['IDCODE']), 'IDCODE = ' . singleQuote($leadRec ['IDCODE']));
                // Updating all opportunities to merge into account if table
                // exists
                if (!empty($this->opponame)) {
                    ClxCommon::$db->updateRecord($this->opponame, array('ACCOUNTCODE' => $accoRec ['IDCODE']), 'LEAD_CODE = ' . singleQuote($leadRec ['IDCODE']));
                    // No reversar la creacion de cuenta para prevenir que
                    // exista
                }
            } else {
                $this->displayMsg($msg, $table);
                $table->addCell(dict('GEN_LBL_ACCO_CREATE') . $this->status_html_label(false), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $table->width));

                $leadRec ['ACCOUNTCODE'] = 'null';
                return false;
            }

            $table->addCell(dict('GEN_LBL_CONVERTING_INTO_ACCO') . ': ' . $leadRec ['ACCOUNTCODE'] . $this->status_html_label(true), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $table->width));
            return true;
        }

        // Si ya esta creado debe retornar??
        $table->addCell(dict('GEN_LBL_CONVERTING_INTO_ACCO') . ': ' . $leadRec ['ACCOUNTCODE'] . $this->status_html_label(true), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $table->width));
        return true;
    }

    /**
     * Builds related account - Previous contact
     * @param unknown_type $leadRec
     * @param unknown_type $table
     * @param unknown_type $undokeys
     */
    private function convert_build_acco_cont(&$leadRec, &$table, &$undokeys) {
        $EDIT = &getTool('EDIT');
        $UIFM = &getTool('UIFM');
        $msg = array();
        $formcode = '';
        $formrec = array();
        $tablecode = '';
        $tablerec = array();
        $accoRec = ClxCommon::$db->getRecord($this->acconame, 'IDCODE = ' . singleQuote($leadRec ['ACCOUNTCODE'])); //CUENTA PADRE
        //se busca si existe por la asociacion de identificacion primer nombre y segundo nombre
        //validar esta condicion.
        if (!empty($leadRec['CONTACT_CODE'])) {
            $unique_acco_crit = 'IDCODE =' . singleQuote($leadRec ['CONTACT_CODE']);
        } else {
            $unique_acco_crit = 'IDENTIFICATION =' . singleQuote($leadRec ['IDENTIFICATION']);
            $unique_acco_crit .= ' AND FIRSTNAME = ' . singleQuote($leadRec ['FIRSTNAME']) . ' ';
            $unique_acco_crit .= ' AND LASTNAME = ' . singleQuote($leadRec ['LASTNAME']) . ' ';
        }
        if ($accoRec ['ISINDIVIDUAL'] == CLX_NUM_ZERO) {//SI EN PERSONA JURIDICA ENTONCES CREAR CUENTA RELACIONADA
            // Child Records Contact Information
            $EDIT->getMenuInformation('ACCO_PERS', 'CREATE_FORM', $formcode, $formrec, $tablecode, $tablerec);
            //LEAD_IDENTIFICATION
            if (ClxCommon::$db->oneExistsRecords($this->acconame, 'IDENTIFICATION =' . singleQuote($leadRec ['IDENTIFICATION'])) > CLX_NUM_ZERO) {
                $relAccoRec = ClxCommon::$db->getFields($this->acconame, 'ID, IDCODE ACCO_IDCODE', $unique_acco_crit);
                $relAccoId = $relAccoRec ['ID'];
            } else {
                $relAccoRec = $EDIT->defaultRecord($tablerec);
                $EDIT->executeInitEvents($formrec, $tablerec, $relAccoRec, $msg);
                // Creating Contact Record
                foreach ($leadRec as $key => $val) {
                    if (array_key_exists('ACCO_' . $key, $relAccoRec)) {
                        $relAccoRec['ACCO_' . $key] = $val;
                    }
                }
                $relAccoRec ['ACCO_ID'] = CLX_INIT_ZERO;
                $relAccoRec ['ACCO_IDCODE'] = 'AUTO';
                $relAccoRec ['ACCO_ID_TYPE'] = $leadRec ['ID_TYPE'];
                $relAccoRec ['ACCO_IDENTIFICATION'] = $leadRec ['IDENTIFICATION'];
                $relAccoRec ['ACCO_SALUTATION'] = $leadRec ['SALUTATION'];
                $relAccoRec ['ACCO_FIRSTNAME'] = $leadRec ['FIRSTNAME'];
                $relAccoRec ['ACCO_SECOND_NAME'] = $leadRec ['SECONDNAME'];
                $relAccoRec ['ACCO_LASTNAME'] = $leadRec ['LASTNAME'];
                //Despues de colocar los numbers
                $relAccoRec ['ACCO_IDNAME'] = 'AUTO';
                //Verificar si incluir company eb udbane
                $this->leadIdname($relAccoRec, 'ACCO_');
                $relAccoRec ['ACCO_ISINDIVIDUAL'] = CLX_NUM_ONE;
                $relAccoRec ['ACCO_MDATE'] = $this->now;
                $relAccoRec ['ACCO_TITLE'] = $leadRec ['JOBTITLE'];
                $relAccoRec ['ACCO_CDATE'] = $this->now;
                $relAccoRec ['ACCO_CREATEDBY'] = $this->username;
                $relAccoRec ['ACCO_MODIFIEDBY'] = $this->username;
                $relAccoRec ['ACCO_STATUS'] = 'A';
                $relAccoRec ['ACCO_SOURCE_LEAD'] = 'null';
                $relAccoRec ['ACCO_OWNERCODE'] = $leadRec ['OWNERCODE'];
                $relAccoRec ['ACCO_LEGAL_TYPE'] = 'I';
                $relAccoRec ['ACCO_PHONE'] = $leadRec ['PHONE'];
                $relAccoRec ['ACCO_MOBILE_PHONE'] = $leadRec ['MOBILE_PHONE'];
                $relAccoRec ['ACCO_FAX'] = $leadRec ['FAX'];
                $relAccoRec ['ACCO_EMAIL'] = $leadRec ['EMAIL'];
                $relAccoRec ['ACCO_MAILING_ADDRESS'] = '1';
                $relAccoRec ['ACCO_LOCTYPE'] = $leadRec ['LOCTYPE'];
                $relAccoRec ['ACCO_ADDRESS1'] = $leadRec ['ADDRESS1'];
                $relAccoRec ['ACCO_ADDRESS2'] = $leadRec ['ADDRESS2'];
                $relAccoRec ['ACCO_CITY'] = $leadRec ['CITY'];
                $relAccoRec ['ACCO_STATE'] = $leadRec ['STATE'];
                $relAccoRec ['ACCO_ZIPCODE'] = $leadRec ['ZIPCODE'];
                $relAccoRec ['ACCO_COUNTRY'] = $leadRec ['COUNTRY'];
                $relAccoRec ['ACCO_SIGNATURE_IMAGE'] = CLX_INIT_ZERO;
                $relAccoRec ['ACCO_PHOTO'] = CLX_INIT_ZERO;
                if (empty($leadRec ['SPOUSE'])) {
                    $relAccoRec['ACCO_SPOUSE'] = '';
                }
                UserRequest::$post = $relAccoRec;
                $UIFM->userCheckForm($formrec, $relAccoRec, $msg);
                if (empty($msg)) {
                    $relAccoId = $EDIT->createRecord($formrec, $tablerec, false);
                    $relAccoRec['ACCO_IDCODE'] = ClxCommon::$db->getField($this->acconame, 'IDCODE', 'ID = ' . $relAccoId);
                    ClxCommon::$db->updateRecord($this->leapname, array('CONTACT_CODE' => $relAccoRec['ACCO_IDCODE']), 'IDCODE = ' . singleQuote($leadRec ['IDCODE']));
                    $undokeys [] = array('tablecode' => 'ACCO', CLX_PROP_ID => $relAccoId);
                    //$table->addCell ( dict ( 'GEN_LBL_REL_ACCO_CREATE' ) . $this->status_html_label ( true ), CLX_PROP_CLASS, CLX_CLASS_DATA, CLX_PROP_COLSPAN, $table->width );
                } else { // Error adding contacts
                    $this->displayMsg($msg, $table);
                    $table->addCell(dict('GEN_LBL_REL_ACCO_CREATE') . $this->status_html_label(false), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $table->width));
                    $this->undoConvertion($undokeys);
                    return false;
                }
            }// end if count contact
            // Dynamic Relation ACCO-CONT Only if not defined already
            if (ClxCommon::$db->oneExistsRecords($this->dyacname, 'PARENT_IDCODE=' . singleQuote($accoRec ['IDCODE']), 'PARENT_TABLECODE=' . singleQuote('ACCO') . '', 'CHILD_IDCODE=' . singleQuote($relAccoRec['ACCO_IDCODE']), 'CHILD_TABLECODE=' . singleQuote('ACCO') . '') == CLX_NUM_ZERO) {
                $a_dyco = array(
                    'PARENT_IDCODE' => $accoRec ['IDCODE'],
                    'PARENT_TABLECODE' => 'ACCO',
                    'CHILD_IDCODE' => $relAccoRec['ACCO_IDCODE'],
                    'CHILD_TABLECODE' => 'ACCO',
                    'ISPRIMARY' => CLX_NUM_ONE
                );
                //Agregando relacion si existe
                if (array_key_exists('RELATIONSHIP', $leadRec)) {
                    $a_dyco['RELATIONSHIP'] = $leadRec['RELATIONSHIP'];
                }
                if (array_key_exists('RELATIONSHIP_TYPE', $leadRec)) {
                    $a_dyco['RELATIONSHIP_TYPE'] = $leadRec['RELATIONSHIP_TYPE'];
                }
                ClxCommon::$db->createRecordVoid($this->dyacname, $a_dyco, false);

                $table->addCell(dict('GEN_LBL_REL_ACCO_CREATE') . ': ' . $relAccoRec ['ACCO_IDCODE'] . $this->status_html_label(true), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $table->width));
            } else {
                $table->addCell(dict('GEN_LBL_REL_ACCO_CREATE') . ': ' . $relAccoRec ['ACCO_IDCODE'] . $this->status_html_label(true), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $table->width));
            }
        } else {
            $table->addCell(dict('GEN_LBL_REL_ACCO_CREATE') . ': ' . $accoRec ['IDCODE'] . $this->status_html_label(true), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $table->width));
        }
        return true;
    }

    /**
     * Builds opportunity record
     *
     * @param unknown_type $leadRec
     * @param unknown_type $table
     * @param unknown_type $undokeys
     * @return boolean
     */
    private function convert_build_oppo(&$leadRec, &$table, &$undokeys) {
        $EDIT = &getTool('EDIT');
        $UIFM = &getTool('UIFM');
        $formcode = '';
        $formrec = array();
        $tablecode = '';
        $tablerec = array();
        $msg = array();
        // Creating Opportunity Record
        if (!empty($this->opponame)) {
            $oppoIdcode = ClxCommon::$db->getField($this->opponame, 'IDCODE', 'LEAD_CODE = ' . singleQuote($leadRec ['IDCODE']) . ' AND ACCOUNTCODE = ' . singleQuote($leadRec ['ACCOUNTCODE']));
            if (empty($oppoIdcode)) {
                $EDIT->getMenuInformation('OPPO_PROS_SRCH', 'CREATE_FORM', $formcode, $formrec, $tablecode, $tablerec);
                $oppoRec = $EDIT->defaultRecord($tablerec);
                $EDIT->executeInitEvents($formrec, $tablerec, $oppoRec, $msg);
                foreach ($leadRec as $key => $val) {
                    if (array_key_exists('OPPO_' . $key, $oppoRec)) {
                        $oppoRec['OPPO_' . $key] = $val;
                    }
                }

                $oppoRec ['OPPO_ACCOUNTCODE'] = $leadRec ['ACCOUNTCODE'];
                $oppoRec ['OPPO_ACCOUNTCODE_prim'] = $leadRec ['ACCOUNTCODE'];
                $oppoRec ['OPPO_ACCOUNTCODE_secd'] = '';
                $oppoRec ['OPPO_ACCOUNTCODE_terc'] = '';
				$oppoRec ['OPPO_CMBP_CODE_prim'] = CLX_INIT_ZERO;
                $oppoRec ['OPPO_COMP_CODE'] = $leadRec ['COMP_CODE'];
                $oppoRec ['OPPO_COMP_CODE_prim'] = $leadRec ['COMP_CODE'];
                $oppoRec ['OPPO_IDCODE'] = 'AUTO';
                $oppoRec ['OPPO_IDNAME'] = $leadRec ['IDNAME']; // $leadRec['COMPANY'].'-'.substr($accoRec['CDATE'], 0,10);
                $oppoRec ['OPPO_ACCOUNTCODE_prim'] = $leadRec ['ACCOUNTCODE'];
                $oppoRec ['OPPO_PRODUCTCODE_secd'] = '';
                $oppoRec ['OPPO_PRODUCTCODE_prim'] = $leadRec ['PRODUCT_CODE'];
                $oppoRec ['OPPO_PRODUCTCODE_secn'] = '';
                $oppoRec ['OPPO_PRODUCTCODE'] = $leadRec ['PRODUCT_CODE'];
                $oppoRec ['OPPO_POTENTIAL_REVENUE'] = $leadRec ['POTENTIAL_REVENUE'];
                $oppoRec ['OPPO_ESTCLOSE_DATE'] = $leadRec ['ESTCLOSE_DATE'];
                $oppoRec ['OPPO_SOURCE_LEAD'] = $leadRec ['IDCODE'];
                $oppoRec ['OPPO_LEAD_CODE'] = $leadRec ['IDCODE'];
                $oppoRec ['OPPO_LEAD_CODE_prim'] = $leadRec ['IDCODE'];
                $oppoRec ['OPPO_LEAD_CODE_secd'] = '';
                $oppoRec ['OPPO_DESCRIPTION'] = $leadRec ['DESCRIPTION'];
                $oppoRec ['OPPO_CAMPAIGN_TYPE'] = '';
                $oppoRec ['OPPO_CDATE'] = $this->now;
                $oppoRec ['OPPO_MDATE'] = $this->now;
                $oppoRec ['OPPO_CREATEDBY'] = $leadRec ['CREATEDBY'];
                $oppoRec ['OPPO_MODIFIEDBY'] = $leadRec ['MODIFIEDBY'];
                $oppoRec ['OPPO_ASSIGNEDTO_USER'] = $leadRec ['ASSIGNEDTO_USER'];
                $oppoRec ['OPPO_EFFTDATE'] = $leadRec ['MDATE'];
                $oppoRec ['OPPO_OWNERCODE'] = $leadRec ['OWNERCODE'];
                $oppoRec ['OPPO_STATUS'] = 'A';
                $oppoRec ['OPPO_BRANCH'] = $leadRec ['BRANCH'];
                $oppoRec ['OPPO_BRANCH_prim'] = $leadRec ['BRANCH'];
                $oppoRec ['OPPO_BRANCH_secd'] = ClxCommon::$db->getField($this->coloname, 'IDNAME', 'IDCODE = ' . singleQuote($leadRec ['BRANCH']));
                $oppoRec ['OPPO_OPPSTAGE'] = $leadRec['LEAD_STATUS'];
                if (!empty($leadRec ['OWNERCODE'])) {
                    $oppoRec ['OPPO_OWNERCODE'] = $leadRec ['OWNERCODE'];
                } else {
                    $oppoRec ['OPPO_OWNERCODE'] = $_SESSION ['user_record'] ['username'];
                }
                $oppoRec ['OPPO_ID'] = CLX_INIT_ZERO;
                UserRequest::$post = $oppoRec;
                $UIFM->userCheckForm($formrec, $oppoRec, $msg);
                if (empty($msg)) {
                    $oppoId = $EDIT->createRecord($formrec, $tablerec, false);
                    $oppoRec['OPPO_IDCODE'] = ClxCommon::$db->getField($this->opponame, 'IDCODE', 'ID = ' . singleQuote($oppoId));

                    $table->addCell(dict('GEN_LBL_OPPO_ON_ACCO') . ': ' . $oppoRec['OPPO_IDCODE'] . ' ' . $this->status_html_label(true), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $table->width));
                    //Adding notification
                    includeCodeLib('SLAP');
                    if (class_exists('SLAP')) {
                        $a = new Slap ();
                        $opporec = ClxCommon::$db->getRecord($this->opponame, 'ID = ' . $oppoId);
                        $a->process_opportunity($opporec);
                        unset($a);
                    }
                } else {
                    // adding error and undoing
                    $this->displayMsg($msg, $table);
                    $table->addCell(dict('GEN_LBL_OPPO_ON_ACCO') . $this->status_html_label(false), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $table->width));
                    $this->undoConvertion($undokeys);
                    return false;
                }
            } else {
                $table->addCell(dict('GEN_LBL_OPPO_ON_ACCO') . ': ' . $oppoIdcode . ' ' . $this->status_html_label(true), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $table->width));
            }
            return true;
        }
    }

    /**
     * Revert any lead conversion in case of failure
     *
     * @param unknown_type $undokeys
     */
    private function undoConvertion($undokeys) {
        foreach ($undokeys as $key => $val) {
            ClxCommon::$db->deleteRecords(tableName($val ['tablecode']), 'ID=' . $val [CLX_PROP_ID]);
        }
    }

    /**
     * Construct leads name
     *
     * @param unknown_type $record
     */
    function leadIdname(&$record, $prefix = '') {
        $idname = (!empty($record [$prefix . 'IDNAME'])) ? $record [$prefix . 'IDNAME'] : 'AUTO';
        $fname = $record [$prefix . 'FIRSTNAME'];
        $lname = $record [$prefix . 'LASTNAME'];
        $cname = (isset($record [$prefix . 'COMPANY'])) ? $record [$prefix . 'COMPANY'] : CLX_CHAR_EMPTY_STRING;
        $idname = uppercase($idname);
        if ($fname === 'null')
            $fname = '';
        if ($lname === 'null')
            $lname = '';
        if ($cname === 'null')
            $cname = '';
        if ($idname === 'AUTO') {
            if (!empty($lname) && !empty($fname) && !empty($cname)) {
                $idname = $lname . ',' . $fname . '-' . $cname;
            } elseif (!empty($lname) && !empty($fname) && empty($cname)) {
                $idname = $lname . ',' . $fname;
            } elseif (!empty($lname) && empty($fname) && !empty($cname)) {
                $idname = $lname . '-' . $cname;
            } elseif (empty($lname) && !empty($fname) && !empty($cname)) {
                $idname = $fname . '-' . $cname;
            } elseif (empty($lname) && empty($fname) && !empty($cname)) {
                $idname = $cname;
            } else {
                $idname = 'N/A';
            }
            $record [$prefix . 'IDNAME'] = uppercase($idname);
        }
        // Setting access tree to assignee
        if (empty($record ['ACCDEP']) && !empty($record ['ASSIGNEDTO_USER'])) {
            $record ['ACCDEP'] = getAccessTreeDefNode('ACCDEP', $record ['ASSIGNEDTO_USER']);
        }
    }

    /**
     * Prepares Err Mesajes
     */
    function displayMsg($msg, &$table) {

        $sql = 'SELECT DISTINCT IFNULL(F.TABLECODE, NULLIF(FPF.TABLECODE,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ')) TABLECODE, FPF.FIELDNAME, FPF.FIELDFORMLABEL, DICT.VALUE FROM CLX_UI_FORM_PANEL_FIELDS FPF, CLX_UI_FORM_PANELS FP, CLX_UI_FORMS F, CLX_DICTIONARY DICT WHERE FP.IDCODE = FPF.PANELID AND F.IDCODE = FP.FORMCODE AND DICT.ENTRY = FPF.FIELDFORMLABEL AND F.IDCODE IN (' . singleQuoteArray(array('ACCO_PERS', 'ACCO_GEN', 'ACCO_CORP', 'OPPORTUNITY')) . ') AND UPPER(DICT.LANGUAGE) = ' .singleQuote(uppercase($_SESSION ['prefs'] ['LANGUAGE']));
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, NUMERIC)) {
            $lbl [$r [CLX_NUM_ZERO] . '_' . $r [CLX_NUM_ONE]] = $r [CLX_NUM_THREE];
        }
		ClxCommon::$db->freeResult($rs);
        foreach ($msg as $key => $val) {
            if (!empty($lbl [$key])) {
                $table->addCell($lbl [$key], array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            } else {
                $table->addCell($key, array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            }
            $table->addCell($val, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        }
    }

    /**
     *Crea lead desde cotizador
     * @param type $idname
     * @param type $identification
     * @param type $email
     * @param type $phone
     * @param type $description
     * @param type $assigned_to
     */
    function saveLeadCotizador($idname, $identification, $email, $phone, $description, $username){
        $firstname = 'na';
        $lastname = 'na';
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $record = array('CREATEDBY' => $username,
                        'MODIFIEDBY' => $username,
                        'ASSIGNEDTO_USER' => $username,
                        'IDCODE' => 'AUTO',
                        'IDNAME' => $idname,
                        'CLX_EFFTDATE' => $this->now,
                        'LEAD_STATUS' => 'A',
                        'ACCDEP' => 'AAA',
                        'FIRSTNAME' => $firstname,
                        'LASTNAME' => $lastname,
                        'EMAIL' => $email,
                        'IDENTIFICATION' => $identification,
                        'PHONE' => $phone,
                        'LEGAL_TYPE' => 'I',
                        'DESCRIPTION' => $description,
                        'LEAD_SOURCE' => '0041',
                        'CDATE' => $this->now,
                        'MDATE' => $this->now);
         $record ['ACCDEP'] = getAccessTreeDefNode('ACCDEP', $username);
         if (!function_exists('setCreationData')){
             includeCodeLib('GEN_REC_UTIL');
         }
         setCreationIdCode($record, 'LEAP');
         ClxCommon::$db->createRecord($this->leapname, $record, false);


    }
}
