<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-09-28 13:29:17 +0000 (Wed, 28 Sep 2016) $
 * @version        $Rev: 8747 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Aagr {

    /**
     * Constructor
     * @param array [$procParameters]
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('FIAS', 'FIAE', 'PROD', 'PRAT', 'GLAC', 'AAGI', 'AAGR', 'ASDO', 'GLT1', 'GLCP', 'FIPA', 'JELN', 'FIPA', 'INVT', 'JEIT'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->je_source = '';
    }

    /**
     * Initialice fiat form - Executed on init event
     *
     * @param unknown_type $record
     */
    function init_form(&$record) {
        if (UserRequest::$request['ac'] === 'DUPLICATE_EFFTDATE' && empty(UserRequest::$post['confirm'])) {
            $record['AAGR_CLX_EFFTDATE'] = xFormat::getNow('Y-m-d');
        }
        $parent = peekHistory();
        if (UserRequest::$request['ac'] === 'CREATE' && empty(UserRequest::$post['confirm']) && !empty($parent['parentrecord'])) {
            $parent = $parent['parentrecord'];
            $record['AAGR_COMP_CODE'] = $parent['FIAE_COMP_CODE'];
            $record['AAGR_CHART_FIELD01'] = $parent['FIAE_CHART_FIELD01'];
            $record['AAGR_CHART_FIELD01_prim'] = $parent['FIAE_CHART_FIELD01_prim'];
            $record['AAGR_CHART_FIELD01_secd'] = $parent['FIAE_CHART_FIELD01_secd'];
            $record['AAGR_CHART_FIELD02'] = $parent['FIAE_CHART_FIELD02'];
            $record['AAGR_CHART_FIELD02_prim'] = $parent['FIAE_CHART_FIELD02_prim'];
            $record['AAGR_CHART_FIELD02_secd'] = $parent['FIAE_CHART_FIELD02_secd'];
            $record['AAGR_CHART_FIELD02_terc'] = $parent['FIAE_CHART_FIELD02_terc'];
            $record['AAGR_CURRENCY_CODE'] = $parent['FIAE_CURRENCY_CODE'];
        }
    }

    /**
     * Delete record on delete.
     * @param array $record
     */
    function delete_record_post($record) {
        $sql = 'DELETE FROM ' . $this->aaginame . ' WHERE AGREEMENT_CODE = ' . singleQuote($record['IDCODE']) . ' AND EFFTDATE = ' . singleQuote($record['CLX_EFFTDATE']);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DELETE FROM ' . $this->asdoname . ' WHERE AGREEMENT_CODE = ' . singleQuote($record['IDCODE']) . ' AND EFFTDATE = ' . singleQuote($record['CLX_EFFTDATE']);
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Event post save form
     * @param array $record
     */
    function save_form_post($record) {
        //Duplicando condiciones del acuerdo
        $qty = ClxCommon::$db->oneExistsRecords($this->aaginame, 'AGREEMENT_CODE = ' . singleQuote($record['IDCODE']) . ' AND EFFTDATE = ' . singleQuote($record['CLX_EFFTDATE']));
        if ($qty == CLX_NUM_ZERO) {
            $sql = 'SELECT AAGI.* FROM ' . $this->aaginame . ' AAGI WHERE AAGI.AGREEMENT_CODE = ' . singleQuote($record['IDCODE']) . ' AND AAGI.EFFTDATE = (SELECT MAX(AAGR.CLX_EFFTDATE) FROM ' . $this->aagrname . ' AAGR WHERE AAGR.IDCODE = ' . singleQuote($record['IDCODE']) . ' AND AAGR.CLX_EFFTDATE<' . singleQuote($record['CLX_EFFTDATE']) . ')';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                unset($r['ID']);
                $r['EFFTDATE'] = $record['CLX_EFFTDATE'];
                ClxCommon::$db->createRecord($this->aaginame, $r, false);
            }
			ClxCommon::$db->freeResult($rs);
        }
        $qty = ClxCommon::$db->oneExistsRecords($this->asdoname, 'AGREEMENT_CODE = ' . singleQuote($record['IDCODE']) . ' AND EFFTDATE = ' . singleQuote($record['CLX_EFFTDATE']));
        if ($qty == CLX_NUM_ZERO) {
            $sql = 'SELECT ASDO.* FROM ' . $this->asdoname . ' ASDO WHERE ASDO.AGREEMENT_CODE = ' . singleQuote($record['IDCODE']) . ' AND ASDO.EFFTDATE = (SELECT MAX(AAGR.CLX_EFFTDATE) FROM ' . $this->aagrname . ' AAGR WHERE AAGR.IDCODE = ' . singleQuote($record['IDCODE']) . ' AND AAGR.CLX_EFFTDATE<' . singleQuote($record['CLX_EFFTDATE']) . ')';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                unset($r['ID']);
                $r['EFFTDATE'] = $record['CLX_EFFTDATE'];
                ClxCommon::$db->createRecord($this->asdoname, $r, false);
            }
			ClxCommon::$db->freeResult($rs);
        }
    }

    /**
     * Run Rent Accrual process
     * @param string $comp_code
     */
    function account_due_rent_cron($comp_code, $asset_code = '') {
        $this->account_due_rent($comp_code, $asset_code);
    }

    /**
     * Creando registros contable para acuerdos
     * @param string $comp_code
     * @param string $asset_code
     */
    private function account_due_rent($comp_code, $asset_code = '') {
        //1. Determinar acuerdos que esten por expirar.
        //2. Generar asiento de devengo de renta (pcobrar) que no esten generados ya
        //Modificar proceso para que genere factura en vez de transaccion
        $this->display = true;
        //GLT1
        $this->je_source = 'AMGT_RENT'; //Amortizacion de cuentas por pagar. Deferred Payment
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($comp_code);
        if ($this->display === true) {
            echoLog('AMGT Rent payment process. BATCH ID: ' . $this->batch_id);
            echoLog('Efective date: ' . $comprec['OPERATION_DATE']);
            echoLog('Asset Code: ' . (($asset_code === '') ? 'ALL' : $asset_code));
        }
        if (empty($comprec) || empty($comp_code)) {
            echoLog('Error, no company operation parameters found');
        }
        if (!$comp->ruco_status($comp_code, $this->je_source)) {
            echoLog('Process: $this->je_source Inactive for company $comp_code ');
            return;
        }
        //Build Invoice
        $this->account_due_rent_invo($comprec, $asset_code);
    }

    /**
     * Builds Invoice from temp table
     *
     * @param type $comprec
     */
    private function account_due_rent_invo(&$comprec, $asset_code = '') {
        $DBLT = &getTool('DBLT');
        $idname = $DBLT->getListItem('SOTY', $this->je_source);
        $idname = substr($idname, CLX_NUM_ZERO, CLX_NUM_60);
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('INVT');
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->invtname);
        //Read information to build Invoi
        $DBLT = &getTool('DBLT');
        $idname = $DBLT->getListItem('SOTY', $this->je_source);
        $idname = substr($idname, CLX_NUM_ZERO, CLX_NUM_60);
        if (!class_exists('Jehd'))
            includeCodeLib('Jehd');
        $jehd = new Jehd();
        $jehd->display = $this->display;
        $operation_date = $comprec['OPERATION_DATE'];
        $comp_code = $comprec['IDCODE'];
        //Clear temporary Table
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('INVT'); //Clear tmp
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->invtname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
        //$sql = 'INSERT INTO ' . $this->invtname . ' (IDNAME, VENDOR_CODE, INVOICEDATE, DUE_DATE, CURRENCY_CODE, INVOICE_AMT, EXT_REF_NO, INVO_STAT, COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, GL_TYPE, JEHDR_CODE, GL01_CODE, GL02_CODE, TGT_ITEM_CODE, TGT_ITEM2_CODE, BATCH_ID, CDATE, CREATEDBY, FEE_01_RATE, GL03_CODE, FROM_CONTRACT_CODE, COMMISSION_CODE) SELECT ' . singleQuote($idname) . ' IDNAME, AAGR.CHART_FIELD02 VENDOR_CODE, ' . singleQuote($operation_date) . ' INVOICEDATE, AAGR.CLX_EFFTDATE DUE_DATE, AAGR.CURRENCY_CODE, AAGR.AGREEMENT_AMT INVOICE_AMT, AAGR.IDCODE EXT_REF_NO, ' . "'01'" . ' INVO_STAT, GLCP.COMP_CODE, AAGR.CHART_FIELD01, AAGR.CHART_FIELD02, FIAE.CHART_FIELD03, null CHART_FIELD04, ' . singleQuote('RENT') . ' ITEM_CODE, GLAC.GL_TYPE, null JEHDR_CODE, PRAT.RENT2_GL_CODE GL01_CODE, PRAT.RENT_GL_CODE GL02_CODE, PRAT.RENT2_ITEM_CODE TGT_ITEM_CODE, PRAT.RENT_ITEM_CODE TGT_ITEM2_CODE, ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->username) . ' CREATEDBY, null FEE_01_RATE, null GL03_CODE, null FROM_CONTRACT_CODE, null COMMISSION_CODE FROM ' . $this->pratname . ' PRAT, ' . $this->fiaename . ' FIAE, ' . $this->glcpname . ' GLCP, ' . $this->aagrname . ' AAGR, ' . $this->fiasname . ' FIAS, ' . $this->fipaname . ' FIPA, ' . $this->glacname . ' GLAC WHERE GLCP.COMP_CODE = AAGR.COMP_CODE AND GLAC.IDCODE = PRAT.RENT2_GL_CODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND FIPA.CONTRACT_CODE = AAGR.CHART_FIELD01 AND FIPA.ACCOUNTCODE = AAGR.CHART_FIELD02 AND FIPA.STATUS = ' . singleQuote('A') . ' AND PRAT.PRODUCT_CODE = FIAE.PRODUCT_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND FIAE.IDCODE = AAGR.ASSETCODE AND FIAS.CONTRACT_CODE = AAGR.CHART_FIELD01 AND FIAS.ASSET_CODE = AAGR.ASSETCODE AND AAGR.START_DATE < ' . singleQuote($operation_date) . ' AND (AAGR.END_DATE >= ' . singleQuote($operation_date) . ' OR AAGR.END_DATE IS NULL) AND GLCP.COMP_CODE =  ' . singleQuote($comp_code) . ' AND AAGR.AGREEMNT_CLASS = ' . singleQuote('300') . ' AND AAGR.AGREEMENT_AMT <> 0 AND AAGR.NEXT_RENT_DATE = GLCP.OPERATION_DATE AND FIAE.CLX_EFFTDATE = (SELECT MAX(FIAEX.CLX_EFFTDATE) FROM AMGT_ASSETS FIAEX WHERE FIAEX.IDCODE = FIAE.IDCODE AND FIAEX.CLX_EFFTDATE <= ' . singleQuote($operation_date) . ') AND AAGR.CLX_EFFTDATE = (SELECT MAX(AAGRX.CLX_EFFTDATE) FROM AMGT_AGREEMENTS AAGRX WHERE AAGRX.IDCODE = AAGR.IDCODE AND AAGRX.CLX_EFFTDATE<= ' . singleQuote($operation_date) . ')';
        $sql = 'INSERT INTO ' . $this->invtname . ' (IDNAME, VENDOR_CODE, INVOICEDATE, DUE_DATE, CURRENCY_CODE, INVOICE_AMT, EXT_REF_NO, INVO_STAT, COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, GL_TYPE, JEHDR_CODE, GL01_CODE, GL02_CODE, TGT_ITEM_CODE, TGT_ITEM2_CODE, BATCH_ID, CDATE, CREATEDBY, FEE_01_RATE, GL03_CODE, FROM_CONTRACT_CODE, COMMISSION_CODE) SELECT ' . singleQuote($idname) . ' IDNAME, AAGR.CONTRACTEE_CODE VENDOR_CODE, ' . singleQuote($operation_date) . ' INVOICEDATE, AAGR.CLX_EFFTDATE DUE_DATE, AAGR.CURRENCY_CODE, AAGR.AGREEMENT_AMT INVOICE_AMT, AAGR.IDCODE EXT_REF_NO, ' . "'01'" . ' INVO_STAT, GLCP.COMP_CODE, AAGR.CHART_FIELD01,AAGR.CHART_FIELD02,  FIAE.CHART_FIELD03, null CHART_FIELD04, ' . singleQuote('RENT') . ' ITEM_CODE, GLAC.GL_TYPE, null JEHDR_CODE, PRAT.RENT2_GL_CODE GL01_CODE, PRAT.RENT_GL_CODE GL02_CODE, PRAT.RENT2_ITEM_CODE TGT_ITEM_CODE, PRAT.RENT_ITEM_CODE TGT_ITEM2_CODE, ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->username) . ' CREATEDBY, null FEE_01_RATE, null GL03_CODE, null FROM_CONTRACT_CODE, null COMMISSION_CODE FROM ' . $this->pratname . ' PRAT, ' . $this->fiaename . ' FIAE, ' . $this->glcpname . ' GLCP, ' . $this->aagrname . ' AAGR, ' . $this->fiasname . ' FIAS, ' . $this->fipaname . ' FIPA, ' . $this->glacname . ' GLAC WHERE GLCP.COMP_CODE = AAGR.COMP_CODE AND GLAC.IDCODE = PRAT.RENT2_GL_CODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND FIPA.CONTRACT_CODE = AAGR.CHART_FIELD01 AND FIPA.ACCOUNTCODE = AAGR.CHART_FIELD02 AND FIPA.STATUS = ' . singleQuote('A') . ' AND PRAT.PRODUCT_CODE = FIAE.PRODUCT_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND FIAE.IDCODE = AAGR.ASSETCODE AND FIAS.CONTRACT_CODE = AAGR.CHART_FIELD01 AND FIAS.ASSET_CODE = AAGR.ASSETCODE  AND AAGR.START_DATE < ' . singleQuote($operation_date) . ' AND (AAGR.END_DATE >= ' . singleQuote($operation_date) . ' OR AAGR.END_DATE IS NULL) AND GLCP.COMP_CODE =  ' . singleQuote($comp_code) . ' AND AAGR.AGREEMNT_CLASS = ' . singleQuote('300') . ' AND AAGR.AGREEMENT_AMT <> 0 AND AAGR.NEXT_RENT_DATE = GLCP.OPERATION_DATE AND FIAE.CLX_EFFTDATE = (SELECT MAX(FIAEX.CLX_EFFTDATE) FROM AMGT_ASSETS FIAEX WHERE FIAEX.IDCODE = FIAE.IDCODE AND FIAEX.CLX_EFFTDATE <= ' . singleQuote($operation_date) . ') AND AAGR.CLX_EFFTDATE = (SELECT MAX(AAGRX.CLX_EFFTDATE) FROM AMGT_AGREEMENTS AAGRX WHERE AAGRX.IDCODE = AAGR.IDCODE AND AAGRX.CLX_EFFTDATE<= ' . singleQuote($operation_date) . ')';
        //pre(beautiful_sql($sql));
        if (!empty($asset_code))
            $sql .=' AND FIAE.IDCODE = ' . singleQuote($asset_code) . ' ';
        ClxCommon::$db->executeQuery($sql); 
        //Return if no record
       /* if (ClxCommon::$db->oneExistsRecords($this->invtname, 'BATCH_ID=' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            return;
        }*/
        //Setting next Run Date
        $sql = 'UPDATE ' . $this->aagrname . ' AAGR, ' . $this->invtname . ' INVT SET AAGR.LAST_RENT_DATE = AAGR.NEXT_RENT_DATE, AAGR.NEXT_RENT_DATE = GL_NEXT_PAYMENT_DATE(AAGR.START_DATE, (case AAGR.PAYMENT_FREQ WHEN ' . singleQuote('12') . ' THEN 1 WHEN ' . singleQuote('2') . ' THEN 6 WHEN ' . singleQuote('1') . ' THEN 12 WHEN ' . singleQuote('3') . ' THEN 4 WHEN ' . singleQuote('4') . ' THEN 3 ELSE AAGR.PAYMENT_FREQ END), AAGR.NEXT_RENT_DATE) WHERE INVT.EXT_REF_NO = AAGR.IDCODE AND INVT.DUE_DATE = AAGR.CLX_EFFTDATE AND INVT.BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
        ClxCommon::$db->executeQuery($sql);
        //pre(beautiful_sql($sql));
        //Check cases where next rent is greater than end date then end date. this only where end date is not null
        $sql = 'UPDATE ' . $this->aagrname . ' AAGR, ' . $this->invtname . ' INVT SET AAGR.NEXT_RENT_DATE = AAGR.END_DATE WHERE INVT.EXT_REF_NO = AAGR.IDCODE AND INVT.DUE_DATE = AAGR.CLX_EFFTDATE AND INVT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND AAGR.END_DATE IS NULL AND AAGR.NEXT_RENT_DATE>AAGR.END_DATE';
        ClxCommon::$db->executeQuery($sql);
       // pre(beautiful_sql($sql));
        //Update glaccounts
        $sql = 'UPDATE ' . $this->invtname . ' INVT, ' . $this->jeitname . ' JEIT SET INVT.GL01_CODE = JEIT.GLACCOUNTCODE WHERE INVT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND JEIT.IDCODE = INVT.TGT_ITEM_CODE AND JEIT.CLX_EFFTDATE=(SELECT MAX(JEITX.CLX_EFFTDATE) FROM ' . $this->jeitname . ' JEITX WHERE JEITX.IDCODE = JEIT.IDCODE AND JEITX.CLX_EFFTDATE <= INVT.INVOICEDATE)';
        ClxCommon::$db->executeQuery($sql);
       // pre(beautiful_sql($sql));
        $sql = 'UPDATE ' . $this->invtname . ' INVT, ' . $this->jeitname . ' JEIT SET INVT.GL02_CODE = JEIT.GLACCOUNTCODE WHERE INVT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND JEIT.IDCODE = INVT.TGT_ITEM2_CODE AND JEIT.CLX_EFFTDATE=(SELECT MAX(JEITX.CLX_EFFTDATE) FROM ' . $this->jeitname . ' JEITX WHERE JEITX.IDCODE = JEIT.IDCODE AND JEITX.CLX_EFFTDATE <= INVT.INVOICEDATE)';
        ClxCommon::$db->executeQuery($sql);
       // pre(beautiful_sql($sql));
        //Setting gltype
        $sql = 'UPDATE ' . $this->invtname . ' INVT, ' . $this->glacname . ' GLAC SET INVT.GL_TYPE = GLAC.GL_TYPE WHERE INVT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLAC.IDCODE = INVT.GL01_CODE';
        ClxCommon::$db->executeQuery($sql);
       // pre(beautiful_sql($sql));
        //Setting Operation date
        $sql = 'UPDATE ' . $this->invtname . ' INVT SET INVT.DUE_DATE = ' . singleQuote($operation_date) . ' WHERE INVT.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
       // pre(beautiful_sql($sql));
        //Build Invoice
        if (!class_exists('Apin'))
            includeCodeLib('APIN');
        
        $apin = new Apin();
        $apin->buildInvoceFromInvt($this->batch_id, 'LI', 'PEND', true);
        if (!class_exists('Invo'))
            includeCodeLib('INVO');
        $invo = new Invo();
        $invo->buildInvoceFromInvt($this->batch_id, 'AS', 'PEND', true);
        unset($invo);
    }

}
