<?php

/**
 * Description of asin
 *
 * @author jalvarez
 */
class asin {

    //put your code here
    var $display = false;

    function __construct($procParameters = array()) {
        multiTableName($this, array('FIAS', 'FIAE', 'PROD', 'PRAT', 'GLAC', 'AMDS', 'GLT1', 'JEHD', 'JELN', 'FIAT', 'JCBV', 'FILC', 'FILO', 'ACCO', 'COMP', 'ASIN'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
        $this->je_source = '';
    }

    function validate_form(&$record, &$msg) {
        // pre($ac);
        //colocar aqui la validacion de fecha menor
        if (UserRequest::$request['ac'] === 'CREATE') {
            $sql = 'SELECT GLCP.COMP_CODE, GLCP.OPERATION_DATE, FIAE.VALORIZATION_METHOD, FIAE.VAL_INS_TYPE, FIAE.CLX_EFFTDATE FROM AMGT_ASSETS FIAE, GL_PARAMETERS_TBL GLCP WHERE FIAE.COMP_CODE = GLCP.COMP_CODE AND FIAE.IDCODE =' . singleQuote($record['ASIN_ASSET_CODE']) . ' AND FIAE.CLX_EFFTDATE = (SELECT MAX(FIAE.CLX_EFFTDATE) FROM AMGT_ASSETS FIAEX WHERE FIAEX.IDCODE = FIAE.IDCODE AND FIAEX.CLX_EFFTDATE <= NOW())';
            //fecha de opoeraciones
            $resultado = ClxCommon::$db->getOneRecord($sql);
            $operation_date = $resultado['OPERATION_DATE'];
            if (trim($record['ASIN_CLX_EFFTDATE']) < $resultado['CLX_EFFTDATE']) {
                $msg['ASIN_CLX_EFFTDATE'] = smsg('MSG-475', $record['ASIN_CLX_EFFTDATE']);
                //addMessage($msg['ASIN_CLX_EFFTDATE']);
                return false;
            }

            if (trim($record['ASIN_CLX_EFFTDATE']) > trim($operation_date)) {
                $msg['ASIN_CLX_EFFTDATE'] = smsg('MSG-456', $record['ASIN_ASSET_CODE']);
                //addMessage($msg['ASIN_CLX_EFFTDATE']);
                return false;
            }

            if (trim($record['ASIN_START_DATE']) > (trim($operation_date))) {
                $msg['ASIN_START_DATE'] = smsg('MSG-457', $record['ASIN_ASSET_CODE']);
                //addMessage($msg['ASIN_START_DATE']);
                return false;
            }

            if (!empty($record['ASIN_END_DATE']) && trim($record['ASIN_START_DATE']) >= trim($record['ASIN_END_DATE'])) {
                $msg['ASIN_END_DATE'] = smsg('MSG-489', $record['ASIN_ASSET_CODE']);
                //addMessage($msg['ASIN_END_DATE']);
                return false;
            }

            $sql = 'SELECT ASIN.CLX_EFFTDATE FROM FIDU_ASSET_INSURANCES ASIN WHERE ASIN.ASSET_CODE =' . singleQuote($record['ASIN_ASSET_CODE']) . ' ORDER BY ASIN.CLX_EFFTDATE DESC';
            $resultado = ClxCommon::$db->getOneRecord($sql);
            $efftdate_asin = $resultado['CLX_EFFTDATE'];
            if ($record['ASIN_CLX_EFFTDATE'] < $efftdate_asin) {
                $msg['ASIN_CLX_EFFTDATE'] = smsg('MSG-459', $efftdate_asin);
                //addMessage($msg['ASIN_CLX_EFFTDATE']);
                return false;
            }
        }
        if (UserRequest::$request['ac'] === 'MODIFY' || UserRequest::$request['ac'] === 'DELETE') {
            $sql = 'SELECT JEHD.IDCODE, JEHD.JE_STATUS FROM ' . $this->asinname . ' ASIN, ' . $this->jehdname . ' JEHD WHERE ASIN.JEHDR_CODE = JEHD.IDCODE AND ASIN.IDCODE =' . singleQuote($record['ASIN_IDCODE']);
            $resultado = ClxCommon::$db->getOneRecord($sql);
            //pre($sql);
            if (!empty($resultado['JE_STATUS']) && $resultado['JE_STATUS'] <> 'PEND') {
                $msg['ASIN_ASSET_CODE'] = smsg('MSG-452', $record['ASIN_ASSET_CODE']);
                if(UserRequest::$request['ac'] === 'DELETE'){
                    addMessage(smsg('MSG-452', $msg['ASIN_ASSET_CODE']).' '.$resultado['IDCODE']);
                }
                return false;
            } else {
                if (UserRequest::$request['ac'] === 'DELETE') {

                    $sql = 'DELETE JELN.* FROM ' . $this->jelnname . ' JELN WHERE JELN.JEHDR_CODE =' . singleQuote($record['ASIN_JEHDR_CODE']).' AND EXISTS (SELECT JEHD.ID FROM GL_JOURNAL_HDR JEHD WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JEHD.JE_STATUS = '.singleQuote('PEND').')';
                    ClxCommon::$db->executeQueryVoid($sql);

                    $sql = 'DELETE JEHD.* FROM ' . $this->jehdname . ' JEHD WHERE JEHD.JE_STATUS = '.singleQuote('PEND').' AND JEHD.IDCODE =' . singleQuote($record['ASIN_JEHDR_CODE']);
                    ClxCommon::$db->executeQueryVoid($sql);
                    return true;

                }
            }
        }
    }

    /**
     * Init record information
     * @param type $record
     */
    function init_form(&$record) {


        if (UserRequest::$request['ac'] === 'CREATE' && empty(UserRequest::$request['confirm']) && !empty($record['ASIN_ASSET_CODE'])) {
            $sql = 'SELECT GLCP.OPERATION_DATE, FIAE.CURRENCY_CODE, FIAE.SALVAGE_VALUE, FIAE.DEPRECIATION_METHOD, FIAE.VALORIZATION_METHOD, FIAE.CLX_EFFTDATE FROM AMGT_ASSETS FIAE, GL_PARAMETERS_TBL GLCP WHERE FIAE.COMP_CODE = GLCP.COMP_CODE AND FIAE.IDCODE =' . singleQuote($record['ASIN_ASSET_CODE']) . ' AND FIAE.CLX_EFFTDATE = (SELECT MAX(FIAE.CLX_EFFTDATE) FROM AMGT_ASSETS FIAEX WHERE FIAEX.IDCODE = FIAE.IDCODE AND FIAEX.CLX_EFFTDATE <= NOW())';
            $r = ClxCommon::$db->getOneRecord($sql);
            $record['ASIN_CURRENCY_CODE'] = $r['CURRENCY_CODE'];
            $record['ASIN_DEPRECIATION_METHOD'] = $r['DEPRECIATION_METHOD'];
            $record['ASIN_SALVAGE_VALUE'] = $r['SALVAGE_VALUE'];
            $record['ASIN_CLX_EFFTDATE'] = $r['OPERATION_DATE'];
        }
    }

    function save_form_post(&$record) {
        $sql = 'SELECT FIAE.COMP_CODE, ASIN.IDCODE, ASIN.ASSET_CODE, ASIN.CLX_EFFTDATE, ASIN.JEHDR_CODE, ASIN.END_DATE, GLCP.OPERATION_DATE, FIAE.VALORIZATION_METHOD, FIAE.VAL_INS_TYPE FROM AMGT_ASSETS FIAE, FIDU_ASSET_INSURANCES ASIN, GL_PARAMETERS_TBL GLCP WHERE ASIN.ASSET_CODE = FIAE.IDCODE AND FIAE.COMP_CODE = GLCP.COMP_CODE AND ASIN.IDCODE =' . singleQuote($record['IDCODE']) . ' AND ASIN.CLX_EFFTDATE = ' . singleQuote($record['CLX_EFFTDATE']) . ' AND FIAE.VAL_INS_TYPE = ASIN.INS_TYPE AND FIAE.IDCODE = ASIN.ASSET_CODE AND FIAE.CLX_EFFTDATE = (SELECT MAX(FIAE.CLX_EFFTDATE) FROM AMGT_ASSETS FIAEX WHERE FIAEX.IDCODE = FIAE.IDCODE AND FIAEX.CLX_EFFTDATE <=NOW())';
        $rs = ClxCommon::$db->executeQuery($sql);
        $val_ins_type_record = $record['INS_TYPE'];
        //pre($record);

        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $this->buil_insurance_valorization($r['COMP_CODE'], $r['IDCODE'], $r['ASSET_CODE'], $r['CLX_EFFTDATE'], $r['JEHDR_CODE'], $r['END_DATE'], $r['OPERATION_DATE'], $r['VALORIZATION_METHOD'], $r['VAL_INS_TYPE'], $val_ins_type_record);
        }
		ClxCommon::$db->freeResult($rs);
    }

    private function buil_insurance_valorization($comp_code, $idcode, $assetcode, $clx_efftdate, $jehdr_code, $end_date, $operation_date, $valorization_method, $val_ins_type, $val_ins_type_record) {
        $this->je_source = 'AMGT.ASIN'; //provision de intereses de prestamos
        $DBLT = &getTool('DBLT');
        $idname = $DBLT->getListItem('SOTY', $this->je_source);
        $idname = substr($idname, CLX_NUM_ZERO, CLX_NUM_60);
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($comp_code);
        $operation_date = $comprec['OPERATION_DATE'];
        //colocar aqui la validacion de fecha final
        if ((trim($end_date) > trim($operation_date)) && (trim($valorization_method) === '2') && (trim($val_ins_type) == trim($val_ins_type_record))) {
            if (empty($comprec) || empty($comp_code)) {
                echoLog('Error, no company operation parameters found');
            }
            //Init Temporary Tables
            $this->initTemporaryTables($this->batch_id);
            //loading temporary table
            $sql = ' INSERT INTO ' . $this->glt1name . ' (BATCH_ID, COMP_CODE, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL02_CODE, GL03_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, LOAN_CODE, PRODUCT_CODE) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote($comp_code) . '  COMP_CODE, FIAE.CLX_EFFTDATE EFFTDATE, PRAT.VALOR_GL_CODE GLACCOUNTCODE, PRAT.VALOR2_GL_CODE GL01_CODE, PRAT.VALOR3_GL_CODE GL02_CODE, PRAT.VALOR4_GL_CODE GL03_CODE, MAX(JCBV.GL_TYPE) GL_TYPE, SUM(JCBV.BALANCE_AMT) BALANCE_AMT, IF(MIN(JCBV.GL_TYPE) = ' . singleQuote('AS') . ',(SUM(JCBV.BALANCE_AMT) - ASIN.COVERAGE_AMT), (- 1 *SUM(JCBV.BALANCE_AMT) - ASIN.COVERAGE_AMT)) CALC_AMT_01, SUM(JCBV.BALANCE_AMT) CALC_AMT_02, 0 CALC_AMT_03, ASIN.COVERAGE_AMT CALC_AMT_04, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, FIAE.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_AMT, 0 CREDIT_AMT, 0 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, FIAE.IDCODE LOAN_CODE, FIAE.PRODUCT_CODE FROM ' . $this->fiaename . ' FIAE, ' . $this->asinname . ' ASIN, ' . $this->fiasname . ' FIAS, ' . $this->jcbvname . ' JCBV, ' . $this->pratname . ' PRAT WHERE 1 = 1 AND ASIN.ASSET_CODE = FIAE.IDCODE AND ASIN.ASSET_CODE =' . singleQuote($assetcode) . ' AND ASIN.CLX_EFFTDATE = ' . singleQuote($clx_efftdate) . ' AND FIAS.IDCODE = JCBV.CHART_FIELD03 AND PRAT.PRODUCT_CODE = FIAE.PRODUCT_CODE AND JCBV.GLACCOUNTCODE IN (PRAT.PRO_GL_CODE, PRAT.VALOR_GL_CODE, PRAT.VALOR3_GL_CODE,PRAT.DPRAC_GL_CODE) AND FIAE.IDCODE = FIAS.ASSET_CODE AND FIAE.CURRENCY_CODE = JCBV.CURRENCY_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND FIAE.VAL_INS_TYPE = ASIN.INS_TYPE AND FIAE.COMP_CODE = ' . singleQuote($comp_code) . ' AND FIAE.CLX_EFFTDATE = (SELECT MAX(FIAE2.CLX_EFFTDATE) FROM ' . $this->fiaename . ' FIAE2 WHERE FIAE2.IDCODE = FIAE.IDCODE AND FIAE2.CLX_EFFTDATE<=' . singleQuote($operation_date) . ') GROUP BY FIAE.CLX_EFFTDATE, PRAT.VALOR_GL_CODE, PRAT.VALOR2_GL_CODE, PRAT.VALOR3_GL_CODE, PRAT.VALOR4_GL_CODE, ASIN.COVERAGE_AMT, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, FIAE.CURRENCY_CODE, FIAE.IDCODE, FIAE.PRODUCT_CODE';
            ClxCommon::$db->executeQuery($sql);
            if (ClxCommon::$db->oneExistsRecords($this->glt1name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
                return;
            }
            /* COLOCANDO CONVERSIONES DE MONEDAS PARA ACTIVIDADES */
            $sql = 'SELECT DISTINCT CURRENCY_CODE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $rate = $comp->comp_current_exchange($comp_code, $r['CURRENCY_CODE'], $operation_date);
                $sql = 'UPDATE ' . $this->glt1name . ' SET CUR_OPERATOR = ' . singleQuote($rate['CUR_OPERATOR']) . ', EXCHANGE_RT = ' . singleQuote($rate['EXCHANGE_RT']) . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CURRENCY_CODE =' . singleQuote($r['CURRENCY_CODE']);
                ClxCommon::$db->executeQuery($sql);
            } //end while
            //Delete all participants where rows from overdraft loans. or cero that will not earn int.
            $sql = 'DELETE FROM ' . $this->glt1name . ' WHERE CALC_AMT_01 = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Colocando monto total
            $sql = 'UPDATE ' . $this->glt1name . ' SET BALANCE_AMT = CALC_AMT_01, CALC_AMT_03 = CALC_AMT_01 WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Colocando contabilidad
            //REEMPLAZANDO LAS CUENTAS CONTABLES
            $sql = 'UPDATE ' . $this->glt1name . ' SET GLACCOUNTCODE = GL02_CODE, GL01_CODE = GL03_CODE WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND BALANCE_AMT < 0 ';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' SET  DEBIT_TRANS_AMT = IF(BALANCE_AMT < 0, BALANCE_AMT * -1, BALANCE_AMT), DEBIT_AMT = ROUND((IF(BALANCE_AMT < 0, BALANCE_AMT * -1, BALANCE_AMT) * POW(EXCHANGE_RT, CUR_OPERATOR)), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND ((GL_TYPE = ' . singleQuote('AS') . ' AND BALANCE_AMT > 0) OR (GL_TYPE <> ' . singleQuote('AS') . ' AND BALANCE_AMT < 0))';
            /*
             *
             * SI EL TIPO ES AS Y EL SALDO ES POSITIVO DEBE IR POR EL DEBE (DEBIT)
             * SI EL TIPO ES AS Y EL SALDO ES NEGATIVO DEBE IR POR EL HABER (CREDIT)
             * SI EL TIPO NO ES AS Y EL SALDO ES POSITIVO DEBE IR POR EL HABER (CREDIT)
             * SI EL TIPO ES AS Y EL SALDO ES NEGATIVO DEBE IR POR EL DEBE (DEBIT)
             */
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' SET CREDIT_TRANS_AMT = IF(BALANCE_AMT < 0, BALANCE_AMT * -1, BALANCE_AMT), CREDIT_AMT = ROUND((IF(BALANCE_AMT < 0, BALANCE_AMT * -1, BALANCE_AMT) * POW(EXCHANGE_RT, CUR_OPERATOR)), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND ((GL_TYPE <> ' . singleQuote('AS') . ' AND BALANCE_AMT > 0) OR (GL_TYPE = ' . singleQuote('AS') . ' AND BALANCE_AMT < 0))';
            ClxCommon::$db->executeQuery($sql);
            if (!class_exists('Jehd'))
                includeCodeLib('Jehd');
            $jehd = new Jehd();
            //$this->display = true;
            $jehd->display = $this->display;
            //Reject any posible todays entry from this process thas has run today
            /* 2. GENERAR ACTIVIDADES DE DEVENGO PARA PARTICIPANTES DE CONTRATO */
            //Build Header for this process, one pre currency
            $sql = 'SELECT DISTINCT COMP_CODE, ' . singleQuote($operation_date) . ' OPERATION_DATE, ' . singleQuote($comprec['LGGROUP_CODE']) . ' LGGROUP_CODE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
            $results = ClxCommon::$db->executeQuery($sql);
            while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                $gl_rec = $jehd->jehd_init_record();
                if (UserRequest::$request['ac'] === 'MODIFY' || UserRequest::$request['ac'] === 'DUPLICATE_EFFTDATE') {
                    $gl_rec['IDCODE'] = $jehdr_code;
                }
                $gl_rec['IDNAME'] = $idname;
                $gl_rec['JE_SOURCE'] = $this->je_source;
                $gl_rec['LGGROUP_CODE'] = $result['LGGROUP_CODE'];
                $gl_rec['EFFTDATE'] = $result['OPERATION_DATE'];
                $gl_rec['REAL_DATE'] = $result['OPERATION_DATE'];
                $gl_rec['COMP_CODE'] = $result['COMP_CODE'];
                $gl_rec['TRANS_CODE'] = null;
                $gl_rec['REQ_CHANNEL'] = 'SYS';

                $gl_rec['BATCH_ID'] = $jehdr_code;
                $jehd->jehd_build($gl_rec);
                if (UserRequest::$request['ac'] === 'MODIFY' || UserRequest::$request['ac'] === 'DUPLICATE_EFFTDATE') {
                    $sql = 'SELECT JEHD.IDCODE IDCODE, JEHD.JE_STATUS STATUS FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JEHD.IDCODE = ' . singleQuote($jehdr_code) . ' AND JEHD.JE_STATUS =' . singleQuote('PEND') . '';
                    $resultado = ClxCommon::$db->getOneRecord($sql);
                    if (!empty($resultado['IDCODE'])) {
                        $sql = 'DELETE FROM ' . $this->jelnname . ' WHERE JEHDR_CODE = ' . singleQuote($jehdr_code);
                        ClxCommon::$db->executeQuery($sql);
                    }
                }
                //Search any scale if apply and dump lines to journal
                //debit in credit as
                $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GL01_CODE GLACCOUNTCODE, ' . singleQuote('IP') . ' ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.DEBIT_TRANS_AMT, X.CREDIT_TRANS_AMT, X.DEBIT_AMT, X.CREDIT_AMT, 1 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
                ClxCommon::$db->executeQuery($sql);
                //contraparte
                $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GLACCOUNTCODE GLACCOUNTCODE, ' . singleQuote('IP') . ' ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.CREDIT_TRANS_AMT DEBIT_TRANS_AMT, X.DEBIT_TRANS_AMT CREDIT_TRANS_AMT, X.CREDIT_AMT DEBIT_AMT, X.DEBIT_AMT CREDIT_AMT, 2 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
                ClxCommon::$db->executeQuery($sql);
                //Removing sub account from in,ex,eq
                $sql = 'UPDATE ' . $this->jelnname . ' JELN SET JELN.CHART_FIELD03 = null WHERE JELN.JEHDR_CODE =' . singleQuote($gl_rec['IDCODE']) . ' AND EXISTS(SELECT GLAC.ID FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GL_TYPE IN (' . singleQuote('IN') . ',' . singleQuote('EX') . ',' . singleQuote('EQ') . '))';
                ClxCommon::$db->executeQuery($sql);
                //Actualizar en el Seguro creado el código del comprobante generado
                $sql = 'UPDATE ' . $this->asinname . ' ASIN SET ASIN.JEHDR_CODE =' . singleQuote($gl_rec['IDCODE']) . ' WHERE ASIN.IDCODE =' . singleQuote($idcode) . ' AND ASIN.CLX_EFFTDATE = ' . singleQuote($clx_efftdate);
                // pre($sql);
                ClxCommon::$db->executeQuery($sql);
                //Verificando conversion;
                $jehd->balance_exchange_rounding($gl_rec['IDCODE']);
            }
			ClxCommon::$db->freeResult($results);
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
        }
    }

    //Actualizar en el Seguro creado el código del comprobante generado
    private function initTemporaryTables($batch_id) {
        // Load temporary table - Req on mysql
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('GLT1');
        // Clear tmp
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($batch_id));
    }

}
