<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author	   $Author: jclerma $
 * @copyright	Alenet, Inc.
 * @since		$Date: 2016-09-29 15:21:10 -0400 (Thu, 29 Sep 2016) $
 * @version		$Rev: 8752 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Fiac {

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return voidFIBK_LSRCH
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('INVO', 'APIN', 'INVT', 'GDVW', 'FTMP', 'FICO', 'COMP', 'TTPA', 'FETR', 'FIPA', 'FIAC', 'FIRT', 'FIRS', 'CURR', 'JACP', 'JABV', 'FITS', 'GLCP', 'JEHD', 'FIAT', 'JELN', 'FIBK', 'GLAC', 'JTMP', 'GDVW', 'GLCT', 'GLCT', 'JEIT', 'INPY'));
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Initialice firt form
     * Executed on init event
     */
    function fiac_init_form(&$record) {
        if (empty(UserRequest::$post ['confirm']) && (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE')) {
            if (!class_exists('Fico'))
                includeCodeLib('FICO');
            $fico = new Fico ();
            $comprec = $fico->fico_comp_operation_parameters($record ['FIAC_CONTRACT_CODE']);
            $record ['FIAC_EFFTDATE'] = $comprec ['OPERATION_DATE'];
            $record ['FIAC_IDCODE'] = 'AUTO';
            if (UserRequest::$request['ac'] === 'CREATE') {
                $record ['FIAC_BRANCH_PRN_prim'] = companyParameter('BRANCH_PRN', $comprec ['IDCODE']);
                $record ['FIAC_FIDU_BANKACT_CODE_prim'] = companyParameter('FIDU_BANK_ACCOUNT', $comprec ['IDCODE']);
                $record ['FIAC_BENEFICIARY_NAME'] = $comprec ['LEGAL_NAME'];
            }
        }
    }

// end function
    /**
     * Validate record information
     * Executed on table validate
     */
    function fiac_validate_form(&$record, &$msg) {
        $sql = 'SELECT COUNT(FIRT.ID)  FROM  ' . $this->firtname . ' FIRT,  ' . $this->ficoname . ' FICO WHERE  FICO.COMP_CODE = FIRT.COMP_CODE AND FIRT.STATUS = ' . singleQuote('I') . ' AND FICO.IDCODE = ' . singleQuote($record ['FIAC_CONTRACT_CODE']) . ' AND FIRT.IDCODE = ' . singleQuote($record ['FIAC_FIDU_RATETBLCODE']);
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
            $msg ['FIAC_FIDU_RATETBLCODE'] = smsg('MSG-82', $record ['FIAC_FIDU_RATETBLCODE']);
        }
        $sql = 'SELECT COUNT(FIRT.ID)  FROM  ' . $this->firtname . ' FIRT,  ' . $this->ficoname . ' FICO WHERE  FICO.COMP_CODE = FIRT.COMP_CODE AND FICO.IDCODE = ' . singleQuote($record ['FIAC_CONTRACT_CODE']) . ' AND FIRT.IDCODE = ' . singleQuote($record ['FIAC_FIDU_RATETBLCODE']);
        if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
            $msg ['FIAC_FIDU_RATETBLCODE'] = smsg('MSG-81', $record ['FIAC_FIDU_RATETBLCODE']);
        }
        $sql = 'SELECT FIRT.PAY_TX_CODE, GLCP.OPERATION_DATE, FIRT.CHARGE_FREQUENCY, FIRT.CPAY_FREQUENCY FROM ' . $this->firtname . ' FIRT, ' . $this->ficoname . ' FICO, ' . $this->glcpname . ' GLCP WHERE FICO.COMP_CODE = FIRT.COMP_CODE AND GLCP.COMP_CODE = FIRT.COMP_CODE AND FICO.IDCODE = ' . singleQuote($record ['FIAC_CONTRACT_CODE']) . ' AND FIRT.IDCODE = ' . singleQuote($record ['FIAC_FIDU_RATETBLCODE']);
        $rec = ClxCommon::$db->getOneRecord($sql);
        $operation_date = $rec['OPERATION_DATE'];
        if ($rec['CHARGE_FREQUENCY'] <> 'NONE' && $rec['CHARGE_FREQUENCY'] <> 'PAY' && empty($record['FIAC_NEXT_CHARGE_DATE'])) {
            $msg['FIAC_NEXT_CHARGE_DATE'] = smsg('MSG-372', $operation_date);
        }
        if ($rec['CPAY_FREQUENCY'] <> 'NONE' && $rec['CPAY_FREQUENCY'] <> 'PAY' && empty($record['FIAC_NEXT_PAYMNT_DATE'])) {
            $msg['FIAC_NEXT_PAYMNT_DATE'] = smsg('MSG-372', $operation_date);
        }
        if (!empty($record['FIAC_NEXT_CHARGE_DATE']) && $operation_date > $record['FIAC_NEXT_CHARGE_DATE']) {
            $msg['FIAC_NEXT_CHARGE_DATE'] = smsg('MSG-373', $operation_date);
        }
        if (!empty($record['FIAC_NEXT_PAYMNT_DATE']) && $operation_date > $record['FIAC_NEXT_PAYMNT_DATE']) {
            $msg['FIAC_NEXT_PAYMNT_DATE'] = smsg('MSG-373', $operation_date);
        }
        if (!empty($record['FIAC_NEXT_CHARGE_DATE']) && !empty($record['FIAC_NEXT_PAYMNT_DATE']) && $record['FIAC_NEXT_CHARGE_DATE'] > $record['FIAC_NEXT_PAYMNT_DATE']) {
            $msg['FIAC_NEXT_PAYMNT_DATE'] = smsg('MSG-374', $operation_date);
        }
        //Validaciones movidas de firt
        if ($record ['FIAC_ADM_DISMNT_TYPE'] === 'CH') {
            if (empty($record ['FIAC_BENEFICIARY_NAME'])) {
                $msg ['FIAC_BENEFICIARY_NAME'] = smsg('MSG-75');
            }
            if (empty($record ['FIAC_BRANCH_PRN']) && $record ['FIAC_BRANCH_PRN'] <> '0') {
                $msg ['FIAC_BRANCH_PRN'] = smsg('MSG-75');
            }
        }
        $qty = ClxCommon::$db->oneExistsRecords($this->fitsname, 'TRANSTBL_CODE = ' . singleQuote($rec ['PAY_TX_CODE']) . ' AND AFFECT_TYPE = ' . singleQuote('CA') . '');
        if ($qty > CLX_NUM_ZERO && empty($record ['FIAC_FIDU_BANKACT_CODE'])) {
            $msg ['FIAC_FIDU_BANKACT_CODE'] = smsg('MSG-75');
        }
    }

    /**
     * Process that calculates adm fees and build accounting
     *
     * @param string $comp_code
     * @param string $operation_date
     * @param string $contract_code
     * @param string $participant_id
     * @param string $parameters
     */
    function fiac_charge_fees($comp_code, $operation_date = '', $contract_code = '', $participant_id = '', $parameters = array(), $firt_code = '', $test = false) {
        $contents = ''; //used for test fee
        // Initial Parameters and table names
        $je_source = 'FEAD';
        // Determine batch id
        $batch_id = batch_id();
        if (!class_exists('Comp')) {
            includeCodeLib('COMP');
        }
        $comp = new Comp ();
        $comprec = $comp->comp_operation_parameters($comp_code);
        $base_currency = $comprec ['CURRENCY_CODE'];
        // If efftdate is not provided then search operation date day as
        // operation date
        if ($operation_date === '') {
            $operation_date = $comprec ['OPERATION_DATE'];
        }
        if (!class_exists('Jehd'))
            includeCodeLib('JEHD');
        $jehd = new Jehd ();
        if (empty($test)) {
            echoLog(' PROCESSING COMMISION CHARGE. BATCH ID: ' . $batch_id);
            echoLog('Efective charge date : ' . $operation_date);
            echoLog('Company: ' . (($comp_code === '') ? 'ALL' : $comp_code));
            echoLog('Contract: ' . (($contract_code === '') ? 'ALL' : $contract_code));
            echoLog('Participant: ' . (($participant_id === '') ? 'ALL' : $participant_id));
        } else {
            $contents .= '<br>' . echoLog(dict('GEN_LBL_OPERATION_DATE') . ': ' . $operation_date, false);
            $contents .= '<br>' . echoLog(dict('GEN_LBL_COMPANY') . ':' . $comp_code, false);
            $contents .= '<br><br>';
        }
        // Load temporary table - Req on mysql
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('FTMP');
        $DBTB->buildTemporaryTable('JTMP');
        $DBTB->buildTemporaryTable('GLCT');
        // Clearing Temporary table for batch id
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ftmpname);
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->jtmpname);
        // Select all commisions and insert it into tmp table
        // Important note. CALC_AMT_02 holds the normal pct for fee to be
        // used latter when dumping lines, also CALC_AMT_03 counts if it has or
        // not scales. see later dump lines
        // Incluir parametro FIRT.CONTRACT_CALENDAR
        // Not scaled commisions
        $sql = 'INSERT INTO ' . $this->ftmpname . ' (FIDU_RATETBLCODE, EFFTDATE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, LGGROUP_CODE, COMMISSION_CODE, GL01_CODE, CURRENCY_CODE, OPER_CURRENCY_CODE, CALC_AMT_01, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, MINIMUM_FEE, MAXIMUM_FEE, ASSET_COM_BASE, COMP_CODE, FEE_TYPE, SCALE_TYPE, CHARGE_FREQUENCY, CHARGE_DAY, FROM_DATE, TO_DATE, SEQNUM, BATCH_ID, REC_STATUS, ADM_TRANSTBL_CODE, INT_PER_TYPE, NO_DAYS) SELECT FIAC.FIDU_RATETBLCODE, FIRT.CLX_EFFTDATE, FIAC.CONTRACT_CODE CHART_FIELD01, FIPA.ACCOUNTCODE CHART_FIELD02, null CHART_FIELD03, null CHART_FIELD04, FIAC.IDCODE ITEM_REF_NO, FIRT.LGGROUP_CODE, FIAC.IDCODE COMMISSION_CODE, FIRT.GL01_CODE, FIRT.CURRENCY_CODE, FIRT.OPER_CURRENCY_CODE, 0 CALC_AMT_01, FIRT.ASSET_PCT CALC_AMT_02, FIRT.DIVIDER_FACTOR CALC_AMT_03, FIRT.FLAT_FEES CALC_AMT_04, FIRT.MINIMUM_FEE, FIRT.MAXIMUM_FEE, FIRT.ASSET_COM_BASE, FIRT.COMP_CODE, FIRT.FEE_TYPE, FIRT.SCALE_TYPE, FIRT.CHARGE_FREQUENCY, FIRT.CHARGE_DAY, ' . singleQuote($operation_date) . ' FROM_DATE, ' . singleQuote($operation_date) . ' TO_DATE, 0 SEQNUM, ' . singleQuote($batch_id) . ' BATCH_ID, ' . singleQuote('RUN') . ' REC_STATUS, FIRT.ADM_TRANSTBL_CODE, FIRT.INT_PER_TYPE, FIRT.DIVIDER_FACTOR NO_DAYS FROM ' . $this->ficoname . ' FICO, ' . $this->fipaname . ' FIPA, ' . $this->fiacname . ' FIAC, ' . $this->firtname . ' FIRT WHERE FIRT.IDCODE = FIAC.FIDU_RATETBLCODE AND FIAC.CONTRACT_CODE = FICO.IDCODE AND FIPA.CONTRACT_CODE = FICO.IDCODE AND (FIAC.PARTICIPANT_ID = FIPA.ACCOUNTCODE  OR FIAC.PARTICIPANT_ID IS NULL  OR FIAC.PARTICIPANT_ID=' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND FIPA.STATUS = ' . singleQuote('A') . ' AND FIAC.STATUS = ' . singleQuote('A') . ' AND FIRT.STATUS = ' . singleQuote('A') . ' AND FIRT.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE)  FROM ' . $this->firtname . ' X WHERE X.IDCODE = FIRT.IDCODE  AND X.CLX_EFFTDATE<=' . singleQuote($operation_date) . ') AND FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ' AND FIRT.CHARGE_FREQUENCY <> ' . singleQuote('NONE') . ' AND FIAC.NEXT_CHARGE_DATE = ' . singleQuote($operation_date) . ' AND FIPA.PARTICIPANT_TYPE IN (' . singleQuoteArray(array('F', 'B', 'G', 'M', 'MB', 'BES', 'BEF', 'G2', 'BEF2', 'B2', 'FC1', 'FC2')) . ') AND EXISTS(SELECT JELN.ID  FROM ' . $this->jelnname . ' JELN  WHERE JELN.CHART_FIELD01 = FIPA.CONTRACT_CODE AND JELN.CHART_FIELD02 = FIPA.ACCOUNTCODE) AND FIRT.COMP_CODE = ' . singleQuote($comp_code) . '  AND FIRT.FEE_TYPE = ' . singleQuote('ADMN') . '  AND FIRT.SCALE_TYPE = 0 ' . (($contract_code !== '') ? 'AND FICO.IDCODE = ' . singleQuote($contract_code) . ' ' : ' ') . (($firt_code !== '') ? 'AND FIRT.IDCODE = ' . singleQuote($firt_code) . ' ' : ' ') . (($participant_id !== '') ? 'AND FIPA.ACCOUNTCODE = ' . singleQuote($participant_id) . '  ' : ' ');
        ClxCommon::$db->executeQuery($sql);
        // Scale commisiones
        $sql = 'INSERT INTO ' . $this->ftmpname . ' (FIDU_RATETBLCODE, EFFTDATE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, LGGROUP_CODE, COMMISSION_CODE, GL01_CODE, CURRENCY_CODE, OPER_CURRENCY_CODE, CALC_AMT_01, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, MINIMUM_FEE, MAXIMUM_FEE, ASSET_COM_BASE, COMP_CODE, FEE_TYPE, SCALE_TYPE, CHARGE_FREQUENCY, CHARGE_DAY, FROM_DATE, TO_DATE, SEQNUM, BATCH_ID, REC_STATUS, ADM_TRANSTBL_CODE, INT_PER_TYPE, NO_DAYS) SELECT FIAC.FIDU_RATETBLCODE, FIRT.CLX_EFFTDATE, FIAC.CONTRACT_CODE CHART_FIELD01, FIPA.ACCOUNTCODE CHART_FIELD02, null CHART_FIELD03, null CHART_FIELD04, FIAC.IDCODE ITEM_REF_NO, FIRT.LGGROUP_CODE, FIAC.IDCODE COMMISSION_CODE, FIRT.GL01_CODE, FIRT.CURRENCY_CODE, FIRT.OPER_CURRENCY_CODE, 0 CALC_AMT_01, FIRT.ASSET_PCT CALC_AMT_02, FIRT.DIVIDER_FACTOR CALC_AMT_03, FIRT.FLAT_FEES CALC_AMT_04, FIRT.MINIMUM_FEE, FIRT.MAXIMUM_FEE, FIRT.ASSET_COM_BASE, FIRT.COMP_CODE, FIRT.FEE_TYPE, FIRT.SCALE_TYPE, FIRT.CHARGE_FREQUENCY, FIRT.CHARGE_DAY, ' . singleQuote($operation_date) . ' FROM_DATE, ' . singleQuote($operation_date) . ' TO_DATE, FIRS.SEQNUM, ' . singleQuote($batch_id) . ' BATCH_ID, ' . singleQuote('RUN') . ' REC_STATUS, FIRT.ADM_TRANSTBL_CODE, FIRT.INT_PER_TYPE, FIRT.DIVIDER_FACTOR NO_DAYS FROM ' . $this->ficoname . ' FICO, ' . $this->fipaname . ' FIPA, ' . $this->fiacname . ' FIAC, ' . $this->firtname . ' FIRT, ' . $this->firsname . ' FIRS WHERE FIRT.IDCODE = FIAC.FIDU_RATETBLCODE AND FIAC.CONTRACT_CODE = FICO.IDCODE AND FIPA.CONTRACT_CODE = FICO.IDCODE AND (FIAC.PARTICIPANT_ID = FIPA.ACCOUNTCODE OR FIAC.PARTICIPANT_ID IS NULL OR FIAC.PARTICIPANT_ID=' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND FIPA.STATUS = ' . singleQuote('A') . ' AND FIAC.STATUS = ' . singleQuote('A') . ' AND FIRT.STATUS = ' . singleQuote('A') . ' AND FIRT.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->firtname . ' X WHERE X.IDCODE = FIRT.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($operation_date) . ') AND FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ' AND FIRS.FIDU_RATETBLCODE = FIRT.IDCODE AND FIRS.EFFTDATE = FIRT.CLX_EFFTDATE AND FIRT.CHARGE_FREQUENCY <> ' . singleQuote('NONE') . ' AND FIAC.NEXT_CHARGE_DATE = ' . singleQuote($operation_date) . ' AND FIPA.PARTICIPANT_TYPE IN (' . singleQuoteArray(array('F', 'B', 'G', 'M', 'MB', 'BES', 'BEF', 'G2', 'BEF2', 'B2', 'FC1', 'FC2')) . ') AND EXISTS(SELECT JELN.ID  FROM ' . $this->jelnname . ' JELN  WHERE JELN.CHART_FIELD01 = FIPA.CONTRACT_CODE AND JELN.CHART_FIELD02 = FIPA.ACCOUNTCODE) AND FIRT.COMP_CODE = ' . singleQuote($comp_code) . '  AND FIRT.FEE_TYPE = ' . singleQuote('ADMN') . '  AND FIRT.SCALE_TYPE IN (1, 2) ' . (($contract_code !== '') ? 'AND FICO.IDCODE = ' . singleQuote($contract_code) . ' ' : ' ') . (($firt_code !== '') ? 'AND FIRT.IDCODE = ' . singleQuote($firt_code) . ' ' : ' ') . (($participant_id !== '') ? 'AND FIPA.ACCOUNTCODE = ' . singleQuote($participant_id) . '  ' : ' ');
        ClxCommon::$db->executeQuery($sql);
        // Limits
        $sql = 'INSERT INTO ' . $this->ftmpname . ' (FIDU_RATETBLCODE, EFFTDATE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, GL01_CODE, ITEM_REF_NO, LGGROUP_CODE, COMMISSION_CODE, CURRENCY_CODE, OPER_CURRENCY_CODE, CALC_AMT_01, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, MINIMUM_FEE, MAXIMUM_FEE, ASSET_COM_BASE, COMP_CODE, FEE_TYPE, SCALE_TYPE, CHARGE_FREQUENCY, CHARGE_DAY, FROM_DATE, TO_DATE, SEQNUM, BATCH_ID, REC_STATUS, ADM_TRANSTBL_CODE, INT_PER_TYPE, NO_DAYS) SELECT FIAC.FIDU_RATETBLCODE, FIRT.CLX_EFFTDATE, FIAC.CONTRACT_CODE CHART_FIELD01, FIPA.ACCOUNTCODE CHART_FIELD02, null CHART_FIELD03, null CHART_FIELD04, FIRT.GL01_CODE, FIAC.IDCODE ITEM_REF_NO, FIRT.LGGROUP_CODE, FIAC.IDCODE COMMISSION_CODE, FIRT.CURRENCY_CODE, FIRT.OPER_CURRENCY_CODE, 0 CALC_AMT_01, 0 CALC_AMT_02, 0 CALC_AMT_03, 0 CALC_AMT_04, FIRT.MINIMUM_FEE, FIRT.MAXIMUM_FEE, FIRT.ASSET_COM_BASE, FIRT.COMP_CODE, FIRT.FEE_TYPE, FIRT.SCALE_TYPE, FIRT.CHARGE_FREQUENCY, FIRT.CHARGE_DAY, ' . singleQuote($operation_date) . ' FROM_DATE, ' . singleQuote($operation_date) . ' TO_DATE, 0 SEQNUM, ' . singleQuote($batch_id) . ' BATCH_ID, ' . singleQuote('RUN') . ' REC_STATUS, FIRT.ADM_TRANSTBL_CODE, FIRT.INT_PER_TYPE, 0 NO_DAYS FROM ' . $this->ficoname . ' FICO, ' . $this->fipaname . ' FIPA, ' . $this->fiacname . ' FIAC, ' . $this->firtname . ' FIRT WHERE FIRT.IDCODE = FIAC.FIDU_RATETBLCODE AND FIAC.CONTRACT_CODE = FICO.IDCODE AND FIPA.CONTRACT_CODE = FICO.IDCODE AND (FIAC.PARTICIPANT_ID = FIPA.ACCOUNTCODE OR FIAC.PARTICIPANT_ID IS NULL OR FIAC.PARTICIPANT_ID=' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND FIPA.STATUS = ' . singleQuote('A') . ' AND FIAC.STATUS = ' . singleQuote('A') . ' AND FIRT.STATUS = ' . singleQuote('A') . ' AND FIRT.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->firtname . ' X WHERE X.IDCODE = FIRT.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($operation_date) . ') AND FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ' AND FIRT.CHARGE_FREQUENCY <> ' . singleQuote('NONE') . ' AND FIAC.NEXT_CHARGE_DATE = ' . singleQuote($operation_date) . ' AND FIPA.PARTICIPANT_TYPE IN (' . singleQuoteArray(array('F', 'B', 'G', 'M', 'MB', 'BES', 'BEF', 'G2', 'BEF2', 'B2', 'FC1', 'FC2')) . ') AND EXISTS(SELECT JELN.ID  FROM ' . $this->jelnname . ' JELN  WHERE JELN.CHART_FIELD01 = FIPA.CONTRACT_CODE AND JELN.CHART_FIELD02 = FIPA.ACCOUNTCODE) AND FIRT.COMP_CODE = ' . singleQuote($comp_code) . '  AND FIRT.FEE_TYPE = ' . singleQuote('LIMT') . '  AND FIRT.SCALE_TYPE = 0 ' . (($contract_code !== '') ? 'AND FICO.IDCODE = ' . singleQuote($contract_code) . ' ' : ' ') . (($firt_code !== '') ? 'AND FIRT.IDCODE = ' . singleQuote($firt_code) . ' ' : ' ') . (($participant_id !== '') ? 'AND FIPA.ACCOUNTCODE = ' . singleQuote($participant_id) . '  ' : ' ');
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->ftmpname . ' SET INT_PER_TYPE = "" WHERE FEE_TYPE IN ("ADMN", "LIMT") AND CHARGE_FREQUENCY <> "D"';
        ClxCommon::$db->executeQuery($sql);
        // Updating from to dates for limit calculations
        $sql = 'UPDATE ' . $this->ftmpname . '  SET FROM_DATE = (case CHARGE_FREQUENCY  WHEN ' . singleQuote('D') . ' THEN DATE_ADD(FROM_DATE, INTERVAL -1 DAY) WHEN ' . singleQuote('2') . ' THEN DATE_ADD(FROM_DATE, INTERVAL -1 MONTH) WHEN ' . singleQuote('4') . ' THEN DATE_ADD(FROM_DATE, INTERVAL -3 MONTH) WHEN ' . singleQuote('5') . ' THEN DATE_ADD(FROM_DATE, INTERVAL -6 MONTH) WHEN ' . singleQuote('6') . ' THEN DATE_ADD(FROM_DATE, INTERVAL -12 MONTH) END) WHERE BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Calculando el numero de dias del periodo en caso de que sea tipo calendario exacto INT_PER_TYPE=S
        /* Not Applicable (1)
          Monthly 1/12 (12)
          Semiannually 1/180 (180)
          Semiannually 1/2 (2)
          Four-monthly 1/3 (3)
          Monthly 1/30 (30)
          Daily 1/360 (360)
          Daily 1/365 (365)
          Daily 1/366 (366)
          Quarterly 1/4 (4)
          Bimonthly 1/6 (6)
          Quarterly 1/90 (90) */
        $sql = '(case CALC_AMT_03 WHEN 180 THEN 6  WHEN 2 THEN 6  WHEN 90 THEN 3 WHEN 4 THEN 3  WHEN 30 THEN 1 WHEN 12 THEN 1 WHEN 3 THEN 4  WHEN 6 THEN 2  ELSE 12 END) MONTH';
        /*
          Cuando es calculo de días exactos, en estos 3 casos debe dividir entre los días especificados, NO entre los dias del año corriente (que puede ser 364 o 365 porque calcula el intervalo a 12 meses)
         */
        $sql2_beging = '(case CALC_AMT_03 WHEN 360 THEN 360 WHEN 365 THEN 365 WHEN 366 THEN 366 ELSE';
        $sql2_end = ' END )';
        /*
          Daily 1/360 (360)
          Daily 1/365 (365)
          Daily 1/366 (366)
         */
        $sql = 'UPDATE ' . $this->ftmpname . '  SET NO_DAYS =  IFNULL((case CHARGE_DAY WHEN 0 THEN ' . $sql2_beging . ' DATEDIFF(DATE_FORMAT(DATE_ADD(TO_DATE, INTERVAL ' . $sql . ' ),' . singleQuote('%Y-%m-01') . '), DATE_FORMAT(TO_DATE,' . singleQuote('%Y-%m-01') . '))  ' . $sql2_end . '  WHEN 31 THEN ' . $sql2_beging . ' DATEDIFF(DATE_FORMAT(DATE_ADD(TO_DATE, INTERVAL ' . $sql . '),' . singleQuote('%Y-%m-01') . '), DATE_FORMAT(TO_DATE,' . singleQuote('%Y-%m-01') . '))  ' . $sql2_end . '  WHEN 30 THEN ' . $sql2_beging . ' DATEDIFF(DATE_FORMAT(DATE_ADD(TO_DATE, INTERVAL ' . $sql . '),' . singleQuote('%Y-%m-01') . '), DATE_FORMAT(TO_DATE,' . singleQuote('%Y-%m-01') . ')) ' . $sql2_end . '  WHEN 29 THEN ' . $sql2_beging . ' DATEDIFF(DATE_FORMAT(DATE_ADD(TO_DATE, INTERVAL ' . $sql . '),' . singleQuote('%Y-%m-01') . '), DATE_FORMAT(TO_DATE,' . singleQuote('%Y-%m-01') . ')) ' . $sql2_end . '   ELSE ' . $sql2_beging . ' DATEDIFF(DATE_FORMAT(DATE_ADD(TO_DATE, INTERVAL ' . $sql . '),CONCAT(' . singleQuote('%Y-%m-') . ',CHARGE_DAY)), DATE_FORMAT(TO_DATE,CONCAT(' . singleQuote('%Y-%m-') . ',CHARGE_DAY))) ' . $sql2_end . '   END),1) WHERE INT_PER_TYPE = ' . singleQuote('S') . '  AND CALC_AMT_03	 <> 1 AND BATCH_ID = ' . singleQuote($batch_id) . ' AND FEE_TYPE <> ' . singleQuote('LIMT') . ' ';
        ClxCommon::$db->executeQuery($sql);
        // CARGANDO CUENTAS DE MOVIMIENTO POSIBLES. LA IDEA ES QUE SI
        // SELECCIONAN UNA CUENTA PADRE TRAIGA LOS HIJOS
        // SE CARGAN TODAS LAS CUENTAS POSIBLES DE ACUERDO A LA CUENTA PADRE.
        $sql = 'SELECT DISTINCT FTMP.FIDU_RATETBLCODE, CAST(REVERSE(CAST(REVERSE(FTMP.GL01_CODE) AS UNSIGNED INTEGER)) AS CHAR) ACPARENT FROM ' . $this->ftmpname . ' FTMP WHERE  FTMP.COMP_CODE = ' . singleQuote($comp_code) . ' AND FTMP.GL01_CODE IS NOT null';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $sql = 'INSERT INTO	' . $this->glctname . '   (IDCODE, GLGROUP_CODE, ALLOW_ACTIVITY, IS_FEE_ACC, IS_FEE_BR_ACC, COMP_CODE, FIDU_RATETBLCODE) SELECT DISTINCT  GLAC.IDCODE, GLAC.GLGROUP_CODE, GLAC.ALLOW_ACTIVITY, GLAC.IS_FEE_ACC, GLAC.IS_FEE_BR_ACC, GLCP.COMP_CODE, ' . singleQuote($r ['FIDU_RATETBLCODE']) . ' FIDU_RATETBLCODE FROM ' . $this->glacname . ' GLAC, ' . $this->glcpname . ' GLCP WHERE GLCP.COMP_CODE= ' . singleQuote($comp_code) . ' AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC.ALLOW_ACTIVITY = 1 AND GLAC.IDCODE LIKE ' . singleQuote($r ['ACPARENT'] . '%') . '';
            ClxCommon::$db->executeQuery($sql);
        }
		ClxCommon::$db->freeResult($rs);
        //20130711 - Se ajusta para tomar moneda original de comision ya que en bat apreciamos que en caso de comision en dolares contabilizando en limpiras estaba tomando el monto base en vez del original.
        // Determinando montos para calculo de comisiones seleccionadas
        // Setting amounts for formula Capital (CAP)
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_01 =  IFNULL((SELECT  /*SUM(- 1 *JABV.BALANCE_AMT)*/ /*SUM(- 1 *JABV.BASE_BAL_AMT)*/ SUM(- 1 *JABV.BALANCE_AMT)  FROM  ' . $this->jabvname . ' JABV WHERE  JABV.CHART_FIELD01 = FTMP.CHART_FIELD01  AND JABV.CHART_FIELD02 = FTMP.CHART_FIELD02  /*AND JABV.CURRENCY_CODE = FTMP.CURRENCY_CODE*/ AND JABV.CURRENCY_CODE = FTMP.CURRENCY_CODE  AND JABV.GL_TYPE = ' . singleQuote('EQ') . '  AND JABV.TRUST_ITEM_TYPE = ' . singleQuote('EQ') . '),0) WHERE FTMP.ASSET_COM_BASE = ' . singleQuote('CAP') . ' AND FTMP.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        // Setting Amounts for formula Capital + Paid Income (CAIN)
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_01 = IFNULL((SELECT  SUM(- 1 *JABV.BALANCE_AMT)  FROM  ' . $this->jabvname . ' JABV  WHERE  JABV.CHART_FIELD01 = FTMP.CHART_FIELD01  AND JABV.CHART_FIELD02 = FTMP.CHART_FIELD02  /*AND JABV.CURRENCY_CODE = FTMP.CURRENCY_CODE*/ AND JABV.CURRENCY_CODE = FTMP.CURRENCY_CODE AND ((JABV.GL_TYPE = ' . singleQuote('EQ') . ' AND JABV.TRUST_ITEM_TYPE = ' . singleQuote('EQ') . ') OR JABV.GL_TYPE = ' . singleQuote('IN') . '))  ,0) WHERE FTMP.ASSET_COM_BASE = ' . singleQuote('CAIN') . ' AND FTMP.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        // Setting Amounts for formula GL Account balance (GLB)
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_01 = IFNULL( (SELECT  /*SUM(IF(JABV.GL_TYPE IN (' . singleQuote('AS') . ',' . singleQuote('EX') . '), 1,-1)*JABV.BALANCE_AMT)*/ /*SUM(IF(JABV.GL_TYPE IN (' . singleQuote('AS') . ',' . singleQuote('EX') . '), 1,-1)*JABV.BASE_BAL_AMT)*/ SUM(IF(JABV.GL_TYPE IN (' . singleQuote('AS') . ',' . singleQuote('EX') . '), 1,-1)*JABV.BALANCE_AMT) FROM  ' . $this->jabvname . ' JABV, ' . $this->glctname . ' GLCT  WHERE  JABV.CHART_FIELD01 = FTMP.CHART_FIELD01  AND JABV.CHART_FIELD02 = FTMP.CHART_FIELD02  AND JABV.CURRENCY_CODE = FTMP.CURRENCY_CODE  AND JABV.GLACCOUNTCODE = GLCT.IDCODE AND GLCT.FIDU_RATETBLCODE = FTMP.FIDU_RATETBLCODE AND JABV.COMP_CODE = GLCT.COMP_CODE AND FTMP.ASSET_COM_BASE = ' . singleQuote('GLB') . ')  ,0) WHERE FTMP.ASSET_COM_BASE = ' . singleQuote('GLB') . ' AND FTMP.FEE_TYPE <> ' . singleQuote('LIMT') . ' AND FTMP.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql); // AND JABV.GLACCOUNTCODE = FTMP.GL01_CODE
        // Setting Amounts for formula GL Account balance (GLB) Limites
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_01 = IFNULL( (SELECT  /*SUM(IF(GDVW.GL_TYPE IN (' . singleQuote('AS') . ',' . singleQuote('EX') . '), 1,-1)*(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT))*/ /*SUM(IF(GDVW.GL_TYPE IN (' . singleQuote('AS') . ',' . singleQuote('EX') . '), 1,-1)*(GDVW.DEBIT_TRANS_AMT-GDVW.CREDIT_TRANS_AMT))*/ SUM(IF(GDVW.GL_TYPE IN (' . singleQuote('AS') . ',' . singleQuote('EX') . '), 1,-1)*(GDVW.DEBIT_TRANS_AMT-GDVW.CREDIT_TRANS_AMT)) FROM  ' . $this->gdvwname . ' GDVW, ' . $this->glctname . '  GLCT  WHERE  GDVW.CHART_FIELD01 = FTMP.CHART_FIELD01  AND GDVW.CHART_FIELD02 = FTMP.CHART_FIELD02  AND GDVW.CURRENCY_CODE = FTMP.CURRENCY_CODE  AND GDVW.GLACCOUNTCODE = GLCT.IDCODE AND GDVW.COMP_CODE = GLCT.COMP_CODE AND GLCT.FIDU_RATETBLCODE = FTMP.FIDU_RATETBLCODE AND ((GDVW.EFFTDATE > FTMP.FROM_DATE OR FTMP.FROM_DATE IS NULL) AND GDVW.EFFTDATE <=FTMP.TO_DATE) AND FTMP.ASSET_COM_BASE = ' . singleQuote('GLB') . ')  ,0) WHERE FTMP.ASSET_COM_BASE = ' . singleQuote('GLB') . ' AND FTMP.FEE_TYPE = ' . singleQuote('LIMT') . ' AND FTMP.BATCH_ID = ' . singleQuote($batch_id); // #AND GDVW.GLACCOUNTCODE =
        // FTMP.GL01_CODE
        ClxCommon::$db->executeQuery($sql);
        // Setting Amounts for formula Capital + Paid Income + Unpaid Income
        // (CARE)
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_01 = IFNULL( (SELECT  /*SUM(- 1 *JABV.BALANCE_AMT)*/ /*SUM(- 1 *JABV.BASE_BAL_AMT)*/ SUM(- 1 *JABV.BALANCE_AMT) FROM  ' . $this->jabvname . ' JABV  WHERE  JABV.CHART_FIELD01 = FTMP.CHART_FIELD01  AND JABV.CHART_FIELD02 = FTMP.CHART_FIELD02  /*AND JABV.CURRENCY_CODE = FTMP.CURRENCY_CODE*/ AND JABV.CURRENCY_CODE = FTMP.CURRENCY_CODE AND ((JABV.GL_TYPE = ' . singleQuote('EQ') . ' AND JABV.TRUST_ITEM_TYPE = ' . singleQuote('EQ') . ')  OR JABV.GL_TYPE IN (' . singleQuote('IN') . ',' . singleQuote('EX') . ')))  ,0) WHERE FTMP.ASSET_COM_BASE = ' . singleQuote('CARE') . ' AND FTMP.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        // Setting Amounts for formula Equity + Income - Expense(Previous Day)
        // (EIEP)
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_01 = IFNULL(  (SELECT  /*-1*SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT)*/ /*-1*SUM(GDVW.DEBIT_TRANS_AMT-GDVW.CREDIT_TRANS_AMT)*/ -1*SUM(GDVW.DEBIT_TRANS_AMT-GDVW.CREDIT_TRANS_AMT) FROM  ' . $this->gdvwname . ' GDVW WHERE  GDVW.CHART_FIELD01 = FTMP.CHART_FIELD01  AND GDVW.CHART_FIELD02 = FTMP.CHART_FIELD02 AND GDVW.CURRENCY_CODE = FTMP.CURRENCY_CODE  AND GDVW.EFFTDATE <= ' . singleQuote($operation_date) . '  AND ((GDVW.GL_TYPE = ' . singleQuote('EQ') . ' AND GDVW.TRUST_ITEM_TYPE = ' . singleQuote('EQ') . ')  OR GDVW.GL_TYPE IN (' . singleQuote('IN') . ',' . singleQuote('EX') . ') OR GDVW.GL_TYPE = ' . singleQuote('EX') . ' AND GDVW.EFFTDATE < ' . singleQuote($operation_date) . ')) ,0) WHERE FTMP.ASSET_COM_BASE = ' . singleQuote('EIEP') . ' AND FTMP.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        // no need for Setting Amounts for formula Fix (FIX) already done on
        // Segun operaciones del periodo
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_01 = IFNULL(  (SELECT  SUM(IF(GDVW.GL_TYPE IN (' . singleQuoteArray(array('AS', 'EX')) . '), 1,-1)*(GDVW.DEBIT_TRANS_AMT-GDVW.CREDIT_TRANS_AMT))   FROM  ' . $this->gdvwname . ' GDVW, ' . $this->glctname . '  GLCT  WHERE  GDVW.CHART_FIELD01 = FTMP.CHART_FIELD01  AND GDVW.CHART_FIELD02 = FTMP.CHART_FIELD02 /*AND GDVW.CURRENCY_CODE = FTMP.CURRENCY_CODE*/ AND GDVW.CURRENCY_CODE = FTMP.CURRENCY_CODE  AND GDVW.EFFTDATE > FTMP.FROM_DATE AND GDVW.EFFTDATE <=FTMP.TO_DATE AND GDVW.GLACCOUNTCODE = GLCT.IDCODE AND GDVW.COMP_CODE = GLCT.COMP_CODE AND GLCT.FIDU_RATETBLCODE = FTMP.FIDU_RATETBLCODE)  ,0) WHERE FTMP.ASSET_COM_BASE = ' . singleQuote('GLO') . ' AND FTMP.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        // AND GDVW.GLACCOUNTCODE = GLCT.IDCODE
        // Segun monto de operacion esta debe tomar monto de operacion cuando no
        // incluye una cuenta contable especifica
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_01 = IFNULL(  (SELECT  SUM(FIAT.TRANS_AMT)  FROM  ' . $this->fiatname . ' FIAT WHERE  FIAT.CHART_FIELD01 = FTMP.CHART_FIELD01  AND FIAT.CHART_FIELD02 = FTMP.CHART_FIELD02 /*AND FIAT.CURRENCY_CODE = FTMP.CURRENCY_CODE*/ AND FIAT.CURRENCY_CODE = FTMP.CURRENCY_CODE  AND FIAT.EFFTDATE > FTMP.FROM_DATE AND FIAT.EFFTDATE <=FTMP.TO_DATE AND (FIAT.TRANSTBL_CODE = FTMP.ADM_TRANSTBL_CODE OR EXISTS(SELECT FETR.ID FROM ' . $this->fetrname . ' FETR WHERE FETR.FIDU_RATETBLCODE = FTMP.FIDU_RATETBLCODE AND FETR.TRANSTBL_CODE = FIAT.TRANSTBL_CODE)) AND FIAT.TRANS_STATUS = ' . singleQuote('AP') . ' AND FIAT.REVERSED = 0 AND (FIAT.REV_TRANS_CODE IS NULL OR FIAT.REV_TRANS_CODE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . '))  ,0) WHERE FTMP.ASSET_COM_BASE = ' . singleQuote('FIAT') . ' AND FTMP.GL01_CODE IS NULL AND FTMP.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        /* Considerar el monto en valor absoluto por ejemplo pagos de activos es negativo pero la comision debe salir por monto pagado */
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_01 = IFNULL(  (SELECT  ABS(SUM((GDVW.DEBIT_TRANS_AMT-GDVW.CREDIT_TRANS_AMT)))  FROM  ' . $this->gdvwname . ' GDVW, ' . $this->glctname . '  GLCT  WHERE  GDVW.CHART_FIELD01 = FTMP.CHART_FIELD01  AND GDVW.CHART_FIELD02 = FTMP.CHART_FIELD02 /*AND GDVW.CURRENCY_CODE = FTMP.CURRENCY_CODE*/ AND GDVW.CURRENCY_CODE = FTMP.CURRENCY_CODE  AND GDVW.EFFTDATE > FTMP.FROM_DATE AND GDVW.EFFTDATE <=FTMP.TO_DATE AND (GDVW.TRANSTBL_CODE = FTMP.ADM_TRANSTBL_CODE OR EXISTS(SELECT FETR.ID FROM ' . $this->fetrname . ' FETR WHERE FETR.FIDU_RATETBLCODE = FTMP.FIDU_RATETBLCODE AND FETR.TRANSTBL_CODE = GDVW.TRANSTBL_CODE)) AND GDVW.GLACCOUNTCODE = GLCT.IDCODE AND GDVW.COMP_CODE = GLCT.COMP_CODE AND GLCT.FIDU_RATETBLCODE = FTMP.FIDU_RATETBLCODE)  ,0) WHERE FTMP.ASSET_COM_BASE = ' . singleQuote('FIAT') . ' AND FTMP.GL01_CODE IS NOT null AND FTMP.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        // Se calcula el monto de la operacion basado en nro de operaciones por
        // monto fijo.
        // El porcentaje se aplica sobre ese monto.
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_01 = IFNULL(  (SELECT  COUNT(FIAT.ID)  FROM  ' . $this->fiatname . ' FIAT WHERE  FIAT.CHART_FIELD01 = FTMP.CHART_FIELD01  AND FIAT.CHART_FIELD02 = FTMP.CHART_FIELD02 /*AND FIAT.CURRENCY_CODE = FTMP.CURRENCY_CODE*/ AND FIAT.CURRENCY_CODE = FTMP.CURRENCY_CODE  AND FIAT.EFFTDATE > FTMP.FROM_DATE AND FIAT.EFFTDATE <=FTMP.TO_DATE AND FIAT.TRANSTBL_CODE = FTMP.ADM_TRANSTBL_CODE AND (FIAT.TRANSTBL_CODE = FTMP.ADM_TRANSTBL_CODE OR EXISTS(SELECT FETR.ID FROM ' . $this->fetrname . ' FETR WHERE FETR.FIDU_RATETBLCODE = FTMP.FIDU_RATETBLCODE AND FETR.TRANSTBL_CODE = FIAT.TRANSTBL_CODE)) AND FIAT.TRANS_STATUS = ' . singleQuote('AP') . ' AND FIAT.REVERSED = 0 AND (FIAT.REV_TRANS_CODE IS NULL OR FIAT.REV_TRANS_CODE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . '))  ,0)*FTMP.CALC_AMT_04, FTMP.CALC_AMT_04 = 0 WHERE FTMP.ASSET_COM_BASE = ' . singleQuote('FIAT_NO') . ' AND FTMP.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);

        // fin de determinar montos contables o para calculo.

        /* CURR.CALC_AMT_01 = ROUND(FTMP.CALC_AMT_01*POW(CURR.EXCHANGE_RT, -1*CURR.CUR_OPERATOR), 2) CALC_AMT_01 */
        //Find currency exchanges
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP, ' . $this->currname . ' CURR SET  FTMP.EXCHANGE_RT = CURR.EXCHANGE_RT, FTMP.CUR_OPERATOR = CURR.CUR_OPERATOR WHERE  FTMP.BATCH_ID = ' . singleQuote($batch_id) . '  AND CURR.BASE_CURRENCY = FTMP.CURRENCY_CODE AND CURR.FOREIGN_CURRENCY = ' . singleQuote($base_currency) . ' AND CURR.CLX_EFFTDATE = (SELECT MAX(CURRX.CLX_EFFTDATE) FROM ' . $this->currname . ' CURRX WHERE CURRX.IDCODE = CURR.IDCODE AND CURRX.CLX_EFFTDATE <= ' . singleQuote($operation_date) . ')';
        ClxCommon::$db->executeQuery($sql);
        // Single scale
        $sql = 'DELETE FROM ' . $this->ftmpname . '  WHERE BATCH_ID = ' . singleQuote($batch_id) . '  AND CALC_AMT_01<0 AND ASSET_COM_BASE IN (' . singleQuoteArray(array('CAP', 'EIEP', 'CAIN')) . ')';
        ClxCommon::$db->executeQuery($sql);
        // Setting scales if exists
        // Single scale
        $sql = 'DELETE FTMP.* FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . '  AND FTMP.SCALE_TYPE = 1 AND EXISTS(SELECT FIRS.ID FROM ' . $this->firsname . ' FIRS WHERE FIRS.FIDU_RATETBLCODE = FTMP.FIDU_RATETBLCODE AND FIRS.EFFTDATE = FTMP.EFFTDATE  AND FIRS.SEQNUM = FTMP.SEQNUM AND (FTMP.CALC_AMT_01< FIRS.RANGE_FROM_AMT OR FIRS.RANGE_TO_AMT < FTMP.CALC_AMT_01))';
        ClxCommon::$db->executeQuery($sql);
        // Set scales values. Fix amount if override
        $sql = 'UPDATE  ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_04 = (SELECT FIRS.FEES_RATE_AMT FROM ' . $this->firsname . ' FIRS WHERE FIRS.FIDU_RATETBLCODE = FTMP.FIDU_RATETBLCODE AND FIRS.EFFTDATE = FTMP.EFFTDATE AND FIRS.SEQNUM = FTMP.SEQNUM)  WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.SCALE_TYPE = 1';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE  ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_02 = (SELECT FIRS.FEES_RATE_PCT FROM ' . $this->firsname . ' FIRS WHERE FIRS.FIDU_RATETBLCODE = FTMP.FIDU_RATETBLCODE AND FIRS.EFFTDATE = FTMP.EFFTDATE  AND FIRS.SEQNUM = FTMP.SEQNUM)  WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.SCALE_TYPE = 1';
        ClxCommon::$db->executeQuery($sql);
        // Fraction scale
        $sql = 'DELETE FTMP.* FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.SCALE_TYPE = 2 AND EXISTS(SELECT FIRS.ID FROM ' . $this->firsname . ' FIRS WHERE FIRS.FIDU_RATETBLCODE = FTMP.FIDU_RATETBLCODE AND FIRS.EFFTDATE = FTMP.EFFTDATE  AND FIRS.SEQNUM = FTMP.SEQNUM AND FTMP.CALC_AMT_01 < FIRS.RANGE_FROM_AMT)';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE  ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_04 = (SELECT FIRS.FEES_RATE_AMT FROM ' . $this->firsname . ' FIRS WHERE FIRS.FIDU_RATETBLCODE = FTMP.FIDU_RATETBLCODE AND FIRS.EFFTDATE = FTMP.EFFTDATE AND FIRS.SEQNUM = FTMP.SEQNUM)  WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.SCALE_TYPE = 2';
        ClxCommon::$db->executeQuery($sql);
        // Fraction scale
        $sql = 'UPDATE  ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_02 = (SELECT FIRS.FEES_RATE_PCT FROM ' . $this->firsname . ' FIRS WHERE FIRS.FIDU_RATETBLCODE = FTMP.FIDU_RATETBLCODE AND FIRS.EFFTDATE = FTMP.EFFTDATE  AND FIRS.SEQNUM = FTMP.SEQNUM)  WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.SCALE_TYPE = 2';
        ClxCommon::$db->executeQuery($sql);
        // set top amount for fee
        $sql = 'UPDATE  ' . $this->ftmpname . ' FTMP SET FTMP.DEBIT_AMT = (SELECT FIRS.RANGE_FROM_AMT FROM ' . $this->firsname . ' FIRS WHERE FIRS.FIDU_RATETBLCODE = FTMP.FIDU_RATETBLCODE AND FIRS.EFFTDATE = FTMP.EFFTDATE  AND FIRS.SEQNUM = FTMP.SEQNUM), FTMP.CREDIT_AMT = (SELECT FIRS.RANGE_TO_AMT FROM ' . $this->firsname . ' FIRS WHERE FIRS.FIDU_RATETBLCODE = FTMP.FIDU_RATETBLCODE AND FIRS.EFFTDATE = FTMP.EFFTDATE  AND FIRS.SEQNUM = FTMP.SEQNUM)  WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.SCALE_TYPE = 2';
        ClxCommon::$db->executeQuery($sql);

        //store for testing AVAILABLE_AMT
        if ($test === true) {
            $sql = 'UPDATE  ' . $this->ftmpname . ' FTMP SET FTMP.AVAILABLE_AMT = FTMP.CALC_AMT_01 WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id);
            ClxCommon::$db->executeQuery($sql);
        }
        // Adjust top amount for fee
        $sql = 'UPDATE  ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_01 = IF(FTMP.CALC_AMT_01 > FTMP.CREDIT_AMT, FTMP.CREDIT_AMT-FTMP.DEBIT_AMT, FTMP.CALC_AMT_01-FTMP.DEBIT_AMT) WHERE  FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.SCALE_TYPE = 2';
        ClxCommon::$db->executeQuery($sql);
        // return debit amount if changed on scales
        $sql = 'UPDATE ' . $this->ftmpname . ' SET DEBIT_AMT = 0, CREDIT_AMT = 0 WHERE BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        // Udateing group
        $sql = 'UPDATE ' . $this->ftmpname . ' SET LGGROUP_CODE = ' . singleQuote($comprec ['LGGROUP_CODE']) . ' WHERE LGGROUP_CODE IS NULL OR LGGROUP_CODE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        // Delete any entry with balance = 0 Maybe CALC_AMT_01 = 0
        $sql = 'DELETE FROM ' . $this->ftmpname . '  WHERE  CALC_AMT_01 = 0  AND CALC_AMT_04 = 0  AND BATCH_ID = ' . singleQuote($batch_id) . ' AND FEE_TYPE <> ' . singleQuote('LIMT') . '';
        ClxCommon::$db->executeQuery($sql);
        // Updating exchange rates
        // NOTA CALC AMT )$ TIENE MONTO FIJO PERO DEBE SER DIVIDIDO SOBRE 360
        // NOTA se agrega no_days para contar la variacion por numero de dias
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_01 =  ROUND(((FTMP.CALC_AMT_01*(FTMP.CALC_AMT_02/100))/FTMP.NO_DAYS)+(FTMP.CALC_AMT_04/FTMP.NO_DAYS) , 2) WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.FEE_TYPE = ' . singleQuote('ADMN') . '';
        ClxCommon::$db->executeQuery($sql);
        // Calculating min and max
        // Setting minimum if apply
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_01 =  FTMP.MINIMUM_FEE WHERE FTMP.CALC_AMT_01<FTMP.MINIMUM_FEE AND FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.FEE_TYPE <> ' . singleQuote('LIMT') . ' AND FTMP.MINIMUM_FEE<>0';
        ClxCommon::$db->executeQuery($sql);
        // setting maximun if apply
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_01 =  FTMP.MAXIMUM_FEE WHERE FTMP.CALC_AMT_01>FTMP.MAXIMUM_FEE AND FTMP.MAXIMUM_FEE>0 AND FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.FEE_TYPE <> ' . singleQuote('LIMT') . ' AND FTMP.MAXIMUM_FEE<>0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DELETE FROM ' . $this->ftmpname . ' WHERE CALC_AMT_01 = 0 AND BATCH_ID = ' . singleQuote($batch_id) . ' AND FEE_TYPE <> ' . singleQuote('LIMT') . '';
        ClxCommon::$db->executeQuery($sql);
        // Build posible lines
        $sql = 'INSERT INTO ' . $this->jtmpname . '  (JE_SOURCE, GLACCOUNTCODE,  ITEM_CODE,  CHART_FIELD01,  CHART_FIELD02,  CHART_FIELD03,  CHART_FIELD04,  ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBITS,  CREDITS, BATCH_ID, PORTFOLIO_CODE, COMP_CODE, EFFTDATE, FEE_TYPE)  SELECT	 FITS.AFFECT_TYPE, FITS.GLACCOUNTCODE, FITS.ITEM_CODE ITEM_CODE,  FTMP.CHART_FIELD01 CHART_FIELD01,  FTMP.CHART_FIELD02 CHART_FIELD02, FTMP.CHART_FIELD03 CHART_FIELD03,  FTMP.CHART_FIELD04 CHART_FIELD04,  FTMP.ITEM_REF_NO, FTMP.OPER_CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR, (case FITS.DEBIT_CREDIT WHEN ' . "'DR'" . ' THEN SUM(FTMP.CALC_AMT_01) ELSE 0 END) DEBIT_TRANS_AMT, (case FITS.DEBIT_CREDIT WHEN ' . "'CR'" . ' THEN SUM(FTMP.CALC_AMT_01) ELSE 0 END) CREDIT_TRANS_AMT, (case FITS.DEBIT_CREDIT WHEN ' . "'DR'" . ' THEN SUM(FTMP.CALC_AMT_01) ELSE 0 END) DEBIT_AMT,  (case FITS.DEBIT_CREDIT WHEN ' . "'CR'" . ' THEN SUM(FTMP.CALC_AMT_01) ELSE 0 END) CREDIT_AMT, ' . singleQuote($batch_id) . ' BATCH_ID, FTMP.BANKACCOUNT_CODE PORTFOLIO_CODE, FTMP.COMP_CODE, ' . singleQuote($operation_date) . ' EFFTDATE, FTMP.FEE_TYPE FROM  ' . $this->fitsname . ' FITS,  ' . $this->firtname . ' FIRT,  ' . $this->ftmpname . ' FTMP  WHERE  FIRT.IDCODE = FTMP.FIDU_RATETBLCODE AND FIRT.CLX_EFFTDATE = FTMP.EFFTDATE  AND FITS.TRANSTBL_CODE = FIRT.CHARGE_TX_CODE  AND FITS.STATUS = ' . singleQuote('A') . '  AND FTMP.REC_STATUS = ' . singleQuote('RUN') . ' AND FTMP.FEE_TYPE <> ' . singleQuote('LIMT') . ' GROUP BY  FITS.AFFECT_TYPE, FITS.GLACCOUNTCODE, FITS.ITEM_CODE,  FTMP.CHART_FIELD01,  FTMP.CHART_FIELD02, FTMP.CHART_FIELD03,  FTMP.CHART_FIELD04,  FTMP.ITEM_REF_NO, FTMP.CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR, FITS.DEBIT_CREDIT, FTMP.BANKACCOUNT_CODE, FTMP.FEE_TYPE';
        ClxCommon::$db->executeQuery($sql);
        //Calculando limites require lo que
        // es esta procesando en el dia
        // Adjusting limit amound to include current execution fees excluded
        // since they were not accounted yet.
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_01 = FTMP.CALC_AMT_01 + IFNULL((SELECT SUM(JTMP.DEBITS-JTMP.CREDITS) FROM ' . $this->jtmpname . ' JTMP WHERE JTMP.GLACCOUNTCODE = FTMP.GL01_CODE AND JTMP.CHART_FIELD01 = FTMP.CHART_FIELD01 AND JTMP.CHART_FIELD02 = FTMP.CHART_FIELD02 AND JTMP.FEE_TYPE <> ' . singleQuote('LIMT') . ' AND JTMP.BATCH_ID = ' . singleQuote($batch_id) . ' ),0) WHERE FTMP.FEE_TYPE = ' . singleQuote('LIMT') . ' AND FTMP.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        // Setting minimum if apply
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_04 = FTMP.MINIMUM_FEE-FTMP.CALC_AMT_01 WHERE FTMP.CALC_AMT_01<FTMP.MINIMUM_FEE AND FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.FEE_TYPE = ' . singleQuote('LIMT') . '';
        ClxCommon::$db->executeQuery($sql);
        // setting maximun if apply
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_04 = FTMP.MAXIMUM_FEE-FTMP.CALC_AMT_01 WHERE FTMP.CALC_AMT_01>FTMP.MAXIMUM_FEE AND FTMP.MAXIMUM_FEE>0 AND FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.FEE_TYPE = ' . singleQuote('LIMT') . '';
        ClxCommon::$db->executeQuery($sql);
        // Clear limit not required to adjust
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CALC_AMT_01 =  FTMP.CALC_AMT_04, FTMP.CALC_AMT_02 = 0, FTMP.CALC_AMT_03 = 0, FTMP.CALC_AMT_04 = 0 WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.FEE_TYPE = ' . singleQuote('LIMT') . '';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DELETE FROM ' . $this->ftmpname . ' WHERE CALC_AMT_01 = 0 AND BATCH_ID = ' . singleQuote($batch_id) . ' AND FEE_TYPE = ' . singleQuote('LIMT') . '';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'INSERT INTO ' . $this->jtmpname . '  (JE_SOURCE, GLACCOUNTCODE,  ITEM_CODE,  CHART_FIELD01,  CHART_FIELD02,  CHART_FIELD03,  CHART_FIELD04,  ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBITS,  CREDITS, BATCH_ID, PORTFOLIO_CODE, COMP_CODE, EFFTDATE, FEE_TYPE)  SELECT	 FITS.AFFECT_TYPE, FITS.GLACCOUNTCODE, FITS.ITEM_CODE ITEM_CODE,  FTMP.CHART_FIELD01 CHART_FIELD01,  FTMP.CHART_FIELD02 CHART_FIELD02, FTMP.CHART_FIELD03 CHART_FIELD03,  FTMP.CHART_FIELD04 CHART_FIELD04,  FTMP.ITEM_REF_NO, FTMP.OPER_CURRENCY_CODE CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR, (case FITS.DEBIT_CREDIT WHEN ' . "'DR'" . ' THEN SUM(FTMP.CALC_AMT_01) ELSE 0 END) DEBIT_TRANS_AMT, (case FITS.DEBIT_CREDIT WHEN ' . "'CR'" . ' THEN SUM(FTMP.CALC_AMT_01) ELSE 0 END) CREDIT_TRANS_AMT, (case FITS.DEBIT_CREDIT WHEN ' . "'DR'" . ' THEN SUM(FTMP.CALC_AMT_01) ELSE 0 END) DEBIT_AMT,  (case FITS.DEBIT_CREDIT WHEN ' . "'CR'" . ' THEN SUM(FTMP.CALC_AMT_01) ELSE 0 END) CREDIT_AMT, ' . singleQuote($batch_id) . ' BATCH_ID, FTMP.BANKACCOUNT_CODE PORTFOLIO_CODE, FTMP.COMP_CODE, ' . singleQuote($operation_date) . ' EFFTDATE, FTMP.FEE_TYPE FROM  ' . $this->fitsname . ' FITS,  ' . $this->firtname . ' FIRT,  ' . $this->ftmpname . ' FTMP  WHERE  FIRT.IDCODE = FTMP.FIDU_RATETBLCODE AND FIRT.CLX_EFFTDATE = FTMP.EFFTDATE  AND FITS.TRANSTBL_CODE = FIRT.CHARGE_TX_CODE  AND FITS.STATUS = ' . singleQuote('A') . '  AND FTMP.REC_STATUS = ' . singleQuote('RUN') . ' AND FTMP.FEE_TYPE = ' . singleQuote('LIMT') . ' GROUP BY  FITS.AFFECT_TYPE, FITS.GLACCOUNTCODE, FITS.ITEM_CODE,  FTMP.CHART_FIELD01,  FTMP.CHART_FIELD02, FTMP.CHART_FIELD03,  FTMP.CHART_FIELD04,  FTMP.ITEM_REF_NO, FTMP.CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR, FITS.DEBIT_CREDIT, FTMP.BANKACCOUNT_CODE, FTMP.FEE_TYPE';
        ClxCommon::$db->executeQuery($sql);
        //Updating tax pct
        $sql = 'UPDATE  ' . $this->jtmpname . ' JTMP,  ' . $this->jeitname . ' JEIT SET  JTMP.DEBITS = ROUND((JTMP.DEBITS*(JEIT.FLAT_RATE/100)), 2), JTMP.CREDITS = ROUND((JTMP.CREDITS*(JEIT.FLAT_RATE/100)), 2), JTMP.DEBIT_TRANS_AMT = ROUND((JTMP.DEBIT_TRANS_AMT*(JEIT.FLAT_RATE/100)), 2), JTMP.CREDIT_TRANS_AMT = ROUND((JTMP.CREDIT_TRANS_AMT*(JEIT.FLAT_RATE/100)), 2) WHERE   JTMP.ITEM_CODE = JEIT.IDCODE AND JTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND JEIT.FLAT_RATE <> 0 AND JEIT.CLX_EFFTDATE<=(SELECT MAX(JEITX.CLX_EFFTDATE) FROM ' . $this->jeitname . ' JEITX WHERE JEITX.IDCODE = JEIT.IDCODE AND JEITX.CLX_EFFTDATE<=' . singleQuote($operation_date) . ')';
        ClxCommon::$db->executeQuery($sql);
        //fin de calculo de limites
        // Setting gl accounts
        $sql = 'UPDATE ' . $this->jtmpname . ' JTMP SET JTMP.GLACCOUNTCODE = (SELECT MAX(PRAT.PRO_GL_CODE) GLACCOUNTCODE FROM GL_PROD_PRMTR_TBL PRAT, FIDU_BANK_ACCOUNTS FIBK WHERE PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE AND FIBK.BANK_ACCOUNT_NO = JTMP.PORTFOLIO_CODE) WHERE JTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND JTMP.JE_SOURCE = ' . singleQuote('CA') . '';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->jtmpname . ' JTMP SET JTMP.GLACCOUNTCODE = (SELECT TTPA.EQ_GL_CODE FROM ' . $this->glcpname . ' GLCP, ' . $this->ttpaname . ' TTPA, ' . $this->ficoname . ' FICO WHERE GLCP.COMP_CODE = FICO.COMP_CODE AND TTPA.GLGROUP_CODE = GLCP.GLGROUP_CODE AND TTPA.FI_TYPE = FICO.FI_TYPE AND FICO.TRUST_FUND_SRC = TTPA.TRUST_FUND_SRC AND TTPA.CONTRACT_TYPE = FICO.CONTRACT_TYPE AND FICO.IDCODE = JTMP.CHART_FIELD01) WHERE JTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND JTMP.JE_SOURCE = ' . singleQuote('EQ') . '';
        ClxCommon::$db->executeQuery($sql);
        // return debit amount if changed on scales
        $sql = 'UPDATE ' . $this->jtmpname . '  SET JE_SOURCE = ' . singleQuote($je_source) . ', PORTFOLIO_CODE = null WHERE BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        // Check debut and credit signs
        $sql = 'UPDATE ' . $this->jtmpname . ' SET CREDITS = ABS(DEBITS), DEBITS = 0 WHERE DEBITS<0 AND BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->jtmpname . ' SET DEBITS = ABS(CREDITS), CREDITS = 0 WHERE CREDITS<0 AND BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        // Setting exchange
        //Si la operacion es igual a la moneda base entonces dejar monto al cambio.
        //1 se coloca el cambio de la moneda de la operacion, 2 se calcula todo en la moneda de la comision
        //3. se convierta todo o solo lo que es moneda extranejera segun moneda de operacion.
        $sql = 'UPDATE  ' . $this->jtmpname . ' SET  DEBITS = ROUND(DEBIT_TRANS_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2), CREDITS = ROUND(CREDIT_TRANS_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2), DEBIT_TRANS_AMT = ROUND(DEBIT_TRANS_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2), CREDIT_TRANS_AMT = ROUND(CREDIT_TRANS_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2), EXCHANGE_RT = 1, CUR_OPERATOR = 1 WHERE  BATCH_ID = ' . singleQuote($batch_id) . ' AND CURRENCY_CODE = ' . singleQuote($base_currency);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE  ' . $this->jtmpname . '  SET  DEBITS = ROUND(DEBIT_TRANS_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2), CREDITS = ROUND(CREDIT_TRANS_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2) WHERE  BATCH_ID = ' . singleQuote($batch_id) . ' AND CURRENCY_CODE <> ' . singleQuote($base_currency);
        ClxCommon::$db->executeQuery($sql);
        // Nota las comisiones se calculan en monto base y se traducen a monto
        // original si comision dice dolares
        //e cho 'aca 4<hr><hr>';
        // remove cero entries
        $sql = 'DELETE FROM ' . $this->jtmpname . '  WHERE DEBITS = 0 AND CREDITS = 0 AND BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Dumping accounting for test
        if ($test === true) {
            //Check fees parameters
            $contents .= '<h4>' . dict('GEN_LBL_FEE_INFORMATION') . '</h4>';
            $table = new htmlTable(CLX_WIDTH_18);
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_FIDU_RATETBL_CODE'), dict('GEN_LBL_COMMISION_CODE'), dict('GEN_LBL_ASSET_COM_BASE'), dict('GEN_LBL_SCALE_TYPE'), dict('GEN_LBL_PERIOD'), dict('GEN_LBL_NO_DAYS'), dict('GEN_LBL_CHARGE_FREQUENCY'), dict('GEN_LBL_CHARGE_DAY'), dict('GEN_LBL_CURRENCY_CODE'), dict('GEN_LBL_OPER_CURRENCY_CODE'), dict('GEN_LBL_EXCHANGE_RT'), dict('GEN_LBL_AVAILABLE_AMT'), dict('GEN_LBL_CALC_AMT_01'), dict('GEN_LBL_CALC_AMT_02'), dict('GEN_LBL_CALC_AMT_03'), dict('GEN_LBL_CALC_AMT_04'), dict('GEN_LBL_MINIMUM_FEE'), dict('GEN_LBL_MAXIMUM_FEE')));
            //GL Account in composition
            $sql = 'SELECT FTMP.* FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id);
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $table->addCells(CLX_CLASS_DATA, array($r['FIDU_RATETBLCODE'], $r['COMMISSION_CODE'], $r['ASSET_COM_BASE'], $r['SCALE_TYPE'], $r['FROM_DATE'] . ' ' . dict('GEN_LBL_TO') . ' ' . $r['TO_DATE'], $r['NO_DAYS'], $r['CHARGE_FREQUENCY'], $r['CHARGE_DAY'], $r['CURRENCY_CODE'], $r['OPER_CURRENCY_CODE'], $r['EXCHANGE_RT'], $r['AVAILABLE_AMT'], $r['CALC_AMT_01'], $r['CALC_AMT_02'], $r['CALC_AMT_03'], $r['CALC_AMT_04'], $r['MINIMUM_FEE'], $r['MAXIMUM_FEE']));
            }
            $contents .= $table->source();
            $contents .= '<br><h4>' . dict('GEN_LBL_ACCOUNTING_ENTRY') . '</h4>';
            $table = new htmlTable(CLX_WIDTH_12);
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_COMP_CODE'), dict('GEN_LBL_GLACCOUNTCODE'), dict('GEN_LBL_ITEM_CODE'), dict('GEN_LBL_CHART_FIELD01'), dict('GEN_LBL_CHART_FIELD02'), dict('GEN_LBL_ITEM_REF_NO'), dict('GEN_LBL_CURRENCY_CODE'), dict('GEN_LBL_DEBIT_TRANS_AMT'), dict('GEN_LBL_CREDIT_TRANS_AMT'), dict('GEN_LBL_EXCHANGE_RT'), dict('GEN_LBL_DEBITS'), dict('GEN_LBL_CREDITS')));
            $sql = 'SELECT FICO.CONTRACT_NUMBER, JTMP.*  FROM ' . $this->jtmpname . ' JTMP, ' . $this->ficoname . ' FICO WHERE JTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND JTMP.CHART_FIELD01 = FICO.IDCODE';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $table->addCells(CLX_CLASS_DATA, array($r['COMP_CODE'], $r['GLACCOUNTCODE'], $r['ITEM_CODE'], $r['CONTRACT_NUMBER'], $r['CHART_FIELD02'], $r['ITEM_REF_NO'], $r['CURRENCY_CODE'], $r['DEBIT_TRANS_AMT'], $r['CREDIT_TRANS_AMT'], $r['EXCHANGE_RT'], $r['DEBITS'], $r['CREDITS']));
            }
			ClxCommon::$db->freeResult($rs);
            $contents .= $table->source();
            unset($table);
            $contents .= '<br><h4>' . dict('GEN_LBL_ACCOUNTS_IN_FEE') . '</h4>';
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_GLACCOUNTCODE'), dict('GEN_LBL_IDNAME')));
            $sql = 'SELECT GLCT.IDCODE GLACCOUNTCODE, GLAC.IDNAME FROM ' . $this->glctname . ' GLCT, ' . $this->glacname . ' GLAC, ' . $this->ftmpname . ' FTMP WHERE GLAC.IDCODE = GLCT.IDCODE AND GLAC.GLGROUP_CODE = GLCT.GLGROUP_CODE AND GLCT.FIDU_RATETBLCODE = FTMP.FIDU_RATETBLCODE AND FTMP.BATCH_ID = ' . singleQuote($batch_id);
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $table->addCells(CLX_CLASS_DATA, array($r['GLACCOUNTCODE'], $r['IDNAME']));
            }
			ClxCommon::$db->freeResult($rs);
            $contents .= $table->source();
            unset($table);
            //just return if test
            return $contents;
        }//end test
        // Reject any posible todays entry from this process thas has run today
        if (CLX_NUM_ONE == CLX_NUM_TWO && empty($parameters['OPTION_FLAG'])) {//este flag se usa en procesos manuales donde quieres correr varios dias sin reversar
            //comentado en glb porque reversaba las comisiones de administradoras por error.
            $jehd->jehd_reverse_by_je_source($comp_code, $je_source, $operation_date);
        }
        //Rechazo se cambia por ejecucion de nueva fecha
        $sql = 'UPDATE  ' . $this->ftmpname . ' FTMP,  ' . $this->fiacname . ' FIAC SET  FIAC.LAST_CHARGE_DATE = FIAC.NEXT_CHARGE_DATE, FIAC.NEXT_CHARGE_DATE = (case FTMP.CHARGE_FREQUENCY WHEN ' . singleQuote('D') . ' THEN ADDDATE(FIAC.NEXT_CHARGE_DATE, INTERVAL 1 DAY)  WHEN ' . singleQuote('2') . ' THEN ADDDATE(FIAC.NEXT_CHARGE_DATE, INTERVAL 1 MONTH)  WHEN ' . singleQuote('4') . ' THEN ADDDATE(FIAC.NEXT_CHARGE_DATE, INTERVAL 3 MONTH)  WHEN ' . singleQuote('5') . ' THEN ADDDATE(FIAC.NEXT_CHARGE_DATE, INTERVAL 6 MONTH)  WHEN ' . singleQuote('6') . ' THEN ADDDATE(FIAC.NEXT_CHARGE_DATE, INTERVAL 1 YEAR)  ELSE null END) WHERE  FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.COMMISSION_CODE = FIAC.IDCODE';
        ClxCommon::$db->executeQuery($sql);

        // Build Header for this process, one pre currency
        $sql = 'SELECT DISTINCT FTMP.OPER_CURRENCY_CODE CURRENCY_CODE, FTMP.LGGROUP_CODE FROM ' . $this->ftmpname . ' FTMP, ' . $this->jtmpname . ' JTMP  WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . '  AND FTMP.REC_STATUS = ' . singleQuote('RUN') . ' AND JTMP.CURRENCY_CODE = FTMP.OPER_CURRENCY_CODE';
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $gl_rec = $jehd->jehd_init_record();
            $gl_rec ['IDNAME'] = dict('GEN_LBL_ADMNFEES');
            $gl_rec ['JE_SOURCE'] = $je_source;
            $gl_rec ['LGGROUP_CODE'] = $result ['LGGROUP_CODE'];
            $gl_rec ['EFFTDATE'] = $operation_date;
            $gl_rec ['REAL_DATE'] = $operation_date;
            $gl_rec ['COMP_CODE'] = $comp_code;
            $gl_rec ['TRANS_CODE'] = null;
            $gl_rec ['REQ_CHANNEL'] = 'SYS';
            $gl_rec ['BATCH_ID'] = $batch_id;
            $jehd->jehd_build($gl_rec);
            // Search any scale if apply and dump lines to journal
            $sql = 'INSERT INTO ' . $this->jelnname . '  (JEHDR_CODE,  GLACCOUNTCODE,  ITEM_CODE,  CHART_FIELD01,  CHART_FIELD02,  CHART_FIELD03,  CHART_FIELD04,  ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT,  CREDIT_TRANS_AMT, DEBIT_AMT,  CREDIT_AMT)  SELECT	 ' . singleQuote($gl_rec ['IDCODE']) . ' JEHDR_CODE,  JTMP.GLACCOUNTCODE,  JTMP.ITEM_CODE,  JTMP.CHART_FIELD01,  JTMP.CHART_FIELD02,  JTMP.CHART_FIELD03,  JTMP.CHART_FIELD04,  JTMP.ITEM_REF_NO, JTMP.CURRENCY_CODE, JTMP.EXCHANGE_RT, JTMP.CUR_OPERATOR, JTMP.DEBIT_TRANS_AMT,  JTMP.CREDIT_TRANS_AMT, JTMP.DEBITS DEBIT_AMT,  JTMP.CREDITS CREDIT_AMT FROM  ' . $this->jtmpname . ' JTMP  WHERE  JTMP.CURRENCY_CODE = ' . singleQuote($result ['CURRENCY_CODE']);
            ClxCommon::$db->executeQuery($sql);
        }
		ClxCommon::$db->freeResult($results);
        // Mark accumulators as done
        ClxCommon::$db->executeQuery('UPDATE ' . $this->ftmpname . ' SET REC_STATUS =' . singleQuote('END') . '  WHERE CURRENCY_CODE = ' . singleQuote($result ['CURRENCY_CODE']) . '  AND BATCH_ID = ' . singleQuote($batch_id));
        // Approve journal
        //Check Rounding
        $jehd->balance_exchange_rounding($batch_id, true);
        if (!$jehd->jehd_approve_by_batch_id($batch_id)) {
            // if approval fail send note
            $msg = 'ADMN01 ' . dict('GEN_LBL_BATCHFAILAPPROVE', $batch_id);
            if (!empty($parameters)) {
                $PRPR = &getTool('PRPR');
                $PRPR->report_exception_by_parameters($parameters, $msg, 'JEHD', 'ERRO');
            } else {
                echoLog($msg);
            }
        }
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glctname . ' WHERE COMP_CODE = ' . singleQuote($comp_code));
        ClxCommon::$db->commit();

        //Building invoices
        $this->build_adm_invoice($comp_code, $operation_date, $contract_code, $participant_id, $parameters, $firt_code, $test);
        //Do some commit
        ClxCommon::$db->commit();
        return $contents;
    }

// end function
    /**
     * Invoice for administration company
     * @param unknown_type $comp_code
     * @param unknown_type $operation_date
     * @param unknown_type $contract_code
     * @param unknown_type $participant_id
     * @param unknown_type $parameters
     * @param unknown_type $firt_code
     * @param unknown_type $test
     */
    private function build_adm_invoice($comp_code, $operation_date = '', $contract_code = '', $participant_id = '', $parameters = array(), $firt_code = '', $test = false) {
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('INVT');
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->invtname . ' WHERE 1=1');

        //Read information to build Invoi
        $sql = 'INSERT INTO ' . $this->invtname . '  (IDNAME, VENDOR_CODE, INVOICEDATE, DUE_DATE, CURRENCY_CODE, INVOICE_AMT, EXT_REF_NO, INVO_STAT, COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, GL_TYPE, JEHDR_CODE, GL01_CODE, GL02_CODE, TGT_ITEM_CODE, TGT_ITEM2_CODE, BATCH_ID, CDATE, CREATEDBY, FEE_01_RATE, GL03_CODE, FROM_CONTRACT_CODE, COMMISSION_CODE) '
                . 'SELECT  FIRT.IDNAME, GDVW.CHART_FIELD02 VENDOR_CODE, GDVW.EFFTDATE INVOICEDATE, GDVW.EFFTDATE DUE_DATE, GDVW.CURRENCY_CODE, SUM((case GDVW.GL_TYPE WHEN ' . singleQuote('LI') . ' THEN -1 ELSE 1 END)*(GDVW.DEBIT_TRANS_AMT-GDVW.CREDIT_TRANS_AMT))  INVOICE_AMT, FIAC.IDCODE EXT_REF_NO, ' . singleQuote('01') . ' INVO_STAT, FIRT.TGT_COMP_CODE COMP_CODE, FIRT.TGT_CHART_FIELD01 CHART_FIELD01, FIRT.TGT_CHART_FIELD02 CHART_FIELD02, null CHART_FIELD03, null CHART_FIELD04, FIRT.TGT_ITEM_CODE ITEM_CODE, GDVW.GL_TYPE, GDVW.IDCODE JEHDR_CODE, null GL01_CODE, null GL02_CODE, FIRT.TGT_ITEM_CODE, FIRT.TGT_ITEM2_CODE, ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->username) . ' CREATEDBY, null FEE_01_RATE, null GL03_CODE, GDVW.CHART_FIELD01 FROM_CONTRACT_CODE, FIAC.IDCODE COMMISSION_CODE FROM  ' . $this->gdvwname . ' GDVW, ' . $this->fiacname . ' FIAC, ' . $this->firtname . ' FIRT WHERE  FIAC.IDCODE = GDVW.ITEM_REF_NO AND FIAC.FIDU_RATETBLCODE = FIRT.IDCODE AND GDVW.GLACCOUNTCODE = FIRT.FEE_GL_CODE AND GDVW.REVERSED = 0 AND GDVW.COMP_CODE = ' . singleQuote($comp_code) . ' AND GDVW.EFFTDATE = ' . singleQuote($operation_date) . ' AND FIRT.STATUS = ' . singleQuote('A') . '  AND FIRT.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE  FROM ' . $this->firtname . ' X  WHERE X.IDCODE=FIRT.IDCODE  AND X.CLX_EFFTDATE<=' . singleQuote($operation_date) . ') GROUP BY  FIRT.IDNAME, GDVW.CHART_FIELD02, GDVW.EFFTDATE, GDVW.EFFTDATE, GDVW.CURRENCY_CODE, FIAC.IDCODE, FIRT.TGT_COMP_CODE, FIRT.TGT_CHART_FIELD01, FIRT.TGT_CHART_FIELD02, FIRT.TGT_ITEM_CODE, GDVW.GL_TYPE, FIRT.TGT_ITEM_CODE, FIRT.TGT_ITEM2_CODE, GDVW.CHART_FIELD01, FIAC.IDCODE';
        if ($contract_code <> '')
            $sql .=' AND GDVW.CHART_FIELD01 = ' . singleQuote($contract_code) . ' ';
        if ($participant_id <> '')
            $sql .=' AND GDVW.CHART_FIELD02 = ' . singleQuote($participant_id) . ' ';
        if ($firt_code <> '')
            $sql .=' AND FIRT.IDCODE = ' . singleQuote($firt_code) . ' ';
        ClxCommon::$db->executeQuery($sql);

        //Adding tax lines selecting
        //Usando gl type li para que sumen al generar la factura
        $sql = 'INSERT INTO ' . $this->invtname . '  (IDNAME, VENDOR_CODE, INVOICEDATE, DUE_DATE, CURRENCY_CODE, INVOICE_AMT, EXT_REF_NO, INVO_STAT, COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, GL_TYPE, JEHDR_CODE, GL01_CODE, GL02_CODE, TGT_ITEM_CODE, TGT_ITEM2_CODE, BATCH_ID, CDATE, CREATEDBY, FEE_01_RATE, GL03_CODE, FROM_CONTRACT_CODE, COMMISSION_CODE) '
                . 'SELECT  FIRT.IDNAME, GDVW.CHART_FIELD02 VENDOR_CODE, GDVW.EFFTDATE INVOICEDATE, GDVW.EFFTDATE DUE_DATE, GDVW.CURRENCY_CODE, SUM((case GDVW.GL_TYPE WHEN ' . singleQuote('LI') . ' THEN -1 ELSE 1 END)*(GDVW.DEBIT_TRANS_AMT-GDVW.CREDIT_TRANS_AMT))  INVOICE_AMT, FIAC.IDCODE EXT_REF_NO, ' . "'01'" . ' INVO_STAT, FIRT.TGT_COMP_CODE COMP_CODE, FIRT.TGT_CHART_FIELD01 CHART_FIELD01, FIRT.TGT_CHART_FIELD02 CHART_FIELD02, null CHART_FIELD03, null CHART_FIELD04, FIRT.TGT_ITEM_CODE ITEM_CODE, GDVW.GL_TYPE, GDVW.IDCODE JEHDR_CODE, null GL01_CODE, null GL02_CODE, FIRT.TGT_ITEM_CODE TGT_ITEM_CODE, FIRT.TGT_TAX_ITEM_CODE TGT_ITEM2_CODE, ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->username) . ' CREATEDBY, null FEE_01_RATE, null GL03_CODE, GDVW.CHART_FIELD01 FROM_CONTRACT_CODE, FIAC.IDCODE COMMISSION_CODE FROM  ' . $this->gdvwname . ' GDVW, ' . $this->fiacname . ' FIAC, ' . $this->firtname . ' FIRT WHERE  FIAC.IDCODE = GDVW.ITEM_REF_NO AND FIAC.FIDU_RATETBLCODE = FIRT.IDCODE AND GDVW.GLACCOUNTCODE = FIRT.TAX_GL_CODE AND GDVW.REVERSED = 0 AND GDVW.COMP_CODE = ' . singleQuote($comp_code) . ' AND GDVW.EFFTDATE = ' . singleQuote($operation_date) . ' AND FIRT.STATUS = ' . singleQuote('A') . '  AND FIRT.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE  FROM ' . $this->firtname . ' X  WHERE X.IDCODE=FIRT.IDCODE  AND X.CLX_EFFTDATE<=' . singleQuote($operation_date) . ') GROUP BY  FIRT.IDNAME, GDVW.CHART_FIELD02, GDVW.EFFTDATE, GDVW.EFFTDATE, GDVW.CURRENCY_CODE, FIAC.IDCODE, FIRT.TGT_COMP_CODE, FIRT.TGT_CHART_FIELD01, FIRT.TGT_CHART_FIELD02, FIRT.TGT_ITEM_CODE, GDVW.GL_TYPE, FIRT.TGT_ITEM_CODE, FIRT.TGT_TAX_ITEM_CODE, GDVW.CHART_FIELD01, FIAC.IDCODE';
        if ($contract_code <> '')
            $sql .=' AND GDVW.CHART_FIELD01 = ' . singleQuote($contract_code) . ' ';
        if ($participant_id <> '')
            $sql .=' AND GDVW.CHART_FIELD02 = ' . singleQuote($participant_id) . ' ';
        if ($firt_code <> '')
            $sql .=' AND FIRT.IDCODE = ' . singleQuote($firt_code) . ' ';
        ClxCommon::$db->executeQuery($sql);

        //Delete all cases where exists invoice already for contract, date and commision
        $sql = 'DELETE INVT.*  FROM ' . $this->invtname . ' INVT WHERE EXISTS (SELECT INVO.ID  FROM ' . $this->invoname . ' INVO WHERE INVO.FROM_CONTRACT_CODE = INVT.FROM_CONTRACT_CODE AND INVO.COMMISSION_CODE = INVT.COMMISSION_CODE AND INVO.INVOICEDATE = INVT.INVOICEDATE)';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DELETE INVT.*  FROM ' . $this->invtname . ' INVT WHERE EXISTS (SELECT APIN.ID  FROM ' . $this->apinname . ' APIN WHERE APIN.FROM_CONTRACT_CODE = INVT.FROM_CONTRACT_CODE AND APIN.COMMISSION_CODE = INVT.COMMISSION_CODE AND APIN.INVOICEDATE = INVT.INVOICEDATE)';
        ClxCommon::$db->executeQuery($sql);
        //Return if no record
        if (ClxCommon::$db->oneExistsRecords($this->invtname, 'BATCH_ID=' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            return;
        }
        //Update glaccounts
        $sql = 'UPDATE ' . $this->invtname . ' INVT, ' . $this->jeitname . ' JEIT  SET  INVT.GL01_CODE = JEIT.GLACCOUNTCODE WHERE  INVT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND JEIT.IDCODE = INVT.TGT_ITEM_CODE AND JEIT.CLX_EFFTDATE=(SELECT MAX(JEITX.CLX_EFFTDATE) FROM ' . $this->jeitname . ' JEITX  WHERE JEITX.IDCODE = JEIT.IDCODE AND JEITX.CLX_EFFTDATE <= INVT.INVOICEDATE)';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->invtname . ' INVT, ' . $this->jeitname . ' JEIT  SET  INVT.GL02_CODE = JEIT.GLACCOUNTCODE WHERE  INVT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND JEIT.IDCODE = INVT.TGT_ITEM2_CODE AND JEIT.CLX_EFFTDATE=(SELECT MAX(JEITX.CLX_EFFTDATE) FROM ' . $this->jeitname . ' JEITX WHERE JEITX.IDCODE = JEIT.IDCODE AND JEITX.CLX_EFFTDATE <= INVT.INVOICEDATE)';
        ClxCommon::$db->executeQuery($sql);
        //Setting gltype
        $sql = 'UPDATE ' . $this->invtname . ' INVT, ' . $this->glacname . ' GLAC  SET  INVT.GL_TYPE = GLAC.GL_TYPE WHERE  INVT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLAC.IDCODE = INVT.GL01_CODE';
        ClxCommon::$db->executeQuery($sql);

        //Build Invoice
        if (!class_exists('Apin'))
            includeCodeLib('APIN');
        $apin = new Apin();
        $apin->buildInvoceFromInvt($this->batch_id, 'LI', 'PEND', true);
        unset($apin);

        if (!class_exists('Invo'))
            includeCodeLib('INVO');
        $invo = new Invo();
        $invo->buildInvoceFromInvt($this->batch_id, 'AS', 'PEND', true);
        unset($invo);
    }

    /**
     * Pay Fees will generate transactions based on balances for each fee
     *
     * @param string $comp_code
     * @param string $operation_date
     * @param string $contract_code
     * @param string $participant_id
     * @param string $parameters
     */
    function fiac_pay_fees($comp_code, $operation_date = '', $contract_code = '', $participant_id = '', $parameters = array()) {
        $username = $_SESSION ['user_record'] ['username'];
        $now = xFormat::getNow('Y-m-d H:i:s');
        $je_source = 'FEAP';
        $idname = dict('GEN_LBL_ADMNFEES');
        // Determine batch id
        $batch_id = batch_id();
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp ();
        $comprec = $comp->comp_operation_parameters($comp_code);
        // If efftdate is not provided then search operation date day as
        // operation date
        if ($operation_date === '') {
            $operation_date = $comprec ['OPERATION_DATE'];
        }
        if (!class_exists('Fiat'))
            includeCodeLib('FIAT');
        $fiat = new Fiat ();
        /* if (! class_exists ( 'Jehd' ))
          includeCodeLib ( 'JEHD' );
          $jehd = new Jehd (); */
        echoLog('PROCESSING COMMISION PAYMENT. BATCH ID: ' . $batch_id);
        echoLog('Efective charge date : ' . $operation_date);
        echoLog('Company: ' . (($comp_code === '') ? 'ALL' : $comp_code));
        echoLog('Contract: ' . (($contract_code === '') ? 'ALL' : $contract_code));
        echoLog('Participant: ' . (($participant_id === '') ? 'ALL' : $participant_id));
        // Reject all posible pending charges for today.
        // Load temporary table - Req on mysql
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('FTMP');
        // Clearing Temporary table for batch id
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ftmpname);
        $sql = 'INSERT INTO ' . $this->ftmpname . '   (IDCODE,  BATCH_ID,  REC_STATUS,  CHART_FIELD01,  CHART_FIELD02,  CHART_FIELD03,  CHART_FIELD04,  LGGROUP_CODE, COMMISSION_CODE, ITEM_REF_NO, FIDU_RATETBLCODE,  CHARGE_FREQUENCY, CURRENCY_CODE,  CALC_AMT_01,  CALC_AMT_02,  EFFTDATE)  SELECT  ' . singleQuote('TMP') . ' IDCODE,  ' . singleQuote($batch_id) . ' BATCH_ID,  ' . singleQuote('RUN') . ' REC_STATUS,  JELN.CHART_FIELD01,  JELN.CHART_FIELD02,  JELN.CHART_FIELD03,  JELN.CHART_FIELD04,  FIRT.LGGROUP_CODE, FIAC.IDCODE COMMISSION_CODE, FIAC.IDCODE ITEM_REF_NO, FIRT.IDCODE FIDU_RATETBLCODE,  FIRT.CPAY_FREQUENCY, JELN.CURRENCY_CODE,  case GLAC.GL_TYPE  WHEN ' . singleQuote('LI') . ' THEN 	SUM(JELN.CREDIT_TRANS_AMT-JELN.DEBIT_TRANS_AMT) ELSE SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT)	 END CALC_AMT_01,  FIAC.APPROVE_PAYMENT CALC_AMT_02,  ' . singleQuote($operation_date) . ' EFFTDATE  FROM  ' . $this->glacname . ' GLAC,  ' . $this->glcpname . ' GLCP,  ' . $this->jelnname . ' JELN,  ' . $this->jehdname . ' JEHD,  ' . $this->firtname . ' FIRT, ' . $this->fipaname . ' FIPA,  ' . $this->ficoname . ' FICO, ' . $this->fiacname . ' FIAC  WHERE  GLCP.COMP_CODE = JEHD.COMP_CODE  AND FIRT.IDCODE = FIAC.FIDU_RATETBLCODE AND FIRT.COMP_CODE = JEHD.COMP_CODE AND JEHD.IDCODE = JELN.JEHDR_CODE  AND FIAC.IDCODE = JELN.ITEM_REF_NO AND FIPA.CONTRACT_CODE = FICO.IDCODE AND FICO.IDCODE = JELN.CHART_FIELD01 AND FIPA.ACCOUNTCODE = JELN.CHART_FIELD02 AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND FIRT.COMP_CODE = ' . singleQuote($comp_code) . ' AND JEHD.JE_STATUS = ' . singleQuote('AP') . '  AND GLAC.IS_FEE_ACC = 1  AND FIRT.CPAY_FREQUENCY <> ' . singleQuote('NONE') . ' AND ( /*finiquito o cancelacion*/ FIPA.END_DATE = GLCP.OPERATION_DATE OR FICO.CANCEL_DATE = GLCP.OPERATION_DATE /*diario D*/ OR FIAC.NEXT_PAYMNT_DATE = ' . singleQuote($operation_date) . ' ) AND FIRT.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE  FROM FIDU_FEES_RATES_TBL X  WHERE X.IDCODE=FIRT.IDCODE  AND X.CLX_EFFTDATE<=JEHD.EFFTDATE) AND FIAC.STATUS = ' . singleQuote('A') . ' AND FIRT.STATUS = ' . singleQuote('A') . ' GROUP BY GLAC.GL_TYPE, JELN.CHART_FIELD01, JELN.CHART_FIELD02, FIRT.LGGROUP_CODE, FIRT.CPAY_FREQUENCY, FIAC.IDCODE, FIRT.IDCODE, JELN.CURRENCY_CODE, FIAC.APPROVE_PAYMENT HAVING SUM(JELN.CREDIT_TRANS_AMT-JELN.DEBIT_TRANS_AMT) <> 0 ORDER BY JELN.CHART_FIELD01, JELN.CHART_FIELD02';
        ClxCommon::$db->executeQuery($sql);
        // SETTING IDCODE INCREMENT
        ClxCommon::$db->executeQuery('UPDATE ' . $this->ftmpname . ' SET IDCODE = CONCAT(' . singleQuote($je_source) . ', ID)  WHERE BATCH_ID = ' . singleQuote($batch_id));
        $sql = 'UPDATE ' . $this->ftmpname . ' SET LGGROUP_CODE = ' . singleQuote($comprec ['LGGROUP_CODE']) . ' WHERE LGGROUP_CODE IS NULL OR LGGROUP_CODE = ' . "''";
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->ftmpname . ' SET IDNAME = ' . singleQuote($idname) . ', EFFTDATE = ' . singleQuote($operation_date) . ' WHERE BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        // build transactions
        $sql = ' SELECT  ' . singleQuote('AUTO') . ' IDCODE,  ' . singleQuote($idname) . ' IDNAME,  ' . singleQuote($operation_date) . ' EFFTDATE,  FIRT.PAY_TX_CODE TRANSTBL_CODE,  ' . singleQuote('PEND') . ' CLX_AUTH_STATUS,  FTMP.CURRENCY_CODE,  FTMP.LGGROUP_CODE, FTMP.ITEM_REF_NO, FICO.COMP_CODE,  FTMP.CHART_FIELD01,  FTMP.CHART_FIELD02,  FTMP.CHART_FIELD03,  FTMP.CHART_FIELD04,  FIAC.FIDU_BANKACT_CODE,  FTMP.CALC_AMT_01 TRANS_AMT,  0 RECONCILIED,  FIAC.ADM_DISMNT_TYPE DISBURSEMENT_TYPE,  FIAC.BANKAC_CODE BANKAC_CODE, ' . singleQuote($operation_date) . ' AVAILABILITY_DATE,  FIAC.BENEFICIARY_NAME,  FIAC.BRANCH_PRN,  0 RECORD_BLOCKING,  ' . singleQuote($je_source) . ' REFERENCE_NO,  ' . singleQuote($batch_id) . ' BATCH_ID,  ' . singleQuote($je_source) . ' JE_SOURCE, ' . singleQuote($username) . ' CREATEDBY,  ' . singleQuote($now) . ' CDATE,  ' . singleQuote($username) . ' MODIFIEDBY,  ' . singleQuote($now) . ' MDATE, FTMP.CALC_AMT_02 FROM  ' . $this->ftmpname . ' FTMP,  ' . $this->ficoname . ' FICO,  ' . $this->firtname . ' FIRT,  ' . $this->fiacname . ' FIAC  WHERE FTMP.CHART_FIELD01 = FICO.IDCODE  AND FIRT.IDCODE = FIAC.FIDU_RATETBLCODE  AND FIRT.COMP_CODE = FICO.COMP_CODE AND FTMP.ITEM_REF_NO = FIAC.IDCODE AND FTMP.CALC_AMT_01<>0  AND FTMP.BATCH_ID = ' . singleQuote($batch_id) . '  AND FTMP.REC_STATUS = ' . singleQuote('RUN') . '  AND FIRT.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE  FROM FIDU_FEES_RATES_TBL X  WHERE X.IDCODE=FIRT.IDCODE  AND X.CLX_EFFTDATE<=FTMP.EFFTDATE) ';
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $approve = $result ['CALC_AMT_02'];
            if ($approve == CLX_NUM_ZERO) {
                $result ['EFFTDATE'] = adodb_next_day($result ['EFFTDATE']);
                $result ['AVAILABILITY_DATE'] = $result ['EFFTDATE'];
            }
            unset($result ['CALC_AMT_02']);
            $xrate = $comp->comp_current_exchange($result ['COMP_CODE'], $result ['CURRENCY_CODE'], $result ['EFFTDATE']);
            $result ['EXCHANGE_RT'] = $xrate ['EXCHANGE_RT'];
            $result ['CUR_OPERATOR'] = $xrate ['CUR_OPERATOR'];
            $trans_code = $fiat->fiat_build($comp_code, $result ['TRANSTBL_CODE'], $result ['CHART_FIELD01'], $result ['CHART_FIELD02'], $result ['TRANS_AMT'], $result);
            // Approving all transactions that may require approval
            if ($approve > CLX_NUM_ZERO) {
                $fiat->fiat_approve_by_transcode($trans_code);
            }
        }
		ClxCommon::$db->freeResult($results);
        //Rechazo se cambia por ejecucion de nueva fecha
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP, ' . $this->fiacname . ' FIAC SET FIAC.LAST_PAY_DATE = FIAC.NEXT_PAYMNT_DATE, FIAC.NEXT_PAYMNT_DATE = (case FTMP.CHARGE_FREQUENCY WHEN ' . singleQuote('D') . ' THEN ADDDATE(FIAC.NEXT_PAYMNT_DATE, INTERVAL 1 DAY) WHEN ' . singleQuote('2') . ' THEN ADDDATE(FIAC.NEXT_PAYMNT_DATE, INTERVAL 1 MONTH) WHEN ' . singleQuote('4') . ' THEN ADDDATE(FIAC.NEXT_PAYMNT_DATE, INTERVAL 3 MONTH) WHEN ' . singleQuote('5') . ' THEN ADDDATE(FIAC.NEXT_PAYMNT_DATE, INTERVAL 6 MONTH) WHEN ' . singleQuote('6') . ' THEN ADDDATE(FIAC.NEXT_PAYMNT_DATE, INTERVAL 1 YEAR) ELSE null END) WHERE  FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.COMMISSION_CODE = FIAC.IDCODE';
        ClxCommon::$db->executeQuery($sql);
        // SETTING ENTRIES AS CLOSED
        ClxCommon::$db->executeQuery('DELETE FROM  ' . $this->ftmpname . ' WHERE 1=1');
        //Do some commit
        ClxCommon::$db->commit();
    }

// end function
    /**
     * Ftmp payment- build payment transaction for adm fees
     * @see glpf build_invoice_pay_fiat_from_ftmp
     * @param string $comp_code
     * @param string $je_source
     */
    function build_invoice_pay_fiat_from_ftmp($batch_id, $je_source) {
        if (ClxCommon::$db->oneExistsRecords($this->ftmpname, 'BATCH_ID = ' . singleQuote($batch_id)) == CLX_NUM_ZERO) {
            return;
        }
        if (!class_exists('Fiat'))
            includeCodeLib('FIAT');
        $fiat = new Fiat ();
        // build transactions /*CALC_AMT_02 RESERVED FOR APPROVE_PAYMENT*/
        $sql = 'SELECT  ' . singleQuote('AUTO') . ' IDCODE,  FTMP.IDNAME,  FTMP.EFFTDATE,  FTMP.TRANSTBL_CODE,  ' . singleQuote('PEND') . ' CLX_AUTH_STATUS,  FTMP.CURRENCY_CODE,  FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR, FTMP.LGGROUP_CODE, FTMP.ITEM_REF_NO, FTMP.ITEM_REF_NO REFERENCE_NO, FTMP.COMP_CODE,  FTMP.CHART_FIELD01,  FTMP.CHART_FIELD02,  FTMP.CHART_FIELD03,  FTMP.CHART_FIELD04,  FIAC.FIDU_BANKACT_CODE,  FTMP.CALC_AMT_01 TRANS_AMT, FTMP.CALC_AMT_02, FTMP.CALC_AMT_03 TAX_AMT,   0 RECONCILIED,  FTMP.DISBURSEMENT_TYPE, FTMP.ITEM_REF_NO,  FTMP.BANKACCOUNT_CODE BANKAC_CODE, FTMP.EFFTDATE AVAILABILITY_DATE,  FTMP.BENEFICIARY_NAME,  FTMP.BRANCH_PRN,  0 RECORD_BLOCKING,  FTMP.BATCH_ID,  ' . singleQuote($je_source) . ' JE_SOURCE, ' . singleQuote($this->username) . ' CREATEDBY,  ' . singleQuote($this->now) . ' CDATE,  ' . singleQuote($this->username) . ' MODIFIEDBY,  ' . singleQuote($this->now) . ' MDATE, FTMP.REC_ID FROM  ' . $this->ftmpname . ' FTMP,  ' . $this->ficoname . ' FICO,  ' . $this->firtname . ' FIRT,  ' . $this->fiacname . ' FIAC  WHERE  FTMP.CHART_FIELD01 = FICO.IDCODE  AND FIRT.IDCODE = FIAC.FIDU_RATETBLCODE  AND FIRT.COMP_CODE = FICO.COMP_CODE AND FTMP.ITEM_REF_NO = FIAC.IDCODE AND FTMP.CALC_AMT_01<>0  AND FTMP.BATCH_ID = ' . singleQuote($batch_id) . '  AND FTMP.REC_STATUS = ' . singleQuote('RUN') . '  AND FIRT.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE  FROM FIDU_FEES_RATES_TBL X  WHERE X.IDCODE=FIRT.IDCODE  AND X.CLX_EFFTDATE<=FTMP.EFFTDATE)';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $approve = $r ['CALC_AMT_02'];
            if ($approve == CLX_NUM_ZERO) {

                $r ['EFFTDATE'] = $r ['EFFTDATE'];
                $r ['AVAILABILITY_DATE'] = $r ['EFFTDATE'];
            }
            unset($r ['CALC_AMT_02']);
            $inpy_id = $r['REC_ID'];
            unset($r ['REC_ID']);
            $trans_code = $fiat->fiat_build($r['COMP_CODE'], $r ['TRANSTBL_CODE'], $r ['CHART_FIELD01'], $r ['CHART_FIELD02'], $r ['TRANS_AMT'], $r);
            if ($je_source === 'FIRTADMPAY' && $inpy_id !== '') {
                ClxCommon::$db->updateRecord($this->inpyname, array('REL_TRANS_CODE' => $trans_code), 'ID = ' . singleQuote($inpy_id));
            }// Approving all transactions that may require approval
            if ($approve > CLX_NUM_ZERO) {
                $fiat->fiat_approve_by_transcode($trans_code);
            }
        }
		ClxCommon::$db->freeResult($rs);
    }

    /**
     * Test fee charge
     * @param bool $test_charge
     * @return string
     */
    function fiac_test_fees_btn($test_charge = true) {
        $idlist = getIdlist();
        $contents = '';
        $sql = 'SELECT IDCODE, COMP_CODE  FROM ' . $this->firtname . '  WHERE ID IN (' . toString($idlist) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $contents .= $this->fiac_test_charge_fees($r ['IDCODE'], $r['COMP_CODE']);
        }
		ClxCommon::$db->freeResult($rs);
        $contents .= '<br>';
        return dialog(dict('GEN_LBL_FEE_CHARGE_TEST'), CLX_CLASS_TITLE, $contents, dict('GEN_LBL_CLOSE'));
    }

    /**
     * Performs charge test
     * @param string $firt_code
     * @param string $comp_code
     * @return string
     */
    private function fiac_test_charge_fees($firt_code, $comp_code) {
        $contents = dict('GEN_LBL_FEE') . ': ' . ClxCommon::$db->getField($this->firtname, 'IDNAME', 'IDCODE = ' . singleQuote($firt_code)) . '(' . $firt_code . ')<br>';
        $parameters = array();
        $contents .= $this->fiac_charge_fees($comp_code, '', '', '', $parameters, $firt_code, true);
        return $contents;
    }

}

// end class