<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author	   $Author: fsantana $
 * @copyright	Alenet, Inc.
 * @since		$Date: 2016-05-05 16:12:23 -0400 (Thu, 05 May 2016) $
 * @version		$Rev: 8177 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Fibn {

    var $display = false;

    /**
     * Constructor
     * @param array [$procParameters]
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('FICO', 'FIBK', 'FIBN'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
        $this->je_source = '';
    }

    /**
     * Init Form
     * @param array $record
     */
    function init_form(&$record) {
        $this->load_form($record);
    }

    /**
     * Load Form
     * @param array $record
     */
    function load_form(&$record) {

        if (UserRequest::$request['ac'] === 'DUPLICATE_EFFTDATE' && empty(UserRequest::$post['confirm'])) {

            $record['FIBN_CLX_EFFTDATE'] = adodb_next_day($record['FIBN_CLX_EFFTDATE']);

            //Incrementando el contador +1 en caso de estar agotadas las ejecuciones pero se esta solicitando una nueva ejecucion
            if ($record['FIBN_RENEW_QTY'] > CLX_NUM_ZERO && $record['FIBN_RENEW_EXEC'] >= $record['FIBN_RENEW_QTY']) {
                $record['FIBN_RENEW_QTY'] ++;
            }
        }
        $record['FIBN_COMP_CODE'] = ClxCommon::$db->getField($this->fibkname, 'COMP_CODE', 'BANK_ACCOUNT_NO = ' . singleQuote($record['FIBN_BANKACT_CODE']));
    }

    /**
     * Salvar registros
     * @param type $record
     */
    function save_form_post(&$record) {
        $ren_type = '';
        $val = intval($record['RENEW_QTY']);
        if ($val === 1) {
            $ren_type = 'RAU';
        } elseif ($val === -1) {
            $ren_type = 'RAI';
        } elseif ($val > 1) {
            $ren_type = 'RAL';
        } else {
            $ren_type = 'SR';
        }
        ClxCommon::$db->updateRecord('FIDU_BANK_ACCOUNTS', array('CD_RENEW_OPT' => $ren_type), 'BANK_ACCOUNT_NO = ' . singleQuote($record['BANKACT_CODE']));
    }

    /**
     * Validation Methods
     * @param type $record
     * @param type $msg
     */
    function validate_form(&$record, &$msg) {
        //Validar que modificacion con feca valor solo se pueda hacer por modificacion con fecha efectiva?
       if(!empty($record['FIBN_ID']) && $record['FIBN_IS_ADJ_BACKVAL'] === '1' && ClxCommon::$db->oneExistsRecords('GL_OPERATION_QUEUE','REC_ID='.$record['FIBN_ID'].' AND GLOQ_TYPE = '.singleQuote('FIBN').' AND REC_STATUS IN ('.singleQuote('IDLE').', '.singleQuote('RUN').')')>0){
           $msg['FIBN_BANKACT_CODE'] = smsg('MSG-498', $record['FIBN_ID']);
       }

       //Validar back value
       $sql = 'SELECT IF(DATEDIFF(FIBK.START_DATE, GLCP.OPERATION_DATE) < GLCP.BCKDATE_ALLWCE,1,0) BACK_STATUS FROM GL_PARAMETERS_TBL GLCP, FIDU_BANK_ACCOUNTS FIBK WHERE FIBK.COMP_CODE = GLCP.COMP_CODE AND FIBK.BANK_ACCOUNT_NO = '.singleQuote($record['FIBN_BANKACT_CODE']);
       if($record['FIBN_IS_ADJ_BACKVAL'] === '1' && ClxCommon::$db->getOne($sql)==='1'){
           $msg['FIBN_BANKACT_CODE'] = smsg('MSG-499');
       }

       //Validar operaciones de pago en periodo
       $sql = 'SELECT COUNT(GLCP.ID) ID FROM GL_PARAMETERS_TBL GLCP, FIDU_BANK_ACCOUNTS FIBK, FIDU_ITEMS FIAS WHERE  FIBK.COMP_CODE = GLCP.COMP_CODE AND FIAS.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND EXISTS(SELECT FIAT.ID  FROM FIDU_TRANSACTIONS FIAT  WHERE FIAT.CHART_FIELD03 = FIAS.IDCODE  AND FIAT.REVERSED = 0 AND FIAT.TRANS_STATUS = '.singleQuote('AP').'  AND FIAT.EFFTDATE > FIBK.START_DATE  AND FIAT.EFFTDATE <= GLCP.OPERATION_DATE AND FIAT.TRANSTBL_CODE = '.singleQuote('SYS_CD-PINT').' AND FIBK.BANK_ACCOUNT_NO = '.singleQuote($record['FIBN_BANKACT_CODE']).')';
       if($record['FIBN_IS_ADJ_BACKVAL'] === '1' && ClxCommon::$db->getOne($sql)==='1'){
           $msg['FIBN_BANKACT_CODE'] = smsg('MSG-500');
       }
    }

    /**
     * Autorization Methods
     * @param type $record
     * @param type $reject
     */
    function post_autorize(&$record, $reject) {
        $prefix = (!empty($record['FIBN_BANKACT_CODE']))?'FIBN_':'';
        if (!$reject && intval($record[$prefix.'IS_ADJ_BACKVAL']) === CLX_NUM_ONE) {
            if(ClxCommon::$db->oneExistsRecords('GL_OPERATION_QUEUE','REC_ID='.$record[$prefix.'ID'].' AND GLOQ_TYPE = '.singleQuote('FIBN').' AND REC_STATUS IN ('.singleQuote('IDLE').', '.singleQuote('RUN').')')==0){
                if (!class_exists('Gloq')) {
                    includeCodeLib('GLOQ');
                }

                $gloq = new Gloq();
                $gloq->pushQueue('FIBN', null, null, null, null, null, $record[$prefix.'ID']);
            }
        }
    }

    function bv_run_gloq($record_id) {

        $record = ClxCommon::$db->getRecord('CD_RENEWALS', 'ID = ' . $record_id);
        $this->bv_process($record);
        return true;
    }

    /**
     * Ajuste con fecha valor
     * @param type $record
     */
    private function bv_process(&$record) {
        $this->bv_interest_rate($record);
        $this->bv_interest($record);
        $this->bv_principal($record);
        $this->bv_set_end($record);
    }

    /**
     * Ajuste de tasa de interes
     * @param type $record
     */
    private function bv_interest_rate(&$record) {
        if ($record['INTEREST_RT'] == 0) {
            return;
        }
        //bank info
        $sql = 'SELECT FIBK.* FROM  FIDU_BANK_ACCOUNTS FIBK WHERE FIBK.BANK_ACCOUNT_NO = ' . singleQuote($record['BANKACT_CODE']);
        $fibkrec = ClxCommon::$db->getOneRecord($sql);

        //Interest info
        $sql = 'SELECT FIBP.* FROM FIDU_FIBK_PARAMETERS_TBL FIBP WHERE FIBP.BANKACT_CODE = ' . singleQuote($record['BANKACT_CODE']) . ' AND FIBP.CLX_EFFTDATE = (SELECT MAX(FIBPX.CLX_EFFTDATE) FROM FIDU_FIBK_PARAMETERS_TBL FIBPX WHERE FIBPX.BANKACT_CODE = FIBP.BANKACT_CODE AND FIBPX.CLX_EFFTDATE<=' . singleQuote($fibkrec['START_DATE']) . ')';
        $fibprecold = ClxCommon::$db->getOneRecord($sql);

        if (!empty($fibprecold)) {
            $fibprec = $fibprecold;
            unset($fibprec['ID']);
            $fibprec['INTEREST_RT'] = $record['INTEREST_RT'];
            $fibprec['CLX_EFFTDATE'] = $fibkrec['START_DATE'];
            $fibprec['MDATE'] = $this->now;
            $fibprec['MODIFIEDBY'] = $this->username;
            ClxCommon::$db->loadDbRecord('FIDU_FIBK_PARAMETERS_TBL', $fibprec, false, 'BANKACT_CODE = ' . singleQuote($fibprec['BANKACT_CODE']) . ' AND CLX_EFFTDATE = ' . singleQuote($fibprec['CLX_EFFTDATE']));
        }
    }

    /**
     * Ajuste de principal
     * @param type $record
     */
    private function bv_principal(&$record) {

        if ($record['ADJUSTMENT_AMT'] == 0) {
            return;
        }

        //Generar asiento para ajustar capital.
        if (!class_exists('Comp')) {
            includeCodeLib('COMP');
        }
        $comp = new Comp();
        if (!class_exists('Fiat')) {
            includeCodeLib('FIAT');
        }

        $fiat = new Fiat ();
        $sql = 'SELECT ' . singleQuote('AUTO') . ' IDCODE, FITB.IDNAME, FIBK.CONTRACT_CODE CHART_FIELD01, FIBK.ACCOUNTCODE CHART_FIELD02, FIAS.IDCODE CHART_FIELD03, NULL CHART_FIELD04, FIBK.BANK_ACCOUNT_NO ITEM_REF_NO, FIBK.CURRENCY_CODE, ' . $record['ADJUSTMENT_AMT'] . ' TRANS_AMT, 0 INTEREST_AMT, FIBK.DEF_BANKACC_CODE FIDU_BANKACT_CODE,/* FIBK.DEF_BANKACC_CODE BANKAC_CODE,*/ ' . singleQuote('OT') . ' DISBURSEMENT_TYPE, FIBK.START_DATE EFFTDATE, FIBK.START_DATE AVAILABILITY_DATE, GLCP.OPERATION_DATE REAL_DATE, FITB.IDCODE TRANSTBL_CODE, FIBK.BENEFICIARY_NAME, GLCP.DEF_LGGROUP_CODE LGGROUP_CODE, GLCP.COMP_CODE FROM GL_PARAMETERS_TBL GLCP, FIDU_ITEMS FIAS, FIDU_BANK_ACCOUNTS FIBK, FIDU_TRANSACTION_TBL FITB WHERE GLCP.COMP_CODE = FIBK.COMP_CODE AND FIAS.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND FIAS.CONTRACT_CODE = FIBK.CONTRACT_CODE AND FITB.IDCODE = IF(' . singleQuote($record['RENWAL_OPER_TYPE']) . '=' . singleQuote('CAP') . ', ' . singleQuote('SYS_CD-RCAP') . ', ' . singleQuote('SYS_CD-RCAI') . ') AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($record['BANKACT_CODE']);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {

            //Is eq+int then trans amount must add both
            if ($r['TRANS_AMT'] == CLX_NUM_ZERO) {
                continue;
            }
            //Exchange rates
            $xrate = $comp->comp_current_exchange($r ['COMP_CODE'], $r ['CURRENCY_CODE'], $r ['EFFTDATE']);
            $r ['EXCHANGE_RT'] = $xrate ['EXCHANGE_RT'];
            $r ['CUR_OPERATOR'] = $xrate ['CUR_OPERATOR'];

            $trans_code = $fiat->fiat_build($r['COMP_CODE'], $r ['TRANSTBL_CODE'], $r ['CHART_FIELD01'], $r ['CHART_FIELD02'], $r ['TRANS_AMT'], $r);
            $fiat->fiat_approve_by_transcode($trans_code);
        }
		ClxCommon::$db->freeResult($rs);
    }

    /**
     * Ajuste de interest
     * @param type $record
     */
    private function bv_interest(&$record) {

        if ($record['INTEREST_RT'] == 0) {
            return;
        }

        //Seleccionar monto de interes calculado
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('GLT2'); //Clear tmp
        //bank info
        $sql = 'SELECT GLCP.OPERATION_DATE, FIBK.* FROM  FIDU_BANK_ACCOUNTS FIBK, GL_PARAMETERS_TBL GLCP WHERE GLCP.COMP_CODE = FIBK.COMP_CODE AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($record['BANKACT_CODE']);
        $fibkrec = ClxCommon::$db->getOneRecord($sql);

        //Interest info
        $sql = 'SELECT FIBP.* FROM FIDU_FIBK_PARAMETERS_TBL FIBP WHERE FIBP.BANKACT_CODE = ' . singleQuote($record['BANKACT_CODE']) . ' AND FIBP.CLX_EFFTDATE = (SELECT MAX(FIBPX.CLX_EFFTDATE) FROM FIDU_FIBK_PARAMETERS_TBL FIBPX WHERE FIBPX.BANKACT_CODE = FIBP.BANKACT_CODE AND FIBPX.CLX_EFFTDATE<=' . singleQuote($fibkrec['START_DATE']) . ')';
        $fibprecold = ClxCommon::$db->getOneRecord($sql);

        $from_date = $fibkrec['START_DATE'];
        $operation_date = $fibkrec['OPERATION_DATE'];
        //$days = date_diff360($from_date, $operation_date);
        $days = day_diff($operation_date, $from_date);
        //Seleccionando monto devangado de intereses

        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($fibkrec['COMP_CODE']);

        ClxCommon::$db->executeQuery('DELETE FROM GL_BACK_VALUE_TMP WHERE BATCH_ID = ' . singleQuote($this->batch_id));

        $sdate = $from_date;
        for ($i = 0; $i < $days; $i++) {

            $sql = 'SELECT IFNULL(SUM(GDVW.DEBIT_TRANS_AMT-GDVW.CREDIT_TRANS_AMT),0) PRODUCT_BAL FROM FIDU_BANK_ACCOUNTS FIBK, FIDU_ITEMS FIAS, GL_PROD_PRMTR_TBL PRAT, GL_JOURNAL_DET_VW GDVW WHERE FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE AND FIBK.BANK_PROD_CODE = PRAT.PRODUCT_CODE AND FIBK.CURRENCY_CODE = GDVW.CURRENCY_CODE AND FIAS.IDCODE = GDVW.CHART_FIELD03 AND GDVW.GLACCOUNTCODE = PRAT.PRO_GL_CODE AND FIBK.BANK_ACCOUNT_NO =  ' . singleQuote($fibkrec['BANK_ACCOUNT_NO']) . ' AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND GDVW.EFFTDATE <=' . singleQuote($sdate);
            $saldo_producto = ClxCommon::$db->getOne($sql);

            $sql = 'SELECT IFNULL(SUM(GDVW.DEBIT_TRANS_AMT-GDVW.CREDIT_TRANS_AMT),0) PRODUCT_BAL FROM FIDU_BANK_ACCOUNTS FIBK, FIDU_ITEMS FIAS, GL_PROD_PRMTR_TBL PRAT, GL_JOURNAL_DET_VW GDVW WHERE FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE AND FIBK.BANK_PROD_CODE = PRAT.PRODUCT_CODE AND FIBK.CURRENCY_CODE = GDVW.CURRENCY_CODE AND FIAS.IDCODE = GDVW.CHART_FIELD03 AND GDVW.GLACCOUNTCODE = PRAT.AR_GL_CODE AND GDVW.JE_SOURCE = ' . singleQuote('CINT') . ' AND FIBK.BANK_ACCOUNT_NO =  ' . singleQuote($fibkrec['BANK_ACCOUNT_NO']) . ' AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND GDVW.EFFTDATE =' . singleQuote($sdate);
            $int_dev_dia = ClxCommon::$db->getOne($sql);

            //Insertar temporal.
            $sql = 'INSERT INTO GL_BACK_VALUE_TMP (BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL02_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, CALC_AMT_02,CALC_AMT_03,CALC_AMT_04, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, TRUST_ITEM_TYPE, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, BANK_ACCOUNT_NO, PRODUCT_CODE, DIVIDER_FACTOR, ITEM_CODE, ITEM02_CODE, COMP_CODE, NO_DAYS, NEXT_DATE) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote($sdate) . ' EFFTDATE, PRAT.PRO_GL_CODE GLACCOUNTCODE, PRAT.AR_GL_CODE GL01_CODE, PRAT.INC_GL_CODE GL02_CODE, ' . singleQuote('AS') . ' GL_TYPE, ' . $saldo_producto . ' BALANCE_AMT, FIBP.INTEREST_RT CALC_AMT_01, 0 CALC_AMT_02, ' . $int_dev_dia . ' CALC_AMT_03, 0 CALC_AMT_04, FIBK.CONTRACT_CODE CHART_FIELD01, FIBK.ACCOUNTCODE CHART_FIELD02, FIAS.IDCODE CHART_FIELD03, NULL CHART_FIELD04, FIAS.TRUST_ITEM_TYPE, FIBK.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, 0 DEBIT_AMT, 0 CREDIT_AMT, FIBK.BANK_ACCOUNT_NO, FIBK.BANK_PROD_CODE PRODUCT_CODE, FIBP.INTEREST_CALC DIVIDER_FACTOR, ' . singleQuote('RCREM') . ' ITEM_CODE, ' . singleQuote('RCREM') . ' ITEM02_CODE, FIBK.COMP_CODE, 1 NO_DAYS, DATE_ADD(' . singleQuote($sdate) . ', INTERVAL -1 DAY) NEXT_DATE FROM FIDU_BANK_ACCOUNTS FIBK, FIDU_FIBK_PARAMETERS_TBL FIBP, FIDU_ITEMS FIAS, GL_PROD_PRMTR_TBL PRAT WHERE FIBK.BANK_ACCOUNT_NO =  ' . singleQuote($fibkrec['BANK_ACCOUNT_NO']) . ' AND FIAS.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND FIBK.BANK_PROD_CODE = PRAT.PRODUCT_CODE AND FIBK.BANK_ACCOUNT_NO = FIBP.BANKACT_CODE AND FIBP.CLX_EFFTDATE = (SELECT MAX(FIBPX.CLX_EFFTDATE) FROM FIDU_FIBK_PARAMETERS_TBL FIBPX WHERE FIBPX.BANKACT_CODE = FIBP.BANKACT_CODE AND FIBPX.CLX_EFFTDATE<= FIBK.START_DATE)';
            ClxCommon::$db->executeQuery($sql);
            $sdate = adodb_next_day($sdate);
        }

        if (ClxCommon::$db->oneExistsRecords('GL_BACK_VALUE_TMP', 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            if(kDefaultIsCron===CLX_NUM_ZERO){
                echoLog('Deposit Interest Back Value Interest None: Nothing to do returning<br>');
            }
            return;
        }

        $sql = 'UPDATE GL_BACK_VALUE_TMP SET CALC_AMT_02 = IFNULL(ROUND((BALANCE_AMT*(CALC_AMT_01/100)* case DIVIDER_FACTOR WHEN ' . singleQuote('360') . ' THEN (1/360) WHEN ' . singleQuote('365') . ' THEN (1/365) WHEN ' . singleQuote('30/360') . ' THEN (1/360) WHEN ' . singleQuote('30/365') . ' THEN (1/365) WHEN ' . singleQuote('AC/360') . ' THEN (1/360) WHEN ' . singleQuote('AC/365') . ' THEN (1/365) WHEN ' . singleQuote('AC/AC') . ' THEN (1/365) ELSE 1 END), 2), 0)-CALC_AMT_03 WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);

        $sql = 'UPDATE GL_BACK_VALUE_TMP SET DEBIT_AMT = CALC_AMT_02, DEBIT_TRANS_AMT = CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND CALC_AMT_02>0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE GL_BACK_VALUE_TMP SET CREDIT_AMT = -1*CALC_AMT_02, CREDIT_TRANS_AMT = -1*CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND CALC_AMT_02<0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE GL_BACK_VALUE_TMP SET CREDIT_AMT = CALC_AMT_02, CREDIT_TRANS_AMT = CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND CALC_AMT_02>0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE GL_BACK_VALUE_TMP SET DEBIT_AMT = -1*CALC_AMT_02, DEBIT_TRANS_AMT = -1*CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND CALC_AMT_02<0';
        ClxCommon::$db->executeQuery($sql);

        $sql = 'DELETE FROM GL_BACK_VALUE_TMP WHERE CREDIT_AMT = 0 AND DEBIT_AMT = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);

        //Delete all participants where rows from overdraft loans. or cero that will not earn int.
        $sql = 'DELETE FROM GL_BACK_VALUE_TMP WHERE CALC_AMT_02 = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        if (ClxCommon::$db->oneExistsRecords('GL_BACK_VALUE_TMP', 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            echoLog('<br>Deposit Interest BV: Nothing to do returning<br>');
            return;
        }


        echoLog(' DEPOSITS BACK VALUE INTEREST. BATCH ID: ' . $this->batch_id);
        echoLog('Efective date: ' . $operation_date);

        if (!class_exists('Fias'))
            includeCodeLib('FIAS');
        if (!class_exists('Jehd'))
            includeCodeLib('Jehd');
        $jehd = new Jehd();
        $fias = new Fias();
        $fias->batch_id = $this->batch_id;
        $je_source = 'CINT'; //Intereses de cuentas de banco

        $sql = 'SELECT * FROM GL_BACK_VALUE_TMP WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ORDER BY NEXT_DATE ASC';
        $rs = ClxCommon::$db->executeQuery($sql);


        while ($src_operation = ClxCommon::$db->getNextRecord($rs)) {
             if(($src_operation['GL_TYPE'] == 'AS' && $src_operation['CALC_AMT_02'] < 0) || ($src_operation['GL_TYPE'] == 'LI' && $src_operation['CALC_AMT_02'] > 0)){
                 $src_operation['ADJUSTMENT'] = 1;
             }
            $src_operation['OPERATION_MODE'] = 1;
            $fias->build_backvalue_operation($src_operation, $comp, $jehd, $comprec, $je_source, $src_operation['EFFTDATE'], $operation_date);
        }
    }

    /**
     * Ajuste de interest
     * @param type $record
     */
    private function bv_set_end(&$record) {

        ClxCommon::$db->updateRecord('CD_RENEWALS', array('IS_ADJ_BACKVAL' => 0), 'BANKACT_CODE = ' . singleQuote($record['BANKACT_CODE']) . ' AND CLX_EFFTDATE = ' . singleQuote($record['CLX_EFFTDATE']) . ' AND IS_ADJ_BACKVAL = 1');

        if ($record['INTEREST_RT'] <> 0) {
            $sql = 'SELECT CDRH.ID FROM  CD_RENEWAL_HIST CDRH,  FIDU_BANK_ACCOUNTS FIBK WHERE  FIBK.BANK_ACCOUNT_NO = ' . singleQuote($record['BANKACT_CODE']) . ' AND CDRH.BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND CDRH.EFFTDATE = (SELECT MAX(CDRHX.EFFTDATE)  FROM CD_RENEWAL_HIST CDRHX WHERE CDRHX.BANKACT_CODE = CDRH.BANKACT_CODE AND CDRHX.EFFTDATE<=FIBK.START_DATE)';
            $id = ClxCommon::$db->getOne($sql);

            $sql = 'UPDATE CD_RENEWAL_HIST SET INTEREST_RT=' . $record['INTEREST_RT'] . ' WHERE ID = ' . ((!empty($id)) ? $id : 0);
            ClxCommon::$db->executeQuery($sql);
        }
    }

    function test($bank_account_no) {
        $sql = 'SELECT FIBN.* FROM CD_RENEWALS FIBN
                  WHERE FIBN.BANKACT_CODE = ' . singleQuote($bank_account_no) . '
                    AND FIBN.CLX_EFFTDATE = (SELECT MAX(FIBNX.CLX_EFFTDATE)
                      FROM CD_RENEWALS FIBNX
                      WHERE FIBNX.BANKACT_CODE = FIBN.BANKACT_CODE
                        AND FIBNX.CLX_EFFTDATE<=CURDATE());';
        $record = ClxCommon::$db->getOneRecord($sql);
        $this->post_autorize($record, false);
    }

}
