<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-04-20 08:37:18 -0400 (Fri, 20 Apr 2018) $
 * @version        $Rev: 9795 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Fico {
    
    public $debug = false;
    
    /*
     * Contructor @param array $procParameters @return void
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('FICO', 'JELN', 'TTPA', 'GLAC', 'FIPA', 'JEBL', 'FIBK', 'FIAS', 'JEHD', 'LEBA', 'FIAT', 'TPRM', 'FIMT', 'INVO', 'APIN', 'OPPO', 'ACCO', 'INVO', 'APIN', 'COOB'));
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
    }

    /**
     * Initialice fico form
     * Executed on init event
     */
    function fico_init_form(&$record) {
        // usado en convertir cuentas fidu
        if (!empty(UserRequest::$post['ac_tbl']))
            return;
        if (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE' || (stristr(UserRequest::$request['ac'], 'BUTTON_') !== false && UserRequest::$request ['qy'] === 'LEAD_FIDU')) {
            $record ['FICO_IDCODE'] = 'AUTO';
            $record ['FICO_CLX_AUTH_STATUS'] = 'PEND';
            $record ['FICO_CONTRACT_STATUS'] = 'NEG';
            $record ['FICO_CONTRACT_NUMBER'] = $this->get_temp_contract_number();
            $record ['FICO_EFFTDATE'] = $this->today;
        }
        if (UserRequest::$request['ac'] === 'DUPLICATE') {
            $record ['FICO_IDCODE'] = 'AUTO';
            $record ['FICO_CLX_AUTH_STATUS'] = 'PEND';
            $record ['FICO_CONTRACT_STATUS'] = 'NEG';
        }
        if (UserRequest::$request['ac'] === 'CREATE') {
            if (!class_exists('Comp'))
                includeCodeLib('COMP');
            $comp = new Comp ();
            $comprec = $comp->comp_operation_parameters();
            unset($comp);
            if (empty($record ['FICO_EFFTDATE']))
                $record ['FICO_EFFTDATE'] = $this->today;
            if (empty($record ['FICO_START_DATE']))
                $record ['FICO_START_DATE'] = $comprec ['OPERATION_DATE'];
            if (empty($record ['FICO_COMP_CODE']))
                $record ['FICO_COMP_CODE'] = $comprec ['IDCODE'];
        }
    }

    private function get_temp_contract_number() {
        $tdt = str_replace(array(' ', '.'), '', microtime(false));
        $tmp_contract_number = 'TMP-' . $tdt;
        return $tmp_contract_number;
    }

    /**
     * Validate record information
     * Executed on table validate
     */
    function fico_validate_form(&$record, &$msg) {
        $ac = UserRequest::$request ['ac'];
        // prevent delete if accounting exists
        if (UserRequest::$request['ac'] === 'DELETE') {
            // validar situacion de transaccion pendiente o no
            $idlist = getIdlist();
            $idlist = toString($idlist);
            $sql = 'SELECT IDCODE FROM ' . $this->ficoname . ' WHERE ID IN (' . $idlist. ') AND CLX_AUTH_STATUS<>'.singleQuote('PEND');
            $reg = ClxCommon::$db->getOne($sql);
            pre($reg);
            if (!empty($reg))  {            
                $msg ['FICO_CLX_AUTH_STATUS'] = smsg('MSG-47', $reg);
                addMessage($msg ['FICO_CLX_AUTH_STATUS']);
            }
            $sql = 'SELECT COUNT(JEHD.ID) QTY FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JEHD.JE_STATUS<>' . singleQuote('PEND') . ' AND JELN.CHART_FIELD01 = ' . singleQuote($reg);
            if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                $msg ['FICO_CLX_AUTH_STATUS'] = smsg('MSG-47', $reg);
                addMessage($msg ['FICO_CLX_AUTH_STATUS']);
            }
            return (!empty($msg)) ? false : true;
        }
        if (!empty($record ['FICO_PARENTCONTRACT_CODE'])) {
            $this->fico_init_subcontract($record);
        }
        // test if type exists
		
		$extra1='';
		if (isset($record ['FICO_TRUST_FUND_SRC'])) {
			$extra1= ' AND TTPA.TRUST_FUND_SRC = ' . singleQuote($record ['FICO_TRUST_FUND_SRC']);
        }
		($record ['FICO_FI_TYPE'] == '' && $record ['FICO_CONTRACT_TYPE'] <> '100')?$crit = '':$crit = ' AND TTPA.FI_TYPE = ' . singleQuote($record ['FICO_FI_TYPE']);
        #$sql = 'SELECT COUNT(TTPA.ID) FROM ' . $this->ttpaname . ' TTPA, ' . $this->glacname . ' GLAC WHERE TTPA.EQ_GL_CODE = GLAC.IDCODE AND GLAC.ALLOW_ACTIVITY = 1 AND GLAC.GL_TYPE = ' . singleQuote('EQ') . ' AND GLAC.EFFTSTAT = ' . singleQuote('A') . ' AND TTPA.CONTRACT_TYPE = ' . singleQuote($record ['FICO_CONTRACT_TYPE']) . ' AND TTPA.FI_TYPE = ' . singleQuote($record ['FICO_FI_TYPE']) . ' AND TTPA.TRUST_FUND_SRC = ' . singleQuote($record ['FICO_TRUST_FUND_SRC']) . ' ';
        $sql = 'SELECT COUNT(TTPA.ID) FROM ' . $this->ttpaname . ' TTPA, ' . $this->glacname . ' GLAC WHERE TTPA.EQ_GL_CODE = GLAC.IDCODE AND GLAC.ALLOW_ACTIVITY = 1 AND GLAC.GL_TYPE = ' . singleQuote('EQ') . ' AND GLAC.EFFTSTAT = ' . singleQuote('A') . ' AND TTPA.CONTRACT_TYPE = ' . singleQuote($record ['FICO_CONTRACT_TYPE']) . $crit . $extra1 . ' ';
        if ($record ['FICO_CONTRACT_TYPE'] <> '999' && ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
            $msg ['FICO_FI_TYPE'] = smsg('MSG-48', $record ['FICO_IDCODE']);
        }
        if ($record ['FICO_CONTRACT_STATUS'] !== 'NEG' and $record ['FICO_CONTRACT_STATUS'] !== 'ACTI' && $ac <> 'IMPORT') {
            $msg ['FICO_CONTRACT_STATUS'] = smsg('MSG-49', $record ['FICO_IDCODE']);
        }
        if ($record ['FICO_FI_TYPE'] === 'CCTR') {
            $record ['FICO_START_DATE'] = $this->now;
        }
        $start_date = strtotime($record ['FICO_START_DATE']);
        if (!empty($record ['FICO_CANCEL_DATE'])) {
            $cancel_date = strtotime($record ['FICO_CANCEL_DATE']);
            if ($start_date >= $cancel_date) {
                $msg ['FICO_CANCEL_DATE'] = smsg('MSG-50', $record ['FICO_IDCODE']);
            }
        }
        if (!empty($record ['FICO_EXPIRATION_DATE'])) {
            $expiration_date = strtotime($record ['FICO_EXPIRATION_DATE']);
            if ($start_date >= $expiration_date) {
                $msg ['FICO_EXPIRATION_DATE'] = smsg('MSG-51', $record ['FICO_IDCODE']);
            }
        }
        if (UserRequest::$request['ac'] === 'REQAUTHORIZATION') {
            // Validate participants and others before approval
            // Validate if participant exists
            if (ClxCommon::$db->oneExistsRecords($this->fipaname, '(STATUS = ' . singleQuote('A') . ' OR CLX_AUTH_STATUS=' . singleQuote('PEND') . ') AND CONTRACT_CODE = ' . singleQuote($record ['FICO_IDCODE']) . ' AND ISPRIMARY = 1') === CLX_NUM_ZERO) {
                $msg ['FICO_CLX_AUTH_STATUS'] = smsg('MSG-52', $record ['FICO_IDCODE']);
            }
            //Validar ejecutivo de cuenta en aprobacion
            $req_acco_exec = companyParameter('FICO_REQUIRE_ACCO_EXEC', $record['FICO_COMP_CODE']);
            if (!empty($req_acco_exec) && empty($record['FICO_ACCO_EXEC'])) {
                $msg['FICO_ACCO_EXEC'] = smsg('MSG-486', $record ['FICO_IDCODE']);
            }
        }
    }

    /**
     * Update Parent (FICO) Information one record is saved
     */
    function fico_save_form(&$record) {
        // Update modified by and modification date on FICO
    }

    /**
     * Process post autorization actions
     * @param array $record
     * @param bool $reject
     * @return boolean
     */
    function fico_post_autorize(&$record, $reject = false) {
        if (UserRequest::$request ['ac'] === 'DELETE' || $reject === true)
            return false;
        if (array_key_exists('FICO_IDCODE', $record)) {
            $contract_code = $record ['FICO_IDCODE'];
        } else {
            $contract_code = $record ['IDCODE'];
        }
        $fico_status = ClxCommon::$db->getField($this->ficoname, 'CONTRACT_STATUS', 'IDCODE = ' . singleQuote($contract_code));
        if ($fico_status === 'NEG') {
            $update = array('CONTRACT_STATUS' => 'ACTI');
            if (strpos($record ['CONTRACT_NUMBER'], 'TMP') !== false) {
                $update ['CONTRACT_NUMBER'] = $this->fico_next_contract_number($contract_code);
            }
            ClxCommon::$db->updateRecord($this->ficoname, $update, 'IDCODE = ' . singleQuote($contract_code) . ' AND CONTRACT_STATUS=' . singleQuote('NEG') . ' AND CLX_AUTH_STATUS = ' . singleQuote('AP') . '');
            // updating all participants to active
            $sql = 'UPDATE ' . $this->fipaname . '  SET CLX_AUTH_STATUS = ' . singleQuote('AP') . ', STATUS = ' . singleQuote('A') . ' WHERE CLX_AUTH_STATUS = ' . singleQuote('PEND') . ' AND CONTRACT_CODE = ' . singleQuote($contract_code);
            ClxCommon::$db->executeQuery($sql);
        }
    }

    /**
     * Cancel negotiation contracts
     * See option "Trust > Contracts > Mark a Contract in negotiation > click on CANCEL NEGOTIATION button"
     */
    function setCancelStatusBtn() {

        $idlist = getIdlist();
        foreach ($idlist as $val) {
            $ficorec = ClxCommon::$db->getRecord($this->ficoname, 'ID = ' . intval($val));
            if ($ficorec['CONTRACT_STATUS'] === 'NEG') {
                $this->setCancelStatus($ficorec['IDCODE']);
            } else {
                addMessage(dict('GEN_ERR_INVALID_STATUS'));
            }
        }
    }

    /**
     * Cancels contract in negotiatio status
     * @param string $contract_code
     */
    private function setCancelStatus($contract_code) {
        if($this->debug) echo '<br>setCancelStatus - Entrada - $contract_code = ' . $contract_code . '<br>';
        $sql = 'UPDATE ' . $this->ficoname . ' FICO SET FICO.CLX_AUTH_STATUS = ' . singleQuote('REJ') . ', FICO.CONTRACT_STATUS = ' . singleQuote('CANC') . ', FICO.CANCEL_DATE = CURDATE(), FICO.MDATE = NOW(), FICO.MODIFIEDBY = ' . singleQuote($_SESSION['user_record']['username']) . ' WHERE FICO.IDCODE = ' . singleQuote($contract_code);
        ClxCommon::$db->executeQuery($sql);

        $sql = 'UPDATE ' . $this->fipaname . ' SET CLX_AUTH_STATUS = ' . singleQuote('REJ') . ', STATUS = ' . singleQuote('I') . ', FIPATERM_REASON = ' . singleQuote('CC') . ', END_DATE = CURDATE(), MDATE = NOW(), MODIFIEDBY = ' . singleQuote($_SESSION["user_record"]["username"]) . ' WHERE CONTRACT_CODE = ' . singleQuote($contract_code);
        ClxCommon::$db->executeQuery($sql);
        if($this->debug) echo '<br>setCancelStatus - Salida<br>';
    }

    /**
     * Returns the next contract number
     *
     * @param string $contract_code
     * @return string
     */
    private function fico_next_contract_number($contract_code) {
        //$r = ClxCommon::$db->getFields($this->ficoname, 'COMP_CODE, FI_TYPE', 'IDCODE = ' . singleQuote($contract_code));
        $r = ClxCommon::$db->getFields($this->ficoname, 'COMP_CODE, FI_TYPE, CONTRACT_TYPE', 'IDCODE = ' . singleQuote($contract_code));
        $comp_code = $r ['COMP_CODE'];
        // Contract Prefix Type define el tipo de prefijo a utilizar en el
        // numero de contrato. El parametro puede ser sin compañía (todos) o
        // especifico por cada compañía. En caso de especificar compañía esta
        // servira de remplazo al caso general. Posibles tipos son:
        // 0=No aplica, 1=Tipo de Fideicomiso, 2=Tipo Contrato + Tipo Fideicomiso
/*
        $def_prefix = companyParameter('FICO_NO_PREFIX_TYPE');
        if (empty($def_prefix)) {
            $def_prefix = CLX_INIT_ZERO;
*/    
        $prefix_sep = companyParameter('FICO_NO_PREFIX_SEP', $comp_code);
        if (is_null($prefix_sep) || trim($prefix_sep) === '') {
            $prefix_sep = companyParameter('FICO_NO_PREFIX_SEP');
            if (is_null($prefix_sep) || trim($prefix_sep) === '')
                $prefix_sep = '_';
        }
/*
        $prefix = companyParameter('FICO_NO_PREFIX_TYPE', $comp_code);
        if ($prefix === '')
            $prefix = $def_prefix;
*/
        $prefix = companyParameter('FICO_NO_PREFIX_TYPE', $comp_code);
        if (is_null($prefix) || trim($prefix) === '') {
            $prefix = companyParameter('FICO_NO_PREFIX_TYPE');
            if (is_null($prefix) || trim($prefix) === '')
                $prefix = CLX_INIT_ZERO;
        }
        switch ($prefix) {
            case '1' :
                //$prefix = $r ['FI_TYPE'] . '_';
                $DBLT = getTool('DBLT');
                $prefixAux1 = $DBLT->getListItem('FITY', $r ['FI_TYPE'], CLX_NUM_THREE);
                if(is_null($prefixAux1) || trim($prefixAux1) == '')
                    $prefixAux1 = $r ['FI_TYPE'];
                $prefix = $prefixAux1 . $prefix_sep;
                break;
            case '2' :
                $DBLT = getTool('DBLT');
                $prefixAux1 = $DBLT->getListItem('FICT', $r ['CONTRACT_TYPE'], CLX_NUM_THREE);
                if(is_null($prefixAux1) || trim($prefixAux1) == '')
                    $prefixAux1 = $r ['CONTRACT_TYPE'];
                $prefixAux2 = $DBLT->getListItem('FITY', $r ['FI_TYPE'], CLX_NUM_THREE);
                if(is_null($prefixAux2) || trim($prefixAux2) == '')
                    $prefixAux2 = $r ['FI_TYPE'];
                $prefix = $prefixAux1 . $prefix_sep . $prefixAux2 . $prefix_sep;
                break;
            default :
                $prefix = '';
                break;
        }

        // Commit set to the end of execution
        $sql = 'SELECT * FROM ' . $this->tprmname . ' WHERE COMP_CODE = ' . singleQuote($comp_code) . ' FOR UPDATE';
        $crec = ClxCommon::$db->getOneRecord($sql);
        if (!empty($crec)) {
            $contract_number = getIdcode($crec ['IDCODE_FORMAT'], $crec ['LAST_IDCODE'], $crec ['INCREMENTS']);
            // Setting New ID Codes Entry
            ClxCommon::$db->updateRecord($this->tprmname, array('LAST_IDCODE' => $contract_number, 'CDATE' => $crec ['CDATE'], 'MDATE' => xFormat::getNow()), 'ID=' . $crec ['ID']);
        } else {
            $contract_number = 'NA';
        }
        return $prefix . $contract_number;
    }

    /**
     * Create subcontract
     */
    function fico_init_subcontract(&$record) {
        if (UserRequest::$request['ac'] === 'CREATE' && !empty($record ['FICO_PARENTCONTRACT_CODE']) && $record ['FICO_PARENTCONTRACT_CODE'] !== 'null') {
            $parentfico = ClxCommon::$db->getRecord($this->ficoname, 'IDCODE = ' . singleQuote($record ['FICO_PARENTCONTRACT_CODE']));
            foreach ($parentfico as $key => $val) {
                if ($key === 'MODIFIEDBY' || $key === 'MDATE' || $key === 'CREATEDBY' || $key === 'CDATE' || $key === 'TOTALBALANCE_AMT' || $key === 'SUBBALANCE_AMT' || $key === 'BASE_BAL_AMT' || $key === 'BALANCE_AMT' || $key === 'CANCEL_DATE' || $key === 'START_DATE' || $key === 'EXPIRATION_DATE' || $key === 'PROJECT_CODE' || $key === 'EFFTDATE' || $key === 'DESCRIPTION' || $key === 'CONTRACT_STATUS' || $key === 'PARENTCONTRACT_CODE' || $key === 'START_AMT' || $key === 'CLX_AUTH_STATUS')
                    continue;
                else
                    $record ['FICO_' . $key] = $val;
            }
            $record ['FICO_EFFTDATE'] = $record ['FICO_START_DATE'];
            unset($record ['ID']);
            $subcode = (ClxCommon::$db->countRecords($this->ficoname, 'PARENTCONTRACT_CODE = ' . singleQuote($record ['FICO_PARENTCONTRACT_CODE'])) + CLX_NUM_ONE);
            if (strlen($subcode) < CLX_NUM_THREE)
                $subcode = str_repeat('0', CLX_NUM_THREE - strlen($subcode)) . $subcode;
            $record ['FICO_IDCODE'] = $record ['FICO_PARENTCONTRACT_CODE'] . '-' . $subcode;
            $record ['FICO_CONTRACT_NUMBER'] = $parentfico ['CONTRACT_NUMBER'] . '-' . $subcode;
        }
    }

    /**
     * Action from jump listing
     */
    public function build_fico_from_oppo_jump_action() {
        $contents = '';
        $idlist = getIdlist();
        if (empty($idlist))
            return;
        foreach ($idlist as $oppoid) {
            $msg = array();
            $contract_number = '';
            if ($this->build_oppo_fico($oppoid, $msg, $contract_number)) {
                // Send ok
                $link = 'tool.php?to=EDIT&ac=DISPLAY&li=FICO&qy=FICO&relfm=&idlist=' . ClxCommon::$db->getField($this->ficoname, 'ID', 'CONTRACT_NUMBER =' . singleQuote($contract_number));
                if($this->debug) echo '<br>Antes de OPPO_OPPSTAGE_CLOSED_STATUS<br>$link='.$link.'<br>';
                $contents .= dict('GEN_LBL_CONTRACT_CREATION_OK') . ' <a href=' . singleQuote($link) . '>' . $contract_number . '</a><br>';
                //Colocando el valor de status definido en el parametro
                $oppo_closed_stage = companyParameter('OPPO_OPPSTAGE_CLOSED_STATUS', '');
                if (!empty($oppo_closed_stage)) {
                    ClxCommon::$db->updateRecord($this->opponame, array('OPPSTAGE' => $oppo_closed_stage), 'ID=' . $oppoid);
                    if($this->debug) echo '<br>Despues de OPPO_OPPSTAGE_CLOSED_STATUS<br>';
                }
            } else {
                // send msg errors
                $contents .= smsg('MSG-354') . '<br>' . $this->displayMsg($msg);
            }
        }
        return dialog(dict('GEN_LBL_NOTE'), CLX_CLASS_DATA, $contents, '') . '<Br>';
    }

    /**
     * Buils msg list for conversion
     * @param unknown_type $msg
     * @return string
     */
    private function displayMsg($msg) {
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProp(CLX_PROP_WIDTH, CLX_PROP_100PCT);
        $sql = 'SELECT DISTINCT IFNULL(F.TABLECODE, NULLIF(FPF.TABLECODE,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ')) TABLECODE, FPF.FIELDNAME, FPF.FIELDFORMLABEL, DICT.VALUE FROM CLX_UI_FORM_PANEL_FIELDS FPF, CLX_UI_FORM_PANELS FP, CLX_UI_FORMS F, CLX_DICTIONARY DICT WHERE FP.IDCODE = FPF.PANELID AND F.IDCODE = FP.FORMCODE AND DICT.ENTRY = FPF.FIELDFORMLABEL AND F.IDCODE IN (' . singleQuoteArray(array('FICO', 'ACCO_PERS', 'ACCO_GEN', 'ACCO_CORP', 'OPPORTUNITY')) . ') AND UPPER(DICT.LANGUAGE) = ' . singleQuote(uppercase($_SESSION ['prefs'] ['LANGUAGE']));
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, NUMERIC)) {
            $lbl [$r [CLX_NUM_ZERO] . '_' . $r [CLX_NUM_ONE]] = dict($r [CLX_NUM_TWO]);
        }

        foreach ($msg as $key => $val) {
            if (!empty($lbl [$key])) {
                $table->addCell($lbl [$key], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            } else {
                $table->addCell($key, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            }
            $table->addCell($val, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        }
        return $table->source();
    }

    /**
     * Builds contract from opportunity
     *
     * @param string $opporec
     * @return boolean
     */
    private function build_oppo_fico($oppoid, &$msg, &$contract_number) {
        $sql = 'SELECT OPPO.*, ACCO.IDENTIFICATION, ACCO.ACCDEP FROM ' . $this->opponame . ' OPPO, ' . $this->acconame . ' ACCO WHERE ACCO.IDCODE = OPPO.ACCOUNTCODE AND OPPO.ID = ' . $oppoid;
        $opporec = ClxCommon::$db->getOneRecord($sql);
        if (empty($opporec))
            return false;
        $EDIT = &getTool('EDIT');
        $UIFM = &getTool('UIFM');
        $savepost = UserRequest::$post;
        $formcode = '';
        $formrec = array();
        $tablecode = '';
        $tablerec = array();
        if (empty($opporec ['CONTRACT_TYPE'])) {
            return true;
        }
        if($this->debug) $this->show_fico_debug($opporec, 1);
        $contract_number = ClxCommon::$db->getField($this->ficoname, 'CONTRACT_NUMBER', 'OPPO_CODE = ' . singleQuote($opporec ['IDCODE']));

        if (empty($contract_number)) {

            if (!function_exists('setCreationIdCode'))
                includeCodeLib('GEN_REC_UTIL');
            //getMenuInformation($listingcode, $formname, &$formcode, &$formrec, &$tablecode, &$tablerec)
            $EDIT->getMenuInformation('FICO', 'CREATE_FORM', $formcode, $formrec, $tablecode, $tablerec);
            $ficoRec = $EDIT->defaultRecord($tablerec);
            $EDIT->executeInitEvents($formrec, $tablerec, $ficoRec, $msg);
            foreach ($opporec as $key => $val) {
                if (array_key_exists('FICO_' . $key, $ficoRec)) {
                    $ficoRec ['FICO_' . $key] = $val;
                }
            }

            $ficoRec ['FICO_OPPO_CODE'] = $opporec ['IDCODE'];
            $ficoRec ['FICO_OPPO_CODE_prim'] = $opporec ['IDCODE'];
            $ficoRec ['FICO_OPPO_CODE_secd'] = $opporec ['IDNAME'];
            $ficoRec ['FICO_IDCODE'] = 'AUTO';
            $ficoRec ['FICO_IDNAME'] = $opporec ['IDNAME'];
            $ficoRec ['FICO_DESCRIPTION'] = $opporec ['DESCRIPTION'];
            $ficoRec ['FICO_CONTRACT_NUMBER'] = $this->get_temp_contract_number();
            $ficoRec ['FICO_CDATE'] = $this->now;
            $ficoRec ['FICO_MDATE'] = $this->now;
            $ficoRec ['FICO_CREATEDBY'] = $opporec ['CREATEDBY'];
            $ficoRec ['FICO_MODIFIEDBY'] = $opporec ['MODIFIEDBY'];
            $ficoRec ['FICO_COMP_CODE_prim'] = $opporec ['COMP_CODE'];
            $ficoRec ['FICO_COMP_CODE'] = $opporec ['COMP_CODE'];
            $ficoRec ['FICO_EFFTDATE'] = $opporec ['ESTCLOSE_DATE'];
            $ficoRec ['FICO_START_DATE'] = $opporec ['ESTCLOSE_DATE'];
            $ficoRec ['FICO_FI_TYPE'] = $opporec ['FI_TYPE'];
            $ficoRec ['FICO_CONTRACT_TYPE'] = $opporec ['CONTRACT_TYPE'];
            $ficoRec ['FICO_CANCEL_DATE'] = '';
            $ficoRec ['FICO_EXPIRATION_DATE'] = (empty($opporec['EXPIRATION_DATE'])) ? '' : $opporec['EXPIRATION_DATE'];
            $ficoRec ['FICO_CONTRACT_STATUS'] = 'NEG';
            $ficoRec ['FICO_CLX_AUTH_STATUS'] = 'PEND';
            $ficoRec ['FICO_CAPITAL_FORMULA'] = CLX_INIT_ZERO;
            $ficoRec ['FICO_TAXID'] = $opporec ['IDENTIFICATION'];
            $ficoRec ['FICO_COMITTED_TRUST_AMT'] = $opporec ['POTENTIAL_REVENUE'];
            $ficoRec ['FICO_ACCDEP'] = $opporec ['ACCDEP'];
            $ficoRec ['FICO_ID'] = CLX_INIT_ZERO;
            UserRequest::$post = $ficoRec;
            $UIFM->userCheckForm($formrec, $ficoRec, $msg);
            if (empty($msg)) {
                $ficoRec = ClxCommon::$db->getRecord($this->ficoname, 'COMP_CODE =' . singleQuote($ficoRec ['FICO_COMP_CODE']) . ' AND CONTRACT_NUMBER = ' . singleQuote($ficoRec ['FICO_CONTRACT_NUMBER']));
                if($this->debug) $this->show_fico_debug($opporec, 41);
                if (empty($ficoRec)) {
                    $ficoId = $EDIT->createRecord($formrec, $tablerec, false);
                    if($this->debug) $this->show_fico_debug($opporec, 42);
                    $fico_qty = ClxCommon::$db->getField($this->ficoname, 'COUNT(ID)', 'OPPO_CODE = ' . singleQuote($opporec ['IDCODE']));
                    if($this->debug) echo '<br>fico_qty='.$fico_qty.'<br>';
                    if($fico_qty > 1) {
                        $sql = 'SELECT * FROM ' . $this->ficoname . ' WHERE ID <> ' . $ficoId . ' AND OPPO_CODE = ' . singleQuote($opporec ['IDCODE']);
                        if($this->debug) $this->show_fico_debug($opporec, 43, $sql);
                        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ficoname . ' WHERE ID <> ' . $ficoId . ' AND OPPO_CODE = ' . singleQuote($opporec ['IDCODE']));
                    }
                    $ficoRec = ClxCommon::$db->getFields($this->ficoname, 'IDCODE, IDNAME, CONTRACT_NUMBER', 'ID=' . $ficoId);
                }
                $contract_number = $ficoRec['CONTRACT_NUMBER'];
                $DBTB = &getTool('DBTB');
                //Clear orphans
                ClxCommon::$db->executeQuery('DELETE FROM ' . $this->fipaname . ' WHERE CONTRACT_CODE =' . singleQuote($ficoRec ['IDCODE']));
                ClxCommon::$db->executeQuery('DELETE FROM ' . $this->coobname . ' WHERE CONTRACT_CODE =' . singleQuote($ficoRec ['IDCODE']));
                // Creado contrato crear participantes
                $newRec = $DBTB->tableDefaultRecord('FIPA');
                $newRec ['IDCODE'] = 'AUTO';
                $newRec ['CONTRACT_CODE'] = $ficoRec ['IDCODE'];
                $newRec ['ACCOUNTCODE'] = $opporec ['ACCOUNTCODE'];
                $newRec ['START_DATE'] = $opporec ['ESTCLOSE_DATE'];
                $newRec ['END_DATE'] = 'null';
                $newRec ['STATUS'] = 'I';
                $newRec ['PARTICIPANT_TYPE'] = 'G';
                $newRec ['CLX_AUTH_STATUS'] = 'PEND';
                $newRec ['ISPRIMARY'] = CLX_NUM_ONE;
                $newRec ['CAPITALIZATION_PCT'] = CLX_NUM_HUNDRED;
                $newRec ['CAPPAYMENT_PCT'] = CLX_INIT_ZERO;
                $newRec ['COMITTED_TRUST_AMT'] = $opporec ['POTENTIAL_REVENUE'];
                $newRec ['CDATE'] = $this->now;
                $newRec ['MDATE'] = $this->now;
                $newRec ['CREATEDBY'] = $opporec ['CREATEDBY'];
                $newRec ['MODIFIEDBY'] = $opporec ['MODIFIEDBY'];
                unset($newRec ['ID']);
                setCreationIdCode($newRec, 'FIPA');
                ClxCommon::$db->createRecord($this->fipaname, $newRec, false);
                // Creando Objetivos de contrato
                $newRec = $DBTB->tableDefaultRecord('COOB');
                $newRec ['SEQNUM'] = '1';
                $newRec ['CONTRACT_CODE'] = $ficoRec ['IDCODE'];
                $newRec ['EFFTDATE'] = $this->now;
                /* $newRec ['IDNAME'] = substr($opporec ['CONTRACT_OBLIGATIONS'], CLX_NUM_ZERO, CLX_NUM_60);
                  $newRec ['DESCRIPTION'] = $opporec ['CONTRACT_OBLIGATIONS']; */
                $newRec ['IDNAME'] = substr($opporec ['OBJECTIVE'], CLX_NUM_ZERO, CLX_NUM_60);
                $newRec ['DESCRIPTION'] = $opporec ['OBJECTIVE'];
                $newRec ['NOTES'] = '';
                $sep = CLX_CHAR_NL . '---' . CLX_CHAR_NL;
                if (!empty($opporec ['CONTRACT_OBLIGATIONS'])) {
                    $newRec ['NOTES'] .= $sep . $opporec ['CONTRACT_OBLIGATIONS'];
                }
                if (!empty($opporec ['OBSERVATIONS'])) {
                    $newRec ['NOTES'] .= $sep . $opporec ['OBSERVATIONS'];
                }
                if (!empty($opporec ['BENEFICIARIES'])) {
                    $newRec ['NOTES'] .= $sep . $opporec ['BENEFICIARIES'];
                }
                if (!empty($opporec ['FUNDS_SRCS'])) {
                    $newRec ['NOTES'] .= $sep . $opporec ['FUNDS_SRCS'];
                }
                if (!empty($opporec ['REPORTING_REQ'])) {
                    $newRec ['NOTES'] .= $sep . $opporec ['REPORTING_REQ'];
                }
                if (!empty($opporec ['SERVICE_FEES'])) {
                    $newRec ['NOTES'] .= $sep . $opporec ['SERVICE_FEES'];
                }
                $newRec ['CDATE'] = $this->now;
                $newRec ['MDATE'] = $this->now;
                $newRec ['CREATEDBY'] = $opporec ['CREATEDBY'];
                $newRec ['MODIFIEDBY'] = $opporec ['MODIFIEDBY'];
                unset($newRec ['ID']);
                ClxCommon::$db->createRecord($this->coobname, $newRec, false);
            } else {
                // Error mostrar mensajes de conversion
                UserRequest::$post = $savepost;
                return false;
            }
        } else {
            // Already exists a record
        }
        UserRequest::$post = $savepost;
        return true;
    }

    /**
     * Debug FICO record for a given opportunity
     * For testing purposes only
     */
    function show_fico_debug($opporec, $num, $sql = '') {
        if($sql === '') {
            $sql = 'SELECT ID, CONTRACT_NUMBER, IDNAME, IDCODE FROM ' . $this->ficoname . ' WHERE OPPO_CODE = ' . singleQuote($opporec ['IDCODE']);
        }
        echo '<br><h2>'.$num.')</h2> '.$sql;
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord ($rs)) {
            echo '<br>' . $r ['ID'] . ' | ' .  $r ['CONTRACT_NUMBER'] . ' | ' .  $r ['IDNAME'] . ' | ' .  $r ['IDCODE'];
        }
    }
    
    /**
     * For testing porpouses only
     */
    function fico_reset_contract() {
        $idlist = getIdlist();
        // Recalculation ledgers
        if (!class_exists('Leba'))
            includeCodeLib('LEBA');
        if (!class_exists('Fibk'))
            includeCodeLib('FIBK');
        $a = new Leba ();
        $fibk = new fibk_utilities ();
        foreach ($idlist as $key => $val) {
            $ficorec = ClxCommon::$db->getRecord($this->ficoname, 'ID = ' . singleQuote($val));
            if (!empty($ficorec ['IDCODE'])) {
                ClxCommon::$db->executeQuery('UPDATE ' . $this->ficoname . ' SET CLX_AUTH_STATUS = ' . singleQuote('PEND') . ', CONTRACT_STATUS = ' . singleQuote('NEG') . ' WHERE IDCODE =' . singleQuote($ficorec ['IDCODE']));
                ClxCommon::$db->executeQuery('UPDATE ' . $this->fipaname . ' SET CLX_AUTH_STATUS = ' . singleQuote('PEND') . ', STATUS=' . singleQuote('I') . ' WHERE CONTRACT_CODE =' . singleQuote($ficorec ['IDCODE']));
                ClxCommon::$db->executeQuery('UPDATE ' . $this->fiatname . ' SET REVERSED = 0, VOID = 0, TRANS_STATUS = ' . singleQuote('PEND') . ', CLX_AUTH_STATUS = ' . singleQuote('PEND') . ' WHERE CHART_FIELD01 =' . singleQuote($ficorec ['IDCODE']));
                ClxCommon::$db->executeQuery('UPDATE ' . $this->fimtname . ' SET REVERSED = 0, VOID = 0, TRANS_STATUS = ' . singleQuote('PEND') . ', CLX_AUTH_STATUS = ' . singleQuote('PEND') . ' WHERE CHART_FIELD01 =' . singleQuote($ficorec ['IDCODE']));
                if (!empty($this->apinname)) {
                    ClxCommon::$db->executeQuery('UPDATE ' . $this->apinname . ' SET CLX_AUTH_STATUS = ' . singleQuote('PEND') . ', INVO_STAT=' . "'01'" . ' WHERE CHART_FIELD01 =' . singleQuote($ficorec ['IDCODE']));
                }
                if (!empty($this->invoname)) {
                    ClxCommon::$db->executeQuery('UPDATE ' . $this->invoname . ' SET CLX_AUTH_STATUS = ' . singleQuote('PEND') . ', INVO_STAT=' . "'01'" . ' WHERE CHART_FIELD01 =' . singleQuote($ficorec ['IDCODE']));
                }
                ClxCommon::$db->executeQuery('UPDATE ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD SET JEHD.HAS_INVOICE = 0, JEHD.INT_SALE_COMPLETE = 0, JEHD.REVERSED = 0, JEHD.JE_STATUS = ' . singleQuote('PEND') . ', JEHD.CLX_AUTH_STATUS = ' . singleQuote('PEND') . ' WHERE JELN.JEHDR_CODE = JEHD.IDCODE AND JELN.CHART_FIELD01 =' . singleQuote($ficorec ['IDCODE']));
                ClxCommon::$db->executeQuery('DELETE FROM ' . $this->lebaname . ' WHERE CHART_FIELD01 =' . singleQuote($ficorec ['IDCODE']));
                ClxCommon::$db->executeQuery('DELETE FROM ' . $this->jeblname . ' WHERE CHART_FIELD01 =' . singleQuote($ficorec ['IDCODE']));
                // need to rebueld
                $a->leba_rebuild($ficorec ['COMP_CODE']);
                $sql = 'SELECT FIBK.BANK_ACCOUNT_NO FROM ' . $this->fibkname . ' FIBK, ' . $this->fiasname . ' FIAS WHERE FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE AND FIAS.CONTRACT_CODE = ' . singleQuote($ficorec ['IDCODE']);
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $fibk->update_balances($r ['BANK_ACCOUNT_NO']);
                }
				ClxCommon::$db->freeResult($rs);
            }
        }
    }

    function fico_comp_operation_parameters($contract_code = '') {
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        if ($contract_code !== '') {
            $comp_code = ClxCommon::$db->getField($this->ficoname, 'COMP_CODE', 'IDCODE = ' . singleQuote($contract_code));
        } else {
            $comp_code = '';
        }
        $comp = new Comp ();
        return $comp->comp_operation_parameters($comp_code);
    }

}
