<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-03-07 18:07:27 -0500 (Mon, 07 Mar 2016) $
 * @version        $Rev: 7927 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Fipd {

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('FITB', 'FITS', 'FIBK', 'COMP', 'FICO', 'FIPD', 'FIPA', 'FTMP', 'TTPA', 'JEIT', 'JEHD', 'JELN', 'FIRT', 'FIAC', 'FIMT', 'FETR', 'FIAT', 'FIRS', 'ACCO', 'GLCP', 'JACP', 'GLAC', 'JCBV'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $record
     */
    function fipd_init_form(&$record) {
        if (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE' || UserRequest::$request['ac'] === 'MODIFY') {
		  $record['FIPD_CHART_FIELD01'] = ClxCommon::$db->getField($this->fiatname, 'CHART_FIELD01', 'IDCODE = ' . singleQuote($record['FIPD_TRANS_CODE']));
		  $record['FIPD_CHART_FIELD01_prim'] = ClxCommon::$db->getField($this->ficoname, 'CONTRACT_NUMBER', 'IDCODE = ' . singleQuote($record['FIPD_CHART_FIELD01']));
        }
        if (UserRequest::$request['ac'] === 'CREATE' && empty(UserRequest::$post['confirm'])) {
		  //Sumarizing left
		  $sql = 'SELECT MAX(FIAT.TRANS_AMT)-IFNULL(SUM(FIPD.PARTICIPATION_AMT),0) FROM ' . $this->fiatname . ' FIAT LEFT JOIN ' . $this->fipdname . ' FIPD ON FIAT.IDCODE = FIPD.TRANS_CODE WHERE FIAT.IDCODE = ' . singleQuote($record['FIPD_TRANS_CODE']);
		  $record['FIPD_PARTICIPATION_AMT'] = ClxCommon::$db->getOne($sql);
        }
    }

//emd method
    /**
     * Validate record information
     * Executed on table validate
     */
    function fipd_validate_form(&$record, &$msg) {
        $fiatrec = ClxCommon::$db->getRecord($this->fiatname, 'IDCODE = ' . singleQuote($record['FIPD_TRANS_CODE']));
        if (!empty($fiatrec['REV_TRANS_CODE'])) {
		  $msg['FIPD_CHART_FIELD02'] = smsg('MSG-89', $fiatrec['IDCODE']);
        }
        //validar situacion de transaccion pendiente o no
        if ($fiatrec['CLX_AUTH_STATUS'] <> 'PEND') {
		  $msg['FIPD_PARTICIPANT_ID'] = smsg('MSG-24', $fiatrec['IDCODE']);
		  if (UserRequest::$request['ac'] === 'DELETE')
			 addMessage($msg['FIPD_PARTICIPANT_ID']);
		  return false;
        }
        //Validar participante este en ese contrato
        $sql = 'SELECT COUNT(FIPA.ID) FROM ' . $this->fipaname . ' FIPA, ' . $this->ficoname . ' FICO WHERE FICO.IDCODE = FIPA.CONTRACT_CODE AND FIPA.CONTRACT_CODE = ' . singleQuote($fiatrec['CHART_FIELD01']) . ' AND FIPA.ACCOUNTCODE = ' . singleQuote($record['FIPD_CHART_FIELD02']) . ' AND STATUS=' . singleQuote('A') . '';
        if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
		  $msg['FIPD_CHART_FIELD02'] = smsg('MSG-32', '', $fiatrec['CHART_FIELD01']);
        }
        //not cero
        if ($record['FIPD_PARTICIPATION_AMT'] == CLX_NUM_ZERO) {
		  $msg['FIPD_PARTICIPATION_AMT'] = smsg('MSG-34', $fiatrec['IDCODE']);
        }
        //Validar que la transaccion no tenga participante
        if (!empty($fiatrec['CHART_FIELD02'])) {
		  $msg['FIPD_CHART_FIELD02'] = smsg('MSG-84', $fiatrec['CHART_FIELD01']);
        }
        //Authorization methods perform all journal validations
        if (UserRequest::$request['ac'] === 'REQAUTHORIZATION') {
		  return (count($msg) > CLX_NUM_ZERO) ? false : true;
        }
    }

    /**
     * Update Parent (FIAT) Information one record is saved
     */
    function fipd_save_form(&$record) {
        //updating accounting
        if (!class_exists('Fiat'))
		  includeCodeLib('FIAT');
        $trans = ClxCommon::$db->getRecord($this->fiatname, 'IDCODE = ' . singleQuote($record['TRANS_CODE']));
        $a = new Fiat();
        $a->fiat_save_form($trans);
        unset($a, $trans);
    }

}
