<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-02-03 15:54:07 -0500 (Wed, 03 Feb 2016) $
 * @version        $Rev: 7783 $
 *
 * CHANGE LOG
 *  Included svn prop
 */

/**
 * Initialice fits form
 * Executed on init event
 */
function fits_init_form(&$record) {
    if (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE') {
        $sql = 'SELECT MAX(SEQNUM) FROM ' . tableName('FITS') . '  WHERE TRANSTBL_CODE =' . singleQuote($record['FITS_TRANSTBL_CODE']);
        $record['FITS_SEQNUM'] = CLX_NUM_ONE + ClxCommon::$db->getOne($sql);
    }
}

/**
 * Validate record information
 * Executed on table validate
 */
function fits_validate_form(&$record, &$msg) {
    $glacname = tableName('GLAC');
    if ($record['FITS_AFFECT_TYPE'] <> 'OTH') {
        if (!empty($record['FITS_GLACCOUNTCODE'])) {
		  $msg['FITS_GLACCOUNTCODE'] = smsg('MSG-215');
        }
    } else {
        if (empty($record['FITS_GLACCOUNTCODE'])) {
		  $msg['FITS_GLACCOUNTCODE'] = smsg('MSG-216');
        } else {
		  //Validar que cuenta seleccionada sea de movimientos y este activa
		  $sql = 'SELECT COUNT(GLAC.ID)  FROM ' . $glacname . ' GLAC WHERE GLAC.IDCODE =' . singleQuote($record['FITS_GLACCOUNTCODE']) . ' AND GLAC.ALLOW_ACTIVITY = 1 AND GLAC.EFFTSTAT = ' . singleQuote('A');
		  if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
			 $msg['FITS_GLACCOUNTCODE'] = smsg('MSG-217');
		  }
        }
    }
}

/**
 * Update Parent (FITS) Information one record is saved
 */
function fits_save_form(&$record) {
    //Update modified by and modification date on FITS
    $fitbname = tableName('FITB');
    $rec = array('MODIFIEDBY' => '', 'MDATE' => '');
    if (!function_exists('setCreationData'))
        includeCodeLib('GEN_REC_UTIL');
    setModificationData($rec);
    ClxCommon::$db->updateRecord($fitbname, $rec, 'IDCODE = ' . singleQuote($record['TRANSTBL_CODE']));
}
