<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author	   $Author: alenetdev $
 * @copyright	Alenet, Inc.
 * @since		$Date: 2017-12-12 14:05:13 -0500 (Tue, 12 Dec 2017) $
 * @version		$Rev: 9662 $
 *
 * CHANGE LOG
 *  Included svn prop
 */

/**
 * Generic Accounting Class.
 * Conteing additional options required for accounting
 */
class gl {

    var $gl_codes = array();
    var $gl_codes_detail = array();
    var $comp_code = '';
    var $chart_field01 = '';
    var $chart_field02 = '';
    var $chart_field03 = '';
    var $chart_field04 = '';
    var $fiscal_period = '';
    var $ledger_code = 'AC';
    var $item_code = '';
    var $glaccountcode = '';
    var $currency_code = '';
    var $exclude_subcontracts = false;
    var $sdate = '';
    var $edate = '';
    var $month_sdate = '';
    var $balance_last_date = '';
    var $single_currency = false;
    var $last_balance_date = '';
    var $has_retaing = true;
    var $ret_earning_code = '';
    var $acr_earning_code = '';
    var $closing_entry = CLX_NUM_ONE;
    var $exclude_or_glac = CLX_INIT_ZERO;
    var $period_type = '';
    var $gl_type_in = array();
    var $is_budget = false;
    var $debug = false;
    var $show_account_detail = false; // when true chart field will be set
    var $batch_id;
    var $username;
    var $now;
    var $today;
    var $display = false;
    var $include_current_month = false;
    var $closing_on_demand = false;
    var $jehd_closing_entry = '';
    var $fi_type = '';

    /**
     * Contructor
     */
    function __construct() {
        if (!empty($this->debug))
            echoLog('Accounting class(GL) started');
        multiTableName($this, array('FICO', 'COMP', 'JEHD', 'GLAC', 'GLCP', 'DYCL', 'FTMP', 'GLAG', 'JELN', 'JEHB', 'GLAB', 'JECA', 'JACP', 'CURR', 'BDLN', 'FIPA', 'TTPA', 'JCBV', 'FIAT', 'PCVW', 'FIBK', 'COLO', 'LEGI', 'JELN', 'JEBL', 'CCVW', 'FCVW', 'PROD', 'FIAS', 'JTMP'));
        $this->batch_id = batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
    }

    /**
     * Initialices chart of account
     */
    function init_gl_code() {
        $sql = 'SELECT GLAC.IDCODE, GLAC.IDNAME, GLAC.GL_TYPE, GLAC.TRUST_ITEM_TYPE, GLAC.ACPARENT, GLAC.ALLOW_ACTIVITY, GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE, 0 INITBALANCE, 0 CUR_MONTH_BAL,  GLAC.PROVISION, GLAC.GLGROUP_CODE FROM ' . $this->glcpname . ' GLCP, ' . $this->glacname . ' GLAC WHERE GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLCP.COMP_CODE = ' . singleQuote($this->comp_code) . ' AND GLAC.EFFTSTAT=' . singleQuote('A') . ' ' . ((!empty($this->gl_type_in)) ? 'AND GLAC.GL_TYPE IN (' . singleQuote(implode("','", $this->gl_type_in)) . ') ' : '') . ((!empty($this->exclude_or_glac)) ? 'AND GLAC.GL_TYPE <> ' . singleQuote('OR') : '') . ' ORDER BY GLAC.IDCODE ASC';
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            if (empty($result ['ACPARENT'])) {
                $result ['LEVEL'] = CLX_NUM_ONE;
            } else {
                $this->init_balance_account($result ['ACPARENT'], CLX_NUM_ONE);
                $result ['LEVEL'] = $this->gl_codes [$result ['ACPARENT']] ['LEVEL'] + CLX_NUM_ONE;
            }
            $this->ret_earning_code = $result ['RET_EARNING_CODE'];
            $this->acr_earning_code = $result ['ACR_EARNING_CODE'];
            $this->gl_codes [$result ['IDCODE']] = array('IDNAME' => $result ['IDNAME'], 'GL_TYPE' => $result ['GL_TYPE'], 'TRUST_ITEM_TYPE' => $result ['TRUST_ITEM_TYPE'], 'ACPARENT' => $result ['ACPARENT'], 'RET_EARNING_CODE' => $result ['RET_EARNING_CODE'], 'ALLOW_ACTIVITY' => $result ['ALLOW_ACTIVITY'], 'INITBALANCE' => $result ['INITBALANCE'], 'CUR_MONTH_BAL' => $result ['CUR_MONTH_BAL'], 'DEBIT_AMT' => CLX_NUM_ZERO, 'CREDIT_AMT' => CLX_NUM_ZERO, 'BALANCE_AMT' => $result ['INITBALANCE'], 'LEVEL' => $result ['LEVEL'], 'PROVISION' => $result ['PROVISION'], 'GLGROUP_CODE' => $result ['GLGROUP_CODE'], 'DETAIL' => array());
        }
		ClxCommon::$db->freeResult($results);
    }

    /**
     *
     * @param unknown_type $sql
     * @param unknown_type $from_balance_view
     */
    function chart_field_criteria(&$sql, $from_balance_view = false) {
        $sql .= 'AND JEHD.COMP_CODE = ' . singleQuote($this->comp_code) . ' ';
        if (!empty($this->chart_field01)) {
            if ($this->exclude_subcontracts) {
                $sql .= 'AND JELN.CHART_FIELD01 = ' . singleQuote($this->chart_field01) . ' ';
            } else {
                $sql .= ' AND JELN.CHART_FIELD01 IN (SELECT FICO.IDCODE FROM ' . $this->ficoname . ' FICO WHERE FICO.IDCODE = ' . singleQuote($this->chart_field01) . ' OR (FICO.PARENTCONTRACT_CODE =' . singleQuote($this->chart_field01) . ' AND FICO.PARENTCONTRACT_CODE IS NOT null)) ';
            }
        }
        $sql .= (!empty($this->chart_field02)) ? 'AND JELN.CHART_FIELD02 = ' . singleQuote($this->chart_field02) . ' ' : '';
        $sql .= (!empty($this->chart_field03)) ? 'AND JELN.CHART_FIELD03 = ' . singleQuote($this->chart_field03) . ' ' : '';
        $sql .= (!empty($this->chart_field04)) ? 'AND JELN.CHART_FIELD04 = ' . singleQuote($this->chart_field04) . ' ' : '';
        $sql .= (!empty($this->glaccountcode)) ? 'AND JELN.GLACCOUNTCODE = ' . singleQuote($this->glaccountcode) . ' ' : '';
        $sql .= ($this->single_currency) ? 'AND JELN.CURRENCY_CODE = ' . singleQuote($this->currency_code) . ' ' : '';
        $sql .= (!empty($this->gl_type_in)) ? 'AND GLAC.GL_TYPE IN (' . singleQuote(implode("','", $this->gl_type_in)) . ') ' : '';
        $sql .= (!empty($this->exclude_or_glac)) ? 'AND GLAC.GL_TYPE <> ' . singleQuote('OR') . ' ' : '';
        if ($from_balance_view === true) {

            $sql .= 'AND JEBL.LEDGER_CODE  = ' . singleQuote($this->ledger_code) . ' ';
            $sql = str_replace('JEHD', 'JEBL', $sql);
            $sql = str_replace('JELN', 'JEBL', $sql);
        } else {
            $sql .= ($this->fiscal_period) ? 'AND JEHD.FISCAL_PERIOD = ' . singleQuote($this->fiscal_period) . ' ' : '';
            $sql .= (empty($this->closing_entry)) ? 'AND JEHD.CLOSING_ENTRY <> 1 ' : '';
            $sql .= (!empty($this->item_code)) ? 'AND JELN.ITEM_CODE = ' . singleQuote($this->item_code) : '';
            $sql .= 'AND JEHD.JE_STATUS = ' . singleQuote('AP') . ' ';
            $sql .= 'AND EXISTS(SELECT LEGI.LGGROUP_CODE FROM ' . $this->leginame . ' LEGI WHERE LEGI.LGGROUP_CODE = JEHD.LGGROUP_CODE AND LEGI.LEDGER_CODE  = ' . singleQuote($this->ledger_code) . ') ';
        }
    }

    /**
     * Sets accounting balances
     */
    private function init_gl_balances() {
        // Init Detail
        $this->gl_codes_detail = array();
        // Retrieve perio details
        $this->month_sdate = xFormat::date($this->edate, 'Y-m-01');


        /*
         * $sql = 'SELECT MAX(IDCODE) IDCODE, MAX(TO_DATE) TO_DATE FROM
         * $this->jacpname.' WHERE TO_DATE < '. singleQuote($this->sdate).' AND COMP_CODE =
         * '. singleQuote($this->comp_code);
         */
        if(!empty(UserRequest::$request['last_period'])){
            $last_period = UserRequest::$request['last_period'];
        }
        else{ 
            $sql = 'SELECT MAX(EFFTDATE) EFFTDATE FROM ' . $this->jeblname . ' WHERE EFFTDATE < ' . singleQuote($this->sdate) . ' AND COMP_CODE = ' . singleQuote($this->comp_code);
            $last_period = ClxCommon::$db->getOneRecord($sql);
        } 
        // Search initial balance
        $cc = '';
        $this->chart_field_criteria($cc, true);
		if (!empty($last_period ['EFFTDATE'])) {
			$sql = 'SELECT JEBL.GLACCOUNTCODE GLACCOUNTCODE, ' . (($this->show_account_detail || $this->fi_type) ? 'FICO.FI_TYPE, ' : '') . ' SUM(JEBL.BASE_BAL_AMT) INITBALANCE, 0 CUR_MONTH_BAL, 0 DEBIT_AMT, 0 CREDIT_AMT, SUM(JEBL.BASE_BAL_AMT) BALANCE_AMT FROM ' . $this->ficoname . ' FICO, ' . $this->glacname . ' GLAC, ' . $this->jeblname . ' JEBL, ' . $this->glcpname . ' GLCP WHERE GLCP.COMP_CODE = JEBL.COMP_CODE AND FICO.IDCODE = JEBL.CHART_FIELD01 AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC.IDCODE = JEBL.GLACCOUNTCODE AND JEBL.EFFTDATE = ' . singleQuote($last_period ['EFFTDATE']) . ' ' . $cc . ' ' . (($this->fi_type) ? ' AND FICO.FI_TYPE IN (' . singleQuoteArray($this->fi_type) . ') ' : '') . ' GROUP BY JEBL.GLACCOUNTCODE ' . (($this->show_account_detail || $this->fi_type) ? ', FICO.FI_TYPE ' : '') . ' ORDER BY JEBL.GLACCOUNTCODE ' . (($this->show_account_detail || $this->fi_type) ? ', FICO.FI_TYPE ' : '');
			$rs = ClxCommon::$db->executeQuery($sql);
			while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
				$this->process_balance_line($r);
				if ($this->show_account_detail || $this->fi_type) {
					$this->process_det_balance_line($r);
				}
			}
			ClxCommon::$db->freeResult($rs);
		}
        if ($this->include_current_month) {
            //$this->edate
        }

        $cc = '';
        $this->chart_field_criteria($cc, false);
        // Saldos del periodo
        if ($this->sdate !== '')
            $cc .= 'AND JEHD.EFFTDATE >= ' . singleQuote($this->sdate) . ' ';
        if ($this->edate !== '')
            $cc .= 'AND JEHD.EFFTDATE <= ' . singleQuote($this->edate) . ' ';
        $sql = 'SELECT JELN.GLACCOUNTCODE GLACCOUNTCODE, ' . (($this->show_account_detail || $this->fi_type) ? 'FICO.FI_TYPE, ' : '') . ' 0 INITBALANCE, '
                . (($this->include_current_month) ? 'SUM(IF(JEHD.EFFTDATE >=' . singleQuote($this->month_sdate) . ', (JELN.DEBIT_AMT-JELN.CREDIT_AMT), 0))' : '0') . ' CUR_MONTH_BAL, '
                . 'SUM(JELN.DEBIT_AMT) DEBIT_AMT, SUM(JELN.CREDIT_AMT) CREDIT_AMT, SUM(JELN.DEBIT_AMT - JELN.CREDIT_AMT) BALANCE_AMT FROM ' . $this->glcpname . ' GLCP, ' . $this->jehdname . ' JEHD, ' . $this->glacname . ' GLAC, ' . $this->jelnname . ' JELN, ' . $this->ficoname . ' FICO WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND GLCP.COMP_CODE = JEHD.COMP_CODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND FICO.IDCODE = JELN.CHART_FIELD01 AND JEHD.EFFTDATE >=' . singleQuote($this->sdate) . ' AND JEHD.EFFTDATE <=' . singleQuote($this->edate) . ' ' . $cc . ' ' . (($this->fi_type) ? ' AND FICO.FI_TYPE IN (' . singleQuoteArray($this->fi_type) . ') ' : '') . '  GROUP BY JELN.GLACCOUNTCODE ' . (($this->show_account_detail || $this->fi_type) ? ',FICO.FI_TYPE' : '') . ' ORDER BY JELN.GLACCOUNTCODE ASC ' . (($this->show_account_detail || $this->fi_type) ? ',FICO.FI_TYPE' : '');
        $rs = ClxCommon::$db->executeQuery($sql);
		//pre($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $this->process_balance_line($r);
            if ($this->show_account_detail || $this->fi_type) {
                $this->process_det_balance_line($r);
            }
        }
		ClxCommon::$db->freeResult($rs);
        // setting detail if apply
        if ($this->show_account_detail || $this->fi_type) {
            foreach ($this->gl_codes as $key => $val) {
                // DETAIL
                if (array_key_exists($key, $this->gl_codes_detail)) {
                    $this->gl_codes [$key] ['DETAIL'] = $this->gl_codes_detail [$key];
                    unset($this->gl_codes_detail [$key]);
                }
            }
        }
    }

    /**
     *
     * @param unknown_type $r
     */
    private function process_det_balance_line(&$r) {
        // Storing Details if required
        if (!array_key_exists($r ['GLACCOUNTCODE'], $this->gl_codes_detail)) {
            $this->gl_codes_detail [$r ['GLACCOUNTCODE']] = array();
        }
        if (!array_key_exists($r ['FI_TYPE'], $this->gl_codes_detail [$r ['GLACCOUNTCODE']])) {
            $this->gl_codes_detail [$r ['GLACCOUNTCODE']] [$r ['FI_TYPE']] = array('INITBALANCE' => CLX_NUM_ZERO, 'DEBIT_AMT' => CLX_NUM_ZERO, 'CREDIT_AMT' => CLX_NUM_ZERO, 'BALANCE_AMT' => CLX_NUM_ZERO);
        }
        $this->gl_codes_detail [$r ['GLACCOUNTCODE']] [$r ['FI_TYPE']] ['INITBALANCE'] += $r ['INITBALANCE'];
        $this->gl_codes_detail [$r ['GLACCOUNTCODE']] [$r ['FI_TYPE']] ['DEBIT_AMT'] += $r ['DEBIT_AMT'];
        $this->gl_codes_detail [$r ['GLACCOUNTCODE']] [$r ['FI_TYPE']] ['CREDIT_AMT'] += $r ['CREDIT_AMT'];
        $this->gl_codes_detail [$r ['GLACCOUNTCODE']] [$r ['FI_TYPE']] ['BALANCE_AMT'] = $this->gl_codes_detail [$r ['GLACCOUNTCODE']] [$r ['FI_TYPE']] ['INITBALANCE'] + $this->gl_codes_detail [$r ['GLACCOUNTCODE']] [$r ['FI_TYPE']] ['DEBIT_AMT'] - $this->gl_codes_detail [$r ['GLACCOUNTCODE']] [$r ['FI_TYPE']] ['CREDIT_AMT'];
        //$this->gl_codes_detail [$r ['GLACCOUNTCODE']] [$r ['FI_TYPE']] ['BALANCE_AMT'] = CURMONTH_BAL_AMT
    }

    /**
     * Process each line
     * @param array $r
     */
    function process_balance_line(&$r) {
        $this->init_balance_account($r ['GLACCOUNTCODE'], $r ['INITBALANCE']);
        $this->add_balance($r ['GLACCOUNTCODE'], $r ['INITBALANCE'], $r['CUR_MONTH_BAL'], $r ['DEBIT_AMT'], $r ['CREDIT_AMT'], $r ['BALANCE_AMT']);
        if ($this->has_retaing) {
            if ($this->gl_codes [$r ['GLACCOUNTCODE']] ['GL_TYPE'] === 'IN' || $this->gl_codes [$r ['GLACCOUNTCODE']] ['GL_TYPE'] === 'EX') {
                $this->add_balance($this->ret_earning_code, $r ['INITBALANCE'], $r['CUR_MONTH_BAL'], $r ['DEBIT_AMT'], $r ['CREDIT_AMT'], $r ['BALANCE_AMT']);
            }
        }
    }

    /**
     * Sets accounting balances for budget
     */
    private function init_gl_balances_budget() {
        $cc = '';
        $this->chart_field_criteria($cc);
        $cc = str_replace('JELN.CURRENCY_CODE', 'JELN.CURRENCY_CODE', $cc);
        $cc = str_replace('JEHD.CLX_AUTH_STATUS', 'JELN.CLX_AUTH_STATUS', $cc);
        $cc = str_replace('JEHD.COMP_CODE ', 'JELN.COMP_CODE ', $cc);
        $cc .= (!empty($this->gl_type_in)) ? 'AND GLAC.GL_TYPE IN (' . singleQuote(implode("','", $this->gl_type_in)) . ') ' : '';
        $cc .= (!empty($this->exclude_or_glac)) ? 'AND GLAC.GL_TYPE <> ' . singleQuote('OR') . ' ' : '';
        //$jehbbalances = 'IFNULL((SELECT ((JELN.DEBITS-JELN.CREDITS) * POWER(CURR.EXCHANGE_RT,CURR.CUR_OPERATOR)) INITBALANCE  FROM ' . $this->currname . ' CURR, GL_JOURNAL_LINES JELN WHERE  CURR.BASE_CURRENCY = JEHB.CURRENCY_CODE AND JEHB.CLX_AUTH_STATUS = ' . singleQuote('AP') . ' AND CURR.FOREIGN_CURRENCY = ' . singleQuote($this->currency_code) . ' AND JEHB.GLACCOUNTCODE = JELN.GLACCOUNTCODE AND (JEHB.CHART_FIELD01 = JELN.CHART_FIELD01 OR (JEHB.CHART_FIELD01 IS NULL AND JELN.CHART_FIELD01 IS NULL)) AND (JEHB.CHART_FIELD02 = JELN.CHART_FIELD02 OR (JEHB.CHART_FIELD02 IS NULL AND JELN.CHART_FIELD02 IS NULL)) AND (JEHB.CHART_FIELD03 = JELN.CHART_FIELD03 OR (JEHB.CHART_FIELD03 IS NULL AND JELN.CHART_FIELD03 IS NULL)) AND (JEHB.CHART_FIELD04 = JELN.CHART_FIELD04 OR (JEHB.CHART_FIELD04 IS NULL AND JELN.CHART_FIELD04 IS NULL)) AND (JEHB.ITEM_CODE = JELN.ITEM_CODE OR (JEHB.ITEM_CODE IS NULL AND JELN.ITEM_CODE IS NULL)) AND JEHB.CURRENCY_CODE = JELN.CURRENCY_CODE AND JEHB.COMP_CODE = JEHD.COMP_CODE AND CURR.EFFTDATE = (SELECT MAX(X.EFFTDATE) FROM ' . $this->currname . ' X WHERE CURR.BASE_CURRENCY = X.BASE_CURRENCY AND CURR.FOREIGN_CURRENCY = X.FOREIGN_CURRENCY AND X.EFFTDATE <= JEHB.EFFTDATE) AND JEHB.EFFTDATE = (SELECT MAX(X.EFFTDATE) FROM GL_BALANCES X WHERE X.EFFTDATE < ' . singleQuote($this->sdate) . ') ),0) ';
        $jehbbalances = '0';
        $sql = 'SELECT JELN.GLACCOUNTCODE GLACCOUNTCODE, ' . $jehbbalances . ' INITBALANCE, SUM(( (case GLAC.GL_TYPE WHEN ' . singleQuote('AS') . ' THEN 1 WHEN ' . singleQuote('EX') . ' THEN 1 WHEN ' . singleQuote('CO') . ' THEN 1 ELSE 0 END)*JELN.BALANCE_AMT * POWER(CURR.EXCHANGE_RT,CURR.CUR_OPERATOR))) DEBIT_AMT, SUM(( (case GLAC.GL_TYPE WHEN ' . singleQuote('LI') . ' THEN 1 WHEN ' . singleQuote('IN') . ' THEN 1 WHEN ' . singleQuote('EQ') . ' THEN 1 ELSE 0 END)*JELN.BALANCE_AMT * POWER(CURR.EXCHANGE_RT,CURR.CUR_OPERATOR))) CREDIT_AMT, SUM((((case GLAC.GL_TYPE WHEN ' . singleQuote('LI') . ' THEN -1 WHEN ' . singleQuote('IN') . ' THEN -1 WHEN ' . singleQuote('EQ') . ' THEN -1 ELSE 1 END)*JELN.BALANCE_AMT) * POWER(CURR.EXCHANGE_RT,CURR.CUR_OPERATOR))) BALANCE_AMT FROM ' . $this->currname . ' CURR, ' . $this->glcpname . ' GLCP, ' . $this->glacname . ' GLAC, ' . $this->bdlnname . ' JELN WHERE  GLCP.COMP_CODE = JELN.COMP_CODE AND JELN.GLACCOUNTCODE = GLAC.IDCODE AND CURR.BASE_CURRENCY = JELN.CURRENCY_CODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND CURR.FOREIGN_CURRENCY = ' . singleQuote($this->currency_code) . ' AND CURR.EFFTDATE = (SELECT MAX(X.EFFTDATE) FROM ' . $this->currname . ' X WHERE CURR.BASE_CURRENCY = X.BASE_CURRENCY AND CURR.FOREIGN_CURRENCY = X.FOREIGN_CURRENCY AND X.EFFTDATE <=JELN.CLX_EFFTDATE) ' . $cc . ' GROUP BY JELN.GLACCOUNTCODE ORDER BY JELN.GLACCOUNTCODE ASC'; 
	//	echo #
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $this->init_balance_account($r ['GLACCOUNTCODE'], $r ['INITBALANCE']);
            $r ['BALANCE_AMT'] += $r ['INITBALANCE'];
            $this->add_balance($r ['GLACCOUNTCODE'], $r ['INITBALANCE'], $r['CUR_MONTH_BAL'], $r ['DEBIT_AMT'], $r ['CREDIT_AMT'], $r ['BALANCE_AMT']);
            if ($this->has_retaing) {
                if ($this->gl_codes [$r ['GLACCOUNTCODE']] ['GL_TYPE'] === 'IN' || $this->gl_codes [$r ['GLACCOUNTCODE']] ['GL_TYPE'] === 'EX') {
                    $this->add_balance($this->ret_earning_code, $r ['INITBALANCE'], $r['CUR_MONTH_BAL'], $r ['DEBIT_AMT'], $r ['CREDIT_AMT'], $r ['BALANCE_AMT']);
                }
            }
        }
		ClxCommon::$db->freeResult($rs);
    }

    function dump_glcode() {
        print_r($this->gl_codes);
    }

    function dump_gl_balances() {
        print_r($this->gl_codes);
    }

    /**
     *
     * @param unknown_type $glaccountcode
     * @return boolean
     */
    private function gl_has_parent($glaccountcode) {
        return array_key_exists('ACPARENT', $this->gl_codes [$glaccountcode]) && strlen(trim($this->gl_codes [$glaccountcode] ['ACPARENT'])) > CLX_NUM_ZERO;
    }

    /**
     *
     * @param unknown_type $glaccountcode
     */
    private function gl_get_parent($glaccountcode) {
        return $this->gl_codes [$glaccountcode] ['ACPARENT'];
    }

    /**
     *
     * @param unknown_type $glaccountcode
     * @param unknown_type $initbalance
     */
    private function init_balance_account($glaccountcode, $initbalance = CLX_NUM_ZERO) {
        if (!array_key_exists($glaccountcode, $this->gl_codes)) {
            $glac_rec = ClxCommon::$db->getRecord($this->glacname, 'IDCODE= ' . singleQuote($glaccountcode));
            $this->gl_codes [$glaccountcode] = $glac_rec;
            $this->gl_codes [$glaccountcode] ['INITBALANCE'] = CLX_INIT_ZERO;
            $this->gl_codes [$glaccountcode] ['CUR_MONTH_BAL'] = CLX_INIT_ZERO;
            $this->gl_codes [$glaccountcode] ['DEBIT_AMT'] = CLX_INIT_ZERO;
            $this->gl_codes [$glaccountcode] ['CREDIT_AMT'] = CLX_INIT_ZERO;
            $this->gl_codes [$glaccountcode] ['BALANCE_AMT'] = CLX_INIT_ZERO;
            $this->gl_codes [$glaccountcode] ['LEVEL'] = CLX_INIT_ZERO;
            $this->gl_codes [$glaccountcode] ['ALLOW_ACTIVITY'] = CLX_INIT_ZERO;
            $this->gl_codes [$glaccountcode] ['IDNAME'] = '';
        }
    }

    /**
     *
     * @param unknown_type $glaccountcode
     * @param unknown_type $initbalance
     * @param unknown_type $debit_amt
     * @param unknown_type $credit_amt
     * @param unknown_type $balance_amt
     */
    private function add_balance($glaccountcode, $initbalance, $cur_month, $debit_amt, $credit_amt, $balance_amt) {

        // C:' . $credit_amt.'<br>';
        $this->init_balance_account($glaccountcode);
        if ($debit_amt == CLX_NUM_ZERO && $credit_amt == CLX_NUM_ZERO && $balance_amt == CLX_NUM_ZERO)
            return;
        $this->gl_codes [$glaccountcode] ['INITBALANCE'] = bcadd($this->gl_codes [$glaccountcode] ['INITBALANCE'], $initbalance);
        $this->gl_codes [$glaccountcode] ['CUR_MONTH_BAL'] = bcadd($this->gl_codes [$glaccountcode] ['CUR_MONTH_BAL'], $cur_month);
        $this->gl_codes [$glaccountcode] ['DEBIT_AMT'] = bcadd($this->gl_codes [$glaccountcode] ['DEBIT_AMT'], $debit_amt);
        $this->gl_codes [$glaccountcode] ['CREDIT_AMT'] = bcadd($this->gl_codes [$glaccountcode] ['CREDIT_AMT'], $credit_amt);
        $this->gl_codes [$glaccountcode] ['BALANCE_AMT'] = bcadd($this->gl_codes [$glaccountcode] ['BALANCE_AMT'], $balance_amt);
//        $this->gl_codes [$glaccountcode] ['CURMONTH_BAL_AMT'] = bcadd($this->gl_codes [$glaccountcode] ['CURMONTH_BAL_AMT'], $balance_amt);
        if ($this->gl_has_parent($glaccountcode)) {

            $this->add_balance($this->gl_get_parent($glaccountcode), $initbalance, $cur_month, $debit_amt, $credit_amt, $balance_amt);
        }
    }

    /**
     * Buils Gl Rollup
     *
     * @param string $comp_code
     * @param string $curr_code
     * @param string $ledger_code
     * @param string $fiscal_period
     * @param string $sdate
     * @param string $edate
     * @param string $cf1
     * @param string $cf2
     * @param string $cf3
     * @param string $cf4
     * @param string $item_code
     * @param string $has_retaing
     * @param string $gl_type_in
     * @param string $glacc
     * @param string $single_currency
     * @param bool $exclude_subcontracts
     * @param bool $closing_entry = 1
     * @param bool $exclude_or_glac = 0
     */
    function &rollup($comp_code, $curr_code, $ledger_code, $fiscal_period, $sdate, $edate, $cf1 = '', $cf2 = '', $cf3 = '', $cf4 = '', $item_code = '', $has_retaing = false, $gl_type_in = array(), $glacc = '', $single_currency = '', $exclude_subcontracts = false, $closing_entry = CLX_NUM_ONE, $exclude_or_glac = CLX_NUM_ZERO, $current_month = false) {
        $this->comp_code = $comp_code;
        $this->chart_field01 = $cf1;
        $this->chart_field02 = $cf2;
        $this->chart_field03 = $cf3;
        $this->chart_field04 = $cf4;
        $this->item_code = $item_code;
        $this->glaccountcode = $glacc;
        $this->currency_code = $curr_code;
        $this->ledger_code = $ledger_code;
        $this->fiscal_period = $fiscal_period;
        $this->closing_entry = $closing_entry;
        $this->sdate = $sdate;
        $this->edate = $edate;
        $this->include_current_month = $current_month;
        $this->single_currency = '';
        $this->exclude_subcontracts = $exclude_subcontracts;
        $this->exclude_or_glac = $exclude_or_glac;
        $this->has_retaing = $has_retaing;
        $this->gl_type_in = $gl_type_in;
        $this->init_gl_code();
        if ($this->is_budget) {
            $this->init_gl_balances_budget();
        } else {
            $this->init_gl_balances();
        }
        return $this->gl_codes;
    }

    // GL CAPITALIZATION AND EARNING PAYMENTS

    /**
      ======================================================================== CIERRE CONTABLE ======================================================================== 1 SUMARIZAR INGRESOS - GASTOS. INVERTIR SALDO PARA BLANQUEAR CUENTAS DE INGRESO Y GASTO  SUMARIZAR LINEAS DE INGRESOS Y GASTOS EN TRANSACCION PARA GENERAR LINEA ADICIONAL SI INGRESOS - GASTOS DE TRANSACCION <0
      DEBE PERDIDAS DEL EJERCICIO SI INGRESOS - GASTOS  DE TRANSACCION >0
      HABER GANANCIAS DEL EJERCICIO  2 Capitalizar o pagar resultados CAPITALIZAR RESULTADOS ACUMULADOS DONDE DEBITOS-CREDITOS<0 (SEGUN PARAMETROS):
      Generar Transaccion para el contrato que (Despues del cierre):
      -Ganancia debe(734 RESULTADOS ACUMULADOS) = Con lo que me queda en 734 -Capital haber(731) = Con lo que me queda en 734 Capitalizacion se genera pagada  PAGAR RESULTADOS ACUMULADOS DONDE DEBITOS-CREDITOS<0  (SEGUN PARAMETRO)
      -Ganancia debe(734) = Con lo que me queda en 734 -Effectivo haber(711) = Con lo que me queda en 734 Nota: Pago sera para el siguiente dia pendiente.
      ================================================================================ CAPITALIZACION Y PAGO REGULAR (SI ES CIERRE CONTABLE DEBE DE OMITIRSE ESTE PROCESO) ================================================================================  1 Calcula monto de formula Ingresos - Gastos o Intereses pagados(HABER DE DEVENGOS) (Formula en contrato)  1 CAPITALIZAR RENDIMIENTOS:
      -Ganancia debe(740 GASTO) = Con la formula por porcentaje de capitalizacion -Capital haber(731 CAPITAL) = Con la formula por porcentaje de capitalizacion  2. PAGAR RENDIMIENTO Transaccion Aprobada SYS_GAS -Gasto debe(740 GASTO) = Con la formula por porcentaje de capitalizacion -Cuenta por pagar haber(722 PASIVO) = Con la formula por porcentaje de capitalizacion Transaccion Pendiente de Pago SYS_PER -Cuenta por pagar debe(722 PASIVO) = Con la formula por porcentaje de capitalizacion -Efectivo haber(711 ) = Con la formula por porcentaje de capitalizacion */

    /**
     * Accounting closing.
     *
     *
     * @param array $parameters
     */
    function capitalization($parameters) {
        $this->start_time = microtime_float();
        $comp_code = $parameters ['COMP_CODE'];
        if (empty($comp_code)) {
            echoLog('Invalid company please verify.
			Process ended. Elapse: ' . (microtime_float() - $this->start_time));
            return false;
        }
        $contract_code = $parameters ['CONTRACT_CODE'];
        $participant_id = $parameters ['PARTICIPANT_ID'];
        $operation_date = $parameters ['OPERATION_DATE'];

        if (!class_exists('Jehd'))
            includeCodeLib('JEHD');
        $jehd = new Jehd ();
        if (!class_exists('Fiat'))
            includeCodeLib('FIAT');
        // $fiat = new Fiat ();
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp ();
        $glcprec = ClxCommon::$db->getRecord($this->glcpname, 'COMP_CODE = ' . singleQuote($comp_code));
        $this->closing_on_demand = (array_key_exists('PROCESSCODE', $parameters) && $parameters['PROCESSCODE'] === 'GLAP') ? true : false;
        if($this->closing_on_demand){
            $operation_date = $parameters ['OPERATION_DATE'];
        }else{
            $operation_date = $glcprec ['OPERATION_DATE'];
        }
		if (empty($operation_date)) {
			echoLog('<br> ERROR not operation date for company: '.$comp_code.' <br>');
			return;
		}
        $approve_entry = (empty($glcprec ['GLCLS_APRV_ENTRY'])) ? false : true;
        $last_balance_date = ClxCommon::$db->getOne('SELECT MAX(EFFTDATE) FROM GL_BALANCES WHERE COMP_CODE = ' . singleQuote($comp_code) . ' AND EFFTDATE<=' . singleQuote($operation_date));
        if (empty($last_balance_date)) {
            $last_balance_date = adodb_prev_month_lastday($operation_date);
        }
        // Determinar si es cierre de ejercicio o no
        $this->closing_entry = (!empty($parameters ['GL_CLOSING'])) ? true : false;
        // Determine batch id
        $batch_id = (!empty($parameters ['RUNID'])) ? $parameters ['RUNID'] : batch_id();
        $je_source = 'GLCP';
        $idname = dict('GEN_LBL_CAPANDPAY');
        echoLog('------------------------------------------------');
        echoLog('PROCESSING ' . $idname . '. BATCH ID: ' . $batch_id);
        echoLog('Contract: ' . (($contract_code === '') ? 'ALL' : $contract_code));
        echoLog('Participant: ' . (($participant_id === '') ? 'ALL' : $participant_id));
        echoLog('PROCESSING ' . $operation_date);
        // Load temporary table - Req on mysql
        $DBTB = getTool('DBTB');
        $DBTB->buildTemporaryTable('FTMP');
        // Clearing Temporary table for batch id
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ftmpname);
        // Reject any journal entry asociated to this process
        // Reject all posible pending charges for today.
        echoLog('Pre-Building temporals Elapse: ' . (microtime_float() - $this->start_time));
        if ($this->closing_entry) {
            // This section runs from closing
            if (!$this->closing_on_demand) {
                $sql = 'INSERT INTO ' . $this->ftmpname . ' (IDCODE, COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, LGGROUP_CODE, ITEM_REF_NO, EFFTDATE, CURRENCY_CODE, GLACCOUNTCODE, CALC_AMT_01, CALC_AMT_02, EARNING_PERIOD, DEBIT_AMT, CREDIT_AMT, BATCH_ID, JE_SOURCE, REC_STATUS) '
                        . 'SELECT ' . singleQuote('NONE') . ' IDCODE, JCBV.COMP_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, GLCP.DEF_LGGROUP_CODE, null ITEM_REF_NO, GLCP.OPERATION_DATE EFFTDATE, COMP.CURRENCY_CODE, TTPA.EQ_GL_CODE GLACCOUNTCODE, FIPA.CAPITALIZATION_PCT, FIPA.CAPPAYMENT_PCT, GLCP.CLOSING_PERIOD EARNING_PERIOD, 0 DEBIT_AMT, -1*SUM(JCBV.BASE_BAL_AMT) CREDIT_AMT, ' . singleQuote($batch_id) . '  BATCH_ID, ' . singleQuote($je_source) . ' JE_SOURCE, ' . singleQuote('RUN') . '  REC_STATUS '
                        . 'FROM ' . $this->pcvwname . ' PCVW, ' . $this->jcbvname . ' JCBV, ' . $this->glcpname . ' GLCP, ' . $this->glacname . ' GLAC, ' . $this->ficoname . ' FICO, ' . $this->fipaname . ' FIPA, ' . $this->ttpaname . ' TTPA, ' . $this->compname . ' COMP WHERE GLCP.COMP_CODE = JCBV.COMP_CODE AND COMP.IDCODE = GLCP.COMP_CODE AND PCVW.CHART_FIELD01 = JCBV.CHART_FIELD01 AND PCVW.CHART_FIELD02 = JCBV.CHART_FIELD02 AND FICO.FI_TYPE = TTPA.FI_TYPE AND TTPA.TRUST_FUND_SRC = FICO.TRUST_FUND_SRC AND FICO.CONTRACT_TYPE = TTPA.CONTRACT_TYPE AND TTPA.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND FICO.IDCODE = JCBV.CHART_FIELD01 AND FICO.CONTRACT_STATUS = '.singleQuote('ACTI').' AND FICO.IDCODE = FIPA.CONTRACT_CODE AND FIPA.ACCOUNTCODE = JCBV.CHART_FIELD02 AND GLAC.IDCODE = JCBV.GLACCOUNTCODE AND GLAC.IDCODE = GLCP.RET_EARNING_CODE AND PCVW.MONTH_END = 1 AND PCVW.CLOSING_ENTRY = 1 AND GLCP.COMP_CODE = ' . singleQuote($comp_code) . ' GROUP BY JCBV.COMP_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, GLCP.DEF_LGGROUP_CODE, GLCP.OPERATION_DATE, COMP.CURRENCY_CODE, TTPA.EQ_GL_CODE, FIPA.CAPITALIZATION_PCT, FIPA.CAPPAYMENT_PCT, GLCP.CLOSING_PERIOD HAVING SUM(JCBV.BASE_BAL_AMT)<0 ';
            } else {
                $sql = 'INSERT INTO ' . $this->ftmpname . ' (IDCODE, COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, LGGROUP_CODE, ITEM_REF_NO, EFFTDATE, CURRENCY_CODE, GLACCOUNTCODE, CALC_AMT_01, CALC_AMT_02, EARNING_PERIOD, DEBIT_AMT, CREDIT_AMT, BATCH_ID, JE_SOURCE, REC_STATUS) '
                        . 'SELECT
                                ' . singleQuote('NONE') . ' IDCODE,
                                A.COMP_CODE,
                                A.CHART_FIELD01,
                                A.CHART_FIELD02,
                                A.CHART_FIELD03,
                                A.CHART_FIELD04,
                                A.DEF_LGGROUP_CODE,
                                NULL ITEM_REF_NO,
                                A.OPERATION_DATE EFFTDATE,
                                A.CURRENCY_CODE,
                                TTPA.EQ_GL_CODE GLACCOUNTCODE,
                                FIPA.CAPITALIZATION_PCT,
                                FIPA.CAPPAYMENT_PCT,
                                A.CLOSING_PERIOD EARNING_PERIOD,
                                0 DEBIT_AMT,
                                -1*SUM(A.BALANCE_AMT) CREDIT_AMT,
                                ' . singleQuote($this->batch_id) . '  BATCH_ID,
                                ' . singleQuote('GLCP') . ' JE_SOURCE,
                                ' . singleQuote('RUN') . ' REC_STATUS
                              FROM
                                FIDU_CONTRACTS FICO,
                                FIDU_PARAMETERS_TBL TTPA,
                                FIDU_PARTICIPANTS FIPA,
                                (SELECT
                                  JEBL.COMP_CODE,
                                  JEBL.CHART_FIELD01,
                                  JEBL.CHART_FIELD02, JEBL.CHART_FIELD03, JEBL.CHART_FIELD04,
                                  GLCP.OPERATION_DATE, JEBL.CURRENCY_CODE,
                                  JEBL.GLACCOUNTCODE,
                                  GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE, GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE,
                                  GLCP.CLOSING_PERIOD,
                                  GLCP.DEF_LGGROUP_CODE,
                                  GLCP.GLGROUP_CODE,
                                  SUM(JEBL.BASE_BAL_AMT) BALANCE_AMT
                                FROM
                                  GL_BALANCES JEBL,
                                  GL_PARAMETERS_TBL GLCP,
                                  BASE_COMPANIES COMP
                                WHERE
                                  GLCP.COMP_CODE = JEBL.COMP_CODE
                                  AND COMP.IDCODE = GLCP.COMP_CODE
                                  AND JEBL.GLACCOUNTCODE = GLCP.RET_EARNING_CODE
                                  AND GLCP.COMP_CODE = ' . singleQuote($comp_code) . '
                                  AND JEBL.EFFTDATE = ' . singleQuote($last_balance_date) . '
                                  ' . ((!empty($contract_code)) ? ' AND JEBL.CHART_FIELD01 = ' . singleQuote($contract_code) : '') . '
                                  ' . ((!empty($participant_id)) ? ' AND JEBL.CHART_FIELD02 = ' . singleQuote($participant_id) : '') . '
                                GROUP BY
                                  JEBL.COMP_CODE,
                                  JEBL.CHART_FIELD01,
                                  JEBL.CHART_FIELD02, JEBL.CHART_FIELD03, JEBL.CHART_FIELD04,
                                  GLCP.OPERATION_DATE, JEBL.CURRENCY_CODE,
                                  JEBL.GLACCOUNTCODE,GLCP.DEF_LGGROUP_CODE,GLCP.GLGROUP_CODE,
                                  GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE, GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE,
                                  GLCP.CLOSING_PERIOD
                                HAVING
                                  SUM(JEBL.BASE_BAL_AMT)<>0
                                UNION ALL
                                SELECT
                                  GLDV.COMP_CODE,
                                  GLDV.CHART_FIELD01,
                                  GLDV.CHART_FIELD02, GLDV.CHART_FIELD03, GLDV.CHART_FIELD04,
                                  GLCP.OPERATION_DATE, GLDV.CURRENCY_CODE,
                                  GLDV.GLACCOUNTCODE,
                                  GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE, GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE,
                                  GLCP.CLOSING_PERIOD,
                                  GLCP.DEF_LGGROUP_CODE,
                                  GLCP.GLGROUP_CODE,
                                  SUM(GLDV.DEBIT_AMT-GLDV.CREDIT_AMT) BALANCE_AMT
                                FROM
                                  GL_JOURNAL_DET_VW GLDV,
                                  GL_PARAMETERS_TBL GLCP,
                                  BASE_COMPANIES COMP
                                WHERE
                                  GLCP.COMP_CODE = GLDV.COMP_CODE
                                  AND COMP.IDCODE = GLCP.COMP_CODE
                                  AND GLDV.GLACCOUNTCODE = GLCP.RET_EARNING_CODE
                                  AND GLCP.COMP_CODE = ' . singleQuote($comp_code) . '
                                  AND GLDV.EFFTDATE > ' . singleQuote($last_balance_date) . '
                                  AND GLDV.EFFTDATE<=' . singleQuote($operation_date) . '
                                  ' . ((!empty($contract_code)) ? ' AND GLDV.CHART_FIELD01 = ' . singleQuote($contract_code) : '') . '
                                  ' . ((!empty($participant_id)) ? ' AND GLDV.CHART_FIELD02 = ' . singleQuote($participant_id) : '') . '
                                GROUP BY
                                  GLDV.COMP_CODE,
                                  GLDV.CHART_FIELD01,
                                  GLDV.CHART_FIELD02, GLDV.CHART_FIELD03, GLDV.CHART_FIELD04,
                                  GLCP.OPERATION_DATE, GLDV.CURRENCY_CODE,
                                  GLDV.GLACCOUNTCODE,GLCP.DEF_LGGROUP_CODE,GLCP.GLGROUP_CODE,
                                  GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE, GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE,
                                  GLCP.CLOSING_PERIOD
                                HAVING
                                  SUM(GLDV.DEBIT_AMT-GLDV.CREDIT_AMT)<>0
                                  UNION ALL
                                SELECT
                                    JEHD.COMP_CODE,
                                    JELN.CHART_FIELD01,
                                    JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04,
                                    GLCP.OPERATION_DATE, JELN.CURRENCY_CODE,
                                    JELN.GLACCOUNTCODE,
                                    GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE, GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE,
                                    GLCP.CLOSING_PERIOD,
                                    GLCP.DEF_LGGROUP_CODE,
                                    GLCP.GLGROUP_CODE,
                                    SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) BALANCE_AMT
                                  FROM
                                    GL_JOURNAL_HDR JEHD,
                                    GL_JOURNAL_LINES JELN,
                                    GL_PARAMETERS_TBL GLCP,
                                    BASE_COMPANIES COMP
                                  WHERE
                                    GLCP.COMP_CODE = JEHD.COMP_CODE
                                    AND JEHD.IDCODE = JELN.JEHDR_CODE
                                    AND JELN.GLACCOUNTCODE = GLCP.RET_EARNING_CODE
                                    AND COMP.IDCODE = GLCP.COMP_CODE
                                    AND JEHD.JE_STATUS = ' . singleQuote('PEND') . '
                                    AND JEHD.IDCODE = ' . singleQuote($this->jehd_closing_entry) . '
                                    AND JEHD.COMP_CODE = ' . singleQuote($comp_code) . '
                                    ' . ((!empty($contract_code)) ? ' AND JELN.CHART_FIELD01 = ' . singleQuote($contract_code) : '') . '
                                    ' . ((!empty($participant_id)) ? ' AND JELN.CHART_FIELD02 = ' . singleQuote($participant_id) : '') . '
                                  GROUP BY
                                    JEHD.COMP_CODE,
                                    JELN.CHART_FIELD01,
                                    JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04,
                                    GLCP.OPERATION_DATE, JELN.CURRENCY_CODE,
                                    JELN.GLACCOUNTCODE,GLCP.DEF_LGGROUP_CODE,
                                    GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE, GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE,
                                    GLCP.CLOSING_PERIOD,
                                    GLCP.GLGROUP_CODE
                                  HAVING
                                    SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT)<>0
                                ) A
                              WHERE
                                FIPA.CONTRACT_CODE = A.CHART_FIELD01
                                AND FIPA.ACCOUNTCODE = A.CHART_FIELD02
                                AND FICO.CONTRACT_STATUS = '.singleQuote('ACTI').'
                                AND FICO.IDCODE = A.CHART_FIELD01
                                AND TTPA.TRUST_FUND_SRC = FICO.TRUST_FUND_SRC
                                AND TTPA.CONTRACT_TYPE = FICO.CONTRACT_TYPE
                                AND TTPA.GLGROUP_CODE = A.GLGROUP_CODE
                              GROUP BY
                                A.COMP_CODE,
                                A.CHART_FIELD01,
                                A.CHART_FIELD02,
                                A.CHART_FIELD03,
                                A.CHART_FIELD04,
                                A.DEF_LGGROUP_CODE,
                                A.OPERATION_DATE,
                                A.CURRENCY_CODE,
                                TTPA.EQ_GL_CODE,
                                FIPA.CAPITALIZATION_PCT,
                                FIPA.CAPPAYMENT_PCT,
                                A.CLOSING_PERIOD
                              HAVING
                                SUM(A.BALANCE_AMT) <>0';
            }
            ClxCommon::$db->executeQuery($sql);
        } else {

            // 1 Dump all participants that apply for accounting closing and formula a. In-ex formula
            $sql = 'INSERT INTO ' . $this->ftmpname . ' (IDCODE, COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, EFFTDATE, CURRENCY_CODE, GLACCOUNTCODE, CALC_AMT_01, CALC_AMT_02, EARNING_PERIOD, DEBIT_AMT, CREDIT_AMT, BATCH_ID, JE_SOURCE, REC_STATUS) '
                    . 'SELECT ' . singleQuote('NONE') . ' IDCODE, JCBV.COMP_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, null CHART_FIELD03, null CHART_FIELD04, null ITEM_REF_NO, GLCP.OPERATION_DATE EFFTDATE, COMP.CURRENCY_CODE, TTPA.EQ_GL_CODE GLACCOUNTCODE, FIPA.CAPITALIZATION_PCT, FIPA.CAPPAYMENT_PCT, PCVW.CAP_PERIOD EARNING_PERIOD, SUM(JCBV.BASE_BAL_AMT) DEBIT_AMT, 0 CREDIT_AMT, ' . singleQuote($batch_id) . '  BATCH_ID, ' . singleQuote($je_source) . ' JE_SOURCE, ' . singleQuote('RUN') . '  REC_STATUS FROM ' . $this->jcbvname . ' JCBV, ' . $this->pcvwname . ' PCVW, ' . $this->ficoname . ' FICO, ' . $this->fipaname . ' FIPA, ' . $this->ttpaname . ' TTPA, ' . $this->glcpname . ' GLCP, ' . $this->glacname . ' GLAC, ' . $this->compname . ' COMP WHERE PCVW.COMP_CODE = JCBV.COMP_CODE AND GLCP.COMP_CODE = PCVW.COMP_CODE AND COMP.IDCODE = GLCP.COMP_CODE AND GLAC.IDCODE = JCBV.GLACCOUNTCODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND TTPA.GLGROUP_CODE = GLCP.GLGROUP_CODE AND PCVW.CHART_FIELD01 = JCBV.CHART_FIELD01 AND PCVW.CHART_FIELD02 = JCBV.CHART_FIELD02 AND FICO.IDCODE = PCVW.CHART_FIELD01 AND FICO.CONTRACT_STATUS = '.singleQuote('ACTI').' AND FIPA.CONTRACT_CODE = FICO.IDCODE AND FIPA.ACCOUNTCODE = PCVW.CHART_FIELD02 AND FICO.FI_TYPE = TTPA.FI_TYPE AND FICO.CONTRACT_TYPE = TTPA.CONTRACT_TYPE AND TTPA.TRUST_FUND_SRC = FICO.TRUST_FUND_SRC AND PCVW.MONTH_END = 1 AND PCVW.CLOSING_ENTRY = 1 AND GLCP.COMP_CODE = ' . singleQuote($comp_code) . ' AND FICO.CAPITAL_FORMULA = 0 AND GLAC.GL_TYPE IN (' . singleQuote('IN') . ',' . singleQuote('EX') . ') AND NOT EXISTS( SELECT CCVW.COMP_CODE FROM GL_COMP_CLOSING_VW CCVW WHERE CCVW.COMP_CODE = GLCP.COMP_CODE AND CCVW.CLOSING_ENTRY = 1 AND CCVW.MONTH_END = 1 UNION SELECT FCVW.COMP_CODE FROM GL_FICO_CLOSING_VW FCVW WHERE FCVW.COMP_CODE = GLCP.COMP_CODE AND FCVW.CLOSING_ENTRY = 1 AND FCVW.MONTH_END = 1 AND FCVW.CHART_FIELD01 = JCBV.CHART_FIELD01) GROUP BY JCBV.COMP_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, /*JCBV.CHART_FIELD03, JCBV.CHART_FIELD04,*/ GLCP.OPERATION_DATE, COMP.CURRENCY_CODE, TTPA.EQ_GL_CODE, FIPA.CAPITALIZATION_PCT, FIPA.CAPPAYMENT_PCT, PCVW.CAP_PERIOD';
            ClxCommon::$db->executeQuery($sql);
            echoLog('Post-Building IN-EX Formula Temps Elapse: ' . (microtime_float() - $this->start_time));
            // b. ar formula
            $sql = 'INSERT INTO ' . $this->ftmpname . ' (IDCODE, COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, EFFTDATE, CURRENCY_CODE, GLACCOUNTCODE, CALC_AMT_01, CALC_AMT_02, EARNING_PERIOD, DEBIT_AMT, CREDIT_AMT, BATCH_ID, JE_SOURCE, REC_STATUS) '
                    . 'SELECT ' . singleQuote('NONE') . ' IDCODE, JEHD.COMP_CODE, JELN.CHART_FIELD01, JELN.CHART_FIELD02, null CHART_FIELD03, null CHART_FIELD04, null ITEM_REF_NO, GLCP.OPERATION_DATE EFFTDATE, JELN.CURRENCY_CODE, TTPA.EQ_GL_CODE GLACCOUNTCODE, FIPA.CAPITALIZATION_PCT, FIPA.CAPPAYMENT_PCT, PCVW.CAP_PERIOD EARNING_PERIOD, SUM(JELN.CREDIT_AMT) DEBIT_AMT, 0 CREDIT_AMT, ' . singleQuote($batch_id) . '  BATCH_ID, ' . singleQuote($je_source) . ' JE_SOURCE, ' . singleQuote('RUN') . '  REC_STATUS FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->pcvwname . ' PCVW, ' . $this->ficoname . ' FICO, ' . $this->fipaname . ' FIPA, ' . $this->ttpaname . ' TTPA, ' . $this->glcpname . ' GLCP, ' . $this->glacname . ' GLAC WHERE PCVW.COMP_CODE = JEHD.COMP_CODE AND JEHD.IDCODE = JELN.JEHDR_CODE AND GLCP.COMP_CODE = PCVW.COMP_CODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND TTPA.GLGROUP_CODE = GLCP.GLGROUP_CODE AND PCVW.CHART_FIELD01 = JELN.CHART_FIELD01 AND PCVW.CHART_FIELD02 = JELN.CHART_FIELD02 AND FICO.IDCODE = PCVW.CHART_FIELD01 AND FICO.CONTRACT_STATUS = '.singleQuote('ACTI').' AND FIPA.CONTRACT_CODE = FICO.IDCODE AND FIPA.ACCOUNTCODE = PCVW.CHART_FIELD02 AND FICO.FI_TYPE = TTPA.FI_TYPE AND TTPA.CONTRACT_TYPE = FICO.CONTRACT_TYPE AND TTPA.TRUST_FUND_SRC = FICO.TRUST_FUND_SRC AND JEHD.JE_STATUS = ' . singleQuote('AP') . ' AND JEHD.EFFTDATE>PCVW.PERIOD_START_DATE AND JEHD.EFFTDATE<=GLCP.OPERATION_DATE AND PCVW.MONTH_END = 1 AND PCVW.CLOSING_ENTRY = 1 AND GLCP.COMP_CODE = ' . singleQuote($comp_code) . ' AND FICO.CAPITAL_FORMULA=1 AND GLAC.GL_TYPE = ' . singleQuote('AS') . ' AND GLAC.TRUST_ITEM_TYPE IN (' . singleQuoteArray(array('ARI', 'AR')) . ') AND NOT EXISTS( SELECT CCVW.COMP_CODE FROM GL_COMP_CLOSING_VW CCVW WHERE CCVW.COMP_CODE = GLCP.COMP_CODE AND CCVW.CLOSING_ENTRY = 1 AND CCVW.MONTH_END = 1 UNION SELECT FCVW.COMP_CODE FROM GL_FICO_CLOSING_VW FCVW WHERE FCVW.COMP_CODE = GLCP.COMP_CODE AND FCVW.CLOSING_ENTRY = 1 AND FCVW.MONTH_END = 1 AND FCVW.CHART_FIELD01 = JELN.CHART_FIELD01) GROUP BY JEHD.COMP_CODE, JELN.CHART_FIELD01, JELN.CHART_FIELD02, GLCP.OPERATION_DATE, JELN.CURRENCY_CODE, TTPA.EQ_GL_CODE, FIPA.CAPITALIZATION_PCT, FIPA.CAPPAYMENT_PCT, PCVW.CAP_PERIOD';
            ClxCommon::$db->executeQuery($sql);
            echoLog('Post-Building AR Formula Temps Elapse: ' . (microtime_float() - $this->start_time));
            $sql = 'UPDATE ' . $this->ftmpname . ' SET CREDIT_AMT = ABS(DEBIT_AMT) WHERE DEBIT_AMT<=0 AND BATCH_ID = ' . singleQuote($batch_id);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->ftmpname . ' SET DEBIT_AMT = 0 WHERE DEBIT_AMT<=0 AND BATCH_ID = ' . singleQuote($batch_id);
            ClxCommon::$db->executeQuery($sql);
        }
        // Calculate earnings and payments
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.IDCODE = CONCAT(' . singleQuote('A' . $batch_id) . ',FTMP.IDCODE), FTMP.REQ_CHANNEL = ' . singleQuote('SYS') . ', FTMP.BRANCH  = (SELECT MAX(COLO.IDCODE) FROM ' . $this->coloname . ' COLO, ' . $this->dyclname . ' DYCL WHERE DYCL.COMP_CODE = FTMP.COMP_CODE AND COLO.IDCODE = DYCL.COMPLOC_CODE AND COLO.ISPRIMARY=1), FTMP.BANKACCOUNT_CODE = (SELECT MAX(FIBK.BANK_ACCOUNT_NO) FROM ' . $this->fibkname . ' FIBK, GL_PROD_PRMTR_TBL PRAT, ' . $this->prodname . ' PROD WHERE PROD.CURRENCY_CODE = FTMP.CURRENCY_CODE AND PROD.IDCODE = FIBK.BANK_PROD_CODE AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE AND FIBK.COMP_CODE = FTMP.COMP_CODE AND PRAT.PRO_GL_CODE IS NOT null AND PRAT.PRO_GL_CODE <>' . singleQuote(CLX_CHAR_EMPTY_STRING) . '), FTMP.CALC_AMT_03 = ROUND(ABS(((FTMP.DEBIT_AMT-FTMP.CREDIT_AMT) *FTMP.CALC_AMT_01/100)), 2), FTMP.CALC_AMT_04 = ROUND(ABS(((FTMP.DEBIT_AMT-FTMP.CREDIT_AMT) *FTMP.CALC_AMT_02/100)), 2) WHERE  BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        // Updating currency_code, exchange rt and currency_operator
        $sql = 'SELECT DISTINCT COMP_CODE, CURRENCY_CODE, EFFTDATE FROM ' . $this->ftmpname;
        $results = ClxCommon::$db->executeQuery($sql);
        while (($result = ClxCommon::$db->getNextRecord($results, NUMERIC)) === true) {
            $oper_def = $comp->comp_operation_parameters($result [CLX_NUM_ZERO]);
            $xrate = $comp->comp_current_exchange($result [CLX_NUM_ZERO], $result [CLX_NUM_ONE], $result [CLX_NUM_TWO]);
            $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CUR_OPERATOR = ' . singleQuote($xrate ['CUR_OPERATOR']) . ', FTMP.EXCHANGE_RT = ' . singleQuote($xrate ['EXCHANGE_RT']) . ', FTMP.FISCAL_PERIOD = ' . singleQuote($oper_def ['FISCAL_PERIOD']) . ', FTMP.LGGROUP_CODE = ' . singleQuote($oper_def ['LGGROUP_CODE']) . ' WHERE COMP_CODE = ' . singleQuote($result [CLX_NUM_ZERO]) . ' AND CURRENCY_CODE = ' . singleQuote($result [CLX_NUM_ONE]) . ' AND EFFTDATE = ' . singleQuote($result [CLX_NUM_TWO]) . ' AND BATCH_ID = ' . singleQuote($batch_id);
            ClxCommon::$db->executeQuery($sql);
        }
		ClxCommon::$db->freeResult($results);
        // Clear all cases where debits-credits<=0
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ftmpname . ' WHERE BATCH_ID = ' . singleQuote($batch_id) . ' AND (DEBIT_AMT>CREDIT_AMT OR (CALC_AMT_03 + CALC_AMT_04) = 0)');
        echoLog('Post-Temps calculations: ' . (microtime_float() - $this->start_time));
        $sql = 'SELECT DISTINCT COMP_CODE, REQ_CHANNEL,BRANCH, FISCAL_PERIOD, LGGROUP_CODE FROM ' . $this->ftmpname . ' WHERE BATCH_ID = ' . singleQuote($batch_id) . ' AND REC_STATUS =' . singleQuote('RUN') . '';
        $results = ClxCommon::$db->executeQuery($sql);
        while (($result = ClxCommon::$db->getNextRecord($results))) {
            $gl_rec = $jehd->jehd_init_record();
            $gl_rec ['IDNAME'] = $idname;
            $gl_rec ['JE_SOURCE'] = $je_source;
            $gl_rec ['EFFTDATE'] = $operation_date;
            $gl_rec ['REAL_DATE'] = $operation_date;
            $gl_rec ['COMP_CODE'] = $result ['COMP_CODE'];
            $gl_rec ['REQ_CHANNEL'] = $result ['REQ_CHANNEL'];
            $gl_rec ['BRANCH'] = $result ['BRANCH'];
            $gl_rec ['FISCAL_PERIOD'] = $result ['FISCAL_PERIOD'];
            $gl_rec ['LGGROUP_CODE'] = $result ['LGGROUP_CODE'];
            $gl_rec ['TRANS_CODE'] = null;
            $gl_rec ['BATCH_ID'] = $batch_id;
            $jehd->jehd_build($gl_rec);
            echoLog('<br>Created JEHD: ' . $gl_rec ['IDCODE']);
            // At this point process lines, first capitalizations
            $this->capitalization_lines($gl_rec ['IDCODE'], $operation_date, $batch_id);
            if (empty($this->closing_entry)) {
                $this->payment_ap_lines($gl_rec ['IDCODE'], $operation_date, $batch_id);
            }
            //ordering lines
            $sql = 'UPDATE ' . $this->jelnname . ' SET SEQNUM = 1 WHERE DEBIT_AMT >0 AND JEHDR_CODE =' . singleQuote($gl_rec ['IDCODE']);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->jelnname . ' SET SEQNUM = 2 WHERE CREDIT_AMT >0 AND JEHDR_CODE =' . singleQuote($gl_rec ['IDCODE']);
            ClxCommon::$db->executeQuery($sql);
            if ($approve_entry) {
                if (!$jehd->jehd_approve_by_code($gl_rec ['IDCODE'])) {
                    // if approval fail send note
                    $msg = 'GLCP01 ' . dict('GEN_LBL_BATCHFAILAPPROVE', $batch_id);
                    if (!empty($parameters)) {
                        $PRPR = &getTool('PRPR');
                        $PRPR->report_exception_by_parameters($parameters, $msg, 'JEHD', 'ERRO');
                    } else
                        echoLog($msg);
                }
            }
        }
		ClxCommon::$db->freeResult($results);
        // Processing payments
        $operation_next_date = adodb_next_day($operation_date);
        $next_fiscal_period = $comp->comp_fiscal_period($comp_code, $operation_next_date);
        $this->payment_lines($next_fiscal_period, $operation_next_date, $batch_id, $idname, $je_source);
        // set ftmp to end
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ftmpname);
        echoLog('Capitalization and payments completed, Waiting for stats: ' . (microtime_float() - $this->start_time));
        echoLog('GLCP Process completed: ' . (microtime_float() - $this->start_time));
    }

    /**
     *
     * @param unknown_type $jehdr_code
     * @param unknown_type $operation_date
     * @param unknown_type $batch_id
     */
    private function capitalization_lines($jehdr_code, $operation_date, $batch_id) {
        $sql = 'INSERT INTO  ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, FTMP.GLACCOUNTCODE, ' . singleQuote('GLCP') . ' ITEM_CODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, FTMP.CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR, 0 DEBIT_AMT, CALC_AMT_03 CREDIT_AMT, 0 DEBIT_TRANS_AMT, CALC_AMT_03 CREDIT_TRANS_AMT, 1 SEQNUM FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.REC_STATUS = ' . singleQuote('RUN') . ' AND FTMP.CALC_AMT_03>0';
        ClxCommon::$db->executeQuery($sql);
        // Contraparte
        $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, SEQNUM, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT) SELECT JELN.JEHDR_CODE, ' . ((!$this->closing_entry) ? 'TTPA.EXP_GL_CODE' : 'GLCP.RET_EARNING_CODE') . ' GLACCOUNTCODE, ' . singleQuote('GLCP') . ' ITEM_CODE, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, JELN.ITEM_REF_NO, JELN.CURRENCY_CODE, JELN.EXCHANGE_RT, JELN.CUR_OPERATOR, 0 SEQNUM, JELN.CREDIT_AMT DEBIT_AMT, JELN.DEBIT_AMT CREDIT_AMT, JELN.CREDIT_TRANS_AMT DEBIT_TRANS_AMT, JELN.DEBIT_TRANS_AMT CREDIT_TRANS_AMT FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->glcpname . ' GLCP, ' . $this->ficoname . ' FICO, ' . $this->ttpaname . ' TTPA WHERE GLCP.COMP_CODE = JEHD.COMP_CODE AND JEHD.IDCODE = JELN.JEHDR_CODE AND JELN.CHART_FIELD01 = FICO.IDCODE AND TTPA.GLGROUP_CODE = GLCP.GLGROUP_CODE AND TTPA.CONTRACT_TYPE = FICO.CONTRACT_TYPE AND TTPA.FI_TYPE = FICO.FI_TYPE AND TTPA.TRUST_FUND_SRC = FICO.TRUST_FUND_SRC AND JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND JELN.SEQNUM = 1';
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     *
     * @param unknown_type $jehdr_code
     * @param unknown_type $operation_date
     * @param unknown_type $batch_id
     */
    private function payment_ap_lines($jehdr_code, $operation_date, $batch_id) {
        /*
         * Si no es cierre del ejercicio para el pago es necesario un asiento
         * Asiento Aprobado SYS_GAS //see function capitalization
         * payment_ap_lines() -Gasto debe(740) = Con lo que me queda en 750-740.
         * -Cuenta por pagar haber(722) = Con lo que me queda en 750-740.
         */
        $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, TTPA.AP_GL_CODE GLACCOUNTCODE, ' . singleQuote('GLCP') . ' ITEM_CODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, FTMP.CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR, 0 DEBIT_AMT, CALC_AMT_04 CREDIT_AMT, 0 DEBIT_TRANS_AMT, CALC_AMT_04 CREDIT_TRANS_AMT, 3 SEQNUM FROM ' . $this->ftmpname . ' FTMP, ' . $this->glcpname . ' GLCP, ' . $this->ficoname . ' FICO, ' . $this->ttpaname . ' TTPA WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.CHART_FIELD01 = FICO.IDCODE AND TTPA.GLGROUP_CODE = GLCP.GLGROUP_CODE AND TTPA.CONTRACT_TYPE = FICO.CONTRACT_TYPE AND TTPA.FI_TYPE = FICO.FI_TYPE AND TTPA.TRUST_FUND_SRC = FICO.TRUST_FUND_SRC AND FTMP.COMP_CODE = GLCP.COMP_CODE AND FTMP.REC_STATUS = ' . singleQuote('RUN') . ' AND FTMP.CALC_AMT_04>0';
        ClxCommon::$db->executeQuery($sql);
        // Contraparte
        $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, SEQNUM, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT) SELECT JELN.JEHDR_CODE, TTPA.EXP_GL_CODE GLACCOUNTCODE, ' . singleQuote('GLCP') . ' ITEM_CODE, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, JELN.ITEM_REF_NO, JELN.CURRENCY_CODE, JELN.EXCHANGE_RT, JELN.CUR_OPERATOR, 4 SEQNUM, JELN.CREDIT_AMT DEBIT_AMT, JELN.DEBIT_AMT CREDIT_AMT, JELN.CREDIT_TRANS_AMT DEBIT_TRANS_AMT, JELN.DEBIT_TRANS_AMT CREDIT_TRANS_AMT FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->glcpname . ' GLCP, ' . $this->ficoname . ' FICO, ' . $this->ttpaname . ' TTPA WHERE GLCP.COMP_CODE = JEHD.COMP_CODE AND JEHD.IDCODE = JELN.JEHDR_CODE AND JELN.CHART_FIELD01 = FICO.IDCODE AND TTPA.GLGROUP_CODE = GLCP.GLGROUP_CODE AND TTPA.CONTRACT_TYPE = FICO.CONTRACT_TYPE AND TTPA.FI_TYPE = FICO.FI_TYPE AND TTPA.TRUST_FUND_SRC = FICO.TRUST_FUND_SRC AND JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND JELN.SEQNUM = 3';
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     *
     * @param unknown_type $fiscal_period
     * @param unknown_type $operation_date
     * @param unknown_type $batch_id
     * @param unknown_type $idname
     * @param unknown_type $je_source
     */
    function payment_lines($fiscal_period, $operation_date, $batch_id, $idname, $je_source) {
        $username = $_SESSION ['user_record'] ['username'];
        $now = xFormat::getNow('Y-m-d H:i:s');
        if (!class_exists('Fiat'))
            includeCodeLib('FIAT');
        $fiat = new Fiat ();
        if (!function_exists('setCreationIdCode'))
            includeCodeLib('GEN_REC_UTIL');
        // Setting idcodes
        $sql = 'SELECT DISTINCT FTMP.CURRENCY_CODE, FTMP.COMP_CODE, FTMP.LGGROUP_CODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, FTMP.BANKACCOUNT_CODE FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.CALC_AMT_04>0 AND FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.REC_STATUS = ' . singleQuote('RUN') . ' ';
        $results = ClxCommon::$db->executeQuery($sql);
        while (($result = ClxCommon::$db->getNextRecord($results))) {
            $result ['IDCODE'] = 'AUTO';
            setCreationIdCode($result, 'JEHD');
            $jehdr_code = $result ['IDCODE'];
            $result ['IDCODE'] = 'AUTO';
            setCreationIdCode($result, 'FIAT');
            $trans_code = $result ['IDCODE'];
            $sql = 'UPDATE ' . $this->ftmpname . ' SET IDCODE = ' . singleQuote($jehdr_code . ',') . ' TRANS_CODE = ' . singleQuote($trans_code) . ' WHERE (CHART_FIELD01 = ' . singleQuote($result ['CHART_FIELD01']) . ' OR CHART_FIELD01 IS NULL) AND (CHART_FIELD02 = ' . singleQuote($result ['CHART_FIELD02']) . ' OR CHART_FIELD02 IS NULL) AND (CHART_FIELD03 = ' . singleQuote($result ['CHART_FIELD03']) . ' OR CHART_FIELD03 IS NULL) AND (CHART_FIELD04 = ' . singleQuote($result ['CHART_FIELD04']) . ' OR CHART_FIELD04 IS NULL) AND (LGGROUP_CODE = ' . singleQuote($result ['LGGROUP_CODE']) . ' OR LGGROUP_CODE IS NULL) AND (BANKACCOUNT_CODE = ' . singleQuote($result ['BANKACCOUNT_CODE']) . ' OR BANKACCOUNT_CODE IS NULL) AND (ITEM_REF_NO = ' . singleQuote($result ['ITEM_REF_NO']) . ' OR ITEM_REF_NO IS NULL) AND CURRENCY_CODE = ' . singleQuote($result ['CURRENCY_CODE']) . ' AND JE_SOURCE = ' . singleQuote($je_source) . ' AND BATCH_ID = ' . singleQuote($batch_id) . ' AND REC_STATUS =' . singleQuote('RUN') . '';
            ClxCommon::$db->executeQuery($sql);
        }
		ClxCommon::$db->freeResult($results);
        if ($this->closing_entry) {
            /**
             * Si es semestral o anual(Ejercicio).
             * Transaccion Pendiente
             * -Ganancia debe(734) = Con lo que me queda en 734.
             * -Effectivo haber(711) = Con lo que me queda en 734.
             */
            // build transactions
            $sql = 'INSERT INTO ' . $this->fiatname . ' (IDCODE, IDNAME, EFFTDATE, TRANSTBL_CODE, CLX_AUTH_STATUS, TRANS_STATUS, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, COMP_CODE, REQ_CHANNEL, BRANCH, LGGROUP_CODE, FISCAL_PERIOD, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, FIDU_BANKACT_CODE, TRANS_AMT, RECONCILIED, DISBURSEMENT_TYPE, AVAILABILITY_DATE, BENEFICIARY_NAME, BRANCH_PRN, RECORD_BLOCKING, REFERENCE_NO, JEHDR_CODE, BATCH_ID, JE_SOURCE, CREATEDBY, CDATE, MODIFIEDBY, MDATE) SELECT DISTINCT FTMP.TRANS_CODE IDCODE, ' . singleQuote($idname) . ' IDNAME, ' . singleQuote($operation_date) . ' EFFTDATE, ' . singleQuote('SYS_PER') . ' TRANSTBL_CODE, ' . singleQuote('PEND') . ' CLX_AUTH_STATUS, ' . singleQuote('PEND') . ' TRANS_STATUS, FTMP.CURRENCY_CODE, FTMP.CUR_OPERATOR, FTMP.EXCHANGE_RT, FTMP.COMP_CODE, FTMP.REQ_CHANNEL, FTMP.BRANCH, FTMP.LGGROUP_CODE, ' . singleQuote($fiscal_period) . ' FISCAL_PERIOD, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, FTMP.BANKACCOUNT_CODE, FTMP.CALC_AMT_04 TRANS_AMT, 0 RECONCILIED, ' . singleQuote('OT') . ' DISBURSEMENT_TYPE, ' . singleQuote($operation_date) . ' AVAILABILITY_DATE, null BENEFICIARY_NAME, null BRANCH_PRN, 0 RECORD_BLOCKING, ' . singleQuote($je_source) . ' REFERENCE_NO, FTMP.IDCODE JEHDR_CODE, ' . singleQuote($batch_id) . ' BATCH_ID, ' . singleQuote($je_source) . ' JE_SOURCE, ' . singleQuote($username) . ' CREATEDBY, ' . singleQuote($now) . ' CDATE, ' . singleQuote($username) . ' MODIFIEDBY, ' . singleQuote($now) . ' MDATE FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.CALC_AMT_04>0 AND FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.REC_STATUS = ' . singleQuote('RUN') . ' ';
            ClxCommon::$db->executeQuery($sql);
            $fiat->fiat_build_accounting_batch($batch_id, $je_source);
            // Lines
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT FTMP.IDCODE JEHDR_CODE, ' . ((!$this->closing_entry) ? 'FTMP.GLACCOUNTCODE' : 'IFNULL((SELECT PRAT.PRO_GL_CODE FROM ' . $this->fibkname . ' FIBK, GL_PROD_PRMTR_TBL PRAT WHERE PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE AND FIBK.BANK_ACCOUNT_NO = FTMP.BANKACCOUNT_CODE), 0)') . ' GLACCOUNTCODE, FTMP.CURRENCY_CODE, FTMP.CUR_OPERATOR, FTMP.EXCHANGE_RT, ' . singleQuote('GLCP') . ' ITEM_CODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, ' . ((!$this->closing_entry) ? 'FTMP.CHART_FIELD03' : 'IFNULL((SELECT MAX(FIAS.IDCODE) FROM ' . $this->fibkname . ' FIBK, ' . $this->fiasname . ' FIAS  WHERE FIAS.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND FIAS.CONTRACT_CODE = FTMP.CHART_FIELD01 AND FIBK.BANK_ACCOUNT_NO = FTMP.BANKACCOUNT_CODE),0)') . ' CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, 0 DEBIT_AMT, CALC_AMT_04 CREDIT_AMT, 0 DEBIT_TRANS_AMT, CALC_AMT_04 CREDIT_TRANS_AMT, 4 SEQNUM FROM ' . $this->ftmpname . ' FTMP, ' . $this->glcpname . ' GLCP WHERE GLCP.COMP_CODE = FTMP.COMP_CODE AND FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.REC_STATUS = ' . singleQuote('RUN') . ' AND FTMP.CALC_AMT_04>0';
            ClxCommon::$db->executeQuery($sql);
            // Contraparte
            $sql = 'INSERT INTO ' . $this->jelnname . '(JEHDR_CODE, GLACCOUNTCODE, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT FTMP.IDCODE JEHDR_CODE,  ' . ((!$this->closing_entry) ? ' IFNULL((SELECT PRAT.PRO_GL_CODE FROM ' . $this->fibkname . ' FIBK,GL_PROD_PRMTR_TBL PRAT WHERE PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE AND FIBK.BANK_ACCOUNT_NO = FTMP.BANKACCOUNT_CODE),0) ' : 'GLCP.RET_EARNING_CODE') . ' GLACCOUNTCODE, FTMP.CURRENCY_CODE, FTMP.CUR_OPERATOR, FTMP.EXCHANGE_RT, ' . singleQuote('GLCP') . ' ITEM_CODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, ' . (($this->closing_entry) ? 'FTMP.CHART_FIELD03' : 'IFNULL((SELECT MAX(FIAS.IDCODE) FROM ' . $this->fibkname . ' FIBK, ' . $this->fiasname . ' FIAS  WHERE FIAS.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND FIAS.CONTRACT_CODE = FTMP.CHART_FIELD01 AND FIBK.BANK_ACCOUNT_NO = FTMP.BANKACCOUNT_CODE),0)') . ' CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, CALC_AMT_04 DEBIT_AMT, 0 CREDIT_AMT, CALC_AMT_04 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, 3 SEQNUM FROM ' . $this->ftmpname . ' FTMP, ' . $this->glcpname . ' GLCP WHERE GLCP.COMP_CODE = FTMP.COMP_CODE AND FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.REC_STATUS = ' . singleQuote('RUN') . ' AND FTMP.CALC_AMT_04>0';
            ClxCommon::$db->executeQuery($sql);
        } else { // si no es cierre contable
            /**
             * Si no es cierre del ejercicio
             * Asiento Aprobado SYS_GAS
             * //see function capitalization payment_ap_lines()
             * -Gasto debe(740) = Con lo que me queda en 750-740.
             * -Cuenta por pagar haber(722) = Con lo que me queda en 750-740.
             *
             * Transaccion Pendiente de Pago SYS_PER
             * -Cuenta por pagar debe(722) = Con lo que me queda en 750-740.
             * -Effectivo haber(711) = Con lo que me queda en 750-740.
             */
            // build transactions
            $sql = 'INSERT INTO ' . $this->fiatname . ' (IDCODE, IDNAME, EFFTDATE, TRANSTBL_CODE, CLX_AUTH_STATUS, TRANS_STATUS, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, COMP_CODE, REQ_CHANNEL, BRANCH, LGGROUP_CODE, FISCAL_PERIOD, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, FIDU_BANKACT_CODE, TRANS_AMT, RECONCILIED, DISBURSEMENT_TYPE, AVAILABILITY_DATE, BENEFICIARY_NAME, BRANCH_PRN, RECORD_BLOCKING, REFERENCE_NO, JEHDR_CODE, BATCH_ID, JE_SOURCE, CREATEDBY, CDATE, MODIFIEDBY, MDATE) SELECT DISTINCT FTMP.TRANS_CODE IDCODE, ' . singleQuote($idname) . ' IDNAME, ' . singleQuote($operation_date) . ' EFFTDATE, ' . singleQuote('SYS_PER') . ' TRANSTBL_CODE, ' . singleQuote('PEND') . ' CLX_AUTH_STATUS, ' . singleQuote('PEND') . ' TRANS_STATUS, FTMP.CURRENCY_CODE, FTMP.CUR_OPERATOR, FTMP.EXCHANGE_RT, FTMP.COMP_CODE, FTMP.REQ_CHANNEL, FTMP.BRANCH, FTMP.LGGROUP_CODE, ' . singleQuote($fiscal_period) . ' FISCAL_PERIOD, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, FTMP.BANKACCOUNT_CODE, FTMP.CALC_AMT_04 TRANS_AMT, 0 RECONCILIED, ' . singleQuote('OT') . ' DISBURSEMENT_TYPE, ' . singleQuote($operation_date) . ' AVAILABILITY_DATE, null BENEFICIARY_NAME, null BRANCH_PRN, 0 RECORD_BLOCKING, ' . singleQuote($je_source) . ' REFERENCE_NO, FTMP.IDCODE JEHDR_CODE, ' . singleQuote($batch_id) . ' BATCH_ID, ' . singleQuote($je_source) . ' JE_SOURCE, ' . singleQuote($username) . ' CREATEDBY, ' . singleQuote($now) . ' CDATE, ' . singleQuote($username) . ' MODIFIEDBY, ' . singleQuote($now) . ' MDATE FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.CALC_AMT_04>0 AND FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.REC_STATUS = ' . singleQuote('RUN') . ' ';
            ClxCommon::$db->executeQuery($sql);
            $fiat->fiat_build_accounting_batch($batch_id, $je_source);
            // Lines
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT FTMP.IDCODE JEHDR_CODE, TTPA.AP_GL_CODE, FTMP.CURRENCY_CODE, FTMP.CUR_OPERATOR, FTMP.EXCHANGE_RT, ' . singleQuote('GLCP') . ' ITEM_CODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, CALC_AMT_04 DEBIT_AMT, 0 CREDIT_AMT, CALC_AMT_04 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, 4 SEQNUM FROM ' . $this->ftmpname . ' FTMP, ' . $this->glcpname . ' GLCP, ' . $this->ficoname . ' FICO, ' . $this->ttpaname . ' TTPA WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND GLCP.COMP_CODE = FTMP.COMP_CODE AND FTMP.CHART_FIELD01 = FICO.IDCODE AND TTPA.GLGROUP_CODE = GLCP.GLGROUP_CODE AND TTPA.CONTRACT_TYPE = FICO.CONTRACT_TYPE AND TTPA.FI_TYPE = FICO.FI_TYPE AND TTPA.TRUST_FUND_SRC = FICO.TRUST_FUND_SRC AND FTMP.REC_STATUS = ' . singleQuote('RUN') . ' AND FTMP.CALC_AMT_04>0';
            ClxCommon::$db->executeQuery($sql);
            // Contraparte
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT FTMP.IDCODE JEHDR_CODE, IFNULL((SELECT PRAT.PRO_GL_CODE FROM ' . $this->fibkname . ' FIBK, GL_PROD_PRMTR_TBL PRAT WHERE PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE AND FIBK.BANK_ACCOUNT_NO = FTMP.BANKACCOUNT_CODE),0) GLACCOUNTCODE, FTMP.CURRENCY_CODE, FTMP.CUR_OPERATOR, FTMP.EXCHANGE_RT, ' . singleQuote('GLCP') . ' ITEM_CODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, IFNULL((SELECT MAX(FIAS.IDCODE) FROM ' . $this->fibkname . ' FIBK, ' . $this->fiasname . ' FIAS WHERE FIAS.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND FIAS.CONTRACT_CODE = FTMP.CHART_FIELD01 AND FIBK.BANK_ACCOUNT_NO = FTMP.BANKACCOUNT_CODE), FTMP.CHART_FIELD03) CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, 0 DEBIT_AMT, CALC_AMT_04 CREDIT_AMT, 0 DEBIT_TRANS_AMT, CALC_AMT_04 CREDIT_TRANS_AMT, 3 SEQNUM FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.REC_STATUS = ' . singleQuote('RUN') . ' AND FTMP.CALC_AMT_04>0';
            ClxCommon::$db->executeQuery($sql);
        }
    }

    // GL CLOSING
    /**
     * Close account period
     *
     * @param string $operation_date
     * @param string $comp_code
     * @param string $contract_code
     * @param string $participant_id
     * @param string $parameters
     */
    function closing($parameters) {
        // 1 Get in-ex amount
        // 2 Set in-ex accounts to cero
        // 3 Add entry for results account
        $this->start_time = microtime_float();
        $comp_code = $parameters ['COMP_CODE'];
        if (empty($comp_code)) {
            echoLog('Invalid company please verify.
				Process ended. Elapse: ' . (microtime_float() - $this->start_time));
            return false;
        }

        $contract_code = $parameters ['CONTRACT_CODE'];
        $participant_id = $parameters ['PARTICIPANT_ID'];
        $operation_date = $parameters ['OPERATION_DATE'];

        if (!class_exists('Jehd'))
            includeCodeLib('JEHD');
        $jehd = new Jehd ();
        if (!class_exists('Fiat'))
            includeCodeLib('FIAT');
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp ();
        $glcprec = ClxCommon::$db->getRecord($this->glcpname, 'COMP_CODE = ' . singleQuote($comp_code));
        $this->closing_on_demand = (array_key_exists('PROCESSCODE', $parameters) && $parameters['PROCESSCODE'] === 'GLAP') ? true : false;
        if($this->closing_on_demand){
            $operation_date = $parameters ['OPERATION_DATE'];
        }else{
            $operation_date = $glcprec ['OPERATION_DATE'];
        }
		if (empty($operation_date)) {
			echoLog('<br> ERROR not operation date for company: '.$comp_code.' <br>');
			return;
		}
        $approve_entry = (empty($glcprec ['GLCLS_APRV_ENTRY'])) ? false : true;
        $last_balance_date = ClxCommon::$db->getOne('SELECT MAX(EFFTDATE) FROM GL_BALANCES WHERE COMP_CODE = ' . singleQuote($comp_code) . ' AND EFFTDATE<=' . singleQuote($operation_date));
        if (empty($last_balance_date)) {
            $last_balance_date = adodb_prev_month_lastday($operation_date);
        }
        // Determine batch id
        $batch_id = (!empty($parameters ['RUNID'])) ? $parameters ['RUNID'] : batch_id();
        $je_source = 'GLCL';
        $idname = dict('GL_CODE_CLOSING');
        echoLog('PROCESSING ' . $idname . '. BATCH ID: ' . $batch_id);
        echoLog('Company: ' . $comp_code);
        echoLog('Contract: ' . (($contract_code === '') ? 'ALL' : $contract_code));
        echoLog('Participant: ' . (($participant_id === '') ? 'ALL' : $participant_id));
        echoLog('PROCESSING ' . $operation_date);
        // Load temporary table - Req on mysql
        $DBTB = getTool('DBTB');
        $DBTB->buildTemporaryTable('FTMP');
        // Clearing Temporary table for batch id
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ftmpname . ' WHERE BATCH_ID = ' . singleQuote($batch_id));
        // Reject any journal entry asociated to this process
        // Reject all posible pending charges for today.
        $cc = '';
        if (!empty($contract_code))
            $cc .= ' AND JCBV.CHART_FIELD01 = ' . singleQuote($contract_code) . ' ';
        if (!empty($participant_id))
            $cc .= ' AND JCBV.CHART_FIELD02 = ' . singleQuote($participant_id) . ' ';
        echoLog('Pre-Building temporals Elapse: ' . (microtime_float() - $this->start_time));

        if (!$this->closing_on_demand) {
            //proceso regular en cierre
            $sql = 'INSERT INTO ' . $this->ftmpname . ' (COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, EFFTDATE, CURRENCY_CODE, GLACCOUNTCODE, GL01_CODE, GL02_CODE, RET_LOSS_CODE, ACR_LOSS_CODE, EARNING_PERIOD, DEBIT_AMT, CREDIT_AMT, BATCH_ID, REC_STATUS) SELECT JCBV.COMP_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, null ITEM_REF_NO, GLCP.OPERATION_DATE EFFTDATE, COMP.CURRENCY_CODE, JCBV.GLACCOUNTCODE, GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE, GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE, GLCP.CLOSING_PERIOD EARNING_PERIOD, SUM(JCBV.BASE_BAL_AMT) DEBIT_AMT, 0 CREDIT_AMT, ' . singleQuote($batch_id) . '  BATCH_ID, ' . singleQuote('RUN') . '  REC_STATUS FROM ' . $this->jcbvname . ' JCBV, ' . $this->glcpname . ' GLCP, ' . $this->glacname . ' GLAC, ' . $this->compname . ' COMP WHERE GLCP.COMP_CODE = JCBV.COMP_CODE AND COMP.IDCODE = GLCP.COMP_CODE AND GLAC.IDCODE = JCBV.GLACCOUNTCODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC.GL_TYPE IN (' . singleQuote('IN') . ',' . singleQuote('EX') . ') AND GLCP.COMP_CODE = ' . singleQuote($comp_code) . ' AND EXISTS( SELECT CCVW.COMP_CODE FROM ' . $this->ccvwname . ' CCVW WHERE CCVW.CLOSING_ENTRY = 1 AND CCVW.MONTH_END = 1 AND CCVW.COMP_CODE = JCBV.COMP_CODE UNION SELECT FCVW.COMP_CODE FROM ' . $this->fcvwname . ' FCVW WHERE FCVW.CLOSING_ENTRY = 1 AND FCVW.MONTH_END = 1 AND FCVW.CHART_FIELD01 = JCBV.CHART_FIELD01 AND FCVW.COMP_CODE = JCBV.COMP_CODE) ' . $cc . ' GROUP BY JCBV.COMP_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, GLCP.OPERATION_DATE, COMP.CURRENCY_CODE, JCBV.GLACCOUNTCODE, GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE, GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE, GLCP.CLOSING_PERIOD HAVING SUM(JCBV.BASE_BAL_AMT)<>0';
        } else {
            //tomando en demanda para fecha
            $sql = 'INSERT INTO ' . $this->ftmpname . ' (COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, EFFTDATE, CURRENCY_CODE, GLACCOUNTCODE, GL01_CODE, GL02_CODE, RET_LOSS_CODE, ACR_LOSS_CODE, EARNING_PERIOD, DEBIT_AMT, CREDIT_AMT, BATCH_ID, REC_STATUS) '
                    . 'SELECT
                        A.COMP_CODE, A.CHART_FIELD01, A.CHART_FIELD02,
                        A.CHART_FIELD03, A.CHART_FIELD04, NULL ITEM_REF_NO, A.OPERATION_DATE EFFTDATE,
                        A.CURRENCY_CODE, A.GLACCOUNTCODE, A.RET_EARNING_CODE, A.ACR_EARNING_CODE,
                        A.RET_LOSS_CODE, A.ACR_LOSS_CODE, A.CLOSING_PERIOD EARNING_PERIOD,
                        SUM(A.BALANCE_AMT) DEBIT_AMT, 0 CREDIT_AMT, ' . singleQuote($batch_id) . '  BATCH_ID, ' . singleQuote('RUN') . '  REC_STATUS
                      FROM
                        (SELECT
                          JEBL.COMP_CODE, JEBL.CHART_FIELD01, JEBL.CHART_FIELD02,
                          JEBL.CHART_FIELD03, JEBL.CHART_FIELD04, GLCP.OPERATION_DATE,
                          COMP.CURRENCY_CODE, JEBL.GLACCOUNTCODE, GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE,
                          GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE, GLCP.CLOSING_PERIOD,
                          SUM(JEBL.BASE_BAL_AMT) BALANCE_AMT
                        FROM
                          GL_BALANCES JEBL,
                          GL_PARAMETERS_TBL GLCP,
                          BASE_COMPANIES COMP,
                          FIDU_CONTRACTS FICO
                        WHERE
                          GLCP.COMP_CODE = JEBL.COMP_CODE
                          AND COMP.IDCODE = GLCP.COMP_CODE
                          AND FICO.IDCODE = JEBL.CHART_FIELD01
                          AND FICO.CONTRACT_STATUS = '.singleQuote('ACTI').'
                          AND JEBL.GL_TYPE IN (' . singleQuote('IN') . ',' . singleQuote('EX') . ')
                          AND GLCP.COMP_CODE = ' . singleQuote($comp_code) . '
                          AND JEBL.EFFTDATE = ' . singleQuote($last_balance_date) . '
                          ' . ((!empty($contract_code)) ? ' AND JEBL.CHART_FIELD01 = ' . singleQuote($contract_code) : '') . '
                          ' . ((!empty($participant_id)) ? ' AND JEBL.CHART_FIELD02 = ' . singleQuote($participant_id) : '') . '
                        GROUP BY
                          JEBL.COMP_CODE,
                          JEBL.CHART_FIELD01, JEBL.CHART_FIELD02, JEBL.CHART_FIELD03, JEBL.CHART_FIELD04,
                          GLCP.OPERATION_DATE, COMP.CURRENCY_CODE, JEBL.GLACCOUNTCODE, GLCP.RET_EARNING_CODE,
                          GLCP.ACR_EARNING_CODE, GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE, GLCP.CLOSING_PERIOD
                        HAVING
                          SUM(JEBL.BASE_BAL_AMT)<>0
                        UNION ALL
                        SELECT
                          GLDV.COMP_CODE, GLDV.CHART_FIELD01, GLDV.CHART_FIELD02,
                          GLDV.CHART_FIELD03, GLDV.CHART_FIELD04, GLCP.OPERATION_DATE,
                          COMP.CURRENCY_CODE, GLDV.GLACCOUNTCODE, GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE,
                          GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE, GLCP.CLOSING_PERIOD,
                          SUM(GLDV.DEBIT_AMT-GLDV.CREDIT_AMT) BALANCE_AMT
                        FROM
                          GL_JOURNAL_DET_VW GLDV,
                          GL_PARAMETERS_TBL GLCP,
                          BASE_COMPANIES COMP,
                          FIDU_CONTRACTS FICO
                        WHERE
                          GLCP.COMP_CODE = GLDV.COMP_CODE
                          AND COMP.IDCODE = GLCP.COMP_CODE
                          AND FICO.IDCODE = GLDV.CHART_FIELD01
                          AND FICO.CONTRACT_STATUS = '.singleQuote('ACTI').'
                          AND GLDV.GL_TYPE IN (' . singleQuote('IN') . ',' . singleQuote('EX') . ')
                          AND GLCP.COMP_CODE = ' . singleQuote($comp_code) . '
                          AND GLDV.EFFTDATE > ' . singleQuote($last_balance_date) . '
                          AND GLDV.EFFTDATE<=' . singleQuote($operation_date) . '
                          ' . ((!empty($contract_code)) ? ' AND GLDV.CHART_FIELD01 = ' . singleQuote($contract_code) : '') . '
                          ' . ((!empty($participant_id)) ? ' AND GLDV.CHART_FIELD02 = ' . singleQuote($participant_id) : '') . '
                        GROUP BY
                          GLDV.COMP_CODE,
                          GLDV.CHART_FIELD01, GLDV.CHART_FIELD02, GLDV.CHART_FIELD03, GLDV.CHART_FIELD04,
                          GLCP.OPERATION_DATE, COMP.CURRENCY_CODE, GLDV.GLACCOUNTCODE, GLCP.RET_EARNING_CODE,
                          GLCP.ACR_EARNING_CODE, GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE, GLCP.CLOSING_PERIOD
                        HAVING
                          SUM(GLDV.DEBIT_AMT-GLDV.CREDIT_AMT)<>0) A
                      WHERE
                        1=1
                      GROUP BY
                        A.COMP_CODE, A.CHART_FIELD01, A.CHART_FIELD02,
                        A.CHART_FIELD03, A.CHART_FIELD04, A.OPERATION_DATE,
                        A.CURRENCY_CODE, A.GLACCOUNTCODE, A.RET_EARNING_CODE, A.ACR_EARNING_CODE,
                        A.RET_LOSS_CODE, A.ACR_LOSS_CODE, A.CLOSING_PERIOD
                      HAVING
                        SUM(A.BALANCE_AMT) <>0';
        }
        ClxCommon::$db->executeQuery($sql);



        $sql = 'UPDATE ' . $this->ftmpname . ' SET CREDIT_AMT = ABS(DEBIT_AMT) WHERE DEBIT_AMT<=0 AND BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->ftmpname . ' SET DEBIT_AMT = 0 WHERE DEBIT_AMT<=0 AND BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        // Updating currency_code, exchange rt and currency_operator
        $sql = 'SELECT DISTINCT COMP_CODE, CURRENCY_CODE, EFFTDATE FROM ' . $this->ftmpname;
        $results = ClxCommon::$db->executeQuery($sql);
        while (($result = ClxCommon::$db->getNextRecord($results, NUMERIC)) === true) {
            $xrate = $comp->comp_current_exchange($result [CLX_NUM_ZERO], $result [CLX_NUM_ONE], $result [CLX_NUM_TWO]);
            $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CUR_OPERATOR = ' . singleQuote($xrate ['CUR_OPERATOR']) . ', FTMP.EXCHANGE_RT = ' . singleQuote($xrate ['EXCHANGE_RT']) . ' WHERE COMP_CODE = ' . singleQuote($result [CLX_NUM_ZERO]) . ' AND CURRENCY_CODE = ' . singleQuote($result [CLX_NUM_ONE]) . ' AND EFFTDATE = ' . singleQuote($result [CLX_NUM_TWO]) . ' AND BATCH_ID = ' . singleQuote($batch_id);
            ClxCommon::$db->executeQuery($sql);
        }
		ClxCommon::$db->freeResult($results);
        echoLog('Post-Building IN-EX Formula Temps Elapse: ' . (microtime_float() - $this->start_time));
        $sql = 'SELECT DISTINCT CURRENCY_CODE FROM ' . $this->ftmpname . ' WHERE BATCH_ID = ' . singleQuote($batch_id) . ' AND REC_STATUS =' . singleQuote('RUN') . '';
        $results = ClxCommon::$db->executeQuery($sql);

        $this->jehd_closing_entry = '';
        while (($result = ClxCommon::$db->getNextRecord($results))) {
            $gl_rec = $jehd->jehd_init_record();
            $gl_rec ['IDNAME'] = $idname;
            $gl_rec ['JE_SOURCE'] = $je_source;
            $gl_rec ['EFFTDATE'] = $operation_date;
            $gl_rec ['REAL_DATE'] = $operation_date;
            $gl_rec ['COMP_CODE'] = $comp_code;
            $gl_rec ['TRANS_CODE'] = null;
            $gl_rec ['BATCH_ID'] = $batch_id;
            $gl_rec ['CLOSING_ENTRY'] = CLX_NUM_ONE;
            $jehd->jehd_build($gl_rec);

            $this->jehd_closing_entry = $gl_rec['IDCODE'];

            echoLog('Created JEHD: ' . $gl_rec ['IDCODE']);
            // Reversando Ingresos y Gastos
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec ['IDCODE']) . ' JEHDR_CODE, FTMP.GLACCOUNTCODE, ' . singleQuote('GLAC') . ' ITEM_CODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, FTMP.CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR, SUM(FTMP.CREDIT_AMT) DEBIT_AMT, SUM(FTMP.DEBIT_AMT) CREDIT_AMT, SUM(FTMP.CREDIT_AMT) DEBIT_TRANS_AMT, SUM(FTMP.DEBIT_AMT) CREDIT_TRANS_AMT, 1 SEQNUM FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.CURRENCY_CODE = ' . singleQuote($result ['CURRENCY_CODE']) . ' AND FTMP.REC_STATUS = ' . singleQuote('RUN') . ' GROUP BY FTMP.GLACCOUNTCODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, FTMP.CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR';
            ClxCommon::$db->executeQuery($sql);

            // Contraparte de resultados
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec ['IDCODE']) . ' JEHDR_CODE, FTMP.GL01_CODE, ' . singleQuote('GLAC') . ' ITEM_CODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, FTMP.CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR, SUM(FTMP.DEBIT_AMT) DEBIT_AMT, SUM(FTMP.CREDIT_AMT) CREDIT_AMT, SUM(FTMP.DEBIT_AMT) DEBIT_TRANS_AMT, SUM(FTMP.CREDIT_AMT) CREDIT_TRANS_AMT, 0 SEQNUM FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.CURRENCY_CODE = ' . singleQuote($result ['CURRENCY_CODE']) . ' AND FTMP.REC_STATUS = ' . singleQuote('RUN') . ' GROUP BY FTMP.GL01_CODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, FTMP.CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR HAVING SUM(FTMP.DEBIT_AMT-FTMP.CREDIT_AMT)<0';
            ClxCommon::$db->executeQuery($sql);
            // Loss
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec ['IDCODE']) . ' JEHDR_CODE, FTMP.RET_LOSS_CODE, ' . singleQuote('GLAC') . ' ITEM_CODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, FTMP.CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR, SUM(FTMP.DEBIT_AMT) DEBIT_AMT, SUM(FTMP.CREDIT_AMT) CREDIT_AMT, SUM(FTMP.DEBIT_AMT) DEBIT_TRANS_AMT, SUM(FTMP.CREDIT_AMT) CREDIT_TRANS_AMT, 0 SEQNUM FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.CURRENCY_CODE = ' . singleQuote($result ['CURRENCY_CODE']) . ' AND FTMP.REC_STATUS = ' . singleQuote('RUN') . ' GROUP BY FTMP.RET_LOSS_CODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, FTMP.CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR HAVING SUM(FTMP.DEBIT_AMT-FTMP.CREDIT_AMT)>0';
            ClxCommon::$db->executeQuery($sql);

            if ($approve_entry) {
                if (!$jehd->jehd_approve_by_code($gl_rec ['IDCODE'])) {
                    // if approval fail send note
                    $msg = 'GLCP01 ' . dict('GEN_LBL_BATCHFAILAPPROVE', $batch_id);
                    if (!empty($parameters)) {
                        $PRPR = &getTool('PRPR');
                        $PRPR->report_exception_by_parameters($parameters, $msg, 'JEHD', 'ERRO');
                    } else
                        echoLog($msg);
                }
            }
        }
		ClxCommon::$db->freeResult($results);
        // set ftmp to end
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ftmpname . ' WHERE BATCH_ID = ' . singleQuote($batch_id));
        echoLog('Closing entries completed, Test for changing results acc: ' . (microtime_float() - $this->start_time));
        // At this point must capitalize base on retairn balance if any closing occured
        $sql = 'SELECT COUNT(JEHD.ID) FROM ' . $this->jehdname . ' JEHD, ' . $this->glcpname . ' GLCP WHERE GLCP.COMP_CODE = JEHD.COMP_CODE AND JEHD.EFFTDATE = GLCP.OPERATION_DATE AND JEHD.BATCH_ID = ' . singleQuote($batch_id);
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
            // Capitalize
            $parameters ['GL_CLOSING'] = CLX_NUM_ONE;
            ClxFreeReturn($this->capitalization($parameters));
        }
        // End of period, change of result account into accumulated
        $idname = dict('GEN_LBL_RETTOACCRUED');
        $je_source = 'GLAR';
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ftmpname . ' WHERE BATCH_ID = ' . singleQuote($batch_id));
        if (!$this->closing_on_demand) {
            $sql = 'INSERT INTO ' . $this->ftmpname . ' (COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, EFFTDATE, CURRENCY_CODE, GLACCOUNTCODE, GL01_CODE, GL02_CODE, RET_LOSS_CODE, ACR_LOSS_CODE, EARNING_PERIOD, DEBIT_AMT, CREDIT_AMT, BATCH_ID, REC_STATUS) SELECT JCBV.COMP_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, null ITEM_REF_NO, GLCP.OPERATION_DATE EFFTDATE, JCBV.CURRENCY_CODE, JCBV.GLACCOUNTCODE, GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE, GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE, GLCP.CLOSING_PERIOD EARNING_PERIOD, SUM(JCBV.BALANCE_AMT) DEBIT_AMT, 0 CREDIT_AMT, ' . singleQuote($batch_id) . '  BATCH_ID, ' . singleQuote('RUN') . '  REC_STATUS FROM ' . $this->jcbvname . ' JCBV, ' . $this->glcpname . ' GLCP, ' . $this->glacname . ' GLAC WHERE GLCP.COMP_CODE = JCBV.COMP_CODE AND GLAC.IDCODE = JCBV.GLACCOUNTCODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC.IDCODE IN (GLCP.RET_EARNING_CODE, GLCP.RET_LOSS_CODE) AND JCBV.BALANCE_AMT <>0 AND GLCP.COMP_CODE = ' . singleQuote($comp_code) . ' AND EXISTS( SELECT CCVW.COMP_CODE FROM ' . $this->ccvwname . ' CCVW WHERE CCVW.CLOSING_ENTRY = 1 AND CCVW.MONTH_END = 1 AND CCVW.FISCAL_YEAR_END = 1 AND CCVW.COMP_CODE = GLCP.COMP_CODE UNION SELECT FCVW.COMP_CODE FROM ' . $this->fcvwname . ' FCVW WHERE FCVW.CLOSING_ENTRY = 1 AND FCVW.MONTH_END = 1 AND FCVW.FISCAL_YEAR_END = 1 AND FCVW.CHART_FIELD01 = JCBV.CHART_FIELD01) ' . $cc . ' GROUP BY JCBV.COMP_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, GLCP.OPERATION_DATE, JCBV.CURRENCY_CODE, JCBV.GLACCOUNTCODE, GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE, GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE, GLCP.CLOSING_PERIOD HAVING SUM(JCBV.BALANCE_AMT) <> 0';
        } else {
            $sql = 'INSERT INTO ' . $this->ftmpname . ' (COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, EFFTDATE, CURRENCY_CODE, GLACCOUNTCODE, GL01_CODE, GL02_CODE, RET_LOSS_CODE, ACR_LOSS_CODE, EARNING_PERIOD, DEBIT_AMT, CREDIT_AMT, BATCH_ID, REC_STATUS) '
                    . 'SELECT
                            A.COMP_CODE, A.CHART_FIELD01, A.CHART_FIELD02,
                            A.CHART_FIELD03, A.CHART_FIELD04, NULL ITEM_REF_NO, A.OPERATION_DATE EFFTDATE,
                            A.CURRENCY_CODE, A.GLACCOUNTCODE, A.RET_EARNING_CODE, A.ACR_EARNING_CODE,
                            A.RET_LOSS_CODE, A.ACR_LOSS_CODE, A.CLOSING_PERIOD EARNING_PERIOD,
                            SUM(A.BALANCE_AMT) DEBIT_AMT, 0 CREDIT_AMT, ' . singleQuote($batch_id) . '  BATCH_ID, ' . singleQuote('RUN') . '  REC_STATUS
                          FROM
                            (SELECT
                              JEBL.COMP_CODE,
                              JEBL.CHART_FIELD01,
                              JEBL.CHART_FIELD02, JEBL.CHART_FIELD03, JEBL.CHART_FIELD04,
                              GLCP.OPERATION_DATE, JEBL.CURRENCY_CODE,
                              JEBL.GLACCOUNTCODE,
                              GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE, GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE,
                              GLCP.CLOSING_PERIOD,
                              SUM(JEBL.BASE_BAL_AMT) BALANCE_AMT
                            FROM
                              GL_BALANCES JEBL,
                              GL_PARAMETERS_TBL GLCP,
                              BASE_COMPANIES COMP,
                              FIDU_CONTRACTS FICO
                            WHERE
                              GLCP.COMP_CODE = JEBL.COMP_CODE
                              AND COMP.IDCODE = GLCP.COMP_CODE
                              AND FICO.IDCODE = JEBL.CHART_FIELD01
                              AND FICO.CONTRACT_STATUS = '.singleQuote('ACTI').'
                              AND JEBL.GLACCOUNTCODE IN (GLCP.RET_EARNING_CODE, GLCP.RET_LOSS_CODE)
                              AND GLCP.COMP_CODE = ' . singleQuote($comp_code) . '
                              AND JEBL.EFFTDATE = ' . singleQuote($last_balance_date) . '
                              ' . ((!empty($contract_code)) ? ' AND JEBL.CHART_FIELD01 = ' . singleQuote($contract_code) : '') . '
                              ' . ((!empty($participant_id)) ? ' AND JEBL.CHART_FIELD02 = ' . singleQuote($participant_id) : '') . '
                            GROUP BY
                              JEBL.COMP_CODE,
                              JEBL.CHART_FIELD01,
                              JEBL.CHART_FIELD02, JEBL.CHART_FIELD03, JEBL.CHART_FIELD04,
                              GLCP.OPERATION_DATE, JEBL.CURRENCY_CODE,
                              JEBL.GLACCOUNTCODE,
                              GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE, GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE,
                              GLCP.CLOSING_PERIOD
                            HAVING
                              SUM(JEBL.BASE_BAL_AMT)<>0
                            UNION ALL
                            SELECT
                              GLDV.COMP_CODE,
                              GLDV.CHART_FIELD01,
                              GLDV.CHART_FIELD02, GLDV.CHART_FIELD03, GLDV.CHART_FIELD04,
                              GLCP.OPERATION_DATE, GLDV.CURRENCY_CODE,
                              GLDV.GLACCOUNTCODE,
                              GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE, GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE,
                              GLCP.CLOSING_PERIOD,
                              SUM(GLDV.DEBIT_AMT-GLDV.CREDIT_AMT) BALANCE_AMT
                            FROM
                              GL_JOURNAL_DET_VW GLDV,
                              GL_PARAMETERS_TBL GLCP,
                              BASE_COMPANIES COMP,
                              FIDU_CONTRACTS FICO
                            WHERE
                              GLCP.COMP_CODE = GLDV.COMP_CODE
                              AND COMP.IDCODE = GLCP.COMP_CODE
                              AND GLDV.GLACCOUNTCODE IN (GLCP.RET_EARNING_CODE, GLCP.RET_LOSS_CODE)
                              AND FICO.IDCODE = GLDV.CHART_FIELD01
                              AND FICO.CONTRACT_STATUS = '.singleQuote('ACTI').'
                              AND GLCP.COMP_CODE = ' . singleQuote($comp_code) . '
                              AND GLDV.EFFTDATE > ' . singleQuote($last_balance_date) . '
                              AND GLDV.EFFTDATE<=' . singleQuote($operation_date) . '
                              ' . ((!empty($contract_code)) ? ' AND GLDV.CHART_FIELD01 = ' . singleQuote($contract_code) : '') . '
                              ' . ((!empty($participant_id)) ? ' AND GLDV.CHART_FIELD02 = ' . singleQuote($participant_id) : '') . '
                            GROUP BY
                              GLDV.COMP_CODE,
                              GLDV.CHART_FIELD01,
                              GLDV.CHART_FIELD02, GLDV.CHART_FIELD03, GLDV.CHART_FIELD04,
                              GLCP.OPERATION_DATE, GLDV.CURRENCY_CODE,
                              GLDV.GLACCOUNTCODE,
                              GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE, GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE,
                              GLCP.CLOSING_PERIOD
                            HAVING
                              SUM(GLDV.DEBIT_AMT-GLDV.CREDIT_AMT)<>0
                              UNION ALL
                          SELECT
                              JEHD.COMP_CODE,
                              JELN.CHART_FIELD01,
                              JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04,
                              GLCP.OPERATION_DATE, JELN.CURRENCY_CODE,
                              JELN.GLACCOUNTCODE,
                              GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE, GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE,
                              GLCP.CLOSING_PERIOD,
                              SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) BALANCE_AMT
                            FROM
                              GL_JOURNAL_HDR JEHD,
                              GL_JOURNAL_LINES JELN,
                              GL_PARAMETERS_TBL GLCP,
                              BASE_COMPANIES COMP,
                              FIDU_CONTRACTS FICO
                            WHERE
                              GLCP.COMP_CODE = JEHD.COMP_CODE
                              AND JEHD.IDCODE = JELN.JEHDR_CODE
                              AND JEHD.JE_STATUS = ' . singleQuote('PEND') . '
                              AND JEHD.IDCODE = ' . singleQuote($this->jehd_closing_entry) . '
                              AND COMP.IDCODE = GLCP.COMP_CODE
                              AND FICO.IDCODE = JELN.CHART_FIELD01
                              AND FICO.CONTRACT_STATUS = '.singleQuote('ACTI').'
                              AND JELN.GLACCOUNTCODE IN (GLCP.RET_EARNING_CODE, GLCP.RET_LOSS_CODE)
                              AND JEHD.COMP_CODE = ' . singleQuote($comp_code) . '
                              ' . ((!empty($contract_code)) ? ' AND JELN.CHART_FIELD01 = ' . singleQuote($contract_code) : '') . '
                              ' . ((!empty($participant_id)) ? ' AND JELN.CHART_FIELD02 = ' . singleQuote($participant_id) : '') . '
                            GROUP BY
                              JEHD.COMP_CODE,
                              JELN.CHART_FIELD01,
                              JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04,
                              GLCP.OPERATION_DATE, JELN.CURRENCY_CODE,
                              JELN.GLACCOUNTCODE,
                              GLCP.RET_EARNING_CODE, GLCP.ACR_EARNING_CODE, GLCP.RET_LOSS_CODE, GLCP.ACR_LOSS_CODE,
                              GLCP.CLOSING_PERIOD
                            HAVING
                              SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT)<>0
                          ) A
                          WHERE
                            1=1
                          GROUP BY
                            A.COMP_CODE, A.CHART_FIELD01, A.CHART_FIELD02,
                            A.CHART_FIELD03, A.CHART_FIELD04, A.OPERATION_DATE,
                            A.CURRENCY_CODE, A.GLACCOUNTCODE, A.RET_EARNING_CODE, A.ACR_EARNING_CODE,
                            A.RET_LOSS_CODE, A.ACR_LOSS_CODE, A.CLOSING_PERIOD
                          HAVING
                            SUM(A.BALANCE_AMT) <>0';
        }
        ClxCommon::$db->executeQuery($sql);


        $sql = 'UPDATE ' . $this->ftmpname . ' SET CREDIT_AMT = ABS(DEBIT_AMT) WHERE DEBIT_AMT<=0 AND BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->ftmpname . ' SET DEBIT_AMT = 0 WHERE DEBIT_AMT<=0 AND BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        echoLog('Post-Building RET ACC Temps Elapse: ' . (microtime_float() - $this->start_time));
        // Updating currency_code, exchange rt and currency_operator
        $sql = 'SELECT DISTINCT COMP_CODE, CURRENCY_CODE, EFFTDATE FROM ' . $this->ftmpname;
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, NUMERIC)) {
            $xrate = $comp->comp_current_exchange($result [CLX_NUM_ZERO], $result [CLX_NUM_ONE], $result [CLX_NUM_TWO]);
            $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET FTMP.CUR_OPERATOR = ' . singleQuote($xrate ['CUR_OPERATOR']) . ', FTMP.EXCHANGE_RT = ' . singleQuote($xrate ['EXCHANGE_RT']) . ' WHERE COMP_CODE = ' . singleQuote($result [CLX_NUM_ZERO]) . ' AND CURRENCY_CODE = ' . singleQuote($result [CLX_NUM_ONE]) . ' AND EFFTDATE = ' . singleQuote($result [CLX_NUM_TWO]) . ' AND BATCH_ID = ' . singleQuote($batch_id);
            ClxCommon::$db->executeQuery($sql);
        }
		ClxCommon::$db->freeResult($results);
        $sql = 'SELECT DISTINCT CURRENCY_CODE FROM ' . $this->ftmpname . ' WHERE BATCH_ID = ' . singleQuote($batch_id) . ' AND REC_STATUS =' . singleQuote('RUN') . '';
        $results = ClxCommon::$db->executeQuery($sql);
        while (($result = ClxCommon::$db->getNextRecord($results))) {
            $gl_rec = $jehd->jehd_init_record();
            $gl_rec ['IDNAME'] = $idname;
            $gl_rec ['JE_SOURCE'] = $je_source;
            $gl_rec ['EFFTDATE'] = $operation_date;
            $gl_rec ['REAL_DATE'] = $operation_date;
            $gl_rec ['COMP_CODE'] = $comp_code;
            $gl_rec ['TRANS_CODE'] = null;
            $gl_rec ['BATCH_ID'] = $batch_id;
            $gl_rec ['CLOSING_ENTRY'] = CLX_NUM_ONE;
            $jehd->jehd_build($gl_rec);
            echoLog('Created JEHD: ' . $gl_rec ['IDCODE']);
            // Cuenta de resultados
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec ['IDCODE']) . ' JEHDR_CODE, FTMP.GLACCOUNTCODE, ' . singleQuote('GLAC') . ' ITEM_CODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, FTMP.CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR, FTMP.CREDIT_AMT DEBIT_TRANS_AMT, FTMP.DEBIT_AMT CREDIT_TRANS_AMT, FTMP.CREDIT_AMT DEBIT_AMT, FTMP.DEBIT_AMT CREDIT_AMT, 1 SEQNUM FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.CURRENCY_CODE = ' . singleQuote($result ['CURRENCY_CODE']) . ' AND FTMP.REC_STATUS =' . singleQuote('RUN') . '';
            ClxCommon::$db->executeQuery($sql);
            // Contraparte de resultados
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec ['IDCODE']) . ' JEHDR_CODE, FTMP.GL02_CODE, ' . singleQuote('GLAC') . ' ITEM_CODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, FTMP.CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR, FTMP.DEBIT_AMT DEBIT_TRANS_AMT, FTMP.CREDIT_AMT CREDIT_TRANS_AMT, FTMP.DEBIT_AMT DEBIT_AMT, FTMP.CREDIT_AMT CREDIT_AMT, 0 SEQNUM FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.CURRENCY_CODE = ' . singleQuote($result ['CURRENCY_CODE']) . ' AND FTMP.REC_STATUS = ' . singleQuote('RUN') . ' AND FTMP.GLACCOUNTCODE = FTMP.GL01_CODE';
            ClxCommon::$db->executeQuery($sql);
            // Contraparte de perdidas accumuladas
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec ['IDCODE']) . ' JEHDR_CODE, FTMP.ACR_LOSS_CODE, ' . singleQuote('GLAC') . ' ITEM_CODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, FTMP.CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR, FTMP.DEBIT_AMT DEBIT_TRANS_AMT, FTMP.CREDIT_AMT CREDIT_TRANS_AMT, FTMP.DEBIT_AMT DEBIT_AMT, FTMP.CREDIT_AMT CREDIT_AMT, 0 SEQNUM FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.BATCH_ID = ' . singleQuote($batch_id) . ' AND FTMP.CURRENCY_CODE = ' . singleQuote($result ['CURRENCY_CODE']) . ' AND FTMP.REC_STATUS = ' . singleQuote('RUN') . ' AND FTMP.GLACCOUNTCODE = FTMP.RET_LOSS_CODE AND FTMP.GL01_CODE <> FTMP.RET_LOSS_CODE';
            ClxCommon::$db->executeQuery($sql);
            if ($approve_entry) {
                if (!$jehd->jehd_approve_by_code($gl_rec ['IDCODE'])) {
                    // if approval fail send note
                    $msg = 'GLCP01 ' . dict('GEN_LBL_BATCHFAILAPPROVE', $batch_id);
                    if (!empty($parameters)) {
                        $PRPR = getTool('PRPR');
                        $PRPR->report_exception_by_parameters($parameters, $msg, 'JEHD', 'ERRO');
                    } else
                        echoLog($msg);
                }
            }
        }
		ClxCommon::$db->freeResult($results);
        // set ftmp to end
        ClxCommon::$db->executeQuery('UPDATE ' . $this->ftmpname . ' SET REC_STATUS = ' . singleQuote('END') . ' WHERE BATCH_ID = ' . singleQuote($batch_id));
        echoLog('GLCP Ret to Acc Earning Process completed: ' . (microtime_float() - $this->start_time));
        return true;
    }

    /**
     *
     * @param unknown_type $comp_code
     * @param unknown_type $operation_date
     */
    function closingReversal($comp_code, $operation_date) {
        echoLog('Reversing closing.');
        echoLog('Company: ' . $comp_code);
        echoLog('Operation date to return: ' . $operation_date);
        multiTableName($this, array('LEBA', 'INAT', 'INFU', 'FICO', 'FIPA', 'JEBL', 'INDT', 'INFA', 'CRCL', 'FILO'));
        // Reject transactions, activities before date
        $sql = 'SELECT COUNT(ID) FROM ' . $this->compname . '  WHERE IDCODE = ' . singleQuote($comp_code);
        if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
            echoLog('No company found: ' . $comp_code);
        }
        $sql = 'SELECT COUNT(ID) FROM ' . $this->glcpname . ' WHERE COMP_CODE = ' . singleQuote($comp_code) . ' AND OPERATION_DATE>' . singleQuote($operation_date);
        if (empty($operation_date) || ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
            echoLog('Date invalid, must be greater than: ' . $operation_date);
        }
        $sql = 'UPDATE ' . $this->fiatname . ' SET CLX_AUTH_STATUS = ' . singleQuote('AP') . ', TRANS_STATUS = ' . singleQuote('REJ') . ' WHERE EFFTDATE>=' . singleQuote($operation_date) . ' AND COMP_CODE = ' . singleQuote($comp_code);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->jehdname . ' SET CLX_AUTH_STATUS = ' . singleQuote('AP') . ', JE_STATUS = ' . singleQuote('REJ') . ' WHERE EFFTDATE>=' . singleQuote($operation_date) . ' AND COMP_CODE = ' . singleQuote($comp_code);
        ClxCommon::$db->executeQuery($sql);
        // Change participants and contracts settled for this dates
        $sql = 'UPDATE ' . $this->fipaname . ' SET FIPATERM_REASON = null, STATUS = ' . singleQuote('A') . ' WHERE END_DATE>=' . singleQuote($operation_date) . ' AND STATUS = ' . singleQuote('I') . ' AND CONTRACT_CODE IN (SELECT FICO.IDCODE FROM ' . $this->ficoname . ' FICO WHERE FICO.COMP_CODE = ' . singleQuote($comp_code) . ')';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->ficoname . ' FICO SET FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ' WHERE FICO.CONTRACT_STATUS = ' . singleQuote('FINQ') . ' AND FICO.COMP_CODE = ' . singleQuote($comp_code) . ' AND EXISTS (SELECT JEHD.ID FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JELN.CHART_FIELD01 = FICO.IDCODE AND JEHD.EFFTDATE>=' . singleQuote($operation_date) . ') ';
        ClxCommon::$db->executeQuery($sql);
        // Rebuild ledgers
        $sql = 'UPDATE ' . $this->inatname . ' SET CLX_AUTH_STATUS = ' . singleQuote('REJ') . ' WHERE EFFTDATE>=' . singleQuote($operation_date) . ' AND PORTFOLIO_CODE IN (SELECT IDCODE FROM ' . $this->infuname . ' WHERE COMP_CODE = ' . singleQuote($comp_code) . ')';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DELETE FROM ' . $this->infaname . ' WHERE EFFTDATE >= ' . singleQuote($operation_date) . ' AND PORTFOLIO_CODE IN (SELECT IDCODE FROM ' . $this->infuname . ' WHERE COMP_CODE = ' . singleQuote($comp_code) . ')';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DELETE FROM ' . $this->indtname . ' WHERE EFFTDATE >= ' . singleQuote($operation_date) . ' AND PORTFOLIO_CODE IN (SELECT IDCODE FROM ' . $this->infuname . ' WHERE COMP_CODE = ' . singleQuote($comp_code) . ')';
        ClxCommon::$db->executeQuery($sql);
        // Rebuilding leba
        if (!class_exists('Leba'))
            includeCodeLib('LEBA');
        $leba = new Leba ();
        $leba->leba_rebuild($comp_code);
        $sql = 'DELETE FROM ' . $this->jeblname . ' WHERE COMP_CODE = ' . singleQuote($comp_code) . ' AND EFFTDATE>=' . singleQuote($operation_date);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glcpname . ' SET OPERATION_DATE = ' . singleQuote($operation_date) . ', ACCOUNTING_DATE = ' . singleQuote(adodb_prev_day($operation_date)) . ' WHERE COMP_CODE = ' . singleQuote($comp_code);
        ClxCommon::$db->executeQuery($sql);
        // check here for end of month
        if (!class_exists('Jebl'))
            includeCodeLib('JEBL');
        $jebl = new Jebl ();
        ClxFreeReturn($jebl->rebuild_balances_since($comp_code, $operation_date));
        unset($jebl);
        // Credit Module Updating Balances
        if (!class_exists('Filo'))
            includeCodeLib('FILO');
        $filo = new Filo ();
        $filo->update_balances_by_company($comp_code, $operation_date);
        unset($filo);
        // Reversando lineas de creditos
        $sql = 'UPDATE ' . $this->crclname . ' SET CLX_AUTH_STATUS = ' . singleQuote('PEND') . ' WHERE START_DATE >= ' . singleQuote($operation_date) . ' AND COMP_CODE = ' . singleQuote($comp_code);
        ClxCommon::$db->executeQuery($sql);
        // Reversando lineas de creditos
        $sql = 'UPDATE ' . $this->filoname . ' SET LOAN_STATUS = ' . singleQuote('PEND') . ', CLX_AUTH_STATUS = ' . singleQuote('PEND') . ' WHERE START_DATE > ' . singleQuote($operation_date) . ' AND COMP_CODE = ' . singleQuote($comp_code);
        ClxCommon::$db->executeQuery($sql);
        /*
         * VER QUE HACER CON CONCILIACIONES SELECT * FROM GL_CONCILIATION_LINES
         * GLRL; SELECT * FROM GL_CONCILIATIONS GLRC;
         */
    }

    // DIFERENCIAL CAMBIARIO

    function exchange_valuation_by_comp($comp_code, $queue = false) {
        $this->exchange_valuation($comp_code, $queue);
    }

    function exchange_valuation_btn() {
        $idlist = getIdlist();
        $sql = 'SELECT IDCODE FROM ' . $this->compname . ' WHERE ID IN (' . toString($idlist) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $this->exchange_valuation($r['IDCODE'], true);
        }
		ClxCommon::$db->freeResult($rs);
    }

    private function exchange_valuation($comp_code, $queue = false) {
        $je_source = 'EXVL';
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('JTMP');
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->jtmpname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp ();
        $comprec = $comp->comp_operation_parameters($comp_code);
        $operation_date = $comprec ['OPERATION_DATE'];
        if (!$comp->ruco_status($comp_code, $je_source)) {
            echoLog('Process: ' . $je_source . ' Inactive for company ' . $comp_code);
            return;
        }
        /* Se usa transcode para almacenar la cuenta de capital del contrato */
        $sql = 'INSERT INTO ' . $this->jtmpname . ' (BATCH_ID, COMP_CODE, TRANS_CODE, EFFTDATE, GLACCOUNTCODE, CURRENCY_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, EXCHANGE_RT, CUR_OPERATOR, BALANCE_AMT, BASE_BAL_AMT) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, JCBV.COMP_CODE, JCBV.GLACCOUNTCODE TRANS_CODE, GLCP.OPERATION_DATE EFFTDATE, JCBV.GLACCOUNTCODE, JCBV.CURRENCY_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, 1 EXCHANGE_RT, 1 CUR_OPERATOR, SUM(JCBV.BALANCE_AMT) BALANCE_AMT, SUM(JCBV.BASE_BAL_AMT) BASE_BAL_AMT FROM ' . $this->jcbvname . ' JCBV, ' . $this->glcpname . ' GLCP, ' . $this->compname . ' COMP WHERE GLCP.COMP_CODE = JCBV.COMP_CODE AND COMP.IDCODE = JCBV.COMP_CODE AND JCBV.COMP_CODE = ' . singleQuote($comp_code) . ' AND JCBV.CURRENCY_CODE <> COMP.CURRENCY_CODE AND JCBV.GL_TYPE IN (' . singleQuote('AS') . ',' . singleQuote('LI') . ') AND JCBV.BALANCE_AMT<>0 GROUP BY JCBV.COMP_CODE, GLCP.OPERATION_DATE, JCBV.GLACCOUNTCODE, JCBV.CURRENCY_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04 HAVING SUM(JCBV.BALANCE_AMT)<>0';
        ClxCommon::$db->executeQuery($sql);
        if (ClxCommon::$db->oneExistsRecords($this->jtmpname, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            return;
        }
        $sql = 'UPDATE ' . $this->jtmpname . ' JTMP SET JTMP.BASE_BAL_AMT = 0 WHERE JTMP.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->jtmpname . ' JTMP SET JTMP.BASE_BAL_AMT = IFNULL( (SELECT SUM(JCBV.BASE_BAL_AMT) FROM ' . $this->jcbvname . ' JCBV WHERE JCBV.COMP_CODE = JTMP.COMP_CODE AND JCBV.GLACCOUNTCODE = JTMP.GLACCOUNTCODE AND JCBV.CHART_FIELD01 = JTMP.CHART_FIELD01 AND JCBV.CHART_FIELD02 = JTMP.CHART_FIELD02 AND (JCBV.CHART_FIELD03 = JTMP.CHART_FIELD03 OR (JCBV.CHART_FIELD03 IS NULL AND JTMP.CHART_FIELD03 IS NULL)) AND (JCBV.CHART_FIELD04 = JTMP.CHART_FIELD04 OR (JCBV.CHART_FIELD04 IS NULL AND JTMP.CHART_FIELD04 IS NULL)) ),0) WHERE JTMP.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->jtmpname . ' JTMP, (SELECT CURR.BASE_CURRENCY, CURR.EXCHANGE_RT, CURR.CUR_OPERATOR, CURR.CLX_EFFTDATE FROM ' . $this->currname . ' CURR, ' . $this->compname . ' COMP WHERE COMP.IDCODE = ' . singleQuote($comp_code) . ' AND CURR.FOREIGN_CURRENCY = COMP.CURRENCY_CODE AND CURR.CLX_EFFTDATE = (SELECT MAX(CURRX.CLX_EFFTDATE) FROM  ' . $this->currname . ' CURRX WHERE CURRX.IDCODE = CURR.IDCODE AND CURRX.CLX_EFFTDATE <= ' . singleQuote($operation_date) . ') ) CURR SET JTMP.EXCHANGE_RT = CURR.EXCHANGE_RT, JTMP.CUR_OPERATOR = CURR.CUR_OPERATOR WHERE JTMP.CURRENCY_CODE = CURR.BASE_CURRENCY AND JTMP.COMP_CODE = ' . singleQuote($comp_code) . ' AND JTMP.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->jtmpname . ' JTMP SET JTMP.DEBITS = ROUND((JTMP.BALANCE_AMT*POW(JTMP.EXCHANGE_RT, JTMP.CUR_OPERATOR)), 2)-JTMP.BASE_BAL_AMT, JTMP.CREDITS = 0 WHERE JTMP.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->jtmpname . ' JTMP SET JTMP.CREDITS = (- 1 *JTMP.DEBITS), JTMP.DEBITS = 0 WHERE JTMP.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND JTMP.DEBITS < 0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DELETE JTMP.* FROM ' . $this->jtmpname . ' JTMP WHERE JTMP.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND JTMP.DEBITS = 0 AND JTMP.CREDITS = 0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->jtmpname . ' JTMP, ' . $this->compname . ' COMP SET JTMP.DEBIT_TRANS_AMT = JTMP.DEBITS, JTMP.CREDIT_TRANS_AMT = JTMP.CREDITS, JTMP.CURRENCY_CODE = COMP.CURRENCY_CODE, JTMP.ITEM_REF_NO = JTMP.EXCHANGE_RT, JTMP.EXCHANGE_RT = 1, JTMP.CUR_OPERATOR = 1 WHERE COMP.IDCODE = JTMP.COMP_CODE AND JTMP.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Actualizando cuenta de capital en registro temporal
        //Colocando cuenta de capital en contra partida TTPA.EQ_GL_CODE OR TTPA.EQF_GL_CODE?
        /* Contra cuenta de ingreso */
        $sql = 'UPDATE ' . $this->jtmpname . ' JTMP, ' . $this->ttpaname . ' TTPA, ' . $this->ficoname . ' FICO, ' . $this->glcpname . ' GLCP SET JTMP.TRANS_CODE = TTPA.EXVL_GL_CODE WHERE GLCP.COMP_CODE = FICO.COMP_CODE AND TTPA.GLGROUP_CODE = GLCP.GLGROUP_CODE AND TTPA.FI_TYPE = FICO.FI_TYPE AND FICO.IDCODE = JTMP.CHART_FIELD01 AND TTPA.CONTRACT_TYPE = FICO.CONTRACT_TYPE AND JTMP.DEBITS > 0 AND JTMP.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        /* Contra cuenta de gastos */
        $sql = 'UPDATE ' . $this->jtmpname . ' JTMP, ' . $this->ttpaname . ' TTPA, ' . $this->ficoname . ' FICO, ' . $this->glcpname . ' GLCP SET JTMP.TRANS_CODE = TTPA.EXVL2_GL_CODE WHERE GLCP.COMP_CODE = FICO.COMP_CODE AND TTPA.GLGROUP_CODE = GLCP.GLGROUP_CODE AND TTPA.FI_TYPE = FICO.FI_TYPE AND FICO.IDCODE = JTMP.CHART_FIELD01 AND TTPA.CONTRACT_TYPE = FICO.CONTRACT_TYPE AND JTMP.CREDITS > 0 AND JTMP.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        /* Actualizando casos donde saldo se encuentra en cuenta de capital extrangero */
        //Creating accounting
        if (!class_exists('Jehd'))
            includeCodeLib('JEHD');
        $jehd = new Jehd ();
        $DBLT = &getTool('DBLT');
        $idname = $DBLT->getListItem('SOTY', $je_source, CLX_NUM_TWO);
        // Build JEHD
        $sql = 'SELECT DISTINCT ' . singleQuote($idname) . ' IDNAME, JTMP.COMP_CODE, JTMP.EFFTDATE, ' . singleQuote($je_source) . ' JE_SOURCE, 0 CLOSING_ENTRY, 0 REVERSED, JTMP.BATCH_ID, ' . singleQuote($this->username) . ' CREATEDBY, ' . singleQuote($this->username) . ' MODIFIEDBY, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->now) . ' MDATE FROM ' . $this->jtmpname . ' JTMP WHERE JTMP.BATCH_ID = ' . singleQuote($this->batch_id);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            // Generar encabezado para portafolio
            $jehd->jehd_build($r);
            $jehdr_code = $r ['IDCODE'];
            // Generando lineas
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, SEQNUM, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, RECONCILIED) SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, 1 SEQNUM, JTMP.GLACCOUNTCODE, JTMP.CHART_FIELD01, JTMP.CHART_FIELD02, JTMP.CHART_FIELD03, JTMP.CHART_FIELD04, JTMP.ITEM_CODE, JTMP.ITEM_REF_NO, JTMP.CURRENCY_CODE, JTMP.EXCHANGE_RT, JTMP.CUR_OPERATOR, JTMP.DEBITS DEBIT_AMT, JTMP.CREDITS CREDIT_AMT, JTMP.DEBIT_TRANS_AMT, JTMP.CREDIT_TRANS_AMT, 0 RECONCILIED FROM ' . $this->jtmpname . ' JTMP WHERE JTMP.BATCH_ID = ' . singleQuote($this->batch_id) . ' ORDER BY JTMP.CHART_FIELD01 ASC';
            ClxCommon::$db->executeQuery($sql);
            // Contrapartida
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, SEQNUM, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, RECONCILIED) SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, 2 SEQNUM, JTMP.TRANS_CODE GLACCOUNTCODE, JTMP.CHART_FIELD01, JTMP.CHART_FIELD02, null CHART_FIELD03, null CHART_FIELD04, JTMP.ITEM_CODE, JTMP.ITEM_REF_NO, JTMP.CURRENCY_CODE, JTMP.EXCHANGE_RT, JTMP.CUR_OPERATOR, JTMP.CREDITS DEBIT_AMT, JTMP.DEBITS CREDIT_AMT, JTMP.CREDIT_TRANS_AMT DEBIT_TRANS_AMT, JTMP.DEBIT_TRANS_AMT CREDIT_TRANS_AMT, 0 RECONCILIED FROM ' . $this->jtmpname . ' JTMP WHERE JTMP.BATCH_ID = ' . singleQuote($this->batch_id) . ' ORDER BY JTMP.CHART_FIELD01 ASC';
            ClxCommon::$db->executeQuery($sql);
            // Cambiar estatus de asientos generados por el proceso
            if ($queue === true) {
                $jehd->jehd_approve_queue_by_code($jehdr_code);
            } else {
                $jehd->jehd_approve_by_code($jehdr_code);
            }
            if ($this->display === true) {
                echoLog('Approving jehd: ' . $jehdr_code . '-' . $je_source);
            }
        } // end while
		ClxCommon::$db->freeResult($rs);
        //cleanup
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->jtmpname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
    }

}
