<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: imrsnik $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-15 20:29:23 +0000 (Thu, 15 Oct 2015) $
 * @version        $Rev: 7314 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Hosc {

    function Hosc($procParameters = array()) {
        multiTableName($this, array('HOSC','RCCP','COMP'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->je_source = '';
    }

    /**
     * Generate calendar for all companies
     *
     */
    function generateJecaAllCompanies() {
        $sql = 'SELECT IDCODE FROM ' . $this->compname;
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            ClxFreeReturn($this->generateJeca($r['IDCODE']));
        }
		ClxCommon::$db->freeResult($rs);
    }

    function prompt() {
		
        $ac = UserRequest::$request['ac'];
        $to = UserRequest::$request[CLX_PROP_TO];
        $it = '';
		
        $EDIT = &getTool('EDIT');
        $title = '';
        $record = array();
        $msg = array();
        $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote('HOSC_LOAD') . '');
        $record = UserRequest::$post;
        if (!empty($record['confirm'])) {
            $EDIT->checkForm2($msg, $formrec);
        }
		if (!empty($record['confirm']) && empty($msg)) {
            $lastdate = $this->generateHosc($record['HOSC_COMP_CODE'], CLX_365_DAYS, $record['HOSC_EFFTDATE']);
            $note = dict('GEN_LBL_PROCESS') . ' ' . dict('GEN_LBL_COMPLETED') . '<br><br>';
            $note .=dict('GEN_LBL_FROM') . ': ' . $record['HOSC_EFFTDATE'] . '<br>';
            $note .=dict('GEN_LBL_TO') . ': ' . $lastdate . '<br>';
            return note($note, dict('GEN_LBL_RETURN'));
        } else {
            $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', $title, dict('GEN_LBL_EXECUTE'));
            return $form->source();
        }
    }

    /**
     * Loads date table. Increases 365 days from last date.
     */
    function generatehosc($comp_code, $qty = CLX_365_DAYS, $startdate = '') {
		$country = ClxCommon::$db->getOne('SELECT COUNTRY FROM BASE_COMPANIES WHERE IDCODE = ' . singleQuote($comp_code));
       	
        if (!function_exists('setCreationData')) {
            includeCodeLib('GEN_REC_UTIL');
        }
        $now = getNow('Y-m-d');
        $rccpprec = ClxCommon::$db->getRecord($this->rccpname, 'COMP_CODE = ' . singleQuote($comp_code));
        if ($startdate === '') {
            $sql = 'SELECT MAX(EFFTDATE) FROM ' . $this->hoscname . ' WHERE COMP_CODE = ' . singleQuote($comp_code);
            $lastdate = ClxCommon::$db->getOne($sql);
        } else {
            $lastdate = $startdate; 
        }
        if ($lastdate === '') {
            $lastdate = $rccpprec['OPERATION_DATE'];
        }
		if ($lastdate === '') {
            $lastdate = date('Y-01-01');
			
        }
		$k=0;
        for ($i = CLX_INIT_ZERO; $i <= $qty; $i++) {
			
            $day = date('N', strtotime($lastdate)); //1to7 1 for monday
			$fecha = date('Y-m-d', strtotime($lastdate));
		    if ($day == CLX_NUM_ONE && $rccpprec['WORK_DAY_MON'] != CLX_NUM_ZERO) {
                $holiday = CLX_NUM_ONE;
            } elseif ($day == CLX_NUM_TWO && $rccpprec['WORK_DAY_TUE'] != CLX_NUM_ZERO) {
                $holiday = CLX_NUM_ONE;
            } elseif ($day == CLX_NUM_THREE && $rccpprec['WORK_DAY_WED'] != CLX_NUM_ZERO) {
                $holiday = CLX_NUM_ONE;
            } elseif ($day == CLX_NUM_FOUR && $rccpprec['WORK_DAY_THU'] != CLX_NUM_ZERO) {
                $holiday = CLX_NUM_ONE;
            } elseif ($day == CLX_NUM_FIVE && $rccpprec['WORK_DAY_FRI'] != CLX_NUM_ZERO) {
                $holiday = CLX_NUM_ONE;
            } elseif ($day == CLX_NUM_SIX && $rccpprec['WORK_DAY_SAT'] != CLX_NUM_ZERO) {
                $holiday = CLX_NUM_ONE;
            } elseif ($day == CLX_NUM_7 && $rccpprec['WORK_DAY_SUN'] != CLX_NUM_ZERO) {
                $holiday = CLX_NUM_ONE;
            } else {
                $holiday = CLX_INIT_ZERO;
            }
		    $record = array('COMP_CODE' => $comp_code,
							'IDNAME' => date('l Y-m-d', strtotime($lastdate)),
							'COUNTRY' =>$country,
							'EFFTDATE' => $fecha, 
							);
		
			setCreationData($record);
            $sql = 'SELECT COUNT(ID) FROM ' . $this->hoscname . ' WHERE COMP_CODE = ' . singleQuote($comp_code) . ' AND EFFTDATE = ' . singleQuote($lastdate);
            if ($holiday && !ClxCommon::$db->getOne($sql)) {
                ClxCommon::$db->createRecord($this->hoscname, $record, false);
                //e cho $lastdate.'<br>';
            }
            $lastdate = adodb_next_day($lastdate);
        }
        return $lastdate;
    }

    /**
     * Returns true if selected date is holiday
     * @param string $comp_code
     * @param string $efftdate
     * @return boolean
     */
    function is_holiday($comp_code, $efftdate) {
        return (ClxCommon::$db->countRecords($this->jecaname, 'COMP_CODE = ' . singleQuote($comp_code) . ' AND EFFTDATE = ' . singleQuote($efftdate) . ' AND HOLIDAY = 1 ') == CLX_NUM_ZERO) ? false : true;
    }

}
