<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-08 15:32:52 -0400 (Thu, 08 Oct 2015) $
 * @version        $Rev: 7191 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Infu {

    var $display = false;

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('STOC', 'INAT', 'INFA', 'JEHD', 'GLAC', 'GLAG', 'COMP', 'INFU', 'FIAS', 'FIAC', 'JELN', 'TTPA', 'FIBK', 'GLCP', 'FIGN', 'FTMP', 'FIAT', 'FITB', 'FITS', 'JEIT', 'OPBV', 'LEDG', 'INFU', 'PTMP', 'FICO', 'FIPA', 'INPR', 'GLCP', 'INTL', 'INFH', 'PRAT', 'JCBV', 'INDT', 'PTMP', 'CURR', 'IAT3', 'IAT4', 'INFA', 'INDV', 'PROD', 'JTMP'));
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Initialice fico form
     * Executed on init event
     */
    function infu_init_form(&$record) {
        if (UserRequest::$request['ac'] === 'CREATE') {
            if (!class_exists('Comp'))
                includeCodeLib('COMP');
            $comp = new Comp ();
            $comprec = $comp->comp_operation_parameters();
            $record ['INFU_EFFTDATE'] = $comprec ['OPERATION_DATE'];
            $record ['INFU_CURRENCY_CODE'] = $comprec ['CURRENCY_CODE'];
            $record ['INFU_COMP_CODE'] = $comprec ['IDCODE'];
        }
    }

    /**
     * Validate record information
     * Executed on table validate
     *
     * @param array $record
     * @param array $msg
     */
    function infu_validate_form(&$record, &$msg) {
        empty($record['INFU_DERIVATIVE_CODE']) ? $record['INFU_DERIVATIVE_CODE'] = '' : $record['INFU_DERIVATIVE_CODE'];
        // reversal can not be modified
        if ($record['INFU_DERIVATIVE_CODE'] <> '' && $record['INFU_DERIVATIVE_CODE'] <> 'null') {
            if (empty($record['INFU_ID']))
                $record['INFU_ID'] = CLX_INIT_ZERO;
            if (ClxCommon::$db->oneExistsRecords($this->infuname, 'DERIVATIVE_CODE = ' . singleQuote($record['INFU_DERIVATIVE_CODE']) . ' AND ID <> ' . $record['INFU_ID']) > CLX_NUM_ZERO) {
                $msg ['INFU_DERIVATIVE_CODE'] = smsg('MSG-336', $record ['INFU_DERIVATIVE_CODE']);
            }
        }
    }

    /**
     * Update Parent (INFU) Information one record is saved
     *
     * @param array $record
     */
    function infu_save_form(&$record) {
        // Update modified by and modification date on INFU
        //Validar que no existan 2 portafolio con el mismo producto derivado de  existir
    }

    /**
     * Load company operation parameters
     *
     * @param string $portfolio_code
     * @return Ambigous <multitype:, multitype:, boolean>
     */
    function infu_comp_operation_parameters($portfolio_code = '') {
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp ();
        if ($portfolio_code !== '') {
            $comp_code = ClxCommon::$db->getField($this->infuname, 'COMP_CODE', 'IDCODE = ' . singleQuote($portfolio_code));
        } else {
            $comp_code = '';
        }
        return $comp->comp_operation_parameters($comp_code);
    }

    // PORTFOLIO REDISTRIBUTION PROCESS
    /**
     * Runs activity accounting process
     *
     * @param string $comp_code
     */
    function infu_inat_distribute($comp_code) {
        if (!class_exists('Inat'))
            includeCodeLib('INAT');
        $inat = new Inat ();
        $inat->display = $this->display;
        $inat->inat_build_accounting_batch($comp_code);
        unset($inat);
    }

// end method
    /**
     * Load record event
     * @param array $record
     */
    function infu_load_record(&$record) {
        $this->infu_portfolio_cash($record);
        //Get the price of the fund
        $prices = $this->infu_portfolio_price($record['INFU_IDCODE']);
        $record['INFU_NET_ASSET_VALUE'] = $prices['NET_ASSET_VALUE'];
        $record['INFU_PRICE'] = $prices['PRICE'];
    }

    // FUND NET ASSET VALUE
    /**
     * Returns func value
     * @param string $portfolio_code
     * @return array
     */
    private function infu_portfolio_price($portfolio_code) {
        $return = array('PORTFOLIO_CODE' => $portfolio_code,
            'OPERATION_DATE' => '',
            'DERIVATIVE_CODE' => '',
            'NET_ASSET_VALUE' => CLX_NUM_0_PT_00,
            'PRICE' => CLX_NUM_0_PT_0000);
        //do sql
        $sql = 'SELECT A.PORTFOLIO_CODE, A.DERIVATIVE_CODE, A.OPERATION_DATE, SUM(A.INVEST_AMT*A.LINE_SIGN) NET_ASSET_VALUE, SUM(A.SHARES) TOTAL_SHARES, ROUND(IFNULL( (SUM(A.INVEST_AMT*A.LINE_SIGN)/nullIF(SUM(A.SHARES), 0)) ,0), 5) PRICE FROM (SELECT INFA.PORTFOLIO_CODE, GLAC.GL_TYPE PROD_TYPE, INFU.DERIVATIVE_CODE, GLCP.OPERATION_DATE, IF(GLAC.GL_TYPE=' . singleQuote('L') . ',-1,1) LINE_SIGN, ((INFA.SHARES*INFA.UNIT_PRICE)+(INFA.INVEST_AMT)+(INFA.ACCRUED_INT_AMT-INFA.PAID_INT_AMT)) INVEST_AMT, /*((INFA.SHARES*INFA.UNIT_PRICE)+(INFA.FACE_VALUE*(INFA.UNIT_PRICE_PCT/100))) INVEST_AMT,*/ (INFA.FACE_VALUE + INFA.SHARES) SHARES, ROUND(((INFA.INVEST_AMT/INFA.FACE_VALUE) + INFA.SHARES), 5)UNIT_PRICE FROM ' . $this->infuname . ' INFU, ' . $this->infaname . ' INFA, ' . $this->pratname . ' PRAT, ' . $this->glacname . ' GLAC, ' . $this->glcpname . ' GLCP WHERE PRAT.PRODUCT_CODE = INFA.PRODUCT_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND GLAC.GLGROUP_CODE = PRAT.GLGROUP_CODE AND GLAC.IDCODE = PRAT.PRO_GL_CODE AND INFU.COMP_CODE = GLCP.COMP_CODE AND INFA.PORTFOLIO_CODE = INFU.IDCODE AND INFU.IDCODE = ' . singleQuote($portfolio_code) . ') A WHERE A.PORTFOLIO_CODE = ' . singleQuote($portfolio_code) . ' GROUP BY A.PORTFOLIO_CODE, A.DERIVATIVE_CODE, A.OPERATION_DATE';
        $result = ClxCommon::$db->getOneRecord($sql);
        if (!empty($result)) {
            $return = array_merge($return, $result);
        }
        return $return;
    }

    /**
     * Sets portfolio prices in stock quotes See Process INFU_001
     * @param unknown_type $comp_code
     */
    function infu_set_company_portfolio_prices($comp_code) {
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('IAT4');
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->iat4name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
        //Guardando revistros en tabla temporal
        $sql = 'INSERT INTO ' . $this->iat4name . ' (BATCH_ID, PORTFOLIO_CODE, INVESTMENT_CODE, EFFTDATE, CHART_FIELD01, FACE_VALUE, IS_INSERT) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, A.PORTFOLIO_CODE PORTFOLIO_CODE, A.DERIVATIVE_CODE INVESTMENT_CODE, A.OPERATION_DATE EFFTDATE, A.CURRENCY_CODE CHART_FIELD01, ROUND(IFNULL((SUM(A.INVEST_AMT*A.LINE_SIGN)/nullIF(SUM(A.SHARES), 0)),0), 5) FACE_VALUE, 1 IS_INSERT FROM (SELECT INFA.PORTFOLIO_CODE, GLAC.GL_TYPE PROD_TYPE, nullIF(INFU.DERIVATIVE_CODE,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') DERIVATIVE_CODE, INFU.CURRENCY_CODE, GLCP.OPERATION_DATE, IF(GLAC.GL_TYPE=' . singleQuote('L') . ',-1,1) LINE_SIGN, /*((INFA.SHARES*INFA.UNIT_PRICE)+(INFA.FACE_VALUE*(INFA.UNIT_PRICE_PCT/100))) INVEST_AMT,*/ ((INFA.SHARES*INFA.UNIT_PRICE)+(INFA.INVEST_AMT)+(INFA.ACCRUED_INT_AMT-INFA.PAID_INT_AMT)) INVEST_AMT, (INFA.FACE_VALUE + INFA.SHARES) SHARES, ROUND(((INFA.INVEST_AMT/INFA.FACE_VALUE) + INFA.SHARES), 5) UNIT_PRICE FROM ' . $this->infuname . ' INFU, ' . $this->infaname . ' INFA, ' . $this->pratname . ' PRAT, ' . $this->glacname . ' GLAC, ' . $this->glcpname . ' GLCP WHERE PRAT.PRODUCT_CODE = INFA.PRODUCT_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND GLAC.GLGROUP_CODE = PRAT.GLGROUP_CODE AND GLAC.IDCODE = PRAT.PRO_GL_CODE AND INFU.COMP_CODE = GLCP.COMP_CODE AND INFA.PORTFOLIO_CODE = INFU.IDCODE AND INFU.COMP_CODE = ' . singleQuote($comp_code) . ' AND INFU.DERIVATIVE_CODE IS NOT null) A WHERE A.DERIVATIVE_CODE IS NOT null GROUP BY A.PORTFOLIO_CODE, A.CURRENCY_CODE, A.DERIVATIVE_CODE, A.OPERATION_DATE';
        ClxCommon::$db->executeQuery($sql);
        //check if something to do
        if (ClxCommon::$db->oneExistsRecords($this->iat4name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            return;
        }
        //Verify if prices exists to update
        $sql = 'UPDATE ' . $this->iat4name . ' IAT4 SET IAT4.IS_INSERT = 0 WHERE EXISTS(SELECT STOC.ID FROM ' . $this->stocname . ' STOC WHERE STOC.INVESTPROD_CODE = IAT4.INVESTMENT_CODE AND STOC.CLX_EFFTDATE = IAT4.EFFTDATE)';
        ClxCommon::$db->executeQuery($sql);
        //Insertando nuevos precios
        $sql = 'INSERT INTO ' . $this->stocname . ' (IDCODE, INVESTPROD_CODE, CLX_EFFTDATE, CURRENCY_CODE, PRICE, DIRTY_PRICE, CLX_AUTH_STATUS) SELECT DISTINCT IAT4.INVESTMENT_CODE IDCODE, IAT4.INVESTMENT_CODE INVESTPROD_CODE, IAT4.EFFTDATE CLX_EFFTDATE, IAT4.CHART_FIELD01 CURRENCY_CODE, IAT4.FACE_VALUE PRICE, IAT4.FACE_VALUE DIRTY_PRICE, ' . singleQuote('AP') . ' FROM ' . $this->iat4name . ' IAT4 WHERE IAT4.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND IAT4.IS_INSERT = 1';
        ClxCommon::$db->executeQuery($sql);
        //Actualizando los que existen para esa fecha
        $sql = 'UPDATE ' . $this->stocname . ' STOC, ' . $this->iat4name . ' IAT4 SET STOC.PRICE = IAT4.FACE_VALUE, STOC.DIRTY_PRICE = IAT4.FACE_VALUE WHERE STOC.INVESTPROD_CODE = IAT4.INVESTMENT_CODE AND IAT4.IS_INSERT = 0';
        ClxCommon::$db->executeQuery($sql);
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->iat4name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
    }

    /**
     * Updates portfolio balances
     *
     * @param string $comp_code
     * @param string $portfolio_code
     */
    function infu_update_portfolio_totals($comp_code, $portfolio_code = '') {
        // Update Portfolio
        $sql = 'UPDATE ' . $this->infuname . ' INFU, (SELECT INFA.PORTFOLIO_CODE, IFNULL(SUM(INFA.INVEST_AMT),0) PORTFOLIO_AMT, IFNULL(SUM(INFA.ACCRUED_INT_AMT),0) INTEARNED_AMT, IFNULL(SUM(INFA.PAID_INT_AMT),0) PAID_INT_AMT, IFNULL(SUM(INFA.ACCRUED_INT_AMT-INFA.PAID_INT_AMT),0) INTTOTAL_AMT, IFNULL(SUM(INFA.GAIN_AMT),0) GAIN_AMT, IFNULL(SUM(INFA.DIVIDEND_AMT),0) DIVIDEND_AMT FROM ' . $this->infaname . ' INFA WHERE INFA.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (($portfolio_code !== '') ? 'AND INFA.PORTFOLIO_CODE = ' . singleQuote($portfolio_code) : '') . ' AND INFA.STATUS = ' . singleQuote('A') . ' GROUP BY INFA.PORTFOLIO_CODE) INFA SET INFU.PORTFOLIO_AMT = INFA.PORTFOLIO_AMT, INFU.INTEARNED_AMT = INFA.INTEARNED_AMT, INFU.PAID_INT_AMT = INFA.PAID_INT_AMT, INFU.INTTOTAL_AMT = INFA.INTTOTAL_AMT, INFU.GAIN_AMT = INFA.GAIN_AMT, INFU.DIVIDEND_AMT = INFA.DIVIDEND_AMT WHERE INFU.IDCODE = INFA.PORTFOLIO_CODE ' . (($portfolio_code !== '') ? 'AND INFU.IDCODE = ' . singleQuote($portfolio_code) : '') . ' AND INFU.COMP_CODE = ' . singleQuote($comp_code);
        ClxCommon::$db->executeQuery($sql);
    }

    // Other methods
    /**
     * Portfolio available cash
     *
     * @param array $record
     */
    function infu_portfolio_cash(&$record, $contract_code = '', $participant_id = '') {
        $cc = '';
        if (!empty($contract_code)) {
            $cc .= ' AND JCBV.CHART_FIELD01 = ' . singleQuote($contract_code) . ' ';
        }
        if (!empty($participant_id)) {
            $cc .= ' AND JCBV.CHART_FIELD02 = ' . singleQuote($participant_id) . ' ';
        }
        $sql = 'SELECT SUM(JCBV.BALANCE_AMT) BALANCE_AMT FROM ' . $this->fiasname . ' FIAS, ' . $this->fibkname . ' FIBK, ' . $this->infuname . ' INFU, ' . $this->jcbvname . ' JCBV, ' . $this->pratname . ' PRAT WHERE FIAS.CONTRACT_CODE = JCBV.CHART_FIELD01 AND FIBK.BANK_ACCOUNT_NO = INFU.FIDU_BANKACT_CODE AND INFU.IDCODE = FIAS.PORTFOLIO_CODE AND JCBV.GLACCOUNTCODE = PRAT.PRO_GL_CODE AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE AND JCBV.CHART_FIELD03 IN (SELECT X.IDCODE FROM  FIDU_ITEMS X WHERE X.CONTRACT_CODE = FIAS.CONTRACT_CODE AND X.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO) AND INFU.IDCODE = ' . singleQuote($record ['INFU_IDCODE']) . '   ' . $cc . ' ';
        $record ['INFU_CASHBAL_AMT'] = ClxCommon::$db->getOne($sql);
    }

    /**
     * For testing porpouses only
     */
    function infu_reset_portfolio() {
        $idlist = getIdlist();
        // Recalculation ledgers
        if (!class_exists('Leba'))
            includeCodeLib('LEBA');
        if (!class_exists('Fibk'))
            includeCodeLib('FIBK');
        $a = new Leba ();
        $fibk = new fibk_utilities ();
        $this->jelnname = tableName('JELN');
        foreach ($idlist as $key => $val) {
            $infurec = ClxCommon::$db->getRecord($this->infuname, 'ID = ' . singleQuote($val));
            if (!empty($infurec ['IDCODE'])) {
                // Delete all activities, Investment Instruments
                $sql = 'SELECT INPR.INVESTMENT_CODE, MIN(INPR.CLX_EFFTDATE) CLX_EFFTDATE FROM INVE_PRODUCTS_TBL INPR WHERE EXISTS (SELECT INFA.ID FROM INVE_INVESTMENTS INFA WHERE INFA.PORTFOLIO_CODE = ' . singleQuote($infurec ['IDCODE']) . ' AND INFA.INVESTMENT_CODE = INPR.INVESTMENT_CODE) GROUP BY INPR.INVESTMENT_CODE';
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $sql = 'DELETE FROM INVE_PRODUCTS_TBL WHERE INVESTMENT_CODE = ' . singleQuote($r['INVESTMENT_CODE']) . ' AND CLX_EFFTDATE>' . singleQuote($r['CLX_EFFTDATE']);
                    ClxCommon::$db->executeQuery($sql);
                }
				ClxCommon::$db->freeResult($rs);
                $sql = 'UPDATE INVE_RENEWALS INVR SET INVR.RENEW_EXEC = 0 WHERE EXISTS (SELECT INFA.ID FROM INVE_INVESTMENTS INFA WHERE INFA.PORTFOLIO_CODE = ' . singleQuote($infurec ['IDCODE']) . ' AND INFA.INVESTMENT_CODE = INVR.INVESTMENT_CODE)';
                ClxCommon::$db->executeQuery($sql);
                ClxCommon::$db->executeQuery('DELETE FROM ' . $this->infaname . ' WHERE PORTFOLIO_CODE = ' . singleQuote($infurec ['IDCODE']));
                ClxCommon::$db->executeQuery('DELETE FROM ' . $this->indtname . ' WHERE PORTFOLIO_CODE = ' . singleQuote($infurec ['IDCODE']));
                ClxCommon::$db->executeQuery('UPDATE ' . $this->infuname . ' SET PORTFOLIO_AMT = 0, GAIN_AMT = 0, PAID_INT_AMT = 0, INTEARNED_AMT = 0, INTTOTAL_AMT = 0, DIVIDEND_AMT = 0 WHERE IDCODE = ' . singleQuote($infurec ['IDCODE']));
                ClxCommon::$db->executeQuery('UPDATE ' . $this->inatname . ' SET JE_COMPLETED = 0, REVERSED = 0, CLX_AUTH_STATUS = ' . singleQuote('PEND') . ', SHARES_SOLD=0 WHERE PORTFOLIO_CODE = ' . singleQuote($infurec ['IDCODE']));
                ClxCommon::$db->executeQuery('DELETE JELN.*, JEHD.* FROM ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD, ' . $this->fiasname . ' FIAS WHERE JELN.JEHDR_CODE = JEHD.IDCODE AND JEHD.INAT_CODE IS NULL AND FIAS.CONTRACT_CODE = JELN.CHART_FIELD01 AND FIAS.IDCODE = JELN.CHART_FIELD03 AND FIAS.PORTFOLIO_CODE =' . singleQuote($infurec ['IDCODE']));
                ClxCommon::$db->executeQuery('UPDATE ' . $this->jehdname . ' JEHD, ' . $this->inatname . ' INAT SET JEHD.CLX_AUTH_STATUS = ' . singleQuote('PEND') . ', JEHD.JE_STATUS = ' . singleQuote('PEND') . ' WHERE INAT.IDCODE = JEHD.INAT_CODE AND INAT.PORTFOLIO_CODE =' . singleQuote($infurec ['IDCODE']));
                $a = new Leba ();
                $a->leba_rebuild($infurec ['COMP_CODE']);
            }
            $sql = 'SELECT FIDU_BANKACT_CODE FROM ' . $this->infuname . '  WHERE IDCODE = ' . singleQuote($infurec ['IDCODE']);
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $fibk->update_balances($r ['FIDU_BANKACT_CODE']);
            }
			ClxCommon::$db->freeResult($rs);
        }
    }

}
