<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-11 10:54:14 -0400 (Sun, 11 Oct 2015) $
 * @version        $Rev: 7209 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
if (!class_exists('Inph')) {

    class Inph {

        /**
         * Constructor
         * @param array [$procParameters]
         */
        function __construct($procParameters = array()) {
            multiTableName($this, array('INPH', 'ACCO', 'CONT', 'INPR', 'FIAT', 'JEHD', 'CONT', 'DYCO', 'FIPA', 'FIBK', 'GDVW', 'GLT1', 'FICO', 'GLCP', 'TTPA', 'GLAC', 'JELN'));
            $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
            $this->username = $_SESSION['user_record']['username'];
            $this->now = xFormat::getNow('Y-m-d H:i:s');
            $this->today = xFormat::getNow('Y-m-d');
            $this->je_source = '';
        }

        /**
         * Initialice fiat form - Executed on init event
         *
         * @param unknown_type $record
         */
        function init_form(&$record) {

        }

        /**
         * Initialice form - Executed on init event
         *
         * @param unknown_type $record
         */
        function load_form(&$record) {
            //Loading beneficiary Information
            $sql = 'SELECT IDNAME INPH_BENEFICIARY_NAME, IDENTIFICATION INPH_IDENTIFICATION, BIRTHDATE INPH_BIRTH_DATE, ADDRESS1 INPH_ADDRESS1, ADDRESS2 INPH_ADDRESS2, CITY INPH_CITY, STATE INPH_STATE, ZIPCODE INPH_ZIPCODE, COUNTRY INPH_COUNTRY, ADDRESS1_02 INPH_ADDRESS1_02, ADDRESS2_02 INPH_ADDRESS2_02, CITY_02 INPH_CITY_02, STATE_02 INPH_STATE_02, ZIPCODE_02 INPH_ZIPCODE_02, COUNTRY_02 INPH_COUNTRY_02, EMAIL INPH_EMAIL, HOME_PHONE INPH_HOME_PHONE, MOBILE_PHONE INPH_MOBILE_PHONE, EMPLOYER INPH_EMPLOYER, BUSINESS_PHONE INPH_BUSINESS_PHONE FROM ' . $this->acconame . ' WHERE IDCODE = ' . singleQuote($record['INPH_ACCOUNTCODE']);
            $rec = ClxCommon::$db->getOneRecord($sql);
            if (!empty($rec)) {
                $record = array_merge($record, $rec);
            }
            //Loading legal representative Information
            $sql = 'SELECT CONT.IDNAME INPH_LR_NAME, CONT.IDENTIFICATION INPH_LR_IDENTIFICATION, CONT.EMAIL INPH_LR_EMAIL, CONT.HOME_PHONE INPH_LR_HOME_PHONE, CONT.MOBILE_PHONE INPH_LR_MOBILE_PHONE, CONT.EMPLOYER INPH_LR_EMPLOYER FROM ' . $this->acconame . ' ACCO, ' . $this->dyconame . ' DYCO, ' . $this->contname . ' CONT WHERE DYCO.PARENT_RECORDID = ACCO.ID AND DYCO.CHILD_RECORDID = CONT.ID AND DYCO.PARENT_TABLECODE = ' . singleQuote('ACC') . ' AND DYCO.CHILD_TABLECODE = ' . singleQuote('CON') . ' AND DYCO.RELATIONSHIP = ' . singleQuote('L') . ' AND ACCO.IDCODE = ' . singleQuote($record['INPH_ACCOUNTCODE']);
            $rec = ClxCommon::$db->getOneRecord($sql);
            if (!empty($rec)) {
                $record = array_merge($record, $rec);
            }
            //Loading Payment Information
            $sql = 'SELECT FIPA.DEF_DSBRSMNT_TYPE INPH_DISBURSEMENT_TYPE, FIPA.DEF_BANKACC_CODE INPH_BANK_ACCOUNT_NO FROM ' . $this->fipaname . ' FIPA WHERE FIPA.CONTRACT_CODE = ' . singleQuote($record['INPH_CONTRACT_CODE']) . ' AND FIPA.ACCOUNTCODE = ' . singleQuote($record['INPH_ACCOUNTCODE']);
            $rec = ClxCommon::$db->getOneRecord($sql);
            if (!empty($rec)) {
                $record = array_merge($record, $rec);
            }
            //Getting bank account information
            $sql = 'SELECT FIBK.BANK_NAME INPH_BANK_NAME, FIBK.BANK_ACCOUNT_NO INPH_BANK_ACCOUNT_NO, FIBK.BANK_PROD_TYPE INPH_BANK_PROD_TYPE, FIBK.INTERMEDIARY_BANK INPH_INTERMEDIARY_BANK, FIBK.BANK_SWIFT INPH_BANK_SWIFT, FIBK.BANK_ROUTING_NO INPH_BANK_ROUTING_NO, FIBK.ADDRESS INPH_BANK_ADDRESS, FIBK.COUNTRY INPH_BANK_COUNTRY, FIBK.STATE INPH_BANK_STATE, FIBK.CITY INPH_BANK_CITY FROM ' . $this->fibkname . ' FIBK WHERE FIBK.BANK_ACCOUNT_NO = ' . singleQuote($record['INPH_BANK_ACCOUNT_NO']);
            $rec = ClxCommon::$db->getOneRecord($sql);
            if (!empty($rec)) {
                $record = array_merge($record, $rec);
            }
        }

        /**
         * Validate record information
         * Executed on table validate
         *
         * @param array $record
         * @param array $msg
         */
        function validate_form(&$record, &$msg) {

        }

        /**
         * Update Information one record is saved
         */
        function save_form(&$record) {
            //Create or Update Account
            includeCodeLib('GEN_REC_UTIL');
            includeCodeLib('ACCO-REC');
            $rec = array('IDCODE' => 'AUTO',
                'ISINDIVIDUAL' => CLX_NUM_ONE,
                'LEGAL_TYPE' => 'I',
                'IDNAME' => UserRequest::$post['INPH_BENEFICIARY_NAME'],
                'FIRSTNAME' => '', 'LASTNAME' => '', 'IDENTIFICATION' => UserRequest::$post['INPH_IDENTIFICATION'],
                'BIRTHDATE' => UserRequest::$post['INPH_BIRTH_DATE'],
                'ADDRESS1' => UserRequest::$post['INPH_ADDRESS1'],
                'ADDRESS2' => UserRequest::$post['INPH_ADDRESS2'],
                'CITY' => UserRequest::$post['INPH_CITY'],
                'STATE' => UserRequest::$post['INPH_STATE'],
                'ZIPCODE' => UserRequest::$post['INPH_ZIPCODE'],
                'COUNTRY' => UserRequest::$post['INPH_COUNTRY'],
                'ADDRESS1_02' => UserRequest::$post['INPH_ADDRESS1_02'],
                'ADDRESS2_02' => UserRequest::$post['INPH_ADDRESS2_02'],
                'CITY_02' => UserRequest::$post['INPH_CITY_02'],
                'STATE_02' => UserRequest::$post['INPH_STATE_02'],
                'ZIPCODE_02' => UserRequest::$post['INPH_ZIPCODE_02'],
                'COUNTRY_02' => UserRequest::$post['INPH_COUNTRY_02'],
                'EMAIL' => UserRequest::$post['INPH_EMAIL'],
                'HOME_PHONE' => UserRequest::$post['INPH_HOME_PHONE'],
                'MOBILE_PHONE' => UserRequest::$post['INPH_MOBILE_PHONE'],
                'EMPLOYER' => UserRequest::$post['INPH_EMPLOYER'],
                'BUSINESS_PHONE' => UserRequest::$post['INPH_BUSINESS_PHONE'],
                'CDATE' => $record['CDATE'],
                'MDATE' => $record['MDATE'],
                'CREATEDBY' => $record['CREATEDBY'],
                'MODIFIEDBY' => $record['MODIFIEDBY'],
                'ACCSTAT' => 'A',
                'ACCDEP' => getAccessTreeDefNode('ACCDEP', $record['CREATEDBY']));
            //Pre commit event
            accoSplitIdname($rec, ',');
            $benef_name = $rec['IDNAME']; //used later on fibk
            createpreAccoRecord($rec);
            //Creating Account Record
            if (!empty($record['ACCOUNTCODE']) && $record['ACCOUNTCODE'] !== 'null') {
                //updating
                $rec['IDCODE'] = $record['ACCOUNTCODE'];
                ClxCommon::$db->updateRecord($this->acconame, $rec, 'IDCODE = ' . singleQuote($rec['IDCODE']));
                $accoid = ClxCommon::$db->getField($this->acconame, 'ID', 'IDCODE = ' . singleQuote($rec['IDCODE']));
            } else {
                setCreationIdCode($rec, 'ACCO');
                $accoid = ClxCommon::$db->createRecord($this->acconame, $rec, false);
                //Post commit Event
                $record['ACCOUNTCODE'] = $rec['IDCODE'];
            }
            updateAccoRecord($rec);
            generateAccotreeEntry($rec);
            //adjusting record for contact
            $rec['ISPRIMARY'] = CLX_NUM_ONE;
            $rec['CONT_ACCESS'] = $rec['ACCDEP'];
            $rec['PHONE'] = $rec['BUSINESS_PHONE'];
            unset($rec['ISINDIVIDUAL'], $rec['BUSINESS_PHONE'], $rec['REQ_SYNCH'], $rec['ACCDEP'], $rec['ACCSTAT']);
            //Adding Contacts
            $contid = ClxCommon::$db->getField($this->contname, 'ID', 'IDENTIFICATION = ' . singleQuote($rec['IDENTIFICATION']));
            if (empty($contid)) {
                $rec['IDCODE'] = 'AUTO';
                setCreationIdCode($rec, 'CONT');
                $contid = ClxCommon::$db->createRecord($this->contname, $rec, false);
            } else {
                unset($rec['IDCODE']);
                ClxCommon::$db->updateRecord($this->contname, $rec, '\'ID = ' . singleQuote($contid));
            }
            if (empty($contid))
                $contid = CLX_INIT_ZERO;
            if (empty($accoid))
                $accoid = CLX_INIT_ZERO;
            //Adding Relation
            $sql = 'SELECT COUNT(ID) FROM ' . $this->dyconame . ' WHERE PARENT_RECORDID = ' . $accoid . ' AND CHILD_RECORDID = ' . $contid . ' AND PARENT_TABLECODE = ' . singleQuote('ACC') . ' AND CHILD_TABLECODE = ' . singleQuote('CON') . '';
            if ($accoid <> CLX_NUM_ZERO && $contid <> CLX_NUM_ZERO && ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
                $rec1 = array('PARENT_RECORDID' => $accoid,
                    'CHILD_RECORDID' => $contid,
                    'PARENT_TABLECODE' => 'ACCO',
                    'CHILD_TABLECODE' => 'CONT');
                ClxCommon::$db->createRecord($this->dyconame, $rec1, false);
            }
            //Creating Legal Representative
            if (!empty(UserRequest::$post['INPH_LR_NAME'])) {
                $rec['IDNAME'] = UserRequest::$post['INPH_LR_NAME'];
                $rec['IDENTIFICATION'] = UserRequest::$post['INPH_LR_IDENTIFICATION'];
                $rec['EMAIL'] = UserRequest::$post['INPH_LR_EMAIL'];
                $rec['PHONE'] = UserRequest::$post['INPH_LR_HOME_PHONE'];
                $rec['HOME_PHONE'] = UserRequest::$post['INPH_LR_HOME_PHONE'];
                $rec['MOBILE_PHONE'] = UserRequest::$post['INPH_LR_MOBILE_PHONE'];
                $rec['EMPLOYER'] = UserRequest::$post['INPH_LR_EMPLOYER'];
                $rec['ISINDIVIDUAL'] = CLX_NUM_ONE;
                accoSplitIdname($rec, ',');
                unset($rec['ISINDIVIDUAL']);
                //Adding Contacts
                $contid = ClxCommon::$db->getField($this->contname, 'ID', 'IDENTIFICATION = ' . singleQuote($rec['IDENTIFICATION']));
                if (empty($contid)) {
                    $rec['IDCODE'] = 'AUTO';
                    setCreationIdCode($rec, 'CONT');
                    $contid = ClxCommon::$db->createRecord($this->contname, $rec, false);
                } else {
                    unset($rec['IDCODE']);
                    ClxCommon::$db->updateRecord($this->contname, $rec, '\'ID = ' . singleQuote($contid));
                }
                //Adding Relation
                $sql = 'SELECT COUNT(ID) FROM ' . $this->dyconame . ' WHERE PARENT_RECORDID = ' . $accoid . ' AND CHILD_RECORDID = ' . $contid . ' AND PARENT_TABLECODE = ' . singleQuote('ACC') . ' AND CHILD_TABLECODE = ' . singleQuote('CON') . '';
                if ($accoid <> CLX_NUM_ZERO && $contid <> CLX_NUM_ZERO && ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
                    $rec1 = array('PARENT_RECORDID' => $accoid,
                        'CHILD_RECORDID' => $contid,
                        'PARENT_TABLECODE' => 'ACCO',
                        'CHILD_TABLECODE' => 'CONT',
                        'RELATIONSHIP' => 'LR');
                    ClxCommon::$db->createRecord($this->dyconame, $rec1, false);
                }
            }
            //Creating Participants
            $sql = 'SELECT COUNT(ID) FROM ' . $this->fipaname . ' WHERE CONTRACT_CODE = ' . singleQuote($record['CONTRACT_CODE']) . ' AND ACCOUNTCODE = ' . singleQuote($record['ACCOUNTCODE']);
            $fiparec = array('DEF_BANKACC_CODE' => UserRequest::$post['INPH_BANK_ACCOUNT_NO'],
                'DEF_DSBRSMNT_TYPE' => UserRequest::$post['INPH_DISBURSEMENT_TYPE']);
            if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
                includeCodeLib('FIPA');
                $fipa = new Fipa();
                $fipa->build($record['CONTRACT_CODE'], $record['ACCOUNTCODE'], 'H', $fiparec);
                unset($fipa);
            } else {
                ClxCommon::$db->updateRecord($this->fipaname, $fiparec, 'CONTRACT_CODE = ' . singleQuote(
                                $record['CONTRACT_CODE']) . ' AND ACCOUNTCODE = ' . singleQuote($record['ACCOUNTCODE']));
            }
            //Creating bank account
            includeCodeLib('FIBK');
            $fibkrec = array('BANK_NAME' => UserRequest::$post['INPH_BANK_NAME'],
                'IDNAME' => $benef_name,
                'BENEFICIARY_NAME' => $benef_name,
                'COMP_CODE' => $record['COMP_CODE'],
                'EXT_PRODUCT_CODE' => UserRequest::$post['INPH_BANK_ACCOUNT_NO'],
                'BANK_PROD_TYPE' => UserRequest::$post['INPH_BANK_PROD_TYPE'],
                'ACCOUNTCODE' => $record['ACCOUNTCODE'],
                'CONTRACT_CODE' => $record['CONTRACT_CODE'],
                'BANK_NAME' => UserRequest::$post['INPH_BANK_NAME'],
                'INTERMEDIARY_BANK' => UserRequest::$post['INPH_INTERMEDIARY_BANK'],
                'BANK_SWIFT' => UserRequest::$post['INPH_BANK_SWIFT'],
                'BANK_ROUTING_NO' => UserRequest::$post['INPH_BANK_ROUTING_NO'],
                'ADDRESS' => UserRequest::$post['INPH_BANK_ADDRESS'],
                'COUNTRY' => UserRequest::$post['INPH_BANK_COUNTRY'],
                'STATE' => UserRequest::$post['INPH_BANK_STATE'],
                'CITY' => UserRequest::$post['INPH_BANK_CITY'],
                'IS_EXTERNAL_PROD' => CLX_NUM_ONE);
            $fibk = new fibk_utilities();
            $fibk->build(UserRequest::$post['INPH_BANK_ACCOUNT_NO'], $fibkrec);
            //Setting flag to prevent accounting
        }

        /**
         * Update Information one record is saved
         */
        function save_form_post(&$record) {
            //Build Accounting for share holders
        }

        /**
         * Process Post Import Accounting
         * @param unknown_type $record
         */
        function save_post_import(&$imprecord) {
            $sql = 'SELECT DISTINCT COMP_CODE FROM ' . $this->inphname . ' WHERE JE_COMPLETED = 0 AND CREATEDBY = ' . singleQuote($this->username);
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $this->buildPaymentAccounting($r['COMP_CODE']);
            }
			ClxCommon::$db->freeResult($rs);
        }

        /**
         * Delete record on delete.
         * @param array $record
         */
        function delete_record_post($record) {

        }

        //Divident charge and payment methods
        /**
         * Prompt Information for dividend processes
         * @param stromg $form_code
         * @return string
         */
        function promptDividend($form_code) {
            //initialization
            $ac = UserRequest::$request['ac'];
            $to = UserRequest::$request[CLX_PROP_TO];
            $it = (array_key_exists('it', UserRequest::$request)) ? UserRequest::$request['it'] : '';
            $contents = '';
            //$form_code = INPH_DIV charge dividends form
            //RTBL_PDIV Pay dividends form
            $EDIT = &getTool('EDIT');
            $record = array();
            $msg = array();
            $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote($form_code));
            $record = UserRequest::$post;
            if (empty($record['confirm'])) {
                if ($form_code === 'INPH_DIV') {
                    if (empty($record['INPH_LAST_DIVIND_DATE']))
                        $record['INPH_LAST_DIVIND_DATE'] = $this->today;
                    $record['INPH_CLX_EFFTDATE'] = $this->today;
                    $record['INPH_SEQNUM'] = CLX_NUM_ONE;
                }else {
                    $record['RTBL_BATCH_ID'] = str_replace('-', '', $this->today);
                }
            }
            if (empty($record['RTBL_CHART_FIELD01_prim']) && empty($record['RTBL_CHART_FIELD01_secn'])) {
                $record['RTBL_CHART_FIELD01'] = '';
            }
            if (empty($record['RTBL_CHART_FIELD02_prim']) && empty($record['RTBL_CHART_FIELD02_secn'])) {
                $record['RTBL_CHART_FIELD02'] = '';
            }
            if (!empty($record['confirm'])) {
                if ($form_code === 'INPH_DIV') {
                    $sql = 'SELECT MAX(SEQNUM)+1 QTY FROM ' . $this->inphname . ' WHERE COMP_CODE = ' . singleQuote($record['INPH_COMP_CODE']) . ' AND CLX_EFFTDATE = ' . singleQuote($record['INPH_CLX_EFFTDATE']);
                    $record['INPH_SEQNUM'] = ClxCommon::$db->getOne($sql);
                    if (empty($record['INPH_SEQNUM']))
                        $record['INPH_SEQNUM'] = CLX_NUM_ONE;
                    UserRequest::$post['INPH_SEQNUM'] = $record['INPH_SEQNUM'];
                }
                $EDIT->checkForm2($msg, $formrec);
                if ($form_code === 'INPH_DIV') {
                    $sql = 'SELECT COUNT(ID) QTY FROM ' . $this->inphname . ' WHERE COMP_CODE = ' . singleQuote($record['INPH_COMP_CODE']) . ' AND CLX_EFFTDATE = ' . singleQuote($record['INPH_CLX_EFFTDATE']) . ' AND CERTIFICATE_NUMBER = ' . singleQuote($record['INPH_CERTIFICATE_NUMBER']) . ' ' . (($record['INPH_ACCOUNTCODE'] <> '') ? ' AND ACCOUNTCODE = ' . singleQuote($record['INPH_ACCOUNTCODE']) : '') . ' AND SEQNUM = ' . singleQuote($record['INPH_SEQNUM']);
                    $qty = ClxCommon::$db->getOne($sql);
                    if ($qty > CLX_NUM_ZERO) {
                        $msg['INPH_SEQNUM'] = dict('GEN_ERR_UNIQUE');
                    }
                    /* if(ClxCommon::$db->oneExistsRecords($this->inphname, 'INVESTMENT_CODE = '' . $record['INPH_INVESTMENT_CODE']) )==0){
                      $msg['INPH_INVESTMENT_CODE'] = smsg('MSG-266');
                      } */
                    if (ClxCommon::$db->oneExistsRecords($this->inphname, 'CERTIFICATE_NUMBER = ' . singleQuote($record['INPH_CERTIFICATE_NUMBER'])) == CLX_NUM_ZERO) {
                        $msg['INPH_CERTIFICATE_NUMBER'] = smsg('MSG-266');
                    }
                    if ($record['INPH_DIVND_OPER_REAS'] <> 'RE' && $record['INPH_DIVIDEND_VAR'] == CLX_NUM_ZERO && $record['INPH_SHARES_VAR'] <= CLX_NUM_ZERO) {
                        $msg['INPH_SHARES_VAR'] = smsg('MSG-267');
                    }
                    if ($record['INPH_DIVND_OPER_REAS'] <> 'RE' && $record['INPH_DIVIDEND_VAR'] == CLX_NUM_ONE && $record['INPH_DIVIDEND_VAR'] <= CLX_NUM_ZERO) {
                        $msg['INPH_DIVIDEND_VAR'] = smsg('MSG-267');
                    }
                    if ($record['INPH_SHARES_BASE'] < CLX_NUM_ZERO) {
                        $msg['INPH_SHARES_BASE'] = smsg('MSG-267');
                    }
                    //dict('GEN_LBL_GREATERTHAN')
                    //Validar que accionista exista
                    if ($record['INPH_DIVND_OPER_REAS'] === 'IN' && empty($record['INPH_ACCOUNTCODE'])) {
                        $msg['INPH_ACCOUNTCODE'] = dict('GEN_ERR_REQUIRED_FIELD');
                    }
                    $sql = 'SELECT COUNT(ID) FROM ' . $this->inphname . ' WHERE CERTIFICATE_NUMBER = ' . singleQuote($record['INPH_CERTIFICATE_NUMBER']) . ' AND CONTRACT_CODE = ' . singleQuote($record['INPH_CONTRACT_CODE']) . ' AND ACCOUNTCODE = ' . singleQuote($record['INPH_ACCOUNTCODE']) . ' ';
                    if ($record['INPH_DIVND_OPER_REAS'] === 'IN' && ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                        $msg['INPH_ACCOUNTCODE'] = smsg('MSG-274');
                    }
                    if ($record['INPH_DIVND_OPER_REAS'] === 'RE' && empty($record['INPH_NEW_CERT_NUMBER'])) {
                        $msg['INPH_NEW_CERT_NUMBER'] = dict('GEN_ERR_REQUIRED_FIELD');
                    }
                    if ($record['INPH_DIVND_OPER_REAS'] === 'IN' && empty($record['INPH_CONTRACT_CODE'])) {
                        $msg['INPH_CONTRACT_CODE'] = dict('GEN_ERR_REQUIRED_FIELD');
                    }
                    if ($record['INPH_DIVND_OPER_REAS'] === 'TR' && empty($record['INPH_ACCOUNTCODE'])) {
                        $msg['INPH_ACCOUNTCODE'] = dict('GEN_ERR_REQUIRED_FIELD');
                    }
                    if ($record['INPH_DIVND_OPER_REAS'] === 'TR' && empty($record['INPH_TO_SHARE_HOLDER'])) {
                        $msg['INPH_TO_SHARE_HOLDER'] = smsg('MSG-269');
                    }
                    //Solo pueden ser operaciones de incremento
                    if ($record['INPH_DIVND_OPER_REAS'] === 'TR' && $record['INPH_DIVND_OPER_TYPE'] <> -CLX_NUM_ONE) {
                        $msg['INPH_DIVND_OPER_TYPE'] = smsg('MSG-270');
                    }
                    //Validar que tenga saldo el accionista de origen
                    if ($record['INPH_DIVND_OPER_REAS'] <> 'RE' && $record['INPH_DIVND_OPER_TYPE'] == -CLX_NUM_ONE && $record['INPH_SHARES_VAR'] <> CLX_NUM_ZERO) {
                        $sql = 'SELECT SUM(SHARES) SHARES FROM ' . $this->inphname . ' INPH WHERE INPH.COMP_CODE = ' . singleQuote($record['INPH_COMP_CODE']) . ' AND INPH.CERTIFICATE_NUMBER = ' . singleQuote($record['INPH_CERTIFICATE_NUMBER']) . ' ' . (($record['INPH_ACCOUNTCODE'] <> '') ? ' AND INPH.ACCOUNTCODE = ' . singleQuote($record['INPH_ACCOUNTCODE']) : '') . ' AND INPH.CLX_EFFTDATE = (SELECT MAX(T.CLX_EFFTDATE) FROM ' . $this->inphname . ' T WHERE T.CONTRACT_CODE = INPH.CONTRACT_CODE AND T.ACCOUNTCODE = INPH.ACCOUNTCODE AND T.CERTIFICATE_NUMBER = INPH.CERTIFICATE_NUMBER AND T.CLX_EFFTDATE <= NOW()) AND INPH.SEQNUM = (SELECT MAX(T2.SEQNUM) FROM ' . $this->inphname . ' T2 WHERE T2.CONTRACT_CODE = INPH.CONTRACT_CODE AND T2.ACCOUNTCODE = INPH.ACCOUNTCODE AND T2.CERTIFICATE_NUMBER = INPH.CERTIFICATE_NUMBER AND T2.CLX_EFFTDATE = INPH.CLX_EFFTDATE)';
                        $qty = ClxCommon::$db->getOne($sql);
                        if (empty($qty) || $qty < $record['INPH_SHARES_VAR']) {
                            //Test for shareholder shares balance.
                            $msg['INPH_SHARES_VAR'] = smsg('MSG-271', $qty, $record['INPH_SHARES_VAR']);
                        }
                    }
                }
            }
            $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', '', dict('GEN_LBL_SUBMIT'));
            $contents .= $form->source();
            if (!empty($record['confirm']) && empty($msg)) {
                $extra = '';
                if ($form_code === 'INPH_DIV') {
                    $this->runDividends($record);
                } else {
                    $this->payDividends($record, $extra);
                }
                return note(dict('GEN_LBL_PROCESS_COMPLETE') . $extra);
            }
            return $contents;
        }

        /**
         * Builds incorporation record
         * @param unknown_type $record
         */
        private function runDivIncorporations(&$record) {
            $DBTB = getTool('DBTB');
            $inphrec = $DBTB->tableDefaultRecord('INPH');
            $inphrec['ACCOUNTCODE'] = $record['INPH_ACCOUNTCODE'];
            $inphrec['CLX_EFFTDATE'] = $record['INPH_CLX_EFFTDATE'];
            $inphrec['ISSUE_DATE'] = ($record['INPH_ISSUE_DATE'] <> '') ? $record['INPH_ISSUE_DATE'] : $record['INPH_CLX_EFFTDATE'];
            $inphrec['COMP_CODE'] = $record['INPH_COMP_CODE'];
            $inphrec['SEQNUM'] = $record['INPH_SEQNUM'];
            $inphrec['CONTRACT_CODE'] = $record['INPH_CONTRACT_CODE'];
            $inphrec['DIVIDEND_AMT'] = $record['INPH_DIVIDEND_VAR'];
            $inphrec['DIVIDEND_VAR'] = $record['INPH_DIVIDEND_VAR'];
            $inphrec['DIVIDEND_PREV_AMT'] = CLX_INIT_ZERO;
            $inphrec['SHARES_PREV_AMT'] = CLX_INIT_ZERO;
            $inphrec['DIVND_OPER_REAS'] = 'IN';
            $inphrec['DIVND_OPER_TYPE'] = '1';
            $inphrec['DIV_COMPLETED'] = CLX_NUM_ONE;
            $inphrec['INVESTMENT_CODE'] = $record['INPH_INVESTMENT_CODE'];
            $inphrec['CERTIFICATE_NUMBER'] = $record['INPH_CERTIFICATE_NUMBER'];
            $inphrec['JE_COMPLETED'] = CLX_INIT_ZERO;
            $inphrec['SHARES'] = $record['INPH_SHARES_VAR'];
            $inphrec['SHARES_BASE'] = CLX_NUM_0_PT_00;
            $inphrec['SHARES_VAR'] = $record['INPH_SHARES_VAR'];
            ClxCommon::$db->createRecord($this->inphname, $inphrec, false);
            unset($inphrec);
        }

        /**
         * Calculate dividends for share holder and build accounting
         * @param array $record
         */
        function runDividends(&$record) {
            $comp_code = $record['INPH_COMP_CODE'];
            $certificate_number = $record['INPH_CERTIFICATE_NUMBER'];
            $efftdate = $record['INPH_LAST_DIVIND_DATE'];
            $dividend_date = $record['INPH_LAST_DIVIND_DATE'];
            $shares_var = $record['INPH_SHARES_VAR'];
            $shares_base = $record['INPH_SHARES_BASE'];
            $dividend_var = $record['INPH_DIVIDEND_VAR'];
            $shareholder = $record['INPH_ACCOUNTCODE'];
            $seqnum = $record['INPH_SEQNUM'];
            if ($record['INPH_DIVND_OPER_REAS'] <> 'RE' && $shares_var == CLX_NUM_ZERO && $dividend_var == CLX_NUM_ZERO)
                return;
            if ($seqnum === '')
                $seqnum = CLX_NUM_ONE;
            $cc = '';
            if ($shareholder <> '') {
                $cc = ' AND INPH.ACCOUNTCODE = ' . singleQuote($shareholder);
            }
            //heandling incorporations
            if ($record['INPH_DIVND_OPER_REAS'] === 'IN') {
                $this->runDivIncorporations($record);
            } else {
                //Handling all other cases. Copying record
                $fields = '';
                $fieldsto = '';
                $comma = '';
                $rs = ClxCommon::$db->executeQuery('SELECT FIELDNAME FROM CLX_DB_TABLEFIELDS WHERE TABLECODE = ' . singleQuote('INP') . ' AND FIELDNAME <> ' . singleQuote('ID') . ' ORDER BY SEQNUM');
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $fields .= $comma . $r['FIELDNAME'];
                    switch ($r['FIELDNAME']) {
                        case 'ID':
                            continue 2;
                            break;
                        case 'CLX_EFFTDATE': case 'MDATE':
                            $fieldsto .= $comma . singleQuote($this->today) . ' ' . $r['FIELDNAME'];
                            break;
                        case 'LAST_DIVIND_DATE':
                            $fieldsto .= $comma . singleQuote($dividend_date) . ' ' . $r['FIELDNAME'];
                            break;
                        case 'MODIFIEDBY':
                            $fieldsto .= $comma . singleQuote($this->username) . ' ' . $r['FIELDNAME'];
                            break;
                        case 'SEQNUM':
                            $fieldsto .= $comma . $seqnum . ' SEQNUM';
                            break;
                        case 'DIV_COMPLETED':
                            $fieldsto .= $comma . ' 0 DIV_COMPLETED';
                            break;
                        case 'JE_COMPLETED':
                            if ($record['INPH_DIVND_OPER_REAS'] === 'DS' || $record['INPH_DIVND_OPER_REAS'] === 'RE') {
                                $fieldsto .= $comma . ' 1 JE_COMPLETED';
                            } else {
                                $fieldsto .= $comma . ' 0 JE_COMPLETED';
                            }
                            break;
                        case 'DIVND_OPER_TYPE':
                            $fieldsto .= $comma . singleQuote($record['INPH_DIVND_OPER_TYPE']) . ' ' . $r['FIELDNAME'];
                            break;
                        case 'DIVND_OPER_REAS':
                            $fieldsto .= $comma . singleQuote($record['INPH_DIVND_OPER_REAS']) . ' ' . $r['FIELDNAME'];
                            break;
                        case 'SHARES_VAR':
                            $fieldsto .= $comma . singleQuote($record['INPH_SHARES_VAR']) . ' ' . $r['FIELDNAME'];
                            break;
                        case 'DIVIDEND_VAR':
                            $fieldsto .= $comma . singleQuote($record['INPH_DIVIDEND_VAR']) . ' ' . $r['FIELDNAME'];
                            break;
                        case 'DIVIDEND_PREV_AMT':
                            $fieldsto .= $comma . 'INPH.DIVIDEND_AMT ' . $r['FIELDNAME'];
                            break;
                        case 'SHARES_PREV_AMT':
                            $fieldsto .= $comma . 'INPH.SHARES ' . $r['FIELDNAME'];
                            break;
                        case 'SHARES_BASE':
                            $fieldsto .= $comma . singleQuote($record['INPH_SHARES_BASE']) . ' ' . $r['FIELDNAME'];
                            break;
                        default:
                            $fieldsto .= $comma . 'INPH.' . $r['FIELDNAME'];
                            break;
                    }
                    $comma = ', ';
                }
				ClxCommon::$db->freeResult($rs);
                //Creating replacement if operation requires it
                if ($record['INPH_DIVND_OPER_REAS'] === 'RE') {
                    $sql = 'INSERT INTO ' . $this->inphname . ' (' . $fields . ') SELECT ' . str_replace('INPH.CERTIFICATE_NUMBER', singleQuote($record['INPH_NEW_CERT_NUMBER']) . ' CERTIFICATE_NUMBER', $fieldsto) . ' FROM ' . $this->inphname . ' INPH WHERE INPH.COMP_CODE = ' . singleQuote($comp_code) . ' AND INPH.CERTIFICATE_NUMBER = ' . singleQuote($certificate_number) . ' ' .
                            $cc . ' AND INPH.CLX_EFFTDATE = (SELECT MAX(T.CLX_EFFTDATE) FROM ' . $this->inphname . ' T WHERE T.CONTRACT_CODE = INPH.CONTRACT_CODE AND T.ACCOUNTCODE = INPH.ACCOUNTCODE AND T.CERTIFICATE_NUMBER = INPH.CERTIFICATE_NUMBER AND T.CLX_EFFTDATE <= ' . singleQuote($this->today) . ') AND INPH.SEQNUM = (SELECT MAX(T2.SEQNUM) FROM ' . $this->inphname . ' T2 WHERE T2.CONTRACT_CODE = INPH.CONTRACT_CODE AND T2.ACCOUNTCODE = INPH.ACCOUNTCODE AND T2.CERTIFICATE_NUMBER = INPH.CERTIFICATE_NUMBER) AND NOT EXISTS(SELECT X.ID FROM ' . $this->inphname . ' X WHERE X.CONTRACT_CODE = INPH.CONTRACT_CODE AND X.ACCOUNTCODE = INPH.ACCOUNTCODE AND X.CERTIFICATE_NUMBER = ' . singleQuote($record['INPH_NEW_CERT_NUMBER']) . ' AND X.SEQNUM = 1 AND X.CLX_EFFTDATE = ' . singleQuote($this->today) . ')';
                    ClxCommon::$db->executeQuery($sql);
                    //Clear shares fields
                    $fieldsto = str_replace('INPH.UNIT_PRICE', '0 UNIT_PRICE', $fieldsto);
                    $fieldsto = str_replace('INPH.SHARES', '0 SHARES', $fieldsto);
                    $fieldsto = str_replace('INPH.DIVIDEND_AMT', '0 DIVIDEND_AMT', $fieldsto);
                    $fieldsto = str_replace('INPH.FACE_VALUE', '0 FACE_VALUE', $fieldsto);
                    $fieldsto = str_replace('INPH.INVEST_AMT', '0 INVEST_AMT', $fieldsto);
                    $fieldsto = str_replace('0 SHARES SHARES_PREV_AMT', 'INPH.SHARES SHARES_PREV_AMT', $fieldsto);
                    $fieldsto = str_replace('0 DIVIDEND_AMT DIVIDEND_PREV_AMT', 'INPH.DIVIDEND_AMT DIVIDEND_PREV_AMT', $fieldsto);
                    $fieldsto = str_replace('INPH.NEW_CERT_NUMBER', singleQuote($record['INPH_NEW_CERT_NUMBER']) . ' NEW_CERT_NUMBER', $fieldsto);
                }
                //Creating normal entity
                $sql = 'INSERT INTO ' . $this->inphname . ' (' . $fields . ') SELECT ' . $fieldsto . ' FROM ' . $this->inphname . ' INPH WHERE INPH.COMP_CODE = ' . singleQuote($comp_code) . ' AND INPH.CERTIFICATE_NUMBER = ' . singleQuote($certificate_number) . ' ' .
                        $cc . ' AND INPH.CLX_EFFTDATE = (SELECT MAX(T.CLX_EFFTDATE) FROM ' . $this->inphname . ' T WHERE T.CONTRACT_CODE = INPH.CONTRACT_CODE AND T.ACCOUNTCODE = INPH.ACCOUNTCODE AND T.CERTIFICATE_NUMBER = INPH.CERTIFICATE_NUMBER AND T.CLX_EFFTDATE <= ' . singleQuote($this->today) . ') AND INPH.SEQNUM = (SELECT MAX(T2.SEQNUM) FROM ' . $this->inphname . ' T2 WHERE T2.CONTRACT_CODE = INPH.CONTRACT_CODE AND T2.ACCOUNTCODE = INPH.ACCOUNTCODE AND T2.CERTIFICATE_NUMBER = INPH.CERTIFICATE_NUMBER AND T2.CLX_EFFTDATE = INPH.CLX_EFFTDATE) AND NOT EXISTS(SELECT X.ID FROM ' . $this->inphname . ' X WHERE X.CONTRACT_CODE = INPH.CONTRACT_CODE AND X.ACCOUNTCODE = INPH.ACCOUNTCODE AND X.CERTIFICATE_NUMBER = INPH.CERTIFICATE_NUMBER AND X.SEQNUM = ' . $seqnum . ' AND X.CLX_EFFTDATE = ' . singleQuote($this->today) . ')';
                ClxCommon::$db->executeQuery($sql);
            }
            if ($record['INPH_DIVND_OPER_REAS'] <> 'TR' && $record['INPH_DIVND_OPER_REAS'] <> 'RE') {
                if ($shares_var > CLX_NUM_ZERO) {//case shares
                    //Dividendo en Acciones = Acciones + ((Acciones / Por Cada ) * Acciones)
                    $sql = 'UPDATE ' . $this->inphname . ' INPH SET INPH.SHARES = INPH.SHARES+(INPH.DIVND_OPER_TYPE*ROUND(((INPH.SHARES/' . $shares_base . ')*' . $shares_var . '), 5)), DIV_COMPLETED = 1 WHERE INPH.COMP_CODE = ' . singleQuote($comp_code) . ' AND INPH.CERTIFICATE_NUMBER = ' . singleQuote($certificate_number) . ' ' .
                            $cc . ' AND INPH.CLX_EFFTDATE = ' . singleQuote($this->today) . ' AND INPH.SEQNUM = ' . $seqnum . ' AND INPH.DIV_COMPLETED = 0';
                    ClxCommon::$db->executeQuery($sql);
                } elseif ($dividend_var > CLX_NUM_ZERO) {//case price
                    //Dividendo en Monto = Monto+((Acciones / por Cada) * Monto)
                    $sql = 'UPDATE ' . $this->inphname . ' INPH SET INPH.DIVIDEND_AMT = INPH.DIVIDEND_AMT+(INPH.DIVND_OPER_TYPE*ROUND(((INPH.SHARES/' . $shares_base . ')*' . $dividend_var . '), 2)), DIV_COMPLETED = 1 WHERE INPH.COMP_CODE = ' . singleQuote($comp_code) . ' AND INPH.CERTIFICATE_NUMBER = ' . singleQuote($certificate_number) . ' ' .
                            $cc . ' AND INPH.CLX_EFFTDATE = ' . singleQuote($this->today) . ' AND INPH.SEQNUM = ' . $seqnum . ' AND INPH.DIV_COMPLETED = 0';
                    ClxCommon::$db->executeQuery($sql);
                }
            }
            //Procesing Transfer Record
            if ($record['INPH_DIVND_OPER_REAS'] === 'TR') {
                //Adjusting Share amount for current holder
                $sql = 'UPDATE ' . $this->inphname . ' INPH SET INPH.SHARES = INPH.SHARES+(INPH.DIVND_OPER_TYPE*' . $shares_var . '), INPH.DIV_COMPLETED = 1, INPH.TO_SHARE_HOLDER = ' . singleQuote($record['INPH_TO_SHARE_HOLDER']) . ' WHERE INPH.COMP_CODE = ' . singleQuote($comp_code) . ' AND INPH.CERTIFICATE_NUMBER = ' . singleQuote($certificate_number) . ' AND INPH.ACCOUNTCODE = ' . singleQuote($shareholder) . ' AND INPH.CLX_EFFTDATE = ' . singleQuote($this->today) . ' AND INPH.SEQNUM = ' . $seqnum . ' AND INPH.DIV_COMPLETED = 0';
                ClxCommon::$db->executeQuery($sql);
                //find if record exists for share holder
                $sql = 'SELECT INPH.* FROM ' . $this->inphname . ' INPH WHERE INPH.COMP_CODE = ' . singleQuote($comp_code) . ' AND INPH.CERTIFICATE_NUMBER = ' . singleQuote($certificate_number) . ' AND INPH.ACCOUNTCODE = ' . singleQuote($record['INPH_TO_SHARE_HOLDER']) . ' AND INPH.CLX_EFFTDATE = (SELECT MAX(T.CLX_EFFTDATE) FROM ' . $this->inphname . ' T WHERE T.CONTRACT_CODE = INPH.CONTRACT_CODE AND T.ACCOUNTCODE = INPH.ACCOUNTCODE AND T.CERTIFICATE_NUMBER = INPH.CERTIFICATE_NUMBER AND T.CLX_EFFTDATE <= ' . singleQuote($this->today) . ') AND INPH.SEQNUM = (SELECT MAX(T2.SEQNUM) FROM ' . $this->inphname . ' T2 WHERE T2.CONTRACT_CODE = INPH.CONTRACT_CODE AND T2.ACCOUNTCODE = INPH.ACCOUNTCODE AND T2.CERTIFICATE_NUMBER = INPH.CERTIFICATE_NUMBER AND T2.CLX_EFFTDATE = INPH.CLX_EFFTDATE)';
                $to_share = ClxCommon::$db->getOneRecord($sql);
                if (empty($to_share)) {
                    //getting share holder info as base to create to share holder record
                    $sql = 'SELECT * FROM ' . $this->inphname . ' INPH WHERE INPH.COMP_CODE = ' . singleQuote($comp_code) . ' AND INPH.CERTIFICATE_NUMBER = ' . singleQuote($certificate_number) . ' AND INPH.ACCOUNTCODE = ' . singleQuote($shareholder) . ' AND INPH.CLX_EFFTDATE = ' . singleQuote($this->today) . ' AND INPH.SEQNUM = ' . $seqnum;
                    $to_share = ClxCommon::$db->getOneRecord($sql);
                    $to_share['ACCOUNTCODE'] = $record['INPH_TO_SHARE_HOLDER'];
                    $to_share['DIVIDEND_AMT'] = CLX_INIT_ZERO;
                    $to_share['DIVIDEND_VAR'] = CLX_INIT_ZERO;
                    $to_share['DIVIDEND_PREV_AMT'] = CLX_INIT_ZERO;
                    $to_share['SHARES_PREV_AMT'] = CLX_INIT_ZERO;
                    $to_share['SHARES'] = $shares_var;
                    $to_share['SHARES_VAR'] = $shares_var;
                    $to_share['DIVND_OPER_REAS'] = 'IN';
                    $to_share['JE_COMPLETED'] = CLX_NUM_ONE;
                    $to_share['SEQNUM'] = CLX_NUM_ONE;
                } else {
                    //shareholder already exists just updating
                    if ($to_share['CLX_EFFTDATE'] == $efftdate) {
                        $to_share['SEQNUM'] ++;
                    } else {
                        $to_share['SEQNUM'] = CLX_NUM_ONE;
                        $to_share['CLX_EFFTDATE'] = $efftdate;
                    }
                    $to_share['DIVIDEND_PREV_AMT'] = $to_share['DIVIDEND_AMT'];
                    $to_share['SHARES_PREV_AMT'] = $to_share['SHARES'];
                    $to_share['DIVIDEND_VAR'] = CLX_INIT_ZERO;
                    $to_share['SHARES'] += $shares_var;
                    $to_share['SHARES_VAR'] = $shares_var;
                    $to_share['DIVND_OPER_REAS'] = $record['INPH_DIVND_OPER_REAS'];
                    $to_share['JE_COMPLETED'] = CLX_NUM_ONE;
                }
                $to_share['SHARES_BASE'] = CLX_INIT_ZERO;
                $to_share['DIVND_OPER_TYPE'] = '1';
                $to_share['TO_SHARE_HOLDER'] = $shareholder;
                unset($to_share['ID']);
                ClxCommon::$db->createRecord($this->inphname, $to_share, false);
            }
            //Build Accounting for share holders
            if ($record['INPH_DIVND_OPER_REAS'] <> 'RE') {//si no es reposicion
                $this->buildPaymentAccounting($comp_code);
            }
        }

        /**
         * builds Accounting for dividends charge
         */
        function buildPaymentAccounting($comp_code) {
            //GLT1
            $je_source = 'INVE-SHDC'; //provision de intereses de prestamos
            $DBLT = &getTool('DBLT');
            $idname = $DBLT->getListItem('SOTY', $je_source);
            $idname = substr($idname, CLX_NUM_ZERO, CLX_NUM_60);
            if (!class_exists('Jehd'))
                includeCodeLib('JEHD');
            if (!class_exists('Comp'))
                includeCodeLib('COMP');
            //Load temporary table - Req on mysql
            $DBTB = &getTool('DBTB');
            $DBTB->buildTemporaryTable('GLT1'); //Clear tmp
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
            $comp = new Comp();
            $comprec = $comp->comp_operation_parameters($comp_code);
            $operation_date = $comprec['OPERATION_DATE'];
            if (empty($comprec))
                return;
            //loading temporary table
            /* SUM((case INPH.DIVND_OPER_REAS WHEN 'IN' THEN 1 ELSE INPH.SHARES END)*INPH.DIVIDEND_VAR) BALANCE_AMT, */
            $sql = 'INSERT INTO ' . $this->glt1name . ' (BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_AMT, CREDIT_AMT, PRODUCT_CODE, PENALTY_CALC_TYPE) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote($comprec['OPERATION_DATE']) . ' EFFTDATE, ' . singleQuote('A') . ' GLACCOUNTCODE, ' . singleQuote('A') . ' GL01_CODE, ' . singleQuote('L') . ' GL_TYPE, SUM(INPH.DIVIDEND_AMT - INPH.DIVIDEND_PREV_AMT) BALANCE_AMT, 0 CALC_AMT_01, 0 CALC_AMT_02, 0 CALC_AMT_03, 0 CALC_AMT_04, INPH.CONTRACT_CODE CHART_FIELD01, null CHART_FIELD02, null CHART_FIELD03, null CHART_FIELD04, ' . singleQuote($comprec['CURRENCY_CODE']) . ' CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_AMT, 0 CREDIT_AMT, null /*INPH.INVESTMENT_CODE*/ PRODUCT_CODE, INPH.DIVND_OPER_TYPE PENALTY_CALC_TYPE FROM ' . $this->inphname . ' INPH WHERE INPH.COMP_CODE = ' . singleQuote($comp_code) . ' AND INPH.JE_COMPLETED = 0 GROUP BY INPH.CONTRACT_CODE, /*INPH.INVESTMENT_CODE,*/ INPH.DIVND_OPER_TYPE HAVING SUM(INPH.DIVIDEND_AMT - INPH.DIVIDEND_PREV_AMT)<>0'; // HAVING SUM(INPH.SHARES*INPH.DIVIDEND_VAR)<>0
            //HAVING SUM((case INPH.DIVND_OPER_REAS WHEN 'IN' THEN 1 ELSE INPH.SHARES END)*INPH.DIVIDEND_VAR)<>0
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' X SET X.GLACCOUNTCODE = (SELECT MAX(TTPA.AP_GL_CODE) FROM ' . $this->ttpaname . ' TTPA, ' . $this->ficoname . ' FICO, ' . $this->glcpname . ' GLCP WHERE FICO.FI_TYPE = TTPA.FI_TYPE AND GLCP.COMP_CODE = FICO.COMP_CODE AND TTPA.TRUST_FUND_SRC = FICO.TRUST_FUND_SRC AND GLCP.GLGROUP_CODE = TTPA.GLGROUP_CODE AND FICO.IDCODE = X.CHART_FIELD01) WHERE X.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' X SET X.GL01_CODE = (SELECT MAX(TTPA.EQ_GL_CODE) FROM ' . $this->ttpaname . ' TTPA, ' . $this->ficoname . ' FICO, ' . $this->glcpname . ' GLCP WHERE FICO.FI_TYPE = TTPA.FI_TYPE AND GLCP.COMP_CODE = FICO.COMP_CODE AND GLCP.GLGROUP_CODE = TTPA.GLGROUP_CODE AND TTPA.TRUST_FUND_SRC = FICO.TRUST_FUND_SRC AND FICO.IDCODE = X.CHART_FIELD01) WHERE X.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Setting gl type and participant
            $sql = 'UPDATE ' . $this->glt1name . ' X SET X.GL_TYPE = (SELECT MAX(GLAC.GL_TYPE) FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = X.GLACCOUNTCODE), X.CHART_FIELD02 = (SELECT MAX(FIPA.ACCOUNTCODE) FROM ' . $this->fipaname . ' FIPA WHERE FIPA.CONTRACT_CODE = X.CHART_FIELD01 AND FIPA.ISPRIMARY = 1) WHERE X.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Setting debits or credits
            $sql = 'UPDATE ' . $this->glt1name . ' X SET X.DEBIT_AMT = X.BALANCE_AMT WHERE X.PENALTY_CALC_TYPE = 1 AND X.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' X SET X.CREDIT_AMT = X.BALANCE_AMT WHERE X.PENALTY_CALC_TYPE <> 1 AND X.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            $jehd = new Jehd();
            //Build Header for this process, one pre currency
            $sql = 'SELECT DISTINCT CURRENCY_CODE, ' . singleQuote($operation_date) . ' OPERATION_DATE, ' . singleQuote($comp_code) . ' COMP_CODE, ' . singleQuote($comprec['LGGROUP_CODE']) . ' LGGROUP_CODE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            $results = ClxCommon::$db->executeQuery($sql);
            while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                $gl_rec = $jehd->jehd_init_record();
                $gl_rec['IDNAME'] = $idname;
                $gl_rec['JE_SOURCE'] = $je_source;
                $gl_rec['LGGROUP_CODE'] = $result['LGGROUP_CODE'];
                $gl_rec['EFFTDATE'] = $result['OPERATION_DATE'];
                $gl_rec['COMP_CODE'] = $result['COMP_CODE'];
                $gl_rec['TRANS_CODE'] = null;
                $gl_rec['TRANSTBL_CODE'] = 'SYS_CRED-INTE';
                $gl_rec['REQ_CHANNEL'] = 'USR';
                $gl_rec['BATCH_ID'] = $this->batch_id;
                $jehd->jehd_build($gl_rec);
                //Search any scale if apply and dump lines to journal
                //debit in credit as
                $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GL01_CODE GLACCOUNTCODE, ' . singleQuote('CADESHD') . ' ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.PRODUCT_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.DEBIT_AMT, X.CREDIT_AMT, 1 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
                ClxCommon::$db->executeQuery($sql);
                //contraparte
                $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GLACCOUNTCODE GLACCOUNTCODE, ' . singleQuote('CADESHD') . ' ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.PRODUCT_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.CREDIT_AMT DEBIT_AMT, X.DEBIT_AMT CREDIT_AMT, 2 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
                ClxCommon::$db->executeQuery($sql);
                $jehd->jehd_approve_queue_by_code($gl_rec['IDCODE']);
            }
			ClxCommon::$db->freeResult($results);
            $sql = 'UPDATE ' . $this->inphname . ' INPH SET INPH.JE_COMPLETED = 1 WHERE INPH.COMP_CODE = ' . singleQuote($comp_code) . ' AND INPH.JE_COMPLETED = 0';
            ClxCommon::$db->executeQuery($sql);
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
        }

        /**
         * Build Payment Transactions
         * @param unknown_type $comp_code
         * @param unknown_type $investment_code
         * @param unknown_type $transtbl_code
         * @param unknown_type $chart_field01
         * @param unknown_type $chart_field02
         * @param unknown_type $bank_account_no
         * @param unknown_type $batch_id
         */
        function payDividends(&$record, &$msg) {
            $comp_code = $record['RTBL_COMP_CODE'];
            $investment_code = $record['RTBL_INVESTMENT_CODE'];
            $transtbl_code = $record['RTBL_TRANSTBL_CODE'];
            $chart_field01 = $record['RTBL_CHART_FIELD01'];
            $chart_field02 = $record['RTBL_CHART_FIELD02'];
            $bank_account_no = $record['RTBL_FIDU_BANKACT_CODE'];
            $disbursement_type = $record['RTBL_DISBURSEMENT_TYPE'];
            $batch_id = $record['RTBL_BATCH_ID'];
            if ($disbursement_type <> '') {
                $batch_id .= '-' . $record['RTBL_DISBURSEMENT_TYPE'];
            }
            $this->batch_id = $batch_id;
            if (!class_exists('Comp'))
                includeCodeLib('COMP');
            $comp = new Comp();
            $comprec = $comp->comp_operation_parameters($comp_code);
            $xrate = $comp->comp_current_exchange($comp_code, $comprec['CURRENCY_CODE'], $comprec['OPERATION_DATE']);
            if (!class_exists('Fiat'))
                includeCodeLib('FIAT');
            $fiat = new Fiat();
            //build transactions
            $sql = 'SELECT ' . singleQuote('AUTO') . ' IDCODE, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' IDNAME, ' . singleQuote($comprec['OPERATION_DATE']) . ' EFFTDATE, ' . singleQuote($transtbl_code) . ' TRANSTBL_CODE, ' . singleQuote('PEND') . ' CLX_AUTH_STATUS, ' . singleQuote($comprec['CURRENCY_CODE']) . ' CURRENCY_CODE, ' . singleQuote($comprec['LGGROUP_CODE']) . ' LGGROUP_CODE, ' . singleQuote($investment_code) . ' ITEM_REF_NO, INPH.COMP_CODE, INPH.CONTRACT_CODE CHART_FIELD01, (SELECT MAX(X.ACCOUNTCODE) FROM ' . $this->fipaname . ' X WHERE X.CONTRACT_CODE = INPH.CONTRACT_CODE AND X.ISPRIMARY = 1 AND X.STATUS = ' . singleQuote('A') . ') CHART_FIELD02, ' . singleQuote('null') . ' CHART_FIELD03, ' . singleQuote('null') . ' CHART_FIELD04, ' . singleQuote($xrate['EXCHANGE_RT']) . ' EXCHANGE_RT, ' . singleQuote($xrate['CUR_OPERATOR']) . ' CUR_OPERATOR, ' . singleQuote($bank_account_no) . '  FIDU_BANKACT_CODE, SUM(INPH.DIVIDEND_AMT-INPH.PAID_DIVIDEND_AMT) TRANS_AMT, 0 RECONCILIED, ' . singleQuote($comprec['OPERATION_DATE']) . ' AVAILABILITY_DATE, INPH.ACCOUNTCODE BENEFICIARY_CODE, FIPA.DEF_BANKACC_CODE BANKAC_CODE, FIPA.DEF_DSBRSMNT_TYPE DISBURSEMENT_TYPE, 0 RECORD_BLOCKING, ' . singleQuote($investment_code) . ' REFERENCE_NO, ' . singleQuote($batch_id) . ' BATCH_ID, ' . singleQuote('INVE-SHD') . ' JE_SOURCE, ' . singleQuote($this->username) . ' CREATEDBY, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->username) . ' MODIFIEDBY, ' . singleQuote($this->now) . ' MDATE FROM ' . $this->inphname . '  INPH, ' . $this->fipaname . ' FIPA WHERE FIPA.CONTRACT_CODE = INPH.CONTRACT_CODE AND FIPA.ACCOUNTCODE = INPH.ACCOUNTCODE AND INPH.COMP_CODE = ' . singleQuote($comp_code) . ' AND INPH.INVESTMENT_CODE = ' . singleQuote($investment_code) . ' AND INPH.CLX_EFFTDATE = (SELECT MAX(T.CLX_EFFTDATE) FROM ' . $this->inphname . ' T WHERE T.CONTRACT_CODE = INPH.CONTRACT_CODE AND T.ACCOUNTCODE = INPH.ACCOUNTCODE AND T.INVESTMENT_CODE = INPH.INVESTMENT_CODE AND T.CLX_EFFTDATE <= NOW()) AND INPH.SEQNUM = (SELECT MAX(T2.SEQNUM) FROM ' . $this->inphname . ' T2 WHERE T2.CONTRACT_CODE = INPH.CONTRACT_CODE AND T2.ACCOUNTCODE = INPH.ACCOUNTCODE AND T2.INVESTMENT_CODE = INPH.INVESTMENT_CODE AND T2.CLX_EFFTDATE = INPH.CLX_EFFTDATE) ' . (($chart_field01 <> '') ? ' AND INPH.CONTRACT_CODE = ' . singleQuote($chart_field01) : '') .
                    (($chart_field02 <> '') ? ' AND INPH.ACCOUNTCODE = ' . singleQuote($chart_field02) : '') .
                    (($disbursement_type <> '') ? ' AND FIPA.DEF_DSBRSMNT_TYPE = ' . singleQuote($disbursement_type) : '') . ' GROUP BY INPH.COMP_CODE, INPH.CONTRACT_CODE, INPH.ACCOUNTCODE, FIPA.DEF_BANKACC_CODE, FIPA.DEF_DSBRSMNT_TYPE HAVING SUM(INPH.DIVIDEND_AMT-INPH.PAID_DIVIDEND_AMT)<>0';
            $rs = ClxCommon::$db->executeQuery($sql);
            $i = CLX_INIT_ZERO;
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $fiat->fiat_build($comp_code, $r['TRANSTBL_CODE'], $r['CHART_FIELD01'], $r['CHART_FIELD02'], $r['TRANS_AMT'], $r);
                $i++;
            }
			ClxCommon::$db->freeResult($rs);
            $msg = '<br>' . dict('GEN_LBL_TRANSACTION_QTY', $i) . '<br>' . dict('GEN_LBL_BATCH_ID') . ': ' . $batch_id;
        }

        /**
         * Sum dividends by transactions
         * @param $trans_code
         */
        function sum_pay_dividends($jehdr_code) {
            /*
             * INPH.DIVIDEND_AMT-INPH.PAID_DIVIDEND_AMT
             * INPH.LAST_PAY_DATE
             *  GDVW.COMP_CODE,
              GDVW.CHART_FIELD01, FIAT.BENEFICIARY_CODE, GDVW.ITEM_REF_NO, */
            $sql = 'SELECT DISTINCT GDVW.COMP_CODE, GDVW.CHART_FIELD01 CONTRACT_CODE, FIAT.BENEFICIARY_CODE ACCOUNTCODE, FIAT.EFFTDATE LAST_PAY_DATE, FIAT.ITEM_REF_NO INVESTMENT_CODE, SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT) PAID_DIVIDEND_AMT FROM ' . $this->gdvwname . ' GDVW, ' . $this->fiatname . ' FIAT, ' . $this->ttpaname . ' TTPA, ' . $this->ficoname . ' FICO, ' . $this->glcpname . ' GLCP WHERE GDVW.CHART_FIELD01 = FIAT.CHART_FIELD01 AND GDVW.CHART_FIELD02 = FIAT.CHART_FIELD02 AND GDVW.TRANS_CODE = FIAT.IDCODE AND GDVW.JE_SOURCE = ' . singleQuote('INVE-SHD') . ' AND GDVW.IDCODE = ' . singleQuote($jehdr_code) . ' AND FICO.FI_TYPE = TTPA.FI_TYPE AND TTPA.TRUST_FUND_SRC = FICO.TRUST_FUND_SRC AND GLCP.COMP_CODE = FICO.COMP_CODE AND GLCP.GLGROUP_CODE = TTPA.GLGROUP_CODE AND FICO.IDCODE = FIAT.CHART_FIELD01 AND GDVW.GLACCOUNTCODE = TTPA.AP_GL_CODE GROUP BY GDVW.COMP_CODE, GDVW.CHART_FIELD01, FIAT.BENEFICIARY_CODE, FIAT.EFFTDATE, FIAT.ITEM_REF_NO';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                if ($r['INVESTMENT_CODE'] === '')
                    continue;
                $sql = 'SELECT MAX(CLX_EFFTDATE) INPH_EFFTDATE, MAX(SEQNUM) INPH_SEQNUM FROM ' . $this->inphname . ' WHERE CONTRACT_CODE = ' . singleQuote($r['CONTRACT_CODE']) . ' AND ACCOUNTCODE = ' . singleQuote($r['ACCOUNTCODE']) . ' AND INVESTMENT_CODE = ' . singleQuote($r['INVESTMENT_CODE']);
                $r2 = ClxCommon::$db->getOneRecord($sql);
                if (empty($r2))
                    continue;
                $sql = 'UPDATE ' . $this->inphname . ' SET PAID_DIVIDEND_AMT = PAID_DIVIDEND_AMT+' . $r['PAID_DIVIDEND_AMT'] . ', LAST_PAY_DATE = ' . singleQuote($r['LAST_PAY_DATE']) . ' WHERE CONTRACT_CODE = ' . singleQuote($r['CONTRACT_CODE']) . ' AND ACCOUNTCODE = ' . singleQuote($r['ACCOUNTCODE']) . ' AND INVESTMENT_CODE = ' . singleQuote($r['INVESTMENT_CODE']) . ' AND CLX_EFFTDATE = ' . singleQuote($r2['INPH_EFFTDATE']) . ' AND SEQNUM = ' . singleQuote($r2['INPH_SEQNUM']);
                ClxCommon::$db->executeQuery($sql);
            }
			ClxCommon::$db->freeResult($rs);
        }

        /**
         * Validation of payments
         * @param unknown_type $jehdr_code
         * @param unknown_type $msg
         */
        function validate_fiat_payment_approval($trans_code, &$msg) {
            $sql = 'SELECT DISTINCT JEHD.COMP_CODE, JELN.CHART_FIELD01 CONTRACT_CODE, FIAT.BENEFICIARY_CODE ACCOUNTCODE, FIAT.EFFTDATE LAST_PAY_DATE, FIAT.ITEM_REF_NO INVESTMENT_CODE, SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) PAID_DIVIDEND_AMT FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->fiatname . ' FIAT, ' . $this->ttpaname . ' TTPA, ' . $this->ficoname . ' FICO, ' . $this->glcpname . ' GLCP WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JELN.CHART_FIELD01 = FIAT.CHART_FIELD01 AND JELN.CHART_FIELD02 = FIAT.CHART_FIELD02 AND JEHD.TRANS_CODE = FIAT.IDCODE AND JEHD.JE_SOURCE = ' . singleQuote('INVE-SHD') . ' AND JEHD.TRANS_CODE = ' . singleQuote($trans_code) . ' AND FICO.FI_TYPE = TTPA.FI_TYPE AND TTPA.TRUST_FUND_SRC = FICO.TRUST_FUND_SRC AND GLCP.COMP_CODE = FICO.COMP_CODE AND GLCP.GLGROUP_CODE = TTPA.GLGROUP_CODE AND FICO.IDCODE = FIAT.CHART_FIELD01 AND JELN.GLACCOUNTCODE = TTPA.AP_GL_CODE GROUP BY JEHD.COMP_CODE, JELN.CHART_FIELD01, FIAT.BENEFICIARY_CODE, FIAT.EFFTDATE, FIAT.ITEM_REF_NO';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $sql = 'SELECT SUM(INPH.DIVIDEND_AMT-INPH.PAID_DIVIDEND_AMT) BALANCE_AMT FROM ' . $this->inphname . ' INPH WHERE INPH.COMP_CODE = ' . singleQuote($r['COMP_CODE']) . ' AND INPH.INVESTMENT_CODE = ' . singleQuote($r['INVESTMENT_CODE']) . ' AND INPH.CLX_EFFTDATE = (SELECT MAX(T.CLX_EFFTDATE) FROM ' . $this->inphname . ' T WHERE T.CONTRACT_CODE = INPH.CONTRACT_CODE AND T.ACCOUNTCODE = INPH.ACCOUNTCODE AND T.INVESTMENT_CODE = INPH.INVESTMENT_CODE AND T.CLX_EFFTDATE <= NOW()) AND INPH.SEQNUM = (SELECT MAX(T2.SEQNUM) FROM ' . $this->inphname . ' T2 WHERE T2.CONTRACT_CODE = INPH.CONTRACT_CODE AND T2.ACCOUNTCODE = INPH.ACCOUNTCODE AND T2.INVESTMENT_CODE = INPH.INVESTMENT_CODE AND T2.CLX_EFFTDATE = INPH.CLX_EFFTDATE) AND INPH.CONTRACT_CODE = ' . singleQuote($r['CONTRACT_CODE']) . ' AND INPH.ACCOUNTCODE = ' . singleQuote($r['ACCOUNTCODE']);
                $available = ClxCommon::$db->getOne($sql);
                if ($available < $r['PAID_DIVIDEND_AMT']) {
                    $msg['JEHD_IDCODE'] = smsg('MSG-275', $trans_code, $r['INVESTMENT_CODE'], $r['ACCOUNTCODE']);
                }
            }
			ClxCommon::$db->freeResult($rs);
        }

    }

}
