<?php

if (!class_exists('inve_reports')) {

    /**
     * General Code File
     * For more information contact  support@alenet.com
     *
     * @author       $Author: cramirez $
     * @copyright    Alenet, Inc.
     * @since        $Date: 2016-12-15 17:09:58 -0500 (Thu, 15 Dec 2016) $
     * @version        $Rev: 8988 $
     *
     * CHANGE LOG
     *  Included svn prop
     */
    class inve_reports {

        var $modulecode; // Module Code
        var $sdate = ''; //Start Date
        var $edate = ''; //To date
        var $chart_field01 = '';
        var $chart_field02 = '';
        var $chart_field03 = '';
        var $chart_field04 = '';
        var $chart_field05 = '';
        var $item_code = '';
        var $glaccountcode = '';
        var $currency_code = '';
        var $exclude_subcontracts = false;
        var $user_sdate = '';
        var $comp_code; // Company
        var $single_currency = false; //Sngle currency on reports,
        //set to true to select from one currency only
        var $url; //Script URL, where script is executed for links.
        //example pop.php, tool.php, etc
        var $debug = false;
        var $contents = '';
        var $date_format = 'd/m/Y';
        var $level = CLX_NUM_ONE;
        var $rounding = CLX_NUM_TWO;
        var $display_rounding = CLX_NUM_TWO;
        var $paging = false;
        var $page_total_qty = CLX_INIT_ZERO;
        var $page_rpp = CLX_NUM_HUNDRED;
        var $page_limit = CLX_NUM_TWO;
        var $new_line = '';
        var $FIRE_lib;

        function __construct() {
            $this->batch_id = batch_id();
            $this->datestamp = date('YmdHis');
            $this->modulecode = 'FIDU'; // Module
            $this->new_line = CLX_CHAR_NL;
            multiTableName($this, array('INFU', 'ETMP', 'INAT', 'ETMP', 'PTMP', 'ITMP', 'INFA', 'INFU', 'GDVW', 'FIAS', 'PRAT', 'PROD', 'INPR', 'INAT', 'INFA', 'FIAD', 'INPR', 'STOC', 'INTT', 'IETB', 'INUI', 'INSI', 'FICO', 'INVA', 'INFH', 'FIAT', 'FITL', 'COMP', 'FIBK', 'JEHD', 'JELN', 'GLAC', 'FIPA', 'CURR', 'COMP', 'RINV', 'GLCP', 'ITMP', 'PTMP', 'INDT'));
        }

        /**
         * Returns source code
         */
        function source() {
            return $this->contents;
        }

// End method
        function init_prompt_record(&$record) {
            if (!array_key_exists('RTBL_COMP_CODE', $record))
                $record['RTBL_COMP_CODE'] = '';
            if (!function_exists('comp_operation_parameters'))
                includeCodeLib('COMP');
            $comp = new Comp();
            $comprec = $comp->comp_operation_parameters($record['RTBL_COMP_CODE']);
            unset($comp);
            if (empty($record['RTBL_COMP_CODE'])) {
                $record['RTBL_TO_DATE'] = $comprec['OPERATION_DATE'];
                $record['RTBL_CURRENCY_CODE'] = $comprec['CURRENCY_CODE'];
                $record['RTBL_COMP_CODE'] = $comprec['IDCODE'];
                $record['RTBL_DATE_FORMAT'] = (empty($record['RTBL_DATE_FORMAT'])) ? $this->date_format : $record['RTBL_DATE_FORMAT'];
                $record['RTBL_SEND_PDF'] = CLX_INIT_ZERO;
            }
            $this->operation_date = $record['RTBL_TO_DATE'];
            $this->extended_report = (!empty($record['RTBL_EXTENDED']));
            $this->send_pdf = ($record['RTBL_SEND_PDF'] == CLX_NUM_ONE) ? true : false;
            $this->contract_code = (!empty($record['RTBL_CONTRACT_CODE'])) ? $record['RTBL_CONTRACT_CODE'] : '';
            $this->participant_id = (!empty($record['RTBL_PARTICIPANT_ID'])) ? $record['RTBL_PARTICIPANT_ID'] : '';
            //  -  - Case 1002306
            if (!class_exists('fidu_statement')) {
                includeCodeLib('FIRE');
            }
            $this->FIRE_lib = new fidu_statement();
            $this->FIRE_lib->send_pdf = $this->send_pdf;
            $this->FIRE_lib->page_footer_start($record['RTBL_COMP_CODE']);
        }

        // CARTERA DE INVERSION
        /**
         * Investment Report Prompt
         * @param void
         */
        function rep_inv_prompt() {
            //initialization
            $ac = UserRequest::$request['ac'];
            $to = UserRequest::$request[CLX_PROP_TO];
            $it = UserRequest::$request['it'];
            $this->init_prompt_record(UserRequest::$post);
            //RTBL_REPCINV
            $EDIT = &getTool('EDIT');
            $record = array();
            $msg = array();
            $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote('RTBL_REPCINV') . '');
            $record = UserRequest::$post;
            if (!empty($record['confirm'])) {
                $EDIT->checkForm2($msg, $formrec);
                if ($record['RTBL_TO_DATE'] > $this->operation_date) {
                    $msg['RTBL_TO_DATE'] = dict('GEN_LBL_LESSTHAN') . ' ' . $this->operation_date;
                }
            }
            $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', '', dict('GEN_LBL_DISPLAY'));
            $this->contents .= $form->source();
            if (!empty($record['confirm']) && empty($msg)) {
                $this->rep_inv($record['RTBL_TO_DATE'], $record['RTBL_DATE_FORMAT'], $record['RTBL_COMP_CODE'], $record['RTBL_INFU_CODE'], $record['RTBL_CONTRACT_CODE'], $record['RTBL_INVE_INSTRMT_CODE'], $record['RTBL_CURRENCY_CODE'], $this->send_pdf, $this->extended_report);
            }
        }

        /**
         * Investment reports - Cartera de inversiones
         *
         * @param unknown_type $efftdate
         * @param unknown_type $dt_format
         * @param unknown_type $comp_code
         * @param unknown_type $portfolio_code
         * @param unknown_type $contract_code
         * @param unknown_type $inve_instrmt_code
         * @param unknown_type $currency_code
         * @param unknown_type $send_pdf
         * @param unknown_type $extended
         */
        function rep_inv($efftdate, $dt_format, $comp_code, $portfolio_code, $contract_code, $inve_instrmt_code, $currency_code, $send_pdf, $extended = CLX_NUM_ZERO) {
            $this->send_pdf = $send_pdf;
            $this->portfolio_code = $portfolio_code;
            $this->currency_code = $currency_code;
            $this->contract_code = $contract_code;
            $this->inve_instrmt_code = $inve_instrmt_code;
            $this->operation_date = $efftdate;
            $month_start = adodb_date('Y-m-01', strtotime($this->operation_date));
            $this->dt_format = $dt_format;
            $this->send_pdf = $send_pdf;
            $this->extended_report = $extended;
            $batch_id = batch_id();
            //0. Limpiar todos los registro de participaciones con saldo en cero.
            $this->initTemporaryTables($batch_id);
            //2. Volcar montos de actividad por contrato y
            //participante multiplicado por participacion ITMP
            $this->build_investment_tmp($batch_id);
            //3. Construir reporte basado en data de ITMP
            //to clarify
            //INVEST AMT = INVEST_AMT - AMORTIZED AMOUNT
            //BOOK VALUE = INVEST_AMT
            $sql = 'SELECT ITMP.DEAL_TICKET_NO, ITMP.INVESTMENT_CODE, ITMP.FIELD_EXTRA00 PRODUCT_CODE, ITMP.FIELD_EXTRA01 SEC_ISSUER, SUM(ITMP.BOOK_VALUE_AMT) BOOK_VALUE, SUM(ITMP.INVEST_AMT) INVEST_AMT, SUM(ITMP.FACE_VALUE) FACE_VALUE, SUM(ITMP.INVEST_AMT)  INVEST_AMT, /*SUM(ITMP.INVEST_AMT - ITMP.AMORTIZED_AMT)  INVEST_AMT,*/ SUM(ITMP.ACCRUED_INT_AMT+ITMP.PAID_INT_AMT) INTEARNED_AMT, SUM(ITMP.PAID_INT_AMT) PAID_INT_AMT, ITMP.ISSUE_DATE ISSUE_DATE, ITMP.EFFTDATE, ITMP.MATURITY_DATE MATURITY_DATE, (ITMP.AMORTIZATION*ITMP.INV_PERIOD) INV_PERIOD, ITMP.COUPON_RT, ROUND(SUM(((ITMP.FACE_VALUE * ITMP.COUPON_RT/100)/ITMP.INTEREST_CALC)), 2) DAILY, ROUND(SUM(((ITMP.FACE_VALUE * ITMP.COUPON_RT/100)/ITMP.INTEREST_CALC)*ITMP.INV_PERIOD), 2) TOTAL_INT, ROUND(SUM(ITMP.AMORTIZATION*(ITMP.INVEST_AMT+((ITMP.FACE_VALUE * ITMP.COUPON_RT/100)/ITMP.INTEREST_CALC)*ITMP.INV_PERIOD)), 2) CAPINT, ROUND(SUM(ITMP.AMORTIZATION*(ITMP.AMORTIZED_AMT/nullIF(ITMP.LAST_OPER_DATE-ITMP.EFFTDATE, 0))), 2) DAYAMOTY, ROUND(SUM(ITMP.AMORTIZED_AMT), 2) AMORTIZED_AMT, ROUND(SUM(ITMP.SHARES), 2) SHARES FROM  ' . $this->itmpname . ' ITMP, ' . $this->infuname . ' INFU WHERE INFU.IDCODE = ITMP.PORTFOLIO_CODE ' . (($this->portfolio_code <> '') ? 'AND INFU.IDCODE = ' . singleQuote($this->portfolio_code) . ' ' : '') .
                    (($this->currency_code <> '') ? 'AND INFU.CURRENCY_CODE = ' . singleQuote($this->currency_code) . ' ' : '') .
                    (($comp_code <> '') ? 'AND INFU.COMP_CODE = ' . singleQuote($comp_code) . ' ' : '') .
                    (($this->contract_code <> '') ? 'AND ITMP.CONTRACT_CODE = ' . singleQuote($this->contract_code) . ' ' : '') .
                    (($this->participant_id <> '') ? 'AND ITMP.PARTICIPANT_ID = ' . singleQuote($this->participant_id) . ' ' : '') .
                    (($this->inve_instrmt_code <> '') ? 'AND ITMP.PRODUCT_CODE = ' . singleQuote($this->inve_instrmt_code) . ' ' : '') .
                    'AND ITMP.BATCH_ID = ' . singleQuote($batch_id) . ' GROUP BY ITMP.DEAL_TICKET_NO, ITMP.INVESTMENT_CODE, ITMP.PRODUCT_CODE, ITMP.FIELD_EXTRA01, ITMP.ISSUE_DATE, ITMP.LAST_OPER_DATE, ITMP.MATURITY_DATE, ITMP.INV_PERIOD, ITMP.COUPON_RT ORDER BY ITMP.INVESTMENT_CODE ';
            if ($this->extended_report) {
                $subtotals = array('DEAL_TICKET_NO' => '', 'IDCODE' => '', 'PRODUCT_CODE' => '', 'SEC_ISSUER' => '', 'BOOK_VALUE' => '', 'FACE_VALUE' => '', 'INVEST_AMT' => '', 'INTEARNED_AMT' => '', 'PAID_INT_AMT' => '', 'ISSUE_DATE' => '', 'EFFTDATE' => '', 'MATURITY_DATE' => '', 'INV_PERIOD' => '', 'COUPON_RT' => '', 'DAILY' => '', 'TOTAL_INT' => '', 'CAPINT' => '', 'DAYAMOTY' => '', 'AMORTIZED_AMT' => '');
                $grantotals = array('DEAL_TICKET_NO' => '', 'IDCODE' => '', 'PRODUCT_CODE' => '', 'SEC_ISSUER' => '', 'BOOK_VALUE' => '', 'FACE_VALUE' => '', 'INVEST_AMT' => '', 'INTEARNED_AMT' => '', 'PAID_INT_AMT' => '', 'ISSUE_DATE' => '', 'EFFTDATE' => '', 'MATURITY_DATE' => '', 'INV_PERIOD' => '', 'COUPON_RT' => '', 'DAILY' => '', 'TOTAL_INT' => '', 'CAPINT' => '', 'DAYAMOTY' => '', 'AMORTIZED_AMT' => '');
            } else {
                $subtotals = array('DEAL_TICKET_NO' => '', 'IDCODE' => '', 'PRODUCT_CODE' => '', 'SEC_ISSUER' => '', 'BOOK_VALUE' => '', 'FACE_VALUE' => '', 'INVEST_AMT' => '', 'INTEARNED_AMT' => '', 'PAID_INT_AMT' => '', 'ISSUE_DATE' => '', 'EFFTDATE' => '', 'MATURITY_DATE' => '', 'INV_PERIOD' => '', 'COUPON_RT' => '');
                $grantotals = array('DEAL_TICKET_NO' => '', 'IDCODE' => '', 'PRODUCT_CODE' => '', 'SEC_ISSUER' => '', 'BOOK_VALUE' => '', 'FACE_VALUE' => '', 'INVEST_AMT' => '', 'INTEARNED_AMT' => '', 'PAID_INT_AMT' => '', 'ISSUE_DATE' => '', 'EFFTDATE' => '', 'MATURITY_DATE' => '', 'INV_PERIOD' => '', 'COUPON_RT' => '');
            }
            $results = ClxCommon::$db->executeQuery($sql);
            $getTitles = true;
            $this->contents .='<table  border="0" cellpadding="1" cellspacing="1" bgcolor="#000000">';
            $getTitles = true;
            $data = array();
            $variants = array();
            $last_prod = '';
            while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                //Limitar tamano de cartera
                $result['PRODUCT_CODE'] = substr($result['PRODUCT_CODE'], CLX_NUM_ZERO, CLX_NUM_40);
                $result['SEC_ISSUER'] = substr($result['SEC_ISSUER'], CLX_NUM_ZERO, CLX_NUM_26);
                //Build Record
                $this->prepare_investments_record($result, $contract_code);
                if ($last_prod <> '' && $last_prod <> $result['PRODUCT_CODE']) {
                    //Adding Total Line
                    $subtotals['FACE_VALUE'] = xFormat::number($subtotals['FACE_VALUE'], CLX_NUM_TWO);
                    $subtotals['BOOK_VALUE'] = xFormat::number($subtotals['BOOK_VALUE'], CLX_NUM_TWO);
                    $subtotals['PAID_INT_AMT'] = xFormat::number($subtotals['PAID_INT_AMT'], CLX_NUM_TWO);
                    $subtotals['INTEARNED_AMT'] = xFormat::number($subtotals['INTEARNED_AMT'], CLX_NUM_TWO);
                    $subtotals['INVEST_AMT'] = xFormat::number($subtotals['INVEST_AMT'], CLX_NUM_TWO);
                    if ($this->extended_report) {
                        $subtotals['DAILY'] = xFormat::number($subtotals['DAILY'], CLX_NUM_TWO);
                        $subtotals['TOTAL_INT'] = xFormat::number($subtotals['TOTAL_INT'], CLX_NUM_TWO);
                        $subtotals['CAPINT'] = xFormat::number($subtotals['CAPINT'], CLX_NUM_TWO);
                        $subtotals['AMORTIZED_AMT'] = xFormat::number($subtotals['AMORTIZED_AMT'], CLX_NUM_TWO);
                        $subtotals['DAYAMOTY'] = xFormat::number($subtotals['DAYAMOTY'], CLX_NUM_TWO);
                    }
                    $data[] = $subtotals;
                    $variants[count($data) - CLX_NUM_ONE] = array('font_face' => 'b');
                    if ($this->extended_report) {
                        $subtotals = array('DEAL_TICKET_NO' => '', 'IDCODE' => '', 'PRODUCT_CODE' => '', 'SEC_ISSUER' => '', 'BOOK_VALUE' => '', 'FACE_VALUE' => '', 'INVEST_AMT' => '', 'INTEARNED_AMT' => '', 'PAID_INT_AMT' => '', 'ISSUE_DATE' => '', 'EFFTDATE' => '', 'MATURITY_DATE' => '', 'INV_PERIOD' => '', 'COUPON_RT' => '', 'DAILY' => '', 'TOTAL_INT' => '', 'CAPINT' => '', 'DAYAMOTY' => '', 'AMORTIZED_AMT' => '');
                    } else {
                        $subtotals = array('DEAL_TICKET_NO' => '', 'IDCODE' => '', 'PRODUCT_CODE' => '', 'SEC_ISSUER' => '', 'INVEST_AMT' => '', 'FACE_VALUE' => '', 'BOOK_VALUE' => '', 'INTEARNED_AMT' => '', 'PAID_INT_AMT' => '', 'ISSUE_DATE' => '', 'EFFTDATE' => '', 'MATURITY_DATE' => '', 'INV_PERIOD' => '', 'COUPON_RT' => '');
                    }
                    $data[] = $subtotals;
                    $variants[count($data) - CLX_NUM_ONE] = array('font_face' => 'b');
                    $last_prod = $result['PRODUCT_CODE'];
                }
                if ($last_prod === '' && $last_prod <> $result['PRODUCT_CODE']) {
                    $data[] = array('DEAL_TICKET_NO' => '', 'IDCODE' => '', 'PRODUCT_CODE' => $result['PRODUCT_CODE'], 'SEC_ISSUER' => '', 'INVEST_AMT' => '', 'FACE_VALUE' => '', 'BOOK_VALUE_AMT' => '', 'INTEARNED_AMT' => '', 'PAID_INT_AMT' => '', 'ISSUE_DATE' => '', 'EFFTDATE' => '', 'MATURITY_DATE' => '', 'INV_PERIOD' => '', 'COUPON_RT' => '');
                    $variants[count($data) - CLX_NUM_ONE] = array('font_face' => 'b');
                }
                //Subtotals
                $subtotals['PRODUCT_CODE'] = dict('GEN_LBL_TOTAL');
                $subtotals['INVEST_AMT'] = bcadd($subtotals['INVEST_AMT'], $result['INVEST_AMT']);
                $subtotals['FACE_VALUE'] = bcadd($subtotals['FACE_VALUE'], $result['FACE_VALUE']);
                $subtotals['BOOK_VALUE'] = bcadd($subtotals['BOOK_VALUE'], $result['BOOK_VALUE']);
                $subtotals['INTEARNED_AMT'] = bcadd($subtotals['INTEARNED_AMT'], $result['INTEARNED_AMT']);
                $subtotals['PAID_INT_AMT'] = bcadd($subtotals['PAID_INT_AMT'], $result['PAID_INT_AMT']);
                if ($this->extended_report) {
                    $subtotals['DAILY'] = bcadd($subtotals['DAILY'], $result['DAILY']);
                    $subtotals['TOTAL_INT'] = bcadd($subtotals['TOTAL_INT'], $result['TOTAL_INT']);
                    $subtotals['CAPINT'] = bcadd($subtotals['CAPINT'], $result['CAPINT']);
                    $subtotals['AMORTIZED_AMT'] = bcadd($subtotals['AMORTIZED_AMT'], $result['AMORTIZED_AMT']);
                    $subtotals['DAYAMOTY'] = bcadd($subtotals['DAYAMOTY'], $result['DAYAMOTY']);
                }

                $last_prod = $result['PRODUCT_CODE'];
                //Gran total
                $grantotals['PRODUCT_CODE'] = dict('GEN_LBL_TOTAL');
                $grantotals['INVEST_AMT'] = bcadd($grantotals['INVEST_AMT'], $result['INVEST_AMT']);
                $grantotals['FACE_VALUE'] = bcadd($grantotals['FACE_VALUE'], $result['FACE_VALUE']);
                $grantotals['BOOK_VALUE'] = bcadd($grantotals['BOOK_VALUE'], $result['BOOK_VALUE']);
                $grantotals['INTEARNED_AMT'] = bcadd($grantotals['INTEARNED_AMT'], $result['INTEARNED_AMT']);
                $grantotals['PAID_INT_AMT'] = bcadd($grantotals['PAID_INT_AMT'], $result['PAID_INT_AMT']);
                if ($this->extended_report) {
                    $grantotals['DAILY'] = bcadd($grantotals['DAILY'], $result['DAILY']);
                    $grantotals['TOTAL_INT'] = bcadd($grantotals['TOTAL_INT'], $result['TOTAL_INT']);
                    $grantotals['CAPINT'] = bcadd($grantotals['CAPINT'], $result['CAPINT']);
                    $grantotals['AMORTIZED_AMT'] = bcadd($grantotals['AMORTIZED_AMT'], $result['AMORTIZED_AMT']);
                    $grantotals['DAYAMOTY'] = bcadd($grantotals['DAYAMOTY'], $result['DAYAMOTY']);
                }
                $this->clean_investments_record($result);
                if (empty($this->send_pdf) && $getTitles) {
                    $this->contents .= '<tr bgcolor="#FFFFFF"><td class=headers><b>' . implode('</b></td><td class=headers><b>', $this->prepare_investments_record_fields($result)) . '</b></td></tr>';
                    $getTitles = false;
                }
                if ($this->send_pdf === true) {
                    $data[] = $result;
                }
                if (empty($this->send_pdf))
                    $this->contents .= '<tr bgcolor="#FFFFFF"><td>' . implode('</td><td>', $result) . '</td></tr>';
            }
			ClxCommon::$db->freeResult($results);
            if (empty($this->send_pdf))
                $this->contents .='<table><br>';
            //Build PDF FILE
            if ($this->send_pdf === true) {
                //Taza promedio = Intereses mes * 360/ Monto invertido . Plazo(nro dias del primero a a la fecha)
                $day_diff = day_diff($this->operation_date, $month_start);
                if ($day_diff == CLX_NUM_ZERO || $grantotals['INVEST_AMT'] == CLX_NUM_ZERO) {
                    $average_rt = CLX_INIT_ZERO;
                } else {
                    $average_rt = bcmul(bcdiv(bcmul($grantotals['INTEARNED_AMT'], '360'), bcmul($grantotals['INVEST_AMT'], $day_diff)), CLX_NUM_HUNDRED);
                }

                //Adding Total Line
                $subtotals['PAID_INT_AMT'] = xFormat::number($subtotals['PAID_INT_AMT'], CLX_NUM_TWO);
                $subtotals['INTEARNED_AMT'] = xFormat::number($subtotals['INTEARNED_AMT'], CLX_NUM_TWO);
                $subtotals['INVEST_AMT'] = xFormat::number($subtotals['INVEST_AMT'], CLX_NUM_TWO);
                $subtotals['FACE_VALUE'] = xFormat::number($subtotals['FACE_VALUE'], CLX_NUM_TWO);
                $subtotals['BOOK_VALUE'] = xFormat::number($subtotals['BOOK_VALUE'], CLX_NUM_TWO);
                if ($this->extended_report) {
                    $subtotals['DAILY'] = xFormat::number($subtotals['DAILY'], CLX_NUM_TWO);
                    $subtotals['TOTAL_INT'] = xFormat::number($subtotals['TOTAL_INT'], CLX_NUM_TWO);
                    $subtotals['CAPINT'] = xFormat::number($subtotals['CAPINT'], CLX_NUM_TWO);
                    $subtotals['AMORTIZED_AMT'] = xFormat::number($subtotals['AMORTIZED_AMT'], CLX_NUM_TWO);
                    $subtotals['DAYAMOTY'] = xFormat::number($subtotals['DAYAMOTY'], CLX_NUM_TWO);
                }
                $data[] = $subtotals;
                $variants[count($data) - CLX_NUM_ONE] = array('font_face' => 'b');
                $data[] = array();
                $grantotals['PAID_INT_AMT'] = xFormat::number($grantotals['PAID_INT_AMT'], CLX_NUM_TWO);
                $grantotals['INTEARNED_AMT'] = xFormat::number($grantotals['INTEARNED_AMT'], CLX_NUM_TWO);
                $grantotals['INVEST_AMT'] = xFormat::number($grantotals['INVEST_AMT'], CLX_NUM_TWO);
                $grantotals['FACE_VALUE'] = xFormat::number($grantotals['FACE_VALUE'], CLX_NUM_TWO);
                $grantotals['BOOK_VALUE'] = xFormat::number($grantotals['BOOK_VALUE'], CLX_NUM_TWO);
                if ($this->extended_report) {
                    $grantotals['DAILY'] = xFormat::number($grantotals['DAILY'], CLX_NUM_TWO);
                    $grantotals['TOTAL_INT'] = xFormat::number($grantotals['TOTAL_INT'], CLX_NUM_TWO);
                    $grantotals['CAPINT'] = xFormat::number($grantotals['CAPINT'], CLX_NUM_TWO);
                    $grantotals['AMORTIZED_AMT'] = xFormat::number($grantotals['AMORTIZED_AMT'], CLX_NUM_TWO);
                    $grantotals['DAYAMOTY'] = xFormat::number($grantotals['DAYAMOTY'], CLX_NUM_TWO);
                }
                $data[] = $grantotals;
                $variants[count($data) - CLX_NUM_ONE] = array('font_face' => 'b');
                $title = dict('GEN_LBL_CARTERAINVERSION');
                if (!empty($portfolio_code)) {
                    $title .= $this->new_line . dict('GEN_LBL_PORTFOLIOCODE') . ': ' . $portfolio_code;
                } elseif (!empty($contract_code)) {
                    $ficorec = ClxCommon::$db->getFields($this->ficoname, 'IDNAME,IDCODE', 'IDCODE = ' . singleQuote($contract_code));
                    $title .= $this->new_line . dict('GEN_LBL_TRUSTNAME') . ': ' . $ficorec['IDNAME'] . 'n ' . dict('GEN_LBL_TRUSTNUMBER') . ': ' . $ficorec['IDCODE'];
                }
                $title .= $this->new_line . dict('GEN_LBL_ASOF') . ' ' . xFormat::date($this->operation_date, $this->dt_format);
                $DBLT = &getTool('DBLT');
                $title .= $this->new_line . dict('GEN_LBL_CURRENCY') . ' ' . $DBLT->getListItem('curr', $currency_code);
                unset($subtotals, $grantotals);
                $comprec = ClxCommon::$db->getRecord($this->compname, 'IDCODE = ' . singleQuote($comp_code));
                //Company Record
                $FILE = getToolObject('DBFT', 'FILE');
                $complogo = $FILE->fileName($comprec['COMP_LOGO']);
                if (!file_exists($complogo))
                    $complogo = '';
                //Output Report
                $RPPD = getToolObject('RPFT', 'RPPD');
                if ($this->extended_report) {
                    $RPPD->__construct('L', 'mm', array(CLX_NUM_400, CLX_NUM_590));
                    $RPPD->setpaper('custom');
                } else {
                    $RPPD->__construct('L', 'mm', array(CLX_NUM_216, CLX_NUM_410));
                    $RPPD->setpaper('custom');
                }
                $RPPD->SetAuthor($comprec['IDNAME']);
                $RPPD->Open();
                $RPPD->SetLeftMargin(CLX_NUM_THREE);
                $RPPD->setHeaderAdd('logo_x', CLX_NUM_TEN);
                $RPPD->setHeaderAdd('logo_y', CLX_NUM_ZERO);
                $RPPD->setHeaderAdd('logo_width', CLX_NUM_36_PT_5);
                $RPPD->setHeaderAdd('logo_height', CLX_NUM_24_PT_6);
                $RPPD->setHeaderAdd('logo_img', $complogo);
                $RPPD->setHeaderAdd(CLX_CLASS_TITLE, uppercase($title));
                $RPPD->setHeaderAdd('logo_text1', strip_tags(str_replace('<br>', $this->new_line, $comprec['REP_GERENCIA'])));
                $RPPD->setHeaderAdd('page_extra', dict('GEN_LBL_AVERAGE_RT_MNTH') . ':     ' . xFormat::number($average_rt, CLX_NUM_TWO));
                $RPPD->setHeaderAdd('logo_text1', strip_tags($comprec['REP_GERENCIA']));
                $RPPD->setHeaderAdd('height', CLX_NUM_FIVE);
                $RPPD->setHeaderAdd('border', CLX_NUM_ZERO);
                $RPPD->setHeaderAdd('pagination', false);
                $RPPD->setHeaderAdd('date', true);
                $header = array(array(dict('RINV_LBL_DEAL_TICKET_NO'), '20', 'L'), array(dict('RINV_LBL_IDCODE'), '20', 'L'),
                    array(dict('RINV_LBL_PRODUCT_CODE'), '70', 'L'), array(dict('RINV_LBL_SEC_ISSUER'), '40', 'L'), array(dict('RINV_LBL_BOOK_VALUE'), '35', 'R'), array(dict('RINV_LBL_FACE_VALUE'), '35', 'R'), array(dict('RINV_LBL_INVEST_AMT'), '35', 'R'), array(dict('RINV_LBL_INTEARNED_AMT'), '30', 'R'), array(dict('RINV_LBL_PAID_INT_AMT'), '30', 'R'), array(dict('RINV_LBL_ISSUE_DATE'), '20', 'C'), array(dict('RINV_LBL_ADQ_DATE'), '20', 'C'), array(dict('RINV_LBL_MATURITY_DATE'), '20', 'C'), array(dict('RINV_LBL_INV_PERIOD'), '12', 'R'), array(dict('RINV_LBL_COUPON_RT'), '10', 'R'));
                if ($this->extended_report) {
                    $header = array_merge($header, array(array(dict('RINV_LBL_DAILY'), '30', 'R'), array(dict('RINV_LBL_TOTAL_INT'), '30', 'R'), array(dict('RINV_LBL_CAPINT'), '30', 'R'), array(dict('RINV_LBL_DAYAMOTY'), '30', 'R'), array(dict('RINV_LBL_AMORTIZED_AMT'), '30', 'R')));
                }
                $RPPD->setHeaderAdd('table_headers', $header);
                $RPPD->setFooter('enabled', true);
                $this->FIRE_lib->page_footer_put_pdf_lines($RPPD, $comprec['VE_TXTINFO']);
                $RPPD->setFooter('page_location', 'R');
                $RPPD->AddPage();
                $RPPD->SetFont('Arial', 'B', CLX_NUM_TEN);
                $RPPD->SetFont('Arial', 'B', CLX_NUM_SIX);
                $RPPD->buildTableData($data, $variants);
                $RPPD->Close();
                $flname = 'temp/rep_inv' . str_replace('.', '', microtime(true)) . '.pdf';
                $RPPD->Output($flname, 'F');
                $this->contents .= note('<a href="./' . $flname . '" target="_blank">' . dict('GEN_LBL_DOWNLOAD_THE_FILE') . '</a><br>');
            }
            $this->end_participation_tmp($batch_id);
        }

//End funcion
        function prepare_investments_record(&$record, $contract_code) {

        }

        function prepare_investments_record_fields(&$record) {
            $titles = array();
            foreach ($record as $key => $val) {
                $lbl = dict('RINV_LBL_' . uppercase($key));
                $titles[] = $lbl;
                $this->headers[] = array($lbl, '30', 'R');
            }
            return $titles;
        }

        private function clean_investments_record(&$record) {
            $record['MATURITY_DATE'] = xFormat::date($record['MATURITY_DATE'], $this->dt_format);
            $record['EFFTDATE'] = xFormat::date($record['EFFTDATE'], $this->dt_format);
            $record['ISSUE_DATE'] = xFormat::date($record['ISSUE_DATE'], $this->dt_format);
            $record['BOOK_VALUE'] = xFormat::number($record['BOOK_VALUE']);
            $record['FACE_VALUE'] = xFormat::number($record['FACE_VALUE']);
            $record['DAILY'] = xFormat::number($record['DAILY']);
            $record['AMORTIZED_AMT'] = xFormat::number($record['AMORTIZED_AMT']);
            $record['TOTAL_INT'] = xFormat::number($record['TOTAL_INT']);
            $record['INTEARNED_AMT'] = xFormat::number($record['INTEARNED_AMT']);
            $record['PAID_INT_AMT'] = xFormat::number($record['PAID_INT_AMT']);
            $record['INVEST_AMT'] = xFormat::number($record['INVEST_AMT']);
            $record['CAPINT'] = xFormat::number($record['CAPINT']);
            $record['DAYAMOTY'] = xFormat::number($record['DAYAMOTY'], CLX_NUM_TWO);
            //$record['SHARES'] = xFormat::number($record['SHARES'],0);
            $record['COUPON_RT'] = xFormat::number($record['COUPON_RT'], CLX_NUM_TWO);
            //Not requires
            unset($record['REC_STATUS'], $record['BATCH_ID'], $record['DISCRETIONARY_PORT'], $record['CAPINT_FACTOR'], $record['INTEREST_CALC'], $record['PORTFOLIO_CODE'], $record['CURRENCY_CODE'], $record['CONTRACT_BALANCE'], $record['TOTAL_BALANCE'], $record['SHARES'], $record['ISSUE_TO_TODAY'], $record['MONTH_TO_TODAY'], $record['AR_CONTRACT_BALANCE'], $record['AR_TOTAL_BALANCE'], $record['ARPAID_CONTRACT_BALANCE'], $record['ARPAID_TOTAL_BALANCE'], $record['INVESTPROD_CODE']);
            //Temp clear for new report
            if (empty($this->extended_report)) {
                unset($record['DAYAMOTY'], $record['DAILY'], $record['TOTAL_INT'], $record['CAPINT'], $record['AMORTIZED_AMT_MONTH'], $record['AMORTIZED_AMT']);
            }
        }

// BUILD PARTICIPATIONS
        /**
         * Initialice all temporary tables
         *
         * @param unknown_type $batch_id
         */
        private function initTemporaryTables($batch_id) {
            //Load temporary table - Req on mysql
            $DBTB = getTool('DBTB');
            $DBTB->buildTemporaryTable('ITMP');
            $DBTB->buildTemporaryTable('PTMP');
            $DBTB->buildTemporaryTable('ETMP');
            //Clear tmp
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->itmpname . ' WHERE BATCH_ID = ' . singleQuote($batch_id));
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ptmpname . ' WHERE BATCH_ID = ' . singleQuote($batch_id));
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->etmpname . ' WHERE BATCH_ID = ' . singleQuote($batch_id));
        }

        private function end_participation_tmp($batch_id) {
            $sql = 'UPDATE ' . $this->ptmpname . '  SET REC_STATUS = ' . "'END'" . ' WHERE BATCH_ID = ' . singleQuote($batch_id);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->itmpname . '  SET REC_STATUS = ' . "'END'" . ' WHERE BATCH_ID = ' . singleQuote($batch_id);
            ClxCommon::$db->executeQuery($sql);
        }

        // ACTIVITY DISTRIBUTIONS
        /**
         * Build report table
         */
        function build_investment_tmp($batch_id) {
            $sql = 'INSERT INTO ' . $this->itmpname . '  (EFFTDATE, DEAL_TICKET_NO, INVESTMENT_CODE, PRODUCT_CODE, PORTFOLIO_CODE, CONTRACT_CODE, PARTICIPANT_ID, BOOK_VALUE_AMT, INVEST_AMT, FACE_VALUE, SHARES, AMORTIZED_AMT, PAID_INT_AMT, ACCRUED_INT_AMT, GAIN_AMT, TAX_AMT, FEES_AMT, LAST_OPER_DATE, INV_PERIOD, COUPON_RT, INTEREST_CALC, SEC_ISSUER, ISSUE_DATE, MATURITY_DATE, FIELD_EXTRA00, FIELD_EXTRA01, AMORTIZATION, BATCH_ID, REC_STATUS) SELECT INFA.ACQUISITION_DATE EFFTDATE, INFA.POSITION_NUMBER DEAL_TICKET_NO, INFA.INVESTMENT_CODE, INPR.PRODUCT_CODE, INFA.PORTFOLIO_CODE, ' . singleQuote($this->contract_code) . ' CONTRACT_CODE, ' . singleQuote($this->participant_id) . ' PARTICIPANT_ID, INFA.BOOK_VALUE_AMT, INFA.INVEST_AMT, INFA.FACE_VALUE, INFA.SHARES, INFA.AMORTIZED_AMT, INFA.PAID_INT_AMT, INFA.ACCRUED_INT_AMT, INFA.GAIN_AMT, INFA.TAX_AMT, INFA.FEES_AMT, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' LAST_OPER_DATE, 0 INV_PERIOD, INPR.COUPON_RT, INPR.INTEREST_CALC, INPR.SEC_ISSUER, INPR.ISSUE_DATE, INPR.MATURITY_DATE, CONCAT(PROD.IDNAME,CONCAT(' . singleQuote(' ') . ' ,PROD.IDCODE)) FIELD_EXTRA00, null FIELD_EXTRA01, (case INFA.INVEST_CLASS WHEN ' . singleQuote('HM') . ' THEN 1 ELSE 0 END) AMORTIZATION, ' . singleQuote($batch_id) . ' BATCH_ID, ' . singleQuote('RUN') . ' REC_STATUS FROM ' . $this->infuname . ' INFU, ' . $this->infaname . ' INFA, ' . $this->inprname . ' INPR, ' . $this->prodname . ' PROD WHERE INFU.IDCODE = INFA.PORTFOLIO_CODE AND PROD.IDCODE = INPR.PRODUCT_CODE AND INPR.INVESTMENT_CODE = INFA.INVESTMENT_CODE AND INPR.CLX_EFFTDATE = (SELECT MAX(INPRX.CLX_EFFTDATE) FROM ' . $this->inprname . ' INPRX WHERE INPRX.INVESTMENT_CODE = INPR.INVESTMENT_CODE AND INPRX.CLX_EFFTDATE <= ' . singleQuote($this->operation_date) . ' ) ' . (($this->portfolio_code <> '') ? 'AND INFU.IDCODE = ' . singleQuote($this->portfolio_code) . ' ' : '') .
                    (($this->currency_code <> '') ? 'AND INFA.CURRENCY_CODE = ' . singleQuote($this->currency_code) . ' ' : '') .
                    (($this->contract_code <> '') ? 'AND INFA.CONTRACT_CODE = ' . singleQuote($this->contract_code) . ' ' : '') .
                    (($this->participant_id <> '') ? 'AND INFA.PARTICIPANT_ID = ' . singleQuote($this->participant_id) . ' ' : '') .
                    (($this->inve_instrmt_code <> '') ? 'AND INPR.PRODUCT_CODE = ' . singleQuote($this->inve_instrmt_code) . ' ' : '');
            $sql .=' ORDER BY INFA.INVESTMENT_CODE ASC';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->itmpname . '  SET INV_PERIOD = DATEDIFF(MATURITY_DATE, EFFTDATE) WHERE BATCH_ID = ' . singleQuote($batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Updating issuers
            $sql = 'UPDATE ' . $this->itmpname . '  ITMP  SET ITMP.FIELD_EXTRA01 = (SELECT MAX(INSI.IDNAME)  FROM ' . $this->insiname . ' INSI  WHERE ITMP.SEC_ISSUER = INSI.IDCODE)  WHERE ITMP.BATCH_ID = ' . singleQuote($batch_id);
            ClxCommon::$db->executeQuery($sql);
        }

        // INVESTMENT EARNING REPORT - RENDIMIENTO DE PORTAFOLIOS
        /**
         * used to display portfolio earnings report
         */
        function rep_inv_earnings_prompt() {
            $show_detail = true;
            $formcode = 'RTBL_INVEAR';
            $title = dict('FIDU_CODE_INFU_EARNINGS');
            $ac = UserRequest::$request['ac'];
            $to = UserRequest::$request[CLX_PROP_TO];
            $this->date_format = (!empty(UserRequest::$post['RTBL_DATE_FORMAT'])) ? UserRequest::$post['RTBL_DATE_FORMAT'] : '';

            $this->edate = (!empty(UserRequest::$post['RTBL_TO_DATE'])) ? UserRequest::$post['RTBL_TO_DATE'] : '';
            $show_detail = (!empty(UserRequest::$post['RTBL_SHOW_DETAILS'])) ? true : false;
            $it = (!empty(UserRequest::$request['it'])) ? UserRequest::$request['it'] : '';
            //RTBL_REPCINV
            $EDIT = &getTool('EDIT');
            $record = array();
            $msg = array();
            $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote($formcode));
            $record = UserRequest::$post;
            if (!empty($record['confirm'])) {
                getLookupValue('RTBL_INFU_CODE', 'INFU_CODE', $record);
                getLookupValue('RTBL_INVESTMENT_CODE', 'INVESTMENT_CODE', $record);
                $EDIT->checkForm2($msg, $formrec);
                if (count(explode('-', UserRequest::$request['RTBL_TO_DATE'])) <> CLX_NUM_THREE)
                    $msg['RTBL_TO_DATE'] = dict('GEN_ERR_CANTPARSE');
                if ($this->sdate > $this->edate) {
                    /*
                     * GEN_ERR_STARTGREATERENDDATE
                     * Start date cannot be greater than end date.
                     * Fecha inicial no puede ser mayor que fecha final.
                     */
                    $msg['RTBL_TO_DATE'] = dict('GEN_ERR_STARTGREATERENDDATE');
                }
            }
            $EDIT = &getTool('EDIT');
            $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', $title);
            if (!empty($record['confirm']) && empty($msg)) {
                //Para ver batch
                $portfolio_code = UserRequest::$post['RTBL_INFU_CODE'];
                $investment_code = UserRequest::$post['RTBL_INVESTMENT_CODE'];
                $edate = UserRequest::$post['RTBL_TO_DATE'];
                //calculando rendimientos
                $earnings = $this->rep_inv_earnings($portfolio_code, $investment_code);
                //-178 [RENDIMIENTO] => -186145 )
                $table = new htmlTable(CLX_WIDTH_TWO);
                $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
                $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_NUM_TWO));
                $portfolio_name = ClxCommon::$db->getField('INVE_PORTFOLIOS', 'IDNAME', 'IDCODE = ' . singleQuote($portfolio_code));
                $tableFrame = new htmlTable(CLX_WIDTH_ONE);
                $tableFrame->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT, CLX_PROP_CLASS => CLX_CLASS_FORM));
                $table = new htmlTable(CLX_WIDTH_TWO);
                $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
                $table->addcell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
                $tableFrame->addcell($table->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                //Account Information
                $table = new htmlTable(CLX_WIDTH_TWO);
                $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
                $table->addCell(dict('GEN_LBL_PORTFOLIO_CODE'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
                $table->addCell($portfolio_code . ', ' . $portfolio_name, array(CLX_PROP_CLASS, CLX_CLASS_DATA));
                if (!empty($investment_code)) {
                    $table->addcells(CLX_CLASS_PROMPT, array(capitalize(dict('GEN_LBL_INVESTMENT_CODE'))));
                    $table->addcells(CLX_CLASS_DATA, array($investment_code));
                }
                $table->addcells(CLX_CLASS_PROMPT, array(dict('GEN_LBL_UNTIL')));
                $table->addcells(CLX_CLASS_DATA, array(xFormat::date($edate, $this->date_format)));
                $table->addcells(CLX_CLASS_PROMPT, array(dict('GEN_LBL_NUMERAL')));
                $table->addcells(CLX_CLASS_DATA, array(xFormat::number($earnings['NUMERAL'], CLX_NUM_FIVE)));
                $table->addcells(CLX_CLASS_PROMPT, array(dict('GEN_LBL_EARNING')));
                $table->addcells(CLX_CLASS_DATA, array(xFormat::number($earnings['DEVENGADO'], CLX_NUM_FIVE)));
                $table->addcells(CLX_CLASS_PROMPT, array(dict('GEN_LBL_NET_EARNING')));
                $table->addcells(CLX_CLASS_DATA, array(xFormat::number($earnings['RENDIMIENTO'], CLX_NUM_FIVE) . ' %'));
                if ($show_detail === true) {
                    $table->addcell(dict('GEN_LBL_DETAIL'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_NUM_TWO));
                    $sql = 'SELECT *  FROM ' . $this->etmpname . '   WHERE BATCH_ID = ' . singleQuote($this->batch_id) . '  ORDER BY INVESTMENT_CODE, EFFTDATE ASC';
                    $rs = ClxCommon::$db->executeQuery($sql);
                    $tabledet = new htmlTable(CLX_WIDTH_NINE);
                    $tabledet->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
                    $tabledet->addcells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_PORTFOLIO_CODE'), dict('GEN_LBL_INVESTMENT_CODE'), dict('GEN_LBL_START_DATE'), dict('GEN_LBL_END_DATE'), dict('GEN_LBL_PERIOD'), dict('GEN_LBL_INIT_BAL_AMT'), dict('GEN_LBL_INVEST_AMT'), dict('GEN_LBL_INTEARNED_AMT'), dict('GEN_LBL_NUMERAL')));
                    while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                        $tabledet->addcells(CLX_CLASS_DATA, array($r['PORTFOLIO_CODE'], $r['INVESTMENT_CODE'], xFormat::date($r['EFFTDATE'], $this->date_format), xFormat::date($r['NEXT_DATE'], $this->date_format), xFormat::number($r['GEN_PERIOD'], CLX_NUM_ZERO), xFormat::number($r['INIT_BAL_AMT'], CLX_NUM_TWO), xFormat::number($r['INVEST_AMT'], CLX_NUM_TWO), xFormat::number($r['ACCRUED_INT_AMT'], CLX_NUM_TWO), xFormat::number($r['CALC_AMT_01'])
                        ));
                    }
					ClxCommon::$db->freeResult($rs);
                    $table->addcell($tabledet->source(), array(CLX_PROP_COLSPAN => CLX_NUM_TWO));
                    unset($tabledet);
                }//show_detail
                $tableFrame->addCell($table->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
                $this->contents .= $tableFrame->source();
            } else {
                $this->contents = $form->source();
            }
        }

        /**
         * Calcula rendimiento de portafolio
         *
         * @param string $portfolio_code
         * @param string $investment_code=
         * @return array
         */
        private function rep_inv_earnings($portfolio_code, $investment_code = '') {
            $this->initTemporaryTables($this->batch_id);
            if ($investment_code <> '') {
                $cc = ' AND INFA.INVESTMENT_CODE = ' . singleQuote($investment_code) . ' ';
            } else {
                $cc = '';
            }
            /* GENERANDO MONTOS DE ACTIVIDAD POR DIA */
            $sql = 'INSERT INTO ' . $this->etmpname . ' (ID, BATCH_ID, PORTFOLIO_CODE, INVESTMENT_CODE, EFFTDATE, NEXT_DATE, INIT_BAL_AMT, INVEST_AMT, ACCRUED_INT_AMT, PAID_INT_AMT, CALC_AMT_01, FIELD_EXTRA01) SELECT MAX(INFA.ID) ID, ' . singleQuote($this->batch_id) . ' BATCH_ID, INFA.PORTFOLIO_CODE, INFA.INVESTMENT_CODE, INFA.ACQUISITION_DATE EFFTDATE, GLCP.OPERATION_DATE NEXT_DATE, 0 INIT_BAL_AMT, SUM(INFA.INVEST_AMT) INVEST_AMT, SUM(INFA.ACCRUED_INT_AMT-INFA.PAID_INT_AMT) ACCRUED_INT_AMT, SUM(INFA.PAID_INT_AMT) PAID_INT_AMT, 0 CALC_AMT_01, 0 FIELD_EXTRA01 FROM ' . $this->infuname . ' INFU, ' . $this->infaname . ' INFA, ' . $this->glcpname . ' GLCP WHERE INFA.PORTFOLIO_CODE = ' . singleQuote($portfolio_code) . ' AND INFU.IDCODE = INFA.PORTFOLIO_CODE AND GLCP.COMP_CODE = INFU.COMP_CODE AND INFA.ACQUISITION_DATE <= ' . singleQuote($this->edate) . ' ' .
                    $cc . '  GROUP BY INFA.PORTFOLIO_CODE, INFA.INVESTMENT_CODE, INFA.ACQUISITION_DATE, GLCP.OPERATION_DATE';
            ClxCommon::$db->executeQuery($sql);
            /* ACTUALIZANDO PLAZO */
            $sql = 'UPDATE ' . $this->etmpname . '  SET GEN_PERIOD = NEXT_DATE-EFFTDATE WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            /* ACTUALIZANDO NUMERAL */
            $sql = 'UPDATE ' . $this->etmpname . '  SET CALC_AMT_01 = INVEST_AMT * GEN_PERIOD WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            $return = array('NUMERAL' => '0', 'DEVENGADO' => '0', 'RENDIMIENTO' => '0');
            $sql = 'SELECT SUM(CALC_AMT_01) NUMERAL FROM ' . $this->etmpname . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            $tmp = ClxCommon::$db->getOne($sql);
            if (!empty($tmp)) {
                $return['NUMERAL'] = $tmp;
            }
            $sql = 'SELECT SUM(ACCRUED_INT_AMT) DEVENGADO FROM ' . $this->etmpname . ' WHERE  BATCH_ID = ' . singleQuote($this->batch_id);
            $tmp = ClxCommon::$db->getOne($sql);
            if (!empty($tmp)) {
                $return['DEVENGADO'] = $tmp;
            }
            if (empty($return['NUMERAL'])) {
                $return['RENDIMIENTO'] = CLX_NUM_0_PT_00;
            } else {
                $return['RENDIMIENTO'] = round((($return['DEVENGADO'] * CLX_360_DAYS) / $return['NUMERAL']) * CLX_NUM_HUNDRED, CLX_NUM_TWO);
            }
            return $return;
        }

        // AMORTIZATION REPORT
        /**
         * Amortization re
         *
         */
        function rep_amortization() {
            $formcode = 'RTBL_INVGEN';
            $title = dict('GEN_LBL_AMORTIZATION_REP');
            $ac = UserRequest::$request['ac'];
            $to = UserRequest::$request[CLX_PROP_TO];
            $this->date_format = (!empty(UserRequest::$post['RTBL_DATE_FORMAT'])) ? UserRequest::$post['RTBL_DATE_FORMAT'] : '';
            $this->sdate = (!empty(UserRequest::$post['RTBL_FROM_DATE'])) ? UserRequest::$post['RTBL_FROM_DATE'] : '';
            $this->edate = (!empty(UserRequest::$post['RTBL_TO_DATE'])) ? UserRequest::$post['RTBL_TO_DATE'] : '';
            $it = (!empty(UserRequest::$request['it'])) ? UserRequest::$request['it'] : '';
            //RTBL_REPCINV
            $EDIT = &getTool('EDIT');
            $record = array();
            $msg = array();
            $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote($formcode));
            $record = UserRequest::$post;
            if (!empty($record['confirm'])) {
                getLookupValue('RTBL_INFU_CODE', 'INFU_CODE', $record);
                getLookupValue('RTBL_INVESTMENT_CODE', 'INVESTMENT_CODE', $record);
                $EDIT->checkForm2($msg, $formrec);
                if (count(explode('-', UserRequest::$request['RTBL_TO_DATE'])) <> CLX_NUM_THREE)
                    $msg['RTBL_TO_DATE'] = dict('GEN_ERR_CANTPARSE');
                if ($this->sdate > $this->edate) {
                    $msg['RTBL_TO_DATE'] = dict('GEN_ERR_STARTGREATERENDDATE');
                }
            }
            $EDIT = &getTool('EDIT');
            $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', $title);
            $this->contents = $form->source();
            if (!empty($record['confirm']) && empty($msg)) {
                $portfolio_code = UserRequest::$post['RTBL_INFU_CODE'];
                $investment_code = UserRequest::$post['RTBL_INVESTMENT_CODE'];
                $operation_date = UserRequest::$post['RTBL_TO_DATE'];
                $portfolio_name = ClxCommon::$db->getField($this->infuname, 'IDNAME', 'IDCODE = ' . singleQuote($portfolio_code));
                $tableWitdh = CLX_NUM_NINE;
                $table = new htmlTable($tableWitdh);
                $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST));
                $table->addCell(dict('GEN_LBL_AMORTIZATION_REP'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tableWitdh));
                $table->addCell(dict('GEN_LBL_PORTFOLIO_CODE') . ': ' . $portfolio_code . ', ' . $portfolio_name, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $tableWitdh));
                $table->addCell(dict('GEN_LBL_OPERATION_DATE') . ': ' . $operation_date, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $tableWitdh));
                $sql = 'SELECT INFA.POSITION_NUMBER, INFA.INVESTMENT_CODE, ' . singleQuote($operation_date) . '  EFFTDATE, INPR.MATURITY_DATE, INFA.INVEST_AMT, INFA.FACE_VALUE, INFA.PREMIUM_DISC_AMT, DATEDIFF(' . singleQuote($operation_date) . ', INFA.ACQUISITION_DATE) PERIOD, IFNULL((SELECT SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT) FROM GL_JOURNAL_DET_VW GDVW, GL_PROD_PRMTR_TBL PRAT, FIDU_ITEMS FIAS WHERE GDVW.ITEM_REF_NO = INFA.POSITION_NUMBER AND PRAT.PRODUCT_CODE = INPR.PRODUCT_CODE AND FIAS.IDCODE = GDVW.CHART_FIELD03 AND FIAS.PORTFOLIO_CODE = INFA.PORTFOLIO_CODE AND GDVW.JE_SOURCE = ' . singleQuote('INAP') . '  AND GDVW.EFFTDATE<=' . singleQuote($operation_date) . ' AND GDVW.GLACCOUNTCODE IN (PRAT.PREMIUM_GL_CODE, PRAT.DISCOUNT_GL_CODE)),0) AMORTIZED_AMT FROM INVE_PRODUCTS_TBL INPR, INVE_INVESTMENTS INFA WHERE INFA.PORTFOLIO_CODE = ' . singleQuote($portfolio_code) . ' AND INPR.INVESTMENT_CODE = INFA.INVESTMENT_CODE AND INFA.INVEST_AMT<>INFA.FACE_VALUE AND INFA.FACE_VALUE <> 0 AND INFA.ACQUISITION_DATE <= ' . singleQuote($operation_date) . ' AND INPR.CLX_EFFTDATE= (SELECT MAX(INPRX.CLX_EFFTDATE) FROM ' . $this->inprname . ' INPRX WHERE INPRX.INVESTMENT_CODE = INPR.INVESTMENT_CODE AND INPRX.CLX_EFFTDATE <= ' . singleQuote($operation_date) . ') ' . ((!empty($investment_code)) ? ' AND INFA.INVESTMENT_CODE = ' . singleQuote($investment_code) : '') . ' ORDER BY INPR.INVESTMENT_CODE ASC';
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $table->addCell($r['POSITION_NUMBER'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addCell($r['INVESTMENT_CODE'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addCell($r['EFFTDATE'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addCell($r['MATURITY_DATE'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addCell(clx_format_currency($r['INVEST_AMT']), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                    $table->addCell(clx_format_currency($r['FACE_VALUE']), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                    $table->addCell(clx_format_currency($r['PREMIUM_DISC_AMT']), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                    $table->addCell($r['PERIOD'], array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                    $table->addCell(clx_format_currency($r['AMORTIZED_AMT']), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                }
				ClxCommon::$db->freeResult($rs);
                $this->contents .= $table->source();
            }
        }

        // REPORTE HISTORICO DE PORTAFOLIO
        /**
         * Reporte de saldos contables vs portafolio historico
         */
        function rep_portfolio_history() {
            $formcode = 'RTBL_INFU_GEN2';
            $title = dict('INVE_PORTFOLIO_VS_ACCOUNTING');
            $ac = UserRequest::$request['ac'];
            $to = UserRequest::$request[CLX_PROP_TO];
            $it = (!empty(UserRequest::$request['it'])) ? UserRequest::$request['it'] : '';
            if (empty(UserRequest::$post['RTBL_TO_DATE'])) {
                UserRequest::$post['RTBL_TO_DATE'] = '';
            }
            //RTBL_INFU_GEN2_4
            //RTBL_REPCINV
            $EDIT = &getTool('EDIT');
            $record = array();
            $msg = array();
            $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote($formcode));
            $record = UserRequest::$post;
            if (!empty($record['confirm'])) {
                getLookupValue('RTBL_INFU_CODE', 'INFU_CODE', $record);
                $EDIT->checkForm2($msg, $formrec);
            }
            $EDIT = &getTool('EDIT');
            $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', $title);
            $contents = $form->source();
            if (!empty($record['confirm']) && empty($msg)) {
                //Para ver batchs
                $portfolio_code = UserRequest::$post['RTBL_INFU_CODE'];
                $edate = ClxCommon::$db->getField($this->glcpname, 'OPERATION_DATE', 'COMP_CODE =' . singleQuote(UserRequest::$post['RTBL_COMP_CODE']));
                $schedule_title = $title . ' ' . $portfolio_code . '-' . $edate;
                //Schedule will redirect if not empty
                $ANRJ = getTool('ANRJ');
                $ANRJ->setBatchGeneral($schedule_title, 'html', UserRequest::$post); //Will redirect if excheduled
                //do job here
                $contents = '<link href="../' . kPathToSkins . kDefaultSkin . '/styles.css" rel="stylesheet" type="text/css">';
                $contents .= '<p class=title>' . $title . '</p>' .
                        $this->rep_portfolio_history_build($portfolio_code, $edate);
            }
            return $contents;
        }

        function rep_portfolio_history_build($portfolio_code, $efftdate) {
            $sql = 'SELECT GLCP.OPERATION_DATE, INFA_VW.POSITION_NUMBER, ' . singleQuote($efftdate) . ' EFFTDATE, ROUND(INFA_VW.INVEST_AMT, 2) IN_BALANCE_AMT, ROUND(GL_VW.INVEST_AMT, 2) GL_BALANCE_AMT, INFA_VW.PORTFOLIO_CODE FROM GL_PARAMETERS_TBL GLCP, (SELECT INFA.POSITION_NUMBER, INFU.COMP_CODE, INFA.PORTFOLIO_CODE, SUM(INFA.INVEST_AMT) INVEST_AMT FROM ' . $this->infaname . ' INFA, ' . $this->infuname . ' INFU WHERE INFU.IDCODE = INFA.PORTFOLIO_CODE AND INFU.IDCODE = ' . singleQuote($portfolio_code) . ' GROUP BY INFA.POSITION_NUMBER, INFU.COMP_CODE, INFA.PORTFOLIO_CODE ORDER BY INFA.POSITION_NUMBER) INFA_VW, (SELECT GDVW.ITEM_REF_NO POSITION_NUMBER, INFU.COMP_CODE, INFU.IDCODE PORTFOLIO_CODE, SUM(GDVW.DEBIT_TRANS_AMT-GDVW.CREDIT_TRANS_AMT) INVEST_AMT FROM ' . $this->gdvwname . ' GDVW, ' . $this->fiasname . ' FIAS, ' . $this->infuname . ' INFU WHERE FIAS.IDCODE = GDVW.CHART_FIELD03 AND FIAS.PORTFOLIO_CODE = INFU.IDCODE AND INFU.IDCODE = ' . singleQuote($portfolio_code) . ' AND GDVW.GLACCOUNTCODE IN (SELECT PRAT.PRO_GL_CODE FROM ' . $this->pratname . ' PRAT, ' . $this->prodname . ' PROD WHERE PROD.IDCODE = PRAT.PRODUCT_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ') GROUP BY GDVW.ITEM_REF_NO, INFU.COMP_CODE, INFU.IDCODE) GL_VW WHERE INFA_VW.PORTFOLIO_CODE = GL_VW.PORTFOLIO_CODE AND INFA_VW.POSITION_NUMBER = GL_VW.POSITION_NUMBER AND INFA_VW.PORTFOLIO_CODE = ' . singleQuote($portfolio_code) . ' AND GLCP.COMP_CODE = INFA_VW.COMP_CODE AND (INFA_VW.INVEST_AMT<>0 OR GL_VW.INVEST_AMT<>0) ORDER BY INFA_VW.POSITION_NUMBER, INFA_VW.PORTFOLIO_CODE';
            $rs = ClxCommon::$db->executeQuery($sql);
            $i = CLX_INIT_ZERO;
            $table = new htmlTable(CLX_WIDTH_FOUR);
            $table->setProps(array(CLX_PROP_CLASS => 'panel'));
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_PORTFOLIO_CODE'), $portfolio_code, dict('GEN_LBL_ASOF'), $efftdate));
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_INVESTMENT_CODE'), dict('GEN_LBL_INBAL'), dict('GEN_LBL_GLBAL'), dict('GEN_LBL_INBAL') . '-' . dict('GEN_LBL_GLBAL')));
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $class = ($i % CLX_NUM_TWO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT;
                $i++;
                $table->addCell('<b>' . $r['POSITION_NUMBER'] . '</b>', array(CLX_PROP_CLASS => $class, CLX_PROP_ALIGN => 'center'));
                $table->addCell(xFormat::number($r['IN_BALANCE_AMT']), array(CLX_PROP_CLASS => $class, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                $table->addCell(xFormat::number($r['GL_BALANCE_AMT']), array(CLX_PROP_CLASS => $class, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                $table->addCell('<b>' . xFormat::number(bcsub($r['IN_BALANCE_AMT'], $r['GL_BALANCE_AMT'])) . '</b>', array(CLX_PROP_CLASS => $class, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            }
			ClxCommon::$db->freeResult($rs);
            return $table->source();
        }

    }

}