<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */

/**
 * Initialice jeit form
 * Executed on init event
 */
function jeit_init_form(&$record) {
    if (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE') {
        $record['JEIT_CLX_AUTH_STATUS'] = 'PEND';
        $record['JEIT_IDCODE'] = 'AUTO';
    }
    if (UserRequest::$request['ac'] === 'CREATE') {
        if (!function_exists('comp_operation_parameters'))
            includeCodeLib('COMP');
    }
}

/**
 * Validate record information
 * Executed on table validate
 */
function jeit_validate_form(&$record, &$msg) {
    if (!empty($record['JEIT_GLACCOUNTCODE'])) {
        includeCodeLib('GLAC');
        $glac = new Glac();
        if ($glac->invalid_glgroup_by_group($record['JEIT_GLGROUP_CODE'], $record['JEIT_GLACCOUNTCODE'])) {
            $msg['JEIT_GLACCOUNTCODE'] = smsg('MSG-360');
        }
    }
    if ($record['fm'] == 'JEIT_AR' or $record['fm'] == 'JEIT_AP'){
        if ($record['JEIT_ITEM_TYPE'] != 'IXP' &&  $record['JEIT_ITEM_TYPE'] != 'IXC' && $record['JEIT_ITEM_TYPE'] != 'TW' && empty($record['JEIT_GLACCOUNTCODE'])) {
            $msg['JEIT_GLGROUP_CODE'] = smsg('MSG-315');
        }
    }
}

function jeit_calculate_item_amt($item, $amount, $efftdate) {
    $jeitname = tableName('JEIT');
    $return = (float) CLX_NUM_ZERO;
    $sql = 'SELECT  JEIT.FLAT_RATE, JEIT.EXEMPT_TAX_AMT, JEIT.TAX_WITHOLDING_PCT, JEIT.TAX_TYPE  FROM ' . $jeitname . ' JEIT WHERE  JEIT.IDCODE = ' . singleQuote('IV') . ' AND JEIT.CLX_EFFTDATE =  (SELECT X.CLX_EFFTDATE  FROM ' . $jeitname . ' X WHERE X.IDCODE = JEIT.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($efftdate) . ')';
    $r = ClxCommon::$db->getOneRecord($sql);
    if (!empty($r)) {
        if ($r['TAX_WITHOLDING_PCT'] <> CLX_NUM_ZERO) {
            $return = (float) round($amount * ($r['TAX_WITHOLDING_PCT'] / CLX_NUM_HUNDRED), CLX_NUM_TWO);
        }
        if ($r['EXEMPT_TAX_AMT'] <> CLX_NUM_ZERO) {
            $return -= (float) $r['EXEMPT_TAX_AMT'];
        }
        if ($r['FLAT_RATE'] <> CLX_NUM_ZERO) {
            $return = round($return * ($r['FLAT_RATE'] / CLX_NUM_HUNDRED), CLX_NUM_TWO);
        }
        $return = rounder($return, CLX_NUM_TWO);
    }
    return $return;
}
