<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-09 09:57:56 -0400 (Fri, 09 Oct 2015) $
 * @version        $Rev: 7195 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Opcl {

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('OPCL', 'SLAA', 'ACTI', 'PROD', 'OPCL', 'ACCO', 'CMBP', 'OPPO', 'OPPH', 'OPST'));
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
    }

    /**
     * Initialice fiai form
     * Executed on init event
     */
    function init_form(&$record) {
        $callingpage = peekHistory();
        if (!empty($callingpage['parentrecord']['OPPO_CMBP_CODE'])) {
		  $record['OPCL_PROCRULE_CODE'] = $callingpage['parentrecord']['OPPO_CMBP_CODE'];
		  $record['OPCL_PROCRULE_CODE_prim'] = $callingpage['parentrecord']['OPPO_CMBP_CODE_prim'];
		  $record['OPCL_PROCRULE_CODE_secd'] = $callingpage['parentrecord']['OPPO_CMBP_CODE_secd'];
        }
    }



    /**
     * Save form post database comit
     *
     * @param unknown_type $record
     */
    function save_form_post(&$record) {
        //verify status on save
        $this->check_oppo_checklist_status($record['IDCODE']);
    }


    /**
     * Pending btn
     *
     */
    function set_pending_btn() {
        $idlist = toString(getIdlist());
        if (!empty($idlist)) {
		  $sql = 'UPDATE ' . $this->opclname . '  SET LISTITEM_STAT = ' . singleQuote('P') . ' WHERE ID IN (' . $idlist . ')';
		  ClxCommon::$db->executeQuery($sql);
        }
        $callingpage = peekHistory();
        if (!empty($callingpage['parentrecord']['OPPO_IDCODE'])) {
		  $this->check_oppo_checklist_status($callingpage['parentrecord']['OPPO_IDCODE']);
        }
    }

    /**
     * Complete btn
     *
     */
    function set_completed_btn() {
        $idlist = toString(getIdlist());
        $notidlist = '';
        //Validar que existan requeridos en la tabla
        $sql = 'SELECT OPCL1.ID, CMBD1.IDNAME FROM CMP_RULE_DOCS CMBD1, ' . $this->opclname . ' OPCL1 LEFT JOIN (SELECT OPCL.ID FROM CMP_ACCOUNT_DOCS CMAD, CMP_RULE_DOCS CMBD, CMP_DOCUMENTS_TBL CMDT, ' . $this->opclname . ' OPCL WHERE CMDT.IDCODE = CMAD.DOC_TYPE_CODE AND OPCL.ACCOUNTCODE = CMAD.ACCOUNTCODE AND OPCL.ID IN (' . $idlist . ') AND OPCL.CMBD_CODE = CMBD.IDCODE AND CMAD.DOC_TYPE_CODE = CMBD.DOC_TYPE_CODE AND CMBD.DOC_TYPE_CODE = CMAD.DOC_TYPE_CODE AND CMAD.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE FROM CMP_ACCOUNT_DOCS X WHERE  X.IDCODE=CMAD.IDCODE AND  X.CLX_EFFTDATE <= NOW())) TMP ON TMP.ID = OPCL1.ID WHERE CMBD1.IDCODE = OPCL1.CMBD_CODE AND OPCL1.ID IN (' . $idlist . ') AND OPCL1.ISREQUIRED = 1 AND TMP.ID IS NULL';
        $rs = ClxCommon::$db->executeQuery($sql);
        $notin = array();
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  addMessage(dict('GEN_LBL_MISSINGDOCS') . ': ' . $r['IDNAME']);
		  $notin[] = $r['ID'];
        }
		ClxCommon::$db->freeResult($rs);
        if (!empty($notin)) {
		  $notidlist = 'AND ID NOT IN (' . toString($notin) . ') ';
        }
        if (!empty($idlist)) {
		  $sql = 'UPDATE ' . $this->opclname . '  SET LISTITEM_STAT = ' . singleQuote('C') . ' WHERE ID IN (' . $idlist . ') ' . $notidlist . ' AND LISTITEM_STAT = ' . singleQuote('P');
		  ClxCommon::$db->executeQuery($sql);
        }
        $callingpage = peekHistory();
        if (!empty($callingpage['parentrecord']['OPPO_IDCODE'])) {
		  $this->check_oppo_checklist_status($callingpage['parentrecord']['OPPO_IDCODE']);
        }
    }

    /**
     * Set status
     *
     */
    function set_excempt_btn() {
        $idlist = toString(getIdlist());
        if (!empty($idlist)) {
		  $sql = 'UPDATE ' . $this->opclname . '  SET LISTITEM_STAT = ' . singleQuote('E') . ' WHERE ID IN (' . $idlist . ') AND LISTITEM_STAT = ' . singleQuote('P');
		  ClxCommon::$db->executeQuery($sql);
        }
        $callingpage = peekHistory();
        if (!empty($callingpage['parentrecord']['OPPO_IDCODE'])) {
		  $this->check_oppo_checklist_status($callingpage['parentrecord']['OPPO_IDCODE']);
        }
    }

    /**
     * Set status
     * @param type $oppo_code
     */
    function check_oppo_checklist_status($oppo_code) {
        //Marcar como pendiente las oportunidades pendientes
        $sql = 'UPDATE SFA_OPPORTUNITIES OPPO SET OPPO.CHKLST_COMPLETE = 0 WHERE OPPO.IDCODE = ' . singleQuote($oppo_code) . ' AND EXISTS(SELECT OPCL.ID FROM PROS_OPPO_CHECKLISTS OPCL WHERE OPCL.OPPO_CODE = OPPO.IDCODE) AND EXISTS(SELECT OPCL.ID FROM PROS_OPPO_CHECKLISTS OPCL WHERE OPCL.OPPO_CODE = OPPO.IDCODE AND OPCL.LISTITEM_STAT = ' . singleQuote('P') . ')';
        ClxCommon::$db->executeQuery($sql);
        //Marcar las oportunidades completadas
        $sql = 'UPDATE SFA_OPPORTUNITIES OPPO SET OPPO.CHKLST_COMPLETE = 1 WHERE OPPO.IDCODE = ' . singleQuote($oppo_code) . ' AND EXISTS(SELECT OPCL.ID FROM PROS_OPPO_CHECKLISTS OPCL WHERE OPCL.OPPO_CODE = OPPO.IDCODE) AND NOT EXISTS(SELECT OPCL.ID FROM PROS_OPPO_CHECKLISTS OPCL WHERE OPCL.OPPO_CODE = OPPO.IDCODE AND OPCL.LISTITEM_STAT = ' . singleQuote('P') . ')';
        ClxCommon::$db->executeQuery($sql);
    }

}
