<?php

if (!class_exists('Ordr')) {

    /**
     * General Code File
     * For more information contact  support@alenet.com
     *
     * @author       $Author: fsantana $
     * @copyright    Alenet, Inc.
     * @since        $Date:  14:20:58 -0400 (Wed, 02 Sep 2009) $
     * @version        $Rev: 1376 $
     *
     * CHANGE LOG
     *  Included svn prop
     */
    class Ordr {
        /* Contructor
         *
         * @param array $procParameters
         * @return void
         */

        function __construct($procParameters = array()) {
            multiTableName($this, array('ACCO', 'CONT', 'ORDL', 'ORDR', 'PROD', 'ITEM', 'COMP', 'ORSH', 'ORPY'));
            $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
            $this->username = $_SESSION['user_record']['username'];
            $this->now = xFormat::getNow('Y-m-d H:i:s');
        }

        /**
         * Initialice rder form
         * Executed on init event
         */
        function ordr_init_form(&$record) {
            if (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE' || UserRequest::$request['ac'] === 'MODIFY') {
                $this->loadContact($record);
            }
        }

        /**
         * Validate record information
         * Executed on table validate
         */
        function ordr_validate_form(&$record, &$msg) {
            getLookupValue('ORDR_CONTACT_CODE', 'CONTACT_CODE', $record);
            if (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE' || UserRequest::$request['ac'] === 'MODIFY') {
                if (empty($record['ORDR_CONTACT_CODE'])) {
                    //Require Contact Information
                    $validate_fields = array('FIRSTNAME', 'LASTNAME', 'EMAIL', 'PHONE', 'ADDRESS1', 'ADDRESS2', 'CITY', 'STATE', 'ZIPCODE');
                    foreach ($validate_fields as $key => $val) {
                        if (strlen($record['ORDR_' . $val]) == CLX_NUM_ZERO) {
                            $msg['ORDR_' . $val] = dict('GEN_LBL_FIELD_REQUIRED');
                        }
                    }
                }//empty contact
            }
        }

        /**
         * Events associate before database commit
         */
        function ordr_save_pre_commit(&$record) {
            if (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE') {
                if (!function_exists('setCreationData'))
                    includeCodeLib('GEN_REC_UTIL');
                //Create Contact Information if not exists already
                $this->createOrderContact($record);
                //if not exists accountcode then
                if (empty($record['ACCOUNTCODE']) || $record['ACCOUNTCODE'] === 'null') {
                    $this->createOrderAccount($record['CONTACT_CODE'], $record);
                }
                //Asociando contacto a cuenta si no existe
                $this->createOrderAccoContRelation($record['CONTACT_CODE'], $record['ACCOUNTCODE']);
            }
            //Adding social hostes to the order
            if (empty($record['SOCIAL_HOSTESS']) && !empty($record['EVENT_CODE'])) {
                $record['SOCIAL_HOSTESS'] = ClxCommon::$db->getField('MARK_CAMPAIGNS', 'SOCIAL_HOSTESS', 'IDCODE = ' . singleQuote($record['EVENT_CODE']));
            }
        }

        /**
         * Builds account and contact relation
         *
         * @param unknown_type $contact_code
         * @param unknown_type $accountcode
         */
        function createOrderAccoContRelation($contact_code, $accountcode) {
            $contact_id = ClxCommon::$db->getField('CRM_CONTACTS', 'ID', 'IDCODE = ' . singleQuote($contact_code));
            $account_id = ClxCommon::$db->getField('CRM_ACCOUNTS', 'ID', 'IDCODE = ' . singleQuote($accountcode));
            if (empty($contact_id) || empty($account_id))
                return;
            $sql = 'SELECT COUNT(REL.ID) FROM CRM_REL_CONTACTS REL, CRM_CONTACTS CONT, CRM_ACCOUNTS ACCO WHERE CONT.IDCODE = ' . singleQuote($contact_code) . ' AND ACCO.IDCODE = ' . singleQuote($accountcode) . ' AND REL.CHILD_RECORDID = CONT.ID AND REL.PARENT_RECORDID = ACCO.ID AND REL.PARENT_TABLECODE = ' . singleQuote('ACC') . ' AND REL.CHILD_TABLECODE = ' . singleQuote('CON') . '';
            if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
                $relrec = array('CHILD_RECORDID' => $contact_id,
                    'PARENT_RECORDID' => $account_id,
                    'PARENT_TABLECODE' => 'ACCO',
                    'CHILD_TABLECODE' => 'CONT');
                ClxCommon::$db->createRecord('CRM_REL_CONTACTS', $relrec, false);
            }
        }

        /**
         * Builds order Account
         *
         * @param string $contact_code
         * @param array $record
         * @param String $formprefix
         */
        function createOrderAccount($contact_code, &$record) {
            if (!function_exists('setCreationData'))
                includeCodeLib('GEN_REC_UTIL');
            $idname = ClxCommon::$db->getOne('SELECT CONCAT(LASTNAME,', ',FIRSTNAME) FROM ' . $this->contname . '  WHERE IDCODE = ' . singleQuote($contact_code));
            $accorec = array();
            $accorec['IDCODE'] = 'AUTO';
            $accorec['IDNAME'] = $idname;
            $accorec['CDATE'] = '';
            $accorec['MDATE'] = '';
            $accorec['CREATEDBY'] = '';
            $accorec['MODIFIEDBY'] = '';
            setCreationData($accorec);
            setCreationIdcode($accorec, 'ACCO');
            $accorec['ACCTYPE'] = 'CUST';
            $accorec['CLIENT_SINCE_DATE'] = $accorec['CDATE'];
            $accorec['ASSIGNEDTO_USER'] = $accorec['CDATE'];
            $accorec['ACCDEP'] = ClxCommon::$db->getOne('SELECT TREENODE FROM CLX_AC_TREE_USERS WHERE USERNAME = ' . singleQuote($accorec['CREATEDBY']) . ' AND DEFAULT_ENTRY = 1 AND TREECODE = ' . singleQuote('SF') . '');
            $sql = 'SELECT ACCO.IDCODE FROM CRM_REL_CONTACTS REL, CRM_CONTACTS CONT, CRM_ACCOUNTS ACCO WHERE CONT.IDCODE = ' . singleQuote($contact_code) . ' AND REL.CHILD_RECORDID = CONT.ID AND REL.PARENT_RECORDID = ACCO.ID AND REL.PARENT_TABLECODE = ' . singleQuote('ACC') . ' AND REL.CHILD_TABLECODE = ' . singleQuote('CON') . '';
            $record['ACCOUNTCODE'] = ClxCommon::$db->getOne($sql);
            if (empty($record['ACCOUNTCODE'])) {
                $record['ACCOUNTCODE'] = $accorec['IDCODE'];
                ClxCommon::$db->createRecord('CRM_ACCOUNTS', $accorec, false);
            }
        }

        /**
         * Builds Contact Record
         *
         * @param unknown_type $record
         * @param unknown_type $formprefix
         */
        function createOrderContact(&$record) {
            $formprefix = (array_key_exists('ORDR_IDCODE', $record)) ? 'ORDR_' : '';
            if (!empty($record['CONTACT_CODE']) && $record['CONTACT_CODE'] <> 'null') {
                if (!empty($record['FIELD_EXTRA01'])) {
                    ClxCommon::$db->updateRecord($this->contname, array('FIELD_EXTRA01' => $record['FIELD_EXTRA01']), 'IDCODE = ' . singleQuote($record['CONTACT_CODE']));
                }
                return;
            }
            if (!function_exists('setCreationData'))
                includeCodeLib('GEN_REC_UTIL');
            $contrec = array();
            $sql = 'SELECT FIELDNAME FROM CLX_DB_TABLEFIELDS WHERE TABLECODE = ' . singleQuote('CON') . '';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                if (array_key_exists($formprefix . $r['FIELDNAME'], UserRequest::$post)) {
                    $contrec[$r['FIELDNAME']] = UserRequest::$post[$formprefix . $r['FIELDNAME']];
                }
                if (array_key_exists($r['FIELDNAME'], $record)) {
                    $contrec[$r['FIELDNAME']] = $record[$formprefix . $r['FIELDNAME']];
                }
            }
			ClxCommon::$db->freeResult($rs);
            unset($contrec['ID']);
            $contrec['IDCODE'] = 'AUTO';
            $contrec['CDATE'] = '';
            $contrec['MDATE'] = '';
            $contrec['CREATEDBY'] = '';
            $contrec['MODIFIEDBY'] = '';
            setCreationData($contrec);
            setCreationIdcode($contrec, 'CONT');
            $contrec['OWNERCODE'] = $contrec['MODIFIEDBY'];
            $contrec['IDNAME'] = $contrec['LASTNAME'] . ', ' . $contrec['FIRSTNAME'];
            $contrec['CONT_ACCESS'] = ClxCommon::$db->getOne('SELECT TREENODE FROM CLX_AC_TREE_USERS WHERE USERNAME = ' . singleQuote($contrec['CREATEDBY']) . ' AND DEFAULT_ENTRY = 1 AND TREECODE = ' . singleQuote('SF') . '');
            if (!empty(UserRequest::$post[$formprefix . 'SAMEASBILLING']) && empty($contrec['ADDRESS1_02'])) {
                //Setting same address for shipping
                $contrec['ADDRESS1_02'] = $contrec['ADDRESS1'];
                $contrec['ADDRESS2_02'] = $contrec['ADDRESS2'];
                $contrec['CITY_02'] = $contrec['CITY'];
                $contrec['STATE_02'] = $contrec['STATE'];
                $contrec['ZIPCODE_02'] = $contrec['ZIPCODE'];
                $contrec['COUNTRY_02'] = $contrec['COUNTRY'];
            }
            if (!empty($record['FIELD_EXTRA01'])) {
                $contrec['FIELD_EXTRA01'] = $record['FIELD_EXTRA01'];
            }
            //Try to match contact
            $sql = 'SELECT IDCODE FROM CRM_CONTACTS WHERE EMAIL LIKE ' . singleQuote('%' . $contrec['EMAIL']);
            $record['CONTACT_CODE'] = ClxCommon::$db->getOne($sql);
            if (empty($record['CONTACT_CODE'])) {
                ClxCommon::$db->createRecord($this->contname, $contrec, false);
                $record['CONTACT_CODE'] = $contrec['IDCODE'];
            } elseif (!empty($record['FIELD_EXTRA01'])) {
                ClxCommon::$db->updateRecord($this->contname, array('FIELD_EXTRA01' => $record['FIELD_EXTRA01']), 'IDCODE = ' . singleQuote($record['CONTACT_CODE']));
            }
        }

//ORDER CONFIRMATION
        /**
         * Send order confirmation
         */
        function orderActions($action) {
            $idlist = toString(getIdlist());
            $rs = ClxCommon::$db->getRecords($this->ordrname, 'ID IN (' . $idlist . ')');
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                switch ($action) {
                    case 'NOTIFY':
                        $this->buildConfirmation($r);
                        break;
                    case 'OPEN_AND_NOTIFY':
                        $this->setOrderStatus($r['IDCODE'], 'O');
                        $this->buildConfirmation($r);
                        break;
                    case 'OPEN':
                        $this->setOrderStatus($r['IDCODE'], 'O');
                        break;
                    case 'CLOSE':
                        $this->setOrderStatus($r['IDCODE'], 'C');
                        break;
                    case 'VOID':
                        $this->setOrderStatus($r['IDCODE'], 'V');
                        break;
                    default:
                        return;
                        break;
                }
            }
			ClxCommon::$db->freeResult($rs);
        }

        /**
         * Builds Order Confirmation
         *
         * @param unknown_type $orderrec
         */
        function buildConfirmation($orderrec) {
            $DBLT = getTool('DBLT');
            $record = array();
            $record = array_merge($record, $orderrec);
            $record['COMPANY_NAME'] = ClxCommon::$db->getField($this->compname, 'IDNAME', 'IDCODE = ' . singleQuote($orderrec['COMP_CODE']));
            $contact_rec = ClxCommon::$db->getRecord('CRM_CONTACTS', 'IDCODE = ' . singleQuote($orderrec['CONTACT_CODE']));
            unset($contact_rec['IDCODE'], $contact_rec['ID']);
            $record = array_merge($record, $contact_rec);
            $record['CURRENT_DATE'] = date('m/d/Y');
            //Setting shipping address
            $sql = 'SELECT DISTINCT ORSH.ADDRESS1, ORSH.ADDRESS2, ORSH.CITY, ORSH.STATE, ORSH.ZIPCODE, ORSH.COUNTRY FROM ORDR_SHIPMENTS ORSH WHERE ORSH.ORDERCODE = ' . singleQuote($orderrec['IDCODE']);
            $rs = ClxCommon::$db->executeQuery($sql);
            $record['SHIPPING_ADDRESSES'] = '<ul>';
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $record['SHIPPING_ADDRESSES'] .= '<li>' . $r['ADDRESS1'] . ' ' .
                        $r['ADDRESS2'] . '<br>' . $r['CITY'] .
                        '<br>' . $r['STATE'] . ' ' .
                        $r['ZIPCODE'] . '</li><br>';
            }
			ClxCommon::$db->freeResult($rs);
            $record['SHIPPING_ADDRESSES'] .= '</ul>';
            //Setting shipping address
            $sql = 'SELECT DISTINCT ORPY.ADDRESS1, ORPY.ADDRESS2, ORPY.CITY, ORPY.STATE, ORPY.ZIPCODE, ORPY.COUNTRY FROM ORDR_SHIPMENTS ORPY WHERE ORPY.ORDERCODE = ' . singleQuote($orderrec['IDCODE']);
            $rs = ClxCommon::$db->executeQuery($sql);
            $record['PAYMENT_ADDRESSES'] = '<ul>';
            $ln = '';
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $record['PAYMENT_ADDRESSES'] .= $ln . '<li>' . $r['ADDRESS1'] . ' ' .
                        $r['ADDRESS2'] . '<br>' . $r['CITY'] .
                        '<br>' . $r['STATE'] . ' ' .
                        $r['ZIPCODE'] . '</li>';
                $ln = '<br>';
            }
			ClxCommon::$db->freeResult($rs);
            $record['PAYMENT_ADDRESSES'] .= '</ul>';
            $record['DISCOUNTS'] = $orderrec['DISCOUNT_AMT'];
            $record['SUBTOTAL_AMT'] = CLX_NUM_0_PT_00;
            $record['TAX_AMT'] = $orderrec['TAX_AMT'];
            $record['SHIPPING_AMT'] = CLX_NUM_0_PT_00;
            $record['TOTAL_AMT'] = CLX_NUM_0_PT_00;
            //Get shipping amount
            $sql = 'SELECT SUM(ORSH.ORDR_SHIPCOST) FROM ORDR_SHIPMENTS ORSH WHERE ORSH.ORDERCODE = ' . singleQuote($orderrec['IDCODE']);
            $record['SHIPPING_AMT'] = ClxCommon::$db->getOne($sql);
            //Build Order Record
            $sql = 'SELECT PROD.IDNAME PRODUCT_NAME, ITEM.ITEM_TYPE, ITEM.ITEM_FABRIC, ITEM.ITEM_COLOR, ITEM.ITEM_SIZE, ORDL.ITEM_CODE, ORDL.DESCRIPTION, ORDL.LINE_TOTAL, ORDL.QUANTITY, ORDL.PRICE FROM CRM_PRODUCTS PROD, INVN_ITEMS ITEM, ORDR_ORDER_LINES ORDL WHERE PROD.IDCODE = ITEM.PRODUCT_CODE AND ITEM.IDCODE = ORDL.ITEM_CODE AND ORDL.ORDERCODE = ' . singleQuote($orderrec['IDCODE']) . ' ORDER BY ORDL.SEQNUM ASC';
            $rs = ClxCommon::$db->executeQuery($sql);
            $record['LISTLIST'] = '<ul>';
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $r['ITEM_TYPE'] = $DBLT->getListItem('ITTY', $r['ITEM_TYPE']);
                $r['ITEM_FABRIC'] = $DBLT->getListItem('ITSZ', $r['ITEM_FABRIC']);
                $r['ITEM_COLOR'] = $DBLT->getListItem('ITCO', $r['ITEM_COLOR']);
                $r['ITEM_SIZE'] = $DBLT->getListItem('ITFA', $r['ITEM_SIZE']);
                $record['LISTLIST'] .= '<li><b>' . $r['PRODUCT_NAME'] . '</b> ';
                $record['LISTLIST'] .= '<i>';
                $record['LISTLIST'] .= $r['ITEM_TYPE'] . ' ' . $r['ITEM_FABRIC'] . ' ' . $r['ITEM_COLOR'] . ' ' . $r['ITEM_SIZE'] . 'Sku: ' .
                        $r['ITEM_CODE'] . '</i> ' .
                        $r['QUANTITY'] . ' x ' . $r['PRICE'] . ' = ' . $r['LINE_TOTAL'] . ' ' . $orderrec['CURRENCY_CODE'] . '</li>';
                $record['SUBTOTAL_AMT'] += $r['LINE_TOTAL'];
            }
            $record['LISTLIST'] .= '</ul>';
            //Formating
            $record['TOTAL_AMT'] = ($record['SUBTOTAL_AMT'] - $record['DISCOUNTS']) + $record['TAX_AMT'] + $record['SHIPPING_AMT'];
            $record['SUBTOTAL_AMT'] = xFormat::number($record['SUBTOTAL_AMT']);
            $record['TAX_AMT'] = xFormat::number($record['TAX_AMT']);
            $record['SHIPPING_AMT'] = xFormat::number($record['SHIPPING_AMT']);
            $record['TOTAL_AMT'] = xFormat::number($record['TOTAL_AMT']);
            if ($record['DISCOUNTS'] > CLX_NUM_ZERO)
                $record['DISCOUNTS'] = 'Discount : ' . xFormat::number($record['DISCOUNTS']);
            else
                $record['DISCOUNTS'] = '';
            //Prepare Template
            $UITM = getTool('UITM');
            unset($record['ID']);
            $templatecode = 'MSG_ORD_CONF';
            $template = $UITM->getTemplateAndRecordMerge($templatecode, $record);
            $from = companyParameter('ORDR_DEFAULT_FROM_MAIL');
            $to = $contact_rec['EMAIL'];
            $cc = null;
            $bcc = $to;
            $msg = $template['CONTENTS'];
            $subject = $template['SUBJECT'];
            if (!clx_mail($from, $to, $msg, $subject, true, $cc, $bcc)) {
                addMessage(dict('GEN_LBL_EMAIL_SEND_FAIL') . ' ' . $to);
            }
            //Administrator copy
            if (!clx_mail($from, $from, $msg, $subject, true, $cc, $bcc)) {
                addMessage(dict('GEN_LBL_EMAIL_SEND_FAIL') . ' ' . $from);
            }
        }

        function setOrderStatus($ordercode, $status) {
            $sql = 'UPDATE ' . $this->ordrname . '  SET ORDERSTATUS = ' . singleQuote($status) . ' WHERE IDCODE = ' . singleQuote($ordercode);
            ClxCommon::$db->executeQuery($sql);
        }

        /**
         * Load contact information on form edition
         *
         * @param unknown_type $record
         */
        function loadContact(&$record) {
            if (empty($record['ORDR_CONTACT_CODE']))
                return;
            $sql = 'SELECT FIRSTNAME, LASTNAME, SECOND_NAME,EMAIL, PHONE, ADDRESS1_02, ADDRESS2_02, CITY_02, STATE_02, ZIPCODE_02, COUNTRY_02, ADDRESS1, ADDRESS2, CITY, STATE, ZIPCODE, COUNTRY FROM ' . $this->contname . '  WHERE IDCODE = ' . singleQuote($record['ORDR_CONTACT_CODE']);
            $contrec = ClxCommon::$db->getOneRecord($sql);
            foreach ($contrec as $key => $val) {
                if (array_key_exists('ORDR_' . $key, $record)) {
                    $record['ORDR_' . $key] = $val;
                }
            }
        }

        //QUICK ORDER FORM METHOD
        function quickCreateOrderForm($return_form = CLX_NUM_ZERO) {
            $contents = '<script language="javascript">
        				showHideMenu(' . singleQuote('pagemenu') . ');
        			</script>
        			<iframe src ="order_form.php?return=' . $return_form . '" width=CLX_PROP_100PCT height="600" frameborder=0>
  						<p>Your browser does not support iframes.</p>
					</iframe>';
            return $contents;
        }

        function validateQuickOrder(&$msg, &$record) {
            if (empty($record['batch_ID'])) {
                $msg = dict('GEN_LBL_ERROR') . ' ' . 'Invalid batch';
                return false;
            }
            if (ClxCommon::$db->oneExistsRecords($this->ordrname, 'BATCH_ID = ' . singleQuote($record['batch_ID'])) > CLX_NUM_ZERO) {
                $msg = dict('GEN_LBL_ERROR') . ' ' . ' Order process completed. Please create a new order';
                return false;
            }
            if (empty($record['PRODUCT_CODE']) && !is_array($record['PRODUCT_CODE'])) {
                $msg = 'Product ' . dict('GEN_LBL_FIELD_REQUIRED');
                return false;
            }
            if (!empty($record['PRODUCT_CODE']) && is_array($record['PRODUCT_CODE'])) {
                foreach ($record['PRODUCT_CODE'] as $key => $val) {
                    if (empty($val)) {
                        $msg = 'Product ' . ($key + CLX_NUM_ONE) . ' ' . dict('GEN_LBL_FIELD_REQUIRED');
                        return false;
                    }
                }
            }
            if ($record['GRANTOTAL_AMT'] == CLX_NUM_ZERO) {
                $msg = 'Order total must be greater than cero.';
                return false;
            }
            if (empty($record['PRODUCT_CODE'])) {
                $msg = 'Product ' . dict('GEN_LBL_FIELD_REQUIRED');
                return false;
            }
            //Charge credit card or notify prior to complete order
            if ($record['CC_AMOUNT'] <> CLX_NUM_ZERO) {//Create Cash Payment entry
                $rec = array();
                $rec['PAYMENT_AMT'] = $record['CC_AMOUNT'];
                $rec['PAYMENT_TYPE'] = 'CC';
                $rec['PAYMENT_STATUS'] = 'PE';
                $rec['ADDRESS1'] = $record['ADDRESS1'];
                $rec['ADDRESS2'] = $record['ADDRESS2'];
                $rec['CITY'] = $record['CITY'];
                $rec['ZIPCODE'] = $record['ZIPCODE'];
                $rec['COUNTRY'] = $record['COUNTRY'];
                $rec['STATE'] = $record['STATE'];
                $rec['PHONE'] = $record['PHONE'];
                $rec['EMAIL'] = $record['EMAIL'];
                $rec['CC_TRNTYPE'] = $record['CC_TRNTYPE'];
                $rec['CC_AUTHORIZATION'] = '';
                $rec['CC_FIRSTNAME'] = $record['CC_NAME_ON_CARD'];
                $rec['CC_LASTNAME'] = '';
                $rec['CC_IS_VPOS_TYPE'] = '1';
                $rec['CC_CVV_CODE'] = '';
                //process card payment
                $mmyy_exp_date = $record['CC_EXP_MONTH'] . substr($record['CC_EXP_YEAR'], CLX_NUM_TWO, CLX_NUM_TWO);
                if (!class_exists('Authorizenet'))
                    includeCodeLib('AUTHNET');
                $a = new Authorizenet();
                $a->test_request = (companyParameter('ORDR_CC_PAYMENT_TEST_MODE') == CLX_NUM_ONE) ? true : false;
                if ($a->test_request) {
                    $msg .= 'CC TEST MODE ENABLE, TO ACTIVATE SEARCH PARAMETER ORDR_CC_PAYMENT_TEST_MODE<br><br>';
                }
                $res = $a->processCcPayment($rec['CC_IS_VPOS_TYPE'], $rec['CC_AUTHORIZATION'], $rec['CC_TRNTYPE'], $rec['CC_FIRSTNAME'], $rec['CC_LASTNAME'], $rec['ADDRESS1'], $rec['CITY'], $rec['STATE'], $rec['ZIPCODE'], $rec['COUNTRY'], $rec['EMAIL'], $rec['PHONE'], $record['CC_NUMBER'], $rec['PAYMENT_AMT'], $mmyy_exp_date, $rec['CC_CVV_CODE']);
                if ($res <> 'AP') {
                    $msg = dict('GEN_LBL_ERROR') . ' ' . $a->get_response_reason_text() . '<br><br>';
                    return false;
                }
                $record['PAYMENT_STATUS'] = $res;
                $record['CC_AUTHORIZATION'] = $a->getAutorizationCode();
            }
            return true;
        }

        function processQuickOrder(&$record) {
            $msg = array();
            if (!$this->validateQuickOrder($msg, $record))
                return $msg;
            //Step 1 Create contact
            $this->createOrderContact($record); //contact code added
            //Step 2 Create Account If not Exists
            $record['ACCOUNTCODE'] = ''; //Will be set on createOrderAccount
            $record['ORDERCODE'] = ''; //Will be added on order creation
            $this->createOrderAccount($record['CONTACT_CODE'], $record);
            //Step 3 Create contact and account relation
            $this->createOrderAccoContRelation($record['CONTACT_CODE'], $record['ACCOUNTCODE']);
            //Step 4 Create Order
            $this->createQuickOrder($record);
            //Step 5 Build Order Items
            $this->createQuickOrderLines($record);
            //Step 6 Build Order Payments
            $this->createQuickOrderPayments($record);
            //Step 7 Build Order Shippments
            $this->createQuickOrderShipment($record);
            //Step 8 Notify client if requested
            if (!empty($record['NOTIFY_CLIENT'])) {
                $orderrec = ClxCommon::$db->getRecord($this->ordrname, 'IDCODE = ' . singleQuote($record['ORDERCODE']));
                $this->buildConfirmation($orderrec);
            }
            $msg = 'Order created. Order number: ' . $record['ORDERCODE'] . '<br> Click On reset to clear customer information and create new order. ';
            return $msg;
        }

        /**
         * Create order quick
         *
         * @param unknown_type $record
         */
        function createQuickOrder(&$record, $formprefix = '') {
            $record['ORDERCODE'] = '';
            if (!function_exists('setCreationData'))
                includeCodeLib('GEN_REC_UTIL');
            $rec = array();
            $rec['IDCODE'] = 'AUTO';
            $rec['BATCH_ID'] = $record['batch_ID'];
            $rec['COMP_CODE'] = $record['COMP_CODE'];
            $rec['EFFTDATE'] = '';
            $rec['ORDERSTATUS'] = 'O';
            $rec['ACCOUNTCODE'] = $record['ACCOUNTCODE'];
            $rec['CONTACT_CODE'] = $record['CONTACT_CODE'];
            $rec['CAMPAIGN_CODE'] = $record['EVENT_CODE'];
            if (empty($record['SOCIAL_HOSTESS']) && !empty($record['EVENT_CODE'])) {
                $record['SOCIAL_HOSTESS'] = ClxCommon::$db->getField('MARK_CAMPAIGNS', 'SOCIAL_HOSTESS', 'IDCODE = ' . singleQuote($record['EVENT_CODE']));
            }
            $rec['SOCIAL_HOSTESS'] = $record['SOCIAL_HOSTESS'];
            $rec['ORDR_SRC'] = 'SE'; //social event
            $rec['CURRENCY_CODE'] = $record['CURRENCY_CODE'];
            $rec['GIFT_REQ_WRAP'] = (empty($record['GIFT_REQ_WRAP'])) ? CLX_NUM_ZERO : CLX_NUM_ONE;
            $rec['GIFT_WRAP_TYPE'] = (empty($record['GIFT_WRAP_TYPE'])) ? CLX_NUM_ZERO : CLX_NUM_ONE;
            $rec['GIFT_NOTE'] = (empty($record['GIFT_NOTE'])) ? '' : $record['GIFT_NOTE'];
            $rec['DISCOUNT_AMT'] = (empty($record['DISCOUNT_AMT'])) ? CLX_NUM_ZERO : $record['DISCOUNT_AMT'];
            $rec['DISCOUNT_PCT'] = (empty($record['DISCOUNT_PCT'])) ? CLX_NUM_ZERO : $record['DISCOUNT_PCT'];
            $rec['TAX_AMT'] = (empty($record['TAX_AMT'])) ? CLX_NUM_ZERO : $record['TAX_AMT'];
            $rec['JOIN_INTEREST'] = (!empty($record['JOIN_INTEREST'])) ? $record['JOIN_INTEREST'] : '';
            $rec['RET_ORDER_CODE'] = (!empty($record['RET_ORDER_CODE'])) ? $record['RET_ORDER_CODE'] : '';
            $rec['CREATEDBY'] = '';
            $rec['CDATE'] = '';
            $rec['MODIFIEDBY'] = '';
            $rec['MDATE'] = '';
            setCreationData($rec);
            setCreationIdcode($rec, 'ORDR');
            $rec['EFFTDATE'] = $rec['CDATE'];
            $rec['IDNAME'] = substr($record['LASTNAME'] . ', ' . $record['FIRSTNAME'], CLX_NUM_ZERO, CLX_NUM_64);
            ClxCommon::$db->createRecord($this->ordrname, $rec, false);
            $record['ORDERCODE'] = $rec['IDCODE'];
        }

        /**
         * Create order item quick
         *
         * @param unknown_type $record
         */
        function createQuickOrderLines(&$record) {
            if (!class_exists('Ordl'))
                includeCodeLib('ORDL');
            if (!function_exists('setCreationData'))
                includeCodeLib('GEN_REC_UTIL');
            $ordl = new Ordl();
            $items = array();
            if (!empty($record['PRODUCT_CODE']) && !is_array($record['PRODUCT_CODE'])) {
                if (!array_key_exists('RETURN', $record))
                    $record['RETURN'] = CLX_NUM_ONE;
                $items[] = array($record['PRODUCT_CODE'], $record['ITEM_COLOR'], $record['ITEM_SIZE'], '', $record['LIST_PRICE'], $record['DISC_PRICE'], $record['QTY'], $record['PRICE'], $record['LINE_TOTAL'], $record['RETURN']);
            }else {
                foreach ($record['PRODUCT_CODE'] as $key => $val) {
                    if (empty($record['RETURN'][$key])) {
                        $record['RETURN'][$key] = CLX_NUM_ONE;
                    }
                    $items[] = array($record['PRODUCT_CODE'][$key], $record['ITEM_COLOR'][$key], $record['ITEM_SIZE'][$key], '', $record['LIST_PRICE'][$key], $record['DISC_PRICE'][$key], $record['QTY'][$key], $record['PRICE'][$key], $record['LINE_TOTAL'][$key], $record['RETURN'][$key]);
                }
            }
            foreach ($items as $key => $val) {
                $rec = array();
                $rec['ORDERCODE'] = $record['ORDERCODE'];
                $rec['SEQNUM'] = $key;
                $rec['PRODUCT_CODE'] = $val[CLX_NUM_ZERO];
                $rec['ITEM_CODE'] = $ordl->getItemCode($val[CLX_NUM_ZERO], $val[CLX_NUM_ONE], $val[CLX_NUM_TWO]);
                $rec['description'] = $val[CLX_NUM_THREE];
                $rec['PRICE_LIST'] = $val[CLX_NUM_FOUR];
                $rec['PRICE_DISC'] = $val[CLX_NUM_FIVE];
                $rec['QUANTITY'] = $val[CLX_NUM_SIX];
                $rec['PRICE'] = $val[CLX_NUM_7];
                $rec['LINE_TOTAL'] = $val[CLX_NUM_8];
                $rec['LINE_SIGN'] = $val[CLX_NUM_NINE];
                $rec['CREATEDBY'] = '';
                $rec['CDATE'] = '';
                $rec['MODIFIEDBY'] = '';
                $rec['MDATE'] = '';
                setCreationData($rec);
                ClxCommon::$db->createRecord($this->ordlname, $rec, false);
            }
        }

        /**
         * Enter description here...
         *
         * @param array $record
         */
        function createQuickOrderPayments(&$record) {
            if (!function_exists('setCreationData'))
                includeCodeLib('GEN_REC_UTIL');
            //Process Cash Payments
            if ($record['CA_AMOUNT'] <> CLX_NUM_ZERO) {//Create Cash Payment entry
                $rec = array();
                $rec['ORDERCODE'] = $record['ORDERCODE'];
                $rec['PAYMENT_DATE'] = '';
                $rec['PAYMENT_AMT'] = $record['CA_AMOUNT'];
                $rec['CC_TRNTYPE'] = '';
                $rec['PAYMENT_TYPE'] = 'CA';
                $rec['PAYMENT_STATUS'] = 'AP';
                $rec['ADDRESS1'] = $record['ADDRESS1'];
                $rec['ADDRESS2'] = $record['ADDRESS2'];
                $rec['CITY'] = $record['CITY'];
                $rec['ZIPCODE'] = $record['ZIPCODE'];
                $rec['COUNTRY'] = $record['COUNTRY'];
                $rec['STATE'] = $record['STATE'];
                $rec['PHONE'] = $record['PHONE'];
                $rec['EMAIL'] = $record['EMAIL'];
                $rec['CHECK_NO'] = $record['CC_NAME_ON_CARD'];
                $rec['CDATE'] = '';
                $rec['CREATEDBY'] = '';
                $rec['MDATE'] = '';
                $rec['MODIFIEDBY'] = '';
                setCreationData($rec);
                $rec['PAYMENT_DATE'] = $rec['CDATE'];
                ClxCommon::$db->createRecord($this->orpyname, $rec, false);
            }
            if ($record['CC_AMOUNT'] <> CLX_NUM_ZERO) {//Create Cash Payment entry
                $rec = array();
                $rec['ORDERCODE'] = $record['ORDERCODE'];
                $rec['PAYMENT_DATE'] = '';
                $rec['PAYMENT_AMT'] = $record['CA_AMOUNT'];
                $rec['PAYMENT_TYPE'] = 'CC';
                $rec['PAYMENT_STATUS'] = $record['PAYMENT_STATUS'];
                $rec['ADDRESS1'] = $record['ADDRESS1'];
                $rec['ADDRESS2'] = $record['ADDRESS2'];
                $rec['CITY'] = $record['CITY'];
                $rec['ZIPCODE'] = $record['ZIPCODE'];
                $rec['COUNTRY'] = $record['COUNTRY'];
                $rec['STATE'] = $record['STATE'];
                $rec['PHONE'] = $record['PHONE'];
                $rec['EMAIL'] = $record['EMAIL'];
                $rec['CC_TRNTYPE'] = $record['CC_TRNTYPE'];
                $rec['CC_AUTHORIZATION'] = $record['CC_AUTHORIZATION'];
                $rec['CC_FIRSTNAME'] = $record['CC_NAME_ON_CARD'];
                $rec['CC_LASTNAME'] = '';
                $rec['CC_IS_VPOS_TYPE'] = '1';
                unset($rec['CC_CVV_CODE']);
                $rec['CDATE'] = '';
                $rec['CREATEDBY'] = '';
                $rec['MDATE'] = '';
                $rec['MODIFIEDBY'] = '';
                setCreationData($rec);
                $rec['PAYMENT_DATE'] = $rec['CDATE'];
                ClxCommon::$db->createRecord($this->orpyname, $rec, false);
            }
        }

        /**
         * Enter description here...
         *
         * @param array $record
         */
        function createQuickOrderShipment(&$record) {
            if (!function_exists('setCreationData'))
                includeCodeLib('GEN_REC_UTIL');
            $rec = array();
            $rec['IDCODE'] = 'AUTO';
            $rec['ORDERCODE'] = $record['ORDERCODE'];
            $rec['SHIPMENT_STATUS'] = 'OP';
            $rec['SHIPPED_VIA'] = $record['SHIPMENT_CARRIER'];
            $rec['SHIPMENT_TYPE'] = $record['SHIPMENT_TYPE'];
            $rec['TRACKING_NO'] = ''; // This will be set from tracking
            $rec['OBSERVATION'] = '';
            $rec['SAMEASBILLING'] = (!empty($record['SAMEASBILLING'])) ? CLX_NUM_ONE : CLX_NUM_ZERO;
            $rec['ORDR_SHIPCOST'] = $record['SHIPPING_AMT'];
            $rec['ADDRESS1'] = $record['ADDRESS1_02'];
            $rec['ADDRESS2'] = $record['ADDRESS2_02'];
            $rec['CITY'] = $record['CITY_02'];
            $rec['ZIPCODE'] = $record['ZIPCODE_02'];
            $rec['STATE'] = $record['STATE_02'];
            $rec['COUNTRY'] = $record['COUNTRY'];
            $rec['CDATE'] = '';
            $rec['CREATEDBY'] = '';
            $rec['MDATE'] = '';
            $rec['MODIFIEDBY'] = '';
            setCreationData($rec);
            setCreationIdcode($rec, 'ORSH');
            $rec['SCHED_SHIP_DTTM'] = $rec['CDATE'];
            ClxCommon::$db->createRecord($this->orshname, $rec, false);
        }

        //SHOPIFY SYNCH METHOD - PROCESS WILL CALL A METHOD
        function requestShopifySynchForm() {
            $contents = '';
            $ac = UserRequest::$request['ac'];
            $to = UserRequest::$request[CLX_PROP_TO];
            $it = UserRequest::$request['it'];
            //RTBL_REPCINV
            $EDIT = &getTool('EDIT');
            $record = array();
            $msg = array();
            $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote('ORDR_SPFY_SYNC') . '');
            $record = UserRequest::$post;
            if (empty($record['RTBL_FROM_DATE'])) {
                $record['RTBL_FROM_DATE'] = xFormat::anytimedate('now', 'Y-m-d');
            } else {
                $record['RTBL_FROM_DATE'] = xFormat::anytimedate($record['RTBL_FROM_DATE'], 'Y-m-d');
            }
            if (empty($record['RTBL_TO_DATE'])) {
                $record['RTBL_TO_DATE'] = xFormat::anytimedate('now', 'Y-m-d');
            } else {
                $record['RTBL_TO_DATE'] = xFormat::anytimedate($record['RTBL_TO_DATE'], 'Y-m-d');
            }
            if (!empty($record['confirm'])) {
                $EDIT->checkForm2($msg, $formrec);
                if (array_key_exists('RTBL_FROM_DATE', $record) && $record['RTBL_FROM_DATE'] > $record['RTBL_TO_DATE']) {
                    /*
                     * GEN_ERR_STARTGREATERENDDATE
                     * Start date cannot be greater than end date.
                     * Fecha inicial no puede ser mayor que fecha final.
                     */
                    $msg['RTBL_FROM_DATE'] = dict('GEN_ERR_STARTGREATERENDDATE');
                    $msg['RTBL_TO_DATE'] = dict('GEN_ERR_STARTGREATERENDDATE');
                }
                if (empty($msg)) {
                    $contents = $this->requestShopifySynchSchedule($record['RTBL_FROM_DATE'], $record['RTBL_TO_DATE']);
                }
            }
            $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', '', dict('GEN_LBL_EXECUTE'));
            $contents = $form->source() . $contents;
            return $contents;
        }

        function requestShopifySynchSchedule($from_date, $to_date) {
            $parameters = array('FROM_DATE' => $from_date, 'TO_DATE' => $to_date);
            $batch_id = batch_id();
            pr_schedules::createScheduleOneTimeNow($batch_id, 'ORDER SYNCHRONIZATION', 'ORDR_SYNCH', $parameters);
            $contents = dict('GEN_LBL_SCHED_ACTIVITY') . '<br>';
            $contents .= dict('GEN_LBL_FROM') . ': ' . $from_date . '<br>';
            $contents .= dict('GEN_LBL_TO') . ': ' . $to_date . '<br>';
            return note($contents);
        }

        function requestShopifySynchProcess($parameters) {
            $parameters = array('limit' => CLX_NUM_250,
                'page' => CLX_NUM_ONE,
                'created_at_min' => $parameters['FROM_DATE'],
                'created_at_max' => $parameters['TO_DATE'],
                'updated_at_min' => '',
                'updated_at_max' => '',
                'status' => 'any',
                'financial_status' => 'any',
                'fulfillment_status' => 'any');
            $a_response = getService('SPFY_ORDR', $parameters);
            pre(htmlentities(print_r($a_response['response'], true)));
        }

    }

}
