<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date:  14:20:58 -0400 (Wed, 02 Sep 2009) $
 * @version        $Rev: 1376 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Orpy {
    /* Contructor
     *
     * @param array $procParameters
     * @return void
     */

    function __construct($procParameters = array()) {
        multiTableName($this, array('ORPY', 'ORDL', 'ORDR', 'PROD', 'ITEM', 'CONT'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Initialice figa form
     * Executed on init event
     */
    function orpy_init_form(&$record) {
        if (UserRequest::$request['ac'] === 'CREATE') {
		  $sql = 'SELECT CONT.FIRSTNAME ORPY_CC_FIRSTNAME, CONT.LASTNAME ORPY_CC_LASTNAME, CONT.ADDRESS1 ORPY_ADDRESS1, CONT.ADDRESS2 ORPY_ADDRESS2, CONT.PHONE ORPY_PHONE, CONT.EMAIL ORPY_EMAIL, CONT.CITY ORPY_CITY, CONT.STATE ORPY_STATE, CONT.FOREIGN_STATE ORPY_FOREIGN_STATE, CONT.ZIPCODE ORPY_ZIPCODE, CONT.COUNTRY ORPY_COUNTRY FROM ORDR_ORDERS ORDR, CRM_CONTACTS CONT WHERE CONT.IDCODE = ORDR.CONTACT_CODE AND ORDR.IDCODE =' . singleQuote($record['ORPY_ORDERCODE']);
		  $billing_address = ClxCommon::$db->getOneRecord($sql);
		  foreach ($billing_address as $key => $val) {
			 $record[$key] = $val;
		  }
		  $record['ORPY_CC_EXP_MO'] = xFormat::date('now', 'n');
		  $record['ORPY_CC_EXP_YR'] = xFormat::date('now', 'Y');
		  $sql = 'SELECT IFNULL((SELECT SUM(ORDL.LINE_TOTAL) FROM ORDR_ORDER_LINES ORDL WHERE ORDL.ORDERCODE =' . singleQuote($record['ORPY_ORDERCODE']) . '),0) + IFNULL((SELECT SUM(ORDR.TAX_AMT) FROM ORDR_ORDERS ORDR WHERE ORDR.IDCODE =' . singleQuote($record['ORPY_ORDERCODE']) . '),0) - IFNULL((SELECT SUM(ORPY.PAYMENT_AMT) FROM ORDR_PAYMENTS ORPY WHERE ORPY.ORDERCODE =' . singleQuote($record['ORPY_ORDERCODE']) . '),0) FROM DUAL';
		  $record['ORPY_PAYMENT_AMT'] = ClxCommon::$db->getOne($sql);
		  if ($record['ORPY_PAYMENT_AMT'] < CLX_NUM_ZERO)
			 $record['ORPY_PAYMENT_AMT'] = CLX_INIT_ZERO;
        }
    }

    /**
     * Validate record information
     * Executed on table validate
     */
    function orpy_validate_form(&$record, &$msg) {
        $status = true;
        if (!empty($record['ORPY_ID']))
		  $id = $record['ORPY_ID'];
        else
		  $id = CLX_INIT_ZERO;
        $sql = 'SELECT IFNULL((SELECT SUM(ORDL.LINE_TOTAL) FROM ORDR_ORDER_LINES ORDL WHERE ORDL.ORDERCODE =' . singleQuote($record['ORPY_ORDERCODE']) . '),0) + IFNULL((SELECT SUM(ORDR.TAX_AMT) FROM ORDR_ORDERS ORDR WHERE ORDR.IDCODE =' . singleQuote($record['ORPY_ORDERCODE']) . '),0) - IFNULL((SELECT SUM(ORPY.PAYMENT_AMT) FROM ORDR_PAYMENTS ORPY WHERE ORPY.ORDERCODE =' . singleQuote($record['ORPY_ORDERCODE']) . ' AND ORPY.ID <> ' . singleQuote($id) . '),0) FROM DUAL';
        if (ClxCommon::$db->getOne($sql) - $record['ORPY_PAYMENT_AMT'] < CLX_NUM_ZERO) {
		  $msg['ORPY_PAYMENT_AMT'] = dict('GEN_LBL_PAYMENT_GREATER_ORDER');
		  $status = false;
        }
        if ($record['ORPY_PAYMENT_AMT'] == CLX_NUM_ZERO) {
		  $msg['ORPY_PAYMENT_AMT'] = dict('GEN_LBL_FIELD_REQUIRED');
		  $status = false;
        }
        if ($record['ORPY_PAYMENT_TYPE'] === 'CC') {
		  if ($record['ORPY_PAYMENT_STATUS'] === 'AP') {
			 $msg['ORPY_PAYMENT_STATUS'] = dict('GEN_LBL_APPROVED_NOUP_ALLOWED');
			 return false;
		  }
		  if (strlen($record['ORPY_CC_TRNTYPE']) == CLX_NUM_ZERO) {
			 $msg['ORPY_CC_TRNTYPE'] = dict('GEN_LBL_FIELD_REQUIRED');
			 $status = false;
		  }
		  if ($record['ORPY_CC_TRNTYPE'] <> CLX_NUM_FOUR && strlen($record['ORPY_CC_NUMBER']) == CLX_NUM_ZERO) {
			 $msg['ORPY_CC_NUMBER'] = dict('GEN_LBL_FIELD_REQUIRED');
			 $status = false;
		  }
		  if ($record['ORPY_CC_TRNTYPE'] <> CLX_NUM_FOUR && empty($record['ORPY_CC_EXP_MO'])) {
			 $msg['ORPY_CC_EXP_MO'] = dict('GEN_LBL_FIELD_REQUIRED');
			 $status = false;
		  }
		  if ($record['ORPY_CC_TRNTYPE'] <> CLX_NUM_FOUR && (strlen($record['ORPY_CC_EXP_YR']) > CLX_NUM_FOUR || empty($record['ORPY_CC_EXP_YR']))) {
			 $msg['ORPY_CC_EXP_YR'] = dict('GEN_LBL_FIELD_REQUIRED');
			 $status = false;
		  }
		  if (($record['ORPY_CC_TRNTYPE'] == CLX_NUM_TWO || $record['ORPY_CC_TRNTYPE'] == CLX_NUM_FOUR) && empty($record['ORPY_CC_AUTHORIZATION'])) {//only when capture
			 $msg['ORPY_CC_AUTHORIZATION'] = dict('GEN_LBL_FIELD_REQUIRED');
			 $status = false;
		  }
		  if ($record['ORPY_CC_TRNTYPE'] <> CLX_NUM_FOUR && strlen($record['ORPY_CC_FIRSTNAME']) == CLX_NUM_ZERO) {
			  $msg['ORPY_CC_FIRSTNAME'] = dict('GEN_LBL_FIELD_REQUIRED');
			 $status = false;
		  }
		  if ($record['ORPY_CC_TRNTYPE'] <> CLX_NUM_FOUR && strlen($record['ORPY_CC_LASTNAME']) == CLX_NUM_ZERO) {
			 $msg['ORPY_CC_LASTNAME'] = dict('GEN_LBL_FIELD_REQUIRED');
			 $status = false;
		  }
		  if ($record['ORPY_CC_TRNTYPE'] <> CLX_NUM_FOUR && strlen($record['ORPY_EMAIL']) == CLX_NUM_ZERO) {
			 $msg['ORPY_EMAIL'] = dict('GEN_LBL_FIELD_REQUIRED');
			 $status = false;
		  }
		  if ($record['ORPY_CC_TRNTYPE'] <> CLX_NUM_FOUR && strlen($record['ORPY_PHONE']) == CLX_NUM_ZERO) {
			 $msg['ORPY_PHONE'] = dict('GEN_LBL_FIELD_REQUIRED');
			 $status = false;
		  }
		  if ($record['ORPY_CC_TRNTYPE'] <> CLX_NUM_FOUR && strlen($record['ORPY_CC_CVV_CODE']) == CLX_NUM_ZERO) {
			 $msg['ORPY_CC_CVV_CODE'] = dict('GEN_LBL_FIELD_REQUIRED');
			 $status = false;
		  }
		  if ($record['ORPY_CC_TRNTYPE'] <> CLX_NUM_FOUR && strlen($record['ORPY_ADDRESS1']) == CLX_NUM_ZERO) {
			 $msg['ORPY_ADDRESS1'] = dict('GEN_LBL_FIELD_REQUIRED');
			 $status = false;
		  }
		  if ($record['ORPY_CC_TRNTYPE'] <> CLX_NUM_FOUR && strlen($record['ORPY_ADDRESS2']) == CLX_NUM_ZERO) {
			 $msg['ORPY_ADDRESS2'] = dict('GEN_LBL_FIELD_REQUIRED');
			 $status = false;
		  }
		  if ($record['ORPY_CC_TRNTYPE'] <> CLX_NUM_FOUR && strlen($record['ORPY_CITY']) == CLX_NUM_ZERO) {
			 $msg['ORPY_CITY'] = dict('GEN_LBL_FIELD_REQUIRED');
			 $status = false;
		  }
		  if ($record['ORPY_CC_TRNTYPE'] <> CLX_NUM_FOUR && strlen($record['ORPY_ZIPCODE']) == CLX_NUM_ZERO) {
			 $msg['ORPY_ZIPCODE'] = dict('GEN_LBL_FIELD_REQUIRED');
			 $status = false;
		  }
		  if ($record['ORPY_CC_TRNTYPE'] <> CLX_NUM_FOUR && strlen($record['ORPY_COUNTRY']) == CLX_NUM_ZERO) {
			 $msg['ORPY_COUNTRY'] = dict('GEN_LBL_FIELD_REQUIRED');
			 $status = false;
		  }
		  if ($record['ORPY_CC_TRNTYPE'] <> CLX_NUM_FOUR && strlen($record['ORPY_STATE']) == CLX_NUM_ZERO) {
			 $msg['ORPY_STATE'] = dict('GEN_LBL_FIELD_REQUIRED');
			 $status = false;
		  }
		  if ($status === true) {
			 $mmyy_exp_date = (($record['ORPY_CC_EXP_MO'] < CLX_NUM_TEN) ? '0' . $record['ORPY_CC_EXP_MO'] : $record['ORPY_CC_EXP_MO']) . substr($record['ORPY_CC_EXP_YR'], CLX_NUM_TWO, CLX_NUM_TWO);
			 if (!class_exists('Authorizenet'))
			     includeCodeLib('AUTHNET');
			 $a = new Authorizenet();
			 $a->test_request = (companyParameter('ORDR_CC_PAYMENT_TEST_MODE') == CLX_NUM_ONE) ? true : false;
			 if ($a->test_request) {
			     addMessage('CC TEST MODE ENABLE, TO ACTIVATE SEARCH PARAMETER ORDR_CC_PAYMENT_TEST_MODE');
			 }
			 $res = $a->processCcPayment($record['ORPY_CC_IS_VPOS_TYPE'], $record['ORPY_CC_AUTHORIZATION'], $record['ORPY_CC_TRNTYPE'], $record['ORPY_CC_FIRSTNAME'], $record['ORPY_CC_LASTNAME'], $record['ORPY_ADDRESS1'], $record['ORPY_CITY'], $record['ORPY_STATE'], $record['ORPY_ZIPCODE'], $record['ORPY_COUNTRY'], $record['ORPY_EMAIL'], $record['ORPY_PHONE'], $record['ORPY_CC_NUMBER'], $record['ORPY_PAYMENT_AMT'], $mmyy_exp_date, $record['ORPY_CC_CVV_CODE']);
			 if ($res <> 'AP') {
			     $msg['ORPY_CC_NUMBER'] = dict('GEN_LBL_ERROR') . ' ' . $a->get_response_reason_text();
			     $status = false;
			 }
			 $record['ORPY_PAYMENT_STATUS'] = $res;
			 UserRequest::$post['ORPY_PAYMENT_STATUS'] = $res;
			 if ($record['ORPY_CC_TRNTYPE'] <> CLX_NUM_FOUR && $record['ORPY_CC_TRNTYPE'] <> CLX_NUM_TWO) {
			     $record['ORPY_CC_AUTHORIZATION'] = $a->getAutorizationCode();
			     UserRequest::$post['ORPY_CC_AUTHORIZATION'] = $record['ORPY_CC_AUTHORIZATION'];
			 }
		  }
        } elseif ($record['ORPY_PAYMENT_TYPE'] === 'CA' || $record['ORPY_PAYMENT_TYPE'] === 'CH') {

		  $record['ORPY_PAYMENT_STATUS'] = 'AP';
		  UserRequest::$post['ORPY_PAYMENT_STATUS'] = $record['ORPY_PAYMENT_STATUS'];
        }
        return $status;
    }

    /**
     * Events associate before database commit
     */
    function orpy_save_pre_commit(&$record) {

    }

    /**
     * Will get selected transaction and perform prior authorizacion capture
     *
     */
    function btnCapture() {
        if (!class_exists('Authorizenet'))
		  includeCodeLib('AUTHNET');
        $a = new Authorizenet;
        $idlist = toString(getIdlist());
        $sql = 'SELECT * FROM ' . $this->orpyname . ' WHERE ID IN (' . $idlist . ') AND CC_TRNTYPE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND CC_AUTHORIZATION IS NOT null AND CC_AUTHORIZATION <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND PAYMENT_STATUS = ' . singleQuote('A') . ' AND CC_CAPTURE_DATE IS NULL AND CC_IS_VPOS_TYPE = 0';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $res = $a->processCcPayment('AUTHNET', $r['CC_AUTHORIZATION'], CLX_NUM_FOUR, $r['CC_FIRSTNAME'], $r['CC_LASTNAME'], $r['ADDRESS1'], $r['CITY'], $r['STATE'], $r['ZIPCODE'], $r['COUNTRY'], $r['EMAIL'], $r['PHONE'], '', $r['PAYMENT_AMT'], '', '');

		  if ($res <> 'AP') {
			 addMessage(dict('GEN_LBL_ERROR') . ' Au#:' . $r['CC_AUTHORIZATION'] . ' ' . $a->get_response_reason_text());
			
		  } else {
			 $sql = 'UPDATE ' . $this->orpyname . ' SET CC_CAPTURE_DATE = now() WHERE ID = ' . $r['ID'];
			 ClxCommon::$db->executeQueryVoid($sql);
			 addMessage(dict('GEN_LBL_CAPTURE_COMPLETE') . ' Au#: ' . $r['CC_AUTHORIZATION']);
		  }
        }
		ClxCommon::$db->freeResult($rs);
    }

    /**
     * Will get selected transaction and perform void
     *
     */
    function btnVoid() {
        if (!class_exists('Authorizenet'))
		  includeCodeLib('AUTHNET');
        $a = new Authorizenet;
        $idlist = toString(getIdlist());
        $sql = 'SELECT * FROM ' . $this->orpyname . ' WHERE ID IN (' . $idlist . ') AND CC_TRNTYPE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND CC_AUTHORIZATION IS NOT null AND CC_AUTHORIZATION <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND PAYMENT_STATUS = ' . singleQuote('A') . ' AND CC_IS_VPOS_TYPE = 0';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $res = $a->processCcPayment('AUTHNET', $r['CC_AUTHORIZATION'], CLX_NUM_FIVE, $r['CC_FIRSTNAME'], $r['CC_LASTNAME'], $r['ADDRESS1'], $r['CITY'], $r['STATE'], $r['ZIPCODE'], $r['COUNTRY'], $r['EMAIL'], $r['PHONE'], '', $r['PAYMENT_AMT'], '', '');

		  if ($res <> 'AP') {
			 addMessage(dict('GEN_LBL_ERROR') . ' Au#:' . $r['CC_AUTHORIZATION'] . ' ' . $a->get_response_reason_text());
		  } else {
			 addMessage(dict('GEN_LBL_VOID_COMPLETE') . ' Au#: ' . $r['CC_AUTHORIZATION']);
		  }
        }
		ClxCommon::$db->freeResult($rs);
    }

}
