<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-05-08 07:21:28 -0400 (Tue, 08 May 2018) $
 * @version        $Rev: 9815 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Srer {

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('SRER'));
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Sends message according to situation
     * @param array $srer_rec
     * @param string $to_user
     * @param string $subject
     * @param string $msg
     * @param string $url
     */
    public function escalation_action(&$srer_rec, $to_user, $subject, $msg, $url) {
        //Sending emails
        //Get User Information
        $user = ClxCommon::$db->getFields('CLX_AC_USERS', 'USERNAME, EMAIL', 'USERNAME = ' . singleQuote($to_user));
        if (empty($user))
		  return;
        //if ($srer_rec['SEND_EMAIL'] === CLX_NUM_ONE) {
        if (0+$srer_rec['SEND_EMAIL'] === CLX_NUM_ONE) {
		  clx_mail_queue($user['EMAIL'], $user['EMAIL'], str_replace('REPLACE_URL', kWebSite . $url, $msg), $subject);
        }
        //sending alert
        //if ($srer_rec['CREATE_ALERT'] === CLX_NUM_ONE) {
        if (0+$srer_rec['CREATE_ALERT'] === CLX_NUM_ONE) {
		  alrt_send(str_replace('REPLACE_URL', $url, $msg), 'now', $user['USERNAME']);
        }
        //creating tasks
        //if ($srer_rec['CREATE_TASK'] === CLX_NUM_ONE) {
        if (0+$srer_rec['CREATE_TASK'] === CLX_NUM_ONE) {
		  //Create Tasks
		  $task = array();
		  $task['STATUS'] = 'IDLE';
		  $task['TYPE'] = 'FIEK';
		  $task['SUBJECT'] = $subject;
		  $task['description'] = strip_tags(str_replace('REPLACE_URL', kWebSite . $url, $msg));
		  $task['PERCENT_COMPLETE'] = '0';
		  $task['COMPLETE_DATE'] = 'null';
		  $task['PRIORITY'] = 'N';
		  $task['OWNERCODE'] = $user['username'];
		  $task['ASSIGNEDTO'] = $user['username'];
		  $task['REMINDER_DATETIME'] = 'null';
		  $task['RECURRING'] = 'NONE';
		  $task['DEPENDS'] = '0';
		  $task['START_DATE'] = getNow('Y-m-d H:i:s');
		  $task['DUE_DATE'] = '';
		  ClxCommon::$db->createRecord('CLX_US_TASKS', $task, false);
        }//end if task
    }

}
