<?php
/**
* General Code File
* For more information contact  support@alenet.com
* 
* @author       Edgard Campos
* @copyright    Alenet, Inc.
* @since        $Date: 2020-06-26 15:01:21 -0500 
* @version        $Rev: 0001 $
* 
* CHANGE LOG
**/

class web_services {

	var $curl;
	var $token_type;
	var $access_token;
	
	var $error;
	var $message;	
	/**
	 * Constructor
	 */
	function __construct() {
        $token_type=null;
		$access_token=null;
		$error='';
		$message='';
		$tool = &getTool('CODE'); 
	} // end function
	
	function ws_login() {
		$this->curl = curl_init();

		curl_setopt_array($this->curl, array(
		  CURLOPT_URL => CODE_IBS_WS_URL_LOGIN,
		  CURLOPT_RETURNTRANSFER => true,
		  CURLOPT_ENCODING => "",
		  CURLOPT_MAXREDIRS => 10,
		  CURLOPT_TIMEOUT => 0,
		  CURLOPT_FOLLOWLOCATION => true,
		  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		  CURLOPT_CUSTOMREQUEST => "POST",
		  CURLOPT_POSTFIELDS =>"\r\n{\r\n  \"username\" : \"".CODE_IBS_WS_USERNAME."\",\r\n  \"password\" : \"".CODE_IBS_WS_PASSWORD."\"\r\n\r\n}",
		  CURLOPT_HTTPHEADER => array(
			"x-api-key: ".CODE_IBS_WS_API_KEY,
			"Content-Type: application/json"
		  ),
		));

		$response = curl_exec($this->curl);
        //$errno = curl_errno($this->curl)
		//Si hay un error en la conexión capturo el error
		if ($this->isErrorCurl($this->curl)) {
    		$response=null;
		}else{
			//convierte JSON en un Arreglo
			//echo "la respuesta es ujn Json";
			//pre ($response);
			$response = json_decode($response,TRUE);
				
		    //verifico que no haya recibido un error en el header de la respuesta
			if ($this->isErrorHeader($response)){
				$response=null;
			}else{
				// si la respuesta no tiene error en el header tomó el token
				$this->token_type=$response['token_type'];
				$this->access_token=$response['access_token'];			
				
			}

				//No hay token entonces busco la razón del error
				/*$response=$response[0];
				$this->error=$response['level'];	
				$this->message=$response['message'];
				$response=null;*/
				
			
			/*if (is_string($response) && !$this->isJson($response)){
				//La respuesta es un error de tipo status=400,500, etc; se recibe en XML no un JSON
				//se convierte XML en un objeto -> JSON -> luego obtener el arreglo
				//convierte  xml string en un objeto
				//echo $response;
				$xml_response = simplexml_load_string($response);
				//convierte  objeto en un JSON
				$json_response = json_encode($xml_response);
				//convierte JSON en un Arreglo
				$response = json_decode($json_response,TRUE);
				$this->error=$response['status'].' '.$response['error'];
				$this->message='';
				$response=null;

			} */
			/*if ($this->isJson($response)){
	
			}*/
		
		}
	
			
		
		
		//curl_close($this->curl);
		return $response;

	} // end function
	
	function ws_logout() {
 		curl_close($this->curl);
    }
	
	function isJson($string) {
 		json_decode($string);
 		return (json_last_error() == JSON_ERROR_NONE);
    }
	
	function getError() {
 		return $this->error. ' : ' . $this->message ;
    }
	
	function isErrorCurl($curl) {
		//Si hay un error en la conexión capturo el error
		if($errno = curl_errno($curl)) {
    		$error_message = curl_strerror($errno);
    		//echo "cURL error ({$errno}):\n {$error_message}";
			$this->error="{$errno}";	
			$this->message= "{$error_message}";
			return true;
		}else{
			return false;
		}
	
	}
	
	function isErrorHeader($response) {
		//pre ($response);
	    //$http_code = curl_getinfo( $this->curl, CURLINFO_HTTP_CODE);
		//echo $http_code;
		//El error viene en el header
		switch ($http_code = curl_getinfo( $this->curl, CURLINFO_HTTP_CODE)) {
			case 200: return false;# OK
				      break;
			case 400: $this->error='Error 400';	
					  $this->message='Bad Request';
				      return true;
					  break;	
			case 401: $this->error='Error 401';	
					  $this->message='No Autorizado';
				      return true;
					  break;
			case 404: $this->error='Error 404';	
					  $this->message='No Encontrado';
				      return true;
					  break;
			case 409: $this->error='Advertencia';	
					  $this->message='Un criterio no coincide. Verificar o corregir criterios';
				      return false;
					  break;
/*			case 500: $this->error='Error 500';	
					  $this->message='Error Interno en el Servidor';
				      return true;
					  break;	*/	
			default:
				//procesamos el error que llego, puede venir de dos formas. Identificamos cuál
				if (array_key_exists('errors', $response)){
					//con error 500 me puede venir la descripcion del error de esta forma
					$response=$response['errors'][0];
					//$response=$response[0];
					$this->error=$response['level'];	
					$this->message=$response['message'];
					//echo 'Unexpected HTTP code: ', $http_code, "\n";
				}else{
					//El error viene en otra estructura
					$response=$response[0];
					$this->error=$response['level'];	
					$this->message=$response['message'];
				}
				return true;
	    }
    }
	
	
	function ws_search_client($record){
		  $this->curl = curl_init();
		  $legalType='';
		  if ($record['ACCO_LEGAL_TYPE']=='I'||$record['ACCO_LEGAL_TYPE']=='E'){
			 $legalType='personal';
		  }else{
			 $legalType='corporate'; 
		  }

		  curl_setopt_array($this->curl, array(
		  CURLOPT_URL => CODE_IBS_WS_URL_COSTUMER_SEARCH."/".$legalType."/". $record['ACCO_IBS_CUSCUN'] ."/INQUIRY",
		  CURLOPT_RETURNTRANSFER => true,
		  CURLOPT_ENCODING => "",
		  CURLOPT_MAXREDIRS => 10,
		  CURLOPT_TIMEOUT => 0,
		  CURLOPT_FOLLOWLOCATION => true,
		  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		  CURLOPT_CUSTOMREQUEST => "GET",
		  CURLOPT_HTTPHEADER => array(
			"Authorization: ".$this->token_type." ".$this->access_token,
			"Content-Type: application/json"
		  ),
		));

		$json_response = curl_exec($this->curl);

		if ($this->isErrorCurl($this->curl)) {
    		$response=null;
		}else{
			//convierte el JSON en un arreglo
			$response=json_decode($json_response,TRUE);	
			
			//verifico que no haya recibido un error en el header de la respuesta
			if ($this->isErrorHeader($response)){
				$response=null;
			}
			return 	$response;
		}
	}
	
	
	function ws_mapping_fields_acco_personal_response($response_search){
		//Si es persona natural mapeamos lo siguiente
		$ar_acco=array();
			
		$ar_acco['IDCODE'] = 'AUTO';
		$ar_acco['IDNAME'] = $response_search['shortName'];
		$ar_acco['FIRSTNAME'] = $response_search['firstName'];
		$ar_acco['SECOND_NAME'] = $response_search['secondName'];
		$ar_acco['LASTNAME'] = $response_search['lastName'];
		$ar_acco['SECOND_LASTNAME'] = $response_search['secondLastName'];


		if ($response_search['legalType']=='2'){
			$ar_acco['LEGAL_TYPE'] = 'I';
			$isindividual=true;
		}else{
			$ar_acco['LEGAL_TYPE'] = 'C';
			$isindividual=false;
		}
		//$a_response['LEGAL_TYPE'] = $record['ACCO_LEGAL_TYPE'];
		$ar_acco['ACCTYPE']='CUST';
		if ($response_search['id1Type']=='CIP'){
			$ar_acco['ID_TYPE'] = 'CIV';
		}else{
			$ar_acco['ID_TYPE'] = $response_search['id1Type'];
		}

		$ar_acco['IDENTIFICATION'] = $response_search['identification1'];
		$ar_acco['IDISS_DT'] = '0000-00-00';
		$ar_acco['IDEXP_DT'] = '0000-00-00';

		$ar_acco['IBS_CUSCUN'] = $response_search['customerNumber'];
		$ar_acco['ISINDIVIDUAL'] = $isindividual;

		$ar_acco['MARRIED_NAME'] = $response_search['marriedSurname'];
		$ar_acco['ADDRESS1'] = $response_search['addressLine2'].'.'.$response_search['addressLine3'];
		$ar_acco['ADDRESS2'] = $response_search['addressLine4'];
		$ar_acco['CITY'] = $response_search['city'];
		$ar_acco['STATE'] = $response_search['state'];
		$ar_acco['COUNTRY'] = $response_search['country'];
		$ar_cont['CITIZENSHIP'] = $response_search['citizenship'];
		$ar_cont['ZIPCODE'] = $response_search['zipCode'];

		$ar_acco['BIRTH_COUNTRY'] = $response_search['birthCountry'];
		$ar_acco['BIRTHDATE'] = $response_search['birthYear'].'-'.$response_search['birthMonth'].'-'.$response_search['birthDay'];

		$ar_acco['SEX'] = $response_search['gender'];
		$ar_acco['MARITAL_STATUS'] = $response_search['maritalStatus'];

		// ACCSTAT, comentario: CUSTOMER STATUS '2.Inactivo 1.Activo 3.Lista Negra'
		$ar_acco['ACCSTAT'] = ($response_search['customerStatus'] === '2') ? 'I' : 'A';

		//Obtener calificación de riesgo
		switch ($response_search['d01RSL']) {
			// Persona Natural
			case 'RIESGO ALTO': $ar_acco['RISK_LEVEL']='A';
								break;
			case 'RIESGO MEDIO': $ar_acco['RISK_LEVEL']='M';
								 break;
			case 'RIESGO BAJO': $ar_acco['RISK_LEVEL']='B';
								break;
			default : $ar_acco['RISK_LEVEL']='N/A';
					  break;
		}

		$ar_acco['PHONE'] = $response_search['phone1'];
		$ar_acco['HOME_PHONE'] = $response_search['homePhone'];
		$ar_acco['EMAIL'] = $response_search['emailAddress'];

		$ar_acco['REFERREDBYNAME'] = $response_search['referByName'];
		//$ar_acco['INDUSTRYCLASS'] = $response_search['emailAddress'];

		$ar_acco['IDISS_DT'] = '0000-00-00';
		$ar_acco['IDEXP_DT'] = '0000-00-00';

		$ar_acco['CLIENT_SINCE_DATE'] = $response_search['registerYear'].'-'.$response_search['registerMonth'].'-'.$response_search['registerDay'];

		return $ar_acco;				
	}
	
	function ws_mapping_fields_acco_corporate_response($response_search){
		//Si es persona natural mapeamos lo siguiente
		$ar_acco=array();
			
		$ar_acco['IDCODE'] = 'AUTO';
		$ar_acco['IDNAME'] = $response_search['legalName'];
		$ar_acco['ID_TYPE'] = $response_search['id1Type'];
		$ar_acco['IDENTIFICATION'] = $response_search['identification1'];

		$ar_acco['LEGAL_TYPE'] = 'C';
		
		$ar_acco['IBS_CUSCUN'] = $response_search['customerNumber'];
		$ar_acco['ISINDIVIDUAL'] = false;
		$ar_acco['ADDRESS1'] = $response_search['addressLine2'].'.'.$response_search['addressLine3'];
		$ar_acco['ADDRESS2'] = $response_search['addressLine4'];
		$ar_acco['CITY'] = $response_search['city'];
		$ar_acco['STATE'] = $response_search['state'];
		$ar_acco['COUNTRY'] = $response_search['country'];
		$ar_acco['ZIPCODE'] = $response_search['zipCode'];
		$ar_acco['ACCTYPE'] = 'CUST';
		
		$ar_acco['LEGAL_NAME'] = $response_search['addressLine1'];
		
		$ar_acco['INCORPORATION_COUNTRY'] = $response_search['foundationCountry'];
		$ar_acco['INCORPORATION_DATE'] = $response_search['foundingYear'].'-'.$response_search['foundingMonth'].'-'.$response_search['foundingDay'];
		
		$ar_acco['CORRESPONDENCE_LANGUAGE'] =  ($response_search['language'] === 'S' ? 'SP' : ($response_search['language'] === 'E' ? 'EN' : $response_search['language']));
		
		// ACCSTAT, comentario: CUSTOMER STATUS '2.Inactivo 1.Activo 3.Lista Negra'
		$ar_acco['ACCSTAT'] = ($response_search['customerStatus'] === '2') ? 'I' : 'A';
		$ar_acco['PHONE'] = $response_search['businessPhone'];
		$ar_acco['FAX'] = $response_search['businessPhone2'];
		$ar_acco['EMAIL'] = $response_search['emailAddress'];
		
		//$ar_acco['INDUSTRYCLASS'] = $response_search['emailAddress'];
		
		return $ar_acco;				
	}
} // end class
?>