var util_msg1 = 'Failure to send parent form information: JSERR20130607';
var util_msg2 = 'Failure to send parent form information: JSERR20130606';
var util_msg3 = "Unicode Character '<!texto1!>' cannot be encoded using standard URL encoding.\n" +
        "(URL encoding only supports 8-bit characters.)\n" +
        'A space (+) will be substituted.';
var util_msg4 = 'Bad escape combination near ...<texto1>';
/**
 * General Javascripts utilities
 * used system wide
 */
// -----------------------------------------------------------------------------
/**
 * Clears form field value
 */
function clearFieldValue(sourceid) {
    $('#' + sourceid).val('');
}
/**
 * Move all selected items to destination box, if clone set to true for copy
 * otherwise false
 * @param sourceid
 * @param destinationid
 * @param clone
 * @return
 */
function moveSelectItems(sourceid, destinationid, clone)
{
    if (clone) {
        $('#' + sourceid + '  option:selected').clone().appendTo('#' + destinationid);
    } else {
        $('#' + sourceid + '  option:selected').appendTo('#' + destinationid);
    }
}

/**
 * Move all items to destination box
 * @param sourceid
 * @param destinationid
 * @param clone
 * @return
 */
function moveSelectItemsAll(sourceid, destinationid, clone)
{
    if (clone) {
        $('#' + sourceid + ' option').clone().appendTo('#' + destinationid);
    } else {
        $('#' + sourceid + ' option').appendTo('#' + destinationid);
    }
}

/**
 * Remove selected item
 * @param sourceid
 * @return
 */
function removeSelectItems(sourceid)
{
    $('#' + sourceid + ' option:selected').remove();
}

/**
 * Remove all item
 * @param sourceid
 * @return
 */
function removeSelectItemsAll(sourceid)
{
    $('#' + sourceid + ' option').remove();
}

/**
 * Order items according direction, multiple selector enabled
 * Allowed direction 'up','down','first','last'
 * @param sourceid
 * @param dir
 * @return
 */
function moveSelectedItem(sourceid, direction) {
    var sel = $('#' + sourceid + ' option:selected');
    switch (direction) {
        case 'up':
            sel.each(function () {
                var self = this;
                $(self).insertBefore($(self).prev());
            });
            break;
        case 'down':
            $(sel.get().reverse()).each(function () {
                var self = this;
                $(self).insertAfter($(self).next());
            });
            break;
        case 'first':
            $(sel.get().reverse()).each(function () {
                var self = this;
                if ($('#' + sourceid + ' option:first').val() !== $(self).val()) {
                    $(self).insertBefore($('#' + sourceid + ' option:first'));
                }
            });
            break;
        case 'last':
            $(sel.get().reverse()).each(function () {
                var self = this;
                if ($('#' + sourceid + ' option:last').val() !== $(self).val()) {
                    $(self).insertAfter($('#' + sourceid + ' option:last'));
                }
            });
            break;
        default:
            break;
    }//end switch
}

// -----------------------------------------------------------------------------

function setFormAction(formid, action) {
    var form = document.getElementById(formid);
	form.ac.value = action;
}

function selectAllSelectors(formid) {
    var tform = document.getElementById(formid);
    var max = tform.elements.length;
    for (var i = 0; i < max; i++) {
        var elem = tform.elements[i];
        if (elem.name.indexOf('selector_') != -1) {
            elem.checked = tform.elements.masive_selector.checked;
        }
    }

    selectButtons(formid);
}

function selectButtons(formid) {
    var tform = document.getElementById(formid);
    var count = 0;
    var max = tform.elements.length;
    for (var i = 0; i < max; i++) {
        var elem = tform.elements[i];
        if (elem.name.indexOf('selector_') != -1 && elem.checked) {
            count++;
        }
    }
    setButtonGroup(formid, 'MULT', (count > 0));
    setButtonGroup(formid, 'ONE', (count == 1));
    setButtonGroup(formid, 'TWO', (count > 1));
}

function setButtonGroup(formid, groupname, status) {
    var form = document.getElementById(formid);
    var qty = form.length;

    for (var i = 0; i < qty; i++) {
        if (form.elements[i].id == groupname) {
            form.elements[i].disabled = !status;

        }
    }
}
//------------------------------------------------------------------------------
function copyFormFieldData(fromfield, tofield) {
    $('#' + tofield).val($('#' + fromfield).val());
}

//-----------------------------------------------------------------------------

function playSound(soundame) {
    var newdiv = $('<audio id = "' + soundame + '" autoplay=false><source src="' + clxskn + '/sounds/' + soundame + '.wav" type="audio/wav" /><source src="' + clxskn + '/sounds/' + soundame + '.mp3" type="audio/mp3" /></audio>');
    $('body').append(newdiv);
    $('#' + soundame).Play();
    $('#' + soundame).remove();
}

//------------------------------------------------------------------------------

function check_alert() {
    playSound('alert');
}

//------------------------------------------------------------------------------

function loadWaitPane() {
    if ($('#loading').val() == undefined) {
        var newdiv = $('<div id="loading" name="loading" style="display:none; width: 100%; height: 100%;"></div>');
        newdiv.html("<div class=\"ui-overlay\"><div class=\"ui-widget-shadow ui-corner-all\" style=\"width: 100%; height: 100%; position: absolute; left: 0px; top: 0px;\"></div><div class=\"ui-widget ui-widget-content ui-corner-all\" style=\"position: absolute; /*width: 100px; height: 100px;*/ left: 55%; top: 20%; padding: 10px;\"><center><img src=\"" + clxskn + "/icons/sqsWait.gif\"/></center></div></div>");
        $('body').append(newdiv);
    }
}

function showWait() {
    loadWaitPane();
    $('#loading').show();
}
function hideWait() {
    loadWaitPane();
    $('#loading').hide();
}
//------------------------------------------------------------------------------
function promptValueList(form_fieldname) {
    form_fieldname = document.getElementById(form_fieldname);
    var item = prompt(lblnewitem, '');
    if (item != null) {
        //var size = form_fieldname.length;
        $('#' + form_fieldname.id).prepend($('<option selected></option>').attr('value', 'new_' + item).text(item));
        $('#' + form_fieldname.id).prop('selectedIndex', 0);
    }
    return;
}

//
function write(txt) {
    document.write(txt);
}

function show_object_props(obj) {
    var props = '';
    for (var i in obj)
        props += '' + i + ' = ' + obj[i] + "<br>\n";
    return props;
}

function getImage(file) {
    var i = new Image();
    i.src = file;
    return i;
}

function donothing() {
    return;
}

// -- COOKIE FUNCTIONS --

function getCookie(name) {
    var arg = name + '=';
    var alen = arg.length;
    var clen = document.cookie.length;
    var i = 0;

    while (i < clen) {
        var j = i + alen;
        if (document.cookie.substring(i, j) == arg) {
            return getCookieVal(j);
        }
        i = document.cookie.indexOf(' ', i) + 1;
        if (i == 0) {
            break;
        }
    }
    return null;
}

function setCookie(name, value) {
    var argv = setCookie.arguments;
    var argc = setCookie.arguments.length;
    var expires = (argc > 2) ? argv[2] : null;
    var path = (argc > 3) ? argv[3] : null;
    var domain = (argc > 4) ? argv[4] : null;
    var secure = (argc > 5) ? argv[5] : false;
    var val = encodeURI(value);
    document.cookie = name + '=' + val +
            ((expires == null) ? '' : ('; expires=' + expires.toGMTString())) +
            ((path == null) ? '' : ('; path=' + path)) +
            ((domain == null) ? '' : ('; domain=' + domain)) +
            ((secure == true) ? '; secure' : '')+
			';SameSite=Lax';
}

function deleteCookie(name) {
    var exp = new Date();
    exp.setTime(exp.getTime() - 1);
    var cval = getCookie(name);

    document.cookie = name + '=' + cval + '; expires=' + exp.toGMTString();
}

/**
 * This javascript file checks for the brower/browser tab action.
 * It is based on the file menstioned by Daniel Melo.
 * Reference: http://stackoverflow.com/questions/1921941/close-kill-the-session-when-the-browser-or-tab-is-closed
 */
var validNavigation = false;
var sessionEnded = false;

/*Ending session*/
function endSession() {
    // Browser or broswer tab is closed
    // Do sth here ...
    if (!sessionEnded) {
        sessionEnded = true;
        unsetFormToCookie();

    }

}

function wireUpEvents() {
    /*
     * For a list of events that triggers onbeforeunload on IE
     * check http://msdn.microsoft.com/en-us/library/ms536907(VS.85).aspx
     */
    window.onbeforeunload = function () {
        if (!validNavigation) {
            endSession();
        }
    };

    // Attach the event keypress to exclude the F5 refresh
    $(document).bind('keypress', function (e) {
        if (e.keyCode == 116) {
            validNavigation = true;
        }
    });

    // Attach the event click for all links in the page
    $('a').bind('click', function () {
        validNavigation = true;
    });

    // Attach the event submit for all forms in the page
    $('form').bind('submit', function () {
        validNavigation = true;
    });

    // Attach the event click for all inputs in the page
    $('input[type=submit]').bind('click', function () {
        validNavigation = true;
    });

}

// Wire up the events as soon as the DOM tree is ready
$(document).ready(function () {
    wireUpEvents();
});

function unsetFormToCookie() {
    $.ajax({
        url: 'tool.php?to=clxmain&main=UNSETPRENTINF&nofr=1&no_menu=1&no_alerts=1&nofr=1',
        async: false,
        success: function (msg) {
        },
        error: function () {
            alert(util_msg1);
        }
    });
}

// -- CURRENT FORM COOKIE ARCHIVAL
function formToCookie(formid) {

    // serialize the data in the form
    var values = $('#' + formid).serialize();
    /* Send the data using post and put the results in a div */
    $.ajax({url: 'tool.php?to=clxmain&main=SETPRENTINF&nofr=1&no_menu=1&no_alerts=1&nofr=1', type: 'post', data: values, async: false, success: function (msg) {
        }, error: function () {
            alert(util_msg2);
        }
    });
}

// -- WINDOW FUNCTIONS --
/**
 * Opens new window. If title is set to '' it will open a new window
 */
var site;
var newDivw;
var activeWindow;
var positionsTop;
if (window.location == parent.location) {
    newDivw = [null, null, null, null, null];
	positionTop=[0,0,0,0,0];
    activeWindow = null;
    site = parent;
}

// ijamc 12-11-2015
// Nota los iframe no son ventanas hijas,nietas .., son todas hijas de la
// misma ventana madre, se trabaja con el content del iframe para llenar la
// anterior.
// parent.activeWindow mantiene el numero de ventana, el valor mas grande es
// la ventana activa.
// Se incrementa en el open, se cierra en el evento close del dialog
// Ningun dialog con su frame se destruyen, el dialog se crea y se mantiene
// todo el tiempo despues se reutilizan, para las demas ventanas.
// Por defecto son 5 ventanas var newDivw=[null,null,null,null,null];
var superpagina=null;
var superhijo=null;
function openWindowExecute(title, url, w, h, winclose,fieldsiteposition, objectSourceposition,posV=0) {
    var newD;
	interno1=document.getElementById('interno1');
	interno2=document.getElementById('interno2');
	interno3=document.getElementById('interno3');
	interno4=document.getElementById('interno4');
	interno5=document.getElementById('interno5');
	/*console.log('qqqqq interno1');
	console.log(interno1);
	console.log('qqqqq interno2');
	console.log(interno2);*/
	/*if ((typeof (parent) != "undefined" && typeof (parent.newDivw) == "undefined") || typeof (site) == "undefined") {
    */
	if (interno1 ==null) {
        newDivw = [null, null, null, null, null];
		positionTop=[0,0,0,0,0];
        activeWindow = null;
       
	//	alert('aca');
    }
	site = window;
    /*}*/
	
	if (objectSourceposition==2) {

		
	}
    if (typeof (site.newDivw) == 'object') {
		//posV=posV+100;
       // for (t = 0; t < site.newDivw.length; t++) {
		    console.log('prewindows 1 ');
		    console.log(site.activeWindow);
			if (site.activeWindow==null) {
				site.activeWindow=0;
			}
			else if (interno1 !=null) {
				console.log('acccccccaaaaaaaa');
				console.log(site.positionTop);
				posV=parseInt(site.positionTop[0]-5);
				console.log(posV);
			}
			console.log('prewindows 2 ');
			console.log(site.activeWindow);
			console.log('prewindows posV ');
			console.log(posV);
		    t=site.activeWindow;
            site.newDivw[t] = $(superpagina.document.createElement('div'));
            site.newDivw[t].prop('id', 'windowpop' + String(t));
			site.positionTop[t]=posV;
			//alert(posV);
            site.newDivw[t].dialog({autoOpen: false,
		/*	position: { my: 'left top', at: 'left+50 top+50'}, */
			position: ["center",posV],
			height: h, width: w, modal: true,
			   open: function(event, ui) {
					var el = $(this).closest('.ui-dialog').find('.ui-dialog-titlebar-close');
				//	el.off();
				
				
					el.bind( "click", function() {
						//closeWindow();
						removeFrame();
					//  alert( "User clicked on 'foo.'" );
					})
										
				},
                close: function (event, ui) {
                    $.ajax({
                        url: "pop.php?no_menu=1&no_alert=1&to=POPCLEAR&ventanapop=" + site.activeWindow
                    })
                            .done(function (data) {
                                //	alert(data);

                            })
                            .fail(function () {
                                //	alert( "error " );
                            });
				//	alert(22);
				//	site.newDivw[t]
					
                    site.activeWindow--;
					
					
                }
            });
       // }
      //  site.activeWindow = 0;

    }
	
    newD = site.newDivw[site.activeWindow];
    newD.prop('title', title);
    newD.prop('height', h);
    newD.prop('width', w);
	
    site.activeWindow++;
//	alert( site.activeWindow);
    if (winclose) {
        document.addEventListener("blur", function () {
            closeWindow();
        });
    }
	
	newD.dialog('open');
	//console.lo(newD.prop("height"));
	
	newD.html('<iframe id ="interno'+objectSourceposition +'" name ="interno'+objectSourceposition +'" src="'+url+'" width="100%" height="100%" seamless=1 scrolling="auto" frameborder=0></iframe>');
	
	//document.getElementsByTagName("IFRAME")[0].src=url;
	//window.open(url);
	/*var iframe = document.createElement('iframe');
    var html = '<body>Foo</body>';
    iframe.src = url;
    document.body.appendChild(iframe);*/

}

var objectSourceposition=0;
function openWindow(title, url, w, h, winclose,fieldsiteposition) {
    var newD;
	posV=150;
	objectPadre=null;
	
	posV+=30;
	console.log('posV:'+posV);
	//console.log(fieldsiteposition);
//	console.log('xxxxxxxxxxxxxxxxxx');
//	console.log(window.parent.document.getElementById('frameclientix'));
	objectSourceposition=0;
	if (window.parent.document.getElementById('frameclientix')!=null ) {
		superpagina=window;
		console.log('aqui1');
		objectSourceposition=1;
	}
	else { superpagina=window;
		
		if (window.parent !=null && window.parent!=window ) {
	//		console.log(window.parent);
			superpagina=window.parent;
			console.log('-----superpagina ivan2------------------');
			console.log(superpagina);
			console.log('-----superpagina ivan3--interno1----------------');
			console.log(superpagina.document.getElementById('interno1'));
			console.log('-----superpagina ivan3--interno2----------------');
			if (superpagina.document.getElementById('interno2')==null)
				objectSourceposition=2;
			else if (superpagina.document.getElementById('interno4')!=null)
				objectSourceposition=5;
			else if (superpagina.document.getElementById('interno3')!=null)
				objectSourceposition=4;
			else if (superpagina.document.getElementById('interno2')!=null)
				objectSourceposition=3;
			console.log('aqui2');
		}
		else {
			objectSourceposition=1;
			superpagina=window;
			console.log('aqui3');
		}
	}
	if (typeof fieldsiteposition !='undefined') {
		posV2=0;
		console.log($("[name="+fieldsiteposition+"_prim]").position());
		if ($("[name="+fieldsiteposition+"_prim]").position()!=null) {
			posV2=parseInt ($("[name="+fieldsiteposition+"_prim]").position().top);
			if (posV2!=0) {
				posV=posV2;
				objectPadre=$("[name="+fieldsiteposition+"_prim]");

			}
		}
	}	
	console.log('=================aaccca---1----------------');
	console.log($("[name="+fieldsiteposition+"]").position());
	console.log(fieldsiteposition);
	if ($("[name="+fieldsiteposition+"]").position()!=null) {
		console.log('=================aaccca---2----------------');
		console.log($("[name="+fieldsiteposition+"]").position().top);
		posV3=parseInt ($("[name="+fieldsiteposition+"]").position().top);
		if (posV3!=0) {
			posV=parseInt(posV3+30);
			objectPadre=$("[name="+fieldsiteposition+"]");
		}
	}
//	console.log('AL FINAL posV :'+posV);
    
	superpagina.openWindowExecute(title, url, w, h, winclose,fieldsiteposition, objectSourceposition,posV);
}


function closeWindowAndPref() {
    unsetFormToCookie();
    closeWindow();
}
function closeWindow() {//alert(parent.activeWindow);

    interno1=parent.document.getElementById('interno1');
	interno2=parent.document.getElementById('interno2');
	interno3=parent.document.getElementById('interno3');
	interno4=parent.document.getElementById('interno4');
	interno5=parent.document.getElementById('interno5');
	console.log(parent.newDivw);
	if (interno5!=null) {
		objectFather=window.parent;
		var newD = parent.newDivw[4];
		
    }
	else if (interno4!=null) {
		objectFather=window.parent;
		var newD = parent.newDivw[3];
		
    }
	else if (interno3!=null) {
		objectFather=window.parent;
		var newD = parent.newDivw[2];
		
    }
	else if (interno2==null) {
		objectFather=window.parent;
		var newD = parent.newDivw[0];
		
    }else if (interno2 !=null) {
		objectFather=window.parent;
		var newD = parent.newDivw[1];
		
    }
	else {
		var newD = parent.newDivw[0];
		objectFather=window;
	}
    newD.dialog('close');

	objectFather.removeFrame();

}
function removeFrame(){
	console.log('-----removeFrames------');
	var iframes = document.querySelectorAll('iframe');
	var i=iframes.length-1;
	if (i!=-1)
		iframes[i].parentNode.removeChild(iframes[i]);
//	console.log('----remove frames exit----');
//	console.log(iframes);
//	console.log('---');
}
function setLookupValue(afield, avalue) {
    var newD;

	interno1=parent.document.getElementById('interno1');
	interno2=parent.document.getElementById('interno2');
	interno3=parent.document.getElementById('interno3');
	interno4=parent.document.getElementById('interno4');
	interno5=parent.document.getElementById('interno5');
	/*console.log('-----Lookups values------');
	console.log("interno1");
	console.log(interno1);
	console.log("interno2");
	console.log(interno2);	*/
	if (interno2==null) {
	//	console.log('---search eee---');
        parent.assignValue(afield, js_remove_scape_caracteres(avalue));
		newD = parent.newDivw[0];
		
		
    }else if (interno2 !=null) {
		
		if (interno5!=null) {
		//	console.log('---search ddd-interno5--');
			interno4.contentWindow.assignValue(afield, js_remove_scape_caracteres(avalue));
			newD = parent.newDivw[4];
			
		}
		else if (interno4!=null) {
		//	console.log('---search ddd-interno4--');
			interno3.contentWindow.assignValue(afield, js_remove_scape_caracteres(avalue));
			newD = parent.newDivw[3];
			
		}
		else if (interno3!=null) {
		//	console.log('---search ddd -interno3--');
			interno2.contentWindow.assignValue(afield, js_remove_scape_caracteres(avalue));
			newD = parent.newDivw[2];
			
		}
		else {
		///	console.log('---search ddd- interno2--');
			interno1.contentWindow.assignValue(afield, js_remove_scape_caracteres(avalue));
			newD = parent.newDivw[1];
		}
    }
	else {
	///	console.log('---search rrr---');
		window.assignValue(afield, js_remove_scape_caracteres(avalue));
		newD = parent.newDivw[1];
    }
	removeFrame();
    newD.dialog('close');

}

/*function setLookupValue(afield, avalue) {
 var newD;
 if (parent.activeWindow == 1) {
 newD=parent.newDivw;
 }else if (parent.activeWindow == 2) {
 newD=parent.newDivw2;
 }
 else if (parent.activeWindow == 3) {
 newD=parent.newDivw3;
 }
 assignValue(afield, avalue);
 newD.dialog('close');
 //    activeWindow --;

 }*/

function setLookupValueNoClose(afield, avalue) {
    if (parent.activeWindow == 1) {
        parent.assignValue(afield, js_remove_scape_caracteres(avalue));
    } else if (parent.activeWindow > 1) {
        parent.document.getElementsByTagName('iframe')[parent.activeWindow - 2].contentWindow.assignValue(afield, js_remove_scape_caracteres(avalue));
    }
}

function assignValue(afield, avalue) {
    $('#' + afield).val(avalue).change();
}

// -- MENU FUNCTIONS --
function showHideMenu(panelname) {
	iframex();
	if (typeof(panelname)=='undefined')
		panelname='pagemenu';
    var menu = document.getElementById(panelname);
    if (menu.style.display == 'block') {
        hideMenu(panelname);
    } else {
        showMenu(panelname);
    }
}

function hideMenu(panelname) {
	
	if (typeof(panelname)=='undefined')
		panelname='pagemenu';
    var menu = document.getElementById(panelname);
    menu.style.display = 'none';
    setCookie(panelname, 'none');
	iframex();
}
function showMenu(panelname) {
	if (typeof(panelname)=='undefined')
		panelname='pagemenu';
    var menu = document.getElementById(panelname);
	if (menu.style.display != 'block') {
    menu.style.display = 'block';
    setCookie(panelname, 'block');
}
	else {
		hideMecnu(panelname);
	}
	iframex();
}

function getMenuStatus(panelname) {
	if (typeof(panelname)=='undefined')
		panelname='pagemenu';
    return getCookie(panelname);
}
// -- PANELS FUNCTIONS --
function showpanel(panelname) {
	if (typeof(panelname)=='undefined')
		panelname='pagemenu';
    var panel = document.getElementById(panelname);
    if (panel.style.display == '') {
        panel.style.display = 'none';
    } else {
        panel.style.display = '';
    }
	iframex('showpanel');
}

function hidepanel(panelname) {
	if (typeof(panelname)=='undefined')
		panelname='pagemenu';
    var panel = document.getElementById(panelname);
    panel.style.display = 'none';
	iframex('hidepanel');
}

function unhidepanel(panelname) {
	if (typeof(panelname)=='undefined')
		panelname='pagemenu';
    var panel = document.getElementById(panelname);
    panel.style.display = '';
	iframex('unhidepanel');
}

// -- TEXT FUNCTIONS --

function quote(aText) {
    return "\"" + aText + "\"";
}

function singleQuote(aText) {
    return "'" + aText + "'";
}

// ------------------------------------------------------------------------------------------

function getYear() {
    var d = new Date();
    return d.getFullYear();
}// End function


// -- ANCHOR FUNCTIONS --
//Function used by back button allow to clean the uri of the ancor when back button is press.
function clearUriAnchor(uri) {
    var winuri = '' + window.location;
    var winpos = winuri.indexOf('#');
    var pos = uri.indexOf('#');
    if (winpos > -1 && pos > -1) {
        uri = uri.substring(0, pos);
    }
    return uri;
}// End function

//Added to allow printing a section
function open_div_window(s_div_name, s_window_title, styles)
{
    var this_location=location.href;
    var divElements = document.getElementById(s_div_name).innerHTML;
    var oldPage = document.body.innerHTML;
    document.body.innerHTML = '<html><head><title>' + s_window_title + '</title></head><link href="' + styles + '" rel="stylesheet" type="text/css"><body>' + divElements + '</body>';
    //console.log("dddd1");
    window.print();
    //console.log("dddd2");
    document.body.innerHTML = oldPage;
	//console.log("dddd3"); 
	location.href=document.referrer;
	//console.log(this_location);
	//nsole.log( location.search);
	//console.log("dddd4");
    return true;
}

function lockFields(fieldname) {
    var thefield = document.getElementById(fieldname);
    thefield.readonly = 'true';
}

/**
 * sets readonly on forms
 * @param fieldname
 * @param is_readonly
 * @param non_readonly_class
 * @return
 */
function field_set_readonly(fieldname, is_readonly, non_readonly_class) {
    if (is_readonly) {
        $('#' + fieldname).attr('readonly', true);
        $('#' + fieldname).attr('class', 'readonly');
    } else {
        $('#' + fieldname).attr('readonly', false);
        $('#' + fieldname).attr('class', non_readonly_class);
    }
}

function url_encode_entities(text) {
    text.replace('#', '%23');
    text.replace("'", '%24');
    return text;
}//End function

function url_simple_encode(value)
{
    value = value.replace('#', '%23');
    value = value.replace("'", '%24');
    return value;
}

/**
 * see ui_listings
 * @param value
 */
function js_remove_scape_caracteres(value) {
    value = value.replace(/x080/g, '\\\"');
    value = value.replace(/x081/g, "\\\'");
    value = value.replace(/x082/g, '"');
    value = value.replace(/x083/g, "'");
    return value;
}
// ====================================================================
//       URLEncode and URLDecode functions
//
// Copyright Albion Research Ltd. 2002
// http://www.albionresearch.com/
//
// You may copy these functions providing that
// (a) you leave this copyright notice intact, and
// (b) if you use these functions on a publicly accessible
//     web site you include a credit somewhere on the web site
//     with a link back to http://www.albionresarch.com/
//
// If you find or fix any bugs, please let us know at albionresearch.com
//
// SpecialThanks to Neelesh Thakur for being the first to
// report a bug in URLDecode() - now fixed 2003-02-19.
// ====================================================================
function URLEncode(plaintext)
{
    // The Javascript escape and unescape functions do not correspond
    // with what browsers actually do...
    var SAFECHARS = '0123456789' + // Numeric
            'ABCDEFGHIJKLMNOPQRSTUVWXYZ' + // Alphabetic
            'abcdefghijklmnopqrstuvwxyz' +
            "-_.!~*'()";					// RFC2396 Mark characters
    var HEX = '0123456789ABCDEF';

    //var plaintext = document.URLForm.F1.value;
    var encoded = '';
    for (var i = 0; i < plaintext.length; i++) {
        var ch = plaintext.charAt(i);
        if (ch == ' ') {
            encoded += '+';				// x-www-urlencoded, rather than %20
        } else if (SAFECHARS.indexOf(ch) != -1) {
            encoded += ch;
        } else {
            var charCode = ch.charCodeAt(0);
            if (charCode > 255) {
                alert(util_msg3.replace("'<!texto1!>'", ch));
                encoded += '+';
            } else {
                encoded += '%';
                encoded += HEX.charAt((charCode >> 4) & 0xF);
                encoded += HEX.charAt(charCode & 0xF);
            }
        }
    } // for

    return encoded;
    //return false;
}
;

function URLDecode(encoded)
{
    // Replace + with ' '
    // Replace %xx with equivalent character
    // Put [ERROR] in output if %xx is invalid.
    var HEXCHARS = '0123456789ABCDEFabcdef';
    // var encoded = document.URLForm.F2.value;
    var plaintext = '';
    var i = 0;
    while (i < encoded.length) {
        var ch = encoded.charAt(i);
        switch (ch) {
            case '+':
                plaintext += ' ';
                i++;
                break;
            case '%':
                if (i < (encoded.length - 2)
                        && HEXCHARS.indexOf(encoded.charAt(i + 1)) != -1
                        && HEXCHARS.indexOf(encoded.charAt(i + 2)) != -1) {
                    plaintext += unescape(encoded.substr(i, 3));
                    i += 3;
                } else {
                    alert(util_msg4.replace('<texto1>', encoded.substr(i)));
                    plaintext += '%[ERROR]';
                    i++;
                }
                break;
            default:
                plaintext += ch;
                i++;
                break;
        }
    } // while
    return plaintext;
    //return false;
}
;

/**
 * Write content to a leyer
 */
function WriteLayer(ID, parentID, sText) {
    document.getElementById(ID).innerHTML = sText;
}//End function

/**
 * Submit Form
 */
function theFormSubmit(formname) {
    var form = document.getElementById(formname);
    form.submit();
}//End function


//---------------------------------------------------------------------------
// Ajax section
//---------------------------------------------------------------------------
// JavaScript Document
function handleClxHttpResponse()
{
    if (clxHttpAjax.readyState == 4) {
        if (clxHttpAjax.status == 200) {
            var response = clxHttpAjax.responseText;
            var lines = response.split('<-container>');
            var clxResultContainer = document.getElementById(lines[0]);
            if (!typeof (clxResultContainer) == 'object') {
                document.getElementById(clxResultContainer).innerHTML = 'WebServices Error: ' + "\n" + '<TABLE BORDER=1><TR><TD>' + lines[0] + '</TD></TR></TABLE><BR>' + lines[1];
            } else {
                document.getElementById(clxResultContainer).innerHTML = lines[1];
            }
        } else if (clxHttpAjax.status == 404) {
            document.getElementById(clxResultContainer).innerHTML = 'Web Services Error [2]: Adress does\'nt exists / La dirección no existe';
        } else {
            document.getElementById(clxResultContainer).innerHTML = 'Web Services Error [3]: ' + "\n" + '<TABLE BORDER=1><TR><TD>' + clxHttpAjax.status + '</TD></TR></TABLE>';
        }
    }
}//end function
//----------------------------------------------------------------------------

function sendFullRequestRedirected(url, redirect) {
    if (url != '') {
        clxHttpAjax.open('GET', url, true);
        clxHttpAjax.onreadystatechange = handleClxHttpResponse;
        clxHttpAjax.send(null);
        window.location = redirect;
    }
}

function sendFullRequest(url) {
    if (url != '') {
        clxHttpAjax.open('GET', url, true);
        clxHttpAjax.onreadystatechange = handleClxHttpResponse;
        clxHttpAjax.send(null);
    }
}

function sendRequest(result_container, parameters) {
    if (result_container == '') {
        result_container = 'divajax';
    }
    //  var clxResultContainer = result_container;
    parameters = parameters.replace('to=', 'tto=');
    parameters = parameters.replace('ac=', 'tac=');
    if (parameters != '') {
        parameters = '&' + parameters;
    }
    var url = 'ajax.php?to=EDIT&ac=AJAX&reslt=' + result_container + parameters;//?ls=TES2&lsp=TES1&lspi=VE";
    //var u = url + "?fl="+fieldobj.name+"&it="+fieldobj.value;
    clxHttpAjax.open('GET', url, true);
    clxHttpAjax.onreadystatechange = handleClxHttpResponse;
    clxHttpAjax.send(null);
}

function clxHTTPObject() {
    var xmlhttp;
    if (!xmlhttp && typeof XMLHttpRequest != 'undefined') {
        try {
            xmlhttp = new XMLHttpRequest();
        } catch (e) {
            xmlhttp = false;
        }
    }
    return xmlhttp;
}
var clxHttpAjax = clxHTTPObject(); // We create the HTTP Object
var clxResultContainer;
//---------------------------------------------------------------------------
// End Ajax section
//---------------------------------------------------------------------------

/**
 * Set number of decimals on number
 */
function numDec(num, dig) {
    return  parseFloat(num).toFixed(dig);
}// End function


/**
 * Used on
 */
function initDbList(fieldname, listcode, selected) {
    $.ajax({type: 'GET',
        url: 'window.php?to=DBLT&ac=LIST_XML&lc=' + listcode,
        dataType: 'xml',
        success: function (xml) {
            $(xml).find('ENTRY').each(function () {
                var self = this;
                var value = $(self).attr('ID');
                $('#' + fieldname).append(new Option($(self).text(), value));
                if (selected == value) {
                    $('#' + fieldname).val(value).attr('selected', 'selected');
                }
            });
        }
    });
}//end function

/**
 * Get's idlist and opens a window
 */
function getIdlistOpenWindow(title, url, height, width) {
    var name = '';
    $('input:checked').each(function () {
        var self = this;
        name = $(self).attr('name');
    });
    var idlist = (name.substring(9));
    url += '&idlist=' + idlist;
    openWindow(title, url, height, width);
}

/**
 * Calculate days in base 360
 * @param sdate YYYY-MM-DD
 * @param edate YYYY-MM-DD
 * @param method Bolean, true = us 360, false = ue360
 * @returns int
 */
function days_between_360(sdate, edate, method)
{
    if (method) {
        return Thirty360USdayCount(sdate, edate);
    } else {
        return Thirty360EUdayCount(sdate, edate);
    }
}

/**
 * Builds day count on base 360
 * @param sdate
 * @param edate
 * @returns
 */
function Thirty360USdayCount(sdate, edate) {

    if (edate == undefined || sdate == undefined || edate == '' || sdate == '') {
        return 0;
    }
    var d1 = parseDate(sdate);
    var d2 = parseDate(edate);

    var dd1 = d1.getDate();
    var mm1 = (d1.getMonth() + 1);
    var yy1 = d1.getFullYear();
    var dd2 = d2.getDate();
    var mm2 = (d2.getMonth() + 1);
    var yy2 = d2.getFullYear();

    if (dd2 == 31 && dd1 < 30) {
        dd2 = 1;
        mm2++;
    }
    return 360 * (yy2 - yy1) + 30 * (mm2 - mm1 - 1) + Math.max(0, 30 - dd1) + Math.min(30, dd2);
}

function Thirty360EUdayCount(sdate, edate) {

    var d1 = parseDate(sdate);
    var d2 = parseDate(edate);

    var dd1 = d1.getDate();
    var mm1 = (d1.getMonth() + 1);
    var yy1 = d1.getFullYear();
    var dd2 = d2.getDate();
    var mm2 = (d2.getMonth() + 1);
    var yy2 = d2.getFullYear();

    return 360 * (yy2 - yy1) + 30 * (mm2 - mm1 - 1) + Math.max(0, 30 - dd1) + Math.min(30, dd2);
}

function days_between(edate, sdate) {
    if (edate == undefined || sdate == undefined || edate == '' || sdate == '') {
        return 0;
    }
    var date1 = parseDate(edate);
    var date2 = parseDate(sdate);

    // The number of milliseconds in one day
    var ONE_DAY = 1000 * 60 * 60 * 24;

    // Convert both dates to milliseconds
    var date1_ms = date1.getTime();
    var date2_ms = date2.getTime();

    // Calculate the difference in milliseconds
    var difference_ms = Math.abs(date1_ms - date2_ms);

    // Convert back to days and return
    return parseFloat(Math.round(difference_ms / ONE_DAY));

}

function parseDate(str) {

    if (str == undefined) {
        return;
    }
    var format = getformatdate();
    var mdy = splitdateformat(str);
    var x = new Date();
    //alert(format);
    //alert(str);
    if (format[0] == 'Y') {
        x.setFullYear(mdy[0], mdy[1] - 1, mdy[2]);
    }
    else {
        x.setFullYear(mdy[2], mdy[1] - 1, mdy[0]);
    }
    return x;
}

function splitdateformat(str){
    var format=getformatdate();
    return str.split(format[3]);
}
function normalize_date(Strdate) {
    var format = getformatdate();
    var fec = splitdateformat(Strdate, format);
    var Objdate;
    if (format[0] == 'Y') {
        Objdate = new Date(fec1[0], fec2[1] - 1, fec[2]);
    }
    else {
        Objdate = new Date(fec1[2], fec2[1] - 1, fec[0]);
    }
    return Objdate;
}
function years_between(edate, sdate) {
    var date1 = normalize_date(sdate);
    var date2 = normalize_date(edate);

    // The number of milliseconds in one day
    var month_diff = parseFloat((date2.getFullYear() - date1.getFullYear()) * 12 + date2.getMonth() - date1.getMonth());
    return Math.floor((month_diff / 12));
}


/**
 * Returns current date time  YYYY-MM-DD H:M:S
 * @returns {String}
 */
function getDateNow() {
    var format = getformatdate();
    var ct = new Date();
    var y = ct.getFullYear();
    var m = ct.getMonth() + 1;
    if (m < 10) {
        m = '0' + m;
    }
    var d = ct.getDate();
    if (d < 10) {
        d = '0' + d;
    }
    var h = ct.getHours();
    if (h < 10) {
        h = '0' + h;
    }
    var g = ct.getMinutes();
    if (g < 10) {
        g = '0' + g;
    }
    var s = ct.getSeconds();
    if (s < 10) {
        s = '0' + s;
    }
    var separator = format[3];
    if (format[0] === 'Y')
        return y + separator + m + separator + d + ' ' + h + ':' + g + ':' + s;
    else
        return d + separator + m + separator + y + ' ' + h + ':' + g + ':' + s;
}
/**
 * Returns current date YYYY-MM-DD
 * @returns {String}
 */

function getDateToday() {
    var format = getformatdate();
    var ct = new Date();
    var y = ct.getFullYear();
    var m = ct.getMonth() + 1;
    if (m < 10) {
        m = '0' + m;
    }
    var d = ct.getDate();
    if (d < 10) {
        d = '0' + d;
    }
    var separator = format[3];
    if (format[0] === 'Y')
        return y + separator + m + separator + d;
    else
        return d + separator + m + separator + y;

}

function getIsoDateFromDateTime(ct) {
    var format = getformatdate();
    var y = ct.getFullYear();
    var m = ct.getMonth() + 1;
    if (m < 10) {
        m = '0' + m;
    }
    var d = ct.getDate();
    if (d < 10) {
        d = '0' + d;
    }
    var h = ct.getHours();
    if (h < 10) {
        h = '0' + h;
    }
    var g = ct.getMinutes();
    if (g < 10) {
        g = '0' + g;
    }
    var s = ct.getSeconds();
    if (s < 10) {
        s = '0' + s;
    }

    if (format[0] == 'Y')
        return y + format["3"] + m + format["3"] + d + ' ' + h + ':' + g + ':' + s;
    else
        return d + format["3"] + m + format["3"] + y + ' ' + h + ':' + g + ':' + s;

}

function getIsoDateFromDate(ct) {
    var format = getformatdate();
    var y = ct.getFullYear();
    var m = ct.getMonth() + 1;
    if (m < 10) {
        m = '0' + m;
    }
    var d = ct.getDate();
    if (d < 10) {
        d = '0' + d;
    }
    if (format[0] == 'Y')
        return y + format["3"] + m + format["3"] + d;
    else
        return d + format["3"] + m + format["3"] + y;
}

/*sets date intervals
 * Intervals are: D, M, Q, S, Y
 */
function setDateInterval(sdate, per, number) {

    var num = parseInt(number);
    var dt = parseDate(sdate);

    switch (per) {
        case 'D': //Days
            dt.setDate(dt.getDate() + num);
            break;
        case 'W': //Weeks
            dt.setDate(dt.getDate() + (7 * num));
            break;
        case 'M': // Month
            dt.setMonth(dt.getMonth() + num);
            break;
        case 'Q': // Quarters
            dt.setMonth(dt.getMonth() + (num * 3));
            break;
        case 'S': // Semesters
            dt.setMonth(dt.getMonth() + (num * 6));
            break;
        case 'Y': // Years
            dt.setFullYear(dt.getFullYear() + (num * 1));
            break;
        default:
            break;
    }

    //return getIsoDateFromDate(dt, format);
    return getIsoDateFromDate(dt, getformatdate());
}
/**
 * Returns current date YYYY-MM-DD
 * sdate datestring
 * @returns {format}
 */


function getformatdate() {

    /*var mdy;
    if (formatprefsdate.substring(2,1)=='-' || formatprefsdate.substring(4,1)=='-') {
	 separator ="-";
	 mdy=formatprefsdate.split('-');
    }
    else {
        separator = "/";
        mdy = formatprefsdate.split('/');
    }
    if (mdy[0] === 'd')
        format = ["D", "M", "Y", separator];
    else
        format = ["Y", "M", "D", separator];*/
    format = ["Y", "M", "D", '-'];
    return format;
}
function toparseDate(str) {

    var format = getformatdate();
    var mdy;
    if (str.indexOf("-") > 0) {
        mdy = str.split('-');
    }
    else {
        mdy = str.split('/');
    }
    var separator = format["3"];
    if (mdy[0].length >= 4) {
        if (format[0] == 'Y')
            return mdy[0] + separator + mdy[1] + separator + mdy[2];
        else
            return mdy[2] + separator + mdy[1] + separator + mdy[0];
    }
    else {
        if (format[2] == 'Y')
            return mdy[0] + separator + mdy[1] + separator + mdy[2];
        else
            return mdy[2] + separator + mdy[1] + separator + mdy[0];
    }
}


/*disable object*/
function disableButton(btnObj) {
    btnObj.disabled = true;
}

/*Prevent resubmition of form*/
function formPreventResubmit(formObj) {

    if (formObj.submitStatus == undefined) {
        formObj.submitStatus = 1;
        return true;
    } else {
        return false;
    }
}
function iframex() {
	return;
	
	
	
	
	
	
	/*	console.log(parent.document.body.scrollWidth);
		var iframe = parent.document.getElementById("frameclientix");
		console.log(iframe.scrollWidth);
		console.log('eee1');
		console.log(this.width);
		console.log('eee2');
	// Adjusting the iframe height onload event
	    h=(parseInt($("#pagemenu").parent().css('height'))+20);
		if (h<900)
		   h=900;
		/*##console.log(typeof (document.getElementById("theForm")));
			console.log(document.getElementById("theForm"));
	
		document.getElementById("xxx").contentWindow.document.getElementById("frameclientix").contentWindow.document.body.scrollHeight
		
		* /
	    iframe.style.height=h+"px";
		w=iframe.style.width = iframe.contentWindow.document.body.scrollWidth + "px";
		//console.log(h);
		//console.log(w);
	*/
	



}