<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class anog extends clx_object {

    var $editform;

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'ANOG';
        $this->name = 'Output Generator Form Format';
        $this->type = '----';
        $this->version = '0.1.1.0';
        $this->description = 'This is a Generic Output Generator Form Format';
        $this->editPanel = array();
    }

    function extractFields($templaterec) {

    }

    function savefield($record) {
        $templatecode = $record['TEMPLATECODE'];
        $fieldname = $record['FIELDNAME'];
        $qty = ClxCommon::$db->oneExistsRecords('CLX_AN_OUTPUT_GEN_FIELDS', 'TEMPLATECODE=' . singleQuote($templatecode) . ' AND FIELDNAME=' . singleQuote($fieldname));
        if ($qty == CLX_NUM_ZERO) {
		  ClxCommon::$db->createRecord('CLX_AN_OUTPUT_GEN_FIELDS', $record, false);
        }
    }

    function getfields($templatecode) {
        $fields = array();
        $records = ClxCommon::$db->getRecords('CLX_AN_OUTPUT_GEN_FIELDS', 'TEMPLATECODE=' . singleQuote($templatecode));
        while (($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE))) {
		  unset($record['ID']);
		  $fields[$record['FIELDNAME']] = $record;
        }
		ClxCommon::$db->freeResult( $records );
        return $fields;
    }

    function deletefiles($templateid) {

    }

    /**
     * Deletes filed
     * @param type $filename
     */
    function deleteFile($filename) {
        if (!clx_file::deleteFileByName(kPathToWebSite . kPathToTemplates . $filename)) {
		  addMessage(dict('GEN_ERR_CANT_OPEN_FILE') . ' ' . $filename);
        }
    }

    function printtemplate($templaterec, $tree, &$contents, &$headers) {
    }

    function set($field, $value) {

    }

    function view_template($templaterec) {
        ClxFreeReturn($templaterec);
        return CLX_CHAR_EMPTY_STRING;
    }

}
