<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @package		Clientix.Tool.Interface
 * @abstract		System Chart Manager
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 */
include_once kPathToObjects . 'cpty.php';

class cpty_line extends cpty {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'CLIN';
        $this->name = 'Line Plot';
        $this->type = 'CPTY';
        $this->version = '0.3.0.0';
        $this->description = 'Line Plot';
        $this->classname = 'LinePlot';
        $this->classfile = 'jpgraph_line.php';
        $this->functions = array(array('function' => 'HideLegend', 'name' => 'HIDELEGEND', CLX_CLASS_PROMPT => 'GEN_LBL_HIDELEGEND', 'arguments' => array(
			     array('name' => 'VALUE', 'type' => 'BOOLEAN', 'default' => ''))
		  ), array('function' => 'SetCenter', 'name' => 'CENTER', CLX_CLASS_PROMPT => 'OBJ_CLIN_PROMPT_SETCENTER', 'arguments' => array(
			     array('name' => 'VALUE', 'type' => 'BOOLEAN', 'default' => ''))
		  ), array('function' => 'SetCSIMTargets', 'name' => 'CSIMTARGETS', CLX_CLASS_PROMPT => 'OBJ_CLIN_PROMPT_SETTARGETS', 'arguments' => array(
			     array('name' => 'TARGETS', 'type' => 'TEXT', 'default' => '', CLX_CLASS_PROMPT => 'OBJ_CLIN_PROMPT_TARGETS'), array('name' => 'ALTS', 'type' => 'TEXT', 'default' => '', CLX_CLASS_PROMPT => 'OBJ_CLIN_PROMPT_ALTTEXTS'))
		  ), array('function' => 'SetLegend', 'name' => 'LEGEND', CLX_CLASS_PROMPT => 'GEN_LBL_LEGEND', 'arguments' => array(
			     array('name' => 'TEXT', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45', CLX_CLASS_PROMPT => 'GEN_LBL_TEXT'), array('name' => 'CSIM', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45', CLX_CLASS_PROMPT => 'OBJ_CLIN_PROMPT_TARGET'), array('name' => 'CSIMAlt', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45', CLX_CLASS_PROMPT => 'OBJ_CLIN_PROMPT_ALTTEXT'))
		  ), array('function' => 'SetColor', 'name' => 'LINECOLOR', CLX_CLASS_PROMPT => 'GEN_LBL_LINECOLOR', 'arguments' => array(
			     array('name' => 'VALUE', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45'))
		  ), array('function' => 'SetLineWeight', 'name' => 'LINEWEIGHT', CLX_CLASS_PROMPT => 'GEN_LBL_LINEWEIGHT', 'arguments' => array(
			     array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '', 'postfix' => 'GEN_LBL_PIXELS'))
		  ), array('function' => 'SetBarCenter', 'name' => 'BARCENTER', CLX_CLASS_PROMPT => 'OBJ_CLIN_PROMPT_BARCENTER', 'arguments' => array(
			     array('name' => 'VALUE', 'type' => 'BOOLEAN', 'default' => ''))
		  ), array('function' => 'SetFillColor', 'name' => 'FILLCOLOR', CLX_CLASS_PROMPT => 'GEN_LBL_FILLCOLOR', 'arguments' => array(
			     array('name' => 'COLOR', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45', CLX_CLASS_PROMPT => 'GEN_LBL_COLOR'), array('name' => 'FILL', 'type' => 'BOOLEAN', 'default' => '', CLX_CLASS_PROMPT => 'OBJ_CLIN_PROMPT_FILLED'))
		  ), array('function' => 'SetFillFromYMin', 'name' => 'FILLYMIN', CLX_CLASS_PROMPT => 'OBJ_CLIN_PROMPT_FILLYMIN', 'arguments' => array(
			     array('name' => 'VALUE', 'type' => 'BOOLEAN', 'default' => ''))
		  ), array('function' => 'SetFillGradient', 'name' => 'FILLGRADIENT', CLX_CLASS_PROMPT => 'GEN_LBL_GRADIENT', 'arguments' => array(
			     array('name' => 'FROMCOLOR', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45', CLX_CLASS_PROMPT => 'GEN_LBL_FROMCOLOR'), array('name' => 'TOCOLOR', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45', CLX_CLASS_PROMPT => 'GEN_LBL_TOCOLOR'), array('name' => 'COLORQTY', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'OBJ_CLIN_PROMPT_COLORQTY'), array('name' => 'FILLED', 'type' => 'BOOLEAN', 'default' => '', CLX_CLASS_PROMPT => 'OBJ_CLIN_PROMPT_FILLED'))
		  ), array('function' => 'SetStepStyle', 'name' => 'STEPSTYPE', CLX_CLASS_PROMPT => 'OBJ_CLIN_PROMPT_STEPSTYLE', 'arguments' => array(
			     array('name' => 'VALUE', 'type' => 'BOOLEAN', 'default' => ''))
		  ), array('function' => 'SetStyle', 'name' => 'STYLE', CLX_CLASS_PROMPT => 'GEN_LBL_STYLE', 'arguments' => array(
			     array('name' => 'VALUE', 'type' => 'LIST', 'default' => '', 'options' => 'solid:GEN_LBL_SOLID,dotted:GEN_LBL_DOTTED,dashed:GEN_LBL_DASHED')
			 )
		  )
        );
    }

    function getPlot(&$graph, $args, $series = array()) {
        $arguments = new XMLObject('properties', false);
        $arguments->parse($args);
        require_once kPathToWebSite . kPathToJpgraph . $this->classfile;
        $plot = new $this->classname($series);
        foreach ($this->functions as $function) {
		  if ($arguments->hasObject($function['name'])) {
			 $func_arguments = $arguments->getObject($function['name']);
			 $this->setFunction($plot, $function, $func_arguments);
		  }
        }
        return $plot;
    }

}
