<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
 
class Graphic extends clx_object {

    var $operators;
    var $Graphicsfile;
    var $has_range;
    var $serie_types;
    var $colorIndex = CLX_INIT_ZERO;
    var $return_xml_only = false;
    var $multiseries = false;

    /**
     * CONSTRUCTOR
     */
    function __construct() {
        $this->code = 'GXPL';
        $this->name = 'Generic Clientix Graphics';
        $this->type = '----';
        $this->version = '1.0.0.1';
        $this->description = 'This is a Generic Clientix Graphics';
        $this->Graphicsfile = '';
        $this->has_range = false;
        $this->serie_types = array(
		  'VAL' => dict('GEN_LABEL_VALUE'),
		  'CAT' => dict('GEN_LABEL_CATEGORY'),
		  'SET' => dict('GEN_LBL_DATASET'),
		  'XAXI' => dict('GEN_LABEL_XAXIS'),
		  'YAXI' => dict('GEN_LABEL_YAXIS'),
		  'PROC' => dict('GEN_LBL_PROCESS'),
		  'PKEY' => dict('GEN_LBL_PRIMARYKEY'),
		  'TASK' => dict('GEN_LBL_TASK'),
		  'SESD' => dict('GEN_LBL_SERIES_SDATE'),
		  'SEED' => dict('GEN_LBL_SERIES_EDATE'),
		  'TASA' => dict('GEN_LBL_ACTUAL_TASK'),
		  'SASD' => dict('GEN_LBL_SERIES_ACTUAL_SDATE'),
		  'SAED' => dict('GEN_LBL_SERIES_ACTUAL_EDATE'));
    }

    /**
     * Panel
     * @param type $msg
     * @param type $Graphicsrecord
     * @param type $form
     */
    function panel($msg, $Graphicsrecord, &$form) {
        /* $table = new htmlTable(CLX_WIDTH_TWO);
		$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
		$table->addCell('This is the panel for field: ' . $this->code, array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
		$div = new htmlDiv($this->code, 'visibility:hidden; display:none', $table->source());
		return CLX_CHAR_NL . CLX_CHAR_NL . $div->source() . CLX_CHAR_NL . CLX_CHAR_NL; */

        $DICT = &getTool('DICT');
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));

        $DICT->editEntry($msg, dict('GEN_LBL_XLABEL') . ':', $this->code . '_xlabel', $Graphicsrecord, $table, $form);
        $DICT->editEntry($msg, dict('GEN_LBL_YLABEL') . ':', $this->code . '_ylabel', $Graphicsrecord, $table, $form);
        // Average Line
        $pop = new htmlSelect($this->code . '_line_average');
        $pop->addItem(dict('GEN_LBL_ACTIVE'), '1', ($Graphicsrecord[$this->code . '_line_average'] === '1'));
        $pop->addItem(dict('GEN_LBL_INACTIVE'), '0', ($Graphicsrecord[$this->code . '_line_average'] === '0'));
        $table->addData(dict('GEN_LBL_AVERAGELINE') . ':', $pop->source());
        // Max Line
        $pop = new htmlSelect($this->code . '_line_max');
        $pop->addItem(dict('GEN_LBL_ACTIVE'), '1', ($Graphicsrecord[$this->code . '_line_max'] === '1'));
        $pop->addItem(dict('GEN_LBL_INACTIVE'), '0', ($Graphicsrecord[$this->code . '_line_max'] === '0'));
        $table->addData(dict('GEN_LBL_MAXLINE') . ':', $pop->source());
        // Min Line
        $pop = new htmlSelect($this->code . '_line_min');
        $pop->addItem(dict('GEN_LBL_ACTIVE'), '1', ($Graphicsrecord[$this->code . '_line_min'] === '1'));
        $pop->addItem(dict('GEN_LBL_INACTIVE'), '0', ($Graphicsrecord[$this->code . '_line_min'] === '0'));
        $table->addData(dict('GEN_LBL_MINLINE') . ':', $pop->source());
        $div = new htmlDiv($this->code, 'visibility:hidden; display:none', $table->source());
        return CLX_CHAR_NL . CLX_CHAR_NL . $div->source() . CLX_CHAR_NL . CLX_CHAR_NL;
    }

    function checkPanel(&$msg) {

    }

    function createPanel(&$Graphicsrecord) {

    }

    function savePanel(&$Graphicsrecord) {

    }

    function loadPanel(&$Graphicsrecord, $values) {

    }

    function deletePanel($Graphicsrecord) {

    }

    function defaultPanel(&$Graphicsrecord) {

    }

    function viewForm(&$table, $record) {

    }

    function defaultRange($Graphicsrecord) {

    }

    private function clean_crcl($value, $replace = ' ') {
        return decode_string(str_replace(CLX_CHAR_CR, $replace, str_replace(CLX_CHAR_NL, $replace, $value)));
    }

    /**
     * Builds Graphics XML
     * General set to single series
     */
    function build($Graphicsrecord) {
	//	pre("build");
        /** XML Setup * */
        $basefont = ($Graphicsrecord['FONTTYPE'] === '') ? 'arial' : $Graphicsrecord['FONTTYPE'];
        $baseFontSize = $Graphicsrecord['FONTSIZE'];
        /** XML Creation * */
        $data = new XMLObject('graph', false);
        $data->setProp('basefontsize', $baseFontSize);
        $data->setProp('basefont', $basefont);
        $data->setProp('caption', $this->clean_crcl(dict($Graphicsrecord['TITLE'])));
        $data->setProp('subCaption', $this->clean_crcl(dict($Graphicsrecord['SUBTITLE'])));
        $data->setProp('xaxisname', $this->clean_crcl(dict($Graphicsrecord['XLABEL'])));
        $data->setProp('yaxisname', $this->clean_crcl(dict($Graphicsrecord['YLABEL'])));
        $data->setProp('canvasBorderThickness', $Graphicsrecord['BORDER']);
        $data->setProp('shownames', $Graphicsrecord['SHOWNAMES']);    //'1/0' : This attribute can have either of the two possible values: 1,0 It sets the configuration whether the data names will be displayed or not alongside the pie.
        $data->setProp('showValues', $Graphicsrecord['SHOWVALUES']);    //='1/0' : This attribute can have either of the two possible values: 1,0 It sets the configuration whether the data values will be displayed along with the pies.
        $data->setProp('rotateNames', $Graphicsrecord['ROTATE_NAMES']);
        $data->setProp('showLegend', $Graphicsrecord['SHOW_LEGEND']);
        $data->setProp('showColumnShadow', $Graphicsrecord['SHOW_COLSHADOW']);
        $data->setProp('showPercentageValues', $Graphicsrecord['SHOW_PCTVALUES']);
        $data->setProp('showPercentageInLabel', $Graphicsrecord['SHOW_PCTINLABEL']);
        $data->setProp('animation', $Graphicsrecord['ANIMATION']);    //='1/0' : This attribute sets whether the animation is to be played or whether the entire chart would be rendered at one go.
        $sourceData = $this->GraphicsData($Graphicsrecord);
       
		if (!empty($sourceData)) {
		  /** Chart Data start * */
		  /** Graphics Data * */
		  $values = array();
		  reset($sourceData);
		  foreach ($sourceData as $key => $val) {
			 $set = new XMLObject('set', false);
			 reset($val);
			 foreach ($val as $key2 => $val2) {
			     switch ($val2['type']) {
			         case 'VAL':
					   $val2['val'] = str_replace(CLX_CHAR_NL, '', $val2['val']);
					   $val2['val'] = str_replace(CLX_CHAR_CR, '', $val2['val']);
					   $set->setProp('value', $this->clean_crcl($val2['val']));
					   $values[] = $val2['val'];
					   break;
			         case 'CAT':
					   $val2['val'] = str_replace(CLX_CHAR_NL, '', $val2['val']);
					   $val2['val'] = str_replace(CLX_CHAR_CR, '', $val2['val']);
					   $set->setProp('name', $this->clean_crcl(str_replace(CLX_CHAR_HTML_NBSP, '', $val2['val'])));
					   break;
			         default:
					   break;
			     }
			 }//end while
			 $set->setProp('color', $this->pickColor());
			 $set->setProp('link', '');
			 $data->addObject($set);
		  }//end while
		  /* Graphics Extras */
		  $set = new XMLObject('trendlines', false);
		  if (!empty($Graphicsrecord['LINE_AVERAGE'])) {
			 $sum = CLX_INIT_ZERO;
			 $ave = CLX_NUM_ZERO;
			 foreach ($values as $key => $val)
			     $sum += $val;
			 $cont = count($values);
			 if ($cont > CLX_NUM_ZERO) {
			     $ave = $sum / $cont;
			 }
			 $line = new XMLObject('line');
			 $line->setProp('value', $ave);
			 $line->setProp('displayValue', dict('GEN_LABEL_AVERAGE'));
			 $line->setProp('color', '#FFCC00');
			 $line->setProp('thickness', '1');
			 $line->setProp('alpha', CLX_NUM_HUNDRED);
			 $set->addObject($line);
			 unset($ave);
		  }
		  if (!empty($Graphicsrecord['LINE_MAX'])) {
			 sort($values, SORT_NUMERIC);
			 reset($values);
			 $key = count($values) - CLX_NUM_ONE;
			 if (isset($values[$key]))
			     $max = $values[$key];
			 else
			     $max = CLX_INIT_ZERO;
			 $line = new XMLObject('line', false);
			 $line->setProp('value', $max);
			 $line->setProp('displayValue', dict('GEN_LABEL_MAX'));
			 $line->setProp('color', '#339900');
			 $line->setProp('thickness', '1');
			 $line->setProp('alpha', CLX_NUM_HUNDRED);
			 $set->addObject($line);
			 unset($max);
		  }
		  if (!empty($Graphicsrecord['LINE_MIN'])) {
			 sort($values, SORT_NUMERIC);
			 reset($values);
			 if (isset($values[CLX_NUM_ZERO]))
			     $min = $values[CLX_NUM_ZERO];
			 else
			     $min = CLX_INIT_ZERO;
			 $line = new XMLObject('line', false);
			 $line->setProp('value', $min);
			 $line->setProp('displayValue', dict('GEN_LABEL_MIN'));
			 $line->setProp('color', '#CC0000');
			 $line->setProp('thickness', '1');
			 $line->setProp('alpha', CLX_NUM_HUNDRED);
			 $set->addObject($line);
			 unset($min);
		  }
		  $data->addObject($set);
		  $contents = $data->source_(array('level' => CLX_NUM_ZERO));
        }else {
		  //setting none
		  $set = new XMLObject('set', false);
		  $data->addObject($set);
		  $contents = $data->source_(array('level' => CLX_NUM_ZERO)); //dict('GEN_ERROR_INVALID_CHART_OR_SEARCH');
        }
        return $contents;
    }
/**
     * Builds Graphics XML
     * General set to single series
     */
    function buildArray($Graphicsrecord) {
	//	pre("buildArray");
		
		$basefont = ($Graphicsrecord['FONTTYPE'] === '') ? 'arial' : $Graphicsrecord['FONTTYPE'];
        $baseFontSize = $Graphicsrecord['FONTSIZE'];
        $data = array();	
        $data['basefontsize']= $baseFontSize;
        $data['basefont']= $basefont;
        $data['caption']= $this->clean_crcl(dict($Graphicsrecord['TITLE']));
        $data['subCaption']= $this->clean_crcl(dict($Graphicsrecord['SUBTITLE']));
        $data['xaxisname']= $this->clean_crcl(dict($Graphicsrecord['XLABEL']));
        $data['yaxisname']= $this->clean_crcl(dict($Graphicsrecord['YLABEL']));
        $data['canvasBorderThickness']= $Graphicsrecord['BORDER'];
        $data['shownames']= $Graphicsrecord['SHOWNAMES'];    //'1/0' : This attribute can have either of the two possible values: 1,0 It sets the configuration whether the data names will be displayed or not alongside the pie.
        $data['showValues']= $Graphicsrecord['SHOWVALUES'];    //='1/0' : This attribute can have either of the two possible values: 1,0 It sets the configuration whether the data values will be displayed along with the pies.
        $data['rotateNames']= $Graphicsrecord['ROTATE_NAMES'];
        $data['showLegend']= $Graphicsrecord['SHOW_LEGEND'];
        $data['showColumnShadow']= $Graphicsrecord['SHOW_COLSHADOW'];
        $data['showPercentageValues']= $Graphicsrecord['SHOW_PCTVALUES'];
        $data['showPercentageInLabel']= $Graphicsrecord['SHOW_PCTINLABEL'];
        $data['animation']= $Graphicsrecord['ANIMATION'];    //='1/0' : This attribute sets whether the animation is to be played or whether the entire chart would be rendered at one go.
        $sourceData = $this->GraphicsData($Graphicsrecord);
        $data['count_record']=count($sourceData);
		if (!empty($sourceData)) {
		  /** Chart Data start * */
		  /** Graphics Data * */
		  $values = array();
		  reset($sourceData);
			//pre($sourceData);
			foreach ($sourceData as $key => $val) {
			 $set = array();
			 reset($val);
				
		        foreach ($val as $key2 => $val2) {
							
			     switch ($val2['type']) {
			         case 'VAL':
							$val2['val'] = str_replace(CLX_CHAR_NL, '', $val2['val']);
					   $val2['val'] = str_replace(CLX_CHAR_CR, '', $val2['val']);
					   $set['value']=$this->clean_crcl($val2['val']);
					   $values[] = $val2['val'];
					   break;
			         case 'CAT':
					   $val2['val'] = str_replace(CLX_CHAR_NL, '', $val2['val']);
					   $val2['val'] = str_replace(CLX_CHAR_CR, '', $val2['val']);
					   $set['name']= $this->clean_crcl(str_replace(CLX_CHAR_HTML_NBSP, '', $val2['val']));
					   break;
			         default:
					   break;
			     }
			 }//end while
			 $set['color']= $this->pickColor();
			 $set['link']= '';
		  }//end while
		  /* Graphics Extras */
		  $set = array();
		  if (!empty($Graphicsrecord['LINE_AVERAGE'])) {
			 $sum = CLX_INIT_ZERO;
			 $ave = CLX_NUM_ZERO;
			 foreach ($values as $key => $val)
			     $sum += $val;
			 $cont = count($values);
			 if ($cont > CLX_NUM_ZERO) {
			     $ave = $sum / $cont;
			 }
			 $line = array();
			 $line['value']= $ave;
			 $line['displayValue']= dict('GEN_LABEL_AVERAGE');
			 $line['color']= '#FFCC00';
			 $line['thickness']= '1';
			 $line['alpha']= CLX_NUM_HUNDRED;
			 unset($ave);
		  }
		  if (!empty($Graphicsrecord['LINE_MAX'])) {
			 sort($values, SORT_NUMERIC);
			 reset($values);
			 $key = count($values) - CLX_NUM_ONE;
			 if (isset($values[$key]))
			     $max = $values[$key];
			 else
			     $max = CLX_INIT_ZERO;
			 $line = array();
			 $line['value']= $max;
			 $line['displayValue']= dict('GEN_LABEL_MAX');
			 $line['color']= '#339900';
			 $line['thickness']= '1';
			 $line['alpha']= CLX_NUM_HUNDRED;
			 unset($max);
		  }
		  if (!empty($Graphicsrecord['LINE_MIN'])) {
			 sort($values, SORT_NUMERIC);
			 reset($values);
			 if (isset($values[CLX_NUM_ZERO]))
			     $min = $values[CLX_NUM_ZERO];
			 else
			     $min = CLX_INIT_ZERO;
			 $line = array();
			 $line['value']= $min;
			 $line['displayValue']= dict('GEN_LABEL_MIN');
			 $line['color']= '#CC0000';
			 $line['thickness']= '1';
			 $line['alpha']= CLX_NUM_HUNDRED;
			 unset($min);
			}	
		}
	    return get_defined_vars();
    }
 
    /**
     * Builds Graphics xml
     *
     * @param array $Graphicsrecord
     * @return string
     */
    function GraphicsDataMultiSeries($Graphicsrecord) {
	//	pre("multiseries");
/*	$te=debug_backtrace(); 
	for ($t=0;$t<12;$t++) {
		if (isset($te[$t]["file"])){
			if ($t==$posx)
				echo $pos."_".$te[$posx]["function"]."_util(pre)-hora:".date("h:i:s d/m/Y")."<br>";
			echo substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"]."<br>";
		}
	}
*/

        ///Old graph
        $colors = array();
        $series = array();
        $sql = '';
        $query = $this->GraphicsGetQuery($Graphicsrecord['QUERYCODE']);
        $this->GraphicsQuery($Graphicsrecord, $series, $sql);
        $has_all_series = (!empty($series['SET']) && !empty($series['CAT']) && !empty($series['VAL']));
        if (!empty($has_all_series)) {
		  /** Chart Data start * */
		  /** XML Setup * */
		  $basefont = ($Graphicsrecord['FONTTYPE'] === '') ? 'arial' : $Graphicsrecord['FONTTYPE'];
		  $baseFontSize = $Graphicsrecord['FONTSIZE'];
		  /** XML Creation * */
		  $data = new XMLObject('graph', false);
		  $data->setProp('basefontsize', $baseFontSize);
		  $data->setProp('basefont', $basefont);
		  $data->setProp('caption', $this->clean_crcl(dict($Graphicsrecord['TITLE'])));
		  $data->setProp('subCaption', $this->clean_crcl(dict($Graphicsrecord['SUBTITLE'])));
		  $data->setProp('xaxisname', dict($Graphicsrecord['XLABEL']));
		  $data->setProp('yaxisname', dict($Graphicsrecord['YLABEL']));
		  $data->setProp('rotateNames', $Graphicsrecord['ROTATE_NAMES']);
		  $data->setProp('canvasBorderThickness', $Graphicsrecord['BORDER']);
		  $data->setProp('shownames', $Graphicsrecord['SHOWNAMES']);    //'1/0' : This attribute can have either of the two possible values: 1,0 It sets the configuration whether the data names will be displayed or not alongside the pie.
		  $data->setProp('showValues', $Graphicsrecord['SHOWVALUES']);    //='1/0' : This attribute can have either of the two possible values: 1,0 It sets the configuration whether the data values will be displayed along with the pies.
		  $data->setProp('showLegend', $Graphicsrecord['SHOW_LEGEND']);
		  $data->setProp('showColumnShadow', $Graphicsrecord['SHOW_COLSHADOW']);
		  $data->setProp('showPercentageValues', $Graphicsrecord['SHOW_PCTVALUES']);
		  $data->setProp('showPercentageInLabel', $Graphicsrecord['SHOW_PCTINLABEL']);
		  $data->setProp('animation', $Graphicsrecord['ANIMATION']);    //='1/0' : This attribute sets whether the animation is to be played or whether the entire chart would be rendered at one go.
		  /** Graphics Data * */
		  /* Categories init */
		  $categories = new XMLObject('categories', false);
		  $categories->setProp('font', $basefont);
		  $categories->setProp('fontSize', $baseFontSize);
		  $categories->setProp('fontColor', '000000');
		  $sql_categories = 'SELECT DISTINCT ' . $series['CAT']['SELECT'] . ' ' . $query['FROMWHERESORT'];
		  $results = ClxCommon::$db->executeQuerySilent($sql_categories);
		  $i = CLX_NUM_ZERO;
		  while (($result = ClxCommon::$db->getNextRecord($results, NUMERIC))) {
			 if ($i == CLX_NUM_ZERO)
			     $i = ClxCommon::$db->numRows($result);
			 /* Category */
			 $category = new XMLObject('category', false);
			 //Format Category
			 if (!empty($series['CAT']['FORMAT'])) {
			     $f = getToolObject('DBFT', $series['CAT']['FIELDTYPE']);
			     $tmp = array($series['CAT']['fieldname'] => $result[CLX_NUM_ZERO]);
			     $result[CLX_NUM_ONE] = $f->formatField($series['CAT']['fieldname'], $series['CAT'], $tmp);
			     $value = $this->clean_crcl(strip_tags($result[CLX_NUM_ONE]));
			     unset($tmp);
			 } else {
			     $result[CLX_NUM_ONE] = $result[CLX_NUM_ZERO];
			 }
			 $category->setProp('hoverText', $value);
			 $category->setProp('name', $value);
			 $categories->addObject($category);
			 /* Data sets */
			 $sql_set = 'SELECT DISTINCT ' . $series['SET']['SELECT'];
			 $sql_set .= ' FROM ' . $query['FROMCLAUSE'];
			 if ($series['SET']['WHERE'] <> '') {
			     $sql_set .= ' WHERE ' . $series['SET']['WHERE'];
			     $sql_set .= ' AND ' . $series['CAT']['SELECT'] . ' = ' . singleQuote($result[CLX_NUM_ZERO]) . ' ';
			 } else {
			     $sql_set .= ' WHERE ' . $series['CAT']['SELECT'] . ' = ' . singleQuote($result[CLX_NUM_ZERO]) . ' ';
			 }
			 if (empty($colors[$result[CLX_NUM_ZERO]])) {
			     $colors[$result[CLX_NUM_ZERO]] = $this->pickColor();
			 }
			 $dataset = new XMLObject('dataset', false);
			 $dataset->setProp('seriesname', $result[CLX_NUM_ONE]);
			 $dataset->setProp('color', $colors[$result[CLX_NUM_ZERO]]);
			 $dataset->setProp('showValues', CLX_NUM_ONE);
			 $dataset->setProp('alpha', CLX_NUM_HUNDRED);
			 $results_set = ClxCommon::$db->executeQuerySilent($sql_set);
			 while (($result_set = ClxCommon::$db->getNextRecord($results_set, NUMERIC))) {
			     /* Data sets */
			     $sql_set = 'SELECT ' . $series['VAL']['SELECT'];
			     $sql_set .= ' FROM ' . $query['FROMCLAUSE'];
			     if ($series['SET']['WHERE'] <> '') {
			         $sql_set .= ' WHERE ' . $series['VAL']['WHERE'];
			         $sql_set .= ' AND ' . $series['SET']['SELECT'] . ' = ' . singleQuote($result_set[CLX_NUM_ZERO]) . ' ';
			         $sql_set .= ' AND ' . $series['CAT']['SELECT'] . ' = ' . singleQuote($result[CLX_NUM_ZERO]) . ' ';
			     } else {
			         $sql_set .= ' WHERE ' . $series['SET']['SELECT'] . ' = ' . singleQuote($result_set[CLX_NUM_ZERO]) . ' ';
			         $sql_set .= ' AND ' . $series['CAT']['SELECT'] . ' = ' . singleQuote($result[CLX_NUM_ZERO]) . ' ';
			     }
			     $values = ClxCommon::$db->executeQuerySilent($sql_set);
			     while (($value = ClxCommon::$db->getNextRecord($values, NUMERIC)) === true) {
			         /* Set values */
			         $set = new XMLObject('set', false);
			         $set->setProp('value', $this->clean_crcl($value[CLX_NUM_ZERO]));
			         $dataset->addObject($set);
			     }
			 }//end while sets
			 $data->addObject($dataset);
			 unset($set, $dataset);
		  }//end while categories
		  $data->addObject($categories);
		  unset($category, $categories);
		  $contents = $data->source_(array('level' => CLX_NUM_ZERO));
        } else {
		  $contents = dict('GEN_ERROR_INVALID_CHART_OR_SEARCH');
        }
        return $contents;
    }

    /**
     * Construct Data Series
     */
    function GraphicsData($Graphicsrecord) {
	//	pre("Graphicsdata");
        $series_records = array();
        $series_data = array();
        $sql = '';
        $fields_cache = array();
        $this->GraphicsQuery($Graphicsrecord, $series_records, $sql);
        $records = ClxCommon::$db->executeQuerySilent($sql);
		if (!empty($records)) { 
		  $i = CLX_NUM_ZERO;
		  while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
			 foreach ($series_records as $series_rec) {
			     $pos = strpos($series_rec['AS'], '_', CLX_NUM_ZERO) + CLX_NUM_ONE;
			     $steps = strlen($series_rec['AS']) - $pos;
			     $fieldname = substr($series_rec['AS'], $pos, $steps);
			     if (array_key_exists($fieldname, $fields_cache)) {
			         $fieldrec = $fields_cache[$fieldname];
			     } else {
			         $fieldrec = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($fieldname));
			         $fields_cache[$fieldname] = $fieldrec;
			     }
			     if (!empty($fieldrec)) {
			         $fieldinstance = getToolObject('DBFT', $fieldrec['FIELDTYPE']);
			         $data = array();
			         $data[$fieldrec['FIELDNAME']] = $record[$series_rec['AS']];
			         if ($fieldrec['FIELDTYPE'] === 'DECN' || $fieldrec['FIELDTYPE'] === 'INTN') {
					   $value = $data[$fieldrec['FIELDNAME']]; // Field format as string could damage the Graphics
			         } else {
					   if (!empty($series_rec['FORMAT'])) {
						  $value = $fieldinstance->formatField($fieldrec['FIELDNAME'], $fieldrec, $data);
						  $value = strip_tags($value);
						  if (stristr($value, 'pop.php?to=DICT&ac=CREATE_FAST&entry') !== false > CLX_NUM_ZERO)
						      $value = $data[$fieldrec['FIELDNAME']];
					   }else {
						  $value = $data[$fieldrec['FIELDNAME']];
					   }
			         }
			         $data = array('val' => $value, 'type' => $series_rec['TYPE']);
			         $series_data[$i][] = $data;
			     }
			 }
			 $i++;
		  }//end while
	    } else {;
		  $series_data = array();
        }//end if
        return $series_data;
    }

    function GraphicsQuery($Graphicsrecord, &$series_records, &$sql) {
        $sql = array();
        $ANGS = &getTool('ANGS');
        $querycode = $Graphicsrecord['QUERYCODE'];
        //Get Default query
        $queryrec = $this->GraphicsGetQuery($querycode);
        $selectclause = '';
        $fromclause = $queryrec['FROMCLAUSE'];
        $whereclause = $queryrec['WHERECLAUSE'];
        $groupclause = '';
        $sql = 'SELECT DBFL.*, ANGS.* FROM ' . $ANGS->tablename . ' ANGS,CLX_DB_FIELDS DBFL WHERE (DBFL.FIELDNAME = ANGS.FIELDNAME OR CONCAT(DBFL.FIELDNAME,' . "'_WRK'" . ') = ANGS.FIELDNAME) AND ANGS.CHARTCODE=' . singleQuote($Graphicsrecord['IDCODE']) . ' AND ANGS.STATUS=1 ORDER BY ANGS.SEQNUM';
        $chartseries = ClxCommon::$db->executeQuery($sql);
        $comma1 = '';
        $comma2 = '';
        $series_records = array();
        while (($series_rec = ClxCommon::$db->getNextRecord($chartseries))) {
		  $use_query_field = empty($series_rec['USE_QUERY_FIELD']) ? true : false;
		  $select = '';
		  $groupby = '';
		  if (empty($use_query_field)) {
			 $query_field_rec = ClxCommon::$db->getField('CLX_DB_QUERY_FIELDS', 'EXPRESSION', 'QUERYCODE=' . singleQuote($querycode), 'TABLECODE=' . singleQuote($series_rec['TABLECODE']), 'FIELDNAME =' . singleQuote($series_rec['FIELDNAME'])
			 );
			 if (!empty($query_field_rec)) {
			     $series_rec['EXPRESSION'] = '(' . $query_field_rec . ') ';
			 }
		  }
		  if (!empty($series_rec['EXPRESSION'])) {
			 $as = $series_rec['TABLECODE'] . '_' . $series_rec['FIELDNAME'];
			 $selectclause .= $comma1 . $series_rec['EXPRESSION'] . ' ' . $as;
			 $select = $series_rec['EXPRESSION'];
		  } elseif (empty($series_rec['FUNCTION'])) {
			 $as = $series_rec['TABLECODE'] . '_' . $series_rec['FIELDNAME'];
			 $selectclause .= $comma1 . $series_rec['TABLECODE'] . '.' . $series_rec['FIELDNAME'] . ' ' . $as;
			 $select = $series_rec['TABLECODE'] . '.' . $series_rec['FIELDNAME'];
		  } else {
			 $as = $series_rec['TABLECODE'] . '_' . $series_rec['FIELDNAME'];
			 $selectclause .= $comma1 . $series_rec['FUNCTION'] . '(' . $series_rec['TABLECODE'] . '.' . $series_rec['FIELDNAME'] . ')' . ' ' . $as;
			 $select = $series_rec['FUNCTION'] . '(' . $series_rec['TABLECODE'] . '.' . $series_rec['FIELDNAME'] . ')';
		  }
		  $comma1 = ', ';
		  if (!empty($series_rec['GROUPBY'])) {
			 $groupclause .= $comma2 . $series_rec['TABLECODE'] . '.' . $series_rec['FIELDNAME'];
			 $comma2 = ', ';
			 $groupby = $series_rec['TABLECODE'] . '.' . $series_rec['FIELDNAME'];
		  }
		  $series_rec['FIELDNAME'] = $series_rec['FIELDNAME'];
		  $series_rec['FIELDTYPE'] = $series_rec['FIELDTYPE'];
		  $series_rec['SELECT'] = $select;
		  $series_rec['GROUPBY'] = $groupby;
		  $series_rec['WHERE'] = $whereclause;
		  $series_rec['AS'] = $as;
		  if (!empty($this->multiseries)) {
			 if (array_key_exists($series_rec['TYPE'], $series_rec)) {
			     $series_records[] = $series_rec;
			 } else {
			     $series_records[$series_rec['TYPE']] = $series_rec;
			 }
		  } else {
			 $series_records[] = $series_rec;
		  }
        }//end while
		if (empty($selectclause)) {
			$selectclause='*';
			
			
		}	
        $sql = 'SELECT ' . $selectclause . ' FROM ' . $fromclause;
        if (!empty($whereclause)) {
		  $sql .= ' WHERE ' . $whereclause;
        }
        if (!empty($groupclause)) {
		  $sql .= ' GROUP BY ' . $groupclause;
        }

        if (!empty($queryrec['SORTCLAUSE'])) {
		  $sql .= ' ORDER BY ' . $queryrec['SORTCLAUSE'];
        }//echo $sql;
    }

    function GraphicsGetQuery($querycode) {
	//	pre("Graphicsgetquery");
        $DBQY = &getTool('DBQY');
        $queryrec = $DBQY->getQuery($this->code, $querycode);
        $whereclause = '';
        $sortclause = '';
        //Adding Filters
        if (!empty($_SESSION['paging'])) {
		  if ((array_key_exists($querycode . '_LIST', $_SESSION['paging']))) {
			 $whereclause = stripslashes($_SESSION['paging'][$querycode . '_LIST']['criteria']);
			 if (array_key_exists('sortby', $_SESSION['paging'][$querycode . '_LIST']))
			     $sortclause = stripslashes($_SESSION['paging'][$querycode . '_LIST']['sortby']);
		  }
        }
        if (strlen($whereclause) > CLX_NUM_ZERO && strlen($queryrec['WHERECLAUSE']) > CLX_NUM_ZERO)
		  $whereclause .= ' AND ';
        if (strlen($sortclause) > CLX_NUM_ZERO && strlen($queryrec['SORTCLAUSE']) > CLX_NUM_ZERO)
		  $whereclause .= ', ';
        $whereclause .= $queryrec['WHERECLAUSE'];
        $sortclause .= $queryrec['SORTCLAUSE'];
        $queryrec['WHERECLAUSE'] = $whereclause;
        $queryrec['SORTCLAUSE'] = $sortclause;
        return $queryrec;
    }

    /**
     * Just a random color picker
     */
    function pickColor() {
        if ($this->colorIndex === '' || $this->colorIndex >= CLX_NUM_18)
		  $this->colorIndex = CLX_INIT_ZERO;
	
		$colors=GXTcolorGraphics()['group_mixed3'];

        $strColor = explode(',',$colors);
        
		$this->colorIndex = $this->colorIndex + CLX_NUM_ONE;
        return  uppercase($strColor[$this->colorIndex]);
    }

}
