<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @package		Clientix.Tool.Interface
 * @abstract		System Events Manager - System Alert Message.
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('uimi') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'uimi.php';

class uimi_url extends uimi {

    /**
     * Contructor
     */
    function __construct() {
        $this->code = 'URL';
        $this->name = 'URL';
        $this->type = 'UIMI';
        $this->version = '0.1.0.0';
        $this->description = 'This is a Clientix Menu Item that takes you to an URL';
    }

    /**
     * Build Meny item type on edit menu.
     * @param array $msg
     * @param array $record
     */
    function panel($msg, $record) {
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => '90%'));
        $table->addCell(dict('OBJ_MITM_URL_TITLE'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addField($msg, dict('GEN_LBL_URL') . ':', 'URL_extra1', (array_key_exists('URL_extra1', $record)) ? $record['URL_extra1'] : '', CLX_NUM_48, CLX_NUM_255);
        $pop = new htmlSelect('URL_extra2');
        $pop->addItem(dict('GEN_LBL_EXTWIN'), '1', (!empty($record['URL_extra2']) && $record['URL_extra2'] === '1'));
        $pop->addItem(dict('GEN_LBL_SAMWIN'), '0', (empty($record['URL_extra2'])));
        $table->addData(dict('GEN_LBL_WINDOW') . ':', $pop->source());
        $div = new htmlDiv($this->code, 'visibility:hidden; display:none', $table->source());
        return CLX_CHAR_NL . CLX_CHAR_NL . $div->source() . CLX_CHAR_NL . CLX_CHAR_NL;
    }

    /**
     * Verifies Menu Item Panel.
     * @param array $msg
     */
    function checkPanel(&$msg) {
        //not really require http up to developer
        //xValidate::url($msg, 'URL_extra1', UserRequest::$post['URL_extra1']);
    }

    /**
     * Loads form values in record for future save.
     * @param array $record
     */
    function getPanel(&$record) {
        $record['EXTRA1'] = UserRequest::$post['URL_extra1'];
        $record['EXTRA2'] = UserRequest::$post['URL_extra2'];
    }

    /**
     * Sets form values from menu record
     * @param array $record
     * @param array $values
     */
    function setPanel(&$record, $values) {
        $record['URL_extra1'] = $values['EXTRA1'];
        $record['URL_extra2'] = $values['EXTRA2'];
    }

    /**
     * Loads Default Panel Values
     * @param array $record
     */
    function defaultPanel(&$record) {
        $record['URL_extra1'] = kWebSite;
    }

    /**
     * Displays Form Object for menu items tool
     * @param obj $table
     * @param array $record
     */
    function viewForm(&$table, $record) {
        $windows = array(dict('GEN_LBL_EXTWIN'), dict('GEN_LBL_SAMWIN'));
        $table->addData(dict('GEN_LBL_WINDOW') . ':', $windows[$record['URL_extra2']]);
    }

    /**
     * Return string with description of menu item.
     * @param array $record
     * @return string
     */
    function describe($record) {
        return 'Go to: ' . $record['EXTRA1'];
    }

    /**
     * Returns URL Form Menu Item
     * @param array $record
     * @return string
     */
    function makeURL($record) {
        return sprintf('%s', $record['EXTRA1']);
    }

}
