<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('ussh') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'ussh.php';

class ussh_edittree extends ussh {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'USTR';
        $this->name = 'Edit Access Tree';
        $this->type = 'USSH';
        $this->version = '0.1.0.0';
        $this->description = 'This is a Clientix Shortcut that edits an Access Tree.';
        $this->editPanel = array('entries' => array(
			 array('label' => 'GEN_LBL_TREE',
			     'fields' => array(
			         array('name' => 'USTR_extra1', 'type' => 'lookup', 'default' => '', 'tool' => 'ACTR', 'validations' => array(
						  array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_AC_TREES'))
			         )
			     )
			 )
		  )
        );
    }

    function getPanel(&$record) {
        $record['EXTRA1'] = UserRequest::$post['USTR_extra1'];
    }

    function setPanel(&$record, $values) {
        $record['USTR_extra1'] = $values['EXTRA1'];
    }

    function defaultPanel(&$record) {
        $record['USTR_extra1'] = '';
    }

    function viewForm(&$table, $record) {
        $table->addData(dict('GEN_LBL_TREE') . ':', $record['USTR_extra1']);
    }

    function describe($record) {
        return 'Edit Access Tree: ' . $record['EXTRA1'];
    }

    function makeURL($record) {
        return sprintf('tool.php?to=ACTE&ac=LIST&level=1&parent=0&treecode=%s', $record['EXTRA1']);
    }

}
