<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('ussh') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'ussh.php';

class ussh_execute extends ussh {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'USEX';
        $this->name = 'Execute external application';
        $this->type = 'USSH';
        $this->version = '0.1.0.0';
        $this->description = 'This is a Clientix Shortcut that executes an external application';
        $this->editPanel = array('entries' => array(
			 array('label' => 'GEN_LBL_PATHNAME',
			     'fields' => array(
			         array('name' => 'USEX_extra1', 'type' => 'string', 'size' => '245', 'displaysize' => '64', 'validations' => array(
						  array('type' => 'string', 'required' => '1'))
			         )
			     )
			 )
		  )
        );
    }

    function getPanel(&$record) {
        $record['EXTRA1'] = UserRequest::$post['USEX_extra1'];
    }

    function setPanel(&$record, $values) {
        $record['USEX_extra1'] = $values['EXTRA1'];
    }

    function defaultPanel(&$record) {
        $record['USEX_extra1'] = '';
    }

    function viewForm(&$table, $record) {
        $table->addData(dict('GEN_LBL_PATHNAME') . ':', $record['USEX_extra1']);
    }

    function describe($record) {
        return 'USEXute application: ' . $record['EXTRA1'];
    }

    function makeURL($record) {
        return 'execute_external_program.php';
    }

}
