<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('ussh') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'ussh.php';

class ussh_listrecords extends ussh {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'USLS';
        $this->name = 'List Records';
        $this->type = 'USSH';
        $this->version = '0.2.0.2';
        $this->description = 'This is a Clientix Shortcut that executes a query.';
        $this->editPanel = array('entries' => array(
			 array('label' => 'OBJ_USSH_USLS_TITLE',
			     'fields' => array(
			         array('name' => 'USLS_extra1', 'type' => 'lookup', 'tool' => 'UILG', 'validations' => array(
						  array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_UI_LISTINGS'))
			         )
			     )
			 )
		  )
        );
    }

    function getPanel(&$record) {
        $record['EXTRA1'] = UserRequest::$post['USLS_extra1'];
    }

    function setPanel(&$record, $values) {
        $record['USLS_extra1'] = $values['EXTRA1'];
    }

    function defaultPanel(&$record) {
        $record['USLS_extra1'] = '';
    }

    function viewForm(&$table, $record) {
        $table->addData(dict('GEN_LBL_LISTING') . ':', $record['USLS_extra1']);
    }

    function describe($record) {
        return 'List Records with listing: ' . $record['EXTRA1'];
    }

    function makeURL($record) {
        return sprintf('tool.php?to=EDIT&ac=LIST&li=%s', $record['EXTRA1']);
    }

}
