<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-10-15 10:19:43 -0400 (Mon, 15 Oct 2018) $
 * @version        $Rev: 10245 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('util') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'util.php';

class util_deletelogs extends util {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'DLOG';
        $this->name = 'Clear Logs Tables';
        $this->type = 'UTIL';
        $this->version = '0.1.0.0';
        $this->description = 'Clears all the data stored in the diferent log tables.';
        $this->haspanel = true;
        $this->interface = array(array('name' => 'audit_records',
			 'dict' => 'GEN_LBL_DELETE_AUDIT_RECORDS',
//			 'init' => true,
			 'init' => false,
			 'table' => 'CLX_AC_AUDIT',
			 'dir' => '',
			 'archive' => 'true',
			 'tool' => 'ACAD'
		  ), array('name' => 'dictionary_heap',
			 'dict' => 'GEN_LBL_DELETE_DICTIONARY_HEAPS',
			 'init' => true,
			 'table' => 'CLX_DICTIONARY_HEAP',
			 'dir' => ''
		  ), array('name' => 'exports',
			 'dict' => 'GEN_LBL_DELETE_EXPORTS',
			 'init' => false,
			 'table' => '',
			 'dir' => kPathToWebSite . kPathToExport
		  ), array('name' => 'packages',
			 'dict' => 'GEN_LBL_DELETE_PACKAGES',
			 'init' => false,
			 'table' => '',
			 'dir' => kPathToWebSite . kPathToPackages
		  ), array('name' => 'process_logs',
			 'dict' => 'GEN_LBL_DELETE_PROCESS_LOGS',
			 'init' => false,
			 'table' => 'CLX_PR_PROC_LOGS',
			 'archive' => 'true',
			 'tool' => 'PRLO',
			 'dir' => ''
		  ), array('name' => 'process_exception_logs',
			 'dict' => 'GEN_LBL_DELETE_PROCESS_EXCEPTION_LOGS',
			 'init' => false,
			 'table' => 'CLX_PR_EXCEPT_LOGS',
			 'archive' => 'true',
			 'tool' => 'PREL',
			 'dir' => ''
		  ), array('name' => 'process_steps_logs',
			 'dict' => 'GEN_LBL_DELETE_PROCESS_STEP_LOGS',
			 'init' => false,
			 'table' => 'CLX_PR_STEP_LOGS',
			 'archive' => 'true',
			 'tool' => 'PRSL',
			 'dir' => ''
		  ), array('name' => 'manager_logs',
			 'dict' => 'GEN_LBL_DELETE_MANAGER_LOGS',
			 'init' => false,
			 'archive' => 'true',
			 'table' => 'CLX_SK_LOGS',
			 'tool' => 'SKML',
			 'dir' => ''
		  ), array('name' => 'system_notification',
			 'dict' => 'GEN_LBL_DELETE_SYSTEM_NOTIFICATION_LOGS',
			 'init' => false,
			 'archive' => 'true',
			 'tool' => 'SYAG',
			 'table' => 'CLX_SYS_NOTIFY_LOGS',
			 'dir' => ''
		  ), array('name' => 'temporary_files',
			 'dict' => 'GEN_LBL_DELETE_TEMPORARY_FILES',
			 'init' => false,
			 'table' => '',
			 'dir' => kPathToWebSite . kPathToTemp
		  ), array('name' => 'user_sessions',
			 'dict' => 'GEN_LBL_DELETE_USER_SESSIONS',
			 'init' => false,
			 'table' => 'CLX_AC_USER_SESSIONS',
			 'dir' => ''
		  ), array('name' => 'bugs',
			 'dict' => 'TOOL_BUGS_TITLE_LIST',
			 'init' => false,
			 'table' => 'CLX_BUGS',
			 'dir' => ''
		  )
        );
    }

    function panel($msg) {
        $contents = '';
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, 'UTIL');
        $form->addArgument('ut', $this->code);
        $form->addArgument('ac', 'PANEL');
        $form->addArgument('confirm', '1');
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('TOOL_CLEAR_LOG_TITLE'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('TOOL_CLEAR_LOG_EXPLAIN'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $class = CLX_CLASS_DATA;
        $total = count($this->interface);
        for ($i = CLX_INIT_ZERO; $i < $total; $i++) {

		  $source = '<b>' . dict($this->interface[$i]['dict']) . '</b><br>';
		  $radio = new htmlRadioButton($this->interface[$i]['name'], (empty($this->interface[$i]['init'])), CLX_NUM_ZERO); //None
		  $source .= dict('GEN_LBL_NONE') . ':' . $radio->source();
		  $radio = new htmlRadioButton($this->interface[$i]['name'], (empty($this->interface[$i]['archive']) && $this->interface[$i]['init']), CLX_NUM_ONE); //Delete
		  $source .= ' ' . dict('GEN_LBL_DELETE') . ':' . $radio->source();
		  if (!empty($this->interface[$i]['archive'])) {
			 $radio = new htmlRadioButton($this->interface[$i]['name'], (!empty($this->interface[$i]['archive']) && $this->interface[$i]['init']), CLX_NUM_TWO); //Archive
			 $source .= ' ' . dict('GEN_LBL_ARCHIVE') . ':' . $radio->source();
		  }
		  $table->addCell($source, array(CLX_PROP_CLASS => $class, CLX_PROP_COLSPAN => CLX_NUM_TWO));
		  $class = ($class == CLX_CLASS_DATA) ? CLX_CLASS_DATAALT : CLX_CLASS_DATA;
        }
        $c = new htmlSubmit('Clear');
        $buttons = $c->source();
        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents = $form->source();
        return $contents;
    }

    function checkPanel(&$msg) {
        $msg = array();
        return count($msg) == CLX_NUM_ZERO;
    }

    function execute_() {
        $callingpage = peekHistory();
        $ACAD = &getTool('ACAD');
        $tablerec = array();
        $parentrecid = CLX_INIT_ZERO;
        foreach ($this->interface as $key => $val) {
		  if (!empty(UserRequest::$request[$val['name']])) {
			 if ($val['table'] <> '') {
			     if (UserRequest::$request[$val['name']] == CLX_NUM_TWO) {
			         $tool = &getTool($val['tool']);
			         $tool->toolArchive();
			         $ACAD->log($tablerec, $parentrecid, 'ARCH_REC', 'Archived ' . $val['tool'] . ' records', $callingpage);
			     } else {
			         if (!empty($val['tool'])) {
					   $tool = &getTool($val['tool']);
					   if ($val['tool'] === 'PRLO') {
						  $tool->deleteLogsUtil();
					   } else {
						  $tool->deleteUtil();
					   }
					   $ACAD->log($tablerec, $parentrecid, 'DEL_REC', 'Clear audit records', $callingpage);
			         } else {
					   ClxCommon::$db->deleteRecords($val['table'], '1=1');
					   $ACAD->log($tablerec, $parentrecid, 'DEL_REC', 'Clear audit records', $callingpage);
			         }
			     }
			 }
			 if ($val['dir'] <> '') {
			     ClxFreeReturn($this->deleteDirectory($val['dir']));
			     $ACAD->log($tablerec, $parentrecid, 'DEL_REC', 'Clear export files', $callingpage);
			 }
		  }
        }
        
        apc_clear_cacheFct('user');
        
        return '';
    }

    /**
     * Clear Directory
     * Deletes all the elements on the directory in the $path variable.
     * It doesn't erase sub-directories, or the files inside them; it doesn't
     * delete the index.php file either. If the path in $path doesn't point
     * to a directory then it does nothing.
     * @param string $path
     * @return bool
     */
    private function deleteDirectory($path) {
        if (is_dir($path)) {
		  if (($dir = opendir($path)) === true) {
			 while (($file = readdir($dir)) !== false) {
			     if (!is_dir($path . $file) && $file !== 'index.php') {
			         unlink($path . $file);
			     }
			 }
		  }
        }
        return true;
    }

}
