<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('util') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'util.php';

class util_rename_field extends util {

    var $verbose = false; //Set true to display output

    // CONSTRUCTOR //

    function __construct() {
        error_reporting(E_ALL);
        ini_set('display_errors', 'on');
        $this->code = 'IPRF';
        $this->name = 'Rename Field Utilities';
        $this->type = 'UTIL';
        $this->version = '0.0.0.1';
        $this->description = 'Field rename process.';
        $this->haspanel = true;
        $this->debug = false;
        $this->panelform = array(CLX_CLASS_TITLE => 'UTIL_IPRF_TITLE_EXECUTE',
		  'panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_FIELDNAME',
					   'fields' => array(
						  array('name' => 'from_fieldname', 'type' => 'lookup', 'default' => '', 'tool' => 'DBFL', 'validations' => array(
								array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'fieldname', 'tablename' => 'CLX_DB_FIELDS'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_NEWFIELDNAME',
					   'fields' => array(
						  array('name' => 'to_fieldname', 'type' => 'lookup', 'default' => '', 'tool' => 'DBFL', 'validations' => array(
								array('type' => 'sqlobject', 'required' => '1'))
						  )
					   )
			         )
			     )
			 )
		  )
        );
    }

    function execute_() {
        $contents = $this->description . '<br>' . CLX_CHAR_NL;
        $from_field = UserRequest::$post[$this->code . '_from_fieldname'];
        $to_field = UserRequest::$post[$this->code . '_to_fieldname'];
        $contents .= dict('GEN_LBL_CONVERTING') . ': ' . $from_field . '->' . $to_field . '<bR>' . CLX_CHAR_NL;
        $sql = '';
        //Sockets
        $sql .='#' . CLX_CHAR_NL . '#Sockets' . CLX_CHAR_NL . '#' . CLX_CHAR_NL . CLX_CHAR_NL;
        $sql .='UPDATE CLX_EB_SOCKET_MAPPINGS SET TABLE_FIELDNAME = ' . singleQuote($to_field) . ' WHERE TABLE_FIELDNAME=' . singleQuote($from_field) . ';' . CLX_CHAR_NL . CLX_CHAR_NL;
        //Converting field
        $sql .='#' . CLX_CHAR_NL . '#Fields' . CLX_CHAR_NL . '#' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_DB_FIELDS SET FIELDNAME = ' . singleQuote($to_field) . ' WHERE FIELDNAME = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        //Campos en tablas
        $sql .='#' . CLX_CHAR_NL . '#Tablefields' . CLX_CHAR_NL . '#' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_DB_TABLEFIELDS SET FIELDNAME = ' . singleQuote($to_field) . ' WHERE FIELDNAME = ' . singleQuote($to_field) . ';' . CLX_CHAR_NL;
        $results = ClxCommon::$db->executeQuery('SELECT T.MODULECODE, T.IDNAME, TF.FIELDNAME FROM CLX_DB_TABLES T, CLX_DB_TABLEFIELDS TF WHERE T.IDCODE = TF.TABLECODE  AND T.TYPE NOT IN (' . singleQuote('TEMP') . ',' . singleQuote('VIEW') . ') AND	TF.FIELDNAME = ' . singleQuote($from_field));
        $sql .='#' . CLX_CHAR_NL . '#Tablefields alters' . CLX_CHAR_NL . '#' . CLX_CHAR_NL;
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
		  //alter table `sbv50bco`.`TEST_TEST_TBL` ,change `IDNAME` `IDNAME2` varchar (64)   NOT null
		  $fieldinfo = ClxCommon::$db->fieldInfo($result['MODULECODE'] . '_' . $result['IDNAME'], $result['fieldname']);
		  if ($fieldinfo['Type'] <> '') {
			 $sql .='ALTER TABLE ' . $result['MODULECODE'] . '_' . $result['IDNAME'] . ', CHANGE `$from_field` `$to_field` ' . $fieldinfo['Type'] . ';' . CLX_CHAR_NL;
		  }
        }
        //Views
        $sql .='#' . CLX_CHAR_NL . '#VIEWS. PLEASE AUDIT TABLE AFTER REPLACING FIELDNAME TO ENABLE VIEWS' . CLX_CHAR_NL . '#' . CLX_CHAR_NL;
        $results = ClxCommon::$db->executeQuery('SELECT T.IDCODE FROM CLX_DB_TABLES T, CLX_DB_TABLEFIELDS TF WHERE T.IDCODE = TF.TABLECODE  AND T.TYPE IN (' . singleQuote('VIEW') . ') AND	TF.FIELDNAME = ' . singleQuote($from_field));
        $sql .='#' . CLX_CHAR_NL . '#Views' . CLX_CHAR_NL . '#' . CLX_CHAR_NL;
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
		  $sql .='UPDATE CLX_DB_TABLES SET VIEW_QUERY = REPLACE(VIEW_QUERY,' . singleQuote($from_field) . ',' . singleQuote($to_field) . ') WHERE IDCODE =  ' . singleQuote($result['IDCODE']) . ';' . CLX_CHAR_NL;
        }
        //Derived fields
        $sql .='#' . CLX_CHAR_NL . '#Derived fields' . CLX_CHAR_NL . '#' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_DB_TABLEDFIELDS SET FIELDNAME = ' . singleQuote($to_field) . ' WHERE FIELDNAME = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        //Table indexes
        $sql .='#' . CLX_CHAR_NL . '#Indexes' . CLX_CHAR_NL . '#' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_DB_TABLEINDEXES SET IDCODE = REPLACE(IDCODE,' . singleQuote($from_field) . ',' . singleQuote($to_field) . ') WHERE FIELDNAME = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_DB_TABLEINDEXES SET FIELDNAME = ' . singleQuote($to_field) . ' WHERE FIELDNAME = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_DB_TABLEINDEXES SET FIELDNAME_SEC = ' . singleQuote($to_field) . ' WHERE FIELDNAME_SEC = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_DB_INDEX_COLUMNS SET FIELDNAME= ' . singleQuote($to_field) . ' WHERE FIELDNAME = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        $sql .='#' . CLX_CHAR_NL . '#To enable index change please.  Please audit db after executing script' . CLX_CHAR_NL . '#' . CLX_CHAR_NL;
        //Reports
        $sql .='#' . CLX_CHAR_NL . '#Reports' . CLX_CHAR_NL . '#' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_AN_REPORT_COLUMNS SET FIELDNAME = ' . singleQuote($to_field) . ' WHERE FIELDNAME = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_AN_REPORT_GROUPS SET FIELDNAME = ' . singleQuote($to_field) . ' WHERE FIELDNAME = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_AN_REPORT_GROUP_FUNC SET FIELDNAME = ' . singleQuote($to_field) . ' WHERE FIELDNAME = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        //Dynamic Relations
        $sql .='#' . CLX_CHAR_NL . '#Dynamic Relations' . CLX_CHAR_NL . '#' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_DB_DYNRELATIONS SET PRIMARY_SEARCHFIELD = ' . singleQuote($to_field) . ' WHERE PRIMARY_SEARCHFIELD = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_DB_DYNRELATIONS SET SECONDARY_SEARCHFIELD = ' . singleQuote($to_field) . ' WHERE SECONDARY_SEARCHFIELD = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        //Imports
        $sql .='#' . CLX_CHAR_NL . '#Imports' . CLX_CHAR_NL . '#' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_DB_IMPORT_MAPPINGS SET TABLE_FIELDNAME = ' . singleQuote($to_field) . ' WHERE TABLE_FIELDNAME = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_DB_IMPORT_ERRORS SET FIELDNAME = ' . singleQuote($to_field) . ' WHERE FIELDNAME = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        //Db Queries
        $sql .='#' . CLX_CHAR_NL . '#Queries' . CLX_CHAR_NL . '#' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_DB_QUERY_FIELDS SET FIELDNAME = ' . singleQuote($to_field) . ' WHERE FIELDNAME = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_DB_QUERY_CRITERIA SET FIELDNAME = ' . singleQuote($to_field) . ' WHERE FIELDNAME = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        //Calendars
        $sql .='#' . CLX_CHAR_NL . '#Calendars' . CLX_CHAR_NL . '#' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_UI_CALENDAR SET FIELDNAME =  ' . singleQuote($to_field) . ' WHERE FIELDNAME = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_UI_CALENDAR SET EXTRA_FIELD1 = ' . singleQuote($to_field) . ' WHERE EXTRA_FIELD1 = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_UI_CALENDAR SET RECURRENCE_FIELD = ' . singleQuote($to_field) . ' WHERE RECURRENCE_FIELD = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_UI_CALENDAR SET DISPLAYFIELD = ' . singleQuote($to_field) . ' WHERE DISPLAYFIELD = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        //Form panel fields
        $sql .='#' . CLX_CHAR_NL . '#Form panel fields' . CLX_CHAR_NL . '#' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_UI_FORM_PANEL_FIELDS SET FIELDNAME = ' . singleQuote($to_field) . ' WHERE FIELDNAME = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        //UI Filter criteria
        $sql .='#' . CLX_CHAR_NL . '#Filter' . CLX_CHAR_NL . '#' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_UI_FILTER_CRITERIA SET FIELDNAME = ' . singleQuote($to_field) . ' WHERE FIELDNAME = ' . singleQuote($from_field) . ';' . CLX_CHAR_NL;
        //UI Form listings
        $sql .='#' . CLX_CHAR_NL . '#Form listings. WARNING: MAY REPLACE MORE THAN REQUIRED' . CLX_CHAR_NL . '#' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_UI_FORM_LISTING_CRITS SET FIELDNAME1 = REPLACE(FIELDNAME1,' . singleQuote($from_field) . ',' . singleQuote($to_field) . ') WHERE FIELDNAME1 LIKE %' . singleQuote($from_field . '%') . ';' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_UI_FORM_LISTING_CRITS SET FIELDNAME2 = REPLACE(FIELDNAME2,' . singleQuote($from_field) . ',' . singleQuote($to_field) . ') WHERE FIELDNAME2 LIKE %' . singleQuote($from_field . '%') . ';' . CLX_CHAR_NL;
        //Ui filters
        $sql .='#' . CLX_CHAR_NL . '#User Interfase WARNING: MAY REPLACE MORE THAN REQUIRED' . CLX_CHAR_NL . '#' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_UI_FILTERS SET SQL_COMMANDS = REPLACE(SQL_COMMANDS,' . singleQuote($from_field) . ',' . singleQuote($to_field) . ') WHERE SQL_COMMANDS LIKE %' . singleQuote($from_field . '%') . ';' . CLX_CHAR_NL;
        $sql .='#' . CLX_CHAR_NL . '#Queries Criteria WARNING: MAY REPLACE MORE THAN REQUIRED' . CLX_CHAR_NL . '#' . CLX_CHAR_NL;
        $sql .='UPDATE CLX_DB_QUERY_CRITERIA SET VALUE = REPLACE(VALUE,' . singleQuote($from_field) . ',' . singleQuote($to_field) . ') WHERE VALUE LIKE %' . singleQuote($from_field . '%') . ';' . CLX_CHAR_NL;
        $txtArea = new htmlTextArea($this->code . '_source', $sql, CLX_NUM_30, CLX_NUM_120);
        $contents .= $txtArea->source() . '<br><br>';
        $contents = dialog(dict('UTIL_IPRF_TITLE_EXECUTE'), '', $contents, '');
        return $contents;
    }

}

//End Class
