<?php

/**
 * Tool App
 * Same as tool.php but for code library items instead of tools. Usefull to download files associated to data/code/programs
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-12-29 00:00:08 +0000 (Sat, 29 Dec 2018) $
 * @version    	$Rev: 10429 $
 */
function clxMainToolApp($template_name = 'master.html', $no_login = false, $attach_messages = true) {
    try {
        $prev_req = (!empty($_SESSION['PREV_REQ']))?$_SESSION['PREV_REQ']:'';
        $contents = '';
        $stime = microtime_float();
        $ACUS = &getTool('ACUS');
        $ACUS->login();

        if(!empty($prev_req)){
		  $_SESSION['PREV_REQ'] = $prev_req;
        }
        changeLanguage(); //Set Language
        $PAGE_VARIABLES = getVariables();

        UserRequest::getLookUpValues();

        if (!empty(UserRequest::$request['no_menu']) && !defined('clxDisplayNoMenus')) {
		  define('clxDisplayNoMenus', 1);
        }
        if (!empty(UserRequest::$request['no_alerts']) && !defined('clxDisplayNoAlerts')) {
		  define('clxDisplayNoAlerts', 1);
        }

        $action = UserRequest::$server['PHP_SELF'];
        $idlist = getIdlist();
        //pop up
        if (array_key_exists('pop', UserRequest::$request)) {

		  $pop = UserRequest::$request['pop'];
		  for ($i = CLX_INIT_ZERO; $i < $pop; $i++) {
			 $info = popHistory();
			 if (array_key_exists('idlist', $info)) {
			     $idlist = toArray($info['idlist']);
			 }
		  }
		  foreach ($info as $key => $value) {
			 UserRequest::$request[$key] = $value;
		  }
        }

        $to = (array_key_exists(CLX_PROP_TO, UserRequest::$request)) ? UserRequest::$request[CLX_PROP_TO] : '';
		if ( !empty($_SESSION["_dEBUG"]) ) { 
			$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");
			
			fwrite($tta,chr(13).chr(10)."4-hora:".date("h:i:s d/m/Y").chr(13).chr(10));
			fwrite($tta,chr(13).chr(10)."to: ".$to.chr(13).chr(10));	
			$te=debug_backtrace();

			for ($t=0;$t<12;$t++) {
				if (isset($te[$t]["file"]))
				fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));


			}
			fclose($tta);
		}	

        if (!empty($_SESSION['PREV_REQ']) && ClxCommon::sessionHasUser()) {
		  $redirect_to = $_SESSION['PREV_REQ'];
		  unset($_SESSION['PREV_REQ']);
		  header('location: ' . $redirect_to);
		  salir(CLX_NUM_ZERO);
        } elseif (ClxCommon::sessionHasUser() && !empty($to)) {
		  $ac = (array_key_exists('ac', UserRequest::$request)) ? UserRequest::$request['ac'] : '';
		  //Save history from forms that is required to search lists

		  if (array_key_exists('main', UserRequest::$get) && UserRequest::$get['main'] === 'SETPRENTINF') {
			 setParentForm(UserRequest::$post);
			 salir(CLX_NUM_ZERO);
		  }
		  if (array_key_exists('main', UserRequest::$get) && UserRequest::$get['main'] === 'UNSETPRENTINF') {
			 unsetParentForm();
			 salir(CLX_NUM_ZERO);
		  }
		  //Clear search listing history if not list. Note that uset and set are no $to=edit
		  //that is why it must run latter
		  if ($to === 'FINN') {//run financial opciones
			 return financial_tools($ac);
		  }
			if ( !empty($_SESSION["_dEBUG"]) ) { 
				$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");
				fwrite($tta,chr(13).chr(10)."app-4-hora:".date("h:i:s d/m/Y").chr(13).chr(10));
				fwrite($tta,chr(13).chr(10)."to: ".$to.chr(13).chr(10));	
				$te=debug_backtrace();
				for ($t=0;$t<18;$t++) {
					if (isset($te[$t]["file"]))
						fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));
				}
				fclose($tta);
			}	
		  if ($to == 'POPCLEAR') {
			 $hkey = 'pop';
			 $ini = UserRequest::$request['ventanapop'] - CLX_NUM_ONE;
			 $max = (!isset($_SESSION['history']['pop']) ? 0 : count($_SESSION['history']['pop'])) - CLX_NUM_ONE;
			 for ($t = $max; $t >= $ini; $t--) {
			     array_splice($_SESSION['history']['pop'], CLX_NUM_MINUS_1, CLX_NUM_ONE);
			 }
		  } else {
			 //$tool = &getTool($to);
				$to = uppercase($to);
				includeCodeLib($to);
			 $tool = new $to();
				// Code library program must have a class named like IDCODE of library (all in uppercase) and a method called "action" with two parameters: $ac, $idlist
				$contents = $tool->action($ac, $idlist);
				unset($tool);
		  }
        } elseif (ClxCommon::sessionHasUser()) {
		  clearHistory();  //Clearing History on Index Page.
		  clearParentForm(); //clearing form history
		  $PAGE_VARIABLES['PAGE_TITLE'] = dict('GEN_LBL_PAGETITLE');
		  $UIPG = &getTool('UIPG');
		  $contents = $UIPG->action('DEF_PAGE', array());
        } elseif ($no_login === true) {
		  $variables = array();
		  $contents = '';
        } elseif (isset(UserRequest::$request['timeout'])) {
		  $PAGE_VARIABLES['PAGE_TITLE'] = dict('GEN_LBL_TIMEOUT');
		  $variables = array();
		  $variables['ACTION'] = $action;
		  $variables['USERNAME'] = '';
		  $variables['MSG'] = dict('GEN_LBL_SESSIONTIMEOUT');
		  $contents = getSkinForm('login.html', $variables);
        } elseif (isset(UserRequest::$post['username'])) {
		  $PAGE_VARIABLES['PAGE_TITLE'] = dict('GEN_ERR_USERNAME_INVALID');
		  $variables = array();
		  $variables['ACTION'] = $action;
		  $variables['USERNAME'] = UserRequest::$post['username'];
		  $variables['MSG'] = $ACUS->get_login_msg();
		  $contents = getSkinForm('login.html', $variables);
        } else {
		  $PAGE_VARIABLES['PAGE_TITLE'] = dict('GEN_LBL_PAGETITLE');
		  $variables = array();
		  $variables['ACTION'] = $action;
		  $variables['USERNAME'] = '';
		  $variables['MSG'] = $ACUS->get_login_msg();
		  //store next request login
		  if (!empty(UserRequest::$get)) {
			 $url = $action . '?';
			 $comma = '';
			 foreach (UserRequest::$get as $key => $val) {
			     $url .= $comma . $key . '=' . $val;
			     $comma = '&';
			 }
			 //Unset preffered should not be redirected
			 if (empty(UserRequest::$get['main']) || UserRequest::$get['main'] <> 'UNSETPRENTINF') {
			     $_SESSION['PREV_REQ'] = $url;
			 }
		  }

		  //Setting main opener
		  /* if (!empty(UserRequest::$get['ibslog']) && empty($_SESSION['iframeMain'])) {
		    return setIfmOpener();
		    } */

		  if (defined('kDefaultFrameLess') && kDefaultFrameLess) {
			 //Set Frameless
			 if (empty($_SESSION['frameless'])) {
			     $_SESSION['frameless'] = CLX_NUM_ONE;
			     $contents = '<script type="text/javascript" language="Javascript">' . CLX_CHAR_NL . 'var winprops=' . singleQuote(' toolbar=0,location=0,directories=0,status=1,menubar=0,scrollbars=1,resizable=1, width=screen.width, height=screen.height, screenX=0,screenY=0,left=0,top=') . CLX_CHAR_NL . 'newWind=window.open(window.location, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', winprops);' . CLX_CHAR_NL . 'newWind.resizeTo(screen.availWidth,screen.availHeight);' . CLX_CHAR_NL . '</script>';
			     $PAGE_VARIABLES['PAGE_TITLE'] = dict('GEN_LBL_PAGETITLE');
			     $PAGE_VARIABLES['MENUS'] = (defined('clxDisplayNoMenus')) ? '' : pageMenus();
			     $PAGE_VARIABLES['CONTENTS'] = $contents;
			     $contents .= getSkinForm('mainOpener.html', $PAGE_VARIABLES);
			     return $contents;
			 }
		  }
		  if ($template_name == CLX_TPL_POP)
			 $contents.= setJavaScriptTag('if (location!=parent.location) parent.location="index.php"');
		  else
			 $contents = getSkinForm('login.html', $variables);
        }
        if (UserResponse::getCustomHeaders()) {
		  UserResponse::sendHeaders();
        } else {
		  //Adding alert messages
		  if ($attach_messages === true) {
			 $contents = displayMessage() . $contents;
		  }
		  //pdf json xml html
		  //setting encoding according requirement
		  $PAGE_VARIABLES['MENUS'] = (defined('clxDisplayNoMenus')) ? '' : pageMenus();
		  $PAGE_VARIABLES['CONTENTS'] = $contents;
		  $PAGE_VARIABLES['PAGETIME'] = rounder((microtime_float() - $stime), CLX_NUM_FOUR);
		  $PAGE_VARIABLES['PAGEPEAKSIZE'] = rounder((memory_get_peak_usage(false) / CLX_NUM_1024), CLX_NUM_TWO) . ' Kb';
		  $PAGE_VARIABLES['BREADCRUMBS'] = makeBreadCrumbs();
		  $contents = getSkinForm($template_name, $PAGE_VARIABLES);
        }
        return $contents;
    } catch (Exception $e) {
        //Exception
    }
}

ob_start();
require 'includes/constants.php';
require 'includes/includes.php';
PrepareConstants();
ConnectToDatabase();
initTools();
echo clxMainToolApp();
ob_end_flush();
