<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Included label
 */
class ac_group_members extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'ACGM';
        $this->name = 'Group Members';
        $this->system = 'Security';
        $this->version = '0.1.0.0';
        $this->accesskey = 'ACGR';



        $this->tablename = 'CLX_AC_GROUP_MEMBERS';
        $this->record_name_singular = 'group member';
        $this->record_name_plural = 'group members';
        $this->primary_field = 'GROUPCODE';
        $this->secondary_field = 'USERNAME';
    }

    function install() {
        if (ClxCommon::$db->oneExistsRecords($this->tablename, 'GROUPCODE=' . singleQuote('admin') . ' AND USERNAME=' . singleQuote('admin')) == CLX_NUM_ZERO) {
		  ClxCommon::$db->createRecord($this->tablename, array('GROUPCODE' => 'admin', 'USERNAME' => 'admin'), false);
        }
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['GROUPCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'GROUPCODE,USERNAME');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

}
