<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 */
class ac_tree_levels extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'ACTL';
        $this->name = 'Access Tree Levels';
        $this->system = 'Security';
        $this->version = '0.3.4.0';

        $this->accesskey = 'ACTR';


        $this->tablename = 'CLX_AC_TREE_LEVELS';
        $this->record_name_singular = 'tree level';
        $this->record_name_plural = 'tree levels';
        $this->primary_field = 'TREECODE';
        $this->secondary_field = 'LEVELS';
        $this->seqnum_field = 'LEVELS';
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_ACTL_TITLE_MODIFY',
		  'panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_FORMAT',
					   'fields' => array(
						  array('name' => 'format', 'type' => 'string', 'default' => '', 'size' => '10', 'displaysize' => '10', 'dontmodify' => '1',
						      'validations' => array(
								array('type' => 'string', 'required' => '1'))
						  )
					   )
			         ), array('label' => 'TOOL_ACTL_PROMPT_NAMESING',
					   'fields' => array(
						  array('name' => 'name_singular', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48', 'validations' => array(
								array('type' => 'string', 'required' => '1'))
						  )
					   )
			         ), array('label' => 'TOOL_ACTL_PROMPT_NAMEPLUR',
					   'fields' => array(
						  array('name' => 'name_plural', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48', 'validations' => array(
								array('type' => 'string', 'required' => '1'))
						  )
					   )
			         ), array('fields' => array(
						  array('name' => 'levels', 'type' => 'string', 'invisible' => '1', 'size' => '3', 'validations' => array(
								array('type' => 'string', 'required' => '1'))
						  )
					   )
			         ), array('fields' => array(
						  array('name' => 'treecode', 'type' => 'string', 'invisible' => '1', 'size' => '255', 'validations' => array(
								array('type' => 'string', 'required' => '1'))
						  )
					   )
			         )
			     )
			 )
		  )
        );
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['TREECODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['NAME_SINGULAR'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['NAME_PLURAL'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['LEVELS'] = array('type' => 'tinyint(3) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['FORMAT'] = array('type' => 'varchar(10)', 'null' => 'YES', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'TREECODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null, 'treecode' => null), $parameters));
        list($package, $treecode) = $parameters;
        $record = $this->unpackRecord($package);
        ClxCommon::$db->createRecord($this->tablename, $record, false);
    }

    function makepanel($groupcode = null) {
        if ($this->getAccess()->canRead()) {
		  $t = time();
		  $to = $this->code;
		  $here = 'tool.php?to=' . $to . '&t=' . $t;
		  $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
		  $form->setProp(CLX_PROP_ID, 'ACTLPanel');
		  $form->addArgument(CLX_PROP_TO, $this->code);
		  $form->addArgument('treecode', $groupcode);
		  $form->addArgument('ac', 'NOT_DEFINED');
		  $selectclause = '*';
		  $fromclause = 'CLX_AC_TREE_LEVELS';
		  $whereclause = 'TREECODE=' . singleQuote($groupcode);
		  $sortclause = 'LEVELS ASC';
		  $page = new xPaging();
		  $page->setProp('rpp', CLX_NUM_TEN_THOUSAND);
		  $page->setProp('printheaders', false);
		  $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
		  $table = new htmlTable(CLX_WIDTH_FOUR);
		  $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
		  $page->header($table);
		  $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_LEVEL'), dict('GEN_LBL_NAME'), dict('GEN_LBL_FORMAT')));
		  $i = CLX_INIT_ZERO;
		  while ($record = $page->nextRecord()) {
			 $recordid = $record['ID'];
			 $select = new htmlCheckbox('selector_' . $recordid, false);
			 $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
			 $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
			 $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['LEVELS'], $record['NAME_SINGULAR'] . '/' . $record['NAME_PLURAL'], $record['FORMAT']));
			 $i++;
		  }
		  $buttons = '';
		  if ($this->getAccess()->canModify()) {
			 $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
		  }
		  if ($this->getAccess()->canDelete()) {
			 $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
		  }
		  if ($this->getAccess()->canDisplay()) {
			 $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_LEVEL')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
		  }
		  if ($page->getProp('qty') > CLX_NUM_ONE) {
			 $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_REORDER'), array('action' => 'REORDER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
		  }
		  $form->addContents($page->footers($table, $buttons));
		  $modulecode = '';
		  return buildPanelInterface(dict('TOOL_ACTL_TITLE_LIST'), $modulecode . 'TABLES', $form->source(), CLX_NUM_MINUS_1);
        } else {
		  return CLX_CHAR_EMPTY_STRING;
        }
    }

    function checkForm(&$msg) {
        $msg = array();
        xValidate::required($msg, 'ACTL_format', UserRequest::$post['ACTL_format']);
        xValidate::subformat($msg, 'ACTL_format', UserRequest::$post['ACTL_format']);
        return count($msg) == CLX_NUM_ZERO;
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('TOOL_ACTL_PROMPT_NAMESING') . ':', $record['ACTL_name_singular']);
    }

    function reorderRecords() {
        $records = ClxCommon::$db->getRecords($this->tablename, 'UPPER(TREECODE)=' . singleQuote(uppercase(UserRequest::$post['treecode'])) . ' ORDER BY LEVELS');
        $list = array();
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
		  $list[$record['ID']] = $record['NAME_SINGULAR'];
        }
		ClxCommon::$db->freeResult( $records );
        return $list;
    }

    function reorderAction() {
        parent::reorderAction();
        $callingpage = peekHistory();
        $treecode = $callingpage['treecode'];
        $ACTR = &getTool('ACTR');
        $ACTR->versionIncrease('IDCODE', $treecode);
    }

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $recordid);
        $record = array();
        $record['ACTL_id'] = $recordid;
        $record['ACTL_treecode'] = $values['TREECODE'];
        $record['ACTL_levels'] = $values['LEVELS'];
        $record['ACTL_name_singular'] = $values['NAME_SINGULAR'];
        $record['ACTL_name_plural'] = $values['NAME_PLURAL'];
        $record['ACTL_format'] = $values['FORMAT'];
        return $record;
    }

    function saveRecord() {
        $record = array();
        $record['NAME_SINGULAR'] = UserRequest::$post['ACTL_name_singular'];
        $record['NAME_PLURAL'] = UserRequest::$post['ACTL_name_plural'];
        $record['FORMAT'] = UserRequest::$post['ACTL_format'];
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['ACTL_id']);
        $ACTR = &getTool('ACTR');
        $ACTR->versionIncrease('IDCODE', UserRequest::$post['ACTL_treecode']);
        $ACTR->updateTree(UserRequest::$post['ACTL_treecode']);
    }

    function createRecordVoid_() {
        ClxFreeReturn($this->createRecord_());
    }

    function createRecord_() {
        $record = array();
        $record['TREECODE'] = UserRequest::$post['ACTL_treecode'];
        $record['NAME_SINGULAR'] = UserRequest::$post['ACTL_name_singular'];
        $record['NAME_PLURAL'] = UserRequest::$post['ACTL_name_plural'];
        $record['LEVELS'] = UserRequest::$post['ACTL_levels'];
        $record['FORMAT'] = UserRequest::$post['ACTL_format'];
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $ACTR = &getTool('ACTR');
        $ACTR->versionIncrease('IDCODE', $record['TREECODE']);
        $ACTR->updateTree($record['TREECODE']);
        return $recordid;
    }

    function deleteRecordSk($id) {
        $treelevelrec = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $id);
        $treecode = $treelevelrec['TREECODE'];
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
        $ACTR = &getTool('ACTR');
        $ACTR->versionIncrease('IDCODE', $treecode);
        $ACTR->updateTree($treecode);
    }

    function defaultRecord() {
        $callingpage = peekHistory();
        $record = array();
        $record['ACTL_id'] = CLX_INIT_ZERO;
        $record['ACTL_treecode'] = $callingpage['treecode'];
        $record['ACTL_name_singular'] = '';
        $record['ACTL_name_plural'] = '';
        $record['ACTL_format'] = '##';
        $record['ACTL_levels'] = ClxCommon::$db->getField($this->tablename, 'LEVELS', 'UPPER(TREECODE)=' . singleQuote(uppercase(UserRequest::$post['treecode'])) . ' ORDER BY LEVELS DESC') + CLX_NUM_ONE;
        return $record;
    }

}
