<?php

/**
 * Translation Sets Manager
 *
 * @package		Clientix.Tool.Analytics
 * @abstract		Reports Header and footer
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2014-02-14 18:24:44 -0430 (vie, 14 feb 2014) $
 * @version    	$Rev: 4568 $
 *
 * CHANGE LOG
 */
class an_head_foot extends clx_tool {

    var $debug = false;

    function __construct() {

	$this->code = 'ANHF';
	$this->name = 'Header y Footer';
	$this->system = 'Analytics';
	$this->version = '1.0.0.0';

	$this->has_preferences = false;
	$this->has_access = true;
	$this->has_package = true;
	$this->has_pagelet = false;
	$this->primary_key = array('IDCODE');
	$this->tablename = 'CLX_AN_HEAD_FOOT';
	$this->record_name_singular = 'HEADER_FOOTER';
	$this->record_name_plural = 'HEADERS_FOOTERS';

	$this->primary_field = 'IDCODE';
	$this->secondary_field = 'IDNAME';
	$this->seqnum_field = '';
	$this->accesskey = 'ANRP';
	$this->has_access = true;
	$this->editform = array(
	    'title' => 'TOOL_ANHF_TITLE_CREATE',
	    'panels' => array(
		array('type' => 'normal',
		    'entries' => array(
			array(
			    'label' => 'GEN_LBL_CODE',
			    'fields' => array(
				array('name' => 'idcode', 'type' => 'string', 'default' => '', 'size' => '16', 'displaysize' => '16', 'dontmodify' => '1',
				    'validations' => array(
					array('type' => 'sqlobject', 'required' => '1'),
					array('type' => 'unique', 'fieldname' => 'idcode', 'tablename' => $this->tablename)
				    )
				)
			    )
			),
			array(
			    'label' => 'GEN_LBL_ACTIVE',
			    'fields' => array(
				array('name' => 'active',
				    'type' => 'list', 'default' => '1',
				    'options' => $this->yesno,
				    'validations' => array()
				)
			    )
			),
			array(
			    'label' => 'GEN_LBL_NAME',
			    'fields' => array(
				array('name' => 'idname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48',
				    'validations' => array(
					array('type' => 'string', 'required' => '1')
				    )
				)
			    )
			),
			array(
			    'label' => 'GEN_LBL_VERSION',
			    'fields' => array(
				array('name' => 'version', 'type' => 'string', 'default' => '1.0.0', 'size' => '32', 'displaysize' => '16',
				    'validations' => array(
					array('type' => 'string', 'required' => '1')
				    )
				)
			    )
			),
			array(
			    'label' => 'GEN_LBL_MODULECODE',
			    'fields' => array(
				array('name' => 'modulecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBMO',
				    'validations' => array(
					array('type' => 'sqlobject', 'required' => '1'),
					array('type' => 'lookup', 'fieldname' => 'idcode', 'tablename' => 'CLX_DB_MODULES')
				    )
				)
			    )
			)
		    )
		),
		array('type' => 'normal',
		    'title' => 'GEN_LBL_HEADER',
		    'entries' => array(array(
			    'label' => 'GEN_LBL_HLEFT',
			    'fields' => array(
				array('name' => 'hleft', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4')
			    )
			),
			array(
			    'label' => 'GEN_LBL_HCENTER',
			    'fields' => array(
				array('name' => 'hcenter', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4')
			    )
			),
			array(
			    'label' => 'GEN_LBL_HRIGHT',
			    'fields' => array(
				array('name' => 'hright', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4')
			    )
			))),
		array(
		    'type' => 'normal',
		    'title' => 'GEN_LBL_FOOTERS',
		    'entries' => array(
			array(
			    'label' => 'GEN_LBL_FLEFT',
			    'fields' => array(
				array('name' => 'fleft', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4')
			    )
			),
			array(
			    'label' => 'GEN_LBL_FCENTER',
			    'fields' => array(
				array('name' => 'fcenter', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4')
			    )
			),
			array(
			    'label' => 'GEN_LBL_FRIGHT',
			    'fields' => array(
				array('name' => 'fright', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4')
			    )
			)
		    )
		)
	    )
	);

	$this->viewform = $this->editform;
    }

// End method

/*	function init() {
		$ACTO = &getTool("ACTO");
		$this->accesskey = $this->code;
		$this->access = $ACTO->getAccess($this->accesskey);
	}*/
//------------------------------------------------------------------------------

    function install() {
	$UIMI = getTool('UIMI');
	$UIMI->add($this->code, 'MENU_TOOLS:MENU_ANALYTICS:MENU_ANHF_SET', 'TOOL', $this->code, 'ac=LIST');
    }

    function toolTableStructure() {
	$fields = array();
	$fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
	$fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
	$fields['IDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
	$fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
	$fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => 0);
	$fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
	$fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
	$fields['HLEFT'] = array('type' => 'mediumtext', 'properties' => '');
	$fields['HCENTER'] = array('type' => 'mediumtext', 'properties' => '');
	$fields['HRIGHT'] = array('type' => 'mediumtext', 'properties' => '');
	$fields['FLEFT'] = array('type' => 'mediumtext', 'properties' => '');
	$fields['FCENTER'] = array('type' => 'mediumtext', 'properties' => '');
	$fields['FRIGHT'] = array('type' => 'mediumtext', 'properties' => '');
	$fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
	$fields['ACTIVE'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => 0);

	$indexes = array();
	$ipf = 'CLX' . $this->code;
	$indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
	$indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
	$indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'IDNAME');
	return array('idcode' => $this->code,
	    'idname' => $this->name,
	    'name' => $this->tablename,
	    'type' => 'InnoDB',
	    'fields' => $fields,
	    'indexes' => $indexes);
    }

//------------------------------------------------------------------------------
//-- M E S A G E S
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
	function setHeader(clx_report_data $header) {
        $this->header[] = $header;
    }

    /**
     * Set Report Header
     * @return data
     */
    function getHeader() {
        return $this->header;
    }

    /**
     * (non-PHPdoc)
     * @see clx_tool::action()
     */

    function action($ac, $idlist) {
	if ($this->getAccess()->canRead()) {
	    switch ($ac) {
		case 'LIST':

		    $contents = parent::action($ac, $idlist);

		    break;
		default:
		    $contents = parent::action($ac, $idlist);
		    break;
	    }
	} else {
	    $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [SYS_TRANSLATION_SETS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
	}
	return $contents;
    }

//------------------------------------------------------------------------------
    /**
     * (non-PHPdoc)
     * @see clx_tool::makelist()
     */
    function makelist($listingcode = null) {

	$t = time();
	$to = $this->code;
	$here = 'tool.php?to=' . $to.'&t=' . $t;

	clearHistory();
	pushHistory($this->code, 'LIST', array());

	$form = new htmlForm('action', 'tool.php');
	$form->setProp('id', $this->code . 'List');
	$form->addArgument('to', $this->code);
	$form->addArgument('ac', 'NOT_DEFINED');

	$selectclause = '*';
	$fromclause = $this->tablename;
	$whereclause = '';
	$sortclause = '';
	$page = new xPaging();
	$page->pageinit($form->getProp('id'), $here, $selectclause, $fromclause, $whereclause, $sortclause);

	$tableWidth = CLX_NUM_12;
	$table = new htmlTable($tableWidth, 'class', 'list', 'width', '100%');
	$table->addCell(dict('TOOL_ANHF_TITLE_LIST'), array('class'=> 'title', 'colspan'=> $tableWidth));
	$page->header($table);

	$table->addCells('headers', array(dict('GEN_LBL_SEL'), dict('GEN_LBL_CODE'), dict('GEN_LBL_NAME'), dict('GEN_LBL_VERSION'), dict('GEN_LBL_HLEFT'), dict('GEN_LBL_HCENTER'), dict('GEN_LBL_HRIGHT'), dict('GEN_LBL_FLEFT'), dict('GEN_LBL_FCENTER'), dict('GEN_LBL_FRIGHT'), dict('GEN_LBL_MODULECODE'), dict('GEN_LBL_ACTIVE')));
	$i = CLX_NUM_ZERO;
	while (($record = $page->nextRecord()) == true) {
	    $recordid = $record['ID'];
	    $select = new htmlCheckbox('selector_' . $recordid, false);
	    $select->setProp('onclick', 'selectButtons(' .singleQuote($form->getProp('id')) . ');');
	    $table->addCell($select->source(), array('class'=> 'footers', 'width'=> '40', 'align'=> 'center'));
	    $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? 'data' : 'dataalt',array( $record['IDCODE'], $record['IDNAME'], $record['VERSION'] . '-' . $record['VERSION_COUNTER'], xFormat::text($record['HLEFT']), xFormat::text($record['HCENTER']), xFormat::text($record['HRIGHT']), xFormat::text($record['FLEFT']), xFormat::text($record['FCENTER']), xFormat::text($record['FRIGHT']), xFormat::text($record['MODULECODE']), xFormat::text($record['ACTIVE']))
	    );
	    $i++;
	}

	$buttons = '';
	$b = new htmlFormSubmit(dict('GEN_LBL_DISPLAY'), 'DISPLAY', $form->getProp('id'));
	$b->setProp('id', 'MULT');
	$buttons .= $b->source();
	if ($this->getAccess()->canModify()) {
	    $b = new htmlFormSubmit(dict('GEN_LBL_MODIFY'), 'MODIFY', $form->getProp('id'));
	    $b->setProp('id', 'MULT');
	    $buttons .= $b->source();
	}
	if ($this->getAccess()->canDelete()) {
	    $b = new htmlFormSubmit(dict('GEN_LBL_DELETE'), 'DELETE', $form->getProp('id'));
	    $b->setProp('id', 'MULT');
	    $buttons .= $b->source();
	}
	if ($this->getAccess()->canAppend()) {
	    $b = new htmlFormSubmit(dict('GEN_LBL_CREATE'), 'CREATE', $form->getProp('id'));
	    $b->setProp('id', 'ON');
	    $buttons .= $b->source();
	}

	if ($this->getAccess()->canAppend()) {
	    $b = new htmlFormSubmit(dict('GEN_LBL_DUPLICATE', dict('GEN_LBL_DUPLICATE')), 'DUPLICATE', $form->getProp('id'));
	    $b->setProp('id', 'ONE');
	    $buttons .= $b->source();
	}
	$b = new htmlFormSubmit(dict('GEN_LBL_FILTER'), 'FILTER', $form->getProp('id'));
	$b->setProp('id', 'ON');
	$buttons .= $b->source();

	$form->addContents($page->footers($table, $buttons));
	return $form->source();
    }

//------------------------------------------------------------------------------

    function searchForm() {

	$contents = '';
	$msg = array();
	// Search Form
	$form = new htmlForm('action', $_SERVER['PHP_SELF']);
	$form->addArgument('to', $this->code);
	$form->addArgument('ac', 'SEARCH');
	$form->addArgument('confirm', '1');
	$form->addArgument('target',   UserRequest::$request['target']);
	if (!array_key_exists('ANHF_modulecode', UserRequest::$post))
		  UserRequest::$post['ANHF_modulecode'] = '';
	$tableWidth = 2;
	$table = new htmlTable($tableWidth, 'class', 'form', 'width', '100%');
	$table->addCell(dict('TOOL_ANHF_TITLE_SEARCH'), array('class'=>'title', 'colspan'=> $tableWidth));

	$table->addField($msg, dict('GEN_LBL_CODE') . ':', 'ANHF_idcode', (array_key_exists('ANHF_idcode', UserRequest::$post)) ? UserRequest::$post['ANHF_idcode'] : '', 16, 16);
	$table->addField($msg, dict('GEN_LBL_NAME') . ':', 'ANHF_idname', (array_key_exists('ANHF_idname', UserRequest::$post)) ? UserRequest::$post['ANHF_idname'] : '', 32, 64);
	$table->addField($msg, dict('GEN_LBL_MODULECODE') . ':', 'ANHF_modulecode', UserRequest::$post['ANHF_modulecode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
	$c = new htmlFormSubmit(dict('GEN_LBL_SEARCH'), 'SEARCH', $form->getProp('id'));
	$buttons = $c->source();
	$c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
	$buttons .= $c->source();
	$table->addCell($buttons, array('class'=> 'footers', 'colspan'=> $tableWidth));

	$form->setContents($table->source());
	$contents .= $form->source();

	// Search Procedure

	if (isset(UserRequest::$post['confirm'])) {
	    $tableWidth = CLX_NUM_ZERO;
	    $table = new htmlTable($tableWidth, 'class', 'list', 'width', '100%');

	    $criteria = '';

	    if (UserRequest::$post[$this->code . '_idcode'] <> '') {
		$criteria .= 'UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post[$this->code . '_idcode']) . '%');
	    }

	    if (UserRequest::$post[$this->code . '_idname'] <> '') {
		$criteria .= 'UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post[$this->code . '_idname'])) . '%');
	    }
	    if (UserRequest::$post[$this->code . '_modulecode'] <> '') {
		$criteria .= 'UPPER(MODULECODE) LIKE '. singleQuote(uppercase(UserRequest::$post[$this->code . '_modulecode']) . '%');
	    }

	    $qty =  ClxCommon::$db->oneExistsRecords($this->tablename, $criteria);
	    if ($qty == CLX_NUM_ZERO) {
		$table->addCell(dict('TOOL_GEN_ERR_NOMATCH'), array('class'=> 'alert', 'colspan'=> $tableWidth));
	    } else {
		$table->addCell(dict('TOOL_GEN_MSG_FOUNDRECORDS'),array('class'=> 'subtitle', 'colspan'=> $tableWidth));
		$records = ClxCommon::$db->getRecords($this->tablename, $criteria);
		$i = CLX_NUM_ZERO;

		while (($record = ClxCommon::$db->getNextRecord($records)) == true) {
		    $js = 'javascript:setLookupValue(' . quote(UserRequest::$request['target']) . ', ' . quote($record['IDCODE']) . ');';
		    $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? 'data' : 'dataalt', array('<page t=an_head_foot></page><a href=' . singleQuote($js).'>' . $record['IDCODE'] . '</a>', $record['IDNAME']));
		    $i++;
		}
		ClxCommon::$db->freeResult($records);
	    }

	    $contents .= $table->source();
	}

	return $contents;
    }

    function search_Data($groupcode = array()) {
        return (empty($groupcode['search']))?null:$this->getToolRecord($groupcode['search']);
    }

    function makepanel($groupcode = array()) {
	$value = $this->search_data($groupcode);
	if ($groupcode['type_report']!='EXCEL') {
	    $table = new htmlTable('3', 'style', 'table-layout:fixed;', 'width', '100%');
	    $position = (UCFIRST($groupcode['position']) == 'Header') ? 'H' : 'F';
	    $table->addCell( ( isset($value[$position . 'LEFT']) ?$value[$position . 'LEFT']:'' ). '&nbsp;',array());
	    $table->addCell( ( isset($value[$position . 'CENTER']) ?$value[$position . 'CENTER']:'') . '&nbsp;',array());
	    $table->addCell( ( isset($value[$position . 'RIGHT']) ?$value[$position . 'RIGHT']:'')  . '&nbsp;',array());
	    echo buildPanelInterface('', '', $this->Merge(clx_keywords_simple($table->source()),UserRequest::$request));
	}
	else
	    return $value;
    }

//------------------------------------------------------------------------------

    function confirmDeleteFill(&$table, $record) {
	$table->addData(dict('GEN_LBL_CODE') . ':', $record[$this->code . '_idcode']);
	$table->addData(dict('GEN_LBL_NAME') . ':', $record[$this->code . '_idname']);
    }

//------------------------------------------------------------------------------

    function viewFormFill($record) {

	addHistory('transl_code', $record[$this->code . '_idcode']);
	$contents = '';
	return $contents;
    }

//------------------------------------------------------------------------------
    /**
     * (non-PHPdoc)
     * @see clx_tool::filterFormFill()
     */
    function filterFormFill($msg, &$table) {

	if (!array_key_exists($this->code . '_idcode', UserRequest::$post))
	    UserRequest::$post[$this->code . '_idcode'] = '';
	if (!array_key_exists($this->code . '_idname', UserRequest::$post))
	    UserRequest::$post[$this->code . '_idname'] = '';
	if (!array_key_exists($this->code . '_modulecode', UserRequest::$post))
	    UserRequest::$post[$this->code . '_modulecode'] = '';

	$table->addField($msg, dict('GEN_LBL_CODE'), $this->code . '_idcode', UserRequest::$post[$this->code . '_idcode'], CLX_NUM_16, CLX_NUM_16);
	$table->addField($msg, dict('GEN_LBL_NAME'), $this->code . '_idname', UserRequest::$post[$this->code . '_idname'], CLX_NUM_32, CLX_NUM_64);
	$table->addField($msg, dict('GEN_LBL_MODULE'), $this->code . '_modulecode', UserRequest::$post[$this->code . '_modulecode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
	$sort = new HtmlSelect($this->code . '_sort');
	$sort->addItem('', '', true);
	$sort->addItem(dict('GEN_LBL_CODE'), 'idcode', false);
	$sort->addItem(dict('GEN_LBL_NAME'), 'idname', false);
	$sort->addItem(dict('GEN_LBL_MODULECODE'), 'modulecode', false);
	$table->addData(dict('GEN_LBL_ORDERBY') . ':', $sort->source());
    }

    /**
     * (non-PHPdoc)
     * @see clx_tool::setfilter()
     */
    function setfilter() {

	$filter = '';
	$boolean = '';

	if (!empty(UserRequest::$post[$this->code . '_idcode'])) {
	    $filter .= $boolean . ' UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['ANHF_idcode']) . '%');
	    $boolean = 'AND';
	}

	if (!empty(UserRequest::$post[$this->code . '_idname'])) {
	    $filter .= $boolean . ' UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post[$this->code . '_idname'])) . '%');
	    $boolean = 'AND';
	}
	if (!empty(UserRequest::$post[$this->code . '_modulecode'])) {
	    $filter .= $boolean . ' UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post[$this->code . '_modulecode']) . '%');

	    $boolean = 'AND';
	}
	$_SESSION['paging'][$this->code . 'List']['sortby'] = UserRequest::$post[$this->code . '_sort'];
	$_SESSION['paging'][$this->code . 'List']['criteria'] = $filter;
	$_SESSION['paging'][$this->code . 'List']['startat'] = '0';
    }

    /**
     * (non-PHPdoc)
     * @see clx_tool::clearfilter()
     */
	///////////////////////////////////////////////////
	///comentado 22/01/2019 para utilizar la clx_tool
	////////////////////////////////////////////////// 
    /*function clearfilter() {
	$_SESSION['paging'][$this->code . 'List']['criteria'] = '';
    }*/

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
    /**
     * (non-PHPdoc)
     * @see clx_tool::loadRecord()
     */
    function loadRecord($recordid) {
	$values = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $recordid);

	$record = array();
	$record[$this->code . '_id'] = $recordid;
	$record[$this->code . '_idcode'] = $values['IDCODE'];
	$record[$this->code . '_idname'] = $values['IDNAME'];
	$record[$this->code . '_version'] = $values['VERSION'];
	$record[$this->code . '_version_counter'] = $values['VERSION_COUNTER'];
	$record[$this->code . '_cdate'] = xFormat::date($values['CDATE']);
	$record[$this->code . '_mdate'] = xFormat::date($values['MDATE']);

	$record[$this->code . '_hleft'] = $values['HLEFT'];
	$record[$this->code . '_hcenter'] = $values['HCENTER'];
	$record[$this->code . '_hright'] = $values['HRIGHT'];
	$record[$this->code . '_fleft'] = $values['FLEFT'];
	$record[$this->code . '_fcenter'] = $values['FCENTER'];
	$record[$this->code . '_fright'] = $values['FRIGHT'];
	$record[$this->code . '_modulecode'] = $values['MODULECODE'];
	$record[$this->code . '_active'] = $values['ACTIVE'];


	return $record;
    }

//------------------------------------------------------------------------------
    /**
     * (non-PHPdoc)
     * @see clx_tool::saveRecord()
     */
    function saveRecord() {

	$d = xFormat::getNow('Y-m-d');

	$record = array();
	$record['IDNAME'] = UserRequest::$post[$this->code . '_idname'];
	$record['VERSION'] = UserRequest::$post[$this->code . '_version'];
	$record['MDATE'] = $d;

	$record['HLEFT'] = UserRequest::getPostField($this->code . '_hleft', FILTER_UNSAFE_RAW, null);;
	$record['HCENTER'] = UserRequest::getPostField($this->code . '_hcenter', FILTER_UNSAFE_RAW, null);;
	$record['HRIGHT'] = UserRequest::getPostField($this->code . '_hright', FILTER_UNSAFE_RAW, null);
	$record['FLEFT'] = UserRequest::getPostField($this->code . '_fleft', FILTER_UNSAFE_RAW, null);
	$record['FCENTER'] = UserRequest::getPostField($this->code . '_fcenter', FILTER_UNSAFE_RAW, null);
	$record['FRIGHT'] = UserRequest::getPostField($this->code . '_fright', FILTER_UNSAFE_RAW, null);

	$record['MODULECODE'] = UserRequest::$post[$this->code . '_modulecode'];
	$record['ACTIVE'] = UserRequest::$post[$this->code . '_active'];

	ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post[$this->code . '_id']);
	$this->versionIncrease('ID', UserRequest::$post[$this->code . '_id']);
    }

//------------------------------------------------------------------------------

    function createRecord() {
	$d = xFormat::getNow('Y-m-d');

	$record = array();
	$record['IDCODE'] = UserRequest::$post[$this->code . '_idcode'];
	$record['IDNAME'] = UserRequest::$post[$this->code . '_idname'];
	$record['VERSION'] = UserRequest::$post[$this->code . '_version'];
	$record['VERSION_COUNTER'] = '0';
	$record['CDATE'] = $d;
	$record['MDATE'] = $d;
	$record['HLEFT'] = UserRequest::$post[$this->code . '_hleft'];
	$record['HCENTER'] = UserRequest::$post[$this->code . '_hcenter'];
	$record['HRIGHT'] = UserRequest::$post[$this->code . '_hright'];
	$record['FLEFT'] = UserRequest::$post[$this->code . '_fleft'];
	$record['FCENTER'] = UserRequest::$post[$this->code . '_fcenter'];
	$record['FRIGHT'] = UserRequest::$post[$this->code . '_fright'];


	$record['MODULECODE'] = UserRequest::$post[$this->code . '_modulecode'];
	$record['ACTIVE'] = UserRequest::$post[$this->code . '_active'];

	$recordid = ClxCommon::$db->createRecord($this->tablename, $record);
	$this->versionIncrease('IDCODE', $record['IDCODE']);

	return $recordid;
    }

    function editForm($ac, $idlist, $record, $msg) {
	if ($ac == 'MODIFY') {
	    $this->editform['title'] = 'TOOL_' . $this->code . '_TITLE_MODIFY';
	} else {
	    $this->editform['title'] = 'TOOL_' . $this->code . '_TITLE_CREATE';
	    if ($record[$this->code . '_version'] == '')
		$record[$this->code . '_version'] = '1.0.0';
	    if ($record[$this->code . '_active'] == CLX_NUM_ZERO)
		$record[$this->code . '_active'] = CLX_NUM_ONE;
	}

	$js = '<!-- TinyMCE -->
	        <script type=' . singleQuote('text/javascript') . ' '.'src=' . singleQuote(kPathToExtLibJs.'tinymce403/js/tinymce/tinymce.min.js') . '></script>';
	$campos = array('_hleft', '_hcenter', '_hright', '_fleft', '_fcenter', '_fright');
	foreach ($campos as $campo) {
	    $js.='<script type=' . singleQuote('text/javascript') . '>
			 	tinyMCE.init({
			 		selector: ' . singleQuote('textarea#' . $this->code . $campo ). ',
			 		mode : ' . singleQuote('exact') . ',
			 		convert_urls : false,
				        plugins: [' . singleQuote('visualblocks') . ',
							 ' . singleQuote('link image lists charmap') . ',
							 ' . singleQuote('visualblocks visualchars code insertdatetime media ') . ',
							 ' . singleQuote('contextmenu  template textcolor paste ') . '
				        ],

				        toolbar1: ' . singleQuote(' bold italic underline | alignleft aligncenter alignright alignjustify |  fontselect fontsizeselect | bullist numlist | outdent indent | undo redo | anchor image | code | inserttime preview | forecolor backcolor ') . ',

				        menubar: false,
				        toolbar_items_size: ' . singleQuote('small') . ',

				        style_formats: [
						{title: ' . singleQuote('Table styles') . '},
						{title: ' . singleQuote('Bold text') . ', inline: ' . singleQuote('b') . '},
							 {title: ' . singleQuote('Example 1') . ', inline: ' . singleQuote('span') . ', classes: ' . singleQuote('example1') . '},
							 {title: ' . singleQuote('Example 2') . ', inline: ' . singleQuote('span') . ', classes: ' . singleQuote('example2') . '},
							 {title: ' . singleQuote('Table row 1') . ', selector: ' . singleQuote('tr') . ', classes: ' . singleQuote('tablerow1') . '},
						{title: ' . singleQuote('Red header') . ', block: ' . singleQuote('h1') . ', styles: {color: ' . singleQuote('#ff0000') . '}},
						{title: ' . singleQuote('Red text') .', inline: ' . singleQuote('span') . ', styles: {color: ' . singleQuote('#ff0000') . '}},
					     ],


					});

			     </script>
			 <!-- /TinyMCE -->';
	}
	return $js . parent::editForm($ac, $idlist, $record, $msg);
    }
    function Merge($contents, $record) {
        foreach ($record as $key => $value) {
			IF (is_array($value)) {
				foreach ($value as $key2 => $value2) {
					$contents = str_replace('!' . $key2, $value2, $contents);
				}
			}
			else
				$contents = str_replace('!' . $key, $value, $contents);
        }
		
		$contents=change_text_change_date($contents);
		
		
        return $contents;
    }


//end method
}
