<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class db_import_parsings extends clx_tool {

    var $editform_csv;
    var $editform_frl;
	var $editform_xls;

    function __construct() {
        //$this->code = 'DBIP';
        $this->code = 'DBIA';
        $this->name = 'Import Parsing';
        $this->system = 'Database';
        $this->version = '7.0.0.0';

        $this->accesskey = 'DBIM';


        $this->tablename = 'CLX_DB_IMPORT_PARSINGS';
        $this->record_name_singular = 'parsing';
        $this->record_name_plural = 'parsings';
        $this->primary_field = 'ID';
        $this->secondary_field = 'IMPORTCODE';
        $this->seqnum_field = 'SEQNUM';
        $this->editform_csv = array(CLX_CLASS_TITLE => 'TOOL_DBIC_TITLE_CREATE',
		  'panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_TABLE_FIELD',
					   'fields' => array(
						  array('name' => 'table_fieldname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '64', 'dontmodify' => '1')
					   )
			         ), array('label' => 'TOOL_DBIC_FILL_WITH',
					   'fields' => array(
						  array('name' => 'type', 'type' => 'dynamic', 'panels' => array(
								'FILE' => 'TOOL_DBIC_FIELD',
								'CALC' => 'GEN_LBL_CONSTANT',
								'FORM' => 'TOOL_DBIC_FORMULA',
								'IGNR' => 'TOOL_DBIC_IGNORE'
						      )
						  )
					   )
			         )
			     )
			 ), array('type' => 'dynamic',
			     'code' => 'FILE',
			     'entries' => array(
			         array('label' => 'GEN_LBL_FILE_FIELD',
					   'fields' => array(
						  array('name' => 'file_fieldname', 'type' => 'function', 'function' => 'getAvailableFields'))
			         )
			     )
			 ), array('type' => 'dynamic',
			     'code' => 'CALC',
			     'entries' => array(
			         array('label' => 'GEN_LBL_FORMULA',
					   'fields' => array(
						  array('name' => 'formula', 'type' => 'text', 'cols' => '48', 'rows' => '4'))
			         )
			     )
			 ), array('type' => 'dynamic',
			     'code' => 'FORM',
			     'entries' => array(
			         array('label' => 'GEN_LBL_FORMULA',
					   'fields' => array(
						  array('name' => 'formula2', 'type' => 'text', 'cols' => '48', 'rows' => '4'))
			         )
			     )
			 ), array('type' => 'dynamic',
			     'code' => 'IGNR',
			     'entries' => array()
			 )
		  )
        );
        $this->editform_frl = array(CLX_CLASS_TITLE => 'TOOL_DBIC_TITLE_CREATE',
		  'panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_TABLE_FIELD',
					   'fields' => array(
						  array('name' => 'table_fieldname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '64', 'dontmodify' => '1')
					   )
			         ), array('label' => 'TOOL_DBIC_FILL_WITH',
					   'fields' => array(
						  array('name' => 'type', 'type' => 'dynamic', 'panels' => array(
								'FIX' => 'TOOL_DBIC_FIELD',
								'CALC' => 'TOOL_DBIC_FORMULA',
								'IGNR' => 'TOOL_DBIC_IGNORE'
						      )
						  )
					   )
			         )
			     )
			 ), array('type' => 'dynamic',
			     'code' => 'FIX',
			     'entries' => array(
			         array('label' => 'GEN_LBL_START_POSITION',
					   'fields' => array(
						  array('name' => 'start_position', 'type' => 'string', 'size' => '10', 'displaysize' => '10', 'sufix' => 'GEN_LBL_CHARACTERS', 'validations' => array(
								array('type' => 'integer', 'required' => '1'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_FIELD_LENGTH',
					   'fields' => array(
						  array('name' => 'field_length', 'type' => 'string', 'size' => '10', 'displaysize' => '10', 'sufix' => 'GEN_LBL_CHARACTERS', 'validations' => array(
								array('type' => 'integer', 'required' => '1'))
						  )
					   )
			         )
			     )
			 ), array('type' => 'dynamic',
			     'code' => 'CALC',
			     'entries' => array(
			         array('label' => 'GEN_LBL_FORMULA',
					   'fields' => array(
						  array('name' => 'formula', 'type' => 'text', 'cols' => '48', 'rows' => '4'))
			         )
			     )
			 ), array('type' => 'dynamic',
			     'code' => 'IGNR',
			     'entries' => array()
			 )
		  )
        );
    }

    function toolTableStructure() {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1664;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_parsings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IMPORTCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['TABLE_FIELDNAME'] = array('type' => 'varchar(255)', 'null' => 'NO', 'properties' => '');
        $fields['TYPE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['FILE_FIELDNAME'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['FORMULA'] = array('type' => 'mediumtext', 'null' => 'YES', 'properties' => '');
        $fields['SEQNUM'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['START_POSITION'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['FIELD_LENGTH'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'IMPORTCODE,SEQNUM');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

    function pack($record) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1665;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_parsings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $o = $this->packRecord($record);
        $id = $record['ID'];
        $objs = new XMLObject($this->code . '_OBJECTS');
        $this->packsub($objs, 'DBIT', 'SELECT * FROM CLX_DB_IMPORT_TRANSLATIONS WHERE MAPID=' . $id);
        $o->addObject($objs);
        return $o;
    }

    function unpack($parameters) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1666;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_parsings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $parameters = array_values(array_merge(array('package' => null, 'id' => null), $parameters));
        list($package, $formid) = $parameters;
        $record = $this->unpackRecord($package);
        $mapid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
		  $objs = $package->getObjectXml($this->code . '_OBJECTS');
		  foreach ($objs->objects as $o) {
			 $toolcode = $o->tag;
			 $tool = &getTool($toolcode);
			 $tool->unpack(array('package' => $o, 'id' => $mapid));
		  }
        }
    }

    function action($ac, $idlist) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1667;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_parsings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        if ($this->getAccess()->canRead()) {
		  $contents = parent::action($ac, $idlist);
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [DB_IMPORT_PARSINGS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function makepanel($importcode = null) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1668;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_parsings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        if ($this->getAccess()->canRead()) {
		  $t = time();
		  $to = $this->code;
		  $here = 'tool.php?to=' . $to . '&t=' . $t;
		  $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
		  //$form->setProp(CLX_PROP_ID, 'DBIPPanel');
		  $form->setProp(CLX_PROP_ID, $this->code.'Panel');
		  $form->addArgument(CLX_PROP_TO, $this->code);
		  $form->addArgument('importcode', $importcode);
		  $form->addArgument('ac', 'NOT_DEFINED');
		  $selectclause = '*';
		  $fromclause = 'CLX_DB_IMPORT_PARSINGS';
		  $whereclause = 'IMPORTCODE=' . singleQuote($importcode);
		  $sortclause = 'SEQNUM ASC';
		  $page = new xPaging();
		  $page->setProp('rpp', CLX_NUM_TEN_THOUSAND);
		  $page->setProp('printheaders', false);
		  $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
		  $table = new htmlTable(CLX_WIDTH_THREE);
		  $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
			$page->header($table);
		  $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_TABLE_FIELD') . ' (' . dict('GEN_LBL_TARGET') . ')', dict('GEN_LBL_SOURCE')));
		  $i = CLX_INIT_ZERO;
		  while ($record = $page->nextRecord()) { 
			 $recordid = $record['ID'];
			 $select = new htmlCheckbox('selector_' . $recordid, false);
			 $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
			 $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
			 if ($record['TYPE'] === 'FIX') {
			     $source = 'Start: ' . $record['START_POSITION'] . ', length: ' . $record['FIELD_LENGTH'];
			 } elseif ($record['TYPE'] === 'IGNR') {
			     $source = dict('GEN_LBL_IGNORE');
			 } elseif ($record['TYPE'] === 'FILE') {
			     $source = 'File field: ' . $record['FILE_FIELDNAME'];
			 } else {
			     $source = $record['FORMULA'];
			 }
			 $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['TABLE_FIELDNAME'], $source));
			 $i++;
		  }
		  $buttons = '';
		  $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
			$buttons .= htmlButton::getButton('submit', dict('GEN_LBL_PARSING'), array('action' => 'PARSER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
		  if ($this->getAccess()->canModify()) {
			 $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
		  }
			
			$form->addContents($page->footers($table, $buttons, false));
			
		//  return buildPanelInterface(dict('TOOL_DBIC_TITLE_LIST'), 'IMPORT_FIELDS_PARSINGS_' . $importcode, $form->source(), -1 * CLX_NUM_ONE);
        } else {
		  return CLX_CHAR_EMPTY_STRING;
        }
    }

    function editForm($ac, $idlist, $record, $msg) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1669;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_parsings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $import_rec = ClxCommon::$db->getRecord('CLX_DB_IMPORTS', 'IDCODE=' . singleQuote($record['DBIC_importcode']));
        if ($import_rec['TYPE'] === 'CSV') {
		  $this->editform = $this->editform_csv;
        } else {
		  $this->editform = $this->editform_frl;
        }
        if (UserRequest::$request['ac'] === 'MODIFY') {
		  $this->editform['TITLE'] = 'TOOL_' . $this->code . '_TITLE_MODIFY';
        } else {
		  $this->editform['TITLE'] = 'TOOL_' . $this->code . '_TITLE_CREATE';
        }
        $form = new clx_form($this->code, $this->editform);
        return $form->editForm($ac, $idlist, $record, $msg);
    }

    function getAvailableFields($field_name, $record) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1670;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_parsings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $importcode = $record['DBIC_importcode'];
        $pop = new HTMLSelect($field_name);
        $fields = ClxCommon::$db->getRecords('CLX_DB_IMPORT_FIELDS', 'IMPORTCODE=' . singleQuote($importcode) . ' ORDER BY SEQNUM');
        while (($field = ClxCommon::$db->getNextRecord($fields))) {
		  $pop->addItem($field['FILE_FIELDNAME'], $field['FILE_FIELDNAME'], ($field['FILE_FIELDNAME'] == $record[$field_name]));
        }
		ClxCommon::$db->freeResult($fields);
        return $pop->source();
    }

    function viewFormFill($record) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1671;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_parsings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		if ( !empty($_SESSION["_dEBUG"]) ) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+"); 	fwrite($tta,chr(13).chr(10)."1201 viewFormFill_db_import_parsing-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}	
        addHistory('mapid', $record['DBIC_id']);
        $contents = '';
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_DBIM_TITLE_VIEW'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_IMPORTCODE') . ':', $record['DBIC_importcode']);
        $table->addData(dict('GEN_LBL_TABLE_FIELD') . ' (' . dict('GEN_LBL_TARGET') . '):', $record['DBIC_table_fieldname']);
        $table->addData(dict('GEN_LBL_FILE_FIELD') . ' (' . dict('GEN_LBL_SOURCE') . '):', $record['DBIC_file_fieldname']);
        $contents .= $table->source();
        if ($record['DBIC_file_fieldname'] !== 'IGNORE') {
		  $DBIT = &getTool('DBIT');
		  $contents .= $DBIT->makepanel($record['DBIC_id']);
        }
        return $contents;
    }

    function loadToolRecord($recordid) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1672;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_parsings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        $record = array();
        $record['DBIC_id'] = $recordid;
        $record['DBIC_table_fieldname'] = $values['TABLE_FIELDNAME'];
        $record['DBIC_type'] = $values['TYPE'];
        if ($values['TYPE'] === 'CALC') {
		  $record['DBIC_formula'] = $values['FORMULA'];
		  $record['DBIC_formula2'] = '';
        } elseif ($values['TYPE'] === 'FORM') {
		  $record['DBIC_formula'] = '';
		  $record['DBIC_formula2'] = $values['FORMULA'];
        } else {
		  $record['DBIC_formula'] = '';
		  $record['DBIC_formula2'] = '';
        }
        $record['DBIC_file_fieldname'] = $values['FILE_FIELDNAME'];
        $record['DBIC_start_position'] = $values['START_POSITION'];
        $record['DBIC_field_length'] = $values['FIELD_LENGTH'];
        $record['DBIC_importcode'] = $values['IMPORTCODE'];
        $record['DBIC_seqnum'] = $values['SEQNUM'];
        return $record;
    }

    function saveRecord() {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1673;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_parsings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $record = array();
        $record['FILE_FIELDNAME'] = UserRequest::$post['DBIC_file_fieldname'];
        if (UserRequest::$post['DBIC_type'] === 'FORM') {
		  $record['FORMULA'] = clx_html_spchrs_decode(UserRequest::$post['DBIC_formula2']);
        } else {
		  $record['FORMULA'] = clx_html_spchrs_decode(UserRequest::$post['DBIC_formula']);
        }
        $record['START_POSITION'] = (array_key_exists('DBIC_start_position', UserRequest::$post)) ? UserRequest::$post['DBIC_start_position'] : CLX_CHAR_EMPTY_STRING;
        $record['FIELD_LENGTH'] = (array_key_exists('DBIC_field_length', UserRequest::$post)) ? UserRequest::$post['DBIC_field_length'] : CLX_CHAR_EMPTY_STRING;
        $record['TYPE'] = UserRequest::$post['DBIC_type'];
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['DBIC_id']);
        $this->versionIncrease('ID', UserRequest::$post['DBIC_id']);
    }

    function versionIncrease($fieldname, $fieldvalue) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1639;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_parsings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $importcode = ClxCommon::$db->getField($this->tablename, 'IMPORTCODE', $fieldname . '=' . singleQuote($fieldvalue));
        $DBIM = &getTool('DBIM');
        $DBIM->versionIncrease('IDCODE', $importcode);
    }

}
