<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-10-15 10:19:43 -0400 (Mon, 15 Oct 2018) $
 * @version        $Rev: 10245 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 *   ajaxList method: only works for windows OS
 */
class db_lists extends clx_tool {

    /**
     * Contructor
     */
    function __construct() {
		$GLOBALS['JSONXX']=0;
        $this->code = 'DBLT';
        $this->name = 'List Manager';
        $this->system = 'Database';
        $this->version = '0.6.3.0';

        $this->has_access = true;
        $this->has_package = true;

        $this->tablename = 'CLX_DB_LISTS';
        $this->record_name_singular = CLX_CLASS_LIST;
        $this->record_name_plural = 'lists';
        $this->primary_field = 'IDCODE';
        $this->secondary_field = 'IDNAME';

        $this->primary_key = array('IDCODE');
        $this->quickfilterform = array('panels' => array(
			 array('type' => 'normal',
			     'entries' => array(array('label' => 'GEN_LBL_CODE', 'fields' => array(array('name' => 'idcode', 'type' => 'string', 'default' => '', 'size' => '4', 'displaysize' => '6'))), array('label' => 'GEN_LBL_NAME', 'fields' => array(array('name' => 'idname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48'))), array('label' => 'GEN_LBL_MODULECODE', 'fields' => array(array('name' => 'modulecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBMO'))
			         )
			     )
			 )
		  )
        );
		IF ( $_SERVER['REMOTE_ADDR']=='1901.79.182.130' || (ISSET($GLOBALS['ADDRDEBUGDICT']) && $GLOBALS['ADDRDEBUGDICT']=='190.79.182.130'))  { 

			$this->debug=true;
		}
    }

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_DATABASE:MENU_LISTS', 'TOOL', $this->code, 'ac=LIST');
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IDCODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['IDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['PARENTLIST'] = array('type' => 'varchar(4)', 'null' => 'YES', 'properties' => '');
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'YES', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['ACCESSES'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['SORT_BY_LABEL'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'IDNAME');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'PARENTLIST');
        $indexes[$ipf . '05'] = array('index' => 'MUL', 'fieldname' => 'USERNAME');
        $indexes[$ipf . '06'] = array('index' => 'MUL', 'fieldname' => 'MODULECODE');
        //$indexes[$ipf . '07'] = array('index' => 'MUL', 'fieldname' => 'IDCODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }

    function pack($record) {
        $o = $this->packRecord($record);
        $code = $record['IDCODE'];
        $objs = new XMLObject($this->code . '_OBJECTS');
        $this->packsub($objs, 'DBLI', 'SELECT * FROM CLX_DB_LIST_ITEMS WHERE LISTCODE=' . singleQuote($code));
        $this->packsub($objs, 'DICT', 'SELECT dict.* FROM CLX_DICTIONARY dict, CLX_DB_LIST_ITEMS li WHERE dict.ENTRY=li.IDNAME AND li.LISTCODE=' . singleQuote($code));
        $o->addObject($objs);
        return $o;
    }

    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        $record['IDCODE'] = uppercase($record['IDCODE']);
        $record['MODULECODE'] = uppercase($record['MODULECODE']);
        $listcode = $record['IDCODE'];

        ClxCommon::$db->loadDbRecord($this->tablename, $record, false, 'IDCODE=' . singleQuote($listcode));
        $listid = ClxCommon::$db->getField($this->tablename, 'ID', 'IDCODE=' . singleQuote($listcode));

        ClxCommon::$db->deleteRecords('CLX_DB_LIST_ITEMS', 'LISTCODE=' . singleQuote($listcode));

        if ($package->hasSubObject($this->code . '_OBJECTS')) {
		  $objs = $package->getObjectXml($this->code . '_OBJECTS');
		  foreach ($objs->objects as $o) {
			 $toolcode = $o->tag;
			 $tool = &getTool($toolcode);
			 $tool->unpack(array('package' => $o, 'id' => $listid));
		  }
        }
    }

    function action($ac, $idlist) {
		//PRE($GLOBALS);
        $contents = '';
        if ($this->getAccess()->canRead()) {
		  switch ($ac) {
			 case 'LIST':
			     if (!empty(UserRequest::$request['mc'])) {//Adding parameter to the filter if mc is set on menu to display only mc.
			         $_SESSION['paging'][$this->code . 'List']['criteria'] = ' UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$request['mc']) . '%');
						if (!empty(UserRequest::$request['qfl'])) {
							$_SESSION['paging'][$this->code . 'List']['criteria'] = ' IDCODE = '.singlequote(UserRequest::$request['qfl']);
						}
			         if (empty($_SESSION['paging'][$this->code . 'List']['sortby']))
					   $_SESSION['paging'][$this->code . 'List']['sortby'] = CLX_INIT_ZERO;
			         if (empty($_SESSION['paging'][$this->code . 'List']['startat']))
					   $_SESSION['paging'][$this->code . 'List']['startat'] = CLX_INIT_ZERO;
			     }
			     $contents = parent::action($ac, $idlist);
			     break;
			 case 'LIST_XML':
			     $listcode = UserRequest::$get['lc'];
			     $contents .=$this->getListAsXml($listcode);
			     break;
			 case 'LIST_AJAX':
					OB_START();
					ob_clean();
			     $contents .= $this->buildAjaxList();
			     break;
			 default:
			     $contents = parent::action($ac, $idlist);
			     break;
		  }
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [DB_LISTS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function makelist($listingcode = null) {
        $this->applyUserAccessFromMenu();
        //$t = time('U'); genera un warning
        $t = time();
        $to = $this->code;
        $here = 'tool.php?to=' . $to . '&t=' . $t;
        clearHistory();
        pushHistory($this->code, 'LIST', array());
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->setProp(CLX_PROP_ID, $this->code . 'List');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NOT_DEFINED');
        $selectclause = '*';
        $fromclause = 'CLX_DB_LISTS';
        $whereclause = '';
        $sortclause = 'IDCODE';
        $page = new xPaging();
        $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
        $table = new htmlTable(CLX_WIDTH_NINE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_DBLT_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_NINE));
        $page->header($table);
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_MODULECODE'), dict('GEN_LBL_CODE'), dict('GEN_LBL_NAME'), dict('GEN_LBL_VERSION'), dict('GEN_LBL_DESCRIPTION'), dict('GEN_LBL_SORT_BY_LABEL'), dict('GEN_LBL_ACCESS'), dict('GEN_LBL_ITEMQTY')));
        $i = CLX_INIT_ZERO;
        $access = array('Restricted', 'System', 'User');
        while ($record = $page->nextRecord()) {
		  $recordid = $record['ID'];
		  $select = new htmlCheckbox('selector_' . $recordid, false);
		  $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
		  $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
		  $qty = ClxCommon::$db->countRecords('CLX_DB_LIST_ITEMS', 'LISTCODE=' . singleQuote($record['IDCODE']));
		  $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['MODULECODE'], $record['IDCODE'], $record['IDNAME'], $record['VERSION'] . '-' . $record['VERSION_COUNTER'], xFormat::text($record['DESCRIPTION']), dict($this->yesno[$record['SORT_BY_LABEL']]), $access[$record['ACCESSES']], $qty));
		  $i++;
        }
        $buttons = '';
        if ($this->getAccess()->canDisplay()) {
		  $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canModify()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDelete()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canAppend()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DUPLICATE'), array('action' => 'DUPLICATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ONE'))->source();
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_LIST')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        }
        $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_FILTER'), array('action' => 'FILTER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        $form->addContents($page->footers($table, $buttons));
        return $form->source();
    }

    function searchForm() {
        $msg = array();
        $contents = '';
        // Search Form
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'SEARCH');
        $form->addArgument('confirm', '1');
        $form->addArgument(CLX_PROP_TARGET, UserRequest::$request[CLX_PROP_TARGET]);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_DBLT_TITLE_SEARCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addField($msg, dict('GEN_LBL_CODE') . ':', 'DBLT_idcode', (!empty(UserRequest::$post['DBLT_idcode'])) ? UserRequest::$post['DBLT_idcode'] : '', CLX_NUM_FOUR, CLX_NUM_FOUR);
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'DBLT_idname', (!empty(UserRequest::$post['DBLT_idname'])) ? UserRequest::$post['DBLT_idname'] : '', CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_MODULECODE') . ':', 'DBLT_modulecode', (!empty(UserRequest::$post['DBLT_modulecode'])) ? UserRequest::$post['DBLT_modulecode'] : '', CLX_NUM_FOUR, CLX_NUM_FOUR);
        $buttons = htmlButton::getButton('submit', dict('GEN_LBL_SEARCH'), array('action' => 'SEARCH', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents .= $form->source();
        // Search Procedure
        if (isset(UserRequest::$post['confirm'])) {
		  $table = new htmlTable(CLX_WIDTH_TWO);
		  $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
		  $criteria = '';
		  if (UserRequest::$post['DBLT_idcode'] <> '') {
			 $criteria .= 'UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['DBLT_idcode']) . '%');
		  }
		  if (UserRequest::$post['DBLT_idname'] <> '') {
			 $criteria .= 'UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['DBLT_idname'])) . '%');
		  }
		  if (UserRequest::$post['DBLT_modulecode'] <> '') {
			 $criteria .= 'UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['DBLT_modulecode']) . '%');
		  }
            $qty = ClxCommon::$db->oneExistsRecords($this->tablename, $criteria);
		  if ($qty == CLX_NUM_ZERO) {
			 $table->addCell(dict('TOOL_GEN_ERR_NOMATCH'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
		  } else {
			 $table->addCell(dict('TOOL_GEN_MSG_FOUNDRECORDS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
			 $records = ClxCommon::$db->getRecords($this->tablename, $criteria);
			 $i = CLX_INIT_ZERO;
			 while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
			     $js = 'javascript:setLookupValue(' . quote(UserRequest::$request[CLX_PROP_TARGET]) . ', ' . quote($record['IDCODE']) . ');';
			     $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array('<page t=db_list></page><a href=' . singleQuote($js) . '>' . $record['IDCODE'] . '</a>', $record['IDNAME']));
			     $i++;
			 }
			 ClxCommon::$db->freeResult($records);
		  }
		  $contents .= $table->source();
        }
        return $contents;
    }

    function editForm($ac, $idlist, $record, $msg) {
        $modify = (UserRequest::$request['ac'] === 'MODIFY');
        $duplicate = (UserRequest::$request['ac'] === 'DUPLICATE');
        $title = ($modify) ? dict('TOOL_DBLT_TITLE_MODIFY') : dict('TOOL_DBLT_TITLE_CREATE');
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', $ac);
        $form->addArgument('confirm', '1');
        $form->addArgument('DBLT_id', $record['DBLT_id']);
        $form->addArgument('idlist', toString($idlist));
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        if (!empty($modify)) {
		  $form->addArgument('DBLT_idcode', $record['DBLT_idcode']);
		  $table->addData(dict('GEN_LBL_CODE') . ':', $record['DBLT_idcode']);
        } else {
		  $table->addField($msg, dict('GEN_LBL_CODE') . ':', 'DBLT_idcode', $record['DBLT_idcode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
        }
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'DBLT_idname', $record['DBLT_idname'], CLX_NUM_48, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_VERSION') . ':', 'DBLT_version', $record['DBLT_version'], CLX_NUM_16, CLX_NUM_16);
        $table->addText($msg, dict('GEN_LBL_DESCRIPTION') . ':', 'DBLT_description', $record['DBLT_description'], CLX_NUM_FOUR, CLX_NUM_48);
        $access = new htmlSelect('DBLT_access');
        $access->addItem(dict('GEN_LBL_RESTRICTED'), '0', ($record['DBLT_access'] == CLX_NUM_ZERO));
        $access->addItem(dict('GEN_LBL_SYSTEM'), '1', ($record['DBLT_access'] == CLX_NUM_ONE));
        $access->addItem(dict('GEN_LBL_USER'), '2', ($record['DBLT_access'] == CLX_NUM_TWO));
        $table->addData(dict('GEN_LBL_ACCESS') . ':', $access->source());
        $table->addYesNo(dict('GEN_LBL_SORT_BY_LABEL'), 'DBLT_sort_by_label', $record['DBLT_sort_by_label'], CLX_WIDTH_TWO, false);
        $this->placeChooseList($msg, dict('GEN_LBL_PARENTLISTCODE') . ':', 'DBLT_parentlist', $record['DBLT_parentlist'], $table);
        $DBMO = &getTool('DBMO');
        $DBMO->placeChooseModule($msg, dict('GEN_LBL_MODULECODE') . ':', 'DBLT_modulecode', $record['DBLT_modulecode'], $table);
        $form->addContents($table->source() . '<br>');
        $buttons = '';
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        if (!empty($modify)) {
		  $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_SAVE'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        } else {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE'), array('action' => (($duplicate) ? 'DUPLICATE' : 'CREATE'), 'form' => $form->getProp(CLX_PROP_ID)))->source();
        }
        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->addContents($table->source());
        return $form->source();
    }

    function checkForm(&$msg) {
        $msg = array();
        $action = UserRequest::$post['ac'];
        if ($action === 'CREATE' || $action === 'DUPLICATE') {
		  xValidate::unique($msg, 'DBLT_idcode', 'code', $this->tablename, 'IDCODE=' . singleQuote(UserRequest::$post['DBLT_idcode']));
		  xValidate::sqlobject($msg, 'DBLT_idcode', UserRequest::$post['DBLT_idcode']);
        }
        if (empty(UserRequest::$post['DBLT_modulecode'])) {
		  $msg['DBLT_modulecode'] = dict('GEN_ERR_REQUIRED');
        }
        if (empty(UserRequest::$post['DBLT_idname'])) {
		  $msg['DBLT_idname'] = dict('GEN_ERR_REQUIRED');
        }
        $DBMO = &getTool('DBMO');
        if (strlen(UserRequest::$post['DBLT_modulecode']) > CLX_NUM_ZERO) {
		  if (!$DBMO->moduleExists(UserRequest::$post['DBLT_modulecode'])) {
			 $msg['DBLT_modulecode'] = dict('TOOL_UILG_ERR_NOMODULECODE');
		  }
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_CODE') . ':', $record['DBLT_idcode']);
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['DBLT_idname']);
    }

    function viewFormFill($record) {
        addHistory('listcode', $record['DBLT_idcode']);
        $access = array('Restricted', 'System', 'User');
        $contents = '';
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_DBLT_TITLE_VIEW') . ': ' . $record['DBLT_idname'], array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_CODE') . ':', $record['DBLT_idcode']);
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['DBLT_idname']);
        $table->addData(dict('GEN_LBL_VERSION') . ':', $record['DBLT_version'] . '-' . $record['DBLT_version_counter']);
        $table->addData(dict('GEN_LBL_DESCRIPTION') . ':', xFormat::text($record['DBLT_description']));
        $table->addData(dict('GEN_LBL_ACCESS') . ':', $access[$record['DBLT_access']]);
        $table->addData(dict('GEN_LBL_SORT_BY_LABEL') . ':', $access[$record['DBLT_sort_by_label']]);
        $table->addData(dict('GEN_LBL_PARENTLISTCODE') . ':', $record['DBLT_parentlist']);
        $table->addData(dict('GEN_LBL_MODULECODE') . ':', $record['DBLT_modulecode']);
        $contents .= $table->source();
        $DBLI = &getTool('DBLI');
        $contents .= $DBLI->makepanel($record['DBLT_idcode']);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addData(dict('GEN_LBL_CDATE') . ':', $record['DBLT_cdate']);
        $table->addData(dict('GEN_LBL_MDATE') . ':', $record['DBLT_mdate']);
        $table->addData(dict('GEN_LBL_USERNAME') . ':', $record['DBLT_username']);
        $contents .= buildPanelInterface(dict('GEN_TTL_SYSTEMINFO'), 'SYSTEMINFO', $table->source(), CLX_NUM_MINUS_1);
        return $contents;
    }

    /**
     * Duplicates record action
     * @return type
     */
    function duplicateRecord() {

        $oldlistid = UserRequest::$post['DBLT_id'];
        $listid = parent::duplicateRecord();
        $sql = 'SELECT DBLI.* FROM CLX_DB_LIST_ITEMS DBLI, CLX_DB_LISTS DBLT WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLT.ID = ' . $oldlistid . ' ORDER BY DBLI.SEQNUM ASC';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs)) {
		  $r['ID'] = '';
		  $r['LISTCODE'] = UserRequest::$post['DBLT_idcode'];
		  ClxCommon::$db->createRecord('CLX_DB_LIST_ITEMS', $r, false);
        }
		ClxCommon::$db->freeResult($rs);
        return $listid;
    }

    /**
     * (non-PHPdoc)
     * @see clx_tool::filterFormFill()
     */
    function filterFormFill($msg, &$table) {
        if (!array_key_exists('DBLT_idcode', UserRequest::$post))
		  UserRequest::$post['DBLT_idcode'] = '';
        if (!array_key_exists('DBLT_idname', UserRequest::$post))
		  UserRequest::$post['DBLT_idname'] = '';
        if (!array_key_exists('DBLT_modulecode', UserRequest::$post))
		  UserRequest::$post['DBLT_modulecode'] = '';
        $table->addField($msg, dict('GEN_LBL_CODE'), 'DBLT_idcode', UserRequest::$post['DBLT_idcode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
        $table->addField($msg, dict('GEN_LBL_NAME'), 'DBLT_idname', UserRequest::$post['DBLT_idname'], CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_MODULECODE'), 'DBLT_modulecode', UserRequest::$post['DBLT_modulecode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
    }

    /**
     * (non-PHPdoc)
     * @see clx_tool::setfilter()
     */
    function setfilter() {
        $filter = '';
        $boolean = '';
        if (!empty(UserRequest::$post['DBLT_idcode'])) {
		  $filter .= $boolean . 'UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['DBLT_idcode']) . '%');
		  $boolean = 'AND ';
        }
        if (!empty(UserRequest::$post['DBLT_idname'])) {
		  $filter .= $boolean . 'UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['DBLT_idname'])) . '%');
		  $boolean = 'AND ';
        }
        if (!empty(UserRequest::$post['DBLT_modulecode'])) {
		  $filter .= $boolean . 'UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['DBLT_modulecode']) . '%');
		  $boolean = 'AND ';
        }
        $this->setFilterKeys($filter, CLX_CHAR_EMPTY_STRING, CLX_NUM_ZERO);
    }

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        $record = array();
        $record['DBLT_id'] = $recordid;
        $record['DBLT_idcode'] = $values['IDCODE'];
        $record['DBLT_idname'] = $values['IDNAME'];
        $record['DBLT_version'] = $values['VERSION'];
        $record['DBLT_version_counter'] = $values['VERSION_COUNTER'];
        $record['DBLT_cdate'] = xFormat::date($values['CDATE']);
        $record['DBLT_mdate'] = xFormat::date($values['MDATE']);
        $record['DBLT_username'] = $values['USERNAME'];
        $record['DBLT_description'] = $values['DESCRIPTION'];
        $record['DBLT_access'] = $values['ACCESSES'];
        $record['DBLT_sort_by_label'] = $values['SORT_BY_LABEL'];
        $record['DBLT_parentlist'] = $values['PARENTLIST'];
        $record['DBLT_modulecode'] = $values['MODULECODE'];
        return $record;
    }

    function saveRecord() {
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['IDCODE'] = uppercase(UserRequest::$post['DBLT_idcode']);
        $record['IDNAME'] = UserRequest::$post['DBLT_idname'];
        $record['VERSION'] = UserRequest::$post['DBLT_version'];
        $record['MDATE'] = $d;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['DESCRIPTION'] = UserRequest::$post['DBLT_description'];
        $record['ACCESSES'] = UserRequest::$post['DBLT_access'];
        $record['SORT_BY_LABEL'] = UserRequest::$post['DBLT_sort_by_label'];
        $record['PARENTLIST'] = UserRequest::$post['DBLT_parentlist'];
        $record['MODULECODE'] = UserRequest::$post['DBLT_modulecode'];
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['DBLT_id']);
        $this->versionIncrease('ID', UserRequest::$post['DBLT_id']);
    }

    function createRecord_() {
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['IDCODE'] = uppercase(UserRequest::$post['DBLT_idcode']);
        $record['IDNAME'] = UserRequest::$post['DBLT_idname'];
        $record['VERSION'] = UserRequest::$post['DBLT_version'];
        $record['VERSION_COUNTER'] = '0';
        $record['CDATE'] = $d;
        $record['MDATE'] = $d;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['DESCRIPTION'] = UserRequest::$post['DBLT_description'];
        $record['ACCESSES'] = UserRequest::$post['DBLT_access'];
        $record['SORT_BY_LABEL'] = UserRequest::$post['DBLT_sort_by_label'];
        $record['PARENTLIST'] = UserRequest::$post['DBLT_parentlist'];
        $record['MODULECODE'] = UserRequest::$post['DBLT_modulecode'];
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        return $recordid;
    }

    function deleteRecordSk($id) {
        $listrec = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $id);
        $listcode = $listrec['IDCODE'];
        ClxCommon::$db->deleteRecords('CLX_DB_LIST_ITEMS', 'LISTCODE=' . singleQuote($listcode));
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    function defaultRecord() {
        $record = array();
        $record['DBLT_id'] = CLX_INIT_ZERO;
        $record['DBLT_idcode'] = '';
        $record['DBLT_idname'] = '';
        $record['DBLT_version'] = '1.0.0';
        $record['DBLT_cdate'] = '';
        $record['DBLT_mdate'] = '';
        $record['DBLT_username'] = $_SESSION['user_record']['username'];
        $record['DBLT_description'] = '';
        $record['DBLT_access'] = '0';
        $record['DBLT_sort_by_label'] = '0';
        $record['DBLT_parentlist'] = '';
        $record['DBLT_modulecode'] = '';
        return $record;
    }

    function createList($code, $name, $description, $access, $items, $modulecode = 'BASE', $parentlist = '') {
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['IDCODE'] = uppercase($code);
        $record['IDNAME'] = $name;
        $record['VERSION'] = '1.0.0';
        $record['VERSION_COUNTER'] = '0';
        $record['CDATE'] = $d;
        $record['MDATE'] = $d;
        $record['USERNAME'] = (!empty($_SESSION['user_record']['username'])) ? $_SESSION['user_record']['username'] : 'admin';
        $record['DESCRIPTION'] = $description;
        $record['ACCESSES'] = $access;
        $record['SORT_BY_LABEL'] = CLX_INIT_ZERO;
        $record['PARENTLIST'] = $parentlist;
        $record['MODULECODE'] = $modulecode;
        ClxCommon::$db->createRecord($this->tablename, $record, false);
        $i = CLX_INIT_ZERO;
        foreach ($items as $key => $value) {
		  $record = array();
		  $record['LISTCODE'] = $code;
		  $record['IDCODE'] = $key;
		  $record['IDNAME'] = $value;
		  $record['INACTIVE'] = CLX_INIT_ZERO;
		  $record['SEQNUM'] = $i++;
		  ClxCommon::$db->createRecord('CLX_DB_LIST_ITEMS', $record, false);
        }
    }

    function getLists($name, $default) {
        $records = ClxCommon::$db->getRecords($this->tablename);
        $pop = new htmlSelect($name);
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
		  $pop->addItem($record['IDNAME'], $record['IDCODE'], ($record['IDCODE'] == $default), 'INACTIVE = 0');
        }
		ClxCommon::$db->freeResult($records);
        return $pop;
    }

    function getListSql($listcode, $criterias = false) {
		$findVar='';
		$fetched = false;
		$lang = getCurrentLanguage();
		$findVar=$listcode. $lang.md5(JSON_ENCODE($criterias)) .'_dblist2_';
		if (kApcTtl_10>0) 
			$sql= apc_fetchFct($findVar , $fetched);
		if ($fetched) {

		}
		else {

			$crit = ($criterias) ? $criterias : '';
			IF (ISSET($GLOBALS['ADDRDEBUGUILISTING']) && $GLOBALS['ADDRDEBUGUILISTING']==$_SERVER['REMOTE_ADDR']) {
				pre('---------lista << '. $listcode. ' >>-------------');
				$te=debug_backtrace(); 
				$pos=$posx=0;
				for ($t=0;$t<12;$t++) {
					if (isset($te[$t]["file"])){
						if ($t==$posx)
							echo $pos."_".$te[$posx]["function"]."_util(pre)-hora:".date("h:i:s d/m/Y")."<br>";
						echo substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"]."<br>";
					}
				}
			}
			switch (kDatabaseType) {
				case 'oci':
					$sql = 'SELECT COALESCE(DBLI.IDCODE, n'.singleQuote('').') IDCODE, COALESCE(DICT.VALUE, COALESCE((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) =n' . singleQuote(uppercase($lang)) . '), CASE WHEN (SELECT COUNT(D3.ID) FROM CLX_DICTIONARY D3 WHERE D3.ENTRY = DBLI.IDNAME AND LOWER(D3.LANGUAGE) =n' . singleQuote($lang) . ') > 0 THEN n'.singleQuote('').' ELSE TO_NCHAR(DBLI.IDNAME) END)) IDNAME, COALESCE(DICT2.VALUE, COALESCE((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) =n' . singleQuote(clx_language_lower_upper($lang)) . '), CASE WHEN (SELECT COUNT(D4.ID) FROM CLX_DICTIONARY D4 WHERE D4.ENTRY = DBLI.IDNAME2 AND LOWER(D4.LANGUAGE) =n' . singleQuote(uppercase($lang)) . ') > 0 THEN n'.singleQuote('').' ELSE TO_NCHAR(DBLI.IDNAME2) END)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = n' . singleQuote(uppercase($lang)) . ' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = n' . singleQuote(uppercase($lang)) . ' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE=n' . singleQuote($listcode) . ' ' . $crit;
				break;
				default: ///pre(kSystemLanguage); pre($lang);die;
					$sql = 'SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) =' . singleQuote(uppercase($lang)) . '), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) =' . singleQuote(clx_language_lower_upper($lang)) . '), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = ' . singleQuote($lang) . ' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = ' . singleQuote($lang) . ' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE=' . singleQuote($listcode) . ' ' . $crit;
					$sql = 'SELECT DBLI.IDCODE, 
					CASE 	WHEN DICT.VALUE		IS NOT NULL THEN DICT.VALUE
						WHEN DICT3.VALUE	IS NOT NULL THEN DICT3.VALUE
						WHEN DICT5.VALUE	IS NOT NULL THEN DICT5.VALUE
						ELSE IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND LOWER(D.LANGUAGE) ='. singleQuote(lowercase($lang)) .'), DBLI.IDNAME)
						END IDNAME, 
					CASE 	WHEN DICT2.VALUE	IS NOT NULL THEN DICT2.VALUE
						WHEN DICT4.VALUE	IS NOT NULL THEN DICT4.VALUE
						WHEN DICT6.VALUE	IS NOT NULL THEN DICT6.VALUE
						ELSE IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME AND LOWER(D2.LANGUAGE) ='. singleQuote(lowercase($lang)) .'), DBLI.IDNAME2)
						END IDNAME2
					FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI 
					LEFT JOIN CLX_DICTIONARY DICT  ON DICT.ENTRY =  DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = '. singleQuote(lowercase($lang)) .'
					LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = '. singleQuote(lowercase($lang)) .' 

					LEFT JOIN CLX_DICTIONARY DICT3 ON DICT3.ENTRY = DBLI.IDNAME AND LOWER(DICT3.LANGUAGE) = "es" 
					LEFT JOIN CLX_DICTIONARY DICT4 ON DICT4.ENTRY = DBLI.IDNAME2 AND LOWER(DICT4.LANGUAGE) = "es" 

					LEFT JOIN CLX_DICTIONARY DICT5 ON DICT5.ENTRY = DBLI.IDNAME AND LOWER(DICT5.LANGUAGE) = "en" 
					LEFT JOIN CLX_DICTIONARY DICT6 ON DICT6.ENTRY = DBLI.IDNAME2 AND LOWER(DICT6.LANGUAGE) = "en"

					WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE=' . singleQuote($listcode) . ' ' . $crit;;


				break;
			}//echo $sql;
			if (ClxCommon::$db->oneExistsRecords($this->tablename, 'IDCODE = ' . singleQuote($listcode) . ' AND SORT_BY_LABEL = 0') === CLX_NUM_ONE) {
				$sql .=' ORDER BY DBLI.SEQNUM ';
			} else {
				$sql .=' ORDER BY 2 ';
			}
			apc_addFct($findVar, $sql, kApcTtl_10);
		}	


		return ClxCommon::$db->executeQuery($sql);
    }

    function getList($listcode, $name, $default, $readonly = false, $multiple = false, $display_options = CLX_NUM_ONE) {
//pre('getList('.$listcode.', '.$name.', '.$default.')');
 
	    $find='';
		$fetched = false;
		if (kApcTtl_10>0) $find= apc_fetchFct($findVar=$listcode.$name.$default .'_dblist_' , $fetched);
		if ($fetched)
			return $find;
		else {
		   
		   if (empty($display_options))
				$display_options = CLX_NUM_ONE;
			/*
			 * para revision. en modo 2 se implementa listas con ajax,
			 * durante desarrollo de funcionalidad se detecto que el sql estaba
			 * realizando llamadas innecesaras. Se mejoro el sql y ahora parece
			 * estar mejor en performance por lo que el ajax queda en standby
			 */
			$mode = CLX_NUM_ONE;
			if ($mode == CLX_NUM_ONE) {
				//if readonly if false is true then only one element are selected by default
	//            $crit = ($readonly) ? ' AND DBLI.IDCODE = ' . singleQuote($default) . ' ' : '';
				$crit = ($readonly) ? ' AND (DBLI.IDCODE = ' . singleQuote($default) . (trim($default)=== CLX_CHAR_EMPTY_STRING ? ' OR DBLI.IDCODE IS NULL' : '') . ') ' : '';
				$records = $this->getListSql($listcode, $crit);
				if ($multiple === true) {
					$name .='[]';
					if (is_array($default)) {
						$default = toString($default, '\'');
					}
				}
				$pop = new htmlSelect($name);
				while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
					if ($multiple === true) {
						if (strlen($default) > CLX_NUM_ZERO) {
							$exists = (strpos(lowercase($default), '' . singleQuote(lowercase($record['IDCODE']))) === false) ? false : true;
						} else {
							$exists = false;
						}
					} else {

						$exists = (lowercase($record['IDCODE']) == lowercase($default)) ? true : false;
					}
					$pop->addItem($record['IDNAME'] . ' (' . $record['IDCODE'] . ')', $record['IDCODE'], $exists);
				}
				ClxCommon::$db->freeResult($records);
				if ($multiple === true) {
					if ($display_options == CLX_NUM_ONE)
						$display_options = CLX_NUM_THREE;
					$pop->setProp('multiple', true);
				}
				$pop->setProp('size', $display_options);
				apc_addFct($findVar, $pop, kApcTtl_10);
				return $pop;
			}else {
				$pop = new htmlSelect($name);
				$code = '$(document).ready(initDbList(' . singleQuote($name) . ' , ' . singleQuote($listcode) . ' , ' . singleQuote($default) . ' ));';
				$script = setJavaScriptTag($code, false);
				$html = new htmlObject('div');
				$html->addContents($script . $pop->source());
				unset($pop, $script);
				apc_addFct($findVar, $html, kApcTtl_10);
				return $html;
			}
		}	
    }

    function getListAsArray($listcode, $criterias = false) {
		$lang = getCurrentLanguage();
	    $findVar=$listcode. $lang.md5(JSON_ENCODE($criterias)) .'_dblistArray_';
		$fetched = false;
		if (kApcTtl_10>0) $pop= apc_fetchFct($findVar , $fetched);
		if ($fetched)
			return $pop;
		else {
			$records = $this->getListSql($listcode, $criterias);
			$pop = array();
			while ($record = ClxCommon::$db->getNextRecord($records, NUMERIC)) {
				$pop[$record[CLX_NUM_ZERO]] = $record[CLX_NUM_ONE];
			}
			ClxCommon::$db->freeResult($records);
			apc_addFct($findVar, $pop, kApcTtl_10);
		}
		return $pop;
    }

    function getListAsXml($listcode) {
        sendXmlHeader();
        $xml = '<?xml version="1.0" standalone="yes"?>' . CLX_CHAR_NL;
        $records = $this->getListSql($listcode);
        $xml .= '<LIST ID="' . $listcode . '">' . CLX_CHAR_NL;
        while ($record = ClxCommon::$db->getNextRecord($records, NUMERIC)) {
		  $xml .='<ENTRY ID="' . $record[CLX_NUM_ZERO] . '">' . htmlspecialchars($record[CLX_NUM_ONE]) . '</ENTRY>' . CLX_CHAR_NL;
        }
		ClxCommon::$db->freeResult($records);
        $xml .= '</LIST>' . CLX_CHAR_NL;
        return $xml;
    }

    /**
     * Returns list items
     * @param string $listcode
     * @param string $itemcode
     * @param bool [$showcode]
     * @return string
     */
    function getListItem($listcode, $itemcode, $field_format = CLX_NUM_ZERO) {
        $return = '';
        $del_start = '';
        $del_end = '';
		  $lang = getCurrentLanguage();
		  $keycode = kSpaceName . '.dblt.' . $lang . '.' . $listcode;
		  $fetched = false;
		if (kApcTtl_8>0) $return = apc_fetchFct($keycode . '.' . $itemcode . '.' . $field_format, $fetched);

		  if (empty($fetched)) {
			 if (is_array($itemcode)) {
			     $del_start = '<li>';
			     $del_end = '</li>';
			     $criterias = 'AND DBLI.IDCODE IN (' . toString($itemcode, '\'') . ')';
			 } else {
			     switch (kDatabaseType) {
			         case 'oci':
					   if(trim($itemcode) === CLX_CHAR_EMPTY_STRING) {
						  $criterias = ' AND (DBLI.IDCODE = ' . singleQuote($itemcode) .' OR DBLI.IDCODE IS NULL)';
					   } else { 
						  $criterias = ' AND DBLI.IDCODE = ' . singleQuote($itemcode);
					   }
					   break;
			         default:
					   $criterias = ' AND DBLI.IDCODE = ' . singleQuote($itemcode);
			     }
			 }
			 $rs = $this->getListSql($listcode, $criterias);
		  	$valores=array();
			 while ($r = ClxCommon::$db->getNextRecord($rs, NUMERIC)) {
				IF ( $_SERVER['REMOTE_ADDR']=='1901.79.182.130' || (ISSET($GLOBALS['ADDRDEBUGDICT']) && $GLOBALS['ADDRDEBUGDICT']=='190.79.182.130'))  { 
					IF(1==0) { 
						pre('--======>');
						pre($r);
					}
					ELSE {
						
						$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivopp.txt','a+');
						fwrite($tta,chr(13).chr(10).'1107- hora:'.date( 'h:i:s d/m/Y').' '. __LINE__ .chr(13).chr(10));	
						fwrite($tta,chr(13).chr(10)."XXJSON:".$GLOBALS['JSONXX'].CHR(13).CHR(10));


						fwrite($tta,chr(13).chr(10).print_r($r,true). chr(13). chr(10));fclose($tta);
					}
				}
				$valores[md5(print_r($r,true))] = $r;
			 }
			ClxCommon::$db->freeResult($rs);
			
			IF ( $_SERVER['REMOTE_ADDR']=='1901.79.182.130' || (ISSET($GLOBALS['ADDRDEBUGDICT']) && $GLOBALS['ADDRDEBUGDICT']=='190.79.182.130'))  { 

				
					IF(1==0) { 
						pre('--======>');
						pre($valores);
					}
					ELSE {
						
						$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivopp.txt','a+');
						fwrite($tta,chr(13).chr(10).'1107- hora:'.date( 'h:i:s d/m/Y').' '. __LINE__ .chr(13).chr(10));	
						fwrite($tta,chr(13).chr(10)."XXJSON:".$GLOBALS['JSONXX'].CHR(13).CHR(10));

						fwrite($tta,chr(13).chr(10).print_r($valores,true). chr(13). chr(10));fclose($tta);
					}
			}
	
				foreach ($valores as $r) {
				//while ($r = ClxCommon::$db->getNextRecord($rs, NUMERIC)) {
			     $this->setItemFormat($field_format, $r, $del_start, $del_end, $return);
			 }
			if (kApcTtl_8>0){
				apc_addFct($keycode . '.' . $itemcode . '.' . $field_format, $return, kApcTtl_8);
		  }
		  }
        return $return;
    }

    /**
     *
     * @param string $field_format
     * @param array $r
     * @param string $del_start
     * @param string $del_end
     * @param string $return
     */
    private function setItemFormat(&$field_format, &$r, &$del_start, &$del_end, &$return) {
        switch ($field_format) {
		  case CLX_NUM_ONE:
			 $return .= $del_start . $r[CLX_NUM_ZERO] . $del_end; // sin formato
			 break;
		  case CLX_NUM_TWO:
			 $return .= $del_start . $r[CLX_NUM_ONE] . $del_end; // formato
			 break;
		  case CLX_NUM_THREE:
			 $return .= $del_start . $r[CLX_NUM_TWO] . $del_end; // segundo nombre
			 break;
		  case CLX_NUM_FOUR:
			 $return .= $del_start . $r[CLX_NUM_TWO] . ' ' . $r[CLX_NUM_ZERO] . $del_end; // segundo nombre - codigo
			 break;
		  case CLX_NUM_FIVE:
			 $return .= $del_start . $r[CLX_NUM_ONE] . ' ' . $r[CLX_NUM_TWO] . $del_end; // nombre - segundo nombre
			 break;
		  case CLX_NUM_SIX:
			 $return .= $del_start . $r[CLX_NUM_ONE] . ' ' . $r[CLX_NUM_TWO] . ' ' . $r[CLX_NUM_ZERO] . $del_end; // nombre - segundo nombre
			 break;
		  case CLX_NUM_7:
			 $return .= $del_start . $r[CLX_NUM_ONE] . $del_end;
			 break;
		  default:
			 if (trim($r[CLX_NUM_ZERO]) === '') {
			     $return .= $del_start . $r[CLX_NUM_ONE] . $del_end;
			 } else {
			     $return .= $del_start . $r[CLX_NUM_ONE] . '(' . $r[CLX_NUM_ZERO] . ')' . $del_end;
			 }
			 break;
        }
    }

    /**
     * Returns list items
     * @param string $listcode
     * @param bool [$showcode]
     * @return array
     */
    function getListItems($listcode, $showcode = true) {
        $return = array();
        $del_start = '';
        $del_end = '';
        
		  $lang = getCurrentLanguage();
		  $keycode = kSpaceName . '.dblt.' . $lang . '.' . $listcode;
		  $fetched = false;
		if (kApcTtl_8>0)$return = apc_fetchFct($keycode, $fetched);
		  if (empty($fetched)) {
			 $criterias = '';
			 $rs = $this->getListSql($listcode, $criterias);
			 while ($r = ClxCommon::$db->getNextRecord($rs, NUMERIC)) {
			     if ($showcode === true) {
			         if ($r[CLX_NUM_ZERO] === '') {
					   if (trim($r[CLX_NUM_ONE]) === '')
						  $r[CLX_NUM_ONE] = dict('GEN_LBL_NOT_APPLY');
					   $return[$r[CLX_NUM_ZERO]] = $del_start . $r[CLX_NUM_ONE] . $del_end;
			         }else {
					   $return[$r[CLX_NUM_ZERO]] = $del_start . $r[CLX_NUM_ONE] . '(' . $r[CLX_NUM_ZERO] . ')' . $del_end;
			         }
			     } else {
			         $return[$r[CLX_NUM_ZERO]] = $del_start . $r[CLX_NUM_ONE] . $del_end;
			     }
			 }
			 ClxCommon::$db->freeResult($rs);
			if (kApcTtl_8>0) {
				apc_addFct($keycode, $return, kApcTtl_8);
			 }
		  }
		IF (ISSET($GLOBALS['ADDRDEBUGUILISTING']) && $GLOBALS['ADDRDEBUGUILISTING']==$_SERVER['REMOTE_ADDR']) {
			PRE($return);
        }
        return $return;
    }

    function listExists($code) {
        $qty = ClxCommon::$db->oneExistsRecords($this->tablename, 'IDCODE=' . singleQuote($code));
        return $qty > CLX_NUM_ZERO;
    }

    function listItemExists($listcode, $itemcode) {
        $qty = ClxCommon::$db->oneExistsRecords('CLX_DB_LIST_ITEMS', 'LISTCODE=' . singleQuote($listcode) . ' AND IDCODE=' . singleQuote($itemcode));
        return $qty > CLX_NUM_ZERO;
    }

    function isParentList($code) {
        $qty = ClxCommon::$db->oneExistsRecords($this->tablename, 'PARENTLIST = ' . singleQuote($code));
        return $qty > CLX_NUM_ZERO;
    }

    /**
     * Return list code based on list label
     * @param string $listcode
     * @param string $label
     * @return Ambigous <string:, boolean>
     */
    function getListItemByLabel($listcode, $label) {
        $sql = 'SELECT DBLI.IDCODE FROM CLX_DB_LIST_ITEMS DBLI, CLX_DICTIONARY DICT WHERE DICT.ENTRY = DBLI.IDNAME AND DBLI.LISTCODE = ' . singleQuote($listcode) . ' AND DICT.VALUE = ' . singleQuote($label) . ' LIMIT 1';
        return ClxCommon::$db->getOne($sql);
    }

    function placeChooseList($msg, $prompt, $name, $default, &$table) {
        $searchIcon = getSkinIcon('view', 'javascript:openWindow(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', ' . singleQuote('pop.php?to=DBLT&ac=SEARCH&target=' . $name) . ',600, 300,null,'.singlequote($name).','.singlequote( __FILE__ .'_'. __LINE__ ) .');', 'Search for a list');
        if (!empty($msg[$name])) {
		  $table->addCell($msg[$name], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => $table->width));
        }
        $table->addCell($prompt, array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $c = new htmlField($name, $default, CLX_NUM_FOUR, CLX_NUM_FOUR);
        $table->addCell($c->source() . $searchIcon, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
    }

    /**
     * List ajax
     * @return type
     */
    function buildAjaxList() {
        $tbs = explode(',', UserRequest::$get['sfl']);
        $child_tb = substr($tbs[CLX_NUM_ZERO], (strpos($tbs[CLX_NUM_ZERO], '_') - strlen($tbs[CLX_NUM_ZERO]) + CLX_NUM_ONE));
        $sql = 'SELECT DISTINCT DBLT.IDCODE, DBLT.PARENTLIST FROM CLX_DB_FIELDS DBFL, CLX_DB_LISTS DBLT WHERE DBFL.FIELD_EXTRA1 = DBLT.IDCODE AND DBFL.FIELDNAME = ' . singleQuote($child_tb) . ' AND DBFL.FIELDTYPE = ' . singleQuote('LIST');
        $list_op = ClxCommon::$db->getOneRecord($sql);
		
		if ( $this->debug==true ) { 
		$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivo.txt','a+');
		fwrite($tta,chr(13).chr(10). __LINE__ . '- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
		fwrite($tta,chr(13).chr(10).'list_sql: '. chr(10).$sql. chr(13).chr(10));fclose($tta);}
		if ( $this->debug==true ) { 
			$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivo.txt','a+');
			fwrite($tta,chr(13).chr(10). __LINE__ .'- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
			fwrite($tta,chr(13).chr(10).'list_ajax_list: '. chr(10).print_r( $this->ajaxList($list_op['IDCODE'], $list_op['PARENTLIST'], UserRequest::$get['it'], $tbs[CLX_NUM_ZERO], 'JSON'),true). chr(10).$result['EXECS'].chr(13).chr(10));fclose($tta);}
	   
		ob_clean();
        return (empty($list_op)) ? '' : $this->ajaxList($list_op['IDCODE'], $list_op['PARENTLIST'], UserRequest::$get['it'], $tbs[CLX_NUM_ZERO], 'JSON');
    }

    /**
     *
     * @param type $code
     * @param type $parentlist
     * @param type $parentitem
     * @param type $child_formfield
     * @param type $output_format
     * @return string
     */
    function ajaxList($code, $parentlist = '', $parentitem = '', $child_formfield = '', $output_format = false) {
        $contents = '';
        $crit = '';
        if (strlen($parentlist) > CLX_NUM_ZERO) {
		  $crit = ' AND DBLT.PARENTLIST = ' . singleQuote($parentlist);
        }
        if (strlen($parentitem) > CLX_NUM_ZERO) {
		  $crit .= ' AND (DBLI.PARENTITEM = ' . singleQuote($parentitem) . ' OR DBLI.PARENTITEM = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ')';
        }
        $rs = $this->getListSql($code, $crit);
		$GLOBALS['XXJSON']=0;
        //$db->debug = false;
        switch ($output_format) {
		  case 'XML':
			 $contents = '<?xml version="1.0" standalone="yes"?>' . CLX_CHAR_NL;
			 $o = new xmlObject('LIST');
			 $o->setProp('ID', $code);
			 $valores=array();
			 while ($r = ClxCommon::$db->getNextRecord($rs, NUMERIC)) {
					$valores[md5(print_r($r,true))] = $r;
			 }
			 ClxCommon::$db->freeResult($rs);
			 foreach ($valores as $r) {  
			     $set = new xmlObject('ENTRY');
//			     $set->setProp('CODE', $r[CLX_NUM_ZERO]);
			     $set->setProp('CODE', (is_null($r[CLX_NUM_ZERO]) ? '' : $r[CLX_NUM_ZERO]));
			     $set->addContents(htmlspecialchars($r[CLX_NUM_ONE]));
			     $o->addObject($set);
			 }
			 $contents .= $o->source_(array('level' => CLX_NUM_ZERO));
			 break;
		  case 'JSON':
			 $return = array();
				
				IF ( $_SERVER['REMOTE_ADDR']=='1901.79.182.130' || (ISSET($GLOBALS['ADDRDEBUGDICT']) && $GLOBALS['ADDRDEBUGDICT']=='190.79.182.130'))  { 
						$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");
						fwrite($tta,chr(13).chr(10)."4-hora:".date("h:i:s d/m/Y").chr(13).chr(10));
						fwrite($tta,chr(13).chr(10)."INIT JSON");
						$te=debug_backtrace();
						for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"]))fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}fclose($tta);

				}
				
				ob_clean();
				$GLOBALS['JSONXX']=1;
			 while ($r = ClxCommon::$db->getNextRecord($rs, NUMERIC)) {
			     //$r[CLX_NUM_ONE] = trim($r[CLX_NUM_ONE]);
			     $r[CLX_NUM_ONE] = (is_null($r[CLX_NUM_ONE]) ? '' : trim($r[CLX_NUM_ONE]));
			     $r[CLX_NUM_ZERO] = (is_null($r[CLX_NUM_ZERO]) ? '' : $r[CLX_NUM_ZERO]);
			     if ($r[CLX_NUM_ZERO] === '') {
			         if ($r[CLX_NUM_ONE] === '')
					   $r[CLX_NUM_ONE] = dict('GEN_LBL_NOT_APPLY');
			         //$return[$r[CLX_NUM_ZERO]] = $r[1];
			         $item = array('key' => $r[CLX_NUM_ZERO], 'val' => trim($r[CLX_NUM_ONE]) . ' (' . $r[CLX_NUM_ZERO] . ')');
			     }else {
			         //$return[$r[CLX_NUM_ZERO]] = trim($r[1]) . ' (' . $r[CLX_NUM_ZERO] . ')';
			         $item = array('key' => $r[CLX_NUM_ZERO], 'val' => trim($r[CLX_NUM_ONE]) . ' (' . $r[CLX_NUM_ZERO] . ')');
			     }
			     $return[md5(print_r($item,true))] = $item;
			 }
			 ClxCommon::$db->freeResult($rs);
			 $return=array_values($return);
			 OB_CLEAN();
			 $contents = json_encode($return);
			 unset($return);
			 break;
		  default:
			 $contents = $child_formfield . ',,' . CLX_CHAR_NL;
				$valores=array();
			 while ($r = ClxCommon::$db->getNextRecord($rs, NUMERIC)) {
					$valores[md5(print_r($r,true))] = $r;
			 }
			 ClxCommon::$db->freeResult($rs);
			 foreach ($valores as $r) {
			     if ($r[CLX_NUM_ZERO] === '') {
			         if ($r[CLX_NUM_ONE] === '') {
					   $r[CLX_NUM_ONE] = dict('GEN_LBL_NOT_APPLY');
			         }
			         $contents .= $child_formfield . ',' . str_replace(',', ' ', $r[CLX_NUM_ONE]) . ',' . $r[CLX_NUM_ZERO] . CLX_CHAR_NL;
			     } else {
			         $contents .= $child_formfield . ',' . str_replace(',', ' ', $r[CLX_NUM_ONE]) . '(' . $r[CLX_NUM_ZERO] . ')' . ',' . $r[CLX_NUM_ZERO] . CLX_CHAR_NL;
			     }
			 }
			 break;
        }
		
		
        return $contents;
    }

    function enable_item_temp($listcode, $criterio = '') {
        ClxCommon::$db->updateRecord('CLX_DB_LIST_ITEMS', array('INACTIVE' => CLX_NUM_ONE), 'LISTCODE = ' . singleQuote($listcode));
        if ($criterio !== '') {
		  ClxCommon::$db->updateRecord('CLX_DB_LIST_ITEMS', array('INACTIVE' => CLX_NUM_ZERO), 'LISTCODE = ' . singleQuote($listcode) . ' AND ' . $criterio);
        } else {
		  ClxCommon::$db->updateRecord('CLX_DB_LIST_ITEMS', array('INACTIVE' => CLX_NUM_ZERO), 'LISTCODE = ' . singleQuote($listcode));
        }
    }

}
