<?php

/**
 * Query Manager
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-02-07 07:56:48 -0500 (Thu, 07 Feb 2019) $
 * @version      $Rev: 10537 $
 *
 * CHANGE LOG
 *  CASO_1004250 HTS - Revision Menu AUTOSERVICIO. (Error Seguridad de Arbol de acceso
 *		Se corrigio el criterio para campo de arbol de acceso de 'TLO' a 'TLOK' funcion getquery() .Access Tree Block
 *  Oracle uppercase record changed
 * 			se arreglo el problema con el Sort Fields y Group By con los campos derivados en el metodo getQuery()
 */

class db_queries extends clx_tool {

    var $efftdate_enabled = true;
    //var $operators = array('EQ' => 'GEN_OPE_EQUAL', 'NQ' => 'GEN_OPE_NOTEQUAL', 'LS' => 'GEN_OPE_LESS', 'LQ' => 'GEN_OPE_LESS_EQUAL', 'GQ' => 'GEN_OPE_GREATER_EQUAL', 'GT' => 'GEN_OPE_GREATER', 'IN' => 'GEN_OPE_IN', 'NI' => 'GEN_OPE_NOTIN', 'BW' => 'GEN_OPE_BETWEEN', 'SW' => 'GEN_OPE_STARTS_WITH', 'EW' => 'GEN_OPE_ENDS_WITH', 'CT' => 'GEN_OPE_CONTAINS');
    var $operators = array('EQ' => 'GEN_OPE_EQUAL', 'NQ' => 'GEN_OPE_NOTEQUAL', 'LS' => 'GEN_OPE_LESS', 'LQ' => 'GEN_OPE_LESS_EQUAL', 'GQ' => 'GEN_OPE_GREATER_EQUAL', 'GT' => 'GEN_OPE_GREATER', 'IN' => 'GEN_OPE_IN', 'NI' => 'GEN_OPE_NOTIN', 'BW' => 'GEN_OPE_BETWEEN', 'SW' => 'GEN_OPE_STARTS_WITH', 'EW' => 'GEN_OPE_ENDS_WITH', 'CT' => 'GEN_OPE_CONTAINS',		    'SN' => 'GEN_OPE_STARTS_NWITH', 'EN' => 'GEN_OPE_ENDS_NWITH', 'CN' => 'GEN_OPE_NCONTAINS',      'EX' => 'GEN_OPE_EXPRESSIONS',        'IS' => 'GEN_OPE_IS', 'IT' => 'GEN_OPE_ISNOT', 'EF' => 'GEN_EFFDATE_LESSEQUAL', 'FQ' => 'GEN_EFFDATE_EQUAL');

    var $include_empty_answers = true;
    var $sec_table_list = NULL; // must be a public property, used by edit.php
	var $access_type_view=array('0' => 'GEN_VIEW_NORMAL', '1' => 'GEN_VIEW_EDITING');
	var $req_date=array('0' => 'GEN_NOT_USE_REQ_EFFTDATE','1' => 'GEN_USE_REQ_EFFTDATE' );
    function __construct() {
        $this->code = 'DBQY';
        $this->name = 'Query Manager';
        $this->system = 'Database';
        $this->version = '5.5.0.0';

        $this->has_access = true;
        $this->has_package = true;

        $this->tablename = 'CLX_DB_QUERIES';
        $this->record_name_singular = 'query';
        $this->record_name_plural = 'queries';
        $this->primary_field = 'IDCODE';
        $this->secondary_field = 'IDNAME';

        $this->primary_key = array('IDCODE');
        $this->access_types = array(CLX_NUM_ZERO => 'GEN_LBL_SYSTEM', CLX_NUM_ONE => 'GEN_LBL_USER');
        $this->access_types_aux = array_merge(array('' => ''), $this->access_types);
        $this->efftdate_enabled = true;
        $this->parent_clx_efftdate = ''; //when value is set getquery limit to this criteria
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_DBQY_TITLE_CREATE',
		  'panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_CODE',
					   'fields' => array(
						  array('name' => 'idcode', 'type' => 'string', 'default' => '', 'size' => '16', 'displaysize' => '16', 'dontmodify' => '1',
						      'validations' => array(
								array('type' => 'unique', 'fieldname' => 'idcode', 'tablename' => $this->tablename, 'required' => '1'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_NAME',
					   'fields' => array(
						  array('name' => 'idname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48', 'validations' => array(
								array('type' => 'string', 'required' => '1'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_VERSION',
					   'fields' => array(
						  array('name' => 'version', 'type' => 'string', 'default' => '1.0.0', 'size' => '32', 'displaysize' => '16', 'validations' => array(
								array('type' => 'string', 'required' => '1'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_DESCRIPTION',
					   'fields' => array(
						  array('name' => 'description', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4'))
			         ), array('label' => 'GEN_LBL_MODULECODE',
					   'fields' => array(
						  array('name' => 'modulecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBMO', 'validations' => array(
								array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'idcode', 'tablename' => 'CLX_DB_MODULES'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_ACCESS',
					   'fields' => array(
						  array('name' => 'accesses', 'type' => CLX_CLASS_LIST, 'default' => '1', 'options' => $this->access_types)
					   )
                        ), array('label' => 'GEN_LBL_INCLUDE_REQ_EFFTDATE',
                            'fields' => array(
                                array('name' => 'req_efftdate', 'type' => CLX_CLASS_LIST, 'default' => '1', 'options' => $this->req_date)
                            )
                        ), array('label' => 'GEN_LBL_TYPE_VIEW',
                            'fields' => array(
                                array('name' => 'view_type', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => $this->access_type_view)
                            )
			         )
			     )
			 )
		  )
        );
        $this->quickfilterform = array('panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_CODE',
					   'fields' => array(
						  array('name' => 'idcode',
						      'type' => 'string',
						      'default' => '',
						      'size' => '16',
						      'displaysize' => '16'
						  )
					   )
			         ), array('label' => 'GEN_LBL_NAME',
					   'fields' => array(
						  array('name' => 'idname',
						      'type' => 'string',
						      'default' => '',
						      'size' => '64',
						      'displaysize' => '48'
						  )
					   )
			         ), array('label' => 'GEN_LBL_MODULECODE',
					   'fields' => array(
						  array('name' => 'modulecode',
						      'type' => 'lookup',
						      'default' => '',
						      'tool' => 'DBMO'
						  )
					   )
			         ), array('label' => 'GEN_LBL_ACCESS',
					   'fields' => array(
						  array('name' => 'accesses',
						      'type' => CLX_CLASS_LIST,
						      'default' => '',
						      'options' => $this->access_types_aux)
					   )
			         )
			     )
			 )
		  )
        );
		IF (ISSET($GLOBALS['ADDRDEBUGDBQUERIES']) && $GLOBALS['ADDRDEBUGDBQUERIES']==$_SERVER['REMOTE_ADDR']) {
			$this->debug=true;
		}
    }

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_DATABASE:MENU_QUERIES', 'TOOL', $this->code, 'ac=LIST');
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['IDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['ACCESSES'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['REQ_EFFTDATE'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ONE);
        $fields['VIEW_TYPE'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['DISTINCT_SELECT'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
		$fields['SET_SUBSELECT_AFTER'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
		
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'IDNAME');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'MODULECODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

    function pack($record) {
        $o = $this->packRecord($record);
        $code = $record['IDCODE'];
        $objs = new XMLObject($this->code . '_OBJECTS');
        $this->packsub($objs, 'DBQT', 'SELECT * FROM CLX_DB_QUERY_TABLES WHERE QUERYCODE=' . singleQuote($code));
        $this->packsub($objs, 'DBQC', 'SELECT * FROM CLX_DB_QUERY_CRITERIA WHERE QUERYCODE=' . singleQuote($code));
		$this->packsub($objs, 'DBQF', 'SELECT * FROM CLX_DB_QUERY_FIELDS WHERE QUERYCODE=' . singleQuote($code));
		$this->packsub($objs, 'DBQJ', 'SELECT * FROM CLX_DB_QUERY_JOIN_CRITERIA WHERE QUERYCODE=' . singleQuote($code));
		$this->packsub($objs, 'DBQR', 'SELECT * FROM CLX_DB_QUERY_JOIN_TYPE_RELATION WHERE QUERYCODE=' . singleQuote($code));
       
        $o->addObject($objs);
        return $o;
    }

    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        $querycode = $record['IDCODE'];
        if (ClxCommon::$db->oneExistsRecords($this->tablename, 'IDCODE=' . singleQuote($querycode)) > CLX_NUM_ZERO) {
		  ClxCommon::$db->updateRecord($this->tablename, $record, 'IDCODE=' . singleQuote($querycode));
        } else {
		  ClxCommon::$db->createRecordVoid($this->tablename, $record, false);
        }
        ClxCommon::$db->deleteRecords('CLX_DB_QUERY_TABLES', 'UPPER(QUERYCODE)=' . singleQuote(UPPERCASE($querycode)));
        ClxCommon::$db->deleteRecords('CLX_DB_QUERY_CRITERIA', 'UPPER(QUERYCODE)=' . singleQuote(UPPERCASE($querycode)));
		ClxCommon::$db->deleteRecords('CLX_DB_QUERY_FIELDS', 'UPPER(QUERYCODE)=' . singleQuote(UPPERCASE($querycode)));
		ClxCommon::$db->deleteRecords('CLX_DB_QUERY_JOIN_CRITERIA', 'UPPER(QUERYCODE)=' . singleQuote(UPPERCASE($querycode)));
		ClxCommon::$db->deleteRecords('CLX_DB_QUERY_JOIN_TYPE_RELATION', 'UPPER(QUERYCODE)=' . singleQuote(UPPERCASE($querycode)));
	
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
		  $objs = $package->getObjectXml($this->code . '_OBJECTS');
		  foreach ($objs->objects as $o) {
			 $toolcode = $o->tag;
				$tool = &getTool($toolcode);
			 $tool->unpack(array('package' => $o));
		  }
        }
    }

    function action($ac, $idlist) {
		$msg='';	
		if (isset(UserRequest::$post['DBQY_idname']))
			UserRequest::$post['DBQY_idname']=clx_change_especial_char_html(UserRequest::$post['DBQY_idname']);
        if ($this->getAccess()->canRead()) {
		  switch ($ac) {
			 case 'QXML':
			     $contents = $this->dumpResultXml(UserRequest::$get[CLX_PROP_TO], UserRequest::$get['qy'], UserRequest::$get['fn'], UserRequest::$get['fv']);
			     break;
			 case 'CREATE_UI':
			     //if (isset(UserRequest::$post['confirm'])) {
			         $contents = $this->create_ui_go();
			         //$info = popHistory();
			        // $contents = executeHistory($info);
			    // } else {
			    //     $record = array();
			    //     $contents = $this->create_ui_form($msg);
			     //}
			     break;
				case 'DISPLAY':
					//pre($_POST);
					if (isset(UserRequest::$post[$this->code.'_distinct_select'])&& uppercase(substr(UserRequest::$post['submit1'],0,3))=='MOD') {
						$idlistx=$idlist[0];
						ClxCommon::$db->executequery('UPDATE '.$this->tablename.
							' SET DISTINCT_SELECT='.UserRequest::$post[$this->code.'_distinct_select']. 
							', SET_SUBSELECT_AFTER='.UserRequest::$post[$this->code.'_set_subselect_after'].
							' WHERE id='.$idlistx); 
					}
			     if (isset(UserRequest::$request['next'])) {
			         popHistory(); // forget where we here
			         array_pop($idlist);
			         $contents = $this->viewForm_($idlist);
			     } else {
			         $contents = $this->viewForm_($idlist);
			     }
			     break;
			 default:
				
						if ($ac=='CREATE' OR $ac=='MODIFY') {
						//echo pre($GLOBALS);
						//pre($this->editform['panels'][0]['entries'][6]['fields'][0]['options']);
							$idlistx = getIdlist();
							If (is_array($idlistx) && count($idlistx)>0 && !ClxCommon::$db->getOne( $SQL='SELECT 1 FROM CLX_DB_QUERY_SAVE DBQS,CLX_DB_QUERIES DBQY WHERE DBQS.QUERYCODE=DBQY.IDCODE AND DBQY.ID='.$idlistx[0] )) {
							//	UNSET($this->editform['panels'][0]['entries'][6]['fields'][0]['options']['VE']);
							}
					
			
						}
				
			     $contents = parent::action($ac, $idlist);
			     break;
		  }
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [DB_QUERIES-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function makelist($listingcode = null) {
        $this->applyUserAccessFromMenu();
        $t = time();
        $to = $this->code;
        $here = 'tool.php?to=' . $to . '&t=' . $t;
        clearHistory();
        pushHistory($this->code, 'LIST', array());
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->setProp(CLX_PROP_ID, 'DBQYList');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NOT_DEFINED');
        $selectclause = '*';
        $fromclause = 'CLX_DB_QUERIES';
        $whereclause = '';
        $sortclause = '';

        $page = new xPaging();
        $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
        $table = new htmlTable(CLX_WIDTH_EIGHT);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_DBQY_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_EIGHT));
        $page->header($table); 
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_MODULECODE'), dict('GEN_LBL_CODE'), dict('GEN_LBL_NAME'), dict('GEN_LBL_VERSION'), dict('GEN_LBL_DESCRIPTION'), dict('GEN_LBL_ACCESS'), dict('GEN_LBL_TYPE_VIEW')));
        $i = CLX_INIT_ZERO;
        while ($record = $page->nextRecord()) {
		  $recordid = $record['ID'];
		  $select = new htmlCheckbox('selector_' . $recordid, false);
		  $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
		  $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
            $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['MODULECODE'], $record['IDCODE'], $record['IDNAME'], $record['VERSION'] . '-' . $record['VERSION_COUNTER'], xFormat::text($record['DESCRIPTION']), dict($this->access_types[$record['ACCESSES']]), ($record['VIEW_TYPE']==1?'<font style="color:A70000;font-weight:800">':''). dict( $this->access_type_view[$record['VIEW_TYPE']]) .($record['VIEW_TYPE']==1?'</font>':'')  ));
		  $i++;
        }
        $buttons = '';
        if ($this->getAccess()->canDisplay()) {
		  $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canModify()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDelete()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        //if ($this->getAccess()->canDisplay()) {
        if ($this->getAccess()->canAppend()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DUPLICATE'), array('action' => 'DUPLICATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ONE'))->source();
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_QUERY')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        }
        if ($this->getAccess()->canModify()) {
		  /*
		   * TOOL_DBQY_GENERATE_UI
		   * Generate Listing
		   * Generar Listado
		   */
		  $buttons .= htmlButton::getButton('submit', dict('TOOL_DBQY_GENERATE_UI'), array('action' => 'CREATE_UI', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ONE'))->source();
        }
        $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_FILTER'), array('action' => 'FILTER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        $form->addContents($page->footers($table, $buttons));
        return $form->source();
    }
    /**
     * Tool Edit Form
     * @param string $ac
     * @param string $idlist
     * @param array $record
     * @param array $msg
     *f @return string
     */
    function editF1sorm($ac, $idlist, $record, $msg) {IF (isset($GLOBALS['ADDRDEBUGEDITFORM_']) && $GLOBALS['ADDRDEBUGEDITFORM_']==1) { ECHO __METHOD__.' '.__FILE__.':'.__LINE__.'<br>'; }
        if (UserRequest::$request['ac'] === 'MODIFY') {
            $this->editform[CLX_CLASS_TITLE] = 'TOOL_' . $this->code . '_TITLE_MODIFY';
        } else {
            $this->editform[CLX_CLASS_TITLE] = 'TOOL_' . $this->code . '_TITLE_CREATE';
        }
	
			//echo pre($GLOBALS);
			//pre($this->editform['panels'][0]['entries'][6]['fields'][0]['options']);
			$idlist = getIdlist()[0];
				if ( !ClxCommon::$db->getOne( $SQL='SELECT 1 FROM CLX_DB_QUERY_SAVE DBQS,CLX_DB_QUERIES DBQY WHERE DBQS.QUERYCODE=DBQY.IDCODE AND DBQY.ID='.$idlist )) {
				UNSET($this->editform['panels'][0]['entries'][6]['fields'][0]['options']['VE']);
			}
			
			
	

        $form = new clx_form($this->code, $this->editform);
        return $form->editForm($ac, $idlist, $record, $msg);
    }

    function searchForm() {
        $msg = array();
        $contents = '';
        // Search Form
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'SEARCH');
        $form->addArgument('confirm', '1');
        $form->addArgument(CLX_PROP_TARGET, UserRequest::$request[CLX_PROP_TARGET]);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_DBQY_TITLE_SEARCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addField($msg, dict('GEN_LBL_CODE') . ':', 'DBQY_idcode', (!empty(UserRequest::$post['DBQY_idcode'])) ? UserRequest::$post['DBQY_idcode'] : '', CLX_NUM_16, CLX_NUM_16);
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'DBQY_idname', (!empty(UserRequest::$post['DBQY_idname'])) ? UserRequest::$post['DBQY_idname'] : '', CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_MODULECODE') . ':', 'DBQY_modulecode', (!empty(UserRequest::$post['DBQY_modulecode'])) ? UserRequest::$post['DBQY_modulecode'] : '', CLX_NUM_FOUR, CLX_NUM_FOUR);
        $sel = new htmlSelect('DBQY_accesses');
        $sel->addItem('', '', CLX_NUM_ONE);
        foreach ($this->access_types as $key => $val) {
		  $sel->addItem(dict($val), $key, CLX_NUM_ZERO);
        }
        $table->addCell(dict('GEN_LBL_ACCESS'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($sel->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $buttons = htmlButton::getButton('submit', dict('GEN_LBL_SEARCH'), array('action' => 'SEARCH', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents .= $form->source();
        // Search Procedure
	    if (isset(UserRequest::$post['confirm'])) {
		  $table = new htmlTable(CLX_WIDTH_TWO);
		  $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
		  $criteria = '';
		  $boolean = '';
		  if (UserRequest::$post['DBQY_idcode'] <> '') {
			 $criteria .= $boolean . 'UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['DBQY_idcode']) . '%');
			 $boolean = ' AND ';
		  }
		  if (UserRequest::$post['DBQY_idname'] <> '') {
			 $criteria .= $boolean . 'UPPER(IDNAME) LIKE ' . singleQuote(uppercase(UserRequest::$post['DBQY_idname']) . '%');
			 $boolean = ' AND ';
		  }
		  if (UserRequest::$post['DBQY_modulecode'] <> '') {
			 $criteria .= $boolean . 'UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['DBQY_modulecode']) . '%');
			 $boolean = ' AND ';
		  }
		  if (UserRequest::$post['DBQY_accesses'] <> '') {
			 $criteria .= $boolean . 'ACCESSES = ' . UserRequest::$post['DBQY_accesses'];
			 $boolean = ' AND ';
		  }
            $qty = ClxCommon::$db->oneExistsRecords($this->tablename, $criteria);
		  if ($qty == CLX_NUM_ZERO) {
			 $table->addCell(dict('TOOL_DBQY_ERR_NOMATCH'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
		  } else {
			 $table->addCell(dict('TOOL_DBQY_MSG_FOUNDRECORDS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
			 $records = ClxCommon::$db->getRecords($this->tablename, $criteria);
			 $i = CLX_INIT_ZERO;
			 while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
			     $js = 'javascript:setLookupValue(' . quote(UserRequest::$request[CLX_PROP_TARGET]) . ', ' . quote($record['IDCODE']) . ');';
			     $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array('<page t=db_queries></page><a href=' . singleQuote($js) . '>' . $record['IDCODE'] . '</a>', $record['IDNAME']));
			     $i++;
			 }
			 ClxCommon::$db->freeResult($records);
		  }
		  $contents .= $table->source();
        }
        return $contents;
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_CODE') . ':', $record['DBQY_idcode']);
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['DBQY_idname']);
    }

    function viewFormFill($record) {
        addHistory('querycode', $record['DBQY_idcode']);
        $modulerec = ClxCommon::$db->getRecord('CLX_DB_MODULES', 'IDCODE=' . singleQuote($record['DBQY_modulecode']));
        $contents = '';
		$existeRegistro=0;
		
			$form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
			$form->addArgument(CLX_PROP_TO, $this->code);
			$form->addArgument('ac', 'DISPLAY');
			$form->addArgument('confirm', '1');
			$form->addArgument('editx', 'DISPLAY');
			$idlist = getIdlist();

			$form->addArgument('selector_'.$idlist[0],'1' );
		  //  $form->addArgument(CLX_PROP_TARGET, UserRequest::$request[CLX_PROP_TARGET]);
		
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_DBQY_TITLE_VIEW') . ': ' . $record['DBQY_idname'], array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_CODE') . ':', $record['DBQY_idcode']);
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['DBQY_idname']);
        $table->addData(dict('GEN_LBL_VERSION') . ':', $record['DBQY_version'] . '-' . $record['DBQY_version_counter']);
        $table->addData(dict('GEN_LBL_DESCRIPTION') . ':', xFormat::text($record['DBQY_description']));
        $table->addData(dict('GEN_LBL_MODULECODE') . ':', $modulerec['IDNAME'] . ' (' . $modulerec['IDCODE'] . ')');
        $table->addData(dict('GEN_LBL_ACCESS') . ':', dict($this->access_types[$record['DBQY_accesses']]));
      	$GET_SQL=$this->getSql($this->code, $record['DBQY_idcode']);
		
		
		$sql = 'SELECT TEXT_SQL FROM CLX_DB_QUERY_SAVE DBQS, CLX_DB_QUERIES DBQY WHERE DBQY.IDCODE=DBQS.QUERYCODE AND (DBQY.VIEW_TYPE=1 '.(isset(UserRequest::$post['SQL_INF'])?' OR 1=1':'')  .' )AND DBQS.QUERYCODE='.singlequote($record['DBQY_idcode']);
		$table->addData(dict('GEN_LBL_TYPE_VIEW'). ':', dict($this->access_type_view[$record['DBQY_view_type']]));
		$GET_SQL2 = ClxCommon::$db->getOne($sql);			
	//echo $sql;
	//	PRE($GET_SQL2);
		
		$size=CLX_NUM_HUNDRED;
		
		if (isset(UserRequest::$post['editx']) || !empty($GET_SQL2 )) {
			$size=CLX_NUM_20;
		}
		$textarea2='';
		$textarea = new htmlTextArea('', $this->getSql($this->code, $record['DBQY_idcode']), CLX_NUM_TEN, $size);
        $textarea->setProp('readonly', CLX_NUM_ONE);
        $textarea->setProp(CLX_PROP_CLASS, CLX_CLASS_DATA);
        
		
		if ($size==CLX_NUM_20) {
			$textarea->setProp(CLX_PROP_CLASS, CLX_CLASS_DATA);
			$textarea->setProp('style','background-color:#cccccc;');
			
			$codetextarea=$textarea->source();
			if(!isset(UserRequest::$post['SQL_INF'])) {
				$GET_SQL_ = ClxCommon::$db->getOne($sql);
				if (!empty($GET_SQL_)) {
					$GET_SQL=$GET_SQL_;
					$existeRegistro=1;
					$form->addArgument('existeRegistro', '1');
				}
			}
			else {
				$GET_SQL = UserRequest::$post['SQL_INF'];
				//pre($GLOBALS);
				if (isset(UserRequest::$post['existeRegistro'])) {
					$form->addArgument('existeRegistro', '1');
					$existeRegistro=1;
				}
			}
			$textarea2 = new htmlTextArea('SQL_INF', $GET_SQL , CLX_NUM_TEN, CLX_NUM_80);
			$textarea2->setProp(CLX_PROP_CLASS, CLX_CLASS_DATA);
			
			$codetextarea="<table width=800><tr><td>".
			'<table><tr><td>'.dict($this->access_type_view[0]).'</td></tr><tr><td>'.
			$codetextarea.'</td></tr></table></td><td><table><tr><td>'.dict($this->access_type_view[1]).'</td></tr><tr><td> '. $textarea2->source()."</td></tr></table></td></tr></table>";
		}
		else
			$codetextarea=$textarea->source();
		$table->addData(dict('GEN_LBL_QUERY') . ':', $codetextarea);
        
        unset($textarea);
			
			if (isset(UserRequest::$post['editx']) or $size==CLX_NUM_20 )  {
				$buttons = htmlButton::getButton('submit', dict('GEN_LBL_SAVE'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
				IF (ISSET(UserRequest::$post['SQL_INF'])) {
					$record2=array();
					$record2['QUERYCODE'] = $record['DBQY_idcode'];
					
					$record2['MDATE'] = xFormat::getNow('Y-m-d');
					$record2['TEXT_SQL'] = UserRequest::$post['SQL_INF'];
				
					if ($existeRegistro==0) {
						$record2['CDATE'] = xFormat::getNow('Y-m-d');
						$recordid = ClxCommon::$db->createRecord('CLX_DB_QUERY_SAVE', $record2, false);
						
					}
					else {
						ClxCommon::$db->updateRecord('CLX_DB_QUERY_SAVE', $record2, 'QUERYCODE=' . singlequote($record['DBQY_idcode']));
					}
				}
			}
			else {
				$buttons = htmlButton::getButton('submit', dict('GEN_LBL_EDIT'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();

			}
			$table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
			$form->setContents($table->source());
			$contents.=$form->source();
		/*}
		else {
        $contents .= $table->source();
		}*/
        // Tables
        $DBQT = &getTool('DBQT');
        $contents .= $DBQT->makepanel($record['DBQY_idcode']);
				// Join
        $DBQJ = &getTool('DBQJ',false);
		if (is_object($DBQJ)) {
			$contents .= $DBQJ->makepanel($record['DBQY_idcode']);
			$DBQR = &getTool('DBQR',false);
			if (is_object($DBQR)) {
				$contents .= $DBQR->makepanel($record['DBQY_idcode']);
			}	
		}	
        // Criteria
        $DBQC = &getTool('DBQC');
        $contents .= $DBQC->makepanel($record['DBQY_idcode']);
        // Fields
        $DBQF = &getTool('DBQF');
        $contents .= $DBQF->makepanel($record['DBQY_idcode']);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addData(dict('GEN_LBL_CDATE') . ':', $record['DBQY_cdate']);
        $table->addData(dict('GEN_LBL_MDATE') . ':', $record['DBQY_mdate']);
        $table->addData(dict('GEN_LBL_USERNAME') . ':', $record['DBQY_username']);
        $contents .= buildPanelInterface(dict('GEN_TTL_SYSTEMINFO'), 'SYSTEMINFO', $table->source(), CLX_NUM_MINUS_1);
		
		
		
		$form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', UserRequest::$request['ac']);
        $form->addArgument('confirm', '1');
		$idlist=getIdlist()[0];
		$form->addArgument('selector_'.$idlist,'1');
        $form->addArgument(CLX_PROP_TARGET, UserRequest::$request[CLX_PROP_TARGET]);
        $buttons='';
		$table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $yesno = new htmlSelect($this->code.'_distinct_select');
        $yesno->addItem(dict('GEN_LBL_NO'), '0', ($record[$this->code.'_distinct_select'] == CLX_NUM_ZERO));
        $yesno->addItem(dict('GEN_LBL_YES'), '1', ($record[$this->code.'_distinct_select'] == CLX_NUM_ONE));
        $table->addData(dict('GEN_LBL_DISTINCT') . ':', $yesno->source());

        $yesno = new htmlSelect($this->code.'_set_subselect_after');
        $yesno->addItem(dict('GEN_LBL_NO'), '0', ($record[$this->code.'_set_subselect_after'] == CLX_NUM_ZERO));
        $yesno->addItem(dict('GEN_LBL_YES'), '1', ($record[$this->code.'_set_subselect_after'] == CLX_NUM_ONE));
        $table->addData(dict('GEN_LBL_SUBSELECT_AFTER') . ':', $yesno->source());


		$buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' =>UserRequest::$request['ac'] , 'form' => $form_id, CLX_PROP_ID => 'MULT'))->source();
		
		$buttons .=htmlButton::getButton('submit', dict('GEN_LBL_EXPLAIN'), array('action' =>UserRequest::$request['ac'] , 'form' => $form_id, CLX_PROP_ID => 'MULT'))->source();
		
		$table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
		$form->setContents($table->source());
        $contents .= buildPanelInterface(dict('GEN_EXTRAINFO'), 'EXTRAINFO', $form->source(), CLX_NUM_MINUS_1);


        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addData(dict('GEN_LBL_CDATE') . ':', $record['DBQY_cdate']);
        $table->addData(dict('GEN_LBL_MDATE') . ':', $record['DBQY_mdate']);
        $table->addData(dict('GEN_LBL_USERNAME') . ':', $record['DBQY_username']);
        $contents .= buildPanelInterface(dict('GEN_TTL_SYSTEMINFO'), 'SYSTEMINFO', $table->source(), CLX_NUM_MINUS_1);
        return $this->showWarningQueryGroupby($this->code, $record['DBQY_idcode']).$contents;
		 		
    }
	function explainPlan($sql) {
		
		ClxCommon::$db->executequery('EXPLAIN PLAN FOR '.$sql);
		$rs=ClxCommon::$db->executequery('select * from table(dbms_xplan.display)');
		$textoExplain='';
		while ($rsx = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			$rsx['PLAN_TABLE_OUTPUT']=str_replace(' --------------------------------------------------------------------------------','',$rsx['PLAN_TABLE_OUTPUT']); 
			
			if ($rsx['PLAN_TABLE_OUTPUT']!='') {
				IF(STRPOS(' '.$rsx['PLAN_TABLE_OUTPUT'],'|')>0) {
						$textoExplain.='<tr<td>'.str_replace('|','</td><td>',$rsx['PLAN_TABLE_OUTPUT']).'</td><tr>';
				}
			}
		}
		ClxCommon::$db->freeResult($rs);
		$textoExplain='<table class="'.CLX_CLASS_FORM.'">'.$textoExplain.'<table>';
		$textoExplain= '		<Script>
			$(function() {
				$( "#dialgExp" ).dialog({
				  height: 240,
				  width: 640,
				  modal: true
				});
				});
			</script><div><div id="dialgExp">'.
			$textoExplain.
			'</div></div>	';
			
		return ((uppercase(substr(UserRequest::$post['submit1'],0,3))=='EXP') ?
			$textoExplain:'');
    }
	
	function showWarningQueryGroupby($code, $querycode) {
		$content='';
		switch (kDatabaseType) {
			case 'oci':
				$query = $this->getQuery($tool, $querycode);
				$SELECTCLAUSE=explode(',',$query['SELECTCLAUSE']);
				$GROUPCLAUSE=explode(',',$query['GROUPCLAUSE']);


				$records = ClxCommon::$db->getRecords('CLX_DB_QUERY_FIELDS', 'UPPER(QUERYCODE)=' . singleQuote(UPPERCASE($querycode)) . ' ORDER BY SEQNUM ASC');

				while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
					$fieldname = trim($record['FIELDNAME']);
					if (strlen($record['EXPRESSION']) > CLX_NUM_ZERO) {
						$record['EXPRESSION'] = ClxCommon::$db->extrac_dbms_sql($record['EXPRESSION']);
						$expression = '(' . $record['EXPRESSION'] . ') ' . $record['TABLECODE'] . '_' . $record['FIELDNAME']; //Set an alias for it
					}
				//	echo $fieldname;
					preg_match_all('/((min)|(avg)|(sum)|(count)|(max))\s{0,}\('.$fieldname.'\)/i',   $SELECTCLAUSE,$matches,PREG_OFFSET_CAPTURE);
					preg_match_all('/\,\s{0,}[0-9a-zA-Z]\.'.$fieldname.'\s{0,}\,/i', ','.$SELECTCLAUSE.',',$matches2,PREG_OFFSET_CAPTURE);
					if (count($matches[0])==0) {
					//	preg_match_all('/\,'.$fieldname.'\,/i', ','.$GROUPCLAUSE.',',$matches2,PREG_OFFSET_CAPTURE);
					//	pre($matches2);
					}
				}
				ClxCommon::$db->freeResult($records);
				break;
			default:
				break;
		}	
		return $content;
	}	
    function filterFormFill($msg, &$table) {
        if (!array_key_exists('DBQY_idcode', UserRequest::$post))
		  UserRequest::$post['DBQY_idcode'] = '';
        if (!array_key_exists('DBQY_idname', UserRequest::$post))
		  UserRequest::$post['DBQY_idname'] = '';
        if (!array_key_exists('DBQY_modulecode', UserRequest::$post))
		  UserRequest::$post['DBQY_modulecode'] = '';
        $table->addField($msg, dict('GEN_LBL_CODE') . ':', 'DBQY_idcode', UserRequest::$post['DBQY_idcode'], CLX_NUM_16, CLX_NUM_16);
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'DBQY_idname', UserRequest::$post['DBQY_idname'], CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_MODULECODE') . ':', 'DBQY_modulecode', UserRequest::$post['DBQY_modulecode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
        $sel = new htmlSelect('DBQY_accesses');
        $sel->addItem('', '', CLX_NUM_ONE);
        foreach ($this->access_types as $key => $val) {
		  $sel->addItem(dict($val), $key, CLX_NUM_ZERO);
        }
        $table->addCell(dict('GEN_LBL_ACCESS'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($sel->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $sort = new HtmlSelect('DBQY_sort');
        $sort->addItem('', '', true);
        $sort->addItem(dict('GEN_LBL_MODULECODE'), 'modulecode', false);
        $sort->addItem(dict('GEN_LBL_CODE'), 'idcode', false);
        $sort->addItem(dict('GEN_LBL_NAME'), 'idname', false);
        $sort->addItem(dict('GEN_LBL_ACCESS'), 'accesses', false);
        $table->addData(dict('GEN_LBL_ORDERBY') . ':', $sort->source());
    }

    function setfilter() {
        $filter = '';
        $boolean = '';
        if (!empty(UserRequest::$post['DBQY_idcode'])) {
		  $filter .= $boolean . ' UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['DBQY_idcode']) . '%');
		  $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['DBQY_idname'])) {
		  $filter .= $boolean . ' UPPER(IDNAME) LIKE ' . singleQuote( uppercase(UserRequest::$post['DBQY_idname']) . '%');
		  $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['DBQY_modulecode'])) {
		  $filter .= $boolean . ' UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['DBQY_modulecode']) . '%');
		  $boolean = 'AND';
        }
        if (UserRequest::$post['DBQY_accesses'] <> '') {
		  $filter .= $boolean . ' ACCESSES = ' . UserRequest::$post['DBQY_accesses'];
		  $boolean = 'AND';
        }

        $sortby = (array_key_exists('DBQY_sort', UserRequest::$post)) ? UserRequest::$post['DBQY_sort'] : CLX_CHAR_EMPTY_STRING;
        $this->setFilterKeys($filter, $sortby, CLX_NUM_ZERO);
    }
	///////////////////////////////////////////////////
	///comentado 22/01/2019 para utilizar la clx_tool
	//////////////////////////////////////////////////
    /*function clearfilter() {
        $_SESSION['paging']['DBQYList']['criteria'] = '';
    }*/

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        $record = array();
        $record['DBQY_id'] = $recordid;
        $record['DBQY_idcode'] = $values['IDCODE'];
        $record['DBQY_idname'] = $values['IDNAME'];
        $record['DBQY_version'] = $values['VERSION'];
        $record['DBQY_version_counter'] = $values['VERSION_COUNTER'];
        $record['DBQY_cdate'] = xFormat::date($values['CDATE']);
        $record['DBQY_mdate'] = xFormat::date($values['MDATE']);
        $record['DBQY_username'] = $values['USERNAME'];
        $record['DBQY_description'] = $values['DESCRIPTION'];
        $record['DBQY_modulecode'] = $values['MODULECODE'];
        $record['DBQY_accesses'] = $values['ACCESSES'];
		$record['DBQY_distinct_select'] = $values['DISTINCT_SELECT'];
		$record['DBQY_SET_SUBSELECT_AFTER'] =$values['SET_SUBSELECT_AFTER'];
		$record['DBQY_view_type'] = $values['VIEW_TYPE'];
		$record['DBQY_req_efftdate'] = $values['REQ_EFFTDATE'];
        return $record;
    }

    function saveRecord() {
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['IDNAME'] = UserRequest::$post['DBQY_idname'];
        $record['VERSION'] = UserRequest::$post['DBQY_version'];
        $record['MDATE'] = $d;
        $record['USERNAME'] = clx_change_especial_char_html($_SESSION['user_record']['username']);
        $record['DESCRIPTION'] = UserRequest::$post['DBQY_description'];
        $record['MODULECODE'] = UserRequest::$post['DBQY_modulecode'];
        $record['ACCESSES'] = UserRequest::$post['DBQY_accesses'];
		$record['VIEW_TYPE'] = UserRequest::$post['DBQY_view_type'];
		$record['REQ_EFFTDATE']= UserRequest::$post['DBQY_req_efftdate'] ;
//		pre(UserRequest::$post);
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['DBQY_id']);
        $this->versionIncrease('ID', UserRequest::$post['DBQY_id']);
		//pre(UserRequest::$post);echo 'xxx';
		apc_clear_querycode(UserRequest::$post['DBQY_idcode']);
    }

    function createRecord_() {
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['IDCODE'] = UserRequest::$post['DBQY_idcode'];
        $record['IDNAME'] = clx_change_especial_char_html(UserRequest::$post['DBQY_idname']);
        $record['VERSION'] = UserRequest::$post['DBQY_version'];
        $record['VERSION_COUNTER'] = '0';
        $record['CDATE'] = $d;
        $record['MDATE'] = $d;
        $record['USERNAME'] = clx_change_especial_char_html($_SESSION['user_record']['username']);
        $record['DESCRIPTION'] = UserRequest::$post['DBQY_description'];
        $record['MODULECODE'] = UserRequest::$post['DBQY_modulecode'];
        $record['ACCESSES'] = UserRequest::$post['DBQY_accesses'];
		$record['VIEW_TYPE'] = UserRequest::$post['DBQY_view_type'];
		$record['REQ_EFFTDATE'] = UserRequest::$post['DBQY_req_efftdate'];
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $DBMO = &getTool('DBMO');
        $DBMO->versionIncrease('IDCODE', $record['MODULECODE']);
        return $recordid;
    }

    function duplicateRecord() {
        $originalqueryid = UserRequest::$post['DBQY_id'];
        $originalqueryrec = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $originalqueryid);
        $originalquerycode = $originalqueryrec['IDCODE'];
        $queryid = $this->createRecord_();
        $querycode = UserRequest::$post['DBQY_idcode'];
        $records = ClxCommon::$db->getRecords('CLX_DB_QUERY_CRITERIA', 'QUERYCODE=' . singleQuote($originalquerycode));
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
		  unset($record['ID']);
		  $record['QUERYCODE'] = $querycode;
		  ClxCommon::$db->createRecord('CLX_DB_QUERY_CRITERIA', $record, false);
        }
		ClxCommon::$db->freeResult($records);
        $records = ClxCommon::$db->getRecords('CLX_DB_QUERY_TABLES', 'QUERYCODE=' . singleQuote($originalquerycode));
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
		  unset($record['ID']);
		  $record['QUERYCODE'] = $querycode;
		  ClxCommon::$db->createRecord('CLX_DB_QUERY_TABLES', $record, false);
        }
		$records = ClxCommon::$db->getRecords('CLX_DB_QUERY_JOIN_CRITERIA', 'QUERYCODE=' . singleQuote($originalquerycode));
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
		  unset($record['ID']);
		  $record['QUERYCODE'] = $querycode;
		  ClxCommon::$db->createRecord('CLX_DB_QUERY_JOIN_CRITERIA', $record, false);
        }
		ClxCommon::$db->freeResult($records);
		$records = ClxCommon::$db->getRecords('CLX_DB_QUERY_JOIN_TYPE_RELATION', 'QUERYCODE=' . singleQuote($originalquerycode));
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
		  unset($record['ID']);
		  $record['QUERYCODE'] = $querycode;
		  ClxCommon::$db->createRecord('CLX_DB_QUERY_JOIN_TYPE_RELATION', $record, false);
        }
		ClxCommon::$db->freeResult($records);
        $records = ClxCommon::$db->getRecords('CLX_DB_QUERY_FIELDS', 'QUERYCODE=' . singleQuote($originalquerycode));
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
		  unset($record['ID']);
		  $record['QUERYCODE'] = $querycode;
		  ClxCommon::$db->createRecord('CLX_DB_QUERY_FIELDS', $record, false);
        }
		ClxCommon::$db->freeResult($records);
        return $queryid;
    }

    function deleteRecordSk($id) {
        $queryrec = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $id);
        $querycode = $queryrec['IDCODE'];
        ClxCommon::$db->deleteRecords('CLX_DB_QUERY_TABLES', 'UPPER(QUERYCODE)=' . singleQuote(UPPERCASE($querycode)));
        ClxCommon::$db->deleteRecords('CLX_DB_QUERY_CRITERIA', 'UPPER(QUERYCODE)=' . singleQuote(UPPERCASE($querycode)));
		ClxCommon::$db->deleteRecords('CLX_DB_QUERY_FIELDS', 'UPPER(QUERYCODE)=' . singleQuote(UPPERCASE($querycode)));
		ClxCommon::$db->deleteRecords('CLX_DB_QUERY_JOIN_TYPE_RELATION', 'UPPER(QUERYCODE)=' . singleQuote(UPPERCASE($querycode)));
		ClxCommon::$db->deleteRecords('CLX_DB_QUERY_JOIN_CRITERIA', 'UPPER(QUERYCODE)=' . singleQuote(UPPERCASE($querycode)));
        
		
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
        $DBMO = &getTool('DBMO');
        $DBMO->versionIncrease('IDCODE', $queryrec['MODULECODE']);
    }

    function defaultRecord() {
        $record = array();
        $record['DBQY_id'] = CLX_INIT_ZERO;
        $record['DBQY_idcode'] = '';
        $record['DBQY_idname'] = '';
        $record['DBQY_version'] = '1.0.0';
        $record['DBQY_cdate'] = '';
        $record['DBQY_mdate'] = '';
        $record['DBQY_username'] = $_SESSION['user_record']['username'];
        $record['DBQY_description'] = '';
        $record['DBQY_modulecode'] = '';
        $record['DBQY_accesses'] = '0';
		$record['DBQY_view_type'] = '0';
		$record['DBQY_req_efftdate']= '1';
        return $record;
    }

    function versionIncrease($fieldname, $fieldvalue) {
        parent::versionIncrease($fieldname, $fieldvalue);
        $modulecode = ClxCommon::$db->getField($this->tablename, 'MODULECODE', $fieldname . '=' . singleQuote($fieldvalue));
        $DBMO = &getTool('DBMO');
        $DBMO->versionIncrease('IDCODE', $modulecode);
    }

    // DEPRECATED in favor of chooseRecord($name, $default)
    function placeChooseQuery($msg, $prompt, $name, $default, &$table) {
        if (!empty($msg[$name]))
		  $table->addCell($msg[$name], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => $table->width));
        $table->addCell($prompt, array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($this->chooseRecord($name, $default), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        return '';
    }

    // DEPRECATED in favor of recordExists($field_label, &$field_value, $msg)
    function queryExists(&$idcode) {
        $qty = ClxCommon::$db->oneExistsRecords($this->tablename, $this->primary_field . '=' . singleQuote($idcode));
        if ($qty > CLX_NUM_ZERO) {
		  $idcode = ClxCommon::$db->getField($this->tablename, $this->primary_field, $this->primary_field . '=' . singleQuote($idcode));
        }
        return $qty > CLX_NUM_ZERO;
    }

    function hasQuestions($querycode) {
        return ClxCommon::$db->oneExistsRecords('CLX_DB_QUERY_CRITERIA', 'UPPER(QUERYCODE)=' . singleQuote(UPPERCASE($querycode)), 'TYPE=' . singleQuote('u')) > CLX_NUM_ZERO;
    }

    function addQuestions($querycode, $form) {
        if ($this->hasQuestions($querycode)) {
		  $sql = 'SELECT QC.OPERATOR, F.* FROM CLX_DB_FIELDS F, CLX_DB_QUERY_CRITERIA QC WHERE QC.FIELDNAME = F.FIELDNAME AND QC.QUERYCODE =' . singleQuote($querycode) . ' AND QC.TYPE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . '';
		  $field_recs = ClxCommon::$db->executeQuery($sql);
		  $entries = array();
		  while ($field_rec = ClxCommon::$db->getNextRecord($field_recs)) {
			 $entries[] = $this->createFormEntry($field_rec);
		  }
		  ClxCommon::$db->freeResult($fields_recs);
		  $form['panels'][] = array('type' => 'normal',
			 'caption' => 'TOOL_DBQY_PARAMETERS',
			 'entries' => $entries
		  );
        }
        return $form;
    }

    /**
     * Returns Query Questions
     * @param mixed $querycode
     * @return array
     */
    function getQuestions($querycode) {
        if (is_array($querycode)) {
		  $crits = 'QC.QUERYCODE IN (' . singleQuote(implode(singleQuote(CLX_CHAR_EMPTY_STRING), $querycode)) . ')';
        } else {
		  $crits = 'QC.QUERYCODE =' . singleQuote($querycode);
        }
        $entries = array();
        $sql = 'SELECT DISTINCT QC.*, F.* FROM CLX_DB_FIELDS F, CLX_DB_QUERY_CRITERIA QC WHERE QC.FIELDNAME = F.FIELDNAME AND	' . $crits . ' AND	QC.TYPE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . '';
        $field_recs = ClxCommon::$db->executeQuery($sql);
        while ($field_rec = ClxCommon::$db->getNextRecord($field_recs)) {
		  $field_rec['OPERATOR_LBL'] = $this->operators[$field_rec['OPERATOR']];
		  $entries[] = $field_rec;
        }
		ClxCommon::$db->freeResult($field_recs);
        return $entries;
    }

    function loadQuestionsRequestFromParameters($querycode, $parameters) {
        $sql = 'SELECT QC.*, F.* FROM CLX_DB_FIELDS F, CLX_DB_QUERY_CRITERIA QC WHERE QC.FIELDNAME = F.FIELDNAME AND QC.QUERYCODE =' . singleQuote($querycode) . ' AND QC.TYPE = ' . singleQuote('u');
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  if (array_key_exists($r['FIELDNAME'], $parameters)) {
			 UserRequest::$request[$r['TABLECODE'] . '_' . $r['FIELDNAME']] = $parameters[$r['FIELDNAME']];
		  }
        }
		ClxCommon::$db->freeResult($rs);
    }

    /**
     * Returns array containing user record. Additional option my include form
     * code. will check against form.
     * @param string $querycode
     * @param array $record
     * @param string $formcode=''
     * @return array
     */
    function loadAnswersFromRecord($querycode, $record, $formcode = '') {
        $entries = array();
        if ($formcode === '') {
		  $sql = 'SELECT DBTF.TABLECODE, DBTF.FIELDNAME FROM CLX_DB_TABLEFIELDS DBTF, CLX_DB_QUERY_TABLES DBQT WHERE DBQT.TABLECODE = DBTF.TABLECODE AND DBQT.QUERYCODE =' . singleQuote($querycode);
        } else {
		  $sql = 'SELECT DBTF.TABLECODE, DBTF.FIELDNAME FROM CLX_DB_TABLEFIELDS DBTF, CLX_DB_QUERY_TABLES DBQT, CLX_UI_FORMS UIFM, CLX_UI_FORM_PANELS UIFP, CLX_UI_FORM_PANEL_FIELDS UIPF WHERE DBQT.TABLECODE = DBTF.TABLECODE AND UIPF.PANELID = UIFP.IDCODE AND UIFM.IDCODE = UIFP.FORMCODE AND DBTF.FIELDNAME = UIPF.FIELDNAME AND DBTF.TABLECODE IN (UIPF.TABLECODE, UIFM.TABLECODE) AND UIPF.ACTIVE = 1 AND UIFP.ACTIVE = 1 AND DBQT.QUERYCODE =' . singleQuote($querycode) . ' AND UIFM.IDCODE = ' . singleQuote($formcode);
        }
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $formfieldname = $r['TABLECODE'] . '_' . $r['FIELDNAME'];
		  if (array_key_exists($formfieldname, $record)) {
			 if (strlen($record[$formfieldname]) > CLX_NUM_ZERO) {
			     $fieldname = $r['TABLECODE'] . '.' . $r['FIELDNAME'];
			     $entries[$fieldname] = $record[$formfieldname];
			 }
		  }
        }
		ClxCommon::$db->freeResult($rs);
        return $entries;
    }

    /**
     * Returns array containing user record. Additional option my include form without tablecode
     * @param string $querycode
     * @param array $record
     * @param string $formcode=''
     * @return array
     */
    function loadAnswersFromRecordNoTablecode($querycode, $record, $formcode = '') {
        $entries = array();
        if ($formcode === '') {
		  $sql = 'SELECT DBTF.TABLECODE, DBTF.FIELDNAME FROM CLX_DB_TABLEFIELDS DBTF, CLX_DB_QUERY_TABLES DBQT WHERE DBQT.TABLECODE = DBTF.TABLECODE AND DBQT.QUERYCODE =' . singleQuote($querycode);
        } else {
		  $sql = 'SELECT DBTF.TABLECODE, DBTF.FIELDNAME FROM CLX_DB_TABLEFIELDS DBTF, CLX_DB_QUERY_TABLES DBQT, CLX_UI_FORMS UIFM, CLX_UI_FORM_PANELS UIFP, CLX_UI_FORM_PANEL_FIELDS UIPF WHERE DBQT.TABLECODE = DBTF.TABLECODE AND UIPF.PANELID = UIFP.IDCODE AND UIFM.IDCODE = UIFP.FORMCODE AND DBTF.FIELDNAME = UIPF.FIELDNAME AND DBTF.TABLECODE IN (UIPF.TABLECODE, UIFM.TABLECODE) AND UIPF.ACTIVE = 1 AND UIFP.ACTIVE = 1 AND DBQT.QUERYCODE =' . singleQuote($querycode) . ' AND UIFM.IDCODE = ' . singleQuote($formcode);
        }
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $formfieldname = $r['TABLECODE'] . '_' . $r['FIELDNAME'];
		  if (array_key_exists($formfieldname, $record)) {
			 if (strlen($record[$formfieldname]) > CLX_NUM_ZERO) {
			     $fieldname = $r['FIELDNAME'];
			     $entries[$fieldname] = $record[$formfieldname];
			 }
		  }
        }
		ClxCommon::$db->freeResult($rs);
        return $entries;
    }

    /**
     * Query method used in ui_listing that builds sql
     * @param string $tool
     * @param string $querycode
     * @param bool $on_efftdate
     */
	 //  //////     //  ////// nuevos parametros (eran para modulo de RCTA (ivan deprecado) no se usan en otro lado, no activo cache para eso
	 //  //  //     //  //  // extra_alias_name, forceADDID, forceADDquerycode, addextraCriteria
	 //  //  // //  //  //  // pero on_efftdate  no se usa
	 //  ////// /////   //////  
    function getquery($tool, $querycode, $on_efftdate = true,$extra_alias_name='',$forceAddId=false,$forceAddquerycode=false,/*$extrafieldsespecialgroup=array(),*/$addExtraCriteria=array()) {
		$fetched = false;
	//	pre();
		$XName=$_SESSION['user_record']['username'];
		$findVar=kSpaceName.'_querycode_!_'.$querycode.'_!_.XName'.($this->get_efftdate_status()?'_!_1':'_!_2');   //.$tool.($on_efftdate?'1':'0').$extra_alias_name.($forceAddId?'1':'0').($forceAddquerycode?'1':'0').'_'.md5(implode('',$addExtraCriteria));
		//echo "<b>getquery:</b>",$querycode,"<br>";
		
		if (kApcTtl_12>0) $queryrec = apc_fetchFct($findVar, $fetched);
		//$fetched=false;
		if (empty($fetched)) {
			//echo 'recreando query';
		        $operators = array('EQ' => '=',
				  'NQ' => '<>',
				  'LS' => '<',
				  'LQ' => '<=',
				  'GQ' => '>=', 'GT' => '>', 'IN' => 'IN',
				  'NI' => 'NOT IN',
				  'BW' => '?',
				  'SW' => 'LIKE',
				  'EW' => 'LIKE',
				  'CT' => 'LIKE',
					'SN' => 'NOT LIKE',
				  'EN' => 'NOT LIKE',
				  'CN' => 'NOT LIKE',
				  'EX' => '',
				  'IS' => 'IS',
				  'IT' => 'IS NOT'
		        );
		   $recordQuery = ClxCommon::$db->getoneRecord('SELECT * FROM CLX_DB_QUERIES WHERE IDCODE=' . singleQuote(UPPERCASE($querycode)));
		        $queryrec = array('IDCODE', $querycode, 'WHERECLAUSE' => '');
		        /*
				Create a list of tables used in this query (later it will be used to create the from clause, among other things...) */
		        switch (kDatabaseType) {
				  case 'oci':
					 $records = ClxCommon::$db->executeQuery('SELECT t.MODULECODE|| ' . "'_'" . '||t.IDNAME TABLENAME, t.IDCODE TABLECODE FROM CLX_DB_QUERY_TABLES qt, CLX_DB_TABLES t WHERE UPPER(qt.QUERYCODE)=' . singleQuote(UPPERCASE($querycode)) . ' AND t.IDCODE = qt.TABLECODE AND qt.INVISIBLE = 0');
					 break;
				  default:
					 $records = ClxCommon::$db->executeQuery('SELECT CONCAT(t.MODULECODE, CONCAT(' . "'_'" . ' , t.IDNAME)) TABLENAME, t.IDCODE TABLECODE FROM CLX_DB_QUERY_TABLES qt, CLX_DB_TABLES t WHERE UPPER(qt.QUERYCODE)=' . singleQuote(UPPERCASE($querycode)) . ' AND t.IDCODE = qt.TABLECODE AND qt.INVISIBLE = 0');
					 break;
		        }
		        $tables = array();
		        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
				  $tables[$record['TABLECODE']] = $record['TABLENAME'];
		        }
				
				ClxCommon::$db->freeResult($records);
		        /*
				Prepare criterias on query, all criterias will be set under where clause ---------------------------------- */
		        $efftdone = false;
		        $sql = 'SELECT * FROM CLX_DB_QUERY_CRITERIA WHERE QUERYCODE = ' . singleQuote($querycode);
				if (empty($this->efftdate_enabled)) {
				  $sql .= ' AND OPERATOR NOT IN (' . singleQuote('EF') . ' , ' . singleQuote('FQ') . ')';
				  $efftdone = true;
		        }
		        $sql .= 'ORDER BY SEQNUM ASC';
		
				$records = ClxCommon::$db->executeQuery($sql);
		        $nextTablecode = CLX_NUM_65;
		        $lastspecial = CLX_INIT_ZERO;
		        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
						$is_dyna = (ClxCommon::$db->oneExistsRecords('CLX_DB_DYNRELATIONS', 'TABLECODE=' . singleQuote($record['TABLECODE']) . '  AND RELATION_TYPE = 0') > CLX_NUM_ZERO);
				  if ($is_dyna === true) {
					 if ($lastspecial != $record['SPECIAL']) {
					     $nextTablecode++;
					     $lastspecial = $record['SPECIAL'];
					 }
					 $dyn_table_rec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($record['TABLECODE']));
					 if (!array_key_exists($record['TABLECODE'], $tables)) {
					     $tablecode = chr($nextTablecode);
					     $tables[chr($nextTablecode)] = $dyn_table_rec['MODULECODE'] . '_' . $dyn_table_rec['IDNAME'];
					 } else {
					     $tablecode = $record['TABLECODE'];
					 }
				  } else {
					 $tablecode = $record['TABLECODE'];
				  }
				  //skeep if not enabled effective date
				  if ($record['OPERATOR'] === 'EF' && !$this->efftdate_enabled) {
					 $record['LOGICAL'] = '';
				  }
				  $comparison_expression = '';
				  switch ($record['OPERATOR']) {
					 // EF => GEN_EFFDATE_LESSEQUAL
					 case 'EF':
					     //override default efftdate
					     if ($this->efftdate_enabled) {
					         $comparison_expression .= ' ' . $this->getQueryEffectiveDate($querycode, $record);
					     }
					     $efftdone = true;
					     break;
					 // FQ => GEN_EFFDATE_EQUAL
					 case 'FQ':
					     //do efftdate equal
					     $val_to_compare = $this->getQueryCriteriaValue($tool, $record);
					     if ($this->include_empty_answers === true || ($this->include_empty_answers == false && strlen(trim($val_to_compare)) > CLX_NUM_ZERO)) {
					         if ($this->efftdate_enabled) {
							   $comparison_expression .= ' ' . $tablecode . '.' . $record['FIELDNAME'] . ' = ' . $val_to_compare;
					         }
					         $efftdone = true;
					     }
					     break;
					 // BW => GEN_OPE_BETWEEN
					 case 'BW':
		
					     $val_to_compare = $this->getQueryCriteriaBetween($tablecode . '.' . $record['FIELDNAME'], $tool, $record);
					     if ($this->include_empty_answers === true || ($this->include_empty_answers == false && strlen(trim($val_to_compare)) > CLX_NUM_ZERO)) {
					         $comparison_expression .= ' ' . $val_to_compare;
					     }
					     break;
					 // EX => GEN_OPE_EXPRESSIONS
					 case 'EX':
		
					     $val_to_compare = $this->getQueryCriteriaValue($tool, $record);
					     if ($this->include_empty_answers === true || ($this->include_empty_answers == false && strlen(trim($val_to_compare)) > CLX_NUM_ZERO)) {
					         $comparison_expression .= ' ' . $val_to_compare;
					     }
					     break;
					 // EQ => GEN_OPE_EQUAL
					 // NQ => GEN_OPE_NOTEQUAL
					 // LS => GEN_OPE_LESS
					 // LQ => GEN_OPE_LESS_EQUAL
					 // GQ => GEN_OPE_GREATER_EQUAL
					 // GT => GEN_OPE_GREATER
					 // IN => GEN_OPE_IN
					 // NI => GEN_OPE_NOTIN
					 // SW => GEN_OPE_STARTS_WITH
					 // EW => GEN_OPE_ENDS_WITH
					 // CT => GEN_OPE_CONTAINS
					 // IS => GEN_OPE_IS
					 // IT => GEN_OPE_ISNOT
					 default:
					     $val_to_compare = $this->getQueryCriteriaValue($tool, $record);
					     if ($this->include_empty_answers === true || ($this->include_empty_answers == false && strlen(trim($val_to_compare)) > CLX_NUM_ZERO)) {
					         $comparison_expression .= ' ' . $tablecode . '.' . $record['FIELDNAME'] . ' ' . $operators[$record['OPERATOR']] . ' ' . $val_to_compare;
					     }
					     break;
				  }
					if ($comparison_expression !== '') {
					 $val_to_compare = (strlen($queryrec['WHERECLAUSE']) == CLX_NUM_ZERO) ? $record['OPEN_BRACKETS'] : ' ' . $record['LOGICAL'] . ' ' . $record['OPEN_BRACKETS'];
					 $val_to_compare .= $comparison_expression;
					 $val_to_compare .= $record['CLOSE_BRACKETS'];
					 $queryrec['WHERECLAUSE'] .= $val_to_compare;
				  }
		        }//End while
				ClxCommon::$db->freeResult($records);
				/*
				The following block takes care of the effective dated issue if not set as a criteria.
				by default when clxefftdate is found and not disabled in listing it adds clxefftdate to crits. if an criteria is provided then it show the criteria instead
		         *///pre($queryrec['WHERECLAUSE']);
					 
				  if (empty($efftdone) && !empty($this->efftdate_enabled)  && isset($recordQuery['REQ_EFFTDATE']) && $recordQuery['REQ_EFFTDATE']==1) {//donot include efftdate
				  $efftdate = $this->getQueryEffectiveDate($querycode);
				  if (strlen($efftdate) > CLX_NUM_ZERO) {
					 if (strlen($queryrec['WHERECLAUSE']) == CLX_NUM_ZERO) {
					     $queryrec['WHERECLAUSE'] = $efftdate;
					 } else {
					     $queryrec['WHERECLAUSE'] .= ' AND ' . $efftdate;
					 }
				  }
		        }
		//////////////////////////////////////
				
		        $sql = 'SELECT * FROM CLX_DB_QUERY_JOIN_CRITERIA WHERE QUERYCODE = ' . singleQuote($querycode);
		        $queryrec['JOIN_CLAUSE']='';
				if (empty($this->efftdate_enabled)) {
				  $sql .= ' AND OPERATOR NOT IN (' . singleQuote('EF') . ' , ' . singleQuote('FQ') . ')';
				  $efftdone = true;
		        }
		        $sql .= 'ORDER BY SEQNUM ASC';
		
				$records = ClxCommon::$db->executeQuery($sql);
		        $nextTablecode = CLX_NUM_65;
		        $lastspecial = CLX_INIT_ZERO;
				$joinTable=array();
				$orderJoin=array();
		
		        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
						$is_dyna = (ClxCommon::$db->oneExistsRecords('CLX_DB_DYNRELATIONS', 'TABLECODE=' . singleQuote($record['TABLECODE']) . '  AND RELATION_TYPE = 0') > CLX_NUM_ZERO);
				  if ($is_dyna === true) {
					 
					 $dyn_table_rec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($record['TABLECODE']));
					 if (!array_key_exists($record['TABLECODE'], $tables)) {
					     $tablecode = chr($nextTablecode);
					     $tables[chr($nextTablecode)] = $dyn_table_rec['MODULECODE'] . '_' . $dyn_table_rec['IDNAME'];
					 } else {
					     $tablecode = $record['TABLECODE'];
					 }
				  } else {
					 $tablecode = $record['TABLECODE'];
				  }
				  //skeep if not enabled effective date
				  if ($record['OPERATOR'] === 'EF' && !$this->efftdate_enabled) {
					 $record['LOGICAL'] = '';
				  }
				  $val_to_compare = $this->getQueryCriteriaValue($tool, $record);
					//pre($record);
					if ($this->include_empty_answers === true || ($this->include_empty_answers == false && strlen(trim($val_to_compare)) > CLX_NUM_ZERO)) {
						
						$cut=explode('.',$val_to_compare);
						$orderJ='!!!'.implode('!!!',$orderJoin);
						$pos1=strpos('!'.trim($record['TABLECODE']).'!',$orderJ);
						$pos2=strpos('!'.trim($cut[0]).'!',$orderJ);
						
						
						$tablasofjoin='';
						if ($pos1<=$pos2 ) {
							if (!in_array(trim($record['TABLECODE']),$orderJoin)) {
								$orderJoin[]=trim($record['TABLECODE']);
							}	
							if ($pos2==0) {
								if (!empty($cut[0]) and !empty($record['TABLECODE']))
									$tablasofjoin=$record['TABLECODE'].'____'.$cut[0];
								else
									$tablasofjoin='';
								if (!in_array(trim($cut[0]),$orderJoin)) {
									$orderJoin[]=trim($cut[0]);
								}	
							}
							else {
								if (!empty($cut[0]) and !empty($record['TABLECODE']))
									$tablasofjoin=$record['TABLECODE'].'____'.$cut[0];
								else
									$tablasofjoin='';
							}
						}	
						else {
							if (!empty($cut[0]) and !empty($record['TABLECODE']))
								$tablasofjoin=$record['TABLECODE'].'____'.$cut[0];
							else	
								$tablasofjoin='';
							if (!in_array(trim($cut[0]),$orderJoin)) {
								$orderJoin[]=trim($cut[0]);
							}
						}
						if (isset($joinTable[$tablasofjoin])) 
							$joinTable[$tablasofjoin].=' AND '. $tablecode . '.' . $record['FIELDNAME'] . ' ' . $operators[$record['OPERATOR']] . ' ' . $val_to_compare;
						else
							$joinTable[$tablasofjoin] =        $tablecode . '.' . $record['FIELDNAME'] . ' ' . $operators[$record['OPERATOR']] . ' ' . $val_to_compare;
						
					}
		
				  
		        }
				
				//End while
				
		
		
		        /*
				The following block takes care of the access tree to enable security at query level---------------------- 
				  
				  */
		
				if (isset($_SESSION['user_record']['isadmin']) && $_SESSION['user_record']['isadmin'] !== '1') {
				//		print_r($_SESSION['user_record']['isadmin']);
						IF (ClxCommon::$db->oneExistsRecords('CLX_AC_GROUP_MEMBERS','GROUPCODE='.singlequote('ACCESS_TREE').'  AND USERNAME='.singlequote($XName))) {
						  $sql = 'FROM CLX_DB_QUERY_TABLES qt, CLX_DB_TABLES t, CLX_DB_TABLEFIELDS tb, CLX_DB_FIELDS f WHERE qt.QUERYCODE =' . singleQuote($querycode) . ' AND t.IDCODE = tb.TABLECODE AND qt.TABLECODE = tb.TABLECODE AND tb.FIELDNAME = f.FIELDNAME AND f.FIELDTYPE = ' . singleQuote('TLOK') . '';
						  $qtyinfo = ClxCommon::$db->executeQuery('SELECT COUNT(*) ' . $sql);
						  $value = ClxCommon::$db->getNextRecord($qtyinfo, NUMERIC);
						
							if ($value[CLX_NUM_ZERO] > CLX_NUM_ZERO) {
							 $ACTR = &getTool('ACTR');
							 switch (kDatabaseType) {
							     case 'oci':
												$fields = ClxCommon::$db->executeQuery('SELECT t.MODULECODE||' . singleQuote(CLX_CHAR_EMPTY_STRING) . '||t.IDNAME TABLENAME,t.IDCODE TABLECODE, f.* ' . $sql);
									    break;
							     default:
							         $fields = ClxCommon::$db->executeQuery('SELECT CONCAT(t.MODULECODE, CONCAT(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', t.IDNAME)) TABLENAME, t.IDCODE TABLECODE, f.* ' . $sql);
							         break;
							 }// End switch
							 $criteria = '';
							 $boolean = '';
							 $tree_criteria = array();
							 $noaccess = false;
							 while (($fieldrec = ClxCommon::$db->getNextRecord($fields)) && !$noaccess) {
								    $treecode = $fieldrec['FIELD_EXTRA1'];
							     $nodes = $ACTR->getUserNodes($treecode);
							     if (count($nodes) == CLX_NUM_ZERO) {
							         $criteria = '1=0';
							         $boolean = ' AND ';
							         $noaccess = true;
							     } else {
							         foreach ($nodes as $node) {
									   $tree_criteria[] = $fieldrec['TABLECODE'] . '.' . $fieldrec['FIELDNAME'] . ' LIKE ' . singleQuote($node . '%');
							         }
							     }
							     if (count($tree_criteria) > CLX_NUM_ZERO) {
							         $criteria .= $boolean . ' (' . implode(' OR ', $tree_criteria) . ') ';
							         $boolean = ' AND ';
							         $tree_criteria = array();
							     }
							 }
							 ClxCommon::$db->freeResult($fields);
							 //e cho $criteria.'<br>';
							 if (strlen($criteria) > CLX_NUM_ZERO)
							     $criteria = $criteria;
							 if (strlen($queryrec['WHERECLAUSE']) == CLX_NUM_ZERO) {
							     $queryrec['WHERECLAUSE'] = $criteria;
							 } else {
							     $queryrec['WHERECLAUSE'] = '(' . $criteria . ') AND (' . $queryrec['WHERECLAUSE'] . ')';
							 }
						  }
				        }//end if
				        //Addinf user field security
				        $ACFS = &getTool('ACFS');
				        $acfs_crit = $ACFS->get_query_criteria($querycode);
				        if (strlen($acfs_crit) > CLX_NUM_ZERO) {
						  if (strlen($queryrec['WHERECLAUSE']) == CLX_NUM_ZERO) {
							 $queryrec['WHERECLAUSE'] = $acfs_crit;
						  } else {
							 $queryrec['WHERECLAUSE'] .= ' AND ' . $acfs_crit;
						  }
				        }
					}
			        unset($acfs_crit);
		
		        /*
				End access tree's security The following creates the from clause... */
				  
				 
				  
				
				
				$queryrec['JOIN_TABLE']='';   
		        $queryrec['FROMCLAUSE'] = '';
		        $comma = '';
		        reset($tables);
				
				$typeRelation=array(0=>' LEFT JOIN ',1=>' RIGHT JOIN ',2=>' INNER JOIN ',3=>' FULL JOIN ');
				$relationsJoin =array();
				$sql='SELECT JOIN_TABLE1, TYPE_JOIN,JOIN_TABLE2 FROM CLX_DB_QUERY_JOIN_TYPE_RELATION QR WHERE UPPER(QR.QUERYCODE)=' . singleQuote(UPPERCASE($querycode)) .' order by SEQNUM';
				$rs = ClxCommon::$db->executeQuery($sql);
			
				while ($record = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
					 $relationsJoin[$record['JOIN_TABLE1'].'____'.$record['JOIN_TABLE2']]=$record['TYPE_JOIN'];
				}
				ClxCommon::$db->freeResult($rs);
				for ($t=0;$t<count($orderJoin);$t++)  {
					for ($r=0;$r<$t;$r++) {
						if	(isset($relationsJoin[$orderJoin[$t].'____'.$orderJoin[$r]]) ) {
						
							$queryrec['JOIN_TABLE'].=chr(13).chr(10).$typeRelation[$relationsJoin[$orderJoin[$t].'____'.$orderJoin[$r]]];	
			
						}
						else if	(isset($relationsJoin[$orderJoin[$r].'____'.$orderJoin[$t]]) ) {
							$queryrec['JOIN_TABLE'].=chr(13).chr(10).$typeRelation[$relationsJoin[$orderJoin[$r].'____'.$orderJoin[$t]]];	
			
						}	
							
					}	
					$tablename=$tables[$orderJoin[$t]];
					
					$queryrec['JOIN_TABLE'].= $tablename.' '.$orderJoin[$t];
					
					IF ($t>0) {
						$yes=false;
						for ($t2=0;$t2<$t;$t2++) {
							if (isset($joinTable[$orderJoin[$t].'____'.$orderJoin[$t2]])) {
								if ($yes)
									$queryrec['JOIN_TABLE'].=' AND ';
								else
									$queryrec['JOIN_TABLE'].=' ON ';	
								$queryrec['JOIN_TABLE'].=$joinTable[$orderJoin[$t].'____'.$orderJoin[$t2]].' ';
								$yes=true;
								
							}
							if (isset($joinTable[$orderJoin[$t2].'____'.$orderJoin[$t]])) {
								if ($yes)
									$queryrec['JOIN_TABLE'].=' AND ';
								else
									$queryrec['JOIN_TABLE'].=' ON ';	
								$queryrec['JOIN_TABLE'].=$joinTable[$orderJoin[$t2].'____'.$orderJoin[$t]].' ';
								$yes=true;
								
							}
						/*	else {
								$queryrec['JOIN_TABLE'].=" ON ".$joinTable[$orderJoin[$t].'____'.$orderJoin[$t2]].' ';
							}*/
							
						}
					}
						
				}
		
				$queryrec['FROMCLAUSE'].=$queryrec['JOIN_TABLE'];
				if (count($orderJoin)>0)
					$comma = ', ';
			    foreach ($tables as $tablecode => $tablename) {
				if (!in_array($tablecode,$orderJoin)) {
					$tbcde=$tablecode;
					if (kDatabaseType!='OCI' &&in_array($tbcde,array('LEAD')) )
						$tbcde='`'.$tbcde.'`';
						
					$queryrec['FROMCLAUSE'] .= $comma . ' ' . $tablename . ' ' . $tbcde;
				}
					$comma = ', ';
		        }
		        /*
				The following creates the selects(Fields) and order by(sort fields) clauses */
		        $DBFL = &getTool('DBFL');
		        $queryrec['SELECTCLAUSE'] = '';
				$queryrec['SELECTCLAUSE_FIELDS']=array();
		        $sel_comma = '';
		        $queryrec['ORDERCLAUSE'] = '';
		        $ord_comma = '';
		        $queryrec['GROUPCLAUSE'] = '';
		        $grp_comma = '';
		        if (empty($queryrec['SORTCLAUSE']))
				  $queryrec['SORTCLAUSE'] = '';
		        $queryrec['COLUMNS'] = array();
		        $sorts = array('', 'ASC', 'DESC');
		        $fieldinstancestore = array();
		        $records = ClxCommon::$db->getRecords('CLX_DB_QUERY_FIELDS', 'UPPER(QUERYCODE)=' . singleQuote(UPPERCASE($querycode)) . ' ORDER BY SEQNUM ASC');
		
		        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
				  $record['FIELDNAME'] = trim($record['FIELDNAME']);
				  if (substr($record['FIELDNAME'], strlen($record['FIELDNAME']) - CLX_NUM_FOUR, CLX_NUM_FOUR) === '_WRK') {
					$fieldrec = $DBFL->getField(substr($record['FIELDNAME'], CLX_NUM_ZERO, CLX_NUM_MINUS_1 * CLX_NUM_FOUR));
					 if(empty($fieldrec)){
					     $BUGS = &getTool('BUGS');
					     if (!empty($BUGS)) {
					         $BUGS->report(E_USER_WARNING, 'Missing field:  ' . substr($record['FIELDNAME'], CLX_NUM_ZERO, CLX_NUM_MINUS_1 * CLX_NUM_FOUR), 'tools/db_queries.php', '893', UserRequest::$request, CLX_NUM_ZERO, '');
					     }
					     continue;
					 }
					 $fieldrec['TABLECODE'] = $record['TABLECODE'];
					 $fieldrec['WORKFIELD'] = true;
					 $fieldrec['WORKFIELD_NAME'] = substr($record['FIELDNAME'], CLX_NUM_ZERO, CLX_NUM_MINUS_1 * CLX_NUM_FOUR);
				  } else {
					 $fieldrec = $DBFL->getField($record['FIELDNAME']);
					 if(empty($fieldrec)){
					     $BUGS = &getTool('BUGS');
					     if (!empty($BUGS)) {
					         $BUGS->report(E_USER_WARNING, 'Missing field:  ' . $record['FIELDNAME'], 'tools/db_queries.php', '893', UserRequest::$request, CLX_NUM_ZERO, '');
					     }
					     continue;
					 }
					 $fieldrec['TABLECODE'] = $record['TABLECODE'];
					 $fieldrec['WORKFIELD'] = false;
					 $fieldrec['WORKFIELD_NAME'] = '';
				  }

				  $fieldrec['FIELDPREFIX_VAL'] = dict($fieldrec['FIELDPREFIX']);
				  $fieldrec['FIELDSUFIX_VAL'] = dict($fieldrec['FIELDSUFIX']);
				  $fieldrec['DBQF_CURRENCY_FIELD_TBL'] = $record['CURRENCY_FIELD_TBL'];
				  $fieldrec['DBQF_CURRENCY_FIELD'] = $record['CURRENCY_FIELD'];
				  $fieldrec['DBQF_CURRENCY_FIELD_INFO'] = array();
				  if ($fieldrec['DBQF_CURRENCY_FIELD'] <> '') {
					 $fieldrec['DBQF_CURRENCY_FIELD_INFO'] = $DBFL->getField($fieldrec['DBQF_CURRENCY_FIELD']);
				  }
		
				  $fieldrec['DBQF_FIELD_FORMAT'] = $record['FIELD_FORMAT'];
					
				  if (empty($fieldrec['FIELDTYPE']))
					 continue;
					$fieldinstance = getToolObject('DBFT', $fieldrec['FIELDTYPE']);
					$existe_fields=array();
				  if (intval($record['VISIBLE']) === CLX_NUM_ONE) {
					 $expression = '';
					 if (strlen($record['EXPRESSION']) > CLX_NUM_ZERO) {
					     $record['EXPRESSION'] = ClxCommon::$db->extrac_dbms_sql($record['EXPRESSION']);
					     $expression = '(' . $record['EXPRESSION'] . ') ' . $record['TABLECODE'] . '_' . $record['FIELDNAME']; //Set an alias for it
					 }
					 $fieldrec['EXPRESSION'] = $expression;
					 $fieldrec['EXPRESSION_ONLY'] = $record['EXPRESSION'];
					 $queryrec['COLUMNS'][$record['TABLECODE'] . '_' . $record['FIELDNAME']] = $fieldrec;
					 $queryrec['SELECTCLAUSE'] .= $sel_comma;
					 if ($extra_alias_name=='') { //cambio hecho para join de querys distinguir campos repetidos
							$queryrec['SELECTCLAUSE'] .= $valuex=$fieldinstance->queryFieldColumn($record['FIELDNAME'], $record['TABLECODE'], $expression);
							$queryrec['SELECTCLAUSE_FIELDS'][]=$valuex;
						}	
						else {	
							$thefield=explode($record['TABLECODE'].'_',$fieldinstance->queryFieldColumn($record['FIELDNAME'], $record['TABLECODE'], $expression));
							$thefield[count($thefield)-2].=$extra_alias_name.'_'.$record['TABLECODE'].'_'.$thefield[count($thefield)-1];
							unset($thefield[count($thefield)-1]);
							$queryrec['SELECTCLAUSE'] .=$valuex=implode($record['TABLECODE'],$thefield);
							$queryrec['SELECTCLAUSE_FIELDS'][]=$valuex;
						}
						$sel_comma = ',';
						
				  }
				  if (intval($record['SORT']) !== CLX_NUM_ZERO) {
					 $queryrec['SORTCLAUSE'] .= $ord_comma;
					 $queryrec['SORTCLAUSE'] .= $fieldinstance->queryFieldSorts($record['FIELDNAME'], $record['TABLECODE'], $sorts[$record['SORT']], $fieldrec['WORKFIELD']);
					 $ord_comma = ',';
				  }
				  if (intval($record['GROUPED']) !== CLX_NUM_ZERO) {
					 $queryrec['GROUPCLAUSE'] .= $grp_comma;
					 
					 $queryrec['GROUPCLAUSE'] .= $fieldinstance->queryFieldGroups($record['FIELDNAME'], $record['TABLECODE'], $fieldrec['WORKFIELD']);
						
					 $grp_comma = ',';
				  }
			    }
				if (!empty($addExtraCriteria)) {
					foreach ($tables as $tablecode => $tablename) {
						$textcriteria='';
						foreach ($addExtraCriteria as $key=>$criteriapar) {
							switch ($key) {
								case 'TEXT_EXTRASELECT' :
									$textcriteria=$criteriapar; 
									break;
								case 'PARAMETERS':
									for ($t=0;$t<count($criteriapar);$t++) {
										switch ($criteriapar[$t][1]) {	
											case 'TEXT' :
												$textcriteria=str_replace('(%'.($t+1).'%)',singleQuote($criteriapar[$t][0]),$textcriteria);	
												break;
											case 'TABLECODE' :
												$textcriteria=str_replace('(%'.($t+1).'%)',singleQuote($tablecode),$textcriteria);	
												break;
											case 'FIELDTABLEVALUE' :
												$textcriteria=str_replace('(%'.($t+1).'%)',$tablecode.'.ID ',$textcriteria);
												break;
										}		
								
									}
									break;
							}
						}//echo $textcriteria."<br><br>";
						$queryrec['WHERECLAUSE'] .=(empty($queryrec['WHERECLAUSE'])?'':' AND ').$textcriteria;
					}
				}

				if ($forceAddId) {
					if (empty($queryrec['GROUPCLAUSE']) ){
						foreach ($tables as $tablecode => $tablename) {
						
							if (strpos(" ".$queryrec['SELECTCLAUSE'], $tablecode.'____ID')>0){}
							else {
								$queryrec['SELECTCLAUSE']= $tablecode.'.ID '. (empty($extra_alias_name)?'':$extra_alias_name.'____').$tablecode.'____ID'. (!empty($queryrec['SELECTCLAUSE'])?',':''). $queryrec['SELECTCLAUSE'];
								$queryrec['SELECTCLAUSE']= singlequote($tablecode).' '. (empty($extra_alias_name)?'':$extra_alias_name.'____').$tablecode.'____TABLECODE' .(!empty($queryrec['SELECTCLAUSE'])?',':''). $queryrec['SELECTCLAUSE'];
		
							}
						}
					}
					else {
						foreach ($tables as $tablecode => $tablename) {
							if (strpos(" ".$queryrec['SELECTCLAUSE'], $tablecode.'____ID')>0){}
							else {
								
								switch (kDatabaseType) {
									case 'oci': // Oracle
										$queryrec['SELECTCLAUSE']= 'LISTAGG('.$tablecode.'.ID,'.singleQuote(',').') ' . (empty($extra_alias_name)?'':$extra_alias_name.'____').$tablecode.'____ID'. (!empty($queryrec['SELECTCLAUSE'])?',':''). $queryrec['SELECTCLAUSE'];	
										break;
									default:
										$queryrec['SELECTCLAUSE']= 'GROUP_CONCAT('.$tablecode.'.ID )'. (empty($extra_alias_name)?'':$extra_alias_name.'____').$tablecode.'____ID'. (!empty($queryrec['SELECTCLAUSE'])?',':''). $queryrec['SELECTCLAUSE'];	
										break;
								
								}
							}
						}	
					}		
				}
				if ($forceAddquerycode) {
					foreach ($tables as $tablecode => $tablename) {
						if (strpos(" ".$queryrec['SELECTCLAUSE'], $tablecode.'____querycode')>0){}
						else {
						
							$queryrec['SELECTCLAUSE']= singlequote($querycode). ' '.(empty($extra_alias_name)?'':$extra_alias_name.'____').$tablecode.'____querycode'. (!empty($queryrec['SELECTCLAUSE'])?',':''). $queryrec['SELECTCLAUSE'];
						}
						
					}
		        }
		        $this->buildFromWhereSort($queryrec);
				//pre($queryrec);
			//echo $find,"<br>";
			if (kApcTtl_12>0) apc_addFct($findVar, $queryrec, kApcTtl_12);
		}
		if ($_SERVER['REMOTE_ADDR']=='186.91.0.52') {
			//pre($queryrec);
		}	
		
		
		return $queryrec;
    }
	
    // EFFTDATE METHODS
    /**
     * Set effective date status
     * @param boolean $status
     */
    function set_efftdate_status($status) {
        $this->efftdate_enabled = $status;
    }

    /**
     * Returns efftdate status
     * @return boolean
     */
    function get_efftdate_status() {
        return $this->efftdate_enabled;
    }

    function has_efftdate($querycode, $tablecode = '') {
        $sql = 'SELECT COUNT(DBTB.IDCODE) COUNTER FROM CLX_DB_QUERY_TABLES DBQT, CLX_DB_TABLES DBTB, CLX_DB_TABLEFIELDS DBTF, CLX_DB_FIELDS DBFT WHERE DBQT.QUERYCODE =' . singleQuote($querycode) . ' AND DBTB.IDCODE = DBTF.TABLECODE AND DBQT.TABLECODE = DBTF.TABLECODE AND DBTF.FIELDNAME = DBFT.FIELDNAME AND DBFT.FIELDNAME = ' . singleQuote('CLX_EFFTDATE') . '';
        if ($tablecode <> '')
		  $sql .='AND DBTF.TABLECODE = ' . singleQuote($tablecode) . ' ';
        $result = ClxCommon::$db->getOne($sql);
        return ($result <> CLX_NUM_ZERO) ? true : false;
    }

    function efftdate_key($querycode) {
        $return = '';
        $sql = 'SELECT DISTINCT DBTI.TABLECODE, DBTC.FIELDNAME, DBTC.SEQNUM FROM CLX_DB_QUERY_TABLES DBQT, CLX_DB_TABLES DBTB, CLX_DB_TABLEFIELDS DBTF, CLX_DB_TABLEINDEXES DBTI, CLX_DB_INDEX_COLUMNS DBTC WHERE DBTI.TABLECODE = DBTB.IDCODE AND DBTC.INDEX_CODE = DBTI.IDCODE AND DBTB.IDCODE = DBTF.TABLECODE AND DBQT.TABLECODE = DBTF.TABLECODE AND DBTI.TYPE = ' . singleQuote('UNI') . ' AND DBQT.QUERYCODE =' . singleQuote($querycode) . ' AND DBTF.FIELDNAME = ' . singleQuote('CLX_EFFTDATE') . ' AND DBTC.FIELDNAME NOT IN (' . singleQuoteArray(array('CLX_EFFTDATE', 'SEQNUM')) . ') ORDER BY DBTC.SEQNUM ASC';
        $rs = ClxCommon::$db->executeQuery($sql);
        $comma = '';
        while ($key = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $return .= $comma . ' ' . $key['TABLECODE'] . '.' . $key['FIELDNAME'] . '= ' . "'" . '<' . $key['TABLECODE'] . '_' . $key['FIELDNAME'] . ">'";
		  $comma = ' AND ';
        }
		ClxCommon::$db->freeResult($rs);
        return $return;
    }

    function getQueryEffectiveDate($querycode, $efftdate_crits = array()) {
        $criteria = '';
        if (count($efftdate_crits) > CLX_NUM_ZERO) {
		  $now = 'X.' . $efftdate_crits['FIELDNAME'] . '<=' . $this->getQueryCriteriaValue('EDIT', $efftdate_crits);
        } else {
		  if ($this->parent_clx_efftdate <> '') {
			 $now = 'X.CLX_EFFTDATE <= ' . singleQuote($this->parent_clx_efftdate);
		  } else {
			 //$now = 'X.CLX_EFFTDATE <= ' . singleQuote(getNow('Y-m-d'));
				switch (kDatabaseType) {
				 case 'oci':
						$now = 'X.CLX_EFFTDATE <= CURRENT_DATE';
						break;
	      		 default:
						$now = 'X.CLX_EFFTDATE <= NOW()';
				}		
		  }
        }
        //Test if clx_efftdate exists on any of the tables
        $sql = 'SELECT  DISTINCT DBTB.IDCODE IDCODE, DBTB.MODULECODE, DBTB.IDNAME FROM CLX_DB_QUERY_TABLES DBQT, CLX_DB_TABLES DBTB, CLX_DB_TABLEFIELDS DBTF, CLX_DB_FIELDS DBFT WHERE DBTB.IDCODE = DBTF.TABLECODE AND DBQT.TABLECODE = DBTF.TABLECODE AND DBTF.FIELDNAME = DBFT.FIELDNAME AND DBQT.QUERYCODE =' . singleQuote($querycode) . ' AND DBFT.FIELDNAME = ' . singleQuote('CLX_EFFTDATE');
        $and = '';
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
		  //Search Keys
		  $findex = array();
		  $sql = 'SELECT DBTI.TABLECODE, DBTC.FIELDNAME FROM CLX_DB_TABLEINDEXES DBTI, CLX_DB_INDEX_COLUMNS DBTC WHERE DBTC.INDEX_CODE = DBTI.IDCODE AND DBTI.TYPE IN (' . singleQuoteArray(array('COM', 'UNI')) . ') AND DBTI.TABLECODE =' . singleQuote($result['IDCODE']) . ' AND DBTC.FIELDNAME <> ' . singleQuote('CLX_EFFTDATE');
		  $keys = ClxCommon::$db->executeQuery($sql);
		  while ($key = ClxCommon::$db->getNextRecord($keys)) {
			 switch (kDatabaseType) {
			     case 'oci':
			         $findex[] = '(X.' . $key['FIELDNAME'] . '=' . $result['IDCODE'] . '.' . $key['FIELDNAME'].' OR (X.' . $key['FIELDNAME'] . ' IS NULL AND ' . $result['IDCODE'] . '.' . $key['FIELDNAME'].' IS NULL))';
			         break;
			     default:
			         $findex[] = 'X.' . $key['FIELDNAME'] . '=' . $result['IDCODE'] . '.' . $key['FIELDNAME'];
			         break;
			 }
		  }
		  ClxCommon::$db->freeResult($keys);
		  if (!empty($findex)) {
			 $t = implode(' AND ', $findex);
		  } else {
			 $t = '';
		  }
		  if (strlen($t) > CLX_NUM_ZERO)
			 $t = $t . ' AND ';
		  $criteria .= $and . ' ' . $result['IDCODE'] . '.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE FROM ' . $result['MODULECODE'] . '_' . $result['IDNAME'] . ' X WHERE  ' . $t . ' ' . $now . ')';
		  $and = ' AND ';
		  $t = '';
        }
		ClxCommon::$db->freeResult($results);
        return $criteria;
    }

    // END EFFTDATE METHODS
    function getQueryCriteriaBetween($fieldname, $tool, $criteria_rec) {
        $value = (array_key_exists($tool . '_' . $this->code . '_' . $criteria_rec['FIELDNAME'], UserRequest::$request)) ? UserRequest::$request[$tool . '_' . $this->code . '_' . $criteria_rec['FIELDNAME']] : '';
        $conector = 'AND';
        $pos = strpos(lowercase($value), $conector);
        if ($pos === false) {
		  $conector = ',';
		  $pos = strpos(lowercase($value), $conector);
        }
        if ($pos === false) {
		  $lower = $value;
		  $upper = '';
        } else {
		  $lower = trim(substr($value, CLX_NUM_ZERO, $pos));
		  $upper = trim(substr($value, $pos + strlen($conector)));
        }
        $hastime = (strpos(lowercase($value), ':') === false) ? false : true;
        $lower_date = adodb_strtotime(trim($lower));
        if ($lower_date != -CLX_NUM_ONE)
		  $lower = adodb_date(($hastime) ? 'Y-m-d H:m:s' : 'Y-m-d', $lower_date);
        $upper_date = adodb_strtotime(trim($upper));
        if ($upper_date != -CLX_NUM_ONE)
		  $upper = adodb_date(($hastime) ? 'Y-m-d H:m:s' : 'Y-m-d', $upper_date);
        if (strlen(trim($upper)) === CLX_NUM_ZERO)
		  $upper = $lower;
        $lower = (is_numeric($lower)) ? $lower : singlequote($lower);
        $upper = (is_numeric($upper)) ? $upper : singlequote($upper);
        return '(' . $fieldname . '>=' . $lower . ' AND ' . $fieldname . '<=' . $upper . ')';
    }

    function getQueryCriteriaValue($tool, $criteria_rec) {
        $value = '';
        $criteria_rec['VALUE'] = ClxCommon::$db->extrac_dbms_sql($criteria_rec['VALUE']);
        switch ($criteria_rec['TYPE']) {
		  case 'f':
			 $value = $criteria_rec['VALUE'];
			 break;
		  case 'k':
			 $value = $criteria_rec['VALUE'];
			 $value = $this->formatCriteriaValue($criteria_rec['OPERATOR'], $value);
			 break;
		  case 'u':
			 $c = $criteria_rec['TABLECODE'] . '_' . $criteria_rec['FIELDNAME'];
			 $value = (array_key_exists($c, UserRequest::$request)) ? UserRequest::$request[$c] : '';
			 if ($this->include_empty_answers === true || ($this->include_empty_answers == false && strlen(trim($value)) > CLX_NUM_ZERO)) {
			     $value = $this->formatCriteriaValue($criteria_rec['OPERATOR'], $value);
			 }
			 break;
		  case 'v':
                $value = clx_keywords_simple($criteria_rec['VALUE'],1);
			 $value = $this->formatCriteriaValue($criteria_rec['OPERATOR'], $value);
			 break;
		  default:
			 break;
        }
        return $value;
    }

    function formatCriteriaValue($operator, $value) {
        switch ($operator) {
		  case 'IN':
		  case 'NI':
			 $value = '(' . singleQuote(implode("','", explode(',', $value))) . ')';
			 break;
		  case 'BW': // this will never happen'....
			 break;
		  case 'SW':
			 $value = singlequote($value . '%');
			 break;
		  case 'EW':
			 $value = singlequote('%' . $value);
			 break;
		  case 'CT':
			 $value = singlequote('%' . $value . '%');
			 break;
			case 'SN':
			 $value = singlequote($value . '%');
			 break;
		  case 'EN':
			 $value = singlequote('%' . $value);
			 break;
		  case 'CN':
			 $value = singlequote('%' . $value . '%');
			 break;					
		  case 'EX':
			 break;
		  case 'IS':
			 break;
		  case 'IT':
			 break;
		  case 'EF':
			 break;
		  case 'FQ':
			 break;
		  default:
			 $value = singlequote($value);
			 break;
        }
        return $value;
    }

    function buildFromWhereSort(&$queryrec) {
        $queryrec['FROMWHERESORT'] = (string) ' FROM ' . $queryrec['FROMCLAUSE'];
        if (strlen($queryrec['WHERECLAUSE']) > CLX_NUM_ZERO)
		  $queryrec['FROMWHERESORT'] .= ' WHERE ' . $queryrec['WHERECLAUSE'];
        if (strlen($queryrec['ORDERCLAUSE']) > CLX_NUM_ZERO)
		  $queryrec['FROMWHERESORT'] .= ' ORDER BY ' . $queryrec['ORDERCLAUSE'];
        if (strlen($queryrec['GROUPCLAUSE']) > CLX_NUM_ZERO)
		  $queryrec['FROMWHERESORT'] .= ' GROUP BY ' . $queryrec['GROUPCLAUSE'];
    }

    /**
     * Return an array with a compounded access record for all the tables in the query
     * @param array $querycode
     */
    function getAppAccess($querycode) {
        $access = new ClxAccess($this->code);
        if (ClxCommon::sessionUserIsAdmin()) {
		  $access->setAdminUser();
        } else {
		  $callingpage = peekHistory();
		  $sq = $this->securityQuery();
		  if (!empty($callingpage['menuid'])) {
			 //solo por seguridad de tabla.
			 $sql = 'SELECT AT.TABLECODE, MAX(AT.CANREAD) CANREAD, MAX(AT.CANMODIFY) CANMODIFY, MAX(AT.CANDELETE) CANDELETE, MAX(AT.CANAPPEND) CANAPPEND, MAX(AT.ISADMIN) ISADMIN FROM CLX_DB_QUERIES Q, CLX_DB_QUERY_TABLES QT, CLX_AC_MENUITEMS AT WHERE Q.IDCODE = ' . singleQuote($querycode) . ' AND Q.IDCODE = QT.QUERYCODE AND AT.TABLECODE IN (QT.TABLECODE,' . singleQuote('NOTABLE') . ') AND AT.MENUID = ' . singleQuote($callingpage['menuid']) . ' AND ' . $sq . ' GROUP BY AT.TABLECODE';
		  } else {
			 //solo por seguridad de tabla.
			 $sql = 'SELECT AT.TABLECODE, MAX(AT.CANREAD) CANREAD, MAX(AT.CANMODIFY) CANMODIFY, MAX(AT.CANDELETE) CANDELETE, MAX(AT.CANAPPEND) CANAPPEND, MAX(AT.ISADMIN) ISADMIN FROM CLX_DB_QUERIES Q, CLX_DB_QUERY_TABLES QT, CLX_AC_TABLES AT WHERE Q.IDCODE = ' . singleQuote($querycode) . ' AND Q.IDCODE = QT.QUERYCODE AND AT.TABLECODE = QT.TABLECODE AND ' . $sq . ' GROUP BY AT.TABLECODE';
			 //Agregando condiciones de listados en codigo donde.
			 if (!empty($callingpage['li'])) {
			     if (strval($callingpage[CLX_PROP_TO]) === 'EDIT') {
			         $sql = 'SELECT AT.TABLECODE, MAX(AT.CANREAD) CANREAD, MAX(AT.CANMODIFY) CANMODIFY, MAX(AT.CANDELETE) CANDELETE, MAX(AT.CANAPPEND) CANAPPEND, MAX(AT.ISADMIN) ISADMIN FROM CLX_DB_QUERIES Q, CLX_DB_QUERY_TABLES QT, CLX_AC_TABLES AT WHERE Q.IDCODE = ' . singleQuote($querycode) . ' AND Q.IDCODE = QT.QUERYCODE AND AT.TABLECODE = QT.TABLECODE AND EXISTS (SELECT UILG.TABLECODE FROM CLX_UI_LISTINGS UILG WHERE UILG.TABLECODE = QT.TABLECODE AND UILG.IDCODE = ' . singleQuote($callingpage['li']) . ') AND ' . $sq . ' GROUP BY AT.TABLECODE';
			     }
			 }
		  }
		  $records = ClxCommon::$db->executeQuery($sql);
		  $this->sec_table_list = array();
		  while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
			 $access->setUserAccess(intval($record ['CANREAD']), intval($record ['CANMODIFY']), intval($record ['CANDELETE']), intval($record ['CANAPPEND']), intval($record ['CANREAD']), intval($record ['ISADMIN']));
			 $this->sec_table_list[$record ['TABLECODE']] = array('access_obj' => $access, 'CANREAD' => intval($record ['CANREAD']), 'CANMODIFY' => intval($record ['CANMODIFY']), 'CANDELETE' => intval($record ['CANDELETE']), 'CANAPPEND' => intval($record ['CANAPPEND']), 'CANREAD' => intval($record ['CANREAD']), 'ISADMIN' => intval($record ['ISADMIN']));
		  }
		  ClxCommon::$db->freeResult($records);
        }
        return $access;
    }

    function userGroups($username) { // this shouldn't be here!!!!
        $list = array();
        $records = ClxCommon::$db->getRecords('CLX_AC_GROUP_MEMBERS', 'UPPER(USERNAME)=' . singleQuote(uppercase($username)));
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
		  $list[] = singlequote($record['GROUPCODE']);
        }
		ClxCommon::$db->freeResult($records);
        return $list;
    }

    /**
     * 	Returns cretieria required to identify owner of security. Example:
     * 	 ((at.ownercode='USER' and at.ownerref='<<what_ever_current_user')
     * 	 or at.ownercode='GRUP' and at.ownerref in ('what_ever_current_usergroups')))
     */
    function securityQuery() {
        $username = $_SESSION['user_record']['username'];
        $usersql = '(OWNERCODE=' . singleQuote('USER') . ' AND UPPER(OWNERREF)=' . singleQuote(uppercase($username)) . ')';
        $usergroups = $this->userGroups($username);
        if (count($usergroups) > CLX_NUM_ZERO) {
		  $usergroups = toString($usergroups);
		  $sql = '(' . $usersql . ' OR (OWNERCODE=' . singleQuote('GRUP') . ' AND OWNERREF IN (' . $usergroups . ')))';
        } else {
		  $sql = $usersql;
        }

        return $sql;
    }

    /**
     * Returns array of posible fields for joined table of query
     * @param string $querycode
     * @return array
     */
    function getQueryFields($querycode, $by_form_fieldname = false) {
        $sql = 'SELECT DBTB.RECORDNAME_PLURAL TABLENAME, DBFL.FIELDLISTLABEL FIELDLABEL, DBTF.TABLECODE, DBTF.FIELDNAME, CONCAT(DBTF.TABLECODE, CONCAT(' . singleQuote('_') . ', DBTF.FIELDNAME)) FORM_FIELDNAME, DBFL.* FROM CLX_DB_QUERIES DBQY, CLX_DB_QUERY_TABLES DBQT, CLX_DB_FIELDS DBFL, CLX_DB_TABLEFIELDS DBTF, CLX_DB_TABLES DBTB WHERE DBQY.IDCODE=' . singleQuote($querycode) . ' AND DBQY.IDCODE = DBQT.QUERYCODE AND DBQT.TABLECODE = DBTB.IDCODE AND DBFL.FIELDNAME = DBTF.FIELDNAME AND DBTF.TABLECODE = DBTB.IDCODE ORDER BY DBTF.TABLECODE ASC, DBTF.SEQNUM ASC';
        $records = ClxCommon::$db->executeQuery($sql);
        $list = array();
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
		  if ($by_form_fieldname === true) {
			 $list[$record['FORM_FIELDNAME']] = $record;
		  } else {
			 $list[$record['FIELDCODE']] = $record;
		  }
        }
		ClxCommon::$db->freeResult($records);
        return $list;
    }

    function getQueryTables($querycode) {
        $sql = 'SELECT TABLECODE FROM CLX_DB_QUERY_TABLES WHERE QUERYCODE = ' . singleQuote($querycode);
        return ClxCommon::$db->executeQuery($sql);
    }

    function createFormEntry($field_rec) {
        //Some xForm Classes are still pending on this case just use string
        if ($field_rec['FIELDTYPE'] <> 'DATE' && $field_rec['FIELDTYPE'] <> 'DATI' && $field_rec['FIELDTYPE'] <> 'LIST') {
		  $type = 'string';
        } else {
		  $type = lowercase($field_rec['FIELDTYPE']);
        }
        $field = array();
        $field['name'] = $this->code . '_' . $field_rec['FIELDNAME'];
        $field['type'] = $type;
        $field['size'] = (!empty($field_rec['FIELD_SIZE'])) ? $field_rec['FIELD_SIZE'] : CLX_NUM_32;
        $field['displaysize'] = (!empty($field_rec['FIELD_DISPLAYSIZE'])) ? $field_rec['FIELD_DISPLAYSIZE'] : CLX_NUM_32;
        $field['prefix'] = $this->operators[$field_rec['OPERATOR']];
        if ($type == CLX_CLASS_LIST)
		  $field['options'] = $field_rec['FIELD_EXTRA1'];
        //print_r($field_rec);
        $fields = array($field);
        $entry = array();
        $entry['label'] = $field_rec['FIELDFORMLABEL'];
        $entry['fields'] = $fields;
        return $entry;
    }
	 //  //////     //  ////// nuevos parametros (eran para modulo de RCTA (ivan deprecado) no se usan en otro lado, no activo cache para eso
	 //  //  //     //  //  // extra_alias_name, forceADDID, forceADDquerycode, addextraCriteria
	 //  //  // //  //  //  // pero on_efftdate  no se usa
	 //  ////// /////   //////  

    function getSql($tool, $querycode, $on_efftdate = true,$extra_alias_name='',$forcerAddId=false,$forcerAddQuery=false,/*$extrafieldsespecialgroup=array(),*/$addExtraCriteria=array(),$identificarpartes=false) {
        $sql = '';
        $query = $this->getQuery($tool, $querycode,$on_efftdate ,$extra_alias_name,$forcerAddId,$forcerAddQuery,/*$extrafieldsespecialgroup,*/$addExtraCriteria);
	    if (!empty($query)) {
		  if (empty($query['SELECTCLAUSE'])) {
				$query['SELECTCLAUSE'] = '*';
			}	
			$sql='';
			if ($identificarpartes) {
				$sql.='  /*##SELECT##*/  ';
			}
			$distinctclause=ClxCommon::$db->getone('SELECT DISTINCT_SELECT FROM '.$this->tablename.' WHERE IDCODE='.singlequote($querycode)); 

		//	pre($querrycode);
		//	pre($query);
		  $sql .= 'SELECT ' .
						(($distinctclause==1)? 'DISTINCT'.CLX_CHAR_NL : ''). 
						  $query['SELECTCLAUSE'] . CLX_CHAR_NL ;
			if ($identificarpartes) {
				$sql.='  /*##FROM##*/  ';
			}
			$sql.=' FROM ' . CLX_CHAR_NL . $query['FROMCLAUSE'] . ' ';
		  if ($identificarpartes) {
				$sql.='  /*##WHERE##*/  ';
			}
		  if ($query['WHERECLAUSE'] <> '') {
                $query['WHERECLAUSE'] = clx_keywords_simple($query['WHERECLAUSE'],1);
			 $sql .= CLX_CHAR_NL . ' WHERE ' . CLX_CHAR_NL . ' ' . $query['WHERECLAUSE'];
		  }
			if ($identificarpartes) {
				$sql.=  '  /*##GROUP##*/  ';
			}
			if ($query['GROUPCLAUSE'] <> '') {
			 $sql .= CLX_CHAR_NL . 'GROUP BY ' . CLX_CHAR_NL . $query['GROUPCLAUSE'];
		  }
			if ($identificarpartes) {
				$sql.='  /*##SORT##*/  ';
			}
		  if ($query['SORTCLAUSE'] <> '') {
			 $sql .= CLX_CHAR_NL . 'ORDER BY ' . CLX_CHAR_NL . $query['SORTCLAUSE'];
		  }
        }
		if ($this->debug==true) {
			pre('GETSQL');
			PRE($sql);
		}
		
        return $sql;
    }

    function getResultXml($tool, $querycode, $critfieldname, $critfieldvalue) {
        //$critfieldnameprefix = substr($critfieldname, 0, 4);
        $xml = new xmlObject('xml', false);
        $xml->setProp(CLX_PROP_TO, $tool);
        $xml->setProp('qy', $querycode);
        $query = $this->getQuery($tool, $querycode);
        if (!empty($query['FROMCLAUSE'])) {
		  if (empty($query['SELECTCLAUSE']))
			 $query['SELECTCLAUSE'] = '*';
		  $sql = 'SELECT ' . CLX_CHAR_NL . $query['SELECTCLAUSE'] . CLX_CHAR_NL . ' FROM ' . CLX_CHAR_NL . $query['FROMCLAUSE'] . ' ';
		  if (!empty($critfieldname)) {
			 if (is_array($critfieldname)) {
			     $cc = '';
			     $comma = '';
			     foreach ($critfieldname as $key => $val) {
			         $cc .= $comma . ' ' . $val . ' = ' . singleQuote($critfieldvalue[$key]);
			         $comma = ' AND ';
			     }
			 } else {
			     $cc = $critfieldname . '=' . singleQuote($critfieldvalue);
			 }
			 if (!empty($cc)) {
			     //Table ok trying sql
			     if (strlen($query['WHERECLAUSE']) > CLX_NUM_ZERO) {
			         $query['WHERECLAUSE'] .= ' AND ' . $cc;
			     } else {
			         $query['WHERECLAUSE'] = ' ' . $cc . ' ';
			     }
			 } else {
			     //error no table found
			     if (strlen($query['WHERECLAUSE']) > CLX_NUM_ZERO) {
			         $query['WHERECLAUSE'] .= ' AND 1=2 ';
			     } else {
			         $query['WHERECLAUSE'] = ' 1=2 ';
			     }
			 }
		  }
		  if ($query['WHERECLAUSE'] <> '') {
			 $sql .= CLX_CHAR_NL . ' WHERE ' . CLX_CHAR_NL . ' ' . $query['WHERECLAUSE'];
		  }
		  if ($query['GROUPCLAUSE'] <> '') {
			 $sql .= CLX_CHAR_NL . 'GROUP BY ' . CLX_CHAR_NL . $query['GROUPCLAUSE'];
		  }
		  if ($query['SORTCLAUSE'] <> '') {
			 $sql .= CLX_CHAR_NL . 'ORDER BY ' . CLX_CHAR_NL . $query['SORTCLAUSE'];
		  }
        } else {
		  return '';
        }
        $i = CLX_INIT_ZERO;
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $y = new xmlObject($querycode);
		  $y->setProp('RNUM', $i);
		  $j = CLX_INIT_ZERO;
		  foreach ($r as $key => $value) {
			 $f = new xmlObject($key);
			 $f->setProp('RNUM', $j);
			 $f->setProp('TBL', $query['COLUMNS'][$key]['TABLECODE']);
			 $f->setProp('WRK', ($query['COLUMNS'][$key]['WORKFIELD']) ? CLX_NUM_ONE : CLX_NUM_ZERO);
			 $f->setContents(htmlspecialchars($value));
			 $y->addObject($f);
			 $j++;
		  }
		  $i++;
		  $xml->addObject($y);
        }
		ClxCommon::$db->freeResult($rs);
        return $xml->source_(array('level' => CLX_NUM_ZERO));
    }
	function getResultArray($tool, $querycode, $critfieldname, $critfieldvalue) {
        //$critfieldnameprefix = substr($critfieldname, 0, 4);
		$sal=array();
		$sal[CLX_PROP_TO]= $tool;
		$sal['qy']= $querycode;
		$query = $this->getQuery($tool, $querycode);
        if (!empty($query['FROMCLAUSE'])) {
            if (empty($query['SELECTCLAUSE']))
                $query['SELECTCLAUSE'] = '*';
            $sql = 'SELECT ' . CLX_CHAR_NL . $query['SELECTCLAUSE'] . CLX_CHAR_NL . ' FROM ' . CLX_CHAR_NL . $query['FROMCLAUSE'] . ' ';
            if (!empty($critfieldname)) {
                if (is_array($critfieldname)) {
                    $cc = '';
                    $comma = '';
                    foreach ($critfieldname as $key => $val) {
                        $cc .= $comma . ' ' . $val . ' = ' . singleQuote($critfieldvalue[$key]);
                        $comma = ' AND ';
                    }
                } else {
                    $cc = $critfieldname . '=' . singleQuote($critfieldvalue);
                }
                if (!empty($cc)) {
                    //Table ok trying sql
                    if (strlen($query['WHERECLAUSE']) > CLX_NUM_ZERO) {
                        $query['WHERECLAUSE'] .= ' AND ' . $cc;
                    } else {
                        $query['WHERECLAUSE'] = ' ' . $cc . ' ';
                    }
                } else {
                    //error no table found
                    if (strlen($query['WHERECLAUSE']) > CLX_NUM_ZERO) {
                        $query['WHERECLAUSE'] .= ' AND 1=2 ';
                    } else {
                        $query['WHERECLAUSE'] = ' 1=2 ';
                    }
                }
            }
            if ($query['WHERECLAUSE'] <> '') {
                $sql .= CLX_CHAR_NL . ' WHERE ' . CLX_CHAR_NL . ' ' . $query['WHERECLAUSE'];
            }
            if ($query['GROUPCLAUSE'] <> '') {
                $sql .= CLX_CHAR_NL . 'GROUP BY ' . CLX_CHAR_NL . $query['GROUPCLAUSE'];
            }
            if ($query['SORTCLAUSE'] <> '') {
                $sql .= CLX_CHAR_NL . 'ORDER BY ' . CLX_CHAR_NL . $query['SORTCLAUSE'];
            }
        } else {
            return '';
        }
        $i = CLX_INIT_ZERO;
        $rs = ClxCommon::$db->executeQuery($sql);
		while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $y = array();
            $y['RNUM']= $i;
            $j = CLX_INIT_ZERO;
            foreach ($r as $key => $value) {
                $f = array($key=>array(
					'RNUM'=> $j,
					'TBL'=> $query['COLUMNS'][$key]['TABLECODE'],
					'WRK'=> ($query['COLUMNS'][$key]['WORKFIELD']) ? CLX_NUM_ONE : CLX_NUM_ZERO,
					'VALUE'=>htmlspecialchars($value)
					));
                $y[$key]=$f;
                $j++;
            }

            $sal[$querycode.'_rec_'.$i]=$y;
			$i++;
        }
		ClxCommon::$db->freeResult($rs);
        return $sal;
    }
    /**
     * Dump sql as xml
     * @param string $tool
     * @param string $querycode
     * @param mixed string array $critfieldname
     * @param mixed string array $critfieldvalue
     * @return string
     */
    function dumpResultXml($tool, $querycode, $critfieldname, $critfieldvalue) {
        sendXmlHeader();
        $xml = $this->getResultXml($tool, $querycode, $critfieldname, $critfieldvalue);
        return '<?xml version="1.0"?>' . CLX_CHAR_NL . $xml;
    }
	
    function get_unique_code($tablename, $code) {
        $number = '';
        $done = false;
        while (empty($done)) {
            $done = (ClxCommon::$db->oneExistsRecords($tablename, 'IDCODE=' . singleQuote($code . $number)) == CLX_NUM_ZERO);
		  if (empty($done))
			 $number++;
        }
        return $code . $number;
    }
    function create_ui_go() {
        $idlist = (isset(UserRequest::$post['idlist']) ? UserRequest::$post['idlist'] : toString(getIdlist()));
        UserResponse::setIgnoreUserAbort(CLX_NUM_ONE);
        UserResponse::setRunTimeLimit(CLX_NUM_2000);
        $DBMO = &getTool('DBMO');
        $d = xFormat::getNow('Y-m-d');
        //
        // PRELIMINARY VERIFICATIONS
        //
        $errmsg = '';
        $queryid = $idlist;
        $queryrec = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $queryid);
        
        if(empty($queryrec)) {   
		  $errmsg .= 'Missing Query ID: '.$queryid.'<br>';
        }       
        $dict_title_value = dict('GEN_LBL_QUICKSEARCH'); // "GEN_LBL_QUICKSEARCH" = Busqueda Rapida
        $dict_title_value_p2 = dict('GEN_LBL_ADV_SEARCH'); // "GEN_LBL_ADV_SEARCH" = Busqueda Avanzada
        if(strpos($dict_title_value, '&ac=CREATE_FAST') !== false) {
		  $errmsg .= 'Missing dictionary: GEN_LBL_QUICKSEARCH<br>';
        }
        if(strpos($dict_title_value_p2, '&ac=CREATE_FAST') !== false) {
		  $errmsg .= 'Missing dictionary: GEN_LBL_ADV_SEARCH<br>';
        }
        if($errmsg !== '') {
		  return '<br><br>' . note($errmsg, 'OK');
        }
        
		//$tablecode = $queryrec['IDCODE'];
        $querycode = $queryrec['IDCODE'];
        $tablename = $queryrec['IDNAME'];
        $modulecode = $queryrec['MODULECODE'];
        
        $tablecodesr = ClxCommon::$db->executeQuery('SELECT TABLECODE FROM CLX_DB_QUERY_TABLES WHERE QUERYCODE = '.singleQuote($querycode) );
        $tablecoderec = ClxCommon::$db->getNextRecord($tablecodesr);
		ClxCommon::$db->freeResult($tablecodesr);
        $tablecode = $tablecoderec['TABLECODE'];   
		$tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singlequote($tablecode));
		   
        unset($tablecodesr);

        // 
        // Report Table -----------------------------------------
        //
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('GEN_LBL_REPORT'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        // Table Columns -------------------------------------------------
        $fields = array();
        $fields_rs = ClxCommon::$db->executeQuery('SELECT F.FIELDNAME, F.FIELDFORMLABEL, F.FIELDPREFIX, F.FIELDSUFIX, TB.FIELD_DEFAULT TABLE_FIELD_DEFAULT, TB.SEQNUM FROM CLX_DB_FIELDS F, CLX_DB_TABLEFIELDS TB WHERE TB.TABLECODE=' . singleQuote($tablecode) . ' AND TB.FIELDNAME = F.FIELDNAME ORDER BY TB.SEQNUM');
        while (($fieldrec = ClxCommon::$db->getNextRecord($fields_rs))) {
		  if ($fieldrec['FIELDNAME'] !== 'ID') {
			 $fields[] = $fieldrec;
		  }
        }
		ClxCommon::$db->freeResult($fields_rs);
        unset($fields_rs);
        //
        // Table Index Columns -------------------------------------------------
        //
        $index_fields = array();
        $fields_rs = ClxCommon::$db->executeQuery('SELECT DBIC.FIELDNAME, DBTI.TYPE NDX_TYPE FROM CLX_DB_TABLEINDEXES DBTI, CLX_DB_INDEX_COLUMNS DBIC WHERE DBTI.IDCODE = DBIC.INDEX_CODE AND DBTI.TABLECODE = ' . singleQuote($tablecode) . ' AND DBIC.FIELDNAME <> ' . singleQuote('ID') );
        while (($fieldrec = ClxCommon::$db->getNextRecord($fields_rs))) {
		  $index_fields[$fieldrec['FIELDNAME']] = $fieldrec['NDX_TYPE'];
        }
		ClxCommon::$db->freeResult($fields_rs);
        $index_fields_qty = count($index_fields);
        unset($fields_rs);
/*        
        //
        // Query -------------------------------------------------
        //
        $record = array();
        $querycode = $this->get_unique_code('CLX_DB_QUERIES', $tablecode);
        $record['IDCODE'] = $querycode;
        $record['IDNAME'] = $tablename;
        $record['VERSION'] = '1.0.0';
        $record['VERSION_COUNTER'] = '0';
        $record['CDATE'] = $d;
        $record['MDATE'] = $d;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['DESCRIPTION'] = 'Auto generated default query';
        $record['MODULECODE'] = $modulecode;
        $queryid = ClxCommon::$db->createRecord('CLX_DB_QUERIES', $record, false);
        $table->addData(dict('GEN_LBL_QUERY'), '<a href="tool.php?to=DBQY&ac=DISPLAY&idlist=' . $queryid . '">' . $tablename . ' (' . $querycode . ')</a>');
        //
        // Query Table ------------------------------------------
        //
        $record = array();
        $record['QUERYCODE'] = $querycode;
        $record['TABLECODE'] = $tablecode;
        $record['INVISIBLE'] = '0';
        ClxCommon::$db->createRecord('CLX_DB_QUERY_TABLES', $record, false);
        //
        // Query Columns -------------------------------------------------
        //
        $record = array();
        $record['QUERYCODE'] = $querycode;
        $record['TABLECODE'] = $tablecode;
        $record['VISIBLE'] = '1';
        $record['FILTER'] = '0';
        $record['GROUPED'] = '0';
        $record['EXPRESSION'] = '';
        $record['CURRENCY_FIELD_TBL'] = '';
        $record['CURRENCY_FIELD'] = '';
        $record['FIELD_FORMAT'] = '0';
        $i = CLX_INIT_ZERO;
        foreach($fields as $fieldrec) {
		  if ($fieldrec['FIELDNAME'] !== 'ID') {
			 $record['FIELDNAME'] = $fieldrec['FIELDNAME'];
			 $record['SORT'] = (isset($index_fields[$fieldrec['FIELDNAME']]) ? '1' : '0');
			 $record['SEQNUM'] = $i;
			 ClxCommon::$db->createRecordVoid('CLX_DB_QUERY_FIELDS', $record, false);
			 $i++;
		  }
        }
*/
        //
        // Form -------------------------------------------------
        //
        $record = array();
        $formcode = $this->get_unique_code('CLX_UI_FORMS', $tablecode);
        $record['IDCODE'] = $formcode;
        $record['IDNAME'] = $tablename;
        $record['VERSION'] = '1.0.0';
        $record['VERSION_COUNTER'] = '0';
        $record['CDATE'] = $d;
        $record['MDATE'] = $d;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['DESCRIPTION'] = 'Auto generated default form';
        $record['TABLECODE'] = $tablecode;
        $record['MODULECODE'] = $modulecode;
        $record['DEFAULT_FORM'] = '0';
        $formid = ClxCommon::$db->createRecord('CLX_UI_FORMS', $record, false);
        $table->addData(dict('GEN_LBL_FORM'), '<a href="tool.php?to=UIFM&ac=DISPLAY&idlist=' . $formid . '">' . $tablename . ' (' . $formcode . ')</a>');
        //
        // Form Panel -------------------------------------------------
        //
        $record = array();
        $record['IDCODE'] = $formcode . '_001';
        $record['IDNAME'] = 'Information';
        $record['FORMCODE'] = $formcode;
        $record['DESCRIPTION'] = 'Auto generated panel';
        $record['PANEL_CLASS'] = '';
        $record['NUMCOLS'] = '1';
        $record['TYPE'] = '0';
        $record['INITIAL_STATE'] = '1';
        $record['TITLE'] = '';
        $record['CAPTION'] = '';
        $record['SEQNUM'] = '0';
        ClxCommon::$db->createRecordVoid('CLX_UI_FORM_PANELS', $record, false);
        $panelcode = $record['IDCODE'];
        //
        // Form Panel Fields -------------------------------------------------
        //
        $record = array();
        $record['PANELID'] = $panelcode;
        $record['CAPTION'] = '';
        $record['CAPTION_CLASS'] = '';
        //$fields = ClxCommon::$db->executeQuery('SELECT F.*, TB.FIELD_DEFAULT TABLE_FIELD_DEFAULT FROM CLX_DB_FIELDS F, CLX_DB_TABLEFIELDS TB WHERE TB.TABLECODE=' . singleQuote($tablecode) . ' AND TB.FIELDNAME = F.FIELDNAME ORDER BY TB.SEQNUM');
        $i = CLX_INIT_ZERO;
        //while (($fieldrec = ClxCommon::$db->getNextRecord($fields))) {
        foreach($fields as $fieldrec) {
		  if ($fieldrec['FIELDNAME'] !== 'ID') {
			 $record['FIELDNAME'] = $fieldrec['FIELDNAME'];
			 $record['FIELDSEQNUM'] = $i;
			 $record['FIELDFORMLABEL'] = $fieldrec['FIELDFORMLABEL'];
			 $record['FIELDPREFIX'] = $fieldrec['FIELDPREFIX'];
			 $record['FIELDSUFIX'] = $fieldrec['FIELDSUFIX'];
			 $record['FIELD_DISPLAYSIZE'] = CLX_INIT_ZERO;
			 $record['FIELD_REQUIRED'] = CLX_NUM_TWO; //field default
			 $record['FIELD_DEFAULT'] = $fieldrec['TABLE_FIELD_DEFAULT'];
			 ClxCommon::$db->createRecordVoid('CLX_UI_FORM_PANEL_FIELDS', $record, false);
			 $i++;
		  }
        }
        //
        // Search Form -------------------------------------------------
        //
        $create_def_search_form = (defined('DBTB_CREATE_DEF_SRCH_FRM') ? DBTB_CREATE_DEF_SRCH_FRM : '');
        if($create_def_search_form === strval(CLX_NUM_ONE)) {
		  // Create panel title dictionaries
		  $DICT = &getTool('DICT');
		  $dict_title_entry = $DICT->createEntry($dict_title_value);
		  if($index_fields_qty > CLX_NUM_ZERO) {
			 $dict_title_entry_p2 = $DICT->createEntry($dict_title_value_p2);
		  }
		  //
		  // Search Form -------------------------------------------------
		  //
		  $formcode_lsrch = $this->get_unique_code('CLX_UI_FORMS', $formcode . '_SRCH');
		  $record = array();
		  $record['IDCODE'] = $formcode_lsrch;
		  $record['IDNAME'] = $tablename . ' (Search Form)';
		  $record['VERSION'] = '1.0.0';
		  $record['VERSION_COUNTER'] = '0';
		  $record['CDATE'] = $d;
		  $record['MDATE'] = $d;
		  $record['USERNAME'] = $_SESSION['user_record']['username'];
		  $record['DESCRIPTION'] = 'Auto generated default search form';
		  $record['TABLECODE'] = $tablecode;
		  $record['MODULECODE'] = $modulecode;
		  $record['DEFAULT_FORM'] = '0';
		  $formid_lsrch = ClxCommon::$db->createRecord('CLX_UI_FORMS', $record, false);
		  $table->addData(dict('GEN_LBL_FORM'), '<a href="tool.php?to=UIFM&ac=DISPLAY&idlist=' . $formid_lsrch . '">' . $tablename . ' (' . $formcode_lsrch . ')</a>');
		  //
		  // Search Form Panel -------------------------------------------------
		  //
		  $record = array();
		  $record['IDCODE'] = $formcode_lsrch . '_001';
		  $record['IDNAME'] = $dict_title_value;
		  $record['FORMCODE'] = $formcode_lsrch;
		  $record['DESCRIPTION'] = 'Auto generated search panel - ' . $dict_title_value;
		  $record['PANEL_CLASS'] = '';
		  $record['NUMCOLS'] = ($index_fields_qty > CLX_NUM_ZERO ? CLX_NUM_ONE : CLX_NUM_TWO);
		  $record['TYPE'] = CLX_INIT_ZERO;
		  $record['INITIAL_STATE'] = CLX_NUM_ONE;
		  $record['TITLE'] = $dict_title_entry;
		  $record['CAPTION'] = '';
		  $record['SEQNUM'] = CLX_INIT_ZERO;
		  ClxCommon::$db->createRecordVoid('CLX_UI_FORM_PANELS', $record, false);
		  $panelcode_lsrch = $record['IDCODE'];
		  // Advanced Search Form Panel -------------------------------------------------
		  if($index_fields_qty > CLX_NUM_ZERO) {
			 $record = array();
			 $record['IDCODE'] = $formcode_lsrch . '_002';
			 $record['IDNAME'] = $dict_title_value_p2;
			 $record['FORMCODE'] = $formcode_lsrch;
			 $record['DESCRIPTION'] = 'Auto generated search panel - ' . $dict_title_value_p2;
			 $record['PANEL_CLASS'] = 'form';
			 $record['NUMCOLS'] = CLX_NUM_TWO;
			 $record['TYPE'] = CLX_NUM_ONE;
			 $record['INITIAL_STATE'] = CLX_INIT_ZERO;
			 $record['TITLE'] = $dict_title_entry_p2;
			 $record['CAPTION'] = '';
			 $record['SEQNUM'] = CLX_INIT_ZERO;
			 ClxCommon::$db->createRecordVoid('CLX_UI_FORM_PANELS', $record, false);
			 $panelcode_lsrch_p2 = $record['IDCODE'];
		  }
		  //
		  // Form Panel Fields -------------------------------------------------
		  //
		  $record = array();
		  $record['CAPTION'] = '';
		  $record['CAPTION_CLASS'] = '';
		  $i = CLX_INIT_ZERO;
		  foreach($fields as $fieldrec) {
			 if ($fieldrec['FIELDNAME'] !== 'ID') {
			     $record['PANELID'] = ($index_fields_qty > CLX_NUM_ZERO && !isset($index_fields[$fieldrec['FIELDNAME']]) ? $panelcode_lsrch_p2 : $panelcode_lsrch);
			     $record['FIELDNAME'] = $fieldrec['FIELDNAME'];
			     $record['FIELDSEQNUM'] = $i;
			     $record['FIELDFORMLABEL'] = $fieldrec['FIELDFORMLABEL'];
			     $record['FIELDPREFIX'] = $fieldrec['FIELDPREFIX'];
			     $record['FIELDSUFIX'] = $fieldrec['FIELDSUFIX'];
			     $record['FIELD_DISPLAYSIZE'] = CLX_INIT_ZERO;
			     $record['FIELD_REQUIRED'] = CLX_INIT_ZERO; // always optional field
			     $record['FIELD_DEFAULT'] = $fieldrec['TABLE_FIELD_DEFAULT'];
			     ClxCommon::$db->createRecordVoid('CLX_UI_FORM_PANEL_FIELDS', $record, false);
			     $i++;
			 }
		  }
        }
        //
        // Listing -------------------------------------------------
        //
        $record = array();
        $listingcode = $this->get_unique_code('CLX_UI_LISTINGS', $tablecode);
        $record['IDCODE'] = $listingcode;
        $record['IDNAME'] = $tablename;
        $record['VERSION'] = '1.0.0';
        $record['VERSION_COUNTER'] = '0';
        $record['CDATE'] = $d;
        $record['MDATE'] = $d;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['DESCRIPTION'] = 'Auto generated default listing';
        $record['TITLE'] = $tablerec['RECORDNAME_PLURAL'];
        $record['CAPTION'] = '';
        $record['MODULECODE'] = $modulecode;
        $record['TABLECODE'] = $tablecode;
        $record['QUERYCODE'] = $querycode;
        $record['CREATE_FORM'] = $formcode;
        $record['MODIFY_FORM'] = $formcode;
        $record['DISPLAY_FORM'] = $formcode;
        $record['DELETE_FORM'] = $formcode;
        //$record['SEARCH_FORM'] = '';
        $record['SEARCH_FORM'] = ($create_def_search_form === strval(CLX_NUM_ONE) ? $formcode_lsrch : '');
        $record['CONTROL_VIEWS'] = '1';
        $record['CONTROL_FILTERS'] = '1';
        $record['VIEW_SUMMARY'] = '0';
        //$record['CONTROL_EXPORT'] = '0';
        $record['CONTROL_EXPORT'] = '1';
        $record['EXEONSEARCH'] = '0';
        $listingid = ClxCommon::$db->createRecord('CLX_UI_LISTINGS', $record, false);
        $table->addData(dict('GEN_LBL_LISTING'), '<a href="tool.php?to=UILG&ac=DISPLAY&idlist=' . $listingid . '">' . $tablename . ' (' . $listingcode . ')</a> --&gt; <a href="tool.php?to=EDIT&ac=LIST&li='.$listingcode.'&menuid=">'.uppercase(dict('GEN_LBL_EXECUTE')).'</a>');
        //
        // Module Version Increase
        //
        $DBMO->versionIncrease('IDCODE', $modulecode);
        //
        $c = new htmlButtonCancel(dict('GEN_LBL_RETURN'));
        $table->addCell($c->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        return $table->source();
    }
    
    /**
     * Builds Tool Filter Form
     * @param array $msg
     * @return  string
     */
    function create_ui_form($msg) {
        $contents = '';
//dict('TOOL_DBQY_TITLE_LIST')
//dict('TOOL_DBQY_GENERATE_UI')
        $title = dict('GEN_TTL_FILTER');
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'FILTER');
        $form->addArgument('confirm', '1');

        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));

        $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $this->filterFormFill($msg, $table);
        $c = new htmlSubmit(dict('GEN_LBL_SET_FILTER'), 'FILTER');
        $buttons = $c->source();
        $c = new htmlSubmit(dict('GEN_LBL_CLEAR_FILTER'), 'UNFILTER');
        $buttons .= $c->source();
        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents = $form->source();
        return $contents;
    }
	function check_indexs_query_exists_create($querycode,$extras=array()){
		$sql='SELECT A.TABLECODE,A.FIELDNAME,A.VALUE, CONCAT(CONCAT(MODULECODE,'.singlequote('_').'),IDNAME) TABLENAME from CLX_DB_QUERY_CRITERIA A,CLX_DB_TABLES B WHERE A.TABLECODE=B.IDCODE AND A.QUERYCODE='.singleQuote($querycode);
		$rs = ClxCommon::$db->executeQuery($sql);
		$fieldswhere=array();
		$tables=array();
		$textotablefind=array();
		while ($result = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		
			$tables[$result['TABLECODE']]=$result['TABLENAME'];
			if (!isset($fieldswhere[$result['TABLECODE']])) {
				$fieldswhere[$result['TABLECODE']]=array();
			}
			$fieldswhere[$result['TABLECODE']][$result['FIELDNAME']]=$result['FIELDNAME'];
		
			$wherexx=preg_split("/( AND )|( OR )/",$result['VALUE']);
			
			foreach ($wherexx as $valuest) {
				$values=PREG_SPLIT("/[=()<>\s,]/",$valuest);
				foreach($values as $valx) {
					if (($xpos=strpos($valx,"."))>0) {
						$tablecode=substr($valx,0,$xpos);
						$tables[$tablecode]='';
						$textotablefind[]=$tablecode;
						$fieldswhere[$tablecode][substr($valx,$xpos+1)]=substr($valx,$xpos+1);
					}	
				}
			}
		}
		ClxCommon::$db->freeResult($rs);
		$sql='select IDCODE TABLECODE,CONCAT(CONCAT(MODULECODE,'.singlequote('_').'),IDNAME) TABLENAME from CLX_DB_TABLES  WHERE IDCODE IN ('.singleQuoteArray($textotablefind).')';
		$rs = ClxCommon::$db->executeQuery($sql);
		while ($result = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			$tables[$result['TABLECODE']]=$result['TABLENAME'];
		}
		ClxCommon::$db->freeResult($rs);
		foreach ($tables as $tablecode=>$tablename){
			$sql='select ID,FIELDNAME,IDCODE from CLX_DB_TABLEINDEXES WHERE TABLECODE='.singlequote($tablecode).' order by IDCODE,ID';
			$rs = ClxCommon::$db->executeQuery($sql);
			$indexexists=array();
			while ($result = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
				IF (!isset($datos[$result['IDCODE']]))
					$datos[$tablecode][$result['IDCODE']]=array();
				IF (!empty($result['FIELDNAME'])) {
					$indexexists[$result['IDCODE']][$result['ID']]=$result['FIELDNAME'];
				}
				else {
					$sql='select LISTAGG(FIELDNAME,'.singlequote(',').') WITHIN GROUP  (ORDER BY SEQNUM) FIELDS from CLX_DB_INDEX_COLUMNS WHERE INDEX_CODE ='.singlequote($result['IDCODE']);
					$rs2 = ClxCommon::$db->executeQuery($sql);
					$fields=ClxCommon::$db->getNextRecord($rs2, ASSOCIATIVE)['FIELDS'];
					ClxCommon::$db->freeResult($rs2); 
					$campos= explode(",",$fields);
					if (!isset($indexexists[$result['IDCODE']])) {
						$indexexists[$result['IDCODE']]=array();
					}	
					foreach ($campos as $campo){
						$indexexists[$result['IDCODE']][]=$campo;
					}	
					
				}	
			}
			ClxCommon::$db->freeResult($rs);
			$contar=0;
			$max=count($fieldswhere[$tablecode]);
			$validocase=true;
			foreach ($indexexists as $idcode=>$indexexistfields){
				$existe=false;
				if (count($indexexistfields)>=count($fieldswhere[$tablecode])) {
					$contar=0;
					foreach ($indexexistfields as $keyid=>$indexexistfield){
						$cantwhere=0;
						
						foreach ($fieldswhere[$tablecode] as $indexfieldswhere){
							$cantwhere++;
							$cantindex=0;
						
							$cantindex++;
							if ($cantindex<=$cantwhere) {
								if ($indexexistfield==$indexfieldswhere) {
									$contar++;
									
								}
							}				
						}

						
					}
					if ($contar==$max) {
						$validocase=false;

					}		

				}
				if (!$validocase) {
					break;
				}
				$antcode=$idcode;
			}

			if ($validocase) {
				$nameindex=$tablecode.'_'.uppercase(substr(md5(rand(1,9999999999)),1,12));
					$sql='INSERT INTO CLX_DB_TABLEINDEXES (ID,TABLECODE,FIELDNAME,TYPE,FIELDNAME_SEC,IDCODE) VALUES (NULL,'.singlequoteArray(array($tablecode,null,'MUL','',$nameindex)).')';

					ClxCommon::$db->executequery($sql);
					$seqnum=0;
					foreach ($fieldswhere[$tablecode] as $indexfieldswhere){ 
						$sql='INSERT INTO CLX_DB_INDEX_COLUMNS (ID, INDEX_CODE,FIELDNAME,SEQNUM) VALUES (NULL, '.singlequote($nameindex).','. singlequote($indexfieldswhere).', '.$seqnum.')';

						$seqnum++;
						ClxCommon::$db->executequery($sql);
					}	
					switch (kDatabaseType) {
						case 'oci': // Oracle
							$sql='CREATE INDEX '.$nameindex.' ON '.$tablename.'('.implode(",",$fieldswhere[$tablecode]).')  ';
							break;
						default:	
							$sql='ALTER TABLE ADD '.$tablename.' ADD INDEX '.$nameindex.'('.implode(",",$fieldswhere[$tablecode]).')';
							break;
					}
					ClxCommon::$db->executequery($sql);
				
			}

			foreach ($fieldswhere[$tablecode] as $indexfields){
				$exists=false;
				
				
				
			
				foreach (/*$indexexistfields*/ $indexexists as $keyid=>$indexexistfield){
					$pos=array_keys($indexexistfield);
				
					if ($indexexistfield[$pos[0]]==$indexfields) {
						$exists=true;
						break;
					}	
				}
				if ($exists==false) {
					$nameindex=$tablecode.'_'.uppercase(substr(md5(rand(1,9999999999)),1,12));
					$sql='INSERT INTO CLX_DB_TABLEINDEXES (ID,TABLECODE,FIELDNAME,TYPE,FIELDNAME_SEC,IDCODE) VALUES (NULL,'.singlequoteArray(array($tablecode,$indexfields,'MUL','',$nameindex)).')';
				
					ClxCommon::$db->executequery($sql);
					$sql='INSERT INTO CLX_DB_INDEX_COLUMNS (ID, INDEX_CODE,FIELDNAME,SEQNUM) VALUES (NULL, '.singlequote($nameindex).','. singlequote($indexfields).', 0)';
				
					ClxCommon::$db->executequery($sql);
					switch (kDatabaseType) {
						case 'oci': // Oracle
							$sql='CREATE INDEX '.$nameindex.' ON '.$tablename.'('.$indexfields.')  ';
							break;
						default:	
							$sql='ALTER TABLE ADD '.$tablename.' ADD INDEX '.$nameindex.'('.$indexfields.')';
							break;
					}
				
					
					
					ClxCommon::$db->executequery($sql);
				}
				
			}
				
		}	
	}

}
