<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @package		Clientix.Tool.Ibs Sockets
 * @abstract		IBS Socket Messages Manager
 * @package		Clientix.Tool.IbsSockets
 * @abstract		IBS Socket Messages Manager
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class eb_socket_mappings extends clx_tool {

    var $editform;
    var $map_type = array('CHAR' => 'GEN_LBL_CHARACTER',
        'DECN' => 'GEN_LBL_NUMERIC',
        'DATE' => 'GEN_LBL_DATE');
    //$this->date_in_formats en tools lista los tipos de
    var $dyn_type = array('FIX' => 'TOOL_DBIC_FIELD',
        'CONS' => 'GEN_LBL_CONSTANT',
        'COPY' => 'GEN_LBL_COPY_FILEFIELD',
        'IGNR' => 'TOOL_DBIC_IGNORE');

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'EBIC';
        $this->name = 'IBS Socket Manager Import Mappings';
        $this->system = 'Sockets';
        $this->version = '1.0.0.1';


        $this->accesskey = 'EBSK';

        $this->tablename = 'CLX_EB_SOCKET_MAPPINGS';
        $this->record_name_singular = 'eb socket mapping';
        $this->record_name_plural = 'eb socket mappings';
        $this->primary_field = 'ID';
        $this->secondary_field = 'EBSOCKETCODE';
        $this->seqnum_field = 'SEQNUM';
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_EBIC_TITLE_CREATE',
		  'panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_SOCKETCODE',
					   'fields' => array(
						  array('name' => 'ebsocketcode', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '64', 'readonly' => true))
			         ), array('label' => 'GEN_LBL_FILE_FIELD',
					   'fields' => array(
						  array('name' => 'file_fieldname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '64', 'dontmodify' => '',
						      'validations' => array(
								array('type' => 'sqlobject', 'required' => '1'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_TABLEFULLNAME',
					   'fields' => array(
						  array('name' => 'tablefullname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '64', 'dontmodify' => false)
					   )
			         ), array('label' => 'GEN_LBL_TABLE_FIELD',
					   'fields' => array(
						  array('name' => 'table_fieldname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '64', 'dontmodify' => '')
					   )
			         ), array('label' => 'GEN_LBL_DATA_TYPE',
					   'fields' => array(
						  array('name' => 'data_type', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => $this->map_type))
			         ), array('label' => 'GEN_LBL_REQUIRED',
					   'fields' => array(
						  array('name' => 'field_required', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => $this->yesno))
			         ), array('label' => 'GEN_LBL_DESCRIPTION',
					   'fields' => array(
						  array('name' => 'description', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4'))
			         ), array('label' => 'GEN_LBL_SEQNUM',
					   'fields' => array(
						  array('name' => 'seqnum', 'type' => 'string', 'default' => '', 'size' => '6', 'displaysize' => '6', 'dontmodify' => '')
					   )
			         ), array('label' => 'GEN_LBL_START_POSITION',
					   'fields' => array(
						  array('name' => 'start_position', 'type' => 'string', 'size' => '10', 'displaysize' => '10', 'sufix' => 'GEN_LBL_CHARACTERS', 'validations' => array(
								array('type' => 'integer', 'required' => '1'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_FIELD_LENGTH',
					   'fields' => array(
						  array('name' => 'field_length', 'type' => 'string', 'size' => '10', 'displaysize' => '10', 'sufix' => 'GEN_LBL_CHARACTERS', 'validations' => array(
								array('type' => 'integer', 'required' => '1'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_FIELD_DECIMALS',
					   'fields' => array(
						  array('name' => 'field_decimals', 'type' => 'string', 'size' => '10', 'displaysize' => '10', 'sufix' => 'GEN_LBL_CHARACTERS', 'validations' => array(
								array('type' => 'integer', 'required' => ''))
						  )
					   )
			         ), array('label' => 'GEN_LBL_FIELD_DTFORMAT',
					   'fields' => array(
						  array('name' => 'field_dtformat', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => $this->date_in_formats))
			         ), array('label' => 'GEN_LBL_IBS_OPERATION_CODE',
					   'fields' => array(
						  array('name' => 'operation_code', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => $this->yesno))
			         ), array('label' => 'GEN_LBL_IBS_ISIBSUSER',
					   'fields' => array(
						  array('name' => 'is_ibs_user', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => $this->yesno))
			         ), array('label' => 'GEN_LBL_SEARCH_KEY',
					   'fields' => array(
						  array('name' => 'search_key', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => $this->yesno))
			         ), array('label' => 'GEN_LBL_READ_ONLY',
					   'fields' => array(
						  array('name' => 'read_only', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => $this->read_only))
			         ), array('label' => 'GEN_LBL_FORMULA',
					   'fields' => array(
						  array('name' => 'formula', 'type' => 'text', 'cols' => '48', 'rows' => '4'))
			         ), array('label' => 'TOOL_EBIC_FILL_WITH',
					   'fields' => array(
						  array('name' => 'type', 'type' => 'dynamic', 'panels' => $this->dyn_type))
			         )
			     )
			 ), array('type' => 'dynamic',
			     'code' => 'FIX',
			     'entries' => array()
			 ), array('type' => 'dynamic',
			     'code' => 'CONS',
			     'entries' => array(
			         array('label' => 'GEN_LBL_CONSTANT',
					   'fields' => array(
						  array('name' => 'val_constant', 'type' => 'string', 'size' => '255', 'displaysize' => '50'))
			         )
			     )
			 ), array('type' => 'dynamic',
			     'code' => 'COPY',
			     'entries' => array(
			         array('label' => 'GEN_LBL_COPY_FILEFIELD',
					   'fields' => array(
						  array('name' => 'copy_filefield', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '64'))
			         )
			     )
			 ), array('type' => 'dynamic',
			     'code' => 'IGNR',
			     'entries' => array()
			 )
		  )
        );
        //Removing field that are not part of the file
        $info = peekHistory();
        if (!empty($info['ebsocket_type'])) {
		  $type = $info['ebsocket_type'];
		  if ($type === 'CSV') {
			 unset($this->editform['panels'][CLX_NUM_ZERO]['entries'][CLX_NUM_8], $this->editform['panels'][CLX_NUM_ZERO]['entries'][CLX_NUM_NINE], $this->editform['panels'][CLX_NUM_ZERO]['entries'][CLX_NUM_TEN]);
		  }
        }
        $this->viewform = $this->editform;
        $this->toolpanelkeys = array(array('name' => 'EBSOCKETCODE', 'type' => 'string'));
        $this->toolpanel = array('name' => $this->tablename, CLX_CLASS_TITLE => $this->record_name_plural, 'fields' => array(
			 array('name' => 'ID', 'type' => 'number', 'label' => 'GEN_LBL_ID'), array('name' => 'EBSOCKETCODE', 'type' => 'string'), array('name' => 'SEQNUM', 'type' => 'number'), array('name' => 'FILE_FIELDNAME', 'type' => 'string'), array('name' => 'DESCRIPTION', 'type' => 'text'), array('name' => 'TABLEFULLNAME', 'type' => 'string'), array('name' => 'TABLE_FIELDNAME', 'type' => 'string'), array('name' => 'DATA_TYPE', 'type' => CLX_CLASS_LIST, 'options' => $this->map_type), array('name' => 'FIELD_REQUIRED', 'type' => CLX_CLASS_LIST, 'options' => $this->yesno), array('name' => 'START_POSITION', 'type' => 'string'), array('name' => 'FIELD_LENGTH', 'type' => 'string'), array('name' => 'FIELD_DECIMALS', 'type' => 'string'), array('name' => 'FIELD_DTFORMAT', 'type' => CLX_CLASS_LIST, 'options' => $this->date_in_formats), array('name' => 'OPERATION_CODE', 'type' => CLX_CLASS_LIST, 'options' => $this->yesno, 'label' => 'GEN_LBL_IBS_OPERATION_CODE'), array('name' => 'IS_IBS_USER', 'type' => CLX_CLASS_LIST, 'options' => $this->yesno), array('name' => 'SEARCH_KEY', 'type' => CLX_CLASS_LIST, 'options' => $this->yesno), array('name' => 'READ_ONLY', 'type' => CLX_CLASS_LIST, 'options' => $this->read_only), array('name' => 'TYPE', 'type' => CLX_CLASS_LIST, 'options' => $this->dyn_type), array('name' => 'VAL_CONSTANT', 'type' => 'string', 'label' => 'GEN_LBL_CONSTANT')), 'buttons' =>
		  array(array('access' => 'canmodify',
			     'tool' => 'has_modify',
			     'library' => 'GEN_LBL_REORDER',
			     'name' => 'REORDER',
			     'prop' => 'ON'
			 ), array('access' => 'canmodify',
			     'tool' => 'has_modify',
			     'library' => 'GEN_LBL_RECALCULATE',
			     'name' => 'RECALCULATE',
			     'prop' => 'ON'
			 )
		  )
        );
        $this->toollist = $this->toolpanel;
    }

    /**
     * Describes the tool table structure.
     * @return array ('type' => 'varchar(255)', 'properties'=>'auto increment',
     * 				'index'=>'', default = '', 'dict'=>true)
     * 				 dict true or false means that field holds dictionary entry
     */
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['EBSOCKETCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['TABLEFULLNAME'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['TABLE_FIELDNAME'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['TYPE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['DATA_TYPE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['FILE_FIELDNAME'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['FIELD_REQUIRED'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['OPERATION_CODE'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['IS_IBS_USER'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['FORMULA'] = array('type' => 'mediumtext', 'null' => 'YES', 'properties' => '');
        $fields['SEQNUM'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['START_POSITION'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['FIELD_LENGTH'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['FIELD_DECIMALS'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['FIELD_DTFORMAT'] = array('type' => 'varchar(20)', 'null' => 'YES', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['SEARCH_KEY'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO, 'properties' => '');
        $fields['READ_ONLY'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO, 'properties' => '');
        $fields['VAL_CONSTANT'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['COPY_FILEFIELD'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'EBSOCKETCODE,SEQNUM');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

//-- I M P O R T    M A P P I N G S
    /**
     * Pack tool record on xml Format
     * @param array record
     * @return obj
     */
    function pack($record) {
        $o = $this->packRecord($record);
        $id = $record['ID'];
        $objs = new XMLObject($this->code . '_OBJECTS');
        $this->packsub($objs, 'EBIT', 'SELECT * FROM CLX_EB_SOCKET_TRANSLATIONS WHERE MAPID=' . $id);
        $o->addObject($objs);
        return $o;
    }

    /**
     * Loads package into system
     * @param string $package
     */
    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null, 'id' => null), $parameters));
        list($package, $formid) = $parameters;
        $record = $this->unpackRecord($package);
        $mapid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
		  $objs = $package->getObjectXml($this->code . '_OBJECTS');
		  foreach ($objs->objects as $o) {
			 $toolcode = $o->tag;
			 $tool = &getTool($toolcode);
			 $tool->unpack(array('package' => $o, 'id' => $mapid));
		  }
        }
    }

    /**
     * Action is called for every user interaction with the module...
     *
     * @param unknown_type $ac
     * @param unknown_type $idlist
     * @return unknown
     */
    function action($ac, $idlist) {
        if ($this->getAccess()->canRead()) {
		  switch ($ac) {
			 case 'RECALCULATE':
			     $this->recalculatePosition();
			     $contents = executeHistory(peekHistory());
			     break;
			 default:
			     $contents = parent::action($ac, $idlist);
			     break;
		  }
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [EB_SOCKET_MAPPINGS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    /**
     * Verify Tool Edit Forms
     * @param array $msg
     * @return bool
     */
    function checkForm(&$msg) {
        $msg = array();
        if (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE') {
            $count = ClxCommon::$db->oneExistsRecords($this->tablename, 'EBSOCKETCODE =' . singleQuote(UserRequest::$post['EBIC_ebsocketcode']) . ' AND FILE_FIELDNAME =' . singleQuote(UserRequest::$post['EBIC_file_fieldname']));
		  if ($count > CLX_NUM_ZERO) {
			 $msg['EBIC_file_fieldname'] = dict('GEN_LBL_ALREADYEXISTS');
		  }
        }
        if (UserRequest::$post['EBIC_data_type'] <> 'DATE' && !empty(UserRequest::$post['EBIC_field_dtformat'])) {
		  $msg['EBIC_field_dtformat'] = dict('GEN_ERR_MUSTBEEMPTY');
        }
        if (UserRequest::$post['EBIC_data_type'] === 'DATE' && empty(UserRequest::$post['EBIC_field_dtformat'])) {
		  $msg['EBIC_field_dtformat'] = dict('GEN_ERR_REQUIRED');
        }
        if (!empty(UserRequest::$post['EBIC_operation_code'])) {
            $qty = ClxCommon::$db->oneExistsRecords($this->tablename, 'EBSOCKETCODE =' . singleQuote(UserRequest::$post['EBIC_ebsocketcode'] . "' AND FILE_FIELDNAME <> '" . UserRequest::$post['EBIC_file_fieldname']) . ' AND OPERATION_CODE = 1');
		  if ($qty >= CLX_NUM_ONE) {
			 $msg['EBIC_operation_code'] = dict('GEN_ERR_ONLY_ONE_ALLOWED');
		  }
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    /**
     * Builds confirm delete form for tool
     * @param obj $table
     * @param array $record
     */
    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_FILE_FIELD') . ':', $record['EBIC_file_fieldname']);
        $table->addData(dict('GEN_LBL_TABLEFULLNAME') . ':', $record['EBIC_tablefullname']);
        $table->addData(dict('GEN_LBL_TABLE_FIELD') . ':', $record['EBIC_table_fieldname']);
    }

    /**
     * Creates reorder list
     * @return string
     */
    function reorderRecords() {
        $no_map = dict('GEN_LBL_NOMAP');
        $callingpage = peekHistory();
        $records = ClxCommon::$db->getRecords($this->tablename, 'EBSOCKETCODE=' . singleQuote($callingpage['ebsocketcode']) . ' ORDER BY SEQNUM');
        $list = array();
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
		  if ($record['TABLEFULLNAME'] === '') {
			 $c = $record['FILE_FIELDNAME'] . '->' . $no_map;
		  } else {
			 $c = $record['FILE_FIELDNAME'] . '->' . $record['TABLEFULLNAME'] . '.' . $record['TABLE_FIELDNAME'];
		  }
		  $c = str_replace(CLX_CHAR_NL, '', $c);
		  $c = trim(str_replace(CLX_CHAR_CR, '', $c));
		  $list[$record['ID']] = $c;
        }
        return $list;
    }

    /**
     * Performs reorder record action
     */
    function reorderAction() {
        parent::reorderAction();
        //Recount Positions
        $this->recalculatePosition();
    }

    /**
     * Build display form contents
     * @param array $record
     * @return string
     */
    function viewFormFill($record) {
        addHistory('mapid', $record['EBIC_id']);
        $contents = parent::viewFormFill($record);
        if ($record['EBIC_file_fieldname'] !== 'IGNORE') {
		  $EBIT = &getTool('EBIT');
		  $contents .= $EBIT->makepanel($record['EBIC_id']);
        }
        return $contents;
    }

    /**
     * Loads current record on selected id
     *
     * @param integer $id
     * @return array
     */
    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        $record = array();
        $record['EBIC_id'] = $recordid;
        $record['EBIC_table_fieldname'] = $values['TABLE_FIELDNAME'];
        $record['EBIC_tablefullname'] = $values['TABLEFULLNAME'];
        $record['EBIC_file_fieldname'] = $values['FILE_FIELDNAME'];
        $record['EBIC_type'] = $values['TYPE'];
        $record['EBIC_description'] = $values['DESCRIPTION'];
        $record['EBIC_field_required'] = $values['FIELD_REQUIRED'];
        $record['EBIC_operation_code'] = $values['OPERATION_CODE'];
        $record['EBIC_is_ibs_user'] = $values['IS_IBS_USER'];
        $record['EBIC_data_type'] = $values['DATA_TYPE'];
        $record['EBIC_formula'] = $values['FORMULA'];
        $record['EBIC_start_position'] = $values['START_POSITION'];
        $record['EBIC_field_length'] = $values['FIELD_LENGTH'];
        $record['EBIC_field_decimals'] = $values['FIELD_DECIMALS'];
        $record['EBIC_field_dtformat'] = $values['FIELD_DTFORMAT'];
        $record['EBIC_search_key'] = $values['SEARCH_KEY'];
        $record['EBIC_read_only'] = $values['READ_ONLY'];
        $record['EBIC_ebsocketcode'] = $values['EBSOCKETCODE'];
        $record['EBIC_seqnum'] = $values['SEQNUM'];
        $record['EBIC_val_constant'] = $values['VAL_CONSTANT'];
        $record['EBIC_copy_filefield'] = $values['COPY_FILEFIELD'];
        return $record;
    }

    /**
     * Defines default record on initializacion
     *
     * @return array
     */
    function defaultRecord() {
        $callingpage = peekHistory();
        $sql = 'SELECT (START_POSITION+FIELD_LENGTH) START_POSITION, (SEQNUM)+1 SEQNUM FROM ' . $this->tablename . ' WHERE EBSOCKETCODE = ' . singleQuote($callingpage['ebsocketcode']) . ' AND SEQNUM = (SELECT MAX(SEQNUM) FROM ' . $this->tablename . ' WHERE EBSOCKETCODE = ' . singleQuote($callingpage['ebsocketcode']) . ')';
        $newstart = ClxCommon::$db->getOneRecord($sql);
        if (empty($newstart)) {
		  $newstart = array('START_POSITION' => CLX_NUM_ZERO, 'SEQNUM' => CLX_NUM_ZERO);
        }
        $record = array();
        $record['EBIC_id'] = CLX_INIT_ZERO;
        $record['EBIC_table_fieldname'] = '';
        $record['EBIC_tablefullname'] = '';
        $record['EBIC_file_fieldname'] = '';
        $record['EBIC_type'] = '';
        $record['EBIC_description'] = '';
        $record['EBIC_data_type'] = '';
        $record['EBIC_field_required'] = CLX_INIT_ZERO;
        $record['EBIC_formula'] = '';
        $record['EBIC_start_position'] = $newstart['START_POSITION'];
        $record['EBIC_field_length'] = CLX_INIT_ZERO;
        $record['EBIC_field_decimals'] = CLX_INIT_ZERO;
        $record['EBIC_operation_code'] = CLX_INIT_ZERO;
        $record['EBIC_search_key'] = CLX_INIT_ZERO;
        $record['EBIC_read_only'] = CLX_INIT_ZERO;
        $record['EBIC_field_dtformat'] = '';
        $record['EBIC_is_ibs_user'] = CLX_INIT_ZERO;
        $record['EBIC_ebsocketcode'] = $callingpage['ebsocketcode'];
        $record['EBIC_seqnum'] = $newstart['SEQNUM'];
        $record['EBIC_val_constant'] = '';
        $record['EBIC_copy_filefield'] = '';
        return $record;
    }

    /**
     * Creates record
     *
     * @return integer
     */
    function createRecord_() {
        $record = array();
        $record['FILE_FIELDNAME'] = UserRequest::$post['EBIC_file_fieldname'];
        $record['TABLE_FIELDNAME'] = UserRequest::$post['EBIC_table_fieldname'];
        $record['TABLEFULLNAME'] = trim(UserRequest::$post['EBIC_tablefullname']);
        $record['FORMULA'] = clx_html_spchrs_decode(UserRequest::$post['EBIC_formula']);
        $record['START_POSITION'] = (empty(UserRequest::$post['EBIC_start_position'])) ? CLX_NUM_ZERO : UserRequest::$post['EBIC_start_position'];
        $record['FIELD_LENGTH'] = (empty(UserRequest::$post['EBIC_field_length'])) ? CLX_NUM_ZERO : UserRequest::$post['EBIC_field_length'];
        $record['FIELD_DECIMALS'] = (empty(UserRequest::$post['EBIC_field_decimals'])) ? CLX_NUM_ZERO : UserRequest::$post['EBIC_field_decimals'];
        $record['TYPE'] = UserRequest::$post['EBIC_type'];
        $record['FIELD_REQUIRED'] = UserRequest::$post['EBIC_field_required'];
        $record['SEQNUM'] = UserRequest::$post['EBIC_seqnum'];
        $record['DESCRIPTION'] = UserRequest::$post['EBIC_description'];
        $record['DATA_TYPE'] = UserRequest::$post['EBIC_data_type'];
        $record['OPERATION_CODE'] = UserRequest::$post['EBIC_operation_code'];
        $record['IS_IBS_USER'] = UserRequest::$post['EBIC_is_ibs_user'];
        $record['SEARCH_KEY'] = UserRequest::$post['EBIC_search_key'];
        $record['READ_ONLY'] = UserRequest::$post['EBIC_read_only'];
        $record['EBSOCKETCODE'] = UserRequest::$post['EBIC_ebsocketcode'];
        $record['FIELD_DTFORMAT'] = UserRequest::$post['EBIC_field_dtformat'];
        $record['VAL_CONSTANT'] = clx_html_spchrs_decode(UserRequest::$post['EBIC_val_constant']);
        $record['COPY_FILEFIELD'] = UserRequest::$post['EBIC_copy_filefield'];
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $this->versionIncrease('ID', UserRequest::$post['EBIC_id']);
        //Update Message Record Length
        $EBSK = &getTool('EBSK');
        $EBSK->saveLength($record['EBSOCKETCODE']);
        return $recordid;
    }

    /**
     * Update records
     *
     * @return integer
     */
    function saveRecord() {
        $record = array();
        $record['TABLE_FIELDNAME'] = UserRequest::$post['EBIC_table_fieldname'];
        $record['TABLEFULLNAME'] = trim(UserRequest::$post['EBIC_tablefullname']);
        $record['FILE_FIELDNAME'] = UserRequest::$post['EBIC_file_fieldname'];
        $record['FORMULA'] = clx_html_spchrs_decode(UserRequest::$post['EBIC_formula']);
        $record['START_POSITION'] = (empty(UserRequest::$post['EBIC_start_position'])) ? CLX_NUM_ZERO : UserRequest::$post['EBIC_start_position'];
        $record['FIELD_LENGTH'] = (empty(UserRequest::$post['EBIC_field_length'])) ? CLX_NUM_ZERO : UserRequest::$post['EBIC_field_length'];
        $record['FIELD_DECIMALS'] = (empty(UserRequest::$post['EBIC_field_decimals'])) ? CLX_NUM_ZERO : UserRequest::$post['EBIC_field_decimals'];
        $record['TYPE'] = UserRequest::$post['EBIC_type'];
        $record['SEQNUM'] = UserRequest::$post['EBIC_seqnum'];
        $record['DESCRIPTION'] = UserRequest::$post['EBIC_description'];
        $record['DATA_TYPE'] = UserRequest::$post['EBIC_data_type'];
        $record['FIELD_REQUIRED'] = UserRequest::$post['EBIC_field_required'];
        $record['OPERATION_CODE'] = UserRequest::$post['EBIC_operation_code'];
        $record['IS_IBS_USER'] = UserRequest::$post['EBIC_is_ibs_user'];
        $record['SEARCH_KEY'] = UserRequest::$post['EBIC_search_key'];
        $record['READ_ONLY'] = UserRequest::$post['EBIC_read_only'];
        $record['FIELD_DTFORMAT'] = UserRequest::$post['EBIC_field_dtformat'];
        $record['VAL_CONSTANT'] = clx_html_spchrs_decode(UserRequest::$post['EBIC_val_constant']);
        $record['COPY_FILEFIELD'] = UserRequest::$post['EBIC_copy_filefield'];
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['EBIC_id']);
        $this->versionIncrease('ID', UserRequest::$post['EBIC_id']);
        //Update Message Record Length
        $EBSK = &getTool('EBSK');
        $EBSK->saveLength(UserRequest::$post['EBIC_ebsocketcode']);
    }

    /**
     * Deletes record on selected id
     *
     * @param integer $id
     */
    function deleteRecordSk($id) {
        $record = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $id);
        ClxCommon::$db->deleteRecords('CLX_EB_SOCKET_TRANSLATIONS', 'MAPID=' . $id);
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
        //Update Message Record Length
        $EBSK = &getTool('EBSK');
        $EBSK->saveLength($record['EBSOCKETCODE']);
        $DBMO = &getTool('DBMO');
        $DBMO->versionIncrease('IDCODE', $record['EBSOCKETCODE']);
    }

    /**
     * Increase tool version
     * @param string $fieldname
     * @param string $fieldvalue
     */
    function versionIncrease($fieldname, $fieldvalue) {
        $ebsocketcode = ClxCommon::$db->getField($this->tablename, 'EBSOCKETCODE', $fieldname . '=' . singleQuote($fieldvalue));
        $DBIM = &getTool('EBSK');
        $DBIM->versionIncrease('IDCODE', $ebsocketcode);
    }

    /**
     * Recalculates the position of the record.
     */
    function recalculatePosition() {
        $callingpage = peekHistory();
        if (empty($callingpage['ebsocketcode']))
		  return;
        $sql = 'SELECT ID, START_POSITION, FIELD_LENGTH FROM ' . $this->tablename . ' WHERE EBSOCKETCODE = ' . singleQuote($callingpage['ebsocketcode']) . ' ORDER BY SEQNUM ASC';
        $rs = ClxCommon::$db->executeQuery($sql);
        $i = CLX_INIT_ZERO;
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  //   - To make a real position recalculation...
		  ClxCommon::$db->updateRecord($this->tablename, array('START_POSITION' => $i), 'ID = ' . $r['ID']);
		  $i += $r['FIELD_LENGTH'];
        }//end while
        //Update Message Record Length
        $EBSK = &getTool('EBSK');
        $EBSK->saveLength($callingpage['ebsocketcode']);
    }

}
