<?php

/**
 * Process Schedule Parameter
 *
 * @package		Clientix.Tool.Process
 * @abstract		Process Engine Manager
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-08-23 18:18:58 -0400 (Thu, 23 Aug 2018) $
 * @version    	$Rev: 9902 $
 */
class pr_sched_prmts extends clx_tool {

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'PRSP';
        $this->name = 'Process Schedule Parameters Manager';
        $this->system = 'Process';
        $this->version = '5.5.0.0';

        $this->has_access = true;


        $this->tablename = 'CLX_PR_SCHED_PRMTS';
        $this->record_name_singular = 'GEN_LBL_PR_PARAMETERS';
        $this->record_name_plural = 'GEN_LBL_PR_PARAMETER';
        $this->primary_key = array('PROCESSCODE', 'FIELDNAME');
        $this->primary_field = 'SCHEDULECODE';
        $this->secondary_field = 'FIELDNAME';

        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_SCHPR_TITLE_CREATE',
		  'panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_SCHEDULECODE',
					   'fields' => array(
						  array('name' => 'schedulecode',
						      'type' => 'lookup',
						      'default' => '',
						      'readonly' => false,
						      'tool' => 'PRSC',
						      'validations' => array(
								array('type' => 'sqlobject',
								    'required' => '1'
								), array('type' => 'lookup',
								    'fieldname' => 'idcode',
								    'tablename' => 'CLX_PR_SCHEDULES'
								)
						      )
						  )
					   )
			         ), array('label' => 'GEN_LBL_FIELDNAME',
					   'fields' => array(
						  array('name' => 'fieldname',
						      'type' => 'lookup',
						      'default' => '',
						      'tool' => 'DBFL',
						      'validations' => array(
								array('type' => 'sqlobject',
								    'required' => '1'
								), array('type' => 'lookup',
								    'fieldname' => 'FIELDNAME',
								    'tablename' => 'CLX_DB_FIELDS'
								)
						      )
						  )
					   )
			         ), array('label' => 'GEN_LBL_PARAMETER_VALUE',
					   'fields' => array(
						  array('name' => 'parameter_value',
						      'type' => 'text',
						      'default' => '',
						      'cols' => '48',
						      'rows' => '4'
						  )
					   )
			         )
			     )
			 )
		  )
        );
        $this->viewform = $this->editform;
        $this->toolpanelkeys = array(array('name' => 'SCHEDULECODE', 'type' => 'string'));
        $this->toolpanel = array('name' => $this->tablename, CLX_CLASS_TITLE => $this->record_name_plural, 'fields' =>
		  array(array('name' => 'ID', 'label' => 'GEN_LBL_ID', 'type' => 'number'), array('name' => 'SCHEDULECODE', 'label' => 'GEN_LBL_SCHEDULECODE', 'type' => 'string'), array('name' => 'FIELDNAME', 'label' => 'GEN_LBL_FIELDNAME', 'type' => 'string'), array('name' => 'PARAMETER_VALUE', 'label' => 'GEN_LBL_PARAMETER_VALUE', 'type' => 'string'))
        );
    }

// End method
    /**
     * Tool Table Structure
     * @return array
     */
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['SCHEDULECODE'] = array('type' => 'varchar(20)', 'null' => 'NO', 'properties' => '');
        $fields['FIELDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['PARAMETER_VALUE'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'SCHEDULECODE,FIELDNAME');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

//-- SCHEDULE PARAMTERS
    /**
     * Unpack Record into Metadata
     * @param obj $o
     * @return array
     */
    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        $exists = (ClxCommon::$db->oneExistsRecords($this->tablename, 'SCHEDULECODE=' . singleQuote($record['SCHEDULECODE']) . ' AND FIELDNAME = ' . singleQuote($record['FIELDNAME'])));
        if (!empty($exists)) {
		  unset($record['ID']);
		  ClxCommon::$db->updateRecord($this->tablename, $record, 'SCHEDULECODE=' . singleQuote($record['SCHEDULECODE']) . ' AND FIELDNAME = ' . singleQuote($record['FIELDNAME']));
        } else {
		  ClxCommon::$db->createRecord($this->tablename, $record, false);
        }
    }

    /**
     * Tool Action
     * @param string $ac Action code
     * @param string $idlist Record(s) affected by action
     * @return string
     */
    	function action($ac, $idlist) {
		
        $contents = '';
        $msg = array();
		if ( !empty($_SESSION["_dEBUG"])) {$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+"); fwrite($tta,chr(13).chr(10)."14001- hora: ac:$ac".date("h:i:s d/m/Y").chr(13).chr(10)); $te=debug_backtrace();for ($t=0;$t<18;$t++) { if (isset($te[$t]["file"]))	fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));	}	  fwrite($tta,chr(13).chr(10).chr(13).chr(10));fclose($tta);}
        if ($this->getAccess()->canRead()) {
		  switch ($ac) {
			 case 'CREATE':
			 case 'MODIFY':
				if (isset(UserRequest::$post['confirm'])) {
					UserRequest::$post['PRSP_parameter_value']=trim(str_replace(chr(13),' ',str_replace(chr(10),' ',str_replace(chr(13).chr(10),' ',UserRequest::$post['PRSP_parameter_value']))));
					UserRequest::$request['PRSP_parameter_value']=trim(str_replace(chr(13),' ',str_replace(chr(10),' ',str_replace(chr(13).chr(10),' ',UserRequest::$request['PRSP_parameter_value']))));
	        	}
			}
			
			$contents=parent::action($ac,$idlist);
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [CLX_TOOL-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
		return $contents; 
    }

    /**
     * Prepares tool default record
     * @return array
     */
    function defaultRecord() {
        $callingpage = peekHistory();
        $record = parent::defaultRecord();
        $record['PRSP_schedulecode'] = $callingpage['schedulecode'];
        return $record;
    }

    /**
     * Verify tool edit form
     * @param array $msg
     * @return bool
     */
    function checkForm(&$msg) {
        $msg = array();
        $DBFL = &getTool('DBFL');
        UserRequest::$post['PRSP_fieldname'] = uppercase(UserRequest::$post['PRSP_fieldname']);
        if (UserRequest::$request['ac'] <> 'MODIFY') {
		  if (!$DBFL->fieldexists(UserRequest::$post['PRSP_fieldname'])) {
			 $msg['PRSP_fieldname'] = dict('TOOL_PRSP_ERR_NOFIELD');
			 $msg['ERROR'] = 'NO_FIELD';
		  } else {
                $qty = ClxCommon::$db->oneExistsRecords($this->tablename, 'SCHEDULECODE=' . singleQuote(UserRequest::$post['PRSP_schedulecode']) . ' AND FIELDNAME= ' . singleQuote(UserRequest::$post['PRSP_fieldname']));
			 if ($qty > CLX_NUM_ZERO) {
			     $msg['PRSP_fieldname'] = dict('TOOL_PRSP_ERR_ALREADYINCLUDED');
			 }
		  }
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    /**
     * Initializes Schedule Parameters
     * @param array $record
     */
    function createParameters($scheduleid) {
        $PRSC = getTool('PRSC');
        $PRPM = getTool('PRPM');
        $sql = 'SELECT PRSC.IDCODE SCHEDULECODE, PSPM.FIELDNAME FROM ' . $PRSC->tablename . ' PRSC, ' . $PRPM->tablename . ' PSPM WHERE PRSC.PROCESSCODE = PSPM.PROCESSCODE AND PRSC.ID = ' . $scheduleid . ' AND NOT EXISTS(SELECT PRSP.ID FROM ' . $this->tablename . ' PRSP WHERE PRSP.SCHEDULECODE = PRSC.IDCODE AND PRSP.FIELDNAME = PSPM.FIELDNAME)';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  ClxCommon::$db->createRecord($this->tablename, $r, false);
        }
		ClxCommon::$db->freeResult( $rs );
    }

    /**
     * Loads schedule parameters and its value from array
     *
     * @param string $schedule_code
     * @param array $parameters
     * @return bool
     */
    function setScheduleParameters($schedule_code, $parameters) {
        if (empty($schedule_code))
		  return false;
        //setting process parameters
        //additional parameters if not defined on process
        foreach ($parameters as $key => $val) {
		  $sql = 'SELECT COUNT(ID) FROM ' . $this->tablename . '  WHERE SCHEDULECODE = ' . singleQuote($schedule_code) . ' AND FIELDNAME = ' . singleQuote($key);
		  if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
			 ClxCommon::$db->updateRecord($this->tablename, array('PARAMETER_VALUE' => $val), 'SCHEDULECODE = ' . singleQuote($schedule_code) . ' AND FIELDNAME = ' . singleQuote($key));
		  } else {
			 ClxCommon::$db->createRecord($this->tablename, array('SCHEDULECODE' => $schedule_code, 'FIELDNAME' => $key, 'PARAMETER_VALUE' => $val), false);
		  }
        }
        return true;
    }

}
