<?php

/**
 * Service Messages Elements
 * Webservices Service Messages Elements
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 *
 * CHANGE LOG
 *  Included label
 */
$GLOBALS['DEBUG_SK_SERVICE']=1; 
class sk_elements extends clx_tool {

    var $editform;

    function __construct() {
        $this->code = 'SKME';
        $this->name = 'Service Messages Elements';
        $this->system = 'Sockets';
        $this->version = '5.5.0.0';

        $this->accesskey = 'SKMS';


        $this->tablename = 'CLX_SK_ELEMENTS';
        $this->record_name_singular = 'GEN_LBL_ELEMENT';
        $this->record_name_plural = 'GEN_LBL_ELEMENTS';
        $this->primary_field = 'IDCODE';
        $this->secondary_field = 'IDNAME';
        $this->seqnum_field = 'SEQNUM';
        $this->ele_types = array('CHAR' => 'GEN_LBL_CHARACTER', 'TEXT' => 'GEN_LBL_TEXT',
            'PNEL' => 'TOOL_SKMP_FIELD_GROUP',
            'SXML' => 'TOOL_SKMP_STRING_XML',
            'IGNR' => 'TOOL_DBIC_IGNORE',
            'INTN' => 'GEN_LBL_INTEGER',
            'DECN' => 'GEN_LBL_DECIMAL',
            'DATE' => 'GEN_LBL_DATE',
            'ACMG' => 'GEN_LBL_ACTION_RES_MSG',
            'ACST' => 'GEN_LBL_ACTION_RES_CODE',
            'ACID' => 'GEN_LBL_ACTION_RES_ID');
        $this->date_formats = $this->date_in_formats;
        $this->editform_csv = array(CLX_CLASS_TITLE => 'TOOL_SKME_TITLE_CREATE',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_MSG_CODE',
                            'fields' => array(
                                array('name' => 'msg_code', 'type' => 'string', 'default' => '', 'size' => '16', 'displaysize' => '16', 'readonly' => true))
                        ), array('label' => 'GEN_LBL_IDCODE',
                            'fields' => array(
                                array('name' => 'idcode', 'type' => 'string', 'default' => '', 'size' => '16', 'displaysize' => '16', 'dontmodify' => true)
                            )
                        ), array('label' => 'GEN_LBL_ELE_NAME',
                            'fields' => array(
                                array('name' => 'idname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '64', 'validations' => array('type' => 'string', 'required' => '1')),),), array('label' => 'GEN_LBL_PATH',
                            'fields' => array(
                                array('name' => 'xpath', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '64', 'readonly' => true),),), array('label' => 'GEN_LBL_DESCRIPTION',
                            'fields' => array(
                                array('name' => 'description', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4'))
                        ), array('label' => 'GEN_LBL_SEQNUM',
                            'fields' => array(
                                array('name' => 'seqnum', 'type' => 'string', 'default' => '', 'size' => '6', 'displaysize' => '6', 'dontmodify' => '')
                            )
                        ), array('label' => 'GEN_LBL_PARENT_ELEMENT',
                            'fields' => array(
                                array('name' => 'parent_element', 'type' => 'lookup', 'default' => '', 'tool' => $this->code, 'validations' => array(
                                        array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => $this->tablename))
                                )
                            )
                        ), array('label' => 'GEN_LBL_MIN_OCCURS',
                            'fields' => array(
                                array('name' => 'min_occurs', 'type' => 'string', 'default' => '', 'size' => '6', 'displaysize' => '6', 'dontmodify' => '')
                            )
                        ), array('label' => 'GEN_LBL_MAX_OCCURS',
                            'fields' => array(
                                array('name' => 'max_occurs', 'type' => 'string', 'default' => '', 'size' => '6', 'displaysize' => '6', 'dontmodify' => '')
                            )
                        ), array('label' => 'GEN_LBL_ELE_DEFAULT',
                            'fields' => array(
                                array('name' => 'ele_default', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '64'))
                        ), array('label' => 'GEN_LBL_TEST_VALUE',
                            'fields' => array(
                                array('name' => 'test_value', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '2'))
                        ), array('label' => 'TOOL_SKME_ELE_TYPE',
                            'fields' => array(
                                array('name' => 'ele_type', 'type' => 'dynamic', 'panels' => $this->ele_types)
                            )
                        )
                    )
                ), array('type' => 'dynamic',
                    'code' => 'ACMG',
                    'entries' => array()
                ), array('type' => 'dynamic',
                    'code' => 'ACST',
                    'entries' => array()
                ), array('type' => 'dynamic',
                    'code' => 'ACID',
                    'entries' => array()
                ), array('type' => 'dynamic',
                    'code' => 'IGNR',
                    'entries' => array()
                ), array('type' => 'dynamic',
                    'code' => 'PNEL',
                    'entries' => array(
                    )
                ), array('type' => 'dynamic',
                    'code' => 'SXML',
                    'entries' => array(
                    )
                ), array('type' => 'dynamic',
                    'code' => 'TEXT',
                    'entries' => array(
                    )
                ), array('type' => 'dynamic',
                    'code' => 'CHAR',
                    'entries' => array(
                    )
                ), array('type' => 'dynamic',
                    'code' => 'INTN',
                    'entries' => array(
                    )
                ), array('type' => 'dynamic',
                    'code' => 'DECN',
                    'entries' => array(
                        array('label' => 'GEN_LBL_ELE_ELE_THOSEP',
                            'fields' => array(
                                array('name' => 'ele_thosep', 'type' => 'string', 'default' => '', 'size' => '1', 'displaysize' => '3'))
                        ), array('label' => 'GEN_LBL_ELE_ELE_DECSEP',
                            'fields' => array(
                                array('name' => 'ele_decsep', 'type' => 'string', 'default' => '', 'size' => '1', 'displaysize' => '3'))
                        ), array('label' => 'GEN_LBL_ELE_NO_DECIMALS',
                            'fields' => array(
                                array('name' => 'ele_decimals', 'type' => 'string', 'default' => '', 'size' => '30', 'displaysize' => '6'))
                        )
                    )
                ), array('type' => 'dynamic',
                    'code' => 'DATE',
                    'entries' => array(
                        array('label' => 'GEN_LBL_ELE_DT_FORMAT',
                            'fields' => array(
                                array('name' => 'ele_dtformat', 'type' => CLX_CLASS_LIST, 'default' => 'NONE', 'options' => $this->date_formats))
                        )
                    )
                )
            )
        );
        $this->editform_frl = $this->editform_csv;
        $this->editform_xml = $this->editform_csv;
        $this->viewform = $this->editform_xml;
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['IDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['MSG_CODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['SEQNUM'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['ELE_TYPE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['ELE_DTFORMAT'] = array('type' => 'varchar(10)', 'null' => 'YES', 'properties' => '');
        $fields['ELE_DECIMALS'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['ELE_DECSEP'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['ELE_THOSEP'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['ELE_START_POS'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['ELE_LENGTH'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['ELE_DEFAULT'] = array('type' => 'varchar(64)', 'null' => 'YES', 'properties' => '');
        $fields['MIN_OCCURS'] = array('type' => 'int(3) unsigned', 'null' => 'YES', 'properties' => '');
        $fields['MAX_OCCURS'] = array('type' => 'int(3) unsigned', 'null' => 'YES', 'properties' => '');
        $fields['PARENT_ELEMENT'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['TEST_VALUE'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['XPATH'] = array('type' => 'mediumtext', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'IDNAME');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'MSG_CODE');
        $indexes[$ipf . '05'] = array('index' => 'MUL', 'fieldname' => 'PARENT_ELEMENT');
        $indexes[$ipf . '06'] = array('index' => 'MUL', 'fieldname' => 'SEQNUM');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

//-- M E S A G E  E L E M E N T S
    function pack($record) {
        $o = $this->packRecord($record);
        $objs = new XMLObject($this->code . '_OBJECTS');
        $o->addObject($objs);
        return $o;
    }

    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        $exists = (ClxCommon::$db->oneExistsRecords($this->tablename, 'UPPER(IDCODE)=' . singleQuote(uppercase($record['IDCODE']))) > CLX_NUM_ZERO);
        if ($exists === true) {
            ClxCommon::$db->deleteRecords($this->tablename, 'UPPER(IDCODE)=' . singleQuote(uppercase($record['IDCODE'])));
        }
        $id = ClxCommon::$db->createRecord($this->tablename, $record, false);
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
            $objs = $package->getObjectXml($this->code . '_OBJECTS');
            foreach ($objs->objects as $o) {
                $toolcode = $o->tag;
                $tool = getTool($toolcode);
                $tool->unpack(array('package' => $o, 'id' => $id));
            }
        }
    }

    function action($ac, $idlist) {
        if ($this->getAccess()->canRead()) {
            switch ($ac) {
                case 'CHECK':
				$contents = $this->check();
                    break;
                default:
                    $contents = parent::action($ac, $idlist);
                    break;
            }
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [SK_ELEMENTS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function makepanel($msg_code = null) {
        if ($this->getAccess()->canRead()) {
            $t = time();
            $to = $this->code;
            $here = 'tool.php?to=' . $to . '&t=' . $t;
            $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
            $form->setProp(CLX_PROP_ID, 'SKMEPanel');
            $form->addArgument(CLX_PROP_TO, $this->code);
            $form->addArgument('msg_code', $msg_code);
            $form->addArgument('ac', 'NOT_DEFINED');
            $selectclause = '*';
            $fromclause = $this->tablename;
            $whereclause = 'MSG_CODE=' . singleQuote($msg_code);
            $sortclause = 'SEQNUM';
            $page = new xPaging();
            $page->setProp('rpp', CLX_NUM_TEN_THOUSAND);
            $page->setProp('printheaders', false);
            $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
            $table = new htmlTable(CLX_WIDTH_NINE);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $page->header($table);
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_IDCODE'), dict('GEN_LBL_ELE_NAME'), dict('GEN_LBL_PARENT_ELEMENT'), dict('GEN_LBL_ELE_TYPE'), dict('GEN_LBL_DESCRIPTION'), dict('GEN_LBL_SEQNUM'), /* dict('GEN_LBL_MIN_OCCURS'),
                  dict('GEN_LBL_MAX_OCCURS'), */
                dict('GEN_LBL_ELE_DEFAULT'), dict('GEN_LBL_TEST_VALUE')));
            $i = CLX_INIT_ZERO;
            while ($record = $page->nextRecord()) {
                $recordid = $record['ID'];
                $select = new htmlCheckbox('selector_' . $recordid, false);
                $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
                $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
                $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array(
                    $record['IDCODE'], $record['XPATH'], $record['PARENT_ELEMENT'], dict($this->ele_types[$record['ELE_TYPE']]), $record['DESCRIPTION'], $record['SEQNUM'],
                    $record['ELE_DEFAULT'], $record['TEST_VALUE']));
                $i++;
            }
            $buttons = '';
            $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            if ($this->getAccess()->canModify()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDelete()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDisplay()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_ELEMENT')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
            }
            $b = new htmlFormSubmit(dict('GEN_LBL_CHECK'), 'CHECK', $form->getProp(CLX_PROP_ID));
            $b->setProp(CLX_PROP_ID, 'ON');
            $buttons .= $b->source();
            $form->addContents($page->footers($table, $buttons));
            return buildPanelInterface(dict('TOOL_SKME_TITLE_LIST'), 'EB_SOCKET_ELEMENTS_' . $msg_code, $form->source(), CLX_NUM_MINUS_1);
        } else {
            return CLX_CHAR_EMPTY_STRING;
        }
    }

    function editForm($ac, $idlist, $record, $msg) {
        $SKMS = getTool('SKMS');
        $type = ClxCommon::$db->getField($SKMS->tablename, 'MSG_TYPE', $SKMS->primary_field . '=' . singleQuote($record['SKME_msg_code']));
        if ($type === 'CSV') {
            $this->editform = $this->editform_csv;
        } elseif ($type === 'XML') {
            $this->editform = $this->editform_xml;
        } else {
            $this->editform = $this->editform_frl;
        }
        if (UserRequest::$request['ac'] === 'MODIFY') {
            $this->editform['TITLE'] = 'TOOL_' . $this->code . '_TITLE_MODIFY';
        } else {
            $this->editform['TITLE'] = 'TOOL_' . $this->code . '_TITLE_CREATE';
        }
        $form = new clx_form($this->code, $this->editform);
        return $form->editForm($ac, $idlist, $record, $msg);
    }

    function viewFormFill($record) {
        addHistory('element_code', $record['SKME_idcode']);
        addHistory('msg_code', $record['SKME_msg_code']);
        $contents = '';
        // Elements
        $SKMP = &getTool('SKMP');
        $contents .= $SKMP->makepanel($record['SKME_idcode']);
        return $contents;
    }

    function searchForm() {
        $contents = '';
        $msg = array();
        // Search Form
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'SEARCH');
        $form->addArgument('confirm', '1');
        $form->addArgument(CLX_PROP_TARGET, UserRequest::$request[CLX_PROP_TARGET]);
        $form->addArgument('SKME_msg_code', '');
        if (!empty(UserRequest::$request['msg_code'])) {
            $form->addArgument('msg_code', UserRequest::$request['msg_code']);
        }
        if (!empty(UserRequest::$request['map_code'])) {
            UserRequest::$request['msg_code'] = ClxCommon::$db->getField('CLX_SK_MAPPINGS', 'MSG_CODE', 'IDCODE = ' . singleQuote(UserRequest::$request['map_code']));
            $form->addArgument('msg_code', UserRequest::$request['msg_code']);
        }
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SKME_TITLE_SEARCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addField($msg, dict('GEN_LBL_IDCODE') . ':', 'SKME_idcode', (array_key_exists('SKME_idcode', UserRequest::$post)) ? UserRequest::$post['SKME_idcode'] : '', CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_ELE_NAME') . ':', 'SKME_idname', (array_key_exists('SKME_idname', UserRequest::$post)) ? UserRequest::$post['SKME_idname'] : '', CLX_NUM_32, CLX_NUM_64);
        $buttons = htmlButton::getButton('submit', dict('GEN_LBL_SEARCH'), array('action' => 'SEARCH', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents .= $form->source();
		
        // Search Procedure
        if (isset(UserRequest::$post['confirm'])) {
            $table = new htmlTable(CLX_WIDTH_THREE);
			$tableWidth=CLX_WIDTH_THREE;
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $criteria = '';
            $comma = '';
            if (UserRequest::$post['SKME_msg_code'] <> '') {
                $criteria .= $comma . 'MSG_CODE LIKE ' . singleQuote(UserRequest::$post['SKME_msg_code'] . '%');
                $comma = ' AND ';
            }
            if (UserRequest::$post['SKME_idcode'] <> '') {
                $criteria .= $comma . 'UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['SKME_idcode']) . '%');
                $comma = ' AND ';
            }
            if (UserRequest::$post['SKME_idname'] <> '') {
                $criteria .= $comma . 'UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['SKME_idname'])) . '%');
                $comma = ' AND ';
            }
            if (UserRequest::$post['msg_code'] <> '') {
                $criteria .= $comma . 'MSG_CODE = ' . singleQuote(UserRequest::$post['msg_code']) . ' ';
                $comma = ' AND ';
            }
            $qty = ClxCommon::$db->oneExistsRecords($this->tablename, $criteria);
            if ($qty == CLX_NUM_ZERO) {
                $table->addCell(dict('TOOL_GEN_ERR_NOMATCH'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => $tableWidth));
            } else {
                $table->addCell(dict('TOOL_GEN_MSG_FOUNDRECORDS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => $tableWidth));
                $records = ClxCommon::$db->getRecords($this->tablename, $criteria);
                $i = CLX_INIT_ZERO;
                while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
                    $js = 'javascript:setLookupValue(' . quote(UserRequest::$request[CLX_PROP_TARGET]) . ', ' . quote($record['IDCODE']) . ');';
                    $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array('<page t=sk_elements></page><a href=' . singleQuote($js) . '>' . $record['IDCODE'] . ': ' . $record['XPATH'] . '</a>', $record['IDNAME'], $record['MSG_CODE']));
                    $i++;
                }
				ClxCommon::$db->freeResult( $records);
            }
            $contents .= $table->source();
        }
        return $contents;
    }

    function checkForm(&$msg) {
        $msg = array();
        parent::checkForm($msg);
        if (strlen(UserRequest::$post['SKME_idcode']) == CLX_NUM_ZERO) {
            $msg['SKME_idcode'] = dict('GEN_LBL_FIELDREQUIRED');
        }
        if (UserRequest::$request['ac'] === 'CREATE') {
			$count = ClxCommon::$db->oneExistsRecords($this->tablename,  'MSG_CODE =' . singleQuote(UserRequest::$post['SKME_msg_code']) . ' AND IDCODE =' . singleQuote(UserRequest::$post['SKME_idcode']));
			if ($count > CLX_NUM_ZERO) {
                $msg['SKME_idcode'] = dict('GEN_LBL_ALREADYEXISTS');
            }
        }
        //Test that selected element belongs to the current message
        if (UserRequest::$post['SKME_parent_element'] <> '' && ClxCommon::$db->oneExistsRecords($this->tablename, 'IDCODE = ' . singleQuote(UserRequest::$post['SKME_parent_element']) . ' AND MSG_CODE = ' . singleQuote(UserRequest::$post['SKME_msg_code']) . ' AND ELE_TYPE IN (' . singleQuote('PNEL') . ',' . singleQuote('SXML') . ',' . singleQuote('IGNR') . ')') == CLX_NUM_ZERO) {
            $msg['SKME_parent_element'] = dict('GEN_SKME_NOTPARENT_OR_INVTYPE');
		}
        if (UserRequest::$post['SKME_parent_element'] == UserRequest::$post['SKME_idcode']) {
            $msg['SKME_parent_element'] = dict('GEN_SKME_CANTSAMEASELEMENT');
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_IDCODE') . ':', $record['SKME_idcode']);
        $table->addData(dict('GEN_LBL_MSG_CODE') . ':', $record['SKME_msg_code']);
    }

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        $record = array();
        $record['SKME_id'] = $recordid;
        $record['SKME_idcode'] = $values['IDCODE'];
        $record['SKME_idname'] = $values['IDNAME'];
        $record['SKME_msg_code'] = $values['MSG_CODE'];
        $record['SKME_seqnum'] = $values['SEQNUM'];
        $record['SKME_description'] = $values['DESCRIPTION'];
        $record['SKME_test_value'] = $values['TEST_VALUE'];
        $record['SKME_ele_type'] = $values['ELE_TYPE'];
        $record['SKME_ele_dtformat'] = $values['ELE_DTFORMAT'];
        $record['SKME_ele_thosep'] = $values['ELE_THOSEP'];
        $record['SKME_ele_decsep'] = $values['ELE_DECSEP'];
        $record['SKME_ele_decimals'] = $values['ELE_DECIMALS'];
        $record['SKME_ele_start_pos'] = $values['ELE_START_POS'];
        $record['SKME_ele_length'] = $values['ELE_LENGTH'];
        $record['SKME_ele_default'] = $values['ELE_DEFAULT'];
        $record['SKME_min_occurs'] = $values['MIN_OCCURS'];
        $record['SKME_max_occurs'] = $values['MAX_OCCURS'];
        $record['SKME_parent_element'] = $values['PARENT_ELEMENT'];
        $record['SKME_xpath'] = $values['XPATH'];
        return $record;
    }

    function defaultRecord() {
        $callingpage = peekHistory();
        $record = array();
        $record['SKME_id'] = CLX_INIT_ZERO;
        $record['SKME_idcode'] = 'ELE' . ClxCommon::$db->getOne('SELECT MAX(ID) FROM ' . $this->tablename);
        $record['SKME_idname'] = '';
        $record['SKME_msg_code'] = $callingpage['msg_code'];
        $record['SKME_seqnum'] = CLX_INIT_ZERO;
        $record['SKME_description'] = '';
        $record['SKME_test_value'] = '';
        $record['SKME_ele_type'] = 'PNEL';
        $record['SKME_ele_dtformat'] = '';
        $record['SKME_ele_thosep'] = ',';
        $record['SKME_ele_decsep'] = '.';
        $record['SKME_ele_decimals'] = '';
        $record['SKME_ele_start_pos'] = CLX_INIT_ZERO;
        $record['SKME_ele_length'] = CLX_INIT_ZERO;
        $record['SKME_ele_default'] = '';
        $record['SKME_min_occurs'] = '';
        $record['SKME_max_occurs'] = '';
        $record['SKME_parent_element'] = '';
        $record['SKME_xpath'] = '';
        return $record;
    }

    function createRecord_() {
        $record = array();
        $record['IDCODE'] = UserRequest::$post['SKME_idcode'];
        $record['IDNAME'] = UserRequest::$post['SKME_idname'];
        $record['MSG_CODE'] = UserRequest::$post['SKME_msg_code'];
        $record['SEQNUM'] = (UserRequest::$post['SKME_seqnum'] > CLX_NUM_ZERO) ? UserRequest::$post['SKME_seqnum'] : ClxCommon::$db->getField($this->tablename, 'MAX(SEQNUM)', 'MSG_CODE =  ' . singleQuote($record['MSG_CODE'])) + CLX_NUM_ONE;
        $record['DESCRIPTION'] = UserRequest::$post['SKME_description'];
        $record['TEST_VALUE'] = UserRequest::$post['SKME_test_value'];
        $record['ELE_TYPE'] = UserRequest::$post['SKME_ele_type'];
        $record['ELE_DTFORMAT'] = UserRequest::$post['SKME_ele_dtformat'];
        $record['ELE_THOSEP'] = UserRequest::$post['SKME_ele_thosep'];
        $record['ELE_DECSEP'] = UserRequest::$post['SKME_ele_decsep'];
        $record['MIN_OCCURS'] = (UserRequest::$post['SKME_min_occurs'] === '') ? 'null' : UserRequest::$post['SKME_min_occurs'];
        $record['MAX_OCCURS'] = (UserRequest::$post['SKME_max_occurs'] === '') ? 'null' : UserRequest::$post['SKME_max_occurs'];
        if (array_key_exists('SKME_ele_start_pos', UserRequest::$post))
            $record['ELE_START_POS'] = UserRequest::$post['SKME_ele_start_pos'];
        if (array_key_exists('SKME_ele_length', UserRequest::$post))
            $record['ELE_LENGTH'] = UserRequest::$post['SKME_ele_length'];
        if (array_key_exists('SKME_ele_decimals', UserRequest::$post))
            $record['ELE_DECIMALS'] = UserRequest::$post['SKME_ele_decimals'];
        $record['ELE_DEFAULT'] = UserRequest::$post['SKME_ele_default'];
        $record['PARENT_ELEMENT'] = UserRequest::$post['SKME_parent_element'];
        $record['XPATH'] = $this->buildXpath($record, '');
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $this->versionIncrease('ID', UserRequest::$post['SKME_id']);
        //Update Message Record Length
        $SKMS = &getTool('SKMS');
        $SKMS->saveLength($record['MSG_CODE']);
        return $recordid;
    }

    function saveRecord() {
        $record = array();
        $record['IDCODE'] = UserRequest::$post['SKME_idcode'];
        $record['IDNAME'] = UserRequest::$post['SKME_idname'];
        $record['SEQNUM'] = UserRequest::$post['SKME_seqnum'];
        $record['DESCRIPTION'] = UserRequest::$post['SKME_description'];
        $record['TEST_VALUE'] = UserRequest::$post['SKME_test_value'];
        $record['ELE_TYPE'] = UserRequest::$post['SKME_ele_type'];
        $record['ELE_DTFORMAT'] = UserRequest::$post['SKME_ele_dtformat'];
        $record['ELE_THOSEP'] = UserRequest::$post['SKME_ele_thosep'];
        $record['ELE_DECSEP'] = UserRequest::$post['SKME_ele_decsep'];
        $record['MIN_OCCURS'] = (UserRequest::$post['SKME_min_occurs'] === '') ? 'null' : UserRequest::$post['SKME_min_occurs'];
        $record['MAX_OCCURS'] = (UserRequest::$post['SKME_max_occurs'] === '') ? 'null' : UserRequest::$post['SKME_max_occurs'];
        if (array_key_exists('SKME_ele_start_pos', UserRequest::$post))
            $record['ELE_START_POS'] = UserRequest::$post['SKME_ele_start_pos'];
        if (array_key_exists('SKME_ele_length', UserRequest::$post))
            $record['ELE_LENGTH'] = UserRequest::$post['SKME_ele_length'];
        if (array_key_exists('SKME_ele_decimals', UserRequest::$post))
            $record['ELE_DECIMALS'] = UserRequest::$post['SKME_ele_decimals'];
        $record['PARENT_ELEMENT'] = UserRequest::$post['SKME_parent_element'];
        $record['ELE_DEFAULT'] = UserRequest::$post['SKME_ele_default'];
        $record['XPATH'] = $this->buildXpath($record, '');
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['SKME_id']);
        $this->versionIncrease('ID', UserRequest::$post['SKME_id']);
        //Update Message Record Length
        $SKMS = &getTool('SKMS');
        $SKMS->saveLength(UserRequest::$post['SKME_msg_code']);
    }

    function deleteRecordSk($id) {
        $record = ClxCommon::$db->getFields($this->tablename, 'IDCODE,MSG_CODE', 'ID=' . $id);
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
        $SKMS = &getTool('SKMS');
        $SKMS->saveLength($record['MSG_CODE']);
        $SKMS->versionIncrease('IDCODE', $record['MSG_CODE']);
    }

    function versionIncrease($fieldname, $fieldvalue) {
        $msg_code = ClxCommon::$db->getField($this->tablename, 'MSG_CODE', $fieldname . '=' . singleQuote($fieldvalue));
        $SKMS = &getTool('SKMS');
        $SKMS->versionIncrease('IDCODE', $msg_code);
    }

    function check() {
        $table = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SKME_PREVIEW'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
        $table->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => ''));
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_WIDTH => CLX_PROP_100PCT));

        $callingpage = peekHistory();
        $o = $this->check_build_xml($callingpage['msg_code']);
        //First perform a few validations
        //1. Test if all table, fields and query match
        //Second dump xml sample
        $table->addCell(dict('TOOL_SKME_SAMPLE_XML'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell('<pre>' . htmlentities($o) . '</pre>', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $b = new htmlButtonCancel(dict('GEN_LBL_RETURN'), null, 'tool.php');
        $table->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => ''));
        $table->addCell($b->source(), array(CLX_PROP_CLASS => ''));
        return $table->source();
    }

    function check_build_xml($msg_code, $level = CLX_NUM_ZERO) {
        $o = $this->check_build_xml_add_item(/*$o*/  '', $msg_code);
        if (is_object($o) === true) {
            $return = $o->source_(array('level' => $level));
        } else {
            $return = dict('GEN_LBL_NO_ELEMENTS_FOUND');
        }
        return $return;
    }

    function check_build_xml_add_item($object, $msg_code, $parent_element = false) {
        if ($object == null)
            $object = new xmlObject('xml', false);
        $parent_element = (!$parent_element) ? ' AND (PARENT_ELEMENT IS NULL OR PARENT_ELEMENT = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ')' : ' AND PARENT_ELEMENT=' . singleQuote($parent_element);
        $results = ClxCommon::$db->getRecords($this->tablename, 'MSG_CODE = ' . singleQuote($msg_code) . ' ' . $parent_element . ' ORDER BY SEQNUM');
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $o = new xmlObject($result['IDNAME'], false);
            if ($result['TEST_VALUE'] <> '')
                $content = $result['TEST_VALUE'];
            elseif (strlen($result['ELE_DEFAULT']) > CLX_NUM_ZERO)
                $content = $result['ELE_DEFAULT'];
            else
                $content = dict($this->ele_types[$result['ELE_TYPE']]);
            $o->addContents($content);
            $o = $this->check_build_xml_add_item($o, $msg_code, $result['IDCODE']);
            //Building return
            $object->addObject($o);
        }
        return $object;
    }

    function buldArray($msg_code, $level = CLX_NUM_ZERO) {
        $o = $this->check_build_xml_add_item($o, $msg_code);
        if (!empty($o)) {
            $return = $o->source_(array('level' => $level));
        } else {
            $return = dict('GEN_LBL_NO_ELEMENTS_FOUND');
        }
        return $return;
    }

    function buildArrayAddElement($array, $msg_code, $parent_element = false) {
        ClxFreeReturn($array);
        ClxFreeReturn($msg_code);
        ClxFreeReturn($parent_element);
    }

    function buildMsgXmlObject($msg_code, $parent_element = '', $object = false) {
        $cc = ($parent_element === '') ? ' (PARENT_ELEMENT IS NULL OR PARENT_ELEMENT = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ')' : ' PARENT_ELEMENT = ' . singleQuote($parent_element) . ' ';
        $sql = 'SELECT IDCODE, IDNAME, XPATH FROM ' . $this->tablename . ' WHERE MSG_CODE = ' . singleQuote($msg_code) . ' AND ' . $cc . '  ORDER BY XPATH ASC';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $obj = new xmlObject($r['IDNAME'], false);
            $obj->setProp('PATH', $r['XPATH']);
            $obj->addContents(' ');
            ClxFreeReturn($this->buildMsgXmlObject($msg_code, $r['IDCODE'], $obj));
            $object = (empty($object)) ? $obj : $object->addObject($obj);
        }
        return $object;
    }
	function buildXpath($record, $xpath = '') {
		return $this->buildXpath2($record, $xpath);
	}	
    function buildXpath2($record, $xpath = '') {
		$xpath ='/'.$record['IDNAME'].''.$xpath;
		$sql = 'SELECT * FROM ' . $this->tablename . '  WHERE IDCODE = ' . singleQuote($record['PARENT_ELEMENT']);
        $r = ClxCommon::$db->getOneRecord($sql);
        return (empty($record['PARENT_ELEMENT'])) ? $xpath : $this->buildXpath2($r, $xpath);
    }

    /**
     * Returs resultset of active elements
     *
     * @param unknown_type $mesage_code
     * @return unknown
     */
    function getElementsResults($mesage_code) {
        IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' SQL CLX_SK_ELEMENTS '. chr(13).chr(10)); fclose($kk);}       
		return ClxCommon::$db->getRecords('CLX_SK_ELEMENTS', 'MSG_CODE = ' . singleQuote($mesage_code) . ' AND ELE_TYPE <> ' . singleQuote('IGNR') . '
								ORDER BY SEQNUM ASC');
    }

}
