<?php

/**
 * Service Messages Mappings
 * Webservices Service Messages Mappings
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 *
 * CHANGE LOG
 *  Included label
 */
class sk_mappings extends clx_tool {

    var $editform;

    function __construct() {
        $this->code = 'SKMP';
        $this->name = 'Service Messages Mappings';
        $this->system = 'Sockets';
        $this->version = '5.5.0.0';



        $this->accesskey = 'EBSK';
        $this->tablename = 'CLX_SK_MAPPINGS';
        $this->record_name_singular = 'GEN_LBL_MAPPING';
        $this->record_name_plural = 'GEN_LBL_MAPPINGS';
        $this->primary_field = 'IDCODE';
        $this->secondary_field = 'ELEMENT_CODE';
        $this->seqnum_field = 'SEQNUM';
        $this->yes_no = array('0' => 'GEN_LBL_NO', '1' => 'GEN_LBL_YES');
        $this->read_only = array('0' => 'GEN_LBL_NEVER', '1' => 'GEN_LBL_ALWAYS', '2' => 'GEN_LBL_ONCREATE', '3' => 'GEN_LBL_ONMODIFY');
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_SKMP_TITLE_CREATE',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_MSG_CODE',
                            'fields' => array(
                                array('name' => 'msg_code', 'type' => 'string', 'default' => '', 'size' => '16', 'displaysize' => '16', 'readonly' => true))
                        ), array('label' => 'GEN_LBL_IDCODE',
                            'fields' => array(
                                array('name' => 'idcode', 'type' => 'string', 'default' => '', 'size' => '16', 'displaysize' => '64', 'dontmodify' => true,
                                    'validations' => array(
                                        array('type' => 'unique', 'fieldname' => 'IDCODE', 'tablename' => $this->tablename), array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_QUERYCODE',
                            'fields' => array(
                                array('name' => 'querycode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBQY', 'validations' => array(
                                        array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_DB_QUERIES'), array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_TABLE',
                            'fields' => array(
                                array('name' => 'tablecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBTB', 'dontmodify' => false, 'readonly' => false,
                                    'validations' => array(
                                        array('type' => 'string', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_DB_TABLES'))
                                )
                            )
                        )
                    )
                )
            )
        );
        $this->viewform = $this->editform;
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['MSG_CODE'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['QUERYCODE'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['TABLECODE'] = array('type' => 'varchar(4)', 'null' => 'YES', 'properties' => '');
        $fields['SEQNUM'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'MSG_CODE');
        $indexes[$ipf . '06'] = array('index' => 'MUL', 'fieldname' => 'TABLECODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

//-- S O C K E T  M A P P I N G S
    function pack($record) {
        $o = $this->packRecord($record);
        $objs = new XMLObject($this->code . '_OBJECTS');
        $this->packsub($objs, 'SKMF', 'SELECT * FROM CLX_SK_MAP_FIELDS WHERE MAP_CODE=' . singleQuote($record['IDCODE']));
        $this->packsub($objs, 'SKMC', 'SELECT * FROM CLX_SK_CRITERIAS WHERE MAP_CODE=' . singleQuote($record['IDCODE']));
        $o->addObject($objs);
        return $o;
    }

    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        $exists = (ClxCommon::$db->oneExistsRecords($this->tablename, 'UPPER(IDCODE)=' . singleQuote(uppercase($record['IDCODE']))) > CLX_NUM_ZERO);
        if ($exists === true) {
            ClxCommon::$db->deleteRecords($this->tablename, 'UPPER(IDCODE)=' . singleQuote(uppercase($record['IDCODE'])));
        }
        $id = ClxCommon::$db->createRecord($this->tablename, $record, false);
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
            $objs = $package->getObjectXml($this->code . '_OBJECTS');
            foreach ($objs->objects as $o) {
                $toolcode = $o->tag;
                $tool = getTool($toolcode);
                $tool->unpack(array('package' => $o, 'id' => $id));
            }
        }
    }

    function makepanel($message_code = null) {
        if ($this->getAccess()->canRead()) {
            $t = time();
            $to = $this->code;
            $here = 'tool.php?to=' . $to . '&t=' . $t;
            $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
            $form->setProp(CLX_PROP_ID, 'SKMPPanel');
            $form->addArgument(CLX_PROP_TO, $this->code);
            $form->addArgument('message_code', $message_code);
            $form->addArgument('ac', 'NOT_DEFINED');
            $selectclause = '*';
            $fromclause = $this->tablename;
            $whereclause = 'MSG_CODE=' . singleQuote($message_code);
            $sortclause = 'SEQNUM, IDCODE, TABLECODE';
            $page = new xPaging();
            $page->setProp('rpp', CLX_NUM_TEN_THOUSAND);
            $page->setProp('printheaders', false);
            $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
            $SKMF = getTool('SKMF');
            $table = new htmlTable(CLX_WIDTH_SIX);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $page->header($table);
            /* $table->addCells(CLX_CLASS_HEADERS,array(
              dict('GEN_LBL_SEL'), dict('GEN_LBL_TABLECODE'))); */
            $table->addCell(dict('GEN_LBL_SEL'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS));
            $table->addCell(dict('GEN_LBL_TABLECODE'), array(CLX_PROP_COLSPAN => '5', CLX_PROP_CLASS => CLX_CLASS_HEADERS));
            $i = CLX_INIT_ZERO;
            while ($record = $page->nextRecord()) {
                $recordid = $record['ID'];
                $select = new htmlCheckbox('selector_' . $recordid, false);
                $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
                $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATAALT, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
                $tb = $record['IDCODE'] . ': ' . tableName($record['TABLECODE']) . ' (' . $record['TABLECODE'] . ')';
                //Display criterias
                $table->addCell($tb, array(CLX_PROP_CLASS => CLX_CLASS_DATAALT));
                $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SOURCE'), dict('GEN_LBL_READ_ONLY'), dict('GEN_LBL_SEARCH_KEY'), dict('GEN_LBL_CLXFIELD_FORMAT')));
                $i++;
                //Adding fields tool SKMF
                $sql = 'SELECT ID, FIELDNAME, VAL_TYPE,VAL_ELEMENT, VAL_FORMULA, READ_ONLY, SEARCH_KEY,CLXFIELD_FORMAT, VAL_MAP_FIELD FROM CLX_SK_MAP_FIELDS WHERE MAP_CODE =' . singleQuote($record['IDCODE']) . ' ORDER BY ID ASC';
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $buttons = '';
                    if (strpos(lowercase(UserRequest::$server['PHP_SELF']), 'index.php') !== null) {
                        $target = 'tool.php';
                    } else {
                        $target = UserRequest::$server['PHP_SELF'];
                    }
                    $url = $target . '?to=SKMF&ac=MODIFY&idlist=' . $r['ID'];
                    $buttons .= getSkinIcon('MODIFY', $url, 'MODIFY');
                    $url = $target . '?to=SKMF&ac=DISPLAY&idlist=' . $r['ID'];
                    $buttons .= getSkinIcon('view', $url, 'DISPLAY');
                    $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addCell($r['FIELDNAME'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $type = dict($SKMF->val_types[$r['VAL_TYPE']]);
                    if (!empty($r['VAL_FORMULA'])) {
                        $type = dict('GEN_LBL_FORMULA');
                    }
                    if ($r['VAL_ELEMENT'] <> '') {
                        $ele = ClxCommon::$db->getFields('CLX_SK_ELEMENTS', 'IDCODE, IDNAME, MSG_CODE, XPATH', 'IDCODE =' . singleQuote($r['VAL_ELEMENT']));
                        if (!empty($ele['XPATH']))
                            $ele['IDNAME'] = $ele['XPATH'];
                        $type .= '<br>' . $ele['IDCODE'] . ': ' . $ele['XPATH'];
                    }
                    if ($r['VAL_MAP_FIELD'] <> '') {
                        $ele = ClxCommon::$db->getFields('CLX_SK_MAP_FIELDS', 'IDCODE, TABLECODE, FIELDNAME', 'IDCODE =' . singleQuote($r['VAL_MAP_FIELD']));
                        $type .= '<br>' . $ele['IDCODE'] . ': ' . $ele['TABLECODE'] . '.' . $ele['FIELDNAME'];
                    }
                    $table->addCell($type, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addCell(dict($this->read_only[$r['READ_ONLY']]), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addCell(dict($this->yes_no[$r['SEARCH_KEY']]), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addCell(dict($this->yes_no[$r['CLXFIELD_FORMAT']]), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                }
            }

            $buttons = htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            if ($this->getAccess()->canModify()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDelete()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDisplay()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_MAPPINGS')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
            }
            if (($page->getProp('qty') > CLX_NUM_ONE) and $this->getAccess()->canModify()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_REORDER'), array('action' => 'REORDER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
            }
            $form->addContents($page->footers($table, $buttons));
            return buildPanelInterface(dict('TOOL_SKMP_TITLE_LIST'), 'EB_SOCKET_MAPPINGS_' . $message_code, $form->source(), CLX_NUM_MINUS_1);
        } else {
            return CLX_CHAR_EMPTY_STRING;
        }
    }

    function editForm($ac, $idlist, $record, $msg) {
        $this->editform['TITLE'] = (UserRequest::$request['ac'] === 'MODIFY') ? 'TOOL_' . $this->code . '_TITLE_MODIFY' : 'TOOL_' . $this->code . '_TITLE_CREATE';
        $form = new clx_form($this->code, $this->editform);
        return $form->editForm($ac, $idlist, $record, $msg);
    }

    function viewFormFill($record) {
        addHistory('map_code', $record['SKMP_idcode']);
        $contents = '';
        $SKMF = &getTool('SKMF');
        $contents .= $SKMF->makepanel($record['SKMP_idcode']);
        //Criterias
        $SKMC = &getTool('SKMC');
        $contents .= $SKMC->makepanel($record['SKMP_idcode']);
        //Translations Moved to skmf
        return $contents;
    }

    function searchForm() {
        $contents = '';
        $msg = array();
        // Search Form
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'SEARCH');
        $form->addArgument('confirm', '1');
        $form->addArgument(CLX_PROP_TARGET, UserRequest::$request[CLX_PROP_TARGET]);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SKMP_TITLE_SEARCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addField($msg, dict('GEN_LBL_IDCODE') . ':', 'SKMP_idcode', (array_key_exists('SKMP_idcode', UserRequest::$post)) ? UserRequest::$post['SKMP_idcode'] : '', CLX_NUM_16, CLX_NUM_16);
        $table->addField($msg, dict('GEN_LBL_TABLECODE') . ':', 'SKMP_tablecode', (array_key_exists('SKMP_tablecode', UserRequest::$post)) ? UserRequest::$post['SKMP_tablecode'] : '', CLX_NUM_32, CLX_NUM_64);
        $buttons = htmlButton::getButton('submit', dict('GEN_LBL_SEARCH'), array('action' => 'SEARCH', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents .= $form->source();
        // Search Procedure
        if (isset(UserRequest::$post['confirm'])) {
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $criteria = '';
            if (UserRequest::$post['SKMP_idcode'] <> '') {
                $criteria .= 'UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['SKMP_idcode']) . '%');
            }
            if (UserRequest::$post['SKMP_element_code'] <> '') {
                $criteria .= 'UPPER(TABLECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['SKMP_tablecode']) . '%');
            }
            $qty = ClxCommon::$db->oneExistsRecords($this->tablename, $criteria);
            if ($qty == CLX_NUM_ZERO) {
                $table->addCell(dict('TOOL_GEN_ERR_NOMATCH'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            } else {
                $table->addCell(dict('TOOL_GEN_MSG_FOUNDRECORDS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
                $records = ClxCommon::$db->getRecords($this->tablename, $criteria);
                $i = CLX_INIT_ZERO;
                while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
                    $js = 'javascript:setLookupValue(' . quote(UserRequest::$request[CLX_PROP_TARGET]) . ', ' . quote($record['TABLECODE']) . ');';
                    $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array('<page t=sk_mappings></page><a href=' . singleQuote($js) . '>' . $record['MSG_CODE'] . '</a>', $record['TABLECODE']));
                    $i++;
                }
				ClxCommon::$db->freeResult( $records);
            }
            $contents .= $table->source();
        }
        return $contents;
    }

    function checkForm(&$msg) {
        $msg = array();
        if (ClxCommon::$db->oneExistsRecords('CLX_DB_QUERIES', 'IDCODE = ' . singleQuote(UserRequest::$post['SKMP_querycode'])) == CLX_NUM_ZERO) {
            $msg['SKMP_querycode'] = dict('GEN_LBL_FIELDREQUIREDORNOTVALID');
        }
        if (ClxCommon::$db->oneExistsRecords('CLX_DB_QUERY_TABLES', 'QUERYCODE = ' . singleQuote(UserRequest::$post['SKMP_querycode']) . ' AND TABLECODE = ' . singleQuote(UserRequest::$post['SKMP_tablecode'])) == CLX_NUM_ZERO) {
            $msg['SKMP_tablecode'] = dict('GEN_LBL_FIELDREQUIREDORNOTVALID');
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_IDCODE') . ':', $record['SKMP_idcode']);
        $table->addData(dict('GEN_LBL_TABLECODE') . ':', $record['SKMP_tablecode']);
    }

    function reorderRecords() {
        $sql = 'SELECT SKMP.ID, SKMP.IDCODE, SKMP.TABLECODE, DBTB.IDNAME, DBTB.MODULECODE FROM ' . $this->tablename . ' SKMP LEFT JOIN CLX_DB_TABLES DBTB ON DBTB.IDCODE = SKMP.TABLECODE WHERE SKMP.MSG_CODE=' . singleQuote(UserRequest::$post['message_code']) . ' 				ORDER BY SKMP.SEQNUM ASC';
        $records = ClxCommon::$db->executeQuery($sql);
        $list = array();
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
            $list[$record['ID']] = $record['IDCODE'] . ': ' . $record['MODULECODE'] . '_' . $record['IDNAME'] . ' (' . $record['TABLECODE'] . ')';
        }
		ClxCommon::$db->freeResult( $records);
        return $list;
    }

    function reorderAction() {
        parent::reorderAction();
        $callingpage = peekHistory();
        $msg_code = $callingpage['msg_code'];
        $SKME = &getTool('SKME');
        $SKME->versionIncrease('IDCODE', $msg_code);
    }

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        $record = array();
        $record['SKMP_id'] = $recordid;
        $record['SKMP_idcode'] = $values['IDCODE'];
        $record['SKMP_msg_code'] = $values['MSG_CODE'];
        $record['SKMP_querycode'] = $values['QUERYCODE'];
        $record['SKMP_tablecode'] = $values['TABLECODE'];
        return $record;
    }

    function defaultRecord() {
        $callingpage = peekHistory();
        $record = array();
        $record['SKMP_id'] = CLX_INIT_ZERO;
        $record['SKMP_idcode'] = 'MAP' . ClxCommon::$db->getOne('SELECT MAX(ID) FROM ' . $this->tablename);
        $record['SKMP_msg_code'] = $callingpage['msg_code'];
        $record['SKMP_querycode'] = '';
        $record['SKMP_tablecode'] = '';
        return $record;
    }

    function createRecord_() {
        $record = array();
        $record['IDCODE'] = UserRequest::$post['SKMP_idcode'];
        $record['MSG_CODE'] = UserRequest::$post['SKMP_msg_code'];
        $record['QUERYCODE'] = UserRequest::$post['SKMP_querycode'];
        $record['TABLECODE'] = UserRequest::$post['SKMP_tablecode'];
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $this->versionIncrease('ID', UserRequest::$post['SKMP_id']);
        //Adding table field for mappings
        $sql = 'SELECT * FROM ( SELECT (SELECT MAX(X.ID) FROM CLX_SK_MAP_FIELDS X) IDCODE, ' . singleQuote($record['MSG_CODE']) . ' MSG_CODE, null ELEMENT_CODE, ' . singleQuote($record['IDCODE']) . ' MAP_CODE, ' . singleQuote($record['QUERYCODE']) . ' QUERYCODE, DBTF.TABLECODE, DBTF.FIELDNAME, null PRMT_NAME, null VAL_ELEMENT, ' . singleQuote('IGNR') . ' VAL_TYPE, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' VAL_FORMULA, 0 CLXFIELD_FORMAT, 0 SEARCH_KEY, 0 READ_ONLY FROM CLX_DB_TABLEFIELDS DBTF WHERE DBTF.TABLECODE =' . singleQuote($record['TABLECODE']) . ' ORDER BY DBTF.SEQNUM ASC) AA UNION '.
               'SELECT * FROM ( SELECT (SELECT MAX(X.ID) FROM CLX_SK_MAP_FIELDS X) IDCODE, ' . singleQuote($record['MSG_CODE']) . ' MSG_CODE, null ELEMENT_CODE, ' . singleQuote($record['IDCODE']) . ' MAP_CODE, ' . singleQuote($record['QUERYCODE']) . ' QUERYCODE, DBTF.TABLECODE, CONCAT(DBTF.FIELDNAME,'.singlequote('_WRK').') FIELDNAME, null PRMT_NAME, null VAL_ELEMENT, ' . singleQuote('IGNR') . ' VAL_TYPE, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' VAL_FORMULA, 0 CLXFIELD_FORMAT, 0 SEARCH_KEY, 0 READ_ONLY FROM CLX_DB_TABLEDFIELDS DBTF WHERE DBTF.TABLECODE =' . singleQuote($record['TABLECODE']) . '      AND EXISTS (SELECT 1 FROM CLX_DB_QUERY_FIELDS X WHERE CONCAT(DBTF.FIELDNAME,'.singlequote('_WRK').')=X.FIELDNAME AND QUERYCODE= '.singleQuote($record['QUERYCODE']).' AND LENGTH( EXPRESSION )>1 )   ' . ' ORDER BY DBTF.SEQNUM ASC) BB';
     //   ECHO $sql;
		$rs = ClxCommon::$db->executeQuery($sql);
        $i = CLX_INIT_ZERO;
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            if ($i == CLX_NUM_ZERO) {
                $i = $r['IDCODE'];
            }
            $i++;
            $r['IDCODE'] = 'MAPF' . $i;
            ClxCommon::$db->createRecord('CLX_SK_MAP_FIELDS', $r, false);
        }
        return $recordid;
    }

    function saveRecord() {
        $record = array();
        $record['MSG_CODE'] = UserRequest::$post['SKMP_msg_code'];
        $record['TABLECODE'] = UserRequest::$post['SKMP_tablecode'];
        $record['QUERYCODE'] = UserRequest::$post['SKMP_querycode'];
        $record['IDCODE'] = UserRequest::$post['SKMP_idcode'];
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['SKMP_id']);
        $this->versionIncrease('ID', UserRequest::$post['SKMP_id']);
    }

    function deleteRecordSk($id) {
        $record = ClxCommon::$db->getFields($this->tablename, 'IDCODE,MSG_CODE', 'ID=' . $id);
        $SKMF = getTool('SKMF');
        $rs = ClxCommon::$db->executeQuery('SELECT ID FROM ' . $SKMF->tablename . '  WHERE MAP_CODE=' . singleQuote($record['IDCODE']));
        while ($r = ClxCommon::$db->getNextRecord($rs, NUMERIC)) {
            $SKMF->deleteRecordSk($r[CLX_NUM_ZERO]);
        }
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
        $SKMS = &getTool('SKMS');
        $SKMS->versionIncrease('IDCODE', $record['MSG_CODE']);
    }

    function versionIncrease($fieldname, $fieldvalue) {
        $msg_code = ClxCommon::$db->getField($this->tablename, 'MSG_CODE', $fieldname . '=' . singleQuote($fieldvalue));
        $SKMS = &getTool('SKMS');
        $SKMS->versionIncrease('IDCODE', $msg_code);
    }

}
