<?php

/**
 * Mapping Translations
 * Webservices Mapping Translations
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 *
 * CHANGE LOG
 *  Included label
 */
class sk_translations extends clx_tool {

    var $translations;

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'SKMT';
        $this->name = 'Services mapping translation';
        $this->system = 'Sockets';
        $this->version = '5.5.0.0';

        $this->accesskey = 'SKMS';


        $this->tablename = 'CLX_SK_TRANSLATIONS';
        $this->record_name_singular = 'GEN_LBL_TRANSLATION';
        $this->record_name_plural = 'GEN_LBL_TRANSLATIONS';
        $this->primary_field = 'MAPF_CODE';
        $this->secondary_field = 'OLD_VALUE';

        $this->translations = array();
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_SKMT_TITLE_CREATE',
		  'panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_MAPF_CODE',
					   'fields' => array(
						  array('name' => 'mapf_code', 'type' => 'string', 'readonly' => '1'))
			         ), array('label' => 'GEN_LBL_TRANSL_CODE',
					   'caption' => 'GEN_LBL_TRANSL_SET_DESC',
					   'fields' => array(
						  array('name' => 'transl_code', 'type' => 'lookup', 'default' => '', 'tool' => 'TRTS', 'validations' => array(
								array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_SYS_TRANSL_SETS'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_ORIGINAL_VALUE',
					   'fields' => array(
						  array('name' => 'original_value', 'type' => 'string', 'default' => '', 'size' => '255', 'displaysize' => '64'))
			         ), array('label' => 'GEN_LBL_REPLACE_VALUE',
					   'fields' => array(
						  array('name' => 'replace_value', 'type' => 'string', 'default' => '', 'size' => '255', 'displaysize' => '64'))
			         ), array('label' => 'GEN_LBL_CASE_SENSITIVE',
					   'fields' => array(
						  array('name' => 'case_sensitive', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => array('0' => 'GEN_LBL_NO', '1' => 'GEN_LBL_YES')))
			         )
			     )
			 )
		  )
        );
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['MAPF_CODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['TRANSL_CODE'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['ORIGINAL_VALUE'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['REPLACE_VALUE'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['CASE_SENSITIVE'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['SEQNUM'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'MAPF_CODE,SEQNUM');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'ORIGINAL_VALUE');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'TRANSL_CODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes,
		  'case_sensitive' => true);
    }

    function makepanel($groupcode = null) {
        if ($this->getAccess()->canRead()) {
		  $t = time();
		  $to = $this->code;
		  $here = 'tool.php?to=' . $to . '&t=' . $t;
		  $yesno = array(dict('GEN_LBL_NO'), dict('GEN_LBL_YES'));
		  $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
		  $form->setProp(CLX_PROP_ID, 'SKMTPanel');
		  $form->addArgument(CLX_PROP_TO, $this->code);
		  $form->addArgument('mapf_code', $groupcode);
		  $form->addArgument('ac', 'NOT_DEFINED');
		  $selectclause = '*';
		  $fromclause = $this->tablename;
		  $whereclause = 'MAPF_CODE=' . singleQuote($groupcode);
		  $sortclause = 'ORIGINAL_VALUE ASC';
		  $page = new xPaging();
		  $page->setProp('rpp', CLX_NUM_TEN_THOUSAND);
		  $page->setProp('printheaders', false);
		  $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
		  $table = new htmlTable(CLX_WIDTH_FIVE);
		  $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
		  $page->header($table);
		  $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_TRANSL_CODE'), dict('GEN_LBL_ORIGINAL_VALUE'), dict('GEN_LBL_REPLACE_VALUE'), dict('GEN_LBL_CASE_SENSITIVE')));
		  $i = CLX_INIT_ZERO;
		  while ($record = $page->nextRecord()) {
			 $recordid = $record['ID'];
			 $select = new htmlCheckbox('selector_' . $recordid, false);
			 $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
			 $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
			 $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['TRANSL_CODE'], $record['ORIGINAL_VALUE'], $record['REPLACE_VALUE'], $yesno[$record['CASE_SENSITIVE']]));
			 $i++;
		  }
		  $buttons = '';
		  if ($this->getAccess()->canModify()) {
			 $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
		  }
		  if ($this->getAccess()->canDelete()) {
			 $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
		  }
		  if ($this->getAccess()->canDisplay()) {
			 $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_TRANSLATION')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
		  }
		  $form->addContents($page->footers($table, $buttons));
		  return buildPanelInterface(dict('TOOL_SKMT_TITLE_LIST'), 'EB_SOCKET_TRANSLATIONS_' . $groupcode, $form->source(), CLX_NUM_MINUS_1);
        } else {
		  return CLX_CHAR_EMPTY_STRING;
        }
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_MAPF_CODE') . ':', $record['SKMT_mapf_code']);
        $table->addData(dict('GEN_LBL_ORIGINAL_VALUE') . ':', $record['SKMT_original_value']);
        $table->addData(dict('GEN_LBL_REPLACE_VALUE') . ':', $record['SKMT_replace_value']);
    }

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        $record = array();
        $record['SKMT_id'] = $recordid;
        $record['SKMT_mapf_code'] = $values['MAPF_CODE'];
        $record['SKMT_transl_code'] = $values['TRANSL_CODE'];
        $record['SKMT_original_value'] = $values['ORIGINAL_VALUE'];
        $record['SKMT_replace_value'] = $values['REPLACE_VALUE'];
        $record['SKMT_case_sensitive'] = $values['CASE_SENSITIVE'];
        $record['SKMT_seqnum'] = $values['SEQNUM'];
        return $record;
    }

    function saveRecord() {
        $record = array();
        $record['TRANSL_CODE'] = UserRequest::$post['SKMT_transl_code'];
        $record['ORIGINAL_VALUE'] = UserRequest::$post['SKMT_original_value'];
        $record['REPLACE_VALUE'] = UserRequest::$post['SKMT_replace_value'];
        $record['CASE_SENSITIVE'] = UserRequest::$post['SKMT_case_sensitive'];
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['SKMT_id']);
        $this->versionIncrease('ID', UserRequest::$post['SKMT_id']);
    }

    function createRecord_() {
        $record = array();
        $record['MAPF_CODE'] = UserRequest::$post['SKMT_mapf_code'];
        $record['SEQNUM'] = '0';
        $record['TRANSL_CODE'] = UserRequest::$post['SKMT_transl_code'];
        $record['ORIGINAL_VALUE'] = UserRequest::$post['SKMT_original_value'];
        $record['REPLACE_VALUE'] = UserRequest::$post['SKMT_replace_value'];
        $record['CASE_SENSITIVE'] = UserRequest::$post['SKMT_case_sensitive'];
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $this->versionIncrease('ID', $recordid);
    }

    function deleteRecordSk($id) {
        $this->versionIncrease('ID', $id);
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    function defaultRecord() {
        $callingpage = peekHistory();
        $record = array();
        $record['EBIM_id'] = CLX_INIT_ZERO;
        $record['SKMT_mapf_code'] = $callingpage['mapf_code'];
        $record['SKMT_transl_code'] = '';
        $record['SKMT_original_value'] = '';
        $record['SKMT_replace_value'] = '';
        $record['SKMT_case_sensitive'] = '0';
        $record['SKMT_seqnum'] = '0';
        return $record;
    }

    function versionIncrease($fieldname, $fieldvalue) {
        $mapf_code = ClxCommon::$db->getField($this->tablename, 'MAPF_CODE', $fieldname . '=' . singleQuote($fieldvalue));
        $SKMF = &getTool('SKMF');
        $SKMF->versionIncrease('IDCODE', $mapf_code);
    }

    function getTranslations($message_code, $direction = '0') {
        $sql = 'SELECT  Z.REPLACE_VALUE, Z.ORIGINAL_VALUE,  Z.MAPF_CODE, SKMP.MSG_CODE, Z.CASE_SENSITIVE FROM  CLX_SK_ELEMENTS SKME, CLX_SK_MAPPINGS SKMP, CLX_SK_MAP_FIELDS SKMF, CLX_SK_TRANSLATIONS Z WHERE  SKMP.IDCODE = SKMF.MAP_CODE AND SKMF.IDCODE = Z.MAPF_CODE AND SKMP.MSG_CODE = ' . singleQuote($message_code) . ' UNION ALL SELECT  Z.REPLACE_VALUE, Z.ORIGINAL_VALUE,  X.MAPF_CODE, SKMP.MSG_CODE, Z.CASE_SENSITIVE FROM CLX_SK_MAPPINGS SKMP, CLX_SK_MAP_FIELDS SKMF, CLX_SK_TRANSLATIONS X, CLX_SYS_TRANSL_SETS Y, CLX_SYS_TRANSL_ITEMS Z WHERE  SKMP.IDCODE = SKMF.MAP_CODE AND SKMF.IDCODE = X.MAPF_CODE AND Y.IDCODE = Z.TRANSL_CODE AND X.TRANSL_CODE = Y.IDCODE AND Z.DIRECTION = ' . $direction . ' AND SKMP.MSG_CODE = ' . singleQuote($message_code);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $this->translations[$r['MAPF_CODE']][uppercase($r['ORIGINAL_VALUE'])] = $r;
        }
		ClxCommon::$db->freeResult( $rs );
    }

    function translate2($mapf_code, &$field_value, $direction = CLX_NUM_ZERO) {
        ClxFreeReturn($direction);
        if (!array_key_exists($mapf_code, $this->translations))
		  return;
        $translations = $this->translations[$mapf_code];
        if (array_key_exists(uppercase($field_value), $translations)) {
		  $info = $translations[uppercase($field_value)];
		  if ($info['case_sensitive'] === true) {
			 if (strcmp($field_value, $info['ORIGINAL_VALUE']) == CLX_NUM_ZERO) {
			     $field_value = $info['REPLACE_VALUE'];
			 }
		  } else {
			 $field_value = $info['REPLACE_VALUE'];
		  }
        }
    }

    /**
     * Performs translation of a value
     */
    function translate($mapf_code, &$value, $direction = CLX_NUM_ZERO) {
        $sql = 'SELECT  Z.REPLACE_VALUE FROM  CLX_SK_TRANSLATIONS Z WHERE  Z.MAPF_CODE = ' . singleQuote($mapf_code) . '  AND Z.ORIGINAL_VALUE = ' . singleQuote(clxCommon::$db->addslashes($value)) . '			       UNION ALL SELECT  Z.REPLACE_VALUE FROM CLX_SK_TRANSLATIONS X, CLX_SYS_TRANSL_SETS Y, CLX_SYS_TRANSL_ITEMS Z WHERE  Y.IDCODE = Z.TRANSL_CODE AND X.TRANSL_CODE = Y.IDCODE AND Z.ORIGINAL_VALUE = ' . singleQuote(clxCommon::$db->addslashes($value)) . '  AND X.MAPF_CODE = ' . singleQuote($mapf_code) . ' AND Z.DIRECTION = ' . $direction . ' ';
        $translation = ClxCommon::$db->getOne($sql);
        if (strlen($translation) > CLX_NUM_ZERO) {
		  $value = $translation;
        }
    }

}
