<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 * @copyright    Alenet, Inc.
 * @package		Clientix.Tool.System
 * @abstract		Process Engine Managers
 * @author       $Author: jclerma $
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version      $Rev: 9615 $
 *
 * CHANGE LOG
 *  Included label
 */
class sys_alerts extends clx_tool {

    var $syal_debug = true;

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'SYAL';
        $this->name = 'System Alerts Manager';
        $this->system = 'System';
        $this->version = '5.5.0.0';


        $this->has_access = true;
        $this->has_package = true;

        $this->tablename = 'CLX_SYS_ALERTS';
        $this->record_name_singular = 'GEN_LBL_SYS_ALERT';
        $this->record_name_plural = 'GEN_LBL_SYS_ALERTS';
        $this->primary_key = array('IDCODE');
        $this->primary_field = 'IDCODE';
        $this->secondary_field = 'IDNAME';

        $this->quickfilterform = array(CLX_CLASS_TITLE => 'TOOL_SYAL_TITLE_CREATE',
		  'panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_CODE',
					   'fields' => array(
						  array('name' => 'idcode',
						      'type' => 'string',
						      'default' => '',
						      'size' => '16',
						      'displaysize' => '16',
						      'dontmodify' => '1'))),
			         array('label' => 'GEN_LBL_NAME',
					   'fields' => array(
						  array('name' => 'idname',
						      'type' => 'string',
						      'default' => '',
						      'size' => '64',
						      'displaysize' => '48'))),
			         array('label' => 'GEN_LBL_MODULECODE',
					   'fields' => array(
						  array('name' => 'modulecode',
						      'type' => 'lookup',
						      'default' => '',
						      'tool' => 'DBMO')))))));
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_SYAL_TITLE_CREATE',
		  'panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_CODE',
					   'fields' => array(
						  array('name' => 'idcode',
						      'type' => 'string',
						      'default' => '',
						      'size' => '16',
						      'displaysize' => '16',
						      'dontmodify' => '1',
						      'validations' => array(
								array('type' => 'sqlobject',
								    'required' => '1'),
								array('type' => 'unique',
								    'fieldname' => 'idcode',
								    'tablename' => $this->tablename))))), array('label' => 'GEN_LBL_NAME',
					   'fields' => array(
						  array('name' => 'idname',
						      'type' => 'string',
						      'default' => '',
						      'size' => '64',
						      'displaysize' => '48',
						      'validations' => array(
								array('type' => 'string',
								    'required' => '1'))))),
			         array('label' => 'GEN_LBL_MODULECODE',
					   'fields' => array(
						  array('name' => 'modulecode',
						      'type' => 'lookup',
						      'default' => '',
						      'tool' => 'DBMO',
						      'validations' => array(
								array('type' => 'sqlobject',
								    'required' => '1'),
								array('type' => 'lookup',
								    'fieldname' => 'idcode',
								    'tablename' => 'CLX_DB_MODULES'))))),
			         array('label' => 'GEN_LBL_DESCRIPTION',
					   'fields' => array(
						  array('name' => 'description',
						      'type' => 'text',
						      'default' => '',
						      'cols' => '48',
						      'rows' => '4'))),
			         array('label' => 'GEN_LBL_VERSION',
					   'fields' => array(
						  array('name' => 'version',
						      'type' => 'string',
						      'default' => '1.0.0',
						      'size' => '32',
						      'displaysize' => '16',
						      'validations' => array(
								array('type' => 'string',
								    'required' => '1'))))),
			         array('label' => 'GEN_LBL_TEST_PARAMETERS',
					   'caption' => 'GEN_LBL_TEST_PARAMT_SAMPLE',
					   'fields' => array(
						  array('name' => 'test_parameters',
						      'type' => 'text',
						      'default' => '',
						      'cols' => '48',
						      'rows' => '2'))))),
			 array('type' => 'normal',
			     CLX_CLASS_TITLE => 'TOOL_SYAL_TMPLANDQRY',
			     'caption' => 'TOOL_SYAL_TMPLANDQRY_CAP',
			     'entries' => array(
			         array('label' => 'GEN_LBL_TEMPLATECODE',
					   'fields' => array(
						  array('name' => 'templatecode',
						      'type' => 'lookup',
						      'default' => '',
						      'tool' => 'UITM',
						      'validations' => array(
								array('type' => 'sqlobject',
								    'required' => '1'),
								array('type' => 'lookup',
								    'fieldname' => 'idcode',
								    'tablename' => 'CLX_UI_TEMPLATES'))))),
			         array('label' => 'GEN_LBL_QUERYCODE',
					   'fields' => array(
						  array('name' => 'querycode',
						      'type' => 'lookup',
						      'default' => '',
						      'tool' => 'DBQY',
						      'validations' => array(
								array('type' => 'sqlobject',
								    'required' => '1'),
								array('type' => 'lookup',
								    'fieldname' => 'idcode',
								    'tablename' => 'CLX_DB_QUERIES'))))),
			         array('label' => 'GEN_LBL_EMAIL_FIELDNAME',
					   'fields' => array(
						  array('name' => 'email_fieldname',
						      'type' => 'lookup',
						      'tool' => 'DBQF',
						      'DBQF_querycode' => 'SYAL_querycode',
						      'validations' => array(
								array('type' => 'string',
								    'required' => '1'),
								array('type' => 'query',
								    'query' => 'SELECT FIELDNAME SYAL_EMAIL_FIELDNAME FROM CLX_DB_QUERY_FIELDS WHERE QUERYCODE=' . singleQuote('SYAL_querycode') . ' AND FIELDNAME = ' . singleQuote('SYAL_email_fieldname') . ''))))),
			         array('label' => 'GEN_LBL_USER_FIELDNAME',
					   'fields' => array(
						  array('name' => 'user_fieldname',
						      'type' => 'lookup',
						      'tool' => 'DBQF',
						      'DBQF_querycode' => 'SYAL_querycode',
						      'validations' => array(
								array('type' => 'query',
								    'query' => 'SELECT FIELDNAME SYAL_USER_FIELDNAME FROM CLX_DB_QUERY_FIELDS WHERE QUERYCODE=' . singleQuote('SYAL_querycode') . ' AND FIELDNAME = ' . singleQuote('SYAL_user_fieldname') . ''))))))),
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_EMAIL_NOTICE',
					   'fields' => array(
						  array('name' => 'email_notice',
						      'type' => CLX_CLASS_LIST,
						      'default' => '0',
						      'options' => $this->yesno))), array('label' => 'GEN_LBL_FROM_USER',
					   'fields' => array(
						  array('name' => 'from_user',
						      'type' => 'lookup',
						      'default' => '',
						      'tool' => 'ACUS',
						      'validations' => array(
								array('type' => 'sqlobject',
								    'required' => '0'),
								array('type' => 'lookup',
								    'fieldname' => 'username',
								    'tablename' => 'CLX_AC_USERS'))))),
			         array('label' => 'GEN_LBL_EMAIL_COPYFROM',
					   'fields' => array(
						  array('name' => 'email_copyfrom',
						      'type' => CLX_CLASS_LIST,
						      'default' => '0',
						      'options' => $this->yesno))), array('label' => 'GEN_LBL_TASK_NOTICE',
					   'fields' => array(
						  array('name' => 'task_notice',
						      'type' => CLX_CLASS_LIST,
						      'default' => '0',
						      'options' => $this->yesno))), array('label' => 'GEN_LBL_ALERT_NOTICE',
					   'fields' => array(
						  array('name' => 'alert_notice',
						      'type' => CLX_CLASS_LIST,
						      'default' => '0',
						      'options' => $this->yesno)))))));
        $this->viewform = $this->editform;
        $this->searchform = $this->editform;
        $this->toollist = $this->listTableStructure();
        unset($this->toollist['fields']['COUNTER']);
        $this->toollist['fields']['MDATE']['type'] = 'dati';
        $this->toollist['fields']['MODULECODE']['type'] = 'lookup';
        $this->toollist['fields']['MODULECODE']['tool'] = 'DBMO';
        $this->toollist['fields']['QUERYCODE']['type'] = 'lookup';
        $this->toollist['fields']['QUERYCODE']['tool'] = 'DBQY';
        $this->toollist['fields']['TEMPLATECODE']['type'] = 'lookup';
        $this->toollist['fields']['TEMPLATECODE']['tool'] = 'UITM';
        $this->toollist['fields']['EMAIL_NOTICE']['type'] = CLX_CLASS_LIST;
        $this->toollist['fields']['EMAIL_NOTICE']['options'] = $this->yesno;
        $this->toollist['fields']['EMAIL_COPYFROM']['type'] = CLX_CLASS_LIST;
        $this->toollist['fields']['EMAIL_COPYFROM']['options'] = $this->yesno;
        $this->toollist['fields']['TASK_NOTICE']['type'] = CLX_CLASS_LIST;
        $this->toollist['fields']['TASK_NOTICE']['options'] = $this->yesno;
        $this->toollist['fields']['ALERT_NOTICE']['type'] = CLX_CLASS_LIST;
        $this->toollist['fields']['ALERT_NOTICE']['options'] = $this->yesno;
        $this->toollist['fields']['VERSION'] = array('name' => 'VERSION',
		  'type' => 'fieldgroup',
		  'fields' => array(
			 array('name' => 'VERSION',
			     'type' => 'string',
			     'sufix' => '-'),
			 array('name' => 'VERSION_COUNTER',
			     'type' => 'number')));
        unset($this->toollist['fields']['FROM_USER'], $this->toollist['fields']['DESCRIPTION'], $this->toollist['fields']['TEST_PARAMETERS'], $this->toollist['fields']['CDATE'], $this->toollist['fields']['USER_FIELDNAME'], $this->toollist['fields']['EMAIL_FIELDNAME'], $this->toollist['fields']['VERSION_COUNTER'], $this->toollist['fields']['COUNTER'], $this->toollist['fields']['USERNAME']);
        $this->toollist['buttons'] = array(array('access' => 'canread',
			 'tool' => 'has_display',
			 'library' => 'GEN_LBL_TEST',
			 'name' => 'RUN_TEST',
			 'prop' => 'ONE',
			 'window' => 'POP'));
    }

    /**
     * Install procedure
     *
     */
    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_SYSTEM:SYS_ALERTS', 'TOOL', $this->code, 'ac=LIST');
    }

    /**
     * Describes the tool table structure.
     * @return array ('type' => 'varchar(255)', 'properties'=>'auto increment',
     * 'index'=>'', default = '', 'dict'=>true)
     * dict true or false means that field holds dictionary entry
     */
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned',
		  'null' => 'NO',
		  'properties' => 'auto_increment', 'index' => 'PRI', 'index' => 'PRI');
        $fields['IDCODE'] = array('type' => 'varchar(16)',
		  'null' => 'NO',
		  'properties' => '',
		  'index' => '');
        $fields['IDNAME'] = array('type' => 'varchar(64)',
		  'null' => 'NO',
		  'properties' => '',
		  'index' => '');
        $fields['MODULECODE'] = array('type' => 'varchar(16)',
		  'null' => 'NO',
		  'properties' => '',
		  'index' => '');
        $fields['QUERYCODE'] = array('type' => 'varchar(16)',
		  'null' => 'NO',
		  'properties' => '',
		  'index' => '');
        $fields['TEMPLATECODE'] = array('type' => 'varchar(16)',
		  'null' => 'NO',
		  'properties' => '',
		  'index' => '');
        $fields['EMAIL_FIELDNAME'] = array('type' => 'varchar(64)',
		  'null' => 'NO',
		  'properties' => '',
		  'index' => '');
        $fields['USER_FIELDNAME'] = array('type' => 'varchar(64)',
		  'null' => 'NO',
		  'properties' => '',
		  'index' => '');
        $fields['EMAIL_NOTICE'] = array('type' => 'tinyint(1) unsigned',
		  'null' => 'NO',
		  'default' => CLX_NUM_ZERO,
		  'properties' => '',
		  'index' => '');
        $fields['EMAIL_COPYFROM'] = array('type' => 'tinyint(1) unsigned',
		  'null' => 'NO',
		  'default' => CLX_NUM_ZERO,
		  'properties' => '',
		  'index' => '');
        $fields['FROM_USER'] = array('type' => 'varchar(30)',
		  'null' => 'YES',
		  'properties' => '',
		  'index' => '');
        $fields['TASK_NOTICE'] = array('type' => 'tinyint(1) unsigned',
		  'null' => 'NO',
		  'default' => CLX_NUM_ZERO,
		  'properties' => '',
		  'index' => '');
        $fields['ALERT_NOTICE'] = array('type' => 'tinyint(1) unsigned',
		  'null' => 'NO',
		  'default' => CLX_NUM_ZERO,
		  'properties' => '',
		  'index' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext',
		  'properties' => '',
		  'index' => '');
        $fields['TEST_PARAMETERS'] = array('type' => 'tinytext',
		  'properties' => '',
		  'index' => '');
        $fields['VERSION'] = array('type' => 'varchar(32)',
		  'null' => 'NO',
		  'properties' => '',
		  'index' => '');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned',
		  'null' => 'NO',
		  'properties' => '',
		  'index' => '',
		  'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime',
		  'null' => 'YES',
		  'default' => '',
		  'properties' => '',
		  'index' => '');
        $fields['MDATE'] = array('type' => 'datetime',
		  'null' => 'YES',
		  'default' => '',
		  'properties' => '',
		  'index' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)',
		  'null' => 'NO',
		  'default' => '',
		  'properties' => '',
		  'index' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'MyISAM',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

    //-- A L E R T S
    /**
     * Pack tool record on xml Format
     * @param array record
     * @return obj
     */
    function pack($record) {
        $o = $this->packRecord($record);
        $code = $record['IDCODE'];
        $objs = new XMLObject($this->code . '_OBJECTS');
        $this->packsub($objs, 'EVNT', 'SELECT * FROM CLX_EVENTS  WHERE OWNERCODE=' . singleQuote($this->code) . ' AND OWNERID=' . singleQuote($code));
        $o->addObject($objs);
        return $o;
    }

    /**
     * Loads package into system
     * @param string $package
     */
    function unpack($parameters) {
        $record = $this->unpackRecord($parameters['package']);
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $idcode = $record['IDCODE'];
        $exists = (ClxCommon::$db->oneExistsRecords($this->tablename, 'IDCODE=' . singleQuote($idcode)) > CLX_NUM_ZERO);
        if ($exists === true) {
		  ClxCommon::$db->deleteRecords($this->tablename, 'IDCODE=' . singleQuote($idcode));
        }
        ClxCommon::$db->deleteRecords('CLX_EVENTS', 'OWNERCODE=' . singleQuote($this->code) . ' AND OWNERID=' . singleQuote($idcode));
        $recid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        unset($recid);
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
		  $objs = $package->getObjectXml($this->code . '_OBJECTS');
		  foreach ($objs->objects as $o) {
			 $toolcode = $o->tag;
			 $tool = &getTool($toolcode);
			 $tool->unpack(array('package' => $o, 'id' => $idcode));
		  }
        }
    }

    /**
     * Action is called for every user interaction with the module...
     *
     * @param string $ac
     * @param string $idlist
     * @return string
     */
    function action($ac, $idlist) {
        if ($this->getAccess()->canRead()) {
		  $idlist = getIdlist();
		  switch ($ac) {
			 case 'RUN_TEST':
			     $contents = $this->runTest($idlist[CLX_NUM_ZERO]);
			     break;
			 default:
			     $contents = parent::action($ac, $idlist);
			     break;
		  }
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [SYS_ALERTS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    /**
     * Construct listing buttons
     *
     * @param string $form_id
     * @return string
     */
    function listingButtons(&$form_id) {
        $buttons = parent::listingButtons($form_id);
        if ($this->getAccess()->canRead()) {
		  $b = new htmlFormSubmit(dict('GEN_LBL_TEST'), 'RUN_TEST', $form_id);
		  $b->setProp(CLX_PROP_ID, 'ONE');
		  $buttons .= $b->source();
        }
        return $buttons;
    }

    /**
     * Build display form contents
     * @param array $record
     * @return string
     */
    function viewFormFill($record) {
        addHistory('ownercode', $this->code);
        addHistory('ownerid', $record[$this->code . '_idcode']);
        $contents = parent::viewFormFill($record);
        //Adding Events
        $EVNT = &getTool('EVNT');
        $contents .= $EVNT->makepanel($this->code, $record[$this->code . '_idcode']);
        //Adding Logs
        $SYAG = &getTool('SYAG');
        $contents .= $SYAG->makepanel($this->code, $record[$this->code . '_idcode']);
        return $contents;
    }

    /**
     * Deletes record on selected id
     *
     * @param integer $id
     */
    function deleteRecordSk($id) {
        $idcode = ClxCommon::$db->getField($this->tablename, 'IDCODE', 'ID=' . $id);
        $EVNT = &getTool('EVNT');
        ClxCommon::$db->deleteRecords($EVNT->tablename, 'OWNERCODE=' . singleQuote($this->code) . ' AND OWNERID=' . singleQuote($idcode));
        //Logs
        $SYAG = getTool('SYAG');
        $rs = ClxCommon::$db->getRecords($SYAG->tablename, 'OWNERID=' . singleQuote($idcode));
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $SYAG->deleteRecordSk($r['ID']);
        }
		ClxCommon::$db->freeResult($rs );
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    /**
     * Runs alerts
     * @param $alertcode
     * @param $parameters
     * @param $test
     */
    function runAlert($alertcode, $parameters = array(), $test = false) {
        $contents = true;
        $qty = ClxCommon::$db->oneExistsRecords($this->tablename, 'IDCODE = ' . singleQuote($alertcode));

        if ($qty == CLX_NUM_ZERO) {
		  if (empty($test)) { //e cho 'Invalid alert: ' . $alertcode.'<br>';
			 return false;
		  }
        }
        $msg = array();
        $EVNT = &getTool('EVNT');
        //Executing Before Start Event
        $EVNT->execute5($this->code, $alertcode, 'SALI', $parameters, $msg);
        if (empty($test)) {
		  $to_lbl = dict('GEN_LBL_TO');
		  $from_lbl = dict('GEN_LBL_FROM');
		  $email_lbl = dict('GEN_LBL_MAIL_NOTICE');
		  $task_lbl = dict('GEN_LBL_TASK_NOTICE');
		  $alert_lbl = dict('GEN_LBL_ALERT_NOTICE');
		  $subject_lbl = dict('GEN_LBL_SUBJECT');
		  $content_lbl = dict('GEN_LBL_CONTENTS');
		  $sql_lbl = dict('GEN_LBL_SQL');
		  $table = new htmlTable(CLX_WIDTH_TWO);
		  $table->setProps(array(CLX_PROP_CLASS => 'listing', CLX_PROP_WIDTH => CLX_PROP_100PCT));
        }
        $syalrec = ClxCommon::$db->getRecord($this->tablename, 'IDCODE = ' . singleQuote($alertcode));
        $DBQY = &getTool('DBQY');
        $UITM = &getTool('UITM');
        //Alert Load Event
        $from = kDefaultEmail;
        $from_user = $syalrec['FROM_USER'];
		if (!empty($from_user)) {
		  $sql = 'SELECT EMAIL FROM CLX_AC_USERS WHERE USERNAME = ' . singleQuote($from_user);
		  $rs_usr = ClxCommon::$db->executeQuery($sql);
		  while (($r_usr = ClxCommon::$db->getNextRecord($rs_usr))) {
                if (!empty($r_usr['EMAIL'])) {
			     $from = $r_usr['EMAIL'];
			 }
			 break;
		  }
		  ClxCommon::$db->freeResult( $rs_usr);
        }
        $email_field = $syalrec['EMAIL_FIELDNAME'];
        $user_field = $syalrec['USER_FIELDNAME'];
        $hasEmail = false;
        $hasOwner = false;
        $doneUser = array();
        $save_request = UserRequest::$request;
        if ($DBQY->hasQuestions($syalrec['QUERYCODE'])) {
		  $DBQY->loadQuestionsRequestFromParameters($syalrec['QUERYCODE'], $parameters);
        }
        $query = $DBQY->getquery($this->code, $syalrec['QUERYCODE']);
        foreach ($query['COLUMNS'] as $key => $val) {
		  if ($val['FIELDNAME'] == $email_field) {
			 $email_field = $key;
			 $hasEmail = true;
		  }
		  if ($val['FIELDNAME'] == $user_field) {
			 $user_field = $key;
			 $hasOwner = true;
		  }
        }
        $tool = &getTool('SYAG');
        $query_fields = $DBQY->getQueryFields($syalrec['QUERYCODE'], true);
        $sql = $DBQY->getSql($this->code, $syalrec['QUERYCODE']);
        $rs = ClxCommon::$db->executeQuery($sql);
        $seqnum = CLX_NUM_ONE;
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  //Executing Load Event
			$EVNT->execute5($this->code, $alertcode, 'SALO', $r, $msg);
		  if (!empty($parameters)) {
			 $r['SYAL_parameters']=$parameters; 
		  }
		  //Formating Fields Here
		  foreach ($r as $key => $val) {
			 if (!array_key_exists($key, $query_fields))
			     continue;
			 if ($key == $email_field) {
			     //do nothing no format on from or to
			 } else {
			     $fieldinstance = getToolObject('DBFT', $query_fields[$key]['FIELDTYPE']);
			     $query_fields[$key]['NOCODES'] = CLX_NUM_ONE;

			     $r[$key] = strip_tags(trim($fieldinstance->formatField($key, $query_fields[$key], $r)), '<a>');
			 }
		  }

		  $tmpl = $UITM->getTemplateAndRecordMerge($syalrec['TEMPLATECODE'], $r);

		  //send email
			$contentx=str_replace('&nbsp;', ' ',htmlspecialchars_decode($tmpl['CONTENTS']));
			$subject =str_replace(chr(239).chr(191).chr(189),' ',strip_tags(substr($contentx,stripos($contentx,'asunto:')+7,105)));
			if (stripos($subject,'REF#')!==false){
				$tmpl['SUBJECT']=str_replace(chr(239).chr(191).chr(189),' ',str_replace('&nbsp;',' ',  trim(strip_tags(htmlspecialchars_decode($subject),"\t\n\r\0\x0B"))));
			}
			$tmpl['CONTENTS']=trim(strip_tags($tmpl['CONTENTS'])," \t\n\r\0\x0B");
 			if($syalrec['EMAIL_NOTICE']&&$hasEmail){
			 $to = trim($r[$email_field]);
				$subjt = $tmpl['SUBJECT'];//decode_string($tmpl['SUBJECT']);

				$subjt=str_replace(chr(194).chr(160),' ',$tmpl['SUBJECT']);
				if(!$test){
					if($this->syal_debug){
                        echo '</br>Send Email</br>';
                        echo 'From: ' . $from . '</br>';
                        echo 'To: ' . $to . '</br>';
                        echo 'Subject: ' . $subjt . '</br>';
                        echo '</br>' . $tmpl['CONTENTS_TXT'];
			     }


                    if (!empty ($to) || $to!=''){
						clx_mail_queue ( $from, $to, $tmpl['CONTENTS_TXT'], $subjt, true, '', '', '', array(), '', false, "UTF-8" );
			         }


                    if(!empty($syalrec['EMAIL_COPYFROM'])){
						if($this->syal_debug){
                            echo '</br>Send Email CC</br>';
                            echo 'From: " . $from . </br>';
                            echo 'To: " . $from . </br>';
                            echo 'Subject: ' . $subjt . '</br>';
                            echo '<br>' . $tmpl['CONTENTS_TXT'];
						}
    					clx_mail_queue ( $from, $from, $tmpl['CONTENTS'], $subjt, true, '', '', '', array(), '', false, "UTF-8" );
						pre($subjt);
						die();
			     }
			     if (!empty($this->syal_debug))
			         echolog('<hr>');
			 }
		  }
		  //send task
		  if(!empty($syalrec['TASK_NOTICE']) && $hasOwner === true) {
			 $user = $r[$user_field];
			 if (!array_key_exists($user, $doneUser)) {
			     //Create Tasks
			     $task = array();
			     $task['STATUS'] = 'IDLE';
			     $task['TYPE'] = 'FIEK';
			     $task['SUBJECT'] = $tmpl['SUBJECT'];
			     $task['DESCRIPTION'] = strip_tags(str_replace('<br>', CLX_CHAR_NL, $tmpl['CONTENTS']));
			     $task['PERCENT_COMPLETE'] = '0';
			     $task['COMPLETE_DATE'] = 'null';
			     $task['PRIORITY'] = 'N';
			     $task['OWNERCODE'] = $user;
			     $task['ASSIGNEDTO'] = $user;
			     $task['REMINDER_DATETIME'] = 'null';
			     $task['RECURRING'] = 'NONE';
			     $task['DEPENDS'] = '0';
			     $task['START_DATE'] = xFormat::getNow('Y-m-d H:i:s');
			     $task['DUE_DATE'] = '';
			     if (empty($test))
			         ClxCommon::$db->createRecord('CLX_US_TASKS', $task, false);
			 }
		  }
		  //send alert
		  if (!empty($syalrec['ALERT_NOTICE']) && $hasOwner === true) {
			 $user = $r[$user_field];
			 if (empty($test))
                    alrt_send($tmpl['SUBJECT'].'</br>'.$tmpl['CONTENTS_TXT'], 'now', $user);
		  }
            if (empty($test)) {
			 $table->addSeparator(CLX_CLASS_DATAALT);
			 $table->addCell('Seqnum', array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
			 $table->addCell((string) $seqnum, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
			 if (!empty($syalrec['EMAIL_NOTICE'])) {
			     $table->addCell($email_lbl, array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
			     $table->addCell($from_lbl . ':' . $from . ', ' . $to_lbl . ': ' . $r[$email_field], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
			 }
			 if (!empty($syalrec['TASK_NOTICE'])) {
			     $table->addCell($task_lbl, array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
			     $table->addCell($to_lbl . ':' . $r[$user_field], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
			 }
			 if (!empty($syalrec['ALERT_NOTICE'])) {
			     $table->addCell($alert_lbl, array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
			     $table->addCell($to_lbl . ':' . $r[$user_field], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
			 }
			 $table->addCell($subject_lbl, array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
			 $table->addCell($tmpl['SUBJECT'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
			 $table->addCell($content_lbl, array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
			 $table->addCell($tmpl['CONTENTS'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
		  }
		  $seqnum++;
		  //Log record
		  $record = array();
		  $record['TOOLCODE'] = $this->code;
		  $record['OWNERID'] = $syalrec['IDCODE'];
		  $record['MODULECODE'] = $syalrec['MODULECODE'];
		  $record['FROM_USER'] = $syalrec['FROM_USER'];
		  $record['FROM_EMAIL'] = $from;
		  $record['TO_EMAIL'] = trim($r[$email_field]);
		  if (!empty($test) === true) {
			 $record['TEST'] = CLX_NUM_ONE;
		  } else {
			 $record['TEST'] = CLX_INIT_ZERO;
		  }
		  if (empty($test)) {
			 $record['MSG_STATUS'] = 'SENT';
			 $add_to_content = '';
			 $td_lbl_ini = '<tr><td valign="top" class=CLX_CLASS_PROMPT>';
			 $td_lbl_mid = '</td><td valign="top" class=CLX_CLASS_DATA>';
			 $td_lbl_end = '</td></tr>';
			 if (!is_null($em_response_1)) {
			     if ($em_response_1['error'] == false) {
			         $record['MSG_STATUS'] .= ' - OK';
			     } else {
			         $record['MSG_STATUS'] .= ' - ERROR';
			         $add_to_content .= $td_lbl_ini . dict('GEN_LBL_FROM_EMAIL') . $td_lbl_mid . $em_response_1['from'] . $td_lbl_end .
			            $td_lbl_ini . dict('GEN_LBL_TO_EMAIL') . $td_lbl_mid . $em_response_1[CLX_PROP_TO] . $td_lbl_end . 
			            $td_lbl_ini . dict('GEN_LBL_ERRORMSG') . $td_lbl_mid . $em_response_1['errormsg'] . $td_lbl_end;
			     }
			 }
			 if (!is_null($em_response_2)) {
			     $record['MSG_STATUS'] .= ',' . CLX_CHAR_NL . 'COPY SENT';
			     if ($em_response_2['error'] == false) {
			         $record['MSG_STATUS'] .= ' - OK';
			     } else {
			         $record['MSG_STATUS'] .= ' - ERROR';
                        if (!empty($add_to_content))
					   $add_to_content .= '<tr><td colspan="2"><hr></td></tr>';
			           $add_to_content .= 
			             $td_lbl_ini . dict('GEN_LBL_FROM_EMAIL') . $td_lbl_mid . $em_response_2['from'] . $td_lbl_end .
			             $td_lbl_ini . dict('GEN_LBL_TO_EMAIL') . ' [COPY]' . $td_lbl_mid . $em_response_2[CLX_PROP_TO] . $td_lbl_end .
			             $td_lbl_ini . dict('GEN_LBL_ERRORMSG') . $td_lbl_mid . $em_response_2['errormsg'] . $td_lbl_end;
			     }
			 }

				if (!empty($add_to_content)) {
			     $add_to_content = '<br><br>' .
                            '<table border="0" cellspacing="0" cellpadding="0" class='.CLX_CLASS_FORM.'>' .
                            '<tr><td colspan="2" class='.CLX_CLASS_PROMPT.'><center>' .
					   dict('GEN_LBL_OTHERINFO') . ' - ' . dict('GEN_LBL_ERRORS') . '</center></td></tr>' .
					   $add_to_content . '</table>';
			 }
			 $record['SENT_DATI'] = getNow('Y-m-d G:i:s');
			 $record['SENTBY_USER'] = $_SESSION['user_record']['username'];
			 $record['SUBJECT'] = $tmpl['SUBJECT'];
			 $record['MSG_CONTENTS'] = $tmpl['CONTENTS'] . $add_to_content;
			 $record['EMAIL_NOTICE'] = $syalrec['EMAIL_NOTICE'];
			 $record['EMAIL_COPYFROM'] = $syalrec['EMAIL_COPYFROM'];
			 $record['TASK_NOTICE'] = $syalrec['TASK_NOTICE'];
			 $record['ALERT_NOTICE'] = $syalrec['ALERT_NOTICE'];
			 $tool->saveLog($record);
		  }
        }
		ClxCommon::$db->freeResult($rs);
        if (!empty($test)) {
            $table = new htmlTable(CLX_WIDTH_TWO);

		  if (!empty($parameters)) {
			 $table->addCell(dict('GEN_LBL_PARAMETERS'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
			 $table->addCell(str_replace(array('Array', '(', ')', '>'), '', print_r($parameters, true)), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
		  }
		  //show sql for test
		  $table->addCell($sql_lbl, array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
		  $textarea = new htmlTextArea('sq', $sql, CLX_NUM_20, CLX_NUM_80);
		  $textarea->setProp('readonly', 'true');
		  $table->addCell($textarea->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
		  $contents = $table->source();
        }
        UserRequest::$request = $save_request;
        return $contents;
    }

    /**
     * Alert Testing Method
     *
     * @param integer $alert_id
     * @return string
     */
    private function runTest($alert_id) {
        $alrt = ClxCommon::$db->getFields($this->tablename, 'IDCODE,TEST_PARAMETERS', 'ID = ' . $alert_id);
        //setting testing parameters
        $parameters = array();
        if (!empty($alrt['TEST_PARAMETERS'])) {
		  $p = explode('&', $alrt['TEST_PARAMETERS']);
		  foreach ($p as $val) {
			 $val = explode('=', $val);
			 if (!empty($val)) {
			     $parameters[$val[CLX_NUM_ZERO]] = $val[CLX_NUM_ONE];
			 }
		  }
        }
        $table = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('GEN_LBL_SYAL_TEST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
        $table->addCell(dict('GEN_LBL_ALERT_CODE') . ': ' . $alrt['IDCODE'], array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE));
        $table->addCell(dict('GEN_LBL_ALRT_TST_NOMSG_SENT'), array(CLX_PROP_CLASS => 'caption'));
        $table->addSeparator('caption');
        $table->addCell(dict('GEN_LBL_OTHERINFO'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE));
        $table->addCell($this->runAlert($alrt['IDCODE'], $parameters, true), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        return $table->source();
    }

}
