<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Included label
 */
class sys_parameters extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'SYPR';
        $this->name = 'System Parameters Manager';
        $this->system = 'System';
        $this->version = '5.5.0.1';


        $this->has_access = true;
        $this->has_package = true;

        $this->tablename = 'CLX_SYS_PARAMETERS';
        $this->record_name_singular = 'system parameter';
        $this->record_name_plural = 'system parameters';
        $this->primary_key = array('TOOLCODE', 'SYPRKEY');
        $this->primary_field = 'TOOLCODE';
        $this->secondary_field = 'SYPRKEY';

        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_DBTB_TITLE_CREATE',
		  'panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_TOOLCODE',
					   'fields' => array(
						  array('name' => 'toolcode', 'type' => 'lookup', 'default' => '', 'tool' => 'MAGR', 'validations' => array(
								array('type' => 'string', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'idcode', 'tablename' => 'CLX_TOOLS'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_SYPRKEY',
					   'fields' => array(
						  array('name' => 'syprkey', 'type' => 'string', 'default' => '', 'size' => '32', 'displaysize' => '32', 'validations' => array(
								array('type' => 'sqlobject', 'required' => '1'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_SYPRVALUE',
					   'fields' => array(
						  array('name' => 'syprvalue', 'type' => 'string', 'default' => '', 'size' => '255', 'displaysize' => '32', 'validations' => array(
								array('type' => 'string', 'required' => '1'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_SYPRDEFVALUE',
					   'fields' => array(
						  array('name' => 'syprdefvalue', 'type' => 'string', 'default' => '', 'size' => '255', 'displaysize' => '32', 'validations' => array(
								array('type' => 'string', 'required' => '1'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_DESCRIPTION',
					   'fields' => array(
						  array('name' => 'description', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4'))
			         )
			     )
			 )
		  )
        );
        $this->viewform = $this->editform;
        $this->searchform = $this->editform;
        $this->toollist = $this->listTableStructure();
        $this->toollist['fields']['TOOLCODE']['type'] = 'lookup';
        $this->toollist['fields']['TOOLCODE']['tool'] = 'MAGR';
        $this->toollist['fields']['MDATE']['type'] = 'dati';
        $this->toollist['fields']['DESCRIPTION']['type'] = 'string';
        $this->toollist['fields']['VERSION'] = array('name' => 'VERSION', 'type' => 'fieldgroup', 'fields' => array(array('name' => 'VERSION', 'type' => 'string', 'sufix' => '-'), array('name' => 'VERSION_COUNTER', 'type' => 'number')));
        unset($this->toollist['fields']['CDATE'], $this->toollist['fields']['MDATE'], $this->toollist['fields']['VERSION_COUNTER'], $this->toollist['fields']['COUNTER'], $this->toollist['fields']['USERNAME']);
    }

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_SYSTEM:SYS_PARAMETERS', 'TOOL', $this->code, 'ac=LIST');
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['TOOLCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['SYPRKEY'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['SYPRVALUE'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['SYPRDEFVALUE'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'TOOLCODE,SYPRKEY');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'MyISAM',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

    /**
     * Compare bpackage vs Object
     * @param obj $o
     * @param int $i
     * @param obj $table
     */
    function packdescribe($o, &$i, &$table) {
        $rv = '';
        $ov = '';
        $class = ($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT;
        if ($o->hasSubObject('VERSION')) {
		  $ov = $o->getSubObjectContents('VERSION') . '-' . $o->getSubObjectContents('VERSION_COUNTER');
            $exists = (ClxCommon::$db->oneExistsRecords($this->tablename, 'TOOLCODE=' . singleQuote($o->getSubObjectContents('TOOLCODE')) . ' AND SYPRKEY=' . singleQuote($o->getSubObjectContents('SYPRKEY'))) > CLX_NUM_ZERO);
		  $ov1 = str_replace('.', '', $ov);
		  $ov1 = str_replace('-', '', $ov1);
		  if ($exists === true) {
			 $record = ClxCommon::$db->getRecord($this->tablename, 'TOOLCODE=' . singleQuote($o->getSubObjectContents('TOOLCODE')) . ' AND SYPRKEY=' . singleQuote($o->getSubObjectContents('SYPRKEY')));
			 $rv = $record['VERSION'] . '-' . $record['VERSION_COUNTER'];
		  }
		  $rv1 = str_replace('.', '', $rv);
		  $rv1 = str_replace('-', '', $rv1);
		  if (empty($exists)) {
			 $table->addCell(dict('GEN_LBL_NEW'), array(CLX_PROP_CLASS => $class, 'style' => 'background-color: yellow', CLX_PROP_WIDTH => '25%'));
		  } elseif ($ov1 > $rv1) {
			 $table->addCell(dict('GEN_LBL_UPGRADE'), array(CLX_PROP_CLASS => $class, 'style' => 'background-color: green', CLX_PROP_WIDTH => '25%'));
		  } elseif ($ov1 == $rv1) {
			 $table->addCell(dict('GEN_LBL_SAME'), array(CLX_PROP_CLASS => $class, CLX_PROP_WIDTH => '25%'));
		  } else {
			 $table->addCell(dict('GEN_LBL_DOWNGRADE'), array(CLX_PROP_CLASS => $class, 'style' => 'background-color: red', CLX_PROP_WIDTH => '25%'));
		  }
		  $table->addCell($rv, array(CLX_PROP_CLASS => $class, CLX_PROP_WIDTH => '25%'));
		  $table->addCell($ov, array(CLX_PROP_CLASS => $class, CLX_PROP_WIDTH => '25%'));
		  $table->addCell($this->packname($o), array(CLX_PROP_CLASS => $class, CLX_PROP_WIDTH => '25%'));
		  $i++;
        } else {
		  $table->addCell(dict('GEN_LBL_OBJECTHASNOVERSION'), array(CLX_PROP_CLASS => $class, CLX_PROP_COLSPAN => '4'));
        }
    }

    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        $exists = (ClxCommon::$db->oneExistsRecords($this->tablename, 'TOOLCODE=' . singleQuote($record['TOOLCODE']) . ' AND SYPRKEY=' . singleQuote($record['SYPRKEY'])) > CLX_NUM_ZERO);
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        if ($exists === true) {
		  ClxCommon::$db->updateRecord($this->tablename, $record, 'TOOLCODE=' . singleQuote($record['TOOLCODE']) . ' AND SYPRKEY=' . singleQuote($record['SYPRKEY']));
        } else {
		  ClxCommon::$db->createRecord($this->tablename, $record, false);
        }
    }

    function saveRecord() {
        $d = xFormat::getNow();
        $table = $this->toolTableStructure();
        $record = array();
        $recordid = UserRequest::$post[$this->code . '_id'];
		//pre(UserRequest::$post);
        foreach ($table['fields'] as $key => $val) {
		  $formfield = $this->code . '_' . lowercase($key);
		  if (array_key_exists($formfield, UserRequest::$post)) {
			 $record[$key] = UserRequest::$post[$formfield];
		  }
        }
        $record['VERSION'] = kSystemVersion;
        $record['MDATE'] = $d;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['SYPRKEY'] = trim(uppercase($record['SYPRKEY']));
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID = ' . $recordid);
        $this->versionIncrease('ID', $recordid);
        $this->clearHeap($record['TOOLCODE'], $record['SYPRKEY'], $record);
        $findVarcache=kSpaceName . '.sypr.' . UserRequest::$post['SYPR_toolcode']  ;
    //    pre($findVarcache);
		apc_deleteFct($findVarcache);
        return $recordid;
    }

    function createRecord_() {
        $d = xFormat::getNow();
        $table = $this->toolTableStructure();
        $record = array();
        foreach ($table['fields'] as $key => $val) {
		  $formfield = $this->code . '_' . lowercase($key);
		  if (array_key_exists($formfield, UserRequest::$post)) {
			 $record[$key] = UserRequest::$post[$formfield];
		  }
        }
        $record['VERSION'] = kSystemVersion;
        $record['VERSION_COUNTER'] = '0';
        $record['CDATE'] = $d;
        $record['MDATE'] = $d;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['SYPRKEY'] = trim(uppercase($record['SYPRKEY']));
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $this->clearHeap($record['TOOLCODE'], $record['SYPRKEY'], $record);
        return $recordid;
    }

    function initParameters($toolcode, $keyname = '') {
        sys_parameters::staticInitParameters($toolcode, $keyname);
    }

    /**
     * Sets default parameters
     * @param string $toolcode
     * @param string $keyname
     */
    static function staticInitParameters($toolcode, $keyname = '') {
		$fetched = false;
		if (kApcTtl_11>0) 
			$preferences = apc_fetchFct($findVar=kSpaceName . '.sypr.' . $toolcode . $keyname, $fetched);
		if (empty($fetched)) {
				$preferences = array();
				$sql = 'SELECT SYPRKEY, SYPRVALUE, TOOLCODE FROM CLX_SYS_PARAMETERS WHERE TOOLCODE = ' . singleQuote($toolcode);
				if ($keyname <> '')
					 $sql .= ' AND SYPRKEY=' . singleQuote($keyname);
				$rs = ClxCommon::$db->executeQuery($sql);
				while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
					$kname = $r['TOOLCODE'] . '_' . $r['SYPRKEY'];
					$preferences[$kname] = $r['SYPRVALUE'];
				}
				ClxCommon::$db->freeResult( $rs );
				if (kApcTtl_11>0) {;
					apc_addFct($findVar, $preferences, kApcTtl_11);
				}
		}
		if (!empty($preferences)) {
				foreach ($preferences as $key => $val) {
				 if (!defined($key))
					 define($key, $val);
				}
		}
		if ($toolcode<>'UTIL') {
				sys_parameters::staticInitParameters('UTIL', '');
		}

    }

    /**
     * Clear field form heap
     * @param string $fieldname
     */
    function clearHeap($toolcode, $keyname, &$preferences) {
		  $kname = $preferences['TOOLCODE'] . '_' . $preferences['SYPRKEY'];
		  $fetched = false;
		if (kApcTtl_11>0)$old = apc_fetchFct($findVar=kSpaceName . '.sypr.' . $toolcode . $keyname, $fetched);
		if (empty($fetched)) {
			 $old[$kname] = $preferences['SYPRVALUE'];
			if (kApcTtl_11>0&&!empty($old)) {
				//apc_deleteFct(kSpaceName . '.sypr.' . $toolcode . $keyname);
				apc_addFct($findVar, $old, kApcTtl_11);
			}
		  }
		  $fetched = false;
		if (kApcTtl_11>0)$old = apc_fetchFct($findVar=kSpaceName . '.sypr.' . $toolcode, $fetched);
		  if ($fetched === true) {
			 $old[$kname] = $preferences['SYPRVALUE'];
			if (kApcTtl_11>0&&!empty($old)) {
				//apc_deleteFct(kSpaceName . '.sypr.' . $toolcode);
				apc_addFct($findVar, $old, kApcTtl_11);
		  }
        }
    }

}
