<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Included label
 */
class ui_filter_criteria extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'UIFC';
        $this->name = 'Filter Criteria';
        $this->system = 'Interface';
        $this->version = '0.5.5.0';


        $this->accesskey = 'UIFT';

        $this->tablename = 'CLX_UI_FILTER_CRITERIA';
        $this->record_name_singular = 'criteria';
        $this->record_name_plural = 'criterias';
        $this->primary_field = 'FILTERID';
        $this->secondary_field = 'FIELDNAME';
        $this->seqnum_field = 'SEQNUM';
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['FILTERID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['TABLECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['FIELDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['OPERATOR'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['FIELDVALUE'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['BOOLEAN'] = array('type' => 'varchar(4)', 'properties' => '');
        $fields['SEQNUM'] = array('type' => 'int(11) unsigned', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'FILTERID,SEQNUM');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'TABLECODE');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'FIELDNAME');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

}
