<?php

/**
 * General Code Iile
 * For more information contact  support@alenet.com
 *
 * @author	   $Author: cramirez $
 * @copyright	Alenet, Inc.  * @since		$Date: 2018-08-23 18:18:58 -0400 (Thu, 23 Aug 2018) $
 * @version		$Rev: 9902 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
if (!class_exists('fibk_utilities')) {

    /**
     * Constructor
     *
     * @author Francisco Santana
     *
     */
    class fibk_utilities {

        var $code = 'FIBR';
        var $modulecode; // Module Code
        var $rounding = CLX_NUM_TWO;
        var $display_rounding = CLX_NUM_TWO;
        var $keepLog = false;
        var $debug = false;
        var $trace = false;
        var $datestamp = '';
        var $batch_id = '';
        var $contents = '';
        private $pay_cd_int_only = 0;

        /**
         * Process parameters sample Array
         * @var type array
         */
        var $process_parameters = array();

        function __construct() {
            if (!empty($this->debug))
                echoLog('Investments started');
            $this->datestamp = date('Y-m-d H:i:s');
            $this->today = date('Y-m-d');
            $this->username = $_SESSION['user_record']['username'];
            $this->now = xFormat::getNow('Y-m-d H:i:s');
            $this->start_time = microtime_float();
            $this->modulecode = 'FIDU'; // Module
            $this->batch_id = batch_id();
            multiTableName($this, array('IETB', 'LEBA','FICO', 'JELN', 'GLAC', 'INFU', 'COMP', 'FIBK', 'JEHD', 'FIDA', 'PRAT', 'PROD', 'FIPA', 'CURR', 'FIAS', 'FIBN', 'FIVW', 'FIBP', 'GLCP', 'FITS', 'FIRT', 'GLT1', 'FITB', 'CDRH', 'INDX', 'GJVW', 'GDVW', 'JABV', 'FIAT', 'GLT1', 'FTMP', 'GDVW', 'RCT1', 'GLRC'));
        }

        /**
         * Earning Test BTN
         */
        function fibk_earnings_btn() {
            $sql = 'SELECT FIBK.COMP_CODE, FIBK.BANK_ACCOUNT_NO FROM ' . $this->fibkname . ' FIBK,' . $this->fibpname . ' FIBP,' . $this->glcpname . ' GLCP WHERE FIBP.BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND FIBK.COMP_CODE = GLCP.COMP_CODE AND FIBK.CALC_INTEREST = 1 AND FIBP.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM FIDU_FIBK_PARAMETERS_TBL X WHERE X.BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND X.CLX_EFFTDATE <= GLCP.OPERATION_DATE) AND FIBK.ID IN (' . toString(getIdList()) . ')';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $this->fibk_earn_interest($r['COMP_CODE'], $r['BANK_ACCOUNT_NO']);
            }
        }

        function fibk_pay_earnings_btn() {
            $sql = 'SELECT FIBK.COMP_CODE, FIBK.BANK_ACCOUNT_NO FROM ' . $this->fibkname . ' FIBK,' . $this->fibpname . ' FIBP,' . $this->glcpname . ' GLCP WHERE FIBP.BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND FIBK.COMP_CODE = GLCP.COMP_CODE AND FIBK.CALC_INTEREST = 1 AND FIBP.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM FIDU_FIBK_PARAMETERS_TBL X WHERE X.BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND X.CLX_EFFTDATE <= GLCP.OPERATION_DATE) AND FIBK.ID IN (' . toString(getIdList()) . ')';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $this->fibk_pay_earnings_cron($r);
            }
			ClxCommon::$db->freeResult($rs);
        }

        /**
         * Cron execution
         * @param string $parameters
         */
        function fibk_earnings_cron($parameters = array()) {
            $this->process_parameters = $parameters;
            if (!isset($parameters ['COMP_CODE'])) {
                return;
            }
            if (empty($parameters ['BANK_ACCOUNT_NO'])) {
                $parameters ['BANK_ACCOUNT_NO'] = '';
            }
            $this->fibk_earn_interest($parameters ['COMP_CODE'], $parameters ['BANK_ACCOUNT_NO']);
        }

        /**
         * Pago de intereses
         * @param string $parameters
         * @return void
         */
        function fibk_pay_earnings_cron($parameters = array(), $is_cdac = 0) {
            $this->process_parameters = $parameters;
            if (empty($parameters ['COMP_CODE'])) {
                return;
            }
            if (empty($parameters ['BANK_ACCOUNT_NO'])) {
                $parameters ['BANK_ACCOUNT_NO'] = '';
            }
            $this->pay_cd_int_only = $is_cdac;
            $this->fibk_pay_interest($parameters ['COMP_CODE'], $parameters ['BANK_ACCOUNT_NO']);
        }

        /**
         * Pay Interest new structure
         * @param string $comp_code
         * @param string $bank_account_no
         */
        private function fibk_pay_interest($comp_code, $bank_account_no = '') {

            $je_source = 'PAYE';
            //setting exchange and currency
            if (!class_exists('Comp')) {
                includeCodeLib('COMP');
            }
            $comp = new Comp();
            $comprec = $comp->comp_operation_parameters($comp_code);
            $operation_date = $comprec['OPERATION_DATE'];
			if (empty($operation_date)) {
				echoLog('<br> ERROR not operation date for company: '.$comp_code.' <br>');
				return;
			}
            echoLog(' BANK ACCOUNTS AND DEPOSITS INTEREST PAYMENT PROCESS. BATCH ID: ' . $this->batch_id);
            echoLog('Efective date: ' . $operation_date);
            echoLog('Deposit Account: ' . (($bank_account_no === '') ? 'ALL' : $bank_account_no));

            //Load temporary table - Req on mysql
            $DBTB = &getTool('DBTB');
            $DBTB->buildTemporaryTable('GLT1'); //Clear tmp
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));

            //Increase Next Payment Dates for regular bank accounts to match end of the month
            if ($this->pay_cd_int_only == 0) {
                $sql = 'UPDATE ' . $this->fibkname . ' FIBK SET FIBK.NEXT_INTPAY_DATE = ' . singleQuote(adodb_month_lastday($operation_date)) . ' WHERE FIBK.COMP_CODE = ' . singleQuote($comp_code) . ' AND FIBK.IS_CDAC = 0 AND FIBK.BK_INTRFSE_MODE = ' . singleQuote(CLX_NUM_ZERO) . ' AND (FIBK.NEXT_INTPAY_DATE IS NULL OR  FIBK.NEXT_INTPAY_DATE <= ' . singleQuote($operation_date) . ')' . ((!empty($bank_account_no)) ? ' AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($bank_account_no) : '');
            } else {
                //Just set maturity as expiration date if not defined by the user
                $sql = 'UPDATE ' . $this->fibkname . ' FIBK SET FIBK.NEXT_INTPAY_DATE = FIBK.MATURITY_DATE '
                        . 'WHERE FIBK.COMP_CODE = ' . singleQuote($comp_code) . ' AND FIBK.IS_CDAC = 1 AND FIBK.BK_INTRFSE_MODE = ' . singleQuote(CLX_NUM_ZERO) . ' AND (FIBK.NEXT_INTPAY_DATE IS NULL  OR (FIBK.NEXT_INTPAY_DATE<' . singleQuote($operation_date) . ' AND FIBK.NEXT_INTPAY_DATE >= FIBK.MATURITY_DATE))' . ((!empty($bank_account_no)) ? ' AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($bank_account_no) : '');
            }
            ClxCommon::$db->executeQuery($sql);

            //Lista de cuentas de banco para calculo de intereses
            $sql = 'INSERT INTO ' . $this->glt1name . ' (BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL02_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, TRUST_ITEM_TYPE, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, BANK_ACCOUNT_NO, PRODUCT_CODE, CALC_AMT_03, CALC_AMT_04, DEF_BANKACC_CODE, CASH_ASSET_CODE, ITEM_CODE, ITEM02_CODE, COMP_CODE) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, GLCP.OPERATION_DATE EFFTDATE, PRAT.AR_GL_CODE GLACCOUNTCODE, PRAT.PRO_GL_CODE GL01_CODE, PRAT.AR_GL_CODE GL02_CODE, JABV.GL_TYPE, SUM(JABV.BALANCE_AMT) BALANCE_AMT, SUM(JABV.BALANCE_AMT) CALC_AMT_01, JABV.CHART_FIELD01, JABV.CHART_FIELD02, JABV.CHART_FIELD03, JABV.CHART_FIELD04, FIAS.TRUST_ITEM_TYPE, FIBK.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, 0 DEBIT_AMT, 0 CREDIT_AMT, FIBK.BANK_ACCOUNT_NO, FIBK.BANK_PROD_CODE PRODUCT_CODE, 0 CALC_AMT_03, FIBK.IS_CDAC CALC_AMT_04, IF(FIBK.IS_CDAC=1, FIBK.DEF_BANKACC_CODE, null) DEF_BANKACC_CODE, null CASH_ASSET_CODE, ' . singleQuote('RCREM') . ' ITEM_CODE, ' . singleQuote('RCREM') . ' ITEM02_CODE, JABV.COMP_CODE FROM ' . $this->compname . ' COMP, ' . $this->jabvname . ' JABV, ' . $this->fiasname . ' FIAS, ' . $this->pratname . ' PRAT, ' . $this->fibkname . ' FIBK, ' . $this->glcpname . ' GLCP WHERE COMP.IDCODE = GLCP.COMP_CODE AND FIBK.BANK_PROD_CODE = PRAT.PRODUCT_CODE AND FIBK.IS_CDAC=' . $this->pay_cd_int_only . ' AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND FIBK.COMP_CODE = GLCP.COMP_CODE AND FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE AND JABV.CHART_FIELD01 = FIAS.CONTRACT_CODE AND JABV.CHART_FIELD03 = FIAS.IDCODE AND JABV.GLACCOUNTCODE = PRAT.AR_GL_CODE AND FIBK.CALC_INTEREST = 1 AND FIBK.BK_INTRFSE_MODE = ' . singleQuote(CLX_NUM_ZERO) . ' AND JABV.CURRENCY_CODE = FIBK.CURRENCY_CODE AND (FIBK.NEXT_INTPAY_DATE = ' . singleQuote($operation_date) . ') AND COMP.IDCODE = ' . singleQuote($comp_code) . ((!empty($bank_account_no)) ? ' AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($bank_account_no) : '') . ' GROUP BY GLCP.OPERATION_DATE, PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE, PRAT.INC_GL_CODE, JABV.GL_TYPE, JABV.CHART_FIELD01, JABV.CHART_FIELD02, JABV.CHART_FIELD03, JABV.CHART_FIELD04, FIAS.TRUST_ITEM_TYPE, FIBK.CURRENCY_CODE, FIBK.BANK_ACCOUNT_NO, FIBK.BANK_PROD_CODE, JABV.COMP_CODE, FIBK.IS_CDAC, FIBK.DEF_DSBRSMNT_TYPE HAVING SUM(JABV.BALANCE_AMT) <> 0';
            ClxCommon::$db->executeQuery($sql);

            //Borrando casos que tienen renovacion de capital e intereses. En ese caso se incluyen en renovacion
            $sql = 'DELETE  GLT1.* FROM ' . $this->glt1name . ' GLT1 WHERE GLT1.BANK_ACCOUNT_NO IN (SELECT FIBK.BANK_ACCOUNT_NO FROM ' . $this->fibkname . ' FIBK,' . $this->fibnname . ' FIBN  WHERE FIBK.IS_CDAC = 1 AND FIBK.COMP_CODE =' . singleQuote($comp_code) . ' AND (FIBK.MATURITY_DATE = ' . singleQuote($operation_date) . ' OR EXISTS(SELECT CDRH.ID FROM CD_RENEWAL_HIST CDRH WHERE CDRH.BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND CDRH.MATURITY_DATE = ' . singleQuote($operation_date) . ')) AND FIBN.RENWAL_OPER_TYPE = ' . singleQuote('CAI') . ' AND FIBN.CLX_AUTH_STATUS = ' . singleQuote('AP') . ' AND FIBN.BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND FIBN.CLX_EFFTDATE = (SELECT MAX(FIBNX.CLX_EFFTDATE) FROM ' . $this->fibnname . ' FIBNX WHERE FIBNX.BANKACT_CODE = FIBN.BANKACT_CODE AND FIBNX.CLX_EFFTDATE <= ' . singleQuote($operation_date) . ' AND FIBNX.CLX_AUTH_STATUS = ' . singleQuote('AP') . '))';
            ClxCommon::$db->executeQuery($sql);
            if (ClxCommon::$db->oneExistsRecords($this->glt1name, 'BATCH_ID = ' . singleQuote($this->batch_id)) === CLX_NUM_ZERO) {
                echoLog('Deposit Interest payment: Nothing to do returning');
                return;
            }

            $sql = 'SELECT GLT1.DEF_BANKACC_CODE,  GLT1.CHART_FIELD01 CONTRACT_CODE,  FIBK.BANK_PROD_CODE, FIBK.EXT_PRODUCT_CODE, FIBK.CURRENCY_CODE, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' ACCOUNTCODE, FIBK.IDNAME, ' . singleQuote('CA') . ' TRUST_ITEM_TYPE FROM ' . $this->glt1name . ' GLT1, ' . $this->fibkname . ' FIBK WHERE FIBK.BANK_ACCOUNT_NO = GLT1.DEF_BANKACC_CODE AND GLT1.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND NOT EXISTS (SELECT FIAS.IDCODE FROM ' . $this->fiasname . ' FIAS WHERE FIAS.CONTRACT_CODE = GLT1.CHART_FIELD01 AND FIAS.FIDU_BANKACT_CODE = GLT1.DEF_BANKACC_CODE)';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $this->build_fias($r); //Adding reference to fibk missing to pay
            }
			ClxCommon::$db->freeResult($rs);
            $sql = 'UPDATE ' . $this->glt1name . ' GLT1 SET GLT1.CASH_ASSET_CODE = (SELECT MAX(FIAS.IDCODE) FROM ' . $this->fiasname . ' FIAS WHERE FIAS.CONTRACT_CODE = GLT1.CHART_FIELD01 AND FIAS.FIDU_BANKACT_CODE = GLT1.DEF_BANKACC_CODE), GLT1.GL01_CODE = IFNULL((SELECT MAX(PRAT.PRO_GL_CODE) FROM ' . $this->pratname . ' PRAT, ' . $this->fibkname . ' FIBK WHERE FIBK.BANK_ACCOUNT_NO = GLT1.DEF_BANKACC_CODE AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE), GLT1.GL01_CODE) WHERE GLT1.DEF_BANKACC_CODE IS NOT NULL AND GLT1.DEF_BANKACC_CODE != ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND GLT1.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Increase Next Payment Dates for regular bank accounts
            $sql = 'UPDATE ' . $this->fibkname . ' FIBK SET FIBK.LAST_INTPAY_DATE = ' . singleQuote($operation_date) . ', FIBK.NEXT_INTPAY_DATE = ' . singleQuote(adodb_next_month_lastday($operation_date)) . ' WHERE FIBK.COMP_CODE = ' . singleQuote($comp_code) . ' AND FIBK.IS_CDAC = 0 AND FIBK.NEXT_INTPAY_DATE = ' . singleQuote($operation_date) . ((!empty($bank_account_no)) ? ' AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($bank_account_no) : '');
            ClxCommon::$db->executeQuery($sql);
            //Increase Next Payment Dates
            $sql = 'UPDATE ' . $this->fibkname . ' FIBK SET FIBK.LAST_INTPAY_DATE = ' . singleQuote($operation_date) . ', FIBK.NEXT_INTPAY_DATE = (SELECT (case FIBP.PAYMENT_FREQ WHEN ' . singleQuote('12') . ' THEN  ADDDATE(FIBK.NEXT_INTPAY_DATE, INTERVAL FIBP.NO_PERIODS MONTH) WHEN ' . singleQuote('6') . ' THEN  ADDDATE(FIBK.NEXT_INTPAY_DATE, INTERVAL 6*FIBP.NO_PERIODS MONTH) WHEN ' . singleQuote('4') . ' THEN  ADDDATE(FIBK.NEXT_INTPAY_DATE, INTERVAL 4*FIBP.NO_PERIODS MONTH) WHEN ' . singleQuote('3') . ' THEN  ADDDATE(FIBK.NEXT_INTPAY_DATE, INTERVAL 3*FIBP.NO_PERIODS MONTH) WHEN ' . singleQuote('2') . ' THEN  ADDDATE(FIBK.NEXT_INTPAY_DATE, INTERVAL 2*FIBP.NO_PERIODS MONTH) WHEN ' . singleQuote('1') . ' THEN  ADDDATE(FIBK.NEXT_INTPAY_DATE, INTERVAL FIBP.NO_PERIODS YEAR) END) NEW_DATE FROM ' . $this->fibpname . ' FIBP WHERE FIBP.BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND FIBP.CLX_EFFTDATE = (SELECT MAX(FIBPX.CLX_EFFTDATE) FROM ' . $this->fibpname . ' FIBPX WHERE FIBPX.BANKACT_CODE = FIBP.BANKACT_CODE AND FIBPX.CLX_EFFTDATE<=' . singleQuote($this->now) . ')) WHERE FIBK.COMP_CODE = ' . singleQuote($comp_code) . ' AND FIBK.IS_CDAC =1 AND FIBK.NEXT_INTPAY_DATE = ' . singleQuote($operation_date) . ((!empty($bank_account_no)) ? ' AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($bank_account_no) : '');
            ClxCommon::$db->executeQuery($sql);
            //CALC_AMT_04 1 es cd 0 es cuenta de banco
            //Cambiando cuentas contable de banco por defecto en pago de intereses de depositos
            $sql = 'SELECT DISTINCT CURRENCY_CODE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $rate = $comp->comp_current_exchange($comp_code, $r['CURRENCY_CODE'], $operation_date);
                $sql = 'UPDATE ' . $this->glt1name . ' SET CUR_OPERATOR = ' . singleQuote($rate['CUR_OPERATOR']) . ', EXCHANGE_RT = ' . singleQuote($rate['EXCHANGE_RT']) . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CURRENCY_CODE = ' . singleQuote($r['CURRENCY_CODE']);
                ClxCommon::$db->executeQuery($sql);
            }
			ClxCommon::$db->freeResult($rs);



            $sql = 'UPDATE ' . $this->glt1name . ' SET DEBIT_AMT = CALC_AMT_01, DEBIT_TRANS_AMT = CALC_AMT_01 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND CALC_AMT_01>0';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' SET CREDIT_AMT = -1*CALC_AMT_01, CREDIT_TRANS_AMT = -1*CALC_AMT_01 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND CALC_AMT_01<0';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' SET CREDIT_AMT = CALC_AMT_01, CREDIT_TRANS_AMT = CALC_AMT_01 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND CALC_AMT_01>0';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' SET DEBIT_AMT = -1*CALC_AMT_01, DEBIT_TRANS_AMT = -1*CALC_AMT_01 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND CALC_AMT_01<0';
            ClxCommon::$db->executeQuery($sql);
            //Perform conversions
            $sql = 'UPDATE ' . $this->glt1name . ' SET DEBIT_AMT = ROUND(DEBIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND DEBIT_AMT<>0';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' SET CREDIT_AMT = ROUND(CREDIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CREDIT_AMT<>0';
            ClxCommon::$db->executeQuery($sql);

            $sql = 'DELETE FROM ' . $this->glt1name . ' WHERE CREDIT_AMT=0 AND 	DEBIT_AMT = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);

            //Delete all participants where rows from overdraft loans. or cero that will not earn int.
            $sql = 'DELETE FROM ' . $this->glt1name . ' WHERE CALC_AMT_01 = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
			
            if (ClxCommon::$db->oneExistsRecords($this->glt1name, 'BATCH_ID = ' . singleQuote($this->batch_id)) === CLX_NUM_ZERO) {
                echoLog('Deposit Interest Payment: Nothing to do returning');
                return;
            }
            if (!class_exists('Jehd'))
                includeCodeLib('Jehd');
            $jehd = new Jehd();
            //Reject any posible todays entry from this process thas has run today
            //GLT1
            $DBLT = &getTool('DBLT');
            $gl_rec = $jehd->jehd_init_record();
            $gl_rec['IDNAME'] = substr($DBLT->getListItem('SOTY', $je_source), CLX_NUM_ZERO, CLX_NUM_60);
            $gl_rec['JE_SOURCE'] = $je_source;
            $gl_rec['LGGROUP_CODE'] = $comprec['LGGROUP_CODE'];
            $gl_rec['EFFTDATE'] = $operation_date;
            $gl_rec['REAL_DATE'] = $operation_date;
            $gl_rec['COMP_CODE'] = $comp_code;
            $gl_rec['TRANS_CODE'] = null;
            $gl_rec['REQ_CHANNEL'] = 'SYS';
            $gl_rec['BATCH_ID'] = $this->batch_id;
            $jehd->jehd_build($gl_rec);
            //Dump to log
            echoLog(dict('GEN_LBL_CREATED') . ' JEHD: ' . $gl_rec ['IDCODE']);
            //Search any scale if apply and dump lines to journal
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GL01_CODE GLACCOUNTCODE, X.ITEM_CODE ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, if(X.CASH_ASSET_CODE IS NOT null, X.CASH_ASSET_CODE, X.CHART_FIELD03)  CHART_FIELD03, X.CHART_FIELD04, if(X.CASH_ASSET_CODE IS NOT null, X.CASH_ASSET_CODE, X.BANK_ACCOUNT_NO) ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.DEBIT_AMT, X.CREDIT_AMT, X.DEBIT_TRANS_AMT, X.CREDIT_TRANS_AMT, 1 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            ////contraparte
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GL02_CODE GLACCOUNTCODE, X.ITEM02_CODE ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.BANK_ACCOUNT_NO ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.CREDIT_AMT DEBIT_AMT, X.DEBIT_AMT CREDIT_AMT, X.CREDIT_TRANS_AMT DEBIT_AMT, X.DEBIT_TRANS_AMT CREDIT_AMT, 2 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Removing sub account from in,ex,eq
            $sql = 'UPDATE ' . $this->jelnname . ' JELN SET JELN.CHART_FIELD03 = null WHERE JELN.JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']) . ' AND EXISTS(SELECT GLAC.ID FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GL_TYPE IN (' . singleQuoteArray(array('IN', 'EX', 'EQ')) . '))';
            ClxCommon::$db->executeQuery($sql);
            //Verificando conversion;
            $jehd->balance_exchange_rounding($gl_rec['IDCODE']);
            //Approve entry
            $jehd->jehd_approve_by_code($gl_rec['IDCODE']);
        }

        /**
         * Send exceptions to process schedule
         */
        function report_exceptions($msg) {
            echoLog($msg);
            $PRPR = &getTool('PRPR');
            $PRPR->report_exception($this->process_parameters ['SCHEDULECODE'], $this->process_parameters ['START_TIME'], $this->process_parameters ['RUNID'], $msg, 'FIBR', 'ERRO');
        }

        /**
         * Renewal test
         */
        function fibk_renewals_btn() {
            $sql = 'SELECT FIBK.COMP_CODE, FIBK.BANK_ACCOUNT_NO  FROM ' . $this->fibkname . ' FIBK, ' . $this->fibpname . ' FIBP, ' . $this->glcpname . ' GLCP WHERE FIBP.BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND FIBK.COMP_CODE = GLCP.COMP_CODE AND FIBP.CLX_EFFTDATE = (SELECT MAX(FIBPX.CLX_EFFTDATE) FROM ' . $this->fibpname . ' FIBPX WHERE FIBPX.BANKACT_CODE = FIBP.BANKACT_CODE) AND FIBK.ID IN (' . toString(getIdList()) . ')';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $this->fibk_renewals($r['COMP_CODE'], $r['BANK_ACCOUNT_NO']);
            }
			ClxCommon::$db->freeResult($rs);
        }

        /**
         * To be run by the cron process
         */
        function fibk_renewals_cron($parameters = array()) {
            $this->fibk_renewals($parameters['COMP_CODE']);
        }

        /**
         * Process Bank Account Renewals
         * @param string $comp_code
         * @param string [$bank_account_no]
         */
        private function fibk_renewals($comp_code, $bank_account_no = '') {
            /*
              Proceso de Renovacion o Pago
              La transaccion de renovacion debe quedar pendiente al inicio de operaciones
              -El pago debe generarse pendiente con referencia a la cuenta de banco. 	      1-Obtener registro de renovacion
              2-Ajustar tasa de interes en caso de ser necesario Nuevo registro FIBN
              3-Generar operaciones de renovaciones
              31 CAP Renovacion de solo capital
              32 CAI Renovacion de capital + Intereses
              33 Si no renueva entonces paga capital e intereses
              Operaciones
              SYS_CD-PINT Pago de Intereses de Certificados de Deposito
              SYS_CD-RCAI Renovacion de capital e intereses
              SYS_CD-RCAP Renovacion de capital
              SYS_CD-VEN Vencimiento de Certificado
             */
            //Obteniendo parametros de compania
            if (!class_exists('Comp'))
                includeCodeLib('COMP');
            $comp = new Comp();
            $comprec = $comp->comp_operation_parameters($comp_code);
            //Load temporal
            $this->fibk_renewals_load_temp($comp, $comprec, $comp_code, $bank_account_no);
            //Check if something to do or return
            if (ClxCommon::$db->oneExistsRecords($this->ftmpname, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
                return;
            }
            //Store renewal history
            $this->fibk_renewals_set_history();
            //Review interest if needed
            $this->fibk_renewals_interest_revision();
            //Set Dates
            $this->fibk_renewals_date_update();
            //Building Transaction
            if (!class_exists('Fiat'))
                includeCodeLib('FIAT');
            $fiat = new Fiat ();
            $sql = 'SELECT FTMP.IDCODE, FITB.IDNAME, FTMP.BATCH_ID, FTMP.CHART_FIELD01,FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, FTMP.ITEM_REF_NO, FTMP.CURRENCY_CODE, FTMP.CALC_AMT_01 TRANS_AMT, FTMP.CALC_AMT_02 INTEREST_AMT, FTMP.BANKACCOUNT_CODE FIDU_BANKACT_CODE, FTMP.EFFTDATE, FTMP.EFFTDATE AVAILABILITY_DATE, FTMP.EFFTDATE REAL_DATE, FTMP.TRANSTBL_CODE, FTMP.DISBURSEMENT_TYPE, FTMP.BENEFICIARY_NAME, FTMP.LGGROUP_CODE, FTMP.COMP_CODE FROM ' . $this->ftmpname . ' FTMP,' . $this->fitbname . ' FITB  WHERE FITB.IDCODE = FTMP.TRANSTBL_CODE  AND FTMP.BATCH_ID = ' . singleQuote($this->batch_id);
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                //Is eq+int then trans amount must add both
                if ($r['TRANSTBL_CODE'] === 'SYS_CD-RCAI' || $r['TRANSTBL_CODE'] === 'SYS_CD-VEN') {
                    $r['TRANS_AMT'] += $r['INTEREST_AMT'];
                }
                if ($r['TRANS_AMT'] == CLX_NUM_ZERO)
                    continue;
                //Exchange rates
                $xrate = $comp->comp_current_exchange($r ['COMP_CODE'], $r ['CURRENCY_CODE'], $r ['EFFTDATE']);
                $r ['EXCHANGE_RT'] = $xrate ['EXCHANGE_RT'];
                $r ['CUR_OPERATOR'] = $xrate ['CUR_OPERATOR'];
                $trans_code = $fiat->fiat_build($comp_code, $r ['TRANSTBL_CODE'], $r ['CHART_FIELD01'], $r ['CHART_FIELD02'], $r ['TRANS_AMT'], $r);
                //Approving all transactions that may require approval
                $fiat->fiat_approve_by_transcode($trans_code);
            }
			ClxCommon::$db->freeResult($rs);
        }

        /**
         * Loads temporary table
         * @param unknown_type $comp_code
         * @param unknown_type $bank_account_no
         */
        private function fibk_renewals_load_temp(&$comp, &$comprec, $comp_code, $bank_account_no = '') {
            //Temporary table for jounal entries
            $DBTB = &getTool('DBTB');
            $DBTB->buildTemporaryTable('FTMP'); //Clear tmp
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ftmpname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
            //Revisando tabla temporal de entradas en renovaciones
            $sql = 'INSERT INTO ' . $this->ftmpname . ' (IDCODE, BATCH_ID, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, CALC_AMT_01, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, BANKACCOUNT_CODE, EFFTDATE, TRANSTBL_CODE, DISBURSEMENT_TYPE, BENEFICIARY_NAME, LGGROUP_CODE, COMP_CODE, GL01_CODE, GL02_CODE, REC_ID) SELECT ' . singleQuote('AUTO') . ' IDCODE, ' . singleQuote($this->batch_id) . ' BATCH_ID, JABV.CHART_FIELD01, JABV.CHART_FIELD02, JABV.CHART_FIELD03, JABV.CHART_FIELD04, FIBK.BANK_ACCOUNT_NO ITEM_REF_NO, FIBK.CURRENCY_CODE, FIBN.ADJUSTMENT_AMT CALC_AMT_01, MAX(FIBK.INTEARNED_AMT-FIBK.INTPAID_AMT) CALC_AMT_02, SUM(JABV.BALANCE_AMT) CALC_AMT_03, FIBN.INTEREST_RT CALC_AMT_04, FIBK.DEF_BANKACC_CODE BANKACCOUNT_CODE, GLCP.OPERATION_DATE EFFTDATE, IF(FIBN.RENWAL_OPER_TYPE=' . singleQuote('CAP') . ', ' . singleQuote('SYS_CD-RCAP') . ', ' . singleQuote('SYS_CD-RCAI') . ') TRANSTBL_CODE, IFNULL(NULLIF(FIBK.DEF_DSBRSMNT_TYPE,' . singleQuote(CLX_CHAR_EMPTY_STRING) . '), ' . singleQuote('OT') . ') DISBURSEMENT_TYPE, FIBK.BENEFICIARY_NAME, ' . singleQuote($comprec ['LGGROUP_CODE']) . ' LGGROUP_CODE, FIBK.COMP_CODE, PRAT.PRO_GL_CODE GL01_CODE, PRAT.AR_GL_CODE GL02_CODE, FIBN.ID REC_ID FROM ' . $this->compname . ' COMP, ' . $this->jabvname . ' JABV, ' . $this->fiasname . ' FIAS, ' . $this->pratname . ' PRAT, ' . $this->fibkname . ' FIBK, ' . $this->glcpname . ' GLCP, ' . $this->fibnname . ' FIBN WHERE FIBN.BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND COMP.IDCODE = GLCP.COMP_CODE AND FIBK.BANK_PROD_CODE = PRAT.PRODUCT_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND FIBK.COMP_CODE = GLCP.COMP_CODE AND FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE AND JABV.CHART_FIELD01 = FIAS.CONTRACT_CODE AND JABV.CHART_FIELD03 = FIAS.IDCODE AND JABV.GLACCOUNTCODE = PRAT.PRO_GL_CODE AND JABV.CURRENCY_CODE = FIBK.CURRENCY_CODE AND FIBN.CLX_AUTH_STATUS = ' . singleQuote('AP') . ' AND FIBK.BK_INTRFSE_MODE = ' . singleQuote('0') . ' AND FIBN.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->fibnname . ' X WHERE X.BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND X.CLX_EFFTDATE <= GLCP.OPERATION_DATE AND X.CLX_AUTH_STATUS = ' . singleQuote('AP') . ') AND FIBK.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (!empty($bank_account_no) ? ' AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($bank_account_no) . ' ' : '') . ' AND (FIBN.RENEW_QTY > FIBN.RENEW_EXEC OR FIBN.RENEW_QTY=-1) AND FIBN.RENEW_QTY <> 0 AND FIBK.BALANCE_AMT > 0 AND FIBK.MATURITY_DATE = GLCP.OPERATION_DATE GROUP BY GLCP.OPERATION_DATE, JABV.CHART_FIELD01, JABV.CHART_FIELD02, JABV.CHART_FIELD03, JABV.CHART_FIELD04, FIBK.BANK_ACCOUNT_NO, FIBK.CURRENCY_CODE, FIBN.ADJUSTMENT_AMT, FIBN.INTEREST_RT, FIBK.BENEFICIARY_NAME, FIBK.DEF_BANKACC_CODE, FIBN.RENWAL_OPER_TYPE, FIBK.DEF_DSBRSMNT_TYPE, FIBK.COMP_CODE, PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE, FIBN.ID';
            ClxCommon::$db->executeQuery($sql);
            //Agregando Vencimientos
            $sql = 'INSERT INTO ' . $this->ftmpname . ' (IDCODE, BATCH_ID, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, CALC_AMT_01, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, BANKACCOUNT_CODE, EFFTDATE, TRANSTBL_CODE, DISBURSEMENT_TYPE, BENEFICIARY_NAME, LGGROUP_CODE, COMP_CODE, GL01_CODE, GL02_CODE, REC_ID) SELECT ' . singleQuote('AUTO') . ' IDCODE, ' . singleQuote($this->batch_id) . ' BATCH_ID, JABV.CHART_FIELD01, JABV.CHART_FIELD02, JABV.CHART_FIELD03, JABV.CHART_FIELD04, FIBK.BANK_ACCOUNT_NO ITEM_REF_NO, FIBK.CURRENCY_CODE, SUM(JABV.BALANCE_AMT) CALC_AMT_01, MAX(FIBK.INTEARNED_AMT-FIBK.INTPAID_AMT) CALC_AMT_02, 0 CALC_AMT_03, 0 CALC_AMT_04, FIBK.DEF_BANKACC_CODE BANKACCOUNT_CODE, GLCP.OPERATION_DATE EFFTDATE, ' . singleQuote('SYS_CD-VEN') . ' TRANSTBL_CODE, IFNULL(NULLIF(FIBK.DEF_DSBRSMNT_TYPE,' . singleQuote(CLX_CHAR_EMPTY_STRING) . '), ' . singleQuote('OT') . ') DISBURSEMENT_TYPE, FIBK.BENEFICIARY_NAME, ' . singleQuote($comprec ['LGGROUP_CODE']) . ' LGGROUP_CODE, FIBK.COMP_CODE, PRAT.PRO_GL_CODE GL01_CODE, PRAT.AR_GL_CODE GL02_CODE, 0 REC_ID FROM ' . $this->compname . ' COMP, ' . $this->jabvname . ' JABV, ' . $this->fiasname . ' FIAS, ' . $this->pratname . ' PRAT, ' . $this->fibkname . ' FIBK, ' . $this->glcpname . ' GLCP WHERE COMP.IDCODE = GLCP.COMP_CODE AND FIBK.BANK_PROD_CODE = PRAT.PRODUCT_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND FIBK.COMP_CODE = GLCP.COMP_CODE AND FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE AND JABV.CHART_FIELD01 = FIAS.CONTRACT_CODE AND JABV.CHART_FIELD03 = FIAS.IDCODE AND JABV.GLACCOUNTCODE = PRAT.PRO_GL_CODE AND JABV.CURRENCY_CODE = FIBK.CURRENCY_CODE AND FIBK.BK_INTRFSE_MODE = ' . singleQuote('0') . ' AND FIBK.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (!empty($bank_account_no) ? ' AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($bank_account_no) . ' ' : '') . ' AND FIBK.BALANCE_AMT > 0 AND FIBK.MATURITY_DATE = GLCP.OPERATION_DATE AND NOT EXISTS(SELECT FIBN.ID FROM ' . $this->fibnname . ' FIBN WHERE FIBN.BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND FIBN.CLX_AUTH_STATUS = ' . singleQuote('AP') . ' AND (FIBN.RENEW_QTY > FIBN.RENEW_EXEC OR FIBN.RENEW_QTY=-1) AND FIBN.RENEW_QTY <> 0 AND FIBN.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->fibnname . ' X WHERE X.BANKACT_CODE = FIBN.BANKACT_CODE AND X.CLX_EFFTDATE <= GLCP.OPERATION_DATE AND X.CLX_AUTH_STATUS = ' . singleQuote('AP') . ') ) GROUP BY JABV.CHART_FIELD01, JABV.CHART_FIELD02, JABV.CHART_FIELD03, JABV.CHART_FIELD04, FIBK.BANK_ACCOUNT_NO, FIBK.BENEFICIARY_NAME, FIBK.CURRENCY_CODE, FIBK.DEF_BANKACC_CODE, GLCP.OPERATION_DATE, FIBK.DEF_DSBRSMNT_TYPE, FIBK.COMP_CODE, PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE';
            ClxCommon::$db->executeQuery($sql);
            //Colocando monto de intereses
            $sql = 'UPDATE ' . $this->ftmpname . ' X SET X.CALC_AMT_02 = IFNULL((SELECT SUM(JABV.BALANCE_AMT) INTEREST_AMT FROM GL_AC_BALANCE_VW JABV WHERE JABV.CURRENCY_CODE = X.CURRENCY_CODE AND JABV.GLACCOUNTCODE = X.GL02_CODE AND JABV.CHART_FIELD01 = X.CHART_FIELD01 AND JABV.CHART_FIELD02 = X.CHART_FIELD02 AND JABV.CHART_FIELD03 = X.CHART_FIELD03),0) WHERE X.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Agregando SYS_CD-VEN
            $sql = 'UPDATE ' . $this->fibnname . ' FIBN SET FIBN.RENEW_EXEC = FIBN.RENEW_EXEC+1 WHERE FIBN.ID IN (SELECT DISTINCT FTMP.REC_ID FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.BATCH_ID = ' . singleQuote($this->batch_id) . ')';
            ClxCommon::$db->executeQuery($sql);
        }

        /**
         * Stores renewal history
         */
        private function fibk_renewals_set_history() {
            $sql = 'INSERT INTO ' . $this->cdrhname . ' (BANKACT_CODE, EFFTDATE, START_DATE, MATURITY_DATE, INTEREST_RT, BALANCE_AMT) SELECT FIBK.BANK_ACCOUNT_NO, FTMP.EFFTDATE, FIBK.START_DATE, FIBK.MATURITY_DATE, (SELECT FIBP.INTEREST_RT FROM FIDU_FIBK_PARAMETERS_TBL FIBP WHERE FTMP.ITEM_REF_NO = FIBP.BANKACT_CODE AND FIBP.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM FIDU_FIBK_PARAMETERS_TBL X WHERE X.BANKACT_CODE = FIBP.BANKACT_CODE AND X.CLX_EFFTDATE <= CURDATE())) INTEREST_RT, FIBK.BALANCE_AMT FROM ' . $this->ftmpname . ' FTMP, FIDU_BANK_ACCOUNTS FIBK WHERE FTMP.ITEM_REF_NO = FIBK.BANK_ACCOUNT_NO AND FTMP.TRANSTBL_CODE IN (' . singleQuote('SYS_CD-RCAP') . ', ' . singleQuote('SYS_CD-RCAI') . ') AND FTMP.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND NOT EXISTS(SELECT CDRH.ID FROM ' . $this->cdrhname . ' CDRH WHERE CDRH.BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND CDRH.EFFTDATE = FTMP.EFFTDATE)';
            ClxCommon::$db->executeQuery($sql);
        }

        /**
         * Setting date in case of renewals
         */
        private function fibk_renewals_date_update() {
            //Ajustando fechas de renovacion
            $sql = 'UPDATE ' . $this->fibkname . ' FIBK, ' . $this->ftmpname . ' FTMP SET FIBK.START_DATE = FTMP.EFFTDATE, FIBK.MATURITY_DATE = (case FIBK.INV_TERM WHEN ' . singleQuote('D') . ' THEN DATE_ADD(FTMP.EFFTDATE, INTERVAL 1*FIBK.INV_PERIOD DAY) /*Days*/ WHEN ' . singleQuote('W') . ' THEN DATE_ADD(FTMP.EFFTDATE, INTERVAL 7*FIBK.INV_PERIOD  DAY) /*Weeks(W)*/ WHEN ' . singleQuote('M') . ' THEN DATE_ADD(FTMP.EFFTDATE, INTERVAL 1*FIBK.INV_PERIOD  MONTH) /*Months(M)*/ WHEN ' . singleQuote('Q') . ' THEN DATE_ADD(FTMP.EFFTDATE, INTERVAL 3*FIBK.INV_PERIOD  MONTH) /*Quaters(Q)*/ WHEN ' . singleQuote('S') . ' THEN DATE_ADD(FTMP.EFFTDATE, INTERVAL 6*FIBK.INV_PERIOD  MONTH) /*Semesters(S)*/ WHEN ' . singleQuote('Y') . ' THEN DATE_ADD(FTMP.EFFTDATE, INTERVAL 1*FIBK.INV_PERIOD  YEAR) /*Years(Y)*/ ELSE FTMP.EFFTDATE END) WHERE FTMP.ITEM_REF_NO = FIBK.BANK_ACCOUNT_NO AND FTMP.TRANSTBL_CODE IN (' . singleQuote('SYS_CD-RCAP') . ', ' . singleQuote('SYS_CD-RCAI') . ') AND FTMP.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
        }

        /**
         * Interest Revision for renewal
         */
        private function fibk_renewals_interest_revision() {
            ClxCommon::$db->executeQuery('DROP TABLE IF EXISTS CD_FIBP_TMP'); //Interest parameters
            //Generando nuevo registro de intereses copiando parametros anteriores
            $sql = 'CREATE TEMPORARY TABLE CD_FIBP_TMP SELECT FIBP.* FROM ' . $this->fibpname . ' FIBP, ' . $this->ftmpname . ' FTMP WHERE FTMP.ITEM_REF_NO = FIBP.BANKACT_CODE AND FTMP.BATCH_ID = ' . singleQuote($this->batch_id) . '
                        AND FTMP.TRANSTBL_CODE IN (' . singleQuote('SYS_CD-RCAP') . ', ' . singleQuote('SYS_CD-RCAI') . ') AND FIBP.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM FIDU_FIBK_PARAMETERS_TBL X WHERE X.BANKACT_CODE = FIBP.BANKACT_CODE AND X.CLX_EFFTDATE <= CURDATE())';
            ClxCommon::$db->executeQuery($sql);
            //Sets id to 0
            $sql = 'UPDATE CD_FIBP_TMP FIBPX,' . $this->ftmpname . ' FTMP SET  FIBPX.ID = 0, FIBPX.CLX_EFFTDATE = FTMP.EFFTDATE,  FIBPX.MDATE = ' . singleQuote($this->today) . ', FIBPX.CDATE = ' . singleQuote($this->today) . ',FIBPX.CREATEDBY = ' . singleQuote($this->username) . ', FIBPX.MODIFIEDBY = ' . singleQuote($this->username) . ' WHERE  FIBPX.BANKACT_CODE = FTMP.ITEM_REF_NO';
            ClxCommon::$db->executeQuery($sql);
            //Set Fixed rate
            $sql = 'UPDATE CD_FIBP_TMP FIBPX, ' . $this->ftmpname . ' FTMP SET FIBPX.INTEREST_RT = IF(FTMP.CALC_AMT_04>0, FTMP.CALC_AMT_04, FIBPX.INTEREST_RT)  WHERE FIBPX.BANKACT_CODE = FTMP.ITEM_REF_NO AND FIBPX.INTEREST_TYPE = ' . singleQuote('FIX') . '';
            ClxCommon::$db->executeQuery($sql);
            //Renewal
            $sql = 'UPDATE CD_FIBP_TMP FIBPX, ' . $this->ftmpname . ' FTMP SET FIBPX.ADJ_POINTS_OVERINDEX = IF(FTMP.CALC_AMT_04>0, FTMP.CALC_AMT_04, FIBPX.ADJ_POINTS_OVERINDEX), FIBPX.INDEX_RATE = (SELECT MAX(INDX.INTEREST_RT) FROM ' . $this->indxname . ' INDX WHERE INDX.ADJ_INDEX = FIBPX.ADJ_INDEX AND INDX.CLX_EFFTDATE = (SELECT MAX(INDXX.CLX_EFFTDATE) FROM ' . $this->indxname . ' INDXX WHERE INDXX.ADJ_INDEX = INDX.ADJ_INDEX AND INDXX.CLX_EFFTDATE<=FIBPX.CLX_EFFTDATE)), FIBPX.INTEREST_RT = FIBPX.INDEX_RATE + FIBPX.ADJ_POINTS_OVERINDEX WHERE FIBPX.BANKACT_CODE = FTMP.ITEM_REF_NO AND FIBPX.INTEREST_TYPE = ' . singleQuote('VAR') . '';
            ClxCommon::$db->executeQuery($sql);
            //Insert entry to table
            $sql = 'INSERT INTO FIDU_FIBK_PARAMETERS_TBL SELECT FIBPX.* FROM  CD_FIBP_TMP FIBPX WHERE NOT EXISTS (SELECT FIBP.ID FROM ' . $this->fibpname . ' FIBP WHERE FIBP.BANKACT_CODE = FIBPX.BANKACT_CODE AND FIBP.CLX_EFFTDATE = FIBPX.CLX_EFFTDATE)';
            ClxCommon::$db->executeQuery($sql);
            ClxCommon::$db->executeQuery('DROP TABLE CD_FIBP_TMP'); //Interest paramters
        }

        /**
         * Calculates interest.
         * @param string $comp_code
         * @param string $bank_account_no
         */
        private function fibk_earn_interest($comp_code, $bank_account_no = '') {
            $je_source = 'CINT'; //Intereses de cuentas de banco
            //setting exchange and currency
            if (!class_exists('Comp')) {
                includeCodeLib('COMP');
            }
            $comp = new Comp();
            $comprec = $comp->comp_operation_parameters($comp_code);
            $operation_date = $comprec['OPERATION_DATE'];
			if (empty($operation_date)) {
				echoLog('<br> ERROR not operation date for company: '.$comp_code.' <br>');
				return;
			}
            echoLog(' BANK ACCOUNTS AND DEPOSITS INTEREST CALC PROCESS. BATCH ID: ' . $this->batch_id);
            echoLog('Efective date: ' . $operation_date);
            echoLog('Deposit Account: ' . (($bank_account_no === '') ? 'ALL' : $bank_account_no));
            //Test if not done already
            $done = ClxCommon::$db->oneExistsRecords($this->jehdname, 'JE_SOURCE = ' . singleQuote($je_source) . ' AND COMP_CODE = ' . singleQuote($comp_code) . ' AND EFFTDATE = ' . singleQuote($operation_date) . ' AND REAL_DATE = ' . singleQuote($operation_date) . ' AND REVERSED = 0');
            if (empty($bank_account_no) && $done > CLX_NUM_ZERO) {
                echoLog('Deposit Interest: Already done for ' . $operation_date . ' ' . $comp_code . ' Please reverse journal of source ' . $je_source . ' to recalculate interest');
                return;
            }
            //Load temporary table - Req on mysql
            $DBTB = &getTool('DBTB');
            $DBTB->buildTemporaryTable('GLT1'); //Clear tmp
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
            //Lista de cuentas de banco para calculo de intereses
            $sql = 'INSERT INTO ' . $this->glt1name . ' (BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL02_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, CALC_AMT_02, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, TRUST_ITEM_TYPE, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, BANK_ACCOUNT_NO, PRODUCT_CODE, CALC_AMT_03, CALC_AMT_04, DIVIDER_FACTOR, ITEM_CODE, ITEM02_CODE, COMP_CODE, NO_DAYS) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, GLCP.OPERATION_DATE EFFTDATE, PRAT.PRO_GL_CODE GLACCOUNTCODE, PRAT.AR_GL_CODE GL01_CODE, PRAT.INC_GL_CODE GL02_CODE, JABV.GL_TYPE, SUM(JABV.BALANCE_AMT) BALANCE_AMT, FIBP.INTEREST_RT CALC_AMT_01, 0 CALC_AMT_02, JABV.CHART_FIELD01, JABV.CHART_FIELD02, JABV.CHART_FIELD03, JABV.CHART_FIELD04, FIAS.TRUST_ITEM_TYPE, FIBK.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, 0 DEBIT_AMT, 0 CREDIT_AMT, FIBK.BANK_ACCOUNT_NO, FIBK.BANK_PROD_CODE PRODUCT_CODE, 0 CALC_AMT_03, 0 CALC_AMT_04, FIBP.INTEREST_CALC DIVIDER_FACTOR, ' . singleQuote('RCREM') . ' ITEM_CODE, ' . singleQuote('RCREM') . ' ITEM02_CODE, JABV.COMP_CODE, 0 NO_DAYS FROM ' . $this->compname . ' COMP, ' . $this->jabvname . ' JABV, ' . $this->fiasname . ' FIAS, ' . $this->pratname . ' PRAT, ' . $this->fibkname . ' FIBK, ' . $this->fibpname . ' FIBP, ' . $this->glcpname . ' GLCP WHERE FIBP.BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND COMP.IDCODE = GLCP.COMP_CODE AND FIBK.BANK_PROD_CODE = PRAT.PRODUCT_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND FIBK.COMP_CODE = GLCP.COMP_CODE AND FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE AND JABV.CHART_FIELD01 = FIAS.CONTRACT_CODE AND JABV.CHART_FIELD03 = FIAS.IDCODE AND JABV.GLACCOUNTCODE = PRAT.PRO_GL_CODE AND JABV.CURRENCY_CODE = FIBK.CURRENCY_CODE AND FIBK.BK_INTRFSE_MODE = ' . singleQuote(CLX_NUM_ZERO) . ' AND (PRAT.AR_GL_CODE IS NOT null AND PRAT.AR_GL_CODE <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND (PRAT.INC_GL_CODE IS NOT null AND PRAT.INC_GL_CODE <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') /*AND (FIBK.MATURITY_DATE <> GLCP.OPERATION_DATE OR FIBK.MATURITY_DATE IS null)*/ AND FIBK.CALC_INTEREST = 1 AND FIBK.BALANCE_AMT <> 0 AND FIBP.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->fibpname . ' X WHERE X.BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND X.CLX_EFFTDATE <= GLCP.OPERATION_DATE) AND COMP.IDCODE = ' . singleQuote($comp_code) . ' ' . ((!empty($bank_account_no)) ? ' AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($bank_account_no) : '') . ' GROUP BY GLCP.OPERATION_DATE, PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE, PRAT.INC_GL_CODE, JABV.GL_TYPE, FIBP.INTEREST_RT, JABV.CHART_FIELD01, JABV.CHART_FIELD02, JABV.CHART_FIELD03, JABV.CHART_FIELD04, FIAS.TRUST_ITEM_TYPE, FIBK.CURRENCY_CODE, FIBK.BANK_ACCOUNT_NO, FIBK.BANK_PROD_CODE, FIBP.INTEREST_CALC, JABV.COMP_CODE';
            ClxCommon::$db->executeQuery($sql);
            //Retor
            if (ClxCommon::$db->oneExistsRecords($this->glt1name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
                echoLog('Deposit Interest: Nothing to do returning');
                return;
            }
            $sql = 'UPDATE ' . $this->glt1name . ' SET CALC_AMT_02 = IFNULL(ROUND((BALANCE_AMT*(CALC_AMT_01/100)* case DIVIDER_FACTOR WHEN ' . singleQuote('30/360') . ' THEN (1/360) WHEN ' . singleQuote('30/365') . ' THEN (1/365) WHEN ' . singleQuote('AC/360') . ' THEN (1/360) WHEN ' . singleQuote('AC/365') . ' THEN (1/365) WHEN ' . singleQuote('AC/AC') . ' THEN (1/365) ELSE 1 END), 2),0) WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'SELECT DISTINCT CURRENCY_CODE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $rate = $comp->comp_current_exchange($comp_code, $r['CURRENCY_CODE'], $operation_date);
                $sql = 'UPDATE ' . $this->glt1name . ' SET CUR_OPERATOR = ' . singleQuote($rate['CUR_OPERATOR']) . ', EXCHANGE_RT = ' . singleQuote($rate['EXCHANGE_RT']) . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CURRENCY_CODE = ' . singleQuote($r['CURRENCY_CODE']);
                ClxCommon::$db->executeQuery($sql);
            } //end while
			ClxCommon::$db->freeResult($rs);
            //Colocando contabilidad
            $sql = 'UPDATE ' . $this->glt1name . ' SET DEBIT_AMT = CALC_AMT_02, DEBIT_TRANS_AMT = CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND CALC_AMT_02>0';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' SET CREDIT_AMT = -1*CALC_AMT_02, CREDIT_TRANS_AMT = -1*CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND CALC_AMT_02<0';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' SET CREDIT_AMT = CALC_AMT_02, CREDIT_TRANS_AMT = CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND CALC_AMT_02>0';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' SET DEBIT_AMT = -1*CALC_AMT_02, DEBIT_TRANS_AMT = -1*CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND CALC_AMT_02<0';
            ClxCommon::$db->executeQuery($sql);
            //Perform conversions
            $sql = 'UPDATE ' . $this->glt1name . ' SET DEBIT_AMT = ROUND(DEBIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND DEBIT_AMT<>0';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' SET CREDIT_AMT = ROUND(CREDIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CREDIT_AMT<>0';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'DELETE FROM ' . $this->glt1name . ' WHERE CREDIT_AMT=0 AND DEBIT_AMT = 0 AND BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
            ClxCommon::$db->executeQuery($sql);
            //Delete all participants where rows from overdraft loans. or cero that will not earn int. 	    $sql = 'DELETE FROM ' . $this->glt1name . 		    ' WHERE CALC_AMT_02 = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Retor
            if (ClxCommon::$db->oneExistsRecords($this->glt1name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
                echoLog('Deposit Interest: Nothing to do returning');
                return;
            }
            if (!class_exists('Jehd')) {
                includeCodeLib('Jehd');
            }
            $jehd = new Jehd();

            //Reject any posible todays entry from this process thas has run today
            $DBLT = &getTool('DBLT');
            $gl_rec = $jehd->jehd_init_record();
            $gl_rec['IDNAME'] = substr($DBLT->getListItem('SOTY', $je_source), CLX_NUM_ZERO, CLX_NUM_60);
            $gl_rec['JE_SOURCE'] = $je_source;
            $gl_rec['LGGROUP_CODE'] = $comprec['LGGROUP_CODE'];
            $gl_rec['EFFTDATE'] = $operation_date;
            $gl_rec['REAL_DATE'] = $operation_date;
            $gl_rec['COMP_CODE'] = $comp_code;
            $gl_rec['REQ_CHANNEL'] = 'SYS';
            $gl_rec['BATCH_ID'] = $this->batch_id;
            $jehd->jehd_build($gl_rec);
            //Dump to log
            echoLog(dict('GEN_LBL_CREATED') . ' JEHD: ' . $gl_rec ['IDCODE']);
            //Search any scale if apply and dump lines to journal
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GL01_CODE GLACCOUNTCODE, X.ITEM_CODE ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.BANK_ACCOUNT_NO ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.DEBIT_AMT, X.CREDIT_AMT, X.DEBIT_TRANS_AMT, X.CREDIT_TRANS_AMT, 1 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //contraparte
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GL02_CODE GLACCOUNTCODE, X.ITEM02_CODE ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.BANK_ACCOUNT_NO ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.CREDIT_AMT DEBIT_AMT, X.DEBIT_AMT CREDIT_AMT, X.CREDIT_TRANS_AMT DEBIT_AMT, X.DEBIT_TRANS_AMT CREDIT_AMT, 2 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Removing sub account from in,ex,eq
            $sql = 'UPDATE ' . $this->jelnname . ' JELN SET JELN.CHART_FIELD03 = null WHERE JELN.JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']) . ' AND EXISTS(SELECT GLAC.ID FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GL_TYPE IN (' . singleQuote('IN') . ',' . singleQuote('EX') . ',' . singleQuote('EQ') . '))';
            ClxCommon::$db->executeQuery($sql);
            //Verificando conversion;
            $jehd->balance_exchange_rounding($gl_rec['IDCODE']);
            //Approve entry
            $jehd->jehd_approve_by_code($gl_rec['IDCODE']);
        }

        /**
         * Validate record information
         * @param unknown_type $record
         * @param unknown_type $msg
         * @return boolean
         */
        function fibk_validate_form(&$record, &$msg) {
            // prevent delete if accounting exists
            if (UserRequest::$request['ac'] === 'DELETE') {
                // Validar que si remunera tenga parametros de remuneracion
                $sql = 'SELECT COUNT(FIAT.ID) FROM ' . $this->fibkname . ' FIBK, ' . $this->fiatname . ' FIAT  WHERE FIBK.ID IN ('. toString(getIdList()) .') AND FIAT.FIDU_BANKACT_CODE=FIBK.BANK_ACCOUNT_NO AND FIAT.TRANS_STATUS = ' . singleQuote('AP');
                //echo ClxCommon::$db->getOne($sql);
                if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                    $msg ['FIBK_BANK_ACCOUNT_NO'] = smsg('MSG-389');
                    addMessage($msg ['FIBK_BANK_ACCOUNT_NO']);
                    return false;
                }
            }
            //Validate that product and accounting group match with company
            $sql = 'SELECT COUNT(PROD.ID) QTY FROM ' . $this->prodname . ' PROD WHERE PROD.IDCODE = ' . singleQuote($record['FIBK_BANK_PROD_CODE']) . ' AND NOT EXISTS (SELECT GLCP.ID FROM ' . $this->glcpname . ' GLCP WHERE GLCP.COMP_CODE = ' . singleQuote($record['FIBK_COMP_CODE']) . ' AND GLCP.GLGROUP_CODE = PROD.GLGROUP_CODE)';
            if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                $msg ['FIBK_BANK_PROD_CODE'] = smsg('MSG-388');
                return false;
            }
            //estado INACTIVO debe verificar que no tenga saldo
            if ($record['FIBK_STATUS'] === 'I' && $record['FIBK_BALANCE_AMT'] > CLX_NUM_ZERO) {
                $msg['FIBK_STATUS'] = smsg('MSG-403', number_format($record ['FIBK_BALANCE_AMT'], CLX_NUM_TWO, ',', '.'));
                return false;
            }
            //Validacion de intereses
            if (array_key_exists('FIBP_INTEREST_RT', $record)) {
                if (!empty($record['FIBK_CALC_INTEREST']) && $record['FIBP_INTEREST_RT'] == CLX_NUM_ZERO) {
                    $msg['FIBP_INTEREST_RT'] = dict('GEN_LBL_REQUIRED');
                }
                //Check Inpr record
                $fm = (!empty(UserRequest::$post['fm']) && UserRequest::$post['fm'] === 'FIBK_CD') ? 'FIBP_CD_DRV' : 'FIBP_DRV';
                $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE=' . singleQuote($fm));
                $UIFM = &getTool('UIFM');
                $UIFM->userCheckForm($formrec, $record, $msg);
            }
        }

        /**
         * Returns fibn record for bank account
         * @param type $bankaccount_no
         * @return type
         */
        private function fibk_fibn_current_rec($bankaccount_no) {
            return ClxCommon::$db->getRecord($this->fibnname, 'BANKACT_CODE = ' . singleQuote($bankaccount_no) . ' ORDER BY CLX_EFFTDATE DESC LIMIT 1');
        }

        /**
         * Saves form
         * @param type $record
         */
        function save_form_post(&$record) {

            //Create asset if exists
            $this->build_fias($record);
            //Load fibn record Validacion de intereses
            if (array_key_exists('FIBP_INTEREST_RT', UserRequest::$post) && !empty($record['BANK_ACCOUNT_NO'])) {
                $fibprec = array();
                foreach (UserRequest::$post as $key => $val) {
                    if (substr($key, CLX_NUM_ZERO, CLX_NUM_FIVE) === 'FIBP_') {
                        $fibprec[str_replace('FIBP_', '', $key)] = $val;
                    }
                }
                if (count($fibprec) > CLX_NUM_ZERO) {
                    $fibprecold = $this->getCurrentFibp($record['BANK_ACCOUNT_NO']);
                    if (!empty($fibprecold)) {
                        ClxCommon::$db->updateRecord($this->fibpname, $fibprec, 'BANKACT_CODE = ' . singleQuote($fibprecold['BANKACT_CODE']), 'CLX_EFFTDATE =  ' . singleQuote($fibprecold['CLX_EFFTDATE']));
                    } else {
                        $fibprec['BANKACT_CODE'] = $record['BANK_ACCOUNT_NO'];
                        $fibprec['CLX_EFFTDATE'] = $record['START_DATE'];
                        ClxCommon::$db->createRecord($this->fibpname, $fibprec, true);
                    }
                }
            }

            //load fibn in case of renewal
            if (!empty($record['CD_RENEW_OPT'])) {

                $fibnrec = $this->fibk_fibn_current_rec($record['BANK_ACCOUNT_NO']);
                if (empty($fibnrec)) {
                    $DBTB = &getTool('DBTB');
                    $fibnrec = $DBTB->tableDefaultRecord('FIBN');
                    $fibnrec['CLX_EFFTDATE'] = $record['START_DATE'];
                    $fibnrec['BANKACT_CODE'] = $record['BANK_ACCOUNT_NO'];
                    $fibnrec['CREATEDBY'] = $record['MODIFIEDBY'];
                    $fibnrec['RENEW_QTY'] = '0';
                }
                $fibnrec['MODIFIEDBY'] = $record['MODIFIEDBY'];
                $fibnrec['MDATE'] = $record['MDATE'];
                $fibnrec['RENWAL_OPER_TYPE'] = (!empty(UserRequest::$request['FIBK_RENWAL_OPER_TYPE'])) ? UserRequest::$request['FIBK_RENWAL_OPER_TYPE'] : 'CAP';
                $fibnrec['CLX_AUTH_STATUS'] = 'AP';

                //RENWAL_OPER_TYPE
                switch ($record['CD_RENEW_OPT']) {
                    case 'RAU': //auto one time
                        $fibnrec['RENEW_QTY'] = '1';
                        break;
                    case 'RAL':
                        $fibnrec['RENEW_QTY'] = (array_key_exists('FIBK_RENEW_QTY', UserRequest::$request) && UserRequest::$request['FIBK_RENEW_QTY'] <> '') ? UserRequest::$request['FIBK_RENEW_QTY'] : $fibnrec['RENEW_QTY'];
                        break;
                    case 'RAI': //auto no limit
                        $fibnrec['RENEW_QTY'] = '-1';
                        break;
                    default: //SR no renewal
                        $fibnrec['RENEW_QTY'] = '0';
                        break;
                }
                ClxCommon::$db->loadDbRecord('CD_RENEWALS', $fibnrec, false, 'BANKACT_CODE = ' . singleQuote($fibnrec['BANKACT_CODE']) . ' AND CLX_EFFTDATE = ' . singleQuote($fibnrec['CLX_EFFTDATE']));
            }
        }

        function save_form(&$record, &$msg) {
            if (ClxCommon::$db->oneExistsRecords($this->fibkname, 'BANK_ACCOUNT_NO = ' . singleQuote($record['BANK_ACCOUNT_NO'])) === CLX_NUM_ZERO) {
                $sql = 'SELECT BANK_ACCOUNT_NO FROM ' . $this->fibkname . ' WHERE ID = ' . UserRequest::$post['FIBK_ID'];
                $viejoid = ClxCommon::$db->getOne($sql);
                if (empty($viejoid)) {
                    return false;
                }
                //Actualizando cuentas de banco associadas en caso de cambio de nuevo de cuenta
                $nuevoid = $record['BANK_ACCOUNT_NO'];
                $sql = 'SELECT  CONCAT("UPDATE ", TB.MODULECODE, "_", TB.IDNAME, " SET ",  FI.FIELDNAME, "=' . singleQuote($nuevoid) . ' WHERE ",  FI.FIELDNAME, "=' . singleQuote($viejoid) . '" )   UPDSQL FROM CLX_DB_FIELDS FI, CLX_DB_TABLES TB, CLX_DB_TABLEFIELDS TF WHERE FI.FIELD_EXTRA1=' . singleQuote('FIBK') . ' AND FI.FIELD_EXTRA2=' . singleQuote('BANK_ACCOUNT_NO') . ' AND FI.FIELDTYPE = ' . singleQuote('LOOK') . ' AND TF.FIELDNAME = FI.FIELDNAME AND TB.IDCODE = TF.TABLECODE AND TB.TYPE IN (' . singleQuote('InnoDB') . ',' . singleQuote('MyISAM') . ') ORDER BY 1';
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    ClxCommon::$db->executeQuery($r['UPDSQL']);
                }
				ClxCommon::$db->freeResult($rs);

                /*actualizando instrucciones de contrato*/
                $sql = 'UPDATE FIDU_INSTRUCTIONS FIAI, FIDU_CONTRACTS FICO SET FIAI.BANK_ACCOUNT_NO  = '.singleQuote($nuevoid).' WHERE FIAI.CHART_FIELD01 = FICO.IDCODE AND FICO.COMP_CODE = '.singleQuote($record['COMP_CODE']).' AND FIAI.BANK_ACCOUNT_NO = '.singleQuote($viejoid);
                ClxCommon::$db->executeQuery($sql);

                $sql = 'UPDATE FIDU_ITEMS FIAS, FIDU_CONTRACTS FICO SET  FIAS.EXT_PRODUCT_CODE  = '.singleQuote($nuevoid).' WHERE FIAS.CONTRACT_CODE = FICO.IDCODE AND FICO.COMP_CODE = '.singleQuote($record['COMP_CODE']).' AND FIAS.EXT_PRODUCT_CODE = '.singleQuote($viejoid);
                ClxCommon::$db->executeQuery($sql);
                if($record['EXT_PRODUCT_CODE']==$viejoid){
                    $record['EXT_PRODUCT_CODE'] = $nuevoid;
                }
                //FIAS.EXT_PRODUCT_CODE
                //FIAI.BANK_ACCOUNT_NO
            }
        }

        /**
         *
         * @param array $record
         */
        function build_fias($record) {
            if (empty($record['CONTRACT_CODE'])) {
                return;
            }
            //test if already exists
            $sql = 'SELECT ID FROM ' . $this->fiasname . ' WHERE CONTRACT_CODE=' . singleQuote($record['CONTRACT_CODE']) . ' AND FIDU_BANKACT_CODE = ' . singleQuote($record['BANK_ACCOUNT_NO']) . ' ORDER BY FIDU_BANKACT_CODE DESC';
            $id = ClxCommon::$db->getOne($sql);
            if (!empty($id)) {
                if ($record['EXT_PRODUCT_CODE'] === 'null' || $record['EXT_PRODUCT_CODE'] === '') {
                    $record['EXT_PRODUCT_CODE'] = $record['BANK_ACCOUNT_NO'];
                }
                $sql = 'UPDATE ' . $this->fiasname . ' SET IDNAME = ' . singleQuote($record['IDNAME']) . ', EXT_PRODUCT_CODE = ' . singleQuote($record['EXT_PRODUCT_CODE']) . ', CONTRACT_CODE=' . singleQuote($record['CONTRACT_CODE']) . ', ACCOUNTCODE=' . singleQuote($record['ACCOUNTCODE']) . ' WHERE ID = ' . $id;
                ClxCommon::$db->executeQuery($sql);
                return;
            }
            //set fias type
            $sql = 'SELECT
                        GLAC.GL_TYPE,
                        GLAC.TRUST_ITEM_TYPE
                    FROM
                        CRM_PRODUCTS PROD,
                        GL_PROD_PRMTR_TBL PRAT,
                        GL_CODES_TBL GLAC
                    WHERE
                        GLAC.IDCODE = PRAT.PRO_GL_CODE
                        AND GLAC.GLGROUP_CODE = PRAT.GLGROUP_CODE
                        AND PRAT.PRODUCT_CODE = ' . singleQuote($record['BANK_PROD_CODE']);
            $pratrec = ClxCommon::$db->getOneRecord($sql);
            if ($record['EXT_PRODUCT_CODE'] === 'null' || $record['EXT_PRODUCT_CODE'] === '') {
                $record['EXT_PRODUCT_CODE'] = $record['BANK_ACCOUNT_NO'];
            }
            $r = array('FIDU_BANKACT_CODE' => $record['BANK_ACCOUNT_NO'], 'EXT_PRODUCT_CODE' => $record['EXT_PRODUCT_CODE'], 'GL_TYPE' => $pratrec['GL_TYPE'], 'TRUST_ITEM_TYPE' => $pratrec['TRUST_ITEM_TYPE'], 'CURRENCY_CODE' => $record['CURRENCY_CODE'], 'CONTRACT_CODE' => $record['CONTRACT_CODE'], 'ACCOUNTCODE' => $record['ACCOUNTCODE'], 'IDNAME' => $record['IDNAME'], 'LOAN_CODE' => 'null', 'ASSET_CODE' => 'null');
            if (!empty($r['CONTRACT_CODE'])) {
                if (!class_exists('Fias'))
                    includeCodeLib('FIAS');
                $fias = new Fias();
                $fias->fias_build($r);
                unset($fias);
            }
        }

        /**
         * Updates bank account record balances from accounting
         *
         * @param string $bank_account_no
         */
        function update_balances($bank_account_no) {
            //nota por diferencial cambiario solo debe sumar el saldo de
            //operaciones en la misma moneda
            /* Updating Bank Account Balance */
            $sql = 'UPDATE ' . $this->fibkname . ' FIBK SET FIBK.BALANCE_AMT = IFNULL((SELECT SUM(JABV.BALANCE_AMT) FROM ' . $this->jabvname . ' JABV, ' . $this->fiasname . ' FIAS, ' . $this->pratname . ' PRAT WHERE JABV.CHART_FIELD03 = FIAS.IDCODE AND FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE AND JABV.CURRENCY_CODE = FIBK.CURRENCY_CODE AND PRAT.PRO_GL_CODE = JABV.GLACCOUNTCODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE),0) WHERE FIBK.BANK_ACCOUNT_NO  = ' . singleQuote($bank_account_no);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->fibkname . ' FIBK SET FIBK.INTEARNED_AMT = IFNULL((SELECT SUM(GDVW.DEBIT_TRANS_AMT-(IF(GDVW.REVERSED=1 OR GDVW.ADJUSTMENT = 1, 1,0)*GDVW.CREDIT_TRANS_AMT)) FROM ' . $this->fiasname . ' FIAS, ' . $this->gdvwname . ' GDVW, ' . $this->pratname . ' PRAT WHERE GDVW.CHART_FIELD03 = FIAS.IDCODE AND FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE AND GDVW.CURRENCY_CODE = FIBK.CURRENCY_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND PRAT.AR_GL_CODE = GDVW.GLACCOUNTCODE AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE),0) WHERE FIBK.BANK_ACCOUNT_NO  = ' . singleQuote($bank_account_no);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->fibkname . ' FIBK SET FIBK.INTPAID_AMT = IFNULL((SELECT SUM(GDVW.CREDIT_TRANS_AMT-(IF(GDVW.REVERSED=1 OR GDVW.ADJUSTMENT = 1, 1,0)*GDVW.DEBIT_TRANS_AMT)) FROM ' . $this->fiasname . ' FIAS, ' . $this->gdvwname . ' GDVW, ' . $this->pratname . ' PRAT WHERE GDVW.CHART_FIELD03 = FIAS.IDCODE AND FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE AND GDVW.CURRENCY_CODE = FIBK.CURRENCY_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND PRAT.AR_GL_CODE = GDVW.GLACCOUNTCODE AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE),0) WHERE FIBK.BANK_ACCOUNT_NO  = ' . singleQuote($bank_account_no);
            ClxCommon::$db->executeQuery($sql);
        }

        /**
         * Updates balances by jehdr_code
         * @param string $jehdr_code
         * @see fibk::update_balances()
         */
/*		 function update_balances_by_jehd2($jehdr_code) {
            //ClxCommon::$db->debug = true;
			if (!isset($GLOBALS['temporary1'])){
				//ClxCommon::$db->executeQuery('DROP TEMPORARY TABLE IF EXISTS BALANCE_AMT');
				$sql ='CREATE TEMPORARY TABLE  IF NOT EXISTS BALANCE_AMT AS SELECT SUM(JABV.BALANCE_AMT)  JABV_BALANCE_AMT ,FIAS.FIDU_BANKACT_CODE FIAS_FIDU_BANKACT_CODE, PRAT.PRODUCT_CODE PRAT_PRODUCT_CODE ,JABV.CURRENCY_CODE JABV_CURRENCY_CODE FROM ' . $this->jabvname . ' JABV, ' . $this->fiasname . '  FIAS, ' . $this->pratname . ' PRAT WHERE JABV.CHART_FIELD03 = FIAS.IDCODE AND PRAT.PRO_GL_CODE = JABV.GLACCOUNTCODE AND PRAT.PROD_STATUS = '. singleQuote('VIG') . ' GROUP BY   FIAS.FIDU_BANKACT_CODE, PRAT.PRODUCT_CODE ,JABV.CURRENCY_CODE';
				ClxCommon::$db->executeQuery($sql);
				$GLOBALS['temporary1']=1;
			}
			if (!isset($GLOBALS['temporary2'])){
				//ClxCommon::$db->executeQuery('DROP TEMPORARY TABLE IF EXISTS INTEARNED');
				$sql ='CREATE TEMPORARY TABLE  IF NOT EXISTS INTEARNEDY AS SELECT SUM((IF(GDVW.REVERSED=1 OR GDVW.ADJUSTMENT = 1,-1*GDVW.CREDIT_TRANS_AMT, GDVW.DEBIT_TRANS_AMT))) INTEARNED_AMT,FIAS.FIDU_BANKACT_CODE FIAS_FIDU_BANKACT_CODE,GDVW.CURRENCY_CODE GDVW_CURRENCY_CODE,PRAT.PRODUCT_CODE PRAT_PRODUCT_CODE, GDVW.IDCODE GDVW_IDCODE FROM ' . $this->fiasname . ' FIAS, ' . $this->gdvwname . ' GDVW, ' . $this->pratname . ' PRAT WHERE GDVW.CHART_FIELD03 = FIAS.IDCODE AND PRAT.PROD_STATUS = '. singleQuote('VIG') . ' AND PRAT.AR_GL_CODE = GDVW.GLACCOUNTCODE GROUP BY FIAS.FIDU_BANKACT_CODE,GDVW.CURRENCY_CODE,PRAT.PRODUCT_CODE,GDVW.IDCODE';
				ClxCommon::$db->executeQuery($sql);
				$GLOBALS['temporary2']=1;
			}
			
			$sql = 'UPDATE ' . $this->fibkname . ' FIBK SET FIBK.BALANCE_AMT = IFNULL((SELECT JABV_BALANCE_AMT FROM BALANCE_AMT WHERE FIBK.BANK_ACCOUNT_NO = FIAS_FIDU_BANKACT_CODE AND JABV_CURRENCY_CODE = FIBK.CURRENCY_CODE AND PRAT_PRODUCT_CODE = FIBK.BANK_PROD_CODE),0) WHERE FIBK.BANK_ACCOUNT_NO IN (SELECT DISTINCT FIAS2.FIDU_BANKACT_CODE FROM ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS2 WHERE JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND JELN.CHART_FIELD03 = FIAS2.IDCODE)'; 
            ClxCommon::$db->executeQuery($sql);
            / * Monto Devengado * /
			$sql = 'UPDATE ' . $this->fibkname . ' FIBK SET FIBK.INTEARNED_AMT = FIBK.INTEARNED_AMT+IFNULL((SELECT INTEARNED.INTEARNED_AMT FROM INTEARNEDY INTEARNED WHERE FIBK.BANK_ACCOUNT_NO = FIAS_FIDU_BANKACT_CODE AND GDVW_CURRENCY_CODE = FIBK.CURRENCY_CODE AND PRAT_PRODUCT_CODE = FIBK.BANK_PROD_CODE AND GDVW_IDCODE = ' . singleQuote($jehdr_code) . '),0) WHERE FIBK.BANK_ACCOUNT_NO IN (SELECT DISTINCT FIAS2.FIDU_BANKACT_CODE FROM ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS2 WHERE JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND JELN.CHART_FIELD03 = FIAS2.IDCODE)';
            ClxCommon::$db->executeQuery($sql);
            / * Monto Pagado * /
			$sql = 'UPDATE ' . $this->fibkname . ' FIBK SET FIBK.INTPAID_AMT = FIBK.INTPAID_AMT+IFNULL((SELECT -INTEARNED.INTEARNED_AMT FROM INTEARNEDY INTEARNED WHERE FIBK.BANK_ACCOUNT_NO = FIAS_FIDU_BANKACT_CODE AND GDVW_CURRENCY_CODE = FIBK.CURRENCY_CODE AND PRAT_PRODUCT_CODE = FIBK.BANK_PROD_CODE AND GDVW_IDCODE = ' . singleQuote($jehdr_code) . '),0) WHERE FIBK.BANK_ACCOUNT_NO IN (SELECT DISTINCT FIAS2.FIDU_BANKACT_CODE FROM ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS2 WHERE JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND JELN.CHART_FIELD03 = FIAS2.IDCODE)';
		 ClxCommon::$db->executeQuery($sql);
		 
			/ *$sql = 'UPDATE ' . $this->fibkname . ' FIBK SET FIBK.BALANCE_AMT = IFNULL((SELECT JABV_BALANCE_AMT FROM BALANCE_AMT WHERE FIBK.BANK_ACCOUNT_NO = FIAS_FIDU_BANKACT_CODE AND JABV_CURRENCY_CODE = FIBK.CURRENCY_CODE AND PRAT_PRODUCT_CODE = FIBK.BANK_PROD_CODE),0),                                FIBK.INTEARNED_AMT = FIBK.INTEARNED_AMT+IFNULL((SELECT INTEARNED.INTEARNED_AMT FROM INTEARNEDY INTEARNED WHERE FIBK.BANK_ACCOUNT_NO = FIAS_FIDU_BANKACT_CODE AND GDVW_CURRENCY_CODE = FIBK.CURRENCY_CODE AND PRAT_PRODUCT_CODE = FIBK.BANK_PROD_CODE AND GDVW_IDCODE = ' . singleQuote($jehdr_code) . '),0),                  FIBK.INTPAID_AMT = FIBK.INTPAID_AMT+IFNULL((SELECT -INTEARNED.INTEARNED_AMT FROM INTEARNEDY INTEARNED2 WHERE FIBK.BANK_ACCOUNT_NO = FIAS_FIDU_BANKACT_CODE AND GDVW_CURRENCY_CODE = FIBK.CURRENCY_CODE AND PRAT_PRODUCT_CODE = FIBK.BANK_PROD_CODE AND GDVW_IDCODE = ' . singleQuote($jehdr_code) . '),0) WHERE FIBK.BANK_ACCOUNT_NO IN (SELECT DISTINCT FIAS2.FIDU_BANKACT_CODE FROM ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS2 WHERE JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND JELN.CHART_FIELD03 = FIAS2.IDCODE)';
			ClxCommon::$db->executeQuery($sql);
			* /
        }*/
		function update_balances_by_jehd($jehdr_code) {
            //ClxCommon::$db->debug = true;

            //caso 1004924
            $crit = '';
            $sql = 'SELECT JEHD.EFFTDATE,GLCP.OPERATION_DATE FROM ' . $this->jehdname . ' JEHD, ' . $this->glcpname . ' GLCP  WHERE JEHD.COMP_CODE=GLCP.COMP_CODE AND JEHD.IDCODE=' . singleQuote($jehdr_code); 
            $back_value = ClxCommon::$db->getOneRecord($sql);
            if(!empty($_SESSION['BACK_VALUE_TRANS_CODE']) && $_SESSION['BACK_VALUE_TRANS_CODE'] == 'RET-FSO')
                $crit = ' OR ' . singleQuote($back_value['EFFTDATE']) . '<' . singleQuote($back_value['OPERATION_DATE']);
            // fin caso 1004924

			$sql = 'UPDATE ' . $this->fibkname . ' FIBK2 JOIN (SELECT FIBK.BANK_ACCOUNT_NO, IFNULL(SUM(IFNULL(LEBA.BALANCE_AMT,0)),0) BALANCE_AMT  FROM  '. $this->fiasname . ' FIAS ,'. $this->lebaname . ' LEBA,'. $this->glcpname . ' GLCP,'. $this->glacname . ' GLAC,' . $this->pratname . ' PRAT,' . $this->fibkname . ' FIBK  WHERE LEBA.CHART_FIELD03 = FIAS.IDCODE AND LEBA.CURRENCY_CODE = FIBK.CURRENCY_CODE AND PRAT.PRO_GL_CODE = LEBA.GLACCOUNTCODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE AND GLCP.COMP_CODE = LEBA.COMP_CODE AND GLCP.DEF_LEDGER_CODE = LEBA.LEDGER_CODE AND GLAC.IDCODE = LEBA.GLACCOUNTCODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE AND EXISTS ( SELECT 1 FROM GL_JOURNAL_LINES JELN WHERE JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND JELN.CHART_FIELD03 = FIAS.IDCODE ) GROUP BY FIBK.BANK_ACCOUNT_NO) X ON X.BANK_ACCOUNT_NO=FIBK2.BANK_ACCOUNT_NO SET FIBK2.BALANCE_AMT=IFNULL(X.BALANCE_AMT,0) '; 
            ClxCommon::$db->executeQuery($sql);
            /* Monto pagado y  devengado*/
            #$sql = 'UPDATE ' . $this->fibkname . ' FIBK JOIN FIDU_ITEMS FIAS  ON FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE  JOIN   ' . $this->jehdname . '  JEHD  ON JEHD.JE_STATUS = '.singleQuote('AP').'  JOIN  GL_JOURNAL_LINES JELN  ON JEHD.IDCODE = JELN.JEHDR_CODE AND JELN.CURRENCY_CODE = FIBK.CURRENCY_CODE   AND JELN.CHART_FIELD03 = FIAS.IDCODE  JOIN  ' . $this->pratname . ' PRAT  ON PRAT.PROD_STATUS =  ' . singleQuote('VIG') . ' AND  PRAT.AR_GL_CODE = JELN.GLACCOUNTCODE AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE SET	FIBK.INTEARNED_AMT = FIBK.INTEARNED_AMT+ IFNULL(IF(JEHD.REVERSED=1 OR JEHD.ADJUSTMENT = 1, -1*JELN.CREDIT_TRANS_AMT, JELN.DEBIT_TRANS_AMT ),0), FIBK.INTPAID_AMT   = FIBK.INTPAID_AMT  + IFNULL(IF(JEHD.REVERSED=1 OR JEHD.ADJUSTMENT = 1, -1*JELN.DEBIT_TRANS_AMT,  JELN.CREDIT_TRANS_AMT),0) WHERE  JELN.JEHDR_CODE  = ' . singleQuote($jehdr_code) . ' AND FIBK.BANK_ACCOUNT_NO= FIAS.FIDU_BANKACT_CODE ';
            
            // caso 1004924
            $sql = 'UPDATE ' . $this->fibkname . ' FIBK JOIN FIDU_ITEMS FIAS  ON FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE  JOIN   ' . $this->jehdname . '  JEHD  ON JEHD.JE_STATUS = '.singleQuote('AP').'  JOIN  GL_JOURNAL_LINES JELN  ON JEHD.IDCODE = JELN.JEHDR_CODE AND JELN.CURRENCY_CODE = FIBK.CURRENCY_CODE   AND JELN.CHART_FIELD03 = FIAS.IDCODE  JOIN  ' . $this->pratname . ' PRAT  ON PRAT.PROD_STATUS =  ' . singleQuote('VIG') . ' AND  PRAT.AR_GL_CODE = JELN.GLACCOUNTCODE AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE SET  FIBK.INTEARNED_AMT = FIBK.INTEARNED_AMT+ IFNULL(IF(JEHD.REVERSED=1 OR JEHD.ADJUSTMENT = 1 ' . $crit . ' , -1*JELN.CREDIT_TRANS_AMT, JELN.DEBIT_TRANS_AMT ),0), FIBK.INTPAID_AMT   = FIBK.INTPAID_AMT  + IFNULL(IF(JEHD.REVERSED=1 OR JEHD.ADJUSTMENT = 1 ' . $crit . ' , -1*JELN.DEBIT_TRANS_AMT,  JELN.CREDIT_TRANS_AMT),0) WHERE  JELN.JEHDR_CODE  = ' . singleQuote($jehdr_code) . ' AND FIBK.BANK_ACCOUNT_NO= FIAS.FIDU_BANKACT_CODE ';
			ClxCommon::$db->executeQuery($sql);
		}

/*
        function update_balances_by_jehd3($jehdr_code) { 
            //ClxCommon::$db->debug = true;
            $sql = 'UPDATE ' . $this->fibkname . ' FIBK SET FIBK.BALANCE_AMT = IFNULL((SELECT SUM(JABV.BALANCE_AMT) FROM ' . $this->jabvname . ' JABV, ' . $this->fiasname . ' FIAS, ' . $this->pratname . ' PRAT WHERE JABV.CHART_FIELD03 = FIAS.IDCODE AND FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE AND JABV.CURRENCY_CODE = FIBK.CURRENCY_CODE AND PRAT.PRO_GL_CODE = JABV.GLACCOUNTCODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE),0) WHERE FIBK.BANK_ACCOUNT_NO IN (SELECT DISTINCT FIAS2.FIDU_BANKACT_CODE FROM ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS2 WHERE JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND JELN.CHART_FIELD03 = FIAS2.IDCODE)';
            ClxCommon::$db->executeQuery($sql);
            / * Monto Devengado * /
            $sql = 'UPDATE ' . $this->fibkname . ' FIBK SET FIBK.INTEARNED_AMT = FIBK.INTEARNED_AMT+IFNULL((SELECT SUM((IF(GDVW.REVERSED=1 OR GDVW.ADJUSTMENT = 1,-1*GDVW.CREDIT_TRANS_AMT, GDVW.DEBIT_TRANS_AMT))) FROM ' . $this->fiasname . ' FIAS, ' . $this->gdvwname . ' GDVW, ' . $this->pratname . ' PRAT WHERE GDVW.CHART_FIELD03 = FIAS.IDCODE AND FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE AND GDVW.CURRENCY_CODE = FIBK.CURRENCY_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND PRAT.AR_GL_CODE = GDVW.GLACCOUNTCODE AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE AND GDVW.IDCODE = ' . singleQuote($jehdr_code) . '),0) WHERE FIBK.BANK_ACCOUNT_NO IN (SELECT DISTINCT FIAS2.FIDU_BANKACT_CODE FROM ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS2 WHERE JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND JELN.CHART_FIELD03 = FIAS2.IDCODE)';
            ClxCommon::$db->executeQuery($sql);
            / * Monto Pagado * /
            $sql = 'UPDATE ' . $this->fibkname . ' FIBK SET FIBK.INTPAID_AMT = FIBK.INTPAID_AMT + IFNULL((SELECT SUM((IF(GDVW.REVERSED=1 OR GDVW.ADJUSTMENT = 1, -1*GDVW.DEBIT_TRANS_AMT,GDVW.CREDIT_TRANS_AMT))) FROM ' . $this->fiasname . ' FIAS, ' . $this->gdvwname . ' GDVW, ' . $this->pratname . ' PRAT WHERE GDVW.CHART_FIELD03 = FIAS.IDCODE AND FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE AND GDVW.CURRENCY_CODE = FIBK.CURRENCY_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND PRAT.AR_GL_CODE = GDVW.GLACCOUNTCODE AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE AND GDVW.IDCODE = ' . singleQuote($jehdr_code) . '),0) WHERE FIBK.BANK_ACCOUNT_NO IN (SELECT DISTINCT FIAS2.FIDU_BANKACT_CODE FROM ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS2 WHERE JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND JELN.CHART_FIELD03 = FIAS2.IDCODE)';
            ClxCommon::$db->executeQuery($sql);
        }
*/
        /**
         * Searches bank account information from the database.
         * @param
         *        	String bank account number
         * @return Array bank account record
         */
        function get_bank_account_information(&$bank_account_number) {
            $sql = 'SELECT FIBK.*, FIBP.*, PRAT.* FROM ' . $this->fibkname . ' FIBK, ' . $this->fibpname . ' FIBP, ' . $this->pratname . ' PRAT, ' . $this->prodname . ' PROD WHERE FIBK.BANK_ACCOUNT_NO = FIBP.BANKACT_CODE AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE AND PROD.IDCODE = FIBK.BANK_PROD_CODE AND FIBP.CLX_EFFTDATE = (SELECT MAX(FIBP2.CLX_EFFTDATE) FROM ' . $this->glcpname . ' GLCP, ' . $this->fibpname . ' FIBP2 WHERE GLCP.COMP_CODE = FIBK.COMP_CODE AND FIBK.BANK_ACCOUNT_NO = FIBP2.BANKACT_CODE AND FIBP2.CLX_EFFTDATE<=GLCP.OPERATION_DATE) AND FIBK.BANK_ACCOUNT_NO =' . singleQuote($bank_account_number);
            return ClxCommon::$db->getOneRecord($sql);
        }

        /**
         * Searches the database to return bank account balance
         * @param unknown_type $bank_account_number
         * @param unknown_type $contract_code
         * @param unknown_type $participant_id
         * @param unknown_type $trust_item_type
         * @return Ambigous <multitype:, boolean>
         */
        function get_bank_account_total_balance(&$bank_account_number, $contract_code = '', $participant_id = '', $trust_item_type = 'CA') {
            $sql = 'SELECT
                        IFNULL(SUM(JABV.BALANCE_AMT),0) BALANCE_AMT
                    FROM
                        GL_AC_BALANCE_VW JABV,
                        GL_PROD_PRMTR_TBL PRAT,
                        FIDU_BANK_ACCOUNTS FIBK,
                        FIDU_ITEMS FIAS
                    WHERE
                        FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE
                        AND JABV.CHART_FIELD03 = FIAS.IDCODE
                        AND JABV.CURRENCY_CODE = FIBK.CURRENCY_CODE
                        AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE
                        AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . '
                        AND FIBK.BANK_ACCOUNT_NO  = ' . singleQuote($bank_account_number) . ' ';
            if ($contract_code !== '')
                $sql .= ' AND JABV.CHART_FIELD01 = ' . singleQuote($contract_code) . ' ';
            if ($participant_id !== '')
                $sql .= ' AND JABV.CHART_FIELD02 = ' . singleQuote($participant_id) . ' ';
            $sql .=($trust_item_type === 'CA') ? 'AND JABV.GLACCOUNTCODE = PRAT.PRO_GL_CODE ' : 'AND JABV.GLACCOUNTCODE = PRAT.AR_GL_CODE ';
            return ClxCommon::$db->getOne($sql);
        }

        /**
         * Search the database to return the number of the last printed check of the bank account
         */
        function getLastCheckNum($comp_code, $bankacco) {
            $sql = 'SELECT FIBK.LAST_CHECK_NO
                    FROM ' . $this->fibkname . ' FIBK
                    WHERE FIBK.COMP_CODE = ' . singleQuote($comp_code) . ' AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($bankacco);
            return ClxCommon::$db->getOne($sql);
        }

        /**
         * Initialice all temporary tables
         *
         * @param unknown_type $batch_id
         */
        private function initTemporaryTables($batch_id) {
            // Load temporary table - Req on mysql
            $DBTB = &getTool('DBTB');
            $DBTB->buildTemporaryTable('GLT1');
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($batch_id));
        }

        /**
         * Bank account earnings
         */
        function rep_fibk_earnings_prompt() {
            $formcode = 'REP_FIBK';
            $title = dict('RTBL_FIBK_EARN');
            $ac = UserRequest::$request ['ac'];
            $to = UserRequest::$request [CLX_PROP_TO];
            UserRequest::$post = array_merge(UserRequest::$request, UserRequest::$post);
            if (empty(UserRequest::$post ['confirm'])) {
                UserRequest::$post ['RTBL_COMP_CODE'] = '';
                UserRequest::$post ['RTBL_FROM_DATE'] = '';
                UserRequest::$post ['RTBL_TO_DATE'] = '';
                UserRequest::$post ['RTBL_BANK_ACCOUNT_NO'] = '';
            } else {
                $this->date_format = UserRequest::$post ['RTBL_DATE_FORMAT'];
                $this->sdate = UserRequest::$post ['RTBL_FROM_DATE'];
                $this->edate = UserRequest::$post ['RTBL_TO_DATE'];
                $this->fibk_no = UserRequest::$post ['RTBL_BANK_ACCOUNT_NO'];
            }
            $it = (!empty(UserRequest::$request ['it'])) ? UserRequest::$request ['it'] : '';
            // RTBL_REPCINV
            $EDIT = &getTool('EDIT');
            $record = array();
            $msg = array();
            $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote($formcode));
            $record = UserRequest::$post;
            if (!empty($record ['confirm'])) {

                $EDIT->checkForm2($msg, $formrec);
                if (count(explode('-', UserRequest::$post ['RTBL_TO_DATE'])) != CLX_NUM_THREE)
                    $msg ['RTBL_TO_DATE'] = dict('GEN_ERR_CANTPARSE');
                if (count(explode('-', UserRequest::$post ['RTBL_FROM_DATE'])) != CLX_NUM_THREE)
                    $msg ['RTBL_FROM_DATE'] = dict('GEN_ERR_CANTPARSE');
                if ($this->sdate > $this->edate) {
                    /*
                     * GEN_ERR_STARTGREATERENDDATE Start date cannot be greater
                     * than end date. Fecha inicial no puede ser mayor que fecha
                     * final. 		     */
                    $msg ['RTBL_TO_DATE'] = dict('GEN_ERR_STARTGREATERENDDATE');
                    $msg ['RTBL_FROM_DATE'] = dict('GEN_ERR_STARTGREATERENDDATE');
                }
            }

            $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', $title);
            if (!empty($record ['confirm']) && empty($msg)) {
                // Para ver batch
                $contract_code = UserRequest::$post ['RTBL_CONTRACT_CODE'];
                $participant_id = UserRequest::$post ['RTBL_ACCOUNTCODE'];
                $comp_code = UserRequest::$post ['RTBL_COMP_CODE'];
                $sdate = UserRequest::$post ['RTBL_FROM_DATE'];
                $edate = UserRequest::$post ['RTBL_TO_DATE'];
                $bank_account_no = UserRequest::$post ['RTBL_BANK_ACCOUNT_NO'];
                $schedule_title = 'FIBK_REM ' . $contract_code . '-' . $participant_id . ' ' . $sdate . ' ' . $edate;
                // Schedule will redirect if not empty
                UserRequest::$request['ANRP_report_type'] = 2;
                $ANRJ = getTool('ANRJ');
                $ANRJ->setBatchGeneral($schedule_title, 'html', UserRequest::$post); // Will
                $this->rep_fibk_earnings($sdate, $edate, $comp_code, $contract_code, $participant_id, $bank_account_no);
                $this->contents .= '<link href="../' . kPathToSkins . kDefaultSkin . '/styles.css") rel="stylesheet" type="text/css")>';
                // labels
                $sql = 'SELECT FIELDNAME, FIELDLISTLABEL FROM CLX_DB_FIELDS WHERE FIELDNAME IN (' . singleQuote('CONTRACT_CODE') . ', ' . singleQuote('COMP_CODE') . ', ' . singleQuote('PARTICIPANT_ID') . ', ' . singleQuote('BALANCE_AMT') . ', ' . singleQuote('YIELD_RT') . ', ' . singleQuote('EARNED_INT_AMT') . ', ' . singleQuote('EFFTDATE') . ') ';
                $results = ClxCommon::$db->executeQuery($sql);
                $labels = array();
                while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                    $labels [$result ['FIELDNAME']] = dict($result ['FIELDLISTLABEL']);
                }
				ClxCommon::$db->freeResult($results);
                $table = new htmlTable(CLX_WIDTH_TWO);
                $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));


                $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
                $contract_name = ClxCommon::$db->getField($this->compname, 'IDNAME', 'IDCODE = ' . singleQuote($comp_code));
                $table->addcells(CLX_CLASS_PROMPT, array($labels ['COMP_CODE']));
                $table->addcells(CLX_CLASS_DATA, array($contract_name));
                if (!empty($contract_code)) {
                    $contract_name = ClxCommon::$db->getField($this->ficoname, 'IDNAME', 'IDCODE = ' . singleQuote($contract_code));
                    $table->addcells(CLX_CLASS_PROMPT, array($labels ['CONTRACT_CODE']));
                    $table->addcells(CLX_CLASS_DATA, array($contract_name . '(' . $contract_code . ')'));
                }
                if (!empty($participant_id)) {
                    $sql = 'SELECT IDNAME||' . singleQuote(' - ') . '||IDENTIFICATION FROM ' . $this->acconame . ' WHERE IDCODE = ' . singleQuote($participant_id);
                    $participant_name = ClxCommon::$db->getOne($sql);
                    $table->addcells(CLX_CLASS_PROMPT, array($labels ['PARTICIPANT_ID']));
                    $table->addcells(CLX_CLASS_DATA, array($participant_name));
                }
                $table->addcells(CLX_CLASS_PROMPT, array(dict('GEN_LBL_FROM')));
                $table->addcells(CLX_CLASS_DATA, array(xFormat::date($sdate, $this->date_format)));
                $table->addcells(CLX_CLASS_PROMPT, array(dict('GEN_LBL_UNTIL')));
                $table->addcells(CLX_CLASS_DATA, array(xFormat::date($edate, $this->date_format)));
                $this->contents .= $table->source() . '<br>';
                $table = new htmlTable(CLX_WIDTH_FOUR);
                $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));


                $table->addcells(CLX_CLASS_HEADERS, array($labels ['EFFTDATE'], $labels ['BALANCE_AMT'], dict('EFFTDATE_RT') . '(%)', $labels ['EARNED_INT_AMT']));
                $sql = 'SELECT X.EFFTDATE, SUM(X.BALANCE_AMT) BALANCE_AMT, AVG(X.CALC_AMT_02) YIELD_RT, ROUND(SUM(((X.BALANCE_AMT*(X.CALC_AMT_02/100))/ nullIF(X.CALC_AMT_01,0))*X.GEN_PERIOD), 2) EARNED_INT_AMT FROM ' . $this->glt1name . ' X WHERE X.EFFTDATE>= ' . singleQuote($sdate) . ' AND X.BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY X.EFFTDATE ORDER BY X.EFFTDATE ASC';
                $results = ClxCommon::$db->executeQuery($sql);
                $i = CLX_INIT_ZERO;
                while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                    if ($result ['EARNED_INT_AMT'] == CLX_NUM_ZERO)
                        continue;
                    $class = ($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT;
                    $table->addCell(xFormat::date($result ['EFFTDATE'], $this->date_format), array(CLX_PROP_CLASS => $class, CLX_PROP_ALIGN => 'center', 'nowrap' => '1'));
                    $table->addCell('<div align="right">' . xFormat::number($result ['BALANCE_AMT'], CLX_NUM_TWO) . '</div>', array(CLX_PROP_CLASS => $class, CLX_PROP_ALIGN => 'right'));
                    $table->addCell('<div align="right">' . xFormat::number($result ['YIELD_RT'], CLX_NUM_TWO) . '</div>', array(CLX_PROP_CLASS => $class, CLX_PROP_ALIGN => 'right'));
                    $table->addCell('<div align="right">' . xFormat::number($result ['EARNED_INT_AMT'], CLX_NUM_TWO) . '</div>', array(CLX_PROP_CLASS => $class, CLX_PROP_ALIGN => 'right'));
                }
				ClxCommon::$db->freeResult($results);
                $this->contents .= $table->source();
            } else {
                $this->contents = $form->source();
            }
            // Clearing all temporary tables
            $this->initTemporaryTables($this->batch_id);
        }

        /**
         * Initializes conciliation report data
         * @param type $sdate
         * @param type $edate
         * @param type $comp_code
         * @param type $contract_code
         * @param type $participant_id
         * @param type $bank_account_no
         */
        function rep_fibk_earnings($sdate, $edate, $comp_code, $contract_code, $participant_id, $bank_account_no) {
            // Initializing temporar
            $this->initTemporaryTables($this->batch_id);
            $glaccounts = array();
            // Find bank accounts
            $sql = 'SELECT
				  FIBK.IDNAME,
				  FIBK.BANK_ACCOUNT_NO,
				  PRAT.PRO_GL_CODE GLACCOUNTCODE,
				  PRAT.AR_GL_CODE RECEIVABLES_GL_CODE,
                                  FIBK.CURRENCY_CODE
				FROM ' . $this->fibkname . ' FIBK,
				  ' . $this->pratname . ' PRAT
				WHERE
				  FIBK.BANK_PROD_CODE = PRAT.PRODUCT_CODE
				  AND FIBK.COMP_CODE = ' . singleQuote($comp_code) . '
				  AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($bank_account_no) . '
				  AND FIBK.CALC_INTEREST = 1';
            $results = ClxCommon::$db->executeQuery($sql);
            $currency_code = '';
            while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                $glaccounts [] = $result ['GLACCOUNTCODE'];
                $currency_code = $result['CURRENCY_CODE'];
            }
			ClxCommon::$db->freeResult($results);
            $cc2 = 'AND GDVW.GLACCOUNTCODE IN (' . singleQuote(implode("','", $glaccounts)) . ') ';
            unset($glaccounts);
            if (!empty($contract_code)) {
                $cc2 .= 'AND GDVW.CHART_FIELD01 = ' . singleQuote($contract_code) . ' ';
            }
            if (!empty($participant_id)) {
                $cc2 .= 'AND GDVW.CHART_FIELD02 = ' . singleQuote($participant_id) . ' ';
            }
            $sql = 'INSERT INTO ' . $this->glt1name . ' (EFFTDATE, NEXT_DATE, GEN_PERIOD, GLACCOUNTCODE, GL_TYPE, TRUST_ITEM_TYPE, INIT_BAL_AMT, DEBIT_AMT, CREDIT_AMT, BALANCE_AMT, CALC_AMT_01, CALC_AMT_02, BATCH_ID) SELECT GDVW.EFFTDATE, GDVW.EFFTDATE NEXT_DATE, 0 GEN_PERIOD, GDVW.GLACCOUNTCODE, GDVW.GL_TYPE, GDVW.TRUST_ITEM_TYPE, 0 INIT_BAL_AMT, SUM(GDVW.DEBIT_TRANS_AMT) DEBIT_AMT, SUM(GDVW.CREDIT_TRANS_AMT) CREDIT_AMT, 0 BALANCE_AMT, 0 CALC_AMT_01, 0 CALC_AMT_02, ' . singleQuote($this->batch_id) . ' BATCH_ID FROM ' . $this->gdvwname . ' GDVW, ' . $this->fiasname . ' FIAS WHERE GDVW.COMP_CODE = ' . singleQuote($comp_code) . ' ' . $cc2 . ' AND GDVW.EFFTDATE>=' . singleQuote($sdate) . ' AND GDVW.EFFTDATE<=' . singleQuote($edate) . ' AND GDVW.CURRENCY_CODE = ' . singleQuote($currency_code) . ' AND GDVW.CHART_FIELD03 = FIAS.IDCODE AND FIAS.FIDU_BANKACT_CODE = ' . singleQuote($bank_account_no) . ' GROUP BY GDVW.EFFTDATE, GDVW.GLACCOUNTCODE, GDVW.GL_TYPE, GDVW.TRUST_ITEM_TYPE';
            ClxCommon::$db->executeQuery($sql);
            // Seting initial balance amount and date
            $sql = 'UPDATE ' . $this->glt1name . ' GLT1 SET GLT1.INIT_BAL_AMT = IFNULL( (SELECT SUM(GDVW.DEBIT_TRANS_AMT-GDVW.CREDIT_TRANS_AMT) FROM ' . $this->gdvwname . ' GDVW, ' . $this->fiasname . ' FIAS WHERE GLT1.GLACCOUNTCODE = GDVW.GLACCOUNTCODE AND GDVW.COMP_CODE = ' . singleQuote($comp_code) . ' AND GDVW.EFFTDATE<GLT1.EFFTDATE AND FIAS.FIDU_BANKACT_CODE = ' . singleQuote($bank_account_no) . ' AND GDVW.CURRENCY_CODE = ' . singleQuote($currency_code) . ' AND GDVW.CHART_FIELD03 = FIAS.IDCODE ' . $cc2 . '),0), GLT1.NEXT_DATE = IFNULL( (SELECT MIN(GDVW.EFFTDATE) FROM ' . $this->gdvwname . ' GDVW, ' . $this->fiasname . ' FIAS WHERE GLT1.GLACCOUNTCODE = GDVW.GLACCOUNTCODE AND GDVW.COMP_CODE = ' . singleQuote($comp_code) . ' AND GDVW.EFFTDATE>GLT1.EFFTDATE AND GDVW.CHART_FIELD03=FIAS.IDCODE AND GDVW.CURRENCY_CODE = ' . singleQuote($currency_code) . ' AND  FIAS.FIDU_BANKACT_CODE = ' . singleQuote($bank_account_no) . ' ' . $cc2 . '),GLT1.EFFTDATE) WHERE GLT1.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLT1.TRUST_ITEM_TYPE = ' . singleQuote('CA') . '';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' GLT1 SET GLT1.CALC_AMT_01 = IFNULL((SELECT MAX(case FIBP.INTEREST_CALC WHEN ' . singleQuote('AC/AC') . ' THEN 365 WHEN ' . singleQuote('AC/365') . ' THEN 365 WHEN ' . singleQuote('30/365') . ' THEN 365 ELSE 360 END ) FROM ' . $this->fibpname . ' FIBP WHERE FIBP.BANKACT_CODE = ' . singleQuote($bank_account_no) . ' ),360) WHERE GLT1.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' GLT1 SET GLT1.CALC_AMT_02 = IFNULL((SELECT MAX(FIBP.INTEREST_RT) FROM ' . $this->fibpname . ' FIBP WHERE FIBP.BANKACT_CODE = ' . singleQuote($bank_account_no) . ' AND FIBP.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->fibpname . ' X WHERE X.BANKACT_CODE = ' . singleQuote($bank_account_no) . ' AND X.CLX_EFFTDATE<=GLT1.EFFTDATE)),0) WHERE GLT1.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' SET BALANCE_AMT = (INIT_BAL_AMT + DEBIT_AMT-CREDIT_AMT), GEN_PERIOD = DATEDIFF(NEXT_DATE,EFFTDATE) WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            /* ACTUALIZANDO BALANCE */
            $sql = 'DELETE FROM ' . $this->glt1name . ' WHERE BALANCE_AMT<=0 AND TRUST_ITEM_TYPE = ' . singleQuote('CA') . ' AND BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' SET BALANCE_AMT = DEBIT_AMT - CREDIT_AMT WHERE TRUST_ITEM_TYPE <> ' . singleQuote('CA') . ' AND BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
        }

        function source() {
            return $this->contents;
        }

        /**
         * Buils Bank Account Record
         *
         * @param string $contract_code
         * @param string $accountcode
         * @param string $participant_type
         * @param array $record
         * @return boolean
         */
        function build($bank_act_no, $record = array()) {
            if (empty($bank_act_no))
                return CLX_NUM_ZERO;
            $id = ClxCommon::$db->getField($this->fibkname, 'ID', 'BANK_ACCOUNT_NO = ' . singleQuote($bank_act_no));
            if (!empty($id))
                return $id;
            $DBTB = &getTool('DBTB');
            $rec = $DBTB->tableDefaultRecord('FIBK');
            $rec ['BANK_ACCOUNT_NO'] = $bank_act_no;
            foreach ($record as $key => $val) {
                if (array_key_exists($key, $rec))
                    $rec [$key] = $val;
            }
            if (!function_exists('setCreationData'))
                includeCodeLib('GEN_REC_UTIL');
            setCreationData($rec);
            setCreationIdCode($rec, 'FIBK');
            $id = ClxCommon::$db->createRecord($this->fibkname, $rec, false);
            return $id;
        }

        /**
         * Init Records
         * @param unknown_type $record
         */
        function init_form(&$record) {

        }

        /**
         * Loads Record
         * @param unknown_type $record
         */
        function load_form(&$record) {
            if (UserRequest::$request['ac'] === 'DUPLICATE' && empty(UserRequest::$post['confirm'])) {
                $record['FIBK_BANK_ACCOUNT_NO'] = '';
                $record['FIBK_EXT_PRODUCT_CODE'] = '';
                $record['FIBK_INI_INTPAID_AMT'] = CLX_INIT_ZERO;
                $record['FIBK_INTEARNED_AMT'] = CLX_INIT_ZERO;
                $record['FIBK_INTPAID_AMT'] = CLX_INIT_ZERO;
                $record['FIBK_BALANCE_AMT'] = CLX_INIT_ZERO;
            }
            //loading parameters from fibp
            $fibprec = $this->getCurrentFibp($record['FIBK_BANK_ACCOUNT_NO']);
            if (empty(UserRequest::$post['confirm']) && !empty($fibprec)) {
                unset($fibprec['ID']);
                foreach ($fibprec as $key => $val) {
                    $record['FIBP_' . $key] = $val;
                }
            }
            if (!empty($record['FIBK_IS_CDAC'])) {
                $fibnrec = $this->fibk_fibn_current_rec($record['FIBK_BANK_ACCOUNT_NO']);
                $record['FIBK_RENWAL_OPER_TYPE'] = (!empty($fibnrec['RENWAL_OPER_TYPE'])) ? $fibnrec['RENWAL_OPER_TYPE'] : CLX_CHAR_EMPTY_STRING;
                $record['FIBK_RENEW_QTY'] = (!empty($fibnrec['RENEW_QTY'])) ? $fibnrec['RENEW_QTY'] : '0';
            }
        }

        /**
         * Returns curren fibp record according accounting date
         *
         * @param type $bank_account_no
         * @return type Retru
         */
        private function getCurrentFibp($bank_account_no) {
            $sql = 'SELECT FIBP.* FROM FIDU_BANK_ACCOUNTS FIBK, GL_PARAMETERS_TBL GLCP, FIDU_FIBK_PARAMETERS_TBL FIBP WHERE GLCP.COMP_CODE = FIBK.COMP_CODE  AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($bank_account_no) . ' AND FIBP.BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND FIBP.CLX_EFFTDATE = (SELECT MAX(FIBPX.CLX_EFFTDATE) FROM FIDU_FIBK_PARAMETERS_TBL FIBPX WHERE FIBPX.BANKACT_CODE = FIBP.BANKACT_CODE AND FIBPX.CLX_EFFTDATE<=GLCP.OPERATION_DATE)';
            return ClxCommon::$db->getOneRecord($sql);
        }

        function rep_fibk_conciliations_prompt() {
            $formcode = 'REP_CONC';
            $title = dict('RTBL_FIBK_CONC');
            $ac = UserRequest::$request ['ac'];
            $to = UserRequest::$request [CLX_PROP_TO];
            UserRequest::$post = array_merge(UserRequest::$request, UserRequest::$post);
            if (empty(UserRequest::$post ['confirm'])) {
                UserRequest::$post ['RTBL_COMP_CODE'] = '';
                UserRequest::$post ['RTBL_TO_DATE'] = '';
                UserRequest::$post ['RTBL_BANK_ACCOUNT_NO'] = '';
            } else {
                $this->date_format = UserRequest::$post ['RTBL_DATE_FORMAT'];
                $this->edate = UserRequest::$post ['RTBL_TO_DATE'];
                $this->fibk_no = UserRequest::$post ['RTBL_BANK_ACCOUNT_NO'];
            }
            $it = (!empty(UserRequest::$request ['it'])) ? UserRequest::$request ['it'] : '';
            // RTBL_REPCINV
            $EDIT = &getTool('EDIT');
            $record = array();
            $msg = array();
            $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote($formcode));
            $record = UserRequest::$post;
            if (!empty($record ['confirm'])) {
                $EDIT->checkForm2($msg, $formrec);
                if (count(explode('-', UserRequest::$post ['RTBL_TO_DATE'])) != CLX_NUM_THREE)
                    $msg ['RTBL_TO_DATE'] = dict('GEN_ERR_CANTPARSE');
            }else {
                $record['RTBL_TO_DATE'] = '';
                $record['RTBL_DATE_FORMAT'] = 'Y-m-d';
            }

            $EDIT = &getTool('EDIT');
            $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', $title);
            //$form->setProp(CLX_PROP_TARGET, 'blank');
            if (!empty($record ['confirm']) && empty($msg)) {

                // Para ver batch
                $comp_code = UserRequest::$post ['RTBL_COMP_CODE'];
                $edate = UserRequest::$post ['RTBL_TO_DATE'];
                $bank_account_no = UserRequest::$post ['RTBL_BANK_ACCOUNT_NO'];
                if (!empty(UserRequest::$post['RTBL_REP_FORMAT'])) {
                    $format = UserRequest::$post['RTBL_REP_FORMAT'];
                } elseif (!empty(UserRequest::$post['RTBL_SEND_PDF'])) {
                    $format = (UserRequest::$post['RTBL_SEND_PDF'] == CLX_NUM_ONE) ? 'pdf' : 'html';
                    UserRequest::$post['RTBL_REP_FORMAT'] = $format;
                } else {
                    $format = 'html';
                }

                /*
                  UserRequest::$post['RTBL_REP_FORMAT'] = 'html';
                  $format = 'html';
                 */
                $sdate = adodb_prev_month_lastday($edate);
                $date_al = adodb_next_day($sdate);
                $date_last = adodb_month_lastday($date_al);
                $comprec = ClxCommon::$db->getRecord($this->compname, 'IDCODE = ' . singleQuote($comp_code));

                $sql = 'SELECT GLRC.IDCODE, COMP.IDNAME COMP_NAME, FIBK.BANK_ACCOUNT_NO, FIBK.IDNAME FIBK_NAME, GLRC.BEGIN_BALANCE_AMT, GLRC.END_BALANCE_AMT FROM BASE_COMPANIES COMP, FIDU_BANK_ACCOUNTS FIBK, ' . $this->glrcname . ' GLRC WHERE FIBK.COMP_CODE = COMP.IDCODE AND FIBK.BANK_ACCOUNT_NO = GLRC.FIDU_BANKACT_CODE AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($bank_account_no) . ' AND GLRC.TO_DATE = IFNULL((SELECT MAX(GLRCX.TO_DATE) FROM GL_CONCILIATIONS GLRCX WHERE GLRCX.FIDU_BANKACT_CODE = GLRC.FIDU_BANKACT_CODE AND GLRCX.TO_DATE <= ' . singleQuote($edate) . '),' . singleQuote($date_last) . ')';
                $fibkrec = ClxCommon::$db->getOneRecord($sql);
                if (empty($fibkrec)) {
                    $EDIT = &getTool('EDIT');
                    $msg ['RTBL_TO_DATE'] = dict('GEN_LBL_ERRP');
                    $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', $title);
                    $this->contents = $form->source();
                    return;
                }


                //-----------------------------------------------------report start
                // Schedule will redirect if not empty
                $this->rep_conciliations_earnings($fibkrec['IDCODE']);


                $FILE = getToolObject('DBFT', 'FILE');
                $complogo = $FILE->fileName($comprec ['COMP_LOGO']);
                if (!file_exists($complogo)) {
                    $complogo = '';
                }

                $amt = array('RETTRANF' => CLX_NUM_0_PT_00, 'RETCHEQ' => CLX_NUM_0_PT_00, 'DEPTRANF' => CLX_NUM_0_PT_00);
                $sql = 'SELECT IF(CREDIT_TRANS_AMT<0,' . singleQuote('RET') . ',' . singleQuote('DEP') . ') ESDEPOSITO, IF(CHECK_NO IS NULL, ' . singleQuote('TRANF') . ',' . singleQuote('CHEQ') . ') ESCHEQUE, SUM(CREDIT_TRANS_AMT) AMOUNT FROM GL_CONCILIATIONS_TMP WHERE RECONCILIED = 1 GROUP BY ESDEPOSITO, ESCHEQUE ORDER BY ESDEPOSITO DESC';
                $results = ClxCommon::$db->executeQuery($sql);
                while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                    $key = $result['ESDEPOSITO'] . $result['ESCHEQUE'];
                    if ($key === 'DEPCHEQ') {
                        $key = 'DEPTRANF';
                    }
                    $amt[$key] = $result['AMOUNT'];
                }
				ClxCommon::$db->freeResult($results);

                // labels
                $labels = array();
                $sql = 'SELECT FIELDNAME, FIELDLISTLABEL FROM CLX_DB_FIELDS WHERE FIELDNAME IN (' . singleQuote('BANK_ACCOUNT_NO') . ', ' . singleQuote('IDNAME') . ', ' . singleQuote('RECONCILIED') . ', ' . singleQuote('MDATE') . ', ' . singleQuote('MODIFIEDBY') . ', ' . singleQuote('CREDIT_TRANS_AMT') . ', ' . singleQuote('CREDIT_NO') . ', ' . singleQuote('COMP_CODE') . ', ' . singleQuote('EFFTDATE') . ') ';
                $results = ClxCommon::$db->executeQuery($sql);
                while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                    $labels [$result ['FIELDNAME']] = dict($result ['FIELDLISTLABEL']);
                }
				ClxCommon::$db->freeResult($results);

                /*
                 * Depositos y notas de credito
                 */
                $sql1 = 'SELECT IFNULL(SUM(CREDIT_TRANS_AMT),0) AMT FROM GL_CONCILIATIONS_TMP WHERE EFFTDATE BETWEEN ' . singleQuote($date_al) . ' AND ' . singleQuote($date_last) . ' AND CREDIT_TRANS_AMT > 0';
                $results1 = ClxCommon::$db->getOneRecord($sql1);
                $depositos_notas = $results1['AMT'] < CLX_NUM_ZERO ? $results1['AMT'] * -CLX_NUM_ONE : $results1['AMT'];

                /*
                 * Cheques Girados
                 */
                //$sql1 = 'SELECT IF(CHECK_NO IS NULL, 0, 1) ES_CHEQUE, IFNULL(SUM(CREDIT_TRANS_AMT),0) AMT FROM GL_CONCILIATIONS_TMP WHERE  RECONCILIED = 1 AND CREDIT_TRANS_AMT<0 GROUP BY ES_CHEQUE DESC';
                $sql1 = 'SELECT IF(CHECK_NO IS NULL, 0, 1) ES_CHEQUE, IFNULL(SUM(CREDIT_TRANS_AMT),0) AMT FROM GL_CONCILIATIONS_TMP WHERE EFFTDATE BETWEEN ' . singleQuote($date_al) . ' AND ' . singleQuote($date_last) . ' AND CREDIT_TRANS_AMT<0 GROUP BY ES_CHEQUE DESC';
                $results1 = ClxCommon::$db->getOneRecord($sql1);
                if ($results1['ES_CHEQUE'] == CLX_NUM_ONE) {
                    $cheques_girados = $results1['AMT'] < CLX_NUM_ZERO ? $results1['AMT'] * -CLX_NUM_ONE : $results1['AMT'];
                } else {
                    $cheques_girados = '0.00';
                }
                /*
                 * Notas de Debito
                 */
                //$sql1 = 'SELECT IF(CHECK_NO IS NULL, 0, 1) ES_CHEQUE, IFNULL(SUM(CREDIT_TRANS_AMT),0) AMT FROM GL_CONCILIATIONS_TMP WHERE RECONCILIED = 1 AND CREDIT_TRANS_AMT<0 GROUP BY ES_CHEQUE ASC';
                $sql1 = 'SELECT IF(CHECK_NO IS NULL, 0, 1) ES_CHEQUE, IFNULL(SUM(CREDIT_TRANS_AMT),0) AMT FROM GL_CONCILIATIONS_TMP WHERE EFFTDATE BETWEEN ' . singleQuote($date_al) . ' AND ' . singleQuote($date_last) . ' AND CREDIT_TRANS_AMT<0 GROUP BY ES_CHEQUE ASC';
                $results1 = ClxCommon::$db->getOneRecord($sql1);
                if ($results1['ES_CHEQUE'] == CLX_NUM_ZERO) {
                    $notas_debito = $results1['AMT'] < CLX_NUM_ZERO ? $results1['AMT'] * -CLX_NUM_ONE : $results1['AMT'];
                } else {
                    $notas_debito = '0.00';
                }
                /*
                 * Depositos en circulacion
                 */
                $sql1 = 'SELECT IFNULL(SUM(CREDIT_TRANS_AMT),0) AMT FROM GL_CONCILIATIONS_TMP WHERE RECONCILIED = 0 AND CREDIT_TRANS_AMT>0';
                $results1 = ClxCommon::$db->getOneRecord($sql1);
                $depositos_tranf = $results1['AMT'] < CLX_NUM_ZERO ? $results1['AMT'] * -CLX_NUM_ONE : $results1['AMT'];

                /**
                 * CHEQUES EN CIRCULACION
                 */
                $sql1 = 'SELECT IF(CHECK_NO IS NULL, 0, 1) ES_CHEQUE, IFNULL(SUM(CREDIT_TRANS_AMT),0) AMT FROM GL_CONCILIATIONS_TMP WHERE RECONCILIED = 0 AND CREDIT_TRANS_AMT<0 GROUP BY ES_CHEQUE DESC';
                $results1 = ClxCommon::$db->getOneRecord($sql1);
                if ($results1['ES_CHEQUE'] == CLX_NUM_ONE) {
                    $cheques_circulacion = $results1['AMT'] < CLX_NUM_ZERO ? $results1['AMT'] * -CLX_NUM_ONE : $results1['AMT'];
                } else {
                    $cheques_circulacion = '0.00';
                }
                /*
                 * DETALLE CHEQUES EN CIRCULACION
                 */
                $sql2 = 'SELECT DEBUG.IDCODE,DEBUG.IDNAME,DEBUG.EFFTDATE, DEBUG.CHECK_NO CHECK_NO, DEBUG.CREDIT_TRANS_AMT TRANS_AMT, IFNULL(FIAT.BENEFICIARY_NAME, (SELECT ACCO.IDNAME FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = FIAT.BENEFICIARY_CODE))  AS BENEFICIARY FROM GL_CONCILIATIONS_TMP DEBUG, GL_JOURNAL_HDR JEHD, FIDU_TRANSACTIONS FIAT WHERE DEBUG.RECONCILIED = 0 AND DEBUG.IDCODE = JEHD.IDCODE AND FIAT.IDCODE = JEHD.TRANS_CODE AND DEBUG.CREDIT_TRANS_AMT < 0 AND DEBUG.CHECK_NO IS NOT NULL ORDER BY DEBUG.CHECK_NO DESC, DEBUG.EFFTDATE, DEBUG.IDCODE';
                $results2 = ClxCommon::$db->executeQuery($sql2);
                $efftdate = array();
                while ($result2 = ClxCommon::$db->getNextRecord($results2)) {
                    $efftdate[] = $result2 ['EFFTDATE'];
                    $check_no[] = ($result2 ['CHECK_NO']==='00null')?'-':$result2 ['CHECK_NO'];
                    $beneficiary[] = $result2 ['BENEFICIARY'];
                    $trans_amt[] = $result2 ['TRANS_AMT'];

                }
				ClxCommon::$db->freeResult($results2);
                /*
                 * DEPOSITOS EN CIRCULACION
                 */
                $efftdate1 = array();
                //$sql1 = 'SELECT IDCODE, EFFTDATE, IDNAME DESCRIPTION, CREDIT_TRANS_AMT TRANS_AMT FROM GL_CONCILIATIONS_TMP WHERE RECONCILIED = 0 AND CREDIT_TRANS_AMT>0';
                $sql1 = 'SELECT IDCODE, EFFTDATE, IDNAME DESCRIPTION, CREDIT_TRANS_AMT TRANS_AMT FROM GL_CONCILIATIONS_TMP WHERE RECONCILIED = 0 AND CREDIT_TRANS_AMT>0';
                $results1 = ClxCommon::$db->executeQuery($sql1);
                while ($result1 = ClxCommon::$db->getNextRecord($results1)) {

                    $efftdate1[] = $result1 ['EFFTDATE'];
                    $description[] = $result1 ['DESCRIPTION'];
                    $trans_amt1[] = $result1 ['TRANS_AMT'];
                }
				ClxCommon::$db->freeResult($results1);
                $saldo_libros = $fibkrec['BEGIN_BALANCE_AMT'] == CLX_NUM_ZERO ? '0.00' : $fibkrec['BEGIN_BALANCE_AMT'];
                $saldo_libros_al = $saldo_libros + $depositos_notas - ($notas_debito + $cheques_girados);
                $saldo_libros_al = $saldo_libros_al == CLX_NUM_ZERO ? '0.00' : $saldo_libros_al;
                $saldo_banco = $fibkrec['END_BALANCE_AMT'] == CLX_NUM_ZERO ? '0.00' : $fibkrec['END_BALANCE_AMT'];
                $depositos_tranf = $depositos_tranf == CLX_NUM_ZERO ? '0.00' : $depositos_tranf;
                $total_chnt = $cheques_girados + $notas_debito;
                $total_chnt = $total_chnt == CLX_NUM_ZERO ? '0.00' : $total_chnt;
                $partida_conciliar = ($saldo_banco + $depositos_tranf - $cheques_circulacion) - $saldo_libros_al;
                //$partida_conciliar = $partida_conciliar < CLX_NUM_ZERO ? $partida_conciliar * -CLX_NUM_ONE : $partida_conciliar;
                $saldo_libro_banco = ($saldo_banco + $depositos_tranf) - ($cheques_circulacion + $partida_conciliar);
                //$saldo_libro_banco = $saldo_libro_banco < CLX_NUM_ZERO ? $saldo_libro_banco * -CLX_NUM_ONE : $saldo_libro_banco;
                $saldo_libro_banco = $saldo_libro_banco == CLX_NUM_ZERO ? '0.00' : $saldo_libro_banco;
                $this->includeReportFiles();

                if ($format == 'pdf') {
					ob_clean();
                    $pdf = new pdf_table('P', 'mm', 'letter');
                    $pdf->setReplogo($complogo, CLX_NUM_16, CLX_NUM_FIVE, CLX_NUM_40, CLX_NUM_28);
                    $pdf->SetMargins(CLX_NUM_TEN, CLX_NUM_TEN, CLX_NUM_TEN);


                    $pdf->num_page['view'] = true;
                    $pdf->num_page['position'] = CLX_NUM_265;
                    $pdf->num_page['nb'] = true;

                    $pdf->AddPage();
                    $pdf->SetFont('Arial','',CLX_NUM_TEN);

                    $pdf->Cell(CLX_NUM_200, CLX_NUM_ZERO, dict('GEN_LBL_DATE') . ': ' . date('d/m/Y'), CLX_NUM_ZERO, CLX_NUM_ONE, 'R');
                    $pdf->Ln(CLX_NUM_TEN);
                    $pdf->SetFont('Arial','B',CLX_NUM_TEN);
                    $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, dict('GEN_LBL_RC'), CLX_NUM_ZERO, CLX_NUM_ONE, 'C');
                    $pdf->Ln(CLX_NUM_TEN);

                    $pdf->SetFont('Arial','',CLX_NUM_TEN);

                    $pdf->SetDrawColor(hexdec ('00'),hexdec ('00'),hexdec ('00'));
                    $pdf->Rect(CLX_NUM_NINE, CLX_NUM_37, CLX_NUM_197, CLX_NUM_17, 'D');

                    $pdf->SetFillColor(hexdec ('DA'),hexdec ('E1'),hexdec ('E8'));
                    $pdf->SetDrawColor(hexdec ('DA'),hexdec ('E1'),hexdec ('E8'));

                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetWidths(array(CLX_NUM_60, CLX_NUM_135));
                    $pdf->Row(array($labels['BANK_ACCOUNT_NO'].':' , $bank_account_no), true);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->Row(array($labels['IDNAME'] . ':' , $fibkrec['FIBK_NAME']), true);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->Row(array(dict('GEN_LBL_CA') . ':' , xFormat::date($edate)), true);
                    $pdf->Ln(CLX_NUM_TEN);

                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetFont('Arial','B',CLX_NUM_TEN);
                    $pdf->SetWidths(array(CLX_NUM_60,CLX_NUM_60,CLX_NUM_75));
                    $pdf->SetAligns(array('L', 'L', 'R'));
                    $pdf->Row(array(dict('GEN_LBL_BOOK') . ':', xFormat::date($date_al, 'd/m/Y'), xFormat::number($this->verif_neg_zero($saldo_libros), CLX_NUM_TWO)), true);
                    $pdf->Ln(CLX_NUM_THREE);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->cell(CLX_NUM_TEN,CLX_NUM_ZERO,dict('GEN_LBL_MORE') . ':');
                    $pdf->SetFont('Arial','',CLX_NUM_TEN);
                    $pdf->Ln(CLX_NUM_FIVE);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->cell(CLX_NUM_115,CLX_NUM_ZERO,dict('GEN_LBL_DC') . ':');
                    $pdf->cell(CLX_NUM_40,CLX_NUM_ZERO,xFormat::number($this->verif_neg_zero($depositos_notas), CLX_NUM_TWO), CLX_NUM_ZERO, CLX_NUM_ZERO, 'R');
                    $pdf->cell(CLX_NUM_40,CLX_NUM_ZERO,xFormat::number($this->verif_neg_zero($depositos_notas), CLX_NUM_TWO), CLX_NUM_ZERO, CLX_NUM_ZERO, 'R');
                    $pdf->SetDrawColor(hexdec ('00'),hexdec ('00'),hexdec ('00'));
                    $pdf->Line(CLX_NUM_126, $pdf->GetY() + CLX_NUM_TWO, CLX_NUM_166, $pdf->GetY() + CLX_NUM_TWO);

                    $pdf->SetDrawColor(hexdec ('FF'),hexdec ('FF'),hexdec ('FF'));
                    $pdf->Ln(CLX_NUM_TEN);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetFont('Arial','B',CLX_NUM_TEN);
                    $pdf->cell(CLX_NUM_TEN,CLX_NUM_ZERO,dict('GEN_LBL_MN') . ':', CLX_NUM_ZERO);
                    $pdf->SetFont('Arial','',CLX_NUM_TEN);
                    $pdf->Ln(CLX_NUM_FIVE);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetWidths(array(CLX_NUM_115, CLX_NUM_40, CLX_NUM_40));
                    $pdf->SetAligns(array('L', 'R', 'R'));
                    $pdf->Row(array(dict('GEN_LBL_CH') . ':',xFormat::number($this->verif_neg_zero($cheques_girados), CLX_NUM_TWO), ''), false);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->Row(array(dict('GEN_LBL_ND') . ':',xFormat::number($this->verif_neg_zero($notas_debito), CLX_NUM_TWO), xFormat::number($this->verif_neg_zero($total_chnt), CLX_NUM_TWO)), false);
                    $pdf->SetDrawColor(hexdec ('00'),hexdec ('00'),hexdec ('00'));
                    $pdf->Line(CLX_NUM_126, $pdf->GetY(), CLX_NUM_166, $pdf->GetY());

                    $pdf->SetDrawColor(hexdec ('FF'),hexdec ('FF'),hexdec ('FF'));
                    $pdf->Ln(CLX_NUM_FIVE);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetWidths(array(CLX_NUM_60,CLX_NUM_55,CLX_NUM_80));
                    $pdf->SetAligns(array('L', 'L', 'R'));
                    $pdf->SetFont('Arial','B',CLX_NUM_TEN);
                    $pdf->Row(array(dict('GEN_LBL_BOOK_ADJ') . ':',xFormat::date($edate, 'd/m/Y'), xFormat::number($this->verif_neg_zero($saldo_libros_al), CLX_NUM_TWO)), true);
                    $pdf->SetFont('Arial','',CLX_NUM_TEN);
                    $pdf->SetDrawColor(hexdec ('00'),hexdec ('00'),hexdec ('00'));
                    $pdf->Line(CLX_NUM_166, $pdf->GetY() - CLX_NUM_5_PT_5, CLX_NUM_205, $pdf->GetY() - CLX_NUM_5_PT_5);
                    $pdf->Line(CLX_NUM_166, $pdf->GetY(), CLX_NUM_205, $pdf->GetY());
                    $pdf->Line(CLX_NUM_166, $pdf->GetY() + CLX_NUM_0_PT_5, CLX_NUM_205, $pdf->GetY() + CLX_NUM_0_PT_5);
                    $pdf->SetDrawColor(hexdec ('FF'),hexdec ('FF'),hexdec ('FF'));
                    $pdf->Ln(CLX_NUM_25);

                    $pdf->SetDrawColor(hexdec ('FF'),hexdec ('FF'),hexdec ('FF'));
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetWidths(array(CLX_NUM_60,CLX_NUM_55,CLX_NUM_80));
                    $pdf->SetAligns(array('L', 'L', 'R'));
                    $pdf->SetFont('Arial','B',CLX_NUM_TEN);
                    $pdf->Row(array(dict('GEN_LBL_BANK') . ':',xFormat::date($edate, 'd/m/Y'), xFormat::number($saldo_banco == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($saldo_banco), CLX_NUM_TWO)), true);
                    $pdf->Ln(CLX_NUM_THREE);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->cell(CLX_NUM_TEN,CLX_NUM_ZERO,dict('GEN_LBL_MORE') . ':');
                    $pdf->SetFont('Arial','',CLX_NUM_TEN);
                    $pdf->Ln(CLX_NUM_FIVE);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->cell(CLX_NUM_115,CLX_NUM_ZERO,dict('GEN_LBL_DT') . ':');
                    $pdf->cell(CLX_NUM_40,CLX_NUM_ZERO,xFormat::number($depositos_tranf == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($depositos_tranf), CLX_NUM_TWO), CLX_NUM_ZERO, CLX_NUM_ZERO, 'R');
                    $pdf->cell(CLX_NUM_40,CLX_NUM_ZERO,xFormat::number($depositos_tranf == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($depositos_tranf), CLX_NUM_TWO), CLX_NUM_ZERO, CLX_NUM_ZERO, 'R');
                    $pdf->SetDrawColor(hexdec ('00'),hexdec ('00'),hexdec ('00'));
                    $pdf->Line(CLX_NUM_126, $pdf->GetY() + CLX_NUM_TWO, CLX_NUM_166, $pdf->GetY() + CLX_NUM_TWO);
                    $pdf->SetDrawColor(hexdec ('FF'),hexdec ('FF'),hexdec ('FF'));

                    $pdf->Ln(CLX_NUM_TEN);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetFont('Arial','B',CLX_NUM_TEN);
                    $pdf->cell(CLX_NUM_TEN,CLX_NUM_ZERO,dict('GEN_LBL_MN') . ':', CLX_NUM_ZERO);
                    $pdf->SetFont('Arial','',CLX_NUM_TEN);
                    $pdf->Ln(CLX_NUM_FIVE);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetWidths(array(CLX_NUM_115, CLX_NUM_40, CLX_NUM_40));
                    $pdf->SetAligns(array('L', 'R', 'R'));
                    $pdf->Row(array(dict('GEN_LBL_CHC') . ':',xFormat::number($cheques_circulacion == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($cheques_circulacion), CLX_NUM_TWO), xFormat::number($cheques_circulacion == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($cheques_circulacion), CLX_NUM_TWO)), false);
                    $pdf->SetDrawColor(hexdec ('00'),hexdec ('00'),hexdec ('00'));
                    $pdf->Line(CLX_NUM_126, $pdf->GetY(), CLX_NUM_166, $pdf->GetY());
                    $pdf->SetDrawColor(hexdec ('FF'),hexdec ('FF'),hexdec ('FF'));

                    $pdf->Ln(CLX_NUM_TEN);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetFont('Arial','B',CLX_NUM_TEN);
                    $pdf->cell(CLX_NUM_155,CLX_NUM_ZERO,dict('GEN_LBL_DIF') . ':', CLX_NUM_ZERO);

                    $pdf->cell(CLX_NUM_40,CLX_NUM_ZERO,xFormat::number($partida_conciliar == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($partida_conciliar), CLX_NUM_TWO), CLX_NUM_ZERO, CLX_NUM_ZERO, 'R');

                    $pdf->Ln(CLX_NUM_FIVE);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetWidths(array(CLX_NUM_60,CLX_NUM_60,CLX_NUM_75));
                    $pdf->SetAligns(array('L', 'L', 'R'));
                    $pdf->Row(array(dict('GEN_LBL_BANK_ADJ') . ':', xFormat::date($edate, 'd/m/Y'), xFormat::number($this->verif_neg_zero($saldo_libro_banco), CLX_NUM_TWO)), true);
                    $pdf->SetDrawColor(hexdec ('00'),hexdec ('00'),hexdec ('00'));
                    $pdf->Line(CLX_NUM_166, $pdf->GetY() - CLX_NUM_5_PT_5, CLX_NUM_205, $pdf->GetY() - CLX_NUM_5_PT_5);
                    $pdf->Line(CLX_NUM_166, $pdf->GetY(), CLX_NUM_205, $pdf->GetY());
                    $pdf->Line(CLX_NUM_166, $pdf->GetY() + .5, CLX_NUM_205, $pdf->GetY() + CLX_NUM_0_PT_5);
                    $pdf->SetDrawColor(hexdec ('FF'),hexdec ('FF'),hexdec ('FF'));

                    $pdf->Ln(CLX_NUM_30);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetWidths(array(CLX_NUM_65,CLX_NUM_65,CLX_NUM_65));
                    $pdf->SetAligns(array('C', 'C', 'C'));
                    $pdf->Row(array(dict('684DC81FC6FD3419C9CBE370108E918F') . ':', dict('GEN_LBL_REVIEWED_BY') . ':', dict('0F1CAD282EAC5192170C1D9330D22C55') . ':'), false);
                    $pdf->Ln(CLX_NUM_TEN);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->Row(array('_____________________________', '_____________________________', '_____________________________'), false);

                    $pdf->AddPage();
                    $pdf->resetMargin = 10;
                    $pdf->marginLeft = CLX_NUM_TEN;
                    $pdf->marginTop = CLX_NUM_TEN;
                    $pdf->marginRight = CLX_NUM_TEN;
                    $pdf->ln_header = true;
                    $pdf->ln_header_post = 20;

                    $pdf->SetFont('Arial','',CLX_NUM_TEN);
                    $pdf->Cell(CLX_NUM_200, CLX_NUM_ZERO, dict('GEN_LBL_DATE') . ': ' . date('d/m/Y'), CLX_NUM_ZERO, CLX_NUM_ONE, 'R');
                    $pdf->Ln(CLX_NUM_TEN);
                    $pdf->SetFont('Arial','B',CLX_NUM_TEN);
                    $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, dict('GEN_LBL_RC'), CLX_NUM_ZERO, CLX_NUM_ONE, 'C');
                    $pdf->Ln(CLX_NUM_TEN);

                    $pdf->SetFont('Arial','',CLX_NUM_TEN);

                    $pdf->SetDrawColor(hexdec ('00'),hexdec ('00'),hexdec ('00'));
                    $pdf->Rect(CLX_NUM_NINE, CLX_NUM_37, CLX_NUM_197, CLX_NUM_17, 'D');

                    $pdf->SetFillColor(hexdec ('DA'),hexdec ('E1'),hexdec ('E8'));
                    $pdf->SetDrawColor(hexdec ('DA'),hexdec ('E1'),hexdec ('E8'));

                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetWidths(array(CLX_NUM_60, CLX_NUM_135));
                    $pdf->SetAligns(array('L', 'L'));
                    $pdf->Row(array($labels['BANK_ACCOUNT_NO'].':' , $bank_account_no), true);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->Row(array($labels['IDNAME'] . ':' , $fibkrec['FIBK_NAME']), true);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->Row(array(dict('GEN_LBL_CA') . ':' , xFormat::date($edate)), true);
                    $pdf->Ln(CLX_NUM_TEN);

                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetFont('Arial','B',CLX_NUM_TEN);
                    $pdf->cell(CLX_NUM_ZERO, CLX_NUM_ZERO, dict('GEN_LBL_DTCT'), false);
                    $pdf->Ln(CLX_NUM_FIVE);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetWidths(array(CLX_NUM_35, CLX_NUM_40, CLX_NUM_80, CLX_NUM_40));
                    $pdf->SetAligns(array('C', 'C', 'C', 'C'));
                    $pdf->SetDrawColor(hexdec ('00'),hexdec ('00'),hexdec ('00'));
                    $pdf->Row(array(dict('GEN_LBL_DATE'), dict('GEN_LBL_NUM_CHK'), dict('GEN_LBL_BENEFICIARY'), dict('B2F40690858B404ED10E62BDF422C704')), true);
                    $pdf->SetDrawColor(hexdec ('DA'),hexdec ('E1'),hexdec ('E8'));
                    $pdf->SetFont('Arial','',CLX_NUM_TEN);

                    $total_ch = CLX_INIT_ZERO;
                    $total = count($efftdate);
                    $pdf->SetAligns(array('C', 'C', 'L', 'R'));
                    for ($c = CLX_INIT_ZERO; $c < $total; $c++) {
                        $pdf->setX(CLX_NUM_TEN);
                        $pdf->Row(array(xFormat::date($efftdate[$c], 'd/m/Y'), $check_no[$c], $beneficiary[$c], number_format($trans_amt[$c] < CLX_NUM_ZERO ? $trans_amt[$c] * -CLX_NUM_ONE : $trans_amt[$c], CLX_NUM_TWO)), false);

                        $total_ch = $total_ch + $trans_amt[$c] * -CLX_NUM_ONE;
                    }

                    $pdf->Ln(CLX_NUM_THREE);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetFont('Arial','B',CLX_NUM_TEN);
                    $pdf->Cell(CLX_NUM_195, CLX_NUM_ZERO, number_format($total_ch, CLX_NUM_TWO), CLX_NUM_ZERO, CLX_NUM_ZERO, 'R');

                    $pdf->Ln(CLX_NUM_TEN);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->cell(CLX_NUM_ZERO, CLX_NUM_ZERO, dict('GEN_LBL_DTDT'), false);
                    $pdf->Ln(CLX_NUM_FIVE);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetWidths(array(CLX_NUM_35, CLX_NUM_120, CLX_NUM_40));
                    $pdf->SetAligns(array('C', 'C', 'C'));
                    $pdf->SetDrawColor(hexdec ('00'),hexdec ('00'),hexdec ('00'));
                    $pdf->Row(array(dict('GEN_LBL_DATE'), dict('FICO_CODE_DESCRIPTION'), dict('B2F40690858B404ED10E62BDF422C704')), true);
                    $pdf->SetDrawColor(hexdec ('DA'),hexdec ('E1'),hexdec ('E8'));
                    $pdf->SetFont('Arial','',CLX_NUM_TEN);

                    $total_dep = CLX_INIT_ZERO;
                    $total = count($efftdate1);
                    $pdf->SetAligns(array('C', 'L', 'R'));
                    for ($c = CLX_INIT_ZERO; $c < $total; $c++) {
                        $pdf->setX(CLX_NUM_TEN);
                        $pdf->Row(array(xFormat::date($efftdate1[$c], 'd/m/Y'), $description[$c], number_format($trans_amt1[$c], CLX_NUM_TWO)), false);

                        $total_dep = $total_dep + $trans_amt1[$c];
                    }

                    $pdf->Ln(CLX_NUM_TWO);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetFont('Arial','B',CLX_NUM_TEN);
                    $pdf->Cell(CLX_NUM_195, CLX_NUM_ZERO, number_format($total_dep, CLX_NUM_TWO), CLX_NUM_ZERO, CLX_NUM_ZERO, 'R');

                    $pdf->Ln(CLX_NUM_TEN);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->cell(CLX_NUM_ZERO, CLX_NUM_ZERO, dict('GEN_LBL_DET_DIF'), false);
                    $pdf->Ln(CLX_NUM_FIVE);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetWidths(array(CLX_NUM_35, CLX_NUM_120, CLX_NUM_40));
                    $pdf->SetAligns(array('C', 'C', 'C'));
                    $pdf->SetDrawColor(hexdec ('00'),hexdec ('00'),hexdec ('00'));
                    $pdf->Row(array(dict('GEN_LBL_DATE'), dict('FICO_CODE_DESCRIPTION'), dict('B2F40690858B404ED10E62BDF422C704')), true);
                    $pdf->setX(CLX_NUM_TEN);
                    $pdf->SetAligns(array('C', 'L', 'R'));
                    $pdf->SetDrawColor(hexdec ('DA'),hexdec ('E1'),hexdec ('E8'));
                    $pdf->Row(array(xFormat::date($edate, 'd/m/Y'), xFormat::text(''), xFormat::number($partida_conciliar == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($partida_conciliar), CLX_NUM_TWO)), false);

                    $this->contents = $this->pdf_end($pdf, 'rep_conc');
                    return true;
                }

                //Data completada para reporte formatos
                $styles = $this->build_styles_conc($format);
                $report = new clx_report('P', 'mm', 'letter');
                $report->setReplogo($complogo, CLX_NUM_16, CLX_NUM_FIVE, CLX_NUM_40, CLX_NUM_28);
                $report->disable_borders = false;
                $page1 = new clx_report_page('Conciliacion');
                $page1->setAutoPage(true, CLX_NUM_15);
                $page1->setLnHeader(CLX_NUM_14, CLX_NUM_SIX);
                $page1->setMargin(array(CLX_NUM_15, CLX_NUM_16, 'H'));
                $page1->setMargin(array(CLX_NUM_15, CLX_NUM_16, 'F'));
                $page1->setMargin(array(CLX_NUM_15, CLX_NUM_16, 'C'));
                $page1->setMarginTop(CLX_NUM_25);
                //$page1->setMarginTop(CLX_NUM_20);
                $page1->setNumPage(true);

                if($format == 'msexcel'){
                    $tabla__ = new clx_report_object_table();
                    $tabla__->addColumn(new clx_report_data($comprec['LEGAL_NAME'], $styles['cell_bold']), $format);
                    $tabla__->addColumn(new clx_report_data(dict('GEN_LBL_DATE') . ': ' . date('d/m/Y'), $styles['head2_']), $format);
                    $tabla__->addRow(new clx_report_data(dict('GEN_LBL_RC'), $styles['head1']));
                    $page1->addPanel(new clx_report_panel($tabla__));
                }else{
                    $page1->setHeader(new clx_report_data('', $styles['head']));
                    $page1->setHeader(new clx_report_data(dict('GEN_LBL_DATE') . ': ' . date('d/m/Y'), $styles['head2']));
                    $page1->setHeader(new clx_report_data('', $styles['head']));
                    $page1->setHeader(new clx_report_data(dict('GEN_LBL_RC'), $styles['head1']));
                }

                $tabla = new clx_report_object_table();
                if ($format == 'pdf') {

                }elseif ($format == 'msexcel') {
                    $tabla->addColumn(new clx_report_data($labels['BANK_ACCOUNT_NO'] . ':', $styles['cell_bold']), $format);
                    $tabla->addColumn(new clx_report_data($bank_account_no, $styles['cell']), $format);
                    $tabla->addRow(new clx_report_data($labels['IDNAME'] . ':', $styles['cell_bold']));
                    $tabla->addRow(new clx_report_data($fibkrec['FIBK_NAME'], $styles['cell']));
                    $tabla->addRow(new clx_report_data(dict('GEN_LBL_CA') . ':', $styles['cell_bold']));
                    $tabla->addRow(new clx_report_data(xFormat::date($edate), $styles['cell']));
                } else {
                    $tabla->addColumn(new clx_report_data($labels['BANK_ACCOUNT_NO'] . ':', $styles['tabla1']), $format);
                    $tabla->addColumn(new clx_report_data($bank_account_no, $styles['tabla1a']), $format);
                    $tabla->addRow(new clx_report_data($labels['IDNAME'] . ':', $styles['tabla1']));
                    $tabla->addRow(new clx_report_data($fibkrec['FIBK_NAME'], $styles['tabla1a']));
                    $tabla->addRow(new clx_report_data(dict('GEN_LBL_CA') . ':', $styles['tabla1']));
                    $tabla->addRow(new clx_report_data(xFormat::date($edate), $styles['tabla1a']));
                }

                $tabla->html_align = '';
                $tabla->html_tbl_post_br = true;
                $page1->addPanel(new clx_report_panel($tabla));

                $tabla1 = new clx_report_object_table();
                if($format<>'pdf'){
                    $tabla1->hideTableHeader();
                }
                $tabla1->addColumn(new clx_report_data('', $styles['tabla_1']), $format);
                $tabla1->addColumn(new clx_report_data('', $styles['tabla_2']), $format);
                $tabla1->addColumn(new clx_report_data('', $styles['tabla_3']), $format);
                $tabla1->addColumn(new clx_report_data('', $styles['tabla_4']), $format);
                $tabla1->addRow(new clx_report_data(dict('GEN_LBL_BOOK') . ':', $styles['tabla_esp1']));

                if ($format == 'msexcel') {
                    $tabla1->addRow(new clx_report_data(xFormat::date($date_al, 'd/m/Y'), $styles['cell_bold_center']));
                    $tabla1->addRow(new clx_report_data('', $styles['cell']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($this->verif_neg_zero($saldo_libros), CLX_NUM_TWO), $styles['cell_bold_right']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_MORE') . ':', $styles['cell_bold']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_DC') . ':', $styles['cell']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($this->verif_neg_zero($depositos_notas), CLX_NUM_TWO), $styles['cell_right_tot']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($this->verif_neg_zero($depositos_notas), CLX_NUM_TWO), $styles['cell_right_tot']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));

                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_MN') . ':', $styles['cell_bold']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));

                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_CH') . ':', $styles['cell']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_1']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($this->verif_neg_zero($cheques_girados), CLX_NUM_TWO), $styles['cell_right']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_1']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_ND') . ':', $styles['cell']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_1']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($this->verif_neg_zero($notas_debito), CLX_NUM_TWO), $styles['cell_right_tot']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($this->verif_neg_zero($total_chnt), CLX_NUM_TWO), $styles['cell_right_tot']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));

                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_BOOK_ADJ') . ':', $styles['cell_bold']));
                    $tabla1->addRow(new clx_report_data(xFormat::date($edate, 'd/m/Y'), $styles['cell_bold_center']));
                    $tabla1->addRow(new clx_report_data('', $styles['cell']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($this->verif_neg_zero($saldo_libros_al), CLX_NUM_TWO), $styles['cell_bold_right']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));

                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_BANK') . ':', $styles['cell_bold']));
                    $tabla1->addRow(new clx_report_data(xFormat::date($edate, 'd/m/Y'), $styles['cell_bold_center']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($saldo_banco == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($saldo_banco), CLX_NUM_TWO), $styles['cell_bold_right']));

                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));

                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_MORE') . ':', $styles['cell_bold']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_DT'), $styles['cell']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($depositos_tranf == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($depositos_tranf), CLX_NUM_TWO), $styles['cell_right']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_MN') . ':', $styles['cell_bold']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_CHC'), $styles['cell']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($cheques_circulacion == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($cheques_circulacion), CLX_NUM_TWO), $styles['cell_right']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));

                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_DIF'), $styles['cell_bold']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($partida_conciliar == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($partida_conciliar), CLX_NUM_TWO), $styles['cell_bold_right']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_BANK_ADJ') . ':', $styles['cell_bold']));
                    $tabla1->addRow(new clx_report_data(xFormat::date($edate, 'd/m/Y'), $styles['cell_bold_center']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($this->verif_neg_zero($saldo_libro_banco), CLX_NUM_TWO), $styles['cell_bold_right']));
                } else {
                    $tabla1->addRow(new clx_report_data(xFormat::date($date_al, 'd/m/Y'), $styles['tabla_esp2']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($this->verif_neg_zero($saldo_libros), CLX_NUM_TWO), $styles['tabla_esp3_']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_row']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_MORE') . ':', $styles['tabla_row']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_DC') . ':', $styles['tabla_esp4a']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($this->verif_neg_zero($depositos_notas), CLX_NUM_TWO), $styles['tabla_esp5_tot']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($this->verif_neg_zero($depositos_notas), CLX_NUM_TWO), $styles['tabla_esp3']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_row']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_MN') . ':', $styles['tabla_row']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_CH') . ':', $styles['tabla_esp4a']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($this->verif_neg_zero($cheques_girados), CLX_NUM_TWO), $styles['tabla_esp5']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp5a']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_ND') . ':', $styles['tabla_esp4a']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($this->verif_neg_zero($notas_debito), CLX_NUM_TWO), $styles['tabla_esp5_tot']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($this->verif_neg_zero($total_chnt), CLX_NUM_TWO), $styles['tabla_esp3']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_row']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_BOOK_ADJ') . ':', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(xFormat::date($edate, 'd/m/Y'), $styles['tabla_esp2']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($this->verif_neg_zero($saldo_libros_al), CLX_NUM_TWO), $styles['tabla_esp3_tot_double']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_row']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_BANK') . ':', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(xFormat::date($edate, 'd/m/Y'), $styles['tabla_esp2']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($saldo_banco == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($saldo_banco), CLX_NUM_TWO), $styles['tabla_esp3']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_row']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_MORE') . ':', $styles['tabla_esp7']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_DT') . ':', $styles['tabla_esp8']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($depositos_tranf == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($depositos_tranf), CLX_NUM_TWO), $styles['tabla_esp5_tot']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($depositos_tranf == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($depositos_tranf), CLX_NUM_TWO), $styles['tabla_esp3']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_row']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_MN') . ':', $styles['tabla_esp7']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_CHC') . ':', $styles['tabla_esp8']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($cheques_circulacion == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($cheques_circulacion), CLX_NUM_TWO), $styles['tabla_esp5_tot']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($cheques_circulacion == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($cheques_circulacion), CLX_NUM_TWO), $styles['tabla_esp3']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_row']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_DIF') . ':', $styles['tabla_esp6']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($partida_conciliar == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($partida_conciliar), CLX_NUM_TWO), $styles['tabla_esp3_tot']));
                    $tabla1->addRow(new clx_report_data('', $styles['tabla_row']));
                    $tabla1->addRow(new clx_report_data(dict('GEN_LBL_BANK_ADJ') . ':', $styles['tabla_esp1']));
                    $tabla1->addRow(new clx_report_data(xFormat::date($edate, 'd/m/Y'), $styles['tabla_esp2']));
                    $tabla1->addRow(new clx_report_data(xFormat::number($this->verif_neg_zero($saldo_libro_banco), CLX_NUM_TWO), $styles['tabla_esp3_tot_double']));
                }

                $tabla1->addRow(new clx_report_data('', $styles['tabla_1']));
                $tabla1->addRow(new clx_report_data('', $styles['tabla_2']));
                $tabla1->addRow(new clx_report_data('', $styles['tabla_3']));

                $tabla1->addRow(new clx_report_data('', $styles['tabla_4']));
                $tabla1->addRow(new clx_report_data('', $styles['tabla_1']));
                $tabla1->addRow(new clx_report_data('', $styles['tabla_2']));
                $tabla1->addRow(new clx_report_data('', $styles['tabla_3']));
                $tabla1->addRow(new clx_report_data('', $styles['tabla_4']));

                $tabla1->addRow(new clx_report_data('', $styles['tabla_1']));
                $tabla1->addRow(new clx_report_data('', $styles['tabla_2']));
                $tabla1->addRow(new clx_report_data('', $styles['tabla_3']));
                $tabla1->addRow(new clx_report_data('', $styles['tabla_4']));
                $tabla1->html_align = '';
                $page1->addPanel(new clx_report_panel($tabla1));

                $page1->setFooterPage(new clx_report_data(str_repeat(CLX_CHAR_HTML_NBSP, CLX_NUM_26) . dict('684DC81FC6FD3419C9CBE370108E918F') . ':'
                        . str_repeat(CLX_CHAR_HTML_NBSP, CLX_NUM_55) . dict('GEN_LBL_REVIEWED_BY') . ':'
                        . str_repeat(CLX_CHAR_HTML_NBSP, CLX_NUM_55) . dict('0F1CAD282EAC5192170C1D9330D22C55') . ':', $styles['foot_']));
                $page1->setFooterPage(new clx_report_data('', $styles['foot_']));
                $page1->setFooterPage(new clx_report_data(str_repeat(CLX_CHAR_HTML_NBSP, CLX_NUM_NINE) . '_____________________________'
                        . str_repeat(CLX_CHAR_HTML_NBSP, CLX_NUM_20) . '_____________________________'
                        . str_repeat(CLX_CHAR_HTML_NBSP, CLX_NUM_21) . '_____________________________', $styles['foot_']));
                $report->addPage($page1);

                //Parte 2
                $page2 = new clx_report_page('Anexo');
                $page2->setAutoPage(true, CLX_NUM_50);
                $page2->setLnHeader(CLX_NUM_14, CLX_NUM_SIX);
                $page2->setMargin(array(CLX_NUM_15, CLX_NUM_15, 'H'));
                $page2->setMargin(array(CLX_NUM_15, CLX_NUM_15, 'F'));
                $page2->setMargin(array(CLX_NUM_15, CLX_NUM_15, 'C'));
                $page2->setMarginTop(CLX_NUM_25);

                if($format == 'msexcel'){
                    $tabla__ = new clx_report_object_table();
                    $tabla__->addColumn(new clx_report_data($comprec['LEGAL_NAME'], $styles['cell_bold']), $format);
                    $tabla__->addColumn(new clx_report_data(dict('GEN_LBL_DATE') . ': ' . date('d/m/Y'), $styles['head2_']), $format);
                    $tabla__->addRow(new clx_report_data(dict('GEN_LBL_RC'), $styles['head1']));
                    $page2->addPanel(new clx_report_panel($tabla__));
                }else{
                    $page2->setHeader(new clx_report_data('', $styles['head']));
                    $page2->setHeader(new clx_report_data(dict('GEN_LBL_DATE') . ': ' . date('d/m/Y'), $styles['head2']));
                    $page2->setHeader(new clx_report_data('', $styles['head']));
                    $page2->setHeader(new clx_report_data(dict('GEN_LBL_RC'), $styles['head1']));
                }

                $tabla3 = new clx_report_object_table();

                if ($format == 'msexcel') {
                    $tabla3->addColumn(new clx_report_data($labels['BANK_ACCOUNT_NO'] . ':', $styles['cell_bold']), $format);
                    $tabla3->addColumn(new clx_report_data($bank_account_no, $styles['cell']), $format);
                    $tabla3->addRow(new clx_report_data($labels['IDNAME'] . ':', $styles['cell_bold']));
                    $tabla3->addRow(new clx_report_data($fibkrec['FIBK_NAME'], $styles['cell']));
                    $tabla3->addRow(new clx_report_data(dict('GEN_LBL_CA') . ':', $styles['cell_bold']));
                    $tabla3->addRow(new clx_report_data(xFormat::date($edate), $styles['cell']));
                } else {
                    $tabla3->addColumn(new clx_report_data($labels['BANK_ACCOUNT_NO'] . ':', $styles['tabla1']), $format);
                    $tabla3->addColumn(new clx_report_data($bank_account_no, $styles['tabla1a']), $format);
                    $tabla3->addRow(new clx_report_data($labels['IDNAME'] . ':', $styles['tabla1']));
                    $tabla3->addRow(new clx_report_data($fibkrec['FIBK_NAME'], $styles['tabla1a']));
                    $tabla3->addRow(new clx_report_data(dict('GEN_LBL_CA') . ':', $styles['tabla1']));
                    $tabla3->addRow(new clx_report_data(xFormat::date($edate), $styles['tabla1a']));
                }

                $tabla3->html_align = '';
                $page2->addPanel(new clx_report_panel($tabla3));
                $tabla4 = new clx_report_object_table();
                $tabla4->addColumn(new clx_report_data('', $styles['tabla_1a']), $format);
                $tabla4->addColumn(new clx_report_data('', $styles['tabla_2a']), $format);
                $tabla4->addColumn(new clx_report_data('', $styles['tabla_3a']), $format);
                $tabla4->addColumn(new clx_report_data('', $styles['tabla_4a']), $format);
                if ($format == 'msexcel') {
                    $tabla4->addRow(new clx_report_data(dict('GEN_LBL_DTCT'), $styles['cell_bold']));
                    $tabla4->addRow(new clx_report_data('', $styles['cell_bold']));
                    $tabla4->addRow(new clx_report_data('', $styles['cell_bold']));
                    $tabla4->addRow(new clx_report_data('', $styles['cell_bold']));
                    $tabla4->addRow(new clx_report_data(dict('GEN_LBL_DATE') . ':', $styles['cell_bold_center']));
                    $tabla4->addRow(new clx_report_data(dict('GEN_LBL_NUM_CHK') . ':', $styles['cell_bold_center']));
                    $tabla4->addRow(new clx_report_data(dict('GEN_LBL_BENEFICIARY') . ':', $styles['cell_bold_center']));
                    $tabla4->addRow(new clx_report_data(dict('B2F40690858B404ED10E62BDF422C704') . ':', $styles['cell_bold_center']));
                } else {
                    $tabla4->addRow(new clx_report_data(dict('GEN_LBL_DTCT'), $styles['blanco']));
                    $tabla4->addRow(new clx_report_data(dict('GEN_LBL_DATE') . ':', $styles['titulo1']));
                    $tabla4->addRow(new clx_report_data(dict('GEN_LBL_NUM_CHK') . ':', $styles['titulo2']));
                    $tabla4->addRow(new clx_report_data(dict('GEN_LBL_BENEFICIARY') . ':', $styles['titulo3']));
                    $tabla4->addRow(new clx_report_data(dict('B2F40690858B404ED10E62BDF422C704') . ':', $styles['titulo4']));
                }
                $tabla4->html_align = '';
                $total_ch = CLX_INIT_ZERO;

                $total = count($efftdate);
                for ($c = CLX_INIT_ZERO; $c < $total; $c++) {
                    if ($format == 'msexcel') {
                        $tabla4->addRow(new clx_report_data(xFormat::date($efftdate[$c], 'd/m/Y'), $styles['cell_center']));
                        $tabla4->addRow(new clx_report_data($check_no[$c], $styles['cell']));
                        $tabla4->addRow(new clx_report_data($beneficiary[$c], $styles['cell']));
                        $tabla4->addRow(new clx_report_data(number_format($trans_amt[$c] < CLX_NUM_ZERO ? $trans_amt[$c] * -CLX_NUM_ONE : $trans_amt[$c], CLX_NUM_TWO), $styles['cell_right']));
                    } else {
                        $tabla4->addRow(new clx_report_data(xFormat::date($efftdate[$c], 'd/m/Y'), $styles['data1']));
                        $tabla4->addRow(new clx_report_data($check_no[$c], $styles['data2']));
                        $tabla4->addRow(new clx_report_data($beneficiary[$c], $styles['data3']));
                        $tabla4->addRow(new clx_report_data(number_format($trans_amt[$c] < CLX_NUM_ZERO ? $trans_amt[$c] * -CLX_NUM_ONE : $trans_amt[$c], CLX_NUM_TWO), $styles['data4']));
                    }
                    $total_ch = $total_ch + $trans_amt[$c] * -CLX_NUM_ONE;
                }

                if ($format == 'msexcel') {
                    $tabla4->addRow(new clx_report_data('', $styles['cell']));
                    $tabla4->addRow(new clx_report_data('', $styles['cell']));
                    $tabla4->addRow(new clx_report_data('', $styles['cell']));
                    $tabla4->addRow(new clx_report_data(number_format($total_ch, CLX_NUM_TWO), $styles['cell_bold_right']));
                } else {
                    $tabla4->addRow(new clx_report_data(number_format($total_ch, CLX_NUM_TWO), $styles['dataCompleta1']));
                }

                $page2->addPanel(new clx_report_panel($tabla4));
                $tabla5 = new clx_report_object_table();
                if ($format == 'msexcel') {
                    $tabla5->addColumn(new clx_report_data('', $styles['tabla_1b']), $format);
                    $tabla5->addColumn(new clx_report_data('', $styles['tabla_2b']), $format);
                    $tabla5->addColumn(new clx_report_data('', $styles['tabla_2b']), $format);
                    $tabla5->addColumn(new clx_report_data('', $styles['tabla_3b']), $format);
                    $tabla5->addRow(new clx_report_data(dict('GEN_LBL_DTDT'), $styles['cell_bold__']));
                    $tabla5->addRow(new clx_report_data('', $styles['tabla_1b']));
                    $tabla5->addRow(new clx_report_data('', $styles['tabla_1b']));
                    $tabla5->addRow(new clx_report_data('', $styles['tabla_1b']));
                    $tabla5->addRow(new clx_report_data(dict('GEN_LBL_DATE') . ':', $styles['cell_bold_center']));
                    $tabla5->addRow(new clx_report_data(dict('FICO_CODE_DESCRIPTION') . ':', $styles['cell_bold_2_center']));
                    $tabla5->addRow(new clx_report_data('', $styles['tabla_1b']));
                    $tabla5->addRow(new clx_report_data(dict('B2F40690858B404ED10E62BDF422C704') . ':', $styles['cell_bold_center']));
                } else {
                    $tabla5->addColumn(new clx_report_data('', $styles['tabla_1b']), $format);
                    $tabla5->addColumn(new clx_report_data('', $styles['tabla_2b']), $format);
                    $tabla5->addColumn(new clx_report_data('', $styles['tabla_3b']), $format);
                    $tabla5->addRow(new clx_report_data(dict('GEN_LBL_DTDT'), $styles['blanco2']));
                    $tabla5->addRow(new clx_report_data(dict('GEN_LBL_DATE') . ':', $styles['titulo1b']));
                    $tabla5->addRow(new clx_report_data(dict('FICO_CODE_DESCRIPTION') . ':', $styles['titulo2b']));
                    $tabla5->addRow(new clx_report_data(dict('B2F40690858B404ED10E62BDF422C704') . ':', $styles['titulo3b']));
                }
                $tabla5->html_align = '';
                $total_dep = CLX_INIT_ZERO;

                $total = count($efftdate1);
                for ($c = CLX_INIT_ZERO; $c < $total; $c++) {
                    if ($format == 'msexcel') {
                        $tabla5->addRow(new clx_report_data(xFormat::date($efftdate1[$c], 'd/m/Y'), $styles['cell_center']));
                        $tabla5->addRow(new clx_report_data($description[$c], $styles['cell_']));
                        $tabla5->addRow(new clx_report_data('', $styles['tabla_1b']));
                        $tabla5->addRow(new clx_report_data(number_format($trans_amt1[$c], CLX_NUM_TWO), $styles['cell_right']));
                    } else {
                        $tabla5->addRow(new clx_report_data(xFormat::date($efftdate1[$c], 'd/m/Y'), $styles['data1b']));
                        $tabla5->addRow(new clx_report_data($description[$c], $styles['data2b']));
                        $tabla5->addRow(new clx_report_data(number_format($trans_amt1[$c], CLX_NUM_TWO), $styles['data3b']));
                    }
                    $total_dep = $total_dep + $trans_amt1[$c];
                }

                if ($format == 'msexcel') {
                    $tabla5->addRow(new clx_report_data('', $styles['cell']));
                    $tabla5->addRow(new clx_report_data('', $styles['cell']));
                    $tabla5->addRow(new clx_report_data('', $styles['cell']));
                    $tabla5->addRow(new clx_report_data(number_format($total_dep, CLX_NUM_TWO), $styles['cell_bold_right']));
                } else {
                    $tabla5->addRow(new clx_report_data(number_format($total_dep, CLX_NUM_TWO), $styles['dataCompleta2']));
                }
                $page2->addPanel(new clx_report_panel($tabla5));

                $tabla6 = new clx_report_object_table();

                if ($format == 'msexcel') {
                    $tabla6->addColumn(new clx_report_data('', $styles['tabla_1b']), $format);
                    $tabla6->addColumn(new clx_report_data('', $styles['tabla_1b']), $format);
                    $tabla6->addColumn(new clx_report_data('', $styles['tabla_2b']), $format);
                    $tabla6->addColumn(new clx_report_data('', $styles['tabla_3b']), $format);

                    $tabla6->addRow(new clx_report_data(dict('GEN_LBL_DET_DIF'), $styles['cell_bold__']));
                    $tabla6->addRow(new clx_report_data('', $styles['cell_bold']));
                    $tabla6->addRow(new clx_report_data('', $styles['cell_bold']));
                    $tabla6->addRow(new clx_report_data('', $styles['cell_bold']));
                    $tabla6->addRow(new clx_report_data(dict('GEN_LBL_DATE') . ':', $styles['cell_bold_center']));
                    $tabla6->addRow(new clx_report_data(dict('FICO_CODE_DESCRIPTION') . ':', $styles['cell_bold_2_center']));
                    $tabla6->addRow(new clx_report_data('', $styles['tabla_3b']));
                    $tabla6->addRow(new clx_report_data(dict('B2F40690858B404ED10E62BDF422C704') . ':', $styles['cell_bold_center']));
                    $tabla6->addRow(new clx_report_data(xFormat::date($edate, 'd/m/Y'), $styles['cell_bold_center']));
                    $tabla6->addRow(new clx_report_data(xFormat::text(''), $styles['cell_bold_']));
                    $tabla6->addRow(new clx_report_data('', $styles['tabla_3b']));
                    $tabla6->addRow(new clx_report_data(xFormat::number($partida_conciliar == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($partida_conciliar), CLX_NUM_TWO), $styles['cell_bold_right']));
                } else {
                    $tabla6->addColumn(new clx_report_data('', $styles['tabla_1b']), $format);
                    $tabla6->addColumn(new clx_report_data('', $styles['tabla_2b']), $format);
                    $tabla6->addColumn(new clx_report_data('', $styles['tabla_3b']), $format);

                    $tabla6->addRow(new clx_report_data(dict('GEN_LBL_DET_DIF'), $styles['blanco2']));
                    $tabla6->addRow(new clx_report_data(dict('GEN_LBL_DATE') . ':', $styles['titulo1b']));
                    $tabla6->addRow(new clx_report_data(dict('FICO_CODE_DESCRIPTION') . ':', $styles['titulo2b']));
                    $tabla6->addRow(new clx_report_data(dict('B2F40690858B404ED10E62BDF422C704') . ':', $styles['titulo3b']));
                    $tabla6->addRow(new clx_report_data(xFormat::date($edate, 'd/m/Y'), $styles['data1b_']));
                    $tabla6->addRow(new clx_report_data(xFormat::text(''), $styles['data2b_']));
                    $tabla6->addRow(new clx_report_data(xFormat::number($partida_conciliar == CLX_NUM_ZERO ? '0.00' : $this->verif_neg_zero($partida_conciliar), CLX_NUM_TWO), $styles['data3b_']));
                }
                $tabla6->html_align = '';
                $page2->addPanel(new clx_report_panel($tabla6));


                $report->addPage($page2);
                //$this->contents = $report->source2($format, false);

                if ($format == 'html') {
                    $contents = $report->source2($format, false);
                    $htmltable = new htmlTable(CLX_NUM_ONE);
                    $htmltable->setProp('border', CLX_NUM_ZERO);
                    $htmltable->setProp('cellpadding', CLX_NUM_TEN);
                    $htmltable->setProp('style', ' height: 100px; width: 90px;');
                    $htmltable->addCell($contents . '<br><Br>', array());
                    $this->contents = $htmltable->source();
                } else {
                    $this->contents = $report->source2($format, false);
                }
                // Clearing all temporary tables
                $this->initTemporaryTables($this->batch_id);
            } else {
                $this->contents = $form->source();
            }
        }

        /*
         * Verificar Monto en zero
         */
        function verif_neg_zero($monto){
            if(number_format($monto, CLX_NUM_TWO) == -0.00)
                $monto = abs($monto);
            return $monto;
        }

        /**
         * Estilos para proceso de conciliacion
         * @return type
         */
        private function build_styles_conc($format) {

            $styles = array();
            $styles['all'] = new clx_style('all');
            $styles['all']->setFontSize(CLX_NUM_TEN);
            $styles['all']->setFontFace('Arial');
            //$styles['all']->setBoxHeight(0);

            if ($format == 'html') {
                $styles['all']->setBoxHeight(CLX_NUM_25);
            } else {
                $styles['all']->setBoxHeight(CLX_NUM_ZERO);
            }
            //$styles['all']->setBoxPadding(CLX_NUM_ZERO);
            //$styles['all']->setBoxBorder(CLX_NUM_ONE);
            //$styles['all']->setBoxBorder(0);
            //$styles['all']->setBoxBorderColor('FFFFFF');
            //$styles['all']->setBoxWidth(40);
            $styles['all']->setFontColor('000000');
            //$styles['all']->setBoxBgColor('FFFFFF');
            //$styles['all']->setNumber(CLX_NUM_13, CLX_NUM_14, CLX_NUM_15);


            $styles['head'] = $styles['all']->copyStyle('head');
            $styles['head']->setFontSize(CLX_NUM_13);
            $styles['head']->setFontAligment(CLX_PROP_LEFT);
            $styles['head']->setFontBold();
            //$styles['head']->setBoxWidth(CLX_NUM_744);
            $styles['head']->setFontColor('0618AB');
            $styles['head']->setBoxColSpan(CLX_NUM_FOUR);
            //$styles['head']->setBoxBorder(0);
            //$styles['head']->setNumber(CLX_NUM_16, CLX_NUM_17, CLX_NUM_18);
            //$styles['head']->setNumber(CLX_NUM_16, CLX_NUM_17, CLX_NUM_18);

            $styles['head1'] = $styles['head']->copyStyle('head1');
            $styles['head1']->setFontAligment('center');
            $styles['head1']->setFontBold();

            $styles['head2'] = $styles['head']->copyStyle('head2');
            $styles['head2']->setFontAligment(CLX_PROP_RIGHT);
            $styles['head2']->setFontBold();
            $styles['head2']->setFontSize(CLX_NUM_NINE);
            //$styles['tabla'] = $styles['head']->copyStyle('tabla');

            $styles['head2_'] = $styles['head2']->copyStyle('head2_');
            $styles['head2_']->setBoxColSpan(CLX_NUM_THREE);

            $styles['tabla'] = $styles['all']->copyStyle('tabla');
            $styles['tabla']->unsetFontBold();
            //$styles['tabla']->setFontSize(CLX_NUM_8);
            $styles['tabla']->setBoxBgColor('DAE1E8');
            $styles['tabla']->setBoxBorder(CLX_NUM_ONE);
            $styles['tabla']->setBoxWidth(CLX_NUM_250);
            $styles['tabla']->setBoxBorderColor('FFFFFF');

            $styles['tabla1a'] = $styles['tabla']->copyStyle('tabla1a');
            $styles['tabla1a']->setBoxWidth(CLX_NUM_550);


            // $styles['tabla']->setNumber(CLX_NUM_19, CLX_NUM_20, CLX_NUM_21);
            if ($format == 'msexcel') {
                $styles['tabla']->setNumber(CLX_NUM_19, CLX_NUM_20, CLX_NUM_21);

                $styles['cell'] = $styles['all']->copyStyle('cell');
                $styles['cell_'] = $styles['cell']->copyStyle('cell_');
                $styles['cell_']->setBoxColSpan(CLX_NUM_TWO);
                $styles['cell_bold'] = $styles['all']->copyStyle('cell_bold');
                $styles['cell_bold']->setFontBold();
                $styles['cell_bold_'] = $styles['cell_bold']->copyStyle('cell_bold_');
                $styles['cell_bold_']->setBoxColSpan(CLX_NUM_TWO);

                $styles['cell_bold_2_center'] = $styles['cell_bold_']->copyStyle('cell_bold_2_center');
                $styles['cell_bold_2_center']->setFontAligment('center');

                $styles['cell_bold__'] = $styles['cell_bold_']->copyStyle('cell_bold__');
                $styles['cell_bold__']->setBoxColSpan(CLX_NUM_FOUR);
                $styles['cell_right'] = $styles['cell']->copyStyle('cell_right');
                $styles['cell_right']->setFontAligment('right');
                $styles['cell_center'] = $styles['cell']->copyStyle('cell_center');
                $styles['cell_center']->setFontAligment('center');
                $styles['cell_bold_right'] = $styles['cell_bold']->copyStyle('cell_bold_right');
                $styles['cell_bold_right']->setFontAligment('right');
                $styles['cell_bold_center'] = $styles['cell_bold']->copyStyle('cell_bold_center');
                $styles['cell_bold_center']->setFontAligment('center');

                $styles['cell_right_tot'] = $styles['cell_right']->copyStyle('cell_right_tot');
                $styles['cell_right_tot']->setBoxBorder(CLX_NUM_ONE);

                $styles['cell_doble'] = $styles['cell']->copyStyle('cell_doble');
                $styles['cell_doble']->setBoxColSpan(CLX_NUM_TWO);
                $styles['cell_doble']->setBoxWidth(CLX_NUM_ZERO);
            }
            $styles['tabla1'] = $styles['tabla']->copyStyle('tabla1');
            $styles['tabla1']->setBoxWidth(CLX_NUM_200);


            $styles['tabla_1'] = $styles['all']->copyStyle('tabla_1');

            //$styles['tabla_1']->setBoxHeight(CLX_NUM_0_PT_1);
            //$styles['tabla_1']->setBoxWidth(CLX_NUM_279);
            $styles['tabla_2'] = $styles['all']->copyStyle('tabla_2');
            //$styles['tabla_2']->setBoxHeight(CLX_NUM_0_PT_1);
            //$styles['tabla_2']->setBoxWidth(CLX_NUM_230);
            $styles['tabla_3'] = $styles['all']->copyStyle('tabla_3');
            //$styles['tabla_3']->setBoxHeight(CLX_NUM_0_PT_1);
            //$styles['tabla_3']->setBoxWidth(CLX_NUM_140);
            $styles['tabla_4'] = $styles['all']->copyStyle('tabla_4');
            //$styles['tabla_4']->setBoxHeight(CLX_NUM_0_PT_1);
            //$styles['tabla_4']->setBoxWidth(CLX_NUM_90);
            $styles['tabla_esp1'] = $styles['tabla']->copyStyle('tabla_esp1');
            $styles['tabla_esp1']->setBoxBgColor('F2F1F1');
            $styles['tabla_esp1']->setBoxBorder(CLX_NUM_ONE);
            //$styles['tabla_esp1']->setBoxWidth(CLX_NUM_279);
            $styles['tabla_esp1']->setBoxBorderColor('FFFFFF');
            $styles['tabla_esp1']->setFontBold();
            //$styles['tabla_esp1']->setNumber(CLX_NUM_22, CLX_NUM_23, CLX_NUM_24);
            $styles['tabla_esp2'] = $styles['tabla_esp1']->copyStyle('tabla_esp2');
            $styles['tabla_esp2']->setFontAligment('center');
            $styles['tabla_esp2']->setBoxColSpan(CLX_NUM_TWO);
            //$styles['tabla_esp2']->setBoxWidth(CLX_NUM_372);
            $styles['tabla_esp2']->setFontBold();
            $styles['tabla_esp3'] = $styles['tabla_esp1']->copyStyle('tabla_esp3');
            $styles['tabla_esp3']->setFontAligment(CLX_PROP_RIGHT);
            $styles['tabla_esp3']->setBoxBgColor('DAE1E8');
            //$styles['tabla_esp3']->setBoxWidth(CLX_NUM_90);
            $styles['tabla_esp3']->unsetFontBold();
            $styles['tabla_esp3_'] = $styles['tabla_esp3']->copyStyle('tabla_esp3_');
            $styles['tabla_esp3_']->setFontBold();
            if ($format == 'msexcel') {
                $styles['tabla_esp3']->setNumber(CLX_NUM_25, CLX_NUM_26, CLX_NUM_27);
            }
            //$styles['tabla_esp3']->setNumber(CLX_NUM_25, CLX_NUM_26, CLX_NUM_27);
            $styles['tabla_esp4'] = $styles['tabla_esp1']->copyStyle('tabla_esp4');
            $styles['tabla_esp4']->setBoxColSpan(CLX_NUM_TWO);
            $styles['tabla_esp4']->setBoxWidth(CLX_NUM_ZERO);
            //$styles['tabla_esp4']->setBoxWidth(CLX_NUM_530);
            $styles['tabla_row'] = $styles['all']->copyStyle('tabla_row');
            $styles['tabla_row']->setBoxColSpan(CLX_NUM_FOUR);
            $styles['tabla_row']->setFontBold();


            $styles['tabla_esp4a'] = $styles['tabla_esp4']->copyStyle('tabla_esp4a');
            $styles['tabla_esp4a']->unsetFontBold();
            //$styles['tabla_esp4a']->setBoxWidth(CLX_NUM_532);
            $styles['tabla_esp5'] = $styles['tabla_esp3']->copyStyle('tabla_esp5');
            $styles['tabla_esp5']->setFontAligment(CLX_PROP_RIGHT);
            $styles['tabla_esp5']->setBoxBgColor('F2F1F1');
            $styles['tabla_esp5']->setBoxWidth(CLX_NUM_ZERO);
            //$styles['tabla_esp5']->setBoxWidth(CLX_NUM_140);
            if ($format == 'msexcel') {
                $styles['tabla_esp5']->setNumber(CLX_NUM_22, CLX_NUM_23, CLX_NUM_24);
            }
            //$styles['tabla_esp5']->setNumber(CLX_NUM_22, CLX_NUM_23, CLX_NUM_24);
            $styles['tabla_esp5a'] = $styles['tabla_esp5']->copyStyle('tabla_esp5a');
            //$styles['tabla_esp5a']->setBoxWidth(CLX_NUM_70);
            $styles['tabla_esp5a']->setBoxWidth(CLX_NUM_ZERO);
            $styles['tabla_esp6'] = $styles['tabla_esp1']->copyStyle('tabla_esp6');
            $styles['tabla_esp6']->setBoxColSpan(CLX_NUM_THREE);
            $styles['tabla_esp6']->setBoxWidth(CLX_NUM_ZERO);
            $styles['tabla_esp7'] = $styles['tabla_esp1']->copyStyle('tabla_esp7');
            $styles['tabla_esp7']->setBoxColSpan(CLX_NUM_THREE);
            $styles['tabla_esp7']->setBoxWidth(CLX_NUM_ZERO);
            //$styles['tabla_esp7']->setBoxWidth(CLX_NUM_444);
            $styles['tabla_esp8'] = $styles['tabla_esp1']->copyStyle('tabla_esp8');
            $styles['tabla_esp8']->unsetFontBold();
            $styles['tabla_esp8']->setBoxColSpan(CLX_NUM_TWO);
            $styles['tabla_esp8']->setBoxWidth(CLX_NUM_ZERO);
            //$styles['tabla_esp8']->setBoxWidth(CLX_NUM_372);

            $styles['tabla_esp5_tot'] = $styles['tabla_esp5']->copyStyle('tabla_esp5_tot');
            $styles['tabla_esp5_tot']->setBoxBorder(CLX_NUM_ONE, 'solid', 'black', 'B');

            $styles['tabla_esp3_tot'] = $styles['tabla_esp3']->copyStyle('tabla_esp3_tot');
            $styles['tabla_esp3_tot']->setBoxBorder(CLX_NUM_ONE, 'solid', 'black', 'B');
            $styles['tabla_esp3_tot']->setFontBold();

            $styles['tabla_esp3_tot_double'] = $styles['tabla_esp3']->copyStyle('tabla_esp3_tot_double');
            $styles['tabla_esp3_tot_double']->setBoxBorder(CLX_NUM_FOUR, 'double', 'black', 'BT');
            $styles['tabla_esp3_tot_double']->setFontBold();

            $styles['dataCompleta'] = $styles['all']->copyStyle('dataCompleta');
            $styles['dataCompleta']->setBoxColSpan(CLX_NUM_FOUR);
            $styles['dataCompleta']->setBoxBgColor('F2F1F1');

            //$styles['dataCompleta']->setBoxWidth(CLX_NUM_746);
            $styles['foot_'] = $styles['all']->copyStyle('foot_');
            $styles['foot_']->setFontAligment(CLX_PROP_LEFT);
            //$styles['foot_']->setBoxWidth(CLX_NUM_738);
            $styles['foot_']->setFontSize(CLX_NUM_8);
            $styles['foot_']->setFontColor('0618AB');
            // $styles['foot_']->setNumber(CLX_NUM_16, CLX_NUM_17, CLX_NUM_18);
            $styles['blanco'] = $styles['tabla_esp1']->copyStyle('blanco');
            //$styles['blanco']->setBoxWidth(CLX_NUM_746);
            $styles['blanco']->setBoxBorder(CLX_NUM_ONE);
            $styles['blanco']->setBoxBgColor('FFFFFF');
            $styles['blanco']->setBoxBorderColor('FFFFFF');
            $styles['blanco']->setBoxColSpan(CLX_NUM_FOUR);
            //$styles['blanco']->setNumber(CLX_NUM_28, CLX_NUM_29, CLX_NUM_30);
            $styles['blanco2'] = $styles['blanco']->copyStyle('blanco2');
            $styles['blanco2']->setBoxColSpan(CLX_NUM_THREE);
            //$styles['blanco2']->setBoxColSpan(CLX_NUM_FOUR);
            $styles['blanco2']->setBoxWidth(CLX_NUM_1024);
            $styles['tabla_1a'] = $styles['all']->copyStyle('tabla_1a');
            //$styles['tabla_1a']->setBoxHeight(CLX_NUM_0_PT_1);
            //$styles['tabla_1a']->setBoxWidth(CLX_NUM_HUNDRED);
            $styles['tabla_2a'] = $styles['all']->copyStyle('tabla_2a');
            //$styles['tabla_2a']->setBoxHeight(CLX_NUM_0_PT_1);
            //$styles['tabla_2a']->setBoxWidth(CLX_NUM_150);
            $styles['tabla_3a'] = $styles['all']->copyStyle('tabla_3a');
            //$styles['tabla_3a']->setBoxHeight(CLX_NUM_0_PT_1);
            //$styles['tabla_3a']->setBoxWidth(CLX_NUM_310);
            $styles['tabla_4a'] = $styles['all']->copyStyle('tabla_4a');
            //$styles['tabla_4a']->setBoxHeight(CLX_NUM_0_PT_1);
            //$styles['tabla_4a']->setBoxWidth(CLX_NUM_180);
            $styles['titulo1'] = $styles['tabla_esp1']->copyStyle('titulo1');
            $styles['titulo1']->setFontAligment('center');
            $styles['titulo1']->setBoxBorder(CLX_NUM_ONE);
            $styles['titulo1']->setBoxBorderColor('FFFFFF');
            $styles['titulo1']->setBoxBgColor('DAE1E8');
            //$styles['titulo1']->setBoxWidth(CLX_NUM_HUNDRED);
            $styles['titulo1']->setFontColor('0618AB');
            //$styles['titulo1']->setNumber(CLX_NUM_31, CLX_NUM_32, CLX_NUM_33);
            $styles['titulo2'] = $styles['titulo1']->copyStyle('titulo2');
            //$styles['titulo2']->setBoxWidth(CLX_NUM_150);
            $styles['titulo3'] = $styles['titulo1']->copyStyle('titulo3');
            $styles['titulo3']->setBoxWidth(CLX_NUM_270);
            $styles['titulo4'] = $styles['titulo1']->copyStyle('titulo4');
            //$styles['titulo4']->setBoxWidth(CLX_NUM_180);
            $styles['dataCompleta1'] = $styles['dataCompleta']->copyStyle('dataCompleta1');
            $styles['dataCompleta1']->setFontAligment(CLX_PROP_RIGHT);
            $styles['dataCompleta1']->setBoxBgColor('FFFFFF');
            $styles['dataCompleta1']->setFontBold();
            $styles['dataCompleta2'] = $styles['dataCompleta1']->copyStyle('dataCompleta2');
            $styles['dataCompleta2']->setFontAligment(CLX_PROP_RIGHT);
            $styles['dataCompleta2']->setBoxColSpan(CLX_NUM_THREE);
            $styles['data1'] = $styles['tabla_esp1']->copyStyle('data1');
            $styles['data1']->setFontAligment('center');
            //$styles['data1']->setBoxWidth(CLX_NUM_HUNDRED);
            $styles['data1']->unsetFontBold();
            $styles['data2'] = $styles['data1']->copyStyle('data2');
            //$styles['data2']->setBoxWidth(CLX_NUM_150);
            $styles['data3'] = $styles['data1']->copyStyle('data3');
            $styles['data3']->setFontAligment(CLX_PROP_LEFT);
            $styles['data3']->setBoxWidth(CLX_NUM_270);
            $styles['data4'] = $styles['data1']->copyStyle('data4');
            $styles['data4']->setFontAligment(CLX_PROP_RIGHT);
            //$styles['data4']->setBoxWidth(CLX_NUM_180);
            $styles['tabla_1b'] = $styles['tabla_1a']->copyStyle('tabla_1b');
            $styles['tabla_1b_'] = $styles['tabla_1b']->copyStyle('tabla_1b_');
            $styles['tabla_1b_']->setBoxColSpan(CLX_NUM_FOUR);
            //$styles['tabla_1b']->setBoxWidth(CLX_NUM_HUNDRED);
            $styles['tabla_2b'] = $styles['tabla_2a']->copyStyle('tabla_2b');
            $styles['tabla_2b_'] = $styles['tabla_2b']->copyStyle('tabla_2b_');
            $styles['tabla_2b_']->setBoxColSpan(CLX_NUM_TWO);
            //$styles['tabla_2b']->setBoxWidth(CLX_NUM_492);
            $styles['tabla_3b'] = $styles['tabla_3a']->copyStyle('tabla_3b');
            //$styles['tabla_3b']->setBoxWidth(CLX_NUM_150);
            $styles['titulo1b'] = $styles['titulo1']->copyStyle('titulo1b');
            //$styles['titulo1b']->setBoxWidth(CLX_NUM_HUNDRED);
            $styles['titulo2b'] = $styles['titulo1b']->copyStyle('titulo2b');
            $styles['titulo2b']->setBoxWidth(CLX_NUM_520);
            $styles['titulo2b_doble'] = $styles['titulo2b']->copyStyle('titulo2b_doble');
            $styles['titulo2b_doble']->setBoxColSpan(CLX_NUM_TWO);
            $styles['titulo2b_doble']->setBoxWidth(CLX_NUM_ZERO);
            //$styles['titulo2b']->setBoxWidth(CLX_NUM_492);
            $styles['titulo3b'] = $styles['titulo1b']->copyStyle('titulo3b');
            //$styles['titulo3b']->setBoxWidth(CLX_NUM_150);
            $styles['data1b'] = $styles['tabla_esp1']->copyStyle('data1b');
            $styles['data1b']->setFontAligment('center');
            //$styles['data1b']->setBoxWidth(CLX_NUM_HUNDRED);
            $styles['data1b']->unsetFontBold();
            $styles['data2b'] = $styles['data1b']->copyStyle('data2b');
            $styles['data2b']->setBoxWidth(520);

            $styles['data2b']->setFontAligment(CLX_PROP_LEFT);
            //$styles['data2b']->setBoxWidth(CLX_NUM_492);
            $styles['data3b'] = $styles['data1b']->copyStyle('data3b');
            $styles['data3b']->setFontAligment(CLX_PROP_RIGHT);
            //$styles['data3b']->setBoxWidth(CLX_NUM_150);

            $styles['data1b_'] = $styles['data1b']->copyStyle('data1b_');
            $styles['data1b_']->setFontBold();
            $styles['data2b_'] = $styles['data2b']->copyStyle('data2b_');
            $styles['data2b_']->setFontBold();
            $styles['data3b_'] = $styles['data3b']->copyStyle('data3b_');
            $styles['data3b_']->setFontBold();

            //setting name for all clones
            foreach ($styles as $key => $val) {
                //                $styles[$key]->setName($key);
                if ($format == 'html') {
                } elseif ($format == 'pdf') {
                    $styles[$key]->setBoxHeight(CLX_NUM_35);
                    $styles[$key]->setBoxWidth(CLX_NUM_ZERO);
                    $styles[$key]->setFontSize(CLX_NUM_TEN);
                    $styles['tabla_esp1']->setBoxWidth(CLX_NUM_300);
                    $styles['tabla_1']->setBoxWidth(CLX_NUM_300);
                } elseif ($format == 'msexcel') {
                    $styles[$key]->setBoxWidth(CLX_NUM_30);
                    $styles[$key]->setBoxHeight(CLX_NUM_ZERO);
                    //$styles[$key]->setBoxColSpan(0);
                    $styles[$key]->unsetBoxBorder();
                    //$styles[$key]->setBoxBorderColor(null);
                } else {
                    $styles[$key]->setBoxWidth(CLX_NUM_30);
                    $styles[$key]->setBoxHeight(CLX_NUM_ZERO);
                    $styles[$key]->setBoxColSpan(CLX_NUM_ZERO);
                }
            }
            return $styles;
        }

        private function includeReportFiles() {
            require_once kPathToWebSite . kPathToPear . 'Spreadsheet/Excel/Writer.php';
            include_once kPathToWebSite . kPathToFpdf . 'fpdf.php';
            include_once 'classes/clx_report.php';
            include_once 'classes/clx_report_page.php';
            include_once 'classes/clx_report_panel.php';
            include_once 'classes/clx_report_object.php';
            include_once 'classes/clx_report_object_table.php';
            include_once 'classes/clx_report_data.php';
            include_once 'classes/clx_style.php';
        }

        function pdf_end(&$RPPD, $filename = 'temp_pdf.pdf') {

            $RPPD->Close();
            $flname = kPathToTemp . $filename . str_replace('.', '', microtime(true)) . '.pdf';
            $RPPD->Output($flname, 'F');
            if (!empty($this->batch_run_id)) {
                $this->batch_process_msg('<a href="' . $flname . '" target="_blank">' . dict('GEN_LBL_DOWNLOAD_THE_FILE') . '</a>');
            } else {
                return note('<a href="' . $flname . '" target="_blank">' . dict('GEN_LBL_DOWNLOAD_THE_FILE') . '</a><br>');
            }
        }

        function build_header_pdf(&$object, $title) {
            $object->setHeaderParameter(CLX_NUM_ZERO, $title, 'Arial', 'B', CLX_NUM_11, CLX_NUM_ZERO, CLX_NUM_FIVE, CLX_NUM_ZERO, 'L', array("r" => 0, "g" => 0, "b" => 0), array(), array(), 1, 0, 0, -1);
            $object->SetAutoPageBreak(true, CLX_NUM_50);
            $object->AddPage();
        }

        function build_footer_pdf(&$object) {
            $object->setFooter(CLX_NUM_ZERO, 'Preparado por:', array('fontface' => 'Arial', 'font' => 'B', 'fontsize' => CLX_NUM_8, CLX_PROP_WIDTH => '90', 'height' => '5', 'border' => false, 'ln' => CLX_NUM_ZERO, 'aligment' => 'L', 'fill' => false));
            $object->setFooter(CLX_NUM_ONE, 'Revisado por:', array('fontface' => 'Arial', 'font' => 'B', 'fontsize' => CLX_NUM_8, CLX_PROP_WIDTH => '90', 'height' => '5', 'border' => false, 'ln' => CLX_NUM_ZERO, 'aligment' => 'L', 'fill' => false));
            $object->setFooter(CLX_NUM_TWO, 'Aprobado por:', array('fontface' => 'Arial', 'font' => 'B', 'fontsize' => CLX_NUM_8, CLX_PROP_WIDTH => '90', 'height' => '5', 'border' => false, 'ln' => CLX_NUM_ONE, 'aligment' => 'L', 'fill' => false));
        }

        function rep_conciliations_earnings($glrc_code) {
            // Initializing temporar
            $DBTB = &getTool('DBTB');
            $DBTB->buildTemporaryTable('RCT1');
            $batch_id = $this->batch_id;
            ClxCommon::$db->executeQuery('DELETE FROM GL_CONCILIATIONS_TMP WHERE BATCH_ID = ' . singleQuote($batch_id));
            $sql = 'INSERT INTO GL_CONCILIATIONS_TMP (BEGIN_BALANCE_AMT, END_BALANCE_AMT, BANK_ACCOUNT_NO, EFFTDATE, IDNAME, IDCODE, RECONCILIED, MDATE, MODIFIEDBY, CREDIT_TRANS_AMT, CHECK_NO, BATCH_ID) SELECT GLRC.BEGIN_BALANCE_AMT, 0 END_BALANCE_AMT, GLRC.FIDU_BANKACT_CODE, JEHD.EFFTDATE, JEHD.IDNAME, JEHD.IDCODE, JELN.RECONCILIED, JEHD.MDATE, JEHD.MODIFIEDBY, (JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) CREDIT_TRANS_AMT, (SELECT NULLIF(FIAT.CHECK_NO,0) FROM FIDU_TRANSACTIONS FIAT WHERE FIAT.IDCODE = JEHD.TRANS_CODE) CHECK_NO, ' . singleQuote($this->batch_id) . ' BATCH_ID FROM FIDU_ITEMS FIAS, FIDU_BANK_ACCOUNTS FIBK, GL_CONCILIATIONS GLRC, GL_JOURNAL_HDR JEHD, GL_JOURNAL_LINES JELN WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND  JEHD.COMP_CODE = FIBK.COMP_CODE AND  JELN.CHART_FIELD03 = FIAS.IDCODE AND  FIAS.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND  JELN.CURRENCY_CODE = FIBK.CURRENCY_CODE AND  JEHD.JE_STATUS = ' . singleQuote('AP') . ' AND  GLRC.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND  JEHD.REVERSED = ' . singleQuote('0') . ' AND  JEHD.EFFTDATE <= GLRC.TO_DATE AND ((JEHD.EFFTDATE >= CAST(DATE_FORMAT(GLRC.TO_DATE,' . singleQuote('%Y-%m-01') . ') AS DATE)) OR (JELN.RECONCILIED_DT IS NULL OR JELN.RECONCILIED_DT = GLRC.TO_DATE)) AND  EXISTS(SELECT PRAT.ID FROM GL_PROD_PRMTR_TBL PRAT WHERE PRAT.PRO_GL_CODE = JELN.GLACCOUNTCODE AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE) AND GLRC.IDCODE = ' . singleQuote($glrc_code) . ' /*GROUP BY JEHD.IDCODE*/ ORDER BY JEHD.EFFTDATE, JEHD.IDCODE ASC ';
            ClxCommon::$db->executeQuery($sql);
        }

    }

}
