<?php
if (!class_exists('Fiat')) {

    /**
     * General Code File
     * For more information contact support@alenet.com
     *
     * @author $Author: cramirez $
     * @copyright Alenet, Inc.
     * @since $Date: 2018-07-20 19:04:00 -0400 (Fri, 20 Jul 2018) $
     * @version $Rev: 9858 $
     *
     * CHANGE LOG
     *  Included svn prop
     * */
    class Fiat {

        var $today;
        var $now;

        /**
         * Contructor
         *
         * @param array $procParameters
         * @return void
         */
        function __construct($procParameters = array()) {
            multiTableName($this, array('FITB', 'COLO', 'FITS', 'FIBK', 'COMP', 'FICO', 'INPH', 'FIPA', 'FTMP', 'TTPA', 'JEIT', 'JEHD', 'FIAS', 'JELN', 'FIRT', 'FIAC', 'FIAT', 'FETR', 'PRAT', 'PROD', 'FIRS', 'ACCO', 'GLCP', 'JACP', 'FIPD', 'GLAC', 'FILO', 'GLPF', 'CRCL', 'PRLT', 'FIAE', 'GJVW', 'JCBV', 'GUAR', 'PRPT', 'FILS', 'GDVW', 'PROJ', 'INVO', 'APIN', 'APIL', 'CEOC', 'CHPR'));
            
			/*foreach($this as $campo => $valor){
  				echo "<br />- ". $campo ." = ". $valor;
			}
			
			exit;*/
			
			
			$this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
            $this->username = $_SESSION ['user_record'] ['username'];
            $this->now = xFormat::getNow('Y-m-d H:i:s');
            $this->today = xFormat::getNow('Y-m-d');
        }

        /**
         * Initialice fiat form
         * Executed on init event
         */
        function fiat_init_form(&$record) {
            // setting choose information
            if (UserRequest::$request['ac'] === 'CODE' && !empty(UserRequest::$post ['fm']) && (UserRequest::$post ['fm'] === 'FIAT_CA_LOAD' || UserRequest::$post ['fm'] === 'FIAT_CRED_LOAD_O' || UserRequest::$post ['fm'] === 'FIAT_CRED_LOAD' || UserRequest::$post ['fm'] === 'FIAT_GUAR_LOAD' || UserRequest::$post ['fm'] === 'FIAT_AMGT_L')) {
                unset(UserRequest::$post [CLX_PROP_TO], UserRequest::$post ['ac'], UserRequest::$post ['fm'], UserRequest::$post ['it'], UserRequest::$post ['idlist'], UserRequest::$post ['submit1']);
                foreach (UserRequest::$post as $key => $val) {
                    $record [$key] = $val;
                }
            }

            if (UserRequest::$request['ac'] === 'CREATE' && empty(UserRequest::$post ['confirm']) && ( UserRequest::$request ['li'] === 'FIAT_AP_SRCH' || UserRequest::$request ['li'] === 'FIAT_AR_SRCH' || (!empty(UserRequest::$post ['fm']) && UserRequest::$post ['fm'] === 'FIAT_CA_LOAD'))) {
                $record ['FIAT_BASE_TRANS_AMT'] = (!empty(UserRequest::$post ['FIAT_BASE_TRANS_AMT'])) ? UserRequest::$post ['FIAT_BASE_TRANS_AMT'] : 0;
                
				
				foreach (UserRequest::$post as $key => $val) {
                    if (array_key_exists($key, $record)) {
						$record [$key] = UserRequest::$post [$key];
                    }
                }
            }
			
			

            if (!class_exists('Comp'))
                includeCodeLib('COMP');
            $comp = new Comp ();
            $comprec = $comp->comp_operation_parameters($record ['FIAT_COMP_CODE']);

            if ((UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE' || UserRequest::$request['ac'] === 'CODE') && empty(UserRequest::$post ['confirm'])) {

                // formula
                $record ['FIAT_CLX_AUTH_STATUS'] = 'PEND';
                $record ['FIAT_TRANS_STATUS'] = 'PEND';
                $record ['FIAT_IDCODE'] = 'AUTO';
                $record ['FIAT_VOID'] = '0';
                $record ['FIAT_EFFTDATE'] = $comprec ['OPERATION_DATE'];
                $record ['FIAT_AVAILABILITY_DATE'] = $record ['FIAT_EFFTDATE'];
                $record ['FIAT_REAL_DATE'] = $record ['FIAT_EFFTDATE'];
                $record ['FIAT_FISCAL_PERIOD'] = $comprec ['FISCAL_PERIOD'];
                $record ['FIAT_LGGROUP_CODE'] = $comprec ['LGGROUP_CODE'];
                $record ['FIAT_RECORD_BLOCKING'] = '0';

                $record ['FIAT_CHECK_PRINT_DATI'] = null;
                $record ['FIAT_CHECK_PRINT_BY'] = '';
                $record ['FIAT_CHECK_NO'] = '';

                $record ['FIAT_REV_TRANS_CODE'] = null;
                $record ['FIAT_REV_TRANS_CODE_prim'] = '';
                $record ['FIAT_REV_TRANS_CODE_secd'] = '';
                $record ['FIAT_REV_TRANS_CODE_terc'] = '';
                $record ['FIAT_REVERSED'] = '0';
                $record ['FIAT_CHECK_NO'] = '0';
            }
            
			if ((UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'CODE') && empty(UserRequest::$post ['confirm'])) {
                $record ['FIAT_REQ_CHANNEL'] = 'OFC';
                //$record ['FIAT_CURRENCY_CODE'] = $comprec ['CURRENCY_CODE'];
                $record ['FIAT_COMP_CODE'] = $comprec ['IDCODE'];
                $this->init_cash_defaults($record);

                if ($comprec['CURRENCY_CODE'] != $record ['FIAT_CURRENCY_CODE']) {
                    $xrate = $comp->comp_current_exchange($record ['FIAT_COMP_CODE'], $record ['FIAT_CURRENCY_CODE'], $record ['FIAT_EFFTDATE']);
                    $record ['FIAT_EXCHANGE_RT'] = $xrate ['EXCHANGE_RT'];
                    $record ['FIAT_CUR_OPERATOR'] = $xrate ['CUR_OPERATOR'];
                }
            }
            
            // Per module initialization
            $this->init_amgt_defaults($record);
            $this->init_guar_defaults($record);
            $this->init_credit_defaults($record);
            // loading default for operation
            $this->init_credit_operation_details($record);
            if (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'CODE') {
                if (!empty($record ['FIAT_CHART_FIELD01']) && empty($record ['FIAT_CHART_FIELD01_prim'])) {
                    $sql = 'SELECT CONTRACT_NUMBER, IDNAME  FROM ' . $this->ficoname . '   WHERE IDCODE = ' . singleQuote($record ['FIAT_CHART_FIELD01']);
                    $ficorec = ClxCommon::$db->getOneRecord($sql);
                    $record ['FIAT_CHART_FIELD01_prim'] = $ficorec ['CONTRACT_NUMBER'];
                    $record ['FIAT_CHART_FIELD01_secd'] = $ficorec ['IDNAME'];
                }
                if (!empty($record ['FIAT_CHART_FIELD02']) && empty($record ['FIAT_CHART_FIELD02_prim'])) {
                    $sql = 'SELECT IDCODE, IDNAME, IDENTIFICATION  FROM ' . $this->acconame . '   WHERE IDCODE = ' . singleQuote($record ['FIAT_CHART_FIELD02']);
                    $ficorec = ClxCommon::$db->getOneRecord($sql);
                    $record ['FIAT_CHART_FIELD02_prim'] = $ficorec ['IDCODE'];
                    $record ['FIAT_CHART_FIELD02_secd'] = $ficorec ['IDNAME'];
                    $record ['FIAT_CHART_FIELD02_terc'] = $ficorec ['IDENTIFICATION'];
                }
                if (!empty($record ['FIAT_CHART_FIELD03']) && empty($record ['FIAT_CHART_FIELD03_prim'])) {
                    $sql = 'SELECT IDCODE, IDNAME  FROM ' . $this->fiasname . '  WHERE IDCODE = ' . singleQuote($record ['FIAT_CHART_FIELD03']);
                    $ficorec = ClxCommon::$db->getOneRecord($sql);
                    $record ['FIAT_CHART_FIELD03_prim'] = $ficorec ['IDCODE'];
                    $record ['FIAT_CHART_FIELD03_secd'] = $ficorec ['IDNAME'];
                }
                if (!empty($record ['FIAT_CHART_FIELD04']) && empty($record ['FIAT_CHART_FIELD04_prim'])) {
                    $sql = 'SELECT IDCODE, IDNAME  FROM ' . $this->projname . '   WHERE IDCODE = ' . singleQuote($record ['FIAT_CHART_FIELD04']);
                    $ficorec = ClxCommon::$db->getOneRecord($sql);
                    $record ['FIAT_CHART_FIELD04_prim'] = $ficorec ['IDCODE'];
                    $record ['FIAT_CHART_FIELD04_secd'] = $ficorec ['IDNAME'];
                }
                if (!empty($record ['FIAT_BENEFICIARY_CODE']) && empty($record ['FIAT_BENEFICIARY_CODE_prim'])) {
                    $sql = 'SELECT IDCODE, IDNAME, IDENTIFICATION FROM ' . $this->acconame . ' WHERE IDCODE = ' . singleQuote($record ['FIAT_BENEFICIARY_CODE']);
                    $ficorec = ClxCommon::$db->getOneRecord($sql);
                    $record ['FIAT_BENEFICIARY_CODE_prim'] = $ficorec ['IDCODE'];
                    $record ['FIAT_BENEFICIARY_CODE_secd'] = $ficorec ['IDNAME'];
                    $record ['FIAT_BENEFICIARY_CODE_terc'] = $ficorec ['IDENTIFICATION'];
                }
                // Si hay contrato, y no hay participante y es crear
                // entonces coloca el participante principal
                if (!empty($record ['FIAT_CHART_FIELD01'])) {
                    $sql = 'SELECT ACCO.IDCODE, ACCO.IDNAME, ACCO.IDENTIFICATION   FROM ' . $this->fipaname . ' FIPA, ' . $this->acconame . ' ACCO   WHERE ACCO.IDCODE = FIPA.ACCOUNTCODE    AND FIPA.CONTRACT_CODE = ' . singleQuote($record ['FIAT_CHART_FIELD01']) . '    AND FIPA.STATUS = ' . singleQuote('A') . '    AND FIPA.ISPRIMARY = 1';
                    $accorec = ClxCommon::$db->getOneRecord($sql);
                    if (!empty($accorec) && empty($record ['FIAT_CHART_FIELD02'])) {
                        $record ['FIAT_CHART_FIELD02'] = $accorec ['IDCODE'];
                        $record ['FIAT_CHART_FIELD02_prim'] = $accorec ['IDCODE'];
                        $record ['FIAT_CHART_FIELD02_secd'] = $accorec ['IDNAME'];
                        $record ['FIAT_CHART_FIELD02_terc'] = $accorec ['IDENTIFICATION'];
                    }
                }
                // setting name
                if ($record ['FIAT_IDNAME'] === '') {
                    $record ['FIAT_IDNAME'] = ClxCommon::$db->getField($this->fitbname, 'IDNAME', 'IDCODE = ' . singleQuote($record ['FIAT_TRANSTBL_CODE']));
                }
            }
            unset($comp);
        }

        /**
         * Validate record information
         * Executed on table validate
         */
        function fiat_validate_form(&$record, &$msg) {

            if (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE' || UserRequest::$request['ac'] === 'MODIFY') {
                $sql = 'SELECT FITB.STATUS FROM ' . $this->fitbname . ' FITB WHERE FITB.IDCODE = ' . singleQuote($record['FIAT_TRANSTBL_CODE']);
                $status = ClxCommon::$db->getOne($sql);
                if ($status === 'I') {
                    $msg ['FIAT_TRANSTBL_CODE'] = smsg('MSG-480', $record ['FIAT_TRANSTBL_CODE']);
                }
            }

            if (array_key_exists('fm', UserRequest::$request) && (UserRequest::$request ['fm'] === 'FIAT_CA_LOAD' || UserRequest::$request ['fm'] === 'FIAT_CRED_LOAD' || UserRequest::$request ['fm'] === 'FIAT_CRED_LOAD_O' || UserRequest::$request ['fm'] === 'FIAT_GUAR_LOAD' || UserRequest::$request ['fm'] === 'FIAT_AMGT_L'))
                return;
            // validar situacion de transaccion pendiente o no
            $is_special_form_to_alter_chk_data_only = (array_key_exists('fm', UserRequest::$request) && UserRequest::$request ['fm'] == 'FIAT_CHK') ? true : false;
            if (UserRequest::$request['ac'] === 'DELETE'){
                $idlist = getIdlist();
                $idlist = toString($idlist);
                $sql = 'SELECT IDCODE FROM ' . $this->fiatname . ' WHERE ID IN (' . $idlist. ') AND CLX_AUTH_STATUS<>'.singleQuote('PEND').' AND CLX_AUTH_STATUS<>'.singleQuote('OPQU');
                $reg = ClxCommon::$db->getOne($sql);
                if (false === $is_special_form_to_alter_chk_data_only) {
                    if (!empty($reg))  {
                        $msg ['FIAT_TRANS_STATUS'] = smsg('MSG-24', $record ['FIAT_IDCODE']);
                        addMessage($msg ['FIAT_TRANS_STATUS']);
                        return false;
                    }else{
                        return true;
                    }    
                }
            }
            // Solve some lookups
            getLookupValue('FIAT_CHART_FIELD01', 'CHART_FIELD01', $record); // beneficiario
            getLookupValue('FIAT_CHART_FIELD02', 'CHART_FIELD02', $record); // beneficiario
            getLookupValue('FIAT_CHART_FIELD03', 'CHART_FIELD03', $record); // beneficiario
            getLookupValue('FIAT_CHART_FIELD04', 'CHART_FIELD04', $record); // beneficiario
            getLookupValue('FIAT_BENEFICIARY_CODE', 'BENEFICIARY_CODE', $record); // beneficiario
            getLookupValue('FIAT_BRANCH', 'BRANCH', $record); // beneficiario
            if (UserRequest::$request['ac'] === 'DELETE')
                return true;
            if (!class_exists('Jehd'))
                includeCodeLib('JEHD');
            if (!$this->fiat_is_editable($record ['FIAT_IDCODE'])) {
                if (false === $is_special_form_to_alter_chk_data_only) {
                    $msg ['FIAT_IDCODE'] = smsg('MSG-24', $record ['FIAT_IDCODE']);
                }
            }
            if ((UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE' || UserRequest::$request['ac'] === 'MODIFY')) {
                if (!empty($record ['FIAT_REV_TRANS_CODE'])) {
                    $msg ['FIAT_COMP_CODE'] = smsg('MSG-89', $record ['FIAT_IDCODE']);
                }
            }
            // Informacion de transaccion
            $fitbrec = ClxCommon::$db->getRecord($this->fitbname, 'IDCODE = ' . singleQuote($record ['FIAT_TRANSTBL_CODE']));
            // Validar que la fecha de la operacion sea menor o igual a la
            // contabilidad +1 dia
            // Requerir sucursal si no es proporcionada
            if (!empty($fitbrec ['REQ_BRANCH']) && empty($record ['FIAT_BRANCH'])) {
                $msg ['FIAT_BRANCH'] = smsg('MSG-328', $record ['FIAT_IDCODE']);
            }
            if (!class_exists('Comp'))
                includeCodeLib('COMP');
            $comp = new Comp ();
            $comprec = $comp->comp_operation_parameters($record ['FIAT_COMP_CODE']);
            unset($comp);
            // Validar que la fecha de la operacion sea menor o igual a la
            // contabilidad +1 dia
            $operation_date = $comprec ['OPERATION_DATE'];
            $bckdtdop = $comprec ['BCKDATE_ALLWCE'];
            $record ['FIAT_EFFTDATE'] = xFormat::anytimedate($record ['FIAT_EFFTDATE'], 'Y-m-d');
            //Validando que fecha real no pueda ser menor a la fecha efectiva
            if ($record['FIAT_EFFTDATE'] > $record['FIAT_REAL_DATE']) {
                $msg['FIAT_REAL_DATE'] = smsg('MSG-462', $record['FIAT_REAL_DATE'], $operation_date);
            }
            if ($record['FIAT_JE_SOURCE'] <> 'GLTT_FITY' && $record['FIAT_REAL_DATE'] < $operation_date) {
                $msg['FIAT_REAL_DATE'] = smsg('MSG-462', $record['FIAT_REAL_DATE'], $operation_date);
            }
            if (empty($bckdtdop))
                $bckdtdop = CLX_INIT_ZERO;
            if (day_diff($record ['FIAT_EFFTDATE'], $operation_date) < $bckdtdop) {
                $msg ['FIAT_EFFTDATE'] = smsg('MSG-25', $bckdtdop, $record ['FIAT_IDCODE']);
            }
            // validar situacion de transaccion pendiente o no
            if ($record ['FIAT_IDCODE'] != 'AUTO' && !$this->fiat_is_editable($record ['FIAT_IDCODE'])) {
                echo 'aca2';
                $msg ['FIAT_TRANS_STATUS'] = smsg('MSG-25', $bckdtdop, $record ['FIAT_IDCODE']);
            }
            
			// validar que la sub-cuenta contable corresponda al numero de contrato especificado en 
			// el formulario - 05-12-2019 E.C 
									
			if (UserRequest::$request['fm'] == "FIAT_AMGT")
			{ // Administracion de Bienes
				$sql = 'SELECT COUNT(FICO.CONTRACT_NUMBER) FROM '. $this->fiasname . ' FIAS,   ' . $this->ficoname . ' FICO  WHERE FIAS.IDCODE = '.singleQuote($record ['FIAT_CHART_FIELD03']).' AND FIAS.CONTRACT_CODE = FICO.IDCODE AND FIAS.ASSET_CODE = ' . singleQuote($record ['FIAT_ASSET_CODE']). ' AND FICO.CONTRACT_NUMBER= '.singleQuote($record ['FIAT_CHART_FIELD01_prim']);

				if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) { 
					$msg ['FIAT_CHART_FIELD03'] = smsg('MSG-15', $record ['FIAT_CHART_FIELD03_prim'],$record ['FIAT_CHART_FIELD01_prim']);
				}
			}
			
			if (UserRequest::$request['fm'] == "FIAT_CASH"){ 
				//Administracion de Efectivo
				if ($record ['FIAT_CHART_FIELD03']!= '') { 
					$sql = 'SELECT COUNT(FICO.CONTRACT_NUMBER) FROM '. $this->fiasname . ' FIAS,   ' . $this->ficoname . ' FICO  WHERE FIAS.IDCODE = '.singleQuote($record ['FIAT_CHART_FIELD03']).' AND FIAS.CONTRACT_CODE = FICO.IDCODE AND FICO.CONTRACT_NUMBER= '.singleQuote($record ['FIAT_CHART_FIELD01_prim']);

					if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
						$msg ['FIAT_CHART_FIELD03'] = smsg('MSG-15', $record ['FIAT_CHART_FIELD03_prim'],$record ['FIAT_CHART_FIELD01_prim']);
					}
				}
			}
			
			// Si existe retiro de efectivo verificar que exista la cuenta de
            // banco del fideicomiso
            if (ClxCommon::$db->countRecords($this->fitsname, 'TRANSTBL_CODE = ' . singleQuote($record ['FIAT_TRANSTBL_CODE']) . ' AND AFFECT_TYPE = ' . singleQuote('CA') . '') > CLX_NUM_ZERO && empty($record ['FIAT_FIDU_BANKACT_CODE']) && empty($record ['FIAT_REV_TRANS_CODE'])) {
                $msg ['FIAT_FIDU_BANKACT_CODE'] = smsg('MSG-26', $record ['FIAT_IDCODE']);
            }
            // Test fi bank account has gl
            if (!empty($record ['FIAT_FIDU_BANKACT_CODE'])) {
                $sql = 'SELECT PRAT.PRO_GL_CODE GLACCOUNTCODE  FROM   ' . $this->pratname . ' PRAT,   ' . $this->fibkname . ' FIBK  WHERE   PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE   AND FIBK.STATUS = ' . singleQuote('A') . '  AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($record ['FIAT_FIDU_BANKACT_CODE']);
                if (ClxCommon::$db->getOne($sql) === '') {
                    $msg ['FIAT_FIDU_BANKACT_CODE'] = smsg('MSG-27', $record ['FIAT_IDCODE']);
                }
            }
            // validando fechas del contrato
            $ficorec = ClxCommon::$db->getFields($this->ficoname, 'COMP_CODE, START_DATE, EXPIRATION_DATE, CANCEL_DATE', 'IDCODE = ' . singleQuote($record ['FIAT_CHART_FIELD01']));
            // Contract Start Date
            if (strtotime($ficorec ['START_DATE']) > strtotime($record ['FIAT_EFFTDATE'])) {
                $msg ['FIAT_EFFTDATE'] = smsg('MSG-28', $record ['FIAT_IDCODE']);
            }
            // Contract Expiration date
            if (!empty($ficorec ['EXPIRATION_DATE']) && strtotime($ficorec ['EXPIRATION_DATE']) < strtotime($record ['FIAT_EFFTDATE'])) {
                $msg ['FIAT_EFFTDATE'] = smsg('MSG-29', $record ['FIAT_IDCODE']);
            }
            // Contract Cancel date
            if (!empty($ficorec ['CANCEL_DATE']) && strtotime(adodb_next_day($ficorec ['CANCEL_DATE'], 'Y-m-d')) < strtotime($record ['FIAT_EFFTDATE'])) {
                $msg ['FIAT_EFFTDATE'] = smsg('MSG-30', $record ['FIAT_IDCODE']);
            }

            // Validar que contrato vs compania
            if ($ficorec ['COMP_CODE'] != $record ['FIAT_COMP_CODE']) {
                $msg ['FIAT_EFFTDATE'] = smsg('MSG-31', $record ['FIAT_IDCODE']);
            }
            // Validar participante este en ese contrato
            $sql = 'SELECT COUNT(FIPA.ID) FROM ' . $this->fipaname . ' FIPA, ' . $this->ficoname . ' FICO WHERE (FICO.IDCODE = FIPA.CONTRACT_CODE  OR FICO.PARENTCONTRACT_CODE = FIPA.CONTRACT_CODE) AND FICO.IDCODE = ' . singleQuote($record ['FIAT_CHART_FIELD01']) . ' AND FIPA.ACCOUNTCODE = ' . singleQuote($record ['FIAT_CHART_FIELD02']) . ' AND STATUS=' . singleQuote('A');
            
			if (!empty($record ['FIAT_CHART_FIELD02']) && ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
            //if (!empty($record ['FIAT_CHART_FIELD02']) && ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO && !($record['FIAT_TRANSTBL_CODE']==='SYS_DESIN' && !empty($record['FIAT_REV_TRANS_CODE'])) && $record['FIAT_REV_TRANS_CODE']!=='null') {
                $msg ['FIAT_CHART_FIELD02'] = smsg('MSG-32', $record ['FIAT_CHART_FIELD02'], $record ['FIAT_CHART_FIELD01']);
            }


            // Validar que la fecha de disponible sea mayor a la fecha efectiva
            // FIAT_AVAILABILITY_DATE
            if (adodb_strtotime($record ['FIAT_AVAILABILITY_DATE']) < adodb_strtotime($record ['FIAT_EFFTDATE'])) {
                $msg ['FIAT_AVAILABILITY_DATE'] = smsg('MSG-33', $record ['FIAT_IDCODE']);
            }
            // not cero
            if ($record ['FIAT_TRANS_AMT'] == CLX_NUM_ZERO && $record ['FIAT_TRANSTBL_CODE']<>'SYS_DESIN') {
                $msg ['FIAT_TRANS_AMT'] = smsg('MSG-34', $record ['FIAT_IDCODE']);
            }

            // Si tipo de desembolso validar que exista beneficiario
            $sql = 'SELECT DEBIT_CREDIT FROM ' . $this->fitsname . '  WHERE TRANSTBL_CODE = ' . singleQuote($record ['FIAT_TRANSTBL_CODE']) . '  AND AFFECT_TYPE = ' . singleQuote('CA') . '  AND DEBIT_CREDIT IN (' . "'DR'" . ',' . "'CR'" . ')';
            $cash_oper = ClxCommon::$db->getOne($sql);
            $is_disbursement = ($cash_oper === 'CR') ? true : false;
            // se excluyen los casos de FEAP en comision ya que es el
            // beneficiario
            if ($fitbrec ['IS_TRANSFER'] == CLX_NUM_ZERO && $is_disbursement && (empty($record ['FIAT_BENEFICIARY_CODE']) && empty($record ['FIAT_BENEFICIARY_NAME'])) && $record ['FIAT_JE_SOURCE'] !== 'FEAP') {
                $msg ['FIAT_BENEFICIARY_CODE'] = smsg('MSG-35', $record ['FIAT_IDCODE']);
            }
            // VALIDAR SI REQUIERE BENEFICIARIO
            if ($fitbrec ['REQ_BENEFICIARY'] == CLX_NUM_ONE) {
                // Validar que exista beneiciario si transaccion lo require
                if (empty($record ['FIAT_BENEFICIARY_CODE'])) {
                    $msg ['FIAT_BENEFICIARY_CODE'] = smsg('MSG-333', $record ['FIAT_IDCODE']);
                }
                // Validar que exista disponible en caso de que sea un retiro
                //E.C Se comenta por CASO 1004857
                /*if (!empty($record ['FIAT_BENEFICIARY_CODE']) && $cash_oper === 'CR') {
                    // FiloReports
                    if (!class_exists('FiloReports')) {
                        includeCodeLib('FILOREP');
                    }
                    $filorep = new FiloReports ();
                    $avl = $filorep->rep_participation_available_amt($record ['FIAT_COMP_CODE'], $record ['FIAT_EFFTDATE'], $record ['FIAT_CHART_FIELD01'], $record ['FIAT_BENEFICIARY_CODE']);
                    if ($record ['FIAT_TRANS_AMT'] > $avl) {
                        $msg ['FIAT_BENEFICIARY_CODE'] = smsg('MSG-334', $record ['FIAT_IDCODE'], $avl);
                    }
                    unset($filorep, $avl);
                }*/
            }


            // Si hay beneficiario que exista la cuenta de banco
            if ($fitbrec ['IS_TRANSFER'] == CLX_NUM_ZERO && $is_disbursement && empty($record ['FIAT_DISBURSEMENT_TYPE'])) {
                $msg ['FIAT_DISBURSEMENT_TYPE'] = smsg('MSG-36', $record ['FIAT_IDCODE']);
            }

            if (!array_key_exists('FIAT_DISBURSEMENT_TYPE', $record)) {
                $record ['FIAT_DISBURSEMENT_TYPE'] = '';
            }

            // Si es cheque solicitar el numero de cheque,
            if (($record ['FIAT_DISBURSEMENT_TYPE'] === 'ET' || $record ['FIAT_DISBURSEMENT_TYPE'] === 'TI') && empty($record ['FIAT_BANKAC_CODE']) && empty($record ['FIAT_BANK_ACCOUNT_NO'])) {
                $msg ['FIAT_BANKAC_CODE'] = smsg('MSG-143', $record ['FIAT_IDCODE']);
            }
            // Validar que el tipo de transaccion
            $sql = 'SELECT COUNT(FITB.ID) FROM ' . $this->fitbname . ' FITB,  ' . $this->ficoname . ' FICO WHERE (FITB.FI_TYPE = FICO.FI_TYPE  OR FITB.FI_TYPE IS NULL  OR FITB.FI_TYPE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ')  AND FITB.IDCODE = ' . singleQuote($record ['FIAT_TRANSTBL_CODE']) . '  AND FICO.IDCODE = ' . singleQuote($record ['FIAT_CHART_FIELD01']);
            if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
                $msg ['FIAT_TRANSTBL_CODE'] = smsg('MSG-39', $record ['FIAT_IDCODE']);
            }
            // Validaciones de Transferencias
            if (ClxCommon::$db->countRecords($this->fitbname, 'IDCODE =' . singleQuote($record ['FIAT_TRANSTBL_CODE']) . ' AND IS_TRANSFER=1', 'MODULECODE = ' . singleQuote('CASH')) > CLX_NUM_ZERO) {
                // Validat que existan las dos cuentas de banco.
                if ($record ['FIAT_BANKAC_CODE'] === '') {
                    $msg ['FIAT_BANKAC_CODE'] = smsg('MSG-264', $record ['FIAT_IDCODE']);
                }
            }

            // Validar el estatus del asiento que no este aprobado
            if (ClxCommon::$db->countRecords($this->jehdname, 'TRANS_CODE = ' . singleQuote($record ['FIAT_IDCODE']) . ' AND JE_STATUS = ' . singleQuote('AP')) > CLX_NUM_ZERO) {
                if (false === $is_special_form_to_alter_chk_data_only) {
                    $msg ['FIAT_TRANS_STATUS'] = smsg('MSG-24', $record ['FIAT_IDCODE']);
                }
            }
            // Validar que linea de efectivo coincida con moneda de cuenta de
            // banco
            //la operacion se lleba a la moneda funcional la contabilidad es en moneda base
            $sql = 'SELECT COUNT(FIBK.ID) FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS, ' . $this->fibkname . ' FIBK, ' . $this->prodname . ' PROD WHERE FIBK.BANK_PROD_CODE = PROD.IDCODE AND JEHD.IDCODE = JELN.JEHDR_CODE AND JELN.CHART_FIELD03 = FIAS.IDCODE AND FIAS.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND JEHD.TRANS_CODE = ' . singleQuote($record ['FIAT_IDCODE']) . ' AND FIBK.CURRENCY_CODE <> JELN.CURRENCY_CODE AND JEHD.JE_SOURCE <> ' . singleQuote('SETT');
            if (!empty($record['FIAT_FIDU_BANKACT_CODE']) && ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                //Existe una linea de otro grupo contable
                $msg['FIAT_FIDU_BANKACT_CODE'] = smsg('MSG-88', $record['FIAT_IDCODE']);
                $msg ['FIAT_CURRENCY_CODE'] = smsg('MSG-88', $record ['FIAT_IDCODE']);
            }

            // Validar que el periodo contable coincida con fecha de transaccion
            $sql = 'SELECT  COUNT(JACP.ID) QTY FROM  ' . $this->ficoname . ' FICO,  ' . $this->jacpname . ' JACP WHERE JACP.COMP_CODE = FICO.COMP_CODE  AND FICO.IDCODE = ' . singleQuote($record ['FIAT_CHART_FIELD01']) . '  AND JACP.FROM_DATE <= ' . singleQuote($record ['FIAT_EFFTDATE']) . '  AND JACP.TO_DATE >= ' . singleQuote($record ['FIAT_EFFTDATE']) . '  AND JACP.IDCODE = ' . singleQuote($record ['FIAT_FISCAL_PERIOD']);
            if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
                $msg ['FIAT_FISCAL_PERIOD'] = smsg('MSG-68', $record ['FIAT_IDCODE']);
            }
            // Validar que el periodo contable coincida con fecha de transaccion
            $sql = 'SELECT  COUNT(FIPD.ID) QTY FROM  ' . $this->fipdname . ' FIPD WHERE  FIPD.TRANS_CODE = ' . singleQuote($record ['FIAT_IDCODE']);
            if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO && !empty($record ['FIAT_CHART_FIELD02'])) {
                $msg ['FIAT_CHART_FIELD02'] = smsg('MSG-85', $record ['FIAT_IDCODE']);
            }
            
            // validaciones ICHCAFE - FIAT
            //validar si el beneficiario existe en la cosecha anterior (para importadores de prestamos ihcafe)
            if(!empty(UserRequest::$request['DBIM_idcode']) && UserRequest::$request['DBIM_idcode'] == 'FIATIHCAFE' ){
                $trans_cos = ClxCommon::$db->getField('BASE_PARAMETERS', 'PVALUE' , 'IDNAME='. singleQuote('FIAT_COSECHA'));
                $hasCos = ClxCommon::$db->countRecords($this->fiatname, 'TRANSTBL_CODE = ' . singleQuote($trans_cos). ' AND TRANS_STATUS = ' . singleQuote('AP') . ' AND REVERSED = 0 AND IDENTIFICATION = ' .singleQuote($record['FIAT_IDENTIFICATION']));
                if($hasCos==0){
                    $msg ['FIAT_TRANSTBL_CODE'] = smsg('MSG-527', $record ["FIAT_IDENTIFICATION"], $record ["FIAT_BENEFICIARY_NAME"], $trans_cos);
                }
            }

            // validaciones ICHCAFE - FIAT
            //validar si la cosecha anterior ya ha sido cargada enteriormente (para importadores de cosechas ihcafe)
            if(!empty(UserRequest::$request['DBIM_idcode']) && UserRequest::$request['DBIM_idcode'] == 'FIATIHCAFECOS' ){
                $trans_cos = ClxCommon::$db->getField('BASE_PARAMETERS', 'PVALUE' , 'IDNAME='. singleQuote('FIAT_COSECHA'));
                $hasCos = ClxCommon::$db->countRecords($this->fiatname, 'TRANSTBL_CODE = ' . singleQuote($trans_cos) . 'AND TRANS_STATUS = ' . singleQuote('AP'). ' AND REVERSED = 0 AND IDNAME = ' . singleQuote($record['FIAT_IDNAME']));
                if($hasCos>0){
                    $msg ['FIAT_TRANSTBL_CODE'] = smsg('MSG-528', $record ["FIAT_IDNAME"]);
                }
            }

            // Validating business processes for document control on validate
            if ($fitbrec ['REQ_DOC_CONTROL'] == CLX_NUM_ONE) {
                if (!class_exists('cmp_utilities')) {
                    includeCodeLib('CMP');
                }
                if (class_exists('cmp_utilities') && !empty($record ['FIAT_BENEFICIARY_CODE'])) {
                    $cmp = new cmp_utilities ();
                    if (!$cmp->validateProcessTransaction($record ['FIAT_CHART_FIELD01'], $record ['FIAT_BENEFICIARY_CODE'], false)) {
                        $msg ['FIAT_BENEFICIARY_CODE'] = smsg('MSG-335', $record ['FIAT_IDCODE'], $record ['FIAT_BENEFICIARY_CODE']);
                    }
                    unset($cmp);
                }
            }
            // Credit, Garranties and Asset Managment Validations
            $this->fiat_cred_validate_form($record, $msg);
            $this->fiat_guar_validate_form($record, $msg);
            $this->fiat_amgt_validate_form($record, $msg);


            //Validacion de facturas AR
            $sql = 'SELECT SUM(IFNULL(INVO.INVOICE_AMT-(IF(INVO.OPENING_BAL<>0, INVO.INVOICE_AMT-INVO.OPENING_BAL, 0)+ IFNULL((SELECT SUM(INPY.PAID_AMT) FIAT_TRANS_AMT FROM GL_JOURNAL_HDR JEHD, FIDU_TRANSACTIONS FIAT, BILL_INVPYMT_TRANS INPY WHERE INPY.INVOICECODE = INVO.IDCODE AND INPY.JEHDR_CODE = JEHD.IDCODE AND FIAT.IDCODE = JEHD.TRANS_CODE AND FIAT.IDCODE <> ' . singleQuote($record['FIAT_IDCODE']) . ' AND (FIAT.CLX_AUTH_STATUS<> ' .singleQuote('REJ'). ' AND FIAT.VOID = 0 )),0)),0)) INVOICE_AMT FROM ' . $this->invoname . ' INVO WHERE ';
            if (!empty($_SESSION['FIAT_OPTS']['INVO'])) {
                $sql .= ' INVO.ID IN (' . toString($_SESSION['FIAT_OPTS']['INVO']) . ')';
            } elseif ($record['FIAT_IDCODE'] <> 'AUTO') {
                $sql .= ' INVO.PAY_JEHDR_CODE = (SELECT MAX(JEHD.IDCODE) FROM GL_JOURNAL_HDR JEHD WHERE JEHD.TRANS_CODE = ' . singleQuote($record['FIAT_IDCODE']) . ')';
            } else {
                $sql .= '1=2';
            }

			//echo $record ['FIAT_REV_TRANS_CODE'];
			if ($record ['FIAT_REV_TRANS_CODE']==''){	
				$invobal = ClxCommon::$db->getOneRecord($sql);
				if (array_key_exists('INVOICE_AMT', $invobal) && $invobal['INVOICE_AMT'] <> '' && $invobal['INVOICE_AMT'] < $record['FIAT_TRANS_AMT']) {
					$msg['FIAT_TRANS_AMT'] = smsg('MSG-494', $record['FIAT_TRANS_AMT'], $invobal['INVOICE_AMT']);
				}
			}

            //Validacion de facturas AP
            $sql = 'SELECT SUM(IFNULL(APIN.INVOICE_AMT-(IF(APIN.OPENING_BAL<>0, APIN.INVOICE_AMT-APIN.OPENING_BAL, 0)+ IFNULL((SELECT SUM(APPY.PAID_AMT) FIAT_TRANS_AMT FROM GL_JOURNAL_HDR JEHD, FIDU_TRANSACTIONS FIAT, AP_PYMT_TRANS APPY WHERE APPY.PAYINV_CODE = APIN.IDCODE AND APPY.JEHDR_CODE = JEHD.IDCODE AND FIAT.IDCODE = JEHD.TRANS_CODE AND FIAT.IDCODE <> ' . singleQuote($record['FIAT_IDCODE']) . ' AND (FIAT.CLX_AUTH_STATUS<> ' .singleQuote('REJ'). ' AND FIAT.VOID = 0)),0)),0)) INVOICE_AMT FROM AP_PAY_INVOICES APIN WHERE ';
            if (!empty($_SESSION['FIAT_OPTS']['APIN'])) {
                $sql .= " APIN.ID IN (" . toString($_SESSION['FIAT_OPTS']['APIN']) . ")";
            } elseif ($record['FIAT_IDCODE'] <> 'AUTO') {
                $sql .= " APIN.PAY_JEHDR_CODE = (SELECT MAX(JEHD.IDCODE) FROM GL_JOURNAL_HDR JEHD WHERE JEHD.TRANS_CODE = '" . $record['FIAT_IDCODE'] . "')";
            } else {
                $sql .= '1=2';
            }

			$invobal = ClxCommon::$db->getOneRecord($sql);
			 //si es una transacción normal valido el monto. Si es una transaccion de reverso no.
			if ($record ['FIAT_REV_TRANS_CODE']==''){	
				if (array_key_exists('INVOICE_AMT', $invobal) && $invobal['INVOICE_AMT'] <> '' && $invobal['INVOICE_AMT'] < $record['FIAT_TRANS_AMT']) {
					$msg['FIAT_TRANS_AMT'] = smsg('MSG-495', $record['FIAT_TRANS_AMT'], $invobal['INVOICE_AMT']);
				}
			}

            // Authorization methods perform all journal validations
            if (UserRequest::$request['ac'] === 'REQAUTHORIZATION' || defined('proc_fiat_jehd_approval')) {
                if ($record['FIAT_REAL_DATE'] <> $operation_date && $record['FIAT_JE_SOURCE'] <> 'GLCL' && $record['FIAT_JE_SOURCE'] <> 'GLAR') {
                    $msg['FIAT_REAL_DATE'] = smsg('MSG-468', $record['FIAT_REAL_DATE'], $operation_date);
                }
                if ($record['FIAT_EFFTDATE'] > $operation_date) {
                    $msg['FIAT_EFFTDATE'] = smsg('MSG-469', $record['FIAT_EFFTDATE'], $operation_date);
                }
                // Validating business processes for document control on approve
                if ($fitbrec ['REQ_DOC_CONTROL'] == CLX_NUM_ONE) {
                    if (class_exists('cmp_utilities') && !empty($record ['FIAT_BENEFICIARY_CODE'])) {
                        $cmp = new cmp_utilities ();
                        if (!$cmp->validateProcessTransaction($record ['FIAT_CHART_FIELD01'], $record ['FIAT_BENEFICIARY_CODE'], true)) {
                            $msg ['FIAT_BENEFICIARY_CODE'] = smsg('MSG-335', $record ['FIAT_IDCODE'], $record ['FIAT_BENEFICIARY_CODE']);
                        }
                        unset($cmp);
                    }
                }
                if ($record ['FIAT_EFFTDATE'] > $operation_date) {
                    $msg ['FIAT_EFFTDATE'] = smsg('MSG-40', $record ['FIAT_IDCODE']);
                }
                // Validate Share Holdes Position for payments
                if ($record ['FIAT_JE_SOURCE'] === 'INVE-SHDP' && !empty($this->inphname)) {
                    if (!class_exists('Inph'))
                        includeCodeLib('INPH');
                    $inph = new Inph ();
                    $inph->validate_fiat_payment_approval($record ['FIAT_IDCODE'], $msg);
                    unset($inph);
                }
                // Validar que el periodo contable coincida con fecha de
                // transaccion
                $sql = 'SELECT  COUNT(FITB.ID) QTY FROM  ' . $this->fitbname . ' FITB WHERE  FITB.IDCODE = ' . singleQuote($record ['FIAT_TRANSTBL_CODE']) . '  AND (FITB.GL_TYPE IS NOT null OR  FITB.TRUST_ITEM_TYPE IS NOT null)';
                $sql1 = 'SELECT   COUNT(FIPD.ID) QTY  FROM   ' . $this->fipdname . ' FIPD  WHERE   FIPD.TRANS_CODE = ' . singleQuote($record ['FIAT_IDCODE']);
                if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO && ClxCommon::$db->getOne($sql1) == CLX_NUM_ZERO && empty($record ['FIAT_CHART_FIELD02'])) {
                    $msg ['FIAT_CHART_FIELD02'] = smsg('MSG-86', $record ['FIAT_IDCODE']);
                }

                $sql = 'SELECT IFNULL(MAX(FIAT.TRANS_AMT) - SUM(FIPD.PARTICIPATION_AMT),0) BALANCE  FROM ' . $this->fiatname . ' FIAT, ' . $this->fipdname . ' FIPD WHERE FIAT.IDCODE = FIPD.TRANS_CODE AND FIPD.TRANS_CODE = ' . singleQuote($record ['FIAT_IDCODE']) . ' HAVING COUNT(FIPD.ID)>0';
                if (ClxCommon::$db->getOne($sql) != CLX_NUM_ZERO) {
                    $msg ['FIAT_TRANS_AMT'] = smsg('MSG-90', $record ['FIAT_IDCODE']);
                }
                $jehdrec = ClxCommon::$db->getRecord($this->jehdname, 'TRANS_CODE = ' . singleQuote($record ['FIAT_IDCODE']));
                if (!empty($jehdrec)) {
                    foreach ($jehdrec as $key => $val) {
                        $jehdrec ['JEHD_' . $key] = $val;
                    }
                } else {
                    $msg ['FIAT_TRANS_STATUS'] = smsg('MSG-41', $record ['FIAT_IDCODE']);
                    return false;
                }
                $sql = 'SELECT COUNT(ID)  FROM ' . $this->fipaname . '  WHERE  CONTRACT_CODE = ' . singleQuote($record ['FIAT_CHART_FIELD01']) . '  AND ACCOUNTCODE = ' . singleQuote($record ['FIAT_CHART_FIELD02']) . '  AND (STATUS = ' . singleQuote('I') . ' OR CLX_AUTH_STATUS = ' . singleQuote('PEND') . ')';
                if (!empty($record ['FIAT_CHART_FIELD02']) && ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                    $msg ['FIAT_CHART_FIELD02'] = smsg('MSG-32', $record ['FIAT_CHART_FIELD02'], $record ['FIAT_CHART_FIELD01']);
                }
                // validaciones de garantias
                if (!class_exists('Jehd'))
                    includeCodeLib('JEHD');
                $jehd = new Jehd ();
                $jehd->jehd_validate_form($jehdrec, $msg);
                return (count($msg) > CLX_NUM_ZERO) ? false : true;
            }

            if(UserRequest::$request['fm'] == "FIAT_CRED_PAY" && UserRequest::$request['li'] == 'FIAT_CRED_P_SRCH' && in_array(UserRequest::$request['ac'], array("CREATE", "MODIFY"))) {
                if(UserRequest::$request['ac'] != "CODE")
                    if(empty($record['FIAT_FIDU_BANKACT_CODE']) && (empty($record['FIAT_GLACCOUNTCODE_prim']) || empty($record['FIAT_GLACCOUNTCODE_prim'])))
                        $msg ['FIAT_FIDU_BANKACT_CODE'] = smsg('MSG-530');
            }

            return (count($msg) > CLX_NUM_ZERO) ? false : true;
        }

        /**
         * Update Parent (FIAT) Information one record is saved
         */
        function fiat_save_form(&$record) {
            //operaciones asociadas a las cuentas de banco con cheque.
            //si tiene numero: ver si es mayor al de la cuenta de banco. De ser afirmativo incrementar cuenta e vbaco al numero ingresado
            if (!isset($record ['DISBURSEMENT_TYPE']))
                $record ['DISBURSEMENT_TYPE'] = '';


            $ibs_print = (companyParameter('EIBS_ENABLE_CHECK_PRINT')==='1') ? true : false;
            if (1==2 && $record ['DISBURSEMENT_TYPE'] === 'CH' && !$ibs_print) {//Moved to printing
                if (!class_exists('FIBK'))
                    includeCodeLib('FIBK');
                $fibk = new fibk_utilities ();
                $lpchk = '';
                $fibklpchk = $fibk->getLastCheckNum($record['COMP_CODE'], $record ['FIDU_BANKACT_CODE']);
                $fiatlpchk = $this->getLastCheckNum($record['COMP_CODE'], $record ['FIDU_BANKACT_CODE']);
                if ($fibklpchk < $fiatlpchk) {
                    $lpchk = $fiatlpchk;
                } else {
                    $lpchk = $fibklpchk;
                }
                $upd = true;
                if (trim(uppercase($record['CHECK_NO'])) === 'AUTO' || trim(uppercase($record['CHECK_NO'])) === 'null' || $record ['CHECK_NO'] === '') {
                    $record ['CHECK_NO'] = intval($lpchk) + CLX_NUM_ONE;
                    $i = strlen($record ['CHECK_NO']);
                    for ($i; $i < CLX_NUM_SIX; $i++) {
                        $record ['CHECK_NO'] = $record ['CHECK_NO'];
                    }

                } elseif ($record ['CHECK_NO'] <= $lpchk) {

                    $sql = 'SELECT * FROM ' . $this->fiatname . ' FIAT WHERE CHECK_NO = ' . singleQuote($record ['CHECK_NO']) . ' AND FIDU_BANKACT_CODE = ' . singleQuote($record ['FIDU_BANKACT_CODE']);
                    if (UserRequest::$request['ac'] === 'MODIFY')
                        $sql.=' AND IDCODE <> ' . singleQuote($record['IDCODE']);
                    $results = ClxCommon::$db->executeQuery($sql);
                    //si es menor omitir
                    if (ClxCommon::$db->numRows($results) == CLX_NUM_ZERO) {
                        $i = strlen($record ['CHECK_NO']);
                        for ($i; $i < CLX_NUM_SIX; $i++) {
                            $record ['CHECK_NO'] = $record ['CHECK_NO'];
                        }
                        $upd = false;
                    } else {
                        //Incrementar
                        $record ['CHECK_NO'] = $lpchk + CLX_NUM_ONE;
                        $i = strlen($record ['CHECK_NO']);
                        for ($i; $i < CLX_NUM_SIX; $i++) {
                            $record ['CHECK_NO'] = $record ['CHECK_NO'];
                        }
                    }
                } else {
                    $i = strlen($record ['CHECK_NO']);
                    for ($i; $i < CLX_NUM_SIX; $i++) {
                        $record ['CHECK_NO'] = $record ['CHECK_NO'];
                    }
                }
                //Actualizar transaccion remplasando auto por numero en fiat where idcode = '$record['IDCODE']
                if ($upd === true) {
                    ClxCommon::$db->updateRecord($this->fiatname, array('CHECK_NO' => $record['CHECK_NO']), 'IDCODE = ' . $record['IDCODE'] . ' ');
                    ClxCommon::$db->updateRecord($this->fibkname, array('LAST_CHECK_NO' => $record['CHECK_NO']), 'BANK_ACCOUNT_NO = ' . singleQuote($record['FIDU_BANKACT_CODE']) . ' ');
                }
            }
            // Build transaction accounting

            ClxFreeReturn($this->fiat_build_accounting($record));
        }

        // Reversal functions
        /**
         * Execute bottom demand from listing jehd
         */
        function fiat_reverse_build() {
            $idlist = toString(getIdlist());
            $results = ClxCommon::$db->executeQuery('SELECT IDCODE    FROM ' . $this->fiatname . ' FIAT    WHERE ID IN (' . $idlist . ')');
            while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                $new_cod = $this->fiat_reverse($result ['IDCODE']);
                if(!empty($this->ceocname)){
                    $sql = 'UPDATE ' . $this->ceocname . ' CEOC SET CEOC.STATUS_CEOC = IF(CEOC.STATUS_CEOC =' . singleQuote('PAGP') . ', ' . singleQuote('REV') . ', CEOC.STATUS_CEOC), CEOC.REV_TRANS_CODE = IF(CEOC.STATUS_CEOC = ' . singleQuote('REV') . ', ' . singleQuote($new_cod) . ', ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') WHERE (CEOC.TRANS_CODE = ' . singleQuote($result ['IDCODE']) . ')';
                    ClxCommon::$db->executeQuery($sql);
                }
            }
			ClxCommon::$db->freeResult($results);
        }

        /**
         * Reverses transaction
         */
        function fiat_reverse($trans_code) {
            $new_trans_code = '';
            // Validating if not reverse of reverse
            if (!$this->fiat_reverse_validate($trans_code))
                return false;
            // Creating reverse operation.
            if (!function_exists('setCreationData'))
                includeCodeLib('GEN_REC_UTIL');
            $revtrans = ClxCommon::$db->getRecord($this->fiatname, 'IDCODE = ' . singleQuote($trans_code));
            if (empty($revtrans))
                return false;
            if (!class_exists('Fico'))
                includeCodeLib('FICO');
            // Validar que la fecha de la operacion
            // sea menor o igual a la contabilidad +1 dia
            //unset($revtrans ['ID'], $revtrans ['EFFTDATE']); // Caso 1003745 - GB-REVERSO BACKVALUE periodo fiscal anterior
            unset($revtrans ['ID']);
            $fico = new Fico ();
            $comprec = $fico->fico_comp_operation_parameters($revtrans ['CHART_FIELD01']);
            unset($fico);
            // Caso 1003745 - GB-REVERSO BACKVALUE periodo fiscal anterior
            //$revtrans ['EFFTDATE'] = $comprec ['OPERATION_DATE'];
            //$revtrans ['AVAILABILITY_DATE'] = $comprec ['OPERATION_DATE'];
            $revtrans ['REAL_DATE'] = $comprec ['OPERATION_DATE'];
            $revtrans ['TRANS_STATUS'] = 'PEND';
            $revtrans ['CLX_AUTH_STATUS'] = 'PEND';
            $revtrans ['REV_TRANS_CODE'] = $trans_code;
            $revtrans ['IDCODE'] = 'AUTO';
            setCreationData($revtrans);
            setCreationIdCode($revtrans, 'FIAT');
            ClxCommon::$db->createRecord($this->fiatname, $revtrans, false);
            $new_trans_code = $revtrans ['IDCODE'];
            unset($revtrans);
            // Loading distribution if exists
            $sql = 'INSERT INTO ' . $this->fipdname . '  (PARTICIPATION_AMT,  CDATE,  MDATE,  CREATEDBY,  MODIFIEDBY,  CHART_FIELD02,  CHART_FIELD01,  TRANS_CODE) SELECT  PARTICIPATION_AMT,  ' . singleQuote($this->now) . ' CDATE,  ' . singleQuote($this->now) . ' MDATE,  ' . singleQuote($this->username) . ' CREATEDBY,  ' . singleQuote($this->username) . ' MODIFIEDBY,  CHART_FIELD02,  CHART_FIELD01,  ' . singleQuote($new_trans_code) . ' TRANS_CODE  FROM ' . $this->fipdname . ' WHERE TRANS_CODE = ' . singleQuote($trans_code);
            ClxCommon::$db->executeQuery($sql);
            // Reversing journal
            if (!class_exists('Jehd'))
                includeCodeLib('JEHD');
            $sql = 'SELECT ID, IDCODE FROM ' . $this->jehdname . '  WHERE TRANS_CODE = ' . singleQuote($trans_code) . ' AND JE_STATUS = ' . singleQuote('AP');
            $results = ClxCommon::$db->executeQuery($sql);
            $jehd = new Jehd ();
            while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                $result ['IDCODE'] = $jehd->jehd_reverse($result ['IDCODE'], $new_trans_code);
            }
			ClxCommon::$db->freeResult($results);
            // setting transaction journal code
            ClxCommon::$db->updateRecord($this->fiatname, array('JEHDR_CODE' => $result ['IDCODE']), 'IDCODE = ' . singleQuote($new_trans_code));
            return $new_trans_code;
        }

        /**
         * Reverse by origin
         *
         * @param string $comp_code
         * @param string $je_source
         * @param string $operation_date
         */
        function fiat_reverse_by_je_source($comp_code, $je_source, $operation_date) {
            // Reject any posible todays entry from this process thas has run
            // today
            $sql = 'UPDATE ' . $this->fiatname . ' SET TRANS_STATUS = ' . singleQuote('REJ') . ', CLX_AUTH_STATUS = ' . singleQuote('REJ') . ' WHERE JE_SOURCE = ' . singleQuote($je_source) . '  AND COMP_CODE = ' . singleQuote($comp_code) . ' AND EFFTDATE >= ' . singleQuote($operation_date) . '   AND TRANS_STATUS =' . singleQuote('PEND') . '';
            ClxCommon::$db->executeQuery($sql);
            // reverse any left
            $sql = 'SELECT DISTINCT FIAT.IDCODE FROM ' . $this->fiatname . ' FIAT,' . $this->jehdname . ' JEHD WHERE   FIAT.IDCODE = JEHD.TRANS_CODE AND FIAT.JE_SOURCE = ' . singleQuote($je_source) . '   AND FIAT.COMP_CODE = ' . singleQuote($comp_code) . '   AND FIAT.EFFTDATE = ' . singleQuote($operation_date) . ' AND FIAT.TRANS_STATUS = ' . singleQuote('AP') . '   AND FIAT.REVERSED = 0';
            $results = ClxCommon::$db->executeQuery($sql);
            while (($result = ClxCommon::$db->getNextRecord($results, NUMERIC))) {
                $rev_trans_code = $this->fiat_reverse($result [CLX_NUM_ZERO]);
                echoLog(dict('GEN_LBL_REVERSING') . ' FIAT: ' . $result [CLX_NUM_ZERO] . '->' . $rev_trans_code);

                ClxFreeReturn($this->fiat_approve_by_transcode($rev_trans_code));
            }
			ClxCommon::$db->freeResult($results);
        }

        /**
         * Reversal validations
         */
        function fiat_reverse_validate($trans_code) {
            $DBLT = getTool("DBLT");
            $record = ClxCommon::$db->getRecord($this->fiatname, 'IDCODE = ' . singleQuote($trans_code) . '   AND TRANS_STATUS = ' . singleQuote('AP'));
            $status = true;
            if (empty($record)) {
                addMessage(smsg('MSG-42', $trans_code));
                return false;
            }
            //if (!empty($record ['IDCODE']) && ClxCommon::$db->countRecords($this->fiatname, 'IDCODE = ' . singleQuote($trans_code) . ' AND (VOID=1 OR RECORD_BLOCKING<>0)') > CLX_NUM_ZERO) {
            if (!empty($record ['IDCODE']) && ClxCommon::$db->countRecords($this->fiatname, 'IDCODE = ' . singleQuote($trans_code). '
                AND VOID=1') > 0) {
                // Check or operation its blocked. Transacci�n cannot be reversed. Transaction ^1 (MSG-43)
                //addMessage(smsg('MSG-43', $trans_code));
                // [1] Transaction already reversed. Transaction ^1
                addMessage('[1] ' . smsg('MSG-44', $trans_code));
                return false;
            }
            $sql = 'SELECT COUNT(ID) FROM ' . $this->fiatname . '  WHERE REV_TRANS_CODE = ' . singleQuote($trans_code). ' and CLX_AUTH_STATUS<>' . singleQuote('REJ');
            if (ClxCommon::$db->getOne($sql)) {
                //addMessage(smsg('MSG-44', $trans_code));
                // [2] Transaction already reversed. Transaction ^1
                addMessage('[2] ' . smsg('MSG-44', $trans_code));
                return false;
            }
            if (!empty($record ['IDCODE']) && ClxCommon::$db->countRecords($this->fiatname, 'IDCODE = ' . singleQuote($trans_code) . ' AND RECORD_BLOCKING<>0') > 0) {
                $disbursement_type_desc = $DBLT->getListItem('DISB', $record['DISBURSEMENT_TYPE']);
                // If chek / internal transference is already sent to IBS, system send a warning:
                // The reversed transaction (^1) involves ^2 type interface. Please verify that was actually canceled (MSG-357)
                addMessage(smsg('MSG-357', $trans_code, $disbursement_type_desc));
            }
            return $status;
        }

        // COLECTIVOS
        /**
         * Mass transactions
         */
        function req_auth_batch() {
            $idlist = getIdlist();
            if (empty($idlist))
                return;
            $EDIT = getTool('EDIT');
            $tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE = ' . singleQuote('FIAT') . '');
            $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote('FIAT') . '');
            $old_post = UserRequest::$post;
            $old_request = UserRequest::$request;
            UserRequest::$request ['ac'] = 'REQAUTHORIZATION';
            $sql = 'SELECT ID FROM ' . $this->fiatname . '  WHERE CLX_AUTH_STATUS = ' . singleQuote('PEND') . '  AND BATCH_ID IN (SELECT BATCH_ID  FROM ' . $this->fiatname . '   WHERE ID IN(' . toString($idlist) . '))';
            $rs = ClxCommon::$db->executeQuery($sql);
            while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
                UserRequest::$post [$tablerec ['IDCODE'] . '_ID'] = $r [CLX_NUM_ZERO];
                $EDIT->requestAuthorization('CREATE', $formrec, $tablerec);
            }
			ClxCommon::$db->freeResult($rs);
            UserRequest::$post = $old_post;
            UserRequest::$request = $old_request;
        }

        // OTHER RELATED METHODS
        /**
         * Test if transaction can be modified
         */
        function fiat_is_editable($idcode) {
            if (!class_exists('Jehd'))
                includeCodeLib('JEHD');
            $jehd = new Jehd ();
            $jehdr_code = $jehd->jehd_get_idcode_by_transcode($idcode);
            return !$jehd->jehd_exists($jehdr_code) || $jehd->jehd_is_editable($jehdr_code);
        }

        /**
         * Allow recalculate btn to build lines by administrator.
         */
        function fiat_regenerate_lines() {
            $sql = 'SELECT FIAT.* FROM ' . $this->fiatname . ' FIAT  WHERE FIAT.IDCODE IN (' . toString(getIdlist()) . ')';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {

                ClxFreeReturn($this->fiat_build_accounting($r, true));
                if ($r['TRANS_STATUS'] === 'AP') {
                    $sql = 'UPDATE ' . $this->jehdname . ' SET CLX_AUTH_STATUS = ' . singleQuote('AP') . ', JE_STATUS = ' . singleQuote('AP') . '   WHERE TRANS_CODE = ' . singleQuote($r['IDCODE']);
                    ClxCommon::$db->executeQuery($sql);
                }
            }
			ClxCommon::$db->freeResult($rs);
            // Actualizar Libros
            if (!class_exists('Leba')) {
                includeCodeLib('LEBA');
            }
            $leba = new Leba ();
            $sql = 'SELECT DISTINCT FIAT.COMP_CODE FROM ' . $this->fiatname . ' FIAT  WHERE FIAT.IDCODE IN (' . toString(getIdlist()) . ')';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $leba->leba_rebuild($r['COMP_CODE']);
            }
			ClxCommon::$db->freeResult($rs);
            unset($leba);
            //Updating bank accounts balances
            if (!class_exists('fibk_utilities'))
                includeCodeLib('FIBK');
            $fibk = new fibk_utilities ();
            $sql = 'SELECT DISTINCT FIAS.FIDU_BANKACT_CODE  FROM  ' . $this->fiatname . ' FIAT,  ' . $this->jehdname . ' JEHD,  ' . $this->jelnname . ' JELN,  ' . $this->fiasname . ' FIAS  WHERE  JEHD.IDCODE = JELN.JEHDR_CODE  AND FIAS.IDCODE= JELN.CHART_FIELD03  AND FIAT.IDCODE = JEHD.TRANS_CODE  AND FIAT.IDCODE IN (' . toString(getIdlist()) . ')';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $fibk->update_balances($r['FIDU_BANKACT_CODE']);
            }
			ClxCommon::$db->freeResult($rs);
            //Update loan
            //Update guar
            //Update invo
            //see jehd approve by status
        }

        /**
         * Builds fiat Record
         *
         * @return : String idcode
         * @param
         *     : String comp_code
         * @param
         *     : String transtbl_code
         * @param
         *     : String contract_code
         * @param
         *     : String participant_id
         * @param
         *     : String trans_amt
         * @param
         *     : Array record
         */
        function fiat_buildVoid($comp_code, $transtbl_code, $contract_code, $participant_id, $trans_amt, &$record) {
            ClxFreeReturn($this->fiat_build($comp_code, $transtbl_code, $contract_code, $participant_id, $trans_amt, $record));
        }

        function fiat_build($comp_code, $transtbl_code, $contract_code, $participant_id, $trans_amt, &$record) {
            if (empty($record ['IDCODE'])) {
                $record ['IDCODE'] = 'AUTO';
            }
            if (empty($record ['CLX_AUTH_STATUS'])) {
                $record ['CLX_AUTH_STATUS'] = 'PEND';
                $record ['TRANS_STATUS'] = 'PEND';
            }
            if (!class_exists('Comp'))
                includeCodeLib('COMP');
            $comp = new Comp ();
            $comprec = $comp->comp_operation_parameters($comp_code);
            // Validar que la fecha de la operacion sea menor o igual a la
            // contabilidad +1 dia
            $record ['COMP_CODE'] = $comp_code;
            if (!array_key_exists('CURRENCY_CODE', $record) || empty($record['CURRENCY_CODE']) || $record['CURRENCY_CODE'] == 'NULL')
                $record ['CURRENCY_CODE'] = $comprec ['CURRENCY_CODE'];
            if (!array_key_exists('EFFTDATE', $record))
                $record ['EFFTDATE'] = $comprec ['OPERATION_DATE'];
            if (!array_key_exists('REAL_DATE', $record))
                $record ['REAL_DATE'] = $comprec ['OPERATION_DATE'];
            if (!array_key_exists('CURRENCY_CODE', $record))
                $record ['CURRENCY_CODE'] = $comprec ['CURRENCY_CODE'];
            if (empty($record ['REQ_CHANNEL']))
                $record ['REQ_CHANNEL'] = 'SYS';
            if (empty($record ['FISCAL_PERIOD'])) {
                $record ['FISCAL_PERIOD'] = $comp->comp_fiscal_period($comp_code, $record ['EFFTDATE']);
            }
            if (empty($record ['IDNAME'])) {
                $DBLT = getTool('DBLT');
                $record ['IDNAME'] = substr($DBLT->getListItem('TRCL', ClxCommon::$db->getField($this->fitbname, 'TRANS_CLASS', 'IDCODE = ' . singleQuote($transtbl_code))), CLX_NUM_ZERO, CLX_NUM_60);
            }
            if (empty($record ['LGGROUP_CODE'])) {
                // setting default ledger
                $record ['LGGROUP_CODE'] = $comprec ['LGGROUP_CODE'];
            }
            $record ['CHART_FIELD01'] = $contract_code;
            $record ['CHART_FIELD02'] = $participant_id;
            $record ['TRANSTBL_CODE'] = $transtbl_code;
            $record ['TRANS_AMT'] = $trans_amt;
            $record ['CREATEDBY'] = '';
            $record ['MODIFIEDBY'] = '';
            $record ['CDATE'] = '';
            $record ['MDATE'] = '';
            if (!function_exists('setCreationData'))
                includeCodeLib('GEN_REC_UTIL');
            setCreationData($record);
            setCreationIdCode($record, 'FIAT');
            $record ['TRANS_STATUS'] = 'PEND';
            $record ['CLX_AUTH_STATUS'] = 'PEND';
            if (empty($record ['CHART_FIELD01']))
                $record ['CHART_FIELD01'] = 'null';
            if (empty($record ['CHART_FIELD02']))
                $record ['CHART_FIELD02'] = 'null';
            if (empty($record ['CHART_FIELD03']))
                $record ['CHART_FIELD03'] = 'null';
            if (empty($record ['CHART_FIELD04']))
                $record ['CHART_FIELD04'] = 'null';
            ClxCommon::$db->createRecord($this->fiatname, $record, false);

            ClxFreeReturn($this->fiat_build_accounting($record));
            return $record ['IDCODE'];
        }

        function fiat_build_fiat_only($comp_code, $transtbl_code, $contract_code, $participant_id, $trans_amt, &$record) {
            if (empty($record ['IDCODE'])) {
                $record ['IDCODE'] = 'AUTO';
            }
            if (empty($record ['CLX_AUTH_STATUS'])) {
                $record ['CLX_AUTH_STATUS'] = 'PEND';
                $record ['TRANS_STATUS'] = 'PEND';
            }
            if (!class_exists('Comp'))
                includeCodeLib('COMP');
            $comp = new Comp ();
            $comprec = $comp->comp_operation_parameters($comp_code);
            // Validar que la fecha de la operacion sea menor o igual a la
            // contabilidad +1 dia
            $record ['COMP_CODE'] = $comp_code;
            if (!array_key_exists('CURRENCY_CODE', $record) || empty($record['CURRENCY_CODE']) || $record['CURRENCY_CODE'] == 'NULL')
                $record ['CURRENCY_CODE'] = $comprec ['CURRENCY_CODE'];
            if (!array_key_exists('EFFTDATE', $record))
                $record ['EFFTDATE'] = $comprec ['OPERATION_DATE'];
            if (!array_key_exists('REAL_DATE', $record))
                $record ['REAL_DATE'] = $comprec ['OPERATION_DATE'];
            if (!array_key_exists('CURRENCY_CODE', $record))
                $record ['CURRENCY_CODE'] = $comprec ['CURRENCY_CODE'];
            if (empty($record ['REQ_CHANNEL']))
                $record ['REQ_CHANNEL'] = 'SYS';
            if (empty($record ['FISCAL_PERIOD'])) {
                $record ['FISCAL_PERIOD'] = $comp->comp_fiscal_period($comp_code, $record ['EFFTDATE']);
            }
            if (empty($record ['IDNAME'])) {
                $DBLT = getTool('DBLT');
                $record ['IDNAME'] = substr($DBLT->getListItem('TRCL', ClxCommon::$db->getField($this->fitbname, 'TRANS_CLASS', 'IDCODE = ' . singleQuote($transtbl_code))), CLX_NUM_ZERO, CLX_NUM_60);
            }
            if (empty($record ['LGGROUP_CODE'])) {
                // setting default ledger
                $record ['LGGROUP_CODE'] = $comprec ['LGGROUP_CODE'];
            }
            $record ['CHART_FIELD01'] = $contract_code;
            $record ['CHART_FIELD02'] = $participant_id;
            $record ['TRANSTBL_CODE'] = $transtbl_code;
            $record ['TRANS_AMT'] = $trans_amt;
            $record ['CREATEDBY'] = '';
            $record ['MODIFIEDBY'] = '';
            $record ['CDATE'] = '';
            $record ['MDATE'] = '';
            if (!function_exists('setCreationData'))
                includeCodeLib('GEN_REC_UTIL');
            setCreationData($record);
            setCreationIdCode($record, 'FIAT');
            $record ['TRANS_STATUS'] = 'PEND';
            $record ['CLX_AUTH_STATUS'] = 'PEND';
            if (empty($record ['CHART_FIELD01']))
                $record ['CHART_FIELD01'] = 'null';
            if (empty($record ['CHART_FIELD02']))
                $record ['CHART_FIELD02'] = 'null';
            if (empty($record ['CHART_FIELD03']))
                $record ['CHART_FIELD03'] = 'null';
            if (empty($record ['CHART_FIELD04']))
                $record ['CHART_FIELD04'] = 'null';
            ClxCommon::$db->createRecord($this->fiatname, $record, false);
            return $record ['IDCODE'];
        }

        /**
         * Bulk transaction processing.
         * Same as transaction process but by batch
         */
        function fiat_build_accounting_batch($batch_id, $je_source = 'sys') {
            // Creating Lines
            $sql = 'INSERT INTO ' . $this->jelnname . '  (JEHDR_CODE,  GLACCOUNTCODE,  ITEM_CODE,  CHART_FIELD01,  CHART_FIELD02,  CHART_FIELD03,  CHART_FIELD04,  ITEM_REF_NO,  CURRENCY_CODE,  CUR_OPERATOR,  EXCHANGE_RT,  DEBIT_AMT,  CREDIT_AMT) SELECT  FIAT.JEHDR_CODE JEHDR_CODE,  (CASE FITS.AFFECT_TYPE WHEN ' . singleQuote('EQ') . '  THEN (SELECT   CASE FIAT.CURRENCY_CODE WHEN COMP.CURRENCY_CODE THEN TTPA.EQ_GL_CODE ELSE TTPA.EQF_GL_CODE END EQ_GL_CODE FROM  ' . $this->compname . ' COMP, ' . $this->ttpaname . ' TTPA, ' . $this->glcpname . ' GLCP, ' . $this->ficoname . ' FICO WHERE GLCP.COMP_CODE = FICO.COMP_CODE AND FICO.COMP_CODE = GLCP.COMP_CODE AND FICO.CONTRACT_TYPE = TTPA.CONTRACT_TYPE AND TTPA.GLGROUP_CODE = GLCP.GLGROUP_CODE  AND TTPA.FI_TYPE = FICO.FI_TYPE AND TTPA.TRUST_FUND_SRC = FICO.TRUST_FUND_SRC AND FIAT.COMP_CODE = FICO.COMP_CODE    AND TTPA.CONTRACT_TYPE = FICO.CONTRACT_TYPE    AND FICO.IDCODE = FIAT.CHART_FIELD01)  WHEN ' . singleQuote('CA') . '  THEN  (SELECT PRAT.PRO_GL_CODE GLACCOUNTCODE FROM GL_PROD_PRMTR_TBL PRAT, FIDU_BANK_ACCOUNTS FIBK WHERE PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE AND FIBK.BANK_ACCOUNT_NO = FIAT.FIDU_BANKACT_CODE) WHEN ' . singleQuote('OTH') . ' THEN FITS.GLACCOUNTCODE  ELSE null END) GLACCOUNTCODE,  FITS.ITEM_CODE,  FIAT.CHART_FIELD01,  FIAT.CHART_FIELD02,  FIAT.CHART_FIELD03,  FIAT.CHART_FIELD04,  FIAT.ITEM_REF_NO,  FIAT.CURRENCY_CODE,  FIAT.CUR_OPERATOR,  FIAT.EXCHANGE_RT,  ((CASE FITS.DEBIT_CREDIT  WHEN ' . "'DR'" . '  THEN 1  ELSE 0 END)*ROUND(((((CASE JEIT.TAX_WITHOLDING_PCT  WHEN 0 THEN 100  ELSE JEIT.TAX_WITHOLDING_PCT  END / 100)  * FIAT.TRANS_AMT)  - IFNULL(JEIT.EXEMPT_TAX_AMT,0))  * (CASE JEIT.FLAT_RATE  WHEN 0 THEN 100  ELSE JEIT.FLAT_RATE  END / 100)), 2)) DEBIT_AMT,  ((CASE FITS.DEBIT_CREDIT  WHEN ' . "'CR'" . '  THEN 1  ELSE 0 END)*ROUND(((((CASE JEIT.TAX_WITHOLDING_PCT  WHEN 0 THEN 100  ELSE JEIT.TAX_WITHOLDING_PCT  END / 100)  * FIAT.TRANS_AMT)  - IFNULL(JEIT.EXEMPT_TAX_AMT,0))  * (CASE JEIT.FLAT_RATE   WHEN 0 THEN 100   ELSE JEIT.FLAT_RATE   END / 100)), 2)) CREDIT_AMT FROM ' . $this->fitbname . ' FITB,  ' . $this->fitsname . ' FITS,  ' . $this->jeitname . ' JEIT,  ' . $this->fiatname . ' FIAT  LEFT JOIN ' . $this->jehdname . ' JEHD  ON FIAT.JEHDR_CODE = JEHD.IDCODE WHERE FIAT.TRANSTBL_CODE = FITS.TRANSTBL_CODE  AND JEIT.IDCODE = FITS.ITEM_CODE  AND FITS.TRANSTBL_CODE = FITB.IDCODE  AND JEIT.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE)  FROM GL_ITEM_TBL X  WHERE X.IDCODE = FITS.ITEM_CODE  AND X.CLX_EFFTDATE<=FIAT.EFFTDATE) AND FITS.STATUS = ' . singleQuote('A') . ' AND FIAT.BATCH_ID = ' . singleQuote($batch_id) . ' AND FIAT.JE_SOURCE = ' . singleQuote($je_source) . ' AND JEHD.IDCODE IS NULL';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'INSERT INTO ' . $this->jehdname . '  (IDCODE,  IDNAME,  COMP_CODE,  REQ_CHANNEL,  BRANCH,  EFFTDATE,  LGGROUP_CODE,  FISCAL_PERIOD,  CLX_AUTH_STATUS,  JE_STATUS,  JE_SOURCE,  CLOSING_ENTRY,  TRANS_CODE,  REVERSED,  BATCH_ID,  CREATEDBY,  MODIFIEDBY,  CDATE,  MDATE) SELECT  FIAT.JEHDR_CODE IDCODE,  FIAT.IDNAME,  FIAT.COMP_CODE,  FIAT.REQ_CHANNEL,  FIAT.BRANCH,  FIAT.EFFTDATE,  FIAT.LGGROUP_CODE,  FIAT.FISCAL_PERIOD,  FIAT.TRANS_STATUS JE_STATUS,  FIAT.CLX_AUTH_STATUS,  ' . singleQuote($je_source) . ' JE_SOURCE,  0 CLOSING_ENTRY,  FIAT.IDCODE TRANS_CODE,  0 REVERSED,  FIAT.BATCH_ID,  FIAT.CREATEDBY,  FIAT.MODIFIEDBY,  FIAT.CDATE,  FIAT.MDATE FROM ' . $this->fiatname . ' FIAT  LEFT JOIN ' . $this->jehdname . ' JEHD  ON FIAT.JEHDR_CODE = JEHD.IDCODE WHERE FIAT.TRANS_STATUS = ' . singleQuote('PEND') . ' AND FIAT.BATCH_ID = ' . singleQuote($batch_id) . ' AND FIAT.JE_SOURCE = ' . singleQuote($je_source) . ' AND JEHD.IDCODE IS NULL';
            ClxCommon::$db->executeQuery($sql);
        }

        /**
         * Build Transaction Accounting
         */
        function fiat_build_accounting(&$record, $force_edit = false) {
            $this->seqnum = CLX_INIT_ZERO;
            $is_credit_tx = ($record ['TRANSTBL_CODE'] === 'SYS_CRED-PYMT' || $record ['TRANSTBL_CODE'] === 'SYS_CRED-DISB' || $record ['TRANSTBL_CODE'] === 'SYS_CRED-ADJ') ? true : false;
            if (!class_exists('Jehd'))
                includeCodeLib('JEHD');
            if (!class_exists('Jeln'))
                includeCodeLib('JELN');
            if (!class_exists('fidu_flexformula'))
                includeCodeLib('FIFF');
            if (empty($force_edit) && !$this->fiat_is_editable($record ['IDCODE']))
                return false;
            // Build jehdr
            if (!class_exists('Jehd'))
                includeCodeLib('JEHD');
            $jehd = new Jehd ();
            $jehdr_code = $this->fiat_build_header($record, $jehd);
            //Mark Lines to posible update or remove if no update occurs, it sets value delete =0 latter on line update
            $sql = 'UPDATE ' . $this->jelnname . '   SET IS_REMOVE = 1  WHERE JEHDR_CODE = ' . singleQuote($jehdr_code);
            ClxCommon::$db->executeQuery($sql);
            // Setting invoice information required latter for lines in
            if (!empty($_SESSION ['FIAT_OPTS'] ['INVO'])) {
                if (!class_exists('Invo'))
                    includeCodeLib('INVO');
                $invo = new Invo();
                $invo->record_fiat_payment_trasaction($jehdr_code, $_SESSION ['FIAT_OPTS'] ['INVO']);
                unset($_SESSION ['FIAT_OPTS'] ['INVO']);
            }
            if (!empty($_SESSION ['FIAT_OPTS'] ['APIN'])) {
                if (!class_exists('Apin'))
                    includeCodeLib('APIN');
                $apin = new Apin();
                $apin->record_fiat_payment_trasaction($jehdr_code, $_SESSION ['FIAT_OPTS'] ['APIN']);
                unset($_SESSION ['FIAT_OPTS'] ['APIN']);
            }
            unset($_SESSION ['FIAT_OPTS']);
            // Building accounting for Credit SYS-CRED
            $restricted = $this->fiat_is_restricted($record ['IDCODE']);
            if (empty($restricted)) {
                $this->fiat_build_fibk_fias($record);
            }
            // update chart_field with if bank account exists
            if (!empty($restricted) && !empty($is_credit_tx)) {
                return $this->fiat_build_accounting_credit($record, $jehdr_code);
            }
            if (!empty($restricted)) {
                // IF RESTRICTED THEN JUST UPDATE DETAILS AND RETURN
                return $this->fiat_update_restricted($record);
            }
            $clear_jeln_rec ['JEHDR_CODE'] = $jehdr_code;
            $this->fiat_build_lines($record ['TRANSTBL_CODE'], $jehdr_code, $record);
            // Needed for currency conversion
            if (!class_exists('Comp'))
                includeCodeLib('COMP');
            $comp = new Comp ();
            // Incorporando lineas de comisiones flat
            $sql = 'SELECT  FIAT.COMP_CODE, FIAC.IDCODE COMMISSION_CODE, FIAC.CONTRACT_CODE, FIRT.IDCODE FIDU_RATETBLCODE,  FIRT.FLAT_FEES FEE_AMT,  FIRT.TRANS_PCT FEE_PCT,  FIRT.TRANS_CHARGE_AFTER,  FIRT.TRANS_CHRG_PER,  FIRT.FLAT_TX_CODE TRANSTBL_CODE,  FIRT.CURRENCY_CODE,  FIAT.EXCHANGE_RT,  FIAT.CUR_OPERATOR,  (SELECT COUNT(FIRS.ID)  FROM ' . $this->firsname . ' FIRS  WHERE FIRS.FIDU_RATETBLCODE = FIRT.IDCODE) HAS_SCALE  FROM  ' . $this->fiacname . ' FIAC,  ' . $this->fiatname . ' FIAT,  ' . $this->firtname . ' FIRT  WHERE FIAC.FIDU_RATETBLCODE = FIRT.IDCODE  AND FIAC.STATUS = FIRT.STATUS  AND FIRT.STATUS = ' . singleQuote('A') . '  AND FIRT.FEE_TYPE = ' . singleQuote('FLAT') . '  AND FIAT.CHART_FIELD01 = FIAC.CONTRACT_CODE  AND (FIAC.PARTICIPANT_ID = FIAT.CHART_FIELD02 OR FIAC.PARTICIPANT_ID IS NULL)  AND (FIAT.TRANSTBL_CODE = FIRT.TRANSCODE   OR EXISTS(SELECT FETR.ID   FROM ' . $this->fetrname . ' FETR WHERE FETR.FIDU_RATETBLCODE = FIRT.IDCODE   AND FETR.TRANSTBL_CODE = FIAT.TRANSTBL_CODE) )  AND FIAT.IDCODE = ' . singleQuote($record ['IDCODE']) . '  AND FIRT.CLX_EFFTDATE <= (SELECT MAX(X.CLX_EFFTDATE)      FROM ' . $this->firtname . ' X      WHERE X.IDCODE = FIRT.IDCODE      AND X.CLX_EFFTDATE<=FIAT.EFFTDATE)  ';
            $results = ClxCommon::$db->executeQuery($sql);
            while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                $trans_record = $record;
                if ($record ['CURRENCY_CODE'] != $result ['CURRENCY_CODE']) {
                    $xrate = $comp->comp_current_exchange($result ['COMP_CODE'], $result ['CURRENCY_CODE'], $record ['EFFTDATE']);
                    $trans_record ['CURRENCY_CODE'] = $result ['CURRENCY_CODE'];
                    $trans_record ['EXCHANGE_RT'] = $xrate ['EXCHANGE_RT'];
                    $trans_record ['CUR_OPERATOR'] = $xrate ['CUR_OPERATOR'];
                }
                // Validar Periodicidad si es mayor que cero
                // FIRT.TRANS_CHARGE_AFTER, FIRT.TRANS_CHRG_PER,
                if ($result ['TRANS_CHARGE_AFTER'] > CLX_NUM_ZERO && !empty($result ['TRANS_CHRG_PER'])) {
                    switch ($result ['TRANS_CHRG_PER']) {
                        case 'M' :
                            $sql = 'SELECT COUNT(ID) FROM ' . $this->fiatname . ' WHERE CHART_FIELD01 = ' . singleQuote($record ['CHART_FIELD01']) . ' ' . 'AND CHART_FIELD02 = ' . singleQuote($record ['CHART_FIELD02']) . ' ' . 'AND TRANSTBL_CODE = ' . singleQuote($record ['TRANSTBL_CODE']) . ' ' . 'AND IDCODE <> ' . singleQuote($record ['IDCODE']) . ' ' . 'AND EFFTDATE <= ' . singleQuote($record ['EFFTDATE']) . ' ' . 'AND EFFTDATE >= ' . singleQuote(substr($record ['EFFTDATE'], CLX_NUM_ZERO, CLX_NUM_8) . '01') . ' ' . 'AND VOID = 0 ';
                            if ((ClxCommon::$db->getOne($sql) - $result ['TRANS_CHARGE_AFTER']) < CLX_NUM_ZERO) {
                                //continue; PHP 5.6
								continue(2); //PHP 7.0+ Edgard 07-03-2021
                            }
                            break;
                        case 'Y' :
                            $sql = 'SELECT COUNT(ID) FROM ' . $this->fiatname . ' WHERE CHART_FIELD01 = ' . singleQuote($record ['CHART_FIELD01']) . ' ' . 'AND CHART_FIELD02 = ' . singleQuote($record ['CHART_FIELD02']) . ' ' . 'AND TRANSTBL_CODE = ' . singleQuote($record ['TRANSTBL_CODE']) . ' ' . 'AND IDCODE <> ' . singleQuote($record ['IDCODE']) . ' ' . 'AND EFFTDATE <= ' . singleQuote($record ['EFFTDATE']) . ' ' . 'AND EFFTDATE >= ' . singleQuote(substr($record ['EFFTDATE'], CLX_NUM_ZERO, CLX_NUM_FIVE) . '01-01') . ' ' . 'AND VOID = 0 ';
                            if ((ClxCommon::$db->getOne($sql) - $result ['TRANS_CHARGE_AFTER']) <= CLX_NUM_ZERO) {
                               //continue; PHP 5.6
								continue(2); //PHP 7.0+ Edgard 07-03-2021
                            }
                            break;
                        default :
                            break;
							}
                }
                if ($result ['FEE_AMT'] != CLX_NUM_ZERO) {
                    // do the flat fee
                    $trans_record ['TRANS_AMT'] = $result ['FEE_AMT'];
                } elseif ($result ['FEE_PCT'] != CLX_NUM_ZERO) {
                    // do the percentage
                    $trans_record ['TRANS_AMT'] = rounder($record ['TRANS_AMT'] * ($result ['FEE_PCT'] / CLX_NUM_HUNDRED), CLX_NUM_TWO);
                } elseif ($result ['HAS_SCALE'] > CLX_NUM_ZERO) { // Test Scales
                    // Test scales
                    $sql = 'SELECT FEES_RATE_PCT, FEES_RATE_AMT FROM   ' . $this->firsname . '   WHERE    FIDU_RATETBLCODE = ' . singleQuote($result ['FIDU_RATETBLCODE']) . ' AND    ((RANGE_FROM_AMT < ' . $trans_record ['TRANS_AMT'] . ' AND RANGE_TO_AMT >= ' . $trans_record ['TRANS_AMT'] . ') OR   (RANGE_FROM_AMT < ' . $trans_record ['TRANS_AMT'] . ' AND RANGE_TO_AMT = 0))';
                    $ratelines = ClxCommon::$db->executeQuery($sql);
                    if (!empty($ratelines))
                        $rateline = ClxCommon::$db->getNextRecord($ratelines);
					ClxCommon::$db->freeResult($ratelines);		
                    $trans_record ['TRANS_AMT'] = rounder(bcadd($rateline ['FEES_RATE_AMT'], ($trans_record ['TRANS_AMT'] * ($rateline ['FEES_RATE_PCT'] / CLX_NUM_HUNDRED))), CLX_NUM_TWO);
                }
                // if all ok then
                $trans_record ['COMMISSION_CODE'] = $result ['COMMISSION_CODE'];
                if ($trans_record ['TRANS_AMT'] != CLX_NUM_ZERO) {
                    $this->fiat_build_lines($result ['TRANSTBL_CODE'], $jehdr_code, $trans_record);
                }
            } // end while
			ClxCommon::$db->freeResult($results);
            // Incorporando lineas de comisiones por desembolsos
            $sql = 'SELECT  FIAC.IDCODE COMMISSION_CODE,  FIAC.CONTRACT_CODE,  FIRT.IDCODE FIDU_RATETBLCODE,  FIRT.CURRENCY_CODE,  FIAT.EXCHANGE_RT,  FIAT.CUR_OPERATOR,  FIRT.DISBURSEMENT_FEE FEE_AMT,  FIRT.DISBURSEMENT_PCT FEE_PCT,  FIRT.DST_TX_CODE TRANSTBL_CODE,  (SELECT COUNT(FIRS.ID)  FROM ' . $this->firsname . ' FIRS  WHERE FIRS.FIDU_RATETBLCODE = FIRT.IDCODE) HAS_SCALE FROM ' . $this->fiacname . ' FIAC, ' . $this->fiatname . ' FIAT, ' . $this->firtname . ' FIRT WHERE FIAC.FIDU_RATETBLCODE = FIRT.IDCODE  AND FIAC.STATUS = FIRT.STATUS  AND FIRT.STATUS = ' . singleQuote('A') . '  AND FIRT.FEE_TYPE = ' . singleQuote('DISB') . '  AND FIAT.CHART_FIELD01 = FIAC.CONTRACT_CODE  /*AND (FIAT.CURRENCY_CODE = FIRT.CURRENCY_CODE OR FIRT.CURRENCY_CODE IS NULL)*/  AND (FIAC.PARTICIPANT_ID = FIAT.CHART_FIELD02 OR FIAC.PARTICIPANT_ID IS NULL)  AND FIAT.DISBURSEMENT_TYPE = FIRT.DISBURSEMENT_TYPE  AND FIAT.IDCODE = ' . singleQuote($record ['IDCODE']) . '  AND FIRT.CLX_EFFTDATE <= (SELECT MAX(X.CLX_EFFTDATE)     FROM ' . $this->firtname . ' X     WHERE X.IDCODE = FIRT.IDCODE     AND X.CLX_EFFTDATE<=FIAT.EFFTDATE) ';
            $results = ClxCommon::$db->executeQuery($sql);
            while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                $trans_record = $record;
                if ($record ['CURRENCY_CODE'] != $result ['CURRENCY_CODE']) {
                    $xrate = $comp->comp_current_exchange($result ['COMP_CODE'], $result ['CURRENCY_CODE'], $record ['EFFTDATE']);
                    $trans_record ['CURRENCY_CODE'] = $result ['CURRENCY_CODE'];
                    $trans_record ['EXCHANGE_RT'] = $xrate ['EXCHANGE_RT'];
                    $trans_record ['CUR_OPERATOR'] = $xrate ['CUR_OPERATOR'];
                }
                if ($result ['FEE_AMT'] != CLX_NUM_ZERO) {
                    // do the flat fee
                    $trans_record ['TRANS_AMT'] = $result ['FEE_AMT'];
                } elseif ($result ['FEE_PCT'] != CLX_NUM_ZERO) {
                    // do the percentage
                    $trans_record ['TRANS_AMT'] = rounder($record ['TRANS_AMT'] * ($result ['FEE_PCT'] / CLX_NUM_HUNDRED), CLX_NUM_TWO);
                } elseif ($result ['HAS_SCALE'] > CLX_NUM_ZERO) { // Test Scales
                    // Test scales
                    $sql = 'SELECT FEES_RATE_PCT, FEES_RATE_AMT FROM ' . $this->firsname . '    WHERE    FIDU_RATETBLCODE = ' . singleQuote($result ['FIDU_RATETBLCODE']) . ' AND    ((RANGE_FROM_AMT < ' . $trans_record ['TRANS_AMT'] . ' AND RANGE_TO_AMT >= ' . $trans_record ['TRANS_AMT'] . ') OR   (RANGE_FROM_AMT < ' . $trans_record ['TRANS_AMT'] . ' AND RANGE_TO_AMT = 0))';
                    $ratelines = ClxCommon::$db->executeQuery($sql);
                    if (!empty($ratelines))
                        $rateline = ClxCommon::$db->getNextRecord($ratelines);
					ClxCommon::$db->freeResult($ratelines);	
                    $trans_record ['TRANS_AMT'] = rounder(bcadd($rateline ['FEES_RATE_AMT'], ($trans_record ['TRANS_AMT'] * ($rateline ['FEES_RATE_PCT'] / CLX_NUM_HUNDRED))), CLX_NUM_TWO);
                }
                // if all ok then
                $trans_record ['COMMISSION_CODE'] = $result ['COMMISSION_CODE'];
                if ($trans_record ['TRANS_AMT'] != CLX_NUM_ZERO)
                    $this->fiat_build_lines($result ['TRANSTBL_CODE'], $jehdr_code, $trans_record);
            } // end while
			ClxCommon::$db->freeResult($results);
            //e cho 'Fin de la historia para asiento ' . $jehdr_code.'<br>';
            $jehd->balance_exchange_rounding($jehdr_code);
        }

        /**
         * Build journal header for accounting
         *
         * @param array $trans_record
         * @param obj $jehd
         */
        private function fiat_build_header(&$trans_record, &$jehd) {
            $this->fiat_is_restrictedVoid($trans_record ['IDCODE']);
            $jehdr_code = $jehd->jehd_get_idcode_by_transcode($trans_record ['IDCODE']);
            // Clear anything previous
            // Crear encabezado de transaccion
            $gl_rec = $jehd->jehd_init_record();
            foreach ($gl_rec as $key => $val) {
                if (array_key_exists($key, $trans_record)) {
                    $gl_rec [$key] = $trans_record [$key];
                }
            }
            if ($jehdr_code !== '') {
                $gl_rec ['IDCODE'] = $jehdr_code;
            } else {
                $gl_rec ['IDCODE'] = 'AUTO';
            }
            $gl_rec ['TRANS_CODE'] = $trans_record ['IDCODE'];
            if (!array_key_exists('IDNAME', $trans_record)) {
                $gl_rec ['IDNAME'] = ClxCommon::$db->getField($this->fitbname, 'IDNAME', 'IDCODE = ' . singleQuote($trans_record ['TRANSTBL_CODE']));
            }
            $jehd->jehd_build($gl_rec);
            $trans_record ['JEHDR_CODE'] = $gl_rec ['IDCODE'];
            // Colocando codigo de transacion
            $sql = 'UPDATE ' . $this->fiatname . ' SET JEHDR_CODE = ' . singleQuote($gl_rec ['IDCODE']) . ' WHERE IDCODE = ' . singleQuote($trans_record ['IDCODE']);
            ClxCommon::$db->executeQuery($sql);
            $jehdr_code = $gl_rec ['IDCODE'];
            return $jehdr_code;
        }

        /**
         * Builds Transaction Lines
         *
         * @param unknown_type $transtbl_code
         * @param unknown_type $jehdr_code
         * @param unknown_type $trans_record
         */
        private function fiat_build_lines($transtbl_code, $jehdr_code, &$trans_record) {
            //Mark Lines for delete before update move previous to prevent delete of lines when multiple transactions occur
            //for example on fees. second transaccion remove by mistake likes from first.
            if (!class_exists('Comp'))
                includeCodeLib('COMP');
            $comp = new Comp();
            // Load jeln class and se clear array
            $jeln = new Jeln ();
            $clear_jeln_rec = $jeln->jeln_init_record();
            // Crear lineas de transaccion
            $sql = 'SELECT COMP.CURRENCY_CODE BASE_CURRENCY, FITB.IDNAME, FITS.INCLUDE_CHFLD, FITS.DEBIT_CREDIT, FITS.ITEM_CODE, FITS.FORMULA_CODE,FITS.USE_BASE_CURRECY, JEIT.FLAT_RATE, JEIT.EXEMPT_TAX_AMT, JEIT.TAX_WITHOLDING_PCT, JEIT.TAX_TYPE, JEIT.FILING_STATUS, JEIT.STATE, JEIT.COUNTRY, FITB.IS_TRANSFER, FIAT.CUR_OPERATOR, FIAT.ITEM_REF_NO, FIAT.CURRENCY_CODE, FIAT.EXCHANGE_RT, FITS.SEQNUM, FITS.AFFECT_TYPE, (CASE FITS.AFFECT_TYPE WHEN ' . singleQuote('EQ') . ' THEN (SELECT CASE FIAT.CURRENCY_CODE WHEN COMP.CURRENCY_CODE THEN TTPA.EQ_GL_CODE ELSE TTPA.EQF_GL_CODE END EQ_GL_CODE FROM ' . $this->ttpaname . ' TTPA, ' . $this->ficoname . ' FICO, ' . $this->compname . ' COMP, ' . $this->glcpname . ' GLCP WHERE GLCP.COMP_CODE = FICO.COMP_CODE AND COMP.IDCODE = GLCP.COMP_CODE AND TTPA.GLGROUP_CODE = GLCP.GLGROUP_CODE AND TTPA.FI_TYPE = FICO.FI_TYPE AND FIAT.COMP_CODE = FICO.COMP_CODE AND TTPA.CONTRACT_TYPE = FICO.CONTRACT_TYPE AND TTPA.TRUST_FUND_SRC = FICO.TRUST_FUND_SRC AND FICO.IDCODE =' . singleQuote($trans_record ['CHART_FIELD01']) . ') WHEN ' . singleQuote('CA') . ' THEN ' . singleQuote('CASH') . ' WHEN ' . singleQuote('OTH') . ' THEN FITS.GLACCOUNTCODE ELSE ' . singleQuote('PRODUCT') . '  END) GLACCOUNTCODE FROM ' . $this->fiatname . ' FIAT, ' . $this->fitbname . ' FITB, ' . $this->fitsname . ' FITS, ' . $this->jeitname . ' JEIT, ' . $this->compname . ' COMP WHERE JEIT.IDCODE = FITS.ITEM_CODE AND COMP.IDCODE = FIAT.COMP_CODE AND FITS.TRANSTBL_CODE = FITB.IDCODE  AND JEIT.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->jeitname . ' X WHERE X.IDCODE = FITS.ITEM_CODE AND X.CLX_EFFTDATE<=' . singleQuote($trans_record ['EFFTDATE']) . ') AND FITB.IDCODE = ' . singleQuote($transtbl_code) . ' AND FIAT.IDCODE = ' . singleQuote($trans_record ['IDCODE']) . ' AND FITS.STATUS = ' . singleQuote('A');
            $results = ClxCommon::$db->executeQuery($sql);
            
			while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                
				// Setting currency from trans_record if exists
                if (!clx_is_empty($result ['CURRENCY_CODE'])) {
                    $result ['CURRENCY_CODE'] = $trans_record ['CURRENCY_CODE'];
                }
                if (!clx_is_empty($result ['EXCHANGE_RT'])) {
                    $result ['EXCHANGE_RT'] = $trans_record ['EXCHANGE_RT'];
                }
                if (!clx_is_empty($result ['CUR_OPERATOR'])) {
                    $result ['CUR_OPERATOR'] = $trans_record ['CUR_OPERATOR'];
                }
                // Init clear jeln rec and set some defaults
                $jeln_rec = $clear_jeln_rec;
                // Comceptos va a calcular el monto de transaccion de la linea
                $trans_amt = $trans_record ['TRANS_AMT'];
                
                //SET_TGT_CHART_FIELD
                $cf1 = $trans_record ['CHART_FIELD01'];
                $cf2 = $trans_record ['CHART_FIELD02'];
                $cf3 = $trans_record ['CHART_FIELD03'];
                $cf4 = $trans_record ['CHART_FIELD04'];

                if(!empty($result['SET_TGT_CHART_FIELD']) && !empty($trans_record['CHART_FIELD01_TGT'])){
                    $cf1 = $trans_record ['CHART_FIELD01_TGT'];
                    $cf2 = $trans_record ['CHART_FIELD02_TGT'];
                    $cf3 = '';
                    $cf4 = $trans_record ['CHART_FIELD04_TGT'];

                }
                
                // Adding invoice lines
                if ($result ['AFFECT_TYPE'] === 'INVO') {
                    // Adding invoice lines AP
                    if (!empty($this->apinname)) {

						//edgard
                        $sql = 'SELECT APIN.CURRENCY_CODE, APIN.IDCODE ITEM_REF_NO, APIN.CHART_FIELD01, APIN.CHART_FIELD02, APIN.CHART_FIELD03, APIN.CHART_FIELD04, APIN.AP_ITEM_CODE ITEM_CODE, APIN.GLACCOUNTCODE, IFNULL((APIN.INVOICE_AMT-(IF(APIN.OPENING_BAL<>0, APIN.INVOICE_AMT-APIN.OPENING_BAL, 0)+IFNULL((SELECT SUM(APPY.PAID_AMT) FIAT_TRANS_AMT FROM AP_PYMT_TRANS APPY, GL_JOURNAL_HDR JEHDX WHERE APPY.PAYINV_CODE = APIN.IDCODE AND JEHDX.IDCODE = APPY.JEHDR_CODE AND JEHDX.CLX_AUTH_STATUS<> ' .singleQuote('REJ'). ' AND JEHDX.REVERSED = 0),0))),0)  INVOICE_AMT FROM AP_PAY_INVOICES APIN WHERE APIN.PAY_JEHDR_CODE = ' . singleQuote($jehdr_code);
                        $rs = ClxCommon::$db->executeQuery($sql);
                        $trans_amt_total = $trans_amt;

                        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
							// Adjusting value to match invoice
                            if ($r ['INVOICE_AMT'] > $trans_amt_total) {
                                $r ['INVOICE_AMT'] = $trans_amt_total;
                            }

                            //Update inpy to set payment amount
                            $sql = 'UPDATE AP_PYMT_TRANS APPY
                                SET APPY.PAID_AMT = ' . $r ['INVOICE_AMT'] . ', APPY.MDATE = NOW(), APPY.MODIFIEDBY = ' . singleQuote($this->username) . '
                                WHERE APPY.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND APPY.PAYINV_CODE  = ' . singleQuote($r['ITEM_REF_NO']);
                            ClxCommon::$db->executeQuery($sql);

                            $jeln_rec_copy = $jeln_rec;
                            $jeln_rec_copy ['JEHDR_CODE'] = $jehdr_code;
                            $jeln_rec_copy ['CURRENCY_CODE'] = $r ['CURRENCY_CODE'];
                            $jeln_rec_copy ['CHART_FIELD01'] = $r ['CHART_FIELD01'];
                            $jeln_rec_copy ['CHART_FIELD02'] = $r ['CHART_FIELD02'];
                            $jeln_rec_copy ['CHART_FIELD03'] = (!empty($r ['CHART_FIELD03'])) ? $r ['CHART_FIELD03'] : 'null';
                            $jeln_rec_copy ['CHART_FIELD04'] = (!empty($r ['CHART_FIELD04'])) ? $r ['CHART_FIELD04'] : 'null';
                            $jeln_rec_copy ['GLACCOUNTCODE'] = $r ['GLACCOUNTCODE'];
                            $jeln_rec_copy ['ITEM_CODE'] = $r ['ITEM_CODE'];
                            $jeln_rec_copy ['ITEM_REF_NO'] = $r ['ITEM_REF_NO'];

                            $jeln_rec_copy ['DEBIT_AMT'] = ($result ['DEBIT_CREDIT'] === 'DR') ? $r ['INVOICE_AMT'] : CLX_NUM_ZERO;
                            $jeln_rec_copy ['CREDIT_AMT'] = ($result ['DEBIT_CREDIT'] === 'CR') ? $r ['INVOICE_AMT'] : CLX_NUM_ZERO;
                            $jeln_rec_copy ['DEBIT_TRANS_AMT'] = ($result ['DEBIT_CREDIT'] === 'DR') ? $r ['INVOICE_AMT'] : CLX_NUM_ZERO;
                            $jeln_rec_copy ['CREDIT_TRANS_AMT'] = ($result ['DEBIT_CREDIT'] === 'CR') ? $r ['INVOICE_AMT'] : CLX_NUM_ZERO;

                            $jeln_rec_copy ['SEQNUM'] = $this->seqnum;
                            $jeln_rec_copy ['CUR_OPERATOR'] = $trans_record ['CUR_OPERATOR'];
                            $jeln_rec_copy ['EXCHANGE_RT'] = $trans_record ['EXCHANGE_RT'];

                            $this->seqnum++;
                            $jeln->jeln_build($jeln_rec_copy);
                            $trans_amt_total = bcsub($trans_amt_total, $r ['INVOICE_AMT']);
                            if ($trans_amt_total <= 0) {
                                break;
                            }
                        }
						ClxCommon::$db->freeResult($rs);
                    } // end invo
                    //
                    // Adding invoice lines AR
                    if (!empty($this->invoname)) {
                       
						//$sql = 'SELECT INVO.CURRENCY_CODE, INVO.IDCODE ITEM_REF_NO, INVO.CHART_FIELD01, INVO.CHART_FIELD02, INVO.CHART_FIELD03, INVO.CHART_FIELD04, INVO.AR_ITEM_CODE ITEM_CODE, INVO.GLACCOUNTCODE, IFNULL((INVO.INVOICE_AMT-(IF(INVO.OPENING_BAL<>0, INVO.INVOICE_AMT-INVO.OPENING_BAL, 0)+ IFNULL((SELECT SUM(INPY.PAID_AMT) FIAT_TRANS_AMT FROM BILL_INVPYMT_TRANS INPY, GL_JOURNAL_HDR JEHDX WHERE INPY.INVOICECODE = INVO.IDCODE AND JEHDX.IDCODE = INPY.JEHDR_CODE AND JEHDX.REVERSED = 0),0))),0) INVOICE_AMT FROM ' . $this->invoname . ' INVO WHERE INVO.PAY_JEHDR_CODE = ' . singleQuote($jehdr_code);
                        
						$sql = 'SELECT INVO.CURRENCY_CODE, INVO.IDCODE ITEM_REF_NO, INVO.CHART_FIELD01, INVO.CHART_FIELD02, INVO.CHART_FIELD03, INVO.CHART_FIELD04, INVO.AR_ITEM_CODE ITEM_CODE, INVO.GLACCOUNTCODE, IFNULL((INVO.INVOICE_AMT-(IF(INVO.OPENING_BAL<>0, INVO.INVOICE_AMT-INVO.OPENING_BAL, 0)+ IFNULL((SELECT SUM(INPY.PAID_AMT) FIAT_TRANS_AMT FROM BILL_INVPYMT_TRANS INPY, GL_JOURNAL_HDR JEHDX WHERE INPY.INVOICECODE = INVO.IDCODE AND JEHDX.IDCODE = INPY.JEHDR_CODE AND JEHDX.CLX_AUTH_STATUS<> ' .singleQuote('REJ'). ' AND JEHDX.REVERSED = 0),0))),0) INVOICE_AMT FROM ' . $this->invoname . ' INVO WHERE INVO.PAY_JEHDR_CODE = ' . singleQuote($jehdr_code);

						
						$rs = ClxCommon::$db->executeQuery($sql);
                        $trans_amt_total = $trans_amt;
                        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                            // Adjusting value to match invoice
                            if ($r ['INVOICE_AMT'] > $trans_amt_total) {
                                $r ['INVOICE_AMT'] = $trans_amt_total;
                            }

                            //Update inpy to set payment amount
                            $sql = 'UPDATE BILL_INVPYMT_TRANS INPY SET INPY.PAID_AMT = ' . $r ['INVOICE_AMT'] . ', INPY.MDATE = NOW(), INPY.MODIFIEDBY = ' . singleQuote($this->username) . ' WHERE INPY.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND INPY.INVOICECODE  = ' . singleQuote($r['ITEM_REF_NO']);
                            ClxCommon::$db->executeQuery($sql);

                            $jeln_rec_copy = $jeln_rec;
                            $jeln_rec_copy ['JEHDR_CODE'] = $jehdr_code;
                            $jeln_rec_copy ['CURRENCY_CODE'] = $r ['CURRENCY_CODE'];
                            $jeln_rec_copy ['CHART_FIELD01'] = $r ['CHART_FIELD01'];
                            $jeln_rec_copy ['CHART_FIELD02'] = $r ['CHART_FIELD02'];
                            $jeln_rec_copy ['CHART_FIELD03'] = (!empty($r ['CHART_FIELD03'])) ? $r ['CHART_FIELD03'] : 'null';
                            $jeln_rec_copy ['CHART_FIELD04'] = (!empty($r ['CHART_FIELD04'])) ? $r ['CHART_FIELD04'] : 'null';
                            $jeln_rec_copy ['GLACCOUNTCODE'] = $r ['GLACCOUNTCODE'];
                            $jeln_rec_copy ['ITEM_CODE'] = $r ['ITEM_CODE'];
                            $jeln_rec_copy ['ITEM_REF_NO'] = $r ['ITEM_REF_NO'];
                            $jeln_rec_copy ['DEBIT_AMT'] = ($result ['DEBIT_CREDIT'] === 'DR') ? $r ['INVOICE_AMT'] : CLX_NUM_ZERO;
                            $jeln_rec_copy ['CREDIT_AMT'] = ($result ['DEBIT_CREDIT'] === 'CR') ? $r ['INVOICE_AMT'] : CLX_NUM_ZERO;
                            $jeln_rec_copy ['DEBIT_TRANS_AMT'] = ($result ['DEBIT_CREDIT'] === 'DR') ? $r ['INVOICE_AMT'] : CLX_NUM_ZERO;
                            $jeln_rec_copy ['CREDIT_TRANS_AMT'] = ($result ['DEBIT_CREDIT'] === 'CR') ? $r ['INVOICE_AMT'] : CLX_NUM_ZERO;
                            $jeln_rec_copy ['SEQNUM'] = $this->seqnum;
                            
                            $jeln_rec_copy ['CUR_OPERATOR'] = $trans_record ['CUR_OPERATOR'];
                            $jeln_rec_copy ['EXCHANGE_RT'] = $trans_record ['EXCHANGE_RT'];

                            $this->seqnum++;
                            $jeln->jeln_build($jeln_rec_copy);

                            $trans_amt_total = bcsub($trans_amt_total, $r ['INVOICE_AMT']);
                            if ($trans_amt_total <= 0) {
                                break;
                            }
                        }
						ClxCommon::$db->freeResult($rs);
                    }
                    continue;
                } // end
                // searching gl account from product table if it is the case
                if ($result ['GLACCOUNTCODE'] === 'PRODUCT') {
                    $fiasrec = ClxCommon::$db->getFields($this->fiasname, 'LOAN_CODE,FIDU_BANKACT_CODE,GUAR_CODE,TRUST_ITEM_TYPE, ASSET_CODE', 'IDCODE=' . singleQuote($cf3));
                    if (!empty($fiasrec ['GUAR_CODE'])) {
                        $prod_info = ClxCommon::$db->getFields($this->guarname, 'PRODUCT_CODE,CURRENCY_CODE', 'IDCODE = ' . singleQuote($fiasrec ['GUAR_CODE']));
                        if (empty($prod_info)) {
                            $product_code = '';
                        } else {
                            $product_code = $prod_info['PRODUCT_CODE'];
                            $result['CURRENCY_CODE'] = $prod_info['CURRENCY_CODE'];
                        }
                    } elseif (!empty($fiasrec ['FIDU_BANKACT_CODE'])) {
                        $prod_info = ClxCommon::$db->getFields($this->fibkname, 'BANK_PROD_CODE, CURRENCY_CODE', 'BANK_ACCOUNT_NO = ' . singleQuote($fiasrec ['FIDU_BANKACT_CODE']));
                        if (empty($prod_info)) {
                            $product_code = '';
                        } else {
                            $product_code = $prod_info['BANK_PROD_CODE'];
                            $result['CURRENCY_CODE'] = $prod_info['CURRENCY_CODE'];
                        }
                    } elseif (!empty($fiasrec ['LOAN_CODE'])) {
                        $prod_info = ClxCommon::$db->getFields($this->filoname, 'CURRENCY_CODE,PRODUCT_CODE', 'IDCODE = ' . singleQuote($fiasrec ['LOAN_CODE']));
                        if (empty($prod_info)) {
                            $product_code = '';
                        } else {
                            $product_code = $prod_info['PRODUCT_CODE'];
                            $result['CURRENCY_CODE'] = $prod_info['CURRENCY_CODE'];
                        }
                    } elseif (!empty($fiasrec ['ASSET_CODE'])) {
                        $prod_info = ClxCommon::$db->getFields($this->fiaename, 'CURRENCY_CODE,PRODUCT_CODE', 'IDCODE = ' . singleQuote($fiasrec ['ASSET_CODE']));
                        if (empty($prod_info)) {
                            $product_code = '';
                        } else {
                            $product_code = $prod_info['PRODUCT_CODE'];
                            $result['CURRENCY_CODE'] = $prod_info['CURRENCY_CODE'];
                        }
                    } elseif ($fiasrec ['TRUST_ITEM_TYPE'] === 'AD') { // ANTICIPOS
                        // PRES
                        $product_code = ClxCommon::$db->getField($this->prptname, 'ADVN_PROD_CODE', 'CONTRACT_CODE = ' . singleQuote($cf1));
                    } elseif ($fiasrec ['TRUST_ITEM_TYPE'] === 'PR') { // PRESTAMOS
                        // PRES
                        $product_code = ClxCommon::$db->getField($this->prptname, 'LOAN_PROD_CODE', 'CONTRACT_CODE = ' . singleQuote($cf1));
                    } else {
                        $product_code = '';
                    }
                    $sql = 'SELECT ' . $result ['AFFECT_TYPE'] . '_CODE FROM ' . $this->pratname . ' WHERE PRODUCT_CODE = ' . singleQuote($product_code) . ' AND PROD_STATUS = ' . singleQuote('VIG');
                    $result ['GLACCOUNTCODE'] = ClxCommon::$db->getOne($sql);
                } elseif ($result ['GLACCOUNTCODE'] === 'CASH') { // search cash gl
                    if ($result ['IS_TRANSFER'] == CLX_NUM_ONE && $result ['SEQNUM'] > CLX_NUM_ONE) {
                        $sql = 'SELECT PRAT.PRO_GL_CODE GLACCOUNTCODE, FIBK.CURRENCY_CODE FROM ' . $this->pratname . ' PRAT, ' . $this->fibkname . ' FIBK   WHERE    PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE    AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($trans_record ['BANKAC_CODE']);
                    } else {
                        $sql = 'SELECT PRAT.PRO_GL_CODE GLACCOUNTCODE, FIBK.CURRENCY_CODE FROM ' . $this->pratname . ' PRAT, ' . $this->fibkname . ' FIBK   WHERE    PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE    AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($trans_record ['FIDU_BANKACT_CODE']);
                    }
                    $prod_info = ClxCommon::$db->getOneRecord($sql);
                    if (!empty($prod_info)) {
                        $result ['GLACCOUNTCODE'] = $prod_info['GLACCOUNTCODE'];
                        $result['CURRENCY_CODE'] = $prod_info['CURRENCY_CODE'];
                    }
                }
                
                // Setting some values
                foreach ($jeln_rec as $key => $val) {
                    if (array_key_exists($key, $trans_record)) {
                        $jeln_rec [$key] = $trans_record [$key];
                    }
                    if (array_key_exists($key, $result)) {
                        $jeln_rec [$key] = $result [$key];
                    }
                }
                $jeln_rec['CHART_FIELD01'] = $cf1;
                $jeln_rec['CHART_FIELD02'] = $cf2;
                $jeln_rec['CHART_FIELD03'] = $cf3;
                $jeln_rec['CHART_FIELD04'] = $cf4;

                //Ajustando caso donde la moneda del activo no es igual a la moneda de la transaccion
                //Existen 2 casos si la transaccion es en moneda base entonces el activo debe vender divisas
                //de lo contrario debe usar el cambio de compra
                if ($trans_record ['CURRENCY_CODE'] <> $result ['CURRENCY_CODE']) {
                    if ($result['BASE_CURRENCY'] == $trans_record ['CURRENCY_CODE']) {
                        //Debe ser cambio para la venta
                        $xrt = $comp->comp_current_exchange($trans_record ['COMP_CODE'], $result ['CURRENCY_CODE'], $trans_record ['EFFTDATE'], CLX_NUM_MINUS_1);
                    } else {
                        //Debe ser cambio para la compra
                        $xrt = $comp->comp_current_exchange($trans_record ['COMP_CODE'], $result ['CURRENCY_CODE'], $trans_record ['EFFTDATE'], CLX_NUM_ZERO);
                        //Cuando la transaccion es en dolares y el activo es en moneda base entonces debe colocar monto base ya que otros elementos en dolares deben coincidir
                        if ($xrt['EXCHANGE_RT'] == CLX_NUM_ONE) {
                            $trans_amt = round($trans_amt * pow($trans_record['EXCHANGE_RT'], $trans_record['CUR_OPERATOR']), CLX_NUM_TWO);
                        }
                    }
                    $jeln_rec['EXCHANGE_RT'] = $xrt['EXCHANGE_RT'];
                    $jeln_rec['CUR_OPERATOR'] = $xrt['CUR_OPERATOR'];
                }
                // Defining sub account not always is needed
                switch ($result ['AFFECT_TYPE']) {
                    case 'CA' :
                        if ($result ['IS_TRANSFER'] == CLX_NUM_ONE && $result ['SEQNUM'] > CLX_NUM_ONE) {
                            // setting transfer glaccount
                            $jeln_rec ['CHART_FIELD03'] = ClxCommon::$db->getField($this->fiasname, 'IDCODE', 'CONTRACT_CODE = ' . singleQuote($cf1) . ' AND FIDU_BANKACT_CODE = ' . singleQuote($trans_record ['BANKAC_CODE']));
                            if(empty($jeln_rec ['ITEM_REF_NO']))
                                $jeln_rec ['ITEM_REF_NO'] = $trans_record ['BANKAC_CODE'];
                        } else {
                            $jeln_rec ['CHART_FIELD03'] = ClxCommon::$db->getField($this->fiasname, 'IDCODE', 'CONTRACT_CODE = ' . singleQuote($cf1) . ' AND FIDU_BANKACT_CODE = ' . singleQuote($trans_record ['FIDU_BANKACT_CODE']));
                            if(empty($jeln_rec ['ITEM_REF_NO']))
                                $jeln_rec ['ITEM_REF_NO'] = $trans_record ['FIDU_BANKACT_CODE'];
                        }
                        $cf3 = $jeln_rec ['CHART_FIELD03'];
                        break;
                    case 'PRO_GL' :
                        $jeln_rec ['CHART_FIELD03'] = $cf3;
                        break;
                    case 'AR_GL' :
                        $jeln_rec ['CHART_FIELD03'] = $cf3;
                        break;
                    case 'AP_GL' :
                        $jeln_rec ['CHART_FIELD03'] = $cf3;
                        break;
                    case 'ORDER_GL' :
                        $jeln_rec ['CHART_FIELD03'] = $cf3;
                        break;
                    case 'ORDER2_GL' :
                        $jeln_rec ['CHART_FIELD03'] = $cf3;
                        break;
                    case 'CINT_GL' :
                        $jeln_rec ['CHART_FIELD03'] = $cf3;
                        break;
                    case 'CINT2_GL' :
                        $jeln_rec ['CHART_FIELD03'] = $cf3;
                        break;
                    case 'COL_GL' :
                        $jeln_rec ['CHART_FIELD03'] = $cf3;
                        break;
                    case 'COL2_GL' :
                        $jeln_rec ['CHART_FIELD03'] = $cf3;
                        break;
                    default :
                        // Colocado a nulo si no viene de alguna definicion de
                        // producto
                        $jeln_rec ['CHART_FIELD03'] = 'null';
                        break;
                }

                if(!empty($result['INCLUDE_CHFLD'])){
                    $jeln_rec ['CHART_FIELD03'] = $cf3;
                }
                //Colocando cambio para activos en moneda original de lo contrario toma la de la transaccion
                $jeln_rec ['JEHDR_CODE'] = $jehdr_code;
                if ($trans_amt >= CLX_NUM_ZERO) {
                    $jeln_rec ['DEBIT_AMT'] = ($result ['DEBIT_CREDIT'] === 'DR') ? $trans_amt : CLX_NUM_ZERO;
                    $jeln_rec ['CREDIT_AMT'] = ($result ['DEBIT_CREDIT'] === 'CR') ? $trans_amt : CLX_NUM_ZERO;
                    $jeln_rec ['DEBIT_TRANS_AMT'] = ($result ['DEBIT_CREDIT'] === 'DR') ? $trans_amt : CLX_NUM_ZERO;
                    $jeln_rec ['CREDIT_TRANS_AMT'] = ($result ['DEBIT_CREDIT'] === 'CR') ? $trans_amt : CLX_NUM_ZERO;
                } else {
                    $jeln_rec ['DEBIT_AMT'] = ($result ['DEBIT_CREDIT'] === 'CR') ? bcmul(-CLX_NUM_ONE, $trans_amt) : CLX_NUM_ZERO;
                    $jeln_rec ['CREDIT_AMT'] = ($result ['DEBIT_CREDIT'] === 'DR') ? bcmul(-CLX_NUM_ONE, $trans_amt) : CLX_NUM_ZERO;
                    $jeln_rec ['DEBIT_TRANS_AMT'] = ($result ['DEBIT_CREDIT'] === 'CR') ? bcmul(-CLX_NUM_ONE, $trans_amt) : CLX_NUM_ZERO;
                    $jeln_rec ['CREDIT_TRANS_AMT'] = ($result ['DEBIT_CREDIT'] === 'DR') ? bcmul(-CLX_NUM_ONE, $trans_amt) : CLX_NUM_ZERO;
                }
                // set commision key
                if (!empty($trans_record ['COMMISSION_CODE']))
                    $jeln_rec ['ITEM_REF_NO'] = $trans_record ['COMMISSION_CODE'];
                // set item if exists
                if (!empty($result ['ITEM_REF_NO']))
                    $jeln_rec ['ITEM_REF_NO'] = $result ['ITEM_REF_NO'];
                // clear blank of empty
                if (empty($jeln_rec ['ITEM_REF_NO']))
                    $jeln_rec ['ITEM_REF_NO'] = 'null';
                // Process formulas
                

				//Aqui sumo las lineas de factura que son de tipo de servicio para eventualmente cuando se desee calcular el ISR ese campo este disponible dentro de las formulas flexibles
				if (!empty($this->apinname)) {
				
					$sql = 'SELECT IFNULL(SUM(APIL.QUANTITY*APIL.PRICE),0.00) INV_SERV_AMT FROM ' . $this->apinname . ' APIN , ' . $this->apilname . ' APIL WHERE APIL.PAYINV_CODE = APIN.IDCODE AND APIL.TYPE_ACTIVE = '. singleQuote('S') . ' AND APIN.PAY_JEHDR_CODE = ' . singleQuote($jehdr_code);
					$sum_services = ClxCommon::$db->getOneRecord($sql);

					if (!empty($sum_services)) {
						 $trans_record['INV_SERV_AMT'] = $sum_services['INV_SERV_AMT'];
					}
				}

				
				//echo "result:"; pre($result);
				if (!empty($result ['FORMULA_CODE'])) {
                    // Apply formulas
                    $flex = new fidu_flexformula ();
                    $line = array_merge($trans_record, $jeln_rec, $result);
                    //echo "line:"; pre($line); 
					$line ['FORMULA_AMT'] = $flex->calculate($result ['FORMULA_CODE'], $line);
                    
					//echo "resultado: ".$line ['FORMULA_AMT']."</br>";
					if ($result ['TAX_WITHOLDING_PCT'] != CLX_NUM_ZERO) {
                        $line ['FORMULA_AMT'] = round($line ['FORMULA_AMT'] * ($result ['TAX_WITHOLDING_PCT'] / CLX_NUM_HUNDRED), CLX_NUM_TWO);
                    }
                    if ($result ['EXEMPT_TAX_AMT'] != CLX_NUM_ZERO) {
                        $line ['FORMULA_AMT'] -= $result ['EXEMPT_TAX_AMT'];
                    }
                    if ($result ['FLAT_RATE'] != CLX_NUM_ZERO) {
                        $line ['FORMULA_AMT'] = round($line ['FORMULA_AMT'] * ($result ['FLAT_RATE'] / CLX_NUM_HUNDRED), CLX_NUM_TWO);
                    }

                    if(!empty($result['USE_BASE_CURRECY'])){
                        $jeln_rec ['CURRENCY_CODE'] = $result['BASE_CURRENCY'];
                        $jeln_rec ['EXCHANGE_RT'] = CLX_NUM_ONE;
                        $jeln_rec ['CUR_OPERATOR'] = CLX_NUM_ONE;
                    }
                    if ($line ['FORMULA_AMT'] >= CLX_NUM_ZERO) {
                        $jeln_rec ['DEBIT_AMT'] = ($result ['DEBIT_CREDIT'] === 'DR') ? $line ['FORMULA_AMT'] : CLX_NUM_ZERO;
                        $jeln_rec ['CREDIT_AMT'] = ($result ['DEBIT_CREDIT'] === 'CR') ? $line ['FORMULA_AMT'] : CLX_NUM_ZERO;
                        $jeln_rec ['DEBIT_TRANS_AMT'] = ($result ['DEBIT_CREDIT'] === 'DR') ? $line ['FORMULA_AMT'] : CLX_NUM_ZERO;
                        $jeln_rec ['CREDIT_TRANS_AMT'] = ($result ['DEBIT_CREDIT'] === 'CR') ? $line ['FORMULA_AMT'] : CLX_NUM_ZERO;
                    } else {
                        $jeln_rec ['DEBIT_AMT'] = ($result ['DEBIT_CREDIT'] === 'CR') ? bcmul(-CLX_NUM_ONE, $line ['FORMULA_AMT']) : CLX_NUM_ZERO;
                        $jeln_rec ['CREDIT_AMT'] = ($result ['DEBIT_CREDIT'] === 'DR') ? bcmul(-CLX_NUM_ONE, $line ['FORMULA_AMT']) : CLX_NUM_ZERO;
                        $jeln_rec ['DEBIT_TRANS_AMT'] = ($result ['DEBIT_CREDIT'] === 'CR') ? bcmul(-CLX_NUM_ONE, $line ['FORMULA_AMT']) : CLX_NUM_ZERO;
                        $jeln_rec ['CREDIT_TRANS_AMT'] = ($result ['DEBIT_CREDIT'] === 'DR') ? bcmul(-CLX_NUM_ONE, $line ['FORMULA_AMT']) : CLX_NUM_ZERO;
                    }
                    unset($flex, $line);
                } else {
                    if ($result ['TAX_WITHOLDING_PCT'] != CLX_NUM_ZERO) {
                        $trans_amt = round($trans_amt * ($result ['TAX_WITHOLDING_PCT'] / CLX_NUM_HUNDRED), CLX_NUM_TWO);
                    }
                    if ($result ['EXEMPT_TAX_AMT'] != CLX_NUM_ZERO) {
                        $trans_amt -= $result ['EXEMPT_TAX_AMT'];
                    }
                    if ($result ['FLAT_RATE'] != CLX_NUM_ZERO) {
                        $trans_amt = round($trans_amt * ($result ['FLAT_RATE'] / CLX_NUM_HUNDRED), CLX_NUM_TWO);
                    }
                    if(!empty($result['USE_BASE_CURRECY'])){
                        $jeln_rec ['CURRENCY_CODE'] = $result['BASE_CURRENCY'];
                        $jeln_rec ['EXCHANGE_RT'] = CLX_NUM_ONE;
                        $jeln_rec ['CUR_OPERATOR'] = CLX_NUM_ONE;
                    }
                    if ($trans_amt >= CLX_NUM_ZERO) {
                        $jeln_rec ['DEBIT_AMT'] = ($result ['DEBIT_CREDIT'] === 'DR') ? $trans_amt : CLX_NUM_ZERO;
                        $jeln_rec ['CREDIT_AMT'] = ($result ['DEBIT_CREDIT'] === 'CR') ? $trans_amt : CLX_NUM_ZERO;
                        $jeln_rec ['DEBIT_TRANS_AMT'] = ($result ['DEBIT_CREDIT'] === 'DR') ? $trans_amt : CLX_NUM_ZERO;
                        $jeln_rec ['CREDIT_TRANS_AMT'] = ($result ['DEBIT_CREDIT'] === 'CR') ? $trans_amt : CLX_NUM_ZERO;
                    } else {
                        $jeln_rec ['DEBIT_AMT'] = ($result ['DEBIT_CREDIT'] === 'CR') ? bcmul(-CLX_NUM_ONE, $trans_amt) : CLX_NUM_ZERO;
                        $jeln_rec ['CREDIT_AMT'] = ($result ['DEBIT_CREDIT'] === 'DR') ? bcmul(-CLX_NUM_ONE, $trans_amt) : CLX_NUM_ZERO;
                        $jeln_rec ['DEBIT_TRANS_AMT'] = ($result ['DEBIT_CREDIT'] === 'CR') ? bcmul(-CLX_NUM_ONE, $trans_amt) : CLX_NUM_ZERO;
                        $jeln_rec ['CREDIT_TRANS_AMT'] = ($result ['DEBIT_CREDIT'] === 'DR') ? bcmul(-CLX_NUM_ONE, $trans_amt) : CLX_NUM_ZERO;
                    }
                }

                $revert_exchange = ($trans_record ['CURRENCY_CODE'] <> $jeln_rec ['CURRENCY_CODE']) ? true : false;
                $jeln_rec ['SEQNUM'] = $this->seqnum;
                $this->seqnum++;
                // Building Lines if participant exists
                if (!empty($trans_record ['CHART_FIELD02']) && $trans_record ['CHART_FIELD02'] !== 'null') {
                    $jeln->jeln_build($jeln_rec, $revert_exchange);
                    // Building line with distribution
                } elseif (ClxCommon::$db->countRecords($this->fipdname, 'TRANS_CODE = ' . singleQuote($trans_record ['IDCODE'])) > CLX_NUM_ZERO) {
                    // distribute for participants
                    $sql = 'SELECT   FIPD.CHART_FIELD02,   FIPD.PARTICIPATION_AMT,   FIAT.TRANS_AMT  FROM   FIDU_TRANSACTIONS FIAT,   FIDU_TRANS_DISTRIBUTIONS FIPD  WHERE   FIAT.IDCODE = FIPD.TRANS_CODE   AND FIAT.IDCODE = ' . singleQuote($trans_record ['IDCODE']);
                    $parts = ClxCommon::$db->executeQuery($sql);
                    while (($part = ClxCommon::$db->getNextRecord($parts))) {
                        $jeln_rec_copy = $jeln_rec;
                        $jeln_rec_copy ['CHART_FIELD02'] = $part ['CHART_FIELD02'];
                        $jeln_rec_copy ['DEBIT_AMT'] = rounder($jeln_rec_copy ['DEBIT_AMT'] * ($part ['PARTICIPATION_AMT'] / $part ['TRANS_AMT']), CLX_NUM_TWO);
                        $jeln_rec_copy ['CREDIT_AMT'] = rounder($jeln_rec_copy ['CREDIT_AMT'] * ($part ['PARTICIPATION_AMT'] / $part ['TRANS_AMT']), CLX_NUM_TWO);
                        $jeln->jeln_build($jeln_rec_copy, $revert_exchange);
                        $this->seqnum++;
                    }
					ClxCommon::$db->freeResult($pats);
                    // Do diff here
                } else {
                    // distribute by fitb formula if exists
                    $sql = 'SELECT *   FROM   (SELECT    JCBV.CHART_FIELD02,    FITB.GL_TYPE,    FITB.TRUST_ITEM_TYPE,    SUM(JCBV.BALANCE_AMT) PARTICIPATION_AMT   FROM    ' . $this->jcbvname . ' JCBV,    ' . $this->glacname . ' GLAC,    ' . $this->fiatname . ' FIAT,    ' . $this->fitbname . ' FITB   WHERE    FITB.IDCODE = FIAT.TRANSTBL_CODE    AND GLAC.IDCODE = JCBV.GLACCOUNTCODE    /*AND JCBV.CURRENCY_CODE = FIAT.CURRENCY_CODE*/    AND GLAC.GL_TYPE = FITB.GL_TYPE    AND (GLAC.TRUST_ITEM_TYPE = FITB.TRUST_ITEM_TYPE    OR GLAC.TRUST_ITEM_TYPE = FITB.TRUST_ITEM_TYPE    OR FITB.TRUST_ITEM_TYPE IS NULL OR FITB.TRUST_ITEM_TYPE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ')    AND JCBV.CHART_FIELD01 = FIAT.CHART_FIELD01    AND FIAT.IDCODE = ' . singleQuote($trans_record ['IDCODE']) . '   GROUP BY    JCBV.CHART_FIELD02,    FITB.GL_TYPE,    FITB.TRUST_ITEM_TYPE) AS PARTS,   (SELECT    SUM(JCBV.BALANCE_AMT) TRANS_AMT   FROM    ' . $this->jcbvname . ' JCBV,    ' . $this->glacname . ' GLAC,    ' . $this->fiatname . ' FIAT,    ' . $this->fitbname . ' FITB   WHERE    FITB.IDCODE = FIAT.TRANSTBL_CODE    AND GLAC.IDCODE = JCBV.GLACCOUNTCODE    /*AND JCBV.CURRENCY_CODE = FIAT.CURRENCY_CODE*/    AND GLAC.GL_TYPE = FITB.GL_TYPE    AND (GLAC.TRUST_ITEM_TYPE = FITB.TRUST_ITEM_TYPE    OR GLAC.TRUST_ITEM_TYPE = FITB.TRUST_ITEM_TYPE    OR FITB.TRUST_ITEM_TYPE IS NULL OR FITB.TRUST_ITEM_TYPE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ')    AND JCBV.CHART_FIELD01 = FIAT.CHART_FIELD01    AND FIAT.IDCODE = ' . singleQuote($trans_record ['IDCODE']) . ') AS TOTAL';
                    $parts = ClxCommon::$db->executeQuery($sql);
                    while (($part = ClxCommon::$db->getNextRecord($parts))) {
                        $jeln_rec_copy = $jeln_rec;
                        $jeln_rec_copy ['CHART_FIELD02'] = $part ['CHART_FIELD02'];
                        $jeln_rec_copy ['DEBIT_AMT'] = rounder($jeln_rec_copy ['DEBIT_AMT'] * ($part ['PARTICIPATION_AMT'] / $part ['TRANS_AMT']), CLX_NUM_TWO);
                        $jeln_rec_copy ['CREDIT_AMT'] = rounder($jeln_rec_copy ['CREDIT_AMT'] * ($part ['PARTICIPATION_AMT'] / $part ['TRANS_AMT']), CLX_NUM_TWO);
                        $jeln->jeln_build($jeln_rec_copy, $revert_exchange);
                        $this->seqnum++;
                    }
					ClxCommon::$db->freeResult($pats);
                    // Catch distribution diff here
                    $sql = 'SELECT   IFNULL(SUM(DEBIT_AMT),0) DEBIT_AMT,   IFNULL(SUM(CREDIT_AMT),0) CREDIT_AMT   FROM   ' . $this->jelnname . '    WHERE   JEHDR_CODE = ' . singleQuote($jeln_rec ['JEHDR_CODE']) . '   AND SEQNUM = ' . singleQuote($jeln_rec ['SEQNUM']);
                    $total = ClxCommon::$db->getOneRecord($sql);
                    $total ['DEBIT_AMT'] -= $jeln_rec ['DEBIT_AMT'];
                    $total ['CREDIT_AMT'] -= $jeln_rec ['CREDIT_AMT'];
                    $sql = 'UPDATE ' . $this->jelnname . '    SET DEBIT_AMT = DEBIT_AMT + ' . $total ['DEBIT_AMT'] . '   WHERE   JEHDR_CODE = ' . singleQuote($jeln_rec ['JEHDR_CODE']) . '   AND SEQNUM = ' . singleQuote($jeln_rec ['SEQNUM']) . '   AND DEBIT_AMT<>0   LIMIT 1';
                    ClxCommon::$db->executeQuery($sql);
                    $sql = 'UPDATE ' . $this->jelnname . '    SET CREDIT_AMT = CREDIT_AMT + ' . $total ['CREDIT_AMT'] . '   WHERE   JEHDR_CODE = ' . singleQuote($jeln_rec ['JEHDR_CODE']) . '   AND SEQNUM = ' . singleQuote($jeln_rec ['SEQNUM']) . '   AND CREDIT_AMT<>0   LIMIT 1';
                    ClxCommon::$db->executeQuery($sql);
                }
                // Limpiar cuentas de ingreso y gasto para que no incluyan
                // subcuenta
                $sql = 'UPDATE ' . $this->jelnname . ' JELN  SET JELN.CHART_FIELD03 = null  WHERE JELN.JEHDR_CODE = ' . singleQuote($jeln_rec ['JEHDR_CODE']) . '  AND EXISTS(SELECT GLAC.IDCODE   FROM ' . $this->glacname . ' GLAC   WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE   AND GLAC.GL_TYPE IN (' . singleQuoteArray(array('IN', 'EX', 'EQ')) . '))';
                ClxCommon::$db->executeQuery($sql);
                // Asignando subcuenta de efectivo
            }
			ClxCommon::$db->freeResult($results);
            //Mark Lines for delete before update
            $sql = 'DELETE FROM ' . $this->jelnname . '   WHERE JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND IS_REMOVE = 1';
            ClxCommon::$db->executeQuery($sql);
        }

        /**
         * Test is transaction is restricted
         *
         * @param String $trans_code
         */
        function fiat_is_restrictedVoid($trans_code) {
            ClxFreeReturn($this->fiat_is_restricted($trans_code));
        }

        function fiat_is_restricted($trans_code) {
            $sql = 'SELECT COUNT(FITB.ID) FROM  ' . $this->fiatname . ' FIAT,  ' . $this->fitbname . ' FITB WHERE  FIAT.TRANSTBL_CODE = FITB.IDCODE  AND FITB.RESTRICTED = 1  AND FIAT.IDCODE = ' . singleQuote($trans_code);
            return (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) ? true : false;
        }

        /**
         * Update transactions elements that could be updated
         *
         * @param Array $record
         */
        function fiat_update_restricted(&$record) {
            $trans_code = $record ['IDCODE'];
            $jehdr_code = ClxCommon::$db->getField($this->jehdname, 'IDCODE', 'TRANS_CODE = ' . singleQuote($trans_code) . '    AND JE_STATUS = ' . singleQuote('PEND') . '');
            if (empty($jehdr_code))
                return false;
            $updateRec = array();
            $sql = 'SELECT DISTINCT  A.FIELDNAME FROM  CLX_DB_TABLEFIELDS A,  CLX_DB_TABLEFIELDS B WHERE  A.FIELDNAME = B.FIELDNAME  AND A.TABLECODE = ' . singleQuote('FIAT') . '  AND B.TABLECODE = ' . singleQuote('JEHD') . '  AND A.FIELDNAME NOT IN (' . singleQuote('BATCH_ID') . ', ' . singleQuote('CDATE') . ',   ' . singleQuote('CLX_AUTH_STATUS') . ', ' . singleQuote('CREATEDBY') . ',   ' . singleQuote('ID') . ', ' . singleQuote('IDCODE') . ', ' . singleQuote('REVERSED') . ',' . singleQuote('GLACCOUNTCODE') . ', ' . singleQuote('CHART_FIELD01') . ',   ' . singleQuote('CHART_FIELD02') . ',' . singleQuote('CHART_FIELD03') . ',' . singleQuote('CHART_FIELD04') . ',   ' . singleQuote('TRANSTBL_CODE') . ')';
            $flds = ClxCommon::$db->executeQuery($sql);
            while (($fld = ClxCommon::$db->getNextRecord($flds, NUMERIC)) === true) {
                if (array_key_exists($fld [CLX_NUM_ZERO], $record))
                    $updateRec [$fld [CLX_NUM_ZERO]] = $record [$fld [CLX_NUM_ZERO]];
            }
			ClxCommon::$db->freeResult($flds);
            if (!empty($updateRec)) {
                ClxCommon::$db->updateRecord($this->jehdname, $updateRec, 'IDCODE = ' . singleQuote($jehdr_code));
            }
            // Updating lines
            $updateRec = array();
            $sql = 'SELECT DISTINCT  A.FIELDNAME FROM  CLX_DB_TABLEFIELDS A,  CLX_DB_TABLEFIELDS B WHERE  A.FIELDNAME = B.FIELDNAME  AND A.TABLECODE = ' . singleQuote('FIAT') . '  AND B.TABLECODE = ' . singleQuote('JELN') . '  AND A.FIELDNAME  NOT IN (' . singleQuote('ID') . ',' . singleQuote('ITEM_REF_NO') . ',' . singleQuote('JEHDR_CODE') . ',' . singleQuote('RECONCILIED') . ',  ' . singleQuote('CHART_FIELD01') . ', ' . singleQuote('CHART_FIELD02') . ',' . singleQuote('CHART_FIELD03') . ',' . singleQuote('CHART_FIELD04') . ')';
            $flds = ClxCommon::$db->executeQuery($sql);
            while (($fld = ClxCommon::$db->getNextRecord($flds, NUMERIC)) === true) {
                if (array_key_exists($fld [CLX_NUM_ZERO], $record))
                    $updateRec [$fld [CLX_NUM_ZERO]] = $record [$fld [CLX_NUM_ZERO]];
            }
			ClxCommon::$db->freeResult($flds);
            if (!empty($updateRec)) {
                ClxCommon::$db->updateRecord($this->jelnname, $updateRec, 'JEHDR_CODE = ' . singleQuote($jehdr_code));
            }
            return true;
        }

        /**
         * Execute bottom demand from listing jehd
         */
        function fiat_reverse_start() {
            if (!class_exists('Jehd'))
                includeCodeLib('JEHD');
            $idlist = toString(getIdlist());
            $sql = 'SELECT  JEHD.IDCODE   FROM   ' . $this->jehdname . ' JEHD,   ' . $this->fiatname . ' FIAT   WHERE   FIAT.IDCODE = JEHD.TRANS_CODE   AND JEHD.REVERSED = 0   AND (JEHD.REV_JEHDR_CODE IS NULL OR JEHD.REV_JEHDR_CODE=' . singleQuote(CLX_CHAR_EMPTY_STRING) . ')   AND FIAT.VOID = 0   AND JEHD.JE_STATUS = ' . singleQuote('AP') . '   AND FIAT.ID IN (' . $idlist . ')';
            $rs = ClxCommon::$db->executeQuery($sql);
            $jehd = new Jehd ();
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $jehd->jehd_reverse($r ['IDCODE']);
            }
			ClxCommon::$db->freeResult($rs);
        }

        /**
         * Approve transaction by batch id
         * @param unknown_type $batch_id
         */
        function fiat_approve_by_batch_id($batch_id, $validate = true) {
            $sql = 'SELECT IDCODE FROM ' . $this->fiatname . '   WHERE BATCH_ID = ' . singleQuote($batch_id) . ' AND TRANS_STATUS =' . singleQuote('PEND');
            ClxCommon::$db->executeQueryVoid($sql);
            while ((ClxCommon::$db->executeQuery($sql)) === true) {
                if (!empty($validate)) {
                    ClxFreeReturn($this->fiat_approve_by_transcode_validate($r['IDCODE']));
                } else {
                    ClxFreeReturn($this->fiat_approve_by_transcode($r['IDCODE']));
                }
            }
        }

        /**
         * Approve transaction by transaction code
         *
         * @param
         *     : string transaction code
         * @return : approval status
         */
        function fiat_approve_by_transcode($trans_code) {

            if (!defined('send_alert')) {
                define('send_alert', true); // set alerts to be sent to alerts
            }
            if (!defined('proc_fiat_jehd_approval')) {
                define('proc_fiat_jehd_approval', true); // set alerts to be sent
                // to
                // alerts
            }
            $msg = array();
            if ($this->fiat_approve_by_transcode_validate($trans_code, $msg)) {
                if (!class_exists('Jehd'))
                    includeCodeLib('JEHD');
                $jehd = new Jehd ();
                $jehd_code = $jehd->jehd_get_idcode_by_transcode($trans_code);
                $status = $jehd->jehd_approve_by_code($jehd_code);
            } else {
                $status = false;
            }
            // set transaction status back to panding
            if (empty($status)) {
                $sql = 'UPDATE ' . $this->fiatname . '  SET CLX_AUTH_STATUS = ' . singleQuote('PEND') . ',   TRANS_STATUS = ' . singleQuote('PEND') . '  WHERE IDCODE = ' . singleQuote($trans_code) . '   AND TRANS_STATUS = ' . singleQuote('OPQU');
                ClxCommon::$db->executeQuery($sql);
                addMessage($msg);
            }
            return $status;
        }

        /**
         * Performs transaction validations.
         *
         * @param string $trans_code
         * @param string $msg
         * @return boolean
         */
        function fiat_approve_by_transcode_validate($trans_code, &$msg) {
            $record = ClxCommon::$db->getRecord($this->fiatname, 'IDCODE = ' . singleQuote($trans_code));
            if (empty($record))
                return false;
            foreach ($record as $key => $val) {
                $record ['FIAT_' . $key] = $val;
                unset($record [$key]);
            }

            ClxFreeReturn($this->fiat_validate_form($record, $msg));

            return (empty($msg)) ? true : false;
        }

        /**
         * Boton de rechazo de transacion
         * @global type $db
         * @global type $idlist
         * @return type
         */
        function fiat_reject_btn(){
            $idlist = toString(getIdlist());

            if (empty($idlist)){
                return;
            }

            $err_id = $this->fiat_search_status_err();

            $sql = "SELECT FIAT.* "
                    . "FROM $this->fiatname FIAT "
                    . "WHERE FIAT.TRANS_STATUS = 'PEND' AND FIAT.ID IN (" . $idlist . ")";
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs)) {
                $this->fiat_post_autorize($r, true);
            }

            return note($err_id . dict('GEN_LBL_PROCESS_COMPLETED'));
        }

        /**
         * Verifica si transacción no se puede rechazar
         * @global type $db
         * @global type $idlist
         * @return String
         */
        function fiat_search_status_err() {
            $idlist = toString(getIdlist());

            if (empty($idlist)){
                return;
            }

            $sql = "SELECT FIAT.* "
                    . "FROM $this->fiatname FIAT "
                    . "WHERE FIAT.TRANS_STATUS <> 'PEND' AND FIAT.ID IN (" . $idlist . ")";
            $rs = ClxCommon::$db->executeQuery($sql);
            $err_id = '';
            while ($r = ClxCommon::$db->getNextRecord($rs)) {
                $err_id .= dict('GEN_LBL_ERR_REJ', $r['IDCODE']) . "<BR />";
            }

            return $err_id . "<br />";
        }

        /**
         * Events running post autorizations
         *
         * @param array $record
         * @param bool $reject
         * @return boolean
         */
        function fiat_post_autorize(&$record, $reject = false) {
            if (UserRequest::$request ['ac'] === 'DELETE')
                return true;
            if (empty($reject)) {
                if (!class_exists('Gloq'))
                    includeCodeLib('GLOQ');
                $gloq = new Gloq ();
                $gloq->pushFiatListing($record ['IDCODE']);
                if(!empty($this->ceocname)){
                    $sql = 'UPDATE ' . $this->ceocname . ' CEOC  SET CEOC.STATUS_CEOC = IF(CEOC.STATUS_CEOC = ' . singleQuote('PAG') . ', ' . singleQuote('PAGP') . ', CEOC.STATUS_CEOC) WHERE (CEOC.TRANS_CODE = ' . singleQuote($record['IDCODE']) . ' || CEOC.REV_TRANS_CODE = ' . singleQuote($record['IDCODE']) . ')';
                    ClxCommon::$db->executeQueryVoid($sql);
                }
            } else {
                ClxCommon::$db->updateRecord($this->fiatname, array('TRANS_STATUS' => 'REJ', 'CLX_AUTH_STATUS' => 'REJ'), 'IDCODE = ' . singleQuote($record ['IDCODE']));
                ClxCommon::$db->updateRecord($this->jehdname, array('JE_STATUS' => 'REJ', 'CLX_AUTH_STATUS' => 'REJ'), 'TRANS_CODE = ' . singleQuote($record ['IDCODE']));
            }
            return true;
        }

        /**
         * Transaction Details report
         *
         * @return string
         */
        function fiat_details() {
            $contents = '';
            $DBFL = &getTool('DBFL');
            $fls = array('CHART_FIELD01' => '', 'TRANSTBL_CODE' => '', 'GLACCOUNTCODE' => '', 'JEHDR_CODE' => '', 'DEBIT_AMT' => '', 'CREDIT_AMT' => '', 'IDENTIFICATION' => '', 'ITEM_CODE' => '', 'ACCOUNTCODE' => '', 'EFFTDATE' => '', 'IDCODE' => '', 'REVERSED' => '', 'CLX_AUTH_STATUS' => '', 'IS_BALANCE' => '', 'DEBIT_TRANS_AMT' => '', 'CREDIT_TRANS_AMT' => '', 'EXCHANGE_RT' => '');
            foreach ($fls as $key => $val) {
                $f = $DBFL->getField($key);
                $fls [$key] = dict($f ['FIELDLISTLABEL']);
            }
            unset($f);
            $idlist = getIdlist();
            foreach ($idlist as $key => $val) {
                $table = new htmlTable(CLX_WIDTH_EIGHT);
                $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_ALIGN => 'center'));
                $table->addCell(dict('CODE_LBL_TRANSACTIONDETAILREPORT'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_EIGHT));
                $table->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_EIGHT));
                $DBLT = &getTool('DBLT');
                // Trasaction Information
                $sql = 'SELECT  FIAT.IDCODE, FIAT.IDNAME, FIAT.EFFTDATE,  FICO.CONTRACT_NUMBER,  FICO.IDCODE CONTRACT_CODE, FICO.IDNAME CONTRACT_NAME,  FITB.IDCODE TRANSTBL_CODE, FITB.IDNAME TRANSTBL_NAME,  FIAT.REV_TRANS_CODE,  ACCO.IDCODE BENEFICIARY_CODE, ACCO.IDNAME BENEFICIARY_NAME,  ACCO.IDENTIFICATION,  FIAT.BENEFICIARY_NAME BENEFICIARY_NAME_NOACCO,  FIAT.IDENTIFICATION IDENTIFICATION_NOACCO,  FIAT.VOID REVERSED,  FIAT.CLX_AUTH_STATUS,  JEHD.JE_STATUS  FROM ' . $this->fitbname . ' FITB,  ' . $this->ficoname . ' FICO,  ' . $this->fiatname . ' FIAT  LEFT JOIN ' . $this->jehdname . ' JEHD   ON JEHD.TRANS_CODE = FIAT.IDCODE  LEFT JOIN ' . $this->acconame . ' ACCO  ON FIAT.CHART_FIELD02 = ACCO.IDCODE  WHERE FIAT.CHART_FIELD01 = FICO.IDCODE  AND FITB.IDCODE = FIAT.TRANSTBL_CODE  AND FIAT.ID =' . singleQuote($val);
                $transres = ClxCommon::$db->executeQuery($sql);
                $transrec = ClxCommon::$db->getNextRecord($transres);
				ClxCommon::$db->freeResult($transres);
                $table->addCell($fls ['IDCODE'], array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
                $table->addCell($transrec ['IDCODE'] . ', ' . $transrec ['IDNAME'], array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_EIGHT - CLX_NUM_THREE));
                $table->addCell($fls ['EFFTDATE'], array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
                $table->addCell($transrec ['EFFTDATE'], array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_EIGHT - CLX_NUM_THREE));
                $table->addCell($fls ['TRANSTBL_CODE'], array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
                $table->addCell($transrec ['TRANSTBL_CODE'] . ', ' . $transrec ['TRANSTBL_NAME'], array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_EIGHT - CLX_NUM_THREE));
                $table->addCell($fls ['CHART_FIELD01'], array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
                $table->addCell($transrec ['CONTRACT_NUMBER'] . ', ' . $transrec ['CONTRACT_NAME'] . ' (' . $transrec ['CONTRACT_CODE'] . ')', array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_EIGHT - CLX_NUM_THREE));
                $table->addCell($fls ['REVERSED'], array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
                $table->addCell(($transrec ['REVERSED'] == CLX_NUM_ONE) ? dict('GEN_LBL_YES') : dict('GEN_LBL_NO'), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_EIGHT - CLX_NUM_THREE));
                $table->addCell($fls ['CLX_AUTH_STATUS'], array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
                $table->addCell($DBLT->getListItem('AUTH', $transrec ['CLX_AUTH_STATUS']), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_EIGHT - CLX_NUM_THREE));
                $table->addCell(dict('GEN_LBL_BENEFICIARIES'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_EIGHT));
                $table->addCells(CLX_CLASS_HEADERS, array($fls ['ACCOUNTCODE']));
                if (!empty($transrec ['BENEFICIARY_CODE'])) {
                    $table->addCell($transrec ['BENEFICIARY_CODE'] . ',' . $transrec ['BENEFICIARY_NAME'], array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_NUM_FOUR));
                    $table->addCell($fls ['IDENTIFICATION'], array(CLX_PROP_CLASS => CLX_CLASS_HEADERS));
                    $table->addCell($transrec ['IDENTIFICATION'], array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_NUM_FOUR));
                } else {
                    $table->addCell($transrec ['BENEFICIARY_NAME_NOACCO'], array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_NUM_FOUR));
                    $table->addCell($fls ['IDENTIFICATION'], array(CLX_PROP_CLASS => CLX_CLASS_HEADERS));
                    $table->addCell($transrec ['IDENTIFICATION_NOACCO'], array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_NUM_FOUR));
                }
                $table->addCell(dict('GEN_LBL_ACCOUNTING'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_EIGHT));
                if (empty($transrec ['JE_STATUS'])) {
                    $table->addCell(dict('GEN_LBL_NORECORDFOUND'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_EIGHT));
                } else {
                    if (!empty($transrec ['REV_TRANS_CODE'])) {
                        $revcc = 'AND JEHD.TRANS_CODE   IN (' . singleQuote($transrec ['IDCODE']) . ',   ' . singleQuote($transrec ['REV_TRANS_CODE']) . ')';
                    } else {
                        $revcc = 'AND JEHD.TRANS_CODE = ' . singleQuote($transrec ['IDCODE']);
                    }
                    // Transaction Accounting
                    $sql = 'SELECT JELN.CURRENCY_CODE, JELN.EXCHANGE_RT, SUM(JELN.DEBIT_TRANS_AMT) DEBIT_TRANS_AMT, SUM(JELN.CREDIT_TRANS_AMT) CREDIT_TRANS_AMT, SUM(JELN.DEBIT_AMT) DEBIT_AMT, SUM(JELN.CREDIT_AMT) CREDIT_AMT, JELN.GLACCOUNTCODE, JEHD.IDCODE, JELN.JEHDR_CODE, JELN.ITEM_CODE, JEIT.IDNAME ITEM_NAME, GLAC.IDNAME GLNAME FROM ' . $this->fiatname . ' FIAT, ' . $this->jehdname . ' JEHD, ' . $this->glacname . ' GLAC, ' . $this->glcpname . ' GLCP, ' . $this->jelnname . ' JELN LEFT JOIN ' . $this->jeitname . ' JEIT  ON JELN.ITEM_CODE = JEIT.IDCODE  AND JEIT.CLX_EFFTDATE = (  SELECT  MAX(X.CLX_EFFTDATE)  FROM  ' . $this->jeitname . ' X  WHERE  X.IDCODE = JEIT.IDCODE  /* AND X.CLX_EFFTDATE<=JEHD.EFFTDATE */) WHERE JELN.JEHDR_CODE = JEHD.IDCODE AND FIAT.IDCODE = JEHD.TRANS_CODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLCP.COMP_CODE = JEHD.COMP_CODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND FIAT.ID =' . singleQuote($val) . ' ' . $revcc . ' GROUP BY JELN.CURRENCY_CODE, JELN.EXCHANGE_RT, JELN.GLACCOUNTCODE, JEHD.IDCODE, JELN.JEHDR_CODE, JELN.ITEM_CODE, JEIT.IDNAME ORDER BY JELN.DEBIT_AMT DESC,  JELN.CREDIT_AMT DESC';
                    $results = ClxCommon::$db->executeQuery($sql);
                    $table->addCells(CLX_CLASS_HEADERS, array($fls ['JEHDR_CODE'], $fls ['GLACCOUNTCODE'], $fls ['ITEM_CODE'], $fls ['DEBIT_TRANS_AMT'], $fls ['CREDIT_TRANS_AMT'], $fls ['EXCHANGE_RT'], $fls ['DEBIT_AMT'], $fls ['CREDIT_AMT']));
                    $total_debits = '0';
                    $total_credits = '0';
                    while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                        $table->addCell($result ['JEHDR_CODE'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                        $table->addCell($result ['GLACCOUNTCODE'] . ', ' . $result ['GLNAME'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                        $table->addCell($result ['ITEM_NAME'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                        $table->addCell(xFormat::number($result ['DEBIT_TRANS_AMT']), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                        $table->addCell(xFormat::number($result ['CREDIT_TRANS_AMT']), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                        $table->addCell(xFormat::number($result ['EXCHANGE_RT'], CLX_NUM_FIVE), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                        $table->addCell(xFormat::number($result ['DEBIT_AMT']), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                        $table->addCell(xFormat::number($result ['CREDIT_AMT']), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                        $total_debits = bcadd($total_debits, $result ['DEBIT_AMT']);
                        $total_credits = bcadd($total_credits, $result ['CREDIT_AMT']);
                    }
					ClxCommon::$db->freeResult($results);
                    $table->addCells(CLX_CLASS_HEADERS, array('', $fls ['IS_BALANCE'], '', '', '', ($total_debits == $total_credits) ? dict('GEN_LBL_YES') : dict('GEN_LBL_NO'), xFormat::number($total_debits), xFormat::number($total_credits)));
                } // end je status
                $contents .= $table->source() . '<br>';
            }
            return $contents;
        }

        /**
         * Builds bank account item on contract
         *
         * @param array $record
         */
        function fiat_build_fibk_fias(&$record) {
            if (empty($record ['FIDU_BANKACT_CODE']) || $record ['FIDU_BANKACT_CODE'] === 'null')
                return;
            $sql = 'SELECT FIAS.IDCODE FROM ' . $this->fiasname . ' FIAS WHERE FIAS.FIDU_BANKACT_CODE = ' . singleQuote($record ['FIDU_BANKACT_CODE']) . ' AND FIAS.CONTRACT_CODE = ' . singleQuote($record ['CHART_FIELD01']);
            $result = ClxCommon::$db->getOne($sql);
            if (!empty($result)) {
                if ($record ['CHART_FIELD03'] === 'null' || empty($record ['CHART_FIELD03'])) {
                    ClxCommon::$db->updateRecord($this->fiatname, array('CHART_FIELD03' => $result), 'IDCODE = ' . singleQuote($record ['IDCODE']));
                    $record ['CHART_FIELD03'] = $result;
                }
            } else {
                // create fias
                if (!class_exists('Fias'))
                    includeCodeLib('FIAS');
                $fias = new Fias ();
                $sql = 'SELECT  BANK_ACCOUNT_NO FIDU_BANKACT_CODE,  BANK_ACCOUNT_NO EXT_PRODUCT_CODE,  ' . singleQuote('AS') . ' GL_TYPE,  ' . singleQuote('CA') . ' TRUST_ITEM_TYPE,  CONTRACT_CODE, IDNAME, CURRENCY_CODE  FROM ' . $this->fibkname . ' WHERE BANK_ACCOUNT_NO = ' . singleQuote($record ['FIDU_BANKACT_CODE']);
                $fiasrec = ClxCommon::$db->getOneRecord($sql);
                $fiasrec ['CONTRACT_CODE'] = $record ['CHART_FIELD01'];
                $fias->fias_build($fiasrec);
                if ($record ['CHART_FIELD03'] === 'null' || empty($record ['CHART_FIELD03'])) {
                    $record ['CHART_FIELD03'] = $fiasrec ['IDCODE'];
                    ClxCommon::$db->updateRecord($this->fiatname, array('CHART_FIELD03' => $record ['CHART_FIELD03']), 'IDCODE = ' . singleQuote($record ['IDCODE']));
                }
                unset($fias, $fiasrec);
            }
            // Creating Transfer cash subaccount
            if (ClxCommon::$db->countRecords($this->fitbname, 'IDCODE=' . singleQuote($record ['TRANSTBL_CODE']), 'IS_TRANSFER=1') == CLX_NUM_ZERO)
                return;
            if (empty($record ['BANKAC_CODE']) || $record ['BANKAC_CODE'] === 'null')
                return;
            $sql = 'SELECT FIAS.IDCODE FROM ' . $this->fiasname . ' FIAS WHERE FIAS.FIDU_BANKACT_CODE = ' . singleQuote($record ['BANKAC_CODE']) . ' AND FIAS.CONTRACT_CODE = ' . singleQuote($record ['CHART_FIELD01']);
            $result = ClxCommon::$db->getOne($sql);
            if (!empty($result)) {
                // setting secundary sub account
                ClxCommon::$db->updateRecord($this->fiatname, array('CHART_FIELD03' => $result), 'IDCODE = ' . singleQuote($record ['IDCODE']));
                $record ['CHART_FIELD03'] = $result;
            } else {
                // create fias
                if (!class_exists('Fias'))
                    includeCodeLib('FIAS');
                $fias = new Fias ();
                $sql = 'SELECT  BANK_ACCOUNT_NO FIDU_BANKACT_CODE, BANK_ACCOUNT_NO EXT_PRODUCT_CODE,  ' . singleQuote('AS') . ' GL_TYPE,  ' . singleQuote('CA') . ' TRUST_ITEM_TYPE,  CONTRACT_CODE,  IDNAME,                       CURRENCY_CODE  FROM   ' . $this->fibkname . '  WHERE   BANK_ACCOUNT_NO = ' . singleQuote($record ['BANKAC_CODE']);
                $fiasrec = ClxCommon::$db->getOneRecord($sql);
                $fiasrec ['CONTRACT_CODE'] = $record ['CHART_FIELD01'];
                $fias->fias_build($fiasrec);
                $record ['CHART_FIELD03'] = $fiasrec ['IDCODE'];
                ClxCommon::$db->updateRecord($this->fiatname, array('CHART_FIELD03' => $record ['CHART_FIELD03']), 'IDCODE = ' . singleQuote($record ['IDCODE']));
                unset($fias, $fiasrec);
            }
        }

// end mehod
        // CREDIT RELATED METHODS
        /**
         * Builds default form elements on credit transactions
         *
         * @param array $record
         */
        private function init_credit_defaults(&$record) {
            if (empty($this->filoname)) {
                return;
            }
            if (strpos($record ['FIAT_TRANSTBL_CODE'], 'SYS_CRED') === false && (UserRequest::$request['ac'] === 'MODIFY' || UserRequest::$request['ac'] === 'DUPLICATE')) {
                return;
            }
            $mod = ClxCommon::$db->getField($this->fitbname, 'MODULECODE', 'IDCODE = ' . singleQuote($record ['FIAT_TRANSTBL_CODE']));
            if (!class_exists('Filo')) {
                includeCodeLib('FILO');
            }
            $filo = new Filo ();
            if ($mod !== 'CRED') {
                return; // means its not credit
            } elseif (empty($record ['FIAT_LOAN_CODE'])) {

                if (!empty(UserRequest::$request ['li']) && UserRequest::$request ['li'] === 'FIAT_CRED_D_SRCH' && empty($record ['FIAT_CHART_FIELD03']) && UserRequest::$request['ac'] === 'CREATE') {
                    // send user tu adjustmnet
                    header('location: tool.php?to=EDIT&ac=CODE&it=FIAT_CRED_DISB');
                    salir();
                }
                if (!empty(UserRequest::$request ['li']) && UserRequest::$request ['li'] === 'FIAT_CRED_P_SRCH' && empty($record ['FIAT_CHART_FIELD03']) && UserRequest::$request['ac'] === 'CREATE') {
                    // send user tu adjustmnet
                    header('location: tool.php?to=EDIT&ac=CODE&it=FIAT_CRED_PAY');
                    salir();
                }
                if (!empty(UserRequest::$request ['li']) && UserRequest::$request ['li'] === 'FIAT_CRED_SRCH' && empty($record ['FIAT_CHART_FIELD03']) && UserRequest::$request['ac'] === 'CREATE') {
                    // send user tu adjustmnet
                    header('location: tool.php?to=EDIT&ac=CODE&it=FIAT_CRED_ADJ');
                    salir();
                }
                $record ['FIAT_LOAN_CODE'] = $filo->get_loan_code_by_fias($record ['FIAT_CHART_FIELD03']);
            }
            $prlt = $filo->get_cred_parameters($record ['FIAT_LOAN_CODE']);
            unset($filo);
            // Setting transaction code
            if (empty($record ['FIAT_TRANSTBL_CODE'])) {
                $sql = 'SELECT IDCODE, IDNAME  FROM ' . $this->fitbname . '   WHERE IDCODE = ' . singleQuote('SYS_CRED-PYMT');
                $r = ClxCommon::$db->getOneRecord($sql);
                UserRequest::$post ['FIAT_TRANSTBL_CODE'] = $r ['IDCODE'];
                UserRequest::$post ['FIAT_TRANSTBL_CODE_prim'] = $r ['IDCODE'];
                UserRequest::$post ['FIAT_TRANSTBL_CODE_secd'] = $r ['IDNAME'];
                $record ['FIAT_TRANSTBL_CODE'] = $r ['IDCODE'];
                $record ['FIAT_TRANSTBL_CODE_prim'] = $r ['IDCODE'];
                $record ['FIAT_TRANSTBL_CODE_secd'] = $r ['IDNAME'];
            }
            // Load default values for chart fields
            $sql = 'SELECT  COMP.IDCODE COMP_CODE,  COMP.IDNAME COMP_NAME,  FIAS.CONTRACT_CODE CHART_FIELD01,  FICO.CONTRACT_NUMBER CHART_FIELD01_prim,  FICO.IDNAME CHART_FIELD01_secd,  FIAS.IDCODE CHART_FIELD03,  FIAS.IDCODE CHART_FIELD03_prim,  FIAS.IDNAME CHART_FIELD03_secd FROM  ' . $this->compname . ' COMP,  ' . $this->fiasname . ' FIAS,  ' . $this->ficoname . ' FICO WHERE  FICO.COMP_CODE = COMP.IDCODE  AND FICO.IDCODE = FIAS.CONTRACT_CODE  AND FIAS.LOAN_CODE = ' . singleQuote($record ['FIAT_LOAN_CODE']) . '  AND ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' <> ' . singleQuote($record ['FIAT_LOAN_CODE']);
            $r = ClxCommon::$db->getOneRecord($sql);
            if (empty($record ['COMP_COMP_CODE_prim'])) {
                UserRequest::$post ['FIAT_COMP_CODE_prim'] = $r ['COMP_CODE'];
                UserRequest::$post ['FIAT_COMP_CODE_secd'] = $r ['COMP_NAME'];
                $record ['FIAT_COMP_CODE_prim'] = $r ['COMP_CODE'];
                $record ['FIAT_COMP_CODE_secd'] = $r ['COMP_NAME'];
            }
            if (empty($record ['FIAT_CHART_FIELD01'])) {
                UserRequest::$post ['FIAT_CHART_FIELD01'] = $r ['CHART_FIELD01'];
                UserRequest::$post ['FIAT_CHART_FIELD01_prim'] = $r ['CHART_FIELD01_prim'];
                UserRequest::$post ['FIAT_CHART_FIELD01_secd'] = $r ['CHART_FIELD01_secd'];
                $record ['FIAT_CHART_FIELD01'] = $r ['CHART_FIELD01'];
                $record ['FIAT_CHART_FIELD01_prim'] = $r ['CHART_FIELD01_prim'];
                $record ['FIAT_CHART_FIELD01_secd'] = $r ['CHART_FIELD01_secd'];
            } // end if loancode
            if (empty($record ['FIAT_CHART_FIELD03'])) {
                UserRequest::$post ['FIAT_CHART_FIELD03'] = $r ['CHART_FIELD03'];
                UserRequest::$post ['FIAT_CHART_FIELD03_prim'] = $r ['CHART_FIELD03_prim'];
                UserRequest::$post ['FIAT_CHART_FIELD03_secd'] = $r ['CHART_FIELD03_secd'];
                $record ['FIAT_CHART_FIELD03'] = $r ['CHART_FIELD03'];
                $record ['FIAT_CHART_FIELD03_prim'] = $r ['CHART_FIELD03_prim'];
                $record ['FIAT_CHART_FIELD03_secd'] = $r ['CHART_FIELD03_secd'];
            } // end if loancode
            // Load default values for chart fields
            $sql = 'SELECT  ACCO.IDCODE CHART_FIELD02,  ACCO.IDCODE CHART_FIELD02_prim,  ACCO.IDNAME CHART_FIELD02_secd,  ACCO.IDENTIFICATION CHART_FIELD02_terc FROM  ' . $this->fiasname . ' FIAS,  ' . $this->ficoname . ' FICO,  ' . $this->fipaname . ' FIPA,  ' . $this->acconame . ' ACCO WHERE  FICO.IDCODE = FIAS.CONTRACT_CODE  AND FIPA.CONTRACT_CODE = FICO.IDCODE  AND ACCO.IDCODE = FIPA.ACCOUNTCODE  AND FIPA.PARTICIPANT_TYPE IN (' . singleQuoteArray(array('F', 'B', 'G', 'M', 'MB')) . ')  AND FIAS.LOAN_CODE = ' . singleQuote($record ['FIAT_LOAN_CODE']) . '  AND ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' <> ' . singleQuote($record ['FIAT_LOAN_CODE']) . ' ORDER BY FIPA.ISPRIMARY DESC ';
            $r = ClxCommon::$db->getOneRecord($sql);
            if (empty($record ['FIAT_CHART_FIELD02'])) {
                UserRequest::$post ['FIAT_CHART_FIELD02'] = $r ['CHART_FIELD02'];
                UserRequest::$post ['FIAT_CHART_FIELD02_prim'] = $r ['CHART_FIELD02_prim'];
                UserRequest::$post ['FIAT_CHART_FIELD02_secd'] = $r ['CHART_FIELD02_secd'];
                UserRequest::$post ['FIAT_CHART_FIELD02_terc'] = $r ['CHART_FIELD02_terc'];
                $record ['FIAT_CHART_FIELD02'] = $r ['CHART_FIELD02'];
                $record ['FIAT_CHART_FIELD02_prim'] = $r ['CHART_FIELD02_prim'];
                $record ['FIAT_CHART_FIELD02_secd'] = $r ['CHART_FIELD02_secd'];
                $record ['FIAT_CHART_FIELD02_terc'] = $r ['CHART_FIELD02_terc'];
            } // end if loancode
            // Adding Payment Sequence
            $payseq = array();
            $payseq [$prlt ['PAY_SEQNO_PRO']] = 'PAY_SEQNO_PRO';
            $payseq [$prlt ['PAY_SEQNO_AR']] = 'PAY_SEQNO_AR';
            $payseq [$prlt ['PAY_SEQNO_FEE_01']] = 'PAY_SEQNO_FEE_01';
            $payseq [$prlt ['PAY_SEQNO_FEE_02']] = 'PAY_SEQNO_FEE_02';
            $payseq [$prlt ['PAY_SEQNO_FEE_03']] = 'PAY_SEQNO_FEE_03';
            $payseq [$prlt ['PAY_SEQNO_FEE_04']] = 'PAY_SEQNO_FEE_04';
            $payseq [$prlt ['PAY_SEQNO_FEE_05']] = 'PAY_SEQNO_FEE_05';
            ksort($payseq);
            $record ['FIAT_PAY_SEQUENCE'] = implode(',', $payseq);
            // Adding loan code if not exists
            if (array_key_exists('FIAT_LOAN_CODE', $record) && array_key_exists('FIAT_EFFTDATE', $record)) {
                // Including loan information from chartfield if exists SYS-CRED
                // used on credit module
                $sql = 'SELECT  FILO.IDCODE,  FILO.IDNAME,  FILO.DEBTOR_CODE BENEFICIARY_CODE,  FILO.PRODUCT_CODE,  FILO.FEE_01_RATE,  FILO.FEE_02_RATE,  FILO.FEE_03_RATE,  FILO.FEE_04_RATE,  FILO.FEE_05_RATE  FROM  ' . $this->filoname . ' FILO,  ' . $this->fiasname . ' FIAS  WHERE  FILO.IDCODE = FIAS.LOAN_CODE  AND FIAS.IDCODE = ' . singleQuote($record ['FIAT_CHART_FIELD03']) . '  AND FILO.CLX_EFFTDATE =   (SELECT MAX(F.CLX_EFFTDATE)   FROM ' . $this->filoname . ' F   WHERE F.IDCODE = FILO.IDCODE   AND F.CLX_EFFTDATE <= NOW())';
                $lrec = ClxCommon::$db->getOneRecord($sql);
                $record ['FIAT_LOAN_CODE'] = $lrec ['IDCODE'];
                $record ['FIAT_LOAN_CODE_prim'] = $lrec ['IDCODE'];
                $record ['FIAT_LOAN_CODE_secd'] = $lrec ['IDNAME'];
                // Setting amoutn and rates for information
                $record ['FIAT_FEE_01_RATE'] = $lrec ['FEE_01_RATE'];
                $record ['FIAT_FEE_02_RATE'] = $lrec ['FEE_02_RATE'];
                $record ['FIAT_FEE_03_RATE'] = $lrec ['FEE_03_RATE'];
                $record ['FIAT_FEE_04_RATE'] = $lrec ['FEE_04_RATE'];
                $record ['FIAT_FEE_05_RATE'] = $lrec ['FEE_05_RATE'];
            }

            // Adding credit bank account
            if (UserRequest::$request['ac'] === 'CODE') { // On transaction init
                if (empty($record ['FIAT_BENEFICIARY_CODE'])) {
                    $sql = 'SELECT ACCO.IDCODE, ACCO.IDNAME, ACCO.IDENTIFICATION  FROM ' . $this->acconame . ' ACCO, ' . $this->filoname . ' FILO  WHERE ACCO.IDCODE = FILO.DEBTOR_CODE   AND FILO.IDCODE = ' . singleQuote($record ['FIAT_LOAN_CODE']);
                    $benef = ClxCommon::$db->getOneRecord($sql);
                    if (!empty($benef)) {
                        $record ['FIAT_BENEFICIARY_CODE'] = $benef ['IDCODE'];
                        $record ['FIAT_BENEFICIARY_CODE_prim'] = $benef ['IDCODE'];
                        $record ['FIAT_BENEFICIARY_CODE_secd'] = $benef ['IDNAME'];
                        $record ['FIAT_BENEFICIARY_CODE_terc'] = $benef ['IDENTIFICATION'];
                    }
                    unset($benef);
                }
                // Adding currency code
                $sql = 'SELECT MAX(FILO.CURRENCY_CODE)  FROM ' . $this->filoname . ' FILO  WHERE FILO.IDCODE = ' . singleQuote($lrec ['IDCODE']);
                $record ['FIAT_CURRENCY_CODE'] = ClxCommon::$db->getOne($sql);
                // Adding exchange rate
                if (!class_exists('Comp'))
                    includeCodeLib('COMP');
                $comp = new Comp ();
                $xrate = $comp->comp_current_exchange($record ['FIAT_COMP_CODE'], $record ['FIAT_CURRENCY_CODE'], $record ['FIAT_EFFTDATE']);
                $record ['FIAT_EXCHANGE_RT'] = $xrate ['EXCHANGE_RT'];
                $record ['FIAT_CUR_OPERATOR'] = $xrate ['CUR_OPERATOR'];
                unset($comp, $xrate);
                // bank account information
                $sql = 'SELECT  FIBK.BANK_ACCOUNT_NO,  FIBK.IDNAME  FROM  ' . $this->fibkname . ' FIBK,  ' . $this->filoname . ' FILO,  ' . $this->prodname . ' PROD,  ' . $this->prodname . ' PROD2  WHERE  FILO.PRODUCT_CODE = PROD.IDCODE  AND FIBK.BANK_PROD_CODE = PROD2.IDCODE  AND FIBK.COMP_CODE = FILO.COMP_CODE  AND FIBK.CURRENCY_CODE = FILO.CURRENCY_CODE  AND FILO.IDCODE = ' . singleQuote($record ['FIAT_LOAN_CODE']) . '  AND FILO.COMP_CODE = ' . singleQuote($record ['FIAT_COMP_CODE']) . '  AND FILO.PAY_BANKACT_NO = FIBK.BANK_ACCOUNT_NO  LIMIT 1';
                $r2 = ClxCommon::$db->getOneRecord($sql);
                $record ['FIAT_FIDU_BANKACT_CODE'] = $r2 ['BANK_ACCOUNT_NO'];
                $record ['FIAT_FIDU_BANKACT_CODE_prim'] = $r2 ['BANK_ACCOUNT_NO'];
                $record ['FIAT_FIDU_BANKACT_CODE_secd'] = $r2 ['IDNAME'];
            }
            // Adding credit payment balances and Payment detail
            $sql = 'SELECT  FILO.COMP_CODE,  FILO.IDCODE LOAN_CODE,  FILO.CLX_EFFTDATE,  FILO.CRED_PAY_METHOD,  FILO.LOAN_AMT,  FILO.PRINCIPAL_BAL,  (FILO.LOAN_AMT-FILO.PRINCIPAL_BAL) AVAILABLE_AMT,  FILO.LOAN_INTEREST,  FILO.NO_PAYMENTS,  FILO.LOAN_PERIOD,  FILO.INTEARNED_AMT,  FILO.INTPAID_AMT,  FILO.RESERVE_AMT,  (FILO.INTEARNED_AMT-FILO.INTPAID_AMT) INTEREST_AMT,  IFNULL((SELECT  SUM(GDVW.DEBIT_TRANS_AMT-GDVW.CREDIT_TRANS_AMT) BALANCE_AMT  FROM  ' . $this->gdvwname . ' GDVW,  ' . $this->pratname . ' PRAT  WHERE   PRAT.PRODUCT_CODE = PRLT.PRODUCT_CODE   AND GDVW.CHART_FIELD03 = FIAS.IDCODE   AND PRAT.PROD_STATUS = FILO.LOAN_STATUS   AND FILO.CURRENCY_CODE = GDVW.CURRENCY_CODE  AND GDVW.GLACCOUNTCODE = PRAT.CINT_GL_CODE),0) INTEREST_CONT,  FILO.FEE_01_AMT,  FILO.FEE_02_AMT,  FILO.FEE_03_AMT,  FILO.FEE_04_AMT,  FILO.FEE_05_AMT,  FILO.DEDUCTIBLE_AMT,  0 INSTALLMENT_CUR,  0 PRINCIPAL_CUR,  0 INTEREST_CUR,  0 RESERVE_CUR,  0 INSTALLMENT_PRE,  0 PRINCIPAL_PRE,  0 INTEREST_PRE,  0 RESERVE_PRE,  PRLT.SIMPLE_INTEREST FROM  ' . $this->prltname . ' PRLT,  ' . $this->filoname . ' FILO,  ' . $this->fiasname . ' FIAS WHERE  PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE  AND FIAS.LOAN_CODE = FILO.IDCODE  AND FILO.CLX_EFFTDATE =  (SELECT MAX(X.CLX_EFFTDATE)  FROM ' . $this->filoname . ' X  WHERE X.IDCODE = FILO.IDCODE  AND X.CLX_EFFTDATE<=' . singleQuote($this->today) . ')  AND FILO.IDCODE = ' . singleQuote($record ['FIAT_LOAN_CODE']);
            $r = ClxCommon::$db->getOneRecord($sql);
            if (empty($r))
                $r = array();
            // Search Current Installment Information
            $sql = 'SELECT   MAX(FILS.INSTALLMENT_NO) INSTALLMENT_NO_CUR,   0 INSTALLMENT_CUR,   0 PRINCIPAL_CUR,   0 INTEREST_CUR,   0 RESERVE_CUR,   0 FEES_CUR,   0 LATEF_CUR,   0 INSTALLMENT_NO_PRE,   SUM((FILS.PRINCIPAL_PAY+ FILS.BALLOON_PAY_AMT-FILS.PPAL_PAID_AMT)+(FILS.INTEREST_PAY-FILS.INTPAID_AMT)) INSTALLMENT_PRE,   SUM(FILS.PRINCIPAL_PAY+ FILS.BALLOON_PAY_AMT -FILS.PPAL_PAID_AMT) PRINCIPAL_PRE,   SUM(FILS.INTEREST_PAY-FILS.INTPAID_AMT) INTEREST_PRE,   SUM(FILS.RESERVE_PAY) RESERVE_PRE,   0 FEES_PRE,   0 LATEF_PRE  FROM   ' . $this->filoname . ' FILO,   ' . $this->filsname . ' FILS  WHERE  FILO.IDCODE = FILS.LOAN_CODE  AND FILO.CLX_EFFTDATE = FILS.EFFTDATE  /*AND FILS.PERIOD_END_DATE < ' . singleQuote($record ['FIAT_EFFTDATE']) . '*/  AND FILS.PERIOD_START_DATE <= ' . singleQuote($record ['FIAT_EFFTDATE']) . '  AND FILO.CLX_EFFTDATE =   (SELECT MAX(X.CLX_EFFTDATE)   FROM ' . $this->filoname . ' X   WHERE X.IDCODE = FILO.IDCODE    AND X.CLX_EFFTDATE<=' . singleQuote($this->today) . ')  AND FILO.IDCODE = ' . singleQuote($record ['FIAT_LOAN_CODE']);
            // ADVANCE_PAID_AMT
            $r2 = ClxCommon::$db->getOneRecord($sql);
            if (!empty($r2)) {
                $r = array_merge($r, $r2);
            }
            //Adding Fee Amount
            $sql = 'SELECT   IFNULL(FILS.FEES_AMT,0)  FROM   ' . $this->filoname . ' FILO,   ' . $this->filsname . ' FILS  WHERE  FILO.IDCODE = FILS.LOAN_CODE  AND FILO.CLX_EFFTDATE = FILS.EFFTDATE  AND FILS.PERIOD_END_DATE < ' . singleQuote($record ['FIAT_EFFTDATE']) . '  AND FILO.CLX_EFFTDATE =   (SELECT MAX(X.CLX_EFFTDATE)   FROM ' . $this->filoname . ' X   WHERE X.IDCODE = FILO.IDCODE    AND X.CLX_EFFTDATE<=' . singleQuote($this->today) . ')  AND FILO.IDCODE = ' . singleQuote($record ['FIAT_LOAN_CODE']) . '  ORDER BY FILS.ID DESC  LIMIT 1';
            $r['FEES_PRE'] = ClxCommon::$db->getOne($sql);
            // setting due interest amount based in interest
            //Revisar el monto de cuotas vencidas si es interes simple ya que no aparece en saldo vencido el monto.
            if (!empty($r)) {
                if (!array_key_exists('PRINCIPAL_CUR', $r))
                    $r ['PRINCIPAL_CUR'] = CLX_INIT_ZERO;
                if (!array_key_exists('INTEREST_CUR', $r))
                    $r ['INTEREST_CUR'] = CLX_INIT_ZERO;
                if (!array_key_exists('AVAILABLE_AMT', $r))
                    $r ['AVAILABLE_AMT'] = CLX_INIT_ZERO;
                if (!array_key_exists('PRINCIPAL_BAL', $r))
                    $r ['PRINCIPAL_BAL'] = CLX_INIT_ZERO;
                if (!array_key_exists('INTEREST_AMT', $r))
                    $r ['INTEREST_AMT'] = CLX_INIT_ZERO;
                if (!array_key_exists('INTEREST_CONT', $r))
                    $r ['INTEREST_CONT'] = CLX_INIT_ZERO;
                if (!array_key_exists('INSTALLMENT_PRE', $r))
                    $r ['INSTALLMENT_PRE'] = CLX_INIT_ZERO;
                $r ['INSTALLMENT_CUR'] = rounder($r ['PRINCIPAL_CUR'] + $r ['INTEREST_CUR'], CLX_NUM_TWO);
                // Balances section
                $record ['FIAT_AVAILABLE_AMT'] = no_format($r ['AVAILABLE_AMT'], CLX_NUM_TWO);
                $record ['FIAT_PRINCIPAL_BAL'] = no_format($r ['PRINCIPAL_BAL'], CLX_NUM_TWO);
                $record ['FIAT_INTEREST_AMT'] = no_format($r ['INTEREST_AMT'], CLX_NUM_TWO);
                $record ['FIAT_INTEREST_CUR'] = no_format($r ['INTEREST_CUR'], CLX_NUM_TWO);
                $record ['FIAT_PRINCIPAL_CUR'] = no_format(($r ['INSTALLMENT_CUR'] - $r ['INTEREST_CUR']), CLX_NUM_TWO);
                $record ['FIAT_INSTALLMENT_CUR'] = no_format($r ['INSTALLMENT_CUR'], CLX_NUM_TWO);
                // installment prev
                $r ['INSTALLMENT_PRE'] = ($r ['PRINCIPAL_PRE'] + $r['FEES_PRE']);
                $r ['INSTALLMENT_PRE'] += $r ['INTEREST_PRE'];
                $record ['FIAT_INSTALLMENT_PRE'] = no_format($r ['INSTALLMENT_PRE'], CLX_NUM_TWO);
                $record ['FIAT_PRINCIPAL_PRE'] = no_format($r ['PRINCIPAL_PRE'], CLX_NUM_TWO);
                $record ['FIAT_INTEREST_PRE'] = no_format($r ['INTEREST_PRE'], CLX_NUM_TWO);
                $record ['FIAT_INTEREST_CONT'] = no_format($r ['INTEREST_CONT'], CLX_NUM_TWO);
                if (UserRequest::$request['ac'] !== 'DISPLAY')
                    $record ['FIAT_TRANS_AMT'] = CLX_INIT_ZERO;
                // if paid no point of duing nothing else
                if ($record ['FIAT_TRANSTBL_CODE'] !== 'SYS_CRED-DISB' && $record ['FIAT_PRINCIPAL_BAL'] == CLX_NUM_ZERO)
                    return;
                if (UserRequest::$request['ac'] === 'CODE') { // on init transaction
                    $record ['FIAT_LOAN_AMT'] = no_format($r ['LOAN_AMT'], CLX_NUM_TWO);
                    $record ['FIAT_RESERVE_AMT'] = no_format($r ['RESERVE_AMT'], CLX_NUM_TWO);
                    $record ['FIAT_DEDUCTIBLE_AMT'] = no_format($r ['DEDUCTIBLE_AMT'], CLX_NUM_TWO);
                    // debe tomar todo
                    $sql = 'SELECT   FILO.FEE_01_AMT,   FILO.FEE_02_AMT,   FILO.FEE_03_AMT,   FILO.FEE_04_AMT,   FILO.FEE_05_AMT  FROM   ' . $this->glcpname . ' GLCP,   ' . $this->filoname . ' FILO  WHERE   FILO.COMP_CODE = GLCP.COMP_CODE   AND FILO.CLX_EFFTDATE =   (SELECT MAX(X.CLX_EFFTDATE)   FROM ' . $this->filoname . ' X   WHERE X.IDCODE = FILO.IDCODE   AND X.CLX_EFFTDATE <=NOW())   AND FILO.IDCODE = ' . singleQuote($record ['FIAT_LOAN_CODE']);
                    $fees = ClxCommon::$db->getOneRecord($sql);
                    $record ['FIAT_FEE_01_PAY'] = $fees ['FEE_01_AMT'];
                    $record ['FIAT_FEE_02_PAY'] = $fees ['FEE_02_AMT'];
                    $record ['FIAT_FEE_03_PAY'] = $fees ['FEE_03_AMT'];
                    $record ['FIAT_FEE_04_PAY'] = $fees ['FEE_04_AMT'];
                    $record ['FIAT_FEE_05_PAY'] = $fees ['FEE_05_AMT'];
                    unset($fees);
                    if (!empty(UserRequest::$request ['li']) && UserRequest::$request ['li'] === 'FIAT_CRED_D_SRCH') {
                        $record ['FIAT_TRANS_AMT'] = $r ['AVAILABLE_AMT'];
                        $record ['FIAT_PRINCIPAL_PAY'] = $r ['AVAILABLE_AMT'];
                        $record ['FIAT_PRINCIPAL_EFFECT'] = 'I';
                        $record ['FIAT_INTEREST_EFFECT'] = '';
                    } elseif (!empty(UserRequest::$request ['li']) && UserRequest::$request ['li'] === 'FIAT_CRED_P_SRCH') {
                        $record ['FIAT_PRINCIPAL_PAY'] = $record ['FIAT_PRINCIPAL_PRE'];
                        $record ['FIAT_INTEREST_PAY'] = $record ['FIAT_INTEREST_PRE'];
                        $record ['FIAT_TRANS_AMT'] = $record ['FIAT_INSTALLMENT_PRE'];
                        $record ['FIAT_PRINCIPAL_EFFECT'] = 'D';
                        $record ['FIAT_INTEREST_EFFECT'] = 'D';
                    }
                }
                // Set product fees information
                if (!empty($lrec ['PRODUCT_CODE'])) {
                    $op_type = $this->fiat_credit_operation_type($record ['FIAT_TRANSTBL_CODE']);
                    $sql = 'SELECT COUNT(JELN.ID)  FROM ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD  WHERE JEHD.IDCODE = JELN.JEHDR_CODE  AND JEHD.TRANS_CODE = ' . singleQuote($record ['FIAT_IDCODE']);
                    $lines_exists = ClxCommon::$db->getOne($sql);
                    if ($this->fiat_credit_operation_type($record ['FIAT_TRANSTBL_CODE']) === 'DIS') {
                        $sign = - CLX_NUM_ONE;
                    } else {
                        $sign = CLX_NUM_ONE;
                    }
                    // Flag to enable javascript to charge p0006 in case of late
                    // fees
                    $record ['FIAT_FEE_HAS_LATE_FEE'] = CLX_INIT_ZERO;
                    $sql = 'SELECT   IDNAME,   FEE_FORMULA,   SEQNUM,   DIVIDER_FACTOR,   IS_TAXABLE,   TAX_ITEM_CODE,   FEE_GL_CODE,   FEE2_GL_CODE,   CHARGE_CUSTOMER,   GLPF_FEE_TYPE  FROM   ' . $this->glpfname . '   WHERE   PRODUCT_CODE = ' . singleQuote($lrec ['PRODUCT_CODE']) . '   AND STATUS = ' . singleQuote('A') . '   AND ID IN (SELECT MAX(ID) FROM ' . $this->glpfname . '     WHERE PRODUCT_CODE = ' . singleQuote($lrec ['PRODUCT_CODE']) . '    GROUP BY FEE_FORMULA, SEQNUM)  ORDER BY   SEQNUM ASC';
                    $rs = ClxCommon::$db->executeQuery($sql);
                    while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                        $i = $r ['SEQNUM'];
                        $record ['FIAT_FEE_FORMULA_0' . $i] = $r ['FEE_FORMULA'];
                        if ($r ['GLPF_FEE_TYPE'] === 'LF') { // set ig late fees and
                            // assign amount
                            if ($record ['FIAT_FEE_0' . $i . '_PAY'] > CLX_NUM_ZERO) {
                                $record ['FIAT_FEE_HAS_LATE_FEE'] = CLX_NUM_ONE;
                            }
                            $record ['FIAT_FEE_0' . $i . '_RATE'] = $record ['FIAT_FEE_0' . $i . '_PAY'];
                        }
                        if ($r ['CHARGE_CUSTOMER'] == CLX_NUM_ZERO) { // fees that are not
                            // required to
                            // be paid by the customer
                            // should skeep.
                            $record ['FIAT_FEE_0' . $i . '_NAME'] = '';
                            $record ['FIAT_TAX_0' . $i . '_AMT'] = '0.00';
                            $record ['FIAT_FEE_0' . $i . '_PAY'] = '0.00';
                            $record ['FIAT_TAX_0' . $i . '_RATE'] = '0.00';
                            $init_val = false;
                            continue;
                        }
                        $lbl = '';
                        if ($r ['GLPF_FEE_TYPE'] !== 'LF' && substr($r ['FEE_FORMULA'], CLX_NUM_ZERO, CLX_NUM_ONE) === 'P')
                            $lbl = '% ';
                        $record ['FIAT_FEE_0' . $i . '_NAME'] = $lbl . $r ['IDNAME'];
                        if ($r ['FEE_FORMULA'] === 'F0001')
                            $init_val = true;
                        elseif ($r ['FEE_FORMULA'] === 'F0002' && $op_type === 'DIS')
                            $init_val = true;
                        elseif ($r ['FEE_FORMULA'] === 'F0003' && $op_type === 'PAY')
                            $init_val = true;
                        else
                            $init_val = false;
                        if (!empty($r ['IS_TAXABLE'])) {
                            $sql = 'SELECT IFNULL(JEIT.FLAT_RATE,0)   FROM ' . $this->jeitname . ' JEIT   WHERE JEIT.IDCODE = ' . singleQuote($r ['TAX_ITEM_CODE']) . '   AND JEIT.CLX_EFFTDATE =    (SELECT MAX(X.CLX_EFFTDATE)    FROM ' . $this->jeitname . ' X    WHERE X.IDCODE = JEIT.IDCODE    AND X.CLX_EFFTDATE<=' . singleQuote($record ['FIAT_EFFTDATE']) . ')';
                            $record ['FIAT_TAX_0' . $i . '_RATE'] = ClxCommon::$db->getOne($sql);
                        }
                        // Set fee amount
                        if (UserRequest::$request['ac'] === 'MODIFY') {
                            $sql = 'SELECT -1*SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) AMT   FROM ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD   WHERE JEHD.IDCODE = JELN.JEHDR_CODE    AND JEHD.TRANS_CODE = ' . singleQuote($record ['FIAT_IDCODE']) . '    AND JELN.GLACCOUNTCODE = ' . singleQuote($r ['FEE_GL_CODE']) . '     ';
                            $record ['FIAT_FEE_0' . $i . '_PAY'] = rounder(ClxCommon::$db->getOne($sql), CLX_NUM_TWO);
                        }
                        if ($lines_exists == CLX_NUM_ZERO && $r ['DIVIDER_FACTOR'] != CLX_NUM_ZERO) {
                            if ($init_val === true) {
                                $record ['FIAT_FEE_0' . $i . '_PAY'] = rounder(($lrec ['FEE_0' . $i . '_RATE'] / $r ['DIVIDER_FACTOR']), CLX_NUM_TWO);
                            }
                            if ($r ['FEE_FORMULA'] === 'P0006' && $op_type === 'PAY') {
                                if ($record ['FIAT_FEE_HAS_LATE_FEE'] == CLX_NUM_ONE) {
                                    $record ['FIAT_FEE_0' . $i . '_PAY'] = rounder($record ['FIAT_TRANS_AMT'] * (($lrec ['FEE_0' . $i . '_RATE'] / CLX_NUM_HUNDRED) / $r ['DIVIDER_FACTOR']), CLX_NUM_TWO);
                                }
                            }
                            $record ['FIAT_TRANS_AMT'] += rounder($sign * $record ['FIAT_FEE_0' . $i . '_PAY'], CLX_NUM_TWO);
                            if (!empty($record ['FIAT_TAX_0' . $i . '_RATE'])) {
                                $record ['FIAT_TAX_0' . $i . '_AMT'] = round($record ['FIAT_FEE_0' . $i . '_PAY'] * ($record ['FIAT_TAX_0' . $i . '_RATE'] / CLX_NUM_HUNDRED), CLX_NUM_TWO);
                            }
                            $record ['FIAT_FEE_0' . $i . '_EFFECT'] = 'I';
                        }
                    }
					ClxCommon::$db->freeResult($rs);
                    $record ['FIAT_TAX_AMT'] = CLX_INIT_ZERO;
                    if (!empty($record ['FIAT_TAX_01_AMT']))
                        $record ['FIAT_TAX_AMT'] += $record ['FIAT_TAX_01_AMT'];
                    if (!empty($record ['FIAT_TAX_02_AMT']))
                        $record ['FIAT_TAX_AMT'] += $record ['FIAT_TAX_02_AMT'];
                    if (!empty($record ['FIAT_TAX_03_AMT']))
                        $record ['FIAT_TAX_AMT'] += $record ['FIAT_TAX_03_AMT'];
                    if (!empty($record ['FIAT_TAX_04_AMT']))
                        $record ['FIAT_TAX_AMT'] += $record ['FIAT_TAX_04_AMT'];
                    if (!empty($record ['FIAT_TAX_05_AMT']))
                        $record ['FIAT_TAX_AMT'] += $record ['FIAT_TAX_05_AMT'];
                    // Adding distribution amounts
                    $record ['FIAT_TRANS_AMT'] += rounder($sign * $record ['FIAT_TAX_AMT'], CLX_NUM_TWO);
                }
                if (strpos($record ['FIAT_TRANSTBL_CODE'], 'SYS_CRED_CAP') !== false && UserRequest::$request['ac'] !== 'DISPLAY') {
                    if ($record ['FIAT_TRANS_AMT'] == CLX_NUM_ZERO) {
                        $record ['FIAT_TRANS_AMT'] = no_format($record ['FIAT_INTEREST_AMT'], CLX_NUM_TWO);
                    }
                }
                if (strpos($record ['FIAT_TRANSTBL_CODE'], 'SYS_CRED') === false && UserRequest::$request['ac'] !== 'DISPLAY') {
                    if ($record ['FIAT_TRANS_AMT'] == CLX_NUM_ZERO) {
                        $record ['FIAT_TRANS_AMT'] = rounder($record ['FIAT_LOAN_AMT'], CLX_NUM_TWO);
                    }
                }
                // Adding affect values
                if ($record ['FIAT_CUR_OPERATOR'] == CLX_NUM_ONE && UserRequest::$request['ac'] !== 'DISPLAY') {
                    $record ['FIAT_BASE_TRANS_AMT'] = rounder(bcmul($record ['FIAT_TRANS_AMT'], $record ['FIAT_EXCHANGE_RT']), CLX_NUM_TWO);
                } else {
                    $record ['FIAT_BASE_TRANS_AMT'] = rounder(bcdiv($record ['FIAT_TRANS_AMT'], $record ['FIAT_EXCHANGE_RT']), CLX_NUM_TWO);
                }
            } // end if code
        }

        /**
         * Evalutates transaction operation type
         *
         * @param string $transtbl_code
         * @return string
         */
        private function fiat_credit_operation_type($transtbl_code) {
            $op_type = '';
            switch ($transtbl_code) {
                case 'SYS_CRED-PYMT' :
                    $op_type = 'PAY';
                    break;
                case 'SYS_CRED-DISB' :
                    $op_type = 'DIS';
                    break;
                case 'SYS_CRED-ADJ' :
                    $op_type = 'ADJ';
                    break;
                default :
                    $op_type = '';
                    break;
            }
            return $op_type;
        }

        /**
         * Construct payment details (derived fields from accounting
         *
         * @param array $record
         */
        private function init_credit_operation_details(&$record) {
            //comentado por duplicar montos asi como en bancor
            /* if (strpos($record ['FIAT_TRANSTBL_CODE'], 'SYS_CRED') === false) {
                return; // means its not credit
            }
            if (UserRequest::$request['ac'] === 'CODE')
                return;
            if (!class_exists('Filo'))
                includeCodeLib('FILO');
            $filo = new Filo ();
            $prat = $filo->get_parameters_by_fias($record ['FIAT_CHART_FIELD03']);
            $oper_type = $this->fiat_credit_operation_type($record ['FIAT_TRANSTBL_CODE']);
            $record ['FIAT_PRINCIPAL_PAY'] = CLX_INIT_ZERO;
            $record ['FIAT_INTEREST_PAY'] = CLX_INIT_ZERO;
            $sql = 'SELECT  JELN.GLACCOUNTCODE,  GLAC.GL_TYPE,  SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) BALANCE_AMT FROM  ' . $this->jehdname . ' JEHD,  ' . $this->jelnname . ' JELN,  ' . $this->glacname . ' GLAC,  ' . $this->glcpname . ' GLCP WHERE  JEHD.IDCODE = JELN.JEHDR_CODE  AND JEHD.COMP_CODE = GLCP.COMP_CODE  AND GLCP.GLGROUP_CODE = GLAC.GLGROUP_CODE  AND GLAC.IDCODE = JELN.GLACCOUNTCODE  AND JEHD.TRANS_CODE = ' . singleQuote($record ['FIAT_IDCODE']) . ' GROUP BY GLAC.GL_TYPE,JELN.GLACCOUNTCODE';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $is_asset = ($r ['GL_TYPE'] === 'AS' || $r['GL_TYPE'] === 'OR') ? true : false;
                if ($r ['BALANCE_AMT'] > CLX_NUM_ZERO && !empty($is_asset)) {
                    $debit_credit = 'I';
                    $amount = bcabs($r ['BALANCE_AMT']);
                } elseif ($r ['BALANCE_AMT'] < CLX_NUM_ZERO && !empty($is_asset)) {
                    $debit_credit = 'D';
                    $amount = bcabs($r ['BALANCE_AMT']);
                } elseif ($r ['BALANCE_AMT'] > CLX_NUM_ZERO && empty($is_asset)) {
                    $debit_credit = 'D';
                    $amount = bcabs($r ['BALANCE_AMT']);
                } elseif ($r ['BALANCE_AMT'] < CLX_NUM_ZERO && empty($is_asset)) {
                    $debit_credit = 'I';
                    $amount = bcabs($r ['BALANCE_AMT']);
                } else {
                    $debit_credit = '';
                    $amount = CLX_INIT_ZERO;
                }
                switch ($r ['GLACCOUNTCODE']) {
                    case (ClxCommon::$db->getField($this->pratname, 'PRO_GL_CODE', 'PRO_GL_CODE = ' . singleQuote($r ['GLACCOUNTCODE']) . ' AND PRODUCT_CODE = ' . singleQuote($prat ['PRODUCT_CODE']))) :
                        $record ['FIAT_PRINCIPAL_PAY'] += $amount;
                        $record ['FIAT_PRINCIPAL_EFFECT'] = $debit_credit;
                        break;
                    case (ClxCommon::$db->getField($this->pratname, 'AR_GL_CODE', 'AR_GL_CODE = ' . singleQuote($r ['GLACCOUNTCODE']) . ' AND PRODUCT_CODE = ' . singleQuote($prat ['PRODUCT_CODE']))) :
                        $record ['FIAT_INTEREST_PAY'] += $amount;
                        $record ['FIAT_INTEREST_EFFECT'] = $debit_credit;
                        break;
                    case (ClxCommon::$db->getField($this->pratname, 'CINT_GL_CODE', 'CINT_GL_CODE = ' . singleQuote($r ['GLACCOUNTCODE']) . 'AND PRODUCT_CODE = ' . singleQuote($prat ['PRODUCT_CODE']))) :
                        $record ['FIAT_INTEREST_PAY'] += $amount;
                        $record ['FIAT_INTEREST_EFFECT'] = $debit_credit;
                        break;
                    case $prat ['RES_GL_CODE'] :
                        $record ['FIAT_PRINCIPAL_PAY'] -= $amount;
                        $record ['FIAT_RESERVE_PAY'] = $amount;
                        $record ['FIAT_RESERVE_EFFECT'] = $debit_credit;
                        break;
                    default :
                        break;
                } // end switch
            } // end while
			ClxCommon::$db->freeResult($rs);
            // Building fee lines
            $sql = 'SELECT  GLPF.SEQNUM,  GLPF.FEE_GL_CODE,  GLPF.FEE2_GL_CODE,  GLPF.DIVIDER_FACTOR,  JELN.GLACCOUNTCODE GLACCOUNTCODE,  GLAC.GL_TYPE,  GLAC.PROVISION,  SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) BALANCE_AMT FROM  ' . $this->jehdname . ' JEHD,  ' . $this->jelnname . ' JELN,  ' . $this->glacname . ' GLAC,  ' . $this->glpfname . ' GLPF WHERE  JEHD.IDCODE = JELN.JEHDR_CODE  AND GLPF.GLGROUP_CODE = GLAC.GLGROUP_CODE  AND GLAC.IDCODE = JELN.GLACCOUNTCODE  AND JELN.GLACCOUNTCODE IN (GLPF.FEE_GL_CODE, GLPF.FEE2_GL_CODE)  AND GLPF.STATUS = ' . singleQuote('A') . '  AND GLPF.PRODUCT_CODE = ' . singleQuote($prat ['PRODUCT_CODE']) . '  AND JEHD.TRANS_CODE = ' . singleQuote($record ['FIAT_IDCODE']) . ' GROUP BY  GLPF.FEE_GL_CODE,  GLPF.FEE2_GL_CODE,  JELN.GLACCOUNTCODE,  GLAC.GL_TYPE,  GLAC.PROVISION,  GLPF.SEQNUM ORDER BY GLPF.SEQNUM ASC';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $i = $r ['SEQNUM'];
                if ($r ['FEE2_GL_CODE'] !== '' && $r ['GLACCOUNTCODE'] != $r ['FEE2_GL_CODE']) {
                    continue;
                }
                if ($oper_type === 'DIS') {
                    $by_debit = ($r ['GL_TYPE'] === 'AS' || $r ['GL_TYPE'] === 'EX' || $r ['GL_TYPE'] === 'OR') ? true : false;
                } else {
                    $by_debit = ($r ['GL_TYPE'] === 'AS' || $r ['GL_TYPE'] === 'EX' || $r ['GL_TYPE'] === 'IN' || $r ['GL_TYPE'] === 'OR') ? false : true;
                    if ($r ['DIVIDER_FACTOR'] == CLX_NUM_ONE) { // means one on payment check
                        // sign
                        if ($r ['GL_TYPE'] === 'LI')
                            $by_debit = false;
                    }
                }
                if ($r ['PROVISION'] == CLX_NUM_ONE)
                    $by_debit = ($by_debit) ? false : true;
                if ($r ['BALANCE_AMT'] > CLX_NUM_ZERO && $by_debit) {
                    $amount = $r ['BALANCE_AMT'];
                } elseif ($r ['BALANCE_AMT'] < CLX_NUM_ZERO && $by_debit) {
                    $amount = $r ['BALANCE_AMT'];
                } elseif ($r ['BALANCE_AMT'] > CLX_NUM_ZERO && empty($by_debit)) {
                    $amount = - CLX_NUM_ONE * $r ['BALANCE_AMT'];
                } elseif ($r ['BALANCE_AMT'] < CLX_NUM_ZERO && empty($by_debit)) {
                    $amount = - CLX_NUM_ONE * $r ['BALANCE_AMT'];
                } else {
                    $amount = CLX_INIT_ZERO;
                }
                $record ['FIAT_FEE_0' . $i . '_PAY'] = $amount;
                $record ['FIAT_TAX_0' . $i . '_AMT'] = rounder($amount * ($record ['FIAT_TAX_0' . $i . '_RATE'] / CLX_NUM_HUNDRED), CLX_NUM_TWO);
            } // end while
			ClxCommon::$db->freeResult($rs);
            if ($oper_type === 'PAY') {
                // $sign = -1;
                $sign = CLX_NUM_ONE;
            } else {
                $sign = - CLX_NUM_ONE;
            }
            $record ['FIAT_TAX_AMT'] = CLX_INIT_ZERO;
            $record ['FIAT_TAX_AMT'] += $record ['FIAT_TAX_01_AMT'];
            $record ['FIAT_TAX_AMT'] += $record ['FIAT_TAX_02_AMT'];
            $record ['FIAT_TAX_AMT'] += $record ['FIAT_TAX_03_AMT'];
            $record ['FIAT_TAX_AMT'] += $record ['FIAT_TAX_04_AMT'];
            $record ['FIAT_TAX_AMT'] += $record ['FIAT_TAX_05_AMT'];
            // Adding distribution amounts
            $record ['FIAT_TRANS_AMT'] = rounder($record ['FIAT_PRINCIPAL_PAY'], CLX_NUM_TWO);
            $record ['FIAT_TRANS_AMT'] += rounder($record ['FIAT_INTEREST_PAY'], CLX_NUM_TWO);
            $record ['FIAT_TRANS_AMT'] += rounder($record ['FIAT_RESERVE_PAY'], CLX_NUM_TWO);
            $record ['FIAT_TRANS_AMT'] += rounder($sign * $record ['FIAT_FEE_01_PAY'], CLX_NUM_TWO);
            $record ['FIAT_TRANS_AMT'] += rounder($sign * $record ['FIAT_FEE_02_PAY'], CLX_NUM_TWO);
            $record ['FIAT_TRANS_AMT'] += rounder($sign * $record ['FIAT_FEE_03_PAY'], CLX_NUM_TWO);
            $record ['FIAT_TRANS_AMT'] += rounder($sign * $record ['FIAT_FEE_04_PAY'], CLX_NUM_TWO);
            $record ['FIAT_TRANS_AMT'] += rounder($sign * $record ['FIAT_FEE_05_PAY'], CLX_NUM_TWO);
            $record ['FIAT_TRANS_AMT'] += rounder($sign * $record ['FIAT_TAX_AMT'], CLX_NUM_TWO);
            // setting base trans amount
            if ($record ['FIAT_CUR_OPERATOR'] == CLX_NUM_ONE) {
                $record ['FIAT_BASE_TRANS_AMT'] = rounder(bcmul($record ['FIAT_TRANS_AMT'], $record ['FIAT_EXCHANGE_RT']), CLX_NUM_TWO);
            } else {
                $record ['FIAT_BASE_TRANS_AMT'] = rounder(bcdiv($record ['FIAT_TRANS_AMT'], $record ['FIAT_EXCHANGE_RT']), CLX_NUM_TWO);
            }
            // Setting Sequence
            */
        }

        /**
         * Assignes effect value
         * @param type $record
         * @param type $line_amt
         * @param type $effect
         * @param type $effect_value
         */
        private function setDebitCreditEffectAmount(&$record, $line_amt, $adjustment, $effect, $effect_value) {
            if ($effect === $effect_value) {
                if ($adjustment == CLX_NUM_ZERO) {
                    $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
                    $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                } else {
                    $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                    $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
                }
            } else {
                if ($adjustment == CLX_NUM_ZERO) {
                    $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                    $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
                } else {
                    $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
                    $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                }
            }
        }

        /**
         * Buils accounting lines for credit transactions
         *
         * @param array $record
         * @param string $jehdr_code
         */
        private function fiat_build_accounting_credit(&$record, $jehdr_code) {
            if (empty($jehdr_code))
                return;
            // setting operation type
            $op_type = $this->fiat_credit_operation_type($record ['TRANSTBL_CODE']);
            if ($op_type === 'PAY') {
                UserRequest::$post ['FIAT_PRINCIPAL_EFFECT'] = 'D';
                UserRequest::$post ['FIAT_INTEREST_EFFECT'] = 'D';
            } elseif ($op_type === 'DIS') {
                UserRequest::$post ['FIAT_PRINCIPAL_EFFECT'] = 'I';
                UserRequest::$post ['FIAT_INTEREST_EFFECT'] = 'I';
            }
            // Loading accounting parameters for loan
            if (!class_exists('Filo'))
                includeCodeLib('FILO');
            if (!function_exists('jeit_calculate_item_amt'))
                includeCodeLib('JEIT');
            $filo = new Filo ();
            $prat = $filo->get_parameters_by_fias($record ['CHART_FIELD03']);
            unset($filo);
            // On payments GLACCOUNTCODE is provided in some cases like
            // eliminating credits
            if (!empty($record ['FIDU_BANKACT_CODE']) && $record ['FIDU_BANKACT_CODE'] !== 'null') {
                // Loading bank account information
                $sql = 'SELECT DISTINCT PRAT.*, FIAS.IDCODE CASH_ASSET_CODE  FROM ' . $this->pratname . ' PRAT,   ' . $this->fibkname . ' FIBK,   ' . $this->fiasname . ' FIAS  WHERE   FIBK.BANK_PROD_CODE = PRAT.PRODUCT_CODE   AND FIAS.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO   AND FIAS.CONTRACT_CODE = ' . singleQuote($record ['CHART_FIELD01']) . '    AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($record ['FIDU_BANKACT_CODE']);
                $fibk_prat_rec = ClxCommon::$db->getOneRecord($sql);
            } else {
                if ($record ['GLACCOUNTCODE'] === 'null')
                    $record ['GLACCOUNTCODE'] = '';
                $fibk_prat_rec = array('CASH_ASSET_CODE' => '', 'PRO_GL_CODE' => $record ['GLACCOUNTCODE']);
            }
            // Search sign for product type if AS or LI
            $is_asset = ClxCommon::$db->getField($this->glacname, 'GL_TYPE', 'IDCODE = ' . singleQuote($prat ['PRO_GL_CODE']), 'GLGROUP_CODE = ' . singleQuote($prat ['GLGROUP_CODE']));
            $is_asset = ($is_asset === 'AS') ? true : false;
            if (!class_exists('Jeln'))
                includeCodeLib('JELN');
            $jeln = new Jeln ();
            $jeln->jeln_delete_lines($jehdr_code);
            $clear_jeln_rec = $jeln->jeln_init_record();
            // Base jeln record
            $clear_jeln_rec ['JEHDR_CODE'] = $jehdr_code;
            $clear_jeln_rec ['RECONCILIED'] = CLX_INIT_ZERO;
            $clear_jeln_rec ['CHART_FIELD01'] = $record ['CHART_FIELD01'];
            $clear_jeln_rec ['CHART_FIELD02'] = $record ['CHART_FIELD02'];
            $clear_jeln_rec ['CHART_FIELD03'] = $record ['CHART_FIELD03'];
            $clear_jeln_rec ['CHART_FIELD04'] = $record ['CHART_FIELD04'];
            $clear_jeln_rec ['CURRENCY_CODE'] = $record ['CURRENCY_CODE'];
            $clear_jeln_rec ['CUR_OPERATOR'] = $record ['CUR_OPERATOR'];
            $clear_jeln_rec ['EXCHANGE_RT'] = $record ['EXCHANGE_RT'];
            $clear_jeln_rec ['SEQNUM'] = CLX_INIT_ZERO;
            $seqnum = CLX_INIT_ZERO;
            //Lineas de capital
            if (array_key_exists('FIAT_PRINCIPAL_EFFECT', UserRequest::$post)) {
                $cash_amt = '0';
                // Build product line
                $effect = UserRequest::$post ['FIAT_PRINCIPAL_EFFECT'];
                $line_amt = UserRequest::$post ['FIAT_PRINCIPAL_PAY'];
                if (!empty($prat ['PRO_GL_CODE']) && $effect !== '' && $line_amt != CLX_NUM_ZERO) {
                    $jeln_rec = $clear_jeln_rec;
                    $jeln_rec ['GLACCOUNTCODE'] = $prat ['PRO_GL_CODE'];
                    $jeln_rec ['ITEM_CODE'] = 'CRED';
                    $jeln_rec ['ITEM_REF_NO'] = $record ['FIDU_BANKACT_CODE'];
                    if ($is_asset === true) {
                        if ($effect === 'I' && $record ['ADJUSTMENT'] == CLX_NUM_ZERO) {
                            $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                            $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
                        } else {
                            $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
                            $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                        }
                    } else {
                        if ($effect === 'I' && $record ['ADJUSTMENT'] == CLX_NUM_ZERO) {
                            $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
                            $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                        } else {
                            $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                            $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
                        }
                    }
                    if ($op_type === 'PAY') {
                        // revising status account for late payments
                       $sql = 'SELECT PRAT.PROD_STATUS, JCBV.GLACCOUNTCODE, SUM(JCBV.BALANCE_AMT) BALANCE_AMT FROM ' . $this->jcbvname . ' JCBV, ' . $this->pratname . ' PRAT,    ' . $this->prltname . ' PRLT,    ' . $this->fiasname . ' FIAS,    CRED_CREDITS FILO   WHERE     FIAS.IDCODE = JCBV.CHART_FIELD03     AND PRAT.PRO_GL_CODE = JCBV.GLACCOUNTCODE     AND PRLT.PRODUCT_CODE = PRAT.PRODUCT_CODE     AND PRAT.PROD_STATUS = FILO.LOAN_STATUS     AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE     AND FILO.IDCODE = FIAS.LOAN_CODE     AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)     FROM ' . $this->filoname . ' FILOX     WHERE FILOX.IDCODE = FILO.IDCODE     AND FILOX.CLX_EFFTDATE <=' . singleQuote($this->now) . ')     AND FIAS.IDCODE = ' . singleQuote($record ['CHART_FIELD03']) . '     AND JCBV.CHART_FIELD01 = ' . singleQuote($record ['CHART_FIELD01']) . '     AND JCBV.CHART_FIELD02 = ' . singleQuote($record ['CHART_FIELD02']) . ' GROUP BY PRAT.PROD_STATUS, JCBV.GLACCOUNTCODE HAVING SUM(JCBV.BALANCE_AMT)<>0 ORDER BY JCBV.GLACCOUNTCODE ASC'; 
                        $rs = ClxCommon::$db->executeQuery($sql);
                        $debit_amt = $jeln_rec ['DEBIT_AMT'];
                        $credit_amt = $jeln_rec ['CREDIT_AMT'];
                        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                            if (abs($r ['BALANCE_AMT']) < abs($debit_amt - $credit_amt)) {
                                if ($debit_amt > CLX_NUM_ZERO) {
                                    $jeln_rec ['DEBIT_AMT'] = abs($r ['BALANCE_AMT']);
                                    $debit_amt -= abs($r ['BALANCE_AMT']);
                                } elseif ($credit_amt > CLX_NUM_ZERO) {
                                    $jeln_rec ['CREDIT_AMT'] = abs($r ['BALANCE_AMT']);
                                    $credit_amt -= abs($r ['BALANCE_AMT']);
                                }
                            } elseif (abs($r ['BALANCE_AMT']) >= abs($debit_amt - $credit_amt)) {
                                $jeln_rec ['DEBIT_AMT'] = $debit_amt;
                                $jeln_rec ['CREDIT_AMT'] = $credit_amt;
                                $debit_amt = CLX_INIT_ZERO;
                                $credit_amt = CLX_INIT_ZERO;
                            } else {
                                break;
                            }
                            $jeln_rec ['GLACCOUNTCODE'] = $r ['GLACCOUNTCODE'];
                            $jeln_rec ['SEQNUM'] = $seqnum;
                            $seqnum++;
                            $jeln_rec_copy = $jeln_rec;
                            $jeln->jeln_build($jeln_rec_copy);
                            unset($jeln_rec_copy);
                            $cash_amt = bcadd($cash_amt, bcsub($jeln_rec ['DEBIT_AMT'], $jeln_rec ['CREDIT_AMT']));
                            if (($debit_amt - $credit_amt) == CLX_NUM_ZERO)
                                break;
                        }
						ClxCommon::$db->freeResult($rs);
                    } else {
                        $jeln_rec ['SEQNUM'] = $seqnum;
                        $seqnum++;
                        $jeln_rec_copy = $jeln_rec;
                        $jeln->jeln_build($jeln_rec_copy);
                        unset($jeln_rec_copy);
                        $cash_amt = bcadd($cash_amt, bcsub($jeln_rec ['DEBIT_AMT'], $jeln_rec ['CREDIT_AMT']));
                    }
                    // Adding Order lines if product requires it
                    $sql = 'SELECT   MAX(FILO.IDCODE) LOAN_CODE,   MAX(FILO.CRED_LINE_CODE) CRED_LINE_CODE,   MAX(FILO.DEBTOR_CODE) DEBTOR_CODE,   MAX(FILO.PRODUCT_CODE) PRODUCT_CODE   FROM ' . $this->filoname . ' FILO, ' . $this->fiasname . ' FIAS   WHERE FILO.IDCODE = FIAS.LOAN_CODE   AND FIAS.IDCODE = ' . singleQuote($record ['CHART_FIELD03']);
                    $temp = ClxCommon::$db->getOneRecord($sql);
                    if (!empty($temp ['CRED_LINE_CODE']) && $prat ['ORDER_GL_CODE'] !== '') {
                        $debtor_code = $temp ['DEBTOR_CODE'];
                        $product_code = $temp ['PRODUCT_CODE'];
                        $amort = ClxCommon::$db->countRecords($this->prltname, 'AMRT_LINE_CREDIT = 1 AND PRODUCT_CODE = ' . singleQuote($product_code));
                        if (($op_type === 'PAY' && !empty($amort)) || $op_type === 'DIS') {
                            $jeln_rec = $clear_jeln_rec;
                            $jeln_rec ['GLACCOUNTCODE'] = $prat ['ORDER_GL_CODE'];
                            $jeln_rec ['CHART_FIELD02'] = $debtor_code;
                            $jeln_rec ['CHART_FIELD03'] = 'null'; /* CR 2017-10-19 - Caso 1003484 - Los asientos de las cuentas de orden, no deben llevar subcuenta, para que sea igual al asiento de creacion de la linea de credito revolvente */
                            $jeln_rec ['CHART_FIELD04'] = 'null';
                            $jeln_rec ['ITEM_CODE'] = 'null';
                            $jeln_rec ['ITEM_REF_NO'] = $temp ['LOAN_CODE'];
                            #$this->setDebitCreditEffectAmount($jeln_rec, $line_amt, $record ['ADJUSTMENT'], $effect, 'I');
                            if ($effect == 'I') {
                                if ($record ['ADJUSTMENT'] == CLX_NUM_ZERO) {
                                    $jeln_rec ['DEBIT_AMT'] = CLX_NUM_ZERO;
                                    $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                                } else {
                                    $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                                    $jeln_rec ['CREDIT_AMT'] = CLX_NUM_ZERO;
                                }
                            } else {
                                if ($record ['ADJUSTMENT'] == CLX_NUM_ZERO) {
                                    $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                                    $jeln_rec ['CREDIT_AMT'] = CLX_NUM_ZERO;
                                } else {
                                    $jeln_rec ['DEBIT_AMT'] = CLX_NUM_ZERO;
                                    $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                                }
                            }
                            $jeln_rec ['SEQNUM'] = $seqnum;
                            $seqnum++;
                            $jeln_rec_copy = $jeln_rec;
                            $jeln->jeln_build($jeln_rec_copy);
                            unset($jeln_rec_copy);
                            $jeln_rec = $clear_jeln_rec;
                            $jeln_rec ['GLACCOUNTCODE'] = $prat ['ORDER2_GL_CODE'];
                            $jeln_rec ['CHART_FIELD02'] = $debtor_code;
                            $jeln_rec ['CHART_FIELD03'] = 'null'; /* CR 2017-10-19 - Caso 1003484 - Los asientos de las cuentas de orden, no deben llevar subcuenta, para que sea igual al asiento de creacion de la linea de credito revolvente */
                            $jeln_rec ['CHART_FIELD04'] = 'null';
                            $jeln_rec ['ITEM_CODE'] = 'null';
                            $jeln_rec ['ITEM_REF_NO'] = $temp ['LOAN_CODE'];
                            #$this->setDebitCreditEffectAmount($jeln_rec, $line_amt, $record ['ADJUSTMENT'], $effect, 'D');
                            if ($effect == 'D') {
                                if ($record ['ADJUSTMENT'] == CLX_NUM_ZERO) {
                                    $jeln_rec ['DEBIT_AMT'] = CLX_NUM_ZERO;
                                    $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                                } else {
                                    $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                                    $jeln_rec ['CREDIT_AMT'] = CLX_NUM_ZERO;
                                }
                            } else {
                                if ($record ['ADJUSTMENT'] == CLX_NUM_ZERO) {
                                    $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                                    $jeln_rec ['CREDIT_AMT'] = CLX_NUM_ZERO;
                                } else {
                                    $jeln_rec ['DEBIT_AMT'] = CLX_NUM_ZERO;
                                    $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                                }
                            }
                            $jeln_rec ['SEQNUM'] = $seqnum;
                            $seqnum++;
                            $jeln_rec_copy = $jeln_rec;
                            $jeln->jeln_build($jeln_rec_copy);
                            unset($jeln_rec_copy);
                        }
                    }
                }
                // Build Interest line
                $effect = UserRequest::$post ['FIAT_INTEREST_EFFECT'];
                $line_amt = UserRequest::$post ['FIAT_INTEREST_PAY'];
                if (!empty($prat ['AR_GL_CODE']) && $effect !== '' && $line_amt != CLX_NUM_ZERO) {
                    $jeln_rec = $clear_jeln_rec;
                    $jeln_rec ['GLACCOUNTCODE'] = $prat ['AR_GL_CODE'];
                    $jeln_rec ['ITEM_CODE'] = 'CRED';
                    $jeln_rec ['ITEM_REF_NO'] = $record ['FIDU_BANKACT_CODE'];
                    if ($is_asset === true) {
                        if ($effect === 'I' && !empty($is_asset)) {
                            $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                            $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
                        } else {
                            $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
                            $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                        }
                    } else {
                        if ($effect === 'I' && !empty($is_asset)) {
                            $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
                            $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                        } else {
                            $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                            $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
                        }
                    }
                    //Contrapartida de intereses
                    if ($op_type === 'PAY') {
                        // En caso de pagos
                        ##if (CLX_NUM_ONE == CLX_NUM_TWO && $record ['PAY_APPLIES_TO'] > CLX_NUM_ZERO) {
                        if ($record ['PAY_APPLIES_TO'] > CLX_NUM_ZERO) {
                            $sql = 'SELECT PRAT.INC_GL_CODE, PRAT.CINT_GL_CODE, PRAT.CINT2_GL_CODE, PRAT.PROD_STATUS, JCBV.GLACCOUNTCODE, SUM(JCBV.BALANCE_AMT) BALANCE_AMT, PRAT.AR_GL_CODE FROM ' . $this->jcbvname . ' JCBV, ' . $this->pratname . ' PRAT, ' . $this->prltname . ' PRLT, ' . $this->fiasname . ' FIAS, ' . $this->filoname . ' FILO WHERE FIAS.IDCODE = JCBV.CHART_FIELD03 AND JCBV.GLACCOUNTCODE IN (PRAT.AR_GL_CODE, PRAT.CINT_GL_CODE ) AND PRLT.PRODUCT_CODE = PRAT.PRODUCT_CODE AND FILO.LOAN_STATUS = PRAT.PROD_STATUS AND FILO.PRODUCT_CODE = PRAT.PRODUCT_CODE AND FILO.LOAN_STATUS = PRAT.PROD_STATUS AND FILO.IDCODE = FIAS.LOAN_CODE AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILOX.IDCODE = FILO.IDCODE AND FILOX.CLX_EFFTDATE<=' . singleQuote($this->now) . ') AND FIAS.IDCODE = ' . singleQuote($record ['CHART_FIELD03']) . 'AND JCBV.CHART_FIELD01 = ' . singleQuote($record ['CHART_FIELD01']) . 'AND JCBV.CHART_FIELD02 = ' . singleQuote($record ['CHART_FIELD02']) . 'GROUP BY PRAT.PROD_STATUS, JCBV.GLACCOUNTCODE, PRAT.CINT_GL_CODE, PRAT.CINT2_GL_CODE, PRAT.INC_GL_CODE HAVING  SUM(JCBV.BALANCE_AMT)<>0 ORDER BY JCBV.GLACCOUNTCODE';
                            if($record['INTEREST_PAY']>=$record['INTEREST_AMT'])
                                $sql.=' ASC';
                            else
                                $sql.=' DESC';
                            $rs = ClxCommon::$db->executeQuery($sql);##pre($jeln_rec);##echo "<br>";echo $sql."<br>";
                            $debit_amt = $jeln_rec['DEBIT_AMT'];
                            $credit_amt = $jeln_rec['CREDIT_AMT'];
                            $jeln_rec_store = $jeln_rec;$counts = 0;
                            while(($r = ClxCommon::$db->getNextRecord($rs))==true){##echo 'balance_amt: '.$r['BALANCE_AMT'].' debit_amt: '.$debit_amt . ' credit_amt: '.$credit_amt.'<br>';
                            if(abs($r['BALANCE_AMT'])<abs($debit_amt-$credit_amt)){
                                //if($r['BALANCE_AMT']<round($debit_amt-$credit_amt,2)){
                                    if($debit_amt>0){##echo 'pase 2661<br>';
                                        $jeln_rec['DEBIT_AMT'] = abs($r['BALANCE_AMT']);
                                        $debit_amt -= abs($r['BALANCE_AMT']);
                                    }elseif($credit_amt>0){
                                        $jeln_rec['CREDIT_AMT'] = abs($r['BALANCE_AMT']); ##echo $jeln_rec['CREDIT_AMT']." (2665)<br>";
                                        #if($r['GLACCOUNTCODE'] == $r['AR_GL_CODE'] && $record['INTEREST_PAY']!=$record['INTEREST_AMT']){
                                        if($r['GLACCOUNTCODE'] == $r['AR_GL_CODE'] && $record['INTEREST_PAY']>$record['INTEREST_AMT']){
                                            $diff_interest = $record['INTEREST_PAY'] - $record['INTEREST_AMT'];
                                            $jeln_rec['CREDIT_AMT'] += $diff_interest;
                                        }
                                        #if($record['INTEREST_PAY']>=$record['INTEREST_AMT']) //##
                                        $credit_amt -= abs($r['BALANCE_AMT']);
                                    }

                                }elseif(abs($r['BALANCE_AMT'])>= abs($debit_amt-$credit_amt)){
                                //}elseif($r['BALANCE_AMT']>= round($debit_amt-$credit_amt, 2)){
                                   $jeln_rec['DEBIT_AMT'] = $debit_amt;
                                   $jeln_rec['CREDIT_AMT'] = $credit_amt;##echo $jeln_rec['CREDIT_AMT']." (2677)<br>";
                                   $debit_amt = 0;
                                   $credit_amt = 0;
                                }else{

                                    break;
                            }

                            $jeln_rec['GLACCOUNTCODE'] = $r['GLACCOUNTCODE'];
                            $jeln_rec['SEQNUM'] = $seqnum; $seqnum++;
                            $jeln_rec_copy = $jeln_rec;##echo 'pase 1 <br>';pre($jeln_rec_copy);
                            $jeln->jeln_build($jeln_rec_copy);
                            #$this->fiat_build_line_credit($jeln_rec);

                            //Adding order counterbalance accounts.
                            if($r['CINT_GL_CODE'] == $r['GLACCOUNTCODE']){
                                $d = $jeln_rec['DEBIT_AMT'];
                                $c = $jeln_rec['CREDIT_AMT'];

                                $jeln_rec['DEBIT_AMT'] = $c;
                                $jeln_rec['CREDIT_AMT'] = $d;
                                $jeln_rec['GLACCOUNTCODE'] = $r['CINT2_GL_CODE'];
                                $jeln_rec['SEQNUM'] = $seqnum; $seqnum++;
                                $jeln_rec_copy = $jeln_rec;##echo 'pase 2 <br>';pre($jeln_rec_copy);
                                $jeln->jeln_build($jeln_rec_copy);
                                ##$this->fiat_build_line_credit($jeln_rec);

                                //Adding Income line for paid cint la cuenta de intereses estara en diciembre
                                $jeln_rec['DEBIT_AMT'] = $d;
                                $jeln_rec['CREDIT_AMT'] = $c;
                                $jeln_rec['GLACCOUNTCODE'] = $r['INC_GL_CODE'];
                                $jeln_rec['SEQNUM'] = $seqnum; $seqnum++;
                                $jeln_rec_copy = $jeln_rec;##echo 'pase 3 <br>';pre($jeln_rec_copy);
                                if($this->get_gl_type($jeln_rec_copy['GLACCOUNTCODE'])['GL_TYPE'] == 'IN')$jeln_rec_copy['CHART_FIELD03'] = 'null'; //## las cuentas de ingreso no llevan subcuenta 1nov2019
                                $jeln->jeln_build($jeln_rec_copy);
                                //$cash_amt = bcadd($cash_amt, bcsub($jeln_rec['DEBIT_AMT'],$jeln_rec['CREDIT_AMT']));
                                #$this->fiat_build_line_credit($jeln_rec);
                            }

                            if(($debit_amt-$credit_amt)==0) break;
                        }
                        $jeln_rec = $jeln_rec_store;
                        unset($jeln_rec_store, $c, $d);
                            //not anymore
                        } else {
                            //Contrapart
                            // Direct amount just set as provided by the user
                            $jeln_rec ['SEQNUM'] = $seqnum;
                            $seqnum++;
                            $jeln_rec_copy = $jeln_rec;
                            $jeln->jeln_build($jeln_rec_copy);
                            //Caso donde pago se refleja en cuentas de orden
                            if ($prat['AR_ALT_GL_CODE'] <> '') {
                                $jeln_rec_copy['GLACCOUNTCODE'] = $prat['AR_ALT_GL_CODE'];
                                //$jeln_rec_copy ['CHART_FIELD03'] = $record ['CHART_FIELD03']; /* FS 20130326 */
                                $jeln_rec_copy ['CHART_FIELD03'] = 'null'; /* CR 2017-10-19 - Caso 1003484 - Los asientos de las cuentas de orden, no deben llevar subcuenta, para que sea igual al asiento de creacion de la linea de credito revolvente */
                                $jeln_rec ['SEQNUM'] = $seqnum;
                                $seqnum++;
                                $jeln->jeln_build($jeln_rec_copy);
                                //Contrapartida de cuenta de orden
                                $jeln_rec_copy['GLACCOUNTCODE'] = $prat['INC_GL_CODE'];
                                $jeln_rec_copy['SEQNUM'] = $seqnum;
                                if ($jeln_rec_copy['DEBIT_AMT'] > CLX_NUM_ZERO) {
                                    $jeln_rec_copy['CREDIT_AMT'] = $jeln_rec_copy['DEBIT_AMT'];
                                    $jeln_rec_copy['CREDIT_TRANS_AMT'] = $jeln_rec_copy['DEBIT_TRANS_AMT'];
                                    $jeln_rec_copy['DEBIT_AMT'] = CLX_INIT_ZERO;
                                    $jeln_rec_copy['DEBIT_TRANS_AMT'] = CLX_INIT_ZERO;
                                } else {
                                    $jeln_rec_copy['DEBIT_AMT'] = $jeln_rec_copy['CREDIT_AMT'];
                                    $jeln_rec_copy['DEBIT_TRANS_AMT'] = $jeln_rec_copy['CREDIT_TRANS_AMT'];
                                    $jeln_rec_copy['CREDIT_AMT'] = CLX_INIT_ZERO;
                                    $jeln_rec_copy['CREDIT_TRANS_AMT'] = CLX_INIT_ZERO;
                                }
                                $seqnum++;
                                $jeln->jeln_build($jeln_rec_copy);
                            }
                            unset($jeln_rec_copy);
                        }
                    } else {
                        //en cualquier otro caso que no sea pato
                        $jeln_rec ['SEQNUM'] = $seqnum;
                        $seqnum++;
                        $jeln_rec_copy = $jeln_rec;
                        $jeln->jeln_build($jeln_rec_copy); //Insertando linea de ajuste
                        unset($jeln_rec_copy);
                    }
                    $jeln_rec_copy ['CHART_FIELD03'] = $record ['CHART_FIELD03']; /* FS 20130326 */
                    // If increment of interest should be agains income/expense
                    // then adding income expense line if not payment
                    $line_amt = bcsub($jeln_rec ['DEBIT_AMT'], $jeln_rec ['CREDIT_AMT']);
                    //Si es no existe cuenta de banco o cuenta contable de operacion que se maneja al final con efectivo entonces
                    //colocar la cuenta de ingresos.
                    if ((($effect === 'I' || $record ['ADJUSTMENT'] == CLX_NUM_ONE) || ($fibk_prat_rec ['PRO_GL_CODE'] === 'null' && $prat ['GL01_CODE'] === '')) && $line_amt != CLX_NUM_ZERO) {
                        $jeln_rec = $clear_jeln_rec;
                        $jeln_rec ['GLACCOUNTCODE'] = $prat ['INC_GL_CODE'];
                        $jeln_rec ['ITEM_CODE'] = 'CRED';
                        $jeln_rec ['ITEM_REF_NO'] = $record ['FIDU_BANKACT_CODE'];
                        //Reviser en el caso que sea ingreso
                        if ($line_amt > CLX_NUM_ZERO) {
                            $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
                            $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                        } else {
                            $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                            $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
                        }
                        $jeln_rec ['SEQNUM'] = $seqnum;
                        $seqnum++;
                        $jeln_rec_copy = $jeln_rec;
                        $jeln->jeln_build($jeln_rec_copy);
                        unset($jeln_rec_copy);
                    } else {
                        $cash_amt = bcadd($cash_amt, bcsub($jeln_rec ['DEBIT_AMT'], $jeln_rec ['CREDIT_AMT']));
                    }
                }
                // Adding reserve into payment
                $line_amt = (empty(UserRequest::$post ['FIAT_RESERVE_PAY'])) ? CLX_NUM_ZERO : UserRequest::$post ['FIAT_RESERVE_PAY'];
                if ($prat ['RES_GL_CODE'] !== '' && $line_amt != CLX_NUM_ZERO) {
                    $jeln_rec = $clear_jeln_rec;
                    $jeln_rec ['GLACCOUNTCODE'] = $prat ['RES_GL_CODE'];
                    $jeln_rec ['ITEM_CODE'] = 'CRED';
                    $jeln_rec ['ITEM_REF_NO'] = 'null';
                    if ($is_asset === true) {
                        if ($record ['ADJUSTMENT'] == CLX_NUM_ZERO) {
                            $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                            $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
                        } else {
                            $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
                            $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                        }
                    } else {
                        if ($record ['ADJUSTMENT'] == CLX_NUM_ZERO) {
                            $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
                            $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                        } else {
                            $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                            $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
                        }
                    }
                    $jeln_rec ['SEQNUM'] = $seqnum;
                    $seqnum++;
                    $jeln_rec_copy = $jeln_rec;
                    $jeln->jeln_build($jeln_rec_copy);
                    unset($jeln_rec_copy);
                    $jeln_rec = $clear_jeln_rec;
                    $jeln_rec ['GLACCOUNTCODE'] = $prat ['PRO_GL_CODE'];
                    $jeln_rec ['ITEM_CODE'] = 'CRED';
                    $jeln_rec ['ITEM_REF_NO'] = 'null';
                    if ($is_asset === true) {
                        if ($record ['ADJUSTMENT'] == CLX_NUM_ZERO) {
                            $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
                            $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                        } else {
                            $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                            $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
                        }
                    } else {
                        if ($record ['ADJUSTMENT'] == CLX_NUM_ZERO) {
                            $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                            $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
                        } else {
                            $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
                            $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                        }
                    }
                    $jeln_rec ['SEQNUM'] = $seqnum;
                    $seqnum++;
                    $jeln_rec_copy = $jeln_rec;
                    $jeln->jeln_build($jeln_rec_copy);
                    unset($jeln_rec_copy);
                } // end if RES_GL_CODE
                // Build fee lines

                //caso 1004262
                $loan_code = ClxCommon::$db->getField($this->fiasname, 'LOAN_CODE', "IDCODE = '" . $record['CHART_FIELD03'] . "'");
                $loan_status = ClxCommon::$db->getField($this->filoname, 'LOAN_STATUS', "IDCODE = '" . $loan_code . "'");
                //fin caso 1004262

                $pay_status = ($op_type === 'PAY' && $prat['PROD_STATUS'] == 'MOR' )?' AND GLPF.PROD_STATUS = '.singleQuote($prat['PROD_STATUS']):'';
                #$pay_status = '';
                $sql = 'SELECT   GLPF.*  FROM ' . $this->glpfname . ' GLPF  WHERE GLPF.PRODUCT_CODE = ' . singleQuote($prat ['PRODUCT_CODE']) . ' AND (GLPF.FEE_FORMULA LIKE ' . singleQuote('P%') . ' OR (GLPF.FEE_FORMULA LIKE ' . singleQuote('F%') . ')) AND GLPF.STATUS = ' . singleQuote('A') . ' ' .$pay_status .'  ORDER BY GLPF.SEQNUM ASC';
                $rs = ClxCommon::$db->executeQuery($sql);

                //caso 1004262
                $count = 0;
                $acum_pay = 0;
                $ult_seqnum = 0;
                $tax = array(
                    'FEE_01_PAY' => 0.00,
                    'FEE_02_PAY' => 0.00,
                    'FEE_03_PAY' => 0.00,
                    'FEE_04_PAY' => 0.00,
                    'FEE_05_PAY' => 0.00
                );
                //fin caso 1004262

                $donegl = array();
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $i = $r ['SEQNUM'];
                    $add_fee_extra_line = false;
                    $jeln_rec = $clear_jeln_rec;
                    if (strpos($r ['FEE_FORMULA'], 'P', CLX_NUM_ZERO) !== false) {
                        if (empty($r ['FEE2_GL_CODE'])) {
                            $jeln_rec ['GLACCOUNTCODE'] = $r ['FEE_GL_CODE'];
                        } else {
                            $jeln_rec ['GLACCOUNTCODE'] = $r ['FEE2_GL_CODE'];
                            $add_fee_extra_line = true;
                            //En pago siempre debe ir contra efectivo el pasivo no contra el ingreso
                            if ($op_type === 'PAY') {
                                $add_fee_extra_line = false;
                            }
                        }
                    } else {
                        if (empty($r ['FEE_GL_CODE'])) {
                            $jeln_rec ['GLACCOUNTCODE'] = $r ['FEE2_GL_CODE'];
                        } else {
                            $jeln_rec ['GLACCOUNTCODE'] = $r ['FEE_GL_CODE'];
                        }
                    }

                    //caso 1004262
                    $count++;
                    if ($ult_seqnum <> $i) {
                        $acum_pay += $_POST ['FIAT_FEE_0' . $i . '_PAY'];
                        $ult_seqnum = $i;
                    }
                    $sql = "
                        SELECT
                            SUM(JCBV.BALANCE_AMT) AS AMOUNT
                        FROM
                            GL_CUR_BALANCE_VW JCBV,
                            FIDU_ITEMS FIAS
                        WHERE
                            JCBV.CHART_FIELD03 = FIAS.IDCODE
                            AND JCBV.CURRENCY_CODE = '".$record['CURRENCY_CODE']."'
                            AND JCBV.GLACCOUNTCODE = '" . $jeln_rec ['GLACCOUNTCODE'] . "'
                            AND FIAS.LOAN_CODE = '" . $loan_code . "'";
                    $tax_amount = ClxCommon::$db->executeQuery($sql);
                    $r_tax_amount = ClxCommon::$db->getNextRecord($tax_amount);
					ClxCommon::$db->freeResult($tax_amount);	
                    if (!empty($r_tax_amount)) {
                        if ($acum_pay >= $r_tax_amount ['AMOUNT']) {
                            $tax ['FEE_0' . $count . '_PAY'] = $r_tax_amount ['AMOUNT'];
                            $acum_pay -= $r_tax_amount ['AMOUNT'];
                        } else {
                            $tax ['FEE_0' . $count . '_PAY'] = $acum_pay;
                            $acum_pay = 0.00;
                        }
                    } else {
                        $tax ['FEE_0' . $count . '_PAY'] = 0.00;
                    }
                    //fin caso 1004262

                    $glacc = ClxCommon::$db->getFields($this->glacname, 'PROVISION, GL_TYPE', 'IDCODE = ' . singleQuote($jeln_rec ['GLACCOUNTCODE']) . ' AND GLGROUP_CODE = ' . singleQuote($r ['GLGROUP_CODE']));
                    $r ['GL_TYPE'] = (!empty($glacc ['GL_TYPE'])) ? $glacc ['GL_TYPE'] : '';
                    $r ['PROVISION'] = (!empty($glacc ['PROVISION'])) ? $glacc ['PROVISION'] : '';
                    $jeln_rec ['ITEM_CODE'] = $r ['FEE_ITEM_CODE'];
                    $jeln_rec ['ITEM_REF_NO'] = '';
                    // Si la comision va por el campo de acumulacion entonces
                    // verificar que no existe mas de una linea
                    if (!empty($donegl [$jeln_rec ['GLACCOUNTCODE']])) {
                        continue;
                    }
                    $donegl [$jeln_rec ['GLACCOUNTCODE']] = CLX_NUM_ONE;
                    if ($op_type === 'DIS') {
                        $by_debit = ($r ['GL_TYPE'] === 'AS' || $r ['GL_TYPE'] === 'EX' || $r ['GL_TYPE'] === 'OR') ? true : false;
                    } else {
                        $by_debit = ($r ['GL_TYPE'] === 'AS' || $r ['GL_TYPE'] === 'EX' || $r ['GL_TYPE'] === 'IN' || $r ['GL_TYPE'] === 'OR') ? false : true;
                        if ($r ['DIVIDER_FACTOR'] == CLX_NUM_ONE) { // means one on payment
                            // check for
                            // sign
                            if ($r ['GL_TYPE'] === 'LI')
                                $by_debit = false;
                        }
                    }
                    if ($r ['PROVISION'] == CLX_NUM_ONE) {
                        $by_debit = ($by_debit) ? false : true;
                    }
                    #$line_amt = UserRequest::$post ['FIAT_FEE_0' . $i . '_PAY']; //comentado por caso 1004262
                    $line_amt = $tax ['FEE_0' . $count . '_PAY'];
                    $tax_line_amt = UserRequest::$post ['FIAT_TAX_0' . $i . '_AMT'];
                    if ($line_amt == CLX_NUM_ZERO) {
                        continue;
                    }
                    if ($line_amt > CLX_NUM_ZERO && $by_debit) {
                        $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                        $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
                    } elseif ($line_amt < CLX_NUM_ZERO && $by_debit) {
                        $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
                        $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                    } elseif ($line_amt > CLX_NUM_ZERO && empty($by_debit)) {
                        $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
                        $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                    } elseif ($line_amt < CLX_NUM_ZERO && empty($by_debit)) {
                        $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                        $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
                    }
                    $jeln_rec ['SEQNUM'] = $seqnum;
                    $seqnum++;
                    $jeln_rec_copy = $jeln_rec;
                    $jeln->jeln_build($jeln_rec_copy);  
                    unset($jeln_rec_copy);

                    // If increment of fees shouldnot be agains cash
                    if (empty($add_fee_extra_line)) {
                        $cash_amt = bcadd($cash_amt, bcsub($jeln_rec ['DEBIT_AMT'], $jeln_rec ['CREDIT_AMT']));
                    } else {
                        // Guardando contrapartida
                        $jeln_rec_save = $jeln_rec;
                        $jeln_rec ['DEBIT_AMT'] = $jeln_rec_save ['CREDIT_AMT'];
                        $jeln_rec ['CREDIT_AMT'] = $jeln_rec_save ['DEBIT_AMT'];
                        if ($jeln_rec ['GLACCOUNTCODE'] == $r ['FEE2_GL_CODE']) {
                            $jeln_rec ['GLACCOUNTCODE'] = $r ['FEE_GL_CODE'];
                        } else {
                            $jeln_rec ['GLACCOUNTCODE'] = $r ['FEE2_GL_CODE'];
                        }
                        $jeln_rec ['SEQNUM'] = $seqnum;
                        $seqnum++;
                        $jeln_rec_copy = $jeln_rec;
                        $jeln->jeln_build($jeln_rec_copy);
                        unset($jeln_rec_copy);
                    }
                    // en caso de ser cuenta de orden es necesario agregar contra partida para evitar
                    if ($r ['GL_TYPE'] === 'OR' && $r ['CINC_GL_CODE'] !== '') {
                        // guardarndo para luego
                        $jeln_rec_save = $jeln_rec;
                        $jeln_rec ['DEBIT_AMT'] = $jeln_rec_save ['CREDIT_AMT'];
                        $jeln_rec ['CREDIT_AMT'] = $jeln_rec_save ['DEBIT_AMT'];
                        if ($jeln_rec ['GLACCOUNTCODE'] == $r ['FEE2_GL_CODE']) {
                            $jeln_rec ['GLACCOUNTCODE'] = $r ['FEE_GL_CODE'];
                        } else {
                            $jeln_rec ['GLACCOUNTCODE'] = $r ['FEE2_GL_CODE'];
                        }
                        $jeln_rec ['SEQNUM'] = $seqnum;
                        $seqnum++;
                        $jeln_rec_copy = $jeln_rec;
                        $jeln->jeln_build($jeln_rec_copy); 
                        unset($jeln_rec_copy);
                        // Agregando linea de ingreso
                        $jeln_rec ['DEBIT_AMT'] = $jeln_rec_save ['DEBIT_AMT'];
                        $jeln_rec ['CREDIT_AMT'] = $jeln_rec_save ['CREDIT_AMT'];
                        $jeln_rec ['GLACCOUNTCODE'] = $r ['CINC_GL_CODE'];
                        $jeln_rec ['SEQNUM'] = $seqnum;
                        $seqnum++;
                        $jeln_rec_copy = $jeln_rec;
                        $jeln->jeln_build($jeln_rec_copy); 
                        unset($jeln_rec_copy);
                        $jeln_rec = $jeln_rec_save;
                        unset($jeln_rec_save);
                    } // end if order
                    // Adding Sales Tax
                    if ($r ['IS_TAXABLE'] == CLX_NUM_ZERO || empty($r ['TAX_GL_CODE']))
                        continue;
                    $gl_type = ClxCommon::$db->getField($this->glacname, 'GL_TYPE', 'IDCODE = ' . singleQuote($r ['TAX_GL_CODE']), 'GLGROUP_CODE = ' . singleQuote($r ['GLGROUP_CODE']));
                    $by_debit = ($gl_type === 'AS' || $gl_type === 'EX') ? true : false;

                    $jeln_rec = $clear_jeln_rec;
                    $jeln_rec ['GLACCOUNTCODE'] = $r ['TAX_GL_CODE'];
                    $jeln_rec ['ITEM_CODE'] = $r ['TAX_ITEM_CODE'];
                    $jeln_rec ['ITEM_REF_NO'] = '';
                    if (substr($r ['FEE_FORMULA'], CLX_NUM_ZERO, CLX_NUM_ONE) === 'F') {
                        // debe calcular en funcion del impuesto si es por
                        // operacion
                        $line_amt = jeit_calculate_item_amt($r ['TAX_ITEM_CODE'], UserRequest::$post ['FIAT_FEE_0' . $i . '_PAY'], UserRequest::$post ['FIAT_EFFTDATE']);
                    } else {
                        // en este caso son acumuladas por proceso monto se
                        // coloca
                        // directamente en la forma de transaccion
                        $line_amt = $tax_line_amt;
                    }
                    // Calculating concepts pct
                    if ($line_amt == CLX_NUM_ZERO)
                        continue;
                    if ($line_amt > CLX_NUM_ZERO && $by_debit) {
                        $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                        $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
                    } elseif ($line_amt < CLX_NUM_ZERO && $by_debit) {
                        $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
                        $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                    } elseif ($line_amt > CLX_NUM_ZERO && empty($by_debit)) {
                        $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
                        $jeln_rec ['CREDIT_AMT'] = abs($line_amt);
                    } elseif ($line_amt < CLX_NUM_ZERO && empty($by_debit)) {
                        $jeln_rec ['DEBIT_AMT'] = abs($line_amt);
                        $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
                    }
                    $jeln_rec ['SEQNUM'] = $seqnum;
                    $seqnum++;
                    $jeln_rec_copy = $jeln_rec;
                    $jeln->jeln_build($jeln_rec_copy);
                    unset($jeln_rec_copy);
                    // If increment of fees shouldnot be agains cash
                    // then adding fee balancing account
                    $cash_amt = bcadd($cash_amt, bcsub($jeln_rec ['DEBIT_AMT'], $jeln_rec ['CREDIT_AMT']));
                } // end while
				ClxCommon::$db->freeResult($rs);
                // Adding deduction amounts
                if (!empty($record ['DEDUCTIBLE_AMT']) && $record ['DEDUCTIBLE_AMT'] > CLX_NUM_ZERO) {
                    $gl_type = ClxCommon::$db->getField($this->glacname, 'GL_TYPE', 'IDCODE = ' . singleQuote($prat ['DEDCTBLE_GL_CODE']), 'GLGROUP_CODE = ' . singleQuote($prat ['GLGROUP_CODE']));
                    $by_debit = ($gl_type === 'AS' || $gl_type === 'EX') ? true : false;
                    $jeln_rec = $clear_jeln_rec;
                    $jeln_rec ['GLACCOUNTCODE'] = $prat ['DEDCTBLE_GL_CODE'];
                    $jeln_rec ['ITEM_CODE'] = 'OT';
                    $jeln_rec ['ITEM_REF_NO'] = '';
                    $jeln_rec ['CHART_FIELD03'] = 'null';
                    if ($record ['DEDUCTIBLE_AMT'] > CLX_NUM_ZERO && $by_debit) {
                        $jeln_rec ['DEBIT_AMT'] = abs($record ['DEDUCTIBLE_AMT']);
                        $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
                    } elseif ($record ['DEDUCTIBLE_AMT'] < CLX_NUM_ZERO && $by_debit) {
                        $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
                        $jeln_rec ['CREDIT_AMT'] = abs($record ['DEDUCTIBLE_AMT']);
                    } elseif ($record ['DEDUCTIBLE_AMT'] > CLX_NUM_ZERO && empty($by_debit)) {
                        $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
                        $jeln_rec ['CREDIT_AMT'] = abs($record ['DEDUCTIBLE_AMT']);
                    } elseif ($line_amt < CLX_NUM_ZERO && empty($by_debit)) {
                        $jeln_rec ['DEBIT_AMT'] = abs($record ['DEDUCTIBLE_AMT']);
                        $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
                    }
                    $jeln_rec ['SEQNUM'] = $seqnum;
                    $seqnum++;
                    $jeln_rec_copy = $jeln_rec;
                    $jeln->jeln_build($jeln_rec_copy);
                    unset($jeln_rec_copy);
                    // If increment of fees shouldnot be agains cash
                    // then adding fee balancing account
                    $cash_amt = bcadd($cash_amt, bcsub($jeln_rec ['DEBIT_AMT'], $jeln_rec ['CREDIT_AMT']));
                }
                // last build cash line seq 1
                $cash_amt = rounder($cash_amt, CLX_NUM_TWO);
                if ($cash_amt != CLX_NUM_ZERO && !($fibk_prat_rec ['PRO_GL_CODE'] === 'null' && $prat ['GL01_CODE'] === '')) {
                    $jeln_rec = $clear_jeln_rec;
                    if (!empty($prat ['GL01_CODE'])) {
                        $jeln_rec ['CHART_FIELD03'] = '';
                        $jeln_rec ['GLACCOUNTCODE'] = $prat ['GL01_CODE'];
                        $jeln_rec ['ITEM_REF_NO'] = '';
                    } else {
                        $jeln_rec ['CHART_FIELD03'] = $fibk_prat_rec ['CASH_ASSET_CODE'];
                        $jeln_rec ['GLACCOUNTCODE'] = $fibk_prat_rec ['PRO_GL_CODE'];
                        $jeln_rec ['ITEM_REF_NO'] = $record ['FIDU_BANKACT_CODE'];
                    }
                    $jeln_rec ['ITEM_CODE'] = 'CRED';
                    if ($cash_amt > CLX_NUM_ZERO) {
                        $jeln_rec ['DEBIT_AMT'] = CLX_INIT_ZERO;
                        $jeln_rec ['CREDIT_AMT'] = $cash_amt;
                    } else {
                        $jeln_rec ['DEBIT_AMT'] = rounder(bcmul(- CLX_NUM_ONE, $cash_amt), CLX_NUM_TWO);
                        $jeln_rec ['CREDIT_AMT'] = CLX_INIT_ZERO;
                    }
                    $jeln_rec ['SEQNUM'] = $seqnum;
                    $seqnum++;
                    $jeln_rec_copy = $jeln_rec;
                    $jeln->jeln_build($jeln_rec_copy);
                    unset($jeln_rec_copy);
                }
            }
        }

        /**
         * Credit specific validations
         *
         * @param array $record
         * @param array $msg
         */
        private function fiat_cred_validate_form(&$record, &$msg) {
            if (!array_key_exists('FIAT_TRANSTBL_CODE', $record)) {
                return;
            }
            if ($record ['FIAT_TRANSTBL_CODE'] !== 'SYS_CRED-PYMT' && $record ['FIAT_TRANSTBL_CODE'] !== 'SYS_CRED-DISB' && $record ['FIAT_TRANSTBL_CODE'] !== 'SYS_CRED-ADJ') {
                return; // return if not credit
            }
            if (!class_exists('Filo'))
                includeCodeLib('FILO');
            $filo = new Filo ();
            getLookupValue('FIAT_GLACCOUNTCODE', 'GLACCOUNTCODE', $record); // glaccountcode
            // Set
            // post
            // amounts
            // validation
            if (array_key_exists('FIAT_PRINCIPAL_EFFECT', UserRequest::$post)) {
                $debit_credit = UserRequest::$post ['FIAT_PRINCIPAL_EFFECT'];
                $loan_code = UserRequest::$post ['FIAT_LOAN_CODE'];
                $op_loan_amt = UserRequest::$post ['FIAT_PRINCIPAL_PAY'];
            } else {
                $loan_code = $filo->get_loan_code_by_fias($record ['FIAT_CHART_FIELD03']);
                $is_asset = $filo->is_asset($loan_code);
                $op_loan_amt = (array_key_exists('FIAT_PRINCIPAL_PAY', UserRequest::$post)) ? UserRequest::$post ['FIAT_PRINCIPAL_PAY'] : CLX_NUM_ZERO;
                if ($is_asset === true && $op_loan_amt > CLX_NUM_ZERO)
                    $debit_credit = 'I';
                elseif (empty($is_asset) && $op_loan_amt < CLX_NUM_ZERO)
                    $debit_credit = 'I';
                else
                    $debit_credit = 'D';
                $op_loan_amt = bcabs($op_loan_amt);
            }
            if ($record ['FIAT_TRANSTBL_CODE'] === 'SYS_CRED-DISB') {
                $sql = 'SELECT  IFNULL(FILO.LOAN_AMT-FILO.PRINCIPAL_BAL,0) LOAN_AMT FROM  ' . $this->filoname . ' FILO WHERE  FILO.IDCODE = ' . singleQuote($loan_code) . '  AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)    FROM ' . $this->filoname . ' FILOX    WHERE FILOX.IDCODE = ' . singleQuote($loan_code) . '    AND FILOX.CLX_EFFTDATE<=NOW())';
            } else {
                // Check if interest greater than available on installment
                if ((UserRequest::$request['ac'] === 'REQAUTHORIZATION' || defined('proc_fiat_jehd_approval')) && !empty($record ['FIAT_INTEREST_PAY']) && $record ['FIAT_TRANSTBL_CODE'] <> 'SYS_CRED-ADJ') {
                    $sql = 'SELECT    PRLT.SIMPLE_INTEREST,    FILO.IDCODE LOAN_CODE,    FILO.CLX_EFFTDATE,    ROUND(SUM(FILO.INTEARNED_AMT-FILO.INTPAID_AMT), 2) INTBALANCE_AMT  FROM   ' . $this->filoname . ' FILO,   '.$this->prltname.' PRLT  WHERE   FILO.PRODUCT_CODE = PRLT.PRODUCT_CODE   AND FILO.IDCODE = ' . singleQuote((isset($record ['FIAT_LOAN_CODE'])) ? $record ['FIAT_LOAN_CODE']:$loan_code)  . '   AND FILO.CLX_EFFTDATE =(SELECT MAX(X.CLX_EFFTDATE)   FROM ' . $this->filoname . ' X   WHERE X.IDCODE = FILO.IDCODE    AND X.CLX_EFFTDATE <=NOW())  GROUP BY    PRLT.SIMPLE_INTEREST,    FILO.IDCODE,    FILO.CLX_EFFTDATE';
                    $prltrec = ClxCommon::$db->getOneRecord($sql);
                    if ($prltrec ['SIMPLE_INTEREST'] == CLX_NUM_ZERO) {
                        $sql = 'SELECT SUM(FILS.INTEREST_PAY-FILS.INTPAID_AMT) INTEREST_AMT FROM ' . $this->filsname . ' FILS WHERE FILS.LOAN_CODE = ' . singleQuote($prltrec ['LOAN_CODE']) . ' AND FILS.EFFTDATE = ' . singleQuote($prltrec ['CLX_EFFTDATE']) . ' AND FILS.PERIOD_START_DATE <= ' . singleQuote($record ['FIAT_EFFTDATE']);
                        $intbalance = ClxCommon::$db->getOne($sql);
                        if (abs($record ['FIAT_INTEREST_PAY']) > abs($intbalance)) {
                            $msg ['FIAT_INTEREST_PAY'] = smsg('MSG-222', no_format($intbalance, CLX_NUM_TWO));
                        }
                    } else{
                        //Chequear si la cuenta contable permite sobregiro
                        $overdraft = $this->checkOverDraft($loan_code);
                        if ($record ['FIAT_INTEREST_PAY'] > $prltrec ['INTBALANCE_AMT'] && !$overdraft) {
                            $msg ['FIAT_INTEREST_PAY'] = smsg('MSG-222', no_format($prltrec ['INTBALANCE_AMT'], CLX_NUM_TWO));
                        }
                    }
                }
                $sql = 'SELECT  IFNULL(FILO.PRINCIPAL_BAL,0) LOAN_AMT FROM  ' . $this->filoname . ' FILO WHERE  FILO.IDCODE = ' . singleQuote($loan_code) . '  AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)    FROM ' . $this->filoname . ' FILOX    WHERE FILOX.IDCODE = ' . singleQuote($loan_code) . '    AND FILOX.CLX_EFFTDATE<=NOW())';
            }
            $loan_amt = ClxCommon::$db->getOne($sql);
            if ((UserRequest::$request['ac'] == 'CREATE' || UserRequest::$request['ac'] == 'DUPLICATE') && $record ['FIAT_TRANSTBL_CODE'] === 'SYS_CRED-DISB' && empty($record['REV_TRANS_CODE'])) {
                $sql = 'SELECT IFNULL(ABS(SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT)),0) FROM FIDU_TRANSACTIONS FIAT, GL_JOURNAL_HDR JEHD, GL_JOURNAL_LINES JELN, FIDU_ITEMS FIAS WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JEHD.TRANS_CODE = FIAT.IDCODE AND JELN.CHART_FIELD03 = FIAS.IDCODE AND FIAS.LOAN_CODE = ' . singleQuote($loan_code) . ' AND EXISTS(SELECT PRAT.ID FROM GL_PROD_PRMTR_TBL PRAT WHERE PRAT.PRO_GL_CODE = JELN.GLACCOUNTCODE) AND FIAT.TRANS_STATUS IN (' . singleQuote('PEND') . ',' . singleQuote('OPQU') . ')';
                $loan_amt = bcsub($loan_amt, ClxCommon::$db->getOne($sql), 2);
            }

            if ($loan_amt < $op_loan_amt && $debit_credit === 'I') {
                if (array_key_exists('FIAT_PRINCIPAL_PAY', UserRequest::$post)) {
                    $msg ['FIAT_PRINCIPAL_PAY'] = smsg('MSG-153', $loan_amt, $record ['FIAT_IDCODE']);
                } else {
                    $msg ['FIAT_TRANS_AMT'] = smsg('MSG-153', $loan_amt, $record ['FIAT_IDCODE']);
                }
            }
            // validate gl parameters for current status
            if (!$filo->has_parameters($loan_code)) {
                $DBLT = &getTool('DBLT');
                $prod_code = $filo->get_cred_product_code($loan_code);
                $msg ['FIAT_IDNAME'] = smsg('MSG-158', $prod_code, $DBLT->getListItem('CRTT', $record ['FIAT_PAY_APPLIES_TO'], true));
            }
            $sql = 'SELECT COUNT(ID) FROM ' . $this->filoname . ' WHERE IDCODE = ' . singleQuote($loan_code) . '  AND LOAN_STATUS IN (' . singleQuote('CAN') . ',' . singleQuote('PRE') . ')  AND CLX_EFFTDATE = (SELECT MAX(CLX_EFFTDATE)  FROM ' . $this->filoname . '   WHERE IDCODE = ' . singleQuote($loan_code) . '   AND CLX_EFFTDATE<=' . singleQuote($this->today) . ')';
            if (ClxCommon::$db->getOne($sql) != CLX_NUM_ZERO) {
                $msg ['FIAT_COMP_CODE'] = smsg('MSG-200', $record ['FIAT_IDCODE']);
            }

            // Must be glaccountcode or bank accountcode could not be both
            if (!empty($record ['FIAT_FIDU_BANKACT_CODE']) && !empty($record ['FIAT_GLACCOUNTCODE'])) {
                $msg ['FIAT_FIDU_BANKACT_CODE'] = smsg('MSG-203', $record ['FIAT_IDCODE']);
            }
            unset($filo);
        }

        /**
         * Prepares transaction choose form
         *
         * @param string $title
         * @param string $formcode
         * @param array $msg
         * @param string $type
         * @return string
         */
        function prompt_dialog($title, $formcode, &$msg, $type = 'PAY') {
            $to = UserRequest::$request [CLX_PROP_TO];
            $it = UserRequest::$request ['it'];
            // RTBL_REPCINV
            $EDIT = &getTool('EDIT');
            $record = array();
            $msg = array();
            $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote($formcode));
            $record = UserRequest::$post;
            if (!empty($record ['confirm'])) {
                $EDIT->checkForm2($formrec, $msg);
                switch ($formrec ['MODULECODE']) {
                    case 'GUAR':
                        if (empty($msg)) { // additional validations
                            UserRequest::$request ['li'] = 'FIAT_GUAR_SRCH'; // to enable list after
                            // save
                            pushHistory('EDIT', 'LIST', '', 'li', 'FIAT_GUAR_SRCH');
                        }
                        break;
                    case 'AMGT':
                        if (empty($msg)) { // additional validations
                            UserRequest::$request ['li'] = 'FIAT_AMGT_SRCH'; // to enable list after
                            // save
                            pushHistory('EDIT', 'LIST', '', 'li', 'FIAT_AMGT_SRCH');
                        }
                        break;
                    case 'CASH':
                        if (empty($msg)) { // additional validations
                            UserRequest::$request ['li'] = 'FIAT_CA_SRCH'; // to enable list after
                            // save
                            pushHistory('EDIT', 'LIST', '', 'li', 'FIAT_CA_SRCH');
                        }
                        break;
                    default:
                        if (empty($msg)) { // additional validations
                            $sql = 'SELECT COUNT(ID) FROM ' . $this->filoname . ' WHERE IDCODE = ' . singleQuote($record ['FIAT_LOAN_CODE']) . ' AND COMP_CODE = ' . singleQuote($record ['FIAT_COMP_CODE']);
                            if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
                                $msg ['FIAT_LOAN_CODE'] = smsg('MSG-154');
                            }
                        }
                        if (empty($msg)) {
                            if ($type === 'DIS') {
                                UserRequest::$request ['li'] = 'FIAT_CRED_D_SRCH';
                                // to enable list after save
                                pushHistory('EDIT', 'LIST', '', 'li', 'FIAT_CRED_D_SRCH');
                            } elseif ($type === 'PAY') {
                                UserRequest::$request ['li'] = 'FIAT_CRED_P_SRCH';
                                // to enable list after save
                                pushHistory('EDIT', 'LIST', '', 'li', 'FIAT_CRED_P_SRCH');
                            } elseif ($type === 'CRED_OTH') {
                                UserRequest::$request ['li'] = 'FIAT_CRED';
                                // to enable list after save
                                pushHistory('EDIT', 'LIST', '', 'li', 'FIAT_CRED');
                            } else { // adj
                                UserRequest::$request ['li'] = 'FIAT_CRED_SRCH';
                                // to enable list after save
                                pushHistory('EDIT', 'LIST', '', 'li', 'FIAT_CRED_SRCH');
                            }
                        }
                        break;
                }
                if (empty($msg)) {
                    // Setting default
                    unset(UserRequest::$post ['confirm']);
                    return $EDIT->action('CREATE', CLX_NUM_ZERO);
                }
            } else {
                // set default values if required
                if (!class_exists('Comp'))
                    includeCodeLib('COMP');
                $comp = new Comp ();
                $comprec = $comp->comp_operation_parameters('');
                $record ['FIAT_COMP_CODE'] = $comprec ['IDCODE'];
                unset($comp, $comprec);
            }
            clearHistory();
            $form = $EDIT->defaultForm($formrec, $record, $msg, UserRequest::$request['ac'], $to, $it, 'tool.php', '', $title, dict('GEN_LBL_EXECUTE'));
            return $form->source();
        }

        // GUARRANTY RELATED METHODS
        /**
         * Guarranties specific validations
         *
         * @param array $record
         * @param array $msg
         */
        private function fiat_guar_validate_form(&$record, &$msg) {
            if (!array_key_exists('FIAT_TRANSTBL_CODE', $record)) {
                return;
            }
            $sql = 'SELECT FIAS.IDCODE, GUAR.GUARANTEE_PCT, GUAR.AVAILABLE_PCT, GUAR.GUARANTEE_AMT, GUAR.BALANCE_AMT, (GUAR.GUARANTEE_AMT-GUAR.BALANCE_AMT) AVAILABLE, FIAS.ACCOUNTCODE, FIAS.CONTRACT_CODE, FICO.CONTRACT_NUMBER, FICO.IDNAME, FIAS.IDNAME FIASNAME, GLAC.GL_TYPE FROM ' . $this->ficoname . ' FICO, ' . $this->guarname . ' GUAR,   ' . $this->fiasname . ' FIAS,   ' . $this->glacname . ' GLAC,  ' . $this->pratname . ' PRAT   WHERE   FICO.IDCODE = FIAS.CONTRACT_CODE   AND FIAS.GUAR_CODE = GUAR.IDCODE   AND PRAT.PRODUCT_CODE = GUAR.PRODUCT_CODE  AND GLAC.IDCODE = PRAT.PRO_GL_CODE  AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . '   AND FIAS.IDCODE = ' . singleQuote($record ['FIAT_CHART_FIELD03']) . '   AND GUAR.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE)    FROM ' . $this->guarname . ' X    WHERE X.IDCODE = GUAR.IDCODE)';
            $guarrec = ClxCommon::$db->getOneRecord($sql);
            if (empty($guarrec))
                return;
            $sql = 'SELECT  FITS.DEBIT_CREDIT FROM  ' . $this->fitsname . ' FITS WHERE  FITS.TRANSTBL_CODE = ' . singleQuote($record ['FIAT_TRANSTBL_CODE']) . '  AND FITS.AFFECT_TYPE = ' . singleQuote('PRO_GL');
            switch (ClxCommon::$db->getOne($sql)) {
                case 'DR' :
                    if ($guarrec ['GL_TYPE'] === 'LI') {
                        // disminulle
                        if (($guarrec ['BALANCE_AMT'] - $record ['FIAT_TRANS_AMT']) < CLX_NUM_ZERO) {
                            // mensaje de saldo no disponible
                            $msg ['FIAT_TRANS_AMT'] = smsg('MSG-248', $record ['FIAT_IDCODE'], $guarrec ['BALANCE_AMT'], $record ['FIAT_TRANS_AMT']);
                        }
                    } else {
                        // aumenta
                        if (($guarrec ['AVAILABLE'] - $record ['FIAT_TRANS_AMT']) < CLX_NUM_ZERO) {
                            $msg ['FIAT_TRANS_AMT'] = smsg('MSG-248', $record ['FIAT_IDCODE'], $guarrec ['AVAILABLE'], $record ['FIAT_TRANS_AMT']);
                        }
                    }
                    break;
                case 'CR' :
                    if ($guarrec ['GL_TYPE'] === 'LI') {
                        // aumenta
                        if (($guarrec ['AVAILABLE'] - $record ['FIAT_TRANS_AMT']) < CLX_NUM_ZERO) {
                            $msg ['FIAT_TRANS_AMT'] = smsg('MSG-248', $record ['FIAT_IDCODE'], $guarrec ['AVAILABLE'], $record ['FIAT_TRANS_AMT']);
                        }
                    } else {
                        if (($guarrec ['BALANCE_AMT'] - $record ['FIAT_TRANS_AMT']) < CLX_NUM_ZERO) {
                            $msg ['FIAT_TRANS_AMT'] = smsg('MSG-248', $record ['FIAT_IDCODE'], $guarrec ['BALANCE_AMT'], $record ['FIAT_TRANS_AMT']);
                        }
                    }
                    break;
                default :
                    break;
            } // end switch
        }

        /**
         * Builds operation guarranty defaults
         *
         * @param
         *     $record
         */
        function init_guar_defaults(&$record) {
            if (!empty($record ['FIAT_GUAR_CODE'])) {
                $sql = 'SELECT DISTINCT   FIAS.IDCODE,   GUAR.GUARANTEE_PCT,   GUAR.AVAILABLE_PCT,   GUAR.GUARANTEE_AMT,   GUAR.BALANCE_AMT,   GUAR.FEE_CHARGED_AMT,  GUAR.FEE_AMORTIZED_AMT,   FIAS.ACCOUNTCODE,   FIAS.CONTRACT_CODE,   FICO.CONTRACT_NUMBER,   FICO.IDNAME,   FIAS.IDNAME FIASNAME,   GLAC.GL_TYPE   FROM   ' . $this->ficoname . ' FICO,   ' . $this->guarname . ' GUAR,   ' . $this->fiasname . ' FIAS,   ' . $this->glacname . ' GLAC,  ' . $this->pratname . ' PRAT   WHERE   FICO.IDCODE = FIAS.CONTRACT_CODE   AND FIAS.GUAR_CODE = GUAR.IDCODE   AND PRAT.PRODUCT_CODE = GUAR.PRODUCT_CODE  AND GLAC.IDCODE = PRAT.PRO_GL_CODE  AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . '   AND GUAR.IDCODE = ' . singleQuote($record ['FIAT_GUAR_CODE']) . '   AND GUAR.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE)    FROM ' . $this->guarname . ' X    WHERE X.IDCODE = GUAR.IDCODE)';
                $guarrec = ClxCommon::$db->getOneRecord($sql);
                $record ['FIAT_GUARANTEE_PCT'] = $guarrec ['GUARANTEE_PCT'];
                $record ['FIAT_AVAILABLE_PCT'] = $guarrec ['AVAILABLE_PCT'];
                $record ['FIAT_CHART_FIELD01'] = $guarrec ['CONTRACT_CODE'];
                $record ['FIAT_CHART_FIELD01_prim'] = $guarrec ['CONTRACT_NUMBER'];
                $record ['FIAT_CHART_FIELD01_secd'] = $guarrec ['IDNAME'];
                $record ['FIAT_CHART_FIELD02'] = $guarrec ['ACCOUNTCODE'];
                $record ['FIAT_CHART_FIELD02_prim'] = $guarrec ['ACCOUNTCODE'];
                $record ['FIAT_CHART_FIELD03'] = $guarrec ['IDCODE'];
                $record ['FIAT_CHART_FIELD03_prim'] = $guarrec ['IDCODE'];
                $record ['FIAT_CHART_FIELD03_secd'] = $guarrec ['FIASNAME'];
                // Test amount to be set it
                $sql = 'SELECT  FITS.AFFECT_TYPE,  FITS.DEBIT_CREDIT  FROM  ' . $this->fitsname . ' FITS  WHERE  FITS.TRANSTBL_CODE = ' . singleQuote($record ['FIAT_TRANSTBL_CODE']) . '  AND FITS.AFFECT_TYPE IN (' . singleQuoteArray(array('PRO_GL', 'GL01')) . ')';
                // Product balancing account (Optional)(GL01) GUAR, Garantia
                // (GUAR)Credit(CR)
                $opertype = ClxCommon::$db->getOneRecord($sql);
                switch ($opertype ['DEBIT_CREDIT']) {
                    case 'DR' :
                        if ($guarrec ['GL_TYPE'] === 'LI' && $opertype ['AFFECT_TYPE'] === 'PRO_GL') {
                            $record ['FIAT_TRANS_AMT'] = $guarrec ['BALANCE_AMT'];
                        } else {
                            $record ['FIAT_TRANS_AMT'] = ($guarrec ['GUARANTEE_AMT'] - $guarrec ['BALANCE_AMT']);
                        }
                        break;
                    case 'CR' :
                        if ($guarrec ['GL_TYPE'] === 'LI' && $opertype ['AFFECT_TYPE'] === 'PRO_GL') {
                            $record ['FIAT_TRANS_AMT'] = ($guarrec ['GUARANTEE_AMT'] - $guarrec ['BALANCE_AMT']);
                        } else {
                            $record ['FIAT_TRANS_AMT'] = $guarrec ['BALANCE_AMT'];
                        }
                        break;
                    default :
                        break;
                } // end switch
                // (AP_GL
                $sql = 'SELECT  FITS.ID  FROM  ' . $this->fitsname . ' FITS  WHERE  FITS.TRANSTBL_CODE = ' . singleQuote($record ['FIAT_TRANSTBL_CODE']) . '  AND FITS.DEBIT_CREDIT = ' . "'DR'" . '  AND FITS.AFFECT_TYPE = ' . singleQuote('AP_GL');
                // Product balancing account (Optional)(GL01) GUAR, Garantia
                // (GUAR)Credit(CR)
                $opertype = ClxCommon::$db->getOneRecord($sql);
                if (!empty($opertype)) {
                    $record ['FIAT_FEES_AMT'] = rounder($guarrec ['FEE_CHARGED_AMT'] - $guarrec ['FEE_AMORTIZED_AMT'], CLX_NUM_TWO);
                } // end switch
            }
            if (empty($record ['FIAT_GUAR_CODE']) && !empty($record ['FIAT_CHART_FIELD03'])) {
                $sql = 'SELECT GUAR.IDCODE, GUAR.IDNAME  FROM ' . $this->guarname . ' GUAR, ' . $this->fiasname . ' FIAS  WHERE FIAS.IDCODE = ' . singleQuote($record ['FIAT_CHART_FIELD03']) . '  AND FIAS.GUAR_CODE = GUAR.IDCODE';
                $guarrec = ClxCommon::$db->getOneRecord($sql);
                if (!empty($guarrec)) {
                    $record ['FIAT_GUAR_CODE'] = $guarrec ['IDCODE'];
                    $record ['FIAT_GUAR_CODE_prim'] = $guarrec ['IDCODE'];
                    $record ['FIAT_GUAR_CODE_secd'] = $guarrec ['IDNAME'];
                }
            }
        }

        /**
         * Asset Managment especific validations
         *
         * @param array $record
         * @param array $msg
         */
        private function fiat_amgt_validate_form(&$record, &$msg) {

        }

        /**
         * Load cash record elements on code call
         * @param type $record
         */
        private function init_cash_defaults(&$record) {
            if (array_key_exists('FIAT_COMP_CODE', UserRequest::$request) && empty($record['FIAT_COMP_CODE']))
                $record['FIAT_COMP_CODE'] = UserRequest::$request['FIAT_COMP_CODE'];
            if (array_key_exists('FIAT_TRANSTBL_CODE', UserRequest::$request) && empty($record['FIAT_TRANSTBL_CODE']))
                $record['FIAT_TRANSTBL_CODE'] = UserRequest::$request['FIAT_TRANSTBL_CODE'];
            if (array_key_exists('FIAT_TRANSTBL_CODE_prim', UserRequest::$request) && empty($record['FIAT_TRANSTBL_CODE_prim']))
                $record['FIAT_TRANSTBL_CODE_prim'] = UserRequest::$request['FIAT_TRANSTBL_CODE_prim'];
            if (array_key_exists('FIAT_TRANSTBL_CODE_secd', UserRequest::$request) && empty($record['FIAT_TRANSTBL_CODE_secd']))
                $record['FIAT_TRANSTBL_CODE_secd'] = UserRequest::$request['FIAT_TRANSTBL_CODE_secd'];
            if (array_key_exists('FIAT_CHART_FIELD01', UserRequest::$request) && empty($record['FIAT_CHART_FIELD01']))
                $record['FIAT_CHART_FIELD01'] = UserRequest::$request['FIAT_CHART_FIELD01'];
            if (array_key_exists('FIAT_CHART_FIELD01_prim', UserRequest::$request) && empty($record['FIAT_CHART_FIELD01_prim']))
                $record['FIAT_CHART_FIELD01_prim'] = UserRequest::$request['FIAT_CHART_FIELD01_prim'];
            if (array_key_exists('FIAT_CHART_FIELD01_secd', UserRequest::$request) && empty($record['FIAT_CHART_FIELD01_secd']))
                $record['FIAT_CHART_FIELD01_secd'] = UserRequest::$request['FIAT_CHART_FIELD01_secd'];
            if (array_key_exists('FIAT_FIDU_BANKACT_CODE', UserRequest::$request) && empty($record['FIAT_FIDU_BANKACT_CODE']))
                $record['FIAT_FIDU_BANKACT_CODE'] = UserRequest::$request['FIAT_FIDU_BANKACT_CODE'];
            if (array_key_exists('FIAT_FIDU_BANKACT_CODE_prim', UserRequest::$request) && empty($record['FIAT_FIDU_BANKACT_CODE_prim']))
                $record['FIAT_FIDU_BANKACT_CODE_prim'] = UserRequest::$request['FIAT_FIDU_BANKACT_CODE_prim'];
            if (array_key_exists('FIAT_FIDU_BANKACT_CODE_secd', UserRequest::$request) && empty($record['FIAT_FIDU_BANKACT_CODE_secd']))
                $record['FIAT_FIDU_BANKACT_CODE_secd'] = UserRequest::$request['FIAT_FIDU_BANKACT_CODE_secd'];

            $sql = 'SELECT FIBK.COMP_CODE, FIBK.BENEFICIARY_NAME, FIBK.CURRENCY_CODE, FIBK.BANK_ACCOUNT_NO, FIAS.IDCODE, FIAS.CONTRACT_CODE, FIAS.IDNAME, FIBK.DEF_BANKACC_CODE, FIBK.IS_CDAC FROM FIDU_ITEMS FIAS, FIDU_BANK_ACCOUNTS FIBK WHERE FIBK.BANK_ACCOUNT_NO = ' . singleQuote($record['FIAT_FIDU_BANKACT_CODE']) . ' AND FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE AND FIAS.CONTRACT_CODE = ' . singleQuote($record['FIAT_CHART_FIELD01']);
            $fibkinfo = ClxCommon::$db->getOneRecord($sql);
            if (!empty($fibkinfo)) {
                $record['FIAT_COMP_CODE'] = $fibkinfo['COMP_CODE'];
                $record['FIAT_CURRENCY_CODE'] = $fibkinfo['CURRENCY_CODE'];
                $record['FIAT_BENEFICIARY_NAME'] = $fibkinfo['BENEFICIARY_NAME'];
            }

            if (!empty($fibkinfo['IS_CDAC']) && !empty($fibkinfo['DEF_BANKACC_CODE'])) {
                $record['FIAT_FIDU_BANKACT_CODE'] = $fibkinfo['DEF_BANKACC_CODE'];
                $record['FIAT_CHART_FIELD03'] = $fibkinfo['IDCODE'];
                $record['FIAT_CHART_FIELD03_prim'] = $fibkinfo['IDCODE'];
                $record['FIAT_CHART_FIELD03_secd'] = $fibkinfo['IDNAME'];
            }
        }

        /**
         * Builds operation guarranty defaults
         *
         * @param
         *     $record
         */
        function init_amgt_defaults(&$record) {

            getLookupValue('FIAT_ASSET_CODE', 'ASSET_CODE', $record);
            if (!empty($record ['FIAT_ASSET_CODE']) && (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'CODE')) {
                $sql = 'SELECT DISTINCT FIAE.CURRENCY_CODE,FIAS.IDCODE, FIAS.ACCOUNTCODE, FIAS.CONTRACT_CODE, FICO.CONTRACT_NUMBER, FICO.IDNAME, FIAS.IDNAME FIASNAME FROM ' . $this->ficoname . ' FICO, ' . $this->fiaename . ' FIAE, ' . $this->fiasname . ' FIAS WHERE FICO.IDCODE = FIAS.CONTRACT_CODE AND FIAS.ASSET_CODE = FIAE.IDCODE AND FIAE.IDCODE = ' . singleQuote($record ['FIAT_ASSET_CODE']) . ' AND FIAE.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->fiaename . ' X WHERE X.IDCODE = FIAE.IDCODE)';
                $fiaerec = ClxCommon::$db->getOneRecord($sql);
                $record ['FIAT_CURRENCY_CODE'] = $fiaerec ['CURRENCY_CODE'];
                $record ['FIAT_CHART_FIELD01'] = $fiaerec ['CONTRACT_CODE'];
                $record ['FIAT_CHART_FIELD01_prim'] = $fiaerec ['CONTRACT_NUMBER'];
                $record ['FIAT_CHART_FIELD01_secd'] = $fiaerec ['IDNAME'];
                $record ['FIAT_CHART_FIELD02'] = $fiaerec ['ACCOUNTCODE'];
                $record ['FIAT_CHART_FIELD02_prim'] = $fiaerec ['ACCOUNTCODE'];
                $record ['FIAT_CHART_FIELD03'] = $fiaerec ['IDCODE'];
                $record ['FIAT_CHART_FIELD03_prim'] = $fiaerec ['IDCODE'];
                $record ['FIAT_CHART_FIELD03_secd'] = $fiaerec ['FIASNAME'];
                $sql = 'SELECT ACCO.IDCODE, ACCO.IDNAME, ACCO.IDENTIFICATION  FROM ' . $this->acconame . ' ACCO, ' . $this->fipaname . ' FIPA  WHERE FIPA.ACCOUNTCODE = ACCO.IDCODE AND FIPA.CONTRACT_CODE = ' . singleQuote($fiaerec ['CONTRACT_CODE']) . ' AND (ACCO.IDCODE = ' . singleQuote($fiaerec ['ACCOUNTCODE']) . ' OR (' . singleQuote($fiaerec ['ACCOUNTCODE']) . ' = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND FIPA.ISPRIMARY = 1))';
                $fiaerec = ClxCommon::$db->getOneRecord($sql);
                $record ['FIAT_CHART_FIELD02'] = $fiaerec ['IDCODE'];
                $record ['FIAT_CHART_FIELD02_prim'] = $fiaerec ['IDCODE'];
                $record ['FIAT_CHART_FIELD02_secd'] = $fiaerec ['IDNAME'];
                $record ['FIAT_CHART_FIELD02_terc'] = $fiaerec ['IDENTIFICATION'];
            }
            if (UserRequest::$request['ac'] === 'CODE') {
                $fitbrec = ClxCommon::$db->getRecord($this->fitbname, 'IDCODE =' . singleQuote($record ['FIAT_TRANSTBL_CODE']));
                if (!empty($fitbrec ['SET_ASSET_VALUE'])) {
                    // setting asset value from asset
                    /* 1, contable, FIAE_001 Asset Purchase Amount, FIAE_002 monto depreciacion */
                    switch ($fitbrec ['SET_ASSET_VALUE']) {
                        case 'FIAE_001':
                            $sql = 'SELECT ROUND(FIAE.PURCHASE_AMT, 2) BALANCE  FROM ' . $this->fiaename . ' FIAE, ' . $this->fiasname . ' FIAS, ' . $this->pratname . ' PRAT WHERE FIAS.ASSET_CODE = FIAE.IDCODE AND PRAT.PRODUCT_CODE = FIAE.PRODUCT_CODE AND FIAE.IDCODE = ' . singleQuote($record ['FIAT_ASSET_CODE']) . ' AND FIAE.CLX_EFFTDATE = (SELECT MAX(FIAEX.CLX_EFFTDATE) FROM ' . $this->fiaename . ' FIAEX WHERE FIAEX.IDCODE = FIAE.IDCODE AND FIAEX.CLX_EFFTDATE<=' . singleQuote($this->now) . ')';
                            break;
                        case 'FIAE_002':
                            $sql = 'SELECT ROUND(FIAE.DEPRECIATION_AMT, 2) BALANCE FROM ' . $this->fiaename . ' FIAE, ' . $this->fiasname . ' FIAS WHERE FIAS.ASSET_CODE = FIAE.IDCODE  AND FIAE.IDCODE = ' . singleQuote($record ['FIAT_ASSET_CODE']) . ' AND FIAE.CLX_EFFTDATE = (SELECT MAX(FIAEX.CLX_EFFTDATE) FROM ' . $this->fiaename . ' FIAEX WHERE FIAEX.IDCODE = FIAE.IDCODE AND FIAEX.CLX_EFFTDATE<=' . singleQuote($this->now) . ')';
                            break;
                        case 'FIAE_003'://compra menos depreciacion acumulada
                            $sql = 'SELECT ROUND((IFNULL((SELECT SUM(JCBV.BALANCE_AMT) FROM GL_CUR_BALANCE_VW JCBV WHERE JCBV.CHART_FIELD03 = FIAS.IDCODE AND JCBV.GLACCOUNTCODE IN (PRAT.PRO_GL_CODE,PRAT.DPRAC_GL_CODE)),0)), 2) BALANCE FROM ' . $this->fiaename . ' FIAE, ' . $this->fiasname . ' FIAS, ' . $this->pratname . ' PRAT WHERE FIAS.ASSET_CODE = FIAE.IDCODE AND PRAT.PRODUCT_CODE = FIAE.PRODUCT_CODE AND FIAE.IDCODE = ' . singleQuote($record ['FIAT_ASSET_CODE']) . ' AND FIAE.CLX_EFFTDATE = (SELECT MAX(FIAEX.CLX_EFFTDATE) FROM ' . $this->fiaename . ' FIAEX   WHERE FIAEX.IDCODE = FIAE.IDCODE   AND FIAEX.CLX_EFFTDATE<=' . singleQuote($this->now) . ')';
                            break;
                        default:
                            $sql = 'SELECT ROUND((IFNULL((SELECT SUM(JCBV.BALANCE_AMT) FROM GL_CUR_BALANCE_VW JCBV WHERE JCBV.CHART_FIELD03 = FIAS.IDCODE AND JCBV.GLACCOUNTCODE = PRAT.PRO_GL_CODE),0)), 2) BALANCE FROM ' . $this->fiaename . ' FIAE, ' . $this->fiasname . ' FIAS,   ' . $this->pratname . ' PRAT WHERE   FIAS.ASSET_CODE = FIAE.IDCODE   AND PRAT.PRODUCT_CODE = FIAE.PRODUCT_CODE   AND FIAE.IDCODE = ' . singleQuote($record ['FIAT_ASSET_CODE']) . ' AND FIAE.CLX_EFFTDATE = (SELECT MAX(FIAEX.CLX_EFFTDATE) FROM ' . $this->fiaename . ' FIAEX WHERE FIAEX.IDCODE = FIAE.IDCODE AND FIAEX.CLX_EFFTDATE<=' . singleQuote($this->now) . ')';
                            break;
                    }
                    $fiae_bal = ClxCommon::$db->getOne($sql);
                    if ($fiae_bal > CLX_NUM_ZERO) {
                        $record ['FIAT_TRANS_AMT'] = $fiae_bal;
                        $record ['FIAT_BASE_TRANS_AMT'] = round($record ['FIAT_TRANS_AMT'] * pow($record ['FIAT_EXCHANGE_RT'], $record ['FIAT_CUR_OPERATOR']), CLX_NUM_TWO);
                    }
                }
            }
            if (empty($record ['FIAT_ASSET_CODE']) && !empty($record ['FIAT_CHART_FIELD03'])) {
                $sql = 'SELECT FIAE.IDCODE, FIAE.IDNAME  FROM ' . $this->fiaename . ' FIAE, ' . $this->fiasname . ' FIAS  WHERE FIAS.IDCODE = ' . singleQuote($record ['FIAT_CHART_FIELD03']) . '  AND FIAS.ASSET_CODE = FIAE.IDCODE';
                $fiaerec = ClxCommon::$db->getOneRecord($sql);
                if (!empty($fiaerec)) {
                    $record ['FIAT_ASSET_CODE'] = $fiaerec ['IDCODE'];
                    $record ['FIAT_ASSET_CODE_prim'] = $fiaerec ['IDCODE'];
                    $record ['FIAT_SEET_CODE_secd'] = $fiaerec ['IDNAME'];
                }
            }
        }

        // TRANSACTION REPORTS
        /**
         * Print Check Method
         * @return string|Ambigous <text, string, unknown>
         */
        function print_check($timp = 'imp') {

            $ibs_print = (companyParameter('EIBS_ENABLE_CHECK_PRINT')) ? true : false;

            if ($ibs_print === true) {
                // Llamada de la interfase de IBS en caso de
                // impresion de cheques por ibs
                includeCodeLib('EIBS_CHK');
                $a = new ibs_check_socket_interface();
                // $a->debug = false;
                return $a->printChecks();
            }
            $idlist = getIdlist();
            if (empty($idlist))
                return alert('Not Found');
            $allcompc = array();
            foreach ($idlist as $transid) {
                $this->comp_code = $this->getCompCode($transid);
                /*
                 *
                 * Caso 1002843 - GB-Anulación y impresión de nuevo cheque
                 */
                $allcompc[$this->comp_code] = $this->comp_code;
            }
            if (count($allcompc) > CLX_NUM_ONE) {
                return warning(dict('GEN_ERR_NO_SAME_CHK_COMPANY'));
            }

            if ($timp === 'imp') {
                $sql = 'SELECT CHK_PRNT_GRP_CODE FROM GL_PARAMETERS_TBL GLCP WHERE GLCP.COMP_CODE = ' . singleQuote($this->comp_code);
                $chpc = ClxCommon::$db->getOne($sql);
                if (empty($chpc)) {
                    return warning(smsg('MSG-370', $this->comp_code));
                } else {
                    $sql = 'SELECT ACGM.* FROM CLX_AC_GROUP_MEMBERS ACGM WHERE ACGM.USERNAME = ' . singleQuote($this->username) . ' AND ACGM.GROUPCODE = ' . singleQuote($chpc);
                    $chpg = ClxCommon::$db->getOne($sql);
                    if (empty($chpg)) {
                        return warning(smsg('MSG-371', $chpc));
                    }
                }
            } else {
                $sql = 'SELECT CHK_RPRNT_GRP_CODE FROM GL_PARAMETERS_TBL GLCP WHERE GLCP.COMP_CODE = ' . singleQuote($this->comp_code);
                $chpc = ClxCommon::$db->getOne($sql);
                if (empty($chpc)) {
                    return warning(smsg('MSG-370', $this->comp_code));
                } else {
                    $sql = 'SELECT ACGM.* FROM CLX_AC_GROUP_MEMBERS ACGM WHERE ACGM.USERNAME = ' . singleQuote($this->username) . ' AND ACGM.GROUPCODE = ' . singleQuote($chpc);
                    $chpg = ClxCommon::$db->getOne($sql);
                    if (empty($chpg)) {
                        return warning(smsg('MSG-371', $chpc));
                    }
                }
            }

            //Prompt format
            if (empty(UserRequest::$get['template'])) {
                return $this->prompt_check_template();
            }

            if (!class_exists('PDF_Visibility') && file_exists(kPathToWebSite . kPathToFpdf . 'PDF_Visibility.php')) {
                include_once kPathToWebSite . kPathToFpdf . 'PDF_Visibility.php';
            }

            $chk_props = $this->print_check_templates(UserRequest::$get['template']);

            // includeCodeLib('GEN_NO_TEXT');
            $pdf = new PDF_Visibility($chk_props['direction'], $chk_props['unit'], array($chk_props['w'], $chk_props['h']), 'PRCH');
            $pdf->SetMargins(CLX_NUM_ZERO, CLX_NUM_ZERO, CLX_NUM_ZERO);
            foreach ($idlist as $transid) {
                /*
                 *
                 * Caso 1002843 - GB-Anulación y impresión de nuevo cheque
                 * Toma los datos de la transacción corriente
                 */
                $this->getCurrTransac($transid);
                $td = $this->getDisbursementT($transid);
                if ($td === true) {
                    /*
                     * CODE_ERR_DISB_NO_CHK_TYPE
                     * Disbursement type is not 'Check' . Transaction # ^1
                     * El desembolso no es de tipo Cheque. Transaction # ^1
                     */
                    return alert(dict('CODE_ERR_DISB_NO_CHK_TYPE', $this->curr_transac['IDCODE']));
                }
                $td = $this->getAprovement($transid);
                if ($td === true) {
                    /*
                     * 017E8B29849843B6DAA2501AAD99F7C1
                     * Pending approval
                     * Pendiente de aprobar
                     */
                    return alert(dict('017E8B29849843B6DAA2501AAD99F7C1') . ' [' . $this->curr_transac['IDCODE'] . ']');
                }
                /*
                 *
                 * Caso 1002843 - GB-Anulación y impresión de nuevo cheque
                 * Verifica la condicion de anulado o reversado
                 */
                if ($this->curr_transac['VOID'] === '1' || $this->curr_transac['REVERSED'] === '1') {
                    /*
                     * CODE_ERR_VOID_CHK_PRT_NA
                     * Voided or reversed check could not be printed. Transaction # ^1
                     * Los cheques anulados o reversados no se pueden imprimir. Transaction # ^1
                     */
                    return alert(dict('CODE_ERR_VOID_CHK_PRT_NA', $this->curr_transac['IDCODE']));
                }
                if ($timp === 'imp' && !empty($this->curr_transac['CHECK_PRINT_DATI'])) {
                    /*
                     * GEN_LBL_PRINTED_CHECK
                     * Check already printed
                     * Cheque ya impreso
                     */
                    return alert(dict('GEN_LBL_PRINTED_CHECK') . ' [' . $this->curr_transac['IDCODE'] . ']');
                }

                $sql = 'SELECT FIAT.COMP_CODE, FIAT.EFFTDATE, FIAT.CHECK_NO, FIAT.CHECK_NO CHECK_NO_O, FICO.CONTRACT_NUMBER, FICO.IDNAME CONTRACT_NAME, FIAT.BRANCH, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' LOCATION, CHECK_PRINT_DATI, FIAT.CURRENCY_CODE, IFNULL(FIAT.BENEFICIARY_NAME, (SELECT MAX(ACCO.IDNAME) FROM ' . $this->acconame . ' ACCO                     WHERE ACCO.IDCODE = FIAT.BENEFICIARY_CODE                 )) BENEFICIARY_NAME, ROUND(FIAT.TRANS_AMT, 2) TRANS_AMT,             FIAT.IDNAME,             FIAT.FIDU_BANKACT_CODE BANK_ACCOUNT_NO,             FIAT.MODIFIEDBY CREATEDBY,             (                 SELECT MAX(ACCO.IDNAME) FROM ' . $this->acconame . ' ACCO WHERE ACCO.IDCODE = FIAT.CHART_FIELD02) PARTICIPANT_NAME FROM ' . $this->fiatname . ' FIAT, ' . $this->ficoname . ' FICO WHERE FIAT.ID = ' . $transid . ' AND FICO.IDCODE = FIAT.CHART_FIELD01 AND FIAT.DISBURSEMENT_TYPE = ' . singleQuote('CH');
                $record = ClxCommon::$db->getOneRecord($sql);
                if (empty($record))
                    continue;
                if (empty($record['CHECK_NO'])) {
                    if (!class_exists('FIBK'))
                        includeCodeLib('FIBK');
                    $fibk = new fibk_utilities();
                    $lpchk = '';
                    $fibklpchk = $fibk->getLastCheckNum($record['COMP_CODE'], $record ['BANK_ACCOUNT_NO']);
                    $fiatlpchk = $this->getLastCheckNum($record['COMP_CODE'], $record ['BANK_ACCOUNT_NO']);
                    if ($fibklpchk < $fiatlpchk) {
                        $lpchk = $fiatlpchk;
                    } else {
                        $lpchk = $fibklpchk;
                    }
                    if (trim(uppercase($record['CHECK_NO'])) === 'AUTO' || trim(uppercase($record['CHECK_NO'])) === 'null' || strval($record ['CHECK_NO']) === ''  || $record ['CHECK_NO'] === '0') {
                        $record ['CHECK_NO'] = $lpchk + CLX_NUM_ONE;
                        $i = strlen($record ['CHECK_NO']);
                        for ($i; $i < CLX_NUM_SIX; $i++) {
                            $record ['CHECK_NO'] = '0' . $record ['CHECK_NO'];
                        }
                    }
                    $record['CHECK_NO_O'] = $record['CHECK_NO'];
                }

                ClxCommon::$db->updateRecord($this->fibkname, array('LAST_CHECK_NO' => $record['CHECK_NO']), 'BANK_ACCOUNT_NO = ' . singleQuote($record ['BANK_ACCOUNT_NO']));
                ClxCommon::$db->updateRecord($this->fiatname, array('CHECK_NO' => $record['CHECK_NO']), 'ID = ' . $transid);
                ClxCommon::$db->updateRecord('FIDU_CHK_PROPS', array('LAST_CHECK_NO' => $record['CHECK_NO']), 'ID = ' . singleQuote($chk_props[CLX_PROP_ID]));

                $record['DETAIL'] = array();
                ClxCommon::$db->updateRecord($this->fiatname, array('CHECK_PRINT_DATI' => $this->now, 'CHECK_PRINT_BY' => $_SESSION ['user_record'] ['username']), 'ID = ' . $transid);
                //$record ['EFFTDATE_TEXT'] = xFormat::date($record ['EFFTDATE'], 'd/F/Y');
                $record ['EFFTDATE_TEXT'] = clx_uppercase(xFormat::textdate($record ['EFFTDATE'], 'Y-m-d'));
                //   - Caso 1002105 - GB-Impresión de Cheques
                // Separacion de los 3 elementos de la fecha para imprimirlos en casillas individuales
                // Requerimiento de nuevo formato de SBP para Global Bank
                $record ['EFFTDATE_DAY'] = xFormat::date($record ['EFFTDATE'], 'd');
                $record ['EFFTDATE_MONTH'] = xFormat::date($record ['EFFTDATE'], 'm');
                $record ['EFFTDATE_YEAR'] = xFormat::date($record ['EFFTDATE'], 'Y');
                $record ['EFFTDATE'] = xFormat::date($record ['EFFTDATE'], 'd/m/Y');
                $record ['TRANS_AMT_TEXT'] = 'Monto en texto';
                $record ['MODIFIEDBY'] = $_SESSION ['user_record'] ['username'];
                if ($record ['BENEFICIARY_NAME'] === '') {
                    $record ['BENEFICIARY_NAME'] = $record ['PARTICIPANT_NAME'];
                }

                // setting number
                $tt = new TextualNumber ();
                try {
                    $record ['TRANS_AMT_TEXT'] = $tt->GetCurrency($record ['TRANS_AMT'], getCurrentLanguage(), '', '');
                } catch (Exception $e) {
                    return alert($e->getMessage() . ' Contact System Administrator / Contactar a administrador del sistema');
                }
                foreach ($record as $key => $val) {
                    if (!is_array($val)) {
                        $record [$key] = clx_uppercase($val);
                    }
                }
                $record['TRANS_AMT'] = $this->formatCurrency($record['TRANS_AMT']);
                //Journal Details
                //$sql = 'SELECT JELN.ID,JELN.JEHDR_CODE,JELN.SEQNUM,JELN.GLACCOUNTCODE,JELN.CHART_FIELD01,JELN.CHART_FIELD02,JELN.CHART_FIELD03,JELN.CHART_FIELD04,JELN.ITEM_CODE,JELN.ITEM_REF_NO,JELN.CURRENCY_CODE,JELN.EXCHANGE_RT,JELN.CUR_OPERATOR,JELN.DEBIT_TRANS_AMT,JELN.DEBIT_AMT,JELN.CREDIT_TRANS_AMT,JELN.CREDIT_AMT,JELN.RECONCILIED,JELN.RECONCILIED_DT,JELN.IS_REMOVE, GLAC.IDNAME GL_NAME, JEHD.EFFTDATE EFFTDATE, FIAT.FIDU_BANKACT_CODE BANK_ACCOUNT_NO, FIAT.IDNAME IDNAME FROM ' . $this->glacname . ' GLAC, ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD, ' . $this->fiatname . ' FIAT, ' . $this->glcpname . ' GLCP WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLCP.COMP_CODE = JEHD.COMP_CODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND FIAT.IDCODE = JEHD.TRANS_CODE AND JELN.CHART_FIELD01 = FIAT.CHART_FIELD01 AND JELN.CHART_FIELD02 = FIAT.CHART_FIELD02 AND FIAT.TRANSTBL_CODE <>'.singleQuote('SYS_DESIN').' AND  GLAC.TRUST_ITEM_TYPE = ' . singleQuote('CA') . ' AND (JELN.DEBIT_TRANS_AMT = 0 || JELN.DEBIT_AMT = 0 ) AND FIAT.ID = ' . $transid.'    UNION ALL SELECT MAX(JELN.ID) ID,MAX(JELN.JEHDR_CODE) JEHDR_CODE,MAX(JELN.SEQNUM) SEQNUM,JELN.GLACCOUNTCODE,MAX(JELN.CHART_FIELD01) CHART_FIELD01,MAX(JELN.CHART_FIELD02) CHART_FIELD02,MAX(JELN.CHART_FIELD03) CHART_FIELD03,MAX(JELN.CHART_FIELD04) CHART_FIELD04,MAX(JELN.ITEM_CODE) ITEM_CODE,MAX(JELN.ITEM_REF_NO) ITEM_REF_NO,MAX(JELN.CURRENCY_CODE) CURRENCY_CODE,MAX(JELN.EXCHANGE_RT) EXCHANGE_RT,MAX(JELN.CUR_OPERATOR) CUR_OPERATOR,0 DEBIT_TRANS_AMT,0 DEBIT_AMT,SUM(JELN.CREDIT_TRANS_AMT-JELN.DEBIT_TRANS_AMT) CREDIT_TRANS_AMT,SUM(JELN.CREDIT_AMT-JELN.DEBIT_AMT) CREDIT_AMT, MAX(JELN.RECONCILIED) RECONCILIED,MAX(JELN.RECONCILIED_DT) RECONCILIED_DT, MAX(JELN.IS_REMOVE) IS_REMOVE, MAX(GLAC.IDNAME) GL_NAME, JEHD.EFFTDATE EFFTDATE, FIAT.FIDU_BANKACT_CODE BANK_ACCOUNT_NO, FIAT.IDNAME IDNAME FROM ' . $this->glacname . ' GLAC, ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD, ' . $this->fiatname . ' FIAT, ' . $this->glcpname . ' GLCP WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLCP.COMP_CODE = JEHD.COMP_CODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND FIAT.IDCODE = JEHD.TRANS_CODE AND JELN.CHART_FIELD01 = FIAT.CHART_FIELD01 AND JELN.CHART_FIELD02 = FIAT.CHART_FIELD02 AND JELN.SEQNUM = 7 AND FIAT.TRANSTBL_CODE ='.singleQuote('SYS_DESIN').' AND  GLAC.TRUST_ITEM_TYPE = ' . singleQuote('CA') . '  AND FIAT.ID = ' . $transid.' GROUP BY JEHD.EFFTDATE, FIAT.FIDU_BANKACT_CODE';
                $sql = 'SELECT JELN.ID,JELN.JEHDR_CODE,JELN.SEQNUM,JELN.GLACCOUNTCODE,JELN.CHART_FIELD01,JELN.CHART_FIELD02,JELN.CHART_FIELD03,JELN.CHART_FIELD04,JELN.ITEM_CODE,JELN.ITEM_REF_NO,JELN.CURRENCY_CODE,JELN.EXCHANGE_RT,JELN.CUR_OPERATOR,JELN.DEBIT_TRANS_AMT,JELN.DEBIT_AMT,JELN.CREDIT_TRANS_AMT,JELN.CREDIT_AMT,JELN.RECONCILIED,JELN.RECONCILIED_DT,JELN.IS_REMOVE, GLAC.IDNAME GL_NAME, JEHD.EFFTDATE EFFTDATE, FIAT.FIDU_BANKACT_CODE BANK_ACCOUNT_NO, FIAT.IDNAME IDNAME FROM ' . $this->glacname . ' GLAC, ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD, ' . $this->fiatname . ' FIAT, ' . $this->glcpname . ' GLCP WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLCP.COMP_CODE = JEHD.COMP_CODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND FIAT.IDCODE = JEHD.TRANS_CODE AND JELN.CHART_FIELD01 = FIAT.CHART_FIELD01 AND JELN.CHART_FIELD02 = FIAT.CHART_FIELD02 AND (FIAT.TRANSTBL_CODE <>'.singleQuote('SYS_DESIN').' OR (FIAT.TRANSTBL_CODE ='.singleQuote('SYS_DESIN').' AND JELN.SEQNUM = 7)) AND  GLAC.TRUST_ITEM_TYPE = ' . singleQuote('CA') . ' AND (JELN.DEBIT_TRANS_AMT = 0 OR JELN.DEBIT_AMT = 0 ) AND FIAT.ID = ' . $transid;
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $record['DETAIL'][] = $r;
                }
				ClxCommon::$db->freeResult($rs);
                $pdf->AddPage();
                $pdf->SetVisibility('screen');
                if ($chk_props['formato_cheque'] <> CLX_NUM_TWO) {
                    $pdf->Image($chk_props['file'], $chk_props['img_x'], $chk_props['img_y'], $chk_props['img_w'], $chk_props['img_h']);
                }
                $pdf->SetXY(CLX_NUM_ZERO,CLX_NUM_ZERO);

                $pdf->SetVisibility('all');

                if ($chk_props['formato_cheque'] == CLX_NUM_TWO) {//usado como personalizado
                    $TRTI = &getTool('TRTI');
                    $TRTI->translate('CUR_CHEQ', $record['CURRENCY_CODE'], CLX_NUM_ZERO);
                    $BANK_ADDRESS_ = str_replace(CLX_CHAR_CR, '***', $chk_props['BANK_ADDRESS']);
                    $BANK_ADDRESS = explode('***', $BANK_ADDRESS_);
                    $pdf->SetFont('Arial', '', CLX_NUM_3_PT_94);
                    $YY = CLX_NUM_0_PT_69;
                    $total = count($BANK_ADDRESS);
                    for ($i = CLX_INIT_ZERO; $i < $total; $i++) {
                        $pdf->SetXY(CLX_NUM_7_PT_06, $YY);
                        $pdf->Cell(CLX_NUM_2_PT_5, CLX_NUM_0_PT_16, $BANK_ADDRESS[$i], CLX_NUM_ZERO, CLX_NUM_ZERO, 'C');
                        $YY += CLX_NUM_0_PT_16;
                    }
                    unset($BANK_ADDRESS);
                    $pdf->Text(CLX_NUM_10_PT_10, CLX_NUM_0_PT_82, 'CUENTA No.');
                    $pdf->Text(CLX_NUM_10_PT_05, CLX_NUM_0_PT_98, 'ACCOUNT No.');
                    $pdf->Text(CLX_NUM_9_PT_76, CLX_NUM_1_PT_14, $chk_props['BANK_ACCOUNT_NO']);
                    $pdf->Rect(CLX_NUM_11_PT_74, CLX_NUM_1_PT_00, CLX_NUM_1_PT_48, CLX_NUM_0_PT_30, 'D');
                    $pdf->Rect(CLX_NUM_11_PT_74, CLX_NUM_0_PT_70, CLX_NUM_1_PT_48, CLX_NUM_0_PT_30, 'D');
                    $pdf->SetFont('Arial', '', CLX_NUM_6_PT_35);
                    $pdf->Text(CLX_NUM_11_PT_92, CLX_NUM_0_PT_93, $record ['EFFTDATE']);
                    $pdf->Text(CLX_NUM_11_PT_78, CLX_NUM_1_PT_24, 'DD/MM/AAYY');
                    $pdf->Rect(CLX_NUM_2_PT_50, CLX_NUM_2_PT_37, CLX_NUM_9_PT_21, CLX_NUM_1_PT_68, 'D');
                    $pdf->SetFillColor(CLX_NUM_255, CLX_NUM_255, CLX_NUM_255);
                    $pdf->Rect(CLX_NUM_2_PT_80, CLX_NUM_2_PT_30, CLX_NUM_8_PT_61, CLX_NUM_1_PT_82, 'F');
                    $pdf->Rect(CLX_NUM_2_PT_43, CLX_NUM_2_PT_60, CLX_NUM_9_PT_35, CLX_NUM_1_PT_08, 'F');
                    $pdf->SetFont('Arial', '', CLX_NUM_3_PT_40);
                    $pdf->Text(CLX_NUM_1_PT_70, CLX_NUM_2_PT_91, 'PAGUESE A LA');
                    $pdf->Text(CLX_NUM_1_PT_96, CLX_NUM_3_PT_05, 'ORDEN DE');
                    $pdf->Text(CLX_NUM_1_PT_87, CLX_NUM_3_PT_33, 'PAY TO THE');
                    $pdf->Text(CLX_NUM_1_PT_96, CLX_NUM_3_PT_47, 'ORDER OF');
                    $pdf->SetFont('Arial', 'B', CLX_NUM_7_PT_00);
                    $pdf->Text(CLX_NUM_11_PT_96, CLX_NUM_2_PT_77, $record['CURRENCY_CODE']);
                    if ($chk_props['file_opc'] !== '') {
                        $pdf->Image($chk_props['file_opc'], CLX_NUM_1_PT_50, CLX_NUM_5_PT_13, CLX_NUM_3_PT_60, CLX_NUM_0_PT_65);
                    }
                    $pdf->SetFont('Arial', 'B', CLX_NUM_3_PT_70);
                    $pdf->Text(CLX_NUM_1_PT_39, CLX_NUM_6_PT_09, decode_string('Timbres pagados según Resolución No.201-219 del 20 de Febrero de 1995'));
                    $pdf->SetFont('Arial', 'B', CLX_NUM_6_PT_30);
                    $pdf->Text(CLX_NUM_12_PT_12, CLX_NUM_8_PT_47, 'CHEQUE NO.:');
                    $pdf->SetFont('Arial', '', CLX_NUM_10_PT_17);
                    $pdf->Text(CLX_NUM_0_PT_93, CLX_NUM_8_PT_20, 'MUNDIAL FIDUCIARIA');
                    $pdf->SetFont('Arial', '', CLX_NUM_7_PT_12);
                    $pdf->Text(CLX_NUM_0_PT_93, CLX_NUM_8_PT_53, 'RETENGASE ESTE COMPROBANTE PARA SU ARCHIVO.');
                    $pdf->SetXY(CLX_NUM_0_PT_89, CLX_NUM_8_PT_80);
                    $pdf->SetFont('Arial', 'B', CLX_NUM_7_PT_30);
                    $pdf->Cell(CLX_NUM_3_PT_41, CLX_NUM_0_PT_34, 'FECHA', CLX_NUM_ONE, CLX_NUM_ZERO, 'C');
                    $pdf->Cell(CLX_NUM_7_PT_81, CLX_NUM_0_PT_34, 'CONCEPTO', CLX_NUM_ONE, CLX_NUM_ZERO, 'C');
                    $pdf->Cell(CLX_NUM_4_PT_14, CLX_NUM_0_PT_34, 'VALOR', CLX_NUM_ONE, CLX_NUM_ONE, 'C');
                    $pdf->SetXY(CLX_NUM_4_PT_36, CLX_NUM_9_PT_34);
                    $pdf->SetFont('Arial', '', CLX_NUM_7_PT_30);
                    $pdf->MultiCell(CLX_NUM_7_PT_69, CLX_NUM_0_PT_40, $record['IDNAME'], CLX_NUM_ZERO, 'J');
                    $pdf->SetXY(CLX_NUM_12_PT_36, CLX_NUM_9_PT_34);
                    $pdf->Cell(CLX_NUM_3_PT_79, CLX_NUM_0_PT_34, $record['TRANS_AMT'], CLX_NUM_ZERO, CLX_NUM_ZERO, 'R');
                    $pdf->Rect(CLX_NUM_0_PT_89, CLX_NUM_9_PT_14, CLX_NUM_3_PT_41, CLX_NUM_8_PT_45, 'D');
                    $pdf->Rect(CLX_NUM_4_PT_30, CLX_NUM_9_PT_14, CLX_NUM_7_PT_81, CLX_NUM_8_PT_45, 'D');
                    $pdf->Rect(CLX_NUM_12_PT_11, CLX_NUM_9_PT_14, CLX_NUM_4_PT_14, CLX_NUM_8_PT_45, 'D');
                    $pdf->SetXY(CLX_NUM_0_PT_89, CLX_NUM_17_PT_59);
                    $pdf->SetFont('Arial', 'B', CLX_NUM_7_PT_30);
                    $pdf->Cell(CLX_NUM_3_PT_41, CLX_NUM_0_PT_34, '', CLX_NUM_ONE, CLX_NUM_ZERO, 'C');
                    $pdf->Cell(CLX_NUM_7_PT_81, CLX_NUM_0_PT_34, '', CLX_NUM_ONE, CLX_NUM_ZERO, 'C');
                    $pdf->Cell(CLX_NUM_4_PT_14, CLX_NUM_0_PT_34, $record['TRANS_AMT'], CLX_NUM_ONE, CLX_NUM_ONE, 'R');
                    $pdf->SetXY(CLX_NUM_1_PT_06, CLX_NUM_20_PT_45);
                    $pdf->SetFont('Arial', 'B', CLX_NUM_6_PT_20);
                    $pdf->Cell(CLX_NUM_3_PT_52, CLX_NUM_0_PT_50, 'VERIFICADO POR', CLX_NUM_ONE, CLX_NUM_ZERO, 'C');
                    $pdf->Cell(CLX_NUM_3_PT_50, CLX_NUM_0_PT_50, 'APROBADO POR', CLX_NUM_ONE, CLX_NUM_ZERO, 'C');
                    $pdf->Cell(CLX_NUM_3_PT_52, CLX_NUM_0_PT_50, 'RECIBIDO POR', CLX_NUM_ONE, CLX_NUM_ZERO, 'C');
                    $pdf->Rect(CLX_NUM_1_PT_06, CLX_NUM_20_PT_95, CLX_NUM_3_PT_52, CLX_NUM_1_PT_00, 'D');
                    $pdf->Rect(CLX_NUM_4_PT_58, CLX_NUM_20_PT_95, CLX_NUM_3_PT_50, CLX_NUM_ONE, 'D');
                    $pdf->Rect(CLX_NUM_8_PT_08, CLX_NUM_20_PT_95, CLX_NUM_3_PT_52, CLX_NUM_ONE, 'D');
                    $pdf->Cell(CLX_NUM_2_PT_47, CLX_NUM_0_PT_50, 'HECHO POR', CLX_NUM_ZERO, CLX_NUM_ONE, 'C');
                    $pdf->SetFont('Arial', '', CLX_NUM_6_PT_20);
                    $pdf->SetXY(CLX_NUM_11_PT_60, CLX_NUM_20_PT_78);
                    $pdf->Cell(CLX_NUM_2_PT_47, CLX_NUM_0_PT_50, $_SESSION['user_record']['username'], CLX_NUM_ZERO, CLX_NUM_ONE, 'C');
                }


                $pdf->SetFont($chk_props['font'], '', $chk_props['fontsize']);
                $pdf->SetXY(CLX_NUM_ZERO, CLX_NUM_ZERO);
                /*
                 * Top Section : Check fields
                 * Sección Superior : Campos del cheque como tal
                 */

                foreach ($chk_props['fields'] as $k => $v) {
                    if (empty($v['enabled'])){
                        continue;
                    }

                    $y_increment = CLX_INIT_ZERO;
                    if (array_key_exists('fields', $v)) {
                        //Description
                        /*
                         * Bottom Section : Payment detail fields
                         * Sección Inferior : Campos del comprobante de pago
                         */
                        $totals = array();
                        foreach ($record [$k] as $item => $row) {
                            $y_increment_max = $v['row_separation']; // Maxima Y alcanzada por alguno de los campos
                            foreach ($v['fields'] as $k2 => $v2) {
                                //   - Caso 1002105 - GB-Impresión de Cheques
                                // Se evalua la formula
                                if (!empty($v2['formula'])) {
                                    // OJO en esta formula se debe usar $row en vez de $record
                                    // para hacer referencia a los valores del registro corriente
                                    $row[$k2] = $this->chk_execute_formula($v2, $row);
                                }
                                if ($k2 === 'CREDIT_AMT') {
                                    $pdf->Text($v2['x'], ($v2['y'] + $y_increment), $this->formatCurrency($row[$k2]));
                                } else {

                                    //   - Caso 1002105 - GB-Impresión de Cheques
                                    // Se incluye wordwrap en las lineas del comprobante de egreso
                                    if (!empty($v2['wordwrap'])) {
                                        $a_tmp_str = $this->chk_wordwrap(decode_string($row[$k2]), $v2['wordwrap'], CLX_CHAR_NL, true);
                                        $y_increment_curr_col = CLX_INIT_ZERO; // Coordenada Y alcanzada por el campo corriente (de acuerdo al wordwrap)
                                        foreach ($a_tmp_str as $kkey => $vvalue) {
                                            $pdf->Text($v2['x'], ($v2['y'] + $y_increment + $y_increment_curr_col), $vvalue);
                                            $y_increment_curr_col += $v['row_separation'];
                                        }
                                        // Asigna Maxima Y alcanzada por alguno de los campos
                                        $y_increment_max = max($v['row_separation'], $y_increment_curr_col);
                                    } else {
                                        // Campo sin WordWrap
                                        $pdf->Text($v2['x'], ($v2['y'] + $y_increment), decode_string($row[$k2]));
                                    }
                                }
                                if (!empty($v2['has_total'])) {
                                    if (!array_key_exists($k2, $totals)) {
                                        $totals[$k2] = array($row[$k2], 'x' => $v2['x_total'], 'y' => $v2['y_total']);
                                    } else {
                                        $totals[$k2][CLX_NUM_ZERO] += $row[$k2];
                                    }
                                }
                            }
                            //   - Caso 1002105 - GB-Impresión de Cheques
                            // Incrementa coordenada Y de acuerdo a la maxima Y alcanzada por alguno de los campos
                            $y_increment += $y_increment_max;
                        }
                        if (!empty($totals)) {
                            foreach ($totals as $k2 => $v2) {
                                $v2[CLX_NUM_ZERO] = $this->formatCurrency($v2[CLX_NUM_ZERO]);
                                $pdf->Text($v2['x'], $v2['y'], $v2[CLX_NUM_ZERO]);
                                //$pdf->MultiCell ( 0, $w, $v2 [CLX_NUM_ZERO], 0, $v2[CLX_PROP_ALIGN]);
                            }
                        }
                    } else {
                        //   - Caso 1002105 - GB-Impresión de Cheques
                        // Se evalua la formula

                        if (!empty($v['formula'])) {
                            // OJO en esta formula se debe usar $record
                            // para hacer referencia a los valores del registro corriente
                            $record [$k] = $this->chk_execute_formula($v, $record);
                        }
                        $record [$k] = decode_string($record [$k]);
                        if (!empty($v['enclose'])) {
                            $record [$k] = $v['enclose'] . $record [$k] . $v['enclose'];
                        }
                        //Normal Field
                        if (!empty($v['show_location'])) {
                            $record [$k] = $record ['LOCATION'] . ' ' . $record [$k];
                        }
                        if (!empty($v['wordwrap'])) {
                            //   - Caso 1002105 - GB-Impresión de Cheques
                            // En caso de Wordwrap, sólo muestra la primera línea si no se especificó 'row_separation'
                            $record [$k] = $this->chk_wordwrap($record[$k], $v['wordwrap'], CLX_CHAR_NL, ($v['row_separation'] != CLX_NUM_ZERO), ($v['row_separation'] == CLX_NUM_ZERO));
                        }
                        //   - Caso 1002105 - GB-Impresión de Cheques
                        $y_increment_max = $v['row_separation'];
                        if (!empty($v['wordwrap']) && $v['row_separation'] != CLX_NUM_ZERO) {
                            // Imprime las varias lineas
                            $y_increment_curr_col = CLX_INIT_ZERO; // Coordenada Y alcanzada por el campo corriente (de acuerdo al wordwrap)
                            foreach ($record [$k] as $kkey => $vvalue) {
                                $pdf->Text($v['x'], $v['y'] + $y_increment_curr_col, decode_string($vvalue));
                                $y_increment_curr_col += $v['row_separation'];
                            }
                            // Asigna Maxima Y alcanzada por alguno de los campos
                            $y_increment_max = max($v['row_separation'], $y_increment_curr_col);
                        } else {
                            // Imprime una sola línea
                            //echo $k.'<br>';
                            /*EFFTDATE_DAY EFFTDATE_MONTH EFFTDATE_YEAR*/
                            //$pdf->SetFont($chk_props['font'], '', $chk_props['fontsize']+3);
                            $pdf->SetFontSpacing($v['FONT_SPACING']);
                            $pdf->Text($v['x'], $v['y'], decode_string($record [$k]));
                            //$pdf->SetXY($v['x'], $v['y']);
                            //$pdf->CellFit(float w [, float h [, string txt [, mixed border [, int ln [, string align [, boolean fill [, mixed link [, boolean scale [, boolean force]]]]]]]]])



                        }
                    }
                }
            }// end foreach trans_id
            $pdf->Output();
        }

        private function formatCurrency($amount) {
            switch (getCurrentLanguage()) {
                case 'en':
                case 'es_PA':
                    $amount = clx_format_currency($amount);
                    break;
                case 'es':
                    $amount = clx_format_currency($amount, CLX_NUM_TWO, ',', '.');
                    break;
                default:
                    if(substr(getCurrentLanguage(), CLX_NUM_ZERO, CLX_NUM_TWO) === 'es') {
                        $amount = clx_format_currency($amount, CLX_NUM_TWO, ',', '.');
                    } else {
                        $amount = clx_format_currency($amount);
                    }
                    break;
            }
            return $amount;
        }

        /**
         * Returns result of a formula
         */
        function chk_execute_formula(&$definition, &$record) {
            //   - Caso 1002105 - GB-Impresión de Cheques
            $cal = new ClxExpression();
            return $cal->parseRecordFormula(trim($definition['formula']));
        }

        /**
         * Returns wordwrapped string
         * If $return_as_array is true, returns array with several lines
         * If $return_only_1st is true, returns string with the first line only
         */
        function chk_wordwrap($str, $col_size, $sep = '<br>\n', $return_as_array = false, $return_only_1st = false) {
            //   - Caso 1002105 - GB-Impresión de Cheques
            $response = wordwrap($str, $col_size, $sep, true);
            if ($return_as_array === true || $return_only_1st === true) {
                $response = explode($sep, $response);
                if ($return_only_1st === true) {
                    $response = $response[CLX_NUM_ZERO];
                }
            }
            return $response;
        }

        /**
         * Prompt Check Templates
         */
        private function prompt_check_template() {
            $props = $this->print_check_templates();
            $form = new htmlForm(CLX_PROP_ACTION, 'pop.php', 'method', 'get');
            foreach (UserRequest::$get as $key => $val) {
                $form->addArgument($key, $val);
            }
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
            $table->addCell(dict('GEN_LBL_SELECT_OPTION'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_NUM_TWO));
            $table->addCell(dict('GEN_LBL_CHECK_TEMPLATE'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $select = new htmlSelect('template');
            foreach ($props as $key => $val) {
                $select->addItem($val['template_name'], $key, false);
            }
            $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            $bs = new htmlSubmit(dict('GEN_LBL_SUBMIT'));
            $b = $bs->source();
            $bs = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
            $b .= $bs->source();
            $table->addCell($b, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_NUM_TWO));
            $form->addContents($table->source());
            return $form->source();
        }

        /**
         * Check Templates
         */
        private function print_check_templates($template = '') {
            $props = array();
            $DBLT = &getTool('DBLT');
            $fieldtp = $DBLT->getListAsArray('CHPF');
            unset($fieldtp[null]);
            $FILE = getToolObject('DBFT', 'FILE');
            $sql = 'SELECT ID id, TEMPLATE_NAME template_name, FILE_DIR file, HEIGHT h, WIDTH w, IMG_X img_x, IMG_Y img_y, IMG_H img_h, IMG_W img_w, UNIT unit, GUIDANCE_PAPER direction, FONT_TYPE font, FONT_SIZE fontsize, IMP_FORM_CHE formato_cheque, BANK_ADDRESS, BANK_ACCOUNT_NO, IMAGEFILE file_opc FROM FIDU_CHK_PROPS CHPR WHERE COMP_CODE = ' . singleQuote($this->comp_code);
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $props[$r[CLX_PROP_ID]] = array(CLX_PROP_ID => $r[CLX_PROP_ID],
                    'template_name' => $r['template_name'],
                    'file' => $r['file'],
                    'h' => $r['h'],
                    'w' => $r['w'],
                    'img_x' => $r['img_x'],
                    'img_y' => $r['img_y'],
                    'img_h' => $r['img_h'], //h 22 w 19
                    'img_w' => $r['img_w'],
                    'unit' => $r['unit'],
                    'direction' => $r['direction'],
                    'font' => $r['font'],
                    'fontsize' => $r['fontsize'],
                    'formato_cheque' => $r['formato_cheque'],
                    'BANK_ADDRESS' => $r['BANK_ADDRESS'],
                    'BANK_ACCOUNT_NO' => $r['BANK_ACCOUNT_NO'],
                    'file_opc' => $r['file_opc'],
                    'fields' => $r[CLX_PROP_ID]
                );
            }
			ClxCommon::$db->freeResult($rs);
            $idd = array();
            foreach ($props as $k => $v) {
                $idd[$k]['fields'] = $props[$k]['fields'];
                $props[$k]['fields'] = array();
                $props[$k]['file'] = $FILE->fileName($props[$k]['file']);
                $props[$k]['file_opc'] = $FILE->fileName($props[$k]['file_opc']);
            }
            foreach ($idd as $k => $v) {
                $sql = 'SELECT ID ID, IDFIELD fieldname, ENABLED enabled, POSITION_X x, POSITION_Y y, ENCLOSE enclose, SHOW_LOCATION show_location, WORDWRAP wordwrap, WRAP_SEPARATION wrap_separation, ROW_SEPARATION row_separation, ALIGN align, HAS_TOTAL has_total, X_TOTAL x_total, CHFD.Y_TOTAL y_total, \'\' formula, FONT_SPACING FROM FIDU_CHK_PROPS_FIELDS_DET CHFD WHERE ID_DETAIL = ' . $idd[$k]['fields'];
                $rs = ClxCommon::$db->executeQuery($sql);
                $df = CLX_INIT_ZERO;
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $props[$k]['fields'][$fieldtp[$r['fieldname']]]['enabled'] = (($r['enabled'] == CLX_NUM_ONE) ? true : $props[$k]['fields'][$fieldtp[$r['fieldname']]]['enabled'] = false);
                    $props[$k]['fields'][$fieldtp[$r['fieldname']]]['x'] = $r['x'];
                    $props[$k]['fields'][$fieldtp[$r['fieldname']]]['y'] = $r['y'];
                    $props[$k]['fields'][$fieldtp[$r['fieldname']]]['enclose'] = (($r['enclose'] !== '') ? $r['enclose'] : '' );
                    $props[$k]['fields'][$fieldtp[$r['fieldname']]]['show_location'] = (($r['show_location'] == CLX_NUM_ONE) ? true : '' );
                    $props[$k]['fields'][$fieldtp[$r['fieldname']]]['wordwrap'] = (($r['wordwrap'] != CLX_NUM_ZERO) ? $r['wordwrap'] : '' );
                    $props[$k]['fields'][$fieldtp[$r['fieldname']]]['wrap_separation'] = (($r['wrap_separation'] != CLX_NUM_ZERO ) ? $r['wrap_separation'] : '' );
                    $props[$k]['fields'][$fieldtp[$r['fieldname']]]['row_separation'] = (($r['row_separation'] != CLX_NUM_ZERO ) ? $r['row_separation'] : '' );
                    $props[$k]['fields'][$fieldtp[$r['fieldname']]][CLX_PROP_ALIGN] = (($r[CLX_PROP_ALIGN] !== '') ? $r[CLX_PROP_ALIGN] : '' );
                    $props[$k]['fields'][$fieldtp[$r['fieldname']]]['has_total'] = (($r['has_total'] == CLX_NUM_ONE) ? true : '' );
                    $props[$k]['fields'][$fieldtp[$r['fieldname']]]['x_total'] = (($r['x_total'] != CLX_NUM_ZERO) ? $r['x_total'] : '' );
                    $props[$k]['fields'][$fieldtp[$r['fieldname']]]['y_total'] = (($r['y_total'] != CLX_NUM_ZERO) ? $r['y_total'] : '' );
                    $props[$k]['fields'][$fieldtp[$r['fieldname']]]['formula'] = $r['formula'];
                    $props[$k]['fields'][$fieldtp[$r['fieldname']]]['FONT_SPACING'] = $r['FONT_SPACING'];
                    if ($fieldtp[$r['fieldname']] === 'DETAIL') {
                        $df = $r['ID'];
                        $props[$k]['fields'][$fieldtp[$r['fieldname']]]['fields'] = array();
                    }
                }
				ClxCommon::$db->freeResult($rs);
                if (array_key_exists('DETAIL', $props[$k]['fields'])) {
                    $sql = 'SELECT IDFIELD fieldname, ENABLED enabled, POSITION_X x,POSITION_Y y, ENCLOSE enclose, SHOW_LOCATION show_location, WORDWRAP wordwrap, WRAP_SEPARATION wrap_separation, ROW_SEPARATION row_separation, ALIGN align, HAS_TOTAL has_total, X_TOTAL x_total, Y_TOTAL y_total, \'\' formula FROM FIDU_CHK_PROPS_FIELDS_DET_FD CHDF WHERE ID_FIELDDT = ' . $df;
                    $rs = ClxCommon::$db->executeQuery($sql);
                    while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                        $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['enabled'] = (($r['enabled'] == CLX_NUM_ONE) ? true : $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['enabled'] = false);
                        $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['x'] = $r['x'];
                        $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['y'] = $r['y'];
                        $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['enclose'] = (($r['enclose'] !== '') ? $r['enclose'] : '' );
                        $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['show_location'] = (($r['show_location'] == CLX_NUM_ONE) ? true : '' );
                        $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['wordwrap'] = (($r['wordwrap'] != CLX_NUM_ZERO) ? $r['wordwrap'] : '' );
                        $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['wrap_separation'] = (($r['wrap_separation'] != CLX_NUM_ZERO) ? $r['wrap_separation'] : '' );
                        $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['row_separation'] = (($r['row_separation'] != CLX_NUM_ZERO) ? $r['row_separation'] : '' );
                        $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]][CLX_PROP_ALIGN] = (($r[CLX_PROP_ALIGN] !== '') ? $r[CLX_PROP_ALIGN] : '' );
                        $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['has_total'] = (($r['has_total'] == CLX_NUM_ONE ) ? true : '' );
                        $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['x_total'] = (($r['x_total'] != CLX_NUM_ZERO ) ? $r['x_total'] : '' );
                        $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['y_total'] = (($r['y_total'] != CLX_NUM_ZERO ) ? $r['y_total'] : '' );
                        $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['formula'] = $r['formula'];
                    }
					ClxCommon::$db->freeResult($rs);
                }
            }
            if ($template === '') {
                return $props;
            } else {
                return $props[$template];
            }
        }

        function getCompCode($id) {
            $sql = 'SELECT COMP_CODE FROM ' . $this->fiatname . ' FIAT WHERE FIAT.ID = ' . singleQuote($id);
            return ClxCommon::$db->getOne($sql);
        }

        /**
         * Trae registro corriente de Cheque
         *
         * Caso 1002843 - GB-Anulación y impresión de nuevo cheque
         */
        var $curr_transac;

        function getCurrTransac($id) {
            $this->curr_transac = ClxCommon::$db->getRecord($this->fiatname, 'ID = ' . singleQuote($id));
        }

        /**
         * Verificar si es de tipo cheque
         */
        function getDisbursementT($id) {
            return ($this->curr_transac['DISBURSEMENT_TYPE'] === 'CH') ? false : true;
        }

        /**
         * Verificar si esta aprobada
         */
        function getAprovement($id) {
            return ($this->curr_transac['TRANS_STATUS'] === 'AP') ? false : true;
        }

        /**
         * Verificar ultimo
         */
        function getLastCheckNum($comp_code, $bankacco) {
            $sql = 'SELECT MAX(CAST(FIAT.CHECK_NO AS UNSIGNED)) FROM  ' . $this->fiatname . ' FIAT WHERE FIAT.COMP_CODE = ' . singleQuote($comp_code) . ' AND FIAT.FIDU_BANKACT_CODE = ' . singleQuote($bankacco);
            return ClxCommon::$db->getOne($sql);
        }

        /**
         * Returns true if transaccin has accounts that donot allows movemen for
         * company.
         *
         * @param string $comp_code
         * @param string $transtbl_code
         * @return boolean
         */
        function invalid_transaction_glroup($comp_code, $transtbl_code) {
            $sql = 'SELECT  SUM(CASE FITS.AFFECT_TYPE   WHEN ' . singleQuote('OTH') . ' THEN (SELECT 1 FROM ' . $this->glacname . ' GLAC, ' . $this->glcpname . ' GLCP WHERE GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC.IDCODE = FITS.GLACCOUNTCODE AND GLCP.COMP_CODE = ' . singleQuote($comp_code) . ') ELSE 1 END) QTY FROM ' . $this->fitsname . ' FITS WHERE FITS.TRANSTBL_cODE = ' . singleQuote($transtbl_code);
            return (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) ? true : false;
        }

        /**
         * Reporte de recivo de transaccion
         *
         */
        function transactionReceipt() {
            $idlist = getIdlist();
            $sql = 'SELECT FIAT.TRANS_STATUS, FIAT.IDCODE FROM FIDU_TRANSACTIONS FIAT WHERE FIAT.ID = ' . singleQuote($idlist[CLX_NUM_ZERO]);
            $result = ClxCommon::$db->getOneRecord($sql);
            if ($result['TRANS_STATUS'] === 'PEND') {
                addMessage(smsg('MSG-481'));
            } else {
                $idcode = $result['IDCODE'];
                $sql = 'SELECT  FIAT.IDCODE TRANS_CODE, FIAT.EFFTDATE, FICO.CONTRACT_NUMBER, FICO.IDNAME CONTRACT_NAME, COMP.LEGAL_NAME, ACCO.IDNAME PARTICIPANT_NAME, FIAT.IDNAME DETAIL_PAY, FICO.COMP_CODE, FIAT.CURRENCY_CODE, /*DETERMINANDO MONTO DE OPERACION APORTE O RETIRO*/ (SELECT SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) FROM GL_JOURNAL_HDR JEHD, GL_JOURNAL_LINES JELN, FIDU_ITEMS FIAS WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JEHD.TRANS_CODE = FIAT.IDCODE AND JELN.CHART_FIELD03 = FIAS.IDCODE AND FIAS.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND FIBK.CURRENCY_CODE = JELN.CURRENCY_CODE) TRANS_AMT, ' . /* cuenta de fideicomiso */ ' FIAT.FIDU_BANKACT_CODE BANK1_NO, INSI.IDNAME BANK1_NAME, IFNULL(FIBK.BENEFICIARY_NAME, ACCO.IDNAME) BANK1_BENEF, CLX_DBLI_ITEM_LABEL(' . singleQuote('BPTY') . ',(SELECT PROD.PRODUCT_TYPE FROM CRM_PRODUCTS PROD WHERE PROD.IDCODE = FIBK.BANK_PROD_CODE),' . singleQuote(getCurrentLanguage()) . ') BANK1_TYPE, ' . /* cuenta beneficiario */ ' IFNULL(FIAT.BANKAC_CODE, FIAT.BANK_ACCOUNT_NO) BANK2_NO, IF(FIAT.BANKAC_CODE IS NULL, FIAT.BANK_NAME, (SELECT INSI.IDNAME FROM INVE_ISSUERS_TBL INSI WHERE INSI.IDCODE = FIBK2.BANK_CODE)) BANK2_NAME, IFNULL(IFNULL(FIBK2.BENEFICIARY_NAME, (SELECT ACCO2.IDNAME FROM CRM_ACCOUNTS ACCO2 WHERE FIAT.BENEFICIARY_CODE = ACCO2.IDCODE)), FIAT.BENEFICIARY_NAME) BANK2_BENEF, IFNULL(CLX_DBLI_ITEM_LABEL(' . singleQuote('BPTY') . ',(SELECT PROD.PRODUCT_TYPE FROM CRM_PRODUCTS PROD WHERE PROD.IDCODE = FIBK2.BANK_PROD_CODE),' . singleQuote(getCurrentLanguage()) . '), CLX_DBLI_ITEM_LABEL(' . singleQuote('ACHT') . ', FIAT.ACH_ACC_TYPE,' . singleQuote(getCurrentLanguage()) . ')) BANK2_TYPE,' . /* User Information */ '(SELECT CONCAT (ACUS.LASTNAME,' . singleQuote(', ') . ',ACUS.FIRSTNAME) FROM CLX_AC_USERS ACUS WHERE ACUS.USERNAME = FIAT.CREATEDBY) PREPARATION, (SELECT CONCAT (ACUS.LASTNAME,' . singleQuote(', ') . ',ACUS.FIRSTNAME) FROM CLX_AC_USERS ACUS WHERE ACUS.USERNAME = FIAT.MODIFIEDBY) VERIFIEDL, (SELECT CONCAT (ACUS.LASTNAME,' . singleQuote(', ') . ',ACUS.FIRSTNAME) FROM CLX_AC_USERS ACUS, CLX_AC_AUTHORIZATIONS AUTH WHERE AUTH.TABLECODE = ' . singleQuote('FIAT') . ' AND AUTH.REC_ID = FIAT.ID AND AUTH.MODIFIEDBY = ACUS.USERNAME) APROBED FROM BASE_COMPANIES COMP, INVE_ISSUERS_TBL INSI, FIDU_BANK_ACCOUNTS FIBK, FIDU_CONTRACTS FICO, CRM_ACCOUNTS ACCO, FIDU_TRANSACTIONS FIAT LEFT JOIN FIDU_BANK_ACCOUNTS FIBK2 ON FIAT.BANKAC_CODE = FIBK2.BANK_ACCOUNT_NO WHERE COMP.IDCODE = FIAT.COMP_CODE AND INSI.IDCODE = FIBK.BANK_CODE AND ACCO.IDCODE = FIAT.CHART_FIELD02 AND FIAT.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND FICO.IDCODE = FIAT.CHART_FIELD01 AND FIAT.IDCODE = ' . singleQuote($idcode);
                $result = ClxCommon::$db->getOneRecord($sql);
                if (!empty($result)) {
                    $update = 'UPDATE FIDU_TRANSACTIONS SET CHECK_PRINT_DATI=NOW() WHERE CHECK_PRINT_DATI IS NULL AND IDCODE = ' . singleQuote($idcode);
                    ClxCommon::$db->executeQuery($update);
                    $update1 = 'UPDATE FIDU_TRANSACTIONS SET CHECK_PRINT_BY=' . singleQuote($_SESSION['user_record']['username']) . ' WHERE CHECK_PRINT_BY IS NULL AND IDCODE = ' . singleQuote($idcode);
                    ClxCommon::$db->executeQuery($update1);
                    ClxCommon::$db->commit();
                }
                ClxFreeReturn($this->transactionPdf($result));
            }
        }

        /**
         * Usado en reporte de recivo de transaccion en fiat.php
         * @see fiat::transactionReceipt()
         * @param type $result
         * @return type
         */
        private function transactionPdf($result) {
            // setting number
            $tt = new TextualNumber ();
            try {
                $textTransAmt = $tt->GetCurrency($result['TRANS_AMT'] < CLX_NUM_ZERO ? $result['TRANS_AMT'] * -CLX_NUM_ONE : $result['TRANS_AMT'], getCurrentLanguage(), '', '');
            } catch (Exception $e) {
                return alert($e->getMessage() . ' Contact System Administrator / Contactar a administrador del sistema');
            }
            $textTransAmt = strip_tags($textTransAmt);
            if (!class_exists('pdf_table'))
                require_once 'classes/clx_report.php';
            $pdf = new pdf_table('P', 'mm', 'letter');
            $pdf->Open();
            $comprec = ClxCommon::$db->getRecord($this->compname, 'IDCODE = ' . singleQuote($result['COMP_CODE']));
            // Company Record
            $FILE = getToolObject('DBFT', 'FILE');
            $complogo = $FILE->fileName($comprec ['COMP_LOGO']);
            if (!file_exists($complogo))
                $complogo = '';
            $pdf->setReplogo($complogo, CLX_NUM_TEN, CLX_NUM_ZERO, CLX_NUM_60, CLX_NUM_45);
            $this->build_header_pdf($pdf, '');
            $xdes = CLX_NUM_TEN;
            $xdes1 = CLX_NUM_65;
            $ydes = CLX_NUM_40;
            $sum = CLX_NUM_FIVE;
            /* logo
             */
            $pdf->SetXY($xdes, $ydes);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, 'Panamá, ' . xFormat::date($result['EFFTDATE']), CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->Ln(CLX_NUM_SIX);
            $pdf->SetX($xdes);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, 'Señores', CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->Ln(CLX_NUM_SIX);
            $pdf->SetX($xdes);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, uppercase($result['TRANS_AMT'] < CLX_NUM_ZERO ? $result['BANK1_NAME'] : $result['BANK2_NAME']), CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->Ln(CLX_NUM_SIX);
            $pdf->SetX($xdes);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, 'No. ' . $result['TRANS_CODE'], CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->Ln(CLX_NUM_TEN);
            $pdf->SetX($xdes);
            $pdf->SetFont('Arial', '', '10');
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, 'Autorizo a debitar de la cuenta: ', CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $ydes += CLX_NUM_40;
            $pdf->SetXY($xdes, $ydes);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, 'Número de cuenta: ', CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->SetXY($xdes1, $ydes);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, capitalize($result['TRANS_AMT'] < CLX_NUM_ZERO ? $result['BANK1_NO'] : $result['BANK2_NO']), CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->SetXY($xdes, $ydes = $ydes + $sum);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, 'Nombre de la cuenta:', CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->SetXY($xdes1, $ydes);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, capitalize($result['TRANS_AMT'] < CLX_NUM_ZERO ? $result['BANK1_BENEF'] : $result['BANK2_BENEF']), CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->SetXY($xdes, $ydes = $ydes + $sum);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, 'Monto en número:', CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->SetXY($xdes1, $ydes);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, capitalize($result['CURRENCY_CODE']) . ' ' . xFormat::number($result['TRANS_AMT'] < CLX_NUM_ZERO ? $result['TRANS_AMT'] * -CLX_NUM_ONE : $result['TRANS_AMT']), CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->SetXY($xdes, $ydes = $ydes + $sum);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, 'Monto en letras:', CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->SetXY($xdes1, $ydes);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, capitalize($textTransAmt), CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->SetXY($xdes, $ydes = $ydes + $sum + CLX_NUM_FIVE);
            $pdf->SetFont('Arial', '', '10');
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, 'Acreditar a la cuenta: ', CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->SetXY($xdes, $ydes = $ydes + $sum + CLX_NUM_THREE);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, 'Número de cuenta:', CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->SetXY($xdes1, $ydes);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, capitalize($result['TRANS_AMT'] < CLX_NUM_ZERO ? $result['BANK2_NO'] : $result['BANK1_NO']), CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->SetXY($xdes, $ydes = $ydes + $sum);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, 'Nombre de la cuenta:', CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->SetXY($xdes1, $ydes);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, capitalize($result['TRANS_AMT'] < CLX_NUM_ZERO ? $result['BANK2_BENEF'] : $result['BANK1_BENEF']), CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->SetXY($xdes, $ydes = $ydes + $sum);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, 'Monto en número:', CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->SetXY($xdes1, $ydes);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, capitalize($result['CURRENCY_CODE']) . ' ' . xFormat::number($result['TRANS_AMT'] < CLX_NUM_ZERO ? $result['TRANS_AMT'] * -CLX_NUM_ONE : $result['TRANS_AMT']), CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->SetXY($xdes, $ydes = $ydes + $sum);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, 'Monto en letras:', CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->SetXY($xdes1, $ydes);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, capitalize($textTransAmt), CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->SetXY($xdes, $ydes = $ydes + $sum + CLX_NUM_THREE);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, 'Detalle del Pago:', CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->SetXY($xdes1, $ydes);
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, 'Solicitud de ' . $result['DETAIL_PAY'], CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->Ln();
            $pdf->SetXY(CLX_NUM_ZERO, CLX_NUM_200);
            $pdf->Cell(CLX_NUM_70, CLX_NUM_ZERO, '________________________', CLX_NUM_ZERO, CLX_NUM_ZERO, 'C');
            $pdf->Cell(CLX_NUM_70, CLX_NUM_ZERO, '', CLX_NUM_ZERO, CLX_NUM_ZERO, 'C');
            $pdf->Cell(CLX_NUM_70, CLX_NUM_ZERO, '________________________', CLX_NUM_ZERO, CLX_NUM_ZERO, 'C');
            $pdf->Ln(CLX_NUM_FOUR);
            $pdf->Cell(CLX_NUM_70, CLX_NUM_ZERO, 'FIRMA AUTORIZADA', CLX_NUM_ZERO, CLX_NUM_ZERO, 'C');
            $pdf->Cell(CLX_NUM_70, CLX_NUM_ZERO, '', CLX_NUM_ZERO, CLX_NUM_ZERO, 'C');
            $pdf->Cell(CLX_NUM_70, CLX_NUM_ZERO, 'FIRMA AUTORIZADA', CLX_NUM_ZERO, CLX_NUM_ZERO, 'C');
            $pdf->Ln(CLX_NUM_16);
            $pdf->SetX($xdes);
            $pdf->SetFontSize(CLX_NUM_NINE);
            $pdf->Cell(CLX_NUM_30, CLX_NUM_ZERO, dict('GEN_LBL_ELABORADO_POR') . ':', CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, capitalize($result['PREPARATION']), CLX_NUM_ZERO, CLX_NUM_ONE, 'L');
            $pdf->Ln(CLX_NUM_FOUR);
            $pdf->SetX($xdes);
            $pdf->Cell(CLX_NUM_30, CLX_NUM_ZERO, dict('GEN_LBL_REVIEWED_BY') . ':', CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, capitalize($result['VERIFIEDL']), CLX_NUM_ZERO, CLX_NUM_ONE, 'L');
            $pdf->Ln(CLX_NUM_FOUR);
            $pdf->SetX($xdes);
            $pdf->Cell(CLX_NUM_30, CLX_NUM_ZERO, dict('GEN_LBL_AUTHORIZED_BY') . ':', CLX_NUM_ZERO, CLX_NUM_ZERO, 'L');
            $pdf->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, capitalize($result['APROBED']), CLX_NUM_ZERO, CLX_NUM_ONE, 'L');
            $pdf->Output('OPER-' . $result['TRANS_CODE'] . '.pdf', 'D');
            salir();
        }

        function build_header_pdf(&$object, $title) {
            $object->setHeaderParameter(CLX_NUM_ZERO, $title, 'Arial', 'B', CLX_NUM_11, CLX_NUM_ZERO, CLX_NUM_FIVE, CLX_NUM_ZERO, 'L');
            $object->SetAutoPageBreak(true, CLX_NUM_30);
            $object->AddPage();
        }

		private function checkOverDraft($loan_code)
        {
            $sql = 'SELECT GLAC.ALLOW_OVERDRAFT FROM ' . $this->filoname . ' FILO, ' . $this->pratname . ' PRAT, ' . $this->glacname . ' GLAC WHERE FILO.PRODUCT_CODE=PRAT.PRODUCT_CODE AND GLAC.IDCODE=PRAT.AR_GL_CODE AND FILO.IDCODE = ' . singleQuote($loan_code) . 'AND FILO.LOAN_STATUS=PRAT.PROD_STATUS';
            return ClxCommon::$db->getOne($sql);
        }

        /**
         * Load Operation information for credits. Used on webservices
         * @param type $loan_code
         * @param type $operation
         * @param type $record
         */
        public function loadCreditOperationRecord($loan_code, $transtbl_code, $operation_date, &$record) {
            #global $db;

            $sql = "SELECT
                        '*' FIAT_IDCODE,
                        1 FIAT_CUR_OPERATOR,
                        1 FIAT_EXCHANGE_RT,
                        0 FIAT_RESERVE_PAY,
                        FILO.IDCODE FIAT_LOAN_CODE,
                        FILO.COMP_CODE FIAT_COMP_CODE,
                        '$operation_date' FIAT_EFFTDATE,
                        '$transtbl_code' FIAT_TRANSTBL_CODE,
                        " . ((empty($record['FIAT_CURRENCY_CODE'])) ? "FILO.CURRENCY_CODE FIAT_CURRENCY_CODE," : "") . "
                        UPPER(CONCAT(IFNULL(FITB.IDNAME,'$transtbl_code'),', ', FILO.IDNAME)) FIAT_IDNAME,
            FILO.PAY_BANKACT_NO FIAT_FIDU_BANKACT_CODE
                    FROM
                        $this->filoname FILO,
                        $this->glcpname GLCP
                            LEFT JOIN $this->fitbname FITB
                                ON FITB.IDCODE = '$transtbl_code'
                    WHERE
                        FILO.COMP_CODE = GLCP.COMP_CODE
                        AND FILO.IDCODE = '" . $loan_code . "'
                        AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)
                            FROM $this->filoname FILOX
                            WHERE FILOX.IDCODE = FILO.IDCODE
                                /*AND FILOX.CLX_EFFTDATE<=NOW()*/)";
            $record = array_merge($record, ClxCommon::$db->getOneRecord($sql));
            if (empty($record)) {
                return;
            }

            if ($transtbl_code == 'SYS_CRED-DISB') {
                //global $ac;
                //$ac = 'CODE';
                UserRequest::$request['ac'] = 'CODE';
            }
            $this->init_credit_defaults_ajax($record);
            // $this->init_credit_operation_details($record);
        }

        /**
         * Load credit installments
         * @param type $loan_code
         * @param type $asof_date
         */
        private function loadCreditInstallments($loan_code, $asof_date) {
            //global $db;
            ClxCommon::$db->executeQuery('CALL CRED_SET_FILS2(' . singleQuote($loan_code) . ',' . singleQuote($asof_date) . ', 0)');
        }


        private function init_credit_defaults_ajax(&$record) {
            if (empty($this->filoname)) {
                return;
            }
            if (strpos($record ['FIAT_TRANSTBL_CODE'], 'SYS_CRED') === false && (UserRequest::$request['ac'] === 'MODIFY' || UserRequest::$request['ac'] === 'DUPLICATE')) {
                return;
            }
            $mod = ClxCommon::$db->getField($this->fitbname, 'MODULECODE', 'IDCODE = ' . singleQuote($record ['FIAT_TRANSTBL_CODE']));
            if (!class_exists('Filo')) {
                includeCodeLib('FILO');
            }
            $filo = new Filo ();
            if ($mod !== 'CRED') {
                return; // means its not credit
            } elseif (empty($record ['FIAT_LOAN_CODE'])) {

                if (!empty(UserRequest::$request ['li']) && UserRequest::$request ['li'] === 'FIAT_CRED_D_SRCH' && empty($record ['FIAT_CHART_FIELD03']) && UserRequest::$request['ac'] === 'CREATE') {
                    // send user tu adjustmnet
                    header('location: tool.php?to=EDIT&ac=CODE&it=FIAT_CRED_DISB');
                    salir();
                }
                if (!empty(UserRequest::$request ['li']) && UserRequest::$request ['li'] === 'FIAT_CRED_P_SRCH' && empty($record ['FIAT_CHART_FIELD03']) && UserRequest::$request['ac'] === 'CREATE') {
                    // send user tu adjustmnet
                    header('location: tool.php?to=EDIT&ac=CODE&it=FIAT_CRED_PAY');
                    salir();
                }
                if (!empty(UserRequest::$request ['li']) && UserRequest::$request ['li'] === 'FIAT_CRED_SRCH' && empty($record ['FIAT_CHART_FIELD03']) && UserRequest::$request['ac'] === 'CREATE') {
                    // send user tu adjustmnet
                    header('location: tool.php?to=EDIT&ac=CODE&it=FIAT_CRED_ADJ');
                    salir();
                }
                $record ['FIAT_LOAN_CODE'] = $filo->get_loan_code_by_fias($record ['FIAT_CHART_FIELD03']);
            }
            $prlt = $filo->get_cred_parameters($record ['FIAT_LOAN_CODE']);
            unset($filo);

            //monto a distribuir que viene via ajax
            $monto_dist = $record['FIAT_TRANS_AMT'];

            // Setting transaction code
            if (empty($record ['FIAT_TRANSTBL_CODE'])) {
                $sql = 'SELECT IDCODE, IDNAME  FROM ' . $this->fitbname . '   WHERE IDCODE = ' . singleQuote('SYS_CRED-PYMT');
                $r = ClxCommon::$db->getOneRecord($sql);
                UserRequest::$post ['FIAT_TRANSTBL_CODE'] = $r ['IDCODE'];
                UserRequest::$post ['FIAT_TRANSTBL_CODE_prim'] = $r ['IDCODE'];
                UserRequest::$post ['FIAT_TRANSTBL_CODE_secd'] = $r ['IDNAME'];
                $record ['FIAT_TRANSTBL_CODE'] = $r ['IDCODE'];
                $record ['FIAT_TRANSTBL_CODE_prim'] = $r ['IDCODE'];
                $record ['FIAT_TRANSTBL_CODE_secd'] = $r ['IDNAME'];
            }
            // Load default values for chart fields
            $sql = 'SELECT  COMP.IDCODE COMP_CODE,  COMP.IDNAME COMP_NAME,  FIAS.CONTRACT_CODE CHART_FIELD01,  FICO.CONTRACT_NUMBER CHART_FIELD01_prim,  FICO.IDNAME CHART_FIELD01_secd,  FIAS.IDCODE CHART_FIELD03,  FIAS.IDCODE CHART_FIELD03_prim,  FIAS.IDNAME CHART_FIELD03_secd FROM  ' . $this->compname . ' COMP,  ' . $this->fiasname . ' FIAS,  ' . $this->ficoname . ' FICO WHERE  FICO.COMP_CODE = COMP.IDCODE  AND FICO.IDCODE = FIAS.CONTRACT_CODE  AND FIAS.LOAN_CODE = ' . singleQuote($record ['FIAT_LOAN_CODE']) . '  AND ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' <> ' . singleQuote($record ['FIAT_LOAN_CODE']);
            $r = ClxCommon::$db->getOneRecord($sql);
            if (empty($record ['COMP_COMP_CODE_prim'])) {
                UserRequest::$post ['FIAT_COMP_CODE_prim'] = $r ['COMP_CODE'];
                UserRequest::$post ['FIAT_COMP_CODE_secd'] = $r ['COMP_NAME'];
                $record ['FIAT_COMP_CODE_prim'] = $r ['COMP_CODE'];
                $record ['FIAT_COMP_CODE_secd'] = $r ['COMP_NAME'];
            }
            if (empty($record ['FIAT_CHART_FIELD01'])) {
                UserRequest::$post ['FIAT_CHART_FIELD01'] = $r ['CHART_FIELD01'];
                UserRequest::$post ['FIAT_CHART_FIELD01_prim'] = $r ['CHART_FIELD01_prim'];
                UserRequest::$post ['FIAT_CHART_FIELD01_secd'] = $r ['CHART_FIELD01_secd'];
                $record ['FIAT_CHART_FIELD01'] = $r ['CHART_FIELD01'];
                $record ['FIAT_CHART_FIELD01_prim'] = $r ['CHART_FIELD01_prim'];
                $record ['FIAT_CHART_FIELD01_secd'] = $r ['CHART_FIELD01_secd'];
            } // end if loancode
            if (empty($record ['FIAT_CHART_FIELD03'])) {
                UserRequest::$post ['FIAT_CHART_FIELD03'] = $r ['CHART_FIELD03'];
                UserRequest::$post ['FIAT_CHART_FIELD03_prim'] = $r ['CHART_FIELD03_prim'];
                UserRequest::$post ['FIAT_CHART_FIELD03_secd'] = $r ['CHART_FIELD03_secd'];
                $record ['FIAT_CHART_FIELD03'] = $r ['CHART_FIELD03'];
                $record ['FIAT_CHART_FIELD03_prim'] = $r ['CHART_FIELD03_prim'];
                $record ['FIAT_CHART_FIELD03_secd'] = $r ['CHART_FIELD03_secd'];
            } // end if loancode
            // Load default values for chart fields
            $sql = 'SELECT  ACCO.IDCODE CHART_FIELD02,  ACCO.IDCODE CHART_FIELD02_prim,  ACCO.IDNAME CHART_FIELD02_secd,  ACCO.IDENTIFICATION CHART_FIELD02_terc FROM  ' . $this->fiasname . ' FIAS,  ' . $this->ficoname . ' FICO,  ' . $this->fipaname . ' FIPA,  ' . $this->acconame . ' ACCO WHERE  FICO.IDCODE = FIAS.CONTRACT_CODE  AND FIPA.CONTRACT_CODE = FICO.IDCODE  AND ACCO.IDCODE = FIPA.ACCOUNTCODE  AND FIPA.PARTICIPANT_TYPE IN (' . singleQuoteArray(array('F', 'B', 'G', 'M', 'MB')) . ')  AND FIAS.LOAN_CODE = ' . singleQuote($record ['FIAT_LOAN_CODE']) . '  AND ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' <> ' . singleQuote($record ['FIAT_LOAN_CODE']) . ' ORDER BY FIPA.ISPRIMARY DESC ';
            $r = ClxCommon::$db->getOneRecord($sql);
            if (empty($record ['FIAT_CHART_FIELD02'])) {
                UserRequest::$post ['FIAT_CHART_FIELD02'] = $r ['CHART_FIELD02'];
                UserRequest::$post ['FIAT_CHART_FIELD02_prim'] = $r ['CHART_FIELD02_prim'];
                UserRequest::$post ['FIAT_CHART_FIELD02_secd'] = $r ['CHART_FIELD02_secd'];
                UserRequest::$post ['FIAT_CHART_FIELD02_terc'] = $r ['CHART_FIELD02_terc'];
                $record ['FIAT_CHART_FIELD02'] = $r ['CHART_FIELD02'];
                $record ['FIAT_CHART_FIELD02_prim'] = $r ['CHART_FIELD02_prim'];
                $record ['FIAT_CHART_FIELD02_secd'] = $r ['CHART_FIELD02_secd'];
                $record ['FIAT_CHART_FIELD02_terc'] = $r ['CHART_FIELD02_terc'];
            } // end if loancode
            // Adding Payment Sequence
            $payseq = array();
            $payseq [$prlt ['PAY_SEQNO_PRO']] = 'PAY_SEQNO_PRO';
            $payseq [$prlt ['PAY_SEQNO_AR']] = 'PAY_SEQNO_AR';
            $payseq [$prlt ['PAY_SEQNO_FEE_01']] = 'PAY_SEQNO_FEE_01';
            $payseq [$prlt ['PAY_SEQNO_FEE_02']] = 'PAY_SEQNO_FEE_02';
            $payseq [$prlt ['PAY_SEQNO_FEE_03']] = 'PAY_SEQNO_FEE_03';
            $payseq [$prlt ['PAY_SEQNO_FEE_04']] = 'PAY_SEQNO_FEE_04';
            $payseq [$prlt ['PAY_SEQNO_FEE_05']] = 'PAY_SEQNO_FEE_05';
            ksort($payseq);
            $record ['FIAT_PAY_SEQUENCE'] = implode(',', $payseq);
            // Adding loan code if not exists
            if (array_key_exists('FIAT_LOAN_CODE', $record) && array_key_exists('FIAT_EFFTDATE', $record)) {
                // Including loan information from chartfield if exists SYS-CRED
                // used on credit module
                $sql = 'SELECT  FILO.IDCODE,  FILO.IDNAME,  FILO.DEBTOR_CODE BENEFICIARY_CODE,  FILO.PRODUCT_CODE,  FILO.FEE_01_RATE,  FILO.FEE_02_RATE,  FILO.FEE_03_RATE,  FILO.FEE_04_RATE,  FILO.FEE_05_RATE  FROM  ' . $this->filoname . ' FILO,  ' . $this->fiasname . ' FIAS  WHERE  FILO.IDCODE = FIAS.LOAN_CODE  AND FIAS.IDCODE = ' . singleQuote($record ['FIAT_CHART_FIELD03']) . '  AND FILO.CLX_EFFTDATE =   (SELECT MAX(F.CLX_EFFTDATE)   FROM ' . $this->filoname . ' F   WHERE F.IDCODE = FILO.IDCODE   AND F.CLX_EFFTDATE <= NOW())';
                $lrec = ClxCommon::$db->getOneRecord($sql);
                $record ['FIAT_LOAN_CODE'] = $lrec ['IDCODE'];
                $record ['FIAT_LOAN_CODE_prim'] = $lrec ['IDCODE'];
                $record ['FIAT_LOAN_CODE_secd'] = $lrec ['IDNAME'];
                // Setting amoutn and rates for information
                $record ['FIAT_FEE_01_RATE'] = $lrec ['FEE_01_RATE'];
                $record ['FIAT_FEE_02_RATE'] = $lrec ['FEE_02_RATE'];
                $record ['FIAT_FEE_03_RATE'] = $lrec ['FEE_03_RATE'];
                $record ['FIAT_FEE_04_RATE'] = $lrec ['FEE_04_RATE'];
                $record ['FIAT_FEE_05_RATE'] = $lrec ['FEE_05_RATE'];
            }

////////////////TRAIDO DEL 55/////////////////////////
            //define usar monto salvado en transaccion en vez de recalculo
            if (empty(UserRequest::$request['ac'])) {
                UserRequest::$request['ac'] = 'CODE';
            }
////////////////TRAIDO DEL 55/////////////////////////

            // Adding credit bank account
            if (UserRequest::$request['ac'] === 'CODE') { // On transaction init
                if (empty($record ['FIAT_BENEFICIARY_CODE'])) {
                    $sql = 'SELECT ACCO.IDCODE, ACCO.IDNAME, ACCO.IDENTIFICATION  FROM ' . $this->acconame . ' ACCO, ' . $this->filoname . ' FILO  WHERE ACCO.IDCODE = FILO.DEBTOR_CODE   AND FILO.IDCODE = ' . singleQuote($record ['FIAT_LOAN_CODE']);
                    $benef = ClxCommon::$db->getOneRecord($sql);
                    if (!empty($benef)) {
                        $record ['FIAT_BENEFICIARY_CODE'] = $benef ['IDCODE'];
                        $record ['FIAT_BENEFICIARY_CODE_prim'] = $benef ['IDCODE'];
                        $record ['FIAT_BENEFICIARY_CODE_secd'] = $benef ['IDNAME'];
                        $record ['FIAT_BENEFICIARY_CODE_terc'] = $benef ['IDENTIFICATION'];
                    }
                    unset($benef);
                }
                // Adding currency code
                $sql = 'SELECT MAX(FILO.CURRENCY_CODE)  FROM ' . $this->filoname . ' FILO  WHERE FILO.IDCODE = ' . singleQuote($lrec ['IDCODE']);
                $record ['FIAT_CURRENCY_CODE'] = ClxCommon::$db->getOne($sql);
                // Adding exchange rate
                if (!class_exists('Comp'))
                    includeCodeLib('COMP');
                $comp = new Comp ();
                $xrate = $comp->comp_current_exchange($record ['FIAT_COMP_CODE'], $record ['FIAT_CURRENCY_CODE'], $record ['FIAT_EFFTDATE']);
                $record ['FIAT_EXCHANGE_RT'] = $xrate ['EXCHANGE_RT'];
                $record ['FIAT_CUR_OPERATOR'] = $xrate ['CUR_OPERATOR'];
                unset($comp, $xrate);
                // bank account information
                $sql = 'SELECT  FIBK.BANK_ACCOUNT_NO,  FIBK.IDNAME  FROM  ' . $this->fibkname . ' FIBK,  ' . $this->filoname . ' FILO,  ' . $this->prodname . ' PROD,  ' . $this->prodname . ' PROD2  WHERE  FILO.PRODUCT_CODE = PROD.IDCODE  AND FIBK.BANK_PROD_CODE = PROD2.IDCODE  AND FIBK.COMP_CODE = FILO.COMP_CODE  AND FIBK.CURRENCY_CODE = FILO.CURRENCY_CODE  AND FILO.IDCODE = ' . singleQuote($record ['FIAT_LOAN_CODE']) . '  AND FILO.COMP_CODE = ' . singleQuote($record ['FIAT_COMP_CODE']) . '  AND FILO.PAY_BANKACT_NO = FIBK.BANK_ACCOUNT_NO  LIMIT 1';
                $r2 = ClxCommon::$db->getOneRecord($sql);
                $record ['FIAT_FIDU_BANKACT_CODE'] = $r2 ['BANK_ACCOUNT_NO'];
                $record ['FIAT_FIDU_BANKACT_CODE_prim'] = $r2 ['BANK_ACCOUNT_NO'];
                $record ['FIAT_FIDU_BANKACT_CODE_secd'] = $r2 ['IDNAME'];
            }
            // Adding credit payment balances and Payment detail
            $sql = 'SELECT  FILO.COMP_CODE,  FILO.IDCODE LOAN_CODE,  FILO.CLX_EFFTDATE,  FILO.CRED_PAY_METHOD,  FILO.LOAN_AMT,  FILO.PRINCIPAL_BAL,  (FILO.LOAN_AMT-FILO.PRINCIPAL_BAL) AVAILABLE_AMT,  FILO.LOAN_INTEREST,  FILO.NO_PAYMENTS,  FILO.LOAN_PERIOD,  FILO.INTEARNED_AMT,  FILO.INTPAID_AMT,  FILO.RESERVE_AMT,  (FILO.INTEARNED_AMT-FILO.INTPAID_AMT) INTEREST_AMT,  IFNULL((SELECT  SUM(GDVW.DEBIT_TRANS_AMT-GDVW.CREDIT_TRANS_AMT) BALANCE_AMT  FROM  ' . $this->gdvwname . ' GDVW,  ' . $this->pratname . ' PRAT  WHERE   PRAT.PRODUCT_CODE = PRLT.PRODUCT_CODE   AND GDVW.CHART_FIELD03 = FIAS.IDCODE   AND PRAT.PROD_STATUS = FILO.LOAN_STATUS   AND FILO.CURRENCY_CODE = GDVW.CURRENCY_CODE  AND GDVW.GLACCOUNTCODE = PRAT.CINT_GL_CODE),0) INTEREST_CONT,  FILO.FEE_01_AMT,  FILO.FEE_02_AMT,  FILO.FEE_03_AMT,  FILO.FEE_04_AMT,  FILO.FEE_05_AMT,  FILO.DEDUCTIBLE_AMT,  0 INSTALLMENT_CUR,  0 PRINCIPAL_CUR,  0 INTEREST_CUR,  0 RESERVE_CUR,  0 INSTALLMENT_PRE,  0 PRINCIPAL_PRE,  0 INTEREST_PRE,  0 RESERVE_PRE,  PRLT.SIMPLE_INTEREST FROM  ' . $this->prltname . ' PRLT,  ' . $this->filoname . ' FILO,  ' . $this->fiasname . ' FIAS WHERE  PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE  AND FIAS.LOAN_CODE = FILO.IDCODE  AND FILO.CLX_EFFTDATE =  (SELECT MAX(X.CLX_EFFTDATE)  FROM ' . $this->filoname . ' X  WHERE X.IDCODE = FILO.IDCODE  AND X.CLX_EFFTDATE<=' . singleQuote($this->today) . ')  AND FILO.IDCODE = ' . singleQuote($record ['FIAT_LOAN_CODE']);
            $r = ClxCommon::$db->getOneRecord($sql);
            if (empty($r))
                $r = array();
            // Search Current Installment Information
            $sql = 'SELECT   MAX(FILS.INSTALLMENT_NO) INSTALLMENT_NO_CUR,   0 INSTALLMENT_CUR,   0 PRINCIPAL_CUR,   0 INTEREST_CUR,   0 RESERVE_CUR,   0 FEES_CUR,   0 LATEF_CUR,   0 INSTALLMENT_NO_PRE,   SUM((FILS.PRINCIPAL_PAY+ FILS.BALLOON_PAY_AMT-FILS.PPAL_PAID_AMT)+(FILS.INTEREST_PAY-FILS.INTPAID_AMT)) INSTALLMENT_PRE,   SUM(FILS.PRINCIPAL_PAY+ FILS.BALLOON_PAY_AMT -FILS.PPAL_PAID_AMT) PRINCIPAL_PRE,   SUM(FILS.INTEREST_PAY-FILS.INTPAID_AMT) INTEREST_PRE,   SUM(FILS.RESERVE_PAY) RESERVE_PRE,   0 FEES_PRE,   0 LATEF_PRE  FROM   ' . $this->filoname . ' FILO,   ' . $this->filsname . ' FILS  WHERE  FILO.IDCODE = FILS.LOAN_CODE  AND FILO.CLX_EFFTDATE = FILS.EFFTDATE  /*AND FILS.PERIOD_END_DATE < ' . singleQuote($record ['FIAT_EFFTDATE']) . '*/  AND FILS.PERIOD_START_DATE <= ' . singleQuote($record ['FIAT_EFFTDATE']) . '  AND FILO.CLX_EFFTDATE =   (SELECT MAX(X.CLX_EFFTDATE)   FROM ' . $this->filoname . ' X   WHERE X.IDCODE = FILO.IDCODE    AND X.CLX_EFFTDATE<=' . singleQuote($this->today) . ')  AND FILO.IDCODE = ' . singleQuote($record ['FIAT_LOAN_CODE']);
            // ADVANCE_PAID_AMT
            $r2 = ClxCommon::$db->getOneRecord($sql);
            if (!empty($r2)) {
                $r = array_merge($r, $r2);
            }

            //Adding Fee Amount
            $sql = 'SELECT   IFNULL(FILS.FEES_AMT,0)  FROM   ' . $this->filoname . ' FILO,   ' . $this->filsname . ' FILS  WHERE  FILO.IDCODE = FILS.LOAN_CODE  AND FILO.CLX_EFFTDATE = FILS.EFFTDATE  AND FILS.PERIOD_END_DATE < ' . singleQuote($record ['FIAT_EFFTDATE']) . '  AND FILO.CLX_EFFTDATE =   (SELECT MAX(X.CLX_EFFTDATE)   FROM ' . $this->filoname . ' X   WHERE X.IDCODE = FILO.IDCODE    AND X.CLX_EFFTDATE<=' . singleQuote($this->today) . ')  AND FILO.IDCODE = ' . singleQuote($record ['FIAT_LOAN_CODE']) . '  ORDER BY FILS.ID DESC  LIMIT 1';
            $r['FEES_PRE'] = ClxCommon::$db->getOne($sql);
            // setting due interest amount based in interest
            //Revisar el monto de cuotas vencidas si es interes simple ya que no aparece en saldo vencido el monto.
            if (!empty($r)) {
                if (!array_key_exists('PRINCIPAL_CUR', $r))
                    $r ['PRINCIPAL_CUR'] = CLX_INIT_ZERO;
                if (!array_key_exists('INTEREST_CUR', $r))
                    $r ['INTEREST_CUR'] = CLX_INIT_ZERO;
                if (!array_key_exists('AVAILABLE_AMT', $r))
                    $r ['AVAILABLE_AMT'] = CLX_INIT_ZERO;
                if (!array_key_exists('PRINCIPAL_BAL', $r))
                    $r ['PRINCIPAL_BAL'] = CLX_INIT_ZERO;
                if (!array_key_exists('INTEREST_AMT', $r))
                    $r ['INTEREST_AMT'] = CLX_INIT_ZERO;
                if (!array_key_exists('INTEREST_CONT', $r))
                    $r ['INTEREST_CONT'] = CLX_INIT_ZERO;
                if (!array_key_exists('INSTALLMENT_PRE', $r))
                    $r ['INSTALLMENT_PRE'] = CLX_INIT_ZERO;
                $r ['INSTALLMENT_CUR'] = rounder($r ['PRINCIPAL_CUR'] + $r ['INTEREST_CUR'], CLX_NUM_TWO);
                // Balances section
                $record ['FIAT_AVAILABLE_AMT'] = no_format($r ['AVAILABLE_AMT'], CLX_NUM_TWO);
                $record ['FIAT_PRINCIPAL_BAL'] = no_format($r ['PRINCIPAL_BAL'], CLX_NUM_TWO);
                $record ['FIAT_INTEREST_AMT'] = no_format($r ['INTEREST_AMT'], CLX_NUM_TWO);
                $record ['FIAT_INTEREST_CUR'] = no_format($r ['INTEREST_CUR'], CLX_NUM_TWO);
                $record ['FIAT_PRINCIPAL_CUR'] = no_format(($r ['INSTALLMENT_CUR'] - $r ['INTEREST_CUR']), CLX_NUM_TWO);
                $record ['FIAT_INSTALLMENT_CUR'] = no_format($r ['INSTALLMENT_CUR'], CLX_NUM_TWO);
                // installment prev
                $r ['INSTALLMENT_PRE'] = ($r ['PRINCIPAL_PRE'] + $r['FEES_PRE']);
                $r ['INSTALLMENT_PRE'] += $r ['INTEREST_PRE'];
                $record ['FIAT_INSTALLMENT_PRE'] = no_format($r ['INSTALLMENT_PRE'], CLX_NUM_TWO);
                $record ['FIAT_PRINCIPAL_PRE'] = no_format($r ['PRINCIPAL_PRE'], CLX_NUM_TWO);
                $record ['FIAT_INTEREST_PRE'] = no_format($r ['INTEREST_PRE'], CLX_NUM_TWO);
                $record ['FIAT_INTEREST_CONT'] = no_format($r ['INTEREST_CONT'], CLX_NUM_TWO);
                if (UserRequest::$request['ac'] !== 'DISPLAY')
                    $record ['FIAT_TRANS_AMT'] = CLX_INIT_ZERO;
                // if paid no point of duing nothing else
                if ($record ['FIAT_TRANSTBL_CODE'] !== 'SYS_CRED-DISB' && $record ['FIAT_PRINCIPAL_BAL'] == CLX_NUM_ZERO)
                    return;


                if (UserRequest::$request['ac'] === 'CODE') { // on init transaction
                    $record ['FIAT_LOAN_AMT'] = no_format($r ['LOAN_AMT'], CLX_NUM_TWO);
                    $record ['FIAT_RESERVE_AMT'] = no_format($r ['RESERVE_AMT'], CLX_NUM_TWO);
                    $record ['FIAT_DEDUCTIBLE_AMT'] = no_format($r ['DEDUCTIBLE_AMT'], CLX_NUM_TWO);
                    // debe tomar todo
                    $sql = 'SELECT   FILO.FEE_01_AMT,   FILO.FEE_02_AMT,   FILO.FEE_03_AMT,   FILO.FEE_04_AMT,   FILO.FEE_05_AMT  FROM   ' . $this->glcpname . ' GLCP,   ' . $this->filoname . ' FILO  WHERE   FILO.COMP_CODE = GLCP.COMP_CODE   AND FILO.CLX_EFFTDATE =   (SELECT MAX(X.CLX_EFFTDATE)   FROM ' . $this->filoname . ' X   WHERE X.IDCODE = FILO.IDCODE   AND X.CLX_EFFTDATE <=NOW())   AND FILO.IDCODE = ' . singleQuote($record ['FIAT_LOAN_CODE']);
                    $fees = ClxCommon::$db->getOneRecord($sql);
                    $record ['FIAT_FEE_01_PAY'] = $fees ['FEE_01_AMT'];
                    $record ['FIAT_FEE_02_PAY'] = $fees ['FEE_02_AMT'];
                    $record ['FIAT_FEE_03_PAY'] = $fees ['FEE_03_AMT'];
                    $record ['FIAT_FEE_04_PAY'] = $fees ['FEE_04_AMT'];
                    $record ['FIAT_FEE_05_PAY'] = $fees ['FEE_05_AMT'];

                    //ajax
                    $record ['FIAT_PRINCIPAL_PAY'] = $record ['FIAT_PRINCIPAL_PRE'];
                    $record ['FIAT_INTEREST_PAY'] = $record ['FIAT_INTEREST_PRE'];
                    $record ['FIAT_TRANS_AMT'] = $record ['FIAT_INSTALLMENT_PRE'];
                    $record ['FIAT_PRINCIPAL_EFFECT'] = 'D';
                    $record ['FIAT_INTEREST_EFFECT'] = 'D';
                    //ajax

                    unset($fees);
                    if (!empty(UserRequest::$request ['li']) && UserRequest::$request ['li'] === 'FIAT_CRED_D_SRCH') {
                        $record ['FIAT_TRANS_AMT'] = $r ['AVAILABLE_AMT'];
                        $record ['FIAT_PRINCIPAL_PAY'] = $r ['AVAILABLE_AMT'];
                        $record ['FIAT_PRINCIPAL_EFFECT'] = 'I';
                        $record ['FIAT_INTEREST_EFFECT'] = '';
                    } elseif (!empty(UserRequest::$request ['li']) && UserRequest::$request ['li'] === 'FIAT_CRED_P_SRCH') {
                        $record ['FIAT_PRINCIPAL_PAY'] = $record ['FIAT_PRINCIPAL_PRE'];
                        $record ['FIAT_INTEREST_PAY'] = $record ['FIAT_INTEREST_PRE'];
                        $record ['FIAT_TRANS_AMT'] = $record ['FIAT_INSTALLMENT_PRE'];
                        $record ['FIAT_PRINCIPAL_EFFECT'] = 'D';
                        $record ['FIAT_INTEREST_EFFECT'] = 'D';
                    }
                }
                // Set product fees information
                if (!empty($lrec ['PRODUCT_CODE'])) {
                    $op_type = $this->fiat_credit_operation_type($record ['FIAT_TRANSTBL_CODE']);
                    $sql = 'SELECT COUNT(JELN.ID)  FROM ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD  WHERE JEHD.IDCODE = JELN.JEHDR_CODE  AND JEHD.TRANS_CODE = ' . singleQuote($record ['FIAT_IDCODE']);
                    $lines_exists = ClxCommon::$db->getOne($sql);
                    if ($this->fiat_credit_operation_type($record ['FIAT_TRANSTBL_CODE']) === 'DIS') {
                        $sign = - CLX_NUM_ONE;
                    } else {
                        $sign = CLX_NUM_ONE;
                    }
                    // Flag to enable javascript to charge p0006 in case of late
                    // fees
                    $record ['FIAT_FEE_HAS_LATE_FEE'] = CLX_INIT_ZERO;
                    $sql = 'SELECT   IDNAME,   FEE_FORMULA,   SEQNUM,   DIVIDER_FACTOR,   IS_TAXABLE,   TAX_ITEM_CODE,   FEE_GL_CODE,   FEE2_GL_CODE,   CHARGE_CUSTOMER,   GLPF_FEE_TYPE  FROM   ' . $this->glpfname . '   WHERE   PRODUCT_CODE = ' . singleQuote($lrec ['PRODUCT_CODE']) . '   AND STATUS = ' . singleQuote('A') . '   AND ID IN (SELECT MAX(ID) FROM ' . $this->glpfname . '     WHERE PRODUCT_CODE = ' . singleQuote($lrec ['PRODUCT_CODE']) . '    GROUP BY FEE_FORMULA, SEQNUM)  ORDER BY   SEQNUM ASC';
                    $rs = ClxCommon::$db->executeQuery($sql);
                    while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                        $i = $r ['SEQNUM'];
                        $record ['FIAT_FEE_FORMULA_0' . $i] = $r ['FEE_FORMULA'];
                        if ($r ['GLPF_FEE_TYPE'] === 'LF') { // set ig late fees and
                            // assign amount
                            if ($record ['FIAT_FEE_0' . $i . '_PAY'] > CLX_NUM_ZERO) {
                                $record ['FIAT_FEE_HAS_LATE_FEE'] = CLX_NUM_ONE;
                            }
                            $record ['FIAT_FEE_0' . $i . '_RATE'] = $record ['FIAT_FEE_0' . $i . '_PAY'];
                        }
                        if ($r ['CHARGE_CUSTOMER'] == CLX_NUM_ZERO) { // fees that are not
                            // required to
                            // be paid by the customer
                            // should skeep.
                            $record ['FIAT_FEE_0' . $i . '_NAME'] = '';
                            $record ['FIAT_TAX_0' . $i . '_AMT'] = '0.00';
                            $record ['FIAT_FEE_0' . $i . '_PAY'] = '0.00';
                            $record ['FIAT_TAX_0' . $i . '_RATE'] = '0.00';
                            $init_val = false;
                            continue;
                        }
                        $lbl = '';
                        if ($r ['GLPF_FEE_TYPE'] !== 'LF' && substr($r ['FEE_FORMULA'], CLX_NUM_ZERO, CLX_NUM_ONE) === 'P')
                            $lbl = '% ';
                        $record ['FIAT_FEE_0' . $i . '_NAME'] = $lbl . $r ['IDNAME'];
                        if ($r ['FEE_FORMULA'] === 'F0001')
                            $init_val = true;
                        elseif ($r ['FEE_FORMULA'] === 'F0002' && $op_type === 'DIS')
                            $init_val = true;
                        elseif ($r ['FEE_FORMULA'] === 'F0003' && $op_type === 'PAY')
                            $init_val = true;
                        else
                            $init_val = false;
                        if (!empty($r ['IS_TAXABLE'])) {
                            $sql = 'SELECT IFNULL(JEIT.FLAT_RATE,0)   FROM ' . $this->jeitname . ' JEIT   WHERE JEIT.IDCODE = ' . singleQuote($r ['TAX_ITEM_CODE']) . '   AND JEIT.CLX_EFFTDATE =    (SELECT MAX(X.CLX_EFFTDATE)    FROM ' . $this->jeitname . ' X    WHERE X.IDCODE = JEIT.IDCODE    AND X.CLX_EFFTDATE<=' . singleQuote($record ['FIAT_EFFTDATE']) . ')';
                            $record ['FIAT_TAX_0' . $i . '_RATE'] = ClxCommon::$db->getOne($sql);
                        }
                        // Set fee amount
                        if (UserRequest::$request['ac'] === 'MODIFY') {
                            $sql = 'SELECT -1*SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) AMT   FROM ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD   WHERE JEHD.IDCODE = JELN.JEHDR_CODE    AND JEHD.TRANS_CODE = ' . singleQuote($record ['FIAT_IDCODE']) . '    AND JELN.GLACCOUNTCODE = ' . singleQuote($r ['FEE_GL_CODE']) . '     ';
                            $record ['FIAT_FEE_0' . $i . '_PAY'] = rounder(ClxCommon::$db->getOne($sql), CLX_NUM_TWO);
                        }
                        if ($lines_exists == CLX_NUM_ZERO && $r ['DIVIDER_FACTOR'] != CLX_NUM_ZERO) {
                            if ($init_val === true) {
                                $record ['FIAT_FEE_0' . $i . '_PAY'] = rounder(($lrec ['FEE_0' . $i . '_RATE'] / $r ['DIVIDER_FACTOR']), CLX_NUM_TWO);
                            }
                            if ($r ['FEE_FORMULA'] === 'P0006' && $op_type === 'PAY') {
                                if ($record ['FIAT_FEE_HAS_LATE_FEE'] == CLX_NUM_ONE) {
                                    $record ['FIAT_FEE_0' . $i . '_PAY'] = rounder($record ['FIAT_TRANS_AMT'] * (($lrec ['FEE_0' . $i . '_RATE'] / CLX_NUM_HUNDRED) / $r ['DIVIDER_FACTOR']), CLX_NUM_TWO);
                                }
                            }
                            $record ['FIAT_TRANS_AMT'] += rounder($sign * $record ['FIAT_FEE_0' . $i . '_PAY'], CLX_NUM_TWO);
                            if (!empty($record ['FIAT_TAX_0' . $i . '_RATE'])) {
                                $record ['FIAT_TAX_0' . $i . '_AMT'] = round($record ['FIAT_FEE_0' . $i . '_PAY'] * ($record ['FIAT_TAX_0' . $i . '_RATE'] / CLX_NUM_HUNDRED), CLX_NUM_TWO);
                            }
                            $record ['FIAT_FEE_0' . $i . '_EFFECT'] = 'I';
                        }
                    }


                    ///////////////////AJAX////////////////////////
                    if($monto_dist)
                        $record['FIAT_TRANS_AMT'] = $monto_dist;
                    
                    if($payseq[0])
                        unset($payseq[0]);
                    
                    /*foreach ($payseq as $payseqtype => $val) {
                        echo $payseqtype.' => '.$val."<br>";
                    }*/

                    $lastElement = end($payseq);
                    foreach ($payseq as $key => $payseqtype) {
                        switch ($payseqtype) {
                            case 'PAY_SEQNO_PRO':

                            if($lastElement == $payseqtype){
                                if($monto_dist < 0){
                                    $record['FIAT_PRINCIPAL_PAY'] = 0;
                                    if($payseq[count($payseq)-1] == 'PAY_SEQNO_AR')
                                        $record['FIAT_INTEREST_PAY'] += $monto_dist;
                                }
                                else 
                                    $record['FIAT_PRINCIPAL_PAY'] = $monto_dist;
                                break; 
                            } 
                            $monto_dist_pre = $monto_dist - $record['FIAT_PRINCIPAL_PAY'];
                            if($monto_dist_pre < 0 && $payseq[count($payseq)] == 'PAY_SEQNO_AR'){
                                $record['FIAT_PRINCIPAL_PAY'] = $monto_dist;
                                $monto_dist = 0;
                            }
                            else
                                $monto_dist -= $record['FIAT_PRINCIPAL_PAY'];
                                break;
                            case 'PAY_SEQNO_AR':

                            if($lastElement == $payseqtype){
                                $record['FIAT_INTEREST_PAY'] = $monto_dist;
                                break;
                            } 
                            $monto_dist -= $record['FIAT_INTEREST_PAY'];

                                break;
                            case 'PAY_SEQNO_FEE_01':case 'PAY_SEQNO_FEE_02':case 'PAY_SEQNO_FEE_03':case 'PAY_SEQNO_FEE_04':case 'PAY_SEQNO_FEE_05':
                                    $numFee = substr($payseqtype, -1);

                                if($lastElement == $payseqtype){
                                    $record['FIAT_FEE_0'.$numFee.'_PAY'] = $monto_dist;
                                    break;
                                } 
                                $monto_dist -= $record['FIAT_FEE_0'.$numFee.'_PAY'];

                                break;
                            default:
                                # code...
                                break;
                        }
                    }

                    $record ['FIAT_TAX_AMT'] = CLX_INIT_ZERO;
                    if (!empty($record ['FIAT_TAX_01_AMT']))
                        $record ['FIAT_TAX_AMT'] += $record ['FIAT_TAX_01_AMT'];
                    if (!empty($record ['FIAT_TAX_02_AMT']))
                        $record ['FIAT_TAX_AMT'] += $record ['FIAT_TAX_02_AMT'];
                    if (!empty($record ['FIAT_TAX_03_AMT']))
                        $record ['FIAT_TAX_AMT'] += $record ['FIAT_TAX_03_AMT'];
                    if (!empty($record ['FIAT_TAX_04_AMT']))
                        $record ['FIAT_TAX_AMT'] += $record ['FIAT_TAX_04_AMT'];
                    if (!empty($record ['FIAT_TAX_05_AMT']))
                        $record ['FIAT_TAX_AMT'] += $record ['FIAT_TAX_05_AMT'];
                    // Adding distribution amounts
                    $record ['FIAT_TRANS_AMT'] += rounder($sign * $record ['FIAT_TAX_AMT'], CLX_NUM_TWO);
                }
                if (strpos($record ['FIAT_TRANSTBL_CODE'], 'SYS_CRED_CAP') !== false && UserRequest::$request['ac'] !== 'DISPLAY') {
                    if ($record ['FIAT_TRANS_AMT'] == CLX_NUM_ZERO) {
                        $record ['FIAT_TRANS_AMT'] = no_format($record ['FIAT_INTEREST_AMT'], CLX_NUM_TWO);
                    }
                }
                if (strpos($record ['FIAT_TRANSTBL_CODE'], 'SYS_CRED') === false && UserRequest::$request['ac'] !== 'DISPLAY') {
                    if ($record ['FIAT_TRANS_AMT'] == CLX_NUM_ZERO) {
                        $record ['FIAT_TRANS_AMT'] = rounder($record ['FIAT_LOAN_AMT'], CLX_NUM_TWO);
                    }
                }
                // Adding affect values
                if ($record ['FIAT_CUR_OPERATOR'] == CLX_NUM_ONE && UserRequest::$request['ac'] !== 'DISPLAY') {
                    $record ['FIAT_BASE_TRANS_AMT'] = rounder(bcmul($record ['FIAT_TRANS_AMT'], $record ['FIAT_EXCHANGE_RT']), CLX_NUM_TWO);
                } else {
                    $record ['FIAT_BASE_TRANS_AMT'] = rounder(bcdiv($record ['FIAT_TRANS_AMT'], $record ['FIAT_EXCHANGE_RT']), CLX_NUM_TWO);
                }
            } // end if code
        }

    function get_gl_type($idcode){
        $sql = 'SELECT GL_TYPE FROM '. $this->glacname . ' WHERE IDCODE = '. singleQuote($idcode) ;
        $gl_type = ClxCommon::$db->getOneRecord($sql);
        return $gl_type;
    }

 	function printerAlquiler() {
	    //global $db;
        if (!class_exists('Invo'))
	    includeCodeLib('INVO');
        $invo = new Invo();
	    $contents = $invo->printer('03');
		//$contents = dialog('Impresión de Alquiler','panel', $Invo->printer('03'),'');
	    //unset($b);
	    return $contents;
	    //dialog($title, $class, $msg, $button)

	}   
	
	}

    // end class
} // end if class exists
